var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-02710769-BA4C-4585-AAFD-4A82EF3D9100\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface Containers\">\n      <meta name=\"indexterm\" content=\"Containers Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: Containers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-02710769-BA4C-4585-AAFD-4A82EF3D9100\"></a><div class=\"head\">\n            <h1>Interface: Containers </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A646F\"></a>   <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6477\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F5247BBB-771F-4786-BC7F-71E6595DDC9A-low.gif\"></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6475\"></a>The <em class=\"strong\">Containers Core Interface</em> available in <em class=\"strong\">3ds Max 2010 and higher</em> exposes methods related to creation and management of <span class=\"char_link\"><a href=\"GUID-0C2F1D71-2708-4294-9C1E-1D1239982AF7.htm\">Container Helpers</a></span> and their content. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6476\"></a>See also the <span class=\"char_link\"><a href=\"GUID-E8D31DDC-9A82-4A5E-BA54-E6FED5494270.htm\">Containers</a></span> overview topic. \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6478\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6479\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; Containers \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647A\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B06\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">Containers.CreateContainer</em> &lt;&amp;node array&gt;contentNodes 	 \n\ncontentNodes is In and Out parameter     </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647B\"></a>Creates a new container from the given node array and returns the resulting Container\n               node if the creation was successful. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647C\"></a>The new container will be automatically selected. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647D\"></a>The position of the container will be the average of the positions of the content\n               nodes, or the world origin if the node array is empty. \n            </p> \n            <p><a name=\"GUID-2E1167F2-A686-475F-8656-0035DBF978D9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B03\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">Containers.CreateInheritedContainer</em> &lt;filename&gt;asset </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647E\"></a>Inherits the content stored in the given asset filename and returns a new Container\n               node if the creation was successful. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A647F\"></a>If the filename argument is invalid (asset file does not exist), a file selection\n               dialog will be opened to let the user select the asset file. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6480\"></a>The container asset files are stored in the <em class=\"strong\">3ds Max</em> scene format but have the file extension .MAXC to be distinguished from regular scene\n               files. \n            </p> \n            <p><a name=\"GUID-A275CD15-D55F-4EAD-88A0-3B3E5A77ADAE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B02\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">Containers.IsInContainer</em> &lt;node&gt;isInContainer </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6481\"></a>Returns the Container node if the node argument is in a container, undefined if it\n               is not in a container. \n            </p> \n            <p><a name=\"GUID-11263ECB-C969-4B39-9A72-AE955E2B42BA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B01\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">Containers.IsContainerNode</em> &lt;node&gt;isContainerNode </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6482\"></a>Returns the Container node if the node argument is a container node, undefined if\n               it is not a container node. \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6483\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6484\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B00\"></a><pre>\nb = Box()\n--&gt; $Box:Box01 @ [0.000000,0.000000,0.000000]\ns = Sphere pos:[100,0,0]\n--&gt; $Sphere:Sphere01 @ [100.000000,0.000000,0.000000]\n&nbsp;\n--Container created midway between the two content nodes:\n--Compare to creating a container using its constructor\nc = Containers.CreateContainer #(b,s)\n--&gt; $Container:Container01 @ [50.000000,0.000000,0.000000]\n&nbsp;\nContainers.IsContainerNode b\n--&gt; undefined\nContainers.IsContainerNode s\n--&gt; undefined\nContainers.IsContainerNode c\n--&gt; $Container:Container01 @ [50.000000,0.000000,0.000000]\nContainers.IsInContainer b\n--&gt; $Container:Container01 @ [50.000000,0.000000,0.000000]\nContainers.IsInContainer s\n--&gt; $Container:Container01 @ [50.000000,0.000000,0.000000]\nContainers.IsInContainer c\n--&gt; undefined\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6485\"></a> <span class=\"char_link\"><a href=\"GUID-E8D31DDC-9A82-4A5E-BA54-E6FED5494270.htm\">Containers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6486\"></a> <span class=\"char_link\"><a href=\"GUID-0C2F1D71-2708-4294-9C1E-1D1239982AF7.htm\">Container : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6487\"></a> <span class=\"char_link\"><a href=\"GUID-9C3BA21A-FE38-426D-AFD5-44AF41BF6371.htm\">Interface: ContainerPreferences</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";