var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0426874C-2351-4579-9C48-F80A5FCC3398\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"refhierarchy Interface\">\n      <meta name=\"indexterm\" content=\"Interface refhierarchy\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: refhierarchy</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0426874C-2351-4579-9C48-F80A5FCC3398\"></a><div class=\"head\">\n            <h1>Interface: refhierarchy </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C5\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; refhierarchy \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C4\"></a>The <em class=\"strong\">refhierarchy Core Interface</em> provides MAXScript access to the reference hierarchy. \n         </p>\n         <p><a name=\"GUID-D91F2661-C0DF-45B3-AD77-65DBD3E545BA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55DD\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> refhierarchy</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C3\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55DC\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">refhierarchy.IsRefTargetInstanced </em>&lt;maxObject&gt;refTarget   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C2\"></a>This method can be used to find out if an object is instanced (instanced pipeline).\n            \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C1\"></a>It Checks if the Derived Object is instanced. If it is, the pipeline part below and\n            including that derived object is instanced. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78C0\"></a>In certain circumstances, objects need to find out whether they are instances or not.\n            Some plugins need this functionality in order to properly interpret the size and position\n            of their ModContext bounding box. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78BF\"></a>Returns<span class=\"code\"> <em class=\"strong\"> True </em> </span>if the maxObjectis an instance,<span class=\"code\"> <em class=\"strong\"> False</em> </span> otherwise. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78BE\"></a>If the argument is undefined, it also returns<span class=\"code\"> <em class=\"strong\"> False</em> </span>. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78BD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-78BC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55DB\"></a><pre>\n--see if undefined returns anyting - it returns false:\nrefhierarchy.IsRefTargetInstanced undefined\n--&gt; false\n&nbsp;\n--create a box - it is not instanced:\nb1 = box()\n--&gt; $Box:Box01 @ [0.000000,0.000000,0.000000]\nrefhierarchy.IsRefTargetInstanced b1\n--&gt; false\n&nbsp;\n--create an instance of the box:\nb2 = instance b1\n--&gt; $Box:Box02 @ [0.000000,0.000000,0.000000]\n--check the firstbox - it is now an instance\nrefhierarchy.IsRefTargetInstanced b1\n--&gt; true\n--as is the second box:\nrefhierarchy.IsRefTargetInstanced b2\n--&gt; true\n&nbsp;\n--create a bend modifier and see if it is instanced - it is not:\ntheMod = Bend()\n--&gt; Bend:Bend\nrefhierarchy.IsRefTargetInstanced theMod\n--&gt; false\n&nbsp;\n--add the Bend modifier to the one box\naddModifier b1 theMod\n--&gt; OK\n--the modifier is still not instanced:\nrefhierarchy.IsRefTargetInstanced theMod\n--&gt; false\n&nbsp;\n--now create a sphere and add the same bend modifier to it:\ns1 = sphere()\n--&gt; $Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\naddModifier s1 theMod\n--&gt; OK\n--now the modifier is instanced:\nrefhierarchy.IsRefTargetInstanced theMod\n--&gt; true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";