var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0453DFB1-1773-40DC-928E-C328D53EE293\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop An SVG Polygon Renderer Part 2\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop An SVG Polygon Renderer - Part 2</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0453DFB1-1773-40DC-928E-C328D53EE293\"></a><div class=\"head\">\n            <h1>How To ... Develop An SVG Polygon Renderer - Part 2 </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A4\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Develop An SVG Polygon Renderer - Part 2 \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-313234CA-9188-4DA4-BA27-A9FC189538EC\"></a> The following is <em class=\"strong\">part two</em> of a three parts tutorials series demonstrating the use of MAXScript together with\n            the <span class=\"char_link\"><a href=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7.htm\">Vector_Map TextureMap</a></span>. MAXScript will be used to write an SVG XML file to disk containing polygon entities\n            representing the faces of scene objects to be rendered. The SVG file can be loaded\n            in any Web Browser or rendered to a bitmap using the <span class=\"code\"> <em class=\"strong\">renderMap()</em> </span> function. For more information about the use of MAXScript to create SVG files, see\n            the <span class=\"char_link\"><a href=\"GUID-3EF5C2D1-992C-4F29-8543-72D61F2870D1.htm\">Vector_Map TextureMap and MAXScript</a></span> topic. \n         </p>\n         <p><a name=\"GUID-FD947704-78BE-471F-BDBC-CCF234B11188\"></a>In <span class=\"char_link\"><a href=\"GUID-6B5EDC11-A154-4AA7-A972-A11AC36949E9.htm\">the first part of the tutorial</a></span>, we output all camera-facing triangle faces of all geometry objects. \n         </p>\n         <p><a name=\"GUID-E58D83CD-8CAF-4F2F-8E4B-A207E44318DA\"></a>In <em class=\"strong\">this second part of the tutorial</em>, we will sort the polygons by depth to make sure the faces do not overlap incorrectly.\n            \n         </p>\n         <p><a name=\"GUID-49276167-56A9-4472-BDE3-1889FAB95671\"></a> In <span class=\"char_link\"><a href=\"GUID-14B02950-26DF-498C-A88A-CD87DC84473C.htm\">the third part of the tutorial</a></span>, we will add support for material colors and implement lighting using Facets Shading\n            and Blinn Specular Highlights. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A8\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A9\"></a> <span class=\"char_link\"><a href=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7.htm\">Vector_Map TextureMap</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AA\"></a> <span class=\"char_link\"><a href=\"GUID-3EF5C2D1-992C-4F29-8543-72D61F2870D1.htm\">Vector_Map TextureMap and MAXScript</a></span> \n         </p>\n         <p><a name=\"GUID-052BEBCC-4DEE-450D-A260-61DDC9DD8754\"></a> <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm#GUID-DF4741A6-F352-4E30-9EEF-35E4CDD45042\">Number Values - bit methods</a></span> \n         </p>\n         <p><a name=\"GUID-3810F316-60DD-4F8B-8663-FC39980ABBFE\"></a> <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm#WS73099CC142F487553098682E12AC2FC2BC7-5E39\">qsort Method</a></span> \n         </p>\n         <p><a name=\"GUID-BD140F75-6A91-42A2-967F-7AF79A7D8E2E\"></a> <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-43D6\">renderMap Method</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AE\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AF\"></a><p class=\"table-body\">Define a function to sort array values by the 6th array element which will be the\n                        Z depth in camera space. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B0\"></a><p class=\"table-body\">Introduce an array to collect all polygon data to be drawn, so it can be pre-sorted.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-BEE14D43-F0AF-4900-A8E8-DC44CF58644E\"></a><p class=\"table-body\">Calculate the Z-depth value and collect all necessary data in the new array. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-8F13FF90-195A-4EB7-A916-3A6FC149A0FE\"></a><p class=\"table-body\">Sort the new array using <span class=\"code\">qsort()</span> and the new sorting function. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-8B01812F-B5A8-41C3-A154-E879A8034305\"></a><p class=\"table-body\">Loop through the sorted array and draw back to front. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B5\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>(\nfn ColorToHex col =\n(\n	local theComponents = #(bit.intAsHex col.r, bit.intAsHex col.g, bit.intAsHex col.b)\n	local theValue = \"#\"\n	for i in theComponents do \n		theValue += (if i.count == 1 then \"0\" else \"\") + i\n	theValue\n)\n\n<em class=\"codeEmphasisStrong\">fn compareFN v1 v2=\n(\n	if v1[6] &lt; v2[6] then -1 else 1\n)</em>\n\nlocal st = timestamp()\nlocal theFileName = (getDir #userscripts + \"\\\\PolygonRendering.svg\")\nlocal theSVGfile = createFile theFileName\nformat \"&lt;svg xmlns=\\\"http://www.w3.org/2000/svg\\\"\\n\" to:theSVGfile\nformat \"\\t\\txmlns:xlink=\\\"http://www.w3.org/1999/xlink\\\"&gt;\\n\" to:theSVGfile\n\nlocal theViewTM =  viewport.getTM()\ntheViewTM.row4 = [0,0,0]\nlocal theViewTM2 = viewport.getTM()\nlocal theViewSize = getViewSize()\nlocal theViewScale = getViewSize()\ntheViewScale.x /= 1024.0\ntheViewScale.y /= 1024.0\n	\n<em class=\"codeEmphasisStrong\">local drawArray = #()		</em>\n	\nlocal theStrokeThickness = 1\n	\ngw.setTransform (matrix3 1)	\nfor o in Geometry where not o.isHiddenInVpt and classof o != TargetObject do\n(\n	local theStrokeColor = white\n	local theFillColor = o.wirecolor	\n	\n	local theMesh = snapshotAsMesh o\n	for f = 1 to theMesh.numfaces do\n	(\n		local theNormal = normalize (getfaceNormal theMesh f) \n		if (theNormal*theViewTM).z &gt; 0 do\n		(\n			local theFace = getFace theMesh f\n			local v1 = gw.transPoint (getVert theMesh theFace.x)\n			local v2 = gw.transPoint (getVert theMesh theFace.y)\n			local v3 = gw.transPoint (getVert theMesh theFace.z)\n			\n			v1.x /= theViewScale.x \n			v1.y /= theViewScale.y \n			v2.x /= theViewScale.x \n			v2.y /= theViewScale.y\n			v3.x /= theViewScale.x\n			v3.y /= theViewScale.y\n			\n<em class=\"codeEmphasisStrong\">			local theFaceCenter = meshop.getFaceCenter theMesh f\n			local theZDepth = (theFaceCenter*theViewTM2).z\n			append drawArray #(v1, v2, v3, (ColorToHex theStrokeColor), (ColorToHex theLitFillColor), theZDepth)\n</em>\n			\n					)--end if normal positive\n	)--end f loop\n)--end o loop\n \n<em class=\"codeEmphasisStrong\">qsort drawArray compareFN\n\nfor d in drawArray do\n(\n	format \"\\t&lt;polygon points=\'%,%  %,%  %,%\' \\n\" d[1].x d[1].y d[2].x d[2].y d[3].x d[3].y to:theSVGfile\n	format \"\\tstyle=\'stroke:%; fill:%; stroke-width:%\'/&gt;\\n\" d[4] d[5] theStrokeThickness to:theSVGfile\n)</em>\n\nformat \"&lt;/svg&gt;\\n\" to:theSVGfile\nclose theSVGfile\nlocal theSVGMap = VectorMap vectorFile:theFileName alphasource:0\nlocal theBitmap = bitmap theViewSize.x theViewSize.y\nrenderMap theSVGMap into:theBitmap filter:true\ndisplay theBitmap\nformat \"Render Time: % sec.\\n\" ((timestamp()-st)/1000.0)\n)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_A4F1B8396F3F4BA681B879A9A951DD43\"></a> \n            <h2><a name=\"GUID-0802DBC1-1675-4B92-996D-EB9F4D380152\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <p><a name=\"GUID-86243E0B-9644-41C2-B1F9-D5F055522CE9\"></a>Code in <span class=\"code\"> <em class=\"mild\">Italic</em> </span> is the same as in <span class=\"char_link\"><a href=\"GUID-6B5EDC11-A154-4AA7-A972-A11AC36949E9.htm\">Part 1</a></span>. Code in <span class=\"code\"> <em class=\"strong\">Bold</em> </span> is new. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">(\nfn ColorToHex col =\n(\n	local theComponents = #(bit.intAsHex col.r, bit.intAsHex col.g, bit.intAsHex col.b)\n	local theValue = \"#\"\n	for i in theComponents do \n		theValue += (if i.count == 1 then \"0\" else \"\") + i\n	theValue\n)</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">fn compareFN v1 v2=\n(\n	if v1[6] &lt; v2[6] then -1 else 1\n)</em></pre></div> \n            <p><a name=\"GUID-4D492B93-775E-4BF6-B2FB-C854102E4F94\"></a>This function will be used by the qsort() method to compare two elements of our sorting\n               array. \n            </p> \n            <p><a name=\"GUID-B5BC26EC-8E6B-4FD2-9197-0622610E9AD1\"></a>We will be storing the Z-Depth value of each polygon in the 6th element of the array,\n               so this function will get two array items and will return -1 or 1 depending on whether\n               the first one is farther or closer than the second one. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">local st = timestamp()\nlocal theFileName = (getDir #userscripts + \"\\\\PolygonRendering.svg\")\nlocal theSVGfile = createFile theFileName\nformat \"&lt;svg xmlns=\\\"http://www.w3.org/2000/svg\\\"\\n\" to:theSVGfile\nformat \"\\t\\txmlns:xlink=\\\"http://www.w3.org/1999/xlink\\\"&gt;\\n\" to:theSVGfile\n\nlocal theViewTM =  viewport.getTM()\ntheViewTM.row4 = [0,0,0]\nlocal theViewTM2 = viewport.getTM()\nlocal theViewSize = getViewSize()\nlocal theViewScale = getViewSize()\ntheViewScale.x /= 1024.0\ntheViewScale.y /= 1024.0</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">local drawArray = #()</em></pre></div> \n            <p><a name=\"GUID-5BFC6A90-0BE4-4674-AC60-0B4568103B33\"></a>This array will be populated with the polygons including vertices transformed into\n               view space, colors to use for Stroke and Fill, as well as the Z-Depth value for sorting.\n               \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">local theStrokeThickness =</em> <em class=\"codeEmphasisStrong\">1</em></pre></div> \n            <p><a name=\"GUID-C065FA80-84B1-408F-95D4-BA1F0B95107E\"></a>We will set the Stroke to 1 to be able to better investigate the previous problems\n               at the outlines of the Geosphere. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">gw.setTransform (matrix3 1)	\nfor o in Geometry where not o.isHiddenInVpt and classof o != TargetObject do\n(\n	local theStrokeColor = white\n	local theFillColor = o.wirecolor	\n	\n	local theMesh = snapshotAsMesh o\n	for f = 1 to theMesh.numfaces do\n	(\n		local theNormal = normalize (getfaceNormal theMesh f) \n		if (theNormal*theViewTM).z &gt; 0 do\n		(\n			local theFace = getFace theMesh f\n			local v1 = gw.transPoint (getVert theMesh theFace.x)\n			local v2 = gw.transPoint (getVert theMesh theFace.y)\n			local v3 = gw.transPoint (getVert theMesh theFace.z)\n			\n			v1.x /= theViewScale.x \n			v1.y /= theViewScale.y \n			v2.x /= theViewScale.x \n			v2.y /= theViewScale.y\n			v3.x /= theViewScale.x\n			v3.y /= theViewScale.y</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">			local theFaceCenter = meshop.getFaceCenter theMesh f\n			local theZDepth = (theFaceCenter*theViewTM2).z</em> </pre></div> \n            <p><a name=\"GUID-35866E2C-B141-4464-9077-7502C215BFBE\"></a>We will sort by the distance of the Face Center to the viewer, so we need to get the\n               Face Center position in the World Space first, then transform it into the View space.\n               \n            </p> \n            <p><a name=\"GUID-044F941E-45F1-4EDB-B652-CAF38997A23A\"></a>The Z coordinate will be a negative value that will be lower the farther the point\n               is from the viewer. \n            </p> \n            <p><a name=\"GUID-F3E57D61-B34E-4DD9-835D-6B1FFAACEA2B\"></a>We will use this in our sorting function called by <span class=\"code\"> <em class=\"strong\">qsort()</em> </span>. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">			append drawArray #(v1, v2, v3, (ColorToHex theStrokeColor), (ColorToHex theLitFillColor), theZDepth)</em></pre></div> \n            <p><a name=\"GUID-1F1B53D1-B08F-4043-8B4E-B600B976D591\"></a>Instead of outputting directly to the SVG file, we will collect each polygon in the\n               drawArray variable, including the three vertices in screen space, the Hexadecimal\n               colors of the polygon\'s Stroke and Fill, and the Z-Depth value calculated above. \n            </p> \n            <div class=\"codeBlock\"><pre>		)--end if normal positive\n	)--end f loop\n)--end o loop</pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">qsort drawArray compareFN</em></pre></div> \n            <p><a name=\"GUID-72F64BD7-63C7-484A-A696-5331236B2FF2\"></a>Now, we can sort the drawArray according to the distance stored in the 6th element\n               (the Z-Depth value). \n            </p> \n            <p><a name=\"GUID-9C4F844B-F8F8-4322-9CE8-D15C23C7AFFF\"></a>We want polygons with lower Z-Depth (larger negative numbers) to be drawn first, thus\n               implementing the \"Painters Algorithm\" where the drawing is performed back to front\n               relative to the camera. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">for d in drawArray do\n(\n	format \"\\t&lt;polygon points=\'%,%  %,%  %,%\' \\n\" d[1].x d[1].y d[2].x d[2].y d[3].x d[3].y to:theSVGfile\n	format \"\\tstyle=\'stroke:%; fill:%; stroke-width:%\'/&gt;\\n\" d[4] d[5] theStrokeThickness to:theSVGfile\n)</em></pre></div> \n            <p><a name=\"GUID-BA209DB2-8DC4-44BE-8369-D4BDFE57B5AB\"></a>This for loop will output the sorted polygon data to the SVG file. \n            </p> \n            <p><a name=\"GUID-1D005004-ACEB-487D-A354-0EA0E8983E52\"></a>This is very similar to the previous version of the code, but we do this in a second\n               loop and read the values from the sorted array. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">format \"&lt;/svg&gt;\\n\" to:theSVGfile\nclose theSVGfile\nlocal theSVGMap = VectorMap vectorFile:theFileName alphasource:0\nlocal theBitmap = bitmap theViewSize.x theViewSize.y\nrenderMap theSVGMap into:theBitmap filter:true\ndisplay theBitmap\nformat \"Render Time: % sec.\\n\" ((timestamp()-st)/1000.0)\n)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_5126BB4C182C4E769C959E1F0322582C\"></a> \n            <h2><a name=\"GUID-05166108-4894-4E90-80BA-EDFE1725ABE3\"></a>Using The Script To Render Geometry\n            </h2> \n            <p><a name=\"GUID-88F636DA-BB3D-4EF3-8342-280AF6815345\"></a>Let us test the changes to the script on the same examples as in Part 1 to see the\n               difference. \n            </p> <img src=\"../images/GUID-A9B56F7D-64FF-41EF-918D-B33EA577D7A2-low.png\"> \n            <p><a name=\"GUID-1ECB1E72-6C99-4F22-91B3-46C95C730B93\"></a>As you can see, the problems at the edges of the Geosphere have been solved by the\n               new sorted drawing approach. \n            </p> \n            <p><a name=\"GUID-5A609AF6-F343-44E1-9E48-6B11492BA93E\"></a>It matches the results seen in the viewport using \"Consistent Colors + Edged Faces\"\n               drawing mode pretty closely. \n            </p> <img src=\"../images/GUID-87DC858E-7C33-40A2-85A5-00E916E855D8-low.png\"> \n            <p><a name=\"GUID-F09467FD-6887-4E58-AD5E-8772CD8599CB\"></a>Let us increase the Stroke Thickness to 2 and render the Teapot primitive from the\n               Part 1: \n            </p> <img src=\"../images/GUID-88054D36-8DC3-4AF0-BDE9-512A1B158ED1-low.png\"> <img src=\"../images/GUID-38B10D6E-F302-4830-9457-9206EA0AA706-low.png\"> \n            <p><a name=\"GUID-EE50258E-888B-481C-8C49-2924E083C175\"></a>Let us resize the viewport and look at the result: \n            </p> <img src=\"../images/GUID-8B4102E6-3BAA-4A11-B0FD-CFF487356F90-low.png\"> <img src=\"../images/GUID-6FE1C4E7-3199-4168-908E-85C0CBE3007E-low.png\"> \n            <p><a name=\"GUID-F355D305-0670-4CAB-9E52-BD3D537BE9E2\"></a>Rendering the problematic setup from the first part also produces correct results\n               now: \n            </p> <img src=\"../images/GUID-74F04213-511B-4230-9128-4CDC677CA769-low.png\"> \n            <p><a name=\"GUID-28A7384E-DAA5-4913-9E62-F587771EA7D7\"></a>Because we are culling the backfaces, it is possible to see the Sphere through the\n               gap between the Teapot\'s Body and Lid. \n            </p> \n            <p><a name=\"GUID-38B90E9B-DFFA-406B-A21F-B8DC12375F38\"></a>By remarking the backface culling line, \n            </p> \n            <div class=\"codeBlock\"><pre>-- if (theNormal*theViewTM).z &gt; 0 do</pre></div> \n            <p><a name=\"GUID-A181884E-5F5D-4586-AFFD-F5EAEF8348AB\"></a>we can render all polygons of all objects without any culling. The rendering will\n               take approximately twice as long, but the sphere will be correctly occluded: \n            </p> <img src=\"../images/GUID-28D3C5E3-F137-4F6E-8F35-39737EB3BC42-low.png\"> \n         </div>\n         <p><a name=\"GUID-5F2BF9CF-E402-4F90-85EA-F79BCF34512F\"></a>In the<span class=\"char_link\"><a href=\"GUID-14B02950-26DF-498C-A88A-CD87DC84473C.htm\"> third part of the tutorial</a></span>, we will add material color and lighting support to the script to produce faceted\n            rendering with diffuse shading and Blinn specular highlights. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";