var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-046BA8F9-DE6C-475F-8641-7F9A5952FF0B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Recursive functions can be faster</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-046BA8F9-DE6C-475F-8641-7F9A5952FF0B\"></a><div class=\"head\">\n            <h1>Recursive functions can be faster </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1426\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1428\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1429\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Recursive functions can be faster \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC142C\"></a>A recursive function is a function that calls itself to perform repetitive tasks.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC142D\"></a>The following scripted function returns a list of the animated subAnims of the object\n            passed as the parameter. The script works well and is not too slow. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC142E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC142F\"></a><p class=\"table-body\"> <em class=\"strong\">NON-RECURSIVE VERSION</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-661E\"></a><pre>\nfn getAllAnimatedProperties theObject =\n(\n  scan_properties = #(theObject)\n  animated_props = #()\n  cnt = 0\n  while cnt &lt; scan_properties.count do\n  (\n    cnt +=1\n    currentObj = scan_properties[cnt]\n    if try (currentObj.isAnimated) catch (false) do\n      append animated_props currentObj\n    for i = 1 to currentObj.numSubs do\n      append scan_properties currentObj[i]\n  )\n  animated_props\n)\ns=sphere isSelected:true\ngetAllAnimatedProperties $\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1443\"></a>Now, take a look at this code: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1444\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1445\"></a><p class=\"table-body\"> <em class=\"strong\">RECURSIVE VERSION</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-661D\"></a><pre>\nanimated_props = #()\nfn getAnimatedProps theObject =\n(\n  if try (theObject.isAnimated) catch (false) do\n    append animated_props theObject\n  for i = 1 to theObject.numSubs do\n    getAnimatedProps theObject[i]\n)\ngetAnimatedProps $\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1451\"></a>The recursive code does the same job, but is much shorter and almost 25% faster. To\n            get some usable measurement, both scripts were executed 100,000 times. The first took\n            13.875 seconds, and the recursive version took only 10.656 seconds. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1453\"></a> <em class=\"strong\">Previous Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1454\"></a> <span class=\"char_link\"><a href=\"GUID-20124F54-0FDC-4A56-A252-18DFE79A7C41.htm\">Pre-initialize arrays when final size is known</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1455\"></a> <em class=\"strong\">Next Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1456\"></a> <span class=\"char_link\"><a href=\"GUID-11F41767-96FF-4693-BB28-2403BE983841.htm\">matchPattern is faster than findString</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";