var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-05A1F59C-7F53-4CB0-A19D-272F310A8C83\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"3dsmax.ini\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <meta name=\"keywords\" content=\" cfgMgr &#xA;&#x9;&#x9;  \">\n      <meta name=\"keyword\" content=\" cfgMgr &#xA;&#x9;&#x9;  \">\n      <title>3ds Max Configuration File 3dsmax.ini</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-05A1F59C-7F53-4CB0-A19D-272F310A8C83\"></a><div class=\"head\">\n            <h1>3ds Max Configuration File 	 3dsmax.ini</h1>\n         </div>\n         <p> Access to the 3ds Max configuration file \n            		<span class=\"filePath\">3dsmax.ini</span> is provided through the \n            		<em class=\"strong\">cfgMgr</em> struct. \n            	 \n         </p>\n         <p>The cfgMgr struct exposes these functions: \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt; cfgMgr.<em class=\"codeEmphasisStrong\">getIniFile</em>()</pre></div>\n         <p>Returns the full path of the 3ds Max INI file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;array&gt; cfgMgr.<em class=\"codeEmphasisStrong\">getAllSectionNames</em>()</pre></div>\n         <p>Returns an array of all the section names in the INI file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>cfgMgr.<em class=\"codeEmphasisStrong\">setSection</em> &lt;section_string&gt;</pre></div>\n         <p>Sets the current section to the specified name. Note that this function will create\n            a new section with the specified name if the section name does not exist. The other\n            get/set/delete functions in \n            		<span class=\"code\">cfgMgr</span> operate on the currently set section.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt; cfgMgr.<em class=\"codeEmphasisStrong\">getSectionName</em>()</pre></div>\n         <p>Gets the current section name, either the last section read, or a section set by \n            		<span class=\"code\">setSection()</span>. Other get/set/delete functions operate on the current section. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">sectionExists</em> &lt;section_string&gt;</pre></div>\n         <p>Returns true if the specified section exists already in the INI file, false otherwise.\n            Note that the section name matching is not case sensitive. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">deleteSection</em> &lt;section_string&gt;</pre></div>\n         <p>Deletes the specified section. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;array&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getSectionKeyNames</em>()</pre></div>\n         <p>Gets an array of key names for the current section. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">keyExists</em> &lt;key_string&gt;</pre></div>\n         <p>Returns true if the specified key exists in the current section, false otherwise.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">deleteKey</em> &lt;key_string&gt;</pre></div>\n         <p>Deletes the specified key. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">putString</em> &lt;key_string&gt; &lt;string&gt;</pre></div>\n         <p>Writes the specified string value to the specified key, where the first parameter\n            is the key name, and the second parameter is the value. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">putFloat</em> &lt;key_string&gt; &lt;float&gt;</pre></div>\n         <p>Writes the specified float value to the specified key. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">putInt</em> &lt;key_string&gt; &lt;int&gt; useULong:&lt;false&gt;</pre></div>\n         <p>Writes the specified integer value to the specified key. The optional \n            		<span class=\"code\">useULong</span> parameter is for internal use only. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">putFloatArray</em> &lt;key_string&gt; &lt;float array&gt;</pre></div>\n         <p>Writes the specified array of floats to the specified key. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; cfgMgr.<em class=\"codeEmphasisStrong\">putIntArray</em> &lt;key_string&gt; &lt;int array&gt; useULong:&lt;false&gt;</pre></div>\n         <p> Writes the specified array of integers to the specified key. The optional \n            		<span class=\"code\">useULong</span> parameter is for internal use only. \n            	 \n         </p>\n         <p>This function always returns \n            		<em class=\"strong\">true</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;string&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getString</em> &lt;key_string&gt;</pre></div>\n         <p>Returns the value of the specified key as a string if the key exists, or as undefined\n            if it does not. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;float&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getFloat</em> &lt;key_string&gt;</pre></div>\n         <p>Returns the value of the specified key as a float if the key exists, or as undefined\n            if it does not. If the key contains an array, the first value is coerced to a float\n            and returned. If the key contains character data, a value of 0.0 is returned. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;int&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getInt</em> &lt;key_string&gt; useULong:&lt;false&gt;</pre></div>\n         <p>Returns the value of the specified key as an integer if the key exists, or as undefined\n            if it does not. If the key contains a float value, it is coerced to an integer before\n            it is returned. If it contains character data, a value of 0 is returned. If the key\n            contains an array, the first value is coerced to an integer and returned.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;float array&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getFloatArray</em> &lt;key_string&gt;</pre></div>\n         <p>Returns an array of floats for the specified key, if it exists, or undefined if it\n            does not. \n            	 \n         </p>\n         <p>Do not call this function on a key that contains anything other than an array of floats.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>[&lt;int array&gt;|undefined] cfgMgr.<em class=\"codeEmphasisStrong\">getIntArray</em> &lt;key_string&gt; useULong:&lt;false&gt;</pre></div>\n         <p>Returns an array of integers for the specified key, if it exists, or undefined if\n            it does not. \n            	 \n         </p>\n         <p> </p><a name=\"TABLE_C9E421CB692C4193A7E2ABF50524FAEC\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">For Example</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- get ini file path:\ncfgMgr.getIniFile()\n--&gt; \"C:\\[path_to_ini_file]\\3dsMax.ini\"\n\n-- get all the sections:\ncfgMgr.getAllSectionNames()\n\n-- create a new section for the demo:\ncfgMgr.setSection \"CFGMGR TEST\"\n\n-- confirm this is the active section:\ncfgMgr.getSectionName()\n--&gt; \"CFGMGR TEST\"\n\ncfgMgr.sectionExists \"CFGMGR TEST\"\n--&gt; false\n-- returns false until the section contains keys\n\ncfgMgr.putString \"MyStringKey\" \"Hello this is a string\"\ncfgMgr.putFloat \"MyFloatKey\" 3.41\ncfgMgr.putInt \"MyIntKey\" 42\ncfgMgr.putFloatArray \"MyFloatArrayKey\" #(2.2,3.3,4.4)\ncfgMgr.putIntArray \"MyIntArrayKey\" #(7,6,5,4,3)\n\n/* At this point the config file contains:\n[CFGMGR TEST]\nMyStringKey=Hello this is a string\nMyFloatKey=3.410000\nMyIntKey=42\nMyFloatArrayKey=2.200000 3.300000 4.400000\nMyIntArrayKey=7 6 5 4 3\n*/\n\n-- you typically do not want to do these things, but they work:\ncfgMgr.getFloat \"MyIntKey\"\n--&gt; 42.0\ncfgMgr.getInt \"MyIntArrayKey\"\n--&gt; 7\ncfgMgr.getString \"MyFloatKey\"\n--&gt; \"3.410000\"\n\n-- does not work, don\'t do it:\n-- cfgMgr.getFloatArray \"MyStringKey\"\n-- nor this: \n-- cfgMgr.getIntArray \"MyFloatArrayKey\"\n\n-- but this is ok:\ncfgMgr.getFloatArray \"MyIntArrayKey\"\n--&gt; #(7.0, 6.0, 5.0, 4.0, 3.0)\n\n-- cleanup, section/key names are not case-sensitve:\ncfgMgr.deleteSection \"Cfgmgr Test\"\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";