var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-07D714FC-B207-4BBF-9590-16C93C631F50\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"return expression\">\n      <meta name=\"indexterm\" content=\"function\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>The Return Expression</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-07D714FC-B207-4BBF-9590-16C93C631F50\"></a><div class=\"head\">\n            <h1>The Return Expression </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87478\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87479\"></a>   As with the loop constructs, you can break out of a function body block-expression\n               prematurely in MAXScript and return a result without evaluating the remaining portion\n               of the block. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8747D\"></a>For this purpose, you can use the <span class=\"code\"> <em class=\"strong\">return</em> </span> expression: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6082\"></a><pre><em class=\"codeEmphasisStrong\">return</em> &lt;expr&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8747F\"></a>If a <span class=\"code\"> <em class=\"strong\">return</em> </span> expression is evaluated in the course of running a function body, the function exits\n               immediately and yields the value given in the <span class=\"code\"> <em class=\"strong\">return &lt;expr&gt;</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87481\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87482\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6081\"></a><pre>\nfn find_root twod_fn =\n(\nlocal root, last_root\nwhile true do\n(\n--...\nif abs(root - last_root) &lt; epsilon then return root\n--...\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1933\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>It is unnecessary to place a <span class=\"code\"> <em class=\"strong\">return</em> </span> expression at the end of a function body to return an expression value. Instead,\n                  simply place the result expression at the end of a function body. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87495\"></a>If a <span class=\"code\"> <em class=\"strong\">return &lt;expr&gt;</em> </span> is used in a mapped function and a collection is passed as the first argument to\n               the function, the value returned will be <span class=\"code\"> <em class=\"strong\">OK</em> </span> rather than <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87496\"></a>As a special case, you can exit a script controller’s script using a <span class=\"code\"> <em class=\"strong\">return &lt;expr&gt;</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87497\"></a> <em class=\"strong\">In 3ds Max 6 and higher</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87498\"></a>You can call <span class=\"code\"> <em class=\"strong\">return()</em> </span> in macroScripts whose body is a single expression (old style MacroScripts that do\n               not implement \'on execute do ...\' handler) to exit the MacroScript. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8749A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8749B\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8749C\"></a><p class=\"table-body\"> The <span class=\"code\"> <em class=\"strong\">return</em> </span> expression is <em class=\"strong\">very slow</em>. If your function will be called very often, try to avoid using it. See <span class=\"char_link\"><a href=\"GUID-DEFAF4D3-ADE9-469E-963A-440996D64BE1.htm\">Do not use return, break, exit or continue</a></span> for details. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";