var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0876DF46-FAA3-4131-838D-5739A67FF2C1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Draw a Freehand Spline</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0876DF46-FAA3-4131-838D-5739A67FF2C1\"></a><div class=\"head\">\n            <h1>How To ... Draw a Freehand Spline </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F94\"></a> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F97\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F98\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Draw a Freehand Spline \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9A\"></a> <em class=\"strong\">3ds Max</em> does not provide a built-in function for drawing splines freely with the mouse. Surprisingly\n               enough, the old Autodesk 3D Studio DOS had such a feature. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9B\"></a>Using the power of MAXScript, we can implement this feature as a simple MacroScript.\n               It will let us draw a spline in the ground plane using the mouse. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9C\"></a> <em class=\"strong\">Related Topics:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9D\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining MacroScripts</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9E\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F9F\"></a> <span class=\"char_link\"><a href=\"GUID-1C3873E2-A01A-4EF5-8B29-44617DFCDE81.htm\">Spline Shape Common Properties, Operators, and Methods</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA0\"></a> <span class=\"char_link\"><a href=\"GUID-42CD0531-6BD1-4489-B5A0-C001F4EE577B.htm\">Picking Points in the Viewports</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA1\"></a> <span class=\"char_link\"><a href=\"GUID-7A4AA91A-0DEB-470B-AD6B-2E7A3A105BD0.htm\">MAXScript Message and Query Dialogs</a></span> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA4\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA5\"></a><p class=\"table-body\">Package the code as macroScript to be able to use as a button, menu item or shortcut.\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA6\"></a><p class=\"table-body\">Define a function to measure the distance between the last and current mouse position\n                           and add a new knot to the spline when a threshold is exceeded. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA7\"></a><p class=\"table-body\">Define a drawing function to capture the mouse movement using the built-in pickPoint\n                           function. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA8\"></a><p class=\"table-body\">Put the complete creation code in an undo context to be able to undo the drawing.\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FA9\"></a><p class=\"table-body\">Create a new splineShape object. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAA\"></a><p class=\"table-body\">Let the user click in the viewport to define the start of the spline. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAB\"></a><p class=\"table-body\">If the user right-clicked, cancel the operation \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAC\"></a><p class=\"table-body\">If the user left-clicked, add a knot to the spline and call the draw function. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAD\"></a><p class=\"table-body\">As long as the user moves the mouse, the pickPoint callback will keep on measuring\n                           the segment lengths and adding new knots when needed. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAE\"></a><p class=\"table-body\">If the user clicked again, ask about closing the spline. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FAF\"></a><p class=\"table-body\">If answer is yes, close the spline, select it and exit the script \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FB0\"></a><p class=\"table-body\">If answer is no, just select the spline and exit the script. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FB2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FB3\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650A\"></a><pre>\nmacroscript FreeSpline category:\"HowTo\" tooltip:\"FreeSpline\"\n(\nlocal old_pos\nlocal new_spline\nlocal second_knot_set\n&nbsp;\nfn get_mouse_pos pen_pos old_pen_pos =\n(\n&nbsp;if old_pos == undefined then old_pos = old_pen_pos\n&nbsp;if distance pen_pos old_pos &gt; 10 then\n&nbsp;(\n&nbsp;&nbsp;if second_knot_set then\n&nbsp;&nbsp;&nbsp;addKnot new_spline 1 #smooth #curve pen_pos\n&nbsp;&nbsp;else\n&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;setKnotPoint new_spline 1 2 pen_pos\n&nbsp;&nbsp;&nbsp;second_knot_set = true\n&nbsp;&nbsp;)\n&nbsp;&nbsp;old_pos = pen_pos\n&nbsp;&nbsp;updateShape new_spline\n&nbsp;)-- end if\n)-- end fn\nfn draw_new_line old_pen_pos =\n(\n&nbsp;pickPoint mouseMoveCallback:#(get_mouse_pos,old_pen_pos)\n)\n&nbsp;\nundo\"Free Spline\"on\n(\n&nbsp;new_spline = splineShape ()\n&nbsp;old_pen_pos = pickPoint ()\n&nbsp;if old_pen_pos == #RightClick then\n&nbsp;(\n&nbsp;&nbsp;delete new_spline\n&nbsp;)\n&nbsp;else\n&nbsp;(\n&nbsp;&nbsp;select new_spline\n&nbsp;&nbsp;new_spline.pos = old_pen_pos\n&nbsp;&nbsp;addNewSpline new_spline\n&nbsp;&nbsp;addKnot new_spline 1 #smooth #curve old_pen_pos\n&nbsp;&nbsp;addKnot new_spline 1 #smooth #curve old_pen_pos\n&nbsp;&nbsp;second_knot_set = false\n&nbsp;&nbsp;draw_new_line old_pen_pos\n&nbsp;&nbsp;q = querybox \"Close Spline?\" title:\"Free Spline\"\n&nbsp;&nbsp;if q then\n&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;close new_spline 1\n&nbsp;&nbsp;&nbsp;updateshape new_spline\n&nbsp;&nbsp;)&nbsp;\n&nbsp;&nbsp;select new_spline\n&nbsp;)--end else\n)--end undo\n)--end script\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FED\"></a> \n               <h3><a name=\"GUID-7304E0AF-1475-4018-AD9C-F814BA75F30E\"></a> <em class=\"strong\">Step-By-Step</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6509\"></a><pre><em class=\"codeEmphasisStrong\">macroscript FreeSpline category:\"HowTo\" tooltip:\"FreeSpline\"\n(</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FF1\"></a>The macroScript will be called \n                  			 <span class=\"code\"> <em class=\"strong\">FreeSpline</em> </span>. To use the script, you can go to Customize... and drag the script from the category\n                  \"HowTo\" to a toolbar, a menu, a quad menu or assign to a keyboard shortcut. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FF2\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6508\"></a><pre><em class=\"codeEmphasisStrong\">local old_pos\nlocal new_spline\nlocal second_knot_set</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FF6\"></a>We will need some local variables to store the last knot position and the new object\n                  created by the script. The third variable will be used as a flag to tell us whether\n                  we just started creation of the spline. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FF7\"></a>These variables will exist only inside the macroScript’s context as we declare them\n                  as local. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FF8\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6507\"></a><pre><em class=\"codeEmphasisStrong\">fn get_mouse_pos pen_pos old_pen_pos =\n(</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FFB\"></a>We create our own function to handle the drawing of new knots in the splineShape.\n                  This function receives two parameters – the current position of the mouse, and the\n                  result of the first click captured by the pickPoint function (see below). \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FFC\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6506\"></a><pre><em class=\"codeEmphasisStrong\">if old_pos == undefined then old_pos = old_pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FFE\"></a>If we don’t know of an existing Knot (creation just started!), we set the value of\n                  the old_pos local variable to the first clicked point provided by the old_pen_pos\n                  parameter. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1FFF\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">If Expression</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2000\"></a> <span class=\"char_link\"><a href=\"GUID-D37202D3-0E64-4A15-B737-9FA0D22A3C5B.htm\">Undefined Value</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6505\"></a><pre><em class=\"codeEmphasisStrong\">if distance pen_pos old_pos &gt; 10 then\n(</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2003\"></a>Next we check the distance between the last known knot’s position and the current\n                  mouse position. If the distance is longer than 10 units... \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2004\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">If Expression</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2005\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm#WS73099CC142F487553098682E12AC2FC2BC7-5F9A\">Distance_Point3</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6504\"></a><pre><em class=\"codeEmphasisStrong\">if second_knot_set then</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2008\"></a>The flag variable we defined will contrain either true or false. When the variable\n                  contains false, spline creation has just started. Because a spline must have at least\n                  two knots (vertices), we will create the first knot twice and then set this flag to\n                  false. When the next knot position is to be set, instead of creating a new one, we\n                  will reposition the existing second knot to the new coordinates and then set the flag\n                  to true. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2009\"></a>When the flag is set to true, we will just create the next new knot - see next line...\n                  \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6503\"></a><pre><em class=\"codeEmphasisStrong\">addKnot new_spline 1 #smooth #curve pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC200B\"></a>...we go on and place a new knot, thus adding a new segment to the spline shape. The\n                  addKnot function requires a splineShape object, the index of the spline (we have just\n                  1), the type of the knot (we use #smooth in our case), and the position to put the\n                  knot at. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC200C\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6502\"></a><pre><em class=\"codeEmphasisStrong\">else\n(\nsetKnotPoint new_spline 1 2 pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2011\"></a>When the flag is set to false, we have to move the existing second knot instead of\n                  creating a new one... \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6501\"></a><pre><em class=\"codeEmphasisStrong\">second_knot_set = true</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2013\"></a>Then we set the flag to true. Next time, a new knot will be created instead... \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6500\"></a><pre><em class=\"codeEmphasisStrong\">)\nold_pos = pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2017\"></a>Then we remember the new knot’s position to use by the next mouse movement check.\n                  \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FF\"></a><pre><em class=\"codeEmphasisStrong\">updateShape new_spline</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2019\"></a>To see the changes made to the spline, we update the splineShape object. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC201A\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FE\"></a><pre><em class=\"codeEmphasisStrong\">) -- end if\n) -- end fn\nfn draw_new_line old_pen_pos =\n(</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2020\"></a>We create another function to handle the capturing of the mouse motion. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2021\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FD\"></a><pre><em class=\"codeEmphasisStrong\">pickPoint mouseMoveCallback:#(get_mouse_pos,old_pen_pos)</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2023\"></a>Our function calls only the built-in pickPoint function which provides an optional\n                  callback which calls the function we just defined (get_mouse_point) and passes the\n                  current mouse position and any user parameters supplied (in our case, old_pen_pos).\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2024\"></a>As long as the mouse is moving and no clicks are encountered, the pickPoint’s mouseMoveCallback\n                  will constantly call our function and thus create new knots at distance of 10 units...\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2025\"></a> <span class=\"char_link\"><a href=\"GUID-42CD0531-6BD1-4489-B5A0-C001F4EE577B.htm\">Picking Points in the Viewports</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FC\"></a><pre><em class=\"codeEmphasisStrong\">)\nundo \"Free Spline\" on\n(</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC202A\"></a>We will put the complete code in an undo context to be able to undo the whole drawing\n                  result. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC202B\"></a> <span class=\"char_link\"><a href=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11.htm\">undo</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FB\"></a><pre><em class=\"codeEmphasisStrong\">new_spline = splineShape ()</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC202D\"></a>When starting the script, we first construct an empty splineShape object. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC202E\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64FA\"></a><pre><em class=\"codeEmphasisStrong\">old_pen_pos = pickpoint ()</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2030\"></a>Then we go into pickPoint mode (but this time without a mouse callback). The function\n                  will wait for a click in the viewport and return the position of the picked point,\n                  or #RightClick if the Right Mouse Button has been pressed. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2031\"></a> <span class=\"char_link\"><a href=\"GUID-42CD0531-6BD1-4489-B5A0-C001F4EE577B.htm\">Picking Points in the Viewports</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F9\"></a><pre><em class=\"codeEmphasisStrong\">if old_pen_pos == #RightClick then\n(\ndelete new_spline\n)</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2036\"></a>If the Right Mouse Button has been actually pressed, we just delete the newly created\n                  splineShape and finish the script. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2037\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">If Expression</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F8\"></a><pre><em class=\"codeEmphasisStrong\">else\n(\nselect new_spline</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC203B\"></a>If the pickButton has returned a position value and not #RightClick, we can select\n                  the splineShape... \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F7\"></a><pre><em class=\"codeEmphasisStrong\">new_spline.pos = old_pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC203D\"></a>Set the position of the splineShape to the clicked point... \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F6\"></a><pre><em class=\"codeEmphasisStrong\">addNewSpline new_spline</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC203F\"></a>...add a new spline to the empty splineShape... \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2040\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F5\"></a><pre><em class=\"codeEmphasisStrong\">addKnot new_spline 1 #smooth #curve old_pen_pos\naddKnot new_spline 1 #smooth #curve old_pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2043\"></a>...and add two new knots to the newly create spline in the splineShape. As mentioned\n                  above, a spline should have at least two knots, so we create the first two with the\n                  same position and will then move the second knot instead of creating a new one. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2044\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F4\"></a><pre><em class=\"codeEmphasisStrong\">second_knot_set = false</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2047\"></a>We \"lower the flag\" by setting it to false. This way, the script will know that we\n                  just created the first two knots and the second one has to be set to the next mouse\n                  position captured by the script. When this is done in the \n                  			 <span class=\"code\"> <em class=\"strong\">get_mouse_pos</em> </span> function, we will \"raise the flag\" again by setting it to true and thus know that\n                  the initial spline creation steps are over... \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F3\"></a><pre><em class=\"codeEmphasisStrong\">draw_new_line old_pen_pos</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2049\"></a>Now we can call our \n                  			 <span class=\"code\"> <em class=\"strong\">draw_new_line</em> </span> function and pass the first clicked point as parameter. That function will start\n                  monitoring the mouse movements until a new click occurs. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC204A\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F2\"></a><pre><em class=\"codeEmphasisStrong\">q = querybox \"Close Spline?\" title:\"Free Spline\"</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC204C\"></a>If a new click has been captured by the \n                  			 <span class=\"code\"> <em class=\"strong\">pickPoint</em> </span> function, the \n                  			 <span class=\"code\"> <em class=\"strong\">draw_new_line</em> </span> function will return to this point. Now we can ask the user whether he wants to close\n                  the newly drawn spline. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC204D\"></a> <span class=\"char_link\"><a href=\"GUID-7A4AA91A-0DEB-470B-AD6B-2E7A3A105BD0.htm\">MAXScript Message and Query Dialogs</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F1\"></a><pre><em class=\"codeEmphasisStrong\">if q then\n(\nclose new_spline 1\nupdateshape new_spline</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2052\"></a>If the answer to the query is Yes, we close the first and only spline in the splineShape\n                  and update the internal data structures to reflect the changes. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2053\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">If Expression</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2054\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64F0\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\nselect new_spline</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2057\"></a>Finally, we select the newly-created splineShape in the scene before exiting. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64EF\"></a><pre><em class=\"codeEmphasisStrong\">)--end else\n)--end undo\n)--end script</em></pre></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC205B\"></a> \n               <h3><a name=\"GUID-A64255ED-3E99-4605-9428-1F9C92467138\"></a> <em class=\"strong\">Using the Script</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC205C\"></a>Evaluate the script. To use it, you can use Customize... to drag the script from the\n                  category \"HowTo\" to a toolbar, a menu, a quad menu or to assign to a keyboard shortcut.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC205D\"></a>Execute the FreeSpline script and left-click in the top or perspective viewport. Drag\n                  the mouse freely to draw a spline. Left-click again to finish drawing. Answer the\n                  prompt with Yes to close or No to leave the spline open. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC205E\"></a> \n               <h3><a name=\"GUID-AEE6EEFA-CE8B-4E87-A04A-1D4154844DB6\"></a> <em class=\"strong\">Where to go from here</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC205F\"></a>This is just some basic code. You could try to add a UI with controls for segment\n                  length threshold, spline segment and knot types (linear, smooth, bezier etc.) \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2060\"></a> <em class=\"strong\">Back to</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2061\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";