var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-09174DC2-033E-4EA5-ACBB-AA840A15D070\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"String Parser Methods\">\n      <meta name=\"indexterm\" content=\"trimRight()\">\n      <meta name=\"indexterm\" content=\"trimLeft()\">\n      <meta name=\"indexterm\" content=\"skipSpace()\">\n      <meta name=\"indexterm\" content=\"readToken()\">\n      <meta name=\"indexterm\" content=\"peekToken()\">\n      <meta name=\"indexterm\" content=\"isSpace()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>String Parser Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-09174DC2-033E-4EA5-ACBB-AA840A15D070\"></a><div class=\"head\">\n            <h1>String Parser Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D3B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D3A\"></a>       The following string parsing methods were first introduced in <em class=\"strong\">gmax</em> 1.0 and are available in <em class=\"strong\">3ds Max 5 and higher</em>. \n            </p> \n            <p><a name=\"GUID-12795059-22BD-4794-9E61-EC09A9580BD5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D32\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6988\"></a><pre>&lt;Boolean&gt;<em class=\"codeEmphasisStrong\">isSpace</em> &lt;String&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D30\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the first character of the given string is whitespace (space, tab, or newline),\n               <span class=\"code\"> <em class=\"strong\">false</em> </span> if not. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D2F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D2E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6987\"></a><pre>\nisSpace \" MAXScript\" --first character is space\ntrue\nisSpace \"MAXScript\" --first character is not whitespace\nfalse\nisSpace \"\\nMAXScript\" --first character is new line\ntrue\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-B8FE841A-926A-439B-ACD7-2FF7C6A04A06\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6986\"></a><pre>&lt;String&gt;<em class=\"codeEmphasisStrong\">trimLeft</em> &lt;String&gt; [String trimChars]   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D22\"></a>Trims all leading characters specified in trimChars from the given string and returns\n               it. If trimChars is not specified, basic whitespace characters (space, tab, and newlines)\n               are trimmed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D21\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D20\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6985\"></a><pre>\ntrimleft \" \\nMAXScript\" --space and new line trimmed\n\"MAXScript\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-195E4737-430A-442D-B426-E3FDC39A8DA7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6984\"></a><pre>&lt;String&gt;<em class=\"codeEmphasisStrong\">trimRight</em> &lt;String&gt; [String trimChars] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D18\"></a>Trims all trailing characters specified in trimChars from the given string and returns\n               it. If trimChars is not specified, basic whitespace characters (space, tab, and newlines)\n               are trimmed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D17\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D16\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6983\"></a><pre>\ntrimright \"MAXScript \\n \" --spaces and new line trimmed\n\"MAXScript\"\ntrimright \"$Teapot0911\" \"1234567890\" --remove trailing numbers\n\"$Teapot\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-659335A6-AC61-4A27-BAA4-056BA02EBDCA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6982\"></a><pre>&lt;String&gt;<em class=\"codeEmphasisStrong\">readToken</em> &lt;CharStream&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D0C\"></a>Reads a token from the given stream and returns it as a string. Tokens are defined\n               by a sequence of characters broken up by whitespace. Leading whitespace and one line\n               \"//\" style comments are automatically skipped. \n            </p> \n            <p><a name=\"GUID-FC7CFD57-B0AA-4D2D-A5A9-57899E4E97FA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6981\"></a><pre>&lt;String&gt;<em class=\"codeEmphasisStrong\">peekToken</em> &lt;CharStream&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D09\"></a>Same as readToken except it does not increment the file position. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D08\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D07\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6980\"></a><pre>\na= \"token! -- /* comment!\\n */ ( ( \\\"nested bracket\\\" pair ) ) \" as stringstream\n(while peekToken a != undefined do print (readToken a);ok)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-2FE879D0-1E8A-4EB2-868F-A19B7940F99A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-697F\"></a><pre><em class=\"codeEmphasisStrong\">skipSpace</em> &lt;CharStream&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1CFF\"></a>Skips to first non-whitespace from the given stream\'s current file position. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1CFC\"></a> <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm\">String Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";