var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Custom Attribute Management Functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Custom Attribute Management Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559\"></a><div class=\"head\">\n            <h1>Custom Attribute Management Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A0D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A0C\"></a> The following management functions are available through the custAttributes struct:\n               \n               		\n            </p> \n            <p><a name=\"GUID-A63AE43F-B9CA-4741-A3FD-627CB328264D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22FE\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">count</em> &lt;obj&gt; [<em class=\"codeEmphasisStrong\">BaseObject</em>:&lt;bool&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A08\"></a>Returns a count of the number of separate scripted custom attribute sets have been\n               added via the \n               		  <span class=\"code\"> <em class=\"strong\">.add()</em> </span> function. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A06\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on instead. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on. \n               		\n            </p> \n            <p><a name=\"GUID-E0214A83-9C8F-4C50-980F-B5FF81CDED69\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22FC\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">get</em> &lt;obj&gt; (&lt;index&gt; | &lt;attrib_def&gt;)[BaseObject:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A04\"></a>Returns the custom attribute set, specified as an index or by its defining attribute\n               definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A02\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on. (In versions prior to \n               		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used.) \n               		\n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F58\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-BC7BACD2-C665-49B0-9D87-006B8AEBFB36\"></a>The custom attribute set values returned by the custAttributes are effectively holder\n                     values for the object\'s custom parameters in that attribute set. You can get at these\n                     parameter values as simple properties on the attribute set value. \n                     		  \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49FD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49FC\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22FA\"></a><pre>\ngp = custAttributes.get $ gameParams\ngp.hitPoints= 50 				  </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49F8\"></a><p class=\"table-body\">This is equivalent to accessing the custom attribute parameters directly on the object:\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F9\"></a><pre>$.gameParams.hitPoints = 50 				</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-5826520F-E570-4840-8A87-7900EB98572B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F8\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">delete</em> &lt;obj_or_collection&gt; (&lt;index&gt; | &lt;attrib_def&gt;) [<em class=\"codeEmphasisStrong\">baseObject</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49F1\"></a>Deletes the specified custom attribute set from the object or from all the objects\n               in the given collection. The set to be deleted is defined by index number or by its\n               defining attributes definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49EF\"></a>If the optional keyword argument \n               		  <span class=\"code\">baseObject</span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\">false</span>, the node itself will be operated on.(In versions prior to \n               		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used.) \n               		\n            </p> \n            <p><a name=\"GUID-E3FC2D6B-28DE-4B9B-A8A2-16DB477356C0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F6\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">makeUnique</em> &lt;obj&gt; (&lt;index&gt; | &lt;attrib_def&gt;) [<em class=\"codeEmphasisStrong\">baseObject</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49EC\"></a>If some objects with custom attribute sets share a specific attributes definition,\n               you can make selected objects have unique copies of the definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49EA\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on.(In versions prior to \n               		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used.) \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49E9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49E8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F4\"></a><pre>custAttributes.<em class=\"codeEmphasisStrong\">add</em> $box* def1 			 </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49E4\"></a><p class=\"table-body\">You can make box01 unique with: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F3\"></a><pre>custAttributes.<em class=\"codeEmphasisStrong\">makeUnique </em>$box01 def1 		  </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49E0\"></a><p class=\"table-body\">or all of them unique with: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F2\"></a><pre>custAttributes.<em class=\"codeEmphasisStrong\">makeUnique</em> $box* def1 		</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-ED466835-A4D2-43FB-8B7C-F79EFCA2C5B9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22F1\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">getDef</em> (&lt;obj&gt; &lt;index&gt;) | &lt;custAttrib&gt; [<em class=\"codeEmphasisStrong\">baseObject</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D9\"></a>Returns the attribute definition for a given custom attribute set in an object or\n               from a custom attribute set accessed with the \n               		  <span class=\"code\"> <em class=\"strong\">.get()</em> </span> method. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D7\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on.(In versions prior to \n               		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used.) \n               		\n            </p> \n            <p><a name=\"GUID-77A782B0-A93F-46F3-9AC8-CCC201DCF1C7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22EF\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">getDefs</em> &lt;obj&gt; [<em class=\"codeEmphasisStrong\">baseObject</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D4\"></a>Returns an array of definitions in attribute set order. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D2\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on.(In versions prior to \n               		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used.) \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D1\"></a> <em class=\"strong\">Next Topic:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49D0\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49CE\"></a> <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Scripted Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49CD\"></a> <span class=\"char_link\"><a href=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7.htm\">Adding Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49CC\"></a> <span class=\"char_link\"><a href=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4.htm\">Global and Private Custom Attributes Definitions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49CB\"></a> <span class=\"char_link\"><a href=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0.htm\">Access to Custom Attributes Virtual Array</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-49CA\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";