var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0A4CD125-5CA0-42DA-B2D6-B8FDF511CCE8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"mouseTrack() Function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>mouseTrack() Function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0A4CD125-5CA0-42DA-B2D6-B8FDF511CCE8\"></a><div class=\"head\">\n            <h1>mouseTrack() Function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36EC\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36EB\"></a> The mouseTrack function lets you register a MAXScript function to track the mouse.\n               While the tracking is going on, this function is called whenever a mouse action occurs,\n               such as a button click or a drag, etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36E9\"></a>The function has the form: \n            </p> \n            <p><a name=\"GUID-44B61C0B-01D8-4D4A-8222-36B1E4F4D3A9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5F\"></a><pre><em class=\"codeEmphasisStrong\">mouseTrack</em> [<em class=\"codeEmphasisStrong\">on</em>:&lt;node&gt;] [<em class=\"codeEmphasisStrong\">prompt</em>:&lt;message_string&gt;] [<em class=\"codeEmphasisStrong\">snap</em>:<em class=\"codeEmphasisStrong\">#2D|#3D</em>] [<em class=\"codeEmphasisStrong\">trackCallback</em>:fn|#(fn,arg)]</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5E\"></a><pre><em class=\"codeEmphasisStrong\">on:</em>&lt;node&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36E6\"></a>Optionally specifies a scene object to track on. If you don\'t supply an object, the\n               mouse tracks on the current active grid. Note that the object surface tracker uses\n               the SDK function IntersectRay() which is not reliably implemented on all object types.\n               Editable meshes always work OK, so you can convertToMesh() if needed. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5D\"></a><pre><em class=\"codeEmphasisStrong\">prompt:</em>&lt;message_string&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36E4\"></a>Displays the prompt message in the MAX status line \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5C\"></a><pre><em class=\"codeEmphasisStrong\">snap:#2D|#3D</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36E2\"></a>Relevant when not tracking on an object surface (no <span class=\"code\"> <em class=\"strong\">on</em> </span>:&lt;node&gt; specified). If snap mode is on and <span class=\"code\"> <em class=\"strong\">#2D</em> </span> is supplied, snaps to snap points on grid, if <span class=\"code\"> <em class=\"strong\">#3D</em> </span> is specified snaps to any near snap point in space. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5B\"></a><pre><em class=\"codeEmphasisStrong\">trackCallback:</em>fn|#(fn,arg) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36E0\"></a>Is where you specify the function to be called as the mouse is dragged over the active\n               grid or object surface. You can specify it is a single function or a function and\n               an argument value in a two element array. The latter form is useful if you have a\n               common callback function for many tasks and want to send in a parameter to control\n               its operation for a particular use. The function you give must be of the following\n               form: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D5A\"></a><pre><em class=\"codeEmphasisStrong\">fn callback_fn msg ir obj faceNum shift ctrl alt = ...</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36DE\"></a>in other words, a scripted function with 7 arguments. While the tracking is going\n               on, it is called whenever a mouse action occurs, such as a button click or a drag,\n               etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36DD\"></a>The <span class=\"code\"> <em class=\"strong\">\'msg\'</em> </span> argument is a message code that indicates what kind of action occurred, and can be\n               one of: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D59\"></a><pre><em class=\"codeEmphasisStrong\">#freeMove</em> - means the mouse is moved without a button being pressed \n<em class=\"codeEmphasisStrong\">#mousePoint</em> - means the left mouse button has just been pressed \n<em class=\"codeEmphasisStrong\">#mouseMove</em> - means the mouse is being dragged with the left button down \n<em class=\"codeEmphasisStrong\">#mouseAbort</em> - means the right mouse button was clicked, normally meaning cancel </pre></div> \n            <p><a name=\"GUID-B1212D4E-BF78-492C-80A9-36E46B1B30F8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D58\"></a><pre>\'ir\' </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36D7\"></a>The grid or surface intersection normal Ray at the current mouse position. The ray\n               has a <span class=\"code\"> <em class=\"strong\">.pos</em> </span> property giving the point in space of the normal and a .dir property giving the normal\'s\n               direction vector. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D57\"></a><pre>\'obj\' </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36D5\"></a>The object being dragged over or undefined if no on:&lt;node&gt; was supplied. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D56\"></a><pre>\'faceNum\' </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36D3\"></a>The number of the face the mouse is over if the object being tracked is an editable\n               mesh, undefined otherwise. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D55\"></a><pre>\'shift\', \'ctrl\' and \'alt\' </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36D1\"></a>True or false depending on the down or up state of the <span class=\"keyboardEntry\">Shift</span>, <span class=\"keyboardEntry\">Ctrl</span> and <span class=\"keyboardEntry\">Alt</span> keys on the keyboard. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36D0\"></a>The function should return the special value <span class=\"code\"> <em class=\"strong\">#continue</em> </span> to continue tracking or any other value to halt tracking. That value then becomes\n               the result of the original <span class=\"code\"> <em class=\"strong\">mouseTrack()</em> </span> call. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36CE\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";