var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0B7D0519-6059-45CE-BB1D-C8673C12B506\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"addModifier()\">\n      <meta name=\"indexterm\" content=\"addModifierWithLocalData\">\n      <meta name=\"indexterm\" content=\"deleteModifier()\">\n      <meta name=\"indexterm\" content=\"collapseStack()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifier Stack Related Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0B7D0519-6059-45CE-BB1D-C8673C12B506\"></a><div class=\"head\">\n            <h1>Modifier Stack Related Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D66\"></a><pre><em class=\"codeEmphasisStrong\">validModifier</em> [&lt;node&gt; | &lt;objectset&gt; | &lt;group&gt; ] &lt;modifier |modifier_class&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-342B\"></a>Tests whether a particular modifier or modifier class might be added the given \n            		<span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> or to all of the objects in the objectset or group. Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if so,<span class=\"code\"> <em class=\"strong\">false</em> </span> if not. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-342A\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">validModifier()</em> </span> method operates exactly as does the Modify panel in determining modifier applicability.\n            Any modifier that takes a deformable object will return \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> for all scene objects except Helpers. This corresponds to the Modify panel\'s behavior\n            of allowing modifiers such as, Bend, Taper, and so on to be applied to lights and\n            cameras, space warp objects, and others as well as geometry types such as, box, sphere,\n            and so on, but not helpers such as, dummys or bones. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3429\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">validModifier()</em> </span> method will return \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if an empty \n            		<span class=\"code\"> <em class=\"strong\">&lt;objectset&gt;</em> </span> is specified, or if a \n            		<span class=\"code\"> <em class=\"strong\">&lt;group&gt;</em> </span> is specified and the modifier is valid for all members of the group. In these cases,\n            applying the modifier using the \n            		<span class=\"code\"> <em class=\"strong\">addModifier()</em> </span> method will fail because the \n            		<span class=\"code\"> <em class=\"strong\">&lt;objectset&gt;</em> </span> is empty in the first case or the modifier cannot be applied to the dummy object\n            that is the parent object of the objects in the group. You will need to test for these\n            conditions in your script or use the \n            		<span class=\"code\"> <em class=\"strong\">modPanel.addModToSelection()</em> </span> method described in \n            		<span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_18FB7D5E10964B3384335931FECC0ABC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D65\"></a><pre><em class=\"codeEmphasisStrong\">addModifier</em> &lt;node&gt; &lt;modifier&gt; [<em class=\"codeEmphasisStrong\">before</em>:index] -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3426\"></a>Applies the modifier to \n            		<em class=\"strong\">all instances</em> of the node(s) to which the function is applied. The optional \n            		<span class=\"code\"> <em class=\"strong\">before:</em> </span> keyword argument can be used to insert the modifier into the node\'s modifier stack\n            just before the indexed modifier, counting from the top of the stack. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3425\"></a>Since \n            		<em class=\"strong\">3ds Max 3</em>, \n            		<span class=\"code\"> <em class=\"strong\">addModifier()</em> </span> does not preserve the sub-object selection that might be active in the modifier stack\n            when adding the modifier. If you want to add a modifier and preserve the sub-object\n            selection, use the \n            		<span class=\"code\"> <em class=\"strong\">modPanel.addModToSelection()</em> </span> method described in \n            		<span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3424\"></a>If \n            		<span class=\"code\"><em class=\"strong\">&lt;node&gt;</em></span> is a collection, an instance of the modifier is placed on each of the nodes in the\n            collection. Unlike interactively applying a modifier to a selection, the position\n            and size of each modifier instance\'s gizmo corresponds to position and size of the\n            node the modifier instance is applied to. To apply a modifier to a collection in the\n            same manner that \n            		<em class=\"strong\">3ds Max</em> applies modifiers, use the \n            		<span class=\"code\"><em class=\"strong\">modPanel.addModToSelection()</em></span> method described in \n            		<span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span>. \n            	 \n         </p>\n         <div><a name=\"GUID-CAC6FB67-20D3-480E-A5C0-BA259448850C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This method does not copy any local data, so, for example, using it to copy a modifier\n               on an existing node that has been manipulated to another node will not also copy the\n               changes. See \n               		<span class=\"code\"><em class=\"strong\">addModifierWithLocalData()</em></span> below to handle this situation. \n               	 \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3423\"></a>Also see \n            		<span class=\"char_link\"><a href=\"GUID-55EC8090-6593-416B-923F-2291D3983BC6.htm\">Modifier and SpacewarpModifier</a></span> for more details. \n            	 \n         </p>\n         <p><a name=\"P_DE569FFEADB544E6B54FB0D3BEF88C6D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">addModifierWithLocalData</em> &lt;destnode&gt; &lt;dest modifier&gt; &lt;srcnode&gt; &lt;src modifier_or_index&gt; [<em class=\"codeEmphasisStrong\">before</em>:index]</pre></div>\n         <p>This method copies an existing modifier, including its local data (including modifications\n            such as vertex positions), to a destination node. The two modifiers must be of the\n            same type. The local data of the source (if any) is cloned and attached to the destination\n            modifier. If the source modifier has no local data, the destination modifier will\n            contain whatever its default local data is (just as if it had been added by the \n            		<span class=\"code\"><em class=\"strong\">addModifier()</em></span> method). \n            	 \n         </p>\n         <p> &nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D64\"></a><pre><em class=\"codeEmphasisStrong\">deleteModifier</em> &lt;node&gt; &lt;modifier_or_index&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-341F\"></a>Lets you delete modifiers from the modifier stack. Takes either a modifier value that\n            is present on the \n            		<span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> stack, or an index specifying the index of the modifier to delete, counting from\n            the top of the stack. \n         </p>\n         <p><a name=\"P_E44E8DB264A44EEC8CB9B6CD951E365F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D63\"></a><pre><em class=\"codeEmphasisStrong\">collapseStack</em> &lt;node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-341C\"></a>Collapses the modifiers out of a stack, leaving a resultant editable base object corresponding\n            to the class of the node(s) on top of their stack. If there are no modifiers in the\n            stack when this is called, no action is taken. If you want to force an object to be\n            an editable mesh, use the function \n            		<span class=\"code\"> <em class=\"strong\">convertToMesh()</em> </span>. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";