var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0DCBE29A-130E-4C3D-82A7-5EEF8CAA8AAE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Referencing Nodes and Controllers in Script Controllers FAQ\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Referencing Nodes and Controllers in Script Controllers FAQ</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0DCBE29A-130E-4C3D-82A7-5EEF8CAA8AAE\"></a><div class=\"head\">\n            <h1>Referencing Nodes and Controllers in Script Controllers FAQ </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D53\"></a> The following Questions and Answers discuss the various variable types available in\n            <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> in <em class=\"strong\">3ds Max 8 and higher</em>. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D50\"></a> \n            <h2><a name=\"GUID-6B97D290-556C-45C6-838B-FAEA628295E3\"></a> <em class=\"strong\">What is the difference between the new and the old script controllers?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4F\"></a>The main difference between the old script controllers available <em class=\"strong\">prior to 3ds Max 8</em> and the new ones in <em class=\"strong\">3ds Max 8 and higher</em> is that there is an \"Assign Node\" button that allows you to pick a node. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4E\"></a>What is special about this is that the node is not held as a direct reference of the\n               script controller, rather it is held as in indirect reference. This is done through\n               an intermediate class called <em class=\"strong\">NodeTransformMonitor</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4D\"></a>The only messages that propagate from the referenced node to the scripted controller\n               are node transform messages and node deletion messages. This allows you to place a\n               scripted controller on a sphere\'s radius track, and then in the scripted controller\n               have a variable pointing at the node holding the sphere without creating a circular\n               dependency. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4C\"></a>Note that the expression controller also uses the NodeTransformMonitor when you have\n               a variable pointing at a node. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4B\"></a>See Also <span class=\"char_link\"><a href=\"GUID-5015B963-A1C7-457F-A76B-F63D3676CC6F.htm\">Script Controller - Avoiding Circular Dependency</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D4A\"></a> \n            <h2><a name=\"GUID-6DA04B45-9374-42C0-8A11-F802962678C9\"></a> <em class=\"strong\">What can I assign through the Assign Constant button?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D49\"></a>If you click <em class=\"strong\">Assign Constant</em>, you can type in any valid MAXScript expression. If the result is a MAXWrapper (like\n               a node, material, modifier, controller etc.), the result is stored as an Object. If\n               the result is a subAnim, it is stored as a Target. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D48\"></a>You can assign either a constant value from a MAXScript expression, or a dynamic value\n               if the expression evaluates to a controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D47\"></a>If you create the variable myVar and use the <em class=\"strong\">Assign Constant</em> button to assign the expression \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D46\"></a>$Box01.position.x_position.controller.value \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D45\"></a>in the Assign Constant dialog, the value of the controller on the current frame will\n               be taken as a constant value and assigned to the variable myVar. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D44\"></a>But if you say \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D43\"></a>$Box01.position.x_position.controller \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D42\"></a>this will create an Object value that points at the controller. In the controller\'s\n               expression code, you can use \'myVar.value\' to get the current value. The value will\n               not be stored as a constant, but will be dynamic and change as the current time changes.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D41\"></a> \n            <h2><a name=\"GUID-7FA43EC9-C0A1-4E83-8E62-A82AD5DF7DD4\"></a> <em class=\"strong\">What is the difference between assigning an Object and a Node to a variable?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D40\"></a>Let\'s say that you have two scripted controllers X and Y, and a node N that has a\n               sphere base object. A variable in X points at N as an Object. A variable in Y points\n               at N as a Node. If you change the sphere\'s radius, only X is re-evaluated. If you\n               move N, both X and Y are re-evaluated. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3F\"></a>If stored as a Node value, the controller is invalidated only if the node\'s transform\n               changes or the node is deleted. But it does allow you to specify nodes that would\n               create a circular reference if specified as an Object value. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3E\"></a>To specify whether to store an Object or a Node, you should use the Assign Track /\n               Assign Node buttons, or the MAXScript methods. When using the Assign Constant expression,\n               a MAXWrapper will always be stored as Object. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3D\"></a> \n            <h2><a name=\"GUID-FB934276-65C4-4DF7-9F40-484E1EB33FAA\"></a> <em class=\"strong\">What is the difference between accessing an object property through Node and Object</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3C\"></a>If you want, you can just create variables that hold Nodes as Object values, and then\n               reference the parameter you want as you would normally in the expression. For example,\n               myNode would point at a sphere node, and your expression would be \"myNode.radius\".\n               But this is not going to have as good performance as pointing to the sphere\'s radius\n               track as a Target. In the former, any change to the node (for example, moving the\n               node) will result in a controller re-evaluation. In the latter, only changes to the\n               sphere base object will result in a controller re-evaluation. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3B\"></a>Also, if you just specify a Node variable and then access base object parameters on\n               it (for example, its radius), you will get an error if you bring in the node as an\n               XRef. An XRef object doesn\'t expose the properties of the object it wraps, so there\n               is no \'radius\' parameter. Thus an error will be generated when the expression is evaluated.\n               If you point a variable at the sphere\'s radius track and use that variable instead,\n               the expression will still work when XRef-ed in. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D3A\"></a> \n            <h2><a name=\"GUID-92C9B183-8577-43A1-AE69-A9400DEF35F9\"></a> <em class=\"strong\">What is the difference between using explicit paths names in the Expression (like\n                  in releases prior to 3ds Max 8) and using the new variables pointing at nodes?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D39\"></a>There are multiple important differences. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D38\"></a>Let\'s say you have an object $Sphere01 using a script controller pointing at an object\n               called $Box01. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D37\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D35\"></a>If you would say \n                  </p> \n               </li>\n            </ul> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B43\"></a><pre>\n$Box01.position.x_position.controller\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D33\"></a>every time the expression is evaluated MAXScript needs to resolve the node name \'Box01\'\n               to a node value, resolve the position property to the position controller, resolve\n               the x_position property to the x_position subAnim, get the controller from the subAnim,\n               and get the MAXScript MAXControl value wrapping the controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D32\"></a>If you had a Target variable pointing at the controller, <em class=\"strong\">all that needs to happen is to get the MAXScript MAXControl value wrapping the controller</em>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D31\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D2F\"></a>The second difference is that if you rename \'Box01\', your scripted controller would\n                     stop working. When using a variable, there is <em class=\"strong\">no node name dependency</em>! \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D2D\"></a>The third difference is that if you select and clone \'Box01\' and the \'Sphere01\', your\n                     newly cloned scripted controller will continue to point at \'Box01\', not the clone\n                     of \'Box01\'. As a variable, it will point at the <em class=\"strong\">cloned</em> controller. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D2B\"></a>The fourth difference is that if you XRef Scene with \'Box01\' and the \'Sphere01\',your\n                     scripted controller will fail because it cannot resolve \'Box01\' since the node is\n                     in an xref scene node tree, not the main <em class=\"strong\">3ds Max</em> scene node tree. As a variable, the scripted controller holds a reference to the\n                     node, so it doesn\'t matter where that node is. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D29\"></a>If you do Save Selected on \'Sphere01\', then \'Box01\' will also be saved because it\n                     is dependent on the controller. Likewise, if you merge \'Sphere01\', \'Box01\' should\n                     also be merged. This would not happen when using explicit path names. \n                  </p> \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D28\"></a> \n            <h2><a name=\"GUID-82166E94-76AA-4AE1-B8D7-0F3427157F32\"></a> <em class=\"strong\">Should I use dependsOn in the new Script Controller?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D27\"></a>You do not need \'dependsOn\' in the scripted controller\'s expression since <em class=\"strong\">3ds Max 8</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D26\"></a>\'dependsOn\' should <em class=\"strong\">not</em> be used in new scripts, and should actually be <em class=\"strong\">removed</em> from old ones. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D25\"></a>When you have \'dependsOn\' in a script controller expression, a new variable will be\n               automatically created (Depends_#) that points at the node as an object. This will\n               cause all changes to the node to result in a script controller re-evaluation. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D24\"></a>The automatic creation of the dependson_# variable is a special case. It is created\n               based on the \'dependsOn\' command being executed and by definition the arguments to\n               dependsOn are MAXWrapper objects. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D23\"></a>This is also needed to ensure that existing script controllers using \'dependsOn\' would\n               continue to work correctly without tweaking the controller. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D20\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D1F\"></a> <span class=\"char_link\"><a href=\"GUID-5015B963-A1C7-457F-A76B-F63D3676CC6F.htm\">Script Controller - Avoiding Circular Dependency</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";