var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0E0372EC-F2D0-4909-8C64-F78DB9D35448\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface colorMan\">\n      <meta name=\"indexterm\" content=\"colorMan Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: colorMan</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0E0372EC-F2D0-4909-8C64-F78DB9D35448\"></a><div class=\"head\">\n            <h1>Interface: colorMan </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63E6\"></a> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63EA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63EB\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                           						<span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; colorMan \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63EC\"></a>The \n               		  <em class=\"strong\">colorMan Core Interface</em> exposes the \n               		  <em class=\"strong\">Color Manager</em> to MAXScript. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63ED\"></a>Within \n               		  <em class=\"strong\">3ds Max</em>, using the \n               		  <em class=\"strong\">Main Menu &gt; Customize &gt; Customize User Interface &gt; Colors</em> tab, you can alter the colors used for various UI elements, change the saturation,\n               value and transparency of elements, and load and save color schemes. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18ED\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>After making any color changes, you must call \n                  		  <span class=\"code\"> <em class=\"strong\">colorMan.repaintUI #repaintAll</em> </span> to apply the changes and synchronize with the customize dialog. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-8BACB934-D497-468C-AB84-D4E62DD2DEFC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>colorMan.colorTheme \ncolorTheme enums: {#dark|#light}</pre></div> \n            <p>Gets or sets the Color Theme as a name value. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>.\n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63EE\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;enum&gt; <em class=\"codeEmphasisStrong\">colorMan.getColorTheme()</em>\n\ngetColorTheme enums: {<em class=\"codeEmphasisStrong\">#dark</em>|<em class=\"codeEmphasisStrong\">#light</em>}</pre></div> \n            <p>Gets the current Color Theme as a name value. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt; <em class=\"codeEmphasisStrong\">colorMan.setColorTheme</em> &lt;enum&gt;theme\n\ntheme enums: {<em class=\"codeEmphasisStrong\">#dark</em>|<em class=\"codeEmphasisStrong\">#light</em>}</pre></div> \n            <p> Sets the current Color Theme. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">colorMan.getColorSchemeType()</em> \n\ngetColorSchemeType enums: {<em class=\"codeEmphasisStrong\">#customColor</em>|<em class=\"codeEmphasisStrong\">#standardWindows</em>|<em class=\"codeEmphasisStrong\">#windowsTheme</em>}</pre></div> \n            <p> Returns the current color scheme type as a name value. \n               		\n            </p> \n            <p><a name=\"GUID-E53A6D2B-5394-419C-8B37-2F1526D60274\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2010 and higher up to 3ds Max 2017</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">colorMan.setColorSchemeType</em> &lt;enum&gt;type \n\nsetColorSchemeType enums: {<em class=\"codeEmphasisStrong\">#customColor</em>|<em class=\"codeEmphasisStrong\">#standardWindows</em>|<em class=\"codeEmphasisStrong\">#windowsTheme</em>}\ntype enums: {<em class=\"codeEmphasisStrong\">#customColor</em>|<em class=\"codeEmphasisStrong\">#standardWindows</em>|<em class=\"codeEmphasisStrong\">#windowsTheme</em>}</pre></div> \n            <p>Sets the color scheme type to the specified name and returns the actual color scheme\n               type as result. \n               		\n            </p> \n            <p><a name=\"GUID-CE43C733-830A-434D-9A85-0F01432289F5\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2010 and higher up to 3ds Max 2017</em>. \n               		\n            </p> \n            <p><a name=\"GUID-35AC7BC5-8594-4BCF-9C1F-97F837E0B30B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B2D\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan.useStandardWindowsColors()</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63EF\"></a><img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\">In versions \n               		  <em class=\"strong\">prior to 3ds Max 2010</em>, returned \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the standard windows colors were used and false if custom colors were used. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B2C\"></a><pre><em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">setUseStandardWindowsColors</em> &lt;boolean&gt;onOff   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F0\"></a><img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\">In versions \n               		  <em class=\"strong\">prior to 3ds Max 2010</em>, used to set whether standard windows colors were used or not. \n               		\n            </p> \n            <p><a name=\"GUID-1041873D-5F41-4DC4-8BF7-82A53BBC31BD\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B2B\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">registerColor</em> &lt;string&gt;color &lt;string&gt;name &lt;string&gt;category &lt;point3&gt;defaultColor </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F2\"></a>This registers a new color with the system, and adds a color to the color manager\n               database that is then accessible from the color customization UI. It returns \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> if the color is already registered; otherwise \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F3\"></a> <span class=\"code\">&lt;string&gt;color</span>: The ID of the color to register. Example: #myNewColor \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F4\"></a> <span class=\"code\">&lt;string&gt;name</span>: The name for the color. Example: \"My Own Color\" \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F5\"></a> <span class=\"code\">&lt;string&gt;category</span>: The category for the color. If the name passed matches one of the existing \n               		  <em class=\"strong\">3ds Max</em> categories the color will be placed in there, otherwise a new one will be created.\n               Example: \"Fun Gaming Colors\" \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F6\"></a> <span class=\"code\">&lt;point3&gt;defaultColor</span>: The default value for the color. This is the value that the color will be reset\n               to when a \n               		  <em class=\"strong\">3ds Max</em> user presses \"Reset\" in the color customization dialog. Example: [1,0,0] \n               		\n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B2A\"></a><pre>colorMan.registerColor #myNewColor \"My Own Color\" \"Ugly Colors\" [1,0,0] 				  </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63F9\"></a><p class=\"table-body\">This registers a new color, with the name \n                           						<span class=\"code\"> <em class=\"strong\">#myNewColor</em> </span>, with a default value of red. The category in the customization UI will be \"Ugly\n                           Colors\" and the name will be \"My Own Color\". \n                           					 \n                        </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FA\"></a><p class=\"table-body\">In other scripts you can access this color using: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B29\"></a><pre>colorMan.getColor #myNewColor	</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18EC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <span class=\"code\"> <em class=\"strong\">colorMan.registerColor</em> </span> should be called from a script in the \n                  		  <em class=\"mild\">\\stdplugs\\stdscripts</em> folder. These scripts are run when \n                  		  <em class=\"strong\">3ds Max</em> starts, so the color will be available in the customization UI immediately. If the\n                  user customizes this color, its value will be saved in the \n                  		  <em class=\"mild\">MaxColors.clr</em> file. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-8ABCD255-CE3A-4631-9D5E-5F61D1D1D58E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B28\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">loadColorFile</em> &lt;filename&gt;file </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FB\"></a>This method will load the specified color file from the current UI directory. Returns\n               \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the load was successful, otherwise \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FC\"></a><span class=\"code\"> &lt;string&gt;file</span>: The filename of the color file to load. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18EB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The path specified must be relative to the \n                  		  <em class=\"mild\">\\UI</em> directory. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-476133C8-51D6-471C-9537-535D7E59A87E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B27\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">saveColorFile</em> &lt;filename&gt;file </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FD\"></a>This method will save the specified color file from the current UI directory. Returns\n               \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the save process was successful, otherwise \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FE\"></a><span class=\"code\"> &lt;string&gt;file</span>: The filename of the color file to save. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18EA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The path specified must be relative to the \n                  		  <em class=\"mild\">\\UI</em> directory. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-6AFCC097-7773-4360-9047-A51A2F2C0B1E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B26\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getColorFile()</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A63FF\"></a>Returns the file name of the current color file. \n               		\n            </p> \n            <p><a name=\"GUID-07FFD912-06C9-490F-8742-C217B3D7651A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B25\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">setColor</em> &lt;string&gt;color &lt;point3&gt;colorValue </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6400\"></a>Sets the color value of the previously registered color whose ID is passed. Returns\n               \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the color was set and \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> if the id passed could not be found. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6401\"></a> <span class=\"code\">&lt;string&gt;color</span>: Specifies which color to set. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6402\"></a> <span class=\"code\">&lt;point3&gt;colorValue</span>: The color value to set. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6403\"></a>Predefined colors include: \n               		\n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6404\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6405\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#background</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6406\"></a><p class=\"table-body\">The background for all controls and buttons \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6407\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#text</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6408\"></a><p class=\"table-body\">The text for all controls and buttons \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6409\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#activeCommand</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640A\"></a><p class=\"table-body\">The color command mode buttons turn when pressed \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#hilight</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640C\"></a><p class=\"table-body\">The hilight color for 3d controls \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#shadow</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640E\"></a><p class=\"table-body\">The shadow color for 3d controls \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A640F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#window</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6410\"></a><p class=\"table-body\">The background color for edit boxes, list boxes and other windows \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6411\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#activeCaption</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6412\"></a><p class=\"table-body\">The color of the active caption \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6413\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#toolTipBackground</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6414\"></a><p class=\"table-body\">The background for viewport tool tips \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6415\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#toolTipText</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6416\"></a><p class=\"table-body\">The text color for viewport tool tips \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6417\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#hilightText</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6418\"></a><p class=\"table-body\">The highlight color in the stack view drop-down list \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6419\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#windowText</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641A\"></a><p class=\"table-body\">The color used in edit boxes, list boxes and other windows \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#itemHilight</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641C\"></a><p class=\"table-body\">The item highlight color \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#subObjectColor</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641E\"></a><p class=\"table-body\">The color used to highlight sub-object levels in StackView \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A641F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#3dDarkShadow</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6420\"></a><p class=\"table-body\">the dark shadow color on 3d controls \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6421\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#3dLight</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6422\"></a><p class=\"table-body\">the light color on 3d controls \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6423\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#appWorkspace</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6424\"></a><p class=\"table-body\">the application workspace color \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6425\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarBg</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6426\"></a><p class=\"table-body\">trackbar background \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6427\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarBgSel</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6428\"></a><p class=\"table-body\">trackbar background for selected keys \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6429\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarText</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642A\"></a><p class=\"table-body\">trackbar text \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarTicks</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642C\"></a><p class=\"table-body\">trackbar ticks \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarKeys</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642E\"></a><p class=\"table-body\">trackbar keys \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A642F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarSelKeys</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6430\"></a><p class=\"table-body\">track bar selected keys \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6431\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#trackbarCursor</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6432\"></a><p class=\"table-body\">track bar cursor \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6433\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#pressedButton</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6434\"></a><p class=\"table-body\">background color for pressed buttons, like the transform constraints \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6435\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#timeSliderBg</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6436\"></a><p class=\"table-body\">The background for the time slider bar. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6437\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#viewportBorder</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6438\"></a><p class=\"table-body\">The viewport border color \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6439\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#activeViewportBorder</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643A\"></a><p class=\"table-body\">The active viewport border color \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rollupTitleFace</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643C\"></a><p class=\"table-body\">Rollout title background \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rollupTitleText</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643E\"></a><p class=\"table-body\">rollout title text \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A643F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rollupTitleHilight</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6440\"></a><p class=\"table-body\">rollout title 3d highlight \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6441\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rollupTitleShadow</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6442\"></a><p class=\"table-body\">rollout title 3d shadow \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6443\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#selectionRubberBand</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6444\"></a><p class=\"table-body\">the selection marquee color \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6445\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#stackViewSelection</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6446\"></a><p class=\"table-body\">the color of a selected item in stack view \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-FC749738-5188-4A5A-B0FB-D67E9E1D44B1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B24\"></a><pre>&lt;color&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getColor</em> &lt;string&gt;color </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6447\"></a>Returns the color value of the color whose ID is passed, or black (RGB(0,0,0)) if\n               the \n               		  <span class=\"code\"> <em class=\"strong\">Color</em> </span> passed was not found. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6448\"></a> <span class=\"code\">&lt;string&gt;color</span>: Specifies which color to get. \n               		\n            </p> \n            <p><a name=\"GUID-B4B67D13-5270-4E16-AA93-7C0FA58237DF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B23\"></a><pre>&lt;name&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getName</em> &lt;string&gt;color </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6449\"></a>Returns the name of the color whose ID is passed. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644A\"></a> <span class=\"code\">&lt;string&gt;color</span>: The ID of the color. \n               		\n            </p> \n            <p><a name=\"GUID-CC8254C0-3EA5-4418-9F1F-AC5ABD51C146\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B22\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getCategory</em> &lt;string&gt;color </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644B\"></a>Returns the category string of the color whose ID is passed. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644C\"></a><span class=\"code\"> &lt;string&gt;color</span>: The ID of the color. \n               		\n            </p> \n            <p><a name=\"GUID-065A1002-477E-4C1A-BCBF-B90F6DC8462F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B21\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">setIconFolder</em> &lt;filename&gt;folder </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644D\"></a> <span class=\"code\">&lt;filename&gt;folder</span> - The name of the folder relative to the UI directory. Absolute pathnames are not\n               supported. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644E\"></a>This method sets the folder from which all icons for the UI are loaded, and immediately\n               reloads the icons from that folder. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-68836E7A-12B6-4857-9450-0B327A7521D1\"></a>If a folder with no icon files is loaded, all icons in the UI become blank, and no\n                     warning is issued. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-E7CFCAEC-FC65-4DB0-9EC9-1DD30D9DA011\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B20\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getIconFolder</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A644F\"></a>Returns the absolute pathname of the current icon folder. Note that \n               		  <span class=\"code\"> <em class=\"strong\">getIconFolder</em> </span> returns an absolute path while \n               		  <span class=\"code\"> <em class=\"strong\">setIconFolder</em> </span> accepts only relative paths. \n               		\n            </p> \n            <p><a name=\"GUID-B832FCFA-72D6-417C-A674-68C227996550\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B1F\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getIconColorScale</em> &lt;enum&gt;type &lt;enum&gt;which \n\ntype enums: {<em class=\"codeEmphasisStrong\">#disabledIcon|#enabledIcon</em>} \nwhich enums: {<em class=\"codeEmphasisStrong\">#saturationScale|#valueScale|#alphaScale</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6450\"></a>Returns a floating point value (in the range 0.0 to 1.0) that is one of the scale\n               factors applied to the specified icon type. These scale values used to do image processing\n               on the icons at start-up time. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6451\"></a> <span class=\"code\"> &lt;enum&gt;type</span>: One of the following values: \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E8\"></a> <span class=\"code\"> <em class=\"strong\">#disabledIcon:</em> </span> The disabled icons. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E7\"></a> <span class=\"code\"> <em class=\"strong\">#enabledIcon:</em> </span> The enabled icons. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6452\"></a> <span class=\"code\"> &lt;enum&gt;which</span> : The icon color scale. One of the following values: \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E6\"></a> <span class=\"code\"> <em class=\"strong\">#saturationScale:</em> </span> The saturation scale. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E5\"></a> <span class=\"code\"> <em class=\"strong\">#valueScale:</em> </span> The value scale. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E4\"></a> <span class=\"code\"> <em class=\"strong\">#alphaScale:</em> </span> The alpha scale. \n               		\n            </p> \n            <p><a name=\"GUID-69FE2132-33C1-4D0B-A19E-ED03B7A34465\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B1C\"></a><pre><em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">setIconColorScale</em> &lt;enum&gt;type &lt;enum&gt;which &lt;float&gt;value \n\ntype enums: {<em class=\"codeEmphasisStrong\">#disabledIcon|#enabledIcon</em>} \nwhich enums: {<em class=\"codeEmphasisStrong\">#saturationScale|#valueScale|#alphaScale</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6453\"></a>Sets the specified scale factor for the icon type passed. The color manager maintains\n               the values for the \n               		  <em class=\"strong\">3ds Max</em> icon image processing system. Developers can set values to scale the saturation,\n               value and transparency for enabled and disabled icon images using this method. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6454\"></a> <span class=\"code\">&lt;enum&gt;type</span>: The icon type. Can be one of the following values: \n               		\n            </p> \n            <p><a name=\"P_5DC78B8B2EC74044A293E6D1796A4618\"></a><span class=\"code\"> <em class=\"strong\">#disabledIcon:</em> </span> The disabled icons. \n               		\n            </p> \n            <p><a name=\"P_B98639A9CBBF46238BF4E6561555F522\"></a><span class=\"code\"> <em class=\"strong\">#enabledIcon:</em> </span> The enabled icons. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6455\"></a> <span class=\"code\"> &lt;enum&gt;which</span>: The icon color scale. Can be one of the following values: \n               		\n            </p> \n            <p><a name=\"P_21024126E8E94B2DBA6C1116CB81753C\"></a><span class=\"code\"> <em class=\"strong\">#saturationScale:</em> </span> The saturation scale. \n               		\n            </p> \n            <p><a name=\"P_B5656F9D01E64DA38B3BF76E44CF7C77\"></a><span class=\"code\"> <em class=\"strong\">#valueScale:</em> </span> The value scale. \n               		\n            </p> \n            <p><a name=\"P_1640DD8318094046BC633BDE7C5EC7D0\"></a><span class=\"code\"> <em class=\"strong\">#alphaScale:</em> </span> The alpha scale. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6456\"></a> <span class=\"code\">&lt;float&gt;value</span>: The value runs from 0.0 to 100.0. \n               		\n            </p> \n            <p><a name=\"GUID-CC6AD2E9-93CF-4C41-A7D3-0FA08F7FFFCA\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B17\"></a><pre><em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getIconColorInvert</em> &lt;enum&gt;type \n\ntype enums: {<em class=\"codeEmphasisStrong\">#disabledIcon</em>|<em class=\"codeEmphasisStrong\">#enabledIcon</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6457\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the invert flag is set for the specified icon type and \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> if not set. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6458\"></a> <span class=\"code\">&lt;enum&gt;type</span>: The icon type. Can be one of the following values: \n               		\n            </p> \n            <p><a name=\"P_39565EC7BF444339A92FBC481D602CDB\"></a><span class=\"code\"> <em class=\"strong\">#disabledIcon:</em> </span> The disabled icons. \n               		\n            </p> \n            <p><a name=\"P_AC5523AFE3094E38BB01308F4293BC59\"></a><span class=\"code\"> <em class=\"strong\">#enabledIcon:</em> </span> The enabled icons. \n               		\n            </p> \n            <p><a name=\"GUID-1932730F-3ABB-4D12-AB3B-3EE25FE1E705\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B12\"></a><pre><em class=\"codeEmphasisStrong\">colorMan.setIconColorInvert</em> &lt;enum&gt;type &lt;boolean&gt;value \n\ntype enums: {<em class=\"codeEmphasisStrong\">#disabledIcon|#enabledIcon</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6459\"></a>Sets the invert flag for the specified icon type to \n               		  <span class=\"code\"> <em class=\"strong\">on</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">off</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645A\"></a><span class=\"code\"> &lt;enum&gt;type</span>: The icon type. One of the following values: \n               		\n            </p> \n            <p><a name=\"P_270208F375484587A4126E52F1C79B15\"></a><em class=\"strong\"> <span class=\"code\">#disabledIcon:</span> </em> The disabled icons. \n               		\n            </p> \n            <p><a name=\"P_5880AC9FFD094529ABA06830055A270D\"></a><em class=\"strong\"> <span class=\"code\">#enabledIcon:</span> </em> The enabled icons. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645B\"></a> <span class=\"code\">&lt;boolean&gt;value</span>: Pass true for inverted; false for not inverted. \n               		\n            </p> \n            <p><a name=\"GUID-672224C6-73C7-44C6-A283-B5D2154ADA51\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B0E\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getFileName</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645C\"></a>Returns the file name of the currently loaded color file. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E3\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This filename specifies an absolute path, even though \n                  		  <span class=\"code\"> <em class=\"strong\">loadColorFile</em> </span> and \n                  		  <span class=\"code\"> <em class=\"strong\">saveColorFile</em> </span> use relative paths. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-63BE323F-CB4F-49DC-8DAA-D1C81BCB2BAE\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B0D\"></a><pre>&lt;color&gt;<em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">getDefaultColor</em> &lt;string&gt;color </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645D\"></a>Returns the default color for the specified ID. The default color is the value passed\n               as defaultValue in registerColor, regardless if a \n               		  <span class=\"code\"> <em class=\"strong\">SetColor()</em> </span> has been done subsequently. This is used by the UI when the user presses \"Reset\"\n               to reset a color to its default value. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645E\"></a><span class=\"code\"> &lt;string&gt;color</span>: The ID of the color. \n               		\n            </p> \n            <p><a name=\"GUID-278D2D55-38A9-4608-97BB-C8E05C74D7E2\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B0C\"></a><pre><em class=\"codeEmphasisStrong\">colorMan</em>.<em class=\"codeEmphasisStrong\">repaintUI</em> &lt;enum&gt;type \n\ntype enums: {<em class=\"codeEmphasisStrong\">#repaintAll|#repaintTrackBar|#repaintTimeBar</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A645F\"></a>This method allows you to issue a repaint of the user interface. This is equivalent\n               to the Apply Colors Now button in the Customize dialog. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6460\"></a> <span class=\"code\">&lt;repaintType&gt;type</span>: The type of repaint you wish to issue; \n               		  <span class=\"code\"> <em class=\"strong\">#repaintAll</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#repaintTrackBar</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#repaintTimeBar</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6461\"></a>Here is a macroScript that turns the time slider and trackbar backgrounds blue: \n               		\n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6462\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6463\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B09\"></a><pre>\nmacroScript BlueBar\ncategory: \"Color\"\ntooltip: \"Blue Bar\"\n(\n  on execute do\n  (\n    colorMan.setColor #timeSliderBg [0, 0, .6]\n    colorMan.repaintUI #repaintTimeBar\n    colorMan.setColor #trackbarBg [0, 0, .6]\n    colorMan.repaintUI #repaintTrackBar\n  )\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-18E2\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>All of \n                  		  <em class=\"strong\">3ds Max</em>\'s standard icon BMP files must exist in that folder. If any of the standard files\n                  are missing, icons will appear blank in \n                  		  <em class=\"strong\">3ds Max</em>\'s UI. All the icons files needed live in the \n                  		  <em class=\"mild\">UI\\Icons</em> folder, which is the default icon folder. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-4D7DDA4E-8E5D-4F7B-A0BF-FF38D262E5F8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B08\"></a><pre><em class=\"codeEmphasisStrong\">colorman</em>.<em class=\"codeEmphasisStrong\">reInitIcons</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6464\"></a>Reloads all CUI icons from the icon files. This can be used to refresh the UI after\n               adding new or editing existing icon bitmap files. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6465\"></a>Available in \n               		  <em class=\"strong\">3ds Max 9 and higher</em>. \n               		\n            </p> \n            <p><a name=\"GUID-8A053E2B-46FD-4769-AB3C-C9058E3B54A9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5B07\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">colorman</em>.<em class=\"codeEmphasisStrong\">resolveIconFolder</em> &lt;filename&gt; &lt;&amp;fullfilename&gt; </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6466\"></a>This method resolves the filename using the user icon path, then the system icon path,\n               and then &lt;3dsmax.exe&gt;\\ui\\icons. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6467\"></a>If the file is found, fully qualified filename is placed in fullfilename and the method\n               returns true. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6468\"></a>If not found, the method returns false. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6469\"></a>Available in \n               		  <em class=\"strong\">3ds Max 9 and higher</em>. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A646A\"></a>See also Class IcolorManager, in the SDK Help file accompanying this product \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A646B\"></a> <span class=\"char_link\"><a href=\"GUID-9E695D17-5731-43F4-AF90-7D5FB42A91AB.htm\">3ds MaxUser Interface Colors</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A646C\"></a> <span class=\"char_link\"><a href=\"GUID-E5EE5B39-C8F2-4AB5-A890-C39C5EFB39E5.htm\">Creating Icon Bitmap Files</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";