var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-0F53E04C-0760-4B9C-A1BE-0E53162DE479\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"BitArray values\">\n      <meta name=\"indexterm\" content=\"join()\">\n      <meta name=\"indexterm\" content=\"findItem()\">\n      <meta name=\"indexterm\" content=\"deleteItem()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"append()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>BitArray Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0F53E04C-0760-4B9C-A1BE-0E53162DE479\"></a><div class=\"head\">\n            <h1>BitArray Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75D2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75D1\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> &gt; BitArray Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75CF\"></a>The MAXScript<em class=\"strong\"> BitArray </em>class provides direct access ’s SDK BitArray class. \n         </p>\n         <p><a name=\"P_C70C5D9441E9474BBF304EB524AB53E2\"></a>The SDK BitArray is used throughout <em class=\"strong\">3ds Max </em>to compactly encode selections as a string of bits. \n         </p>\n         <p><a name=\"P_B8559E07B5754D11BFFC9D8EA4AC1A75\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75CE\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB5\"></a><pre>#{ &lt;selection&gt; } -- these are curly brackets!</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75CC\"></a>where<span class=\"code\"> &lt;selection&gt; </span>is a comma-separated list of the following \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB4\"></a><pre>&lt;integer&gt; -- integers must be &gt; 0\n&lt;integer&gt; .. &lt;integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C9\"></a>For example, #{1, 5, 10..200, 302} says that the bits 1, 5, 10 to 200, and 302 are\n            \"turned on\". \n         </p>\n         <p><a name=\"P_BFB94711D09A411592AD634D8BFD54AF\"></a>When used in connection with selections in <em class=\"strong\">3ds Max </em>(such as vertex or face or control vertex) the \"on\" bits imply the elements or sub-objects\n            with those indexes are selected. \n         </p>\n         <p><a name=\"P_673EA15613B0475DBA6649D9E486D0BF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C8\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB3\"></a><pre>&lt;bitarray&gt;.<em class=\"codeEmphasisStrong\">count</em> : Integer 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C6\"></a>Returns the largest possible index held in the BitArray at that point in time. \n         </p>\n         <p><a name=\"P_2E5B3F0FD3C2463794DFD9B667CB7441\"></a>This value is independent of whether any particular indexes are selected or not. BitArrays\n            grow dynamically as needed to accommodate the indexes used on it, just as with arrays.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C5\"></a>Writing to the <span class=\"code\"> <em class=\"strong\">.count</em> </span> property sets the storage to the specified number of bits. \n         </p>\n         <p><a name=\"P_8ED10B33451F4B8CA8DF58FAFA86090B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C4\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB2\"></a><pre>&lt;bitarray&gt;[&lt;integer&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75C2\"></a>Yields true if selected, else false \n         </p>\n         <p><a name=\"P_2C262525E1FF43829AC4C177DB1EDB9A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB1\"></a><pre>&lt;bitarray&gt;[&lt;integer&gt;] = &lt;boolean&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75BF\"></a>Sets or clears indexed bit \n         </p>\n         <p><a name=\"P_15187F91F2D2441B9A755F415E6E680B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB0\"></a><pre>&lt;bitarray&gt; + &lt;bitarray&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75BC\"></a>Union (\"OR\" operation) \n         </p>\n         <p><a name=\"P_CAF64B3074BF4052906EF77C8D96C6E1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAF\"></a><pre>&lt;bitarray&gt; * &lt;bitarray&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75B9\"></a>Intersection (\"AND\" operation) \n         </p>\n         <p><a name=\"P_AC656F05F9C34850A8233ADEFAD043A3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAE\"></a><pre>&lt;bitarray&gt; - &lt;bitarray&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75B6\"></a>Difference \n         </p>\n         <p><a name=\"P_9DC26ACD6035446ABA7F4110186B8579\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAD\"></a><pre>-&lt;bitarray&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75B3\"></a>Invert the bitarray \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-62D1\"></a>      <em class=\"strong\">Methods</em> \n         </p>\n         <p><a name=\"P_F03D5934613245158FFEFDDFB3EABBA9\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAC\"></a><pre><em class=\"codeEmphasisStrong\">append </em>&lt;bitarray&gt; &lt;integer&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75AB\"></a>Adds index to bitarray, growing bitarray if necessary. \n         </p>\n         <p><a name=\"P_11D08EDAD22A4831AA6292803DF2D62A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAB\"></a><pre><em class=\"codeEmphasisStrong\">join</em> &lt;bitarray&gt; &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75A8\"></a>Union (\"OR\" operation) of the two bitarrays. \n         </p>\n         <p><a name=\"P_D86A30206D8A4823A9D5258462E9D4DE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DAA\"></a><pre><em class=\"codeEmphasisStrong\">findItem </em>&lt;bitarray&gt; &lt;integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75A5\"></a>Yields index <span class=\"code\"> <em class=\"strong\">&lt;integer&gt; </em> </span>if selected, 0 otherwise. \n         </p>\n         <p><a name=\"P_EB04915C8F23441DB97AAD4EC673F510\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA9\"></a><pre><em class=\"codeEmphasisStrong\">deleteItem</em> &lt;bitarray&gt; &lt;integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75A2\"></a>Clears the index selection. \n         </p>\n         <p><a name=\"P_C9CDA6CB5C68480D90DA6F1CE720D4A5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA8\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-759F\"></a>Creates an independent copy of the bitarray. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-190C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>BitArrays can be used interchangeable with ordinary #(...) <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">arrays</a></span> of index numbers where ever a selection array is applicable, such as in mesh sub-object\n               selections. \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-759E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-759B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA7\"></a><pre>\n$foo.verts[#{20..1023}] --selects all vertices between 20 and 1023\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7596\"></a>You can sequence over BitArrays with a for-loop, which yields a sequence of index\n            numbers corresponding to the currently selected items. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7595\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7594\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA6\"></a><pre>\nfor i in #{2..200} do print i -- print the numbers between 2 &amp; 200\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-758F\"></a>You can perform an \"AND\" operation between two BitArrays by inverting the difference\n            between them. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-758E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-758D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA5\"></a><pre>\na=#{1..5}\nb=#{3..10}\nc=-(a-b) -- result in c is #{3..5}\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_19E81FED9E0C44ACBB5B12BDFB0E06F1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-62B5\"></a> <em class=\"strong\">Coercion of bitArray to array and integer arrays to bitArrays:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA4\"></a><pre>&lt;bitArray&gt;<em class=\"codeEmphasisStrong\"> as array</em> \n&lt;integer array&gt;<em class=\"codeEmphasisStrong\"> as bitArray</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7583\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7582\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA3\"></a><pre>\na=#{1..5,10}\nb=a as array\nc=b as bitarray\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-757B\"></a>If an element of the array cannot be coerced to an integer, an error is thrown. <span class=\"code\"> <em class=\"strong\">.numberSet</em> </span> and <span class=\"code\"> <em class=\"strong\">.isEmpty </em> </span>are read-only properties, which have been added to the<span class=\"code\"> <em class=\"strong\"> BitArrayValue</em> </span> class. \n         </p>\n         <p><a name=\"P_3174DDFF70A74574A34B66D2C223EBCD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA2\"></a><pre><em class=\"codeEmphasisStrong\">.numberSet</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7578\"></a>Returns the number of bits set \n         </p>\n         <p><a name=\"P_77D89588ACEE466E8527C61DA08B3AFD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA1\"></a><pre><em class=\"codeEmphasisStrong\">.isEmpty</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7575\"></a>Returns true if no bits are set and false if one or more bits are set. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7574\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7573\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DA0\"></a><pre>\na=#{1..5,10..20} \na.numberset --&gt; 16\na.isEmpty --&gt; false\n a=#{}\n a.numberset --&gt; 0\n a.isEmpty --&gt; true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array Values </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";