var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1000FD9C-A4FA-4875-974C-90E3F32443D3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurfConstPoint - NURBSPoint\">\n      <meta name=\"indexterm\" content=\"NURBSPoint - NURBSObject\">\n      <meta name=\"indexterm\" content=\"getObject()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSSurfConstPoint : NURBSPoint</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1000FD9C-A4FA-4875-974C-90E3F32443D3\"></a><div class=\"head\">\n            <h1>NURBSSurfConstPoint : NURBSPoint </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-465D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-465C\"></a>   This class defines a dependent point on a surface or related to it. There are four\n               ways to specify the displacement of the point’s location relative to the UV position:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4658\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4656\"></a>OnObject - the point is actually on the surface of the object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4654\"></a>Offset - the point is offset some distance (specified in object space) from the surface\n                     of the object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4652\"></a>Normal - the point is offset along the direction of the surface’s normal. (Negative\n                     values move it opposite to the normal.) \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4650\"></a>Tangent - the point is offset some U and/or V distance along the tangent from the\n                     surface. If the value is positive it\'s the tangent that heads in the direction of\n                     increasing parameter value; if negative it\'s the tangent that heads in the direction\n                     of decreasing parameter value. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-464F\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222D\"></a><pre><em class=\"codeEmphasisStrong\">NURBSSurfConstPoint</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-464D\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222C\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4649\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222B\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4647\"></a>The parent surface by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222A\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4644\"></a>The parent surface by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2229\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">type</em> :#onObject, #offset, #normal, #tangent </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2228\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">uParam</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-463E\"></a>Parametric position along u direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2227\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">vParam</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-463B\"></a>Parametric position along v direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2226\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">offset</em> : point3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4638\"></a>Offset vector if an offset type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2225\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">normal</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4635\"></a>Distance along the normal if a normal type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2224\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">uTangent</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4632\"></a>Distance along the u tangent if a tangent type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2223\"></a><pre>&lt;nurbssurfconstpoint&gt;.<em class=\"codeEmphasisStrong\">vTangent</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-462F\"></a>Distance along the v tangent if a tangent type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-462D\"></a> <span class=\"char_link\"><a href=\"GUID-7066A0C4-409A-4469-84C8-52C1977FE546.htm\">NURBSPoint</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-462C\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-462B\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";