var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-102A446F-9146-4D1B-A44A-818F749E61E8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"select()\">\n      <meta name=\"indexterm\" content=\"move()\">\n      <meta name=\"indexterm\" content=\"findItem()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection values\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: select()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: move()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: findItem()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: deselect()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: delete()\">\n      <meta name=\"indexterm\" content=\"EdgeSelection Methods: append()\">\n      <meta name=\"indexterm\" content=\"deselect()\">\n      <meta name=\"indexterm\" content=\"delete()\">\n      <meta name=\"indexterm\" content=\"collections\">\n      <meta name=\"indexterm\" content=\"append()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>EdgeSelection Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-102A446F-9146-4D1B-A44A-818F749E61E8\"></a><div class=\"head\">\n            <h1>EdgeSelection Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-762D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-762C\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> &gt; EdgeSelection Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-762A\"></a>An<em class=\"strong\"> EdgeSelection</em> represents a set of edges for a scene mesh node as a virtual array. \n            	 \n         </p>\n         <p><a name=\"P_ABFD37BD8B444D138C6C6F80286E7D5A\"></a>As such, you can access an edge by index, iterate over the edges, and apply mapped\n            functions to the edges. \n            	 \n         </p>\n         <p><a name=\"P_915C932B70A0483FBF2D8DF8C9027CE1\"></a>See also \n            		<span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Editable Mesh</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_503EEE4407754760B1B9FF9851FF7A3A\"></a>The EdgeSelection array is \n            		<em class=\"strong\">dynamic</em> (its contents change as the edges or selected edges of the mesh node change). \n            	 \n         </p>\n         <p><a name=\"P_BD35174A52AD4FD3A57746CB9967340B\"></a>EdgeSelection values are \n            		<em class=\"strong\">mappable</em>. \n            	 \n         </p>\n         <p><a name=\"P_732198182E034CEBA8939731BCBB26AD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7629\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC8\"></a><pre>&lt;mesh&gt;.<em class=\"codeEmphasisStrong\">selectedEdges</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7627\"></a>The currently selected edges of the mesh object. \n            	 \n         </p>\n         <p><a name=\"P_969FE38627414A06A3624ABC0DDD2662\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC7\"></a><pre>&lt;mesh&gt;.<em class=\"codeEmphasisStrong\">Edges</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7624\"></a>All of the edges of the mesh object (read-only). \n            	 \n         </p>\n         <p><a name=\"P_F320EDC16D3E40A7B3C88C9AA05DC71E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7623\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC6\"></a><pre>&lt;edgeselection&gt;.<em class=\"codeEmphasisStrong\">count</em> : Integer, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7621\"></a>Returns the number of edges in the edge array. \n            	 \n         </p>\n         <p><a name=\"P_BECFF7B2BAE04AF7B167F2D014FD062F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC5\"></a><pre>&lt;edgeselection&gt;.<em class=\"codeEmphasisStrong\">selSetNames </em>: Array of names, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-761E\"></a>Returns an array of names of the current edge-level named selection sets for the object\n            the EdgeSelection is associated with. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-761C\"></a>The following property is present for singleton selections (of the form $foo.edges[n]):\n            \n            	 \n         </p>\n         <p><a name=\"P_72B513CC8A35421E8618EB3B5E2AA1A3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC4\"></a><pre>&lt;edgeselection&gt;.<em class=\"codeEmphasisStrong\">index </em>: Integer, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-761A\"></a>Returns the index of the selected element in the mesh, \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7619\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7618\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC3\"></a><pre>\n$foo.selectedEdges[2].index\n--returns the edge index of the 2nd edge in the current selection.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7611\"></a>Iterating over a selection yields singleton selections in the loop body: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7610\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-760F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC2\"></a><pre>\nse = for i in $foo.selectedVerts collect i.index\n--se contains selected edges as array\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_81FE9276A32F4C208E021A27835DA419\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7609\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC1\"></a><pre>&lt;mesh&gt;.<em class=\"codeEmphasisStrong\">selectedEdges</em> = (&lt;array&gt; | &lt;bitarray&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7607\"></a>Selects the specified edges. \n            	 \n         </p>\n         <p><a name=\"P_32C406BBA8B341FB9897634DC4F532FB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DC0\"></a><pre>&lt;edgeselection&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7604\"></a>Retrieves the indexed edge as a singleton EdgeSelection. Index starts at 1. \n            	 \n         </p>\n         <p><a name=\"P_5B680EF4E23A4F5B93BF9A3918D606F2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBF\"></a><pre>&lt;edgeselection&gt;<em class=\"codeEmphasisStrong\">[</em>(&lt;integer_array&gt; | &lt;bitarray&gt;)<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7601\"></a>Retrieves the indexed edges as an EdgeSelection. Index starts at 1. \n            	 \n         </p>\n         <p><a name=\"P_6B65FEBE5ED34189A0B76F4EFB5D301C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBE\"></a><pre>&lt;edgeselection&gt;<em class=\"codeEmphasisStrong\">[(</em>&lt;#name&gt; | &lt;string&gt;)<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75FE\"></a>Retrieves the edge-level named selection set, where the name of the named selection\n            set can be specified as a name or string value. \n            	 \n         </p>\n         <p><a name=\"P_F744DB5CF541436382384CF268C18883\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBD\"></a><pre>&lt;edgeselection&gt;<em class=\"codeEmphasisStrong\">[</em>(&lt;#name&gt; | &lt;string&gt;)<em class=\"codeEmphasisStrong\">]</em> = (&lt;faceselection&gt; | &lt;integer_array&gt; | &lt;bitarray&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75FB\"></a>Sets the edge-level named selection set to the specified edges. \n            	 \n         </p>\n         <p><a name=\"P_43E4D7FB0F0449598EE727ADA372EDF8\"></a>The name of the named selection set can be specified as a name or string value, and\n            the edges can be specified as an array, a bitArray, or an EdgeSelection from the same\n            object. \n            	 \n         </p>\n         <p><a name=\"P_D37F0364DBD242D8A10FCB226C10EB43\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75FA\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBC\"></a><pre><em class=\"codeEmphasisStrong\">move</em> &lt;edgeselection&gt; &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75F8\"></a>Moves the edges in the EdgeSelection. \n            	 \n         </p>\n         <p><a name=\"P_DC9EABA275514C9E9B429053D401B1EE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBB\"></a><pre><em class=\"codeEmphasisStrong\">select</em> &lt;edgeselection&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75F5\"></a>Selects the edges in the EdgeSelection. \n            	 \n         </p>\n         <p><a name=\"P_4E3DE7582E194FCF85EC7AC6582C3B22\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DBA\"></a><pre><em class=\"codeEmphasisStrong\">deselect</em> &lt;edgeselection&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75F2\"></a>Deselects the edges in the EdgeSelection. \n            	 \n         </p>\n         <p><a name=\"P_83DD9F95A8EA4A6493C2CBA162A542C2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB9\"></a><pre><em class=\"codeEmphasisStrong\">delete</em> &lt;edgeselection&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75EF\"></a>Deletes the edges in the EdgeSelection. \n            	 \n         </p>\n         <p><a name=\"P_2AD226D2495240C7A67FBE69A9C725E7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB8\"></a><pre><em class=\"codeEmphasisStrong\">append</em> &lt;edgeselection&gt; (&lt;edgeselection&gt; | &lt;integer&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75EC\"></a>Appends the edge(s) to the EdgeSelection. \n            	 \n         </p>\n         <p><a name=\"P_D7099E1BBB7846EC8D30D19988D38A78\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB7\"></a><pre><em class=\"codeEmphasisStrong\">findItem </em>&lt;edgeselection&gt; (&lt;edgeselection[&lt;integer&gt;] | &lt;integer&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75E9\"></a>Returns the selection index of the matching item or 0 if not found. The item is selection\n            index or singleton EdgeSelection. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75E8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-75E7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5DB6\"></a><pre>\n-- move edges in \'mouth\' named selection set\nmove $foo.edges[#mouth] [0,0,10]\n-- select edges in \'front edges\' set\nselect $baz.edges[\"front edges\"]\n-- set \'baz\' named selection set to given edges\n$foo.edges[#baz] = #(1,3,4,5,10)\n-- set \'cursel\' set to current selection\n$baz.edges[#cursel] = $baz.selectedEdges\n-- all the names of the edge-level named selection sets for object $foo\n$foo.edges.selSetNames\n-- print out all edge-level named selection sets\nfor n in $.edges.selSetNames do print $.edges[n]\n-- print all selected edges, but gets truncated to the first 20 by default\nprint $.selectedEdges\n-- use printAllElements context to view all edges\nwith printAllElements on print $.selectedEdges\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085.htm#GUID-00EA922C-A318-4A2F-888A-67C3DE859EA9\">PrintAllElements Variable and Context </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";