var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-10373DCE-57EA-49B2-A66D-1C7320A6EA0F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Index vs Integer Function Arguments\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Index vs Integer Function Arguments</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-10373DCE-57EA-49B2-A66D-1C7320A6EA0F\"></a><div class=\"head\">\n            <h1>Index vs Integer Function Arguments </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CD8\"></a> In general, indices in MAXScript are 1-based. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CDA\"></a>Functions expecting a 1-based index will specify this as <span class=\"code\">&lt;index&gt;</span> in the function definition. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CDB\"></a>For example, \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638A\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">getName</em> &lt;index&gt;listIndex</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CDD\"></a> <span class=\"code\">&lt;index&gt;listIndex:</span> The index of the item for which to get the name. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CDE\"></a>In the cases where a function requires a 0-based argument, it will be specified as\n            <span class=\"code\">&lt;integer&gt;</span> instead. \n         </p>\n         <p><a name=\"P_15F463E565C949C78E675DDEF8BE034E\"></a>Usually, the fact that the argument is expected as 0-based will also be noted explicitly\n            in the description of the function. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CDF\"></a>For example, \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6389\"></a><pre>&lt;maxObject&gt;<em class=\"codeEmphasisStrong\">GetRenderElement</em> &lt;integer&gt;index</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CE1\"></a>Returns a specific element, index is 0 based. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5.htm\">Syntax Definitions in This Document </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";