var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-10A0C4F9-D22E-4203-A775-5087AA190156\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"properties: nested objects\">\n      <meta name=\"indexterm\" content=\"nested object properties\">\n      <meta name=\"indexterm\" content=\"MAXWrapper - Value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Nested Object Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-10A0C4F9-D22E-4203-A775-5087AA190156\"></a><div class=\"head\">\n            <h1>Nested Object Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3708\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3707\"></a>   Several of the properties on <em class=\"strong\">3ds Max</em> objects contain values that are themselves compound, for example <span class=\"code\"> <em class=\"strong\">&lt;node&gt;.pos</em> </span> yields a Point3, which itself contains <span class=\"code\"> <em class=\"strong\">x</em> </span>,<span class=\"code\"> <em class=\"strong\">y</em> </span> and <span class=\"code\"> <em class=\"strong\">z</em> </span> properties. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3703\"></a>MAXScript provides a mechanism that lets you modify these nested properties on MAXWrapper\n               objects <em class=\"strong\">in place</em> such that assignment to them will affect that nested property on the <em class=\"strong\">3ds Max</em> object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3702\"></a>This mechanism depends on the nested property being accessed in <em class=\"strong\">one, cascaded</em> property access. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3701\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3700\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD1\"></a><pre>\n$foo.pos.x += 23-- move the node 23 units in x\n$baz.rotation.angle *= 2-- double the rotation\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36FA\"></a>If you first get the intermediate value into some variable and then set the property\n               on that value, the change will <em class=\"strong\">not</em> be reflected in the original object, the connection is only maintained within a single\n               cascaded property access. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36F9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36F8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD0\"></a><pre>\np = $foo.pos-- get foo\'s position as a \'detached\' point3\np.x += 23-- set the x prop of that point, it doesn\'t know\n-- about foo anymore, foo\'s pos isnotchanged\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36F2\"></a><p class=\"table-body\">In this case, you would have to explicitly re-assign the free-standing point to $foo\'s\n                           position to affect $foo: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCF\"></a><pre>\n$foo.pos = p-- set foo\'s new position\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36ED\"></a>In general, any property on a MAXWrapper object that is itself a foundation compound\n               value such as a Point3 or Quat will yield a free-standing value when simply accessed\n               and supports object sub-property assignment in cascaded property assignment. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";