var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-12B3ED06-A78F-4D92-8127-BB94F00AC841\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"renderSceneDialog\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>renderscenedialog</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-12B3ED06-A78F-4D92-8127-BB94F00AC841\"></a><div class=\"head\">\n            <h1>renderscenedialog </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-354F\"></a>The \n            		<em class=\"strong\">renderSceneDialog</em> structure provides a set of functions for controlling the Render Scene Dialog window. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D1A\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.cancel</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-354D\"></a>Closes Render Scene Dialog if open. Changes made in the dialog are rejected. No arguments.\n            \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-757A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The render dialog provides only limited support for canceling (the \n               		<em class=\"strong\">Cancel</em> button was removed when the tabbed dialogs were introduced in \n               		<em class=\"strong\">3ds Max 6</em>). It will \n               		<em class=\"strong\">only</em> cancel the uncommitted changes in the \n               		<em class=\"strong\">Common</em> and \n               		<em class=\"strong\">Renderer</em> tabs. \n               	 \n            </div>\n         </div>\n         <p><a name=\"GUID-6EFC1D72-EEEF-4462-A605-9EC8950C3F81\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D19\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.close</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3547\"></a>Closes Render Scene Dialog if open. Changes made in the dialog are accepted. No arguments.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-A1E3213F-D4AD-40CC-BCE2-9AAB2B7466A9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D18\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.commit</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3544\"></a>If Render Scene dialog is open, the dialog remains open, but changes made in the dialog\n            are accepted. No arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-7B6D8907-6860-4397-9E0B-8BB66D3B3B3E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D17\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.isOpen</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3541\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the Render Scene dialog is open, \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> is closed. No arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-99FD4891-0630-4BC3-ABEE-1AA5148BCC30\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D16\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.open</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-353E\"></a>Opens Render Scene Dialog if not already open. No arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-06682FB0-58C6-401C-A62F-B172C930D5EE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D15\"></a><pre><em class=\"codeEmphasisStrong\">renderSceneDialog.update</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-353B\"></a>If Render Scene dialog is open, it is updated to show the changes made to it. No arguments.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-08E7A463-D271-4AC9-9C2B-0B71858E3D0D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3539\"></a> <span class=\"char_link\"><a href=\"GUID-30AF1E53-5A69-402D-84D6-4D6ECCDD6D20.htm\">Render Scene Dialog</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3538\"></a> <span class=\"char_link\"><a href=\"GUID-27B7B613-AE4B-48C5-B26B-FB7D8369299C.htm\">envEffectsDialog - Open and Close the Environment and Effects dialog</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3536\"></a> <span class=\"char_link\"><a href=\"GUID-D4C5C5DF-7447-485F-9802-2E5328037EBE.htm\">Default_Scanline_Renderer : RendererClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3533\"></a> <span class=\"char_link\"><a href=\"GUID-4F292A16-0DED-46B2-A074-D814ED1BAB2A.htm\">3ds Max Default Scanline Renderer Anti-Aliasing Filters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3532\"></a> <span class=\"char_link\"><a href=\"GUID-9175301C-13E6-488B-ABA6-D27CD804B205.htm\">Controlling the Renderer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3530\"></a> <span class=\"char_link\"><a href=\"GUID-37D4FFFF-1BF1-4B51-B9C5-99D5E20E1D30.htm\">TabbedDialogs - Controlling Tabbed Dialogs</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";