var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1361B847-7878-4C52-98DE-5BC5CA830B40\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"rollout\">\n      <meta name=\"indexterm\" content=\"Clauses\">\n      <meta name=\"indexterm\" content=\"group - Rollout User-Interface item\">\n      <meta name=\"indexterm\" content=\"Event Handlers\">\n      <meta name=\"indexterm\" content=\"utility\">\n      <meta name=\"indexterm\" content=\"on\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout Clauses</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1361B847-7878-4C52-98DE-5BC5CA830B40\"></a><div class=\"head\">\n            <h1>Rollout Clauses </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D9\"></a>Rollout clauses define the components of a rollout (utilities are considered a special\n            case of rollouts) and can be one of these four basic things: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D8\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D6\"></a> <em class=\"strong\">Local variables, functions, or structure definitions</em> are variables, functions, and structures whose scope is the rollout. These locals\n                  will exist as long as the rollout value exists. The rollout value will exist until\n                  a new value is assigned to the rollout’s variable name. Local variables are particularly\n                  useful for storing the working data associated with the rollout such as, picked objects\n                  or arrays of generated objects. The visibility of locals and accessing rollout locals\n                  from external code are described in <span class=\"char_link\"><a href=\"GUID-608825CD-D025-4054-91E2-2562A6AB31CF.htm\">Visibility of Locals, Functions, Structures, and User-Interface Items in Rollout Code</a></span> and <span class=\"char_link\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code</a></span>. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D4\"></a> <em class=\"strong\">Mouse tools</em> are used to perform a set of actions based on mouse clicks in the<em class=\"strong\"> 3ds Max</em> viewports and are described in <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\"> Scripted Mouse Tools</a></span>. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D2\"></a> <em class=\"strong\">User-interface control items</em> are elements displayed in the rollout such as, buttons, spinners, and list boxes.\n                  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69D0\"></a> <em class=\"strong\">Event handlers</em> are special functions associated with certain user-interface control items. Event\n                  handlers specify the processing that must occur when a user interacts with a user-interface\n                  item. For example, pressing a button or adjusting a spinner. These user actions generate\n                  named events and the optional event handler you supply for that event is called when\n                  the user action occurs. For example, if you press a button named <em class=\"strong\">DoIt</em>, the <em class=\"strong\">on DoIt pressed</em> event handler expression is executed. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69CF\"></a>Formally, the syntax of a <span class=\"code\"> <em class=\"strong\">&lt;rollout_clause&gt;</em> </span> is defined as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CB\"></a><pre>&lt;rollout_clause&gt; ::= &lt;local_variable_decl&gt; | &lt;local_function_decl&gt; | &lt;local_struct_decl&gt; | &lt;global_variable_decl&gt; | &lt;mousetool&gt; | &lt;user_interface_item&gt; | &lt;item_group&gt; | &lt;event_handler&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69CD\"></a> <em class=\"strong\">Locals</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69CC\"></a>A <span class=\"code\"> <em class=\"strong\">&lt;local_variable_decl&gt;</em> </span>, <span class=\"code\"> <em class=\"strong\">&lt;global_variable_decl&gt;</em> </span>, <span class=\"code\"> <em class=\"strong\">&lt;local_function_decl&gt;</em> </span>, and <span class=\"code\"> <em class=\"strong\">&lt;local_struct_decl&gt;</em> </span> are exactly the same as local and global variable, local function, and local structure\n            definitions in MAXScript: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CA\"></a><pre>&lt;local_variable_decl&gt; ::= <em class=\"codeEmphasisStrong\">local</em> &lt;decl&gt; { <em class=\"codeEmphasisStrong\">, </em>&lt;decl&gt; } \n&lt;decl&gt; ::= &lt;name&gt; [ = &lt;expr&gt; ] -- optional initial value</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C9\"></a><pre>&lt;global_variable_decl&gt; ::= <em class=\"codeEmphasisStrong\">global</em> &lt;decl&gt; { , &lt;decl&gt; } \n&lt;decl&gt; ::= &lt;name&gt; [ = &lt;expr&gt; ] -- optional initial value</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C8\"></a><pre>&lt;local_function_decl&gt; ::= [ <em class=\"codeEmphasisStrong\">mapped</em> ](<em class=\"codeEmphasisStrong\">function</em> | <em class=\"codeEmphasisStrong\">fn</em>) &lt;name&gt; { &lt;argument&gt; }<em class=\"codeEmphasisStrong\"> = </em>&lt;expr&gt;</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C7\"></a><pre>&lt;local_struct_decl&gt; ::= <em class=\"codeEmphasisStrong\">struct</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">(</em> &lt;member&gt; {<em class=\"codeEmphasisStrong\"> , </em>&lt;member&gt; } <em class=\"codeEmphasisStrong\">)</em>\n&lt;member&gt; ::= ( &lt;name&gt; [ <em class=\"codeEmphasisStrong\">=</em>&lt;expr&gt; ] | &lt;local_function_decl&gt; )</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69C3\"></a>Examples of the previous (in order) are: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C6\"></a><pre>\nlocal numSelected\nglobal foo\nlocal numSelected = 0\nfn onlyOneSelected = (selection.count == 1)\nstruct parents (mother=\"\", father=\"\")\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69BD\"></a>When writing scripts, it is a good programming practice to explicitly declare your\n            local and global variables. Implicit declaration is provided as a short-hand, typically\n            used when working in the Listener interactively or developing short scripts. When\n            developing extended scripts, explicitly declaring variables can reduce errors and\n            improve readability of the code. It is also recommend to declare all variables as\n            local unless you really want them to be global variables. The reasons for this are\n            described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69BC\"></a> <em class=\"strong\">User-Interface Items</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69BB\"></a>A <span class=\"code\"> <em class=\"strong\">&lt;user_interface_item&gt;</em> </span> defines an individual button, check box, spinner, or other user-interface control\n            item that will appear in the rollout. These user-interface control items are described\n            in <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69BA\"></a>An <span class=\"code\"> <em class=\"strong\">&lt;item_group&gt;</em> </span> is used to place a sequence of user-interface items in a labeled box in the rollout,\n            so you can organize large rollouts into meaningful groups. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69B9\"></a> <em class=\"strong\">Its syntax is:</em>  \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C5\"></a><pre><em class=\"codeEmphasisStrong\">group</em> &lt;group_label_string&gt; \n<em class=\"codeEmphasisStrong\">(</em> \n{ &lt;user_interface_item&gt; } \n<em class=\"codeEmphasisStrong\">)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69B6\"></a>The use of <span class=\"code\"> <em class=\"strong\">group</em> </span> is shown in the following script: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69B5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69B4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C4\"></a><pre>\nutility Infinity \"Game Utilities\"\n(\ngroup \"Lighting\"\n(\nlabel label1d \"Number of Day lights:\" across:2 offset:[10,0]\nlabel label2d \"0\" offset:[10,0]\nlabel label1n \"Number of Night lights:\" across:2 offset:[13,0]\nlabel label2n \"0\" offset:[10,0]\nlabel label3\nRadiobuttons WhichOn \"Active Lights:\" labels:#(\"Day\",\"Night\")\n)\ngroup \"Scene Data Dump\"\n(\nButton scenedump \"Dump Scene Data\"\n)\ngroup \"Exclusions/Inclusions\"\n(\nButton DispExcl \"Unhide Exclusions&amp;Inclusions\"\n)\ngroup \"Camera Mattes\"\n(\nradiobuttons CamMatte labels:#(\"None\",\"1\",\"2\",\"3\",\"4\") columns:3\n)\nButton resetb \"Reset\"\n)\ncreateDialog infinity\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6997\"></a>The Utilities panel rollout that the previous script generates looks like the following\n            figure. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6996\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E0CDD9A7-9855-440A-A567-A0AB1C53AEE3-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6995\"></a> <em class=\"strong\">Game Utilities rollout using group user-interface item</em> \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75EC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A group is technically not an user-interface control. If you want to use a group that\n               is an interface control, consider the <span class=\"char_link\"><a href=\"GUID-A8C801C7-BA79-448C-A1EE-28C40B16287C.htm\">GroupBox</a></span> user-interface control. \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-698F\"></a>Internally, a group is implemented as two controls of <span class=\"code\"> <em class=\"strong\">GroupStartControl</em> </span> and <span class=\"code\"> <em class=\"strong\">GroupEndControl</em> </span> classes, enclosing the grouped user-interface controls like brackets. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-698E\"></a>In <em class=\"strong\">3ds Max 8 and higher</em>, you can access and change the <span class=\"code\"> <em class=\"strong\">.caption</em> </span> property of either controls if you access them using the <span class=\"code\"> <em class=\"strong\">.controls</em> </span> property of a rollout. This was not possible in the previous versions. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-698D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-698C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C3\"></a><pre>\nrollout test \"Test\"\n(\ngroup \"Group\"\n(\nbutton pressme \"Press Me\"\n)\n)\ncreateDialog test\ntest.controls\ntest.controls[1].caption = \"XXX\" --this is the GroupStartControl\ntest.controls[3].caption = \"Test me\" --this is the GroupEndControl\n--Both change the group\'s caption!\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-697C\"></a>In <em class=\"strong\">3ds Max 2010 and higher</em>, user Interface controls\' event handlers can be included inside a Group\'s body. In\n            previous versions of<em class=\"strong\"> 3ds Max</em>, including an even handler inside the group caused a Syntax Error. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-697B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-697A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C2\"></a><pre>\nrollout test \"Test\"\n(\ngroup \"Group\"\n(\nbutton pressme \"Press Me\"\n--In versions prior to 3ds Max 2010,\n--this would have caused a Syntax Error:\non pressme pressed do print \"Pressed!\"\n) --because the handler is inside the group\'s body.Now allowed.\n)\ncreateDialog test\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-7F54\"></a>  <em class=\"strong\">Event Handlers</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6969\"></a>An <span class=\"code\"> <em class=\"strong\">&lt;event_handler&gt;</em> </span> is a special function definition local to a utility or rollout that you provide to\n            handle the processing that must occur when a user performs an action on a user-interface\n            item. For example, event handlers are called when the user presses a button or adjusts\n            a spinner, opens or closes the utility or rollout, or resizes or moves a rollout floater\n            window. These user actions generate named events and any event handler you supply\n            for that event is called when the action occurs. The syntax for defining an event\n            handler is as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C1\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;item_name&gt; &lt;event_name&gt; [ &lt;argument&gt; ] <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6966\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;item_name&gt;</em> </span> specifies the name of the item to which this handler is connected. The <span class=\"code\"> <em class=\"strong\">&lt;event_name&gt;</em> </span> specifies the type of event to be handled and the optional <span class=\"code\"> <em class=\"strong\">&lt;argument&gt;</em> </span> is used to pass various values to the handler. The possible events you can specify\n            depend on the item type. These events include: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74C0\"></a><pre><em class=\"codeEmphasisStrong\">pressed</em> <em class=\"codeEmphasisStrong\">changed</em> <em class=\"codeEmphasisStrong\">picked</em> <em class=\"codeEmphasisStrong\">entered</em> <em class=\"codeEmphasisStrong\">selected</em> <em class=\"codeEmphasisStrong\">resized</em> <em class=\"codeEmphasisStrong\">moved</em> <em class=\"codeEmphasisStrong\">open</em> <em class=\"codeEmphasisStrong\">close</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-695C\"></a>The available events and passed arguments are defined in the description for each\n            user-interface item type, as listed in <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span>. The available events and passed arguments for utilities and rollouts are described\n            in <span class=\"char_link\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout Properties, Methods, and Event Handlers</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-695B\"></a>You can access and invoke the event handler functions in a scripted rollout by referring\n            to the handlers as properties on the user-interface items. The event handler functions\n            are accessed as sub-properties of the item using the event name as the sub-property\n            name. For example, if a scripted rollout has a check box item named <span class=\"code\"> <em class=\"strong\">foo</em> </span>, and an <span class=\"code\"> <em class=\"strong\">on foo changed</em> </span> event handler is defined, you can invoke the handler as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74BF\"></a><pre>foo.changed true -- call foo\'s \'changed\' handler function, passing argument of true</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6959\"></a>Or, if a scripted rollout has a button item named <span class=\"code\"> <em class=\"strong\">apply</em> </span>, and an <span class=\"code\"> <em class=\"strong\">on apply pressed</em> </span> event handler is defined, you can invoke the handler as follows: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6958\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6957\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74BE\"></a><pre>\napply.pressed() -- call apply’s \'pressed\' handler function, no argument.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6952\"></a>You can access an event handler function as a sub-property of the item. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6951\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6950\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74BD\"></a><pre>\nApplyPressedEH = apply.pressed\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-694C\"></a><p class=\"table-body\">stores a copy of the <span class=\"code\"> <em class=\"strong\">on apply pressed</em> </span> event handler function value to variable <span class=\"code\"> <em class=\"strong\">ApplyPressedEH</em> </span>. The event handler functions can only be <em class=\"strong\">read</em>. You <em class=\"strong\">cannot set</em> the handler function to another user-defined function. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";