var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-15203C86-5F9F-484E-A89D-7EDF2A20F9DB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MaxLiquid\">\n      <meta name=\"indexterm\" content=\"AlembicObject - GeometryClass\">\n      <meta name=\"indexterm\" content=\"geometry - Node\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MaxLiquid : GeometryClass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-15203C86-5F9F-484E-A89D-7EDF2A20F9DB\"></a><div class=\"head\">\n            <h1>MaxLiquid : GeometryClass</h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MaxLiquid - superclass: GeometryClass; super-superclass:node - 28:0 - classID: #(712128612L, 2137014116L)</em></pre></div>\n         <p><a name=\"GUID-3F0E5633-D2A6-4133-90DA-D50A2FD36CC8\"></a>Available in <em class=\"strong\">3ds Max 2018.3 and higher</em>. The liquid class contains the set up parameters for a fluid simulation, including\n            references to other objects, such as colliders and kill planes, that interact with\n            the liquid in the simulation. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1C2B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1C2A\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-2497AE43-97CA-4D30-B40E-8D45AC6DAEC5.htm\">GeometryClass</a></span> &gt; MaxLiquid \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-506A\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><pre>MaxLiquid...</pre></div><a name=\"TABLE_DEF0C656B8E544B98A425389BA3B09AD\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">Example \n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- Max fluid scene set up\nresetmaxFile #noPrompt\np = plane()\n\nb = box width:70 length:70 height:20\nconvertto b editable_poly\n\nsubobjectlevel = 4\nb.SetSelection #Face #{2}\nb.delete #face\naddmodifier b (shell outerAmount:3.0)\n\nliquid = maxLiquid pos:[0,0,50]\n-- don\'t do this:\n-- append liquid.collider_Meshes b\n-- append liquid.killplanes p\nliquid.AddCollider b\nliquid.AddKillPlane p\n\n-- create a new solver for the liquid and set the master voxel size\nliquid.CreateSolver 1\nsolver = liquid.solvers[1]\nsolver.masterVoxelSize = 4.0\n\n-- Turn on override for the first collider:\nsolver.colliderConversionOverrideTab[1] = true\n-- Set thickness for the collider\nsolver.colliderConversionOverrideThicknessTab[1] = 5.0</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-8DB798BB-4EE0-4788-9531-45DA05B76799\"></a> <em class=\"strong\"> Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">accelerator_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>Reserved for future use. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">cacheOutputFilePattern</em>     String    default: \"&lt;ProjectName&gt;\\SimCache\\&lt;ObjectName&gt;\\&lt;SolverName&gt;\\\"   --  string</pre></div>\n         <p>Reserved for future use. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">collider_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as colliders with the liquid in the simulation. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            collider meshes, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Colliders (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">emitter_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as liquid emitters. This array is only used when\n            the emitter icon type is \"custom\". \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            emitter meshes, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Emitters (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">emitterType</em>     Integer    default: 0   --  integer</pre></div>\n         <p>The type of emitter icon, where: \n            	 \n         </p><a name=\"UL_6E269EFA9FB04A608642180A7CD0BFFE\"></a><ul>\n            <li>0 = sphere \n               		\n            </li>\n            <li>1 = box \n               		\n            </li>\n            <li>2 = plane \n               		\n            </li>\n            <li>3 = custom – the nodes in the \n               		  <em class=\"strong\">emitter_Meshes</em> array are used as emitters. \n               		\n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">emitterHeight</em>     Float    default: 5.0   --  animatable; float\n&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">emitterLength</em>     Float    default: 5.0   --  animatable; float\n&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">emitterWidth</em>     Float    default: 5.0   --  animatable; float</pre></div>\n         <p>The height, length, and width of the emitter, when it is a box. When it is a sphere,\n            the \n            		<em class=\"strong\">emitterLength</em> is the radius. When the emitter is a plane, only the width and length parameters\n            are used. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">exportPRTFiles</em>     BooleanClass    default: false   --  Boolean</pre></div>\n         <p>Indicates whether to export voxels as PRT files when running the solve. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">field_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as motion fields. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            motion fields, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for motion fields (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">foammask_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as foam masks. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            foam masks, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Foam Masks (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">guide_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as guide meshes. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            guide meshes, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Guide Meshes (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">guideEmitter_Meshes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as Guide Emitters. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            guide emitter meshes, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Guide Emitters (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">iconSize</em>     Float    default: 10.0   --  float</pre></div>\n         <p>The size of the liquid icon in the viewport. Note that this is always in inches, regardless\n            of the scene units. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">killplanes</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of scene nodes that act as kill planes in the simulation. \n            	 \n         </p>\n         <p><em class=\"strong\">Note</em>: this array should not be directly manipulated, it is for reading only. To work with\n            kill planes, use the \n            		<span class=\"code\">Add/Get/Delete</span> methods for Kill Planes (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">killVolumeNode</em>     UndefinedClass    default: undefined   --  node</pre></div>\n         <p>Reserved for future use \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">lastSelectedSolverIndex</em>     Integer    default: 1   --  integer</pre></div>\n         <p>Contains the index in the solvers array of the last solve selected by the user. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">maxScratchCacheRAM</em>     Float    default: 1.0   --  float</pre></div>\n         <p>Reserved for future use. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">renderSolveIndex</em>     Integer    default: 1   --  integer</pre></div>\n         <p>Contains the index of the solver in the solver list which was last rendered. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">renderSolveLock</em>     BooleanClass    default: false   --  Boolean</pre></div>\n         <p>Gets or sets the state of the render lock button, where true indicates that the selected\n            solve is locked. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">rootSimDirectory</em>     String    default: \"c:\\MaxFluidSim\\\"   --  string</pre></div>\n         <p>Contains the root directory in which cache files are saved. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">scratchCache</em>     String    default: \"c:\\MaxFluidScratchCache\\\"   --  string</pre></div>\n         <p>Reserved for future use. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">showVoxelGrid</em>     BooleanClass    default: true   --  Boolean</pre></div>\n         <p>Indicates whether to show a visual representation of the voxel size in the viewport.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">solvers</em>     ArrayParameter    default: #()   --  maxObject array; SubAnim</pre></div>\n         <p>An array of solver objects for the liquid. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;MaxLiquid&gt;.<em class=\"codeEmphasisStrong\">useProjectFolders</em>     BooleanClass    default: false   --  Boolean</pre></div>\n         <p>Indicates whether to use the Max project folder instead of the \n            		<em class=\"strong\">rootSimDirectory</em> to store solver cache files. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"section\"><a name=\"SECTION_06739E67D5AA45BBABE6FD5D1BDA7822\"></a> \n            <h2><a name=\"GUID-BE537422-8CFE-44BC-9B34-08D0E4A3EAC9\"></a>MaxLiquid Interfaces\n            </h2> \n            <p> </p> \n         </div>\n         <p> </p>\n         <p> <em class=\"strong\">Interface: MaxFluidLiquidObject</em> \n         </p>\n         <p><em class=\"strong\"> Properties:</em> \n         </p>\n         <p><em class=\"strong\"> Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">CreateSolver</em> &lt;&amp;index&gt;solverIndex\n       solverIndex is Out parameter</pre></div>\n         <p>Creates a new solver in the liquid’s solvers array, returning the index of the newly\n            created solve. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">CloneSolver</em> &lt;index&gt;index &lt;&amp;TSTR&gt;cloneName &lt;&amp;index&gt;cloneIndex\n       cloneName is Out parameter\n       cloneIndex is Out parameter</pre></div>\n         <p>Creates a new, cloned copy of the solver specified by the index, returning the new\n            name and index. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteSolver</em> &lt;index&gt;index</pre></div>\n         <p>Deletes the solver specified by the index. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;integer&gt;<em class=\"codeEmphasisStrong\">NumberSolvers()</em></pre></div>\n         <p>Returns the number of solvers in the solvers array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddEmitter</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberEmitters</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetEmitter</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteEmitter</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of emitters held in the liquid\'s \n            		<span class=\"code\">emitter_Meshes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddCollider</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberColliders</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetCollider</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteCollider</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of colliders held in the liquid\'s \n            		<span class=\"code\">collider_Meshes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddKillPlane</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberKillPlanes</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetKillPlane</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteKillPlane</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of kill planes held in the liquid\'s \n            		<span class=\"code\">killplanes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddFoamMask</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberFoamMasks</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetFoamMask</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteFoamMask</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of foam masks held in the liquid\'s \n            		<span class=\"code\">foammask_Meshes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddGuideEmitter</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberGuideEmitters</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetGuideEmitter</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteGuideEmitter</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of guide emitters held in the liquid\'s \n            		<span class=\"code\">guideEmitter_Meshes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>    &lt;index&gt;<em class=\"codeEmphasisStrong\">AddMotionField</em> &lt;node&gt;node\n    &lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumberMotionFields</em>()\n    &lt;node&gt;<em class=\"codeEmphasisStrong\">GetMotionField</em> &lt;index&gt;index\n    &lt;boolean&gt;<em class=\"codeEmphasisStrong\">DeleteMotionField</em> &lt;index&gt;index</pre></div>\n         <p>Manipulates the collection of motion fields held in the liquid\'s \n            		<span class=\"code\">field_Meshes</span> array. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\"> Actions:</em> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";