var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"length()\">\n      <meta name=\"indexterm\" content=\"dot()\">\n      <meta name=\"indexterm\" content=\"cross()\">\n      <meta name=\"indexterm\" content=\"normalize()\">\n      <meta name=\"indexterm\" content=\"distance()\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"arbAxis()\">\n      <meta name=\"indexterm\" content=\"matrixFromNormal()\">\n      <meta name=\"indexterm\" content=\"turbulence()\">\n      <meta name=\"indexterm\" content=\"noise4()\">\n      <meta name=\"indexterm\" content=\"noise3()\">\n      <meta name=\"indexterm\" content=\"fractalNoise()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Point3 Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C\"></a><div class=\"head\">\n            <h1>Point3 Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BFF\"></a>The \n            		<em class=\"strong\">Point3</em> class defines the characteristics of points in 3D space. These values are also known\n            as vectors and contain three component floating point numbers. All the coordinates\n            passed to and from \n            		<em class=\"strong\">3ds Max</em> are in these values. See also \n            		<span class=\"char_link\"><a href=\"GUID-A2C25DDF-2FC1-456B-90C2-B91D98296C3F.htm\">2D and 3D Point Literals</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C00\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAC\"></a><pre><em class=\"codeEmphasisStrong\">[</em>&lt;expr&gt;, &lt;expr&gt;, &lt;expr&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C03\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C04\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAB\"></a><pre>\n[x, y, z]\n[10, 10, 10]\n[sin x, cos y, tan z]\nx_axis --equivalent to [1,0,0]\ny_axis --equivalent to [0,1,0]\nz_axis --equivalent to [0,0,1]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C0D\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAA\"></a><pre><em class=\"codeEmphasisStrong\">point3</em> &lt;x&gt; &lt;y&gt; &lt;z&gt; \n&lt;color&gt; <em class=\"codeEmphasisStrong\">as point3</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C10\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA9\"></a><pre>&lt;point3&gt;.<em class=\"codeEmphasisStrong\">x</em>: Float -- the x coordinate\n&lt;point3&gt;.<em class=\"codeEmphasisStrong\">y</em>: Float -- the y coordinate\n&lt;point3&gt;.<em class=\"codeEmphasisStrong\">z</em>: Float -- the z coordinate</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C14\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA8\"></a><pre>&lt;point3&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;point3&gt;\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;point3&gt;\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;point3_or_number&gt;\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;point3_or_number&gt;\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;point3_or_number&gt;\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">/</em> &lt;point3_or_number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C1C\"></a>Standard vector arithmetic. If the second operand is a number, the operation is performed\n            on each component of the value. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA7\"></a><pre>\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;matrix3&gt;\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C1F\"></a>Transforms \n            		<span class=\"code\"> <em class=\"strong\">point3</em> </span> into the coordinate system specified by \n            		<span class=\"code\"> <em class=\"strong\">matrix3</em> </span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA6\"></a><pre>&lt;point3&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C22\"></a>Rotates \n            		<span class=\"code\"> <em class=\"strong\">point3</em>. \n               		</span> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA5\"></a><pre><em class=\"codeEmphasisStrong\">-</em> &lt;point3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C25\"></a>Unary minus. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA4\"></a><pre>&lt;point3&gt;[&lt;integer&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C28\"></a>Returns a component of the Point3 as a float. Valid range on the index is 1 to 3.\n            \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA3\"></a><pre>&lt;point3&gt;[&lt;integer&gt;] <em class=\"codeEmphasisStrong\">=</em> &lt;float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C2B\"></a>Sets a component of the Point3 to the float. Valid range on the index is 1 to 3. \n            	 \n         </p>\n         <p><a name=\"P_DE294D477B404064B9482B309C1161E7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C2C\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA2\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;point3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C2E\"></a>Creates a new copy of the point3 value. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C2F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C30\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5592\"></a><pre>\nnewPos = copy oldPos\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C34\"></a>The new value contains a copy of the input point3 value and is independent of the\n            input point3 value. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C35\"></a> \n            <h2><a name=\"GUID-DAB9997B-8C10-40BA-83D5-490D356A3E98\"></a> <em class=\"strong\">Vector Length</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA1\"></a><pre><em class=\"codeEmphasisStrong\">length</em> &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C37\"></a>Returns the length of the vector. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6B65\"></a> \n            <h2><a name=\"GUID-3C87F076-0DED-4B5A-B679-9CF6265AA122\"></a> <em class=\"strong\">Vector Dot Product</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FA0\"></a><pre><em class=\"codeEmphasisStrong\">dot</em> &lt;point3&gt; &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C39\"></a>Returns the vector dot product. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3A\"></a>The geometric interpretation of the dot product is the length of the projection of\n               the first vector onto the unit vector of the second vector. Obviously, when the two\n               vectors are perpendicular, the dot product is 0.0. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3B\"></a>The dot product is \n               		  <em class=\"strong\">commutative</em>, which means that \n               		  <em class=\"strong\">dot X Y == dot Y X</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3C\"></a>The dot product is \n               		  <em class=\"strong\">associative</em>, which means that \n               		  <em class=\"strong\">dot (r*X) Y == r*(dot X Y)</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3D\"></a>The dot product is \n               		  <em class=\"strong\">distributive</em>, which means that \n               		  <em class=\"strong\">dot X (Y+Z) == (dot X Y) + (dot X Z)</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3E\"></a>Because the dot product of two normal vectors is the cosine of the angle between them,\n               the dot product can be used conveniently \n               		  <em class=\"strong\">to calculate the angle</em> between two vectors: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C3F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C40\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9F\"></a><pre>\nfn GetVectorsAngle v1 v2 =\n(\ntheAngle = acos(dot (normalize v1) (normalize v2))\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9E\"></a><pre>\nGetVectorsAngle [10,0,0] [10,20,0]\n63.435\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C4D\"></a> \n            <h2><a name=\"GUID-D1522310-6DF6-424D-8F1A-8E47DFF36BE9\"></a> <em class=\"strong\">Vector Cross Product</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9D\"></a><pre><em class=\"codeEmphasisStrong\">cross</em> &lt;point3&gt; &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C4F\"></a>Returns the vector cross product. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C50\"></a>The cross product is a third vector which is always perpendicular to the plane defined\n               by the two vectors with orientation determined by the right-hand rule. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C51\"></a>The cross product can be expressed as the length of the first vector multiplied by\n               the length of the second vector, multiplied by the sine of the angle between the two\n               vectors. Because of this, the \n               		  <em class=\"strong\">cross product of parallel vectors</em> is 0.0 (because sin 0.0 == 0.0). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C52\"></a>The cross product is also equal to the Area of the parallelogram formed by the two\n               vectors. If the two vectors are edges of a face, the cross product is the normal vector\n               to that face (a vector perpendicular to the face) with length equal to the Area of\n               the face multiplied by 2. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C53\"></a>The cross product is \n               		  <em class=\"strong\">anticommutative</em>, which means that \n               		  <em class=\"strong\">cross X Y == cross -Y X</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C54\"></a>The cross product is \n               		  <em class=\"strong\">associative</em>, which means that \n               		  <em class=\"strong\">cross (r*X) Y == r*(cross X Y)</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C55\"></a>The cross product is \n               		  <em class=\"strong\">distributive</em>, which means that \n               		  <em class=\"strong\">cross X (Y+Z) == (cross X Y) + (cross X Z)</em>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C56\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C57\"></a><p class=\"table-body\"> <em class=\"strong\">SEE EXAMPLE IN THE MAXSCRIPT FAQ:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C59\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-1193B0E7-10DF-4D3F-A89F-29FF0A291646.htm\">How do I align the UVW_Modifier\'s Gizmo to a selected face?</a></span> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C5C\"></a> \n            <h2><a name=\"GUID-047A96D8-F2D4-4F83-BAC9-11256B978048\"></a> <em class=\"strong\">Normalize Vector</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9C\"></a><pre><em class=\"codeEmphasisStrong\">normalize</em> &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C5E\"></a>Returns the \n               		  <span class=\"code\"> <em class=\"strong\">point3</em> </span> value normalized such that the vector length equals 1. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C5F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C60\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9B\"></a><pre>\nb =[100,30.5,41.3]--take somePoint3 value\n[100,30.5,41.3]\nnormalB1 =normalize b--getthe normalized vector\n[0.889603,0.271329,0.367406]\nlength normalB1-- check the length, should be 1.0\n1.0-- It is!\nnormalB2 =b / (length b)-- Do-It-Yourself Normalize...\n[0.889603,0.271329,0.367406]-- same value\nlength normalB2-- of course, the length is also 1.0\n1.0\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C6F\"></a> \n            <h2><a name=\"GUID-1B9C7D08-97E6-4E80-9329-9747894D293F\"></a> <em class=\"strong\">Distance Between Two Points / Vectors</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F9A\"></a><pre><em class=\"codeEmphasisStrong\">distance</em> &lt;point3&gt; &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C71\"></a>Returns the distance between the points, equivalent to the length of (point 2 - point\n               1). \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C72\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C73\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F99\"></a><pre>\na = [10,20,30]\nb = [100,30.5,41.3]\ndistance a b-- returns 91.3123\ndistance b a-- returns 91.3123\nlength (b-a)-- returns 91.3123\nlength (a-b)-- returns 91.3123\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C7E\"></a> \n            <h2><a name=\"GUID-42783C04-EA60-4F9A-9850-5BE7B3BA0B79\"></a> <em class=\"strong\">Pseudo-Random Point / Vector</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F98\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;point3&gt; &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C80\"></a>Generates a pseudo-random point between the given points. If point A and point B are\n               seen as the corners of a world-oriented bounding box, the random points will not reside\n               on the vector B-A, but will fill in the volume of the bounding box. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C81\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C82\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F97\"></a><pre>\na = [-10,-20,-30]-- define point A\nb = [20,30,50]-- define point B\np1 = Point pos:a-- create a Point Helper at point A\np2 = Point pos:b-- create a Point Helper at point B\n-- create 2000 spheres at random positions between point A and B\nfor i = 1 to 2000 do\n&nbsp;sphere pos:(random a b) radius:2 wirecolor:blue\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C8B\"></a><p class=\"table-body\">&nbsp; \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C8F\"></a> \n            <h2><a name=\"GUID-D2483257-7EA7-4D4B-92C6-2B2D14914BA4\"></a> <em class=\"strong\">Arbitrary Axis Matrix</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F96\"></a><pre><em class=\"codeEmphasisStrong\">arbAxis</em> &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C91\"></a>Returns a Matrix3 value representing an arbitrary axis system using \n               		  <span class=\"code\"> <em class=\"strong\">point3</em> </span> as the \"up\" direction. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C93\"></a> \n            <h2><a name=\"GUID-3378767C-3EE9-4CA7-A945-14858F2B4672\"></a> <em class=\"strong\">Matrix From Normal</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F95\"></a><pre><em class=\"codeEmphasisStrong\">matrixFromNormal</em> &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C95\"></a>Returns a Matrix3 value with the normal specified by the given point as the Z axis.\n               The translation portion of the Matrix3 value will be [0,0,0]. The components of the\n               scale portion are the inverse of the values required to normalize the \n               		  <span class=\"code\"> <em class=\"strong\">point3</em> </span> value. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87C96\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-887D3A2C-64CB-4AAA-A6E9-FFC73455CDAD.htm\">How Do I Get the Local Rotation of a Face?</a></span> for an example. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C97\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C98\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F94\"></a><pre>\nMatrixFromNormal [0,0,1]\nMatrixFromNormal [0,1,1]\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87C9D\"></a><p class=\"table-body\">will return \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F93\"></a><pre>\n(matrix3 [1,0,0], [0,1,0], [0,0,1], [0,0,0])\n(matrix3 [0,-0.707107,0.707107] [1.41421,0,0] [0,1,1] [0,0,0])\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CA3\"></a> \n            <h2><a name=\"GUID-55D5BF06-E310-4D8D-ABE6-7C4DA27B103F\"></a> <em class=\"strong\">3D Noise Functions</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F92\"></a><pre><em class=\"codeEmphasisStrong\">noise3</em> &lt;point3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CA8\"></a>A floating point noise function over 3D space implemented by a pseudo-random tricubic\n               spline. The return value is in the range -1.0 to +1.0. Given the same \n               		  <span class=\"code\"> <em class=\"strong\">point3</em> </span> value, the \n               		  <span class=\"code\"> <em class=\"strong\">noise3()</em> </span> function always returns the same value. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F91\"></a><pre><em class=\"codeEmphasisStrong\">noise4</em> &lt;point3&gt; &lt;phase_float&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CAB\"></a>The same function as noise3 in which the phase can be varied using the second parameter.\n               The return value is in the range -1.0 to +1.0. \n               		\n            </p> \n            <p><a name=\"P_949743E0DAB84069BD3CC20883EDB344\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F90\"></a><pre><em class=\"codeEmphasisStrong\">turbulence</em> &lt;point3&gt; &lt;frequency_float&gt;\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CAE\"></a>This is a simple fractal-loop turbulence built on top of the noise3 function. The\n               second parameter controls the frequency of the turbulence. The return value is in\n               the range 0.0 to +1.0. \n               		\n            </p> \n            <p><a name=\"P_5F3E8CDFA28E45E7B7C0748E7B453E70\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8F\"></a><pre><em class=\"codeEmphasisStrong\">fractalNoise</em> &lt;point3&gt; &lt;H_float&gt; &lt;lacunarity_float&gt; &lt;octaves_float&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB1\"></a>This is a fractal function of 3D space implemented using fractional Brownian motion.\n               The function is homogeneous and isotropic. It returns a float. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB2\"></a>The parameters are as follows: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB3\"></a> <span class=\"code\"> point3 \n                  		  </span>- The point in space at which the noise is computed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB4\"></a> <span class=\"code\"> H_float \n                  		  </span>- The fractal increment parameter in the range [0,1]. When \n               		  <span class=\"code\">H_float</span> is 1 the function is relatively smooth; as \n               		  <span class=\"code\">H_float</span> goes to 0, the function approaches white noise. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB5\"></a> <span class=\"code\"> lacunarity_float \n                  		  </span>- The gap between successive frequencies, best set at 2.0. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB6\"></a> <span class=\"code\"> octaves_float \n                  		  </span>- The number of frequencies in the function. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CB8\"></a>All the noise functions are based on code and algorithms in the book \"Texturing and\n               Modeling: A Procedural Approach\", Musgrave, Peachey, Perlin and Worley. Academic Press,\n               ISBN: 0-12-228760-6. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CBA\"></a>The following script shows the use of various literals, constructors, properties,\n               operators, and methods of the Point3 class. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CBB\"></a>The following script was written as a test bed for the noise functions. This script\n               displays a two dimensional slice of the noise function output as a bitmap. By changing\n               the noise parameters in lines 4 through 10 and specifying which noise function to\n               evaluate in line 12, you can see the effects of changes in the parameters and use\n               of different noise functions. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CBC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CBD\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8E\"></a><pre>\n-- noise functions test bed\nb_width=320-- specify size of bitmap\nb_height=320\nsize=10.-- total distance covered by each row and column\nz=0.-- z coordinate of 2D slice\nphase=0.5-- noise4 parameter\nfrequency=10.-- turbulence parameter\nfract_interval=.5-- fractalNoise parameters\nlacunarity=2.\noctaves=5\n--\nwhichfunc=1-- 1 = noise3; 2 = noise4; 3 = turbulence; 4 = fractalNoise\n--\nb=bitmap b_width b_height-- create the bitmap\nfor h=0 to (b_height-1) do-- step through each row of the bitmap\n(\nh_norm=(h as float/(b_height-1))*size-- calculate y coordinate\nrow = for w=0 to (b_width-1) collect-- collect row of pixel colors\n(\nw_norm=(w as float/(b_width-1))*size-- calculate x coordinate\nnoise_val = case whichfunc of-- store result of selected function\n(\n1: noise3 [w_norm, h_norm , z]\n2: noise4 [w_norm, h_norm , z] phase\n3: turbulence [w_norm, h_norm , z] frequency\n4: fractalNoise [w_norm, h_norm , z] fract_interval lacunarity octaves\n)\nnoise_val = 0.5*(1.+noise_val)-- convert output range to 0. to 1.\nwhite*noise_val-- and multiply by color white\n)\nsetpixels b [0,h] row-- store row of pixels in bitmap\n)\ndisplay b-- display bitmap in VFB\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE1\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE2\"></a><p class=\"table-body\">The following figures show the bitmap generated by the above script for each noise\n                           function type. \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE3\"></a><p class=\"table-body\">&nbsp; \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE4\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E1A3F292-6EA1-4AEE-AEB1-502E3DCE01CC-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE5\"></a><p class=\"table-body\"> <em class=\"strong\">noise3</em> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE6\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5FD7748F-FBA6-4D70-8C05-0780FFF85741-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE7\"></a><p class=\"table-body\"> <em class=\"strong\">noise4</em> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE8\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-1CF4BF1F-3EE8-4490-BF1C-A8A05C5DBCB8-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CE9\"></a><p class=\"table-body\"> <em class=\"strong\">turbulence</em> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CEA\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-99DB7D3A-A175-43E7-BE89-CED16649A430-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87CEB\"></a><p class=\"table-body\"> <em class=\"strong\">fractalNoise</em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CEF\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CF0\"></a> <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CF1\"></a> <span class=\"char_link\"><a href=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525.htm\">Box2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CF2\"></a> <span class=\"char_link\"><a href=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D.htm\">Ray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";