var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-189F1545-ABFC-4F2C-A7F0-17E069DD69F3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSTextureSurface - Value\">\n      <meta name=\"indexterm\" content=\"setTextureSurface()\">\n      <meta name=\"indexterm\" content=\"setPoint()\">\n      <meta name=\"indexterm\" content=\"getPoint()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSTextureSurface : Value</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-189F1545-ABFC-4F2C-A7F0-17E069DD69F3\"></a><div class=\"head\">\n            <h1>NURBSTextureSurface : Value </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC7\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC6\"></a> This class contains an editable texture coordinate surface corresponding to the editable\n               texture surface in NURBS surfaces. You can create and apply them to any NURBSSurface\n               value or retrieve existing texture surfaces using the <span class=\"code\"> <em class=\"strong\">getTextureSurface()</em> </span> and <span class=\"code\"> <em class=\"strong\">setTextureSurface()</em> </span> methods to access any of the 99 texture channels for a NURBS surface. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC4\"></a> <em class=\"strong\">3ds Max</em> uses the texture surface to control how materials are mapped. In effect, changing\n               the texture surface stretches or otherwise changes the UV coordinates for the surface,\n               altering the mapping. This is a 2D (not 3D) surface that lives in the parameter space\n               of the corresponding NURBSSurface which controls the texture mapping used by the NURBSSurface.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC3\"></a>It is not possible to assign texture surfaces to NURBS objects that are present in\n               the scene. You can create new NURBSSets and the texture surface is used when you call\n               <span class=\"code\"> <em class=\"strong\">createNURBSObject()</em> </span>. However, if you do a <span class=\"code\"> <em class=\"strong\">getNURBSSet()</em> </span>and assign a NURBSTextureSurface to a texture channel for a NURBS surface, nothing\n               happens. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC2\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2083\"></a><pre>NURBSTextureSurface <em class=\"codeEmphasisStrong\">[&lt;property&gt;:&lt;val&gt;]...</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EC0\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2082\"></a><pre><em class=\"codeEmphasisStrong\">getTextureSurface</em> &lt;nurbssurface&gt; &lt;channel_index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2081\"></a><pre>&lt;nurbssurface&gt;.<em class=\"codeEmphasisStrong\">textureSurface1</em> \n&lt;nurbssurface&gt;.<em class=\"codeEmphasisStrong\">textureSurface2</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EBB\"></a>Provides backward compatibility for scripts written for <em class=\"strong\">3ds Max</em> R2.5. Get and set the texture surfaces for the first two texture channels. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EBA\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2080\"></a><pre>&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">type</em>:<em class=\"codeEmphasisStrong\">#default, #userDefined, #projected </em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EB8\"></a>The type of texture surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-207F\"></a><pre>&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">parent</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EB5\"></a>The parent surface by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-207E\"></a><pre>&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">parentID</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EB2\"></a>The parent surface by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-207D\"></a><pre>&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">numUPoints</em>: integer -- read-only \n&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">numVPoints</em>: integer -- read-only \n&lt;nurbstexturesurface&gt;.<em class=\"codeEmphasisStrong\">numPoints</em>: point2 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EAD\"></a>The number of U and V points. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-4E06\"></a>    <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-207C\"></a><pre><em class=\"codeEmphasisStrong\">getPoint</em> &lt;nurbstexturesurface&gt; &lt;u_index&gt; &lt;v_index&gt; \n<em class=\"codeEmphasisStrong\">setPoint</em> &lt;nurbstexturesurface&gt; &lt;u_index&gt; &lt;v_index&gt; &lt;texturepoint&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EA6\"></a>Get or set a NURBSTexturePoint value for the texture point at the U and V index of\n               the texture surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EA5\"></a> <em class=\"strong\">Associated Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-207B\"></a><pre><em class=\"codeEmphasisStrong\">setTextureSurface</em> &lt;nurbssurface&gt; &lt;channel_index&gt; &lt;NURBSTextureSurface&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3EA3\"></a>This method sets the texture surface for the selected channel. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F4D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The NURBSTextureSurface class has been updated to correspond to the new texture surface\n                  mechanism in <em class=\"strong\">3ds Max4 and higher</em>, and has different properties and methods that were defined in <em class=\"strong\">3ds Max R3</em>. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3E9F\"></a>&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3E9D\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3E9C\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";