var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-19058A42-F710-48A4-8F8B-A52597748EAA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"makeValidName\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Name Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-19058A42-F710-48A4-8F8B-A52597748EAA\"></a><div class=\"head\">\n            <h1>Name Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AF7\"></a>The \n            		<em class=\"strong\">Name</em> class defines the characteristics of names. Names are primarily used as parameters\n            in function calls to signify one of a set of options. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AF8\"></a> <em class=\"strong\">Literal</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCA\"></a><pre><em class=\"codeEmphasisStrong\">#</em>&lt;var_name&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AFA\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-1C428A1F-3638-4DAC-812C-C6EBAE2100A8.htm\">Names</a></span> for a description of Name literals. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AFB\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC9\"></a><pre>&lt;string&gt; <em class=\"codeEmphasisStrong\">as name</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AFD\"></a>Converts a String value into a name. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AFE\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC8\"></a><pre>\n&lt;name&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;name&gt;\n&lt;name&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;name&gt;\n&lt;name&gt; <em class=\"codeEmphasisStrong\">&lt;</em> &lt;name&gt;\n&lt;name&gt; <em class=\"codeEmphasisStrong\">&gt;</em> &lt;name&gt;\n&lt;name&gt; <em class=\"codeEmphasisStrong\">&lt;=</em> &lt;name&gt;\n&lt;name&gt; <em class=\"codeEmphasisStrong\">&gt;=</em> &lt;name&gt;\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B05\"></a>Comparison of names is alphabetic (caseless). Among other things, this allows arrays\n            of names to be sorted using the array sort function. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B06\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC7\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;name&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B08\"></a>Creates a new copy of the name value. \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;name&gt; <em class=\"codeEmphasisStrong\">makeValidName</em> &lt;string&gt;</pre></div>\n         <p>  Returns a valid name value name from the specified string, where all spaces and punctuation\n            are replaced with the underscore \'_\' character. This can be useful for safely creating\n            rollout controls or scripted Paramblock2 parameters from strings. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 or higher</em>. \n            	 \n         </p>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B0A\"></a>The following script shows the use of various literals, constructors, and operators\n            of the Name class. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B0B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B0C\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC6\"></a><pre>\n-- name test bed\nname1=#Hello-- set variable to name literal\nname2=\"HELLO\"as name-- convert string to name\nif name1 == name2 do print\"names are equal\"-- compare the names\nbox_props=getpropnames box-- get the properties of box class\nsort box_props-- sort the property names\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B15\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC5\"></a><pre>\n#Hello-- result of line 2\n#Hello-- result of line 3\n\"names are equal\"-- output from line 4\n\"names are equal\"-- result of line 4\n-- following are the results of lines 5 and 6\n#(#height, #length, #lengthsegs, #width, #widthsegs, #mapCoords, #heightsegs)\n#(#height, #heightsegs, #length, #lengthsegs, #mapCoords, #width, #widthsegs)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B21\"></a> <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm\">String Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";