var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-19874C74-DEE5-4BCD-A5FD-4F0F51EB3451\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"FormattedPrint\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>formattedprint</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-19874C74-DEE5-4BCD-A5FD-4F0F51EB3451\"></a><div class=\"head\">\n            <h1>formattedprint </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8776C\"></a> The \n            		<em class=\"strong\">FormattedPrint</em> method was added to MAXScript in \n            		<em class=\"strong\">3ds Max 9</em>. It was previously available through the free \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6035\"></a><pre><em class=\"codeEmphasisStrong\">formattedPrint</em> &lt;value&gt; <em class=\"codeEmphasisStrong\">format</em>:&lt;string&gt; <em class=\"codeEmphasisStrong\">userLocale</em>:&lt;bool&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87770\"></a>Returns a string representation of value based on the format specified. \n            	 \n         </p>\n         <p><a name=\"P_EE1BE42742684E82BB231CC6CB9112B7\"></a>The format specified is applied for each component value for values that are comprised\n            of more than a single value. \n            	 \n         </p>\n         <p><a name=\"P_7B5B7B5CA8E34A068D600B02AC2998EC\"></a>For values or component values that are floating point numbers, the default format\n            string is \"0.8g\", for integers, \"%d\". \n            	 \n         </p>\n         <p><a name=\"P_50778B3985E7480CB1EFE552BAE4416F\"></a>The value specified must be one of: float, double, integer, integer64, intptr, string,\n            bool, ray, point2, point3, point4, quat, angleAxis, eulerAngle, matrix3, box2, color,\n            time, or interval. \n            	 \n         </p>\n         <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020.1 Update:</em> The optional \n            		<span class=\"code\"><em class=\"strong\">userLocal</em></span> parameter specifies whether to use the decimal character specified by the user\'s\n            locale. If false (the default) a period (\".\") is used as the decimal character, regardless\n            of locale. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87772\"></a>The optional \n            		<span class=\"code\"> <em class=\"strong\">format:</em> </span> string is of the form: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6034\"></a><pre>\"[Flags][Width][.Precision][SizePrefix]Type\"</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87774\"></a>where \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87775\"></a> <em class=\"strong\">Flags</em> is: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87776\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">Flag</em> \n                  </th>\n                  <th class=\"table-heading\"> <em class=\"strong\">Meaning</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87779\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">-</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777A\"></a><p class=\"table-body\">Left align the result within the given field width. Default is to right align. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">+</em> </span>&nbsp; \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777C\"></a><p class=\"table-body\">Prefix the output value with a sign (+ or -). Default is that sign appears only for\n                        negative signed values (-). \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">0</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777E\"></a><p class=\"table-body\">If width is prefixed with 0, zeros are added until the minimum width is reached. If\n                        0 and - appear, the 0 is ignored. If 0 is specified with an integer format (i, u,\n                        x, X, o, d) the 0 is ignored. Default is no padding. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8777F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">Blank</em>(\' \')</span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87780\"></a><p class=\"table-body\">Prefix the output value with a blank if the output value is signed and positive; the\n                        blank is ignored if both the blank and + flags appear. Default is no blank appears.\n                        \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87781\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87782\"></a><p class=\"table-body\">When used with the o, x, or X format, the # flag prefixes any nonzero output value\n                        with 0, 0x, or 0X, respectively. Default is no blank appears. When used with the e,\n                        E, or f format, the # flag forces the output value to contain a decimal point in all\n                        cases. Default is decimal point appears only if digits follow it. When used with the\n                        g or G format, the # flag forces the output value to contain a decimal point in all\n                        cases and prevents the truncation of trailing zeros. Default is decimal point appears\n                        only if digits follow it, and trailing zeros are truncated. Ignored when used with\n                        d, i, or u. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87784\"></a> <em class=\"strong\">Width</em> is a non-negative decimal integer controlling the minimum number of characters printed.\n            If the number of characters in the output value is less than the specified width,\n            blanks are added to the left or the right of the values - depending on whether the\n            - flag (for left alignment) is specified - until the minimum width is reached. If\n            width is prefixed with 0, zeros are added until the minimum width is reached (not\n            useful for left-aligned numbers). The width specification never causes a value to\n            be truncated. If the number of characters in the output value is greater than the\n            specified width, or if width is not given, all characters of the value are printed\n            (subject to the precision specification). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87785\"></a> <em class=\"strong\">Precision</em> specifies a non-negative decimal integer, preceded by a period (.), which specifies\n            the number of characters to be printed, the number of decimal places, or the number\n            of significant digits. Unlike the width specification, the precision specification\n            can cause either truncation of the output value or rounding of a floating-point value.\n            If precision is specified as 0 and the value to be converted is 0, the result is no\n            characters output. \n            		\n            <div><a name=\"GUID-8A1F0079-342B-4492-B75D-A9EC824E4D1C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Precision is always specified by a period (.) even if the locale specifies a different\n                  decimal character. \n                  		\n               </div>\n            </div> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87786\"></a> <em class=\"strong\">Type:d, i, u, o, x, X</em> - The precision specifies the minimum number of digits to be printed. If the number\n            of digits in the argument is less than precision, the output value is padded on the\n            left with zeros. The value is not truncated when the number of digits exceeds precision.\n            Default precision is 1. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87787\"></a> <em class=\"strong\">Type:e, E</em> - The precision specifies the number of digits to be printed after the decimal point.\n            The last printed digit is rounded. Default precision is 6; if precision is 0 or the\n            period (.) appears without a number following it, no decimal point is printed. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87788\"></a> <em class=\"strong\">Type: f</em> - The precision value specifies the number of digits after the decimal point. If\n            a decimal point appears, at least one digit appears before it. The value is rounded\n            to the appropriate number of digits. Default precision is 6; if precision is 0, or\n            if the period (.) appears without a number following it, no decimal point is printed.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87789\"></a> <em class=\"strong\">Type: g, G</em> - The precision specifies the maximum number of significant digits printed. Six significant\n            digits are printed, with any trailing zeros truncated. \n            	 \n         </p>\n         <p><em class=\"strong\">Type: s</em> - The precision specifies the minimum number of characters in the string, and left-pads\n            the formatted string with space characters, if required. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8778A\"></a>where \n            		<em class=\"strong\">Type</em> character is the only required format field; it appears after any optional format\n            fields. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8778B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"11.475281602002504%\">\n                  <col width=\"11.475281602002504%\">\n                  <col width=\"77.04943679599499%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">Character</em> \n                  </th>\n                  <th class=\"table-heading\"> <em class=\"strong\">Type</em> \n                  </th>\n                  <th class=\"table-heading\"> <em class=\"strong\">Output Format</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8778F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">d, i&nbsp;</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87790\"></a><p class=\"table-body\">int \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87791\"></a><p class=\"table-body\">Signed decimal integer. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87792\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">o</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87793\"></a><p class=\"table-body\">int \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87794\"></a><p class=\"table-body\">Unsigned octal integer. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87795\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">u</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87796\"></a><p class=\"table-body\">int \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87797\"></a><p class=\"table-body\">Unsigned decimal integer. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87798\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">x</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87799\"></a><p class=\"table-body\">int \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779A\"></a><p class=\"table-body\">Unsigned hexadecimal integer, using \"abcdef.\" \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779B\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">X</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779C\"></a><p class=\"table-body\">int \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779D\"></a><p class=\"table-body\">Unsigned hexadecimal integer, using \"ABCDEF.\" \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779E\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">e</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8779F\"></a><p class=\"table-body\">double \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A0\"></a><p class=\"table-body\">Signed value having the form \n                        					 <em class=\"strong\">[ - ]d.dddd e [sign]ddd</em> where \n                        					 <em class=\"strong\">d</em> is a single decimal digit, \n                        					 <em class=\"strong\">dddd</em> is one or more decimal digits, \n                        					 <em class=\"strong\">ddd</em> is exactly three decimal digits, and sign is \n                        					 <em class=\"strong\">+</em> or -<em class=\"strong\"> ;</em>. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A1\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">E</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A2\"></a><p class=\"table-body\">double \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A3\"></a><p class=\"table-body\">Identical to the e format except that \n                        					 <em class=\"strong\">E</em> rather than \n                        					 <em class=\"strong\">e</em> introduces the exponent. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A4\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">f</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A5\"></a><p class=\"table-body\">double \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A6\"></a><p class=\"table-body\">Signed value having the form \n                        					 <em class=\"strong\">[ - ]dddd.dddd</em>, where \n                        					 <em class=\"strong\">dddd</em> is one or more decimal digits. The number of digits before the decimal point depends\n                        on the magnitude of the number, and the number of digits after the decimal point depends\n                        on the requested precision. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A7\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">g</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A8\"></a><p class=\"table-body\">double \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877A9\"></a><p class=\"table-body\">Signed value printed in \n                        					 <em class=\"strong\">f</em> or \n                        					 <em class=\"strong\">e</em> format, whichever is more compact for the given value and precision. The \n                        					 <em class=\"strong\">e</em> format is used only when the exponent of the value is less than -4 or greater than\n                        or equal to the precision argument. Trailing zeros are truncated, and the decimal\n                        point appears only if one or more digits follow it. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877AA\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">G</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877AB\"></a><p class=\"table-body\">double \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877AC\"></a><p class=\"table-body\">Identical to the \n                        					 <em class=\"strong\">g</em> format, except that \n                        					 <em class=\"strong\">E</em>, rather than \n                        					 <em class=\"strong\">e</em>, introduces the exponent (where appropriate). \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">s</em> </span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\">string \n                        				  \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\">A string of characters. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877AD\"></a> <em class=\"strong\">SizePrefix</em> is: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877AE\"></a>I - value being printed is an IntegerPtr \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877AF\"></a>I32 - value being printed is an Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877B0\"></a>I64 - value being printed is an Integer64 \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877B2\"></a>For Integer values, the default format is \"I32d\" \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877B3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6033\"></a><pre>\nv = 12611668 -- Integer\nformattedPrint v\n\"12611668\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877BB\"></a>For Integer64 values, the default format is \"I64d\" \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877BC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6032\"></a><pre>\nv = 126116680000L -- Integer64\nformattedPrint v\n\"126116680000\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877C4\"></a>For IntegerPtr values, the default format is \"Id\" \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E877C5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6031\"></a><pre>\nv = 12611668P -- IntegerPtr\nformattedPrint v\n\"12611668\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E877CD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E877CE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6030\"></a><pre>\nformattedPrint pi\n\"3.1415927\"\n&nbsp;\nformattedPrint pi format:\"0 g\"\n\" 3.14159\"\n&nbsp;\nformattedPrint -pi format:\"0 g\"\n\"-3.14159\"\n&nbsp;\nformattedPrint pi format:\"12.8g\"\n\" 3.1415927\"\n\n-- when user locale uses \",\" as the decimal separator:\nformattedPrint pi userLocale:true\n\"3,1415927\"\n&nbsp;\nformattedPrint yellow\n\"(color 255 255 0)\"\n&nbsp;\nm = matrix3 1\nformattedPrint m\n\"(matrix3 [1,0,0] [0,1,0] [0,0,1])\"\n&nbsp;\nformattedPrint m format:\"#g\"\n\"(matrix3 [1.00000,0.000000,0.000000] [0.000000,1.00000,0.000000] [0.000000,0.000000,1.00000])\"\n&nbsp;\nformattedPrint 10 format:\"#o\"\n\"012\"\n&nbsp;\nformattedPrint 10 format:\"#x\"\n\"0xa\"\n&nbsp;\nformattedPrint v format:\"19.18g\"\n\" 1.2345678901234567\"\n\nformattedPrint \"abc\" format:\"15s\"\n\"            abc\"\n\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";