var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Callbacks\">\n      <meta name=\"indexterm\" content=\"change handlers: and callbacks\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Change Handlers and Callbacks</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7\"></a><div class=\"head\">\n            <h1>Change Handlers and Callbacks </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AD0\"></a> <em class=\"strong\">Change Handlers</em> and <em class=\"strong\">Callbacks</em> are used to detect when certain types of events occur to scene objects or within\n            <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACF\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers</a></span> are applied to individual <span class=\"char_link\"><a href=\"GUID-025B6C97-8601-4FEF-ACB8-E47EE0929300.htm\">MAXWrapper</a></span> objects and specify an attribute to monitor for that object and an expression to\n            evaluate when that attribute changes. Example attributes that can be monitored are\n            geometry, name, transform, and parameters. Change Handlers are not stored in the <em class=\"strong\">3ds Max</em> scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACE\"></a> <em class=\"strong\">Callbacks</em> are used to register with <em class=\"strong\">3ds Max</em> functions that are called when specific events occur within <em class=\"strong\">3ds Max</em>. Events that can be monitored are changes to the <span class=\"char_link\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">time slider tim</a></span> and <span class=\"char_link\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">redrawing of viewports</a></span>. Callbacks are not stored in a <em class=\"strong\">3ds Max</em> scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACD\"></a>MAXScript also provides several methods that automatically tie into <em class=\"strong\">3ds Max</em>’s Callback system. These <em class=\"strong\">General Event Callback Mechanism</em> methods are used to register and unregister <em class=\"strong\">3ds Max</em>s scripts that are called for a variety of <em class=\"strong\">3ds Max</em> events. These scripts can optionally be saved with the currently-open file and stay\n            permanently with it, running whenever the scene is loaded, until they are explicitly\n            removed. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACC\"></a>The <em class=\"strong\">Node Event System</em> introduced in <em class=\"strong\">3ds Max 2009</em> provides a direct exposure of the SDK <span class=\"code\"> <em class=\"strong\">INodeEventCallback</em> </span> methods and allows more node-related events to be captured, including mapping changes\n            and node-related Undo/Redo actions. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACB\"></a> \n            <h2><a name=\"GUID-FCF0231C-66A2-4D36-9C59-958A73C3B73B\"></a> <em class=\"strong\">The above systems are described in more detail in the following topics:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ACA\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC9\"></a> <span class=\"char_link\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">Time Change Callback Mechanism</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC8\"></a> <span class=\"char_link\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">Viewport Redraw Callback Mechanism</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC7\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC6\"></a> <span class=\"char_link\"><a href=\"GUID-7C91D285-5683-4606-9F7C-B8D3A7CA508B.htm\">Node Event System</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC3\"></a> <span class=\"char_link\"><a href=\"GUID-45E2F1A9-AFBB-413F-AEAD-7C9816BA94E5.htm\">Trackbar Filter Callback Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AC2\"></a> <span class=\"char_link\"><a href=\"GUID-F7FF013A-F607-4E85-B656-4E1479B8CF26.htm\">RenderEffect Progress Callback Mechanism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">Time Change Callback Mechanism </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">Viewport Redraw Callback Mechanism </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-7C91D285-5683-4606-9F7C-B8D3A7CA508B.htm\">Node Event System </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-45E2F1A9-AFBB-413F-AEAD-7C9816BA94E5.htm\">Exploring the Trackbar Filter Callback Functions </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";