var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1C3873E2-A01A-4EF5-8B29-44617DFCDE81\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"spline: common properties: operators: and methods\">\n      <meta name=\"indexterm\" content=\"trimextend()\">\n      <meta name=\"indexterm\" content=\"measureOffset()\">\n      <meta name=\"indexterm\" content=\"applyOffset()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Spline Shape Common Properties, Operators, and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1C3873E2-A01A-4EF5-8B29-44617DFCDE81\"></a><div class=\"head\">\n            <h1>Spline Shape Common Properties, Operators, and Methods </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1846\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1845\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-2497AE43-97CA-4D30-B40E-8D45AC6DAEC5.htm\">GeometryClass</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-20DA1210-561D-4070-A19B-C8360F350243.htm\">Shape</a></span> &gt; SplineShape \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1844\"></a>The following methods apply to all spline shape objects. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1843\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1842\"></a>None \n         </p>\n         <p><a name=\"P_9ACAE657B5DC47F8B0CE6AAA628065C4\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3DDCBAB2212B7835B3AF-67BA\"></a>    <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-373B\"></a><pre><em class=\"codeEmphasisStrong\">applyOffset</em> &lt;spline_shape_node&gt; &lt;offset_float&gt; 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-183D\"></a>For each spline in the shape, makes a copy of the spline, offset on all sides to the\n            distance in units specified by <span class=\"code\"> <em class=\"strong\">offset_float</em> </span>. If a spline is open, the resulting spline and its outline will make a single closed\n            spline. Negative <span class=\"code\"> <em class=\"strong\">offset_float</em> </span> values create an offset spline to the left of the spline (as the spline is drawn\n            from its start to its finish). The <span class=\"code\"> <em class=\"strong\">spline_shape_node</em> </span> is converted to a SplineShape (Editable Spline) if it is not already a SplineShape.\n            \n         </p>\n         <p><a name=\"P_539D8D3C32CD4B3382E6C2606460FC13\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-373A\"></a><pre><em class=\"codeEmphasisStrong\">measureOffset</em> &lt;spline_shape_node&gt; &lt;point3&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-183A\"></a>Returns a Float value whose absolute value is the distance from <span class=\"code\"> <em class=\"strong\">point3</em> </span> to the closest point on a spline in the shape. The sign of the value is positive\n            if the <span class=\"code\"> <em class=\"strong\">point3</em> </span> position is to the left of the spline (as the spline is drawn from its start to its\n            finish). The value returned by this method can usually be used as the <span class=\"code\"> <em class=\"strong\">offset_float</em> </span> parameter in <span class=\"code\"> <em class=\"strong\">applyOffset()</em> </span> to have an offset spline pass through the <span class=\"code\"> <em class=\"strong\">point3</em> </span> position. If the closest point on a spline in the shape is an endpoint of an open\n            spline, the offset spline will not pass through the <span class=\"code\"> <em class=\"strong\">point3</em> </span> position. \n         </p>\n         <p><a name=\"P_7B855B7EC0534C218F34FC359E0A5A2C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3739\"></a><pre><em class=\"codeEmphasisStrong\">trimextend</em> &lt;fixed_node_array&gt; &lt;alterable_node_array&gt; \\ \n[ <em class=\"codeEmphasisStrong\">trim</em>: &lt;boolean&gt; ] [ <em class=\"codeEmphasisStrong\">extend</em>: &lt;boolean&gt;] [ <em class=\"codeEmphasisStrong\">infinite</em>: &lt;boolean&gt;] \\ \n[ <em class=\"codeEmphasisStrong\">project</em>: <em class=\"codeEmphasisStrong\">view</em>|<em class=\"codeEmphasisStrong\">#3D</em>|<em class=\"codeEmphasisStrong\">#grid</em>] </pre></div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AD6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <em class=\"strong\">THIS FEATURE IS CURRENTLY BROKEN.</em> \n            </div>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-1830\"></a> <span class=\"char_link\"><a href=\"GUID-20DA1210-561D-4070-A19B-C8360F350243.htm\">Shape Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5750\"></a> <span class=\"char_link\"><a href=\"GUID-AB920CA1-5DC2-44F5-9B3C-2B6D5047AC8A.htm\">Node Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-182E\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-574F\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";