var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-1CF90959-B604-45F9-8552-7680F535BF50\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"tokens\">\n      <meta name=\"indexterm\" content=\"scripts\">\n      <meta name=\"indexterm\" content=\"script files\">\n      <meta name=\"indexterm\" content=\"nesting\">\n      <meta name=\"indexterm\" content=\"Code\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"including scripts within scripts\">\n      <meta name=\"indexterm\" content=\"include()\">\n      <meta name=\"indexterm\" content=\"fileIn()\">\n      <meta name=\"indexterm\" content=\"constructs - compile time\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Including Scripts Within Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1CF90959-B604-45F9-8552-7680F535BF50\"></a><div class=\"head\">\n            <h1>Including Scripts Within Scripts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C40\"></a>          MAXScript provides a compile-time source-file include mechanism, allowing you to break\n            up large scripts into smaller files that can be included at nearly any point in a\n            script. You can use the \n            		<span class=\"code\"> <em class=\"strong\">include</em> &lt;file&gt;</span> construct at any point in your code to effectively insert the contents of a file\n            at that point in your code. \n            	 \n         </p>\n         <p>By convention, scripts that are only included in other scripts, and not intended to\n            run on their own, use the \n            		<span class=\"filePath\">.mxs</span> extension. This extension an extension that is supported by the MAXScript editor\'s\n            file open/save dialog, but not the \n            		<em class=\"strong\">Scripting &gt; Run Script</em> dialog. Colorization and autocomplete are supported in the MAXScript editor for \n            		<span class=\"filePath\">.mxs</span> files.\n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C4B\"></a>The form is: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6399\"></a><pre><em class=\"codeEmphasisStrong\">include</em> \"filename_string\"</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C4E\"></a>This is a compile-time construct, therefore the file name specification must be a\n            string literal, and not a variable or an expression. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C4F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C50\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6398\"></a><pre>\nutility foo \"Baz\"\n(\nlocal a, b, c\ninclude \"foo-ui.ms\"\nrollout bar \"Bar\"\n(\ninclude \"bar-rollout.ms\"\n)\ninclude \"foo-handlers.ms\"\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C5E\"></a>The \n            		<span class=\"code\"><em class=\"strong\">include</em> &lt;file&gt;</span> construct is effectively replaced in the source code at that point with the contents\n            of the named file. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C5F\"></a>You can nest included files as deeply as needed (included files can include other\n            files, and so on). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C60\"></a>Because \n            		<span class=\"code\"> <em class=\"strong\">include</em> </span> is a compile-time construct, the current MAXScript scope is maintained within the\n            included file. This is opposed to the \n            		<span class=\"code\"> <em class=\"strong\">fileIn() \n                  		  </em> </span>method described in \n            		<span class=\"char_link\"><a href=\"GUID-86D82FCE-B88F-4487-9B34-B6222EDA1C71.htm\">Running Scripts</a></span>, whose script file content is compiled in a global scope context. For more information,\n            see \n            		<span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope_of_Variables</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C61\"></a>The \n            		<span class=\"code\"><em class=\"strong\">include</em> &lt;file&gt;</span> can appear at any point a new token is expected such as a name, literal, or punctuation.\n            This means that you can complete a partial expression with an included file. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C62\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C63\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6395\"></a><pre>include \"op1.ms\"+ include \"op2.ms\"\nif include \"test2.ms\" then print a else print b</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C69\"></a>You cannot place an \n            		<span class=\"code\"> <em class=\"strong\">include</em> &lt;file&gt; \n               		</span>within a token. For example, the following is not valid: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C6A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C6B\"></a><p class=\"table-body\"> <em class=\"strong\">NOT VALID:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6394\"></a><pre>timeval = 2:include \"framenum.ms\".0</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";