var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"drawing a box with MAXScript\">\n      <meta name=\"indexterm\" content=\"box creation example\">\n      <meta name=\"indexterm\" content=\"adding objects\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Drawing a Box with MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D\"></a><div class=\"head\">\n            <h1>Drawing a Box with MAXScript </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EEA\"></a>   In the <span class=\"char_link\"><a href=\"GUID-BEFD6E9D-65BF-4C0B-B217-8604DC48200B.htm\">previous lessons</a></span> you have seen some of MAXScript’s useful capabilities; however, nothing that is visible\n            in the interface. MAXScript is also useful for working with regular objects, such\n            as boxes or cylinders. You can draw a box in MAXScript just by entering the <span class=\"code\">box()</span> command: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508C\"></a><pre>box()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EEF\"></a>This creates a box with the default parameters. It is generally better practice to\n            assign an object to a variable, so you can later refer to it by name and manipulate\n            it using that name: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508B\"></a><pre>mybox = box()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EF1\"></a>When you use MAXScript to create an object without specifying any parameters, it is\n            important to use empty parentheses, \"<span class=\"code\">()</span>\". This tells MAXScript to use the default parameters for the object. If you want\n            to specify any of the parameters during creation, such as the size or location of\n            the object, you do not need parentheses. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EF2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EF3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508A\"></a><pre>mybox = box length:20 width:20 height:20</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EF8\"></a>MAXScript returns the box object name and the position of the box: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EF9\"></a>&nbsp;<img src=\"../images/GUID-5FDDA070-6661-4F33-B6CD-D742197F4814-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EFA\"></a>This example creates a box, and supplies three <span class=\"code\">parameters</span>: the length, width, and height of the box. The parameter names are followed by a\n            colon and then by the value for that parameter. You can enter all parameters, without\n            any punctuation between them. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EFB\"></a>MAXScript returns the following statement: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5089\"></a><pre>$Box:Box001 @ [0.000000,0.000000,0.000000].</pre></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EFD\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EFF\"></a>The first part of the statement is called a pathname. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F01\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F03\"></a>A pathname in MAXScript is similar to a pathname in Windows, such as <span class=\"code\">c:\\3dsmax\\examples\\file.max</span>, which represents a path through a hierarchy of directories pointing to a particular\n                        file. In MAXScript, a similar path concept is used. However paths in MAXScript end\n                        up pointing to objects, not files. Pathnames in MAXScript always begin with the \"$\"\n                        character. For more information on Pathnames, see the <span class=\"char_link\"><a href=\"GUID-8395020C-E3B6-4282-AF1C-5B58BDB97A24.htm\">Pathname Literals</a></span> topic in the MAXScript reference. \n                     </p> \n                  </li>\n               </ul> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F05\"></a>The second part of the statement is the object name:<span class=\"code\">Box01</span>, in this case. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F07\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F09\"></a>This name appears in the Select Object dialog when you use the<img src=\"../images/GUID-E5AF59C7-4FE3-40E8-B95F-7F4C150D5226-low.gif\"> Select by Name toolbar button in <em class=\"strong\">3ds Max</em>. It is <em class=\"mild\">not </em>the name of your box variable, which is <span class=\"code\">mybox</span>. This variable is merely a placeholder that points to the object, <span class=\"code\">Box01</span>. \n                     </p> \n                  </li>\n               </ul> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F0A\"></a>The values inside the brackets represent the x, y, and z coordinates of the center\n            of the box. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F0B\"></a>MAXScript also draws the box in the viewports, as shown in this perspective viewport:\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F0C\"></a>&nbsp;<img src=\"../images/GUID-C5612F82-AC96-4F00-9C00-DA20EA95FCD2-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F0D\"></a>Notice that you can use<img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\"> Undo (as you can with most MAXScript creation and modification commands) to remove\n            the box from the scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F0F\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F10\"></a> <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">Modifying the Box</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";