var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-212F239E-EBC5-4AD3-A620-CECDDA7E69B5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"rootScene System Global Variable\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>rootScene System Global Variable</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-212F239E-EBC5-4AD3-A620-CECDDA7E69B5\"></a><div class=\"head\">\n            <h1>rootScene System Global Variable </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BC4\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BC3\"></a>  The <em class=\"strong\">rootScene</em> is a system global variable that represents the Scene Root. It is available in <em class=\"strong\">3ds Max 2011 and higher</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BC1\"></a>Its subAnims can be used to access various elements of the scene hierarchy including:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BC0\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BBE\"></a>Sound \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BBC\"></a>Video Post \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BBA\"></a>Global Tracks \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BB8\"></a>Biped \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BB6\"></a>Animation Layer Control Manager \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BB4\"></a>Schematic Material Editor \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BB2\"></a>Environment \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BB0\"></a>Render Effects \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BAE\"></a>Render Elements \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BAC\"></a>Renderers \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BAA\"></a>Global Shadow Parameters \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA8\"></a>Scene Materials \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA6\"></a>Medit Materials \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA4\"></a>World \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA3\"></a>The rootScene is used by the Macro Recorder to emit script code relative to the scene\n               root. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA2\"></a>Below are some examples of accessing the rootScene and its subAnims: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4BA0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B9F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2320\"></a><pre>\nrootScene\n--&gt;$&lt;rootScene&gt;\n&nbsp;\ngetsubanimnames rootScene\n--&gt;#(#Sound, #Video_Post, #Global_Tracks, #biped, #Anim_Layer_Control_Manager, #SME, #Environment, #Render_Effects, #Render_Elements, #renderer, #Global_Shadow_Parameters, \n--&gt;#Scene_Materials, #Medit_Materials, #world)\n&nbsp;\nw=rootscene[#world]\n--&gt;SubAnim:World\n&nbsp;\nw.object\n--&gt;$&lt;root&gt;\n&nbsp;\nclassof rootScene\n--&gt;Scene\n&nbsp;\nweaponDataCA = attributes weaponData\n(\nparameters main rollout:params\n(\nhitPoints type:#float ui:hits default:10\ncost type:#float ui:cost default:100\nsound type:#string\n)\nrollout params \"Weapon Parameters\"\n(\nspinner hits \"Hit Points\" type:#float\nspinner cost \"Cost\" type:#float\ndropdownlist sound_dd \"Sound\" items:#(\"boom\", \"sparkle\", \"zap\", \"fizzle\")\non sound_dd selected i do sound = sound_dd.items[i]\n)\n)\nCustAttributes.add rootnode weaponDataCA\nCustAttributes.add rootscene weaponDataCA\ncreatedialog rootnode.weapondata.params\n--Playing with parameters generates clean macro recorder output\n&nbsp;\n--Close dialog before running next line:\n&nbsp;\ncreatedialog rootscene.weapondata.params\n--Playing with parameters generates clean macro recorder output\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B71\"></a> <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm#WS3ED54CBA79FF2E3D1E593B6612B78359E8F-78D4\"> Max System Globals - R</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B70\"></a> <span class=\"char_link\"><a href=\"GUID-FA932DB0-738F-4A58-B49E-9A184064676C.htm\">Track View Nodes</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";