var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-21C94F78-E3A1-4B24-AA5A-DDF4C9F0A9C8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"NURBSSelection - Value\">\n      <meta name=\"indexterm\" content=\"select()\">\n      <meta name=\"indexterm\" content=\"scale()\">\n      <meta name=\"indexterm\" content=\"rotate()\">\n      <meta name=\"indexterm\" content=\"move()\">\n      <meta name=\"indexterm\" content=\"findItem()\">\n      <meta name=\"indexterm\" content=\"deselect()\">\n      <meta name=\"indexterm\" content=\"delete()\">\n      <meta name=\"indexterm\" content=\"append()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSSelection : Value</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-21C94F78-E3A1-4B24-AA5A-DDF4C9F0A9C8\"></a><div class=\"head\">\n            <h1>NURBSSelection : Value </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FDC\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FDB\"></a>  A <em class=\"strong\">NURBSSelection</em> represents a set of NURBS sub-objects for a scene NURBS node as a virtual array.\n               As such, you can access a sub-object by index, iterate over the sub-objects, and apply\n               mapped functions to the sub-objects. The NURBSSelection array is dynamic (its contents\n               will change as the sub-objects of the NURBS node change). NURBSSelection values are\n               mappable. \n            </p> \n            <p><a name=\"GUID-329FF811-FAFB-4A71-A631-7793C5EA1441\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FD8\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B8\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedCurveCVs</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedCurves</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedImports</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedPoints</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedSurfaces</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedSurfCVs</em> \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">curveCVs</em> -- read-only \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">curves</em> -- read-only \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">imports</em> -- read-only \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">surfaces</em> -- read-only \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">surfCVs</em> -- read-only \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">points</em> -- read-only 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FCB\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <p><a name=\"GUID-E54B8D45-CDFA-434A-A0D6-6EF39245A8CA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B7\"></a><pre>&lt;nurbsselection&gt;.<em class=\"codeEmphasisStrong\">count</em>: Integer, read-only   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC9\"></a>Returns the number of sub-objects in the NURBSSelection array. \n            </p> \n            <p><a name=\"GUID-2E2FD824-25C4-40DC-B610-6AD35DF1BE90\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B6\"></a><pre>&lt;nurbsselection&gt;.<em class=\"codeEmphasisStrong\">selSetNames</em>: Array of names, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC6\"></a>Returns an array of names of the current named selection sets corresponding to the\n               NURBSSelection level for the object the NURBSSelection is associated with. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC4\"></a>The following property is present for singleton selections (of the form $foo.curveCVs[n]):\n               \n            </p> \n            <p><a name=\"GUID-7380C926-D792-49F4-B784-587A4B585A5A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B5\"></a><pre>&lt;nurbsselection&gt;.<em class=\"codeEmphasisStrong\">index</em>: Integer, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC2\"></a>Returns the index of the selected sub-object in the NURBS object, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FC0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B4\"></a><pre>\n$foo.selectedcurveCVs[2].index\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FBC\"></a><p class=\"table-body\">returns the curve CV index of the second curve CV in the current selection. </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-BD2AC1C1-5B06-4819-80D5-0220FF94EDB0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F4E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Iterating over a selection yields singleton selections in the loop body: \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FB8\"></a></p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B3\"></a><pre>sCVs = for i in $foo.selectedcurveCVs collect i.index</pre></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FB4\"></a>sCVs contains selected curve CVs as array. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-6212A4BD-2FFF-4D31-B98D-49E8CC9DB8A7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FB2\"></a> <em class=\"strong\">Operators</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B2\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedCurveCVs</em> = (&lt;array&gt; | &lt;bitarray&gt;) \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedCurves</em> = (&lt;array&gt; | &lt;bitarray&gt;) \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedImports</em> = (&lt;array&gt; | &lt;bitarray&gt;) \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedPoints</em> = (&lt;array&gt; | &lt;bitarray&gt;) \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedSurfaces</em> = (&lt;array&gt; | &lt;bitarray&gt;) \n&lt;node&gt;.<em class=\"codeEmphasisStrong\">selectedSurfCVs</em> = (&lt;array&gt; | &lt;bitarray&gt;) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FAB\"></a>Selects the specified sub-objects. \n            </p> \n            <p><a name=\"GUID-834D4D7D-A416-46DD-91AD-869C6227605E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B1\"></a><pre>&lt;nurbsselection&gt; <em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FA8\"></a>Retrieves the indexed sub-object as a singleton NURBSSelection. Index starts at 1.\n               \n            </p> \n            <p><a name=\"GUID-B4FEB9D6-B837-45A4-9417-03623ABE9605\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B0\"></a><pre>&lt;nurbsselection&gt; <em class=\"codeEmphasisStrong\">[</em>(&lt;integer_array&gt; | &lt;bitarray&gt;)<em class=\"codeEmphasisStrong\">]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FA5\"></a>Retrieves the indexed sub-objects as a NURBSSelection. Index starts at 1. \n            </p> \n            <p><a name=\"GUID-DF7A6C21-FCE5-46D3-B9EC-93ED42E3C2F6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AF\"></a><pre>&lt;nurbsselection&gt;<em class=\"codeEmphasisStrong\"> [(</em>&lt;#name&gt; | &lt;string&gt;)<em class=\"codeEmphasisStrong\">]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FA2\"></a>Retrieves the sub-object level named selection set, where the name of the named selection\n               set can be specified as a name or string value. \n            </p> \n            <p><a name=\"GUID-0AC41BAA-21D8-4E6D-822C-615828F8362D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AE\"></a><pre>&lt;nurbsselection&gt; <em class=\"codeEmphasisStrong\">[</em>(&lt;<em class=\"codeEmphasisStrong\">#name</em>&gt; | &lt;string&gt;)<em class=\"codeEmphasisStrong\">]</em> = (&lt;nurbsselection&gt; | &lt;integer_array&gt; | &lt;bitarray&gt;) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F9F\"></a>Sets the sub-object level named selection set to the specified edges. The name of\n               the named selection set can be specified as a name or string value, and the edges\n               can be specified as an array, bitArray, or a NURBSSelection from the same object and\n               of the same sub-object level. \n            </p> \n            <p><a name=\"GUID-627D1E8C-E2E2-4A8B-AEF8-B07D1948D07C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-4ED4\"></a>         <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AD\"></a><pre><em class=\"codeEmphasisStrong\">move</em> &lt;nurbsselection&gt; &lt;point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F94\"></a>Moves the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-F3DCB205-BF5F-4E02-8833-81876F1BF8BF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AC\"></a><pre><em class=\"codeEmphasisStrong\">rotate</em> &lt;nurbsselection&gt; &lt;quat_or_other_rotation_form&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F91\"></a>Rotates the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-71FCFF9D-EFAE-4B6B-A99C-7FF8E12D84F5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AB\"></a><pre><em class=\"codeEmphasisStrong\">scale</em> &lt;nurbsselection&gt; &lt;point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F8E\"></a>Scales the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-6639D334-3182-4D43-B8FD-8A1584BF6A5F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20AA\"></a><pre><em class=\"codeEmphasisStrong\">select</em> &lt;nurbsselection&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F8B\"></a>Selects the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-EDAF3D58-0BAD-406D-8D26-8688B978BC3D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20A9\"></a><pre><em class=\"codeEmphasisStrong\">deselect</em> &lt;nurbsselection&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F88\"></a>Deselects the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-DCF2E2DE-5BD2-4AFC-B52E-E9920310BDD6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20A8\"></a><pre><em class=\"codeEmphasisStrong\">delete</em> &lt;nurbsselection&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F85\"></a>Deletes the sub-objects in the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-D0437A42-9848-4B27-ACDA-E9EC42FA7AAC\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20A7\"></a><pre><em class=\"codeEmphasisStrong\">append</em> &lt;nurbsselection&gt; (&lt;nurbsselection&gt; | &lt;integer&gt;) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F82\"></a>Appends the sub-objects(s) to the NURBSSelection. \n            </p> \n            <p><a name=\"GUID-0B00EFC5-126B-44F3-84F2-8F663211611A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20A6\"></a><pre><em class=\"codeEmphasisStrong\">findItem</em> &lt;nurbsselection&gt; (&lt;nurbsselection[&lt;integer&gt;] | &lt;integer&gt;) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F7F\"></a>Returns the selection index of the matching item or 0 if not found. The item is selection\n               index or singleton NURBSSelection. \n            </p> \n            <p><a name=\"GUID-B8D9EC11-B5B7-4A68-A16F-6E761B09744D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F7C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F7B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20A5\"></a><pre>\n$foo.surfCVs[#baz] -- retrieves the surf CV selection named baz\nmove $foo.curves[#bar] [0,0,10] -- moves the \"bar\" curve selection 10 in Z\nmove $foo.selectedSurfCVs [0,0,10] -- moves the current surface CV selection 10 in Z\ncoordsys local scale $foo.surfaces [#baz] [2,2,2]\nselect $foo.curveCVs[#(1,2,3,4,5)] -- select the specified curve CVs\ndeselect $foo.curves-- deselect all curves\ndelete $foo.points[#{1..31, 40..50}] -- delete the specified points\n$foo.curveCVs[#fred] = $foo.selectedCurveCVs -- \"snapshot\" the selected curve CVs\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F70\"></a>&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3F6E\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";