var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-22A56B6C-CB64-49BA-8C15-0354378EB575\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"transformations\">\n      <meta name=\"indexterm\" content=\"modifying the box\">\n      <meta name=\"indexterm\" content=\"box transformations\">\n      <meta name=\"indexterm\" content=\"animate\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>More Box Transformations</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-22A56B6C-CB64-49BA-8C15-0354378EB575\"></a><div class=\"head\">\n            <h1>More Box Transformations </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FBC\"></a>     \n         </p>\n         <div><a name=\"GUID-DB8D76BC-33AA-4EC3-88ED-4F005940CFE1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This is a continuation of the <span class=\"char_link\"><a href=\"GUID-4C1D639F-0A2C-402D-A078-56D8A8DB4964.htm\">\"Manipulating The Box - First Steps in MAXScript\"</a></span> tutorial\'s previous lesson <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">\"Drawing a Box with MAXScript\"</a></span>, <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">\"Modifying the Box\"</a></span>, and <span class=\"char_link\"><a href=\"GUID-308EA213-59FA-4F1B-AF40-FC7E658F5DD2.htm\">\"Applying Standard Transformations\"</a></span>. It requires the variable <span class=\"code\">mybox</span> to be already defined with an instance of a Box primitive. If you are <em class=\"strong\">not</em> continuing directly from these previous lessons, you must at least evaluate the line\n               \n               <div class=\"codeBlock\"><pre>mybox = box()</pre></div>to apply the following examples to the <em class=\"strong\">3ds Max</em> scene. \n            </div>\n         </div>\n         <p><a name=\"GUID-4F982F80-1035-4B74-A931-3D7582E3A8D8\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-7E1ACD15-9AE9-44C6-8090-2612696F2EA9\"></a>The following lines prepare our box for more complex transformations. They change\n            the number of box segments on all sides, and put a check mark into the Generate Mapping\n            Coords. box in the Parameters rollout: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FC2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FC3\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER THE FOLLOWING FOUR LINES OF CODE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507A\"></a><pre>mybox.lengthsegs = 10\nmybox.widthsegs = 10\nmybox.heightsegs = 10\nmybox.mapCoords = true</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCA\"></a>MAXScript has changed the appropriate settings in the Parameters rollout: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCB\"></a>&nbsp;<img src=\"../images/GUID-3F997663-F8AE-49B0-8738-6F1EF9DD14BE-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCC\"></a>Any time you change a property of a <em class=\"strong\">3ds Max</em> object, MAXScript immediately reflects the change in the scene and in the user interface.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCD\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E64E1B7B-57FC-4A00-8AAC-3E6D1D141F36-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCE\"></a>You can also create modifiers and add them to an object. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FCF\"></a> \n            <h2><a name=\"GUID-B6DE4413-0918-4348-BB86-1EA06998CA1F\"></a> <em class=\"strong\">Creating and Assigning Modifiers</em> \n            </h2> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD0\"></a> \n            <h2><a name=\"GUID-984C9952-E7D2-4B68-8857-B2E2B5D58695\"></a>Creating a Modifier\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD1\"></a>Creating a modifier is pretty simple. You use the <span class=\"code\">addModifier</span> command and specify the name of the modifier you want to use and its appropriate\n               parameters. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD2\"></a>To create a Twist modifier set to 30 degrees and apply it to your box, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD4\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5079\"></a><pre>addModifier mybox (twist angle:30)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FD9\"></a>&nbsp;<img src=\"../images/GUID-9CEA05A7-1098-442E-A7A6-FE862CB0BD91-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDA\"></a>The box in your Perspective viewport is now twisted and the interface shows the new\n               Twist modifier in the modifier stack display, together with its parameters: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDB\"></a>&nbsp;<img src=\"../images/GUID-8A833A77-FD4B-40F5-9991-02EDA62350A9-low.gif\"> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDC\"></a> \n            <h2><a name=\"GUID-674E8D55-779B-45C9-B28C-2926011CAE30\"></a>Changing a Modifier\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDD\"></a>Changing a modifier is similar to changing a creation parameter. Again, because you\n               used a variable name for your object, and you added a modifier to that object variable,\n               you now have easy access to the new modifier properties of your object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDE\"></a>To change the angle of the twist modifier to 60 degrees, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FDF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE0\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5078\"></a><pre>mybox.twist.angle = 60</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE5\"></a>&nbsp;<img src=\"../images/GUID-A8CF0897-0F2C-4EC7-A4FE-89CB97E61E16-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE6\"></a>The twist of your box is now more pronounced and the Angle parameter of the Twist\n               modifier displays the new value: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE7\"></a>&nbsp;<img src=\"../images/GUID-521BCD82-318E-4A55-A30C-28C9C97FCD36-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE8\"></a>Now, you can add and change other modifiers as you like. The syntax is the same for\n               all modifiers. To find out the names of other modifiers, search for the \"Modifier\n               : MAXWrapper\" topic in the MAXScript Reference. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FE9\"></a>If you entered the above commands, click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo twice to bring the box back to its original state. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FEA\"></a> \n            <h2><a name=\"GUID-1DB57994-FCA3-4D74-BDD8-746A0AADEDBC\"></a> <em class=\"strong\">Animating the Box</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FEB\"></a>MAXScript has several syntax forms that mirror the main UI tools such as, the Auto\n               Key button, the time slider, and the active coordinate system. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FEC\"></a>In the following example, you turn on the Auto Key button, set the slider to several\n               different values, and adjust the properties of your box, just as you would do using\n               the software’s UI: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FED\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FEE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5077\"></a><pre>\nanimate on\n(\n  at time 0 (mybox.pos = [-100, 0, 0]; mybox.scale = [1, 1, 0.25])\n  at time 100 (mybox.pos = [100, 0, 0]; mybox.scale = [1, 1, 3])\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FF7\"></a>Drag the slider around, and you will see that MAXScript has animated the box, and\n               placed keyframes at 0 and 100. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FF8\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A415CD53-3D19-438D-9AE9-681C81D21546-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FF9\"></a>When you use MAXScript to animate objects, the actual Auto Key button in the UI does\n               not come on, nor does the time slider move; these things happen within MAXScript.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FFA\"></a>In this example, the time was given as a simple number. If no unit is specified, MAXScript\n               interprets this as a frame number. You can also use one of the various time literals\n               in the following manner: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FFB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FFC\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5076\"></a><pre>\n2.5s-- 2.5 seconds\n20f-- 20 frames\n4800t-- 4800 ticks = 1 sec\n1m3s5f-- 1 min, 3 seconds, 5 frames\n1:15.5-- SMPTE: 1 min, 15 seconds, 5 frames\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7E22\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5007\"></a>All times are automatically converted to frames. \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5009\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC500A\"></a><p class=\"table-body\"> <em class=\"strong\">HISTORY:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC500B\"></a><p class=\"table-body\">In the early versions of<em class=\"strong\">3ds Max</em>, the User Interface featured a button called <em class=\"strong\">Animate</em>, which performed the same function as the current <em class=\"strong\">Auto Key</em> button. For this reason, the MAXScript context for creating animations is called\n                           <em class=\"strong\">Animate</em> and not Autokey. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC500D\"></a> <em class=\"strong\">Next Topic</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC500E\"></a> <span class=\"char_link\"><a href=\"GUID-28C01632-B984-483F-9233-FD7B62F093BE.htm\">The Script Editor</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";