var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2420F55C-E839-4F6A-9E89-6866D118A4A9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Optimizing Particle Flow Script Operator For Loops For Speed</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2420F55C-E839-4F6A-9E89-6866D118A4A9\"></a><div class=\"head\">\n            <h1>Optimizing Particle Flow Script Operator For Loops For Speed </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15FD\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15FF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1600\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Optimizing Particle Flow Script Operator For Loops For Speed \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1603\"></a> \n            <h2><a name=\"GUID-6BE41A5A-07F6-43BC-9176-7B369AB0564A\"></a> <em class=\"strong\">A user posted this code used inside an On Proceed() handler:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1605\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FD\"></a><pre>\nfor i in 1 to count do\n(\npCont.particleIndex = i\ncolmult = 80\npspeed = pCont.particlespeed\npvel = sqrt (pspeed.x*pspeed.x+pspeed.y*pspeed.y+pspeed.z*pspeed.z)\npCont.particleAge = pvel*colmult\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1612\"></a> \n            <h2><a name=\"GUID-6D78E800-4EE5-4B96-88A4-ECA7872303E1\"></a> <em class=\"strong\">Performance Comments:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1613\"></a>The line, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FC\"></a><pre>\npvel = sqrt (pspeed.x*pspeed.x+pspeed.y*pspeed.y+pspeed.z*pspeed.z)\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1615\"></a>is equivalent to, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FB\"></a><pre>\npvel = length pspeed\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1617\"></a>but is 4 times slower. When calculating inside a Particle Flow operator, you want\n               the fastest method because the code is called thousands and even millions of times,\n               once for each particle. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1619\"></a>The first code block evaluates in 3360 ms when run on a particular machine. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC161A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FA\"></a><pre>\n(\nst = timestamp()\npspeed = [10,2,3]\nfor i = 1 to 1000000 do\nsqrt (pspeed.x*pspeed.x+pspeed.y*pspeed.y+pspeed.z*pspeed.z)\nformat \"%\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1624\"></a>However, the same code using the length() method, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1625\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F9\"></a><pre>\n(\nst = timestamp()\npspeed = [10,2,3]\nfor i = 1 to 1000000 do\nlength pspeed\nformat \"%\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC162F\"></a>evaluates in just 813 ms on the same machine, which is 4.13 times faster. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1631\"></a>In addition, assigning to a temporary variable pvel adds 200 ms to 1 million calls\n               in both cases, so rewriting the original code block to \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1632\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F8\"></a><pre>\n(\nfor i = 1 to count do(\npCont.particleIndex = i\npCont.particleAge = length (pCont.particlespeed) * 80\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC163B\"></a>without any intermediate variables can shave off up to 600 ms per one million calls\n               on top of the speed up from using the length() method. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC163D\"></a>Here is another test to simulate this. It contains three variable assignments within\n               the loop and the original velocity calculation: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC163E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F7\"></a><pre>\n(\nst = timestamp()\nfor i = 1 to 1000000 do (\npspeed = [10,2,3]\ncolmult = 80\npvel = sqrt (pspeed.x*pspeed.x+pspeed.y*pspeed.y+pspeed.z*pspeed.z)\npvel * colmult\n)\nformat \"%\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC164B\"></a>The above code is very similar to what the original code was doing (minus actually\n               reading and writing particle values). It evaluates in 5750 ms. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC164D\"></a>In contrast, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC164E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F6\"></a><pre>\n(\nst = timestamp()\nfor i = 1 to 1000000 do (\npspeed = [10,2,3]\ncolmult = 80\npvel = length pspeed\npvel * colmult\n)\nformat \"%\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC165C\"></a>executes in 3200 ms just because we got rid of the three additions and three multiplications\n               within the MAXScript code. Length() does the same internally, but is implemented in\n               C++ and is thus much faster. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC165D\"></a>The inline version of the test code without any intermediate variables that calculates\n               the same value at the end needs only 1400 ms. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC165E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F5\"></a><pre>\n(\nst = timestamp()\nfor i = 1 to 1000000 do (\nlength [10,2,3] * 80\n)\nformat \"%\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1669\"></a>In short, avoid using local intermediate variables within your PFlow scripts and use\n               built-in methods to get the best performance as in: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC166A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F4\"></a><pre>\n(\nfor i = 1 to pCont,Numparticles() do (\npCont.particleIndex = i\npCont.particleAge = length (pCont.particlespeed) * 80\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1675\"></a> <em class=\"strong\">Previous Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1676\"></a> <span class=\"char_link\"><a href=\"GUID-F6D660D1-D0EE-41DB-804D-7404E513E2B6.htm\">For Loop Collect Vs For Loop Do Performance</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1678\"></a> <em class=\"strong\">Next Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1679\"></a> <span class=\"char_link\"><a href=\"GUID-8A616D27-6311-4A66-9C2D-43534D24511B.htm\">Using Bsearch For Fast Table Lookup</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";