var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-25211F97-E81A-4D49-AFB6-50B30894FBEB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"AnimHandle System\">\n      <meta name=\"indexterm\" content=\"getAnimByPointer\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AnimHandle System</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-25211F97-E81A-4D49-AFB6-50B30894FBEB\"></a><div class=\"head\">\n            <h1>AnimHandle System </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7122\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7121\"></a> The \n               		  <em class=\"strong\">AnimHandle system</em> defines a unique ID number for every entity in the scene, including nodes, modifiers,\n               materials, controllers, etc. When an entity is deleted from memory, its number will\n               never be reused by any entity created later, except in the case of the so-called \"wrap-around\"\n               - an unhealthy condition possible only when four billion entities (the 32-bit limit)\n               are created in a single \n               		  <em class=\"strong\">3ds Max</em> session. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-711F\"></a>Therefore you can determine whether an object is deleted by requesting the object\n               using its handle, and seeing if the result is undefined. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-711E\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2008</em> and higher. \n               		\n            </p> \n            <p><a name=\"P_9D2047C9B6B6408295E5D08E017FEBD4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-711D\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D18\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">GetHandleByAnim</em> &lt;object&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-711B\"></a>This method returns the unique AnimHandle ID for the given scene entity. \n               		\n            </p> \n            <p><a name=\"P_2750098C495D4EF6B30F1B70DFBD1419\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D17\"></a><pre>&lt;object&gt;<em class=\"codeEmphasisStrong\">GetAnimByHandle</em> &lt;integer&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7118\"></a>This method returns the scene entity corresponding to the unique AnimHandle ID, or\n               undefined if the entity has been deleted or has not been created yet. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;IntegerPtr&gt;<em class=\"codeEmphasisStrong\">getAnimPointer</em> &lt;maxwrapper&gt; </pre></div> \n            <p>This method returns a pointer to the wrapped refTarg as an IntegerPtr, or 0 if the\n               value is \n               		  <span class=\"code\">undefined</span>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;maxwrapper&gt;<em class=\"codeEmphasisStrong\">getAnimByPointer</em> &lt;IntegerPtr&gt;</pre></div> \n            <p> Returns the corresponding maxwrapper for the specified pointer address. This means:\n               \n               		  <span class=\"code\">(getAnimByPointer (getAnimPointer &lt;maxwrapper&gt;)) == maxwrapper</span>. This function is intended mainly for internal use and debugging. \n               		\n            </p> \n            <p>Available in \n               		  <em class=\"strong\">3ds Max 2018</em> and higher. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7116\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7115\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D16\"></a><pre>\nx = teapot() --create a teapot\nxHandle = GetHandleByAnim x --get the anim.handle\nx_verify = GetAnimByHandle xhandle --get by anim.handle\nx == x_verify --compare the two -returns true\ndelete x --delete the teapot\nclearUndoBuffer() --object deleted completely from memory\nx_verify = GetAnimByHandle xhandle --now returns undefined\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";