var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-258F6015-6B45-4A87-A7F5-BB091A2AE065\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Menu Manager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Menu Manager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-258F6015-6B45-4A87-A7F5-BB091A2AE065\"></a><div class=\"head\">\n            <h1>Menu Manager </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38AF\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38AE\"></a> MAXScript has full access to the menu manager and menu creation system. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7580\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Be very careful when using or testing this API. It makes permanent changes to the\n                  menu database, and it is very easy to mess things up quite badly. For example, if\n                  you \"unRegister\" the main menu bar, <em class=\"strong\">3ds Max</em> won\'t start. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A8\"></a>Anyone using this API should make a copy of the \"..\\UI\\MaxStartUI.mnu\" file before\n               running any of the scripts. If anything messes up, just copy the backup version back\n               on to MaxMenu.mnu. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A7\"></a>There are 4 exposed interfaces to MAXScript: the <span class=\"char_link\"><a href=\"GUID-1374EDCA-CC8B-4B43-81A5-6ED98DBE01D3.htm\">menu manager</a></span>, <span class=\"char_link\"><a href=\"GUID-CA86733B-05E1-4F7E-A589-FF20E75CE094.htm\">menu objects</a></span>, <span class=\"char_link\"><a href=\"GUID-1374EDCA-CC8B-4B43-81A5-6ED98DBE01D3.htm#WS73099CC142F487553098682E12AC2FC2BC7-585D\">quad menu objects</a></span> and <span class=\"char_link\"><a href=\"GUID-1374EDCA-CC8B-4B43-81A5-6ED98DBE01D3.htm\">menu items</a></span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A6\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A4\"></a>The menu manager is a database of menus and quad menus. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A2\"></a>The main menubar and all sub-menus are menu objects. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38A0\"></a>A quad menu object holds 4 menu objects, one for each quad. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-389E\"></a>A menu object is a container for menu items. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-389C\"></a>A menu item can be a separator, an action that invokes a macroScript or a sub-menu\n                     that pops up a cascading menu. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-389B\"></a> <em class=\"strong\">Menu Manager</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA7\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.loadMenuFile</em> \"file.mnu\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3899\"></a>This loads a new menu file with the given name. It looks in the current \"UI\" directory\n               for the file. It return true if successful, and false if not. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA6\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.saveMenuFile</em> \"file.mnu\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3896\"></a>This saves a new menu file with the given name. It saves it in the current \"UI\" directory.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA5\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getMenuFile</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3893\"></a>Returns the full path to the current menu file. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA4\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.updateMenuBar</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3890\"></a>This updates the main menu bar with any changes that have been made. This MUST be\n               called after changing anything on the main menu bar. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA3\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.registerMenuContext</em> contextId</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-388D\"></a>This call is used to register menu extensions. The \"contextId\" is a random 32-bit\n               integer. It can be generated using the <span class=\"char_link\"><a href=\"GUID-E59FCB9A-04C0-4228-9779-4FD74F2D35AD.htm\">\"genclassid()\"</a></span>. This function registers an extension with the menu manager that is remembered permanently.\n               It returns true the first time the extension is registered, and false every time thereafter.\n               This is saved in the MaxMenu.mnu file, so it is sticky from session to session. This\n               is used so that scripts can add items and sub-menus MAX\'s main menu bar and quad menus.\n               See the sample scripts below for the proper usage. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA2\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.findMenu</em> \"menuName\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-388A\"></a>This function returns the menu with the given name. It returns \"undefined\" if no menu\n               exists in the menu manager with the given name. This requires the full name of the\n               menu, including and \"&amp;\" characters that might be in the name. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3889\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3888\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA1\"></a><pre>\nhelpMenu = menuMan.findMenu \"&amp;Help\" -- Retrieve3ds Max’shelp menu.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DA0\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.findQuadMenu</em> \"quadMenuName\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3882\"></a>This method works like \"findMenu\" but it gets quad menus instead of menus. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9F\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.unRegisterMenu</em>menu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-387F\"></a>This method removes a menu from the menu manager. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-387E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-387D\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING! USE EXTREME CAUTION WHEN USING THIS METHOD!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-387C\"></a><p class=\"table-body\">If you unregister a menu that is used as a sub-menu, or in a quad menu, or the main\n                           menu bar, you will corrupt your <em class=\"strong\">3ds Max</em> installation. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9E\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.unRegisterQuadMenu</em>quadMenu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3879\"></a>This method works like \"unregisterMenu\" but for quad menus. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9D\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.createMenu</em> \"name\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3876\"></a>This method creates a new, empty menu with the given name. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9C\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.createQuadMenu</em> \"name\" \"quad1Name\" \"quad2Name\" \"quad3Name\" \"quad4Name\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3873\"></a>This method creates a new, empty quad menu. It contains, 4 empty menus, one for each\n               quad. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9B\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.createSubMenuItem</em> \"name\" subMenu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3870\"></a>This method creates a new sub-menu item that can be added to a menu. It uses the given\n               \"name\" and it displays the given sub-menu. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D9A\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.createSeparatorItem</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-386D\"></a>This method creates a new menu separator that can be added to a menu. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D99\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.createActionItem</em> \"macroScriptName\" \"macroScriptCategory\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-386A\"></a>This method creates a new menu item that can be added to a menu. The item is an action\n               that executes the macro script with the given name and category. This returns \"undefined\"\n               if there is no macroScript with the given name and category. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D98\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setViewportRightClickMenu</em> which quadMenu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3867\"></a>This method sets the viewport right click menu to be the given quad menu. The value\n               of \"which\" can be one of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D97\"></a><pre><em class=\"codeEmphasisStrong\">#nonePressed</em> <em class=\"codeEmphasisStrong\">#shiftPressed</em> <em class=\"codeEmphasisStrong\">#altPressed</em> <em class=\"codeEmphasisStrong\">#controlPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndControlPressed</em> <em class=\"codeEmphasisStrong\">#controlAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltAndControlPressed</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-385E\"></a>The following example sets the default (no keys pressed) quad menu the \"Modeling 2\".\n               The menu name must be a quad menu that is listed in the \"Quads\" customization dialog,\n               and the name must match exactly, including capitalization. <span class=\"code\"> <em class=\"strong\">menuMan.SetViewportRightClickMenu</em> </span> returns FALSE if you try to set the viewport right-click menu to a menu that is not\n               allowed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-385D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-385C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D96\"></a><pre>\nmenuMan.setViewportRightClickMenu #nonePressed \"Modeling 2\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D95\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getViewportRightClickMenu</em> which</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3856\"></a>Retrieves the quad menu used for right-clicking in the viewport. The \"which\" parameter\n               can be one of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D94\"></a><pre> <em class=\"codeEmphasisStrong\">#nonePressed</em> <em class=\"codeEmphasisStrong\">#shiftPressed</em> <em class=\"codeEmphasisStrong\">#altPressed</em> <em class=\"codeEmphasisStrong\">#controlPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndControlPressed</em> <em class=\"codeEmphasisStrong\">#controlAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltAndControlPressed</em> <em class=\"codeEmphasisStrong\">menuMan.getMainMenuBar</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-384C\"></a>Returns the menu being used as MAX\'s main menu bar. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D93\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setMainMenuBar</em> menu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3849\"></a>Sets the menu being used as MAX\'s main menu bar. You must call \"menuMan.updateMenuBar()\"\n               in order to see the result. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D92\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getShowAllQuads</em> quadMenu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3846\"></a>Gets the \"show all quads\" setting for the given quad menu. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D91\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setShowAllQuads</em> quadMenu value</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3843\"></a>This sets the \"show all quads\" flag for the given quad menu. \"value\" can be <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D90\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getQuadMenuName</em> quadMenu</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3840\"></a>This returns the name of the given quad menu. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8F\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setQuadMenuName</em> quadMenu \"name\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-383D\"></a>This sets the name of the give quad menu. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8E\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.numMenus</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-383A\"></a>Returns the total number of menus in registered with the menu manager. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8D\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getMenu</em> index</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3837\"></a>Retrieves the \"index\"th menu in the menu manager. This is a 1-based index. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8C\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.numQuadMenus</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3834\"></a>Returns the total number of quad menus registered with the menu manager. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8B\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.getQuadMenu</em> index</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3831\"></a>Retrieves the \"index\"th quad menu in the menu manager. This is a 1-based index. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3830\"></a> \n               <h3><a name=\"GUID-F7192565-EC84-4E93-9123-75698B7C578D\"></a> <em class=\"strong\">Quad Menu objects</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-382F\"></a>Quad menu objects have the following functions available: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D8A\"></a><pre><em class=\"codeEmphasisStrong\">quadMenu.getMenu</em> quadIndex</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-382D\"></a>Retrieves the menu object associated with the 4 quads of the menu. \"quadIndex\" can\n                  take the value 0, 1, 2, or 3. Quad 0 is the lower-right, and they are numbered counter-clockwise\n                  from there. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D89\"></a><pre>\nquadMenu.trackMenu showAllQuads\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-382A\"></a>This displays the quad menu. If \"showAllQuads\" is true, then all 4 quads are shows\n                  at once. It is displayed at the current cursor position. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3829\"></a> \n               <h3><a name=\"GUID-2D813FFF-1E7C-4FDF-BCFF-C24D62579AD4\"></a> <em class=\"strong\">Menu Objects</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3828\"></a>Menus are containers for menu items, and have the following functions: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D88\"></a><pre><em class=\"codeEmphasisStrong\">menu.setTitle</em> \"title\"</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3826\"></a>Sets the title of the menu to the give string. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D87\"></a><pre><em class=\"codeEmphasisStrong\">menu.getTitle</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3823\"></a>Returns the current title of the menu. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D86\"></a><pre><em class=\"codeEmphasisStrong\">menu.numItems</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3820\"></a>Returns the number of items the menu holds. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D85\"></a><pre><em class=\"codeEmphasisStrong\">menu.getItem</em> index</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-381D\"></a>Retrieves the menu item at the given index. \n               </p> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-757F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"GUID-144647C3-2A92-49E7-9758-B4F3C444CEE7\"></a>The index is 0-based. \n                     </p> \n                  </div>\n               </div> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D84\"></a><pre><em class=\"codeEmphasisStrong\">menu.addItem</em> menuItem position</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3817\"></a>This inserts an item in the menu at the given position, which is 0-based. If the position\n                  is -1, then the item is appended to the end of the menu. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D83\"></a><pre><em class=\"codeEmphasisStrong\">menu.removeItemByPosition</em> position</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3814\"></a>This removes the item at the given position. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D82\"></a><pre><em class=\"codeEmphasisStrong\">menu.removeItem</em> menuItem</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3811\"></a>This removes the given item from the menu, if it is in the menu. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3810\"></a> \n               <h3><a name=\"GUID-20CB4631-E290-428D-84D2-77BEEDF17627\"></a> <em class=\"strong\">Menu Item objects</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-380F\"></a>A menu item can be a separator, a sub-menu or an action that is connected to a macroScript.\n                  The following functions are available for menuItems: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D81\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.setTitle </em>\"title\"</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-380D\"></a>Sets the name associated with the item. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D80\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.getTitle</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-380A\"></a>Returns the name associated with the item. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7F\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.setUseCustomTitle</em> value</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3807\"></a>When value is true, this tells an item that is associated with a macroScript to use\n                  the item title when displaying the menu. Otherwise it will use the name of the macro\n                  or the \"buttontext\" of the macroScript. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7E\"></a><pre>\nmenuItem.getUseCustomTitle()\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3804\"></a>Returns the current value of the custom title flag. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7D\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.setDisplayFlat</em> value</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3801\"></a>This is for sub-menu items. When value is true, it tells the menu to display the sub-menu\n                  in-line, rather than as a cascading sub-menu. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7C\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.getDisplayFlat</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37FE\"></a>Returns the current value for the \"display flat\" flag. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7B\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.getIsSeparator</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37FB\"></a>Return true if the item is a separator, and false otherwise. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D7A\"></a><pre><em class=\"codeEmphasisStrong\">menuItem.getSubMenu</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37F8\"></a>If the item is a sub-menu item, this returns the menu associated with the sub-menu.\n                  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37F6\"></a>Included below is a script that shows how to use the menuMan interface to register\n                  menu extensions. This script should go in the \"stdplugs\\stdscripts\" folder. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37F5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37F4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D79\"></a><pre>\n-- Sample menu extension script\n-- If this script is placed in the \"stdplugs\\stdscripts\"\n-- folder, then this will add the new items to MAX\'s menu bar\n-- when MAX starts.\n-- A sample macroScript that we will attach to a menu item\nmacroScript MyTest\ncategory: \"Menu Test\"\ntooltip: \"Test Menu Item\"\n(\non execute do print \"Hello World!\"\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37E3\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37E2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D78\"></a><pre>\n-- This example adds a new entry to MAX\'s main \"Help\" menu.\n-- Register a menu context. This returns true the first time it\n-- is registered, and we can add things to the menu. If\n-- it returns false, then the context is already registered,\n-- and the items are already in the menu.\n-- The number 0x246c6dbe is random, and can be generated\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37D9\"></a><p class=\"table-body\">-- using the <span class=\"char_link\"><a href=\"GUID-E59FCB9A-04C0-4228-9779-4FD74F2D35AD.htm\">genClassID() function</a></span>. \n                           </p> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D77\"></a><pre>\nif menuMan.registerMenuContext 0x246c6dbe then\n(\n-- Get the main menu bar\nlocal mainMenuBar = menuMan.getMainMenuBar()\n-- The help menu is always the last menu.\nlocal helpMenuIndex = mainMenuBar.numItems()\n-- Get the menu item that holds the help menu\nlocal helpMenuItem = mainMenuBar.getItem(helpMenuIndex)\n-- Get the menu from the item\nlocal helpMenu = helpMenuItem.getSubMenu()\n-- create a menu separator item\nlocal sepItem = menuMan.createSeparatorItem()\n-- create a menu items that calls the sample macroScript\nlocal testItem = menuMan.createActionItem \"MyTest\" \"Menu Test\"\n-- Add the separator to the end of the help menu.\n-- the position of -1 means add it to the end.\nhelpMenu.addItem sepItem -1\n-- Add the action item to the end of the help menu.\nhelpMenu.addItem testItem -1\n-- redraw the menu bar with the new item\nmenuMan.updateMenuBar()\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37B3\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-37B2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D76\"></a><pre>\n-- This example adds a new sub-menu to MAX\'s main menu bar.\n-- It adds the menu just before the \"Help\" menu.\nif menuMan.registerMenuContext 0x1ee76d8e then\n(\n-- Get the main menu bar\nlocal mainMenuBar = menuMan.getMainMenuBar()\n-- Create a new menu\nlocal subMenu = menuMan.createMenu \"Test Menu\"\n-- create a menu item that calls the sample macroScript\nlocal testItem = menuMan.createActionItem \"MyTest\" \"Menu Test\"\n-- Add the item to the menu\nsubMenu.addItem testItem -1\n-- Create a new menu item with the menu as it\'s sub-menu\nlocal subMenuItem = menuMan.createSubMenuItem \"Test Menu\" subMenu\n-- compute the index of the next-to-last menu item in the main menu bar\nlocal subMenuIndex = mainMenuBar.numItems() - 1\n-- Add the sub-menu just at the second to last slot\nmainMenuBar.addItem subMenuItem subMenuIndex\n-- redraw the menu bar with the new item\nmenuMan.updateMenuBar()\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-378F\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-378E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D75\"></a><pre>\n-- This example adds a new command to MAX\'s default right-click quad menu\nif menuMan.registerMenuContext 0x36690115 then\n(\n-- Get the default viewport right-click quad menu\nlocal quadMenu = menuMan.getViewportRightClickMenu #nonePressed\n-- Get the lower-left menu from the quad\nlocal menu = quadMenu.getMenu 3\n-- create a menu item that calls the sample macroScript\nlocal testItem = menuMan.createActionItem \"MyTest\" \"Menu Test\"\n-- Add the item to the menu\nmenu.addItem testItem -1\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3779\"></a> <em class=\"strong\">Here are two macroScripts that set and reset two of the right-click menus:</em> \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3778\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D74\"></a><pre>\nmacroScript SetQuads\ncategory:\"Custom UI\"\ntooltip:\"Set Quad\"\n(\non execute do\n(\nquadmenu = menuMan.findQuadMenu \"Modeling 2\"\nif quadmenu != undefined do menuMan.setViewportRightClickMenu #nonePressed quadmenu\nquadmenu = menuMan.findQuadMenu \"Sample 4x1\"\nmenuMan.setViewportRightClickMenu #controlPressed quadmenu\n)\n)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D73\"></a><pre>\nmacroScript ResetQuads\ncategory:\"Custom UI\"\ntooltip:\"Reset Quads\"\n(\non execute do\n(\nquadmenu = menuMan.findQuadMenu \"Default Viewport Quad\"\nif quadmenu != undefined do menuMan.setViewportRightClickMenu #nonePressed quadmenu\nquadmenu = menuMan.findQuadMenu \"Modeling 1 [Cntrl+RMB]\"\nif quadmenu != undefined do menuMan.setViewportRightClickMenu #controlPressed quadmenu\n)\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3758\"></a> <span class=\"char_link\"><a href=\"GUID-C5835D80-FE88-459C-BD84-6C7817500627.htm\">Quad Menu</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3757\"></a> <span class=\"char_link\"><a href=\"GUID-F122718E-CC36-4CAB-8947-527F608FC184.htm\">Menu and CUI Loading</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3756\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">maxOps</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3755\"></a> <span class=\"char_link\"><a href=\"GUID-B3111CBF-BEB9-465C-A728-AE5CE611FCE3.htm\">Interface: quadMenuSettings</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3754\"></a> <span class=\"char_link\"><a href=\"GUID-1374EDCA-CC8B-4B43-81A5-6ED98DBE01D3.htm\">Interface: menuMan</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3753\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">Interface: maxOps</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";