var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-279879A8-9844-4C29-9EA8-43E5FF922692\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>For Loop By Index Vs For Loop Through Collection Performance</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-279879A8-9844-4C29-9EA8-43E5FF922692\"></a><div class=\"head\">\n            <h1>For Loop By Index Vs For Loop Through Collection Performance </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC153D\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC153F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1540\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt;For Loop By Index Vs. For Loop Through Collection \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1542\"></a> \n            <h2><a name=\"GUID-A3B52351-4DB9-46BC-B581-28ACAE89ED0F\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1544\"></a>What is the difference between using \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-660E\"></a><pre>for i = 1 to theArray.count do( ... )</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1546\"></a>and \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-660D\"></a><pre>for i in theArray do( ... )</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1549\"></a>Are they the same? Is one faster than the other ? Anything else to be aware of? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC154A\"></a> \n            <h2><a name=\"GUID-59ACB0EF-0C3F-4FFA-AB9E-0752F7008668\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC154B\"></a>Both can be used to do the same, but have different strengths and performance characteristics.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC154C\"></a>The first version gives you an index. So, if you want to drive a progress bar display,\n               or use the index to access another array with the same amount of elements, it is usually\n               the one to use - you can still get the i-th object, but you also have the number of\n               objects that you have processed so far for free. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC154D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC154E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-660C\"></a><pre>theArray = for i = 1 to 10  collect i\n(\nfor i = 1 to theArray.count do\n(\n  --assuming prg_bar is a progressbar UI control:\n  --prg_bar.value = 100.0*i/theArray.count\n  --some more code here...\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC155A\"></a>In the second case, you have to add your own counter local variable to keep track\n               of the current indexes: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC155B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC155C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-660B\"></a><pre>\n(\ncnt = 0\nfor i in theArray do\n(\n  cnt+=1\n  --prg_bar.value = 100.0*cnt/theArray.count\n  --some more code...\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1569\"></a>Also, the first form allows you to loop backwards, which is essential if you are removing\n               elements from the array while processing it. The following example creates an array\n               of 1000 random integers and then in the second for loop it deletes any elements with\n               a value less than 50: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC156A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC156B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-660A\"></a><pre>\n(\ntheArray =for i = 1 to 1000 collect random 1 100\nfor i = theArray.count to 1 by -1 where theArray[i] &lt; 50 do\n  deleteItem theArray i\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1574\"></a>When it comes to speed though, the direct loop through the array elements is faster.\n               Let us create an array of 10000 elements and loop through it 1000 times to get a significant\n               time value to measure. The inner loop itself does not perform any actual work, only\n               loops through the array and accesses the i-th element. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1575\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1576\"></a><p class=\"table-body\"> <em class=\"strong\">LOOP BY INDEX:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6609\"></a><pre>\n(\ntheArray = for i = 1 to 10000 collect random 1 100\nst = timestamp()\nfor j = 1 to 1000 do\n  for i = 1 to theArray.count do theArray[i]\nformat \"% ms\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1581\"></a>This code executes on a particular machine in 5.6 seconds (+/- 0.1 seconds). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1582\"></a>Removing the actual access to the array element by index (theArray[i]) reduces this\n               time to 4.6 seconds. For example, if you were running from 1 to the array count, but\n               not using the array elements for anything, which is highly improbable. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1584\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1585\"></a><p class=\"table-body\"> <em class=\"strong\">IN COMPARISON, LOOPING THROUGH THE COLLECTION</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6608\"></a><pre>\n(\ntheArray =for i = 1 to 10000 collect random 1 100\nst = timestamp()\nfor j = 1 to 1000 do\n  for i in theArray do i\n    format \"% ms\\n\" (timestamp()-st)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1590\"></a>This executes on the same machine in 4.3 seconds (+/- 0.1 sec.), which is 1.3 times\n               faster. Because the variable i already contains the n-th element, it does not matter\n               whether we actually use the array element value for anything or not. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1592\"></a>Now, if you do need the counter for something else like progress updates, the first\n               approach is almost four times faster than the second. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1594\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1595\"></a><p class=\"table-body\"> <em class=\"strong\">SLOW</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6607\"></a><pre>\n(\ntheArray =for i = 1 to 10000 collect random 1 100\nst = timestamp()\nfor j = 1 to 1000 do\n(\n  cnt = 0\n  for i in theArray do cnt +=1\n)\nformat \"% ms\\n\" (timestamp()-st) \n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15A2\"></a>The above code executes in 14.3 seconds on the same machine because of the memory\n               overhead involved in overwriting the value of the variable cnt 10 million times. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15A4\"></a>In other words, if the counter variable is significant for your code, you can use\n               the form <em class=\"strong\">for i = 1 to theArray.count do()</em>, otherwise use the direct loop through the collection as it is slightly faster in\n               the general case. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15A6\"></a> <em class=\"strong\">Previous Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15A7\"></a> <span class=\"char_link\"><a href=\"GUID-A117E4A6-4D54-4713-B04F-9FFA670B7EEE.htm\">Try not to use Execute function if there is an alternative</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";