var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Using MAXScript in Script Actions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using MAXScript in Script Actions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794\"></a><div class=\"head\">\n            <h1>Using MAXScript in Script Actions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8458D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84590\"></a>  <em class=\"strong\">Particle Flow provides the following Script Actions:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84591\"></a> <span class=\"char_link\"><a href=\"GUID-BF55A04D-AED5-4948-A837-8D3E2C7E82DE.htm\">Birth_Script : Helper</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84592\"></a> <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator : Helper</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84593\"></a> <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84594\"></a>These Actions can be used to give birth to particles, manipulate their properties,\n               and test properties against user-defined values. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84595\"></a> <em class=\"strong\">Handlers:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84596\"></a>All Script Actions implement four handlers to specify the channels used, perform initialization\n               tasks, proceed, and perform cleanup works. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84597\"></a>These handlers are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E1D\"></a><pre><em class=\"codeEmphasisStrong\">on ChannelsUsed</em> pCont <em class=\"codeEmphasisStrong\">do ...</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84599\"></a>Defines the channels to be made available to the script. The list of all possible\n               channels is available under <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8459A\"></a>The parameter passed to the handler contains the Particle Container the script is\n               applied to. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8459B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8459C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E1C\"></a><pre>\non ChannelsUsed pCont do\n(\npCont.useTime = true--enable the Time channel\npCont.useSpeed = true--enable the Speed channel\npCont.useInteger = true--enable the Integer channel\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-72AFFC71-6D01-4C15-8975-E9717CD17D5B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E1B\"></a><pre><em class=\"codeEmphasisStrong\">on Init</em> pCont <em class=\"codeEmphasisStrong\">do ...</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845A7\"></a>This hander is called when the Action is being initialized. It can be used to perform\n               preparation tasks like defining variables, creating (limited) additional geometry,\n               and so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845A8\"></a>For examples about implementing the Init handler, see <span class=\"char_link\"><a href=\"GUID-A968E741-4D24-4286-B3D0-1FDDE49B6ABE.htm\">Fragmentation Sample Script</a></span> and <span class=\"char_link\"><a href=\"GUID-AB7D2A56-0AEE-48FE-8D59-7862B88421FA.htm\">Metaball Sample Script</a></span>. \n            </p> \n            <p><a name=\"GUID-E455F0EE-FF42-4E47-BF0C-F75FA031AD5A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E1A\"></a><pre><em class=\"codeEmphasisStrong\">on Proceed</em> pCont <em class=\"codeEmphasisStrong\">do</em>... </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845AB\"></a>The Proceed handler is called whenever the Action is evaluated. The handler contains\n               the main script applied to the Particles. In this handler, each particle can be modified\n               by accessing its various properties. For a list of all properties and methods available\n               inside the <em class=\"strong\">on Proceed</em> handler, see <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845AC\"></a>The parameter pCont passed to the handler contains the Particle Container the script\n               is applied to. \n            </p> \n            <p><a name=\"GUID-60126E6E-F2F6-44C5-B703-F2498722E44C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E19\"></a><pre><em class=\"codeEmphasisStrong\">on Release</em> pCont <em class=\"codeEmphasisStrong\">do ...</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845AF\"></a>The Release handler is called when the Action is released. It can be used to do cleanup\n               work, but is typically empty. \n            </p> \n            <p><a name=\"GUID-87B800D9-9BEF-4515-87FC-BF84E6FB8115\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845B2\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845B3\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";