var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-282F32AC-5A80-4FDB-B8C0-275D2CC15845\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Windows Structure\">\n      <meta name=\"indexterm\" content=\"getMaxHWND() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"getDesktopHWND() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"sendMessage() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"postMessage() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"processPostedMessages() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"getChildrenHWND() - windows struct methods\">\n      <meta name=\"indexterm\" content=\"getChildHWND() - windows struct methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Windows Structure</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-282F32AC-5A80-4FDB-B8C0-275D2CC15845\"></a><div class=\"head\">\n            <h1>Windows Structure </h1>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F1D\"></a> The \n            		<em class=\"strong\">Windows struct</em> provides methods to access the Windows OS\' User Interface elements. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F1B\"></a>Unless noted otherwise, these methods are available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. \n            	 \n         </p>\n         <p><a name=\"GUID-AB53AFA2-1C2A-4226-A985-0DEF7840E5E1\"></a>They were previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span> . \n            	 \n         </p>\n         <p><a name=\"GUID-4641A568-07AB-41D7-80E4-72946671F940\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BE\"></a><pre><em class=\"codeEmphasisStrong\">windows.getMAXHWND()</em></pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EEE\"></a> This method returns the HWND of the main \n            		<em class=\"strong\">3ds Max</em> window as an integer (Pointer value). \n            	 \n         </p>\n         <p><a name=\"GUID-84030010-5C99-4996-B8CE-2B7E2B175318\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BD\"></a><pre><em class=\"codeEmphasisStrong\">windows.getDesktopHWND()</em></pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EEB\"></a> This method returns the HWND of the MS Window\'s desktop as an integer (Pointer value).\n            \n            	 \n         </p>\n         <p><a name=\"GUID-18E45D72-A2E5-4D87-8FB7-00B33F230DB4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.sendMessage</em> &lt;int HWND&gt; &lt;int message&gt; &lt;int messageParameter1&gt; &lt;int messageParameter2&gt;</pre></div>\n         <p><a name=\"GUID-CA9315ED-D662-466E-8497-8CBB8A9C5FC1\"></a>Sends a Win32 message to the HWND specified in the first argument. \n            	 \n         </p>\n         <p><a name=\"GUID-A405C15D-10B9-4778-8DEC-FC714E1B54AE\"></a>The second argument is the message ID, usually specified as hexadecimal number. \n            	 \n         </p>\n         <p><a name=\"GUID-5FEB6232-010B-4E33-B4F4-7020B189EF59\"></a>The third and fourth arguments are the message parameters. When no parameters are\n            expected, pass 0 as a placeholder. \n            	 \n         </p>\n         <p><a name=\"GUID-1B1134A9-2100-4D5B-93F5-7D3F8B28EEBD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.postMessage</em> &lt;int HWND&gt; &lt;int message&gt; &lt;int messageParameter1&gt; &lt;int messageParameter2&gt; </pre></div>\n         <p><a name=\"GUID-341AF19C-BDE7-48E4-9C4C-4ED77EEA4209\"></a> Calls the Window\'s PostMessage function passing the argument values. \n            	 \n         </p>\n         <p><a name=\"GUID-857CF7C9-4551-4F0A-99D0-9655547F429D\"></a>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-C4228B9B-2B33-4547-976A-C6E051343C75\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.processPostedMessages()</em></pre></div>\n         <p><a name=\"GUID-D924C434-FFAD-4259-96B6-9B8B0C39A4BF\"></a> Runs a message pump that retrieves any pending Window\'s messages and dispatches them\n            to \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-5DB94FD2-AF08-4FD0-8329-9B501DC081A8\"></a>Calling this method will process all pending messages. It can be used inside a MAXScript\n            loop which would otherwise cause a \"white screen\" in Windows 7 due to \n            		<em class=\"strong\">3ds Max</em> being unresponsive while performing long calculations. \n            	 \n         </p>\n         <p><a name=\"GUID-6EA06DEB-E36B-4FC2-B984-D9B4137F20F7\"></a>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-4F83AF7F-2EC1-4C51-9C46-37ED349DCB02\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C4\"></a><pre><em class=\"codeEmphasisStrong\">windows.getChildrenHWND</em> {&lt;int HWND&gt;|<em class=\"codeEmphasisStrong\">#max</em>} <em class=\"codeEmphasisStrong\">parent:</em>{&lt;int HWND&gt;| <em class=\"codeEmphasisStrong\">#max</em>}</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F19\"></a> This method returns an array of the children windows of the specified HWND, recursively.\n            \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F17\"></a>If the specified HWND is 0, only the top level desktop windows are returned (not recursively).\n            \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F16\"></a>If the parent HWND is specified, only windows whose immediate parent is the specified\n            window are returned. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F15\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">#max</em> </span> is specified as the HWND, the HWND associated with the \n            		<em class=\"strong\">3ds Max</em> main window is used. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F14\"></a>If the specified HWND does not exist, the value \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F13\"></a>Otherwise, an array is returned. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F12\"></a>Each element of the array corresponds to a window, and contains an 8 elements array\n            (originally, only the first 5 elements were returned in \n            		<em class=\"strong\">3ds Max 2008</em>) \n            	 \n         </p>\n         <p><a name=\"GUID-871346B6-952E-4124-BC6D-301D651055D4\"></a> <em class=\"strong\">The elements of these arrays represent the window\'s:</em> \n         </p>\n         <p><a name=\"GUID-F2BFBB44-5A9E-4395-9B34-3EEC37F6B296\"></a>1: HWND \n            	 \n         </p>\n         <p><a name=\"GUID-2378F414-7C3C-49E9-AF28-1A83295B62DA\"></a>2: the parent HWND. This does not include the owner (GetAncestor(hWnd,GA_PARENT))\n            \n            	 \n         </p>\n         <p><a name=\"GUID-945981E0-4706-4EDF-8541-999F2F034CAC\"></a>3: the parent or owner HWND. If the window is a child window, the return value is\n            a handle to the parent window. If the window is a top-level window, the return value\n            is a handle to the owner window. (GetParent(hWnd)) \n            	 \n         </p>\n         <p><a name=\"GUID-EFFA9432-3A37-43FA-9ADC-751BB8AC09E8\"></a>4: class name as a string (GetClassName(hWnd, className, bufSize)) - limit of 255\n            characters \n            	 \n         </p>\n         <p><a name=\"GUID-36A35037-F8B9-4FDF-B8C9-B291058BEE63\"></a>5: window text as a string (GetWindowText(hWnd, windowText, bufSize)) - limit of 255\n            characters \n            	 \n         </p>\n         <p><a name=\"GUID-3F61BD2B-42BA-48FE-815D-310C02FC02C3\"></a>6: the owner\'s HWND (GetWindow(hWnd,GW_OWNER)) \n            	 \n         </p>\n         <p><a name=\"GUID-1F1A7E68-B073-441C-A6AE-0440E179C643\"></a>7: root window HWND. The root window as determined by walking the chain of parent\n            windows (GetAncestor(hWnd,GA_ROOT)) \n            	 \n         </p>\n         <p><a name=\"GUID-21145D8A-0D29-44A4-9B5E-5EB37A3FE61D\"></a>8: owned root window HWND. The owned root window as determined by walking the chain\n            of parent and owner windows returned by GetParent (GetAncestor(hWnd,GA_ROOTOWNER))\n            \n            	 \n         </p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F0C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F0B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE, A PARTIAL RESULT FROM THE CALL</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C3\"></a><pre>\nprint (windows.getChildrenHWND #max)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F09\"></a><p class=\"table-body\">looks like \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C2\"></a><pre>\n...\n#(16990604P, 25827408P, 25827408P, \"#32770\", \"Main Toolbar\", 25827408P, 25827408P, 25827408P)\n#(2048768P, 16990604P, 16990604P, \"CustToolbar\", \"\", 0P, 25827408P, 25827408P)\n#(8794706P, 2048768P, 2048768P, \"CustSeparator\", \"\", 0P, 25827408P, 25827408P)\n#(33762226P, 2048768P, 2048768P, \"CustButton\", \"\", 0P, 25827408P, 25827408P)\n#(34615562P, 2048768P, 2048768P, \"CustButton\", \"\", 0P, 25827408P, 25827408P)\n#(999632P, 2048768P, 2048768P, \"CustButton\", \"\", 0P, 25827408P, 25827408P)\n#(5908980P, 2048768P, 2048768P, \"CustSeparator\", \"\", 0P, 25827408P, 25827408P)\n#(19083138P, 2048768P, 2048768P, \"ComboBox\", \"All\", 0P, 25827408P, 25827408P)\n...\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F07\"></a><p class=\"table-body\">In this case, the Main Toolbar of \n                        					 <em class=\"strong\">3ds Max</em> is a docked window which has a HWND of 16990604, the \n                        					 <em class=\"strong\">3ds Max</em> main window\'s HWND is 25827408, the class name of the Main Toolbar is \"#32770\" and\n                        the window text of the toolbar is \"Main Toolbar\". It is owned by and rooted at the\n                        \n                        					 <em class=\"strong\">3ds Max</em> window with HWND 25827408, which explains elements 6,7 and 8. \n                        				  \n                     </p> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F06\"></a><p class=\"table-body\">The next element is the toolbar window itself which has a HWND of 2048768 and is parented\n                        to the Main Toolbar window with HWND 16990604. The class of the toolbar is \"CustToolbar\"\n                        and it does not display any text. It is not owned by a window (so the HWND is 0),\n                        but it is rooted at the \n                        					 <em class=\"strong\">3ds Max</em> window with HWND 25827408. \n                        				  \n                     </p> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F05\"></a><p class=\"table-body\">The next element is the first separator in the toolbar. It has a HWND of 8794706 and\n                        is parented to the custom toolbar with HWND of 2048768. Its class is \"CustSeparator\"\n                        and has no text associated with it. It has no owner and is rooted at the 3ds Max window.\n                        \n                        				  \n                     </p> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F04\"></a><p class=\"table-body\">After that we get the first icon in the Main Toolbar with HWND 33762226. It is also\n                        parented to the custom toolbar with HWND of 2048768 and has the class \"CustButton\"\n                        and no text. It has no owner and is rooted at the 3ds Max window. \n                        				  \n                     </p> <a name=\"GUID-8C53FC76-D914-42F4-9A00-B2F8D0EB4C4D\"></a><p class=\"table-body\">After that come more buttons and separators. The one with HWND 19083138P is the Selection\n                        Filter ComboBox which displays \"All\" by default. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C1\"></a><pre><em class=\"codeEmphasisStrong\">windows.getChildHWND</em> {&lt;int HWND&gt;| <em class=\"codeEmphasisStrong\">#max</em>} &lt;string&gt; <em class=\"codeEmphasisStrong\">parent</em>:{&lt;int HWND&gt;|<em class=\"codeEmphasisStrong\">#max</em>}</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F02\"></a> The mehod returns the child window of the specified HWND with the given child window\'s\n            text. Child windows are recursively searched. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F00\"></a>If the specified HWND is 0, only the top level desktop windows are searched (not recursively).\n            \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFF\"></a>If the parent HWND is specified, only windows whose immediate parent is the specified\n            window are searched. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFE\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">#max</em> </span> is specified as the HWND, the HWND associated with \n            		<em class=\"strong\">3ds Max</em> main window is used. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFD\"></a>If the specified HWND does not exist, the value \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFC\"></a>If a child window with the specified text is not found, \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFB\"></a>The text comparison is \n            		<em class=\"strong\">case insensitive</em>. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EFA\"></a>If a match is found, an 8 element array is returned. See the documentation of the\n            \n            		<em class=\"strong\"> <span class=\"code\">windows.getChildrenHWND()</span> </em> method above for details on their meaning. \n            	 \n         </p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EF4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EF3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE, A PARTIAL RESULT FROM THE CALL</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C0\"></a><pre>\nmax file xref object -- open xref object dialog\nxro_hwnd = windows.getChildHWND 0 \"XRef Objects\" parent:#max -- find xref object dialog\nif xro_hwnd != undefined do windows.sendMessage xro_hwnd[1] 0x0010 0 0 -- if found, send close message\nmax file xref scene -- open xref sceen dialog\nxrs_hwnd = windows.getChildHWND 0 \"XRef Scenes\" parent:#max -- find xref scene dialog\nif xrs_hwnd != undefined do windows.sendMessage xrs_hwnd[1] 0x0010 0 0 -- if found, send close message\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EF1\"></a><p class=\"table-body\"> <em class=\"strong\">LISTENER OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BF\"></a><pre>\nOK\n#(25961156P, 65552P, 25827408P, \"#32770\", \"XRef Objects\", 25827408P, 25961156P, 25827408P)\n1\nOK\n#(26813124P, 65552P, 25827408P, \"#32770\", \"XRef Scenes\", 25827408P, 26813124P, 25827408P)\n1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-7A37CF93-9FAC-40A1-9838-6C3FCD3C8A3F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.getHWNDData</em> {&lt;int HWND&gt;|<em class=\"codeEmphasisStrong\">#max</em>}</pre></div>\n         <p><a name=\"GUID-23C2731E-C5FB-40B2-8D31-0CF86FDB83AE\"></a> Returns data associated with the specified HWND. \n            	 \n         </p>\n         <p><a name=\"GUID-45DCD91B-9211-4C5E-8A6E-3D83782E03ED\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">#max</em> </span> is specified as the HWND, the HWND associated with the \n            		<em class=\"strong\">3ds Max \n               		</em>main window is used. \n            	 \n         </p>\n         <p><a name=\"GUID-88CFD6F8-8575-4810-81D1-927367906239\"></a>If the specified HWND does not exist, the value undefined is returned. \n            	 \n         </p>\n         <p><a name=\"GUID-CE35CF5C-D874-4B9E-8687-3230FD68E452\"></a>If a match is found, a 8 element array is returned. See the documentation of the \n            		<em class=\"strong\"> <span class=\"code\">windows.getChildrenHWND()</span> </em> method above for details on their meaning. \n            	 \n         </p>\n         <p><a name=\"GUID-B5B4FFA6-A972-4B4A-8918-9F56159C15FC\"></a>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-8B21392B-ABB3-41B2-AD04-B287C88AB573\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-49B338BC-F30D-4C54-98DD-800746CFB561\"></a> Note that in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>, rollouts and rollout controls expose a read-only \n            		<span class=\"code\"> <em class=\"strong\">.hwnd</em> </span> property. \n            	 \n         </p>\n         <p><a name=\"GUID-CF8D41C2-61A8-47FD-BC25-6EA0E9B003A8\"></a>In the case of a rollout, the property contains the Window\'s HWND associated with\n            the rollout, or 0 if the rollout is not open. \n            	 \n         </p>\n         <p><a name=\"GUID-122F80E5-C424-40BA-807B-86AE8A343BBB\"></a>In the case of a rollout User Interface control, the property contains an array of\n            the Window\'s HWND of the rollout containing the rollout, or an empty array of the\n            rollout is not open. \n            	 \n         </p>\n         <p><a name=\"GUID-B09E5B84-8074-4888-B473-2B5F201FA19F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.setWindowPos</em> &lt;int HWND&gt; &lt;int x&gt; &lt;int y&gt; &lt;int width&gt; &lt;int height&gt; &lt;bool repaint&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p>]\n            	 \n         </p>\n         <p><a name=\"GUID-3137D8AB-A1E7-4DDC-BEA2-8F16B62C2E6C\"></a> Set the position of the window specified by the HWND to the X and Y coordinates specified\n            by the second and third arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-156DA160-EFF4-447E-8ED8-1A0B5AC7AE48\"></a>Also set the Width and Height of the window to the values passed as fourth and fifth\n            arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-12C45575-A3F4-4800-87BC-934A6F9D1B05\"></a>When the sixth argument is set to True, the window will also be repainted. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\"><em class=\"strong\">applyUIScaling</em></span> parameter indicates whether to apply scaling required on high DPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-8672E912-3F97-46F0-AE90-0CA90AF8F40C\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.setWindowPos</em> &lt;int HWND&gt; &lt;Box2 rect&gt; &lt;bool repaint&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p><a name=\"GUID-94658629-2A5F-47F3-BC9F-D1FC96BCBC93\"></a> Set the position of the window specified by the HWND to the coordinates and size\n            given by the second Box2 argument. \n            	 \n         </p>\n         <p><a name=\"GUID-0010DEF7-A58D-4739-97BA-0DAFB026FEEA\"></a>When the third argument is set to True, the window will also be repainted. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\">applyUIScaling</span> parameter, when set to true, applies any scaling required on HDPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-78BBBCBE-059F-49B3-83FE-095D4C12CCB8\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-F09BCE9F-67FF-4F55-BBE1-3DF9B7AC03CD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Box2 rect&gt;<em class=\"codeEmphasisStrong\">windows.getWindowPos</em> &lt;int HWND&gt; [ <em class=\"codeEmphasisStrong\">removeUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p><a name=\"GUID-861C7413-CA74-46C4-AF67-23B926E57867\"></a> Returns the position of the upper left corner and the width and height of the window\n            specified by the HWND argument. \n            	 \n         </p>\n         <p><a name=\"GUID-7EAD567C-D22B-4367-AFEA-C1BBD316BABA\"></a>The position is expressed in screen coordinates relative to the upper-left corner\n            of the screen. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\">removeUIScaling</span> parameter, when true, removes any scaling applied on HDPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-BA572B30-FFDF-411D-A816-E27C26AE2FFE\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p><a name=\"TABLE_9774FA3E8A154CBEA019C0BCC7A6403B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-EB172701-969E-4430-8067-2991CB3134AF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>rollout test1 \"Test\" ( button btn \"PRESS ME\" ) --a test rollout\ncreateDialog test1 200 50 120 140 --rollout, width, height, x, y\nwindows.getWindowPos test1.hwnd --get the resulting position and size\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-AAB722F3-B908-434A-8104-6F5C845390BC\"></a><p class=\"table-body\"> <em class=\"strong\">LISTENER OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nRollout:test1\ntrue\n(Box2 120 140 206 75)\n--Note that the width and height include the borders and the title bar \n--and can vary depending on the Windows Theme used.\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-21DBFB4B-17E6-4F22-805A-DC45742D33A2\"></a><p class=\"table-body\"> <em class=\"strong\">NOW LET\'S MOVE AND RESIZE IT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>windows.setWindowPos test1.hwnd 220 240 206 55 true</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-87C2E53F-AB20-41DD-B283-FA8A2CE944B9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">windows.clientToScreen</em> &lt;int HWND&gt; &lt;int x&gt; &lt;int y&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">windows.clientToScreen</em> &lt;int HWND&gt; &lt;Point2 clientCoord&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p><a name=\"GUID-D8A1A355-E248-43E7-9F9A-DF0792B4DCFA\"></a> Converts the coordinates from the Client space of the window specified by the first\n            argument to coordinates relative to the upper left corner of the Screen. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\">applyUIScaling</span> parameter, when set to true, applies any scaling required on HDPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-C6DDF48B-1F48-4E7D-BB81-246E40F87AD4\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-9AE0C83F-0723-45E2-855C-B2D238ACF3E6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">windows.screenToClient</em> &lt;int HWND&gt; &lt;int x&gt; &lt;int y&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">windows.screenToClient</em> &lt;int HWND&gt; &lt;Point2 screenCoord&gt; [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt;] </pre></div>\n         <p><a name=\"GUID-77A3CB40-5D71-4089-AB7F-E94D48B368A6\"></a>Converts the coordinates from Screen space relative to the upper left corner into\n            Client space of the window specified by the first argument. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\">applyUIScaling</span> parameter, when set to true, applies any scaling required on HDPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-C29947C3-5B63-4B57-9B44-436CAA691CAF\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-06E0E7B5-2C0C-441B-9E6F-063AD07190E0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"TABLE_9EF11123986649DD82AB1DEB862B5E06\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-7541AF52-377F-4941-97C9-B7C2221ECB16\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>tv = trackviews.getTrackView 1\n--&gt;&lt;MixinInterface:TrackView&gt;\n\nwindows.getWindowPos tv.ui.hwnd\n--&gt;(Box2 244 242 1200 400)\n\nscreenPos = windows.clientToScreen tv.ui.hwnd 10 20 \n--&gt;[262,312]\n\nwindows.screenToClient tv.ui.hwnd screenPos.x screenPos.y\n--&gt;[10,20]\n\nwindows.getWindowPos tv.ui.hwnd \n--&gt;(Box2 244 242 1200 400)\n\nwindows.setWindowPos tv.ui.hwnd 0 0 1200 400 \n--&gt;true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0A0921AB-EE52-4C89-8770-F31C9A58E9FA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.snapshot</em> {&lt;int_HWND&gt;|<em class=\"codeEmphasisStrong\">#max</em>} <em class=\"codeEmphasisStrong\">captureAlpha:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">gammaCorrect:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">captureScreenPixels:</em>&lt;bool&gt; </pre></div>\n         <p><a name=\"GUID-8BE582DE-7F8B-451C-8FCA-95FDBB333BA1\"></a>Creates a Bitmap snapshot of the specified HWND. \n            	 \n         </p>\n         <p><a name=\"GUID-CEAC3FF8-7D29-43A5-84F2-9374EFC6A96D\"></a>If the specified HWND is 0, a snapshot of the Windows Desktop will be taken. \n            	 \n         </p>\n         <p><a name=\"GUID-B548E0AD-4720-47DE-8DA4-BA71AF0ADE0D\"></a>If the argument is set to \n            		<span class=\"code\"> <em class=\"strong\">#max</em> </span>, the HWND associated with the 3ds Max main window will be used. \n            	 \n         </p>\n         <p><a name=\"GUID-D362A84F-416A-41D4-AE51-7E5ABAD3451A\"></a> If the \n            		<span class=\"code\"> <em class=\"strong\">captureAlpha:</em> </span> optional keyword argument is specified and set to True, the viewport Alpha will also\n            be captured. If not specified or set to False, the returned image will contain no\n            Alpha and only the RGB channels. \n            	 \n         </p>\n         <p><a name=\"GUID-6A1E5FA5-F369-49D7-B2A5-A6B7B2F10454\"></a>If the \n            		<span class=\"code\"> <em class=\"strong\">gammaCorrect:</em> </span> optional keyword argument is not specified or set to True, gamma correction will\n            be performed on the returned Bitmap value. If set to False, no gamma correction will\n            be performed. \n            	 \n         </p>\n         <p><a name=\"GUID-17296CDB-F09A-4DA2-AA8F-B71D18457B7B\"></a>If the \n            		<span class=\"code\"> <em class=\"strong\">captureScreenPixels:</em> </span> optional keyword argument is set to True, the window desktop pixels will be captured\n            within the region of the specified window. \n            	 \n         </p>\n         <p><a name=\"GUID-3767B219-1316-43EC-ACD7-F3976433F59C\"></a> Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p><a name=\"TABLE_B77D3DA8705044F9A6337F524B563B29\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-8A10E9D5-8FBA-4150-ACAA-672BCAC41211\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n--Get a snapshot of the Windows Desktop:\nssBitmap1 = windows.snapshot 0\ndisplay ssBitmap1 caption:\"Desktop Snapshot\"\n\n--Get a snapshot of the 3ds Max Main Window without gamma correction:\nssBitmap2 = windows.snapshot #max gammaCorrect:False\ndisplay ssBitmap2 caption:\"3ds Max Main Window\"\n\n--Get a snapshot of the active viewport:\nssBitmap3 = windows.snapshot (viewport.getHWnd()) \ndisplay ssBitmap3 caption:\"Active Viewport\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-28BF\"></a>See also \n            		<span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm#WS73099CC142F487553098682E12AC2FC2BC7-6BA8\">Viewport.GetViewportDib()</a></span> and \n            		<span class=\"char_link\"><a href=\"GUID-1B088FF0-6A36-420E-9F37-F0DBE9FB2676.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-57DD\">gw.getViewportDib()</a></span>. \n            	 \n         </p>\n         <p><a name=\"GUID-C4999DAE-C8A0-4129-9B63-2C2A311EAC2D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">windows.addChild</em> &lt;int_HWND&gt; &lt;int_HWND&gt;</pre></div>\n         <p><a name=\"GUID-675B85F9-802F-4C94-BAC9-8F7B8B07482E\"></a> Makes an ActiveX control whose HWND is passed as first argument the child of the\n            window with HWND passed as second argument. \n            	 \n         </p>\n         <p><a name=\"GUID-3D1809DE-5666-41B9-BC66-44055EC600CA\"></a>The first argument cannot be a MAXScript control or rollout, it must be an ActiveX\n            control. \n            	 \n         </p>\n         <p><a name=\"GUID-BD001A87-2AA5-4222-B1F8-4BD14F0F7E85\"></a>Given that ActiveX controls are considered obsolete since \n            		<em class=\"strong\">3ds Max 9</em>, this method can also be considered \n            		<em class=\"strong\">obsolete</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-9466421A-EE5C-45E4-8445-1055E4573B3A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE9\"></a> <span class=\"char_link\"><a href=\"GUID-D65AE3C0-0C12-4262-8807-B23CBED54508.htm\">Interaction With The Operating System</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE8\"></a> <span class=\"char_link\"><a href=\"GUID-E3BE9E3B-06F2-482F-8E2B-77EE9175B3D6.htm\">Sending Windows Message</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";