var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-28C01632-B984-483F-9233-FD7B62F093BE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"The Script Editor\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>The Script Editor</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-28C01632-B984-483F-9233-FD7B62F093BE\"></a><div class=\"head\">\n            <h1>The Script Editor </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5011\"></a> Now that you have explored the beginnings of <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">object creation</a></span> and <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">manipulation</a></span>, the next step is programming. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5013\"></a>MAXScript is a programming language at heart, and two of the most important concepts\n            necessary for mastering MAXScript are conditional statements and loops. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5015\"></a>At this point, real script writing comes into play. From the <em class=\"strong\">Main Menu &gt; MAXScript</em> menu item, select \"New Script\". A new MAXScript editor window will open. In this\n            window, you can create, edit, save, and load scripts. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5016\"></a>Another way to open a new script is the \"New Script\" button in the MAXScript Utility\n            in the Utilities tab. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5017\"></a>Other than the Listener, you can open many scripts as tabs inside the Editor and work\n            on multiple scripts at a time, copy and paste code between them etc. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5019\"></a>Thus far in this tutorial, you have been performing all of the script examples in\n            the MAXScript Listener, however when you are writing or editing a script of your own,\n            you will use the Script editor. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC501A\"></a>The main difference between the Script Editor and the Listener is that the Listener\n            can only evaluate one set of information at a time. In contrast, you can enter long,\n            complex scripts in the Script Editor and evaluate them piece-by-piece or all at once.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC501C\"></a>Scripts are entered using the same syntax and rules, however they are not executed\n            upon pressing ENTER. In order to execute the entire script, use \"Evaluate All\" from\n            the Tools Menu of the Script Editor, or press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">E</span></em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC501D\"></a>You can also execute scripts several lines at a time by highlighting the lines you\n            want to execute and pressing <em class=\"strong\"><span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">RETURN</span></em>, or <em class=\"strong\"> <span class=\"keyboardEntry\">ENTER</span> </em> on the numeric keypad. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC501F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5020\"></a><p class=\"table-body\"> <em class=\"strong\">IMPORTANT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5022\"></a><p class=\"table-body\">The rest of this page is for your information only and not a direct continuation of\n                        the tutorials from the previous chapter. Please do not attempt to use the tools described\n                        below yet, just note their existence. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5023\"></a><p class=\"table-body\">If you want to continue with the practical examples, please go to the next topic:\n                        <span class=\"char_link\"><a href=\"GUID-321A4B1F-11D8-41F4-B049-4C02E7567125.htm\">Controlling Program Flow in Scripts</a></span>. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5026\"></a> \n            <h2><a name=\"GUID-9811BCFC-D01C-4267-BB0A-B9090A6016EF\"></a> <em class=\"strong\">Navigating the Script Editor</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5027\"></a>The Script Editor contains several useful tools for navigating and error-checking\n               large scripts. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5028\"></a> \n               <h3><a name=\"GUID-8809542A-CE92-485C-B3A0-D3FE4B4B53FA\"></a> <em class=\"strong\">Tabs and Indentation</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5029\"></a>You can use the <em class=\"strong\"> <span class=\"keyboardEntry\">TAB</span> </em> key to control the indentation in your script. This makes it easier to read the script\n                  and to keep track of opening and closing parentheses used to create blocks of commands.\n                  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC502A\"></a>In contrast to some simpler text editors, selecting multiple lines and pressing <em class=\"strong\"> <span class=\"keyboardEntry\">TAB</span> </em> will not delete the lines but indent them as a block. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC502B\"></a>To move the selected line(s) back one tab position, you can press <em class=\"strong\"><span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">TAB</span></em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC502C\"></a>If you press the <em class=\"strong\"> <span class=\"keyboardEntry\">RETURN</span> </em> key to add a new line while inside an indented block in your script, the newly inserted\n                  line will respect the indentation and will also use the same number of tabs as the\n                  surrounding code lines. If you want the new line to be less indented, you can press\n                  the <em class=\"strong\"> <span class=\"keyboardEntry\">BACKSPACE</span> </em> key one or more times to remove one or more Tabs. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC502D\"></a>Optionally, you can also display the tabs and other \"white spaces\" by pressing <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">8</span></em> to make it easier to see and correct the formatting. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC502E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-85A7ACEC-17FD-4823-AE51-BE1A8613DAB7-low.gif\"></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5030\"></a> \n               <h3><a name=\"GUID-15DD6EB9-EFEB-4BF6-A7B5-E4EA1CA192FA\"></a> <em class=\"strong\">CTRL-Right Click Navigation</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5031\"></a>Pressing <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+Right Mouse Button</em> will open a right-click menu which allows you to jump to any specific event, UI item,\n                  function or rollout definition in the script. Selecting an entry from this menu will\n                  reposition the editor at the code line containing the definition of the selected item.\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5032\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-8B91DF62-E7C5-4CDC-AD9D-41679C9FB6A7-low.gif\"></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5033\"></a>For this feature to work, the Editor must contain at least one of the supported elements.\n                  Otherwise, no navigation menu will appear. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5034\"></a> \n               <h3><a name=\"GUID-C1706195-969D-4280-98AC-FD05A704C898\"></a> <em class=\"strong\">Bracket Balance</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5035\"></a>In complex scripts, it is common to lose track of blocks of commands, causing you\n                  to add extra parentheses or leave them out. You can find these errors by pressing\n                  <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">B</span></em>. MAXScript will highlight the block that your cursor is on, showing you the start\n                  and end parentheses. Pressing <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">B</span></em> will jump the cursor to the matching parenthesis. Also, the Editor will show by default\n                  guides connecting pairs of parentheses, making it easier to see the relationships.\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5036\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-C814249B-F415-410E-ACCF-C81D64105940-low.gif\"></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5037\"></a> \n               <h3><a name=\"GUID-8F21570A-E2D1-4C68-B244-A22F83B9A063\"></a> <em class=\"strong\">Color Coding</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5038\"></a>MAXScript will display different elements of your script in different colors, making\n                  it easier for you to navigate your script at a glance.Since<em class=\"strong\"> 3ds Max 2008</em>, the color coding is based on data exported from MAXScript directly into the listener,\n                  thus all kinds of keywords, functions, interfaces, object names and so on are recognized\n                  automatically and colored accordingly. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5039\"></a>The color coding is performed dynamically, but can be switched off by using <em class=\"strong\"><span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">F11</span></em> or the Language &gt; Text option from the menu. Select Language &gt; MAXScript to enable\n                  the color coding again. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC503A\"></a> <em class=\"strong\">See also</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC503B\"></a> <span class=\"char_link\"><a href=\"GUID-F561FC1E-CFF8-4FF6-874C-95EC4B9CD2CD.htm\">MAXScript Tabbed Editor Window</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC503C\"></a> <span class=\"char_link\"><a href=\"GUID-BB89D44C-96BB-4E3C-99F7-C66350AA45C0.htm\">MAXScript Editor Commands</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC503D\"></a> <em class=\"strong\">Next Topic</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC503E\"></a> <span class=\"char_link\"><a href=\"GUID-321A4B1F-11D8-41F4-B049-4C02E7567125.htm\">Controlling Program Flow in Scripts</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";