var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2921953D-F655-4663-B243-2E8DAFEED15F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"translate()\">\n      <meta name=\"indexterm\" content=\"scale()\">\n      <meta name=\"indexterm\" content=\"isEmpty()\">\n      <meta name=\"indexterm\" content=\"empty()\">\n      <meta name=\"indexterm\" content=\"contains()\">\n      <meta name=\"indexterm\" content=\"enlargeBy\">\n      <meta name=\"indexterm\" content=\"expandToInclude\">\n      <meta name=\"indexterm\" content=\"makeCube\">\n      <meta name=\"indexterm\" content=\"Intersects\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Box3 Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2921953D-F655-4663-B243-2E8DAFEED15F\"></a><div class=\"head\">\n            <h1>Box3 Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FEE\"></a>The Box3 class describes a 3D box volume described by two 3d corner coordinates. The\n            Box3 class provides methods that return individual coordinates of the box, scale and\n            translate it, retrieve its center, modify its size, expand it to include points or\n            other boxes, and determine if points are inside the box. \n            	 \n         </p>\n         <p><a name=\"P_AA9C198F12824EE693E36EF6CDE38EA2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FEF\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F09\"></a><pre><em class=\"codeEmphasisStrong\">Box3()</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF1\"></a>Creates a new, empty Box3 object.\n            	 \n         </p>\n         <p><a name=\"P_A22D2E36E3A04A6AB113FF736E31DD9C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F08\"></a><pre><em class=\"codeEmphasisStrong\">Box3</em> &lt;min_Point3&gt; &lt;max_Point3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF3\"></a>Creates a new Box3 object defined by the min and max Point3 corners. \n            	 \n         </p>\n         <p><a name=\"P_45ADE2EF71474DAC9BBE2DD2A0893947\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF4\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"section\"><a name=\"GUID-8EC5785B-F013-4A64-8890-3401FB2875BA\"></a>&lt;Box3&gt;.min: Point3\n         </div>\n         <p>The “minimum” corner of the Box3 value.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Box3&gt;.max: Point3</pre></div>\n         <p>The “maximum” corner of the Box3 value\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Box3&gt;.center: Point3 </pre></div>\n         <p>The center of the Box3 volume; read-only.\n            	 \n         </p>\n         <p><a name=\"P_9307D15FBC8546029A126432B29A897E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-8000\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F06\"></a><pre>&lt;Box3&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;Box3&gt;\n&lt;Box3&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;Box3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FFD\"></a>Standard comparison operators. Two Box3 values are equal if all of their component\n            values are equal. \n            	 \n         </p>\n         <p><a name=\"P_D7F57D2D93C64B3C9F7FD59C890F95B9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6907\"></a>      <em class=\"strong\">Methods</em> \n         </p>\n         <p><a name=\"P_DE588A1AA4744D3BAF0C1040D944A245\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">contains</em> &lt;Box3&gt; &lt;Point3&gt;</pre></div>\n         <p>Returns true if the Point3 value is within the bounds of the Box3 volume.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">empty</em> &lt;Box3&gt;</pre></div>\n         <p>Resets the Box3 value to an “empty” state with meaningless min and max values.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">enlargeBy</em> &lt;Box3&gt; &lt;float&gt;</pre></div>\n         <p>Enlarges the Box3. A Point3 is created from the float f as Point3(f,f,f) and added\n            to min and subtracted from max. If the box is \'empty\', the Box3 is centered at (0,0,0)\n            and then enlarged.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">expandToInclude</em> &lt;Box3&gt; &lt;Point3&gt;</pre></div>\n         <p>Enlarges the Box3 to include the specified Point3.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">makeCube</em> &lt;Point3&gt; &lt;float&gt;</pre></div>\n         <p>Modifies the Box3 such that its center is located at the specified &lt;Point3&gt; with equal\n            sides with the specified &lt;float&gt; length.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Intersects</em> &lt;Box3&gt; &lt;Box3&gt;</pre></div>\n         <p>Returns true if the two Box3 values intersect.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">isEmpty</em> &lt;Box3&gt;</pre></div>\n         <p>Returns true if the specified Box3 value is empty.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Scale</em> &lt;Box3&gt; &lt;float&gt;</pre></div>\n         <p>Scales the Box3 value about its center by the specified value.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Translate</em> &lt;Box3&gt; &lt;float&gt;</pre></div>\n         <p>Translates the Box3 value by the specified distance. The point is added to each corner.\n            	 \n         </p>\n         <p><a name=\"P_9ADD9388277F4DA28826FF67FC642E4D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p> <span class=\"char_link\"><a href=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525.htm\">Box2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE3\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE2\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE1\"></a> <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE0\"></a> <span class=\"char_link\"><a href=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D.htm\">Ray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";