var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-296A15F5-AE95-4D2A-9775-D8B730AF2A23\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"polymorphism\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>polymorphism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-296A15F5-AE95-4D2A-9775-D8B730AF2A23\"></a><div class=\"head\">\n            <h1>polymorphism </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E9B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E9C\"></a> As in mathematical expressions, MAXScript operators are <em class=\"mild\">polymorphic</em>. This term means a single operator can be used to operate on a number of different\n               types of values and performs the appropriate action for each type of value.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E9E\"></a>For example, a <span class=\"code\"> <em class=\"strong\">\"+\"</em> </span> operator between two integers performs integer arithmetic, between two floats it\n               performs real arithmetic, and between two matrices it performs a matrix addition.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E9F\"></a>MAXScript allows certain non-mathematical types to use certain math operators.You\n               can concatenate two strings with the <span class=\"code\"> <em class=\"strong\">\"+\"</em> </span> operator,\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EA0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EA1\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6122\"></a><pre>\n\"twas brillig\" + \" and the slithy tobes\"\nx.name += sequence_number as string\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EA7\"></a>In some cases, you can mix operand types and MAXScript converts them appropriately.\n               For example, adding a float to an integer results in a float. Multiplying a 3D point\n               by a float results in a scalar vector product, and so on.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EA8\"></a>Internally in MAXScript the allowable operators and the actions performed by the operators\n               are defined for each type of value. The allowable operators and their actions are\n               documented with the value type descriptions.\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EAA\"></a> <span class=\"char_link\"><a href=\"GUID-CA82121D-8CA7-4739-A5E4-545534EF6C75.htm\">Inheritance and Polymorphism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";