var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2A321518-2745-417A-8599-19EDE58CD6A7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I change the text in a Text Shape dynamically?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2A321518-2745-417A-8599-19EDE58CD6A7\"></a><div class=\"head\">\n            <h1>How do I change the text in a Text Shape dynamically? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD79\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD7B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD7C\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8C7\">Accessing Object Properties</a></span> &gt; How do I change the text in a Text Shape dynamically? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD7E\"></a>Normally, the text of a <span class=\"char_link\"><a href=\"GUID-6CB41D09-0586-43DF-821A-93EBEE01DD9D.htm\">Text</a></span> shape is not animatable. The resulting mesh will be evaluated once at the beginning\n            of the rendering and will not change as it is considered static (not changing over\n            time). A workaround is to assign a script controller to a property of the text shape\n            which will do two things: tell the renderer that the text shape is animated and thus\n            requires reevaluation on each frame, and set the actual text in the text property.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD7F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD80\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING!</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD81\"></a><p class=\"table-body\">Changing the text object\'s text property in anything other than a controller applied\n                        to the text object can lead to a renderer crash! \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD83\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD84\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-665B\"></a><pre>\n--Create a box and a text shape\nb=box name: \"ControlBox\" wirecolor:blue\nt=text name: \"ControlledText\" wirecolor:red\nt.baseobject.renderable=true --set the shape to renderable\ntheCtrl = float_script() --create a float script controller\ntheCtrl.addNode \"TheText\" t --add a variable, connect to theText node\ntheCtrl.addNode \"TheBox\" b --add a variable, connect to the Box node\n--Set the expression to assign the height of the box as string to the\n--.text property of the text shape, then return 0 on the next line:\ntheCtrl.SetExpression \"TheText.text = TheBox.height as string\\n0\"\nt.kerning.controller=theCtrl --assign the controller to the kerning\nanimate on at time 100 b.height*=2 --animate the height of the box\nmax tool zoomextents all --zoom into the two objects\nplayAnimation() --play back the animation\n&nbsp;\n--You should be able to render the scene without any problems\n--and the text will show the height of the box in generic units.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD9A\"></a> <span class=\"char_link\"><a href=\"GUID-6CB41D09-0586-43DF-821A-93EBEE01DD9D.htm\">Text : Shape</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD9B\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";