var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2ABB9CAE-B990-48D0-AB37-C742EEE82E9D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"block expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Block-Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2ABB9CAE-B990-48D0-AB37-C742EEE82E9D\"></a><div class=\"head\">\n            <h1>Block-Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F9C\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F9D\"></a>  Block-expressions are the basic constructors for structured code. They allow you to\n               group a sequence of expressions and evaluate them in sequence as though they were\n               a single expression. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FA0\"></a>The syntax for <span class=\"code\">&lt;block_expr&gt;</span> is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6102\"></a><pre><em class=\"codeEmphasisStrong\">(</em> &lt;expr&gt; { (<em class=\"codeEmphasisStrong\">;</em> | &lt;eol&gt;) &lt;expr&gt; } <em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FA2\"></a>It is a parenthesized sequence of expressions with each <span class=\"code\">&lt;expr&gt;</span> separated by either a line break or a <em class=\"strong\">\"; \"</em> semicolon. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FA3\"></a>MAXScript also allows empty block-expressions, <span class=\"code\"> <em class=\"strong\">()</em> </span>. This is useful when incrementally building code to place an empty expression in\n               a path to be filled in later. When evaluated, empty expressions yield the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FA5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FA6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6101\"></a><pre>\nx = 2\ny = 3\nz = 4\np = [10,10,10]\ncentre = [20,20,20]\n(\nd = centre.x^2 - (p.x^2 + p.y^2)\nnewz =if d &gt; 0 then sqrt d else p.z\nprint newz\n)\nif x &lt; y then (print x; print y; u += 10; print u)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FB0\"></a>You can use a mixture of line breaks or semicolons: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FB1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FB2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6100\"></a><pre>\n(\nprint x; print y\np.x += 10\nprint p.x; print p.y\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FBB\"></a>Because a block-expression is an <span class=\"code\">&lt;operand&gt;</span> , you can insert a block-expression anywhere you can put an <span class=\"code\">&lt;operand&gt;</span>. This is <em class=\"strong\">unlike most languages</em> that limit where you can put blocks of code to only a few places. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FBC\"></a>Further, because all constructs are expressions in MAXScript, a block-expression yields\n               a value defined to be the last <span class=\"code\">&lt;expr&gt;</span> in the block. This allows you to use a nested sequence of expressions to compute\n               an operand for some operation: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FBD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FBE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FF\"></a><pre>\nb = box()\nb.pos.z =\n(\nd = x^2 - y^2\nif d &gt; 0 then sqrt d else z\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FC6\"></a><p class=\"table-body\">Here, the result of the block-expression is the result of the final <span class=\"code\"> <em class=\"strong\">if</em> </span> expression, which is then assigned to <span class=\"code\"> <em class=\"strong\">b.pos.z</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FC8\"></a>Because the item in parentheses can be <span class=\"code\"><em class=\"strong\">any</em>&lt;expr&gt;</span>, you can turn any construct in MAXScript into an operand by putting it in parentheses.\n               This allows you to write the following example, in which the operand to be indexed\n               is the conditional result of an <span class=\"code\"> <em class=\"strong\">if</em> </span> expression: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FC9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FE\"></a><pre>\n(if a &gt; b then c else d)[n + 1]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FCE\"></a>As described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>, top-level open parentheses in a script file or in the Listener create a new variable\n               scope. Any block-expressions with the top-level block-expression do not create a new\n               variable scope, even if the variable is explicitly declared as local in the inner\n               block-expression. A variable’s scope extends into any block-expressions within the\n               variable’s scope. If you declare a variable as local in a scope, the newly declared\n               local variable hides any outer variables with the same name. Any reference to that\n               variable name later in the local variable\'s scope refers to the new local variable.\n               At the end of the local variable\'s scope, the next outer variable becomes visible\n               again. This is shown in the following script: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FCF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FD0\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FD\"></a><pre>\na=1\n(\nlocal a=2\n(\nlocal a=3\n)\nprint a\n)\na\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FDC\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FC\"></a><pre>\n1 -- result of line 1\n3 -- output of line 7\n3 -- result of block-expression lines 2 to 8\n1 -- result of line 9\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FE4\"></a>Any variable names used in a block-expression which have not been created at a higher\n               scope level are implicitly declared as local in the present scope. This can result\n               in unexpected execution results for scripts that are not set up correctly. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FE5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FE6\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE, CONSIDER THE FOLLOWING SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FB\"></a><pre>\n(b=bend();addmodifier Objs b) -- create bend modifier and apply to objects\nb.angle=10\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FEB\"></a><p class=\"table-body\">The first time you execute this script, the following<em class=\"strong\"> error message</em> is generated: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60FA\"></a><pre>\n-- Unknown property: \"angle\" in undefined\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FEF\"></a><p class=\"table-body\">If you execute the script again, it works properly. The reason is there are actually\n                           two variables with the name <span class=\"code\"> <em class=\"strong\">b</em> </span> - one is local to the block-expression and contains the bend modifier value, and\n                           the other is global and has the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. During the second execution, global <span class=\"code\"> <em class=\"strong\">b</em> </span> exists, so the block-expression does not implicitly declare a new variable <span class=\"code\"> <em class=\"strong\">b</em> </span>, rather it uses the global variable <span class=\"code\"> <em class=\"strong\">b</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FF1\"></a>When writing scripts, it is also a good programming practice to explicitly declare\n               as local all variables unless you really want them to be global variables. There are\n               several reasons for this practice: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FF2\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FF4\"></a>All the variable names used in the block or function will be together, which makes\n                     it easier to find the variable names and helps prevent using incorrect names in the\n                     script. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FF6\"></a>If more than one script is executing at the same time (for example, you are running\n                     a scripted utility and have a scripted controller in the scene) and both scripts use\n                     the same global variable name, the two scripts can interfere with one another. This\n                     can cause apparently random failures of one or both scripts. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FF8\"></a>You are sure you are using the correct variable in the event that a variable with\n                     the same name has already been declared at a higher scope, and you will not inadvertently\n                     change the higher-level variable\'s value. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FFA\"></a>Values of variables explicitly defined as local are displayed in error call stack\n                     trace-backs. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86FFC\"></a>In <em class=\"strong\">3ds Max</em> R2.5, if a <em class=\"strong\">3ds Max</em> class, a MAXScript method, or a MAXScript read-only global variable has the same\n                     name as an implicitly declared local variable, a MAXScript runtime error will be generated\n                     if an assignment to that variable name occurs. Since the variable name already existed\n                     with a global scope, an implicitly declared local variable was not created. Since\n                     one or more new <em class=\"strong\">3ds Max</em> classes will be created by any third party plug-ins the user has loaded, you were\n                     not be able to tell ahead of time if a variable name was a global variable name. In\n                     <em class=\"strong\">3ds Max 4 and higher</em>, if the MAXScript compiler detects that the first reference to such a variable is\n                     an assignment, it will implicitly declare a local variable, rather than leaving it\n                     as a reference to a read-only system global. \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FFD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FFE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86FFF\"></a><p class=\"table-body\">executing the following expression in <em class=\"strong\">3ds Max R2.5</em> would result in a value of <span class=\"code\"> <em class=\"strong\">Box</em> </span>, since <span class=\"code\"> <em class=\"strong\">Box</em> </span> is a <em class=\"strong\">3ds Max</em> object class. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87000\"></a><p class=\"table-body\">In <em class=\"strong\">3ds Max 4 and higher</em>, MAXScript detects that the first use of variable <span class=\"code\">box</span> is an assignment and creates an implicitly declared local variable <span class=\"code\"> <em class=\"strong\">box</em> </span>. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87001\"></a><p class=\"table-body\">The result of this expression in <em class=\"strong\">3ds Max 4 and higher</em> is the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F9\"></a><pre>\n(if false do box=10;box)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";