var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2AD4D018-52CE-4199-9BEB-D9935A7118EF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"dotNetMXSValue\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dotnetmxsvalue</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2AD4D018-52CE-4199-9BEB-D9935A7118EF\"></a><div class=\"head\">\n            <h1>dotnetmxsvalue </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10BD\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10B9\"></a>The \n               		  <em class=\"strong\">dotNetMXSValue value class</em> holds another value. The dotNetMXSValue can be assigned to .net objects. A \"proxy\"DotNet\n               value is actually stored to theDotNet object, and that proxy points back to the dotNetMXSValue. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10B8\"></a>As long as the DotNet object holds the proxy value, the dotNetMXSValue and the value\n               it holds are protected from garbage collection. \n               		\n            </p> \n            <p>The value held by a dotNetMXSValue object can be read from its read-only \n               		  <span class=\"code\">.value</span> property. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10B7\"></a>Available in \n               		  <em class=\"strong\">3ds Max 9</em> and higher. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10B6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10B5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B8\"></a><pre>\na = color 10 20 30 --MAXScript color value\nb = dotNetMXSValue a --DotNet value holding the MAXScript value\ntv = dotnetobject \"treeview\" --DotNet TreeView control\ntv.tag = b --The tag is set to the color\ntv.tag\na=b=undefined --Both a and b are set to undefined\ngc() --and manual garbage collection is requested\n--BUT the color value and dotNetMXSValue protected are from\n--collection because the treeview instance holds\n--the dotNetMXSValue proxy!\ntv = undefined --assign undefined to the treeview variable\ngc() --and request garbage collection again\n--This time both the color value and the dotNetMXSValue are not\n--protected from collection\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-10A0\"></a>Note that the above garbage collection may not delete the color value and the dotNetMXSValue\n               because the DotNet garbage collector has not deleted the treeview and freed its values\n               yet. One can force manual garbage collection of DotNet: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-109F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-109E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B7\"></a><pre>\ndgc = dotnetclass \"system.gc\"\ndgc.collect()\ngc() -- color value and dotNetMXSValue collected\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1096\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";