var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2B6FF55D-52A2-44D7-98E1-592DD5AA5FAB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Proceed With Integrate Script_Test Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Proceed With Integrate Script_Test Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2B6FF55D-52A2-44D7-98E1-592DD5AA5FAB\"></a><div class=\"head\">\n            <h1>Proceed With Integrate Script_Test Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C9F\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA0\"></a>The following example shows the usage of the Integrator interface in a Script_Test\n            action. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA1\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA2\"></a>Should be used inside a <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> action. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-52279FFE-03E3-438B-975B-3D23325703A0-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA4\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA5\"></a>Shows the necessity of using the Integrator. Without the Integrator particles are\n            stopped <em class=\"mild\">somewhere</em> around the zero Z plane. The Integrator is able to stop particles exactly at the\n            plane level (without any modification of the particle position). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA6\"></a>In the example flow, the particles are born and accelerated. The Script_Test checks\n            their position and if they pass the scripted test, they are moved to the second event\n            which stops them. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84CA9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E06\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true --enable the Time channel\npCont.usePosition = true --enable the Position channel\npCont.useSpeed = true --enable the Speed channel\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n \n)\n \non Proceed pCont do\n(\n--Get the End Time\nend = pCont.GetTimeEnd() as float\n--Get the interface to the Integrator\n_int = pCont.GetIntegrator()\n--Get the current particle count\ncount = pCont.NumParticles()\n--Get the particle container\npCont_curr = pCont.GetParticleContainer()\n--Initialize Arrays\ntimeToStopInt = #()\ntimeToStopFloat = #()\nparticlesToStop = #{}\n--Initialize a flag to signal when\n--there are particles to send to the integrator\nhasParticlesToIntegrate = false\n \n--Go through all particles\nfor i in 1 to count do\n(\n--Set the current particle index\npCont.particleIndex = i\n--Calculate the remaining time to travel\ntimeForTravel = end - (pCont.particleTimeasfloat)\n-- format \"time to travel % = %\\n\" i timeforTravel\n--Get the current position and speed of the particle\ncurPos = pCont.particlePosition\ncurSpeed = pCont.particleSpeed\n \n--Calculate the time to the XY plane. Because of the minus sign,\n--when the Z coordinate is negative, the time will be positive\ntimeToPlane = -curPos.z / curSpeed.z\n-- format \"time to plane % = %\\n\" i timeToPlane\n \n--Initialize a flag\nstopThisParticle = 0\n--Get the particle time in frames\ncurParticleTime = pCont.particleTime as time\n \n--If the time to plane is positive or zero and shorter\n--than the time to travel, then the particle has passed\n--the plane already and has to be stopped!\nif((timeToPlane &gt;= 0.0)and(timeToPlane &lt;= timeForTravel))do\n(\n--Set the Test status to true\npCont.particleTestStatus = true\n--Set the precise particle time\npCont.setParticleTestTimePrecise i pCont.particleTime timeToPlane\n--Append the particle index to the BitArray of particles\n--to be stopped\nappend particlesToStop i\n--Raise the flag to signal there is work for the integrator\nhasParticlesToIntegrate = true\n)\n \n--Append the particle time frame and fraction to the two arrays \nappend timeToStopInt curParticleTime\nappend timeToStopFloat timeToPlane\n)\n \n--If the flag has been set \nif hasParticlesToIntegrate then\n(\n--If the integrator can be accessed, send the particles to stop\n--to the Integrator\nif _int != undefined then\n_int.proceedASync pCont_curr timeToStopInt timeToStopFloat true particlesToStop\n)\n-- format \"time to stop Int= %\\n\" timeToStopInt\n-- format \"time to stop Float= %\\n\" timeToStopFloat\n-- format \"part to stop Index= %\\n\" particlesToStop\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D13\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D14\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";