var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2C2819EA-8997-45DF-8ED6-A81FE3E154A4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"IVFB Interface\">\n      <meta name=\"indexterm\" content=\"Interface IVFB\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: IVFB</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2C2819EA-8997-45DF-8ED6-A81FE3E154A4\"></a><div class=\"head\">\n            <h1>Interface: IVFB </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9FD\"></a> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9FC\"></a>  The<em class=\"strong\"> IVFB Interface </em>is returned as notification parameter result by the two <span class=\"char_link\"><a href=\"\">Rendered Frame Window and Image Viewer-related callbacks</a></span>. \n            </p> \n            <p><a name=\"P_EEB65092DA854C57AA75D99CDCEC24BA\"></a>It can be used to customize the appearance and register user-defined scripted rollouts\n               in the top left, top right and bottom panels of the dialog. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F9\"></a>Available in<em class=\"strong\"> 3ds Max 2009 and higher</em>. \n            </p> \n            <p><a name=\"P_45B8F45A637548F69FDEB951D7E822B0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F8\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F5\"></a><pre>&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">ShowOverlays</em> : boolean : Read|Write 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F7\"></a>Get/set the display of the render region box in the Rendered Frame Window. Corresponds\n               to the \"Toggle UI Overlays\" button in the Rendered Frame Window main toolbar. \n            </p> \n            <p><a name=\"P_71B042551FEA4CD6BD088A5C12C20458\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F4\"></a><pre>&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">ShowRollups</em> : boolean : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F5\"></a>This property is true when the rollout panels are displayed in the Rendered Frame\n               Window. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F4\"></a>If no rollout panels have been installed, this may still return true, because it\'s\n               only a global toggle used to optionally hide the rollouts. &nbsp;Setting this property\n               will show/hide the rollout panels, and the UI is immediately updated. \n            </p> \n            <p><a name=\"P_D806D3C468E0400098FED5CFB482BED9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F3\"></a><pre>&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">IsFramebuffer</em> : boolean : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F2\"></a>This property contains true if the window is a Rendered Frame Window. \n            </p> \n            <p><a name=\"P_49594F8C9948443183CD117EF821FD59\"></a>It is false for Image Viewer windows (as from File&gt;View Image File). \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9F1\"></a>This allows a script to install render controls on only the Rendered Frame Window.\n               \n            </p> \n            <p><a name=\"P_DB6FBAB14B7C4D1A8F69D864D7124083\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F2\"></a><pre>&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">IsVisible</em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9EF\"></a>Get/set the visible state of the Image Viewer. \n            </p> \n            <p><a name=\"P_FAD08149DC35472299F24AA2E0E3A6AE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F1\"></a><pre>&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">IsInitialized </em>: boolean : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9ED\"></a>Contains true if the Image Viewer has been initialized already by calling the<span class=\"code\"> <em class=\"strong\"> .InitLayout()</em> </span> method documented further on this page. \n            </p> \n            <p><a name=\"P_B9418585DC7E40F7A7569A7E3DDCF6FF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9EC\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52F0\"></a><pre>&lt;value&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">InitRolloutWindow </em>&lt;enum&gt;which &lt;integer&gt;width &lt;integer&gt;height \n\nwhich enums:<em class=\"codeEmphasisStrong\"> {#TopLeft | #TopRight | #Bottom}</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9EB\"></a>Returns a RolloutFloater value, allowing rollouts to be added to it. \n            </p> \n            <p><a name=\"P_9A8E615D75494F3A9E751619144C94D0\"></a>It represents a single panel, not the entire floating window. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9EA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E9\"></a>MAXScript can now <span class=\"char_link\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-7EB1\">create rollouts in borderless mode</a></span> by calling<span class=\"code\"> <em class=\"strong\"> AddRollout</em> </span> with the optional keyword argument<span class=\"code\"> <em class=\"strong\"> border:</em> </span> set to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n                  </p> \n                  <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E8\"></a>Such rollouts do not have a title bar nor border around them and merge seamlessly\n                     with the rest of the panel. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"P_237FBB14225D456FA58100725AB48AEA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52EE\"></a><pre>&lt;boolean&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">GetRolloutWindowVisible </em>&lt;enum&gt;which \n\nwhich enums: <em class=\"codeEmphasisStrong\">{#TopLeft | #TopRight | #Bottom}</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E6\"></a>Returns the visibility of the specified rollout panel. \n            </p> \n            <p><a name=\"P_0CA5D6C8EC214190A77F32243E6F21C9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52EC\"></a><pre>&lt;void&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">SetRolloutWindowVisible </em>&lt;enum&gt;which &lt;boolean&gt;show \n\nwhich enums:<em class=\"codeEmphasisStrong\"> {#TopLeft | #TopRight | #Bottom}</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E4\"></a>Sets the visibility of the specified rollout panel. \n            </p> \n            <p><a name=\"P_23120B05FBA24D8F8C6E8762BA7DE68D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52EA\"></a><pre>&lt;void&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">SetMetric</em> &lt;enum&gt;metricID &lt;integer&gt;value \n\nmetric ID enums:<em class=\"codeEmphasisStrong\"> {#HorzMarginLeft | #HorzMarginCenter | #HorzMarginRight | #VertMarginTop | #VertMarginCenter | #VertMarginBottom | #MinClientWidth | #MinClientHeight}</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E2\"></a>Sets the spacing between the panels in the framebuffer. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E1\"></a>The first parameters can be one of the following: \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9E0\"></a> <span class=\"code\"> <em class=\"strong\">#horzMarginLeft </em> </span>- Space in pixels between the left edge of the window and the left rollout panel.\n               \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DF\"></a> <span class=\"code\"> <em class=\"strong\">#horzMarginCenter </em> </span>- Horizontal space in pixels between the two rollout panels. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DE\"></a> <span class=\"code\"> <em class=\"strong\">#horzMarginRight </em> </span>- Space in pixels between the right edge of the window and the right rollout panel.\n               \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DD\"></a> <span class=\"code\"> <em class=\"strong\">#vertMarginTop</em> </span> - Space in pixels between the top of the window and the top of the rollout panels.\n               \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DC\"></a> <span class=\"code\"> <em class=\"strong\">#vertMarginCenter</em> </span> - Vertical space in pixels between the rollout panels and the bitmap view. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DB\"></a> <span class=\"code\"> <em class=\"strong\">#vertMarginBottom </em> </span>- Vertical space in pixels between the bottom rollout panel and the bitmap view. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9DA\"></a> <span class=\"code\"> <em class=\"strong\">#minClientWidth</em> </span> - Minimum sizable width of the window in pixels. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D9\"></a> <span class=\"code\"> <em class=\"strong\">#minClientHeight</em> </span> - Minimum sizable height of the window in pixels. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D7\"></a>Despite the values of<span class=\"code\"> <em class=\"strong\"> #minCleintWidth</em> </span> and<span class=\"code\"> <em class=\"strong\"> #minClientHeight</em> </span>, the window can never be resized down to become smaller than the combined width of\n                     the top two rollouts. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"P_93EB07B249424E09A1EDFC59D53BA2AA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52E8\"></a><pre>&lt;integer&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">GetMetric </em>&lt;enum&gt;metricID \n\nmetricID enums:<em class=\"codeEmphasisStrong\">{#HorzMarginLeft | #HorzMarginCenter | #HorzMarginRight | #VertMarginTop | #VertMarginCenter | #VertMarginBottom | #MinClientWidth | #MinClientHeight}</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D4\"></a>Returns the spacing settings for the specified parameter of the current layout. \n            </p> \n            <p><a name=\"P_65EFB31698F041988D025CE33E95AC06\"></a>See above for details. \n            </p> \n            <p><a name=\"P_F35F8D1553C94647AEFCF73B3FEF3059\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-52E6\"></a><pre>&lt;void&gt;&lt;IVFB&gt;.<em class=\"codeEmphasisStrong\">InitLayout</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D2\"></a>Calling this method causes the current layout set up using the properties and methods\n               above to be initialized. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-9D0\"></a> <span class=\"char_link\"><a href=\"GUID-6171A574-2BEE-4259-8D34-2B31E324020B.htm\">Rendered Frame Window and MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";