var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2D04C2F5-0C6F-4FAC-987D-34D0A319654C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface actionMan\">\n      <meta name=\"indexterm\" content=\"ActiveShadeFragmentManager Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: ActiveShadeFragmentManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2D04C2F5-0C6F-4FAC-987D-34D0A319654C\"></a><div class=\"head\">\n            <h1>Interface: ActiveShadeFragmentManager</h1>\n         </div>\n         <p>  </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EA5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EA4\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; ActiveShadeFragmentManager \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-37C71495-C364-4DEB-ACD4-BCC3F4B47BD2\"></a> The \n            		<em class=\"strong\">ActiveShadeFragmentManager Interface</em> provides MAXScript access to the viewport ActiveShade mode, where a viewport can\n            display using the ActiveShade renderer but maintain interactive capabilities. Available\n            in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-66943EB6-8DC7-4865-8B0D-4C30256A9050\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-386A16F5-758A-4E0F-9437-04AFFDD0A6E5\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <p>None \n            	 \n         </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ToggleInActiveViewport</em>()</pre></div>\n         <p>Toggles the ActiveShade viewport mode. Returns true if the mode was toggled on or\n            off, and false if something went wrong and the mode was not toggled. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SetRenderRegionInActiveViewport</em> &lt;float&gt;<em class=\"codeEmphasisStrong\">left</em> &lt;float&gt;<em class=\"codeEmphasisStrong\">top</em> &lt;float&gt;<em class=\"codeEmphasisStrong\">right</em> &lt;float&gt;<em class=\"codeEmphasisStrong\">bottom</em></pre></div>\n         <p>Sets the region to render in the active viewport. The \n            		<em class=\"strong\">left</em>, \n            		<em class=\"strong\">top</em>, \n            		<em class=\"strong\">right</em>, and \n            		<em class=\"strong\">bottom</em> parameters are floats in the range of 0.0 to 1.0, and specify 2D coordinates to set\n            as the ActiveShade render region where (0.0, 0.0) is the top left corner, and (1.0,\n            1,0) is the bottom right. The rest of the viewport will be rendered with the default\n            viewport renderer (typically Nitrous). For example, passing \n            		<span class=\"code\">0.0 0.0 0.5 0.5</span> will cause the top left quarter of the viewport to render with ActiveShade. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">RemoveActiveShadeFragmentFromAllViewports</em>()</pre></div>\n         <p>Turns ActiveShade mode off for all viewports. \n            	 \n         </p>\n         <p>Currently, only one viewport at a time can run in ActiveShade render mode, but this\n            might change in the future. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;int by value array&gt;<em class=\"codeEmphasisStrong\">GetRunningActiveShadeViewportsIndices</em>()\n       <em class=\"codeEmphasisStrong\">GetRunningActiveShadeViewportsIndices</em> - no automatic redraw after invoked</pre></div>\n         <p> Returns an array of two integers indicating which viewport is running in ActiveShade\n            render mode. The first integer is the index of the view panel, and the second is the\n            index of the viewport in the panel running in ActiveShade render mode. Note that these\n            indices are 0-based. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IsRunningInActiveViewport</em>()\n       <em class=\"codeEmphasisStrong\">IsRunningInActiveViewport</em> - no automatic redraw after invoked</pre></div>\n         <p>Returns true if the currently active viewport is running in ActiveShade mode. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IsRunningInViewport</em> &lt;integer&gt;<em class=\"codeEmphasisStrong\">ZeroBasedViewPanelIndex</em> &lt;integer&gt;<em class=\"codeEmphasisStrong\">ZeroBasedViewportIndex</em>\n       IsRunningInViewport - no automatic redraw after invoked</pre></div>\n         <p>Returns true if the viewport specified by view panel index and viewport index is running\n            in ActiveShade render mode. Note that these indices are 0-based. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IsRunningInAtLeastOneViewport</em>()\n       <em class=\"codeEmphasisStrong\">IsRunningInAtLeastOneViewport</em> - no automatic redraw after invoked</pre></div>\n         <p>Returns true if at least one viewport is running in ActiveShade mode. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">CurrentActiveShadeRendererSupportsConcurrentRendering</em>()\n       <em class=\"codeEmphasisStrong\">CurrentActiveShadeRendererSupportsConcurrentRendering</em> - no automatic redraw after invoked</pre></div>\n         <p>Returns true if the currently selected ActiveShade renderer supports concurrent rendering\n            (rendering multiple scenes at once). \n            	 \n         </p>\n         <p> </p><a name=\"TABLE_D5229DFB57DB423482848C9451F5E4FB\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">For Example \n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>global asfm = ActiveShadeFragmentManager\n\nvp_indices = asfm.GetRunningActiveShadeViewportsIndices()\nformat \"This should be 0: %\" vp_indices.count\n-- check that there is no ActiveShade\nisASFMRunning()\n-- now toggle\nasfm.ToggleInActiveViewport()\n-- should be running in the active viewport\nisASFMRunning()\n-- set the active render region to the top left quarter of the viewport\nasfm.SetRenderRegionInActiveViewport 0.0 0.0 0.5 0.5\n-- now turn off again\nasfm.RemoveActiveShadeFragmentFromAllViewports()\n\n\n function isASFMRunning =  (	\n	format \"Is running in active viewport? %\\n\" (asfm.IsRunningInActiveViewport())\n	format \"Is running in any viewport? %\\n\" (asfm.IsRunningInAtLeastOneViewport())\n	format \"Lets check each viewport\"\n	panel_index = ViewPanelManager.GetActiveViewPanelIndex()\n	-- note that the panel index and viewport index are 0-based, so we must subtract 1 for MXS interop\n	for i = 0 to viewport.numViews-1 do (\n	 format \"Running in viewport index %? %\\n\" i (asfm.IsRunningInViewport (panel_index-1) i)\n	)\n	 \n )\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> <em class=\"strong\">Actions:</em> \n         </p>\n         <p>None \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";