var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2D8606DF-EF5D-4F5B-A00C-B10D29A14947\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>File Notifications</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2D8606DF-EF5D-4F5B-A00C-B10D29A14947\"></a><div class=\"head\">\n            <h1>File Notifications</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68EE\"></a><pre><em class=\"codeEmphasisStrong\">#filePreOpen:(integer | undefined)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17F2\"></a>Sent before a new file is opened. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17F1\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an integer value of 2 if a render preset file is being opened, undefined\n            otherwise. \n            	 \n         </p>\n         <p><a name=\"P_56C90732217444029DDD3E30C30D9F43\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68ED\"></a><pre><em class=\"codeEmphasisStrong\">#filePostOpen: (integer |undefined)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17EE\"></a>Sent after a new file is opened successfully. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17ED\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an integer value of 2 if a render preset file is being opened, undefined\n            otherwise. \n            	 \n         </p>\n         <p><a name=\"P_8F8060A6948E4A5589406006498C073D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68EC\"></a><pre><em class=\"codeEmphasisStrong\">#filePreOpenProcess: #(integer, string)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17EA\"></a>Sent before the file open process starts. This event is sent immediately after \n            		<span class=\"code\">#filePreOpen</span>, and it sends additional information not sent by \n            		<span class=\"code\">#filePreOpen</span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17E9\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an array with two elements: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17E8\"></a>The first element is 1 if doing a normal file load, 2 if doing an \n            		<em class=\"strong\">Edit&gt;Fetch</em> . \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17E5\"></a>The second element is the scene file name being loaded. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17E4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17E3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68EB\"></a><pre>\ncallbacks.removeScripts id:#testCallback\ncallbacks.addScript #filePreOpenProcess \"print (callbacks.notificationParam())\" id:#testCallback\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17DE\"></a><p class=\"table-body\"> <em class=\"strong\">PERFORM A FETCH - THE CALLBACK WILL PRINT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68EA\"></a><pre>\n2\n\"C:\\Documents and Settings\\user\\My Documents\\3dsmax\\autoback\\maxhold.mx\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_FE86B4D19D654A8983D1A2FC5B66983A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">#fileOpenFailed: integer</em> </pre></div>\n         <p>Sent after a file open fails. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an integer indicating the file type, where 0 is a 3ds Max file, and 1 is\n            a material library. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E9\"></a><pre><em class=\"codeEmphasisStrong\">#filePostOpenProcess: #(integer, string)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17D7\"></a>Sent after the file open process has finished. This callback is sent immediately after\n            \n            		<span class=\"code\">#filePostOpen</span>, and it sends additional information not sent by \n            		<span class=\"code\">#filePostOpen</span>. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns a 2 element array: \n            	 \n         </p><a name=\"UL_C7C702AC82AB4788B82D6BB4AA022234\"></a><ul>\n            <li>The first element is an integer that indicates the type of file open, where 1 indicates\n               a normal scene file load, and 2 indicates an \n               		  <em class=\"strong\">Edit&gt;Fetch</em> operation. \n               		\n            </li>\n            <li>The second element is a string containing the opened filename. \n               		\n            </li>\n         </ul>\n         <p><a name=\"P_77507AEDFFC54BB8B695BE0DE456EFE7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">#filePostOpenProcessFinalized: undefined</em> </pre></div>\n         <p> Sent after #filePostOpenProcess is sent and all animatables created by the load process\n            but no longer used are deleted. Available in \n            		<em class=\"strong\">3ds Max 2018</em> and higher. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E8\"></a><pre><em class=\"codeEmphasisStrong\">#filePreSave: string</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17D5\"></a>Sent before a file is saved. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17D4\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns a String containing the file name. \n            	 \n         </p>\n         <p><a name=\"P_914642E5F28E4DAAA9A6E3A5D85D7C76\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E7\"></a><pre><em class=\"codeEmphasisStrong\">#filePostSave: string</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17D1\"></a>Sent after a file is saved. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17D0\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns a String containing the file name. \n            	 \n         </p>\n         <p><a name=\"P_F8E2D56AEF664CDA870B3C2EE513A587\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E6\"></a><pre><em class=\"codeEmphasisStrong\">#filePreSaveProcess: #(integer, string)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17CD\"></a>Sent before the save process has started. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17CC\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns a 2 element array: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17CB\"></a>Element 1 is \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17CA\"></a>1 if doing a normal file save, \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C9\"></a>2 if doing an Edit&gt;Hold \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C8\"></a>3 if doing an Autobackup \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C7\"></a>Element 2 is the scene file name being saved. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17C3\"></a><p class=\"table-body\">Evaluate the following code: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E5\"></a><pre>\ncallbacks.removeScripts id:#testCallback\ncallbacks.addScript #filePreSaveProcess \"print (callbacks.notificationParam())\" id:#testCallback\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17BE\"></a><p class=\"table-body\">Save the file to \"TestingCallback.max\" - the callback will print: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E4\"></a><pre>\n1\n\"C:\\Documents and Settings\\user\\My Documents\\3dsmax\\scenes\\testingcallback.max\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17B9\"></a><p class=\"table-body\">Perform an Edit&gt;Fetch at this point - the callback will print: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E3\"></a><pre>\n2\n\"C:\\Documents and Settings\\user\\My Documents\\3dsmax\\autoback\\maxhold.mx\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17B4\"></a><p class=\"table-body\">Wait fro the Autobackup to kick in - the callback will print: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E2\"></a><pre>\n3\n\"C:\\Documents and Settings\\user\\My Documents\\3dsmax\\autoback\\AutoBackup01.max\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_75E9D45925BC4168891E4A4445ACE0F7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E1\"></a><pre><em class=\"codeEmphasisStrong\">#filePostSaveProcess: #(integer, string)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17AC\"></a>Sent after the save process has finished. \n            	 \n         </p>\n         <p><a name=\"GUID-92C0AC5C-2D14-48E6-93A8-DF1D67D4B3A2\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns the same 2-element array as \n            		<span class=\"code\"> <em class=\"strong\">#filePreSaveProcess</em> </span> - please see above for details. \n            	 \n         </p>\n         <p><a name=\"P_725AD48CBB9144718A9B4575CEA72012\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68E0\"></a><pre><em class=\"codeEmphasisStrong\">#filePreSaveOld: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17A9\"></a>Sent before an old version file is saved. \n            	 \n         </p>\n         <p><a name=\"P_CD749977D1024F86A2849554596DA7C6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DF\"></a><pre><em class=\"codeEmphasisStrong\">#filePostSaveOld: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17A6\"></a>Sent after an old version file is saved. \n            	 \n         </p>\n         <p><a name=\"P_3176BEA5434B42619EEAD07E58B73D47\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DE\"></a><pre><em class=\"codeEmphasisStrong\">#filePreMerge: integer</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17A3\"></a>Sent before a file is merged. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-17A2\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an integer value of 1 if object or scene Xref merged, undefined otherwise.\n            \n            	 \n         </p>\n         <p><a name=\"P_FCD214AA0545403488D4E073ED8FB508\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DD\"></a><pre><em class=\"codeEmphasisStrong\">#filePostMerge: integer</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-179F\"></a>Sent after a file is merged successfully. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-179E\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an integer value of 1 if object or scene Xref merged, undefined otherwise.\n            \n            	 \n         </p>\n         <p><a name=\"P_81ED415089854F1BBC4CA3533F76A84B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">#filePostMerge2: #(integer, integer)</em> </pre></div>\n         <p>Sent after a file is merged successfully, right after \n            		<em class=\"strong\">#filePostMerge</em>. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an array with two elements, with the first element being the file save version,\n            and the second element the file save as version. \n            	 \n         </p>\n         <p>For example, if loading a file saved from 3ds Max 2017, where a Save As Type was set\n            to 3ds Max 2016, the values would be 19000 (MAX_RELEASE_R19) and 18000 (MAX_RELEASE_R189).\n            See the \n            		<span class=\"filePath\">plugapi.h</span> file in the 3ds Max SDK for possible values. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">#filePostMerge3: #(string, boolean, integer, integer, boolean)</em> </pre></div>\n         <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020.1 Update:</em> Sent after a file is merged successfully, right after \n            		<em class=\"strong\">#filePostMerge2</em>. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> returns an array with five elements: \n            	 \n         </p><a name=\"OL_6FC47D3647FC49B6A240E3CF055CD880\"></a><ol type=\"1\" start=\"1\">\n            <li>The full path of the file being merged or XRefed \n               		\n            </li>\n            <li>A boolean indicating whether the merge was successful (true) or failed (false) \n               		\n            </li>\n            <li>An integer indicating file save version. See the \n               		  <span class=\"filePath\">plugapi.h</span> file in the 3ds Max SDK for possible values. \n               		\n            </li>\n            <li>An integer indicating file save as version. See the \n               		  <span class=\"filePath\">plugapi.h</span> file in the 3ds Max SDK for possible values. \n               		\n            </li>\n            <li>A boolean indicating whether the operation was an XRef (true) or merge (false) \n               		\n            </li>\n         </ol>\n         <div><a name=\"GUID-CC3804AF-65FF-4BA5-9484-4989C33742AE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This callback notification contains all the information from \n               		<span class=\"code\">#filePostMerge</span> and \n               		<span class=\"code\">#filePostMerge2</span>, as well as additional information, and should be used as a replacement for those\n               notifications. \n               	 \n            </div>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DC\"></a><pre><em class=\"codeEmphasisStrong\">#filePostMergeProcess: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-179B\"></a>Sent after the merge process has finished. \n            	 \n         </p>\n         <p><a name=\"P_1FA4E5CAAC5548A598F3260B60417A7C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">#filePostMergeProcessFinalized: undefined</em> </pre></div>\n         <p>occurs after #filePostMerge2 is sent and all animatables created by merge process\n            but no longer used are deleted. Available in \n            		<em class=\"strong\">3ds Max 2018</em> and higher. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DB\"></a><pre><em class=\"codeEmphasisStrong\">#preImport: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1798\"></a>Sent before a file is imported. \n            	 \n         </p>\n         <p><a name=\"P_D0F9ED828CF44E958228937D87C37688\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68DA\"></a><pre><em class=\"codeEmphasisStrong\">#postImport: filename</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1795\"></a>Sent after a file is imported successfully. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\">callbacks.notificationParam()</span> returns the name of the file being imported. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_F3B3A4CFC20A4B698F5B758851EFDA26\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68D9\"></a><pre><em class=\"codeEmphasisStrong\">#importFailed: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1792\"></a>Sent if import fails. \n            	 \n         </p>\n         <p><a name=\"P_C061C1BCDC1C47B982F98F1F866CCC00\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68D8\"></a><pre><em class=\"codeEmphasisStrong\">#preExport: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-178F\"></a>Sent before a file is exported. \n            	 \n         </p>\n         <p><a name=\"P_FCF26C94A8E64080A164D18A82348AA6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68D7\"></a><pre><em class=\"codeEmphasisStrong\">#postExport: filename</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-178C\"></a>Sent after a file is exported successfully. \n            	 \n         </p>\n         <p>Calling \n            		<span class=\"code\">callbacks.notificationParam()</span> returns the name of the file being exported. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_A0AD770C4A7445149639FF2BA3189416\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-68D6\"></a><pre><em class=\"codeEmphasisStrong\">#exportFailed: undefined</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1789\"></a>Sent if export fails. \n            	 \n         </p>\n         <p><a name=\"P_91E45DE4871844E88BD57814D81F83F1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";