var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-2F2F1393-AB2C-45B9-B7D0-AB452115EDC9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Parameter Wiring\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Parameter Wiring</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2F2F1393-AB2C-45B9-B7D0-AB452115EDC9\"></a><div class=\"head\">\n            <h1>Parameter Wiring </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3629\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3628\"></a> The Parameter Wire manager is described in the core interface \'paramWire\'. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3626\"></a>Generally, a wire controller can be wired to any number of other wire controllers\n               in two-way relationships. Each wire has a set of information that defines it, accessible\n               using the indexed accessor functions. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3624\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3623\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3622\"></a><p class=\"table-body\">The following will demonstrate a way to query a wire controller and determine what\n                           parameters it is referencing. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D34\"></a><pre>\nb=box isSelected:true\nwc = $.pos.controller.x_position.controller -- get pos X controller\nif classOf wc == Float_Wire do\n(-- list out its connections\nfor i in 1 to wc.numWires do\n(\nparent = wc.getWireParent i\nparent_owner = (refs.dependents parent)[1]\nparam_name = getSubAnimName parent (wc.getWireSubnum i)\nformat \"wire %: % in %\\n\" i param_name parent_owner\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3613\"></a>Additionally, you can use the subAnim indexing operator as a way to scan down through\n               an object for wire controllers. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3611\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3610\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D33\"></a><pre>\nfor i in 1 to $foo.numSubs do\nif classOf $foo[i].controller == ...\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-360B\"></a>Also, you might find the <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">exprForMAXObject()</a></span> method useful here to get a MAXScript expression for the parent or parent owner.\n               \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3609\"></a> <span class=\"char_link\"><a href=\"GUID-85826518-65D4-492B-8FB7-A6112A09EAA3.htm\">Interface: paramWire</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3608\"></a> <span class=\"char_link\"><a href=\"GUID-4D368C80-2B26-4DE2-8543-DA568879195D.htm\">Float_Wire : FloatController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3607\"></a> <span class=\"char_link\"><a href=\"GUID-B5348C25-A633-4E07-BCE6-EBFFD323402F.htm\">Point3_Wire : Point3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3606\"></a> <span class=\"char_link\"><a href=\"GUID-BE1E433F-890A-4B81-BF25-123AA04AE2BD.htm\">Position_Wire : PositionController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3605\"></a> <span class=\"char_link\"><a href=\"GUID-8FBE6DA0-2372-4076-8881-3440F28FDDCE.htm\">Rotation_Wire : RotationController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3604\"></a> <span class=\"char_link\"><a href=\"GUID-95AD4515-983E-485B-B4B4-C374631487D8.htm\">Scale_Wire : ScaleController</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";