var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-321A4B1F-11D8-41F4-B049-4C02E7567125\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"loops\">\n      <meta name=\"indexterm\" content=\"if/then/else expression\">\n      <meta name=\"indexterm\" content=\"for loop\">\n      <meta name=\"indexterm\" content=\"do and while loops\">\n      <meta name=\"indexterm\" content=\"controlling program flow in scripts\">\n      <meta name=\"indexterm\" content=\"conditional statements\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Controlling Program Flow in Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-321A4B1F-11D8-41F4-B049-4C02E7567125\"></a><div class=\"head\">\n            <h1>Controlling Program Flow in Scripts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5040\"></a>      MAXScript provides commands that allow you to control the path that the software follows\n            it evaluates your script. The two most useful groups of commands are the conditional\n            statements and loop statements. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5047\"></a>Before you go on, let\'s make sure you have the correct base scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5048\"></a>In the new MAXScript Editor you opened in the previous step, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5049\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC504A\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5075\"></a><pre>resetMaxFile #noprompt\nmybox = box length:10 width:10 height:10 wirecolor:blue</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5050\"></a>Then press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">E</span></em> to evaluate the script. This will reset the current scene without the \"Are You Sure\"\n            prompt and will create a new blue box with dimensions 10x10x10 at the origin. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5051\"></a> \n            <h2><a name=\"GUID-784FDADC-C8BB-4781-9CA4-8CF8DA0ECE2C\"></a> <em class=\"strong\">Conditional Statements</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5052\"></a>Conditional statements simply tell MAXScript to perform a specified command if a certain\n               condition is met. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5053\"></a>Enter the following in the Listener (and not in the newly opened Script Editor): \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5054\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5055\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5074\"></a><pre>if mybox.height == 10 then mybox.width = 20</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC505A\"></a>This changes the width of the box we just created to 20 if its height is equal to\n               10 (which happens to be the case). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC505B\"></a>You may have taken note of the double equal sign used in the statement above. This\n               is discussed at the end of this topic and denotes the logical operation \"Is Equal\n               To\". \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC505D\"></a>This \"if…then…\" statement can be expanded to include an \"else\" statement, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC505E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC505F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5073\"></a><pre>if mybox.height == 10 then mybox.width = 20 else mybox.width = 10</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5064\"></a>This statement tells MAXScript to change the width of your box to 20 if its height\n               is 10, otherwise change the width to 10. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5065\"></a>The \"if\", \"then\" and \"else\" portions of the statement can all be on separate lines,\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5066\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5067\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5072\"></a><pre>if mybox.height == 10\nthen mybox.width = 20\nelse mybox.width = 10</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC506F\"></a>What is even more fascinating about MAXScript is that since the if...then...else uses\n               three expressions (one condition and two alternative expressions depending on whether\n               the condition is true or false), the above could be written much shorter as \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5070\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5071\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5071\"></a><pre>mybox.width = if mybox.height == 10 then 20 else 10</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5076\"></a>In this case, the right-hand side of the assignment is an IF expression which evaluates\n               the condition whether the height of the box is 10 or not and returns a value of 20\n               if it is and of 10 if it is not. Then the resulting value is assigned to the left-hand\n               side of the assignment expression. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5077\"></a>This can be made clearer with some additional parentheses which are optional and simply\n               improve readability: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5078\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5079\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5070\"></a><pre>mybox.width = (if mybox.height == 10 then 20 else 10)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC507E\"></a> \n               <h3><a name=\"GUID-7C91E917-9981-4CF9-A3A5-E1E5C3302DD4\"></a> <em class=\"strong\">If...Then Conditions In the Listener</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC507F\"></a>If you are entering these commands into the Listener window, you may notice that the\n                  commands are not executed line by line, as is typical of the Listener. This is because\n                  the Listener recognizes that the \"if\" statement requires a \"then\" statement to be\n                  complete. In fact, the Listener does not execute the statement after the \"then\" statement,\n                  because it does not know if you intend to include an \"else\" statement. For this reason,\n                  the Listener does not execute an \"if...then...\" statement until you have either entered\n                  a \"then\" statement or <em class=\"mild\">after</em> the next line you type, following the \"if...then...\" statement. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5080\"></a>To avoid the waiting for an \"else\" statement when typing in the Listener, you can\n                  use \"if...do...\" instead. You cannot use \"else\" with \"if...do...\", so the Listener\n                  will not wait and will execute the expression after \"do\" as long as the condition\n                  expression after the \"if\" is true. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5082\"></a> \n               <h3><a name=\"GUID-62B486EF-8113-4486-8890-C7DCEC346147\"></a> <em class=\"strong\">Comparison Operators</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5083\"></a>The double equal sign in the last statement, \"==\" tells MAXScript to compare two values.\n                  The single \"=\" sign always signifies value assignment. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5084\"></a>This is common in many standard programming languages, such as C++. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5085\"></a>There are several different conditional operators used in MAXScript. They are listed\n                  here: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5086\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5088\"></a>== equal to \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC508A\"></a>!= not equal to \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC508C\"></a>&gt; greater than \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC508E\"></a>&gt;= greater than or equal to \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5090\"></a>&lt; less than \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5092\"></a>&lt;= less than or equal to \n                     </p> \n                  </li>\n               </ul> \n               <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7DB5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5097\"></a>Any time MAXScript evaluates a conditional expression, the result is either true or\n                        false. MAXScript temporarily stores the value of this result. In an \"if…then\" statement,\n                        MAXScript uses this result to determine the path to follow in the statement. If the\n                        result of the \"if\" statement is true, MAXScript will evaluate the \"then\" expression.\n                        If the result is false, MAXScript will evaluate the \"else\" expression, assuming one\n                        is specified; otherwise, it will cease evaluating the conditional statement. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5098\"></a>In some scripts, you might see the words <span class=\"code\">on</span> and <span class=\"code\">off</span> used in place of <span class=\"code\">true</span> and <span class=\"code\">false</span>, respectively. These words are interchangeable and they mean the same thing to MAXScript.\n                        \n                     </p> \n                  </div>\n               </div> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC509B\"></a> \n            <h2><a name=\"GUID-08121628-4F66-4292-8060-CAECD89D8F94\"></a> <em class=\"strong\">Loops</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC509C\"></a>Loops are repetitive operations that tell MAXScript to repeat the execution of a collection\n               of commands. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC509D\"></a>Loops are useful for working with large groups of objects, as you can make changes\n               to many objects with one set of commands. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC509E\"></a>For example, if you wanted to make 50 boxes, you could use a loop to execute the create\n               command 50 times, rather than creating the boxes with 50 separate commands. Loops\n               are also useful for changing the properties of multiple objects. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC509F\"></a>There are several different types of loop. The first to be considered are for and\n               while loops. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A0\"></a> \n               <h3><a name=\"GUID-89332EA0-9945-416D-A0A5-85853CECE3BC\"></a> <em class=\"strong\">For Loops</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A1\"></a>The for loop iterates through a range of numbers, time values, or a sequenced collection\n                  of values, such as an array or object set. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A2\"></a>You can use a for loop to copy the box you created. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A3\"></a>Let\'s expand the script we started in the beginning of this lesson: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50A6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE SCRIPT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506F\"></a><pre>\nresetMaxFile #noprompt --reset the scene\nmybox = box length:10 width:10 height:10 wirecolor:blue --new box\nfor i = 1 to 5 do --repeat five times, for each iteration do:\n(\nbox_copy = copy mybox --create a copy of the original box\nbox_copy.pos = [i*20, 0, 0] --place it i*20 units along x\nbox_copy.wirecolor = [i*25,i*50,(5-i)*50] --blue-green gradient\n)--end of the for loop\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50B3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F4FA540A-2020-443C-AFFB-5B49F4210483-low.gif\"></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50B4\"></a>Everything inside of the parentheses makes up a \"block\". All loop statements must\n                  be created as a block. This statement executes five times. Each time, a new box copy\n                  is created, placed to a new position and its color is changed. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50B5\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50B7\"></a>A for statement starts with the word \'for\'. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50B9\"></a>Next, you must define how many times the statement will repeat. In this case, we have\n                        used the variable \"i\" to control the loop. The line, \"<span class=\"code\">for i = 1 to 5</span>\" tells MAXScript to set the variable \"i\" to the value 1, execute the contents of\n                        the loop body, then set the variable \"i\" to 2, execute the loop body, and so on. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50BB\"></a>The variable \"i\" is called the <em class=\"mild\">index</em> for the loop. Each time the loop executes, the index is incremented by 1 automatically,\n                        without requiring any user input. Each repetition of the loop is called an iteration.\n                        \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50BD\"></a>To make MAXScript increment the index by a value other than 1, insert \'by x\' after\n                        the index statement, where x is the amount to increment the index by. \n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50BE\"></a>The following statement will set the index to 1, then 3, then 5, \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50BF\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50C0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506E\"></a><pre>\nresetMaxFile #noprompt --reset the scene\nmybox = box length:10 width:10 height:10 wirecolor:blue --new box\nfor i = 1 to 5 by 2 do --repeat with step of 2:\n(\nbox_copy = copy mybox --create a copy of the original box\nbox_copy.pos = [i*20, 0, 0] --place it i*20 units along x\nbox_copy.wirecolor = [i*25,i*50,(5-i)*50] --blue-green gradient\n)--end of the for loop\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50CD\"></a>&nbsp;<img src=\"../images/GUID-C33149D7-7EA4-4AE7-B286-1DCD29D648F3-low.gif\"> \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50CE\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D0\"></a>The \"do\" keyword tells MAXScript to execute the following block or statement each\n                        time the loop repeats. Note that in some loops you might see the word \"in\" in place\n                        of the equal sign, \"=\". These both mean the same thing in for loops, and can be used\n                        interchangeably. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D2\"></a>Note how the index was used within the loop statement to set the position of each\n                        new box by multiplying by an offset value. This is a useful way to work with multiple\n                        object creation. The same approach was used for the color, changing the R, G and B\n                        components based on the index. \n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D3\"></a>For loops can also be used to build arrays and/or access values within an array. In\n                  the following example, you use a for loop to build an array called \'arr\': \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D4\"></a>&nbsp;<img src=\"../images/GUID-5784B80E-8DE1-4255-8BE4-C7FDC62F3299-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D5\"></a>Remember that because MAXScript is an expression-based language, you are able to use\n                  expressions in variable assignment, as seen above in the assignment of the for loop\n                  expression to the variable, <span class=\"code\">arr</span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D6\"></a>Note the \'collect\' statement in the for loop above. This tells MAXScript to collect\n                  the results of each iteration in an array, rather than just calculate them. In this\n                  case, you only asked MAXScript to collect the value of the index; however, you can\n                  collect iterations of any expression. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D7\"></a>Finally, for loops can also perform iterations with the contents of an array. In the\n                  following example, you use a for loop to access the values of the array you created\n                  in the previous example: \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D8\"></a>&nbsp;<img src=\"../images/GUID-76BD54C0-D1BB-41FF-8635-1D962B77587C-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50D9\"></a>The \'print\' command is a MAXScript function that displays the specified variable in\n                  the Listener window. In this example you used \'in\' instead of an equal sign; however,\n                  they are still both acceptable, even when accessing values within an array. \n               </p> \n               <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7D8A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50DC\"></a>You can also access the number of elements in an array with the <span class=\"code\">.count</span> property. \n                     </p> \n                  </div>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50DE\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50DF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50E0\"></a><p class=\"table-body\">the previous example could have been written as: </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506D\"></a><pre>for i = 1 to arr.count do print arr[i]</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50E4\"></a><p class=\"table-body\">This will return the same result. </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50E6\"></a> \n               <h3><a name=\"GUID-C1AEDE8A-22C6-4405-8786-C9FF8B43DE3B\"></a> <em class=\"strong\">While and Do Loops</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50E7\"></a>While and Do loops are used to repeatedly execute an expression until a test expression\n                  evaluates as false. The while and do loop are simple variants of one another. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50E8\"></a>The syntax is: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506C\"></a><pre><em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt; -- do loop\n<em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt; -- while loop</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50EB\"></a>The following example will return the value of a variable, incrementing the variable\n                  by -1 with each iteration. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50ED\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50EE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506B\"></a><pre>x=10\nwhile x&gt;0 do print (x-=1)</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC50F3\"></a><p class=\"table-body\"> <em class=\"strong\">RETURNS</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-506A\"></a><pre>9\n8\n7\n6\n5\n4\n3\n2\n1\n0\n0</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5102\"></a>MAXScript automatically returns the final value of the loop to the Listener. In this\n                  example, MAXScript is also instructed to return the value at each iteration of the\n                  loop; therefore, the final value is returned twice. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5103\"></a>Both loops repeat the <span class=\"code\">do &lt;expr&gt;</span> as long as the <span class=\"code\">while &lt;expr&gt;</span> evaluates to the value <span class=\"code\">true</span>. The do form evaluates the <span class=\"code\">do &lt;expr&gt;</span> at least at least once, before evaluating the text expression at the end of the loop.\n                  The while form evaluates the test expression at the start of the loop, and might not\n                  loop at all. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5104\"></a>Both forms return as their value the result of the <span class=\"code\">do &lt;expr&gt;</span> from the last successful loop iteration. The while form returns the value undefined\n                  if the test expression immediately returns <span class=\"code\">false</span>. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5105\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5106\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5069\"></a><pre>x=10\ndo print (x-=1) while x&gt;10</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC510B\"></a><p class=\"table-body\"> <em class=\"strong\">RETURNS</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5068\"></a><pre>9\nundefined</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5110\"></a><p class=\"table-body\"> <em class=\"strong\">HOWEVER</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5067\"></a><pre>x=10\nwhile x&gt;10 do print (x-=1)</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5115\"></a><p class=\"table-body\"> <em class=\"strong\">RETURNS</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5066\"></a><pre>undefined</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC511A\"></a> <em class=\"strong\">Next Topic</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC511B\"></a> <span class=\"char_link\"><a href=\"GUID-A6E95530-F419-4837-B10A-E881A62AD5F9.htm\">Local and Global Variables</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";