var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-32FB1A07-6F09-4E85-B7D3-1E9CDE3FBB4C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripts\">\n      <meta name=\"indexterm\" content=\"output pane\">\n      <meta name=\"indexterm\" content=\"trace-back of call stack\">\n      <meta name=\"indexterm\" content=\"runtime - detecting errors\">\n      <meta name=\"indexterm\" content=\"errors - locating in MAXScript\">\n      <meta name=\"indexterm\" content=\"error messages\">\n      <meta name=\"indexterm\" content=\"call stack trace-back\">\n      <meta name=\"indexterm\" content=\"alert box\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Error Messages</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-32FB1A07-6F09-4E85-B7D3-1E9CDE3FBB4C\"></a><div class=\"head\">\n            <h1>Error Messages </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-6A2A\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4AF9\"></a>        When MAXScript detects a runtime error in your script, it displays an error message\n               and prints diagnostic information to the Listener output pane. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B02\"></a>If the error occurs in a controller script or rollout panel script, the error message\n               is displayed in an Alert Box window and is also printed in the Listener output pane.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B03\"></a><em class=\"strong\">3ds Max</em> also features a <span class=\"char_link\"><a href=\"GUID-1B1833F0-8712-4EA5-AFFA-3E42DBF7960C.htm\">MAXScript Debugger</a></span> which provides a more advanced toolset for dealing with errors and monitoring variables.\n               \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B04\"></a> \n               <h3><a name=\"GUID-E595F184-DBD6-4254-B44F-A14308CCB069\"></a> <em class=\"strong\">Listener Call Stack Trace-Back And Editor Error Highlight</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B05\"></a>The diagnostic information is in the form of a <em class=\"mild\">call stack trace-back</em> which can help determine the cause and location of the error in your code. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B06\"></a>The call stack trace-back shows \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B07\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B09\"></a>The nesting of called MAXScript functions at the point of error, deepest ones first\n                        to outermost ones last; \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B0B\"></a>The filename, position and line number the error occurred at; \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B0D\"></a>The values in all the local variables and function parameters at the levels they are\n                        declared or first used. \n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B0E\"></a>Note that <span class=\"code\"> <em class=\"strong\">for </em> </span>loops produce separate entries in the call stack trace-back and include a variable\n                  dump for the loop variable and any locals in the loop body. This is because a for\n                  loop body represents a <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">variable scope</a></span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B0F\"></a>As a further aid in locating the error, MAXScript highlights the line in which the\n                  error occurred in an MAXScript Editor window if the running code was compiled from\n                  a source file (any code not entered directly in the Listener). If the source file\n                  is not currently open in the <span class=\"char_link\"><a href=\"GUID-CBBE48A6-D1C6-4589-8F93-1F26EE28A809.htm\">MAXScript Editor</a></span>, MAXScript opens the file in a new tab. The line containing the code in which the\n                  error occurred is highlighted and scrolled into view. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B10\"></a>The error message is either displayed in an Alert Box window or the Listener window.\n                  In both cases, the Alert Box or Listener window is brought to the front and the MAXScript\n                  Editor window containing the code causing the error is immediately behind. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B11\"></a>Compile and runtime error messages reported in the Listener output pane are preceded\n                  by the comment symbol \"--\", so you can reselect and evaluate code in Listener that\n                  might have embedded error messages and not have them cause syntax errors. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B13\"></a>In the following figure, an Editor and a Listener window are shown where an error\n                  was detected while running the script. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B14\"></a>The error occurred in the highlighted line in the Editor window. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B15\"></a>Looking at the call stack trace-back, we see the error occurred when the <span class=\"code\"> <em class=\"strong\">for </em> </span>loop variable <span class=\"code\"> <em class=\"strong\">i </em> </span>is equal to 100. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B16\"></a>In the line in error, the position of the object from array <span class=\"code\"> <em class=\"strong\">b </em> </span>with index i is being set. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B17\"></a>After further investigation, it was found the array <span class=\"code\"> <em class=\"strong\">b </em> </span>only had 99 elements defined. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B18\"></a>Thus element <span class=\"code\"> <em class=\"strong\">b[i] </em> </span>contained the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>, which resulted in the error as there is no position property associated with <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B19\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-970A912F-8366-469B-9B93-75922D3E0173-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B1B\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B1C\"></a><p class=\"table-body\"> <em class=\"strong\">ADVANCED INFORMATION ON THIS SPECIFIC ERROR:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B1D\"></a><p class=\"table-body\">The correct way to avoid this particular error would be to use \'for i = 1 to b.count\n                              do\' to ensure the loop never exceeds the number of objects in b, and also divide by\n                              b.count in the line \'z=360.0*i/b.count\'. \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B1E\"></a><p class=\"table-body\">Obviously, the above \"mistake\" was introduced to cause an error for demonstration\n                              purposes. \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B1F\"></a><p class=\"table-body\">The script itself tries to place all selected objects in a circle with radius the\n                              Radius around the point pos0. \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B22\"></a> \n               <h3><a name=\"GUID-163BB590-7501-4EDE-BE52-561010AB00E7\"></a> <em class=\"strong\">Script Controller Errors</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B23\"></a>In the following figure, an error dialog and script controller dialog are shown. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B24\"></a>An error was detected while running the script assigned to a script controller. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B25\"></a>This error was caused by the deletion of object Box001, whose position was used directly\n                  in the script. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B26\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-AB5E55EC-78F2-4188-8273-854F90151359-low.gif\"></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B27\"></a>The MAXScript Listener shows the following call stack trace-back for this error: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B28\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-458A6EC5-61FD-43F6-945C-F5AD5C7C466B-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B2A\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B2B\"></a><p class=\"table-body\"> <em class=\"strong\">ADVANCED INFORMATION ON THIS SPECIFIC ERROR:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B2C\"></a><p class=\"table-body\">Since <em class=\"strong\">3ds Max 8</em>, the above way of accessing object properties is considered obsolete and a Bad Practice\n                              exactly because it can cause a large number of errors when a referenced object is\n                              deleted or cannot be found for other reasons (for example when an object with a Script\n                              Controller is brought into a scene via XRef). \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B2D\"></a><p class=\"table-body\">The correct approach to avoid this specific kind of error would be to use a Variable\n                              assigned the Position track of Box001. Deleting the Box001 would not cause an error\n                              in the controller. As an added bonus, the controlled object would update its position\n                              when Box001 is moved along Z automatically. \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B2E\"></a><p class=\"table-body\">Please see <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> for details. \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-1B1833F0-8712-4EA5-AFFA-3E42DBF7960C.htm\">The MAXScript Debugger </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";