var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-33391123-6956-49B8-9535-37A87754BA32\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Create XView Checker\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop A Face Area XView Checker - Part 3</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-33391123-6956-49B8-9535-37A87754BA32\"></a><div class=\"head\">\n            <h1>How To ... Develop A Face Area XView Checker - Part 3 </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3704\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3705\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Develop A Face Area xView Checker - Part 3 \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3707\"></a>The following tutorial extends the scripted xView Check created in Part 1 and 2 with\n            sticky settings using an INI file. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3708\"></a>The xView Checker is available in <em class=\"strong\">3ds Max 2010</em> and higher. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3709\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC370A\"></a> <span class=\"char_link\"><a href=\"GUID-3E1B1FA8-710C-4FF8-A067-68F6DFF15799.htm\">xViewChecker Access</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC370B\"></a> <span class=\"char_link\"><a href=\"GUID-1FF02C5C-F675-469F-9D5B-E27EF6E23066.htm\">Interface:xViewChecker</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC370E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC370F\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3710\"></a><p class=\"table-body\">Add saving of each configuration dialog setting to the INI file. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3711\"></a><p class=\"table-body\">Create a list of all settings to be loaded from the INI file. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3712\"></a><p class=\"table-body\">Load each setting from the INI file when the script is evaluated. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3715\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3716\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-628C\"></a><pre>\n(\nglobal FaceAreaChecker\nstruct FaceAreaCheckerStruct\n(\nFaceAreaThresholdMin = 1,\nFaceAreaThresholdMax = 10,\nFaceAreaMode = 1,\nfaceAreaDialog = undefined,\nInteractiveUpdates = true,\niniFileName = (getDir #plugcfg +\"\\\\FaceAreaXViewChecker.ini\"),\nresultColors = #(green, blue+green*0.5, red+yellow*0.5, blue, yellow, red),\n&nbsp;\nfn geomCheck theTime theNode theResults =\n(\n  local theCount =case classof theNode of\n  (\n    Editable_Poly: getNumFaces theNode\n    Editable_Mesh: theNode.numfaces\n  )\n  local theAreaMethod =case classof theNode of\n  (\n    Editable_Poly: polyOp.getFaceArea\n    Editable_Mesh: meshOp.getFaceArea\n  )\n&nbsp;&nbsp;\n  for f = 1 to theCount do\n  (\n    local theArea = theAreaMethod theNode f\n    case FaceAreaChecker.FaceAreaMode of\n    (\n      default: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMin and theArea &lt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n      2: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMin do append theResults f\n      3: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMin do append theResults f\n      4: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n      5: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n      6: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMin or theArea &gt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n    )&nbsp;\n  )&nbsp;\n3\n),\n&nbsp;\nfn supportedCheck theNode =\n(\n  classof theNode == Editable_Mesh or classof theNode == Editable_Poly\n),\n&nbsp;\nfn configDlg =\n(\n  try(destroyDialog FaceAreaChecker.faceAreaDialog)catch()\n  rollout faceAreaDialog \"Face Area Checker\"\n  (\n    dropdownlist ddl_FaceAreaMode width:150 align:#left offset:[-10,-3] items:#(\"Between Min. and Max\",\"Less Than Min.\",\"Greater Than Min.\",\"Less Than Max.\",\"Greater Than Max.\",\"Not Between Min. and Max\") selection:FaceAreaChecker.FaceAreaMode across:2\n    colorpicker clr_resultsColor fieldwidth:10 align:#right offset:[7,-3] color:FaceAreaChecker.resultColors[FaceAreaChecker.FaceAreaMode]\n    spinner spn_FaceAreaThresholdMin \"Min. Threshold:\" range:[0,1000000,FaceAreaChecker.FaceAreaThresholdMin] offset:[7,-3] type:#worldUnits\n    spinner spn_FaceAreaThresholdMax \"Max. Threshold:\" range:[0,1000000,FaceAreaChecker.FaceAreaThresholdMax] offset:[7,-3] type:#worldUnits\n    checkbox chk_InteractiveUpdates \"Interactive\" checked:FaceAreaChecker.InteractiveUpdates offset:[0,-3] across:2\n    button btn_selectResults \"Selection\" align:#right width:72 height:18 offset:[7,-3]\n&nbsp;&nbsp;&nbsp;\n    fn updateDisplay =\n    (\n      if FaceAreaChecker.InteractiveUpdates do\n      (\n        XViewChecker.runCheck CurrentTime\n        max views redraw\n      )\n    )\n    on ddl_FaceAreaMode selected itm do\n    (\n      FaceAreaChecker.FaceAreaMode = itm\n      updateDisplay()\n      setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaMode\" (itm as string)\n      clr_resultsColor.color = FaceAreaChecker.resultColors[itm]\n    )\n    on clr_resultsColor changed val do\n    (\n      FaceAreaChecker.resultColors[ddl_FaceAreaMode.selection] = val\n      updateDisplay()\n      setIniSetting FaceAreaChecker.iniFileName\"Colors\" (\"Color_\"+ddl_FaceAreaMode.selection as string) (val as string)\n    )\n    on chk_InteractiveUpdates changed state do\n    (\n      FaceAreaChecker.InteractiveUpdates = state\n      updateDisplay()\n      setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"InteractiveUpdates\" (state as string)\n    )&nbsp;\n    on spn_FaceAreaThresholdMin changed val do\n    (\n      FaceAreaChecker.FaceAreaThresholdMin = val\n      updateDisplay()\n      setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaThresholdMin\" (val as string)\n    )&nbsp;\n    on spn_FaceAreaThresholdMax changed val do\n    (\n      FaceAreaChecker.FaceAreaThresholdMax = val\n      updateDisplay()\n      setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaThresholdMax\" (val as string)\n    )&nbsp;&nbsp;&nbsp;\n    on btn_selectResults pressed do\n    (\n      XViewChecker.selectResults CurrentTime\n      max views redraw\n    )&nbsp;\n    on faceAreaDialog moved pos do setIniSetting FaceAreaChecker.iniFileName \"Dialog\" \"Position\" (pos as string)\n  )--end rollout\n&nbsp;&nbsp;\n  local thePos = execute (getIniSetting FaceAreaChecker.iniFileName \"Dialog\" \"Position\")\n  if classof thePos != Point2 do thePos = mouse.screenpos\n  createDialog faceAreaDialog 170 82 thePos.x thePos.y\n  FaceAreaChecker.faceAreaDialog = faceAreaDialog\n),\n&nbsp;\nfn textOverride =\n(\n  case FaceAreaChecker.FaceAreaMode of\n  (\n    1: \"Between \"+FaceAreaChecker.FaceAreaThresholdMin as string +\" and \"+FaceAreaChecker.FaceAreaThresholdMax as string\n    2: \"Less Than \"+FaceAreaChecker.FaceAreaThresholdMin as string\n    3: \"Greater Than \"+FaceAreaChecker.FaceAreaThresholdMin as string\n    4: \"Less Than \"+FaceAreaChecker.FaceAreaThresholdMax as string\n    5: \"Greater Than \"+FaceAreaChecker.FaceAreaThresholdMax as string\n    6: \"Not Between \"+FaceAreaChecker.FaceAreaThresholdMin as string +\" and \"+FaceAreaChecker.FaceAreaThresholdMax as string\n  )\n),\n&nbsp;\nfn dispOverride theTime theNode theHwnd theResults =\n(\n  local theColor = FaceAreaChecker.resultColors[FaceAreaChecker.FaceAreaMode]\n  XViewChecker.displayResults theColor theTime theNode theHwnd 3 theResults\n)\n)--end struct\n&nbsp;\ntry(destroyDialog FaceAreaChecker.faceAreaDialog)catch()\nFaceAreaChecker = FaceAreaCheckerStruct()\n&nbsp;\nlocal valuesToLoad = #(\n  #(\"Settings\",\"FaceAreaMode\", &amp;FaceAreaChecker.FaceAreaMode,0),\n  #(\"Settings\",\"InteractiveUpdates\", &amp;FaceAreaChecker.InteractiveUpdates,0),&nbsp;\n  #(\"Settings\",\"FaceAreaThresholdMin\", &amp;FaceAreaChecker.FaceAreaThresholdMin,0),&nbsp;\n  #(\"Settings\",\"FaceAreaThresholdMax\", &amp;FaceAreaChecker.FaceAreaThresholdMax,0),&nbsp;\n  #(\"Colors\",\"Color_1\", FaceAreaChecker.resultColors, 1),&nbsp;\n  #(\"Colors\",\"Color_2\", FaceAreaChecker.resultColors, 2),&nbsp;\n  #(\"Colors\",\"Color_3\", FaceAreaChecker.resultColors, 3),&nbsp;\n  #(\"Colors\",\"Color_4\", FaceAreaChecker.resultColors, 4),&nbsp;\n  #(\"Colors\",\"Color_5\", FaceAreaChecker.resultColors, 5),&nbsp;\n  #(\"Colors\",\"Color_6\", FaceAreaChecker.resultColors, 6)\n)\nfor i in valuesToLoad do\n(\n  local theVal = execute (getIniSetting FaceAreaChecker.iniFileName i[1] i[2])\n  if theVal != OK do\n    if i[4] &gt; 0 then i[3][i[4]] = theVal else *i[3] = theVal\n)--end i loop&nbsp;\n&nbsp;\nxViewChecker.unRegisterChecker \"Face Area Checker\"\nxViewChecker.registerChecker FaceAreaChecker.geomCheck FaceAreaChecker.supportedCheck #Faces \"Face Area Checker\" FaceAreaChecker.configDlg FaceAreaChecker.textOverride FaceAreaChecker.dispOverride\n)--end script\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-628B\"></a><pre><em class=\"codeEmphasisStrong\"><em class=\"codeEmphasisMild\">--code in italic has not changed since Part 2</em></em> <em class=\"codeEmphasisMild\">(\nglobal FaceAreaChecker\nstruct FaceAreaCheckerStruct\n(\nFaceAreaThresholdMin = 1,\nFaceAreaThresholdMax = 10,\nFaceAreaMode = 1,\nfaceAreaDialog = undefined,\nInteractiveUpdates = true,\niniFileName = (getDir #plugcfg +\"\\\\FaceAreaXViewChecker.ini\"),\nresultColors = #(green, blue+green*0.5, red+yellow*0.5, blue, yellow, red),\nfn geomCheck theTime theNode theResults =\n(\nlocal theCount = case classof theNode of\n(\nEditable_Poly: getNumFaces theNode\nEditable_Mesh: theNode.numfaces\n)\nlocal theAreaMethod = case classof theNode of\n(\nEditable_Poly: polyOp.getFaceArea\nEditable_Mesh: meshOp.getFaceArea\n)\nfor f = 1 to theCount do\n(\nlocal theArea = theAreaMethod theNode f\ncase FaceAreaChecker.FaceAreaMode of\n(\ndefault: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMin and theArea &lt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n2: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMin do append theResults f\n3: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMin do append theResults f\n4: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n5: if theArea &gt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n6: if theArea &lt;= FaceAreaChecker.FaceAreaThresholdMin or theArea &gt;= FaceAreaChecker.FaceAreaThresholdMax do append theResults f\n)&nbsp;\n)&nbsp;\n3\n),\n\nfn supportedCheck theNode =\n(\nclassof theNode == Editable_Mesh or classof theNode == Editable_Poly\n),\n\nfn configDlg =\n(\ntry (destroyDialog FaceAreaChecker.faceAreaDialog)catch()\nrollout faceAreaDialog \"Face Area Checker\"\n(\ndropdownlist ddl_FaceAreaMode width:150 align:#left offset:[-10,-3] items:#(\"Between Min. and Max\",\"Less Than Min.\", \"Greater Than Min.\",\"Less Than Max.\", \"Greater Than Max.\",\"Not Between Min. and Max\") selection:FaceAreaChecker.FaceAreaMode across:2\ncolorpicker clr_resultsColor fieldwidth:10 align:#right offset:[7,-3] color:FaceAreaChecker.resultColors[FaceAreaChecker.FaceAreaMode]\nspinner spn_FaceAreaThresholdMin \"Min. Threshold:\" range:[0,1000000,FaceAreaChecker.FaceAreaThresholdMin] offset:[7,-3] type:#worldUnits\nspinner spn_FaceAreaThresholdMax \"Max. Threshold:\" range:[0,1000000,FaceAreaChecker.FaceAreaThresholdMax] offset:[7,-3] type:#worldUnits\ncheckbox chk_InteractiveUpdates \"Interactive\" checked:FaceAreaChecker.InteractiveUpdates offset:[0,-3] across:2\nbutton btn_selectResults \"Selection\" align:#right width:72 height:18 offset:[7,-3]&nbsp;&nbsp;\n\nfn updateDisplay =\n(\nif FaceAreaChecker.InteractiveUpdates do\n(\nXViewChecker.runCheck CurrentTime\nmax views redraw\n)\n)\non ddl_FaceAreaMode selected itm do\n(\nFaceAreaChecker.FaceAreaMode = itm\nupdateDisplay()</em> <em class=\"codeEmphasisStrong\">setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaMode\" (itm as string)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC37FD\"></a>When the mode is changed, we now save the current selection in the INI file under\n            the category \"Settings\" and the key \"FaceAreaMode\". \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-628A\"></a><pre><em class=\"codeEmphasisMild\">clr_resultsColor.color = FaceAreaChecker.resultColors[itm]\n)\non clr_resultsColor changed val do\n(\nFaceAreaChecker.resultColors[ddl_FaceAreaMode.selection] = val\nupdateDisplay()</em> <em class=\"codeEmphasisStrong\">setIniSetting FaceAreaChecker.iniFileName \"Colors\" (\"Color_\"+ddl_FaceAreaMode.selection as string) (val as string)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3805\"></a>When the color is changed, we now save the new color in the INI file under the category\n            \"Colors\" and the key \"Color_N\", where N is the current mode. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6289\"></a><pre><em class=\"codeEmphasisMild\">)\non chk_InteractiveUpdates changed state do\n(\nFaceAreaChecker.InteractiveUpdates = state\nupdateDisplay()</em> <em class=\"codeEmphasisStrong\">setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"InteractiveUpdates\" (state as string)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC380C\"></a>When the interactive mode checkbox is changing state, we save the current state in\n            the INI file under the category \"Settings\" and the key \"InteractiveUpdates\". \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6288\"></a><pre><em class=\"codeEmphasisMild\">)&nbsp;\non spn_FaceAreaThresholdMin changed val do\n(\nFaceAreaChecker.FaceAreaThresholdMin = val\nupdateDisplay()</em> <em class=\"codeEmphasisStrong\">setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaThresholdMin\" (val as string)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3813\"></a>When the min. threshold spinner is changing value, we save the current value in the\n            INI file under the category \"Settings\" and the key \"FaceAreaThresholdMin\". \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6287\"></a><pre><em class=\"codeEmphasisMild\">)&nbsp;\non spn_FaceAreaThresholdMax changed val do\n(\nFaceAreaChecker.FaceAreaThresholdMax = val\nupdateDisplay()</em> <em class=\"codeEmphasisStrong\">setIniSetting FaceAreaChecker.iniFileName \"Settings\" \"FaceAreaThresholdMax\" (val as string)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC381A\"></a>When the min. threshold spinner is changing value, we save the current value in the\n            INI file under the category \"Settings\" and the key \"FaceAreaThresholdMax\". \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6286\"></a><pre><em class=\"codeEmphasisMild\">)&nbsp;&nbsp;&nbsp;\non btn_selectResults pressed do\n(\nXViewChecker.selectResults CurrentTime\nmax views redraw\n)&nbsp;\non faceAreaDialog moved pos do setIniSetting FaceAreaChecker.iniFileName \"Dialog\" \"Position\" (pos as string)\n)--end rollout\n&nbsp;&nbsp;\nlocal thePos = execute (getIniSetting FaceAreaChecker.iniFileName \"Dialog\" \"Position\")\nif classof thePos != Point2 do thePos = mouse.screenpos\ncreateDialog faceAreaDialog 170 82 thePos.x thePos.y\nFaceAreaChecker.faceAreaDialog = faceAreaDialog\n),\n\nfn textOverride =\n(\ncase FaceAreaChecker.FaceAreaMode of\n(\n1: \"Between \"+FaceAreaChecker.FaceAreaThresholdMin as string +\" and \" +FaceAreaChecker.FaceAreaThresholdMax as string\n2: \"Less Than \"+FaceAreaChecker.FaceAreaThresholdMin as string\n3: \"Greater Than \"+FaceAreaChecker.FaceAreaThresholdMin as string\n4: \"Less Than \"+FaceAreaChecker.FaceAreaThresholdMax as string\n5: \"Greater Than \"+FaceAreaChecker.FaceAreaThresholdMax as string\n6: \"Not Between \"+FaceAreaChecker.FaceAreaThresholdMin as string +\" and \" +FaceAreaChecker.FaceAreaThresholdMax as string\n)\n),\n\nfn dispOverride theTime theNode theHwnd theResults=\n(\nlocal theColor = FaceAreaChecker.resultColors[FaceAreaChecker.FaceAreaMode]\nXViewChecker.displayResults theColor theTime theNode theHwnd 3 theResults\n)\n)--end struct\n\ntry (destroyDialog FaceAreaChecker.faceAreaDialog)catch()\nFaceAreaChecker = FaceAreaCheckerStruct()</em>\n&nbsp;\n<em class=\"codeEmphasisStrong\">local valuesToLoad = #(</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3842\"></a>To simplify the loading of the INI file settings, we declare an array of arrays to\n            define the category, key, property to set, and in the case of colors, the index of\n            the color. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6285\"></a><pre><em class=\"codeEmphasisStrong\">#(\"Settings\", \"FaceAreaMode\", &amp;FaceAreaChecker.FaceAreaMode,0),\n#(\"Settings\", \"InteractiveUpdates\", &amp;FaceAreaChecker.InteractiveUpdates,0),\n#(\"Settings\", \"FaceAreaThresholdMin\", &amp;FaceAreaChecker.FaceAreaThresholdMin,0),&nbsp;\n#(\"Settings\", \"FaceAreaThresholdMax\", &amp;FaceAreaChecker.FaceAreaThresholdMax,0),&nbsp;</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3847\"></a>To load these settings, we define an array containing the category name, the key name,\n            a reference to the property, and the index 0, which means that we do not use sub-indexing.\n            We take the property by-reference with the &amp; operator to store the pointer to the\n            property instead of its value. This way, the property is not evaluated and we can\n            write back a value into it using its pointer and the de-referencing operator *. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6284\"></a><pre><em class=\"codeEmphasisStrong\">#(\"Colors\", \"Color_1\", FaceAreaChecker.resultColors, 1),&nbsp;\n#(\"Colors\", \"Color_2\", FaceAreaChecker.resultColors, 2),&nbsp;\n#(\"Colors\", \"Color_3\", FaceAreaChecker.resultColors, 3),&nbsp;\n#(\"Colors\", \"Color_4\", FaceAreaChecker.resultColors, 4),&nbsp;\n#(\"Colors\", \"Color_5\", FaceAreaChecker.resultColors, 5),&nbsp;\n#(\"Colors\", \"Color_6\", FaceAreaChecker.resultColors, 6)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC384E\"></a>To load these color settings, we define an array containing the category name, the\n            key name, a reference to the property, and the corresponding color index into the\n            array of colors. We do not need to use by-reference here because the property is an\n            array and arrays are always handled by-reference implicitly. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6283\"></a><pre><em class=\"codeEmphasisStrong\">)\nfor i in valuesToLoad do\n(</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3852\"></a>We loop through the list of settings to load. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6282\"></a><pre><em class=\"codeEmphasisStrong\">local theVal = execute (getIniSetting FaceAreaChecker.iniFileName i[1] i[2])</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3854\"></a>We load the value from the INI file based on the category and the key name and evaluate\n            the string to convert to the correct MAXScript value. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6281\"></a><pre><em class=\"codeEmphasisStrong\">if theVal != OK do\nif i[4] &gt; 0 then i[3][i[4]] = theVal else *i[3] = theVal</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3857\"></a>If the result of the evaluation is not the value OK (which is returned if the string\n            returned by the getIniSetting is empty), we check to see whether the 4<sup> <span class=\"charspan-emphasis\">th</span> </sup>element of the sub-array is greater than zero. If it is, we assign the value to the\n            corresponding indexed item of the colors array. Otherwise, we just assign the value\n            to the de-referenced property. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6280\"></a><pre> <em class=\"codeEmphasisStrong\">)--</em>end i loop&nbsp;\n&nbsp;\n<em class=\"codeEmphasisMild\">\nxViewChecker.unRegisterChecker \"Face Area Checker\"\nxViewChecker.registerChecker FaceAreaChecker.geomCheck FaceAreaChecker.supportedCheck #Faces \"Face Area Checker\" FaceAreaChecker.configDlg FaceAreaChecker.textOverride FaceAreaChecker.dispOverride\n)--end script</em></pre></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC385E\"></a> \n            <h2><a name=\"GUID-9631328C-49A1-46DE-AF12-F9CD2A06A390\"></a> <em class=\"strong\">Using the Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC385F\"></a>Our Face Area xView Checker is now feature-complete. In the last <span class=\"char_link\"><a href=\"GUID-8385056C-4105-485F-B9AE-4280F87E366A.htm\">Part 4 of the tutorial</a></span>, we will look at how it can be integrated into the Viewport Menus for easier access.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3860\"></a>The settings in the Configuration Dialog will now be sticky between sessions. The\n               rest of the features are the same as in the previous Part 2. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3861\"></a> <em class=\"strong\">Previous</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3862\"></a> <span class=\"char_link\"><a href=\"GUID-09495930-94A5-4CE7-BADB-D630B8306883.htm\">How To ... Develop A Face Area XView Checker - Part2</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3863\"></a> <em class=\"strong\">Next</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3864\"></a> <span class=\"char_link\"><a href=\"GUID-8385056C-4105-485F-B9AE-4280F87E366A.htm\">How To ... Develop A Face Area XView Checker - Part4</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3867\"></a> <span class=\"char_link\"><a href=\"GUID-3E1B1FA8-710C-4FF8-A067-68F6DFF15799.htm\">xViewChecker Access</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3868\"></a> <span class=\"char_link\"><a href=\"GUID-1FF02C5C-F675-469F-9D5B-E27EF6E23066.htm\">Interface:xViewChecker</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC386A\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";