var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-34329D61-0CB8-4505-81F5-2E893DC0BA50\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I understand the function definitions in this document?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-34329D61-0CB8-4505-81F5-2E893DC0BA50\"></a><div class=\"head\">\n            <h1>How do I understand the function definitions in this document? </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC902\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC903\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; How do I understand the function definitions in this document? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC905\"></a> <span class=\"char_link\"><a href=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5.htm\">Syntax Definitions in This Document</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC906\"></a>The above topic explains the general syntax used in the MAXScript Online Reference,\n            but practice has shown that many users have difficulties applying the function definitions\n            to actual code. \n         </p>\n         <p><a name=\"P_1DE678E7FB384D65B5C9EF5A1B1BB19B\"></a>Below are some guidelines to help you understand the syntax. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC907\"></a>Here is a typical function definition taken from the <span class=\"char_link\"><a href=\"GUID-EF78FA1A-A382-4BED-BA10-7C856A7551A5.htm\">Meshop Face Methods</a></span>: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-66AB\"></a><pre><em class=\"codeEmphasisStrong\">meshop.detachFaces</em> &lt;Mesh mesh&gt; &lt;facelist&gt; <em class=\"codeEmphasisStrong\">delete</em>:&lt;boolean=true&gt; <em class=\"codeEmphasisStrong\">asMesh</em>:&lt;boolean=false&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC909\"></a>Detaches the specified faces. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90A\"></a>If <span class=\"code\"> <em class=\"strong\">delete</em> </span> is <span class=\"code\"> <em class=\"strong\">true</em> </span>, the faces are deleted after being detached. If <span class=\"code\"> <em class=\"strong\">delete</em> </span> is <span class=\"code\"> <em class=\"strong\">false</em> </span>, the faces are not deleted. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90B\"></a>If <span class=\"code\"> <em class=\"strong\">asMesh</em> </span> is <span class=\"code\"> <em class=\"strong\">true</em> </span>, the faces are detached and returned as a Mesh value. If <span class=\"code\"> <em class=\"strong\">asMesh</em> </span> is <span class=\"code\"> <em class=\"strong\">false</em> </span>, the faces are detached as an element in the mesh and a value of OK is returned.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90C\"></a>First of all, this function is part of a structure called meshop. A structure can\n            be used to group related functions. This function has been implemented using the SDK,\n            but you can organize your own MAXScript functions by putting them into a structure,\n            too. See <span class=\"char_link\"><a href=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E.htm\">Defining Local Functions in Structures</a></span> for more info. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90D\"></a>The name of the function is <span class=\"code\">detachFaces</span>. It is written in <em class=\"strong\">bold</em> because according to the <span class=\"char_link\"><a href=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5.htm\">Syntax Definitions in This Document</a></span> topic, bold denotes code written \"as is\". Actually, the name of the structure (meshop)\n            would have to be in bold too, but this would make it more difficult to read the documentation.\n            Now you can easily spot any function or keyword by quickly browsing a page and looking\n            for bold letters. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90E\"></a>Next, two arguments (parameters) to the function are described. These two arguments\n            are compulsory and the function will issue an error message if the parameters are\n            not supplied or the classes of the provided values do not match the requirements.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC90F\"></a> <span class=\"code\">&lt;Mesh mesh&gt; </span>defines a <em class=\"strong\">rule</em>. Any text written inside of &lt;&gt; describes what should be used in place of the rule.\n            In this case, it tells you to replace the rule with a mesh object. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC910\"></a>The next rule, <span class=\"code\">&lt;facelist&gt;</span>, tells you to provide a list of faces. A face list can be either a regular <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array</a></span> containing indices of the faces to affect, for example #(1,3,10,11,12,13,14,15),\n            or a <span class=\"char_link\"><a href=\"GUID-0F53E04C-0760-4B9C-A1BE-0E53162DE479.htm\">bitArray</a></span> with bits set for any face to be affected, for example, #{1,3,10..15}. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC911\"></a>Then, two <em class=\"strong\">optional parameters</em> are described. While the order of the first two parameters is significant (the function\n            always expects the mesh to be the first and the facelist to be the second parameter),\n            optional named parameters can come in any order - they are recognized by their name.\n            \n         </p>\n         <div><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7F91\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC914\"></a>In the syntax definitions of this document, optional parameters are written inside\n                  of [] brackets. Typically, when defining a function, any <em class=\"strong\">named</em> parameters are optional. This is why in some function definitions, optional parameters\n                  might not have been listed inside of [] brackets. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC916\"></a>When a value is not provided for an optional parameter, the special value of <span class=\"code\"> <em class=\"strong\">unsupplied</em> </span> will be sent to the function instead. The function will check whether the value is\n            supplied or not and replace an <span class=\"code\"> <em class=\"strong\">unsupplied</em> </span> value with a default value. To learn more about <span class=\"code\"> <em class=\"strong\">unsupplied</em> </span> values, see <span class=\"char_link\"><a href=\"GUID-EF3AB642-73A1-4ED3-917B-0DC74FC20D72.htm\">What is the difference between \'undefined\' and \'unsupplied\' values?</a></span> and <span class=\"char_link\"><a href=\"GUID-5A0FC656-A2EC-4F0C-8E75-9FF9ADD4261C.htm\">Unsupplied Value</a></span> topics. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC917\"></a>In the case of the <span class=\"code\"> <em class=\"strong\">delete:</em> </span> parameter, the definition tells you that the name of the parameter should be written\n            as is, and a boolean value (<span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span>) is expected after the colon \'<span class=\"code\"> <em class=\"strong\">:</em> </span>\'. A value of <span class=\"code\"> <em class=\"strong\">true</em> </span> will be assumed by default if the parameter is not supplied. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC918\"></a>Finally, the <span class=\"code\"> <em class=\"strong\">asMesh:</em> </span> parameter is also optional and will be <span class=\"code\"> <em class=\"strong\">false</em> </span> by default if not supplied. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC919\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC91A\"></a><p class=\"table-body\"> <em class=\"strong\">A TYPICAL CALL TO THIS FUNCTION WOULD LOOK LIKE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-66AA\"></a><pre>meshop.detachFaces $MyMesh02 #{1..25}</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC91E\"></a><p class=\"table-body\">In this case, the function is being told to detach faces with indices from 1 to 25\n                        from the EditableMesh object named \"MyMesh02\". The faces will be deleted by default\n                        from the original mesh and a new element inside of MyMesh02 will be created because\n                        the two optional parameters will be used with default values. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC920\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC921\"></a><p class=\"table-body\"> <em class=\"strong\">IF YOU CHANGE THE LINE TO</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-66A9\"></a><pre>meshop.detachFaces $MyMesh02 #{1..10,40..55} delete:false</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC925\"></a><p class=\"table-body\">the faces with indices from 1 to 10 and from 40 to 55 will be cloned to element inside\n                        of the mesh - a new element will be created (asMesh is false by default), but the\n                        original faces will not be deleted from the mesh. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC927\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC928\"></a><p class=\"table-body\"> <em class=\"strong\">IF YOU CHANGE THE CODE AGAIN TO</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-66A8\"></a><pre>newMesh = meshop.detachFaces $MyMesh02 #(1,2,3,4,5,10,11,15) delete:false asMesh:true</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC92C\"></a><p class=\"table-body\">then this time the faces with indices described by the regular array will be cloned\n                        to a new TriMesh without being deleted from the original object. The function will\n                        return the TriMesh value and will store it into the newMesh user variable. See the\n                        second example provided for this function in the <span class=\"char_link\"><a href=\"GUID-EF78FA1A-A382-4BED-BA10-7C856A7551A5.htm\">Meshop Face Methods</a></span> topic for more info on using the returned TriMesh value to create a new object. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";