var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-34349384-3978-4F17-8D45-326326909A35\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"short-circuiting logical expressions\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Short-Circuiting Logical Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-34349384-3978-4F17-8D45-326326909A35\"></a><div class=\"head\">\n            <h1>Short-Circuiting Logical Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EF7\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EF8\"></a>  Following the convention in most other programming languages, logical expressions\n               in MAXScript are short-circuiting or non-strict. This means only enough of the sub-expression\n               is evaluated to determine the overall result:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EFB\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EFD\"></a>If the first operand is <span class=\"code\"> <em class=\"strong\">false</em> </span> in an <span class=\"code\"> <em class=\"strong\">and</em> </span> expression, the result must be <span class=\"code\"> <em class=\"strong\">false</em> </span>, therefore, the second operand is not evaluated.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EFF\"></a>If the first operand is <span class=\"code\"> <em class=\"strong\">true</em> </span> in an <span class=\"code\"> <em class=\"strong\">or</em> </span> expression, the result must be <span class=\"code\"> <em class=\"strong\">true</em> </span>, therefore, the second operand is not evaluated.\n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F00\"></a>This saves execution time and enables <em class=\"strong\">useful shorthand notation</em>.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F01\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F02\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F03\"></a><p class=\"table-body\">if you want to calculate <span class=\"code\"> <em class=\"strong\">\"sin a\" </em> </span>if the value of variable <span class=\"code\"> <em class=\"strong\">a</em> </span> isn’t <span class=\"code\"> <em class=\"strong\">undefined</em> </span>, you can use the following\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6117\"></a><pre>\nif a != undefined and sin a &gt; 0 then...\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F07\"></a><p class=\"table-body\">In a strict language, the <span class=\"code\"> <em class=\"strong\">\"sin a\"</em> </span>evaluation of an <span class=\"code\"> <em class=\"strong\">undefined</em> </span> operand results in an error, and you would need to break up the expression into two\n                           <span class=\"code\"> <em class=\"strong\">if</em> </span> statements:\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6116\"></a><pre>\nif a != undefined then\nif sin a &gt; 0 then ...\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";