var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-34D853AE-9747-4AD8-B587-9311D3320F02\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"What is the difference between \'assignment\' and \'equality\' operators\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>What is the difference between \'assignment\' and \'equality\' operators</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-34D853AE-9747-4AD8-B587-9311D3320F02\"></a><div class=\"head\">\n            <h1>What is the difference between \'assignment\' and \'equality\' operators </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA41\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA42\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; What is the difference between \'=\' and \'==\' operators? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA44\"></a>In MAXScript, there is a VERY BIG difference between these two operators! \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA45\"></a>The \'=\' is the so-called <span class=\"char_link\"><a href=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04.htm\">assignment operator</a></span> and is used to assign the result of the expression on the right side of the operator\n            to the variable on the left side. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA46\"></a>The \'==\' is the so-called <span class=\"char_link\"><a href=\"GUID-FD8FF72C-629C-4004-A42A-55189B0641F2.htm\">equality comparison operator</a></span> and is used to check whether the two expressions on both sides are equal or not.\n            It returns <span class=\"code\">true</span> of they are equal, and <span class=\"code\">false</span> if they are not. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA47\"></a>It is a common error to mistype \'==\' as \'=\' which can lead to errors in IF comparisons,\n            non-initialized variables etc. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA48\"></a>In the following example, the variable a is set to 1. In the IF expression, \'a\' should\n            be compared to 0, but it is assigned by mistake the value 0 instead. The result of\n            the expression is not a boolean value (true or false) and an error message is generated\n            to inform you about the problem: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA49\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA4A\"></a><p class=\"table-body\"> <em class=\"strong\">TYPICAL ERROR:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-668D\"></a><pre>\na = 1\nif a = 0 then print \"A is Zero!\" else print \"A is not Zero!\"\n-- Type error: if-test requires BooleanClass, got: 0\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA50\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA51\"></a><p class=\"table-body\"> <em class=\"strong\">CORRET CODE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-668C\"></a><pre>\na = 1\nif a == 0 then print \"A is Zero!\" else print \"A is not Zero!\"\n--&gt;\"A is not Zero!\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA57\"></a>In the second version, the variable \'a\' is set to 1. In the IF expression, \'a\' is\n            correctly compared to 0. The result of the expression is a boolean value (false) and\n            the expected result is printed. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA59\"></a> <span class=\"char_link\"><a href=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04.htm\">Variable Assignment</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA5A\"></a> <span class=\"char_link\"><a href=\"GUID-FD8FF72C-629C-4004-A42A-55189B0641F2.htm\">Comparison Expressions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA5B\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";