var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-354B1DA2-6573-40FA-AE1E-5AF191E0056C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MatEditor - Open and Close the Material Editor\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MatEditor - Open and Close the Material Editor</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-354B1DA2-6573-40FA-AE1E-5AF191E0056C\"></a><div class=\"head\">\n            <h1>MatEditor - Open and Close the Material Editor </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38FE\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38FD\"></a> Provides properties and methods to open and close the Material Editor, query whether\n               it is open and get and set its mode. These methods apply to both the Compact (Legacy)\n               Material Editor and the Schematic Material Editor introduced in \n               		  <em class=\"strong\">3ds Max 2011</em>. \n               		\n            </p> \n            <p><a name=\"GUID-96A6DC61-517D-4CBE-ABF4-F94F175DE3E7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38FB\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB2\"></a><pre><em class=\"codeEmphasisStrong\">MatEditor.mode</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F9\"></a> Get/set the Material Editor Mode. Available in \n               		  <em class=\"strong\">3ds Max 2011 and higher</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F8\"></a>Possible values are: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F7\"></a> <em class=\"strong\">#basic</em>- Compact (legacy) Material Editor. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F6\"></a> <em class=\"strong\">#advanced</em> - Slate Material Editor. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F5\"></a>This property duplicates the \n               		  <span class=\"code\"> <em class=\"strong\">maxOps.mtldlgMode</em> </span> property\'s functionality, but does not accept integer values (0 or 1) in place of\n               the \n               		  <span class=\"code\"> <em class=\"strong\">#basic</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">#advanced</em> </span> enums. It is provided in the \n               		  <span class=\"code\"> <em class=\"strong\">MatEditor</em> </span> struct for convenience. \n               		\n            </p> \n            <p><a name=\"GUID-0F062F41-0204-4AB8-B23B-397E626A33D8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F4\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB1\"></a><pre><em class=\"codeEmphasisStrong\">MatEditor.Open</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38F2\"></a>Opens the Compact Material Editor or Slate Material Editor, depending on the current\n               mode (see property above). \n               		\n            </p> \n            <p><a name=\"GUID-86887C89-4DC0-4268-BCC0-0838C5DE8A80\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB0\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">MatEditor.isOpen</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38EF\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if either the Compact or the Slate Material Editor is open. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38EE\"></a>Returns false if the Material Editor is closed. \n               		\n            </p> \n            <p><a name=\"GUID-8696D72C-6113-47DC-A597-3CBE24899F6B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DAF\"></a><pre><em class=\"codeEmphasisStrong\">MatEditor.Close</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38EB\"></a>Closes the Material Editor regardless of its mode. \n               		\n            </p> \n            <p><a name=\"GUID-D4E725B3-8740-40CF-B488-6D1BAEB070CA\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E9\"></a> <em class=\"strong\">Related Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DAE\"></a><pre><em class=\"codeEmphasisStrong\">SME.Open()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E7\"></a> Opens specifically the Slate Material Editor. Available in \n               		  <em class=\"strong\">3ds Max 2011 and higher</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E6\"></a>If the Compact Material Editor is open, it will be closed automatically. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E5\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-7E144C67-4F97-4A2A-924E-711870C7DF6E.htm\">Interface: SME</a></span> for all SME-related methods. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E2\"></a> <span class=\"char_link\"><a href=\"GUID-E1FA38D3-D03C-4A33-9C5A-C2DA3B21EFAF.htm\">Material Editor</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E1\"></a> <span class=\"char_link\"><a href=\"GUID-0763253E-5392-4078-9B0B-E6CA3ACD32A2.htm\">Interface: medit</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38E0\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">maxOps Material Editor Mode</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38DF\"></a> <span class=\"char_link\"><a href=\"GUID-7E144C67-4F97-4A2A-924E-711870C7DF6E.htm\">Interface: SME</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";