var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"defining\">\n      <meta name=\"indexterm\" content=\"function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Defining Local Functions in Structures</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E\"></a><div class=\"head\">\n            <h1>Defining Local Functions in Structures </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87501\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87502\"></a>  You can define local functions in structures, providing a convenient mechanism for\n               packaging a set of related functions and avoiding possible name conflicts when many\n               global functions are defined, possibly by several separate scripts. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87505\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87506\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6071\"></a><pre>\nstruct foo\n(\na, b, c,\nfn baz n = sqrt (n + 1),\nfn bar x y = print (x ^ 2 + y ^ 2)\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8750F\"></a><p class=\"table-body\">This defines a structure definition <span class=\"code\"> <em class=\"strong\">foo</em> </span> with three elements named <span class=\"code\"> <em class=\"strong\">a</em> </span>, <span class=\"code\"> <em class=\"strong\">b</em> </span>, and <span class=\"code\"> <em class=\"strong\">c</em> </span>, and two local functions: <span class=\"code\"> <em class=\"strong\">bar</em> </span> and <span class=\"code\"> <em class=\"strong\">baz</em> </span>. You can access these functions as properties of either the structure definition\n                           value itself or an instance of the foo structure: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6070\"></a><pre>\np = foo.baz q -- access as property of the structure definition value\nfoo.bar x y\nf = foo 2 3 4\nf.bar x y -- access as property of the structure instance\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87517\"></a>Local functions declared in a structure definition can make references to the member\n               data variables defined in the structure, such that when that member function in some\n               instance of the structure is called, the references access the members of that instance.\n               This allows you to initialize and maintain data structures for the structure functions\n               within the structure itself. An example of including functions that use members of\n               the structure is shown in the following script. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87518\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87519\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606F\"></a><pre>\nstruct RandVals\n(\nRndVals=#(), ptr, eedVal,\nfn generateRV num fromVal toVal =\n(\nif seedVal != undefined do seed seedVal\nRndVals=for i=1 to num collect random fromVal toVal\nptr=1\nRndVals\n),\nfn deleteRv =\n(\nRndVals=#()\nptr=undefined\nundefined\n),\nfn getNextRV =\n(\nif Nvals == 0 do return undefined\nval=RndVals[ptr]\nptr += 1\nif ptr &gt;RndVals.count do ptr=1\nval\n),\nfn sortRV =(sort RndVals),\nfn setSeed val = (SeedVal = val),\nfn setPointer val =\n(\nif val &gt; 0 and val &lt;= RndVals.count then\n(ptr=val;true)\nelse\nfalse\n)\n)\nMyRandomVals= RandVals()\nMyRandomVals.setSeed 12345\nMyRandomVals.generateRV 10 0 100\nMyRandomVals.getNextRV()\nMyRandomVals.sortRV()\nMyRandomVals.setPointer 1\nMyRandomVals.getNextRV()\nMyRandomVals.deleteRv()\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87546\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606E\"></a><pre>\n#Struct:RandVals( -- result of struct def lines 1 to 29\n  RndVals:&lt;data&gt;; Public,\n  sortRV:&lt;fn&gt;; Public,\n  ptr:&lt;data&gt;; Public,\n  seedVal:&lt;data&gt;; Public,\n  generateRV:&lt;fn&gt;; Public,\n  deleteRv:&lt;fn&gt;; Public,\n  getNextRV:&lt;fn&gt;; Public,\n  setSeed:&lt;fn&gt;; Public,\n  setPointer:&lt;fn&gt;; Public)\n(RandVals RndVals:#() ptr:undefined seedVal:undefined) -- result line 30\n12345 -- result line 31\n#(23, 59, 79, 68, 17, 72, 84, 16, 89, 72) -- result line 32\n23 -- result line 33\n#(16, 17, 23, 59, 68, 72, 72, 79, 84, 89) -- result line 34\ntrue -- result line 35\n16 -- result line 36\nundefined -- result line 37\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8755C\"></a>In this script, the structure has three data members and six function members. Note\n               the references to the structure data members in the <span class=\"code\"> <em class=\"strong\">generateRV()</em> </span> function. In line 30, an instance of the <span class=\"code\"> <em class=\"strong\">RndVals</em> </span> structure is created and stored in variable <span class=\"code\"> <em class=\"strong\">MyRandomVals</em> </span>. In line 31, the <span class=\"code\"> <em class=\"strong\">setSeed()</em> </span> function in the structure instance is called, which initializes the random seed variable\n               by storing the specified value in data member <span class=\"code\"> <em class=\"strong\">seedVal</em> </span> in the structure instance. In line 32, the <span class=\"code\"> <em class=\"strong\">generateRV()</em> </span> function in the structure instance is called, which initializes the random number\n               using the seed value specified by <span class=\"code\"> <em class=\"strong\">setSeed()</em> </span>, sets up and stores an array of random numbers in data member <span class=\"code\"> <em class=\"strong\">RndVals</em> </span>, updates data member <span class=\"code\"> <em class=\"strong\">ptr</em> </span>, and then returns the random number array. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8755D\"></a>Local functions defined in structures are not stored in every instance of the structure.\n               The local function is stored once in the structure definition and references to them\n               in the instances refer to their definitions in the structure definition. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8755F\"></a> <span class=\"char_link\"><a href=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6.htm\">Structure Definition</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87560\"></a> <span class=\"char_link\"><a href=\"GUID-D5426B3F-7060-4C02-BA75-CB24A66B2ABD.htm\">Structure Inherited Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87561\"></a> <span class=\"char_link\"><a href=\"GUID-4B31E2CC-8862-4C19-AA07-2DDED173757C.htm\">Structure Scope While Initializing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87562\"></a> <span class=\"char_link\"><a href=\"GUID-A3A4E597-B4D7-4C38-90A6-E8F78203114E.htm\">Structure Creation and Cloning Event Handlers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87563\"></a> <span class=\"char_link\"><a href=\"GUID-0D3592DD-2F20-4A41-B19F-544426B8186E.htm\">Private and Public Members in Structure Definitions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";