var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-37D4FFFF-1BF1-4B51-B9C5-99D5E20E1D30\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"TabbedDialogs - Controlling Tabbed Dialogs\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>TabbedDialogs - Controlling Tabbed Dialogs</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-37D4FFFF-1BF1-4B51-B9C5-99D5E20E1D30\"></a><div class=\"head\">\n            <h1>TabbedDialogs - Controlling Tabbed Dialogs </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3044\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3040\"></a>These methods let you control <em class=\"strong\">3ds Max</em> tabbed dialogs like Rendering, Environment and Effects, Object Properties, Configure\n               Paths, and so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-303F\"></a> <em class=\"strong\">Specs:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-303E\"></a>The following specs define what a valid argument looks like for the tabbedDialogs\n               methods. MAXScript does not have a class that corresponds to Class_ID, so these are\n               passed as a two element array of integers. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C44\"></a><pre>tabbedDialogSpec ::= ( #<em class=\"codeEmphasisStrong\">render</em> | #<em class=\"codeEmphasisStrong\">renderVP</em> | #<em class=\"codeEmphasisStrong\">envEffects</em> | #<em class=\"codeEmphasisStrong\">objProp</em> | #<em class=\"codeEmphasisStrong\">preferences</em> | #<em class=\"codeEmphasisStrong\">configPath</em> | #(&lt;int&gt;,&lt;int&gt;) )\n\n#(&lt;int&gt;,&lt;int&gt;) is Class_ID of tabbed dialog\ntabPageSpec ::= ( &lt;int&gt; | #(&lt;int&gt;,&lt;int&gt;) )\n&lt;int&gt; is index in dialog (1-based)\n#(&lt;int&gt;,&lt;int&gt;) is Class_ID of tab page\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3038\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C42\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.isOpen</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3036\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified dialog is open. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3035\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3034\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3033\"></a><p class=\"table-body\">The <span class=\"code\"> <em class=\"strong\">tabbedDialogs.isOpen</em> </span> method must be called before calling any of the other methods. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3032\"></a><p class=\"table-body\">If the specified dialog is not open, the remainder of the methods will not perform\n                           any action or throw an error, and those methods that return a value will return \'undefined\'.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C41\"></a><pre>&lt;#(&lt;int&gt;,&lt;int&gt;)&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.getDialogID</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-302F\"></a>Returns the Class_ID of the specified tabbed dialog. \n            </p> \n            <p><a name=\"GUID-E0670719-4C46-4F45-9497-9E7A5251C03E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C40\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.invalidate</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-302C\"></a>Invalidates all pages in the dialog. \n            </p> \n            <p><a name=\"GUID-717A91B0-F0FE-4E8A-8534-F05243005428\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3F\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.OkToCommit</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3029\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if all pages in dialog are ok to commit changes. Used for modal dialogs with IDOK\n               and IDCANCEL. \n            </p> \n            <p><a name=\"GUID-B25ED1B6-9CE2-4ED8-BA7B-77AC35DB7E0E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3E\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.CommitPages</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3026\"></a>Commits changes in all pages. Used for modal dialogs with IDOK and IDCANCEL. \n            </p> \n            <p><a name=\"GUID-590ED007-1A4F-4CFA-9EDD-20B96C3E27F7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3D\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.CloseDialog</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3023\"></a>Closes the dialog. \n            </p> \n            <p><a name=\"GUID-1ED208B8-3A60-4BD6-B219-7A82F798B536\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3C\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.CancelDialog</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3020\"></a>Cancels the dialog. \n            </p> \n            <p><a name=\"GUID-3551B4CE-01DD-4283-BCCE-E3C5277134F8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3B\"></a><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.getNumPages</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-301D\"></a>Returns the number of tab pages in the specified dialog. \n            </p> \n            <p><a name=\"GUID-55AA2554-5592-40AD-9B61-5396180C8C84\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C3A\"></a><pre>&lt;#(&lt;int&gt;,&lt;int&gt;)&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.getPageID</em> &lt;tabbedDialogSpec&gt; &lt;tabPageSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-301A\"></a>Returns the Class_ID of the specified tab page. \n            </p> \n            <p><a name=\"GUID-491E0E57-3953-4705-AAD4-1B13310A036D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C39\"></a><pre>&lt;#(&lt;int&gt;,&lt;int&gt;)&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.getCurrentPage</em> &lt;tabbedDialogSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3017\"></a>Returns the Class_ID of the current tab page. \n            </p> \n            <p><a name=\"GUID-9B2C8049-3391-4E78-AB3E-258518116AA3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C38\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.setCurrentPage</em> &lt;tabbedDialogSpec&gt; &lt;tabPageSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3014\"></a>Sets the specified tab page as the current tab page. \n            </p> \n            <p><a name=\"GUID-E7449C4F-7488-453A-AF14-63E822E8A21B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C37\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.invalidatePage</em> &lt;tabbedDialogSpec&gt; &lt;tabPageSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3011\"></a>Invalidates the specified tab page. \n            </p> \n            <p><a name=\"GUID-3F989E33-BB72-4C7C-81DE-119A2766CEB7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C36\"></a><pre><em class=\"codeEmphasisStrong\">tabbedDialogs.getPageTitle</em> &lt;tabbedDialogSpec&gt; &lt;tabPageSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-300E\"></a>Returns the tab title for the specified tab page. This title is localized. \n            </p> \n            <p><a name=\"GUID-7E8C5F9E-05D9-4B8A-A6C1-B13A9E947FF3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C35\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">tabbedDialogs.isPage</em> &lt;tabbedDialogSpec&gt; &lt;tabPageSpec&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-300B\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified tab page is present in the dialog. \n            </p> \n            <p><a name=\"GUID-F5EE587C-7BC5-408D-9654-1CC95C55A34C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3009\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3008\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C34\"></a><pre>\n--Switch to Adv.Lighting tab if Render Scene dialog is open:\nif tabbedDialogs.isOpen #render do\ntabbedDialogs.setCurrentPage #render #(1758358594, 1812881699)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3000\"></a> <span class=\"char_link\"><a href=\"GUID-27B7B613-AE4B-48C5-B26B-FB7D8369299C.htm\">envEffectsDialog - Open and Close the Environment and Effects dialog</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FFF\"></a> <span class=\"char_link\"><a href=\"GUID-12B3ED06-A78F-4D92-8127-BB94F00AC841.htm\">renderSceneDialog</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";