var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-38D6774C-2377-4976-BDA1-A56C88620537\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Sort a MultiMaterial By Material ID?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-38D6774C-2377-4976-BDA1-A56C88620537\"></a><div class=\"head\">\n            <h1>How do I Sort a MultiMaterial By Material ID? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD9C\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD9E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD9F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8C7\">Accessing Object Properties</a></span> &gt; How do I Sort a MultiMaterial By Material ID? \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA1\"></a>Since \n            		<em class=\"strong\">3ds Max 4</em>, material IDs can be specified independently from the sub-material order inside a\n            MultMaterial. The material IDs can get messy after a long process of adding sub-materials.\n            Especially when giving a scene to other people, it might be a good idea to reorder\n            the sub-materials by sorting the Material IDs in ascending order for easier access.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA2\"></a>The following function performs this operation using a simple bubble sort algorithm\n            without using the built-in \n            		<span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm#WS73099CC142F487553098682E12AC2FC2BC7-5E3A\">sort</a></span> or \n            		<span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm#WS73099CC142F487553098682E12AC2FC2BC7-5E39\">qsort</a></span> functions provided by MAXScript. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA3\"></a>A bubble sort algorithm compares two values and switches their places when their order\n            is not right. It repeats this process until no changes are required anymore. The name\n            of the method is based on the fact that entries with low values tend to float up \"to\n            the surface\" while higher values fall down \"to the bottom\". \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA4\"></a>The function sets a flag variable and repeats a while loop until the flag is set to\n            true. The flag will be set to false whenever two materials have switched places denoting\n            that the sorting is not over yet. Inside the while loop, a for loop will run through\n            the sub-materials and compare pairs of neighbor Material ID values. When the current\n            value is higher than the following one, then their IDs, the respective sub-materials,\n            the names and the enable switches have to change places. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDA6\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-665A\"></a><pre>\nfn sortMultiSubById m =\n(\nif classof m == MultiMaterial then--make sure the material is MultiMaterial\n(\n&nbsp;local sorted = false--initialize a local variable as a sort status flag\n&nbsp;while not sorted do--repeat until the flag is set to true\n&nbsp;(\n&nbsp;&nbsp;sorted = true--set the flag to true in the beginning\n&nbsp;&nbsp;--loop though all sub-materials except the last one:\n&nbsp;&nbsp;for i = 1 to m.numsubs-1 do\n&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;--if the MatID of the current sub-material is greater than the next one...\n&nbsp;&nbsp;&nbsp;if m.materialIDList[i] != undefined and m.materialIDList[i+1] and m.materialIDList[i] &gt; m.materialIDList[i+1] do\n&nbsp;&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;&nbsp;--store the current material in a temp. variable\n&nbsp;&nbsp;&nbsp;&nbsp;tmp = m.materialList [i]\n&nbsp;&nbsp;&nbsp;&nbsp;--copy the next material into the current one\n&nbsp;&nbsp;&nbsp;&nbsp;m.materialList [i] = m.materialList[i+1]\n&nbsp;&nbsp;&nbsp;&nbsp;--copy the current material into the next one using the temp var.\n&nbsp;&nbsp;&nbsp;&nbsp;m.materialList[i+1] = tmp\n&nbsp;&nbsp;&nbsp;&nbsp;--do the same with the material IDs\n&nbsp;&nbsp;&nbsp;&nbsp;tmp = m.materialIDList[i]\n&nbsp;&nbsp;&nbsp;&nbsp;m.materialIDList[i] = m.materialIDList[i+1]\n&nbsp;&nbsp;&nbsp;&nbsp;m.materialIDList[i+1] = tmp\n&nbsp;&nbsp;&nbsp;&nbsp;--then copy the states of the enable checkboxes\n&nbsp;&nbsp;&nbsp;&nbsp;tmp = m.mapEnabled[i]\n&nbsp;&nbsp;&nbsp;&nbsp;m.mapEnabled[i] = m.mapEnabled[i+1]\n&nbsp;&nbsp;&nbsp;&nbsp;m.mapEnabled[i+1] = tmp\n&nbsp;&nbsp;&nbsp;&nbsp;--and finally switch the places of the user-defined names.\n&nbsp;&nbsp;&nbsp;&nbsp;tmp = m.names[i]\n&nbsp;&nbsp;&nbsp;&nbsp;m.names[i] = m.names[i+1]\n&nbsp;&nbsp;&nbsp;&nbsp;m.names[i+1] = tmp&nbsp;\n&nbsp;&nbsp;&nbsp;&nbsp;--set the flag to false as we switched places, ergo sorting goes on\n&nbsp;&nbsp;&nbsp;&nbsp;sorted = false\n&nbsp;&nbsp;&nbsp;)--end if&nbsp;\n&nbsp;&nbsp;)--end for\n&nbsp;)--end while\n)--end if\n)--end fn\n&nbsp;\n-- Sample usage:\nsortMultiSubById $Box001.material\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDD5\"></a> <span class=\"char_link\"><a href=\"GUID-7ECB1E85-6199-4143-BEDA-3B26DD35E0C3.htm\">MultiMaterial : Material</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCDD6\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";