var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-39A9FDB8-E508-413F-BF58-EC8F52BE7CA9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"dictionary values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Dictionary Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-39A9FDB8-E508-413F-BF58-EC8F52BE7CA9\"></a><div class=\"head\">\n            <h1>Dictionary Values</h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A04\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A03\"></a><p class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> &gt; Dictionary Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> Available in \n            		<em class=\"strong\">3ds Max 2017.1 Update and higher</em>: A Dictionary is a collection of key/value pairs, also known as an associative array.\n            Keys can be of type name, string, or integer. For a given dictionary, the key type\n            specified at the time of creation, and is always the same. The value can be of any\n            type. \n            	 \n         </p>\n         <p>Dictionaries support iteration in a for loop, where each element is processed as a\n            \n            		<span class=\"code\">DataPair</span>. Each \n            		<span class=\"code\">DataPair</span> contains the key as \n            		<span class=\"code\">v1</span>, the value as \n            		<span class=\"code\">v2</span>, the \n            		<span class=\"code\">value1_name</span> of \n            		<span class=\"code\">#key</span>, and \n            		<span class=\"code\">value2_name</span> of \n            		<span class=\"code\">#value</span>. \n            	 \n         </p><a name=\"TABLE_140D2E542E894E5B92C27907E6AA0DA1\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">Example</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>d = Dictionary #(#ss, 1) #(#tt, 2)\nfor ele in d do print ele</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">Results</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>Dictionary #name ss:1 tt:2 \n(DataPair key:#ss value:1)\n(DataPair key:#tt value:2)\nOK</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>The Dictionary value class can be specified in a persistent global variable. All values\n            in the Dictionary must be specifiable as a persistent global variable in order for\n            the Dictionary to be fully restored on scene file load. \n            	 \n         </p>\n         <p><em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><pre>Dictionary() -- empty dictionary of type #name\nDictionary (#integer | #name | #string) -- empty dictionary of the specified type\nDictionary {#(key, value)}+ -- one or more two-value arrays\nDictionary {key:value}+ -- one or more explicit key:value pairs\nDictionary {(DataPair key value)} -- one or more DataPair objects</pre></div>\n         <p>Dictionaries can be constructed using different types at once, for example with an\n            array and a \n            		<span class=\"code\">DataPair</span>, but the key type must always be the same. \n            	 \n         </p>\n         <p>The default key type for a dictionary is \n            		<span class=\"code\">#name</span>. If the dictionary constructor uses \n            		<span class=\"code\">DataPairs</span>, the key type is the type of the first \n            		<span class=\"code\">DataPair</span>\'s key value. All remaining \n            		<span class=\"code\">DataPairs</span> must have the same key value type. If the dictionary constructor uses Arrays, the\n            key type is the type of the first Array’s element 1 value. All remaining Arrays must\n            have the same element 1 value type. If keyword arguments are used, their key type\n            is \n            		<span class=\"code\">#name</span>. For dictionaries of type \n            		<span class=\"code\">#integer</span>, the actual key value type can be any of \n            		<span class=\"code\">Integer</span>, \n            		<span class=\"code\">IntegerPtr</span>, or \n            		<span class=\"code\">Integer64</span>, interchangeably. \n            	 \n         </p>\n         <p><em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;dictionary&gt;.count : Integer, read-only</pre></div>\n         <p>A count of items in the dictionary \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;dictionary&gt;.type read-only </pre></div>\n         <p>The type of the dictionary, which can be \n            		<span class=\"code\">#name</span>, \n            		<span class=\"code\">#string</span>, \n            		<span class=\"code\">#integer</span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;dictionary&gt;.keys : Array, read-only</pre></div>\n         <p>An array of the dictionary\'s keys. Note: changing this array does not affect the dictionary.\n            \n            	 \n         </p>\n         <p><em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;dictionary&gt;[key] </pre></div>\n         <p>Gets the value for \n            		<span class=\"code\">key</span>. If there is not an entry for the key, the value \n            		<span class=\"code\">undefined</span> is returned. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;dictionary&gt;[key] = &lt;value&gt;</pre></div>\n         <p>Sets the value for key. An existing entry does not need to exist for the key. \n            	 \n         </p>\n         <p><em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><pre>GetDictValue &lt;dictionary&gt; &lt;key &gt;</pre></div>\n         <p>Gets a value from the dictionary based on \n            		<span class=\"code\">key</span>. If there is no entry for the key, a value of undefined is returned. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SetDictValue &lt;dictionary&gt; &lt;key &gt; &lt;value&gt;</pre></div>\n         <p>Sets the value for an existing entry in dictionary based on \n            		<span class=\"code\">key</span>. If there is no entry for the key, nothing happens. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>PutDictValue &lt;dictionary&gt; &lt;key &gt; &lt;value&gt; putOnlyIfNew:&lt;bool&gt; -- defaults false</pre></div>\n         <p>Puts a value in dictionary based on key. \n            	 \n         </p>\n         <p>If \n            		<span class=\"code\">putOnlyIfNew</span> is true, the value is added only if there is no existing entry for the key. If \n            		<span class=\"code\">putOnlyIfNew</span> is false, the value is added even if there is an existing entry for the key. If there\n            is an entry, its value is set. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>RemoveDictValue &lt;dictionary&gt; &lt;key &gt;</pre></div>\n         <p>Removes the existing entry in the dictionary based on \n            		<span class=\"code\">key</span>. If there is no entry for the key, nothing happens. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>HasDictValue &lt;dictionary&gt; &lt;key &gt;</pre></div>\n         <p>Returns whether there is an existing entry in the dictionary for the given \n            		<span class=\"code\">key</span>. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>GetDictKeys &lt;dictionary&gt;</pre></div>\n         <p>Returns an array of key values in the dictionary. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>GetDictKeyType &lt;dictionary&gt;</pre></div>\n         <p>Returns the key type of the dictionary - \n            		<span class=\"code\">#name</span>, \n            		<span class=\"code\">#string</span>, or \n            		<span class=\"code\">#integer</span>. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>copy &lt;dictionary&gt; [#nomap]</pre></div>\n         <p>Creates a shallow copy of the dictionary. Note that unlike with other collection types,\n            \n            		<span class=\"code\">copy()</span> always makes a shallow copy of Dictionaries, the \n            		<span class=\"code\">#nomap</span> option is not actually required. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>deepCopy &lt;dictionary&gt;</pre></div>\n         <p> Creates a deep copy of the dictionary. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. The dictionary is recursively traversed, and new copies are generated of all items\n            in the dictionary. Note that if the dictionary contains multiple references to a single\n            value, the deep copy will contain multiple references to a single, new value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>free &lt;dictionary&gt;</pre></div>\n         <p>Frees the internal memory associated with the dictionary. This effectively removes\n            all items from the dictionary. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";