var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-3A44E400-8175-4A99-A53B-68192403819C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"sortKeys()\">\n      <meta name=\"indexterm\" content=\"moveKeys()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Values\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: sortKeys()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: moveKeys()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: deleteKeys()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: deleteKey()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: append()\">\n      <meta name=\"indexterm\" content=\"MAXKeyArray Methods: addNewKey()\">\n      <meta name=\"indexterm\" content=\"deleteKeys()\">\n      <meta name=\"indexterm\" content=\"deleteKey()\">\n      <meta name=\"indexterm\" content=\"deleteItem()\">\n      <meta name=\"indexterm\" content=\"collections\">\n      <meta name=\"indexterm\" content=\"append()\">\n      <meta name=\"indexterm\" content=\"addNewKey()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXKeyArray Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3A44E400-8175-4A99-A53B-68192403819C\"></a><div class=\"head\">\n            <h1>MAXKeyArray Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7559\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7558\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> &gt; MAXKeyArray Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7556\"></a>A <em class=\"strong\">MAXKeyArray</em> represents all the keyframe keys in a <em class=\"strong\">3ds Max </em>controller track. \n         </p>\n         <p><a name=\"P_9842BED4F3D640C888710674C28E5877\"></a>See also <span class=\"char_link\"><a href=\"GUID-5ED6F7E0-33CC-4F4E-972E-094EB33BEA85.htm\">MAXKey Values</a></span>, <span class=\"char_link\"><a href=\"GUID-B015A2D1-AC4D-4773-99F1-78115ACC944D.htm\">Working with MAXKey Values</a></span>, and <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span>. \n         </p>\n         <p><a name=\"P_631A95BD256B43508DA3606C962A7143\"></a>MAXKeyArray values are <em class=\"strong\">mappable</em>. \n         </p>\n         <p><a name=\"P_BAA8DFD78CBA41B1BE9764A4D4FF39F2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7555\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9F\"></a><pre>&lt;node&gt;.&lt;animatable_property&gt;.<em class=\"codeEmphasisStrong\">keys</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7553\"></a>The key array can be accessed using the <span class=\"code\"> <em class=\"strong\">keys</em> </span> property on an animated<em class=\"strong\"> 3ds Max</em> object property. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7552\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7551\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9E\"></a><pre>\n$foo.position.keys\n$foo.twist.angle.keys\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-754C\"></a>If the<em class=\"strong\"> 3ds Max </em>object parameter is not yet animated (no controller has been assigned to the parameter),\n            a value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n         </p>\n         <p><a name=\"P_5BB0CFBAF98F4F51B1B7EE53F9AFA242\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9D\"></a><pre>&lt;controller&gt;.<em class=\"codeEmphasisStrong\">keys</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7549\"></a>The key array can be accessed using the<span class=\"code\"> <em class=\"strong\"> keys </em> </span>property on a controller. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7548\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7547\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9C\"></a><pre>\n$foo.position.controller.keys\n$foo[3][1].keys\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_40695F67E1AE4F1DBE0337D8D45100EB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7542\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9B\"></a><pre>&lt;key_array&gt;.<em class=\"codeEmphasisStrong\">count </em>: Integer, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7540\"></a>Returns the number of keys in the key array. \n         </p>\n         <p><a name=\"P_788B2FEA9BCA4683A012BB06AD3CC767\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-753F\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D9A\"></a><pre>&lt;key_array&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;index_integer&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-753D\"></a>Returns a <span class=\"char_link\"><a href=\"GUID-5ED6F7E0-33CC-4F4E-972E-094EB33BEA85.htm\">MAXKey</a></span> value representing the indexed key in the key array. Indexes start at 1. \n         </p>\n         <p><a name=\"P_D9ABC56B77F446FCA355D8FC209445DE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-753C\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D99\"></a><pre><em class=\"codeEmphasisStrong\">append</em> &lt;key_array&gt; &lt;key&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-753A\"></a>Appends key to key array. \n         </p>\n         <p><a name=\"P_E628468A3689409AA4A50F1F8D4CDF31\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D98\"></a><pre><em class=\"codeEmphasisStrong\">deleteItem</em> &lt;key_array&gt; &lt;index_integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7537\"></a>Deletes the indexed key. Key indexes are<em class=\"strong\"> 1-based</em>. \n         </p>\n         <p><a name=\"P_A324201DC5304F66ADF59237E1C67238\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D97\"></a><pre><em class=\"codeEmphasisStrong\">addNewKey</em> &lt;key_array&gt; &lt;time&gt; [<em class=\"codeEmphasisStrong\"> #select</em> ] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7534\"></a>Adds a new key to the key array at the time specified. The value for the new key is\n            the interpolated controller value at the specified time. \n         </p>\n         <p><a name=\"P_2F88ECF463344924BCD02C6310585A73\"></a>The new key is also selected if the <span class=\"code\"> <em class=\"strong\">#select</em> </span> optional argument is specified. \n         </p>\n         <p><a name=\"P_E1294CB0049A419C943334D11646EA01\"></a>The value for the new key is the interpolated controller value at that time.<span class=\"code\"> <em class=\"strong\"> addNewKey()</em> </span> will not add a key if a key already exists at the specified time. \n         </p>\n         <p><a name=\"P_099EAC7F37EF40F692A003DEB4F898BD\"></a>The return value in this case is the key located at the specified time. \n         </p>\n         <p><a name=\"P_329CFE9AC8EC4796BC84BE96CF0A447E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D96\"></a><pre><em class=\"codeEmphasisStrong\">deleteKeys </em>&lt;key_array&gt; [ <em class=\"codeEmphasisStrong\">#allKeys</em> ] [ <em class=\"codeEmphasisStrong\">#selection</em> ] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7531\"></a>Deletes keys from the controller according to the optional symbolic argument supplied.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7530\"></a> <span class=\"code\"> <em class=\"strong\">#allKeys</em> (default)</span>: deletes<em class=\"strong\"> all</em> keys in the controller. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-752F\"></a> <span class=\"code\"> <em class=\"strong\">#selection</em> </span>: deletes the currently selected keys. \n         </p>\n         <p><a name=\"P_8107653BDE3143B3A39D60A0183DE9EF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D95\"></a><pre><em class=\"codeEmphasisStrong\">deleteKey</em> &lt;key_array&gt; &lt;index_integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-752C\"></a>Deletes the indexed key. Key indexes are <em class=\"strong\">1-based</em>. \n         </p>\n         <p><a name=\"P_BDE648612F52485FB315087FD2DA0DB8\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D94\"></a><pre><em class=\"codeEmphasisStrong\">moveKeys </em>&lt;key_array&gt; &lt;time&gt; [ <em class=\"codeEmphasisStrong\">#selection </em>] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7529\"></a>Moves all keys by the time given. If <span class=\"code\"> <em class=\"strong\">#selection </em> </span>is specified, move the current selection. Otherwise, move all keys. \n         </p>\n         <p><a name=\"P_682DD60D717849E3BCFD4FB7EC5364B2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D93\"></a><pre><em class=\"codeEmphasisStrong\">sortKeys</em> &lt;key_array&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7526\"></a>Re-sorts keys according to their times. Some MAXKey operations can result in out of\n            order keys and this function must be called to correctly order keys. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-190B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7522\"></a>All of the above methods might re-sequence keys in the key array and cause existing\n                  keys to take on <em class=\"strong\">different </em>indexes because key array indexes are time positional. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7521\"></a>Take care when inserting and deleting keys into arrays that have individual keys in\n                  variables and other containers. MAXKey values are defined internally in terms of this\n                  index and might point to<em class=\"strong\"> different </em>keys if you re-arrange the keys in a controller. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-751F\"></a>MAXKeyArrays also support mapped property assignment in their contents in the same\n            way that pathname and array collections do in their contents. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-751E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-751D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D92\"></a><pre>\nb = box()\nc = cylinder()\nfor i = 1 to 3 do\nb.pos.controller[i].controller.keys.time += 10f\n--bumps all position key times by 10 frames,\n--this is necessary because Position_XYZ has 3 sub-controllers\n\nc.bend.angle.keys.value *= 1.2\n--scales all the bend angle key values up by 1.2.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7511\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7510\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D91\"></a><pre>\nkeys = $box01.bend.angle.keys\nfor t in 0f to 100f by 10f do \naddNewKey keys t\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";