var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-3DC75DDE-E4BC-4033-ABA9-A42063036CB9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"macros struct\">\n      <meta name=\"indexterm\" content=\"macro scripts\">\n      <meta name=\"indexterm\" content=\"load() - macros\">\n      <meta name=\"indexterm\" content=\"new() - macros\">\n      <meta name=\"indexterm\" content=\"run() - macros\">\n      <meta name=\"indexterm\" content=\"edit() - macros\">\n      <meta name=\"indexterm\" content=\"list() - macros\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Macro Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3DC75DDE-E4BC-4033-ABA9-A42063036CB9\"></a><div class=\"head\">\n            <h1>Macro Scripts </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AE9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AE8\"></a>   The Macro Script functions are in a structure package named macros. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AE4\"></a>These functions allow you to access and run Macro Scripts. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AE3\"></a>See <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> for information on creating Macro Scripts. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AE1\"></a>The Macro Script functions are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF7\"></a><pre><em class=\"codeEmphasisStrong\">macros.load</em> [ &lt;path_name_string&gt; ] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ADF\"></a>Loads all of the Macro Script definition (.mcr) files in the current UI directory\n               path, or in directory path specified by <span class=\"code\"> <em class=\"strong\">&lt;path_name_string&gt;</em> </span>. \n            </p> \n            <p><a name=\"GUID-9299F158-F83B-48EF-A747-EBA43C317E05\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ADE\"></a>You can get the current UI directory path using the function: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF6\"></a><pre>local ui_dir = cui.getDir()</pre></div> \n            <p><a name=\"GUID-7C83946F-CCF8-48DB-AFB4-EEBD2627F4D7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF5\"></a><pre>macros.new &lt;category_string&gt; &lt;name_string&gt; &lt;toolTip_string&gt; &lt;buttonText_string&gt; &lt;body_string&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ADA\"></a>Creates a new Macro Script with the specified name and category. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AD9\"></a>Returns an Integer Macro Script ID value that uniquely identifies the new Macro Script.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AD8\"></a>See <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> for a description of Macro Script definitions. \n            </p> \n            <p><a name=\"GUID-E6F0A7FA-C2DE-4334-8FAA-4D7ED90B923B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF4\"></a><pre><em class=\"codeEmphasisStrong\">macros.run</em> &lt;category_string&gt; &lt;name_string&gt;   </pre></div> \n            <p><a name=\"GUID-5951BB89-750C-448B-9823-9CF9DDE42261\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF3\"></a><pre><em class=\"codeEmphasisStrong\">macros.run</em> &lt;macro_id_integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AD4\"></a>Executes the specified Macro Script. The Macro Script is identified by either its\n               category and name, or by its unique Macro Script ID value. \n            </p> \n            <p><a name=\"GUID-2C507B94-CE62-41F9-8012-BFD8ED9063FC\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF2\"></a><pre><em class=\"codeEmphasisStrong\">macros.edit</em> &lt;category_string&gt; &lt;name_string&gt; <em class=\"codeEmphasisStrong\">macros.edit</em> &lt;macro_id_integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AD0\"></a>These methods will open the Macro Script definition (.mcr) file that defines the specified\n               Macro Script in a script Editor window. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ACF\"></a>The Macro Script is identified by either its category and name, or by its unique Macro\n               Script ID value. \n            </p> \n            <p><a name=\"GUID-F353FD43-F529-4A20-BD0C-7EFB2CCF173A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF1\"></a><pre><em class=\"codeEmphasisStrong\">macros.list</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ACC\"></a>Lists all installed macro scripts and related data, in this order:  \n            </p> <a name=\"UL_486E8F30271B4B5E905F5741D2503BC7\"></a><ul>\n               <li> ID </li>\n               <li> name </li>\n               <li>category </li>\n               <li>internal category - this is the non-localized (English) category </li>\n               <li>macro source filename </li>\n               <li>macro button icon image filename </li>\n               <li>button icon index </li>\n            </ul> \n            <p><a name=\"GUID-36676FB8-B843-4A6D-B1FC-CCBD30A69CCE\"></a></p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3ACA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3AC9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF0\"></a><pre>\nmacros.load \"f:/gametools/macros\"\nmacros.edit \"objects\" \"box\"\nmacros.run 132\nmacros.run \"modifiers\" \"bend\"\n\n-- Save all installed macros to a stringStream:\nmyStringStream = stringStream \"\"\nmacros.list to:myStringStream\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";