var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-3F90A2E3-2AA1-4C3E-9474-15EE04750992\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"special notes about function calls\">\n      <meta name=\"indexterm\" content=\"function calls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Special Notes About Function Calls</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3F90A2E3-2AA1-4C3E-9474-15EE04750992\"></a><div class=\"head\">\n            <h1>Special Notes About Function Calls </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F7D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F7E\"></a>  Functions in MAXScript are just another value that can be stored in variables and\n               arrays, and passed to other functions as arguments. Such functions are sometimes called\n               higher-order functions. All built-in functions, and functions that MAXScript defines\n               based on the <em class=\"strong\">3ds Max</em> object classes, are values stored in system global variables of the same name as\n               the function. When you define a scripted function, the function value is placed in\n               a variable with the same name as the function. You can use the value in these variables\n               and work with them as you would with other values, such as storing them in an array\n               or passing them as arguments.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F81\"></a>Because the function name is a variable that simply yields the function itself, functions\n               that take no arguments need to be called in a special way.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F82\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F83\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1935\"></a><p class=\"table-body\">if you want to call a function <span class=\"code\"> <em class=\"strong\">get_current_target</em> </span> that takes no arguments, you can not simply write:\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6106\"></a><pre>\nt = get_current_target\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F88\"></a><p class=\"table-body\">This stores the <span class=\"code\"> <em class=\"strong\">get_current_target</em> </span> function value in variable <span class=\"code\"> <em class=\"strong\">t</em> </span>, rather than storing the result of executing function <span class=\"code\"> <em class=\"strong\">get_current_target</em> </span>. Instead, you must use the \"()\" <em class=\"mild\">nullary call operator</em>:\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6105\"></a><pre>\nt = get_current_target()\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F8D\"></a>The function to be called is defined as an <span class=\"code\">&lt;operand&gt;</span> in the syntax for function calls. This means that it can bean expression that is\n               evaluated to get the function to call.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F8E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F8F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6104\"></a><pre>\n(if a &gt; b then sin else cos) x --conditional function choice\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6103\"></a><pre>\nhandlers= #(move, scale)\nx = 2\nhandlers[x] $box01 [1,1,1] --get the function out of an array\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F9A\"></a> <span class=\"char_link\"><a href=\"GUID-DC5B0A00-8EE5-4290-A150-C9D72F9B59D7.htm\">When do I use () after a function?</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";