var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-3F9BC35F-918C-46C6-8617-7DCDDD62FCE3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"subAnims\">\n      <meta name=\"indexterm\" content=\"indexed access to animatable properties in 3ds Max objects\">\n      <meta name=\"indexterm\" content=\"Accessing subAnims\">\n      <meta name=\"indexterm\" content=\"Accessing animatable properties in 3ds Max objects\">\n      <meta name=\"indexterm\" content=\"getSubAnimNames()\">\n      <meta name=\"indexterm\" content=\"getSubAnimName()\">\n      <meta name=\"indexterm\" content=\"getSubAnim()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Indexed Access to Animatable Properties in 3ds Max Objects</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3F9BC35F-918C-46C6-8617-7DCDDD62FCE3\"></a><div class=\"head\">\n            <h1>Indexed Access to Animatable Properties in 3ds Max Objects </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71A4\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71A3\"></a>    As an alternative to using named property accesses, you can access in an object any\n               animatable property that is visible as a track in Track View by indexing the <em class=\"strong\">3ds Max</em> object value as though it were an array. \n            </p> \n            <p><a name=\"P_A758A252528C4B1AA26C87C27995AD20\"></a>This simplifies such tasks as iterating over all the animatable properties in an object\n               and accessing sub-controllers that don\'t have unique names, such as within list controllers.\n               \n            </p> \n            <p><a name=\"P_93735696B1624478877EC9CC447468D8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-719E\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D30\"></a><pre>&lt;maxwrapper_object&gt;.<em class=\"codeEmphasisStrong\">numSubs </em>: Integer, read-only 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-719C\"></a>Yields the number of accessible sub-animatables, or tracks, in an object. This is\n               the number of immediate <em class=\"strong\">children subAnims</em>, and may include as yet invisible tracks in the track view, such as visibility tracks\n               on a node or yet-to-be animated vertices in an FFD. This property operates on any\n               MAXWrapper subclass. \n            </p> \n            <p><a name=\"P_B594D031652E462895BEFA0A036AF5E2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7EC9\"></a>   <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2F\"></a><pre><em class=\"codeEmphasisStrong\">getSubAnimName</em> &lt;maxwrapper_object&gt; &lt;index&gt; [ <em class=\"codeEmphasisStrong\">asString</em>:&lt;Boolean&gt; ]   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7198\"></a>Returns the name of the indexed subAnimin the supplied MAXWrapper. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7197\"></a>If the optional <span class=\"code\"> <em class=\"strong\">asString</em> </span> keyword is supplied and set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, the name is returned as a string. If <span class=\"code\"> <em class=\"strong\">false</em> </span> or not specified, a Name Value is returned. \n            </p> \n            <p><a name=\"P_0ABCBB89DE774CD9924B954581C8CF32\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2E\"></a><pre><em class=\"codeEmphasisStrong\">getSubAnimNames</em> &lt;maxwrapper_object&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7194\"></a>Returns an array of names in subAnim index order. \n            </p> \n            <p><a name=\"P_7FB8B42D93C24BDFA851421AF471B8A5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2D\"></a><pre><em class=\"codeEmphasisStrong\">getSubAnim</em> &lt;maxwrapper_object&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7191\"></a>Returns the indexed subAnim. See the index operator below. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7190\"></a> <em class=\"strong\">Operators</em> \n            </p> \n            <p><a name=\"P_818BBE4594074E8BA9B6559C1E10403C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2C\"></a><pre>&lt;maxwrapper_object&gt;<em class=\"codeEmphasisStrong\">[&lt;</em>index_number<em class=\"codeEmphasisStrong\">&gt;|&lt;</em>subanim_name<em class=\"codeEmphasisStrong\">&gt;]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-718E\"></a>Returns the subAnim with the specified index or name. You can apply the index operator,\n               <span class=\"code\"> <em class=\"strong\">[&lt;index_number&gt;]</em> </span>, to any MAXWrapper object (nodes, modifiers, controllers, materials, etc.) to access\n               a numbered subAnim. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-718D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-718C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2B\"></a><pre>\nfor i in 1 to $foo.numSubs do print $foo[i] -- iterate them\n$bar.position.controller[3] -- third subAnim in a position list controller\nffd_mod[i].value -- position of i\'th FFD control point\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1905\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"P_8036CE14259142A68799611F1E7B6FCF\"></a>You cannot set subAnims with the index operator, this is a read-only access. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7181\"></a>In place of an index, you can also use a subanim name. It can be any expression that\n               yields a string or name value. So, whereas in releases prior <em class=\"strong\">3ds Max 4</em>, getting at the position subAnim in a node require you to remember index 3 for the\n               transform subanim and 1 for its position subanim, in other words \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7180\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D2A\"></a><pre>\n$foo[3][1] -- position within transform within node\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-717C\"></a><p class=\"table-body\">you can use instead: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D29\"></a><pre>$foo[#transform][#position]</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7177\"></a>The names you can use are those seen in the track view or retrieved with the functions\n               <span class=\"code\"> <em class=\"strong\"> getSubAnimName()</em> </span> or <span class=\"code\"> <em class=\"strong\">getSubAnimNames().</em> </span> \n            </p> \n            <p><a name=\"P_35053DC0AEBA4D19ABCC8543178DEAE3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7175\"></a> \n            <h2><a name=\"GUID-C7A4A07C-62E9-4490-AE0E-F0E97F208DCA\"></a> <em class=\"strong\">SubAnim Class</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7174\"></a>MAXScript defines a <span class=\"code\"> <em class=\"strong\">SubAnim</em> </span> class, instances of which provide a general representation for sub-animatables. Whenever\n               you use the index operator on a <em class=\"strong\">3ds Max</em> object, it returns a SubAnim instance. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7173\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7172\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D28\"></a><pre>\n$box01[3] -&gt; SubAnim:Transform\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-716E\"></a>The third subAnim in a node is typically the transform track. \n            </p> \n            <p><a name=\"P_D00396BD2BC84D8D91DBB93C76A0E1B8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-716D\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D27\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">name</em> : String, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-716B\"></a>Returns the name of the track subAnim as shown in TrackView. \n            </p> \n            <p><a name=\"P_D36F1053A6A0497D84471B31E44384AC\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D26\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">parent</em> : Node, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7168\"></a>Returns thetrue owner of the subAnim. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1904\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"P_63F826B9B97842AAA492E5E927B38E6E\"></a>The true object owning the subAnim can be different than what was originally specified\n                     when creating the subAnim, and MAXScript automatically hides certain types of subAnims,\n                     automatically promoting the subAnims within them. \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7162\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7161\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D25\"></a><pre>\ns=sphere()\nsa = s.baseobject[1]\n--&gt; SubAnim:Radius\nsa.parent\n--&gt; ReferenceTarget:ParamBlock\nsa.index\n--&gt; 1\n--The actual owner of the Radius subAnim is the sphere\'s parameter block.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_9D5AAC3BE9D54AA186F4F98DE5B7316E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D24\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">index</em> : Integer, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7153\"></a>Returns the index of the subAnim. \n            </p> \n            <p><a name=\"P_7AF5489F1AA94F329A324606C45BE9A5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D23\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">value</em> : Value </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7150\"></a>The current value of the track subAnim, equivalent to <span class=\"code\"> <em class=\"strong\">&lt;controller&gt;.value</em> </span>. Returns <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if no appropriate value exists or the track has not yet been assigned a controller.\n               The <span class=\"code\"> <em class=\"strong\">.value</em> </span> property yields the value at the current MAXScript time. You can assign to this value\n               to set the track\'s value at that time. \n            </p> \n            <p><a name=\"P_AF498F68CCF74BA29B464EAE6305BF3F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D22\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">controller</em> : Controller </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-714D\"></a>The controller for the track SubAnim. Returns <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if a controller has not yet been assigned or if the SubAnim is not animatable. You\n               can assign a new controller to a track by assigning to the <span class=\"code\"> <em class=\"strong\">.controller</em> </span> property of its subAnim. \n            </p> \n            <p><a name=\"P_EF38B068B98144BE88746471570BEAC0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D21\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">keys</em> : KeyArray, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-714A\"></a>Yields the key array for that track or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if not keyable or a controller has not yet been assigned. This property is read-only.\n               \n            </p> \n            <p><a name=\"P_4AC7ADA8CD134C8585B4AEA19943F193\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D20\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">isAnimated</em> : Boolean, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7147\"></a>Yields <span class=\"code\"> <em class=\"strong\">true</em> </span> if there is an animated controller present. This property is read-only. \n            </p> \n            <p><a name=\"P_974555555BBB489E9215271DB98BB8BE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1F\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">object</em> : MAXWrapper, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7144\"></a>Yields the subAnim object, or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if not assigned. This property is read-only. The <span class=\"code\"> <em class=\"strong\">.object</em> </span> property may return any kind of MAXWrapper object, depending on what the parent object\n               decides to put there. For example, <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[1].object</em> </span> is the visibility controller or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if not yet assigned, <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[2].object</em> </span> contains the bindings of any space warps bound to the node, or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if none have been bound, <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[3].object</em> </span> is the transform controller, <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[4].object</em> </span> is the node\'s object, either the modified object if there are modifiers present or\n               the base object if not, <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[5].object</em> </span> is the material assigned to the node or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if no material has been assigned, and <span class=\"code\"> <em class=\"strong\">&lt;node&gt;[6].object</em> </span> is the Image Motion Blur Multiplier controller or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if not yet assigned. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7143\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7142\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1E\"></a><pre>\nb = box()\nb[4].object -- returns a reference to the Box base object\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_21BCF8534BAF4C19B37CB44BE21EFC29\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1D\"></a><pre>&lt;subAnim&gt;.<em class=\"codeEmphasisStrong\">numSubs</em> : Integer, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-713B\"></a>The number of immediate subAnim children. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-713A\"></a>If you attempt to access subAnim properties, such as <span class=\"code\"> <em class=\"strong\">.value</em> </span>, <span class=\"code\"> <em class=\"strong\">.numSubs</em> </span>, <span class=\"code\"> <em class=\"strong\">.category</em> </span>, etc., on certain subAnims that had yet to be assigned controllers, such as scene\n               node visibility tracks, these properties return null values such as 0, or <span class=\"code\"> <em class=\"strong\">undefined</em> </span>, as appropriate. \n            </p> \n            <p><a name=\"P_F1AA9D1F1BED4E0591F828763F2976DB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7139\"></a> <em class=\"strong\">Methods</em>  \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1C\"></a><pre><em class=\"codeEmphasisStrong\">getSubAnim</em> &lt;subAnim&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7137\"></a>Returns the indexed subAnim. See the index operator below. \n            </p> \n            <p><a name=\"P_CB50ABE4AE8E45789710372C1F8F3BB3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7136\"></a> <em class=\"strong\">Operators</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1B\"></a><pre>&lt;subAnim&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;index_number&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7134\"></a>Returns the indexed subAnim. You can work down through nested subAnims (nested tracks)\n               by indexing into subAnims themselves. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7133\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7132\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D1A\"></a><pre>\n$box01[3][2]\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-712E\"></a><p class=\"table-body\">yields the rotation track subAnim since &lt;node&gt;[3] is always the transform track and\n                           the second track in it is always the rotation track. Indexing a SubAnim always yields\n                           another SubAnim. For those familiar with SubAnims in the <em class=\"strong\">3ds Max</em> SDK, it should be noted that MAXScript SubAnims descend automatically through \'hidden\'\n                           subAnim levels, reflecting the structure seen in Track View. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1903\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-712A\"></a>You can get at the base object\'s Track View parameters by indexing into the base object:\n                     \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D19\"></a><pre>b=box()\ngetSubAnimNames b[4] -- returns #(#length, #width, #height, ...)\nb[4][2].value -- returns current width value\ni = 3\nb[4][i].controller = float_list() -- assign height controller</pre></div> \n               </div>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";