var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-41FCD8A3-66F8-48EE-82EA-A0D62AEF747D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface Iassembly\">\n      <meta name=\"indexterm\" content=\"Iassembly Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: IAssembly</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-41FCD8A3-66F8-48EE-82EA-A0D62AEF747D\"></a><div class=\"head\">\n            <h1>Interface: IAssembly </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C5C\"></a> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C5B\"></a>  This is a Node Interface providing access to the Assembly head and member related\n               properties of a node. \n            </p> \n            <p><a name=\"GUID-22D22DEA-0B78-4654-B471-8C076E6A7C2A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C58\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53AC\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.assemblyMember </em>: boolean : Read|Write 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C57\"></a>Returns <span class=\"code\"> <em class=\"strong\">true </em> </span>if the node is an Assembly Member,<span class=\"code\"> <em class=\"strong\"> false</em> </span> if it isn’t. \n            </p> \n            <p><a name=\"GUID-AD4205F1-9461-4090-8928-8EF2BF995ED5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53AB\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.assemblyHead </em>: boolean : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C55\"></a>Returns<span class=\"code\"> <em class=\"strong\"> true</em> </span> if the node is an Assembly Head,<span class=\"code\"> <em class=\"strong\"> false</em> </span> if it isn’t. \n            </p> \n            <p><a name=\"GUID-513C87BA-9D90-4EA3-9773-088004CBA0D5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53AA\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.assemblyMemberOpen</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C53\"></a>Returns<span class=\"code\"> <em class=\"strong\"> true </em> </span>if the node is a Member of an open Assembly, <span class=\"code\"> <em class=\"strong\">false </em> </span>is the Assembly is closed or the node is not a Member of an Assembly. \n            </p> \n            <p><a name=\"GUID-A8F1FA12-E2AC-4A99-9E1A-2D48EA28B522\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53A9\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.assemblyHeadOpen</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C51\"></a>Returns<span class=\"code\"> <em class=\"strong\"> true </em> </span>if the node is a Head of an open Assembly,<span class=\"code\"> <em class=\"strong\"> false </em> </span>if the Assembly is closed or the node is not a Head of an Assembly. \n            </p> \n            <p><a name=\"GUID-686CFCF1-EC66-4F38-96DE-B79FF7EEEE26\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53A8\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">assemblyBBoxDisplay </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C4F\"></a>Get/set the bounding box display. \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C4D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C4C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-53A7\"></a><pre>\n-- find all top level assembly heads\nfor obj in objects do\nif obj.assemblyHead and not obj.isAssemblyMember do\nprint obj.name\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C4A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C49\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C48\"></a><p class=\"table-body\">While these properties are Read/Write,<em class=\"strong\"> setting </em>these properties can result in<em class=\"strong\"> unpredictable behavior</em>! \n                        </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-C47\"></a><p class=\"table-body\">Only set these properties if you really know what you are doing! </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-E9D3BB95-67F8-4E02-AE00-F95CC1711C0C.htm\">Interface:AssemblyMgr </a></span></li>\n                  <li><span class=\"char_link\"><a href=\"GUID-38A8EFE3-685B-41F8-9E36-5B6B5CEACC18.htm\">Node Interfaces </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";