var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-44B28C85-6206-4C7E-8A03-B251E4737DF3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSPoint - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBSCurveConstPoint - NURBSPoint\">\n      <meta name=\"indexterm\" content=\"getObject()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCurveConstPoint : NURBSPoint</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-44B28C85-6206-4C7E-8A03-B251E4737DF3\"></a><div class=\"head\">\n            <h1>NURBSCurveConstPoint : NURBSPoint </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4717\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4716\"></a>   This class defines a dependent point that lies on a curve or relative to it. The point\n               can either be on the curve or off the curve. If it is on the curve, the U Position\n               is the only control of its location. The U Position specifies a location along the\n               curve (based on the curve’s local U axis). There are four ways to specify the displacement\n               of the point’s location relative to the U position: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4712\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4710\"></a>OnObject - the point is actually on the surface of the object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-470E\"></a>Offset - the point is moved according to a relative (object space) X,Y,Z location.\n                     \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-470C\"></a>Normal - the point is moved along the direction of the curve’s normal. (Negative values\n                     move it opposite to the normal.) \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-470A\"></a>Tangent - the point is moved along the tangent of the U Position. If the value is\n                     positive it\'s the tangent that heads in the direction of increasing U value; if negative\n                     it\'s the tangent that heads in the direction of decreasing U value. \n                  </p> \n               </li>\n            </ul> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4709\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2258\"></a><pre><em class=\"codeEmphasisStrong\">NURBSCurveConstPoint</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4707\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2257\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4703\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2256\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4701\"></a>The parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2255\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46FE\"></a>The parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2254\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">uParam</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46FB\"></a>Parametric point along the parent curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2253\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">type</em> :<em class=\"codeEmphasisStrong\">#onObject, #offset, #normal, #tangent </em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46F8\"></a>Specifies the transform relationship between the point and the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2252\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">offset</em> : point3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46F5\"></a>Offset vector if an offset type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2251\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">normal</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46F2\"></a>Distance along the normal if a normal type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2250\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">uTangent</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46EF\"></a>Distance along the curve tangent if a tangent type. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-224F\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">trimCurve</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46EC\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, trims parent curve at the point. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-224E\"></a><pre>&lt;nurbscurveconstpoint&gt;.<em class=\"codeEmphasisStrong\">flipTrim</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46E9\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span> the curve is trimmed from the point towards low parameter space. If <span class=\"code\"> <em class=\"strong\">false</em> </span> the curve is trimmed from the point towards high parameter space. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46E7\"></a> <span class=\"char_link\"><a href=\"GUID-7066A0C4-409A-4469-84C8-52C1977FE546.htm\">NURBSPoint</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46E6\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-46E5\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";