var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-46331E7C-A2DF-4FCD-B69F-D94A7FDF8795\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Script Operator Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Script Operator Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-46331E7C-A2DF-4FCD-B69F-D94A7FDF8795\"></a><div class=\"head\">\n            <h1>Script Operator Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84857\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84858\"></a>The following example shows the default Script Operator script with detailed comments.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84859\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8485A\"></a>Used by the <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span> as default script. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8485B\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8485C\"></a>The script slows particles down, and when they are slow enough, splits off the first\n            50 particles into a stream traveling in a negative direction on the world X axis,\n            and the remainder in the opposite direction. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8485D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8485E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E11\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true--enable the Time channel\npCont.useSpeed = true--enable the Speed channel\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n(\n--Get the total number of particles:\ncount = pCont.NumParticles()\n--Define slow speed as one unit per frame:\nslowSpeed = 1/160.0\n--Define very slow speed as 0.01 units per frame:\nverySlowSpeed = 0.01/160.0\n--Define random angular deviation per frame\ndivAngle = 12.0\n--Get the start time in ticks\n--(when conerting time values to float, the result is ticks)\ntStart = pCont.getTimeStart() as float\n--Get the end time in ticks\ntEnd = pCont.getTimeEnd() as float\n--Calculate the length of the time interval in ticks\ntimeDif = tEnd - tStart\n--Then convert to frames (160 ticks/frame when using 30 fps NTSC)\ntimeDif /= 160.0\n--Define a drag coefficient\ndragCoef = 0.08\n \n \n--Loop from 1 to the number of particles...\nfor i in 1 to count do\n(\n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one:\npCont.particleIndex = i\n \n--If the particle is faster, then slow it down\nif length (pCont.particleSpeed) &gt; slowSpeed then\npCont.particleSpeed -= dragCoef*timeDif*pCont.particleSpeed\n \n--Calculate the length of the particle speed vector\nnewLen = length(pCont.particleSpeed)\n--If the current speed is higher than the defined very slow speed\n--then calculate a random divergence using the deviation angle.\n--If it is slower (very slow!), then don’t use the angle but a\n--fixed value.\nif newLen &gt; verySlowSpeed then\npCont.particleSpeed = pCont.randDivergeVector(pCont.particleSpeed)(divAngle/(160*newLen))\nelse\npCont.particleSpeed = pCont.randDivergeVector(pCont.particleSpeed)(180.0)\n \n--If slow enough, the first 50 particles go to the left.\n--The particles with ID above 50 go to the right.\nif length(pCont.particleSpeed) &lt; 1.5*slowSpeed then\n(\nif pCont.particleID &lt; 50 then\npCont.particleSpeed += [-0.005*timeDif, 0, 0]\nelse\npCont.particleSpeed += [0.005*timeDif, 0, 0]\n)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848B7\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848B8\"></a> <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848B9\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848BA\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";