var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"sortKeys()\">\n      <meta name=\"indexterm\" content=\"setTimeRange()\">\n      <meta name=\"indexterm\" content=\"setBeforeORT()\">\n      <meta name=\"indexterm\" content=\"setAfterORT()\">\n      <meta name=\"indexterm\" content=\"selectKeys()\">\n      <meta name=\"indexterm\" content=\"scaleTime()\">\n      <meta name=\"indexterm\" content=\"reverseTime()\">\n      <meta name=\"indexterm\" content=\"reduceKeys()\">\n      <meta name=\"indexterm\" content=\"object hierarchies: time and key functions on\">\n      <meta name=\"indexterm\" content=\"moveKeys()\">\n      <meta name=\"indexterm\" content=\"insertTime()\">\n      <meta name=\"indexterm\" content=\"enableORTs()\">\n      <meta name=\"indexterm\" content=\"deselectKeys()\">\n      <meta name=\"indexterm\" content=\"deleteTime()\">\n      <meta name=\"indexterm\" content=\"deleteKeys()\">\n      <meta name=\"indexterm\" content=\"deleteEaseCurve()\">\n      <meta name=\"indexterm\" content=\"addNewKey()\">\n      <meta name=\"indexterm\" content=\"addEaseCurve()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time and Key Functions on Object Hierarchies</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF\"></a><div class=\"head\">\n            <h1>Time and Key Functions on Object Hierarchies </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F7B\"></a>Certain of the controller time and key functions can be called on any <em class=\"strong\">3ds Max</em> object or collection of <em class=\"strong\">3ds Max</em> objects, not just individual controllers. If called in this way, they apply recursively\n            to all the nested controllers within those objects and on any on sub-objects and sub-controllers\n            within those objects. In this way, they work in a manner similar to the object-level\n            tracks in the <em class=\"strong\">3ds Max</em> Track View that allow you to manipulate keys and time for all the sub-objects and\n            sub-controllers within them. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F7C\"></a>The time and controller functions that work this way are: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE6\"></a><pre> <em class=\"codeEmphasisStrong\">deleteTime</em> <em class=\"codeEmphasisStrong\">reverseTime</em> <em class=\"codeEmphasisStrong\">scaleTime</em> <em class=\"codeEmphasisStrong\">insertTime</em> <em class=\"codeEmphasisStrong\">setTimeRange</em> </pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE5\"></a><pre> <em class=\"codeEmphasisStrong\">addNewKey</em> <em class=\"codeEmphasisStrong\">deleteKeys</em> <em class=\"codeEmphasisStrong\">selectKeys</em> <em class=\"codeEmphasisStrong\">deselectKeys</em> <em class=\"codeEmphasisStrong\">moveKeys</em> <em class=\"codeEmphasisStrong\">sortKeys</em> <em class=\"codeEmphasisStrong\">reduceKeys</em> </pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE4\"></a><pre> <em class=\"codeEmphasisStrong\">addEaseCurve</em> <em class=\"codeEmphasisStrong\">deleteEaseCurve</em> <em class=\"codeEmphasisStrong\">setBeforeORT</em> <em class=\"codeEmphasisStrong\">setAfterORT</em> <em class=\"codeEmphasisStrong\">enableORTs</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F8E\"></a>The above functions can be called on any <em class=\"strong\">3ds Max</em> object collection (such as a wild-card pathname or object set or array of objects\n            ) and will recursively apply to all animation within those objects. If they are called\n            on components <em class=\"strong\">within</em> an object that themselves have nested controllers, they are applied to all those\n            nested controllers - see the examples below. \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7FAF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>An exception to the above behavior is the <span class=\"code\"> <em class=\"strong\">setTimeRange</em> </span> function which will be applied recursively only when a <span class=\"code\"> <em class=\"strong\">#linkToKeys</em> </span> argument is provided. See <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm#WS73099CC142F487553098682E12AC2FC2BC7-2F08\">setTimeRange</a></span> for details. \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F94\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F95\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE3\"></a><pre>\ninsertTime $box01.xform 0f 10f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F99\"></a><p class=\"table-body\">all keys after <span class=\"code\"> <em class=\"strong\">0f</em> </span> in all controllers in the <span class=\"code\"> <em class=\"strong\">xform</em> </span> modifier are moved by <span class=\"code\"> <em class=\"strong\">10f</em> </span> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE2\"></a><pre>\ninsertTime $box01 0f 10f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7F9D\"></a><p class=\"table-body\">all keys after <span class=\"code\"> <em class=\"strong\">0f</em> </span> in <span class=\"code\"> <em class=\"strong\">box01</em> </span> are moved (transform, creation, modifiers) \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE1\"></a><pre>\nselectKeys $box02.xform.gizmo.rotation.controller 0f 100f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FA1\"></a><p class=\"table-body\">selects keys in <span class=\"code\"> <em class=\"strong\">0-100f</em> </span>, if controller is Euler, e.g., will select x, y and z keys \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">deleteTime $box* 10f 20f</em> </span> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FA5\"></a><p class=\"table-body\">delete time from frame 10 and frame 20 in all objects named <span class=\"code\"> <em class=\"strong\">$box*</em> </span> (works with any pathname or array of objects) \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EE0\"></a><pre>\ninsertTime $box03.children 0f 10f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FA9\"></a><p class=\"table-body\">inserts time in all controllers of all children of <span class=\"code\"> <em class=\"strong\">$box03</em> </span> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EDF\"></a><pre>\nreduceKeys $box01.modifiers 0.5 1f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FAD\"></a><p class=\"table-body\">applies key reductions to all controllers in all modifiers in <span class=\"code\"> <em class=\"strong\">$box01</em> </span> (leaves transform and creation parameters alone) \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FB0\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FB1\"></a> <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FB2\"></a> <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7FB3\"></a> <span class=\"char_link\"><a href=\"GUID-D839F477-A534-4764-BC16-93B702F72807.htm\">Animation Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";