var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-46ECBAD7-35E9-43BD-8A8C-849772924805\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript grammar\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Grammar</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-46ECBAD7-35E9-43BD-8A8C-849772924805\"></a><div class=\"head\">\n            <h1>MAXScript Grammar </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E85D8B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E85D8C\"></a> The following is the complete MAXScript grammar in Extended Backus-Naur Form (EBNF).\n               It differs slightly in factoring from the syntax forms given in the online reference\n               so that all precedence is explicit in the rules. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E85D8E\"></a>These rules or <em class=\"mild\">syntax definitions</em> follow the standard EBNF notation. The rules typically contain a number of characters\n               with special meanings. For example, brackets enclose optional items such as, the minus\n               sign in front of the number. Braces enclose items you can use repeatedly, and bars\n               separate multiple items from which you can choose one. Sometimes, rules are given\n               names, so they can be referred to in the documentation or as parts of other rules.\n               The special characters in the rules have the following meaning: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6274\"></a><pre>\n[...] -- items inside the brackets are optional\n(...|...|...) -- choose one of the items separated by the bars\n{...} -- you can specify the braced item ZERO or more times\n{...}+ -- you can specify the braced item ONE or more times\n::= -- define a name for a syntax rule\n&lt;rule&gt; -- you can insert what is defined by the named rule\n\n<em class=\"codeEmphasisStrong\">bold_characters </em>-- characters or token as written</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E85D96\"></a>An example of an EBNF form is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6273\"></a><pre>[<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}[<em class=\"codeEmphasisStrong\">.</em>{&lt;digit&gt;}][(<em class=\"codeEmphasisStrong\">e </em>|<em class=\"codeEmphasisStrong\"> E</em>)[<em class=\"codeEmphasisStrong\">+ </em>|<em class=\"codeEmphasisStrong\"> -</em>]{&lt;digit&gt;}+]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E85D98\"></a>This example is interpreted as follows: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85D99\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"47.549019607843135%\">\n                     <col width=\"52.450980392156865%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85D9A\"></a><p class=\"table-body\"> <em class=\"strong\">Syntax</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85D9B\"></a><p class=\"table-body\"> <em class=\"strong\">Definition</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6272\"></a><pre>[<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}</pre></div> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85D9D\"></a><p class=\"table-body\">an optional minus sign (the sign), followed by 0 or more digits (the integer part),\n                           followed by \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6271\"></a><pre><em class=\"codeEmphasisStrong\">.</em>{&lt;digit&gt;}]</pre></div> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85D9F\"></a><p class=\"table-body\">an optional sequence (the fraction part) comprised of: a period character, followed\n                           by 0 or more digits, followed by \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6270\"></a><pre>[(<em class=\"codeEmphasisStrong\">e </em>|<em class=\"codeEmphasisStrong\"> E</em>)[<em class=\"codeEmphasisStrong\">+ </em>|<em class=\"codeEmphasisStrong\"> -</em>]{&lt;digit&gt;}+]</pre></div> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E85DA1\"></a><p class=\"table-body\">an optional sequence (the exponent part) comprised of: either an ’e’ or \'E’, followed\n                           by an optional plus or minus sign, followed by one or more digits. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_37F59A01D5F64A308BBAB048CCFD7C32\"></a><pre>&lt;program&gt; ::= { &lt;expr&gt; }+\n&lt;expr&gt; ::= &lt;simple_expr&gt;\n&lt;variable_decls&gt;\n&lt;assignment&gt;\n&lt;if_expr&gt;\n&lt;while_loop&gt;\n&lt;do_loop&gt;\n&lt;for_loop&gt;\n&lt;loop_exit&gt;\n&lt;case_expr&gt;\n&lt;struct_def&gt;\n&lt;try_expr&gt;\n&lt;variable_decls&gt;\n&lt;function_def&gt;\n&lt;function_return&gt;\n&lt;context_expr&gt;\n&lt;max_command&gt;\n&lt;utility_def&gt;\n&lt;rollout_def&gt;\n&lt;tool_def&gt;\n&lt;rcmenu_def&gt;\n&lt;macroscript_def&gt;\n&lt;plugin_def&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_61AB3D747EBA4E9CB23946547F4FBBCC\"></a><pre>&lt;variable_decls&gt; ::= ( <em class=\"codeEmphasisStrong\">local </em>| <em class=\"codeEmphasisStrong\">global</em> ) &lt;decl&gt; {<em class=\"codeEmphasisStrong\"> ,</em> &lt;decl&gt; }\n<em class=\"codeEmphasisStrong\">persistent global</em> &lt;decl&gt; {<em class=\"codeEmphasisStrong\"> ,</em> &lt;decl&gt; }</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_FF7C36D87A4B4C239C4FCCF9950852B8\"></a><pre>&lt;decl&gt; ::= &lt;var_name&gt; [<em class=\"codeEmphasisStrong\">=</em>&lt;expr&gt; ] -- name and optional initial value</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_3766737706CF43789BDD295400E8980B\"></a><pre>&lt;var_name&gt; ::= { &lt;alphanumeric&gt; |<em class=\"codeEmphasisStrong\"> _ </em>}\n<em class=\"codeEmphasisStrong\">\'</em>{ &lt;any_char_except_quote&gt; }\'</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_2ADC9BAF3C164910B326BC9A7AA62BA4\"></a><pre>&lt;assignment&gt; ::= &lt;destination&gt;<em class=\"codeEmphasisStrong\">=</em>&lt;expr&gt;\n&lt;destination&gt; <em class=\"codeEmphasisStrong\">+=</em> &lt;expr&gt;\n&lt;destination&gt; <em class=\"codeEmphasisStrong\">-= </em>&lt;expr&gt;\n&lt;destination&gt; <em class=\"codeEmphasisStrong\">*= </em>&lt;expr&gt;\n&lt;destination&gt; <em class=\"codeEmphasisStrong\">/=</em> &lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_2DBE2F18148146F4A0BADC347EBCEFF1\"></a><pre>&lt;destination&gt; ::= &lt;var_name&gt;\n&lt;property&gt;\n&lt;index&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_F84E457CF1AD41988D1CBDCB869A6E43\"></a><pre>&lt;if_expr&gt; ::=<em class=\"codeEmphasisStrong\"> if</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\"> then</em> &lt;expr&gt; [ <em class=\"codeEmphasisStrong\">else</em> &lt;expr&gt; ]\n<em class=\"codeEmphasisStrong\">if </em>&lt;expr&gt; <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_A071A5D0C724476AAC0A9D4C60A078B7\"></a><pre>&lt;while_loop&gt; ::=<em class=\"codeEmphasisStrong\"> while</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\"> do </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_8D9EAC0355E0439AA8FE60B22B190F77\"></a><pre>&lt;do_loop&gt; ::= <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\"> while</em> &lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_ED208F8DC8F64F8D8E05D88B6EA96A6F\"></a><pre>&lt;for_loop&gt; ::=<em class=\"codeEmphasisStrong\"> for </em>&lt;name&gt;( <em class=\"codeEmphasisStrong\">in </em>|<em class=\"codeEmphasisStrong\"> = </em>) &lt;source&gt; (<em class=\"codeEmphasisStrong\">do </em>|<em class=\"codeEmphasisStrong\"> collect</em>) &lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_C98FF193BA4540ECABA03EA90577BF47\"></a><pre>&lt;source&gt; ::= &lt;expr&gt; <em class=\"codeEmphasisStrong\">to </em>&lt;expr&gt; [<em class=\"codeEmphasisStrong\">by</em> &lt;expr&gt;] [<em class=\"codeEmphasisStrong\">where </em>&lt;expr&gt;]\n\n&lt;expr&gt; [<em class=\"codeEmphasisStrong\">where</em> &lt;expr&gt;]</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_B1A4A755A5A14DC7A40B3375F9DC6FE6\"></a><pre>&lt;loop-exit&gt; ::=<em class=\"codeEmphasisStrong\">exit </em>[<em class=\"codeEmphasisStrong\">with </em>&lt;expr&gt;]</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_B059BA12108745DBB552C2DD389B4E0C\"></a><pre>&lt;loop-continue&gt; ::=<em class=\"codeEmphasisStrong\"> continue</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_57DD36C6CD1743799D80FBAE2A462B38\"></a><pre>&lt;case_expr&gt; ::= <em class=\"codeEmphasisStrong\">case </em>[&lt;expr&gt;] <em class=\"codeEmphasisStrong\">of (</em> { &lt;case_item&gt; }<em class=\"codeEmphasisStrong\">)</em> \n\n&lt;case_item&gt; ::= &lt;factor&gt; : &lt;expr&gt;\n<em class=\"codeEmphasisStrong\">default</em> : &lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_5C53D2DB45484EF7B8449326A7DFF1AD\"></a><pre>&lt;struct_def&gt; ::=<em class=\"codeEmphasisStrong\"> struct (</em> &lt;member&gt; {<em class=\"codeEmphasisStrong\">,</em>&lt;member&gt; } <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;member&gt; ::= &lt;name&gt; [<em class=\"codeEmphasisStrong\">=</em>&lt;expr&gt; ] -- name and optional initial value\n&lt;function_def&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_BFA762B3859D46129EFD9D1A60911689\"></a><pre>&lt;try_expr&gt; ::= <em class=\"codeEmphasisStrong\">try </em>&lt;expr&gt;<em class=\"codeEmphasisStrong\"> catch </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_E92825C5BC3444E9BDB80FBD06527375\"></a><pre>&lt;function_def&gt; ::= [ <em class=\"codeEmphasisStrong\">mapped</em> ] ( <em class=\"codeEmphasisStrong\">function </em>|<em class=\"codeEmphasisStrong\"> fn </em>) &lt;var_name&gt; { &lt;arg&gt; }<em class=\"codeEmphasisStrong\">= </em>&lt;expr&gt;\n\n&lt;arg&gt; ::= &lt;var_name&gt;\n&lt;var_name&gt;: [ &lt;operand&gt; ]</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_0A1B0985E4A94EF38C1BE679D26A9A9C\"></a><pre>&lt;function_return&gt; ::=<em class=\"codeEmphasisStrong\"> return </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_B05EDF133C154D09A519906A30F762DD\"></a><pre>&lt;context_expr&gt; ::= &lt;context&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;context&gt; } &lt;expr&gt;\n\n&lt;context&gt; ::= [<em class=\"codeEmphasisStrong\">with</em>]<em class=\"codeEmphasisStrong\"> animate </em>&lt;logical_expr&gt;\n<em class=\"codeEmphasisStrong\">at level</em> &lt;operand&gt;\n<em class=\"codeEmphasisStrong\">at time </em>&lt;operand&gt;\n<em class=\"codeEmphasisStrong\">in</em> &lt;operand&gt;\n[<em class=\"codeEmphasisStrong\">in</em>]<em class=\"codeEmphasisStrong\"> coordsys</em> (<em class=\"codeEmphasisStrong\"> local </em>| <em class=\"codeEmphasisStrong\">world </em>| <em class=\"codeEmphasisStrong\">parent </em>| &lt;operand&gt; )\n<em class=\"codeEmphasisStrong\">about </em>(<em class=\"codeEmphasisStrong\"> pivot </em>| <em class=\"codeEmphasisStrong\">selection </em>| <em class=\"codeEmphasisStrong\">coordsys </em>| &lt;operand&gt; )\n[<em class=\"codeEmphasisStrong\"> with </em>] <em class=\"codeEmphasisStrong\">undo </em>&lt;logical_expr&gt;\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_8CBB71AAD9F247719B37604B13B75FE7\"></a><pre>&lt;set_context&gt; ::=<em class=\"codeEmphasisStrong\"> set </em>&lt;context&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_BC777D7BD9AE4FC399CC40E4C3C3503E\"></a><pre>&lt;utility_def&gt; ::=<em class=\"codeEmphasisStrong\"> utility </em>&lt;var_name&gt; &lt;string&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; } \\\n<em class=\"codeEmphasisStrong\">( </em>{ &lt;utility_clause&gt; }+ <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;utility_clause&gt; ::= &lt;rollout&gt;\n&lt;rollout_clause&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_1126209FC26F46F0A3A1DB079374483B\"></a><pre>&lt;rollout_def&gt; ::=<em class=\"codeEmphasisStrong\"> rollout </em>&lt;var_name&gt; &lt;string&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; } \\\n<em class=\"codeEmphasisStrong\">(</em> { &lt;rollout_clause&gt; }+<em class=\"codeEmphasisStrong\"> )</em>\n\n&lt;rollout_clause&gt; ::=<em class=\"codeEmphasisStrong\"> local </em>&lt;decl&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;decl&gt; }\n&lt;function_def&gt;\n&lt;struct_def&gt;\n&lt;mousetool&gt;\n&lt;item_group&gt;\n&lt;rollout_item&gt;\n&lt;rollout_handler&gt;\n\n&lt;item_group&gt; ::= <em class=\"codeEmphasisStrong\">group </em>&lt;string&gt; <em class=\"codeEmphasisStrong\">(</em> { &lt;rollout_item&gt; } <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;rollout_handler&gt; ::=<em class=\"codeEmphasisStrong\"> on </em>&lt;var_name&gt; &lt;var_name&gt; { &lt;var_name&gt; }<em class=\"codeEmphasisStrong\"> do </em>&lt;expr&gt;\n\n&lt;rollout_item&gt; ::= &lt;item_type&gt; &lt;var_name&gt; [ &lt;string&gt; ] { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; }\n\n&lt;item_type&gt; ::= <em class=\"codeEmphasisStrong\">label</em> <em class=\"codeEmphasisStrong\">button</em> <em class=\"codeEmphasisStrong\">edittext</em> <em class=\"codeEmphasisStrong\">combobox</em> <em class=\"codeEmphasisStrong\">dropdownList</em> <em class=\"codeEmphasisStrong\">listbox</em> <em class=\"codeEmphasisStrong\">spinner</em> <em class=\"codeEmphasisStrong\">slider</em> <em class=\"codeEmphasisStrong\">pickbutton</em> <em class=\"codeEmphasisStrong\">radiobuttons</em> <em class=\"codeEmphasisStrong\">checkbox</em> <em class=\"codeEmphasisStrong\">checkbutton</em> <em class=\"codeEmphasisStrong\">colorPicker</em> <em class=\"codeEmphasisStrong\">mapbutton</em> <em class=\"codeEmphasisStrong\">materialbutton</em> <em class=\"codeEmphasisStrong\">progressbar</em> <em class=\"codeEmphasisStrong\">timer</em> <em class=\"codeEmphasisStrong\">bitmap</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_D0CEC70BEE2B49D3A1286272C704AF3E\"></a><pre>&lt;rcmenu_def&gt; ::=<em class=\"codeEmphasisStrong\"> rcmenu</em> &lt;var_name&gt; <em class=\"codeEmphasisStrong\">( </em>{ &lt;rcmenu_clause&gt; }+ <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;rcmenu_clause&gt; ::=<em class=\"codeEmphasisStrong\"> local</em> &lt;decl&gt; { <em class=\"codeEmphasisStrong\">, </em>&lt;decl&gt; }\n&lt;function_def&gt;\n&lt;struct_def&gt;\n&lt;rcmenu_item&gt;\n&lt;rcmenu_handler&gt;\n\n&lt;rcmenu_handler&gt; ::= <em class=\"codeEmphasisStrong\">on </em>&lt;var_name&gt; &lt;var_name&gt; <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;\n\n&lt;rcmenu_item&gt; ::= &lt;rcmenu_item_type&gt; &lt;var_name&gt; &lt;string&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; }\n&lt;rcmenu_item_type&gt;::= <em class=\"codeEmphasisStrong\">menuitem</em> <em class=\"codeEmphasisStrong\">separator</em> <em class=\"codeEmphasisStrong\">submenu</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_E974CFCDFE004E3ABB6DC4492799F6E2\"></a><pre>&lt;macroscript_def&gt; ::= macroscript &lt;var_name&gt; &lt;string&gt; { &lt;var_name&gt;:&lt;operand&gt; } <em class=\"codeEmphasisStrong\">(</em> &lt;expr_seq&gt; <em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_0A635D27BEC94A9990013CBB222F01EE\"></a><pre>&lt;mousetool_def&gt; ::=<em class=\"codeEmphasisStrong\"> tool </em>&lt;var_name&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; }<em class=\"codeEmphasisStrong\">(</em>{ &lt;tool_clause&gt; }+<em class=\"codeEmphasisStrong\">)</em>\n\n&lt;tool_clause&gt; ::=<em class=\"codeEmphasisStrong\"> local </em>&lt;decl&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;decl&gt; }\n&lt;function_def&gt;\n&lt;struct_def&gt;\n&lt;tool_handler&gt;\n\n&lt;tool_handler&gt; ::= <em class=\"codeEmphasisStrong\"> on</em> &lt;var_name&gt; &lt;var_name&gt; { &lt;var_name&gt; } <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_A00DEB7733274F33BDEEB447D14A6183\"></a><pre>&lt;plugin_def&gt; ::= <em class=\"codeEmphasisStrong\">plugin </em>&lt;var_name&gt; &lt;var_name&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; } \\\n<em class=\"codeEmphasisStrong\">(</em> { &lt;plugin_clause&gt; }+ <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;plugin_clause&gt; ::=<em class=\"codeEmphasisStrong\"> local </em>&lt;decl&gt; { <em class=\"codeEmphasisStrong\">, </em>&lt;decl&gt; }\n&lt;function_def&gt;\n&lt;struct_def&gt;\n&lt;parameters&gt;\n&lt;mousetool_def&gt;\n&lt;rollout_def&gt;\n&lt;plugin_handler&gt;\n\n&lt;parameters&gt; ::=<em class=\"codeEmphasisStrong\"> parameters </em>&lt;var_name&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; } <em class=\"codeEmphasisStrong\">( </em>{ &lt;param_clause&gt; }+ <em class=\"codeEmphasisStrong\">)</em>\n\n&lt;param_clause&gt; ::= { &lt;param_defs&gt; }+\n{ &lt;param_handler&gt; }\n\n&lt;param_defs&gt; ::= &lt;var_name&gt; { &lt;var_name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt; }\n\n&lt;param_handler&gt; ::= <em class=\"codeEmphasisStrong\">on </em>&lt;var_name&gt; &lt;var_name&gt; { &lt;var_name&gt; } <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;\n\n&lt;plugin_handler&gt; ::=<em class=\"codeEmphasisStrong\"> on </em>&lt;var_name&gt;<em class=\"codeEmphasisStrong\"> do </em>&lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_85B9C88B4F424441B58A6BD123695A5C\"></a><pre>&lt;simple_expr&gt; ::= &lt;operand&gt;\n&lt;math_expr&gt;\n&lt;compare_expr&gt;\n&lt;logical_expr&gt;\n&lt;function_call&gt;\n&lt;expr_seq&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_A5A091B390644835938546D2EFF9AD14\"></a><pre>&lt;math_expr&gt; ::= &lt;math_operand&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;math_operand&gt; -- standard arithmetic addition\n&lt;math_operand&gt;<em class=\"codeEmphasisStrong\"> - </em>&lt;math_operand&gt; -- standard arithmetic subtraction\n&lt;math_operand&gt;<em class=\"codeEmphasisStrong\"> * </em>&lt;math_operand&gt; -- standard arithmetic multiplication\n&lt;math_operand&gt;<em class=\"codeEmphasisStrong\"> /</em> &lt;math_operand&gt; -- standard arithmetic division\n&lt;math_operand&gt;<em class=\"codeEmphasisStrong\"> ^ </em>&lt;math_operand&gt; -- exponential, raise to the power\n&lt;math_operand&gt;<em class=\"codeEmphasisStrong\"> as </em>&lt;class&gt; -- conversion between types\n\n&lt;math_operand&gt; ::= &lt;operand&gt;\n&lt;function_call&gt;\n&lt;math_expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_3ECE51D3695342F08FCAA5CAA4C5FDFA\"></a><pre>&lt;logical_expr&gt; ::= &lt;logical_operand&gt;<em class=\"codeEmphasisStrong\"> or </em>&lt;logical_operand&gt;\n&lt;logical_operand&gt;<em class=\"codeEmphasisStrong\"> and </em>&lt;logical_operand&gt;\n<em class=\"codeEmphasisStrong\">not </em>&lt;logical_operand&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_716FD2C0D8994437AE3678AAB0F65A32\"></a><pre>&lt;logical_operand&gt; ::= &lt;operand&gt;\n&lt;compare_expr&gt;\n&lt;function_call&gt;\n&lt;logical_expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_CD900D98633B438FB234380B6C712AFE\"></a><pre>&lt;compare_expr&gt; ::= &lt;compare_operand&gt; = = &lt;compare_operand&gt; -- equal\n&lt;compare_operand&gt; <em class=\"codeEmphasisStrong\">!= </em>&lt;compare_operand&gt; -- not equal\n&lt;compare_operand&gt; <em class=\"codeEmphasisStrong\">&gt; </em>&lt;compare_operand&gt; -- greater than\n&lt;compare_operand&gt; <em class=\"codeEmphasisStrong\">&lt;</em> &lt;compare_operand&gt; -- less than\n&lt;compare_operand&gt; <em class=\"codeEmphasisStrong\">&gt;=</em> &lt;compare_operand&gt; -- greater than or equal\n&lt;compare_operand&gt;<em class=\"codeEmphasisStrong\"> &lt;=</em> &lt;compare_operand&gt; -- less than or equal</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_0FC8EE30B2C84792AF1B136719188670\"></a><pre>&lt;compare_operand&gt; ::= &lt;math_expr&gt;\n&lt;operand&gt;\n&lt;function_call&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_411082FC262647E280CAE7D6F1B07A63\"></a><pre>&lt;function_call&gt; <em class=\"codeEmphasisStrong\">::=</em> &lt;operand&gt; <em class=\"codeEmphasisStrong\">( )</em>\n&lt;operand&gt; { &lt;parameter&gt; } -- up to an end of line or lower precedence token</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_07CB9849D2B240BEAEC5D5D68806F952\"></a><pre>&lt;parameter&gt; <em class=\"codeEmphasisStrong\">::=</em> &lt;operand&gt;\n&lt;name&gt;<em class=\"codeEmphasisStrong\">:</em>&lt;operand&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_971A7F1EAE7C4560888A938B34ED0608\"></a><pre>&lt;operand&gt; <em class=\"codeEmphasisStrong\">::=</em> &lt;factor&gt;\n&lt;property&gt;\n&lt;index&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_0777B5122AE24D8493077AA0493A6BAF\"></a><pre>&lt;property&gt; ::= &lt;operand&gt; . &lt;var_name&gt; -- properties and indexes left associate</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_FCF8E3292B8643DE899BD2FE0B57828A\"></a><pre>&lt;index&gt; ::= &lt;operand&gt; <em class=\"codeEmphasisStrong\">[ </em>&lt;expr&gt;<em class=\"codeEmphasisStrong\"> ]</em> </pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_0C542099BC304CB38633050DA4FD9D19\"></a><pre>&lt;factor&gt; ::= &lt;number&gt;\n&lt;string&gt;\n&lt;path_name&gt;\n&lt;var_name&gt;\n#&lt;var_name&gt;\n&lt;array&gt;\n&lt;bitarray&gt;\n&lt;point3&gt;\n&lt;point2&gt;\n<em class=\"codeEmphasisStrong\">true</em> <em class=\"codeEmphasisStrong\">false</em> <em class=\"codeEmphasisStrong\">on</em> <em class=\"codeEmphasisStrong\">off</em> <em class=\"codeEmphasisStrong\">ok</em> <em class=\"codeEmphasisStrong\">undefined</em> <em class=\"codeEmphasisStrong\">unsupplied</em>\n- &lt;expr&gt; -- unary minus\n&lt;expr_seq&gt;\n<em class=\"codeEmphasisStrong\">?</em> -- last Listener result</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_5A5418FD0B3E404DA9CEBAEAEF705DC4\"></a><pre>&lt;expr_seq&gt; ::= <em class=\"codeEmphasisStrong\">(</em> &lt;expr&gt; { ( <em class=\"codeEmphasisStrong\">;</em> | &lt;eol&gt;) &lt;expr&gt; }<em class=\"codeEmphasisStrong\"> )</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_B504BC536B394E5EAEC13240C2C97C41\"></a><pre>&lt;number&gt; ::= [-]{&lt;digit&gt;}[.{&lt;digit&gt;}[(<em class=\"codeEmphasisStrong\">e </em>|<em class=\"codeEmphasisStrong\"> E</em>)[+ | -]{&lt;digit&gt;}+] -- decimal number\n0x{&lt;hex_digit&gt;}+ -- hexadecimal number</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_274E2D894E1F4615ACCE03F114E3796A\"></a><pre>&lt;string&gt; ::= <em class=\"codeEmphasisStrong\">\"</em>{ &lt;any_char_except_quote&gt;| <em class=\"codeEmphasisStrong\">\\\" </em>|<em class=\"codeEmphasisStrong\"> \\n </em>|<em class=\"codeEmphasisStrong\"> \\r </em>|<em class=\"codeEmphasisStrong\"> \\t </em>|<em class=\"codeEmphasisStrong\"> \\*</em> |<em class=\"codeEmphasisStrong\"> \\? </em>|<em class=\"codeEmphasisStrong\"> \\\\</em> |<em class=\"codeEmphasisStrong\"> \\% </em>|<em class=\"codeEmphasisStrong\"> \\x</em> {&lt;hex_digit&gt;}+ }<em class=\"codeEmphasisStrong\">\"</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_1270404DAB0247EBB307CCF5C1A4C804\"></a><pre>&lt;time&gt; ::= [-]{&lt;decimal_number&gt;[<em class=\"codeEmphasisStrong\">m </em>|<em class=\"codeEmphasisStrong\"> s </em>| <em class=\"codeEmphasisStrong\">f </em>|<em class=\"codeEmphasisStrong\"> t</em>]}+ -- minutes/sec/frames/ticks\n[-]{&lt;digit&gt;}<em class=\"codeEmphasisStrong\">:</em>{&lt;digit&gt;}[.{&lt;digit&gt;}] -- SMPTE mins:secs.frame\n[-]&lt;decimal_number&gt;<em class=\"codeEmphasisStrong\">n</em> -- active segment normalized time</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_35134DE9B4374BCD99B840618016F186\"></a><pre>&lt;box2&gt; ::= <em class=\"codeEmphasisStrong\">[</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">, </em>&lt;expr&gt;<em class=\"codeEmphasisStrong\">, </em>&lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\"> ]</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_21C174B58B244FD6B06C1E33B0CAEE66\"></a><pre>&lt;point3&gt; ::= <em class=\"codeEmphasisStrong\">[ </em>&lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">]</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_C2B49FA93E704A05BC3536C48CD887EF\"></a><pre>&lt;point2&gt; ::=<em class=\"codeEmphasisStrong\"> [</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">]</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_57D27A9A02CB4D369A7F32D28DC6B3B7\"></a><pre>&lt;array&gt; ::= <em class=\"codeEmphasisStrong\">#( )</em> <em class=\"codeEmphasisStrong\">#(</em> &lt;expr&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt; }<em class=\"codeEmphasisStrong\"> )</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_66185E6E5E424A42B135D6B9B61584DC\"></a><pre>&lt;bitarray&gt; ::= <em class=\"codeEmphasisStrong\">#{ }</em> <em class=\"codeEmphasisStrong\">#{ </em>[&lt;expr&gt; | &lt;expr&gt;<em class=\"codeEmphasisStrong\">. .</em>&lt;expr&gt;] { <em class=\"codeEmphasisStrong\">,</em> [&lt;expr&gt; | &lt;expr&gt;<em class=\"codeEmphasisStrong\">. .</em>&lt;expr&gt;] } <em class=\"codeEmphasisStrong\">}</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_588FF0BED3F24C12A2B6711388F0D982\"></a><pre>&lt;path_name&gt; ::=<em class=\"codeEmphasisStrong\"> $</em>&lt;path&gt; | <em class=\"codeEmphasisStrong\">$</em></pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_1330A6DE70724667ACD9D5FD924B0599\"></a><pre>&lt;path&gt; ::= [ &lt;objectset&gt; ] [ <em class=\"codeEmphasisStrong\">/</em> ] [ &lt;levels&gt; ] &lt;level_name&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_1BE58EB498574DD8A12AE04C650514E9\"></a><pre>&lt;levels&gt; ::= &lt;level&gt; { <em class=\"codeEmphasisStrong\">/</em> &lt;level&gt; }\n\n&lt;level&gt; ::= &lt;level_name&gt;\n\n&lt;level_name&gt; ::= { &lt;alphanumeric&gt; |<em class=\"codeEmphasisStrong\"> _ </em>|<em class=\"codeEmphasisStrong\"> * </em>|<em class=\"codeEmphasisStrong\"> ?</em> |<em class=\"codeEmphasisStrong\"> \\</em> }</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-626F\"></a><pre><em class=\"codeEmphasisStrong\">\'</em>{ &lt;any_char_except_single_quote&gt;|<em class=\"codeEmphasisStrong\"> \\* </em>|<em class=\"codeEmphasisStrong\"> \\? </em>|<em class=\"codeEmphasisStrong\"> \\\\</em> }<em class=\"codeEmphasisStrong\">\'</em></pre></div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";