var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4845926E-C867-4338-A52E-067B7C5A6C0E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSPointCurve - NURBSCurve\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"indexterm\" content=\"setPoint()\">\n      <meta name=\"indexterm\" content=\"refine()\">\n      <meta name=\"indexterm\" content=\"getPoint()\">\n      <meta name=\"indexterm\" content=\"close()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSPointCurve : NURBSCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4845926E-C867-4338-A52E-067B7C5A6C0E\"></a><div class=\"head\">\n            <h1>NURBSPointCurve : NURBSCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44AF\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44AE\"></a>  This class defines an independent curve that uses points to describe its shape. All\n               the points lie on the curve itself. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44AB\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C8\"></a><pre><em class=\"codeEmphasisStrong\">NURBSPointCurve</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44A9\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C7\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44A5\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C6\"></a><pre>&lt;nurbspointcurve&gt;.<em class=\"codeEmphasisStrong\">numPoints</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44A3\"></a>The number of points in the point curve. If this value is changed, the previous point\n               data is not maintained. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C5\"></a><pre>&lt;nurbspointcurve&gt;.<em class=\"codeEmphasisStrong\">closed</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44A0\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the curve is closed, <span class=\"code\"> <em class=\"strong\">false</em> </span> if open. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C4\"></a><pre>&lt;nurbspointcurve&gt;.<em class=\"codeEmphasisStrong\">transform</em> : matrix3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-449D\"></a>The transformation matrix for the NURBSPointCurve. This controls the relative position\n               of the item within a NURBSSet. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-538B\"></a>     <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C3\"></a><pre><em class=\"codeEmphasisStrong\">close</em> &lt;nurbspointcurve&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4497\"></a>Closes the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C2\"></a><pre><em class=\"codeEmphasisStrong\">getPoint</em> &lt;nurbspointcurve&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4494\"></a>Get the indexed curve point as a NURBSIndependentPoint \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C1\"></a><pre><em class=\"codeEmphasisStrong\">setPoint</em> &lt;nurbspointcurve&gt; &lt;index&gt; &lt;nurbs_independent_pt&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4491\"></a>Set the indexed point to the given NURBSIndependentPoint \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21C0\"></a><pre><em class=\"codeEmphasisStrong\">refine</em> &lt;nurbspointcurve&gt; &lt;u_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-448E\"></a>Adds a new, interpolated point at the given parametric position along the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-448B\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-448A\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4489\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";