var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-49AC1816-93C7-452E-BD30-62066AB038B7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"time control\">\n      <meta name=\"indexterm\" content=\"stopAnimation()\">\n      <meta name=\"indexterm\" content=\"sliderTime\">\n      <meta name=\"indexterm\" content=\"playAnimation()\">\n      <meta name=\"indexterm\" content=\"animButtonState\">\n      <meta name=\"indexterm\" content=\"animButtonEnabled\">\n      <meta name=\"indexterm\" content=\"isAnimPlaying()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Control</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-49AC1816-93C7-452E-BD30-62066AB038B7\"></a><div class=\"head\">\n            <h1>Time Control </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FFC\"></a>      The following methods and \n            		<em class=\"strong\">3ds Max</em> system global variables are associated with the \n            		<em class=\"strong\">3ds Max</em> Time Controls: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C33\"></a><pre><em class=\"codeEmphasisStrong\">animButtonEnabled</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FF3\"></a>A Boolean value that specifies whether the user can change the state of the Auto Key\n            button. \n            	 \n         </p>\n         <p> If set to True, the user can change the Auto Key button state. \n            	 \n         </p>\n         <p>If set to False, the user cannot change the Auto Key button state. \n            	 \n         </p>\n         <p>A script can change the state of the Auto Key button using animButtonState regardless\n            of the animButtonEnabled value. \n            	 \n         </p>\n         <p><a name=\"GUID-8D0FBFCD-0A08-40AA-97C8-A29F197818B2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C32\"></a><pre><em class=\"codeEmphasisStrong\">animButtonState</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FF0\"></a>Lets you to get and set the state of the Auto Key button as a Boolean value. \n            	 \n         </p>\n         <p> When set to True, the Auto Key button is on and changing scene objects will create\n            animation keys. \n            	 \n         </p>\n         <p> When set to False, the Auto Key button is off. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FEF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">HISTORY:</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FED\"></a><p class=\"table-body\">In the early \n                        					 <em class=\"strong\">3ds Max</em> versions, there was no \n                        					 <em class=\"strong\">Set Key</em> mode and the \n                        					 <em class=\"strong\">Auto Key</em> button was called the \n                        					 <em class=\"strong\">Animate</em> button. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FEC\"></a><p class=\"table-body\">The name is still used for compatibility reasons. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">animateMode</em></pre></div>\n         <p> Lets you to get and set the animate mode without affecting the Auto Key button state.\n            Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p> When set to True, changing object properties will set animation keys, but the Auto\n            Key button will not be checked. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C31\"></a><pre><em class=\"codeEmphasisStrong\">sliderTime</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE9\"></a>Lets you get and set a Time value that defines the time associated with the \n            		<em class=\"strong\">3ds Max</em> time slider. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE7\"></a>Two functions are provided for starting and stopping the \n            		<em class=\"strong\">3ds Max</em> animation playback, which are essentially equivalent to pressing the Play button\n            in the \n            		<em class=\"strong\">3ds Max</em> user interface. \n            	 \n         </p>\n         <p> The functions are: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C30\"></a><pre><em class=\"codeEmphasisStrong\">playAnimation</em> [ <em class=\"codeEmphasisStrong\">#selOnly</em> ] <em class=\"codeEmphasisStrong\">immediateReturn</em>:&lt;boolean&gt;\n\n<em class=\"codeEmphasisStrong\">stopAnimation</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE4\"></a>If you specify the optional argument, \n            		<span class=\"code\"> <em class=\"strong\">#selOnly</em> </span>, to \n            		<span class=\"code\"> <em class=\"strong\">playAnimation()</em> </span> only the currently selected objects are animated. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE3\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">immediateReturn</em> </span> is set to False or not specified, and Real Time Playback is on (<span class=\"code\"> <em class=\"strong\">realTimePlayback = true</em> </span>), the method does not return until animation playback is stopped. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE2\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">immediateReturn</em> </span> is set to True, or Real Time Playback is off (<span class=\"code\"> <em class=\"strong\">realTimePlayback = false</em> </span>), the method returns immediately. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FE0\"></a>There is an important restriction to understand when using these functions: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FDF\"></a>Calling \n            		<span class=\"code\"> <em class=\"strong\">playAnimation()</em> </span> is a thread-blocking call internally in \n            		<em class=\"strong\">3ds Max</em> and does not return until the playback is stopped by the user clicking the Stop Play\n            button or another thread executing a \n            		<span class=\"code\"> <em class=\"strong\">stopAnimation()</em> </span>. \n            	 \n         </p>\n         <p>The only way to achieve the latter in MAXScript currently is to call \n            		<span class=\"code\"> <em class=\"strong\">stopAnimation()</em> </span> from a scripted rollout panel handler such as a button press handler or from a scripted\n            controller script. \n            	 \n         </p>\n         <p>If you invoke \n            		<span class=\"code\"> <em class=\"strong\">playAnimation()</em> </span> in code run from the Listener, you will not be able to invoke \n            		<span class=\"code\"> <em class=\"strong\">stopAnimation()</em> </span> from the Listener because the Listener is blocked inside the \n            		<span class=\"code\"> <em class=\"strong\">playAnimation()</em> </span> call. \n            	 \n         </p>\n         <p><a name=\"GUID-06C1B599-C449-4EE2-B59D-A978CCBD8C8A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C2F\"></a><pre><em class=\"codeEmphasisStrong\">isAnimPlaying</em>()</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-799A\"></a>  Returns True if the animation is currently playing, False otherwise. \n            	 \n         </p>\n         <p> Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2FDA\"></a>Also see \n            		<span class=\"char_link\"><a href=\"GUID-0E38D992-E687-4A0D-80BB-875F0BAD021E.htm\">Time Configuration Dialog</a></span> for methods for setting options in the Time Configuration dialog. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";