var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-49BE2F03-7AC0-41B3-9B82-EF2D2B094BDE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"collections\">\n      <meta name=\"indexterm\" content=\"ArrayParameter values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ArrayParameter Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-49BE2F03-7AC0-41B3-9B82-EF2D2B094BDE\"></a><div class=\"head\">\n            <h1>ArrayParameter Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B09\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B08\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; ArrayParameter Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B06\"></a>Certain plug-ins in <em class=\"strong\">3ds Max</em> store parameter data in a form that is accessible by MAXScript as <em class=\"strong\">ArrayParameters</em>. As such, you can access the parameter data by index and iterate over the parameter\n            data. \n         </p>\n         <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B05\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6C\"></a><pre>&lt;MAXWrapper&gt;.<em class=\"codeEmphasisStrong\">parameter</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B03\"></a>Where the parameter contains an ArrayParameter. \n         </p>\n         <p><a name=\"P_E1D8B1B5453F4EDAA85A83A7BA3C37C5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B02\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6B\"></a><pre>&lt;ArrayParameter&gt;.<em class=\"codeEmphasisStrong\">count</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B00\"></a>Returns the number of values in the ArrayParameter. Read-only in most cases with exceptions\n            noted in the MAXWrapper object description where an adjustable ArrayParameter is used.\n            \n         </p>\n         <p><a name=\"P_18F0120AA4214DC981769B2E9CBDD98C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AFF\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6A\"></a><pre>&lt;ArrayParameter&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AFD\"></a>Returns the element of ArrayParameter. Indexes start at 1. \n         </p>\n         <p><a name=\"P_15787EE8BC8A4C6EA2EE02ABE1A952C7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E69\"></a><pre>&lt;ArrayParameter&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> = &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AFA\"></a>Sets the element of ArrayParameter to a value. \n         </p>\n         <p><a name=\"P_7109A72CC97540C48812158482E48417\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF8\"></a>Each ArrayParameter can only contain data of a certain type (for example, Float),\n            or a controller that matches that data type. The <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span> function indicates these array parameters as <span class=\"code\"> <em class=\"strong\">&lt;type&gt; array</em> </span>, for example, <span class=\"code\"> <em class=\"strong\">int array</em> </span>, <span class=\"code\"> <em class=\"strong\">texmap array</em> </span>, and so on. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF7\"></a>A plug-in can also define parameter names that point to specific entries in one of\n            its ArrayParameters. For example, <span class=\"code\"> <em class=\"strong\">mapAmounts</em> </span> is a property of Standard materials containing an ArrayParameter. Each element in\n            this ArrayParameter contains the map amount for one of the map channels. For easier\n            access in a script, the Standard <span class=\"code\"> <em class=\"strong\">.ambientMapAmount</em> </span> property is provided as an alias for <span class=\"code\"> <em class=\"strong\">mapAmounts[1]</em> </span> (along with aliases for all the other common maps). You can access the controller\n            for the <span class=\"code\"> <em class=\"strong\">ambientMapAmount</em> </span> alias either through the <span class=\"code\"> <em class=\"strong\">.controller</em> </span> property on the alias or on the <span class=\"code\"> <em class=\"strong\">.mapAmounts[1]</em> </span> property. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF5\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF4\"></a><p class=\"table-body\">either </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E68\"></a><pre>\n$foo.material.ambientMapAmount.controller\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AF0\"></a><p class=\"table-body\">or </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E67\"></a><pre>\n$foo.material.mapAmounts[1].controller\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AEC\"></a><p class=\"table-body\">will get the controller on the ambient map amount material property. </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AEA\"></a>ArrayParameter values can be coerced to Array in <em class=\"strong\">3ds Max 6 and higher</em>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AE9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AE8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E66\"></a><pre>\nmtl = standard()\nmapsArray = mtl.maps as array\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AE1\"></a>The following script shows the use of <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span> to show the data type for elements of ArrayParameters, access to ArrayParameter elements,\n            and a case of a plug-in defining parameter names that point to a specific entry in\n            one of its ArrayParameters. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7ADF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7ADE\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E65\"></a><pre>\nm=CompositeMaterial() -- create a Composite material\nshowproperties m -- show the properties for the material\nm.amount -- show value of parameter amount\nm.amount[1] *= .5 -- reduce the value for one element\nm=standard() -- create a Standard material\nshowproperties m -- show it’s properties\nm.ambientMapAmount=13 -- set the value for one element via its alias\nm.mapAmounts[1] -- and show the element was changed\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7AD3\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E64\"></a><pre>\ncompositematerial:Composite -- result line 1\n.materialList (Material : material array -- output line 2\n.mixType (Composite Type) : int array -- ArrayParameter elements are integer\n.mapEnables (Map Enable) : bool array -- ArrayParameter elements are boolean\n.amount : float array -- ArrayParameter elements are float\nOK -- result line 2\n#(100, 100, 100, 100, 100, 100, 100, 100, 100, 100) -- result line 3\n50.0 -- result line 4\nStandardmaterial:Standard -- result line 5\n.mapEnables (Map Enables) : bool array -- pruned output line 6\n.maps : texmap array\n.mapAmounts (Map Amounts) : percent array\n.ambientMap (alias for maps[0])\n.ambientMapAmount (alias for mapAmounts[0])\n.ambientMapEnable (alias for mapEnables[0])\n.bumpMap (alias for maps[8])\n.bumpMapAmount (alias for mapAmounts[8])\n.bumpMapEnable (alias for mapEnables[8])\n13 -- result line 7\n13.0 -- result line 8\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";