var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4B31E2CC-8862-4C19-AA07-2DDED173757C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Structure Scope While Initializing\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Structure Scope While Initializing</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4B31E2CC-8862-4C19-AA07-2DDED173757C\"></a><div class=\"head\">\n            <h1>Structure Scope While Initializing </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8756E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8756F\"></a> When initializing a structure, the scope will be set to the structure\'s context. Note\n               that this effectively lets you run a function within the structure when an instance\n               of the structure is created!\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87571\"></a>For example, when creating an instance of the following structure, the variable \'foo\'\n               is initialized to 2, the function \'onCreate\' increments the value of foo and then\n               returns a value of foo plus 3, and the variable \'a\' is initialized to the result of\n               calling the function \'onCreate\':\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87573\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87574\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606D\"></a><pre>\nstruct doinStuff (\nfoo = 2,\nfn onCreate= (foo += 1;foo+3),\na = onCreate()\n)\nDoIt = doinStuff()\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8757D\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS IN:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606C\"></a><pre>\ndoinStuff foo:3 a:6\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87582\"></a>You can be real inventive with what you can do when you create a structure instance.\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87584\"></a> <span class=\"char_link\"><a href=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6.htm\">Structure Definition</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87585\"></a> <span class=\"char_link\"><a href=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E.htm\">Defining Local Functions in Structures</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87586\"></a> <span class=\"char_link\"><a href=\"GUID-D5426B3F-7060-4C02-BA75-CB24A66B2ABD.htm\">Structure Inherited Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87587\"></a> <span class=\"char_link\"><a href=\"GUID-A3A4E597-B4D7-4C38-90A6-E8F78203114E.htm\">Structure Creation and Cloning Event Handlers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87588\"></a> <span class=\"char_link\"><a href=\"GUID-0D3592DD-2F20-4A41-B19F-544426B8186E.htm\">Private and Public Members in Structure Definitions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";