var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4C14F474-CD23-4001-93DF-0F0F9A6025C7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Tutorial: MAXScript\">\n      <meta name=\"indexterm\" content=\"Learning MAXScript\">\n      <meta name=\"indexterm\" content=\"contents\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Learning MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4C14F474-CD23-4001-93DF-0F0F9A6025C7\"></a><div class=\"head\">\n            <h1>Learning MAXScript </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD0\"></a>   Welcome to the \"Learning MAXScript\" section. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD4\"></a>This introductory reference should help you getting started using MAXScript, the scripting\n            language of <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD5\"></a>\"Learning MAXScript\" can be used as an introductory reference. However, it is most\n            useful if read straight through as a tutorial. You can follow the examples in this\n            reference by using copy-and-paste to bring the code from this document into the MAXScript\n            Listener. You can also type in your own text and start experimenting with MAXScript\n            as you learn it. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD6\"></a>In addition, the <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" tutorials chapter</a></span> will introduce you to some simple real-world examples with detailed comments and\n            links to the definitions of used methods and functions. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD7\"></a> \n            <h2><a name=\"GUID-F6EA85B3-A2EE-4A42-9D4E-92B47236FB0B\"></a> <em class=\"strong\">Getting Started</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD8\"></a> <span class=\"char_link\"><a href=\"GUID-B51DE21E-DD2E-4A06-A7FD-F63C788EAC3D.htm\">Accessing MAXScript</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DD9\"></a> <span class=\"char_link\"><a href=\"GUID-E7FBAD67-2B3F-42B4-9C91-81E1F40087AB.htm\">Source Code Layout</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDA\"></a> <span class=\"char_link\"><a href=\"GUID-34C253DE-0F9F-4FB5-BBB1-4233F2C32477.htm\">Entering Information into MAXScript</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDB\"></a> <span class=\"char_link\"><a href=\"GUID-78A3F5B1-9C42-4725-B7BB-E67708D39644.htm\">Assigning Variables</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDC\"></a> <span class=\"char_link\"><a href=\"GUID-BEFD6E9D-65BF-4C0B-B217-8604DC48200B.htm\">Mathematical Operations in MAXScript</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDD\"></a> \n            <h2><a name=\"GUID-FA76A2A3-9BAE-4248-A82E-A3063046F51B\"></a> <em class=\"strong\">Manipulating The Box - First Steps in MAXScript</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDE\"></a> <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">Drawing a Box with MAXScript</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DDF\"></a> <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">Modifying the Box</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE0\"></a> <span class=\"char_link\"><a href=\"GUID-308EA213-59FA-4F1B-AF40-FC7E658F5DD2.htm\">Applying Standard Transformations</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE1\"></a> <span class=\"char_link\"><a href=\"GUID-22A56B6C-CB64-49BA-8C15-0354378EB575.htm\">More Box Transformations</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE2\"></a> \n            <h2><a name=\"GUID-F5BB22A2-D8E4-4512-92BC-D1F9FE3BAC68\"></a> <em class=\"strong\">Creating Your Own Scripts</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE3\"></a> <span class=\"char_link\"><a href=\"GUID-28C01632-B984-483F-9233-FD7B62F093BE.htm\">The Script Editor</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE4\"></a> <span class=\"char_link\"><a href=\"GUID-321A4B1F-11D8-41F4-B049-4C02E7567125.htm\">Controlling Program Flow in Scripts</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE5\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE6\"></a> <span class=\"char_link\"><a href=\"GUID-A35C74C5-1721-4B19-9FC4-E1CD6563505B.htm\">Structure Definitions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE7\"></a> <span class=\"char_link\"><a href=\"GUID-C778E515-8B85-4828-96E9-8CB41315E4C4.htm\">max Commands in MAXScript</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE8\"></a> <span class=\"char_link\"><a href=\"GUID-6A990055-4774-4EC8-B73E-AC2BFC37F741.htm\">Saving your Commands in a Script File</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DE9\"></a> <span class=\"char_link\"><a href=\"GUID-27B7736C-D892-4D7D-A5DC-02AA2FD08C40.htm\">Loading and Running Your Script File</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DEA\"></a> \n            <h2><a name=\"GUID-8487DA45-1478-448A-8D7F-1B17C5878089\"></a> <em class=\"strong\">Learning From Other Scripts</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DEB\"></a> <span class=\"char_link\"><a href=\"GUID-38734FD0-CCD7-42DC-995D-9C837DDED654.htm\">Loading Other Scripts</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DEC\"></a> <span class=\"char_link\"><a href=\"GUID-EA733C02-CC2B-4F62-AE69-9BD1A870D9D3.htm\">Learning MAXScript by Walking Through a Script</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DED\"></a> <span class=\"char_link\"><a href=\"GUID-D6AF4319-041A-43F4-A6C7-55FF078EBF06.htm\">Learning MAXScript with the Macro Recorder</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DEE\"></a> \n            <h2><a name=\"GUID-8427300F-F64C-47FD-B01A-739813FCB8D2\"></a> <em class=\"strong\">MAXScript for New and Casual Users</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DEF\"></a> <span class=\"char_link\"><a href=\"GUID-35CB7918-A86D-465E-AC63-3AAE310A113B.htm\">MAXScript for New and Casual Users</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF0\"></a> <span class=\"char_link\"><a href=\"GUID-06825F89-B5DD-42D8-AB32-B928C897CA60.htm\">Scripted Utilities for New Users</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF1\"></a> <span class=\"char_link\"><a href=\"GUID-C3F61DC1-D07C-4DCD-939C-CF30E4DCA29F.htm\">MacroScripts for New Users</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF2\"></a> <span class=\"char_link\"><a href=\"GUID-78D21100-E161-4015-9C8A-15629B153F8D.htm\">Scripted Plug-ins for New Users</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF3\"></a> <span class=\"char_link\"><a href=\"GUID-F2A15BBB-2542-4983-89C0-BAEDC0E6051E.htm\">Scripted Functions for New Users</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF4\"></a> <span class=\"char_link\"><a href=\"GUID-7A554E0F-6509-4E50-9B52-7FF75774D064.htm\">MAXScript DLX Extensions for New Users</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF5\"></a> \n            <h2><a name=\"GUID-B7A0AE92-3D9F-473B-BC3D-5077E061BCB6\"></a> <em class=\"strong\">FAQ:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF6\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF7\"></a> \n            <h2><a name=\"GUID-00C5C612-F919-4A30-B165-D940C3B074AA\"></a> <em class=\"strong\">\'How To\' Tutorials:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF8\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To - Introduction to the Tutorials</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DF9\"></a> \n            <h2><a name=\"GUID-B0C9DDD5-F2C1-466C-8FDF-47701252F9FE\"></a> <em class=\"strong\">Sample Scripts:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DFA\"></a> <span class=\"char_link\"><a href=\"GUID-6B55BDA6-7A44-4910-9650-C65CA1457343.htm\">Online Help Script Examples</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DFB\"></a> \n            <h2><a name=\"GUID-7EF5DC5B-F642-4369-8D00-B165EA30C7EE\"></a> <em class=\"strong\">Navigation Help:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DFC\"></a> <span class=\"char_link\"><a href=\"\">Locating Information in this Help File</a></span> \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-4C1D639F-0A2C-402D-A078-56D8A8DB4964.htm\">Manipulating The Box - First Steps in MAXScript</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-CA4091CE-3656-4190-99DC-B2419214ED84.htm\">Creating Your Own Scripts</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-437CA877-4B60-4D1D-9FBC-BB9716C0286A.htm\">Getting Started</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-AA4C423A-13E0-425E-B399-A3C6AE7E9D93.htm\">Learning From Other Scripts</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-78A07874-70D3-4FFF-BE06-C9BB3721F252.htm\">Trigonometric Functions </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-8FCABE2E-664A-4A82-9FAC-2C5694DC8B4C.htm\">Vector Arithmetic </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";