var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4D849015-4C46-4C98-96CA-A9807ED79EC8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSPointConstPoint - NURBSPoint\">\n      <meta name=\"indexterm\" content=\"NURBSPoint - NURBSObject\">\n      <meta name=\"indexterm\" content=\"getObject()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSPointConstPoint : NURBSPoint</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4D849015-4C46-4C98-96CA-A9807ED79EC8\"></a><div class=\"head\">\n            <h1>NURBSPointConstPoint : NURBSPoint </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-467E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-467D\"></a>   This class defines a dependent point that lies at a point or relative to it. It is\n               a point constrained relative to another point. This can be a point used to define\n               a point surface or point curve, it can be a trim point, or just a point in space.\n               There are two ways to specify the displacement of the point’s location relative to\n               the U position: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4679\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4677\"></a>OnObject - the point is actually at the parent. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4675\"></a>Offset - the point is moved according to a relative (object space) X,Y,Z location.\n                     \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4674\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2233\"></a><pre><em class=\"codeEmphasisStrong\">NURBSPointConstPoint</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4672\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2232\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-466E\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2231\"></a><pre>&lt;nurbspointconstpoint&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-466C\"></a>The parent point by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2230\"></a><pre>&lt;nurbspointconstpoint&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4669\"></a>The parent point by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222F\"></a><pre>&lt;nurbspointconstpoint&gt;.<em class=\"codeEmphasisStrong\">type</em> :<em class=\"codeEmphasisStrong\">#onObject, #offset</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4666\"></a>&nbsp; \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-222E\"></a><pre>&lt;nurbspointconstpoint&gt;.<em class=\"codeEmphasisStrong\">offset</em> : point3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4663\"></a>Offset vector if an offset type. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4660\"></a> <span class=\"char_link\"><a href=\"GUID-7066A0C4-409A-4469-84C8-52C1977FE546.htm\">NURBSPoint</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-465F\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-465E\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";