var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4E926577-61C6-463E-9238-D422EFC03718\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Resource ID\">\n      <meta name=\"indexterm\" content=\"Resource Value\">\n      <meta name=\"indexterm\" content=\"Resource Localization\">\n      <meta name=\"indexterm\" content=\"Resource File\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Resource String Replacement</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4E926577-61C6-463E-9238-D422EFC03718\"></a><div class=\"head\">\n            <h1> Resource String Replacement </h1>\n         </div>\n         <p><a name=\"GUID-F81524F3-E079-48A3-A53F-CF19E1F3FDFC\"></a>     \n         </p>\n         <div class=\"section\"><a name=\"SECTION_EB48DA902E624611A82B38037490C340\"></a> \n            <h2><a name=\"GUID-7D1C187D-1AD6-4AB6-B667-DD735CB5FEB4\"></a>Overview\n            </h2> \n            <p><a name=\"GUID-DAC37D30-1931-4C9C-8187-88E8EB692EF1\"></a>Starting with \n               		  <em class=\"strong\">3ds Max 2012</em>, Scripts and MacroScripts can use Resource IDs in place of strings. \n               		\n            </p> \n            <p><a name=\"GUID-7C52B3FC-BEC6-49D8-8425-253266834462\"></a>This simplifies the localization of scripts significantly: \n               		\n            </p> \n            <p><a name=\"GUID-ED73AF33-57D8-4A31-AB67-6F3606C9EA0E\"></a>All hard-coded English strings can be replaced with Resource IDs and the Resource\n               IDs together with the original values can be stored in a Resource file. \n               		\n            </p> \n            <p><a name=\"GUID-18CAF0AA-AF0E-4CEE-88C1-699223BC18F5\"></a>The Resource file can then be translated into multiple languages and the corresponding\n               language version can be loaded automatically according to the \n               		  <em class=\"strong\">3ds Max \n                  		  </em>Language Settings. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_78704EA3ABFF4ECF88D8021980DE3028\"></a> \n            <h2><a name=\"GUID-8F0A85D0-C7F5-41DC-ACBF-0C90B94183F5\"></a>Implementation\n            </h2> \n            <p><a name=\"GUID-C7F3D14D-FF6A-49EC-A692-183F2222415A\"></a>A \n               		  <em class=\"strong\">Resource ID</em> is identified as a name surrounded by tildes, for example ~LIGHT_LISTER_DIALOG_NAME~.\n               \n               		\n            </p> \n            <p><a name=\"GUID-D2E8993F-1F0C-4A33-A423-97B797DFDFE8\"></a>If MAXScript encounters a Resource ID \n               		  <em class=\"strong\">at compile time</em>, it will search for and load the Resource File that contains the Resource ID / Resource\n               Value pairs and will use the Resource Value in place of the Resource ID. Note that\n               MAXScript will disregard matched files with a size of 0, and will continue searching\n               as described below.\n               		\n            </p> \n            <p><a name=\"GUID-A66BB76E-DD51-402B-BD3E-8ECF882B35F7\"></a>The search for the Resource File will be performed as follows: \n               		\n            </p> <a name=\"UL_7862CF6F96E74C0EACD8F44F8CCA8387\"></a><ul>\n               <li>The directory in which the script source file is stored will be scanned for the same\n                  file name as script file, but with the extension .RES. If the script is not saved\n                  in a file yet, a Compile error will be thrown. \n                  		  \n               </li>\n               <li>If the Resource file was not found there, MAXScript will look for that filename in\n                  a subdirectory whose name is based on the ISO language/country name (for example,\n                  fr-FR) \n                  		  \n               </li>\n               <li>If the file is still not found, MAXScript will look in the en-US subdirectory. \n                  		  \n               </li>\n               <li>As result, if no localized version of the Resource file exists, the English Resource\n                  file will be used by default (if found). \n                  		  \n               </li>\n               <li>If no matching Resource file could be found, a Compile error will be thrown. \n                  		  \n               </li>\n            </ul> \n            <p><a name=\"GUID-35D50030-2DCC-470D-B810-7E246FE4B5D4\"></a>Errors and warnings related to loading MacroScripts and especially issues with Resource\n               IDs, Values and Files will be reported to the MAXScript Listener. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_D3DC31798BE045A08624F11DA1FCFCCC\"></a> \n            <h2><a name=\"GUID-E3CD0A64-D070-4A54-9EF6-08CE5875098C\"></a>Resource File Editing\n            </h2> \n            <p><a name=\"GUID-43FC1AC9-8BD0-4B8E-B11E-1B3FA40D8601\"></a> \'Resource files (*.res)\' files are now supported in the MAXScript Editor\'s \n               		  <em class=\"strong\">File &gt; Open</em> and \n               		  <em class=\"strong\">File &gt; Save</em> dialogs. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";