var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4E9CCD61-F575-42E1-8654-315DDF6C6A26\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"at time context\">\n      <meta name=\"indexterm\" content=\"at\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>at time</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4E9CCD61-F575-42E1-8654-315DDF6C6A26\"></a><div class=\"head\">\n            <h1>at time </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8708F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87090\"></a>   The <span class=\"code\"> <em class=\"strong\">at time &lt;time&gt;</em> </span> context corresponds to the <em class=\"strong\">3ds Max</em> time slider. Any animatable property references will yield their interpolated values\n               for the specified time. If the Animate button is on, or the script is also in an <span class=\"code\"> <em class=\"strong\">animate on</em> </span> context, keyframes are generated at the specified time when an animatable property\n               of a <em class=\"strong\">3ds Max</em> object is changed. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87094\"></a>Setting an <span class=\"code\"> <em class=\"strong\">at time</em> </span> context does not affect the <em class=\"strong\">3ds Max</em> time slider. The time associated with the time slider can be queried and set using\n               the <span class=\"code\"> <em class=\"strong\">sliderTime</em> </span> global variable. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87095\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87096\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60ED\"></a><pre>\n-- generate a keyframed animation of $foo randomly chasing $baz\nfoo=box pos:[0,0,0]\nbaz=sphere pos: [20,20,20]\nanimate on\nfor t in 0 to 100 by 5 do\nat time t\n$foo.pos = $baz.pos + random [-10,-10,-10] [10,10,10]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";