var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-4FF16589-C618-41D4-86A2-794BAA1C275E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"XAML Files with MAXScript Controls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>XAML Files with MAXScript Controls</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4FF16589-C618-41D4-86A2-794BAA1C275E\"></a><div class=\"head\">\n            <h1>XAML Files with MAXScript Controls </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D55\"></a> The Extensible Application Markup Language (XAML) is used to write Windows Presentation\n            Foundation (WPF) applications. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D53\"></a>XAML files are used to define the content of the Ribbon and of the Application Menu\n            of <em class=\"strong\">3ds Max 2010 and higher</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D52\"></a>In <em class=\"strong\">3ds Max 2010</em>, XAML files had to be edited manually to modify existing features or add new ones.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D51\"></a>Since <em class=\"strong\">3ds Max 2011</em>, the XAML files of the Ribbon interface can be customized using dedicated tools.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D50\"></a>Several MAXScript controls can be included in the XAML code to integrate features\n            like MacroScripts, spinners and color pickers. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D4F\"></a> \n            <h2><a name=\"GUID-EE7650C1-27C9-4362-A1AB-54D74058719F\"></a> <em class=\"strong\">ActionItem in an XAML File</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D4E\"></a>A MacroScript, which technically defines an ActionItem, can be added to the Application\n               Menu using the following syntax: \n            </p> \n            <p><a name=\"GUID-89E16B17-DF4C-42E9-82F5-33066BFE1482\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7148\"></a><pre><em class=\"codeEmphasisStrong\">{wpfmax:ActionItem MacroCategory</em>=&lt;Category&gt;, <em class=\"codeEmphasisStrong\">MacroName</em>=&lt;MacroScriptName&gt; <em class=\"codeEmphasisStrong\">}</em> </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D4B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D4A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D49\"></a><p class=\"table-body\">For example, to add a new option to the Application Menu &gt; Export sub-menu to write\n                           the scene to the 3<sup> <span class=\"charspan-emphasis\">rd</span> </sup> party BFF file format, you could add the following to the<em class=\"strong\"> \\ui\\ApplicationMenu.xaml</em> file inside the definition starting with the header \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D48\"></a><p class=\"table-body\">&lt;ApplicationMenuItem Text=\"Export\" IsSplit=\"true\" Id=\"ExportSplit\" ... </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7147\"></a><pre>\n&lt;ApplicationMenuItem Text=\"Bobo\'s File Format\" Id=\"BFFExp\" KeyTip=\"B\"\nLargeImage=\"Icons/ApplicationMenu/export_32.ico\"\nDescription=\"Exports the scene in the MAXScript-based BFF format.\"\nCommandHandler=\"{wpfmax:ActionItem MacroCategory=Bobo_s Tools, MacroName=BFF_Exporter}\"/&gt;\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D40\"></a><p class=\"table-body\">After re-saving the XAML file, opening the3ds Max Application Menu shows the following\n                           additional command: \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D3F\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-DF6AC041-D236-42E0-9BCE-90B7E90E766F-low.gif\"></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D3C\"></a> \n            <h2><a name=\"GUID-B8FE089F-07F5-4AB3-A2B3-3B2A89D63DA7\"></a> <em class=\"strong\">Spinner in an XAML File</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D3B\"></a>Afloat or integer Spinner control can be defined in the Ribbon\'s XAML file. The spinner\n               will interact with the scene via a set of two callback functions defined in a struct.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D3A\"></a> <em class=\"strong\">Syntax:</em> \n            </p> \n            <p><a name=\"GUID-FD8C0F41-E976-4C84-97AF-5BE28DC1E163\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7146\"></a><pre><em class=\"codeEmphasisStrong\">&lt;wpfmax:MaxSpinnerFloat Id</em>=&lt;string&gt;ID 	 <em class=\"codeEmphasisStrong\">MinWidth</em>=&lt;string&gt;MinWidth 	 <em class=\"codeEmphasisStrong\">Width</em>=&lt;string&gt;Width 	 <em class=\"codeEmphasisStrong\">Height</em>=&lt;string&gt;Height 	 <em class=\"codeEmphasisStrong\">Min</em>=&lt;string&gt;MinValur 	 <em class=\"codeEmphasisStrong\">Max</em>=&lt;string&gt;MaxValue 	 <em class=\"codeEmphasisStrong\">Scale</em>=&lt;string&gt;ScaleValue 	 <em class=\"codeEmphasisStrong\">init</em>=&lt;string&gt;InitValue 	 <em class=\"codeEmphasisStrong\">ToolTip</em>=&lt;string&gt;Tooltip 	 <em class=\"codeEmphasisStrong\">MaxscriptCallback</em>=&lt;string&gt;ColorSwatchCallbackStruct /&gt;   </pre></div> \n            <p><a name=\"GUID-82161ED0-F712-445D-8777-E65F0BE45C8E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7145\"></a><pre><em class=\"codeEmphasisStrong\">&lt;wpfmax:MaxSpinnerInt Id</em>=&lt;string&gt;ID   <em class=\"codeEmphasisStrong\">MinWidth</em>=&lt;string&gt;MinWidth   <em class=\"codeEmphasisStrong\">Width</em>=&lt;string&gt;Width   <em class=\"codeEmphasisStrong\">Height</em>=&lt;string&gt;Height   <em class=\"codeEmphasisStrong\">Min</em>=&lt;string&gt;MinValue   <em class=\"codeEmphasisStrong\">Max</em>=&lt;string&gt;MaxValue   <em class=\"codeEmphasisStrong\">Scale</em>=&lt;string&gt;ScaleValue   <em class=\"codeEmphasisStrong\">init</em>=&lt;string&gt;InitValue   <em class=\"codeEmphasisStrong\">ToolTip</em>=&lt;string&gt;Tooltip   <em class=\"codeEmphasisStrong\">MaxscriptCallback</em>=&lt;string&gt;ColorSwatchCallbackStruct /&gt; </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D34\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D33\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D32\"></a><p class=\"table-body\">Here is the sample to define a float spinner that could change the radius of an object\n                           like a sphere or a teapot: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D31\"></a><p class=\"table-body\"> <em class=\"strong\">XAML CODE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7144\"></a><pre>\n&lt;wpfmax:MaxSpinnerFloat Id=\"FloatSpinnerSample\" MinWidth=\"40\" Width=\"40\" Height=\"16\"\nmin=\"0.0\" max=\"10000.0\"\nscale=\"1.0\"\ninit=\"1.0\"\nMaxscriptCallback=\"MySpinnerFloat\"/&gt;\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D29\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT CODE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7143\"></a><pre>\n--Define a global struct with two functions - OnChange() and GetValue()\n--These will be called by the Ribbon spinner thanks to the\n--MaxscriptCallback definition:\nstruct MySpinnerFloat\n(\nfn OnChanged Value = (\nfor o in selection where is Property o #radius do o.radius = Value\n),\nfn GetValue = (\nif selection.count &gt; 0 then\nfor o in selection where is Property o #radius do return o.radius\nelse\n0\n)\n)\n--The OnChanged() function will be called when the value in the UI is changing.\n--The GetValue() function will be called when the system needs to update the value in the UI.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D12\"></a> \n            <h2><a name=\"GUID-C38A8663-1846-460F-BEAF-C076363D075A\"></a> <em class=\"strong\">Colorpicker in an XAML File</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D11\"></a>A ColorPicker UI Controls can be defined in the Ribbon\'s XAML file. The ColorPicker\n               will interact with the scene via a set of two callback functions defined in a struct.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D10\"></a> <em class=\"strong\">Syntax:</em> \n            </p> \n            <p><a name=\"GUID-6BE3EBF3-88AA-461C-8E59-4D7BE8C50122\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7142\"></a><pre><em class=\"codeEmphasisStrong\">&lt;wpfmax:MaxRibbonColorSwatch Id</em>=\"ID\" <em class=\"codeEmphasisStrong\">MinWidth</em>=&lt;string&gt;MinWidth <em class=\"codeEmphasisStrong\">Width</em>=&lt;string&gt;Width <em class=\"codeEmphasisStrong\">Height</em>=&lt;string&gt;Height <em class=\"codeEmphasisStrong\">MaxscriptCallback</em>=&lt;string&gt;ColorSwatchCallbackStruct /&gt; </pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D0D\"></a> \n            <h2><a name=\"GUID-0C56F18F-3B0A-4AD3-8F60-D89DD8BC8480\"></a> <em class=\"strong\">MAXScript Command in an XAML File</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D0C\"></a>A MAXScript Command call can be defined in the Ribbon\'s XAML file. The command can\n               be any valid MAXScript expression. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D0B\"></a> <em class=\"strong\">Syntax:</em> \n            </p> \n            <p><a name=\"GUID-02B0963A-3A42-48EA-B234-93E736AB6A9F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7141\"></a><pre><em class=\"codeEmphasisStrong\">&lt;wpfmax:MaxscriptCommand Maxscript=</em>&lt;string&gt;Expression <em class=\"codeEmphasisStrong\">MaxscriptToggleOff=</em>&lt;string&gt;OffExpression<em class=\"codeEmphasisStrong\"> /&gt;</em> </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D08\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D07\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D06\"></a><p class=\"table-body\">Here is the actual code of the Border Sub-Object button in the Ribbon. </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D05\"></a><p class=\"table-body\">When the button is toggled on, the MAXScript command \"subObjectLevel = 3\" is called\n                           to set the Border mode. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D04\"></a><p class=\"table-body\">When the button is toggled off, the MAXScriptToggleOff expression \"subObjectLevel=\n                           0\" is called. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D03\"></a><p class=\"table-body\">The rest of the code defines which panels should be made visible when the toggle is\n                           on or off. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4D02\"></a><p class=\"table-body\"> <em class=\"strong\">XAML CODE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7140\"></a><pre>\n&lt;wpfmax:MaxSubjectobjectToggleButton Id=\"mBordermode\" Text=\"Border\" Mode=\"Border\" Orientation=\"Vertical\" ShowText=\"False\" Size=\"Standard\" Image=\"Icons/Modeling/bordermode_editpolygons.ico\" &gt;\n&lt;wpfmax:MaxSubjectobjectToggleButton.CommandHandler&gt;\n&lt;wpfmax:MaxscriptCommand Maxscript=\"subobjectLevel = 3\" MaxscriptToggleOff=\"subobjectLevel = 0\" /&gt;\n&lt;/wpfmax:MaxSubjectobjectToggleButton.CommandHandler&gt;\n&lt;s:String&gt;AUseSS, EModifyPanel, ESelectPanel, ESelectLoopsPanel, ESelectByPanel, AStorePanel, ANamedSetsPanel, APatternsPanel&lt;/s:String&gt;\n&lt;s:String&gt;BBorderEdgesPanel, ETriangulationPanel, VGeometryPanel, VCutsPanel, VAlignPanel, VSubdivisionPanel, VPaintDeformPanel, OPropertiesPanel&lt;/s:String&gt;\n&lt;/wpfmax:MaxSubjectobjectToggleButton&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";