var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-51429B01-2FC6-4746-9E88-5EB5D93056CC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"time values\">\n      <meta name=\"indexterm\" content=\"normTime()\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"abs()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-51429B01-2FC6-4746-9E88-5EB5D93056CC\"></a><div class=\"head\">\n            <h1>Time Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FCF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FCE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"\">Time Data Values</a></span> &gt; Time Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FCC\"></a>The <em class=\"strong\">Time </em>class implements animation time in MAXScript. \n         </p>\n         <p><a name=\"P_63783CAE272149D9AED9DE43708F0DD7\"></a>Time values reflect the properties of animation time in<em class=\"strong\"> 3ds Max</em>. \n         </p>\n         <p><a name=\"P_D62C7285D0E94042ABDAA406E2308A67\"></a>Resolution is in <span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">ticks</a></span>, with<em class=\"strong\"> 4800 ticks per second</em>. \n         </p>\n         <p><a name=\"P_513FD6C98DC04D3D819EB4FBD347920F\"></a>You can work with time as ticks, frames, h.m.s, or normalized time. \n         </p>\n         <p><a name=\"P_DB72CF13ACAC423E99A564009A14F0E3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FCB\"></a>You can intermix numbers and time values in time computations defined below. \n         </p>\n         <p><a name=\"P_4F1266106BBF4916AE4CF282B20DC8BA\"></a>The rule is that numbers are always interpreted as <em class=\"strong\">frame</em> counts, with floating point numbers specifying fractional frames. \n         </p>\n         <p><a name=\"P_3D1606F4376043D18A9768B6F5BD41E1\"></a>The numbers are always converted to tick-based time values internally and so have\n            an ultimate resolution of 4800 ticks per second. \n         </p>\n         <p><a name=\"P_10A0CDF03E5B445D9443922A0BA48A35\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FCA\"></a>You can do time arithmetic and comparisons using numbers as well as time values and\n            convert between time and (frame) numbers using the <span class=\"code\"> <em class=\"strong\">as</em> </span> operator. See also <span class=\"char_link\"><a href=\"GUID-4389A5F4-9D6E-4DDE-B3A1-F19E89ED3FB5.htm\">Time Literals</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FC9\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFF\"></a><pre>[-]{&lt;decimal_number&gt;[m | s | f | t]}+ </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FC7\"></a>minutes/sec/frames/<span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">ticks</a></span> \n         </p>\n         <p><a name=\"P_1B99A5960C0B46FE817F91A8F8A973C3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFE\"></a><pre>[-]{&lt;digit&gt;}:{&lt;digit&gt;}[.{&lt;digit&gt;}]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FC4\"></a>SMPTE mins:secs.frame \n         </p>\n         <p><a name=\"P_15B341EBA1CD4AE59699DFDADF3FD7EA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFD\"></a><pre>[-]&lt;decimal_number&gt;n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FC1\"></a>Active segment normalized time \n         </p>\n         <p><a name=\"P_AEB5F45F69CD4F648745D700D54B30B1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FC0\"></a> <em class=\"strong\">Example Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFC\"></a><pre>\n2.5s -- 2.5 seconds\n1m15s -- 1 minute 15 seconds\n2m30s5f2t -- 2 minutes 30 seconds 5 frames 2 ticks\n125f -- 125 frames\n17.25f -- 17.25 frames\n1f20t -- 1 frame 20 ticks\n2:10.0 -- 2 minutes 10 seconds 0 frames (SMPTE)\n0:0.29 -- 29 frames (SMPTE)\n</pre></div>\n         <p><a name=\"P_7517C2713C6242FF858EA3E9285E9E74\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FB7\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFB\"></a><pre><em class=\"codeEmphasisStrong\">normTime</em> &lt;float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FB5\"></a>Time from normal fraction based on the current scene animation range: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FB4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FB3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EFA\"></a><pre>\nanimationRange --check out the current animation range:\n(interval 0f 100f)\ntheHalfTime = normTime 0.5 --get the middle of the range:\n50f\nanimationRange = interval 42f 1024f --set new scene range:\n(interval 42f 1024f)\ntheHalfTime = normTime 0.5 --get the middle of the new range:\n533f\ntheTenth = normTime 0.1 --get the frame at 1/10 of the range:\n140.2f\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FA5\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF9\"></a><pre>&lt;time&gt;.<em class=\"codeEmphasisStrong\">ticks</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FA3\"></a>Time as <span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">ticks</a></span>. \n         </p>\n         <p><a name=\"P_57A9A446D0FB4E38BFDAA92995612C6B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF8\"></a><pre>&lt;time&gt;.<em class=\"codeEmphasisStrong\">frame</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FA0\"></a>Time as frames. \n         </p>\n         <p><a name=\"P_42CC47B64F5948A59665D04D3C347F69\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF7\"></a><pre>&lt;time&gt;.<em class=\"codeEmphasisStrong\">normalized</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F9D\"></a>Time as normalized fraction of active segment (scene animation range): \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F9C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F9B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF6\"></a><pre>\nanimationRange --check out the current animation range:\n(interval 0f 100f)\ntheHalfTime = 50f --the middle of the range:\n50f\nnormalizedTime = theHalfTime.normalized --the normalized time:\n0.5\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F92\"></a>This is the inverse of the<span class=\"code\"> <em class=\"strong\"> normTime</em> </span> constructor described earlier. \n         </p>\n         <p><a name=\"P_6CFC911F608F43359F56A8CDEC4E2C5B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F91\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF5\"></a><pre>&lt;time&gt;<em class=\"codeEmphasisStrong\"> +</em> &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F8F\"></a>Time values addition. \n         </p>\n         <p><a name=\"P_012F712BAFA544B99075847C1D701804\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF4\"></a><pre>&lt;time&gt; - &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F8C\"></a>Time values subtraction. \n         </p>\n         <p><a name=\"P_B9EFC37BE66B44F5AB26EBE5D3372053\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF3\"></a><pre><em class=\"codeEmphasisStrong\">-</em> &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F89\"></a>Invert time value \n         </p>\n         <p><a name=\"P_66BCE4DC363841CAB5AC58F479311518\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF2\"></a><pre>&lt;time&gt;<em class=\"codeEmphasisStrong\"> *</em> &lt;number&gt;\n&lt;time&gt;<em class=\"codeEmphasisStrong\"> /</em> &lt;number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F85\"></a>Scale time \n         </p>\n         <p><a name=\"P_09C3A0E04F7A4DD085A23B9A09A8079B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF1\"></a><pre>&lt;time&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F82\"></a>Compare time values for equality. Returns true if the two time values are equal, false\n            if they are not. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F81\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F80\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EF0\"></a><pre>\nif sliderTime == 42f then \"It is time!\" else \"Not yet!\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EEF\"></a><pre>&lt;time&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F7A\"></a>Compare time values for non-equality. Returns true if the two time values are not\n            equal, false if they are equal. \n         </p>\n         <p><a name=\"P_A68BA3FC765A40FF93E251C5464CB78B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EEE\"></a><pre>&lt;time&gt; <em class=\"codeEmphasisStrong\">&gt; </em>&lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F77\"></a>Returns true if the first time value is greater than the second time value, false\n            if it is less or equal to the second time value. \n         </p>\n         <p><a name=\"P_6277AB4110744854A8FD114772B393FB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EED\"></a><pre>&lt;time&gt;<em class=\"codeEmphasisStrong\"> &gt;= </em>&lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F74\"></a>Returns true if the first time value is greater or equal to the second time value,\n            false if it is less than the second time value. \n         </p>\n         <p><a name=\"P_A69835331F2842EC95939C6578505BC2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EEC\"></a><pre>&lt;time&gt; <em class=\"codeEmphasisStrong\">&lt; </em>&lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F71\"></a>Returns true if the first time value is less than the second time value, false if\n            it is greater than or equal to the second time value. \n         </p>\n         <p><a name=\"P_4351DF400C5444F4BBCF9600CE050780\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EEB\"></a><pre>&lt;time&gt;<em class=\"codeEmphasisStrong\"> &lt;= </em>&lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F6E\"></a>Returns true if the first time value is less than or equal to the second time value,\n            false if it is greater than the second time value. \n         </p>\n         <p><a name=\"P_776740EDCB8B4BCD88BB8008AB1113F4\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EEA\"></a><pre>&lt;time&gt;<em class=\"codeEmphasisStrong\"> as</em> &lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F6B\"></a>You can coerce a time value to an Integer or Float number - you get the time in <span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">ticks</a></span>: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F6A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F69\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE9\"></a><pre>\nsliderTime = 35\n35\ncurrentTime\n35f\ncurrentTime as integer\n5600\ncurrentTime as float\n5600.0\n(currentTime as integer)/TicksPerFrame\n35\n(currentTime as float)/TicksPerFrame\n35.0\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-191B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F57\"></a>To coerce a Time Value to Frames integer, you can use the <span class=\"code\"> <em class=\"strong\">.frame</em> </span> property documented above: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE8\"></a><pre>\ncurrentTime\n35f\ncurrentTime as integer\n5600\ncurrentTime.frame\n35\n</pre></div> \n            </div>\n         </div>\n         <p><a name=\"P_7021219F6B294FC38A7439680A1BE021\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-689F\"></a>  <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE7\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;time&gt; &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F4B\"></a>Generates a random time value in the range defined by the two time values. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F4A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F49\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE6\"></a><pre>\nrandom 10f 100f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F45\"></a><p class=\"table-body\"> <em class=\"strong\">POSSIBLE OUTPUT VALUES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE5\"></a><pre>\n70.9813f\n78.175f\n59.225f\n...\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-191A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F3B\"></a>To generate full frame random values, use Integers instead of Time Values instead.\n                  Integers are always assumed to represent full frames when used in place of Time Values.\n                  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE4\"></a><pre>random 10 100</pre></div> \n            </div>\n         </div>\n         <p><a name=\"P_A32A901611074093B92BAE93A7570C34\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE3\"></a><pre><em class=\"codeEmphasisStrong\">abs</em> &lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F33\"></a>Returns the absolute value of the time value. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F32\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F31\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE2\"></a><pre>\ntheTime = -100f\n-100f\nabs theTime\n100f\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F28\"></a>Some of the examples above refer to system global variables. See <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm\">3ds Max System Globals</a></span> for more details. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";