var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-521FBB6C-CB73-473E-A565-D1A369E7CDAE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"NURBSDisplay - Value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSDisplay : Value</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-521FBB6C-CB73-473E-A565-D1A369E7CDAE\"></a><div class=\"head\">\n            <h1>NURBSDisplay : Value </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4002\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4001\"></a>  This class corresponds to the NURBS display control checkboxes in the General NURBS\n               rollout panel. You can exert control over the display levels in a NURBS object by\n               either assigning NURBSDisplay values to the <span class=\"code\"> <em class=\"strong\">.display</em> </span> property of a NURBSSet value or using the <span class=\"code\"> <em class=\"strong\">setSurfaceDisplay()</em> </span> node function. See <span class=\"char_link\"><a href=\"GUID-8E66EBA2-CD22-41DB-8F26-6A961B0F7018.htm\">NURBS Node Properties and Methods</a></span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FFE\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20C3\"></a><pre><em class=\"codeEmphasisStrong\">NURBSDisplay</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FFC\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20C2\"></a><pre>&lt;nurbsset&gt;.<em class=\"codeEmphasisStrong\">display</em> </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FFA\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20C1\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayCurves</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FF8\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if curves are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20C0\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displaySurfaces</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FF5\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if surfaces are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BF\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayLattices</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FF2\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if lattices are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BE\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displaySurfCVLattices</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FEF\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if surface CV lattices are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BD\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayCurveCVLattices</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FEC\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if curve CV lattices are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BC\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayDependents</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FE9\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if dependent sub-objects are displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BB\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayTrimming</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FE6\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if surface trimming is displayed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20BA\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">degradeOnMove</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FE3\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the surface may degrade while transforming it; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20B9\"></a><pre>&lt;nurbsdisplay&gt;.<em class=\"codeEmphasisStrong\">displayShadedLattice</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FE0\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the NURBS surfaces appear as shaded lattices in shaded viewports and wireframe\n               viewports display the surface\'s lattice without shading. <span class=\"code\"> <em class=\"strong\">false</em> </span> if NURBS surfaces display as tessellated meshes in shaded viewport and wireframe\n               viewports surfaces display as either iso curves or wire meshes. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3FDD\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";