var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-52C211F5-CD4E-4F4C-9C31-08A0611BBEEF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Regular Expressions Find and Replace in the MAXScript Editor\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Regular Expressions Find and Replace in the MAXScript Editor</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-52C211F5-CD4E-4F4C-9C31-08A0611BBEEF\"></a><div class=\"head\">\n            <h1>Regular Expressions Find and Replace in the MAXScript Editor </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F8A\"></a>The following topic is based on the public domain document located on <a href=\"http://www.scintilla.org/SciTERegEx.html\">http://www.scintilla.org/SciTERegEx.html</a> \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F8C\"></a> \n            <h2><a name=\"GUID-A05D67D2-968B-4390-B018-A77917C37A8A\"></a> <em class=\"strong\">Purpose</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F8D\"></a> <em class=\"strong\">Regular Expressions</em> (RegEx) can be used for searching for patterns rather than literals. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F8E\"></a>For example, using the following posix-mode Regular Expression, it is possible to\n               <em class=\"strong\">search</em> for variables in property files which look like $(name.subname) \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6473\"></a><pre>\\$([a-z.]+)</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F91\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35B2\"></a>This Regular Expression can be read like this:\n            </p>\n            <ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F93\"></a>Find a string which matches the following rules: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F95\"></a><ul>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F97\"></a>Starts with<span class=\"code\"> <em class=\"strong\"> $</em> </span>, denoted as the special character <span class=\"code\"> <em class=\"strong\">\\$</em> </span> \n                        </p> \n                     </li>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F99\"></a>Is followed by a lower case character between <em class=\"strong\">a</em> and<em class=\"strong\"> z </em>followed by <em class=\"strong\">any character</em> specified by a period <em class=\"strong\">.</em> \n                        </p> \n                     </li>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F9B\"></a>The above set repeated one or more times, as denoted by the <span class=\"code\"> <em class=\"strong\">+ </em> </span>sign after the <span class=\"code\"> <em class=\"strong\">[] </em> </span>set definition. \n                        </p> \n                     </li>\n                  </ul> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F9C\"></a> <em class=\"strong\">Replacement </em>with regular expressions allows for complex transformations with the use of tagged\n               expressions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F9D\"></a>For example, pairs of numbers separated by a comma could be reordered by replacing\n               the posix-mode regular expression \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6472\"></a><pre>([0-9]+),([0-9]+)</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3F9F\"></a>with: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6471\"></a><pre>\\2,\\1</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FA1\"></a>The first RegEx means: Match one or more digits between 0 and 9 before the comma and\n               one or more digits between 0 and 9 after the comma. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FA2\"></a>In non-posix mode, the same would be written as \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6470\"></a><pre>\\([0-9]+\\),\\([0-9]+\\)</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FA5\"></a>The replacement RegEx <span class=\"code\"> <em class=\"strong\">\\2, \\1 </em> </span>means: Take the second matched expression and put it before the comma, then place\n               the first matched expression after the comma. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FA7\"></a>The first posix mode RegEx could even be written as \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-646F\"></a><pre>(\\d+),(\\d+))</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FA9\"></a>which also means any number of digits before the comma and any number of digits after\n               the comma. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FAA\"></a> \n            <h2><a name=\"GUID-2779375B-9F05-4389-95E2-A1A68A5FAD26\"></a> <em class=\"strong\">Syntax Styles - Posix vs. Old Unix Style</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FAB\"></a>Regular expression syntax depends on the parameter \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33AA\"></a> <span class=\"code\"> <em class=\"strong\">find.replace.regexp.posix</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FAD\"></a>If set to 0 (default), the Regular Expression syntax uses the old Unix style where\n               <em class=\"strong\">\\(</em> and <em class=\"strong\">\\)</em> mark capturing sections while <em class=\"strong\">(</em> and <em class=\"strong\">)</em> represent themselves. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FAE\"></a>If set to 1, the RegEx syntax uses the more common style where opening and closing\n               parentheses <em class=\"strong\">(</em> and <em class=\"strong\">)</em> mark capturing sections while <em class=\"strong\">\\(</em> and <em class=\"strong\">\\)</em> are plain parentheses. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FAF\"></a> \n            <h2><a name=\"GUID-9A051059-C67C-4A18-B5AA-A0C417DFEAB9\"></a> <em class=\"strong\">Syntax Rules</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-3908\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35B1\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35B0\"></a> <span class=\"code\"> <em class=\"strong\">[1] char</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AF\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AE\"></a>A character matches itself, unless it is a special character (metachar): . \\ [ ] *\n                        + ^ $ and( ) in posix mode. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-3915\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AD\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AC\"></a> <span class=\"code\"> <em class=\"strong\">[2] .</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AB\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35AA\"></a>matches any character. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-3922\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A9\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A8\"></a> <span class=\"code\"> <em class=\"strong\">[3] \\</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A7\"></a> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FB7\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A6\"></a>matches the character following it, except:\n                     </p>\n                     <ul>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FB9\"></a> <span class=\"code\">\\a,\\b,\\f,\\n,\\r,\\t,\\v</span> match the corresponding C escape char, respectively BEL, BS, FF, LF, CR, TAB and\n                              VT; Note that <span class=\"code\">\\r</span> and <span class=\"code\">\\n</span> are never matched because in Scintilla, regular expression searches are made line\n                              per line (stripped of end-of-line chars). \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FBB\"></a>if not in posix mode, when followed by a left or right round bracket (see [7]); \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FBD\"></a>when followed by a digit 1 to 9 (see [8]); \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FBF\"></a>when followed by a left or right angle bracket (see[9]); \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC1\"></a>when followed by d, D, s, S, w or W (see [10]); \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC3\"></a>when followed by x and two hexa digits (see [11]); \n                           </p> \n                        </li>\n                     </ul> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC4\"></a>Backslash is used as an escape character for all other meta-characters, and itself.\n                        \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-3946\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A5\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A4\"></a> <span class=\"code\"> <em class=\"strong\">[4] [set]</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A3\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC6\"></a>matches one of the characters in the set. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC7\"></a>If the first character in the set is ^, it matches the characters NOT in the set,\n                        i.e. complements the set. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC8\"></a>A shorthand S-E (start dash end) is used to specify a set of characters S up to E,\n                        inclusive. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FC9\"></a>The special characters ]and-have no special meaning if they appear as the first chars\n                        in the set. To include both, put - first: [-]A-Z], or just add a backslash before\n                        each of them, like [A-Z\\]\\-] \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FCA\"></a><div class=\"table-ruled\">\n                        <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                           <colgroup>\n                              <col width=\"50%\">\n                              <col width=\"50%\">\n                           </colgroup>\n                           <tr class=\"ruled-odd-row\">\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FCB\"></a><p class=\"table-body\"> <em class=\"strong\">example</em> \n                                 </p> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FCC\"></a><p class=\"table-body\"> <em class=\"strong\">match</em> \n                                 </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-even-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[-]|]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FCE\"></a><p class=\"table-body\">matches these 3 chars, </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-odd-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[]-|]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FD0\"></a><p class=\"table-body\">matches from ] to | chars </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-even-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[a-z]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FD2\"></a><p class=\"table-body\">any lowercase alpha </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-odd-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[^-]]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FD4\"></a><p class=\"table-body\">any char except - and ] </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-even-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[^A-Z]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FD6\"></a><p class=\"table-body\">any char except uppercase alpha </p> \n                              </td>\n                           </tr>\n                           <tr class=\"ruled-odd-row\">\n                              <td class=\"table-body\"> <span class=\"code\">[a-zA-Z]</span> \n                              </td>\n                              <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FD8\"></a><p class=\"table-body\">any alpha </p> \n                              </td>\n                           </tr>\n                        </table>\n                     </div> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-3995\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A2\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A1\"></a> <span class=\"code\"> <em class=\"strong\">[5] *</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-35A0\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FDA\"></a>any regular expression form <span class=\"code\"> <em class=\"strong\">[1] </em> </span>to <span class=\"code\"> <em class=\"strong\">[4] </em> </span>(except <span class=\"code\"> <em class=\"strong\">[7]</em> </span>, <span class=\"code\"> <em class=\"strong\">[8] </em> </span>and<span class=\"code\"> <em class=\"strong\"> [9] </em> </span>forms of <span class=\"code\"> <em class=\"strong\">[3]</em> </span>), followed by closure char (<span class=\"code\"> <em class=\"strong\">*</em> </span>) matches <em class=\"strong\">zero or more</em> matches of that form. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FDB\"></a>For example, <span class=\"code\"> <em class=\"strong\">[a-z]* </em> </span>means \"Zero or more occurrences of a lower case alpha character\". \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4020\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359F\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359E\"></a> <span class=\"code\"> <em class=\"strong\">[6] +</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359D\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FDD\"></a>same as <span class=\"code\"> <em class=\"strong\">[5]</em> </span>, except it matches <em class=\"strong\">one or more</em>. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FDE\"></a>Both<span class=\"code\"> <em class=\"strong\">[5] </em> </span>and<span class=\"code\"> <em class=\"strong\"> [6] </em> </span>are <em class=\"strong\">greedy</em>- they match as many characters as possible, until a mismatch is encountered. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4036\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359C\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359B\"></a> <span class=\"code\"> <em class=\"strong\">[7]</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-359A\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE0\"></a>a regular expression in the form [1]to[12], enclosed as \\(form\\)(or(form)with posix\n                        flag) matches what form matches. The enclosure creates a set of tags, used for[8]and\n                        for pattern substitution. The tagged forms are numbered starting from 1. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4043\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3599\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3598\"></a> <span class=\"code\"> <em class=\"strong\">[8]</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3597\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE2\"></a>a <span class=\"code\"> <em class=\"strong\">\\ </em> </span>followed by a digit <span class=\"code\"> <em class=\"strong\">1 </em> </span>to <span class=\"code\"> <em class=\"strong\">9</em> </span> matches whatever a previously tagged regular expression ([7]) matched. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4056\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3596\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3595\"></a> <span class=\"code\"> <em class=\"strong\">[9] \\&lt; \\&gt;</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3594\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE4\"></a>a regular expression <em class=\"strong\">starting with a</em><span class=\"code\"> <em class=\"strong\">\\&lt;</em> </span> construct and/or <em class=\"strong\">ending with a</em><span class=\"code\"> <em class=\"strong\">\\&gt;</em> </span>construct, restricts the pattern matching to the beginning of a word, and/or the end\n                        of a word. A word is defined to be a character string beginning and/or ending with\n                        the characters A-Z a-z 0-9 and _. The Editor extends this definition by user setting.\n                        The word must also be preceded and/or followed by any character outside those mentioned.\n                        \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4069\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3593\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3592\"></a> <span class=\"code\"> <em class=\"strong\">[10] \\l</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3591\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE6\"></a>a <em class=\"strong\">backslash </em>followed by<em class=\"strong\"> d</em>, <em class=\"strong\">D</em>, <em class=\"strong\">s</em>, <em class=\"strong\">S</em>, <em class=\"strong\">w </em>or <em class=\"strong\">W</em>, becomes a character class (both inside and outside <em class=\"strong\">[] </em>sets). \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE7\"></a><ul>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FE9\"></a> <em class=\"strong\">d</em>: decimal digits \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FEB\"></a> <em class=\"strong\">D</em>: any char <em class=\"strong\">except decimal digits</em> \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FED\"></a> <em class=\"strong\">s</em>:<em class=\"strong\">whitespace</em> (space, \\t \\n \\r \\f \\v) \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FEF\"></a> <em class=\"strong\">S</em>: any char <em class=\"strong\">exceptwhitespace</em> (anything but space, \\t \\n \\r \\f \\v) \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FF1\"></a> <em class=\"strong\">w</em>:<em class=\"strong\">alphanumeric</em> and<em class=\"strong\"> underscore</em> (changed by user setting) \n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FF3\"></a> <em class=\"strong\">W</em>: any char <em class=\"strong\">except alphanumeric</em> and <em class=\"strong\">underscore</em> (see above) \n                           </p> \n                        </li>\n                     </ul> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4110\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3590\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358F\"></a> <span class=\"code\"> <em class=\"strong\">[11] \\xHH</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358E\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FF5\"></a>a <em class=\"strong\">backslash </em>followed by <em class=\"strong\">x </em>and <em class=\"strong\">two hexadecimal digits</em>, becomes the character whose Ascii code is equal to these digits. If not followed\n                        by two digits, it represents the character \'x\' itself. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4120\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358D\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358C\"></a> <span class=\"code\"> <em class=\"strong\">[12]</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358B\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FF7\"></a>a composite regular expression <span class=\"code\"> <em class=\"strong\">xy </em> </span>where <span class=\"code\"> <em class=\"strong\">x </em> </span>and<span class=\"code\"> <em class=\"strong\"> y</em> </span> are in the form <span class=\"code\"> <em class=\"strong\">[1] </em> </span>to <span class=\"code\"> <em class=\"strong\">[10] </em> </span>matches the <em class=\"strong\">longest match of x</em> followed by a<em class=\"strong\"> match for y</em>. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-4139\"></a><dl>\n               <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-358A\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3589\"></a> <span class=\"code\"> <em class=\"strong\">[13] ^ $</em> </span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3588\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FF9\"></a>a regular expression starting with a <span class=\"code\">^ </span>character and/or ending with a <span class=\"code\">$ </span>character, restricts the pattern matching to the beginning of the line, or the end\n                        of line. Elsewhere in the pattern, <span class=\"code\">^ </span>and <span class=\"code\">$ </span>are treated as ordinary characters. \n                     </p> \n                  </div>\n               </dd>\n            </dl> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FFA\"></a> \n            <h2><a name=\"GUID-87B0C167-C354-447B-BC17-EFF01B28AAE1\"></a> <em class=\"strong\">Acknowledgments</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3FFB\"></a>Most of this documentation was originally written by Ozan S. Yigit. Additions by Neil\n               Hodgson and Philippe Lhoste. All of this document is in the public domain. \n            </p> <a name=\"TABLE_B3B7B838C1814A8295531AB930824DE3\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"5.656108597285068%\">\n                     <col width=\"51.696832579185525%\">\n                     <col width=\"42.64705882352941%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_5BA5BA7117F647F898BD978B1B7B4030\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_DC5455D66D5D4652BCD6487588BC00E9\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">MAXScript Editor - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";