var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-53483E27-8DFA-47E6-8835-E6FE1C031B12\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Macro Recorder Emission From Rollout UI Actions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-53483E27-8DFA-47E6-8835-E6FE1C031B12\"></a><div class=\"head\">\n            <h1>Macro Recorder Emission From Rollout UI Actions </h1>\n         </div>\n         <p><a name=\"GUID-3DA1CC9C-DD24-490D-AA19-C7873988882C\"></a>When performing a UI action from a scripted rollout, MAXScript disables the MacroRecorder.\n            \n         </p>\n         <p><a name=\"GUID-329B3945-81C7-41C0-9F34-6C2AFB901558\"></a>To allow the code emission from UI actions modifying <em class=\"strong\">existing</em> paramBlock parameters, the following context can be specified in <em class=\"strong\">3ds Max 2013 and higher</em>: \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">with macroRecorderEmitterEnabled</em> &lt;bool_expr&gt; &lt;expr&gt;</pre></div>\n         <p><a name=\"GUID-B7934B20-F8CE-4D20-85B0-A24C72FB669E\"></a>When &lt;bool_expr&gt; evaluates to <span class=\"code\"> <em class=\"strong\">true</em> </span>, the MacroRecorder will be enabled and relevant changes to paramBlock parameters,\n            as well as scene node creation, will trigger code emission. Creation arguments will\n            <em class=\"strong\">not </em>be recorded. \n         </p>\n         <p><a name=\"GUID-51E5BFE3-BC5E-4C8E-9CD6-C9BC620D6BA9\"></a>When &lt;bool_expr&gt; evaluates to <span class=\"code\"> <em class=\"strong\">false</em> </span>, or if the context is not specified at all, the expression will produce no Macro\n            Recorder output. \n         </p>\n         <p><a name=\"GUID-A9174975-8869-46F2-82A1-FC4E0C9D9219\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div><a name=\"GUID-C7E54EA8-8D61-42E6-9E40-BF86771508AF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Other scene changes like object deletion, or calls to other functionality except for\n               paramBlock changes will <em class=\"strong\">not</em> produce Macro Recorder output. \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D79\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D78\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698D\"></a><pre>\nrollout testMacroRecorderEmission \"Test MRec Emission\"\n(\n	local theSpheres = #()\n	checkbox chk_emitMacroRecorderCode \"Emit MacroRecorder Code\"\n	button btn_modifyRandomSphere \"Modify Random Sphere Radius\"\n	\n	on btn_modifyRandomSphere pressed do\n	(\n		with macroRecorderEmitterEnabled chk_emitMacroRecorderCode.checked \n		(\n			theSpheres[random 1 theSpheres.count].radius = random 10 100\n		)\n	)\n	on testMacroRecorderEmission open do\n	(\n		for y = 1 to 5 do \n			for x = 1 to 5 do\n				append theSpheres (sphere radius:10 pos:[x*50,y*50,0])\n	)\n)\ncreateDialog testMacroRecorderEmission\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";