var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-55EC8090-6593-416B-923F-2291D3983BC6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SpacewarpModifier - MAXWrapper\">\n      <meta name=\"indexterm\" content=\"Modifier - MAXWrapper\">\n      <meta name=\"indexterm\" content=\"MAXWrapper - Value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifier : MAXWrapper and SpacewarpModifier : MAXWrapper</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-55EC8090-6593-416B-923F-2291D3983BC6\"></a><div class=\"head\">\n            <h1>Modifier : MAXWrapper and SpacewarpModifier : MAXWrapper </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3675\"></a>The Modifier and SpacewarpModifier families of classes can be created and added to\n            an object’s modifier stack using the <span class=\"code\"> <em class=\"strong\">addModifier()</em> </span> or <span class=\"code\"> <em class=\"strong\">modPanel.addModToSelection()</em> </span> methods. Unless otherwise noted, the term modifier will be used to mean members of\n            either class. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3676\"></a>By making a single modifier and adding it to several objects, you are sharing the\n            modifier between the objects, as you would by applying a modifier to a selection of\n            objects in the <em class=\"strong\">3ds Max</em> user interface. The constructors in the following classes can take any of the listed\n            properties as optional keyword arguments with the defaults as shown. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_259949E6CA9548649A7C089CCDB8A704\"></a> \n            <h2><a name=\"GUID-6B988C5D-82C2-42DE-A33D-86AC366CA4C7\"></a>Accessing Existing Modifiers\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3677\"></a> Existing modifiers can be accessed in two ways: \n            </p> \n            <div class=\"section\"><a name=\"SECTION_FBD9D39895BB4DD29C9C7C83E2FBFD4C\"></a> \n               <h3><a name=\"GUID-4A9B387C-FDFD-4894-AAF6-B41B6AB232FA\"></a>Node.Property Access\n               </h3> \n               <p><a name=\"GUID-681F51B5-8E02-4017-A955-53AC4058FE7F\"></a>Modifiers can be accessed as a property of a node. \n               </p> \n               <p><a name=\"GUID-9681C161-84FC-4465-9C8E-19A5DBCB7451\"></a>When you access properties on a &lt;node&gt; scene object such as, its name, position, length,\n                  and so on, MAXScript will also consider modifiers on the object to be properties,\n                  for example: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50C3\"></a><pre>\n$box001.heightsegs --get creation parameter\n$box001.twist --get the twist modifier\n$box001.twist.angle --the twist’s angle\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C367E\"></a>You can then access modifier properties as sub-properties on the modifier as shown.\n                  If the modifier name has spaces in it, you can use underscore <em class=\"strong\">‘_’</em> as space convention that pathnames use as follows: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50C2\"></a><pre>\n$box001.uvw_map --to get the ‘UVW Map’ modifier\n</pre></div> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_584A049C5BB947259D4E503D03A8DABE\"></a> \n               <h3><a name=\"GUID-099A894B-46E9-43AE-BAD3-A414139871D0\"></a>.Modifiers Array Access\n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3682\"></a>The property access described above will work in simple situations, but there might\n                  be several modifiers with the same name, or a modifier with the same name as a creation\n                  parameter (the latter is always looked for first). \n               </p> \n               <p><a name=\"GUID-167D8C44-51D3-4EEE-9ABD-71C1B9AE9E1E\"></a>In this situation, you can use the modifier array mechanism, which yields an array\n                  of modifiers you can index into in several ways: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50C1\"></a><pre>\nb = box()\n$box001.modifiers --get the array or modifiers\n$box001.modifiers[3] --get the 3rd modifier counted from top of the list\n$box001.modifiers[#twist] --get the modifier named \"twist\" using name literal\n$box001.modifiers[\"ffd 4x4x4\"] --get the FFD named \"ffs 4x4x4\" using string\n$box001.modifiers[bend] --get the Bend by class (Added in 3ds Max 2013)\n</pre></div> \n               <div class=\"section\"><a name=\"SECTION_95C38C4788994B229D9154B2036D0B4F\"></a> \n                  <h4><a name=\"GUID-FF216D73-A15C-4248-AA00-FC66AC2FC5A5\"></a>Looping Through The Modifiers\n                  </h4> \n                  <p><a name=\"GUID-ECADACA1-363D-479C-9229-C9ADAC365AB6\"></a>You can use a for loop over the .modifiers array to go through all existing modifiers\n                     and check their name, class, and properties to find the one you need. \n                  </p> \n               </div> \n               <div class=\"section\"><a name=\"SECTION_21F331C202AF47529F726D2DC1FCDE81\"></a> \n                  <h4><a name=\"GUID-FD5EFFF6-2FD7-46A8-ADA4-E933B7352FFB\"></a>Accessing a Modifier By Index\n                  </h4> \n                  <p><a name=\"GUID-CCA223F6-C62D-4C40-BCB0-9D94BC17836F\"></a>You can access a modifier in the <span class=\"code\"> <em class=\"strong\">.modifiers</em> </span> array by its index. \n                  </p> \n                  <p><a name=\"GUID-C1F82484-128B-4353-B5AF-1FD2C2A6CD5E\"></a>The modifiers are listed as shown in the Modifier stack, indexed from top to bottom,\n                     starting with 1. \n                  </p> \n                  <p><a name=\"GUID-0300E5A0-F086-43D2-B219-08D6E7DAAC05\"></a>If the index is out of range, either higher than the number of modifiers in the array\n                     or less than 1, the value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> will be returned. \n                  </p> \n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D79\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D78\"></a><p class=\"table-body\"> <em class=\"strong\">FOR LOOP AND INDEX EXAMPLES SETUP</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698D\"></a><pre>\nt=teapot() --create a teapot\naddmodifier t (bend angle:30) --add a Bend modifier with Angle 30\naddmodifier t (bend angle:60 direction:90) --add a Bend modifier with angle 60 and dir 90\naddmodifier t (twist angle:180) --add a Twist modifier with Angle 180\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-30A8456B-A061-4285-BA52-1B11170B81AD\"></a><p class=\"table-body\"> <em class=\"strong\">FOR LOOP AND INDEX EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>\n--The following will find all Bend modifiers with Angle less than 90 and change the Angle to 90\nfor m in t.modifiers where classof m == Bend and m.angle &lt; 90 do m.angle = 90\n\n--The following will find all modifiers (in this case both the Bends and the Twist)\n--with an Angle property and change it to 0\nfor m in t.modifiers where isProperty m #Angle do m.angle = 0\n\n--The following will delete modifiers that have a direction property other than 0.\n--On our case this is the second, upper Bend modifier.\n--Note that we must count backwards from bottom of the stack because deleting a modifier\n--will renumber the modifiers array and we could otherwise miss a modifier:\nfor m = t.modifiers.count to 1 by -1 \\\n  where isProperty t.modifiers[m] #Direction and t.modifiers[m].direction != 0 do\n    deleteModifier t m\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <div class=\"section\"><a name=\"SECTION_BA9F11840130472B980EA8C417B6B7C9\"></a> \n                  <h4><a name=\"GUID-744E93AD-8109-4247-ACF2-288BCD3E4381\"></a>Accessing a Modifier By a Name Literal\n                  </h4> \n                  <p><a name=\"GUID-5F3FB707-673A-4F5A-A821-561216078649\"></a>You can access a modifier in the <span class=\"code\"> <em class=\"strong\">.modifiers</em> </span> array by a name literal. \n                  </p> \n                  <p><a name=\"GUID-2EF51972-DC75-4246-AD2E-5D7B7450F996\"></a>Use underscore <em class=\"strong\">‘_’</em> in place of spaces in the name like with properties access. \n                  </p> \n                  <p><a name=\"GUID-855DB2DF-B0A8-4854-B096-934E9CD35A76\"></a>If two modifiers have the same name, the top-most will be returned. \n                  </p> \n                  <p><a name=\"GUID-C2BD9B89-9B26-4B90-8051-59EF6CC742C2\"></a>If a modifier with the specified name does not exist in the array, the value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> will be returned. \n                  </p> \n               </div> \n               <div class=\"section\"><a name=\"SECTION_B19230E4DFDA48DFAE96F9BC53B39DE0\"></a> \n                  <h4><a name=\"GUID-16849B49-101B-48AA-932B-E249B1F74747\"></a>Accessing a Modifier By a Name String\n                  </h4> \n                  <p><a name=\"GUID-56566D1A-FA89-4F0D-998D-3E738983533C\"></a>You can access a modifier in the <span class=\"code\"> <em class=\"strong\">.modifiers</em> </span> array by a name string. \n                  </p> \n                  <p><a name=\"GUID-852BED10-3819-4015-A17A-142BA09F2902\"></a>The name string access is case-insensitive. \n                  </p> \n                  <p><a name=\"GUID-28433C2C-3DE9-46EE-931F-F60467F777DB\"></a>If two modifiers have the same name, the top-most will be returned. \n                  </p> \n                  <p><a name=\"GUID-7889D0BD-8FAD-42EC-8E50-D3E5482EB491\"></a>If a modifier with the specified name does not exist in the array, the value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> will be returned. \n                  </p> \n               </div> <a name=\"TABLE_C29F2F446B674526B2B91ACE01187B1E\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-80CB67CD-22FC-47F2-B11C-85D6AD7455F0\"></a><p class=\"table-body\"> <em class=\"strong\">NAME LITERAL AND NAME STRING ACCESS EXAMPLES</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>\nt=teapot() --create a teapot\naddmodifier t (ffd_4x4x4()) --add a FFD 4x4x4 modifier with default name\naddmodifier t (ffd_2x2x2 name:\"My FFD\") --add a FFD 2x2x2 modifier with custom name\naddmodifier t (twist angle:90 name:\"My Twist\") --add a twist with custom name\n\nt.modifiers[#ffd_4x4x4] --try to access by name literal\nt.modifiers[#ffd_2x2x2] --try to access by name literal - that name does not exist!\nt.modifiers[#My_FFD]    --try to access by the custom name - that works\nt.modifiers[#My_Twist]  --try to access by the custom name - also works\n	\nt.modifiers[\"ffd 4x4x4\"] --same as above, but with string, so we can use spaces\nt.modifiers[\"ffd 2x2x2\"] --that name does not exist, so we get undefined back\nt.modifiers[\"My FFD\"]    --this is the correct name, so we get it now\nt.modifiers[\"My Twist\"]  --this is also the correct name, so we get the Twist\nt.modifiers[\"mY tWiSt\"]  --the names are case-insensitive, so this returns the same Twist\nt.modifiers[\"My_Twist\"]  --we can even replace spaces with underscores in string names!\ntheName = #My_Twist      --in other words, if we have a name literal,\nt.modifiers[theName]     --we can use it as name literal,\nt.modifiers[theName as string] --or as string and both will produce the same result!\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-E4063AE2-CCD7-4B03-9EEF-0BC2EED94639\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT LISTENER OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>\n$Teapot:Teapot001 @ [0.000000,0.000000,0.000000]\nOK\nOK\nOK\nFFD_4x4x4:FFD 4x4x4\nundefined\nFFD_2x2x2:My FFD\nTwist:My Twist\nFFD_4x4x4:FFD 4x4x4\nundefined\nFFD_2x2x2:My FFD\nTwist:My Twist\nTwist:My Twist\nTwist:My Twist\nTwist:My Twist\nTwist:My Twist\nOK\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <div class=\"section\"><a name=\"SECTION_DA810CA274C34D13A4EB0160E5515A11\"></a> \n                  <h4><a name=\"GUID-037CEAF3-5076-4605-AF20-A4E639A4148E\"></a>Accessing a Modifier By Class\n                  </h4> \n                  <p><a name=\"GUID-C2CD8576-890F-4BB4-A73B-B60B170CD2A5\"></a>In <em class=\"strong\">3ds Max 2013 and higher</em>, you can access a modifier in the<span class=\"code\"> <em class=\"strong\">.modifiers</em> </span>array using its class instead of its name. \n                  </p> \n                  <p><a name=\"GUID-3536246C-B049-462A-A2A0-4145DF67BB77\"></a>If two modifiers have the same class, the top-most will be returned. \n                  </p> \n                  <p><a name=\"GUID-7BBE2C5C-3335-4E8E-84CF-EBB82D4AB4F1\"></a>If a modifier with the specified class does not exist in the array, the value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> will be returned. \n                  </p> <a name=\"TABLE_C48C387CDA2F452A9539A38F2360B949\"></a><div class=\"table-ruled\">\n                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                        <colgroup>\n                           <col width=\"100%\">\n                        </colgroup>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> <a name=\"GUID-23FCA893-1CEE-42DF-9D69-DD718F66D6F2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                              </p> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-even-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><pre>\nt=teapot() --create a teapot\naddmodifier t (bend name:\"MyBendAtBottom\") --add a Bend modifier\naddmodifier t (bend name:\"MyBendOnTop\") --add another Bend modifier\naddmodifier t (twist name:\"MyTwist\") --add a Twist modifier\nt.modifiers[twist] --access the Twist\nt.modifiers[bend] --access the top-most Bend (\"MyBendOnTop\")\nt.modifiers[skew] --undefined, because no Skew was added\n</pre></div> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> <a name=\"GUID-A96C7259-9FE9-4FB4-A6A4-858C3C344126\"></a><p class=\"table-body\"> <em class=\"strong\">LISTENER OUTPUT:</em> \n                              </p> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-even-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><pre>$Teapot:Teapot001 @ [0.000000,0.000000,0.000000]\nOK\nOK\nOK\nTwist:MyTwist\nBend:MyBendOnTop\nundefined</pre></div> \n                           </td>\n                        </tr>\n                     </table>\n                  </div> \n               </div> \n            </div> \n         </div>\n         <p><a name=\"P_AC188672084641C2B7938C60AE97B11F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3689\"></a>The classes derived directly from the Modifier and SpacewarpModifier classes are described\n            in <span class=\"char_link\"><a href=\"GUID-29CF3A8E-D9CC-4233-AEBF-FF0989FBB859.htm\">Modifier and SpacewarpModifier Types</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C368A\"></a>The properties, operators, and methods that are common to all classes derived directly\n            from the Modifier and SpacewarpModifier classes are described in <span class=\"char_link\"><a href=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD.htm\">Modifier Common Properties, Operators, and Methods</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C368B\"></a>The Modifier and SpacewarpModifier classes are derived from the MAXWrapper class,\n            and inherits the properties and methods defined for that class. These properties and\n            methods are described in <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span>. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";