var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"superClassOf()\">\n      <meta name=\"indexterm\" content=\"print()\">\n      <meta name=\"indexterm\" content=\"options.oldPrintStyles\">\n      <meta name=\"indexterm\" content=\"oldPrintStyles - options\">\n      <meta name=\"indexterm\" content=\"isStructDef()\">\n      <meta name=\"indexterm\" content=\"isStruct()\">\n      <meta name=\"indexterm\" content=\"isKindOf()\">\n      <meta name=\"indexterm\" content=\"isController()\">\n      <meta name=\"indexterm\" content=\"getHashValue()\">\n      <meta name=\"indexterm\" content=\"format()\">\n      <meta name=\"indexterm\" content=\"classOf()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Value Common Properties, Operators, and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C\"></a><div class=\"head\">\n            <h1>Value Common Properties, Operators, and Methods </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E8765E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8765F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; Value Common Properties, Operators and Methods \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87661\"></a>The \n            		<em class=\"strong\">Value</em> class is the root class for all MAXScript classes. It supplies methods and operators\n            that \n            		<em class=\"strong\">any</em> class can use. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87662\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6053\"></a><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87664\"></a>compare if equal \n            	 \n         </p>\n         <p><a name=\"P_EB3ED9D00ECE4F51AB5913C17EC61BC4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6052\"></a><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87667\"></a>compare if not equal \n            	 \n         </p>\n         <p><a name=\"P_47021F98D2A24DC5A68674B1B643E016\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6051\"></a><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">as</em> &lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8766A\"></a>Converts the value to an instance of given class. See the description for each class\n            for valid conversions. All values can be converted to class String, which yields a\n            string with the printed representation of the value. \n            	 \n         </p>\n         <p><a name=\"P_26E46E1E6A92422AA56E73D442DE5913\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8766B\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6050\"></a><pre><em class=\"codeEmphasisStrong\">print</em> &lt;value&gt; [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ] [<em class=\"codeEmphasisStrong\">#noMap</em>] -- mappable</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8766D\"></a>where \n            		<span class=\"code\">&lt;stream&gt;</span> is \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604F\"></a><pre>( &lt;filestream&gt; | &lt;stringstream&gt; | &lt;windowstream&gt; )</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8766F\"></a>Prints single value to Listener or optional \n            		<span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">filestream</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6.htm\">stringstream</a></span>, or \n            		<span class=\"char_link\"><a href=\"GUID-88912612-DDDC-4016-AD24-1180BB2DAD96.htm\">windowstream</a></span>, followed by a line break. If the argument value is a \n            		<span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collection</a></span>, and \n            		<span class=\"code\"> <em class=\"strong\">#noMap</em> </span> is not specified, each value in the collection is printed out on a separate line.\n            If \n            		<span class=\"code\"> <em class=\"strong\">#noMap</em> </span> is specified, the collection value is printed out on a single line. The printed form\n            of all basic data value types, except for BigArray, are directly readable by the \n            		<span class=\"code\"> <em class=\"strong\">readValue()</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">readExpr()</em> </span> functions, making it simpler to read back in values printed to a file by MAXScript.\n            If the pre-<em class=\"strong\">3ds Max</em> R3 print forms are required for compatibility with existing scripts, you can set\n            the system global variable \n            		<span class=\"code\"> <em class=\"strong\">options.oldPrintStyles</em> </span> to \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_60C10FB1511C491181FA3180ACBF03B4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604E\"></a><pre><em class=\"codeEmphasisStrong\">format</em> &lt;format_string&gt; { &lt;value&gt; } [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87672\"></a>Prints one or more values to Listener or optional filestream, stringstream, or windowstream,\n            using the format string as a template. The format string is a string that can contain\n            plain text to print interspersed with the \n            		<span class=\"code\"> <em class=\"strong\">\'%\'</em> </span> (percent) metacharacter. Each occurrence of a \n            		<span class=\"code\"> <em class=\"strong\">\'%\'</em> </span> is replaced by the printed representation of the successive argument values following\n            the format string. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87673\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87674\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604D\"></a><pre>\nformat \"name:%, pos:%\\n\" obj.name obj.pos\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87678\"></a><p class=\"table-body\">generates something like: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604C\"></a><pre>\nname: box01, pos: [0, 150.0, 0.5]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8767C\"></a>format does not automatically append a line break to the output stream, so you can\n            build up a line from several format calls and generally control layout better. An\n            explicit \'<span class=\"code\"> <em class=\"strong\">\\n</em> </span>\' newline escape character sequence is needed to place a line break in the output\n            stream. Other escape character sequences are documented in \n            		<span class=\"char_link\"><a href=\"GUID-7F17449E-C377-445C-AC15-CD3BA88A975B.htm\">String Literals</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_B37BA673049849A28332DA5EAA9983E0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604B\"></a><pre><em class=\"codeEmphasisStrong\">classOf</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8767F\"></a>Returns the value\'s class. Each type of value has its own class. If the value is a\n            Node value, \n            		<span class=\"code\"> <em class=\"strong\">classOf()</em> </span> returns the class of the world state object (the state of the node at the top of\n            its stack). See \n            		<span class=\"char_link\"><a href=\"GUID-1C9953AA-4750-4147-91DC-127AF2F7BC87.htm\">Node : MAXWrapper</a></span> for more information. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To avoid a conflict between a user class value in global variable named \'rollout\'\n               and MAXScript reserved word \'rollout\' which always introduces a rollout definition\n               the class variable name for a rollout is \n               		<span class=\"code\"> <em class=\"strong\">RolloutClass</em> </span>. So, for a rollout foo you\'d now say \"if classOf foo == RolloutClass do ...\" \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_61C21B1442014F16A4900B408062C740\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-604A\"></a><pre><em class=\"codeEmphasisStrong\">superClassOf</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87686\"></a>Returns the value\'s superclass. A value\'s superclass is the class from which the value\'s\n            class was derived. \n            	 \n         </p>\n         <p><a name=\"P_3E753EF5CAD742838098C42CC097E770\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6049\"></a><pre><em class=\"codeEmphasisStrong\">isKindOf</em> &lt;value&gt; &lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87689\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if value has given class or inherits from class. \n            	 \n         </p>\n         <p><a name=\"P_122CBCBAEB914D9F826773A28A3C9FB6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6048\"></a><pre><em class=\"codeEmphasisStrong\">isStructDef</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8768C\"></a>Returns true if the value is a structure definition \n            	 \n         </p>\n         <p><a name=\"P_4F337FAC07D540B3A7215AEDC04489E4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6047\"></a><pre><em class=\"codeEmphasisStrong\">isStruct</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8768F\"></a>Returns true if the value is a structure instance \n            	 \n         </p>\n         <p><a name=\"P_189D92266572459AACE42C008C9784FF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6046\"></a><pre><em class=\"codeEmphasisStrong\">isController</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87692\"></a>Returns true if the value is a controller \n            	 \n         </p>\n         <p><a name=\"P_C293CF7D2C4B427BA2DAE9C49411904C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6045\"></a><pre><em class=\"codeEmphasisStrong\">isMSPlugin</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87694\"></a>Returns true if the value is a MAXScript scripted plugin. \n            	 \n         </p>\n         <p><a name=\"P_7DD4D15342BE43C98C7CE49400B49375\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6044\"></a><pre><em class=\"codeEmphasisStrong\">isMSPluginClass</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87697\"></a>Returns true if the value is a MAXScript scripted plugin class. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87698\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87699\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6043\"></a><pre>\nb = box() --create a Box primitive\n--&gt;$Box:Box001 @ [0.000000,0.000000,0.000000]\na = emptymodifier() --create an attribute holder modifier\n--&gt;EmptyModifier:Attribute Holder\naddModifier b a --add the modifier to the box\n--&gt;OK\nisMSPlugin a --see if the modifier is a scripted plugin? Yes!\n--&gt;true\nisMSPlugin b --see if the box is a scripted plugin? No!\n--&gt;false\nisMSPluginClass EmptyModifier --is the modifier class scripted? Yes!\n--&gt;true\nisMSPluginClassBox --is the object class scripted? No!\n--&gt;false\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_BB4E6A0439E54EBB996ED9C4A6F5DE7D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6042\"></a><pre><em class=\"codeEmphasisStrong\">isMSCustAttrib</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876AD\"></a>Returns true if the value is a MAXScript Custom Attribute. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Since Custom Attributes are a special case of a scripted plugin, \n               		<span class=\"code\"> <em class=\"strong\">isMSPlugin</em> </span> will also return true. \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_506A8489C5DE43ED950100E1614C5868\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6041\"></a><pre><em class=\"codeEmphasisStrong\">isMSCustAttribClass</em> &lt;value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876B4\"></a>Returns true if the value is a MAXScript Custom Attribute class. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Since Custom Attributes are a special case of a scripted plugin, \n               		<span class=\"code\"> <em class=\"strong\">isMSPluginClass</em> </span> will also return true. \n               	 \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E876B9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E876BA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6040\"></a><pre>\nweaponDataCA = attributes weaponData\n(\nParameters main\n(\n)\n)\nb=box()\ncustAttributes.add b weaponDataCA\n&nbsp;\nc=b.baseobject.custAttributes[1]\nd=classof c\nsuperclassof c\nisMSPluginClass d\nisMSCustAttribClass d\nisMSPluginClass b\nisMSCustAttribClass b\n\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E876CD\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603F\"></a><pre>\n&lt;AttributeDef:weaponData&gt;\n$Box:Box03 @ [0.000000,0.000000,0.000000]\ntrue\n&nbsp;\nweaponDataCustAttrib:weaponData\n&lt;AttributeDef:weaponData&gt;\nCustAttrib\ntrue\ntrue\nfalse\nfalse\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_30DB0F5D304E4E5891EEEBEC9F0318D5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603E\"></a><pre><em class=\"codeEmphasisStrong\">getHashValue</em> &lt;value&gt; &lt;Integer oldHashValue&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876DD\"></a>If the value is one of the supported value types, returns an integer hash value that\n            is a factor of the \n            		<span class=\"code\">&lt;value&gt;</span> and \n            		<span class=\"code\">&lt;oldHashValue&gt;</span>. If the value type is not supported, returns a value of \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876DE\"></a>The supported value types are: \n            	 \n         </p><a name=\"UL_64B37619AAAC4B818B15FD16A98829C8\"></a><ul>\n            <li>Float \n               		\n            </li>\n            <li>Integer \n               		\n            </li>\n            <li>String \n               		\n            </li>\n            <li>BitArray \n               		\n            </li>\n            <li>Point3 \n               		\n            </li>\n            <li>Ray \n               		\n            </li>\n            <li>Quat \n               		\n            </li>\n            <li>AngAxis \n               		\n            </li>\n            <li>EulerAngles \n               		\n            </li>\n            <li>Matrix3 \n               		\n            </li>\n            <li>Point2 \n               		\n            </li>\n            <li>Color \n               		\n            </li>\n            <li>Arrays containing any of the above value types \n               		\n            </li>\n         </ul>\n         <div><a name=\"GUID-01168852-1635-4BE7-AADF-419ABDE7FF37\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Since Custom Attributes are a special case of a scripted plugin, \n               		<span class=\"code\"> <em class=\"strong\">isMSPlugin</em> </span> will also return true. \n               	 \n            </div>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">deepCopy</em> &lt;value&gt;</pre></div>\n         <p>Returns a deep copy of the value, which means all nested values are copies rather\n            than references. The default implementation of this method is to call the copy() method.\n            This method is only implemented for these value types: \n            	 \n         </p><a name=\"UL_AED48F5F121048C2AA43EAB262916316\"></a><ul>\n            <li>Array \n               		\n            </li>\n            <li>DataPair (in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>) \n               		\n            </li>\n            <li>Dictionary (in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>) \n               		\n            </li>\n            <li>Structure (in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>) \n               		\n            </li>\n            <li>MAXWrapper (in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>) - does not create a copy of the 3ds Max object, rather just returns the original\n               value. \n               		\n            </li>\n         </ul>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876ED\"></a> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876EE\"></a> <span class=\"char_link\"><a href=\"GUID-0AEEF510-1859-48B7-9A19-A6158B0310A7.htm\">Working with Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F0\"></a> <span class=\"char_link\"><a href=\"\">Basic Data Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F1\"></a> <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm\">Bitmap Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F2\"></a> <span class=\"char_link\"><a href=\"GUID-A2290E77-5392-431D-8B75-F6A1262E9639.htm\">Stream Values \n                              			 </a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F3\"></a> <span class=\"char_link\"><a href=\"GUID-5ED6F7E0-33CC-4F4E-972E-094EB33BEA85.htm\">MAXKey Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F4\"></a> <span class=\"char_link\"><a href=\"GUID-49BE2F03-7AC0-41B3-9B82-EF2D2B094BDE.htm\">ArrayParameter Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876F5\"></a> <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";