var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5670F5FB-2426-4898-A659-277D6AFED6D2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: OffsetManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5670F5FB-2426-4898-A659-277D6AFED6D2\"></a><div class=\"head\">\n            <h1>Interface: OffsetManager</h1>\n         </div>\n         <p> The \n            		<span class=\"code\">OffsetManager</span> Core Interface exposes methods for creating and managing Offset controllers and Animation\n            Presets. Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"section\"><a name=\"SECTION_DF34DF5318A54AAFB6EC9D7C9AF22B4F\"></a> \n            <h2><a name=\"GUID-610E6268-B890-4E94-9599-B9747B089760\"></a>Properties:\n            </h2> \n            <p>None \n               		\n            </p> \n         </div>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <p><em class=\"strong\">Animation &gt; Offset Controllers menu</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.addSel()</pre></div>\n         <p> Opens the “Select Controllers” dialog and displays the controllers of the selected\n            objects. \n            	 \n         </p>\n         <p>Equivalent to invoking the Main Menu &gt; Animation &gt; Offset Controllers &gt; Add Offset\n            Controllers menu item. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.RemoveOffsetControlDlg()</pre></div>\n         <p> Opens the “Remove Offset Controllers” dialog. \n            	 \n         </p>\n         <p> Equivalent to selecting the Main Menu &gt; Animation &gt; Offset Controllers &gt; Delete Offset\n            Controllers menu item. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Animation &gt; Presets menu</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.LoadEffectDlg()</pre></div>\n         <p> Opens the Load Preset dialog and lets the user assign a Preset to the current selection.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.PublishLocal &lt;maxObject&gt;modifier &lt;node&gt;template &lt;&amp;node array&gt;nodes</pre></div>\n         <p> nodes is In and Out parameter \n            	 \n         </p>\n         <p>Applies the Preset controlled by the Preset_Maker Modifier supplied as first argument\n            from the template node specified by the second argument to the by-reference array\n            of nodes supplied by the third argument. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.RemoveEffectFromNodes &lt;string&gt;name &lt;&amp;node array&gt;nodes</pre></div>\n         <p> nodes is In and Out parameter \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.createTemplate()</pre></div>\n         <p> Opens the “Select Preset Controllers” dialog for the currently selected object. \n            	 \n         </p>\n         <p>A single object must be selected for the dialog to open. \n            	 \n         </p>\n         <p>Equivalent to invoking the Main Menu &gt; Animation &gt; Presets &gt; Create Preset menu item.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.RemoveEffectFromDisk &lt;string&gt;name</pre></div>\n         <p>Removes the specified named Preset from disk. \n            	 \n         </p>\n         <p>Roughly equivalent to opening the Main Menu &gt; Animation &gt; Presets &gt; Remove Preset\n            From Disk menu item, but instead on opening a dialog, it deletes the specified named\n            preset directly. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Modifier &gt; “Offset Motion Controls” rollout &gt; “Offset Order By Distance” group of\n               controls</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.OffsetByPos &lt;node&gt;center &lt;node array&gt;nodes &lt;boolean&gt;x &lt;boolean&gt;y &lt;boolean&gt;z</pre></div>\n         <p> Applies a new position-based offset to the nodes array passed as second argument\n            starting from the center node given as first argument. \n            	 \n         </p>\n         <p> The three Boolean arguments enable distance measurements along the X, Y and Z axes\n            of the center node. \n            	 \n         </p>\n         <p> Equivalent to the “Set Offset By Distance” controls exposed in the Offset modifier’s\n            UI. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Modifier &gt; “Preset Maker” rollout</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.PublishToFile &lt;maxObject&gt;modifier &lt;node&gt;template</pre></div>\n         <p>Saves to disk a named Preset using the Preset_Maker modifier specified as first argument,\n            and the template node specified as the second argument. \n            	 \n         </p>\n         <p>The name of the preset will be taken from the Preset_Maker modifier’s .publishFile\n            property. \n            	 \n         </p>\n         <p>Equivalent to pressing the “Save Preset” button in the “Preset Maker” rollout of the\n            modifier. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">MAXScript-Only Functions</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.LoadEffect &lt;string&gt;name</pre></div>\n         <p>Loads from disk a previously saved named Preset and applies it to the current selection.\n            \n            	 \n         </p>\n         <p>This is similar to \n            		<span class=\"code\">OffsetManager.LoadEffectDlg()</span> but operates on the named Preset directly without opening an interactive dialog.\n            \n            	 \n         </p>\n         <p>To get the name of a preset, use the \n            		<span class=\"code\">OffsetManager.GetEffectList()</span> method (see below). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.GetEffectList &lt;&amp;string array&gt;names</pre></div>\n         <p> names is Out parameter \n            	 \n         </p>\n         <p>Returns into the by-reference argument an array of the names of previously saved to\n            disk Preset. \n            	 \n         </p>\n         <p>This is similar to \n            		<span class=\"code\">OffsetManager.LoadEffectDlg()</span> but returns the names of the Presets as a MAXScript array of strings value instead\n            of opening an interactive dialog. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.ReorderEffect &lt;string&gt;name</pre></div>\n         <p>Goes through the offset controllers and resets their Order IDs to their original values.\n            \n            	 \n         </p>\n         <p>When offset controllers are first applied, the Order ID is incremented for each controller\n            to determine the order in which the controllers are played back. \n            	 \n         </p>\n         <p>The user can modify the Order ID to change the playback order. \n            	 \n         </p>\n         <p>This method resets the Order IDs back to the default state. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.AddNodeToEffect &lt;string&gt;name &lt;&amp;node array&gt;nodes</pre></div>\n         <p> nodes is In and Out parameter \n            	 \n         </p>\n         <p> Adds the nodes specified by the by-reference node array as second argument to the\n            named Preset specified by the first string argument. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;OffsetManager.addMenu()</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Actions</em>: \n            	 \n         </p>\n         <p>None \n            	 \n         </p>\n         <p> </p>\n         <p> <a name=\"TABLE_B50A0E3D43414E198298413720B06C79\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><em class=\"strong\">Example 1 \n                           				  </em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>(\nresetMaxFile #noprompt --reset the scene without prompting\nanimationRange = interval 0 140 --set the scene time range to 140 frames\nc = cylinder heightsegs:32 height:100 --create a tall cylinder\ncopiesArray = for i = 1 to 21 collect --create a few copies\n(\n 	cc = copy c --copy the original cylinder\n 	cc.pos = [(i-1)*40,0,0] --move the copy 40 units along X\n 	cc.wirecolor = green --set the object color to green\n 	cc --collect the copy in the array\n)\n \nb = bend direction:90 --create a Bend modifier rotated at 90 degrees\naddmodifier c b --add the Bend modifier to the cylinder\nwith animate on  --enable animation\n(\n 	at time 15 b.angle = 90 --set Bend Angle to 90 degrees at frame 15\n 	at time 30 b.angle = 0  --set Bend Angle back to 0 at frame 30\n)\n \nselect c --select the original cylinder\nOffsetManager.createTemplate() --prompt the user to create a template\nc.modifiers[1].timingUI.perNodeOffset = 5 --set Per Node Delay to 5 frames\n \nOffsetManager.PublishLocal c.modifiers[1] c &amp;copiesArray --apply the template to the copies\n \nc.modifiers[1].publishFile = \"Bend90DegOver30F\" --give the preset a name\nOffsetManager.PublishToFile c.modifiers[1] c --and save it to disk for future use\n \ndelete c --delete the original cylinder\n \nOffsetManager.OffsetByPos copiesArray[11] copiesArray true false false --start from the middle\n \nmax zoomext sel all --zoom extents all\nredrawViews() --redraw the views\nplayAnimation() --and play back the animation...\n)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <p> </p><a name=\"TABLE_6810513EA7AE4B9F972A78CF342F3D50\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">Example 2 \n                        				  </em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>(\nx = box heightsegs:32 height:250 --create a tall box\ncopiesArray = for i = 1 to 21 collect --create a few copies\n(\n 	cx = copy x --copy the original box\n 	cx.pos = [(i-1)*40,60,0] --move the copy 40 units along X and 60 along Y\n 	cx.wirecolor = color 200 40 100 --set the object color to pink\n 	cx --collect the copy\n)	\ndelete x --delete the original\nselect copiesArray --select the newly created box copies\nOffsetManager.LoadEffect \"Bend90DegOver30F\" --load the preset saved in Example 1\nmax zoomext sel all --zoom extents all\n)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";