var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5702AD16-5D90-4B74-A7E7-F49A8B6903C0\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Mesh Color-Per-Vertex Methods\">\n      <meta name=\"indexterm\" content=\"setNumCPVVerts() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"getNumCPVVerts() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"defaultVCFaces() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"buildVCFaces() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"setVertColor() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"getVertColor() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"setVCFace() - Mesh CPV Methods\">\n      <meta name=\"indexterm\" content=\"getVCFace() - Mesh CPV Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Mesh Color-Per-Vertex Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5702AD16-5D90-4B74-A7E7-F49A8B6903C0\"></a><div class=\"head\">\n            <h1>Mesh Color-Per-Vertex Methods </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1647\"></a>The following methods provide basic access to the Color Per Vertex channel. \n         </p><a name=\"TABLE_4862DF0C279349D3BD5F89AC5C4BE60F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">HISTORY NOTE:</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C164B\"></a><p class=\"table-body\">When MAXScript was first introduced in <em class=\"strong\">3ds Max 2</em>, there were only two mapping channels, with Channel 0 being used to store either\n                        color information or a second texture coordinates channel. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C164C\"></a><p class=\"table-body\">For generalized access to all map channels, you should consider using the methods\n                        described in <span class=\"char_link\"><a href=\"GUID-A97DF4E3-04A7-4A91-AE7C-3C75A8BAA399.htm\">Meshop General Mapping Methods</a></span> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C164E\"></a> <em class=\"strong\">For legacy methods providing access only to the Texture Channel 1, see also</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C164F\"></a> <span class=\"char_link\"><a href=\"GUID-2E5C8194-F165-4D09-8A19-069BFCF83104.htm\">Mesh Texture Vertex Methods</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1650\"></a> <em class=\"strong\">Methods:</em>   \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5535\"></a><pre><em class=\"codeEmphasisStrong\">getNumCPVVerts</em> &lt;mesh&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1653\"></a>Returns number of Color-Per-Vertex vertices as an integer, equivalent to using <span class=\"code\"> &lt;node&gt;.<em class=\"strong\">numcpvverts</em> </span> \n         </p>\n         <p><a name=\"P_D2BA5E3F8D034EF3A642705C102D269E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5534\"></a><pre><em class=\"codeEmphasisStrong\">setNumCPVVerts</em> &lt;mesh&gt; &lt;integer&gt; [ &lt;boolean&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1656\"></a>Sets the number of Color-Per-Vertex vertices. If the optional boolean argument is\n            <span class=\"code\"> <em class=\"strong\">true</em> </span>, the existing topology remains intact. If it is <span class=\"code\"> <em class=\"strong\">false</em> </span> or not supplied, the topology is lost. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1657\"></a>When setting the number of CPV vertices using the <span class=\"code\"> <em class=\"strong\">numCPTVerts</em> </span> property or <span class=\"code\"> <em class=\"strong\">setNumCPVVerts</em> </span> method, the new verts are initialized to [0.,0.,0.] \n         </p>\n         <p><a name=\"P_BB2D50BF6B7B439D835AE1ED1C03B691\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5533\"></a><pre><em class=\"codeEmphasisStrong\">buildVCFaces</em> &lt;mesh&gt; [ &lt;boolean&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C165C\"></a>Builds the Color-Per-Vertex face array after you have set the c-p-v vertex count.\n            If the optional boolean argument is <span class=\"code\"> <em class=\"strong\">true</em> </span>, the existing topology remains intact. If it is <span class=\"code\"> <em class=\"strong\">false</em> </span> or not supplied, the topology is lost. \n         </p>\n         <p><a name=\"P_288E604A058B4A948181AD37ADF71B88\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5532\"></a><pre><em class=\"codeEmphasisStrong\">defaultVCFaces</em> &lt;mesh&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C165F\"></a>Sets the number of Color-Per-Vertex vertices and Color-Per-Vertex faces to match exactly\n            the current mesh\'s geometry and topology and calls <span class=\"code\"> <em class=\"strong\">buildVCFaces()</em> </span> \n         </p>\n         <p><a name=\"P_0A8A3AAF907C4B97B4C292B7860E9099\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5531\"></a><pre><em class=\"codeEmphasisStrong\">getVertColor</em> &lt;mesh&gt; &lt;CPVvert_index_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1664\"></a>Returns the color of the indexed Color-Per-Vertex vertex as a color. \n         </p>\n         <p><a name=\"P_3C037F46AA384AD793C6DB531777B1D9\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5530\"></a><pre><em class=\"codeEmphasisStrong\">setVertColor</em> &lt;mesh&gt; &lt;CPVvert_index_integer&gt; &lt;color&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1667\"></a>Sets the color of the indexed Color-Per-Vertex vertex. \n         </p>\n         <p><a name=\"P_BB3ABA83D1514F48B93512A54E577FF0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-552F\"></a><pre><em class=\"codeEmphasisStrong\">getVCFace</em> &lt;mesh&gt; &lt;CPVface_index_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C166C\"></a>Returns the topology for the indexed Color-Per-Vertex face as a point3 containing\n            3 Color-Per-Vertex vertex indexes. \n         </p>\n         <p><a name=\"P_B86D454C5FC34A7DB06F5EE0AB11D0CC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-552E\"></a><pre><em class=\"codeEmphasisStrong\">setVCFace</em> &lt;mesh&gt; &lt;CPVface_index_integer&gt; &lt;CPVvert_indices_point3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C166F\"></a>Sets the indexed Color-Per-Vertex face topology from a point3 containing 3 Color-Per-Vertex\n            vertex indexes. \n         </p>\n         <p><a name=\"P_F59D03C96D264374A852ACA9EBEA5052\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-552D\"></a><pre><em class=\"codeEmphasisStrong\">setVCFace</em> &lt;mesh&gt; &lt;CPVface_index_integer&gt; &lt;CPVvert_index_integer&gt; &lt;CPVvert_index_integer&gt; &lt;CPVvert_index_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1674\"></a>The Color-Per-Vertex vertex and face indexes are 1-based as with other mesh indexes\n            in MAXScript. Remember that you need to call <span class=\"code\"> <em class=\"strong\">update()</em> </span> on the mesh after making changes to it for the changes to be reflected in the scene.\n            \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AC5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AC4\"></a>The mesh class contains a list of color vertices which are completely independent\n                  of the regular vertices in the mesh. There is no correlation between the number of\n                  vertices in a mesh and the number of color vertices. In addition to the color vertices\n                  there are also color faces. There needs to be one color face for every regular face\n                  in the mesh. For details, see <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinatesand Vertex Colors</a></span> topic. \n               </p> \n               <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AC3\"></a>Each color face has three indices into the color vertex array. The coordinates of\n                  a color vertex are RGB coordinates, and are accessed as Color values. \n               </p> \n               <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AC2\"></a>The techniques for building and accessing color vertices and faces is virtually identical\n                  to the techniques for building and accessing texture vertices and faces. An example\n                  script for creating planar texture mapping on an object is shown in <span class=\"char_link\"><a href=\"GUID-CA252E0A-3EB7-4DDD-9E9A-19B95E592902.htm\">Working with Editable Meshes</a></span>. \n               </p> \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AC1\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1680\"></a> <em class=\"strong\">For more mesh-related methods, see</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1681\"></a> <span class=\"char_link\"><a href=\"\">Editable Mesh - Topics Index</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1682\"></a> <span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Editable_Mesh : GeometryClass and TriMesh : Value</a></span> \n            </p> <a name=\"TABLE_56A7AC5202FD4923860FD00652E60AD4\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"2.965599051008304%\">\n                     <col width=\"54.35943060498221%\">\n                     <col width=\"42.674970344009495%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_4A15B447F4434F0F814F7ECDFE1E736D\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_E3D7C9312CC741F5ACF59E9CE8CB55E1\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Editable Mesh - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C167D\"></a> <span class=\"char_link\"><a href=\"GUID-A97DF4E3-04A7-4A91-AE7C-3C75A8BAA399.htm\">Meshop General Mapping Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C167E\"></a> <span class=\"char_link\"><a href=\"GUID-2E5C8194-F165-4D09-8A19-069BFCF83104.htm\">Mesh Texture Vertex Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C167F\"></a> <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinates and Vertex Colors</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";