var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-570A4B99-5421-4CEE-B6FA-2D9A8230A71F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Every Step Update Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Every Step Update Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-570A4B99-5421-4CEE-B6FA-2D9A8230A71F\"></a><div class=\"head\">\n            <h1>Every Step Update Example </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E845DA\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845DD\"></a> <em class=\"strong\">Description:</em>  \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845DE\"></a>The following example shows the default Every Step Update script with detailed comments.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845DF\"></a> <em class=\"strong\">Can Be Used With:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845E0\"></a>Used by <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source</a></span> as default Every Step Update script. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845E1\"></a> <em class=\"strong\">Effect:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E845E2\"></a>The script modifies particle speed and direction, causing particles to follow a spiral\n               path: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E845E3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-6B4C2B59-6E09-4B1D-9352-5B4F035BEEB1-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E845E4\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E845E5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E18\"></a><pre>\n--Get the current particle system executing the script\npf_node_current = particleFlow.scriptRunner()\n \n--In case the current particle system is a valid node\nif (pf_node_current != undefined) then\n(\n \n--Get the total number of particles\ncount = pf_node_current.NumParticles()\n--Loop from 1 to the number of particles\nfor i in 1 to count do\n(\n \n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one:\npf_node_current.particleIndex = i\n \n--Get the age of the particle, multiply by 5 and use as angle\n--to define the particle speed\n--Decreasing the constant 5 will slow down the rotation\n--Increasing the constant will speed up the rotation\nage = 5*pf_node_current.particleAge\n \n--Calculate the speed of the particle using the\n--function of the circle.\n--Info: In general, a circle can be drawn using an Angle\n--going from 0 to 2*Pi and the following functions for X and Y:\n--X = CenterX+Radius*Cos(Angle)\n--Y = CenterY+Radius*Sin(Angle)\n--In our case, CenterX and CenterY are 0, Radius is 0.05 units,\n--and Angle is based on the Age of the particles (see above).\n--Changing the constant 0.05 will change the radius of the path.\n--Changing the -0.05 (Z speed) will change the height of the spiral.\npf_node_current.particleSpeed = [0.05*cos(age), 0.05*sin(age), -0.05]\n \n)--end i loop\n)--end if\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8460F\"></a> <span class=\"char_link\"><a href=\"GUID-D2A11E7A-5E6B-4D78-8936-26A0C4080033.htm\">Final Step Update Example</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84610\"></a> <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84611\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";