var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-57429360-CC34-49BB-8901-4FCC628E234E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Registering Windows SystemEvents Callbacks Using DotNet\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Registering Windows SystemEvents Callbacks Using DotNet</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-57429360-CC34-49BB-8901-4FCC628E234E\"></a><div class=\"head\">\n            <h1>Registering Windows SystemEvents Callbacks Using DotNet </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B52\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B4E\"></a>The following example demonstrates how to register a MAXScript event handler that\n               will react when Windows System settings are being changed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B4C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B4B\"></a><p class=\"table-body\"> <em class=\"strong\">CODE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6779\"></a><pre>\n--First we need the SystemEvents DotNet Class:\nc = dotNetClass \"Microsoft.Win32.SystemEvents\"\n--&gt;dotNetClass:Microsoft.Win32.SystemEvents\n--Then we get a list of all available events:\nshowevents c\n--&gt;[static] DisplaySettingsChanged &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] DisplaySettingsChanging &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] EventsThreadShutdown &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... ) \n--&gt;[static] InstalledFontsChanged &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] LowMemory &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] PaletteChanged &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] PowerModeChanged &lt;System.Object&gt;sender &lt;Microsoft.Win32.PowerModeChangedEventArgs&gt;e = ( ... )\n--&gt;[static] SessionEnded &lt;System.Object&gt;sender &lt;Microsoft.Win32.SessionEndedEventArgs&gt;e = ( ... )\n--&gt;[static] SessionEnding &lt;System.Object&gt;sender &lt;Microsoft.Win32.SessionEndingEventArgs&gt;e = ( ... )\n--&gt;[static] SessionSwitch &lt;System.Object&gt;sender &lt;Microsoft.Win32.SessionSwitchEventArgs&gt;e = ( ... )\n--&gt;[static] TimeChanged &lt;System.Object&gt;sender &lt;System.EventArgs&gt;e = ( ... )\n--&gt;[static] TimerElapsed &lt;System.Object&gt;sender &lt;Microsoft.Win32.TimerElapsedEventArgs&gt;e = ( ... )\n--&gt;[static] UserPreferenceChanged &lt;System.Object&gt;sender &lt;Microsoft.Win32.UserPreferenceChangedEventArgs&gt;e = ( ... )\n--&gt;[static] UserPreferenceChanging &lt;System.Object&gt;sender &lt;Microsoft.Win32.UserPreferenceChangingEventArgs&gt;e = ( ... )\n--&gt;true\n--We define a global function to be called by the event handler:\nfn TimeChanged a1 a2 = format \"TimeChanged callback: % : %\\n\" a1 a2\n--&gt;TimeChanged()\n--Finally we add the Event Handler for the event \"TimeChanged\":\ndotnet.addeventhandler c \"TimeChanged\" TimeChanged\n--&gt;OK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B2A\"></a>Now, if you open the Date and Time properties of MS Windows, change the seconds only\n               (to avoid problems with your <em class=\"strong\">3ds Max</em> license, do not change the date too much) and apply the changes. The MAXScript function\n               we registered will be called and will print in the Listener: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6778\"></a><pre>\nTimeChanged callback: dotNetObject:Microsoft.Win32.SystemEvents : dotNetObject:System.EventArgs\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B27\"></a>As you can see from the events list, you can register event handlers to be notified\n               when display settings are being changed, the palette or fonts are changing, and so\n               on. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B25\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";