var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5901C70F-60C6-4EE9-93B3-2E5093AB1F42\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"noValue\">\n      <meta name=\"indexterm\" content=\"silentValue\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NoValue Value</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5901C70F-60C6-4EE9-93B3-2E5093AB1F42\"></a><div class=\"head\">\n            <h1>NoValue Value</h1>\n         </div>\n         <p>The \n            		<em class=\"strong\">NoValue</em> class implements a void and silent value returned by setListenerSel() to prevent\n            \"OK\" from being printed to the listener.\n            	 \n         </p>\n         <p>There is one distinguished instance of the \n            		<em class=\"strong\">NoValue</em> class in the reserved system variable \n            		<span class=\"code\">silentValue</span>.\n            	 \n         </p>\n         <p>You can return \n            		<span class=\"code\">silentValue</span> from a function and it will prevent anything from being printed in the listener,\n            including an concluding \"OK\" and any output sent to \n            		<span class=\"code\">format()</span> or \n            		<span class=\"code\">print()</span>.\n            	 \n         </p><a name=\"TABLE_D24A35026F1E494DA4763A2D82564479\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">For Example</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>fn loudFunc = (	format \"I\'m printing something\")\nfn quietFunc = (format \"I won\'t print anything\"; return silentValue)\n\nloudFunc()\nquietFunc()\n\n--&gt; output:\nloudFunc()\nquietFunc()\nI\'m printing somethingOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";