var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-59FC1891-1A03-4E0F-86D8-C8DB0DE73CD9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getSafeFaceCenter() - polyOp\">\n      <meta name=\"indexterm\" content=\"getFaceNormal() - polyOp\">\n      <meta name=\"indexterm\" content=\"getFaceCenter() - polyOp\">\n      <meta name=\"indexterm\" content=\"getFaceArea() - polyOp\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Editable_Poly Get Face Center, Normal and Area Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-59FC1891-1A03-4E0F-86D8-C8DB0DE73CD9\"></a><div class=\"head\">\n            <h1>Editable_Poly Get Face Center, Normal and Area Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52E6\"></a><pre><em class=\"codeEmphasisStrong\">polyop</em>.<em class=\"codeEmphasisStrong\">getFaceCenter</em> &lt;Poly poly&gt; &lt;int face&gt; \\\n<em class=\"codeEmphasisStrong\">node</em>:&lt;node=unsupplied&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2446\"></a>Returns the center of the face by taking the average of all its vertices. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2447\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is a node, or if \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is specified, the position returned is in the current coordinate system context.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2448\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is not specified, the return value is in the poly\'s local coordinate system. \n            	 \n         </p>\n         <p><a name=\"P_40AA78789286431B9AA02ED3D753C84A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52E5\"></a><pre><em class=\"codeEmphasisStrong\">polyop</em>.<em class=\"codeEmphasisStrong\">getSafeFaceCenter</em> &lt;Poly poly&gt; &lt;int face&gt; \\\n<em class=\"codeEmphasisStrong\">node</em>:&lt;node=unsupplied&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C244B\"></a>Returns the \"safe\" center of the face, if possible. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C244C\"></a>For non-convex faces, the average point found using \n            		<span class=\"code\"> <em class=\"strong\">getFaceCenter</em> </span> is unsuitable for some applications because it can lie outside the face completely,\n            or in a region where it cannot see all the face\'s vertices (line segments from the\n            center to the corner pass outside of the face). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C244D\"></a>If a safe center cannot be found, a value of \n            		<em class=\"strong\"> <span class=\"code\">undefined</span> </em> is returned. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C244E\"></a>This routine provides a better solution in some cases by finding the center of the\n            convex hull of the face. The convex hull is defined as the region in a face with a\n            clear line-of-sight to all the corners. Some faces such as, the top face in an extruded\n            letter M have an empty convex hull, in which case this routine fails and merely provides\n            the regular center given by \n            		<span class=\"code\"> <em class=\"strong\">ComputeCenter</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C244F\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is a node, or if \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is specified, the position returned is in the current coordinate system context.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2450\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is not specified, the return value is in the poly\'s local coordinate system. \n            	 \n         </p>\n         <p><a name=\"P_2198986D4753482EB70292C63E9D16C8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52E4\"></a><pre><em class=\"codeEmphasisStrong\">polyop</em>.<em class=\"codeEmphasisStrong\">getFaceNormal</em> &lt;Poly poly&gt; &lt;int face&gt; \\\n<em class=\"codeEmphasisStrong\">node</em>:&lt;node=unsupplied&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2453\"></a>Returns the face normal of the face. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2454\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is a node, or if \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is specified, the direction vector returned is in the current coordinate system context.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2455\"></a>If \n            		<span class=\"code\">&lt;poly&gt;</span> is an Editable Poly and \n            		<span class=\"code\">&lt;node&gt;</span> is not specified, the return value is in the poly\'s local coordinate system. \n            	 \n         </p>\n         <p><a name=\"P_5BAD39E1C77A492F90422D5AD62FC8D3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52E3\"></a><pre><em class=\"codeEmphasisStrong\">polyop</em>.<em class=\"codeEmphasisStrong\">getFaceArea</em> &lt;Poly poly&gt; &lt;int face&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2458\"></a>Returns the area of the specified face. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";