var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Ray Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D\"></a><div class=\"head\">\n            <h1>Ray Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D8F\"></a>The \n            		<em class=\"strong\">Ray</em> class defines the characteristics of a ray in 3D space. \n            	 \n         </p>\n         <p><a name=\"P_D2E7F14FAFBC43B7B0760C5B359C5A27\"></a>A ray has two Point3 components, one defining a start position and the other a direction\n            vector for the ray. \n            	 \n         </p>\n         <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D90\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F73\"></a><pre><em class=\"codeEmphasisStrong\">ray</em> &lt;pos_point3&gt; &lt;dir_point3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D92\"></a>Returns a new ray with given position and direction vector. \n            	 \n         </p>\n         <p><a name=\"P_2F058CA0085F4F1EB7C273C11DDCEF77\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F72\"></a><pre>&lt;node&gt; <em class=\"codeEmphasisStrong\">as ray</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D95\"></a>Takes a scene object that has a target, such as a Tape Helper, a Target Camera or\n            Target Light and returns a ray from the object to the target. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D96\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the object has no target. \n            	 \n         </p>\n         <p><a name=\"P_6160D34277604A48BC3419385E8C4207\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D97\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F71\"></a><pre>&lt;ray&gt;.<em class=\"codeEmphasisStrong\">pos</em>: Float\n&lt;ray&gt;.<em class=\"codeEmphasisStrong\">position</em>: Float --pos and position are synonyms\n&lt;ray&gt;.<em class=\"codeEmphasisStrong\">dir</em>: Point3 --unit normalized direction vector</pre></div>\n         <p><a name=\"P_4D8077AC97E24C97A8D0199BE759100A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ray&gt; == &lt;ray&gt;\n&lt;ray&gt; != &lt;ray&gt;</pre></div>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 and higher</em>: Standard comparisons. \n            	 \n         </p>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D9B\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F70\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;ray&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D9D\"></a>Creates a new copy of the ray value. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D9E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87D9F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6F\"></a><pre>\nnewRay = copy oldRay\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DA3\"></a>The new value contains a copy of the input ray value, and is independent of the input\n            ray value. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DA6\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DA7\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DA8\"></a> <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DA9\"></a> <span class=\"char_link\"><a href=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525.htm\">Box2 Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";