var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5C069EAA-E2EB-4F7B-B6AC-DECD51121348\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"setProgressCancel()\">\n      <meta name=\"indexterm\" content=\"progressUpdate()\">\n      <meta name=\"indexterm\" content=\"progressStart()\">\n      <meta name=\"indexterm\" content=\"progressEnd()\">\n      <meta name=\"indexterm\" content=\"progress bar display\">\n      <meta name=\"indexterm\" content=\"getProgressCancel()\">\n      <meta name=\"indexterm\" content=\"enableEscape\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Progress Bar Display</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5C069EAA-E2EB-4F7B-B6AC-DECD51121348\"></a><div class=\"head\">\n            <h1>Progress Bar Display </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-309F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-309E\"></a>      This group of functions lets you display a progress bar for operations that might\n               be time consuming, similar to the progress bar that <em class=\"strong\">3ds Max</em> uses for IK, Preview Rendering, and Reduce Key computations. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3097\"></a>The functions are: \n            </p> \n            <p><a name=\"GUID-8B3D77F4-10B4-4AB7-ABB8-0F3D702AB475\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C53\"></a><pre><em class=\"codeEmphasisStrong\">progressStart</em> \"caption\" 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3095\"></a>Initially displays the progress bar with the caption given. \n            </p> \n            <p><a name=\"GUID-A5E4F839-508C-43EF-8C02-C03CD0A1F0D8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C52\"></a><pre><em class=\"codeEmphasisStrong\">progressUpdate</em> &lt;percent&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3092\"></a>Updates the bar display to show the given percentage complete (in the range 0-100).\n               This function also checks to see if the user has clicked the Cancel button in the\n               progress bar, and returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the computation must continue and <span class=\"code\"> <em class=\"strong\">false</em> </span> if the user has requested a cancel. You can also call <span class=\"code\"> <em class=\"strong\">getProgressCancel()</em> </span> (described below) to check the cancel status, which is a low overhead function and\n               might be called more frequently than <span class=\"code\"> <em class=\"strong\">progressUpdate()</em> </span>. \n            </p> \n            <p><a name=\"GUID-083EC5AF-459E-4CD9-9582-210254A33A3E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C51\"></a><pre><em class=\"codeEmphasisStrong\">progressEnd</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-308F\"></a>Signals the end of the operation and removes the progress bar display. \n            </p> \n            <p><a name=\"GUID-D7D82438-8448-4E00-AB32-CDE0CF715D6C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C50\"></a><pre><em class=\"codeEmphasisStrong\">getProgressCancel</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-308C\"></a>A low-overhead function that checks whether the user has canceled the operation using\n               the Cancel button in the progress bar. You might want to call this function frequently\n               within deep loops in your code to reduce cancel latency for the user because you must\n               only call <span class=\"code\"> <em class=\"strong\">progressUpdate()</em> </span> as needed to show significant progress bar changes to keep overhead low. The <span class=\"code\"> <em class=\"strong\">getProgressCancel()</em> </span> function as well as <span class=\"code\"> <em class=\"strong\">progressUpdate()</em> </span> displays a confirmation dialog if the user hits the cancel button and returns the\n               cancel status from that confirmation. Unlike <span class=\"code\"> <em class=\"strong\">progressUpdate()</em> </span>, this function returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the user has made a confirmed cancel request and <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            </p> \n            <p><a name=\"GUID-5C6A0BF2-8913-4661-9DF6-AD1FD2A0DF54\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C4F\"></a><pre><em class=\"codeEmphasisStrong\">setProgressCancel</em> &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3089\"></a>Sets or clears the Cancel flag for the progress bar. By passing a value of <span class=\"code\"> <em class=\"strong\">true</em> </span>, the Cancel flag is set and will be detected by <span class=\"code\"> <em class=\"strong\">progressUpdate()</em> </span> and <span class=\"code\"> <em class=\"strong\">getProgressCancel()</em> </span>. By passing a value of <span class=\"code\"> <em class=\"strong\">false</em> </span>, the Cancel flag is cleared if set. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3087\"></a>The following <em class=\"strong\">3ds Max</em> system global variable is associated with the Progress Bar display: \n            </p> \n            <p><a name=\"GUID-A1F14F63-F675-4A8D-AE54-4BBF958EAA91\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C4E\"></a><pre><em class=\"codeEmphasisStrong\">escapeEnable</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3085\"></a>Lets you get and set a Boolean value defining whether <span class=\"code\"> <em class=\"strong\">ESC</em> </span> key interrupt detection is on or off. Setting <span class=\"code\"> <em class=\"strong\">enableEscape</em> </span> to <span class=\"code\"> <em class=\"strong\">false</em> </span> turns <span class=\"code\"> <em class=\"strong\">ESC</em> </span> key interrupt detection off, setting it to <span class=\"code\"> <em class=\"strong\">true</em> </span> turns it on again. This variable is useful when used in conjunction with a Progress\n               Bar. You can set <span class=\"code\"> <em class=\"strong\">enableEscape</em> </span> to <span class=\"code\"> <em class=\"strong\">false</em> </span> when you do not want the user to interrupt a script running a long computation and\n               you have set up a progress bar with its own Cancel button. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3083\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3082\"></a><p class=\"table-body\"> <em class=\"strong\">NOTES ON CALCULATING PERCENTAGES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3081\"></a><p class=\"table-body\">When calculating the percentage from a current Integer value and a total Integer value,\n                           the order in which the values are multiplied and divided does matter. Dividing them\n                           first and then multiplying by 100.0 will always return 0.0 because an Integer divided\n                           by an Integer yields an Integer, and because the result is less than zero, it is rounded\n                           down to zero. If the total value is 20, for each value between 1 and 19, you will\n                           get: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C4D\"></a><pre>\n1/20*100.0 -&gt; 0*100.0 -&gt; 0.0\n2/20*100.0 -&gt; 0*100.0 -&gt; 0.0\n3/20*100.0 -&gt; 0*100.0 -&gt; 0.0\n...\n19/20*100.0-&gt; 0*100.0 -&gt; 0.0\n20/20*100.0-&gt; 1*100.0 -&gt; 100.0\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-307A\"></a><p class=\"table-body\">but </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C4C\"></a><pre>\n100.0*1/20 -&gt; 100.0/20 -&gt; 5.0\n100.0*2/20 -&gt; 200.0/20 -&gt; 10.0\n100.0*3/20 -&gt; 300.0/20 -&gt; 15.0\n...\n100.0*19/20-&gt; 1900.0/20-&gt; 95.0\n100.0*20/20-&gt; 2000.0/20-&gt; 100.0\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3073\"></a><p class=\"table-body\">When starting with the Float value 100.0, the final result is implicitly converted\n                           to a Float because a Float multiplied by an Integer returns a Float, and a Float divided\n                           by an Integer still returns a Float. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3070\"></a> <span class=\"char_link\"><a href=\"GUID-776617CF-FAED-45E7-8BDD-FCAB34421625.htm\">Status Bar</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-306F\"></a> <span class=\"char_link\"><a href=\"GUID-1F607FAC-886A-4B99-9B84-FCF5BAC5C140.htm\">Prompt Line</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-306E\"></a> <span class=\"char_link\"><a href=\"GUID-3EED3E7C-D7BB-4160-99BB-82B7872CA86D.htm\">Coordinate Display</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-306D\"></a> <span class=\"char_link\"><a href=\"GUID-2C42EF48-5949-4EC9-A067-EBE1267CCBFD.htm\">Status Bar Buttons</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-306C\"></a> <span class=\"char_link\"><a href=\"GUID-D62137AE-E500-4B42-983D-E7443E3DFF04.htm\">Interface: StatusPanel</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";