var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5DFECB42-C452-457B-BAD4-B07767AE8C9E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout .Controls Property</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5DFECB42-C452-457B-BAD4-B07767AE8C9E\"></a><div class=\"head\">\n            <h1>Rollout .Controls Property </h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"P_DB6FF9FF970A46089C11C51479214734\"></a><pre>&lt;rollout&gt;.<em class=\"codeEmphasisStrong\">controls</em></pre></div>\n         <p><a name=\"P_1B40AFA6AD24458B9DAE0B4576803C2F\"></a>This property returns an array of all the controls in the rollout. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6722\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6721\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7472\"></a><pre>\nrollout testRollout \"Test\"\n(\n  group \"Test\"\n  (\n    button btn_button \"Press Me If You Can\"\n    spinner spn_spinner \"Spin Me If You Can\"\n    checkbox chk_checkbox \"Check Me If You Can\"\n  )--end group\n)--end rollout\ncreateDialog testRollout width:200\n \n\nfor c in testRollout.controls do print c\n\n--loop through all controls in the rollout and \n--disable them all:\n\nfor c in testRollout.controls do c.enabled = false\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"TABLE_A48F9E5AD97B49A0B3AD7663A5E2DA9C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"P_463E333783B24BA4A2446C49EE1CC171\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_4F5EF5D0F7B345F897849C088F5E0258\"></a><pre>\nRollout:testRollout\ntrue\nGroupStartControl:Test\nButtonControl:btn_button\nSpinnerControl:spn_spinner\nCheckBoxControl:chk_checkbox\nGroupEndControl:Test\nOK\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_7D7EB02F2A364AF4AC9D1816D9FC1ADE\"></a></p><img src=\"../images/GUID-B9169A27-6DE8-44E2-A064-1F6DA3AFBBF3-low.bmp\"><div><a name=\"GUID-69CAD714-F0A6-4BA0-88F0-CB7C96459B75\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"P_B65112B537874A89B09A6FAB931F9C81\"></a>Note that a group is implemented as a pair of controls: <span class=\"code\">groupStartControl</span> and <span class=\"code\">groupEndControl</span>, which \"bracket\" the rest of the controls. In the above example, the group is also\n                  disabled. \n               </p> \n            </div>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66CB\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66CA\"></a> <span class=\"char_link\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Rollout User-Interface Controls Types</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66C9\"></a> <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Controls Common Properties</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66C8\"></a> <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Controls Common Layout Parameters</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";