var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-5ECE930B-32E0-42A7-9344-B9E0A2F73171\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Never get a single pixel when you can get a whole line</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5ECE930B-32E0-42A7-9344-B9E0A2F73171\"></a><div class=\"head\">\n            <h1>Never get a single pixel when you can get a whole line </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1300\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1302\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1303\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Never get a single pixel when you can get a whole line \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1306\"></a>The <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm#WS73099CC142F487553098682E12AC2FC2BC7-5ED0\">getPixels and setPixels functions</a></span> for reading and writing pixels from / to bitmaps are rather slow. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1307\"></a>When changing a large number or even all pixels of a bitmap, it is a good idea to\n            perform the <span class=\"code\"> <em class=\"strong\">getPixels()</em> </span> and <span class=\"code\"> <em class=\"strong\">setPixels()</em> </span> just once for each horizontal line and do the rest of the work with the resulting\n            array elements. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1308\"></a>In the following examples, a 1000x1000 pixels bitmap should be altered by changing\n            every single pixel. This means reading and writing back one million pixels. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1309\"></a>In the first example, every single pixel will be read separately, multiplied by a\n            number and written back. We will stop the time in order to compare to the optimized\n            version. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC130A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC130B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1 - UNOPTIMIZED SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662C\"></a><pre>\nb = bitmap 1000 1000 color:red--create new bitmap with red background\nst = timestamp()--get start time in milliseconds\nfor y = 1 to 1000 do--go through all lines in the bitmap\n(\n  for x = 1 to 1000 do--go through all pixels in a line\n  (\n    pixels = getPixels b [x-1,y-1] 1--read one pixel from X,Y\n    pixels[1] *= (x+y)/2000.0--alter the pixel\n    setPixels b [x-1,y-1] pixels--write modified pixel back\n  )--end x loop\n)--end y loop\net = timestamp()--get end time in milliseconds\nprint (et-st)--print time to finish\ndisplay b--show a nice black-red gradient\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC131C\"></a><p class=\"table-body\">Running this script on a 2.1GHz system resulted in a time stamp of 16094 milliseconds.\n                        \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC131E\"></a>In the second example, instead of reading every single pixel, will be read every line\n            and process all its pixels inside the array returned by <span class=\"code\"> <em class=\"strong\">getPixels()</em> </span> before writing the whole line back to the bitmap. This means we will make only 1000\n            read and 1000 write calls instead of one million reads and one million writes. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC131F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1320\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2 - OPTIMIZED SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662B\"></a><pre>\nb = bitmap 1000 1000 color:red--create new bitmap with red background\nst = timestamp()--get start time in milliseconds\nfor y = 1 to 1000 do--go through all lines in the bitmap\n(\n  pixels = getPixels b [0,y-1] 1000--read all 1000 pixels of a single line\n  for x = 1 to 1000 do--go through all pixels in the line\n  (\n    pixels[x] *= (x+y)/2000.0--alter the pixel\n  )&nbsp;\n  setPixels b [0,y-1] pixels--write back the complete modified line\n)\net = timestamp()--get end time in milliseconds\nprint (et-st)--print time to finish\ndisplay b--show the same nice black-red gradient\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1331\"></a><p class=\"table-body\">Running the optimized script on the same 2.1GHz system resulted in a time stamp of\n                        4937 milliseconds - more than three times faster! \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1333\"></a>Since <em class=\"strong\">3ds Max 2010</em>, <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm#WS73099CC142F487553098682E12AC2FC2BC7-5EB7\">the pasteBitmap() function</a></span> can be used in a custom <span class=\"code\">function:</span> mode to perform per-pixel operations using a MAXScript function. This method does\n            not involve the <span class=\"code\">getPixels()</span> and <span class=\"code\">setPixels()</span> calls but does the same and is also great for bothcompositing two bitmaps together\n            and for manipulating pixels ina single bitmap as in our test example.We simply pass\n            the same bitmap twice. The result is normally stored in the second bitmap, in this\n            case it is identical to the first bitmap so we effectively read and write using one\n            bitmap value: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1334\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1335\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 3 - ALTERNATIVE SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662A\"></a><pre>\nfn compfn c1 p1 c2 p2 =\n(\n  c1 * ((p1.x+p1.y)/2000.0)\n)\nb = bitmap 1000 1000 color:red--create new bitmap with red background\nst = timestamp()--get start time in milliseconds\npasteBitmap b b [0,0] [0,0] type:#function function:compfn--call the function per pixel\net = timestamp()--get end time in milliseconds\nprint (et-st)--print time to finish\ndisplay b--show the same nice black-red gradient\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1343\"></a><p class=\"table-body\">Running the alternative script on the same 2.1GHz system resulted in a time stamp\n                        of 3828 milliseconds - a second faster than the optimized script above! \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1345\"></a>The following table shows the times in milliseconds for the three examples at different\n            image resolutions: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1346\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"15.997381056307288%\">\n                  <col width=\"15.997381056307288%\">\n                  <col width=\"15.997381056307288%\">\n                  <col width=\"15.997381056307288%\">\n                  <col width=\"18.114360541248363%\">\n                  <col width=\"17.896115233522476%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1347\"></a><p class=\"table-body\">&nbsp; </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1348\"></a><p class=\"table-body\"> <em class=\"strong\">2000x2000</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1349\"></a><p class=\"table-body\"> <em class=\"strong\">1000x1000</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134A\"></a><p class=\"table-body\"> <em class=\"strong\">500x500</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134B\"></a><p class=\"table-body\"> <em class=\"strong\">250x250</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134C\"></a><p class=\"table-body\"> <em class=\"strong\">125x125</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134E\"></a><p class=\"table-body\">64657 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC134F\"></a><p class=\"table-body\">16094 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1350\"></a><p class=\"table-body\">3578 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1351\"></a><p class=\"table-body\">906 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1352\"></a><p class=\"table-body\">203 </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1353\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1354\"></a><p class=\"table-body\">20000 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1355\"></a><p class=\"table-body\">4937 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1356\"></a><p class=\"table-body\">1266 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1357\"></a><p class=\"table-body\">344 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1358\"></a><p class=\"table-body\">62 </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1359\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 3</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC135A\"></a><p class=\"table-body\">15187 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC135B\"></a><p class=\"table-body\">3828 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC135C\"></a><p class=\"table-body\">906 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC135D\"></a><p class=\"table-body\">172 </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC135E\"></a><p class=\"table-body\">47 </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1360\"></a> <em class=\"strong\">Previous Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1361\"></a> <span class=\"char_link\"><a href=\"GUID-6B3B7471-7599-4F6E-9AF2-67C9C04D3A35.htm\">Use the \'flagForeground\' node viewport state method</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1362\"></a> <em class=\"strong\">Next Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1363\"></a> <span class=\"char_link\"><a href=\"GUID-7C1FC5F5-58C3-48FA-84F8-B6F4B4A70239.htm\">Only calculate once if possible</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";