var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-606985DE-108C-4DF6-9C2A-8568D93366AA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface DaylightSystemFactory2\">\n      <meta name=\"indexterm\" content=\"DaylightSystemFactory2 Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: DaylightSystemFactory2</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-606985DE-108C-4DF6-9C2A-8568D93366AA\"></a><div class=\"head\">\n            <h1>Interface: DaylightSystemFactory2 </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F2\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; DaylightSystemFactory2 \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F3\"></a>The <em class=\"strong\">DaylightSystemFactory2 Interface</em> exposes a method for creating a daylight system using the given sun and sky classes.\n            \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F5\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AD4\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">DaylightSystemFactory2.Create sunClass</em>:&lt;class&gt;	<em class=\"codeEmphasisStrong\">skyClass</em>:&lt;class&gt; 	 \n\nsunClass default value: undefined\nskyClass default value: undefined</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F6\"></a>Creates a Daylight system. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F7\"></a>If the optional keywords are supplied, they should define the sun and/or sky classes\n            to be used.If any of the optional keywords is omitted, the system default settings\n            will be used. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F8\"></a>Possible classes for <span class=\"code\"> <em class=\"strong\">sunClass:</em> </span> are: \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64F9\"></a> <em class=\"strong\">&nbsp;DirectionalLight</em> - corresponds to Standard entry in the Daylight System UI \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FA\"></a> <em class=\"strong\">&nbsp;IES_Sun</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FB\"></a> <em class=\"strong\">&nbsp;mr_Sun</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FC\"></a>Possible classes for <span class=\"code\"> <em class=\"strong\">skyClass:</em> </span> are: \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FD\"></a>&nbsp;<em class=\"strong\">IES_Sky</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FE\"></a> <em class=\"strong\">&nbsp;mr_Sky</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A64FF\"></a> <em class=\"strong\">&nbsp;Skylight</em> \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6500\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6501\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AD2\"></a><pre>\ntheInt = DaylightSystemFactory2.Create sunClass:mr_Sun skyClass:mr_Sky\n--&gt; &lt;MixinInterface:IDaylightSystem&gt;\ntheInt.getSun()\n--&gt; mr Sun\ntheInt.getSky()\n--&gt; mr Sky\ntheInt = DaylightSystemFactory2.Create sunClass:DirectionalLight\n--&gt; &lt;MixinInterface:IDaylightSystem&gt;\ntheInt.getSun()\n--&gt; Free Directional Light\ntheInt.getSky()\n--&gt; Skylight\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6502\"></a> <span class=\"char_link\"><a href=\"GUID-9EEFF581-95CC-4D3C-887F-A7E1B2752C4F.htm\">Daylight : System</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6503\"></a> <span class=\"char_link\"><a href=\"GUID-7F4F35BB-E4C7-41DB-B4AB-9615BC0E1E8E.htm\">Light : Node</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6505\"></a> <span class=\"char_link\"><a href=\"GUID-B4023B21-58A2-4D64-821D-94093891FA2E.htm\">Lighting Analysis and DaylightSimulation Tools</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";