var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-60B05D43-86DE-402E-B9A7-8F8E5E05A316\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Accessing the Viewport Vertex Alpha Values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Accessing the Viewport Vertex Alpha Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-60B05D43-86DE-402E-B9A7-8F8E5E05A316\"></a><div class=\"head\">\n            <h1>Accessing the Viewport Vertex Alpha Values </h1>\n         </div><a name=\"TABLE_7DF23F2441DE47489011B0ABA142CA9E\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.026634382566586%\">\n                  <col width=\"54.29782082324456%\">\n                  <col width=\"42.675544794188866%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\"> <a name=\"P_FEB053DB60644F30877E3EB3396D856A\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_CD2BE44BB1CC4444B011E456370B61E5\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Editable Mesh - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18ED\"></a> <em class=\"strong\">3ds Max</em> supports 100 map channels that can be used for storing mapping coordinates. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18EE\"></a>Historically, \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18EF\"></a> <em class=\"strong\">3ds Max</em> 1.0 supported only one texture channel which is currently Channel 1. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F0\"></a> <em class=\"strong\">3ds Max</em> 2.0 added support for a second channel which could be used either for texture coordinates\n            or for storing vertex colors. Currently it is stored as Channel 0. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F1\"></a> <em class=\"strong\">3ds Max</em> 3.0 increased the number of channels to 100. The channels are numbered from 1 to\n            99 plus the already mentioned Vertex Colors Channel 0. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F2\"></a>All these Channels can be accessed by the Unwrap_UVW, by the Maps in the Material\n            Editor etc. The channels support map vertices and faces connecting them. For details,\n            you can see <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinates</a></span>. For related methods, see <span class=\"char_link\"><a href=\"GUID-A97DF4E3-04A7-4A91-AE7C-3C75A8BAA399.htm\">General Meshop Mapping Methods</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F3\"></a> <em class=\"strong\">3ds Max</em> 4.0 added support for Alpha in the Viewports. This new internal channel has been\n            given the index -2. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F4\"></a>In addition,<em class=\"strong\">3ds Max</em> 4.0 introduced 100 user data channels with indices from 1 to 100. These channels\n            can be used to store arbitrary Point3 data per vertex, for example special data for\n            game models that can be exported to game engines. They do not have face arrays, only\n            vertex data arrays. For related methods, see <span class=\"char_link\"><a href=\"GUID-102D2769-720E-4F73-9973-13AE18A65E90.htm\">Meshop Vertex Data Methods</a></span> \n         </p><a name=\"TABLE_94178A2302FD4D9F9C2E0506F7A17B05\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18F8\"></a><p class=\"table-body\">Mapping channels and Vertex Data channels are <em class=\"strong\">not the same thing!</em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18FA\"></a>While the User Data Channel 3 is dedicated to Alpha values, it is unrelated to the\n            Viewport Vertex Alpha channel which is the internal map channel with index -2. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18FB\"></a>In the following example we will create a sphere with 4 segments (only 6 vertices)\n            and access its Viewport Alpha values. You can try and increase the number of sphere\n            segments to get more vertices anytime. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18FD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18FE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C5\"></a><pre>\ns = sphere segs:4 -- create a sphere\nconvertToMesh s -- collapse to Editable Mesh\ns.showVertexColors = true -- enable Vertex Colors in Viewport\ns.vertexColorType = #alpha -- set Vertex Color type to Alpha\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1905\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-26D57D79-C342-4716-9624-3B1144BCCCED-low.gif\"></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C4\"></a><pre>\n--Read the number of mesh vertices\nmesh_verts = s.numverts\n--Set the map vertices for the first and last mesh vertex to black\n--Note that this access will automatically enable channel -2 and\n--build its internal vertex and face arrays.\nmeshop.setVertAlpha s -2 #(1, mesh_verts) 0.0\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C190D\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5F73F8BA-7CC0-4783-AB21-71C8ADA0FE6E-low.gif\"></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C3\"></a><pre>\n--Read the number of map vertices in Channel -2\n--Since the channel -2 is now enabled, you will get a valid result.\n--Evaluating this line BEFORE the previous one would lead to\n--an error message telling you Channel -2 is not enabled...\nmap_verts = meshop.getNumMapVerts s -2\n--Go through all map vertices except the first and last and change\n--their Alpha value to a non-greyscale color using direct access\n--to the Mapping Channel -2\nfor i = 2 to map_verts-1 do\n    meshop.setMapVert s -2 i [i*0.1,i*0.05,1.0-i*0.1]\n--Update the mesh:\nupdate s\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C191B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-BF63242B-CD06-45D9-B67F-9F75F8E9A277-low.gif\"></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C2\"></a><pre>\n--Go through all map vertices and print their values by\n--reading directly from Channel -2\nfor i = 1 to map_verts do format \"Map Vertex % = %\\n\" i (meshop.getMapVert s -2 i)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C191F\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C1\"></a><pre>\n$Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\n$Editable_Mesh:Sphere01 @ [0.000000,0.000000,0.000000]\ntrue\n#Alpha\n6\nOK\n6\nOK\nOK\nMap Vertex 1 = [0,0,0]\nMap Vertex 2 = [0.2,0.1,0.8]\nMap Vertex 3 = [0.3,0.15,0.7]\nMap Vertex 4 = [0.4,0.2,0.6]\nMap Vertex 5 = [0.5,0.25,0.5]\nMap Vertex 6 = [0,0,0]\nOK\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AB4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The array #(1, mesh_verts) specifies the Mesh Vertex Indices and not the Map Vertex\n               indices! The <span class=\"code\"> <em class=\"strong\">meshop.setVertAlpha</em> </span> will find all corresponding Map Vertices in the channel and affect them all without\n               the need to look for them! \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1937\"></a>On the other hand, the index supplied to <span class=\"code\"> <em class=\"strong\">meshop.setMapVert</em> </span> is the Map Vertex index and not the Mesh Index as in the case of <span class=\"code\"> <em class=\"strong\">meshop.setVertAlpha</em> </span>. If there are more Map Vertices corresponding to a single Mesh Vertex, you would\n            have to find them all and read their values separately. In this simple case though,\n            there are 6 Mesh Vertices and corresponding 6 Map Vertices, so the indices are the\n            same. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1938\"></a> <span class=\"code\"> <em class=\"strong\">meshop.getMapVert</em> </span> reads the actually stored value from a specific Map Vertex which is always a Point3\n            value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1939\"></a>As you see from the example, you can use <span class=\"code\"> <em class=\"strong\">meshop.setMapVert</em> </span> to set the value of Map Vertices in the Alpha Channel -2 to a color which will be\n            displayed as color in the viewport! The Alpha Channel -2 is just a regular mapping\n            channel used in a similar way to the Vertex Color Channel 0. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C193A\"></a> <span class=\"code\"> <em class=\"strong\">meshop.setVertAlpha</em> </span> lets the user set all Point3 components to single value at once for all Map Vertices\n            related to the supplied array of Mesh Vertices. This ensures the Alpha channel contains\n            a greyscale value and not an RGB value and shields the user from additional work to\n            provide Point3 values and find out which Map Vertices to affect. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C193B\"></a>The reason there is NO <span class=\"code\">meshop.getVertAlpha</span> counterpart is that a single Mesh Vertex could have any number of corresponding Map\n            Vertices, all with possibly different values, and all values having 3, possible different,\n            components. It would be difficult to return meaningful values for a group of Mesh\n            Vertices, each with multiple results and multiple Point3 components. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C193C\"></a>Using <span class=\"code\"> <em class=\"strong\">meshop.getMapVert</em> </span>, you will always get the exact Point3 value for the exact Map Vertex of interest,\n            and will be able to use it the way you want. \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AB3\"></a> <a name=\"TABLE_2CD3708692BD47EAB0D2DCB9ABECC2B5\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1476235442241105%\">\n                     <col width=\"54.170601196096946%\">\n                     <col width=\"42.681775259678936%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_3FF91AD81B7C4FDE9A56338E26B98D3B\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_CEF3B400115D4F20B301DE1DF3123F69\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Editable Mesh - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C193E\"></a> <span class=\"char_link\"><a href=\"GUID-A97DF4E3-04A7-4A91-AE7C-3C75A8BAA399.htm\">General Meshop Mapping Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C193F\"></a> <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinates</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";