var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-619AF4D3-A347-4155-943B-707D421BC460\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Clauses\">\n      <meta name=\"indexterm\" content=\"tool\">\n      <meta name=\"indexterm\" content=\"worldPoint\">\n      <meta name=\"indexterm\" content=\"worldDist\">\n      <meta name=\"indexterm\" content=\"worldAngle\">\n      <meta name=\"indexterm\" content=\"gridPoint\">\n      <meta name=\"indexterm\" content=\"shiftKey\">\n      <meta name=\"indexterm\" content=\"rButton\">\n      <meta name=\"indexterm\" content=\"mButton\">\n      <meta name=\"indexterm\" content=\"lButton\">\n      <meta name=\"indexterm\" content=\"gridDist\">\n      <meta name=\"indexterm\" content=\"gridAngle\">\n      <meta name=\"indexterm\" content=\"ctrlKey\">\n      <meta name=\"indexterm\" content=\"altKey\">\n      <meta name=\"indexterm\" content=\"nodeTM\">\n      <meta name=\"indexterm\" content=\"on\">\n      <meta name=\"indexterm\" content=\"scripted mouse tool event handlers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Mouse Tool Clauses</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-619AF4D3-A347-4155-943B-707D421BC460\"></a><div class=\"head\">\n            <h1>Mouse Tool Clauses </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5665\"></a>  The <span class=\"code\"> <em class=\"strong\">&lt;tool_body&gt;</em> </span> of a mouse tool definition is made up of a sequence of tool clauses as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7255\"></a><pre>&lt;tool_body&gt; ::= { &lt;tool_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5661\"></a>Tool clauses define the components of a tool and can be one of two basic things: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5660\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-565E\"></a> <em class=\"strong\">Local variables, functions or structure definitions</em> are variables, functions, and structures whose scope is the tool. The <span class=\"code\"> <em class=\"strong\">&lt;tool_body&gt;</em> </span> is compiled in its own local scope and the locals are only visible inside the scope\n                  of the tool. Tool locals are heap-based locals, which are slightly different from\n                  normal (stack-based) locals. Normal locals are visible in the current scope and have\n                  a lifetime of one execution of that scope. Heap-based locals are also visible only\n                  in the current scope, but have a lifetime equal to the lifetime of the top-level expression\n                  where they are defined. A tool’s locals are created the first time you execute the\n                  tool and are kept permanently in the heap (unless and until you redefine the tool).\n                  This means things like rollouts created in a tool that live beyond the simple execution\n                  of the tool can refer to these locals and the locals will still exist. Each time you\n                  execute a tool, its local variables are initialized to a value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span>, or to their specified initialization value. For example, you can create a rollout\n                  in a tool, and the rollout’s event handlers can access the locals defined in the tool\n                  because the rollout is executing within the scope of the tool. You cannot access the\n                  tool’s locals from another utility or from Listener, because they are not executing\n                  within the scope of the tool. See <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> for more information. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-565C\"></a> <em class=\"strong\">Event handlers</em> are special kinds of functions associated with particular events. Event handlers\n                  specify the processing you want to occur when a user clicks or moves a mouse, right-clicks,\n                  or starts or stops the tool. These actions generate named events and the optional\n                  event handler you supply for that event is called when the action occurs. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-565B\"></a>Formally, the syntax of a <span class=\"code\"> <em class=\"strong\">&lt;tool_clause&gt;</em> </span> is defined as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7254\"></a><pre>&lt;tool_clause&gt; ::= &lt;local_variable_decl&gt; | &lt;local_function_decl&gt; | &lt;local_struct_decl&gt; | &lt;event_handler&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5659\"></a> <em class=\"strong\">Locals</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5658\"></a>A <span class=\"code\"> <em class=\"strong\">&lt;local_variable_decl&gt;</em> </span>, <span class=\"code\"> <em class=\"strong\">&lt;local_function_decl&gt;</em> </span>, and <span class=\"code\"> <em class=\"strong\">&lt;local_struct_decl&gt;</em> </span> are exactly the same as local variable, function, and structure definitions in MAXScript:\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7253\"></a><pre>&lt;local_variable_decl&gt; ::= <em class=\"codeEmphasisStrong\">local</em> &lt;decl&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;decl&gt; } \n&lt;decl&gt; ::= &lt;name&gt; [ = &lt;expr&gt; ] -- optional initial value\n&lt;local_function_decl&gt; ::= [ <em class=\"codeEmphasisStrong\">mapped</em> ](<em class=\"codeEmphasisStrong\">function</em> | <em class=\"codeEmphasisStrong\">fn</em> ) &lt;name&gt; { &lt;argument&gt; } <em class=\"codeEmphasisStrong\">= </em>&lt;expr&gt;\n&lt;local_struct_decl&gt; ::+ <em class=\"codeEmphasisStrong\">struct</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">(</em> &lt;member&gt; { <em class=\"codeEmphasisStrong\">, </em>&lt;member&gt; } <em class=\"codeEmphasisStrong\">)</em>\n&lt;member&gt; ::= ( &lt;name&gt; [<em class=\"codeEmphasisStrong\"> = </em>&lt;expr&gt; ] | &lt;local_function_decl&gt; )</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5654\"></a>Global variables cannot be declared as a tool clause, however they can be declared\n            within event handler scripts. If you need to ensure a variable name references a global\n            variable, declare the variable name as global immediately before defining the tool\n            in your script. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5653\"></a>When writing scripts, it is good programming practice to explicitly declare your local\n            and global variables. Implicit declaration is provided as a short-hand, typically\n            used when working in the Listener interactively or developing short scripts. When\n            developing extended scripts, explicitly declaring variables can reduce errors and\n            improve readability of the code. It is also recommend that you declare as local all\n            variables unless you really want them to be global variables. The reasons for this\n            are described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5652\"></a>Within the functions and event handlers of a tool, 13 pre-defined locals variables\n            are always accessible. Each one holds a useful value relating to the mouse action\n            that just occurred: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7252\"></a><pre><em class=\"codeEmphasisStrong\">viewPoint</em> Point2</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-7F58\"></a>The current mouse position in viewport pixel coordinates. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7251\"></a><pre><em class=\"codeEmphasisStrong\">worldPoint</em> Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-564B\"></a>The current mouse position projected on the active grid in world coordinates. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7250\"></a><pre><em class=\"codeEmphasisStrong\">worldDist</em> Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5649\"></a>The distance in X, Y, and Z from the previous click point to the current click point\n            in world coordinates. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724F\"></a><pre><em class=\"codeEmphasisStrong\">worldAngle</em> Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5647\"></a>The angles around the world X, Y, and Z axes from the previous click point to the\n            current click point in world coordinates. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724E\"></a><pre><em class=\"codeEmphasisStrong\">gridPoint</em> Point3</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-7F57\"></a>The current mouse position projected on the active grid in the coordinate system of\n            the active grid. If the active grid is the home grid, the coordinate system is the\n            home grid plane active in the current viewport (that is, the construction plane).\n            See the discussion of grid versus world values below. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724D\"></a><pre><em class=\"codeEmphasisStrong\">gridDist</em> Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-563C\"></a>The distance in X, Y, and Z from the previous click point to the current click point\n            in the coordinate system of the active grid. If the active grid is the home grid,\n            the coordinate system is the home grid plane active in the current viewport (that\n            is, the construction plane). See the discussion of grid versus world values below.\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724C\"></a><pre><em class=\"codeEmphasisStrong\">gridAngle</em> Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-563A\"></a>The angles around the world X, Y, and Z axes from the previous click point to the\n            current click point in the coordinate system of the active grid. If the active grid\n            is the home grid, the coordinate system is the home grid plane active in the current\n            viewport (that is, the construction plane). See the discussion of grid versus world\n            values below. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724B\"></a><pre><em class=\"codeEmphasisStrong\">shiftKey</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5638\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if <em class=\"strong\"> <span class=\"keyboardEntry\">SHIFT</span> </em> key was down. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-724A\"></a><pre><em class=\"codeEmphasisStrong\">ctrlKey</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5636\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if <em class=\"strong\"> <span class=\"keyboardEntry\">Ctrl</span> </em> key was down. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7249\"></a><pre><em class=\"codeEmphasisStrong\">altKey</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5634\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if <em class=\"strong\"> <span class=\"keyboardEntry\">Alt</span> </em> key was down. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7248\"></a><pre><em class=\"codeEmphasisStrong\">lButton</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5632\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if left mouse button was down. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7247\"></a><pre><em class=\"codeEmphasisStrong\">mButton</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5630\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if middle mouse button was down. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7246\"></a><pre><em class=\"codeEmphasisStrong\">rButton</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-562E\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if right mouse button was down. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-7F56\"></a>When a create mouse tool is used in a level 5 scripted plug-in, an additional local\n            variable is accessible: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7245\"></a><pre><em class=\"codeEmphasisStrong\">nodeTM</em> Matrix3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-562B\"></a>Provides read/write access to the transform of the node currently being created. This\n            value is in the current grid coordinate system. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-562A\"></a>See <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> for more information. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5629\"></a>When writing SimpleObject scripted plug-ins, you should always use the <span class=\"code\"> <em class=\"strong\">gridPoint</em> </span>, <span class=\"code\"> <em class=\"strong\">gridDist</em> </span>, and <span class=\"code\"> <em class=\"strong\">gridAngle</em> </span> values rather than corresponding world values, as object-creation in SimpleObject\n            scripted plug-ins is managed in the active grid coordinate system. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5628\"></a>For <span class=\"code\"> <em class=\"strong\">gridDist</em> </span>, the .X and .Y components are the delta X and Y between the previous clicked point\n            and the current mouse point in the plane of the current grid. The .Z component is\n            a projection from the current Y screen coordinates onto a Z-vector (in the grid coordinate\n            system) based at the last point clicked on the grid, such that the .Z value is the\n            projected height up the Z-vector. For non-orthogonal viewports this is as expected,\n            but for orthogonal viewports (in which you are always dragging in the XY plane of\n            the grid), this is always the same as <span class=\"code\"> <em class=\"strong\">gridDist.y</em> </span>. If you are using the gridDist value to build the portion of an object on the grid,\n            or determine the distance on the current grid from the last point, you want to use\n            only the .X and .Y components. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5627\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5626\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7244\"></a><pre>\nside1Len = gridDist.x\nside2Len = gridDist.y\ndist=length [gridDist.x,gridDist.y]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5620\"></a>If you are specifying the height off of the current grid, you would typically use\n            the .Z component. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-561F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-561E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7243\"></a><pre>\nheight = gridDist.z\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-561A\"></a>For <span class=\"code\"> <em class=\"strong\">worldDist</em> </span>, the behavior is similar to that for <span class=\"code\"> <em class=\"strong\">gridDist</em> </span>, however the projected component is dependent on the construction plane of the viewport.\n            For the Top, Bottom, and non-orthogonal viewports, the projected height is contained\n            in the .Z component. For Left and Right viewports, the projected height is contained\n            in the .X component. For Front and Back viewports, the projected height is contained\n            in the .Y component. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5619\"></a>When you create a node in the <em class=\"strong\">3ds Max</em> user-interface, the local Z axis of the node is perpendicular to the construction\n            plane. When you create a node using MAXScript, by default the local Z axis of the\n            node points along the direction of the world Z axis. If you create a node in a tool\n            (other than in a SimpleObject scripted plug-in), you must take into account the construction\n            plane orientation if you want to duplicate <em class=\"strong\">3ds Max</em>’s behavior when creating a node. The easiest way to do this is to create the node\n            in a <span class=\"code\"> <em class=\"strong\">coordsys grid</em> </span> context and specify the position of the node during creation in grid coordinate space.\n            An example of this is shown in the following script. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5617\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5616\"></a><p class=\"table-body\"> <em class=\"strong\">POINT CREATOR</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7242\"></a><pre>\ntool PointCreator\n(\nlocal p, createpoint\n-- define a function to perform actual node creation. Setting coordsys to\n-- ’r;grid’ in order for the alignment of the node’s local Z axis to be\n-- perpendicular to the construction grid\nfn createpoint = in coordsys grid p=point pos:gridPoint\n--\n-- set up so that a node is created on a mouse button down, move node\n-- drag, release node at mouse button up.\n--\n-- if clickno == 1, then we are at first mouse click, which is a mouse\n-- button down. If clickno != 1, at following mouse button up.\non mousePoint clickno do\n(\nif clickno == 1\nthen createPoint()\n-- if p == undefined, then clicked twice without mouse movement\n-- (double clicked). No point object present, so just ignore this click.\nelse if p != undefined do (p.pos=worldPoint;p=undefined)\n)\n-- if p != undefined, we are moving a previously created node\n-- if p == undefined, and left mouse button is down, create a node\non mouseMove clickno do\n(\nif p != undefined\nthen p.pos=worldPoint\nelse if lbutton do createPoint()\n)\n)\n-- start the tool. No exit condition defined, so right-click to exit.\nstartTool PointCreator\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-747D\"></a>   <em class=\"strong\">Event Handlers</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55F0\"></a>An <span class=\"code\"> <em class=\"strong\">&lt;event_handler&gt;</em> </span> is a special function definition local to a tool that you provide to handle the processing\n            you want to occur when a user clicks in a viewport, right-clicks, or starts or stops\n            the tool. Each user action generates a named event and any event handler you supply\n            for that event is called when the action occurs. The available event handlers are:\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7241\"></a><pre><em class=\"codeEmphasisStrong\">on start do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55EE\"></a>Called when the tool starts. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7240\"></a><pre><em class=\"codeEmphasisStrong\">on stop do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55EB\"></a>Called when the tool ends. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723F\"></a><pre><em class=\"codeEmphasisStrong\">on freeMove do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55E8\"></a>Called when the mouse moves prior to the first click. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723E\"></a><pre><em class=\"codeEmphasisStrong\">on mousePoint</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55E5\"></a>Called for each mouse click, parameter <span class=\"code\"> <em class=\"strong\">arg</em> </span> contains the number of the click. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723D\"></a><pre><em class=\"codeEmphasisStrong\">on mouseMove</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55E2\"></a>Called when the mouse moves anytime after the first click. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723C\"></a><pre><em class=\"codeEmphasisStrong\">on mouseAbort</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55DF\"></a>Called when the user right-clicks to cancel or presses the ESC key. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55DE\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;arg&gt;</em> </span> parameter on each of the mouse event handlers lets you know which mouse click you\n            are in. Mouse clicks are actually only the mouse click release, except for the initial\n            mouse click. If you do a mouse click, drag, release, move, click, drag, and release,\n            the <span class=\"code\"> <em class=\"strong\">on mousePoint</em> </span> event handler is called three times: the first click, the first release, and the\n            second release, with <span class=\"code\"> <em class=\"strong\">&lt;arg&gt;</em> </span> values of 1, 2, and 3, respectively. The mouse click counter is incremented after\n            processing the <span class=\"code\"> <em class=\"strong\">on mousePoint</em> </span> event handler, so the <span class=\"code\"> <em class=\"strong\">&lt;arg&gt;</em> </span> parameter for the <span class=\"code\"> <em class=\"strong\">mouseMove</em> </span> and <span class=\"code\"> <em class=\"strong\">mouseAbort</em> </span> event handlers specify the click count for the next mouse click. In the previous\n            example, when you drag between the first click and first release, the <span class=\"code\"> <em class=\"strong\">&lt;arg&gt;</em> </span> value for a <span class=\"code\"> <em class=\"strong\">mouseMove</em> </span> event handler will have a value of 2. During the following move, click, and drag\n            it will have a value of 3. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55DD\"></a>In <em class=\"strong\">3ds Max 6 and higher,</em> while running a mouse tool, if you click in a viewport where the construction plane\n            is on edge, the tool will exit with a return value of <span class=\"code\"> <em class=\"strong\">#abort</em> </span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55DC\"></a>The following script simply demonstrates when the various event handlers are called.\n            Simply run this script and drag in the viewports. Right-click or press the ESC key\n            to stop the tool’s execution. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55DA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55D9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723B\"></a><pre>\ntool foo\n(\non freeMove do print \"Free Moving\"\non mousePoint clickno do format \"Point: %\\n\" clickno\non mouseAbort clickno do format \"Abort: %\\n\" clickno\non mouseMove clickno do format \"Moving: %\\n\" clickno\non start do print \"Starting\"\non end do print \"Ending\"\n)\nstartTool foo prompt:\"Hello!\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55CB\"></a>All of the mouse action event handlers may return the special value <span class=\"code\"> <em class=\"strong\">#stop</em> </span> which causes the tool to stop. In the following <span class=\"code\"> <em class=\"strong\">mousePoint</em> </span> event handler example, the first click creates the box and the release (second click)\n            terminates the tool. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55CA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55C9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-723A\"></a><pre>\non mousePoint clickno do\nif clickno == 1\nthen b = box pos:worldPoint\nelse #stop\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55C1\"></a>The following script implements the following functions: on mouse click three spot\n            lights are created at the mouse point. While holding the mouse button down, drag the\n            mouse to position the classical key, back and fill light positions. During this drag,\n            holding down the SHIFT key will flip the fill light side. Release the mouse button\n            and move the mouse to change the elevation of the lights. Click the mouse button when\n            the lights are at the correct height. The back light is raised 1.5 times the key light’s\n            height, and the fill light is raised 0.75 times the key light’s height. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55C0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55BF\"></a><p class=\"table-body\"> <em class=\"strong\">TO START THIS TOOL, YOU WOULD SAY</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7239\"></a><pre>\nstartTool three_lights\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55BB\"></a>and then drag in one of the viewports. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55B9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-55B8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7238\"></a><pre>\ntool three_lights\n(\nlocal key, fill, back, targ\non mousePoint click do coordsys grid\n(\nif click == 1 then -- create key, back &amp; fill lights at mousedown\n(\ntarg = targetobject pos:gridPoint\nkey = targetspot pos:gridPoint name:\"key\"target:targ\nback = targetspot pos:gridPoint name:\"back\"target:targ\nfill = targetspot pos:gridPoint name:\"fill\"target:targ\n)\nif click == 3 then #stop\n)\non mouseMove click do\n(\nif click == 2 then -- drag out &amp; round on x-y plane\n(\ncoordsys grid key.pos = gridPoint\ncoordsys targ back.pos = - key.pos\nlocal p = if shiftKey then 90 else -90\ncoordsys targ fill.pos = key.pos * ((eulerangles 0 0 p) as quat)\n)\nelse if click == 3 then -- drag up to elevate lights\n(\nin coordsys targ\n(\nlocal Z = gridDist.z\nkey.pos.z = Z\nback.pos.z = Z * 1.5\nfill.pos.z = Z * 0.5\n)\n)\n)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5591\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";