var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-639CF6E0-1B9F-4B05-9CE8-D6418162E0CE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ObjImp ImporterPlugin\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ObjImp : ImporterPlugin</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-639CF6E0-1B9F-4B05-9CE8-D6418162E0CE\"></a><div class=\"head\">\n            <h1>ObjImp : ImporterPlugin </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6382\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6381\"></a> The <em class=\"strong\">ObjImp ImporterPlugin</em> introduced in <em class=\"strong\">3ds Max 2010</em> exposes an interface to access the ASCII-based INI files location and name of the\n               exporter dialog. The settings can then be queried and modified using the regular MAXScript\n               INI settings functions <span class=\"code\"> <em class=\"strong\">getIniSetting()</em> </span> and <span class=\"code\"> <em class=\"strong\">setIniSetting()</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-637F\"></a> <em class=\"strong\">ObjImp Interfaces:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2985\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">iobjimp</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-637D\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2984\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">objImp.getIniName</em> ()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-637B\"></a>Returns the name of the Obj Importer Settings file. \n            </p> \n            <p><a name=\"GUID-04EA8EA0-2F31-43B4-B04A-5057AAB2C6AF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2983\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">objImp.getPresetIniName</em> () </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6378\"></a>Returns the name of the Obj Importer Preset file. \n            </p> \n            <p><a name=\"GUID-FC800E5C-F089-4CF1-B54B-CEE593F18A20\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6376\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6375\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2982\"></a><pre>\n--Open the INI file for editing in the MAXScript Editor\nedit (objimp.getIniName())\n&nbsp;\n--Alternatively, use INI file access to read and write:\ntheINI =objimp.getIniName()\ngetIniSetting theINI--get INI file categories\n--&gt;#(\"General\", \"Objects\", \"Geometry\", \"Units/Scale\", \"Material\")\n&nbsp;\n--get the keys of the General category:\ngetIniSetting theINI \"Geometry\"\n--&gt;#(\"FlipZyAxis\", \"CenterPivots\", \"Shapes\", \"TextureCoords\", \"SmoothingGroups\", \"NormalsType\", \"SmoothAngle\", \"FlipNormals\")\n&nbsp;\n--get thevalueof theGeometry&gt;Shapeskey:\ngetIniSetting theINI \"Geometry\"\"Shapes\"\n--&gt;\"0\"\n&nbsp;\n--TurnShapes on:\nsetIniSetting theINI \"Geometry\"\"Shapes\" \"1\"\n--&gt;true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-635D\"></a> <span class=\"char_link\"><a href=\"GUID-4BAF2F8E-4EAC-4276-A9A7-FF80EE597A45.htm\">ObjExp : ExporterPlugin</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-635C\"></a> <span class=\"char_link\"><a href=\"GUID-5F4CDEC6-288D-4C33-91FA-0CB1AF4121C7.htm\">Import and Export Filters</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";