var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-674593EC-8C24-4BF7-8192-CC84AE0D3D61\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface pfSystem\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: pfSystem</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-674593EC-8C24-4BF7-8192-CC84AE0D3D61\"></a><div class=\"head\">\n            <h1>Interface: pfSystem </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E832E7\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E832EA\"></a> <em class=\"strong\">The pfSystem Interface is exposed by the Particle Flow Source Class.</em>  \n            </p> \n            <p><a name=\"GUID-692307E1-2432-4912-930D-2D570E42B594\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E832EB\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4180\"></a><pre>&lt;float&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getMultiplier</em> &lt;time&gt;time 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E832ED\"></a>Returns the Quality multiplier depending on the Render State. See methods <span class=\"code\"> <em class=\"strong\">setRenderState</em> </span> and <span class=\"code\"> <em class=\"strong\">isRenderState</em> </span> below for more details on Render State. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E832EE\"></a>A value of 1.0f means that the operator produces particles at 100% rate. A value of\n               0.5f means that the operator produces only half the particles that it is supposed\n               to generate. For example, if a Birth operator is set to produce 1000 particles total,\n               then when the multiplier is set to 0.5f, the operator will produce only 500 particles.\n               \n            </p> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FEA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <em class=\"strong\">time</em> parameter is reserved <em class=\"strong\">for future use</em>. Pass <em class=\"strong\">0f</em> or any time value to call the method. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E832F3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E832F4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-417F\"></a><pre>\n--Create a new Particle Flow Source in the Viewport\npfs = PF_Source()\n--&gt; $PF_Source:PF Source 001 @ [2.536594,-48.031052,0.000000]\n--Get the Multiplier while in Viewport state\npfs.getMultiplier 0f\n--&gt; 0.5\n--Change the Particle Source State to Render\npfs.SetRenderState true\n--&gt; true\n--Get the Multiplier again - when in Render State, the Source\n--generates all particles!\npfs.getMultiplier 0f\n--&gt; 1.0\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-3C82E11B-8F8A-4769-8A0F-1A21C13ACB9B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-417E\"></a><pre>&lt;integer&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getBornAllowance</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83307\"></a>Returns the born allowance, which is currently the Upper Limit at time zero, same\n               as <span class=\"code\">&lt;PF_Source&gt;.Particle_Amount_Limit</span>. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FE9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-0BBFCA63-3F24-4089-BD4D-0DC997DC6489\"></a>Implemented for future use. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-27851BBA-3B9D-4179-A0E2-315A0B0BF5D6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-417D\"></a><pre>&lt;bool&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">hasEmitter</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8330D\"></a>Returns <em class=\"strong\">true</em> if the Particle System has emitter(s), <em class=\"strong\">false</em> otherwise. \n            </p> \n            <p><a name=\"GUID-6399B0FC-FF20-47E2-9720-AD50E6B5E794\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-417C\"></a><pre>&lt;integer&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getEmitterType</em> &lt;time&gt;time </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83310\"></a>Returns the Emitter Type at the specified time. \n            </p> \n            <p><a name=\"GUID-7A964D56-B98F-4F38-AE10-E8C4004819D5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-417B\"></a><pre>&lt;void&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getEmitterDimensions</em> &lt;time&gt;time &lt;&amp;float array&gt;dimensions \n\ndimensions is In and Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83314\"></a>Returns the Emitter Dimensions at the specified time as an array of floats stored\n               in the by-reference variable. \n            </p> \n            <p><a name=\"GUID-E2C73BD4-9E25-4352-9BD9-E27F35A52A9E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4179\"></a><pre>&lt;mesh&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getEmitterGeometry</em> &lt;time&gt;time </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83317\"></a>Returns the Emitter geometry at the specified time as mesh. \n            </p> \n            <p><a name=\"GUID-52FCEBB6-EB4F-4E57-9DBC-78AEF6E563DB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4178\"></a><pre>&lt;bool&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">isEmitterGeometryAnimated</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8331A\"></a>Returns <em class=\"strong\">true</em> if the Emitter geometry is animated, <em class=\"strong\">false</em> otherwise. \n            </p> \n            <p><a name=\"GUID-AE671AE5-24FE-43BD-AF3B-A360234C5D05\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4177\"></a><pre>&lt;void&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">setRenderState</em> &lt;bool&gt;renderState </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8331D\"></a>Sets the render State of the Particle System to the supplied boolean value. See explanation\n               below. \n            </p> \n            <p><a name=\"GUID-620A8998-1174-4F04-9A81-1DE11B20FAD0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4176\"></a><pre>&lt;bool&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">isRenderState</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83320\"></a>Returns <em class=\"strong\">true</em> if the Particle System is in render state, <em class=\"strong\">false</em> otherwise. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83321\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83322\"></a><p class=\"table-body\"> <em class=\"strong\">IMPORTANT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83323\"></a><p class=\"table-body\">A <em class=\"strong\">Particle Flow</em> particle system has two states: render and viewport. At any given moment it is exclusively\n                           in the one state or the other. The particle system might have different parameters\n                           during render and viewport (Multiplier value, emitter geometry, and others) therefore\n                           it is important to know what state it is in. It is possible to switch the state of\n                           a particle system using the <em class=\"strong\">setRenderState</em> method. A <em class=\"strong\">Particle Flow</em> particle system alternates its state automatically when the rendering starts and\n                           when the rendering ends. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-DB0C6031-F5F6-404B-9249-0083216C8573\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4175\"></a><pre>&lt;time&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getIntegrationStep</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83326\"></a>Returns the Integration Step as time value. \n            </p> \n            <p><a name=\"GUID-8E96AF1D-DD7A-423A-A6D4-77DAE3F26C5C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4174\"></a><pre>&lt;integer&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getUpdateType</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83329\"></a>Returns the Update Type as integer. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8332A\"></a>0: <em class=\"strong\">Complete</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8332B\"></a>1: <em class=\"strong\">Forward</em> \n            </p> \n            <p><a name=\"GUID-9AE90B62-72EB-4EA7-A887-3CA75486E671\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4173\"></a><pre>&lt;integer&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">numParticlesSelected</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8332E\"></a>Returns the number of selected particles. \n            </p> \n            <p><a name=\"GUID-5C48A7B2-EAB5-4727-BE18-4F9F3D98CA7F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4172\"></a><pre>&lt;index&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getSelectedParticleID</em> &lt;index&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83331\"></a>Returns the particle ID of the indexed particle. \n            </p> \n            <p><a name=\"GUID-8CB35638-70F4-4618-8EC1-D86C3CF493AD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4171\"></a><pre>&lt;bool&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">isParticleSelected</em> &lt;index&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83334\"></a>Returns <em class=\"strong\">true</em> if the indexed particle is selected, <em class=\"strong\">false</em> otherwise. \n            </p> \n            <p><a name=\"GUID-DB1F5376-A240-4AB4-8D4D-1E81FAF769FB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4170\"></a><pre>&lt;integer&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">numActionListsSelected</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83337\"></a>Returns the number of selected Action Lists. \n            </p> \n            <p><a name=\"GUID-F0CC22F3-83D0-4917-BDB0-02356BA6E222\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-416F\"></a><pre>&lt;node&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">getSelectedActionList</em> &lt;index&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8333A\"></a>Returns the indexed Action List. \n            </p> \n            <p><a name=\"GUID-CBC88606-531A-46ED-9A68-C4F7ACFB1C54\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-416E\"></a><pre>&lt;bool&gt;&lt;PF_Source&gt;.<em class=\"codeEmphasisStrong\">isActionListSelected</em> &lt;index&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8333D\"></a>Returns <em class=\"strong\">true</em> if the indexed Action List is selected, <em class=\"strong\">false</em> otherwise. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8333F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83340\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES AND RESULTS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-416D\"></a><pre>\n--Create a new Particle Flow Source in the Viewport\n--from the Create tab, then get it by name from the scene\npf = $\'PF Source 001\'\n--&gt; $PF_Source:PF Source 001 @ [0.000000,0.000000,0.000000]\n--Get the number of particles that the Source can give birth to\npf.getBornAllowance()\n--&gt; 100000\n--Check whether the Source has an emitter\npf.hasEmitter()\n--&gt; true\n--Get the emitter type\npf.getEmitterType 0\n--&gt; 0\ndim = #()--define an empty array\n--&gt; #()\n--get the Emitter dimensions,\n--pass the empty array variable by reference\npf.getEmitterDimensions 0 &amp;dim\n--&gt; OK\n--look into the previously empty array -\n--the dimensions are in it\nDim\n--&gt; #(20.0, 20.0)\n--Get the Emitter Geometry as TriMesh on frame 0\nm = pf.getEmitterGeometry 0\n--&gt; TriMesh\nm.numverts--check the number of vertices\n--&gt; 4\nm.numfaces--check the number of faces\n--&gt; 2\n--Check if the emitter geometry is animated\npf.isEmitterGeometryAnimated()\n--&gt; false\n--Set and get the render state\npf.setRenderState false\n--&gt; OK\npf.isRenderState()\n--&gt; false\npf.setRenderState true\n--&gt; OK\npf.isRenderState()\n--&gt; true\n--Get the viewport integration step\npf.getIntegrationStep()\n--&gt; 1f\n--Get the update type - 0 means Complete!\npf.getUpdateType()\n--&gt; 0\n--Get the number of selected particles\npf.numParticlesSelected()\n--&gt; 0\n--Check if particle 1 is selected\npf.isParticleSelected 1\n--&gt; false\n--Get the number of selected Action Lists in the UI\npf.numActionListsSelected()\n--&gt; 0\n--In the UI, select the first Action List and try again:\npf.numActionListsSelected()\n--&gt; 1\n--Get the node of the Action List you just selected:\npf.getSelectedActionList 1\n--&gt; $Event:Event 01 @ [0.000000,0.000000,0.000000]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83383\"></a> <em class=\"strong\">This Interface is available in:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83384\"></a> <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source : GeometryClass</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83386\"></a> <span class=\"char_link\"><a href=\"GUID-B4D7BCE0-D4BC-48C8-8B0E-1513ED9BF43E.htm\">Particle Flow Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";