var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-679F210A-C719-4BB7-BA8C-AAC8BB863AC4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Limitations on using MAXScript with Particle Flow\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Limitations on using MAXScript with Particle Flow</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-679F210A-C719-4BB7-BA8C-AAC8BB863AC4\"></a><div class=\"head\">\n            <h1>Limitations on using MAXScript with Particle Flow </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C30\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C34\"></a>MAXScript can be used in the Every Step and Final Step scripts of the <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source</a></span> and in the Scripted Actions &amp;endash; <span class=\"char_link\"><a href=\"GUID-BF55A04D-AED5-4948-A837-8D3E2C7E82DE.htm\">Birth_Script</a></span>, <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span> and <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test</a></span>.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C35\"></a>These scripts are executed very often and in a very special environment, for example,\n               during rendering. This is why it is not possible to use all MAXScript commands with\n               <em class=\"strong\">Particle Flow</em>.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C36\"></a> <em class=\"strong\">Here are some known limitations:</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E82C37\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C39\"></a>You <em class=\"strong\">cannot</em> reset <em class=\"strong\">3ds Max</em> from inside a <em class=\"strong\">Particle Flow</em> script.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C3B\"></a>You <em class=\"strong\">cannot</em> create a new <em class=\"strong\">3ds Max</em> scene.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C3D\"></a>You <em class=\"strong\">cannot</em> open an existing.MAX file.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C3F\"></a>You <em class=\"strong\">cannot</em> merge a MAX file with the current scene.\n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128F27532E82C40\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C42\"></a>You <em class=\"strong\">cannot</em> create or delete <em class=\"strong\">Particle Flow</em> Operators.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C44\"></a>You <em class=\"strong\">cannot</em> excessively create objects during the evaluation of <em class=\"strong\">Particle Flow</em> scripts (for example inside the <em class=\"strong\">on Proceed</em> method).\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C46\"></a>You <em class=\"strong\">cannot</em> delete objects from inside a <em class=\"strong\">Particle Flow</em> script.\n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C48\"></a>The MAXScript <span class=\"code\"> <em class=\"strong\">snapshot as mesh</em> </span> method should not be used during render time (like in the Proceed method), or all\n                     objects that the shapshot as mesh method is used upon should be hidden during render,\n                     otherwise a crash will occur.\n                  </p> \n               </li>\n            </ul> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FFB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>There are techniques allowing the creation of a <em class=\"strong\">limited</em> number of new objects as shown in the <span class=\"char_link\"><a href=\"GUID-A968E741-4D24-4286-B3D0-1FDDE49B6ABE.htm\">Fragmentation script example</a></span>.\n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C4E\"></a> <span class=\"char_link\"><a href=\"GUID-B63E19A0-DD0A-4B95-BBBD-3D41894C49BE.htm\">Particle Flow and MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82C4F\"></a> <span class=\"char_link\"><a href=\"GUID-5E6797AF-920E-4DB4-A0BD-0AD336CF7827.htm\">Using MAXScript with Particle Flow</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";