var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Access to Custom Attributes Virtual Array\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Access to Custom Attributes Virtual Array</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0\"></a><div class=\"head\">\n            <h1>Access to Custom Attributes Virtual Array </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-494C\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-494B\"></a> Custom attributes in MAXScript can now be applied to any type of MAX object, including\n               nodes and the scene rootnode. However, the rollouts associated with the custom attributes\n               will only be displayed for materials, modifiers, and base objects. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4949\"></a>A \n               		  <span class=\"code\"> <em class=\"strong\">.custAttributes</em> </span> property has been added to MAXWrapper in \n               		  <em class=\"strong\">3ds Max 5.1</em>. It contains a virtual array of the custom attributes assigned to the object. Standard\n               array methods and operations can be performed on this virtual array, with the exception\n               of \n               		  <span class=\"code\"><em class=\"strong\">join</em></span> and \n               		  <span class=\"code\"><em class=\"strong\">sort</em></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4948\"></a>The class of the virtual array is \n               		  <span class=\"code\"> <em class=\"strong\">MSCustAttribArray</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4947\"></a> <em class=\"strong\">Supported operations are:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22D5\"></a><pre><em class=\"codeEmphasisStrong\">findItem</em> &lt; MSCustAttribArray &gt; &lt; cust_attrib &gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4945\"></a>Find the given custom attribute in the supplied virtual array. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22D4\"></a><pre>&lt; MSCustAttribArray &gt; [&lt; integer &gt; | &lt; cust_attrib_name &gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4942\"></a>Get a custom attribute by index or name. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22D3\"></a><pre>&lt; MSCustAttribArray &gt; [&lt; integer &gt; | &lt; cust_attrib_name &gt;] = &lt; cust_attrib &gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-493F\"></a>Set a custom attribute by index or name. \n               		\n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F56\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p>NULL/undefined values cannot be stored in a MSCustAttribArray, so if you perform an\n                     indexed write where the index is greater than the number of existing custom attributes,\n                     the custom attribute will be appended to the MSCustAttribArray. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22D2\"></a><pre><em class=\"codeEmphasisStrong\">append</em> &lt; MSCustAttribArray &gt; &lt; cust_attrib &gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4939\"></a>Add a custom attribute to the end of the virtual array. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22D1\"></a><pre><em class=\"codeEmphasisStrong\">deleteItem</em> &lt; MSCustAttribArray &gt; (&lt; cust_attrib &gt; | &lt; cust_attrib_name &gt;) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4936\"></a>Delete a custom attribute from the virtual array by providing the custom attribute\n               or its name. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4935\"></a>You can also map across the MSCustAttribArray. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;MSCustAttribArray&gt;.<em class=\"codeEmphasisStrong\">owner</em></pre></div> \n            <p> Returns the owner of this custom attribute array. Available in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>.\n               		\n            </p> <a name=\"TABLE_6FC324A9FD16482E88A1B6427B9A559D\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">For Example\n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>t = teapot()\ncac = t.baseobject.custAttributes\no = cac.owner\n--&gt; Teapot \no == t\n--&gt; true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4934\"></a> <em class=\"strong\">Next Topic:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4933\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4931\"></a> <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Scripted Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4930\"></a> <span class=\"char_link\"><a href=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7.htm\">Adding Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-492F\"></a> <span class=\"char_link\"><a href=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4.htm\">Global and Private Custom Attributes Definitions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-492E\"></a> <span class=\"char_link\"><a href=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559.htm\">Custom Attribute Management Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-492D\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";