var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6A28F484-B4D7-4C62-BA6B-29EB562CEBAE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"BlendedBoxMap\">\n      <meta name=\"indexterm\" content=\"BlendedBoxMap\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <meta name=\"keywords\" content=\" Blended Box Map &#xA;&#x9;&#x9;  \">\n      <meta name=\"keyword\" content=\" Blended Box Map &#xA;&#x9;&#x9;  \">\n      <title>BlendedBoxMap: TextureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6A28F484-B4D7-4C62-BA6B-29EB562CEBAE\"></a><div class=\"head\">\n            <h1>BlendedBoxMap: TextureMap</h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-439E\"></a><pre><em class=\"codeEmphasisStrong\">BlendedBoxMap – superclass: textureMap; super-superclass:material – classID: #(334310678, 1815100752)</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7325\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7326\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap</a></span> &gt; BlendedBoxMap \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>The BlendedBoxMap texture map allows you to project maps onto one or more objects.\n            It projects images from three 90 degree directions. You can project 1, 3, or 6 different\n            maps for each side of the projection box. You can also customize the way the images\n            are blended. Available in \n            		<em class=\"strong\">3ds Max 2017.1 Update and higher</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7328\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-439D\"></a><pre><em class=\"codeEmphasisStrong\">BlendedBoxMap</em>... 	 </pre></div>\n         <p> </p><a name=\"TABLE_9CAFBDDB409C4635A41575E5CD6325F5\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">Example \n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- Example creation:\ns = Sphere()\nmat = StandardMaterial()\nmat.name = \"MyStandard\"\ns.material=mat\nbbm = BlendedBoxMap()\nmat.diffuseMap = bbm\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C732B\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-439C\"></a><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">mode</em> Integer default: 1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C732D\"></a>The number of projections used by the BlendedBoxMap, where: \n            	 \n         </p><a name=\"UL_8BB74675C33748B3A326F74252AD13A7\"></a><ul>\n            <li>0 = 1 projection \n               		\n            </li>\n            <li> 1 = 3 projections \n               		\n            </li>\n            <li>2 = 6 projections \n               		\n            </li>\n         </ul>\n         <p>This property corresponds to the \n            		<span class=\"MenuCascade\">Number of Projections</span> radio button. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.colors : RGB color array default:\n#((color 0 0 255), (color 255 0 0), (color 0 255 0), (color 255\n255 0), (color 255 0 255), (color 0 255 255))</pre></div>\n         <p> </p>\n         <p>An array of colors for the BlendedBoxMap projections. Note that while the \n            		<em class=\"strong\">mode</em> property or UI may be set to 1 or 3 projections, this array always contains 6 members.\n            \n            	 \n         </p>\n         <p>This array corresponds to the color selectors under the \n            		<em class=\"strong\">Maps</em> section of the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">tex</em> (SubMat0) : texturemap array default:\n#(undefined…)</pre></div>\n         <p>An array of texturemaps for the projections. This array contains seven items. The\n            first six are the individual projection maps, and the seventh is the blend map. \n            	 \n         </p>\n         <p>This array corresponds to the map selectors under the \n            		<em class=\"strong\">Maps</em> section of the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">MapEnable</em> : Boolean array\ndefault:\n#(true, true, true, true, true, true, false)</pre></div>\n         <p> </p>\n         <p>An array of Boolean values indicating whether the associated map is enabled. The first\n            six are the individual projection maps, and the seventh is the blend map. \n            	 \n         </p>\n         <p>This array corresponds to the checkboxes next to the color and map selectors under\n            the \n            		<em class=\"strong\">Maps</em> section of the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">mapscale</em> : float default: 100.0</pre></div>\n         <p>The percentage scaling value, applied to all maps. \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Map Scale</em> spinbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">blend</em> : float default: 25.0</pre></div>\n         <p>The percentage amount of blend between each projection. \n            	 \n         </p>\n         <p>This corresponds to the \n            		<em class=\"strong\">Blend Amount</em> spinbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">blendMapStrength</em> : float default: 25.0</pre></div>\n         <p>The percentage amount of blend with the BlendMap, which is the \n            		<em class=\"strong\">tex</em>[7] map. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">texturespace</em> : integer</pre></div>\n         <p> The projection method that will be used, where: \n            	 \n         </p><a name=\"UL_64665A3C2E294F41A0117E355D1C716D\"></a><ul>\n            <li>0 = Individual Objects \n               		\n            </li>\n            <li>1 = Multiple Objects at Once \n               		\n            </li>\n            <li>2 = Auto \n               		\n            </li>\n         </ul>\n         <p>This corresponds to the \n            		<em class=\"strong\">Project Onto</em> combobox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">node</em> (Object) : node</pre></div>\n         <p> The node used to control projection when in Multiple Objects at Once texture space.\n            If this node is not set to a valid scene node, a default projection and bounding box\n            is used. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Randomize Projection Properties</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">FORSeed</em> : integer</pre></div>\n         <p>The seed used to initialize the pseudo-random number generator for the Randomize Projection\n            settings. This property corresponds to the \n            		<em class=\"strong\">Seed</em> setting in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">randx</em> : Boolean \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">randy</em> : Boolean \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">randz</em> : Boolean</pre></div>\n         <p>Indicates whether to randomize the projection on the X, Y, and Z axes. \n            	 \n         </p>\n         <p>These properties correspond to the \n            		<em class=\"strong\">Randomize Axis</em> checkboxes in the UI. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Map Transform Properties</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">useRandom</em> : Boolean default: False</pre></div>\n         <p>Indicates whether the map transform parameters are generated randomly, between the\n            minimum and maximum specified values, or are specified as static values. \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Use Random Values</em> checkbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">seed</em> : integer default: 12345</pre></div>\n         <p>The seed value used to initialize the pseudo-random number generator when \n            		<em class=\"strong\">useRandom</em> is True. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">posu</em> : float default: 0.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">posu2</em> : float default: 0.0</pre></div>\n         <p>The Position U and V values, or if \n            		<em class=\"strong\">useRandom</em> is True, the minimum random value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">posv</em> : float \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">posv2</em> : float default: 0.0</pre></div>\n         <p>The Position U and V values, or if \n            		<em class=\"strong\">useRandom</em> is True, the maximum random value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">posLock</em> : Boolean default: False</pre></div>\n         <p>Indicates whether the Position V is locked to match the Position U. When True, the\n            values for \n            		<em class=\"strong\">posu</em> and \n            		<em class=\"strong\">posu2</em> are used, and \n            		<em class=\"strong\">posv</em> and \n            		<em class=\"strong\">posv2</em> are ignored. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rota</em> : float default: 0.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rotb</em> : float default: 0.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rotc</em> : float default: 0.0</pre></div>\n         <p>The Rotation T/B, L/R and F/B values, or if \n            		<em class=\"strong\">useRandom</em> is True, the minimum random values. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rota2</em> : float default: 0.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rotb2</em> : float default: 0.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rotc2</em> : float default: 0.0</pre></div>\n         <p>The Rotation T/B, L/R, and F/B maximum random values. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">rotLock</em> : Boolean default: False</pre></div>\n         <p>Indicates whether all offsets are locked to the Rotation T/B values. When True, only\n            the values from \n            		<em class=\"strong\">rota</em> and \n            		<em class=\"strong\">rota2</em> are used. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">scaleu</em> : float default: 100.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">scalev</em> : float default: 100.0</pre></div>\n         <p>The Scale U and V values, or if \n            		<em class=\"strong\">useRandom</em> is True, the minimum random value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">scaleu2</em> : float default: 100.0 \n&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">scalev2</em> : float default: 100.0</pre></div>\n         <p>The Scale U and V maximum random values. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">scaleLock</em> : Boolean default: False</pre></div>\n         <p>Indicates whether the Scale V values are locked to the Scale U values. When true,\n            both values are taken from \n            		<em class=\"strong\">scaleu</em> and \n            		<em class=\"strong\">scaleu2</em>. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Render Projection Templates</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">renderResolution</em> : Integer\ndefault:1024</pre></div>\n         <p>The Resolution Maximum Value. \n            	 \n         </p>\n         <div><a name=\"GUID-EC13A33C-7CFC-45FE-BB22-391B466A34F0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The projection template file and the \n               		<em class=\"strong\">Render</em> button are exposed by the \n               		<span class=\"code\">BlendedBoxMap</span> interface; see below for the methods that access this functionality. \n               	 \n            </div>\n         </div>\n         <p> </p>\n         <p><em class=\"strong\">Projection Properties</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">cube</em> : Boolean default: False</pre></div>\n         <p>Indicates whether the projection is projected as a cube. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">cubeMode</em> : Integer default: 0</pre></div>\n         <p>The cube projection mode where: \n            	 \n         </p><a name=\"OL_5221FC8E98BE4A8082E3442D00D95DAA\"></a><ul>\n            <li> 0 = Non-Uniform \n               		\n            </li>\n            <li> 1 = Uniform - Picked \n               		\n            </li>\n            <li> 2 = Uniform - Size \n               		\n            </li>\n            <li> 3 = Uniform - Largest \n               		\n            </li>\n         </ul>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Cube</em> dropdown in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">cubeSize</em> : Integer default: 100</pre></div>\n         <p>The cube projection size, when the \n            		<em class=\"strong\">cubeMode</em>=2 (Uniform - Size). \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Cube</em> size spinbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">cubeNode</em> : node default: Undefined</pre></div>\n         <p>The cube projection node, when the \n            		<em class=\"strong\">cubeMode</em> = 1 (Picked). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">lockToFrame</em> : Boolean default: False</pre></div>\n         <p>Indicates whether the projection is locked to a frame, indicated by \n            		<em class=\"strong\">lockFrame</em>. \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Lock to Frame</em> checkbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">lockFrame</em> : Integer default: 0</pre></div>\n         <p>The frame the projection is locked to, if \n            		<em class=\"strong\">lockToFrame</em> is True. \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Lock to Frame</em> spinbox in the UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;BlendedBoxMap&gt;.<em class=\"codeEmphasisStrong\">coords</em> (Coordinates) : StandardXYZGen</pre></div>\n         <p>An object that represents the Coordinate settings for the Blended Box Map. See StandardXYZGen\n            for the exposed properties. \n            	 \n         </p>\n         <p> </p>\n         <p> </p>\n         <p><em class=\"strong\">BlendedBoxMap Interfaces</em> \n         </p>\n         <div class=\"codeBlock\"><pre>Interface: BlendedBoxMap</pre></div>\n         <p>This interface provides access to the Render Projection Templates for the Blended\n            Box Map feature. This feature creates images that can be used to paint. \n            	 \n         </p>\n         <p> <em class=\"strong\">Properties</em>: \n            	 \n         </p>\n         <p>None \n            	 \n         </p>\n         <p> </p>\n         <p> <em class=\"strong\">Methods</em>: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">Render</em>()</pre></div>\n         <p>Triggers a template render for the BlendedBoxMap. Returns False if the render cannot\n            be performed (for example, if no render output path is specified), otherwise True.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">GetBaseFileName</em> &lt;&amp;TSTR&gt;fname \n  Fname is out parameter</pre></div>\n         <p>Gets the Render Projection Templates output path and base filename for the specified\n            BlendedBoxMap. \n            	 \n         </p>\n         <p>For example: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>str = \"\"\ndiffuseMap.GetBaseFilename &amp;str</pre></div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">SetBaseFilename</em> &lt;TSTR&gt;fname</pre></div>\n         <p>Sets the Render Projection Templates output directory and base filename for the BlendedBoxMap.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>-- create blended boxmap teapot and render\nt = teapot()\nmat = StandardMaterial()\nt.material = mat\nbbm = BlendedBoxMap()\nmat.diffuseMap = bbm\nbbm.SetBaseFilename \"C:\\\\maps\\\\teapot.jpg\"\nbbm.Render()</pre></div>\n         <p>Setting this base filename with a six-projection Blended Box Map will result in the\n            following files when the \n            		<span class=\"code\">Render()</span> method is used: \n            	 \n         </p><a name=\"UL_DEDDDE3E2C6044E39E39098F8FA5FF28\"></a><ul>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Top.jpg</span> \n            </li>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Bottom.jpg</span> \n            </li>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Left.jpg</span> \n            </li>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Right.jpg</span> \n            </li>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Front.jpg</span> \n            </li>\n            <li><span class=\"filePath\">C:\\maps\\teapot_Back.jpg</span> \n            </li>\n         </ul>\n         <p> </p>\n         <p> <em class=\"strong\">Actions</em>: \n            	 \n         </p>\n         <p>None \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";