var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6AC542FD-A91B-4F32-89DD-56A9E1B118E3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Smooth Brushes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6AC542FD-A91B-4F32-89DD-56A9E1B118E3\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Smooth Brushes </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27A8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27A9\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Smooth Brushes \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27AB\"></a>In this step of the Bitmap Painting tool development, we will add optional smooth\n            falloff to the brush. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27AD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27AE\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27AF\"></a><p class=\"table-body\">We will add a new item to the brushes listbox. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27B0\"></a><p class=\"table-body\">We will extend the paintbrush function with a new case calculating the new color using\n                        the existing one and a falloff based on the pixel\'s distance to the center of the\n                        brush. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27B2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27B3\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6400\"></a><pre>\nmacroScript MicroPaint category: \"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry (destroyDialog MicroPaint_CanvasRollout) catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n  bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n  colorpicker inkColor height:16 modal:false color:black across:4\n  checkbutton airBrush \"AirBrush\"width:50\n  spinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:30\n  spinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40\n  listbox BrushShape items:#(\"Circle\",\"Box\",\"Circle Smooth\") pos:[bitmapX+5,0] width:90\n&nbsp;\n  fn paintBrush pos =\n  (\n    case BrushShape.selection of\n    (\n      1: (\n        if distance pos currentPos &lt;= BrushSize.value/2 do\n          setPixels theCanvasBitmap pos #(inkColor.color)\n      )\n      2: setPixels theCanvasBitmap pos #(inkColor.color)\n      3: (\n        theFactor = (distance pos currentPos) / (BrushSize.value/2.0)\n        if theFactor &lt;= 1.0 do\n        (\n          theFactor = sin ( 90.0 * theFactor)\n          thePixels = getPixels theCanvasBitmap pos 1\n          if thePixels[1] != undefined do\n          (\n            thePixels[1] = (thePixels[1] * theFactor) + (inkColor.color * (1.0 - theFactor))\n            setPixels theCanvasBitmap pos thePixels\n          )\n        )\n      )--end case 3\n    )--end case\n  )--end fn\n&nbsp;\n  fn drawStroke lastPos pos =\n  (\n    currentPos = lastPos\n    deltaX = pos.x - lastPos.x\n    deltaY = pos.y - lastPos.y\n    maxSteps = amax #(abs(deltaX),abs(deltaY))\n    deltaStepX = deltaX / maxSteps\n    deltaStepY = deltaY / maxSteps\n    for i = 0 to maxSteps do\n    (\n      if airBrush.checked then\n      (\n        for b = 1 to (BrushSize.value / AirBrushSpeed.value) do\n        paintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n      )\n      else\n        for b = -BrushSize.value/2 to BrushSize.value/2 do\n          for c = -BrushSize.value/2 to BrushSize.value/2 do\n            paintBrush (currentPos + [c,b])\n      currentPos += [deltaStepX, deltaStepY]\n    )\n    theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n  on MicroPaint_CanvasRollout lbuttondown pos do\n  (\n    lastPos = pos\n    isDrawing = true\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\n  on MicroPaint_CanvasRollout mousemove pos do\n  (\n    if isDrawing do drawStroke lastPos pos\n    lastPos = pos\n  )\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2809\"></a> \n            <h2><a name=\"GUID-445B3677-9C52-4D60-9137-83F979CA379B\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FF\"></a><pre><em class=\"codeEmphasisMild\"><em class=\"codeEmphasisStrong\">--Code in italic has no changes since the previous version.</em></em> <em class=\"codeEmphasisMild\">macroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog CanvasRollout)catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\nbitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\ncolorpicker inkColor height:16 modal:false color:black across:4\ncheckbutton airBrush \"AirBrush\" width:50\nspinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:40\nspinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40\n</em> <em class=\"codeEmphasisStrong\">listbox BrushShape items:#(\"Circle\", \"Box\", \"Circle Smooth\") pos:[bitmapX+5,0] width:90</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC281E\"></a>We add a new brush to our \"toolbox\" - \"Circle Smooth\". \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FE\"></a><pre>fn paintBrush pos =\n(\ncase BrushShape.selection of\n(\n1: (\nif distance pos currentPos &lt;= BrushSize.value/2 do\nsetPixels theCanvasBitmap pos #(inkColor.color)\n)\n2: setPixels theCanvasBitmap pos #(inkColor.color)\n&nbsp;\n<em class=\"codeEmphasisStrong\">3: (</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC282B\"></a>When the \"Circle Smooth\" brush is selected, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FD\"></a><pre><em class=\"codeEmphasisStrong\">theFactor =(distance pos currentPos)/ (BrushSize.value/2.0)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC282D\"></a>we calculate the distance from the pixel to be drawn to the center of the brush and\n               divide by the radius of the brush. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FC\"></a><pre><em class=\"codeEmphasisStrong\">if theFactor &lt;= 1.0 do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2830\"></a>If the result is less than 1.0, the pixel lies inside the circle. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FB\"></a><pre><em class=\"codeEmphasisStrong\">theFactor = sin ( 90.0 * theFactor)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2832\"></a>In that case, we multiply the value by 90 and use the Sine function to calculate a\n               nice falloff curve. Note that remarking this line gives you a linear falloff curve\n               instead of the sine-based falloff curve. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63FA\"></a><pre><em class=\"codeEmphasisStrong\">thePixels = getPixels theCanvasBitmap pos 1</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2834\"></a>Next, we read a single pixel from the position we are about to write to. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63F9\"></a><pre><em class=\"codeEmphasisStrong\">if thePixels[1] != undefined do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2837\"></a>If the single pixel in the array is a valid color, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63F8\"></a><pre><em class=\"codeEmphasisStrong\">thePixels[1] = (thePixels[1] * theFactor) + (inkColor.color * (1.0 - theFactor))</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2839\"></a>we blend the color of the background with the brush color based on the distance factor.\n               If the factor is 0.5, the two colors will be blended 50-50%. If the factor is 1 (at\n               the edge of the circle, the background color will be used 100% and the ink will be\n               0%. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63F7\"></a><pre><em class=\"codeEmphasisStrong\">setPixels theCanvasBitmap pos thePixels</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC283B\"></a>Finally, we write the color back into the bitmap. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63F6\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\n)\n)&nbsp;&nbsp;\n)\n)</em>\n&nbsp;\n<em class=\"codeEmphasisMild\">\nfn drawStroke lastPos pos =\n(\ncurrentPos = lastPos\ndeltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y\nmaxSteps = amax #(abs(deltaX),abs(deltaY))\ndeltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps\nfor i = 0 to maxSteps do\n(\nif airBrush.checked then\n(\nfor b = 1 to (BrushSize.value / AirBrushSpeed.value) do\npaintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n)\nelse\nfor b = -BrushSize.value/2 to BrushSize.value/2 do\nfor c = -BrushSize.value/2 to BrushSize.value/2 do\npaintBrush (currentPos + [c,b])\ncurrentPos += [deltaStepX, deltaStepY]\n)&nbsp;\ntheCanvas.bitmap = theCanvasBitmap\n)\n\non MicroPaint_CanvasRollout lbuttondown pos do\n(\nlastPos = pos\nisDrawing = true\ndrawStroke lastPos pos\n)\non MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\non MicroPaint_CanvasRollout mousemove pos do\n(\nif isDrawing do drawStroke lastPos pos\nlastPos = pos\n)\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30)\n)</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC286A\"></a> <em class=\"strong\">Result</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC286B\"></a> <img src=\"../images/GUID-12EBE87A-1379-4F63-BD1F-2A497503DBD9-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC286D\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC286E\"></a> <span class=\"char_link\"><a href=\"GUID-78460DD3-5FA4-4F68-990A-54D8D6092802.htm\">How To ... Develop a Bitmap Painting Tool - Airbrush and Shapes</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC286F\"></a> <em class=\"strong\">Next Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2870\"></a> <span class=\"char_link\"><a href=\"GUID-2A734060-09D6-44CE-A0B1-6E7094C03AC3.htm\">How To ... Develop a Bitmap Painting Tool - Load and Save</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2872\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";