var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6E1C44F4-81C0-400F-9558-E565E1F77D36\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"By-Reference parameter passing\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>By Reference Parameter Passing</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6E1C44F4-81C0-400F-9558-E565E1F77D36\"></a><div class=\"head\">\n            <h1>By Reference Parameter Passing </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E873D5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873D6\"></a> MAXScript supports by-reference parameter passing. This allows a reference to be passed\n               to a variable, property, or array element in the caller\'s context as a parameter to\n               a function and any assignments to that parameter in the called function is assigned\n               directly to the caller\'s variable, property, or array element. This is often used\n               as a mechanism for passing multiple results back from a function. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873D8\"></a>To define by-reference parameters for a function, you need to prefix them with an\n               \'<em class=\"strong\">&amp;</em>\' character. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873D9\"></a> <em class=\"strong\">System Exception Note:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873DA\"></a>The following example is an error: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873DB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873DC\"></a><p class=\"table-body\"> <em class=\"strong\">ERROR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6097\"></a><pre>\nfn test1 &amp;p3 = return &amp;p3.x\np=[1,2,3]\nr=test1 p\n*r\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873E3\"></a> <em class=\"strong\">Result: access violation!</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E873E4\"></a>It is <em class=\"strong\">an error</em> to pass back a reference to a local that has gone from the call stack, but it is\n               very difficult to detect this efficiently. Be careful <span class=\"code\"> <em class=\"strong\">not to pass back &amp;refs</em> </span> to local variables as it might cause system exceptions. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873E5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873E6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6096\"></a><pre>\nfunction foo x y &amp;z =\n(\n-- ...\nz = x * y\n-- ...\nreturn true\n)\n-- test function\nz = 12\nfoo 5 6 &amp;z\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873F0\"></a><p class=\"table-body\">Declares a function taking three parameters, x, y and z. The <span class=\"code\"> <em class=\"strong\">&amp;z</em> </span> in the parameter list indicates the z parameter is to be passed by-reference. To\n                           call this function, you provide a reference value for the z parameter using the new\n                           \'<em class=\"strong\">&amp;</em>\' reference operator. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6095\"></a><pre>\nlocal var1, var2\n...\nvar1 = foo 2 3 &amp;var2\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873F6\"></a><p class=\"table-body\">The above example calls the foo function with the arguments 2, 3 and <span class=\"code\"> <em class=\"strong\">&amp;var2</em> </span>. The <span class=\"code\"> <em class=\"strong\">&amp;var2</em> </span> is a reference to the var2 local variable. When the function is called, the z parameter\n                           in the body is a reference to <span class=\"code\"> <em class=\"strong\">var2</em> </span> local in the caller, and the \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6094\"></a><pre>\nz = x * y\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873FA\"></a><p class=\"table-body\">in the body of foo will cause x * y to be assigned to the <span class=\"code\"> <em class=\"strong\">var2</em> </span> local in the caller. After \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6093\"></a><pre>\nvar1 = foo 2 3 &amp;var2\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E873FE\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">var1</em> </span> will contain <span class=\"code\"> <em class=\"strong\">true</em> </span> and <span class=\"code\"> <em class=\"strong\">var2</em> </span> will contain <span class=\"code\"> <em class=\"strong\">x * y</em> </span> or <span class=\"code\"> <em class=\"strong\">6</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87400\"></a>Any number of by-reference parameters can be used and they can be keyword parameters\n               if needed: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87401\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6092\"></a><pre>\nfn foo x y &amp;z: = ...\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87405\"></a><p class=\"table-body\">called like this: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6091\"></a><pre>\nvar1 = foo 2 3 <em class=\"codeEmphasisStrong\">z:&amp;var2</em> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8740A\"></a>The \'<span class=\"code\"> <em class=\"strong\">&amp;</em> </span>\' reference operator used to supply references in a call can be applied to any &lt;accessor&gt;\n               construct in MAXScript. These are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6090\"></a><pre>\nvariables (locals, globals, rollout locals, plug-in locals, etc.)\nproperty access\narray index\nparameter (of a scripted plug-in)\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8740F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87410\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608F\"></a><pre>\np = [1, 2, 3]\nfoo 2 3 &amp;p.x\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87415\"></a><p class=\"table-body\">would cause the x coordinate in the point to be passed by-reference and so after the\n                           call, the value in p would be \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608E\"></a><pre>\n[6, 2, 3]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87419\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8741A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608D\"></a><pre>\na = #(1, 2, 3, 4, 5)\nfoo 2 3 &amp;a[3]\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8741F\"></a><p class=\"table-body\">would cause the 3rd element in the array to be passed by-reference and so after the\n                           call, the value in a would be #(1, 2, 6, 4, 5) \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1934\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"P_1139B110CD8E415093F47937F52BEF42\"></a>This mechanism is used by the Function Publishing interface in MAXScript to support\n                     BY-REF interface method parameters and results. Any parameter defined as by-ref (or\n                     with a type code suffix _BR) in the published interface, requires an \'&amp;\' reference\n                     value. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87426\"></a> <span class=\"char_link\"><a href=\"GUID-059672B5-A234-438C-8A80-F5CC6C3BE936.htm\">Dereferencing Operator</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87427\"></a> <span class=\"char_link\"><a href=\"GUID-15EBBE7C-3ADD-4A28-96E7-B9FE47072004.htm\">Visible Class For \'&amp;\' Reference Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";