var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"defining\">\n      <meta name=\"indexterm\" content=\"macroScript\">\n      <meta name=\"indexterm\" content=\"macro scripts\">\n      <meta name=\"indexterm\" content=\"macros struct\">\n      <meta name=\"indexterm\" content=\"run() - macros\">\n      <meta name=\"indexterm\" content=\"new() - macros\">\n      <meta name=\"indexterm\" content=\"load() - macros\">\n      <meta name=\"indexterm\" content=\"edit() - macros\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Defining Macro Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055\"></a><div class=\"head\">\n            <h1>Defining Macro Scripts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5881\"></a>    <em class=\"strong\">MacroScripts</em> are scripts that are associated with Customize User Interface ActionItems (toolbar\n            buttons, Menu or QuadMenu items, and keyboard shortcuts) and are executed when the\n            corresponding ActionItem is invoked. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-587D\"></a>MacroScripts have to be defined with the \n            		<span class=\"code\"> <em class=\"strong\">macroScript</em> </span> definition construct and can then be associated with a toolbar button by right-clicking\n            a Shortcut toolbar or Tab and choosing Customize. The Customize User Interface dialog\n            is displayed, which lets you choose from either Command shortcuts or MacroScripts.\n            MacroScripts are essentially pieces of MAXScript code that have a name and category,\n            and optionally a tooltip and icon. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-587C\"></a>MacroScripts do not automatically create user interface items. If you want a MacroScript\n            to display a dialog, you need to create a rollout floater window and rollout(s) as\n            described in \n            		<span class=\"char_link\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm\">Rollout Floater Windows</a></span>, and create and install the user-interface items in the rollout(s) as described in\n            \n            		<span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-587B\"></a> <em class=\"strong\">A MacroScript is defined using the following syntax: \n               		</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7282\"></a><pre><em class=\"codeEmphasisStrong\">macroScript</em> &lt;name&gt; \n[<em class=\"codeEmphasisStrong\">category</em>:&lt;string&gt;] \n[<em class=\"codeEmphasisStrong\">buttonText</em>:&lt;string&gt;] \n[<em class=\"codeEmphasisStrong\">toolTip</em>:&lt;string&gt;] \n[<em class=\"codeEmphasisStrong\">icon</em>:#(&lt;string&gt;, &lt;index&gt;) | <em class=\"codeEmphasisStrong\">iconName</em>:&lt;string&gt;] \n[<em class=\"codeEmphasisStrong\">silentErrors</em>:&lt;boolean&gt;] \n[<em class=\"codeEmphasisStrong\">autoUndoEnabled</em>:boolean&gt;] \n(&lt;macro_script_body&gt;)</pre></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5877\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5876\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7281\"></a><pre>\nmacroScript Free_Camera category:\"Cameras\" tooltip:\"Free Camera\"\nIcon:#(\"Cameras\",2)\n(\n  StartObjectCreation FreeCamera\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7280\"></a><pre>\nmacroScript Target_Camera category:\"Cameras\"\ntooltip:\"Targeted Camera\" Icon:#(\"Cameras\",1)\n(\n  StartObjectCreation TargetCamera\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-1C1147E6-86D9-476E-B4BB-1EAA7186609D\"></a>Since \n            		<em class=\"strong\">3ds Max 2011</em>, the strings defining the name properties of the MacroScript definition can be replaced\n            with localized Resources strings whose definitions are enclosed in tildes. Please\n            see the \n            		<span class=\"char_link\"><a href=\"GUID-4E926577-61C6-463E-9238-D422EFC03718.htm\">Resources String Replacement topic</a></span> for details. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5867\"></a>After MAXScript evaluates a \n            		<span class=\"code\"> <em class=\"strong\">macroScript</em> </span> construct, the MacroScript definition shows up in the appropriate category list in\n            the Customize User-Interface dialog. The following figure shows a Customize User Interface\n            dialog containing the previous two MacroScripts. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5866\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-214A2746-EF3D-436C-8DE4-9F65752957AB-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5865\"></a>If a tooltip is specified, that tooltip is the name shown in the Customize User Interface\n            dialog. If a tooltip is not specified, \n            		<span class=\"code\">&lt;name&gt;</span> is the name shown. Unlike other similar constructs (Scripted Utilities, Functions,\n            and right-click menus), \n            		<span class=\"code\"> <em class=\"strong\">macroScript</em> </span> does not create a variable with this name. Rather, MacroScripts are stored as pointers\n            into files, as described below. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75CB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-3135294D-B64F-463C-B79F-50CC0C6D214B\"></a>You can use non-alpha numeric characters to define any of the argument strings. This\n                  includes support for escaped double quote characters: \\\". \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5860\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">category:</em> </span> argument specifies in which category of the Customize User-Interface dialog the MacroScript\n            name is listed. The use of categories is intended to help you organize your MacroScripts\n            into groupings so that the MacroScript names are less likely to clash. If you do not\n            specify a category, a default category of \"unknown\" is used. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585F\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">internalCategory</em> </span> argument is intended to identify operations in \n            		<em class=\"strong\">.cui</em>, \n            		<em class=\"strong\">.mnu</em>, and \n            		<em class=\"strong\">.kbd</em> files. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585E\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">toolTip:</em> </span> argument specifies the tooltip for the button. If no tooltip is specified, \n            		<span class=\"code\">&lt;name&gt;</span> is displayed for the button. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585D\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">buttonText:</em> </span> argument specifies the text that appears in the button, and the \n            		<span class=\"code\"> <em class=\"strong\">icon:</em> </span> argument specifies the icon that appears in the button. You can choose in the Customize\n            User Interface dialog whether the \n            		<span class=\"code\"> <em class=\"strong\">buttonText</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">icon</em> </span> appears in the button. If no \n            		<span class=\"code\"> <em class=\"strong\">buttonText:</em> </span> argument is specified, the MacroScript name is used as the \n            		<span class=\"code\"> <em class=\"strong\">buttonText</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5841\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">silentErrors:</em> </span> parameter controls whether the MAXScript runtime error messages are displayed while\n            executing the MacroScript. If this parameter is set to True , error messages are not\n            displayed. This is useful for distributed MacroScripts that might confuse the user\n            with MAXScript error messages. The default value is False. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-75B3\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">autoUndoEnabled:</em> </span> parameters controls whether the MacroScript body is automatically wrapped in a \n            		<span class=\"char_link\"><a href=\"GUID-17BFEAAF-3395-4FFB-9F98-54767481AB08.htm\">theHold</a></span> begin/accept calls internally. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5840\"></a>When set to False , the execution of the MacroScript body does not generate an undo\n            record for the whole MacroScript. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-583F\"></a>When set to True or not specified, the whole MacroScript body creates an undo record\n            when executed. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-583E\"></a>The default value is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-583D\"></a>Available in \n            		<em class=\"strong\">3ds Max 2010</em> and higher. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-583B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-583A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-727C\"></a><pre>\nMacroScript MacroScript_autoUndoEnabled_test1\ncategory:\"MacroScript_autoUndoEnabled_test\"\nbuttontext:\"test1\"\nautoUndoEnabled:false\n(\n  format \"test1\\n\"\n  format \"expecting theHold.holding == false, got: %\\n\" (theHold.holding())\n  format \"expecting theHold.IsSuspended == false, got: %\\n\" (theHold.IsSuspended())\n  format \"expecting theHold.Restoring == false, got: %\\n\" (theHold.Restoring())\n  format \"expecting theHold.Redoing == false, got: %\\n\" (theHold.Redoing())\n  format \"expecting theHold.RestoreOrRedoing == false, got: %\\n\" (theHold.RestoreOrRedoing())\n  format \"expecting theHold.SuperLevel == 0, got: %\\n\" (theHold.SuperLevel())\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_C793DB1ADD964056916D750C0DBD8F4E\"></a> \n            <h2><a name=\"GUID-1A5B3CBC-909F-4B83-BEB7-77F2E2C804D3\"></a>Icons\n            </h2> \n            <p>In \n               		  <em class=\"strong\">3ds Max 2017</em> a new method of loading icons was introduced to support high-DPI display scaling.\n               The \n               		  <span class=\"code\"><em class=\"strong\">iconName:</em></span> argument uses this method. This argument can specify an icon in one of these locations:\n               \n               		\n            </p> <a name=\"OL_057E57C3D28F4C57ADB0B5C7A3154DC5\"></a><ol type=\"1\" start=\"1\">\n               <li>Baseline 3ds Max icons located in the compiled resource files \n                  			 <span class=\"filePath\">IconsDark.rcc</span> and \n                  			 <span class=\"filePath\">IconsLight.rcc</span> (for the dark and light themes, respectively), located under \n                  			 <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\</span>. See the \n                  			 <em class=\"strong\">Icon Reference Guide</em> in the \n                  			 3ds Max Developer\'s Guide for full paths to these icons. All icons are loaded by 3ds Max on startup, and are\n                  referred to by \n                  			 <span class=\"filePath\">&lt;internal_path&gt;/&lt;base_name&gt;</span>, where \n                  			 <span class=\"code\">internal_path</span> is the path to the icon inside the rcc file (see the Icon Reference) and the \n                  			 <span class=\"code\">base_name</span> is the icon name minus the \n                  			 <span class=\"filePath\">_xx.png</span> suffix, where \n                  			 <em class=\"strong\">_xx</em> is the resolution of the icon. Typically 4 resolutions are supplied, and the system\n                  picks the best one for the current display resolution. \n                  		  \n               </li>\n               <li>Custom icons compiled into .rcc resource files placed in \n                  			 <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\Icons\\</span>. Any \n                  			 <span class=\"filePath\">.rcc</span> file found in this location is loaded by 3ds Max on startup. These files must be\n                  compiled with the Qt resource compiler; see \n                  			 <span class=\"char_link\"><a href=\"\">Qt RCC Compiler</a></span>. You should include both light and dark versions to support both themes, and four\n                  resolutions to support high-DPI displays. As with baseline icons, these are referred\n                  to by \n                  			 <span class=\"filePath\">&lt;internal_path&gt;/&lt;base_name&gt;</span>. For more information on creating your own .rcc files, see the \n                  			 <em class=\"strong\">Using Multi-Res Icons in Max and Qt</em> topic in the \n                  			 Developer\'s Guide. \n                  		  \n               </li>\n               <li>PNG files from disk located in the \n                  			 <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\Icons\\[Dark|Light]\\</span> - depending on the active theme (you need a copy of the icon in each location). For\n                  example, an icon with four resolutions (my_icon_24.png, my_icon_30.png, my_icon_36.png,\n                  my_icon_48.png) placed in both \n                  			 <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\Icons\\Dark\\MyIcons\\</span> and \n                  			 <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\Icons\\Light\\MyIcons\\</span> would be referred to in the macroScript as \n                  			 <span class=\"code\">iconName: \"MyIcons/my_icon\"</span>. \n                  			 <em class=\"strong\">Note: \n                     			 </em> <span class=\"filePath\">&lt;3ds Max&gt;\\UI_ln\\Icons\\[Dark|Light]\\</span> do not exist by default, you will have to create these directories. \n                  		  \n               </li>\n               <li>The location pointed to by \n                  			 <span class=\"code\">#userIcons</span>, and the current theme name under \n                  			 <span class=\"code\">#userIcons</span>, a directory named \"Light\" or \"Dark\". See \n                  			 <span class=\"char_link\"><a href=\"GUID-B501AD6E-091C-4357-B9BF-A6CDF88F42FC.htm\">3ds Max System Directories</a></span> for information about \n                  			 <span class=\"code\">#userIcons</span>. \n                  		  \n               </li>\n            </ol> \n            <p> </p> \n            <p>Prior to \n               		  <em class=\"strong\">3ds Max 2017</em>, the \n               		  <span class=\"code\"><em class=\"strong\">icon:</em></span> argument is used. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585C\"></a><em class=\"strong\">Note</em>: this is now considered a \"legacy\" method of specifying icons, and is supported for\n               backwards compatibility. As of \n               		  <em class=\"strong\">3ds Max 2017</em>, this method no longer supports \n               		  <span class=\"filePath\">.bmp</span> files, icons must be \n               		  <span class=\"filePath\">.png</span> format. \n               		\n            </p> \n            <p>The \n               		  <span class=\"code\"> <em class=\"strong\">icon:</em> </span> argument specifies the icon bitmap file and the icon image within the icon bitmap\n               file. The icon bitmap file must be located in the current \n               		  <em class=\"strong\">3ds Max</em> user-interface directory. Icon bitmap files have a base name such as, \"MyToolbar\",\n               followed by a suffix such as, \"_24i.bmp\" that specifies the individual icon size and\n               icon bitmap file type. The \n               		  <span class=\"code\"> <em class=\"strong\">icon:</em> </span> argument string is just the base name with no extensions. This base name is the name\n               shown in the Image Group list in the Customize User-Interface dialog. Each icon bitmap\n               file can have any number of individual icons, lined up side-by-side in the file. If\n               the icon bitmap file contains multiple icons, \n               		  <span class=\"code\">&lt;index&gt;</span> specifies which icon in the icon bitmap file to use. The left-most icon has an \n               		  <span class=\"code\">&lt;index&gt;</span> of 1. The \n               		  <em class=\"strong\">3ds Max</em> internal icons (Image Group Internal in the Customize User-Interface dialog) are\n               not stored in an icon file, and are referenced by using an empty string as the \n               		  <span class=\"code\"> <em class=\"strong\">icon:</em> </span> argument. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585B\"></a>So, the \n               		  <span class=\"code\"> <em class=\"strong\">icon:</em> </span> argument is a two-element array containing the icon bitmap file’s base name as a\n               string and the icon’s index in that file. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-585A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5859\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-727F\"></a><pre>\nmacroScript Box category:\"Objects\" tooltip:\"Box\"\nicon:#(\"standard\", 1) <span class=\"codeComment\">-- use first icon in standard</span>\n(\n  StartObjectCreation Box\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-727E\"></a><pre>\nmacroScript Sphere category:\"Objects\" tooltip:\"Sphere\"\nicon:#(\"\", 2) <span class=\"codeComment\">-- use second icon in internal icons</span>\n(\n  StartObjectCreation Sphere\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5843\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-E5EE5B39-C8F2-4AB5-A890-C39C5EFB39E5.htm\">Creating Icon Bitmap Files</a></span> for more information. \n               		\n            </p> \n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-75AB\"></a>The \n            		<span class=\"code\">&lt;macro_script_body&gt;</span> can be one of two forms. \n            	 \n         </p>\n         <p><a name=\"GUID-CA0D5D85-CFEF-4BE8-81CF-25EB9188DC3C\"></a>The body can be either a single MAXScript expression, or a set of event handlers.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-F2C86C8D-64B2-405F-BAC1-5C03E7AE74A0\"></a>An \n            		<span class=\"code\">&lt;event_handler&gt;</span> is a special function definition local to the MacroScript that handles events generated\n            by \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-F8AB302A-D23E-422D-B45C-6F8A93D5B6CD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5828\"></a>The valid \n            		<span class=\"code\"> <em class=\"strong\">&lt;event_name&gt;</em> </span> are: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-727B\"></a><pre><em class=\"codeEmphasisStrong\">on isChecked do</em> &lt;expr&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5826\"></a>If \n            		<span class=\"code\">&lt;expr&gt;</span> returns True and the MacroScript item is in a menu or quad menu, a check mark is\n            placed next to the MacroScript item. If the MacroScript is a toolbar button, the button\n            appears as \"pressed in\". The \n            		<span class=\"code\"> <em class=\"strong\">do</em> </span> is optional for this event handler. If this event handler is not specified, the item\n            is not checked. \n            	 \n         </p>\n         <p><a name=\"GUID-49B757AC-25A0-462E-915B-5A552C934A76\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">on isIndeterminate do</em> &lt;expr&gt;   </pre></div>\n         <p><a name=\"GUID-E127793C-8463-4C94-BBBC-2EE2C79FFE7B\"></a> If \n            		<span class=\"code\">&lt;expr&gt;</span> returns True and the MacroScript item is in a menu or Quad menu, a horizontal dash\n            symbol is placed next to the MacroScript item. If the MacroScript is a toolbar button,\n            this handler has no effect. This handler is independent from the \n            		<span class=\"code\"> <em class=\"strong\">on isChecked do</em> </span> handler and sets the Indeterminate symbol even if \n            		<span class=\"code\"> <em class=\"strong\">isChecked</em> </span> returns False. \n            	 \n         </p>\n         <p><a name=\"GUID-BF2CC0E9-A447-4F29-853B-8611DF1D0EC6\"></a> Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-21B6AFCC-75A7-4231-BDAA-3BD8CC56C655\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-727A\"></a><pre><em class=\"codeEmphasisStrong\">on isEnabled do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5823\"></a>If \n            		<span class=\"code\">&lt;expr&gt;</span> returns False and the macroscript item is in a menu or quad menu, the MacroScript\n            item does not appear in the menu or quad menu. If the MacroScript is a toolbar button,\n            the button is disabled. The \n            		<span class=\"code\"> <em class=\"strong\">do</em> </span> is optional for this event handler. If this event handler is not specified, the item\n            is enabled. \n            	 \n         </p>\n         <p><a name=\"GUID-0E3D6380-76D4-4257-AE94-40DEC26CBF65\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7279\"></a><pre><em class=\"codeEmphasisStrong\">on isVisible do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5820\"></a>If \n            		<span class=\"code\">&lt;expr&gt;</span> returns False and the macroscript item is in a menu or quad menu, the MacroScript\n            item does not appear in the menu or quad menu. If the MacroScript is a toolbar button,\n            this handler has no affect. The \n            		<span class=\"code\"> <em class=\"strong\">do</em> </span> is optional for this event handler. If this event handler is not specified, the item\n            is visible. \n            	 \n         </p>\n         <p><a name=\"GUID-F9117209-5E2D-4261-9BE4-8E9D3FE77D94\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7278\"></a><pre><em class=\"codeEmphasisStrong\">on execute do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-581D\"></a>The expression evaluated when the menu or quad menu item is chosen, or the toolbar\n            button clicked. A runtime error is generated if this event handler is not specified.\n            \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-581B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-581A\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7277\"></a><pre>\nmacroScript Free_Camera\ncategory:\"Lights and Cameras\"\ninternalcategory:\"Lights and Cameras\"\ntooltip:\"Free Camera\"\nbuttontext:\"Free Camera\"\nIcon:#(\"Cameras\",2)\n(\n  on execute do StartObjectCreation FreeCamera\n  on isChecked return (mcrUtils.IsCreating FreeCamera)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-580C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-580B\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7276\"></a><pre>\nmacroScript SubObject_Vertex\nbuttonText:\"Vertex\"\ncategory:\"Modifier Stack\"\ninternalCategory:\"Modifier Stack\"\ntooltip:\"Vertex Sub-object Mode\"\nicon:#(\"SubObjectIcons\",1)\n(\n  on isChecked do (subObjectLevel == 1 and filters.canSwitchTo_Vertex())\n  on isEnabled do Filters.canSwitchTo_Vertex()\n  on isVisible do Filters.canSwitchTo_Vertex()\n  on execute do\n  (\n    if subObjectLevel == undefined then max modify mode\n    if subObjectLevel != 1 then subObjectLevel = 1 else subObjectLevel = 0\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-1BBD4F06-B18E-4565-8EA7-5BB75267C04C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7275\"></a><pre><em class=\"codeEmphasisStrong\">on altExecute</em> &lt;type&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57F7\"></a>If a MacroScript implements the \n            		<span class=\"code\"> <em class=\"strong\">altExecute</em> </span> event handler, then a mouse icon (with a dark click button) appears in the quad menu\n            item that corresponds to the MacroScript. When the icon is clicked, the event handler\n            is executed with \n            		<span class=\"code\"> <em class=\"strong\">&lt;type&gt;</em> </span> being \n            		<span class=\"code\"> <em class=\"strong\">#default</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57F6\"></a>For example, the following adds alternative execute functionality to the standard\n            \"Wire Parameters\" quad menu. When you click the icon, it pops the Param Wiring Editor\n            instead of putting into the Wiring mode. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57F5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57F4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7274\"></a><pre>\nmacroScript paramWire\ncategory:\"Parameter Wire\"\ninternalcategory:\"Parameter Wire\"\nbuttonText:\"Wire Parameters\"\ntooltip:\"Start Parameter Wiring\"\nIcon:#(\"MAXScript\" ,1)\n(\n  on isEnabled return selection.count == 1\n  on execute do(paramWire.start())\n  on altExecute type do\n  (\n    paramWire.OpenEditor()\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-01BBEEEF-C997-44E2-8E9B-AA90481E5AC0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7273\"></a><pre><em class=\"codeEmphasisStrong\">on closeDialogs do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57E1\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">closeDialogs</em> </span> handler is called instead of the \n            		<span class=\"code\"> <em class=\"strong\">on Execute</em> </span> handler whenever the \n            		<span class=\"code\"> <em class=\"strong\">isChecked</em> </span> handler returns True (the button/icon/item is checked). It can be used to TOGGLE\n            back to the unchecked state. This handler must implement any cleanup code that closes\n            any open dialogs and basically returns the MacroScript to a pre-executed state. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75CA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The \n               		<span class=\"code\"> <em class=\"strong\">closeDialogs</em> </span> handler depends on the existence of the \n               		<span class=\"code\"> <em class=\"strong\">isChecked</em> </span> handler. If an \n               		<span class=\"code\"> <em class=\"strong\">on closeDialogs</em> </span> handler is defined without an \n               		<span class=\"code\"> <em class=\"strong\">isChecked</em> </span> handler to be defined, a compile-time error is thrown. \n               	 \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57DC\"></a>Here is a test for a MacroScript that toggles its rollout on and off: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57DB\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57DA\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7272\"></a><pre>\nmacroScript testCloseDialogs category:\"MXS Help\"\n(\nrollout testCloseRollout \"Test\" <span class=\"codeComment\">--define a rollout</span>\n(\nlabel lb_test \"testing CloseDialogs handler...\"\n)\non isChecked do testCloseRollout.open <span class=\"codeComment\">--return true if rollout is open</span> <span class=\"codeComment\">--if isChecked returns false (the rollout is not open in a dialog),</span> <span class=\"codeComment\">--the on execute handler will be called and will create the dialog.</span>\n\non execute do createDialog testCloseRollout\n\n  <span class=\"codeComment\">--If isChecked returns true and the user pressed the button again,</span> <span class=\"codeComment\">--instead of calling the on execute handler, the macroScript will call</span> <span class=\"codeComment\">--the on closeDialogs handler and destroy the dialog.</span>\n\non closeDialogs do destroyDialog testCloseRollout\n)\n\n  <span class=\"codeComment\">--If you drag the macroScript to a toolbar and click the button,</span> <span class=\"codeComment\">--a dialog should appear and the button should be checked.</span> <span class=\"codeComment\">--Click it again and the dialog will disappear.</span> <span class=\"codeComment\">--Repeat as often as you want - the dialog will be toggled on and off!</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-4ADD35E9-7C38-43C8-BED5-999CECDF3DD1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7271\"></a><pre><em class=\"codeEmphasisStrong\">on droppable</em> &lt;window&gt; <em class=\"codeEmphasisStrong\">node</em>:<em class=\"codeEmphasisStrong\">point</em>:do... </pre></div>\n         <p><a name=\"GUID-A2210866-0B61-429A-8C6C-F6D98C36D53D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7270\"></a><pre><em class=\"codeEmphasisStrong\">on drop</em> &lt;window&gt; <em class=\"codeEmphasisStrong\">node</em>:<em class=\"codeEmphasisStrong\">point</em>:do... </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57BE\"></a>These optional MacroScript event handlers are used to define the so-called DropScripts\n            that are used in conjunction with the i-Drop technology. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57BC\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">&lt;macro_script_body&gt;</em> </span> can contain global and local variables, functions, and structure definitions. The\n            \n            		<span class=\"code\"> <em class=\"strong\">&lt;macro_script_body&gt;</em> </span> is compiled in its own local scope, and the locals are only visible inside the scope\n            of the MacroScript. MacroScript locals are heap-based locals, which are slightly different\n            from normal (stack-based) locals. \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-758A\"></a>Normal locals are visible in the current scope and have a lifetime of one execution\n            of that scope. Heap-based locals are also visible only in the current scope, but have\n            a lifetime equal to the lifetime of the top-level expression where they are defined.\n            A MacroScript’s locals are created the first time you execute the MacroScript, initialized\n            to a value of \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>, or to their specified initialization value. These values are stored in a separate\n            memory stack. On entry to each function (or top level script) in the MacroScript,\n            a ’r;frame’ in the memory stack is marked and when the function (or top level script)\n            exits, all of the values in the frame are freed from the memory. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57BB\"></a>Because a MacroScript’s name is not created as a variable, you cannot access a MacroScript’s\n            locals outside the scope of the MacroScript. So, for example, you can create a rollout\n            in a MacroScript, and the rollout’s event handlers can access the locals defined in\n            the MacroScript because the rollout is executing within the scope of the MacroScript.\n            However, you cannot access the MacroScript’s locals from another utility or from the\n            Listener because they are not executing within the scope of the MacroScript. See \n            		<span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> for more information. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57BA\"></a>When you execute a \n            		<span class=\"code\"> <em class=\"strong\">macroScript</em> </span> definition, the return value is an integer MacroScript ID value. MAXScript internally\n            stores information about each MacroScript in an array, and the returned MacroScript\n            ID value is the array index for that MacroScript. The information stored for each\n            MacroScript consists of the file in which that MacroScript is defined and a pointer\n            into that file specifying where the MacroScript definition begins. The MacroScript\n            definition is only compiled when you first press a toolbar button that contains the\n            script, or execute the MacroScript using the \n            		<span class=\"code\"> <em class=\"strong\">macros.run()</em> </span> method. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B9\"></a> \n            <h2><a name=\"GUID-C0813835-DE22-4A29-8BF1-97743748C0BF\"></a> <em class=\"strong\">There are five ways a MacroScript can be defined:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B8\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B6\"></a>The default user-interface directory and its subdirectories are automatically scanned\n                     at startup for files of type .mcr, which are parsed for MacroScript definitions. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B4\"></a>A MacroScript definition is executed in an Editor window, in a script file that you\n                     execute, or in a startup script file. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B2\"></a>If you evaluate a MacroScript definition in the Listener window, a file is automatically\n                     created to contain the MacroScript definition. This file is stored in the MacroScripts\n                     directory under the current user-interface directory. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57B0\"></a>MAXScript supports text drag onto toolbars to create MacroScript buttons. You can\n                     select and drag text from any text window such as, Listener window panes or Editor\n                     windows onto any visible toolbar. The cursor changes to an arrow with + sign when\n                     it is OK to drop the text. If you drop it, a MacroScript button is added to the toolbar\n                     with the dropped text as the body of the MacroScript. The classic case here is to\n                     drag some text from the Macro Recorder pane in the Listener window onto a toolbar\n                     to make a button that does the sequence of events just recorded. Remember that tabbed\n                     elements on the Shelf are toolbars and can accept dropped text. MAXScript automatically\n                     encloses the text in a MacroScript definition with a MacroScript name of \n                     				<span class=\"code\"> <em class=\"strong\">DragAndDrop-MacroN</em> </span>, where \n                     				<span class=\"code\"> <em class=\"strong\">N</em> </span> is a number that makes the MacroScript name unique. The category is DragAndDrop and\n                     no tooltip is specified. As with MacroScripts defined in the Listener window, a file\n                     is automatically created to contain the MacroScript definition. This file is stored\n                     in the MacroScripts directory under the current user-interface directory. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57AE\"></a>A MacroScript can be defined using the \n                     				<span class=\"code\"> <em class=\"strong\">macros.new()</em> </span> method that is described next. As with MacroScripts defined in the Listener window,\n                     a file is automatically created to contain the MacroScript definition. This file is\n                     stored in the MacroScripts directory under the current user-interface directory. \n                     			 \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57AD\"></a>If you move or delete a file that contains a MacroScript definition that has been\n               loaded, and try to execute the MacroScript, an error message appears. Further, if\n               you edit a file containing MacroScript definitions, make sure to save and re-evaluate\n               the entire file so that any other MacroScripts defined in the file have their file\n               pointer updated. If you do not do this, you might get an error message indicating\n               that the currently loaded definition no longer matches its file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57AC\"></a>If you reevaluate a MacroScript definition, any button using that MacroScript can\n               see any changes that you make. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57AB\"></a>Any macroScript definition evaluated in MAXScript or created by dropping text onto\n               a toolbar has a separate definition .mcr file created in the MacroScripts directory\n               under the current user-interface directory (typically UI\\MacroScripts). The name of\n               the file is &lt;category_name&gt;-&lt;macro_name&gt;.mcr. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57AA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57A9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726F\"></a><pre>\nDragAndDrop-Macro12.mcr\n</pre></div> \n                     </td>\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726E\"></a><pre> <span class=\"codeComment\">for macroScript Macro12 category:\"DragAndDrop\"</span> </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726D\"></a><pre>\nNURBS-Map_Updater.mcr\n</pre></div> \n                     </td>\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726C\"></a><pre> <span class=\"codeComment\">for macroScript Map_Updater category:\"NURBS\"</span> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57A3\"></a>If you evaluate a macroScript definition in the Listener or drop text on a toolbar,\n               its recorded \n               		  <em class=\"strong\">definition file</em> is this backing file in UI\\MacroScripts. This definition file is the one that gets\n               opened if you hit Edit MacroScript in the CUI customize menus or dialogs. For macroScript\n               definitions evaluated in Listener, this means the same definition is updated each\n               time you evaluate it, rather than having separate backing file for each evaluation.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57A2\"></a>If you evaluate macroScript definitions in a .ms or .mcr file that does not already\n               reside in the UI\\MacroScripts directory, a copy for each is placed in a separate file\n               in UI\\MacroScripts, but the recorded definition file is the original source file,\n               so that hitting Edit MacroScript goes to that file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-57A1\"></a>This means that if any buttons containing such macroScript definitions are added to\n               toolbars in the \n               		  <em class=\"strong\">startup.cui</em> file, the backing .mcr file in UI\\MacroScripts is used as its definition at the next\n               \n               		  <em class=\"strong\">3ds Max</em> startup. When you start \n               		  <em class=\"strong\">3ds Max</em>, the macroScript definitions are taken from the backing files in UI\\MacroScripts.\n               If these MacroScripts are also defined in MAXScript startup script files, they are\n               re-defined at MAXScript startup and so the definition file of record is updated to\n               point to the script file. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-756F\"></a> \n            <h2><a name=\"GUID-FAB97487-E036-4CFC-8626-0A5B6F89516C\"></a>     MacroScripts Access:\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-579B\"></a>MAXScript provides several methods that allow you to access and run MacroScripts from\n               within a script. These MacroScript functions are in a structure package named \n               		  <span class=\"code\"> <em class=\"strong\">macros</em> </span>. For a description of the available methods, see the \n               		  <span class=\"char_link\"><a href=\"GUID-3DC75DDE-E4BC-4033-ABA9-A42063036CB9.htm\">Macro Scripts</a></span> topic. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5799\"></a>The following MacroScript allows you to render directly to the RAMPlayer. This MacroScript\n               shows the use of rollouts and rollout floater windows in MacroScripts. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5797\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5796\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726B\"></a><pre>\n--<span class=\"codeComment\"> MacroScript to Render to RamPlayer</span>\n--<span class=\"codeComment\"> Author: Alexander Bicalho</span>\n--<span class=\"codeComment\">****************************************************************</span>\n--<span class=\"codeComment\"> MODIFY THIS AT YOUR OWN RISK</span>\n--<span class=\"codeComment\"> This utility will allow you to render directly to the RamPlayer</span>\n\nMacroScript RAM_Render category:\"Tools\" tooltip:\"Render to Ram\"\n(\n--<span class=\"codeComment\">declare local variables and define some functions</span>\nlocal r_dialogue\nlocal get_names existFile\nfunction get_names name a = append a name\nfunction existFile fname = (getfiles fname).count != 0\n--<span class=\"codeComment\">create the rollout definition</span>\nrollout r_size\"Render Parameters\"\n(\nlocal p = 95\nlocal p2 = p+78\ngroup \"Time Output\"\n(\nradiobuttons r_time columns:1 align:#left labels:#(\"Single\",\"Active Time Segment\",\"Range:\" )\nspinner nth \"Every Nth Frame:\" pos:[215,24] fieldwidth:50 type:#integer range:[0,10000,1] enabled:false\nspinner r_from fieldwidth:60 pos:[75,56] type:#integer range:[0,10000,1] enabled:false\nspinner r_to \"To:\" fieldwidth:60 pos:[152,56] type:#integer range:[0,10000,100] enabled:false\n)\ngroup \"Render Size\"\n(\nspinner rw \"Width \" fieldwidth:60 pos:[15,p+08] type:#integer range:[0,10000,320]\nspinner rh \"Height \" fieldwidth:60 pos:[12,p+32] type:#integer range:[0,10000,240]\nspinner aspect \"Aspect \" fieldwidth:60 pos:[10,p+56] type:#float range:[0,20,1.0]\nbutton s160 \"160x120\" pos:[125,p+06] width:75 height:19\nbutton s256 \"256x243\" pos:[125,p+30] width:75 height:19\nbutton s320 \"320x240\" pos:[205,p+06] width:75 height:19\nbutton s512 \"512x486\" pos:[205,p+30] width:75 height:19\nbutton s640 \"640x480\" pos:[285,p+06] width:75 height:19\nbutton s720 \"720x486\" pos:[285,p+30] width:75 height:19\nbutton conf_render \"Configure\" pos:[125,p+54] width:115 height:19\nbutton wipe \"Purge Files\" pos:[245,p+54] width:115 height:19\nbutton go \"Render\" pos:[125,p+78] width:235 height:19\n)\nlabel abt0 \"Render to RAM\" pos:[8,p2+31]\nlabel abt1 \"Version 0.2a\" pos:[8,p2+46]\nlabel abt2 \"Alexander Esppeschit Bicalho\" pos:[225,p2+31]\nlabel abt3 \"abicalho@brasilmail.com\" pos:[249,p2+46]\n--<span class=\"codeComment\">define the rollout event handlers</span>\non wipe pressed do\n(\nlocal tempfilename_a = (getdir #image) + \"\\\\ramplayertemp_a.avi\"\nlocal tempfilename_b = (getdir #image) + \"\\\\ramplayertemp_b.avi\"\nif existfile tempfilename_a then deletefile tempfilename_a\nif existfile tempfilename_b then deletefile tempfilename_b\n)\non r_time changed state do\n(\ncase state of\n(\n1: nth.enabled = r_from.enabled = r_to.enabled = false\n2: (\nnth.enabled = true\nr_from.enabled = r_to.enabled = false\n)\n3: nth.enabled = r_from.enabled = r_to.enabled = true\n)\n)\non s160 pressed do (rw.value=160; rh.value=120; aspect.value=1.0)\non s320 pressed do (rw.value=320; rh.value=240; aspect.value=1.0)\non s256 pressed do (rw.value=256; rh.value=243; aspect.value=1.266)\non s512 pressed do (rw.value=512; rh.value=486; aspect.value=1.266)\non s640 pressed do (rw.value=640; rh.value=480; aspect.value=1.0)\non s720 pressed do (rw.value=720; rh.value=486; aspect.value=0.9)\non conf_render pressed do (max render scene)\non go pressed do\n(\nlocal tempfilename_a = (getdir #image) + \"\\\\ramplayertemp_a.avi\"\nlocal tempfilename_b = (getdir #image) + \"\\\\ramplayertemp_b.avi\"\nif existfile tempfilename_b then\n(\ndeletefile tempfilename_a\ncopyfile tempfilename_b tempfilename_a\ntempfilename = tempfilename_b\n)\nelse\n(\nif existfile tempfilename_a then\ntempfilename = tempfilename_b\nelse\n(\ntempfilename = tempfilename_a\ntempfilename_b = \"\"\n)\n)\ncase r_time.state of\n(\n1: ( render outputheight:rh.value outputwidth:rw.value pixelaspect:aspect.value outputfile:tempfilename vfb:off)\n2: ( render outputheight:rh.value outputwidth:rw.value pixelaspect:aspect.value outputfile:tempfilename vfb:off nthframe:nth.value framerange:#active )\n3: ( render outputheight:rh.value outputwidth:rw.value pixelaspect:aspect.value outputfile:tempfilename vfb:off nthframe:nth.value fromframe:r_from.value toframe:r_to.value )\n)\nramplayer tempfilename_a tempfilename_b\ncloserolloutfloater r_dialogue\n)--<span class=\"codeComment\">end of on go pressed</span>\n)--<span class=\"codeComment\">end of rollout r_size</span>\n--<span class=\"codeComment\">close the old rollout floater if it exists</span>\ntry(closerolloutfloater r_dialogue)catch()\n--<span class=\"codeComment\">put up new rollout floater and add rollout to it.</span>\nr_dialogue = newrolloutfloater \"Render to RAM\" 400 300\naddrollout r_size r_dialogue\n--<span class=\"codeComment\">end of MacroScript, rollout takes over...</span>\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5725\"></a> <span class=\"char_link\"><a href=\"GUID-C3F61DC1-D07C-4DCD-939C-CF30E4DCA29F.htm\">MacroScripts for New Users</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-5CC15862-BCB2-4DF6-A047-6B92F2FA3A55\"></a> <span class=\"char_link\"><a href=\"GUID-4E926577-61C6-463E-9238-D422EFC03718.htm\">Resource String Replacement</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-23013A3F-2F69-4970-9ECE-D53A8A3DED28.htm\">macroScript Localization Support for CUI and menu files </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-4E926577-61C6-463E-9238-D422EFC03718.htm\"> Resource String Replacement </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E5EE5B39-C8F2-4AB5-A890-C39C5EFB39E5.htm\">Creating Icon Bitmap Files </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5A4580C6-B5CF-4104-898B-9313D1AAECD4.htm\">Context Filters </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";