var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rollout user-interface controls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout User-Interface Controls</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1\"></a><div class=\"head\">\n            <h1>Rollout User-Interface Controls </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-666D\"></a>There is a multitude of user-interface control types that you can choose from to construct\n            your rollout. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-666C\"></a>They all share the same overall syntax: \n         </p>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_2488CB6FB88547FF949D93E54803F5FD\"></a><pre>&lt;item_type&gt; &lt;name&gt; [ &lt;label_string&gt; ] [ &lt;parameters&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6669\"></a>The item types correspond to the types of user-interface control items you see in\n            typical <em class=\"strong\">3ds Max</em> rollouts. \n         </p>\n         <p><a name=\"GUID-4629B500-3635-496C-8965-3DCD15045764\"></a>The types of user-interface control items are described in <span class=\"char_link\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Rollout User-Interface Control Types</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6668\"></a>The <span class=\"code\">&lt;name&gt;</span> is used to name an automatically constructed rollout local variable that will hold\n            the value representing the control item, and is used to associate event handler functions\n            with the control item. \n         </p>\n         <p><a name=\"GUID-3A0CA77E-D12E-4940-8250-3971D2DDA795\"></a>The optional <span class=\"code\">&lt;label_string&gt;</span> is used as a caption, item label, or text content depending on the control item type,\n            as described in the topics for each type. \n         </p>\n         <p><a name=\"GUID-C4150736-38B1-4FC1-980A-B8ACABAD69D9\"></a>The optional <span class=\"code\">&lt;parameters&gt;</span> is a sequence of keyword arguments used to set options or influence layout for the\n            control item. The exact parameters that each control item type supports is also defined\n            in the topics for each type. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6667\"></a>There are <em class=\"strong\">properties </em> associated with each of the user-interface control item types. \n         </p>\n         <p><a name=\"GUID-BB8423F5-1622-4A76-A244-5FB86A838054\"></a>The properties that are common to all user-interface control item types are described\n            in <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Controls Common Properties</a></span>. \n         </p>\n         <p><a name=\"GUID-2354AC5B-EC1A-4ADB-8C5B-D20B99A742B9\"></a>Properties that are unique to a user-interface control item type are defined in the\n            topics for each type. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6666\"></a>As you define a sequence of control items, MAXScript will by default automatically\n            lay them out in the rollout, one below the other in the order they are defined. \n         </p>\n         <p><a name=\"GUID-4510CBAD-0E43-4D28-866E-ABC8521BE634\"></a>You can override this layout or make adjustments to it using special layout parameters\n            defined in <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Controls Common Layout Parameters</a></span>. \n         </p><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Controls Common Properties </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Controls Common Layout Parameters </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-99E9BB72-ACE0-4436-8893-8D1AA4AEFCA3.htm\">Setting Focus on User Interface Controls </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Rollout User-Interface Controls Types </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-63E016F3-250E-4C93-B213-2C1AB51710F7.htm\">Image Buttons </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";