var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-6FEB5CF5-2747-4EC8-9D98-872CD363C460\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Passing SplineShape Knot Selections Up The Stack\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Passing SplineShape Knot Selections Up The Stack</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6FEB5CF5-2747-4EC8-9D98-872CD363C460\"></a><div class=\"head\">\n            <h1>Passing SplineShape Knot Selections Up The Stack </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC0\"></a> When setting a Knot selection using the setKnotSelection method, you are <em class=\"strong\">always</em> affecting the base object - the EditableSpline at the bottom of the stack. It is\n            not directly possible to set the sub-object vertex selection of a specific <span class=\"char_link\"><a href=\"GUID-BBF3E736-E848-45FC-9BC7-6AAA21FC7732.htm\">Edit_Spline</a></span> modifier using this method. The selection flows up the stack through any existing\n            Edit_Spline modifiers and changes the sub-object selections of all of them. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC1\"></a>In the following example, the script has to select a single vertex at the end of a\n            SplineShape and link it to an object using a Linked XForm modifier. Then the other\n            vertex on the other end of the SplineShape has to be linked to a different object\n            using a second Linked XForm modifier. In result, moving either object should stretch\n            the spline between the two objects similar to a rope. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC2\"></a>Obviously, trying to set the vertex selection for both ends will fail because the\n            second selection would flow through the whole stack and overwrite the first selection,\n            resulting in both Linked XForm modifiers affecting the same vertex. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC3\"></a>To avoid this, we have to do two things - we will apply the modifiers from top to\n            bottom instead of adding them on top of each-other, and we will use a SplineSelect\n            modifier as a \"selection blocker\" to stop the second sub-object selection from overwriting\n            the first one. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CC6\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5415\"></a><pre>\nresetMaxFile #noPrompt\ntheSphere1= sphere()\ntheSphere1.pos = [-100,0,0]\ntheSphere2= sphere()\ntheSphere2.pos = [100,0,0]\ntheShape = splineShape()\naddnewSpline theShape\naddKnot theShape 1 #corner #line [-100,0,0]\naddKnot theShape 1 #corner #line [100,0,0]\nupdateShape theShape\nmax modify mode --switch to modify panel\nselect theShape --select the spline \nes1 = edit_spline name:\"First ES\" --create 1st Edit_Spline\naddmodifier theShape es1 --add to the TOP of the stack\nsubobjectLevel = 1 --vertex level...\nsetKnotSelection theShape 1 #(1) --select first vertex in BASE OBJECT\nLX1 = Linked_XForm name:\"First XForm\" --Add Linked XForm\nmodPanel.addModToSelection LX1 --Add to the sub-selection\nLX1.Control = theSphere1--Set control\nsselect = splineselect name:\"Blocker\" --Add a SplineSelect to stop the flow\naddmodifier theShape sselect before:2 --Add it BEFORE the first Edit_Spline!\n --Note: Since modifiers are always counted from top to bottom,\n --having 2 modifiers on top will place the new modifier before them\n --when using \"before:2\"\nes2 = edit_spline name:\"Second ES\" --Create second Edit_Spline\naddmodifier theShape es2 before:3 --Add it BEFORE the SlineSelect \"Blocker\"\nmodPanel.setCurrentObject es2 --Set the Modifier stack to it \nsubobjectLevel = 1 --vertex SO level\nsetKnotSelection theShape 1 #(2) --select second vertex\n --Note that at this point, the selection will flow up until it\n --hits the SplineSelect modifier which is set to Object Level and does\n --not let the selection pass beyond that point. This preserves\n --the selection of vertex 1 in the top Edit_Spline and sets the\n --selection in the bottom one to vertex 2.\nLX2 = Linked_XForm name:\"Second XForm\" --create new Linked XForm\n modPanel.addModToSelection LX2 --Add on top of the current selection\nLX2.Control = theSphere2 --set second control\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";