var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7358FB2E-182A-4BB8-8208-3E74D28FC205\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Editor - Defining And Using Abbreviations\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Editor - Defining And Using Abbreviations</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7358FB2E-182A-4BB8-8208-3E74D28FC205\"></a><div class=\"head\">\n            <h1>MAXScript Editor - Defining And Using Abbreviations </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E0\"></a>The <span class=\"char_link\"><a href=\"GUID-F561FC1E-CFF8-4FF6-874C-95EC4B9CD2CD.htm\">Tabbed MAXScript Editor</a></span> introduced in <em class=\"strong\">3ds Max 2008 </em>lets you define and use abbreviations of common used words to speed up the typing\n            of scripting code. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E1\"></a> \n            <h2><a name=\"GUID-38B886C9-C1DC-489A-B8B2-8A77B8FB0F88\"></a>Defining Abbreviations\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E2\"></a>The abbreviations are defined in a file called <em class=\"strong\">MXS_Editor_Abbrev.properties </em>which is empty by default after a fresh installation of <em class=\"strong\">3ds Max </em>and is located in the <em class=\"strong\">3ds Max</em> root directory, but can be easily accessed and edited using the <span class=\"char_link\"><a href=\"GUID-029EF4FB-5822-4E33-85A6-BD140F8D26FD.htm\">Tools</a></span> &gt;<em class=\"strong\">Open Abbreviations.properties </em>Editor Menu option. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3510\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E3\"></a> <em class=\"strong\">An abbreviation is defined in the form</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BF\"></a><pre>&lt;AbbrevName&gt;=&lt;Expanded Form&gt;</pre></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-350F\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E6\"></a>The abbreviation names can contain any characters (except control chars lile \\r or\n                  \\n), including high ASCII characters (accented characters). Abbreviation names cannot\n                  start with #, space or tab (but can contain spaces inside the name) and cannot contain\n                  the \'=\' character inside. Abbreviations names are limited to 32 characters. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E7\"></a>The expanded form may contain new line characters indicated by \'\\n\' and a caret position\n                  indicated by the \'|\' character. To include a literal \'|\' character, use \'||\'. When\n                  expanding, the names don\'t need to be separated from the previous text. For example,\n                  if you define \'é\' as \'&amp;eacute;\', you can expand it inside a word. If a name is the\n                  ending of another one, only the shorter will ever be expanded. For example if you\n                  define \'ring\' and \'gathering\', the later will see only the \'ring\' part expanded. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-350E\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49E9\"></a>You can define abbreviation definitions for any word, special character or expression\n                  that you find yourself typing in too often or is too long to remember. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49EA\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49EB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49EC\"></a><p class=\"table-body\">The following are some possible abbreviations for accelerating GUI creation: </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BE\"></a><pre>cd=CreateDialog\nnf=newRolloutFloater\nrof=rendOutputFilename</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49F2\"></a><p class=\"table-body\">After defining the abbreviations, press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">S</span></em> to save the <em class=\"strong\">MXS_Editor_Abbrev.properties </em>file to disk. \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49F4\"></a> \n            <h2><a name=\"GUID-C16ADF58-4117-424D-98C6-A93C560B6718\"></a> <em class=\"strong\">Using the Expand Abbreviation Feature</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49F5\"></a>Press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">N</span></em>to open a new Untitled script in a new tab.In the new script, enter \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49F6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BD\"></a><pre>nf</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49FA\"></a><p class=\"table-body\">While the cursor is still at the end of the abbreviation, press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">A</span></em>. The abbreviation will immediately turn into \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BC\"></a><pre>new Rollout Floater</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC49FF\"></a> \n            <h2><a name=\"GUID-35DEB237-9977-4F12-8AE9-0001DB197051\"></a> <em class=\"strong\">Using the Insert Abbreviation Feature</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A00\"></a>Alternatively, position the cursor at the desired location in the editor and press\n               <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">R</span></em> to open a small dialog listing all defined abbreviations. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A01\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-173264A2-BDE2-47DF-9F32-8A247EABE5FD-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A02\"></a>Either select an entry from the list or type in an existing abbreviation and press\n               the Insert button to add the expanded word to your code. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A04\"></a> \n            <h2><a name=\"GUID-414696F9-04A6-47E7-99F1-EBADA17E1F5C\"></a> <em class=\"strong\">Using the Abbreviation Feature To Write Code Fragments</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A05\"></a>Since the expanded version can contain new line characters, it is possible to define\n               abbreviations that contain prototype code and even full functions you need often to\n               be inserted into your code. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A06\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A07\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A08\"></a><p class=\"table-body\">You can define the following for loop prototype code as abbreviation in the file <em class=\"strong\">MXS_Editor_Abbrev.properties</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BB\"></a><pre>\nfor do =for i = 1 to 100 where true do\\n(\\n)\\n&nbsp;\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A0C\"></a><p class=\"table-body\">After defining the abbreviations, press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">S</span> </em>to save the <em class=\"strong\">MXS_Editor_Abbrev.properties </em>file to disk. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A0D\"></a><p class=\"table-body\">If can now type in a script file </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63BA\"></a><pre>\nfordo\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A11\"></a><p class=\"table-body\">and after pressing <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">A</span></em>, the following code would appear: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63B9\"></a><pre><em class=\"codeEmphasisStrong\">for </em>i<em class=\"codeEmphasisStrong\">=</em>1 <em class=\"codeEmphasisStrong\">to </em>100 <em class=\"codeEmphasisStrong\">where true do</em> <em class=\"codeEmphasisStrong\">(</em> <em class=\"codeEmphasisStrong\">)</em> </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4A17\"></a><p class=\"table-body\">Now you could customize this prototype code by modifying the <em class=\"strong\">from </em>and <em class=\"strong\">to </em>values, entering a valid <em class=\"strong\">while </em>condition in place of true and writing some code into the body of the for loop, but\n                           it would have saved you some typing. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_2B1D426775784488B6C2A32E5C209BA5\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"2.9036004645760745%\">\n                     <col width=\"54.4425087108014%\">\n                     <col width=\"42.65389082462253%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_5A7518CE5E0D495B9EF54010AA35F6CD\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_1D753D8FF55D4C619AF06743F89A10AB\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">MAXScript Editor - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";