var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-766FF906-5021-47C9-B48D-F76AB0144475\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Scripted Position Test Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Position Test Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-766FF906-5021-47C9-B48D-F76AB0144475\"></a><div class=\"head\">\n            <h1>Scripted Position Test Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE2\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE3\"></a>The following example uses Script_Test actions to implement scripted position tests\n            with both relative offset and absolute position options. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE4\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE5\"></a>The two scripts must be used inside the <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> actions. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE6\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0C191B7B-F2A0-4FE2-B454-0511ACBD51B8-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE7\"></a> <em class=\"strong\">Effect:</em> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AE8\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AEA\"></a>The PF_Source generates particles which get tested for relative offset of -100 to\n                  their birth position along the Z axis. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AEC\"></a>If they pass the scripted offset test, the particles are moved to the second Event\n                  which stops them and tests them for Age above 30. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AEE\"></a>If they pass the Age Test, the particles are moved to the Third event which tests\n                  them for absolute offset of -200 along the world Z axis using the second script. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AF0\"></a>If they pass the scripted position test, the particles are moved to the last Event\n                  which stops them. \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AF1\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-C2C276D5-8312-4EA3-B00D-1E2B41772542-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AF3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84AF4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT 1</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0B\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true\npCont.usePosition = true\n)\n \n--The Init handler is called on initialization.\n--In this case, it is used to define the offset parameters\non Init pCont do\n(\n--Data paramters definition\nstruct paramsStruct (cond_less, axis, testpos, offset)\nglobal paramsData = paramsStruct()\n \n--true means less than, false means greater then\nparamsData_offset.cond_less = true\n--Axis option: x=1, y=2, z=3\nparamsData_offset.axis = 3\n--When set to true, the offset test is relative\n--When set to false, the offset test is absolute.\nparamsData_offset.offset = true\n--Set the offset value to test for\nparamsData_offset.testpos = -100\n \n-- collects initial pos of each particle for offset test\nglobal pos_init_array =#()\n)\n \n--In the Proceed handler, the actual testing is performed\n \non Proceed pCont do\n(\ncount = pCont.NumParticles()\n \nfor i in 1 to count do\n(\npCont.particleIndex = i\n-- get ID of active particle\nid = pCont.getParticleID pCont.particleIndex\nif paramsData.cond_less == true then\n(\nif paramsData.offset == true then\n(\n-- collect initial pos for new born particle\nif pCont.particleNew == true then\nappend pos_init_array pCont.particlePosition[paramsData.axis]\npos_id = pCont.GetParticlePositionByID id\nif pos_id[paramsData.axis] &lt; (pos_init_array[id] + paramsData.testpos) then\n testSatisfied = true\n)\nelse\n(\nif pCont.particlePosition[paramsData.axis] &lt; paramsData.testpos then\ntestSatisfied = true\n)\n)\nelse\n(\nif paramsData.offset == true then\n(\n-- collect initial pos for new born particle\n if pCont.particleNew == true then\nappend pos_init_array pCont.particlePosition[paramsData.axis]\npos_id = pCont.GetParticlePositionByID id\n if pos_id[paramsData.axis] &gt; (pos_init_array[id] + paramsData.testpos) then\ntestSatisfied = true\n)\nelse\n(\n if pCont.particlePosition[paramsData.axis] &gt; paramsData.testpos then\ntestSatisfied = true\n)\n)\nif testSatisfied == true then\n(\npCont.particleTestStatus = true\npCont.particleTestTime = pCont.particleTime\n)\n)\n)\n \non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84B52\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84B53\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT 2</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0A\"></a><pre>\non ChannelsUsed pCont do\n(\npCont.useTime = true\npCont.usePosition = true\n)\non Init pCont do\n(\n--Data paramters definition\nstruct paramsStruct (cond_less, axis, testpos, offset)\nglobal paramsData = paramsStruct()\n \n--true means less than, false means greater then\nparamsData.cond_less = true\n \n--Axis option: x=1, y=2, z=3\nparamsData.axis = 3\n--When set to false, the offset test is absolute.\n--When set to true, the offset test is relative\nparamsData.offset = false\n--Set the position value to test\nparamsData.testpos = -200\n \n-- Collects initial pos of each particle for offset test:\nglobal pos_init_array =#()\n)\n \n--The Proceed handler is identical to the one in the first script.\n--Only the test parameters defined in the Init handler alter the\n--behavior of the script!\n \non Proceed pCont do\n(\ncount = pCont.NumParticles()\n \nfor i in 1 to count do\n(\npCont.particleIndex = i\n-- get ID of active particle\nid = pCont.getParticleID pCont.particleIndex\nif paramsData.cond_less == true then\n(\nif paramsData.offset == true then\n(\n-- collect initial pos for new born particle\nif pCont.particleNew == true then\nappend pos_init_array pCont.particlePosition[paramsData.axis]\npos_id = pCont.GetParticlePositionByID id\nif pos_id[paramsData.axis] &lt; (pos_init_array[id] + paramsData.testpos) then\n testSatisfied = true\n)\nelse\n(\nif pCont.particlePosition[paramsData.axis] &lt; paramsData.testpos then\ntestSatisfied = true\n)\n)\nelse\n(\nif paramsData.offset == true then\n(\n-- collect initial pos for new born particle\nif pCont.particleNew == true then\nappend pos_init_array pCont.particlePosition[paramsData.axis]\npos_id = pCont.GetParticlePositionByID id\nif pos_id[paramsData.axis] &gt; (pos_init_array[id] + paramsData.testpos) then\ntestSatisfied = true\n)\nelse\n(\nif pCont.particlePosition[paramsData.axis] &gt; paramsData.testpos then\ntestSatisfied = true\n)\n)\nif testSatisfied == true then\n(\npCont.particleTestStatus = true\npCont.particleTestTime = pCont.particleTime\n)\n)\n)\n \non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";