var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-782447FD-103B-4686-8F65-97A2A02EB3FB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"showInterfaces Inspector Function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>showInterfaces Inspector Function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-782447FD-103B-4686-8F65-97A2A02EB3FB\"></a><div class=\"head\">\n            <h1>showInterfaces Inspector Function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-707D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-707A\"></a> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7079\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7078\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D06\"></a><pre><em class=\"codeEmphasisStrong\">showInterfaces</em> {&lt;maxwrapper&gt; | &lt;maxclass&gt; | node} [ <em class=\"codeEmphasisStrong\">to:</em>&lt;stream&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7075\"></a>where, <span class=\"code\"> &lt;maxwrapper&gt; </span> is the <em class=\"strong\">3ds Max</em> object to be inspected. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7074\"></a><span class=\"code\"> &lt;maxclass&gt; </span> is the <em class=\"strong\">3ds Max</em> class to be inspected. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7073\"></a>The optional <em class=\"strong\">to</em>:&lt;stream&gt; keyword argument specifies a Stream Value to output the display to. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7072\"></a>When the <em class=\"strong\">3ds Max</em> entity specified is a node (for example, $box01), this function only displays the\n               Interfaces of the base object. It does <em class=\"strong\">not</em> show the Interfaces of the transform controllers, modifiers, or materials applied\n               to the object. To display the Interfaces for one of these objects, the object must\n               be specified as the <em class=\"strong\">3ds Max</em> entity. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7071\"></a>As a special case, you can also call <span class=\"code\"> <em class=\"strong\">showInterfaces()</em> </span> on the superclass <em class=\"strong\">\'Node\'</em> to display the interfaces that are common to all scene nodes. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7070\"></a>The display of interface information is divided into three sections: <em class=\"strong\">Properties</em>, <em class=\"strong\">Methods</em>, and <em class=\"strong\">Actions</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-706F\"></a>In the <em class=\"strong\">Properties</em> section, each property exposed by the interface is listed along with its data type\n               or enumeration values and whether the property can be read and written to. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-706E\"></a>In the <em class=\"strong\">Methods</em> section, each method is listed along with its return type and its argument list.\n               The value type for each argument is shown. If the return type is shown as &lt;void&gt;,\n               the method returns a value of \'ok\'. Methods that are used by <em class=\"strong\">Actions</em> are commented as such. These methods typically require that the object be selected\n               and active in the appropriate command panel. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-706D\"></a>In the <em class=\"strong\">Actions</em> section, each Action is listed along with its category and action description as\n               shown in the Customize User Interface dialog, and the shortcut keys, if any, assigned\n               to the Action. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1901\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Refer to <span class=\"char_link\"><a href=\"\">MAXScript Class Hierarchy</a></span> to see which objects are exposed using maxwrapper. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7068\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7067\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D05\"></a><pre>\nshowinterfaces node\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7063\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D04\"></a><pre>\n  Interface: IAssembly\n   Properties:\n    .assemblyMember : boolean : Read|Write\n    .assemblyHead : boolean : Read|Write\n    .assemblyMemberOpen : boolean : Read|Write\n    .assemblyHeadOpen : boolean : Read|Write\n    .assemblyBBoxDisplay : boolean : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeGIProperties\n   Properties:\n    .isGIExcluded : boolean : Read|Write\n    .isGIOccluder : boolean : Read|Write\n    .isGIReceiver : boolean : Read|Write\n    .isGIDiffuse : boolean : Read|Write\n    .isGISpecular : boolean : Read|Write\n    .GIUseGlobalMeshing : boolean : Read|Write\n    .GIMeshingEnabled : boolean : Read|Write\n    .nbGIRefineSteps : integer : Read|Write|Validated by Range: 0 to 65535\n    .nbGIRefineStepsDone : integer : Read|Write|Validated by Range: 0 to 65535\n    .GIMeshSize : worldUnits : Read|Write|Validated by Range: 0.01 to 1e+009\n    .isGIExcludedFromRegather : boolean : Read|Write\n    .storeIllumToMesh : boolean : Read|Write\n    .GIByLayer : boolean : Read|Write\n    .GIRayMult : float : Read|Write\n    .GIUseAdaptiveSubdivision : boolean : Read|Write\n    .GIMinMeshSize : float : Read|Write\n    .GIInitialMeshSize : float : Read|Write\n    .GIContrastThreshold : float : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeGIProperties\n   Properties:\n    .isGIExcluded : boolean : Read|Write\n    .isGIOccluder : boolean : Read|Write\n    .isGIReceiver : boolean : Read|Write\n    .isGIDiffuse : boolean : Read|Write\n    .isGISpecular : boolean : Read|Write\n    .GIUseGlobalMeshing : boolean : Read|Write\n    .GIMeshingEnabled : boolean : Read|Write\n    .nbGIRefineSteps : integer : Read|Write|Validated by Range: 0 to 65535\n    .nbGIRefineStepsDone : integer : Read|Write|Validated by Range: 0 to 65535\n    .GIMeshSize : worldUnits : Read|Write|Validated by Range: 0.01 to 1e+009\n    .isGIExcludedFromRegather : boolean : Read|Write\n    .storeIllumToMesh : boolean : Read|Write\n    .GIByLayer : boolean : Read|Write\n    .GIRayMult : float : Read|Write\n    .GIUseAdaptiveSubdivision : boolean : Read|Write\n    .GIMinMeshSize : float : Read|Write\n    .GIInitialMeshSize : float : Read|Write\n    .GIContrastThreshold : float : Read|Write\n   Methods:\n   Actions:\n  Interface: INode\n   Properties:\n    .boneEnable : boolean : Read|Write\n    .posTaskWeight : float : Read|Write\n    .rotTaskWeight : float : Read|Write\n    .boneAutoAlign : boolean : Read|Write\n    .boneFreezeLength : boolean : Read|Write\n    .boneScaleType : enum : Read|Write\n       boneScaleType enums: {#scale|#squash|#none}\n    .stretchTM : matrix3 by value : Read\n    .boneAxis : enum : Read|Write\n       boneAxis enums: {#X|#Y|#Z}\n    .boneAxisFlip : boolean : Read|Write\n    .primaryVisibility : boolean : Read|Write\n    .secondaryVisibility : boolean : Read|Write\n    .applyAtmospherics : boolean : Read|Write\n    .vertexColorType : enum : Read|Write\n       vertexColorType enums: {#color|#illum|#alpha|#color_plus_illum|#soft_select|#map_channel}\n    .showVertexColors : integer : Read|Write\n    .shadeVertexColors : integer : Read|Write\n    .vertexColorMapChannel : integer : Read|Write\n    .handle : DWORD : Read\n    .posInParent : point3 : Read\n    .rotInParent : point3 : Read\n    .scaleInParent : point3 : Read\n    .scaleOrientInParent : quat : Read\n   Methods:\n    &lt;void&gt;setBoneEnable &lt;boolean&gt;onOff &lt;time&gt;time\n    &lt;void&gt;realignBoneToChild()\n    &lt;void&gt;resetBoneStretch()\n   Actions:\n  Interface: INodeLayerProperties\n   Properties:\n    .layer : Interface : Read\n    .displayByLayer : boolean : Read|Write\n    .renderByLayer : boolean : Read|Write\n    .motionByLayer : boolean : Read|Write\n    .colorByLayer : boolean : Read|Write\n    .globalIlluminationByLayer : boolean : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeBakeProperties\n   Properties:\n    .bakeEnabled : boolean : Read|Write\n    .bakeChannel : integer : Read|Write\n    .nDilations : integer : Read|Write\n    .flags : integer : Read|Write\n    .surfaceArea : float : Read|Write\n    .areaScale : float : Read|Write\n    .activeOriginX : float : Read|Write\n    .activeOriginY : float : Read|Write\n    .activeWidth : float : Read|Write\n    .activeHeight : float : Read|Write\n   Methods:\n    &lt;boolean&gt;addBakeElement &lt;maxObject&gt;element\n    &lt;boolean&gt;removeBakeElement &lt;maxObject&gt;element\n    &lt;boolean&gt;removeBakeElementByIndex &lt;index&gt;elementIndex\n    &lt;boolean&gt;removeBakeElementByName &lt;string&gt;elementName\n    &lt;void&gt;removeAllBakeElements()\n    &lt;integer&gt;numBakeElements()\n    &lt;maxObject&gt;getBakeElement &lt;index&gt;index\n    &lt;index&gt;findByName &lt;string&gt;elementName\n    &lt;integer&gt;renderWidth()\n    &lt;integer&gt;renderHeight()\n    &lt;boolean&gt;effectiveEnable()\n    &lt;integer&gt;numElementParams &lt;maxObject&gt;element\n    &lt;string&gt;paramName &lt;maxObject&gt;element &lt;index&gt;paramIndex\n    &lt;integer&gt;paramType &lt;maxObject&gt;element &lt;index&gt;paramIndex\n    &lt;fpvalue by value&gt;paramValue &lt;maxObject&gt;element &lt;index&gt;paramIndex\n    &lt;void&gt;setParamValue &lt;maxObject&gt;element &lt;index&gt;paramIndex &lt;fpvalue by value&gt;paramValue\n    &lt;fpvalue by value&gt;paramValueMin &lt;maxObject&gt;element &lt;index&gt;paramIndex\n    &lt;fpvalue by value&gt;paramValueMax &lt;maxObject&gt;element &lt;index&gt;paramIndex\n    &lt;index&gt;findParam &lt;maxObject&gt;element &lt;string&gt;paramName\n    &lt;fRGBA color by value&gt;GetBackgroundColor &lt;maxObject&gt;element\n    &lt;void&gt;SetBackgroundColor &lt;maxObject&gt;element &lt;fRGBA color by value&gt;color\n   Actions:\n  Interface: SkinPose\n   Properties:\n    .skinPos : point3 by value : Read|Write\n    .skinRot : point3 by value : Read|Write\n    .skinScale : point3 by value : Read|Write\n    .skinScaleOrient : quat by value : Read|Write\n    .skinPosEnabled : bool : Read|Write\n    .skinRotEnabled : bool : Read|Write\n    .skinScaleEnabled : bool : Read|Write\n    .skinPoseMode : bool : Read|Write\n   Methods:\n    &lt;void&gt;setSkinPose()\n    &lt;void&gt;assumeSkinPose()\n   Actions:\n  Interface: INodeBakeProjProperties\n   Properties:\n    .enabled : boolean : Read|Write\n    .projectionMod : maxObject : Read|Write\n    .projectionModTarget : string : Read|Write\n    .cropAlpha : boolean : Read|Write\n    .projSpace : enum : Read|Write\n       projSpace enums: {#raytrace|#uvw_match}\n    .normalSpace : enum : Read|Write\n       normalSpace enums: {#world|#screen|#local|#tangent}\n    .tangentYDir : enum : Read|Write\n       tangentYDir enums: {#Y_Up|#Y_Down}\n    .tangentXDir : enum : Read|Write\n       tangentXDir enums: {#X_Right|#X_Left}\n    .useCage : boolean : Read|Write\n    .rayOffset : float : Read|Write\n    .hitResolveMode : enum : Read|Write\n       hitResolveMode enums: {#closest|#furthest}\n    .hitMatchMtlID : boolean : Read|Write\n    .hitWorkingModel : boolean : Read|Write\n    .warnRayMiss : boolean : Read|Write\n    .rayMissColor : color : Read|Write\n    .heightMapMin : float : Read|Write\n    .heightMapMax : float : Read|Write\n    .heightBufMin : float : Read|Write\n    .heightBufMax : float : Read|Write\n    .BakeObjectLevel : boolean : Read|Write\n    .BakeSubObjLevels : boolean : Read|Write\n    .useObjectBakeForMtl : boolean : Read|Write\n    .proportionalOutput : boolean : Read|Write\n    .subObjBakeChannel : integer : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeMentalRayProperties\n   Properties:\n    .mr_displacementUseGlobalSettings : bool : Read|Write\n    .mr_displacementMethod : enum : Read|Write\n       mr_displacementMethod enums: {#Fine|#Fine_NoSmoothing}\n    .mr_viewDependentDisplacement : bool : Read|Write\n    .mr_displacementEdgeLength : float : Read|Write\n    .mr_maxDisplace : float : Read|Write\n    .mr_displacementMaxLevel : integer : Read|Write\n    .mr_rcvFGIllum : bool : Read|Write\n    .mr_castModeFGIllum : enum : Read|Write\n       mr_castModeFGIllum enums: {#ObjColor|#Black|#Invisible}\n    .mr_excludeGlobalIllum : bool : Read|Write\n    .mr_excludeCaustics : bool : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeDisplayProperties\n   Properties:\n    .NeverDegrade : boolean : Read|Write\n   Methods:\n   Actions:\n  Interface: INodeShadingProperties\n   Properties:\n    .ViewportShadowCasting : bool : Read|Write\n    .ViewportIllumination : bool : Read|Write\n    .LockedViewportIllumination : bool : Read|Write\n   Methods:\n   Actions:\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7042\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7041\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7040\"></a> <span class=\"char_link\"><a href=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94.htm\">GetInterfaces Interface Inspector</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";