var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7861EA5A-81DC-4BFE-9585-1FFC08ACEDB2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"operands\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Operands</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7861EA5A-81DC-4BFE-9585-1FFC08ACEDB2\"></a><div class=\"head\">\n            <h1>Operands </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E28\"></a>  <em class=\"strong\">Operands</em>, denoted as <span class=\"code\">&lt;operand&gt;</span> in the syntax definitions, are the references to values that surround operators or\n            are passed as parameters to a function. Prime examples are <span class=\"char_link\"><a href=\"GUID-ECB4AC81-658B-4256-A31D-9C3FE78D9EB5.htm\">Literal Constants</a></span> and variable names. Operands are divided into two groups, <em class=\"strong\">Factors</em> and <em class=\"strong\">Accessors</em>. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E2A\"></a> \n            <h2><a name=\"GUID-E013329A-B28B-4D69-B5BC-A3B5E063F4AB\"></a> <em class=\"strong\">Factors</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E2B\"></a> <em class=\"strong\">Factors</em>, denoted as <span class=\"code\">&lt;factor&gt;</span> in the syntax definitions, are references to values, where the entire value is acted\n               on. A factor can be a <span class=\"char_link\"><a href=\"GUID-ECB4AC81-658B-4256-A31D-9C3FE78D9EB5.htm\">Literal Constants</a></span>, a <span class=\"char_link\"><a href=\"GUID-92E3BC56-2B85-4D54-AB88-EC0B5B23C470.htm\">Reserved Global Variable</a></span>, a variable name, or an expression. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E2C\"></a>The unary minus applies the math negate operator to its operand. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6133\"></a><pre>-&lt;operand&gt; -- unary minus</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E2E\"></a>The unary minus is only applicable to factors that evaluate to a number. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E2F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E30\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6132\"></a><pre>-0.75\nsin (-a*pi)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E36\"></a> \n            <h2><a name=\"GUID-6F6F96CB-1EA8-4A4F-BCBE-CF5C4686D939\"></a> <em class=\"strong\">Accessors</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E37\"></a> <em class=\"strong\">Accessors</em> are constructs that let you access the components in compound values, such as arrays\n               and 3D points. There are two kinds of accessors corresponding to the two kinds of\n               compound values in MAXScript: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E38\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E3A\"></a>The component values are arranged in an indexable sequence, as in arrays or strings.\n                     \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E3C\"></a>The compound value contains a fixed set of named components, as with 3D points and\n                     time intervals. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E3D\"></a>All <em class=\"strong\">3ds Max</em> objects, such as boxes, spheres, bend modifiers, or bitmap textures are treated as\n               compound values in this sense. All of their parameters, such as height and angle,\n               or map file name, are accessed as named components. In MAXScript, these named components\n               are referred to as properties. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E3E\"></a>Accessors have one of two forms, an <span class=\"code\"> <em class=\"strong\">&lt;array_index&gt;</em> </span> : \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6131\"></a><pre>&lt;operand&gt; <em class=\"codeEmphasisStrong\">[</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">]</em> -- an indexed element</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E40\"></a>or a <span class=\"code\">&lt;property&gt;</span>: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6130\"></a><pre>&lt;operand&gt;.&lt;var_name&gt; -- a named property</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E42\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E43\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-612F\"></a><pre>maps[i]\nselection[n+1]\nposition.x\nbend.angle</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";