var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-793D939B-1301-41DE-A09D-9F69E867A7D7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Birth Script Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Birth Script Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-793D939B-1301-41DE-A09D-9F69E867A7D7\"></a><div class=\"head\">\n            <h1>Birth Script Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8473F\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84740\"></a>The following example shows the default Birth_Script script with detailed comments.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84741\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84742\"></a>This script is used as the default script in the <span class=\"char_link\"><a href=\"GUID-BF55A04D-AED5-4948-A837-8D3E2C7E82DE.htm\">Birth_Script</a></span> action. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84743\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-4F8043EF-DE61-49E8-AF83-B356BF3D953A-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84744\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84745\"></a>The script generates a nice particle pattern - a helix built by a sine curve. In order\n            to see the effect of the script, you should: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84746\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84748\"></a>Create a default PF_Source in the scene from the Create Tab of <em class=\"strong\">3ds Max</em>. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8474A\"></a>Open Particle View \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8474C\"></a>Replace the Birth action with a Birth_Script action \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8474E\"></a>Delete the Speed, Position and Rotation operators. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84750\"></a>Scrub the Time \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27532E84751\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-DE6B1B3E-E8B2-4F6B-9AEC-49B852E38286-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84752\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84753\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E13\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true--enable the Time channel\npCont.useAge = true--enable the Age channel\npCont.usePosition = true--enable the Position channel\npCont.useSpeed = true--enable the Speed channel\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n(\n--Get the Start Time as float. This converts the time to ticks.\nt1 = pCont.getTimeStart() as float\n--Get the End Time as float. This converts the time to ticks.\nt2 = pCont.getTimeEnd() as float\n \n--Clamp negative time values to 0\nif (t1 &lt; 0)then(t1 = 0)\n \n--If the end time is less than 100 frames\n--(100 frames * 160 ticks per frame in 30 fps NTSC)\nif (t2 &lt; 100*160) do\n(\n--then do a loop using the time values divided by 8\n--this way a particle will be created every 8 ticks\nfor i in (t1/8+1) to (t2/8) do\n(\n--set the variable curTime to the actual time in ticks\ncurTime = 8*i as float\n--give birth to a new particle\npCont.AddParticle()\n--get the index of the last particle that was added\npCont.particleIndex = pCont.NumParticles()\n--set the current time of the particle in frames\n--(160 ticks in one frame at 30 fps NTSC animation)\npCont.particleTime = curTime/160\n--Set the age of the particle to 0 - newborn!\npCont.particleAge = 0\n--Define a radius variable based on the sine of the current time\nsh = 2*sin(5*curTime)\n--Define an angle variable based on the current time\nang = 0.2*curTime\n--Set the particle position using the above variables\npCont.particlePosition = [sh*sin(ang), sh*cos(ang), 0]\n--Define the speed using the same variables and falling down along Z\npCont.particleSpeed = [0.01*sin(ang), 0.01*cos(ang), -0.005]\n)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8479E\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8479F\"></a> <span class=\"char_link\"><a href=\"GUID-BF55A04D-AED5-4948-A837-8D3E2C7E82DE.htm\">Birth_Script : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A0\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A1\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";