var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-798DBAF9-7171-457A-95EE-FC8F2062CCBD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Controlling Program Flow</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-798DBAF9-7171-457A-95EE-FC8F2062CCBD\"></a><div class=\"head\">\n            <h1>Controlling Program Flow </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8719F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871A0\"></a> MAXScript has several <span class=\"code\">&lt;expr&gt;</span> expression forms used for explicitly controlling the flow of execution. They are:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C8\"></a><pre>\n&lt;if_expr&gt;\n&lt;case_expr&gt;\n&lt;do_loop&gt;\n&lt;while_loop&gt;\n&lt;for_loop&gt;\n&lt;loop_exit&gt;\n&lt;try_expr&gt;\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871A9\"></a>These expression forms correspond to the standard control constructs found in many\n               programming languages. Each is described in its own topic: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AA\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">If Expression</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AB\"></a> <span class=\"char_link\"><a href=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439.htm\">Case Expression</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AC\"></a> <span class=\"char_link\"><a href=\"GUID-EAD55DDE-6C7C-44CB-8BC8-34905BC05BE5.htm\">While and Do Loops</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AD\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AE\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">Loop Exit</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871AF\"></a> <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm\">Try Expression</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B0\"></a>Additionally, there are several constructs for implicitly controlling the program\n               flow. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B1\"></a>The <span class=\"code\"> <em class=\"strong\">when</em> </span> construct is used for scripting general change handlers, so you can write scripts\n               that respond to user operations such as, object moves, vertex edits, object deletions,\n               name changes, and so on. Callback mechanisms are used to have a function called when\n               certain specific events occur. See <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> for more information. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B2\"></a>The <span class=\"code\"> <em class=\"strong\">on</em> </span> construct is used when scripting rollouts, tools, or plugins, so the script can respond\n               to events that are often user-generated in those constructs. See <span class=\"char_link\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout Properties, Methods, and Event Handlers</a></span> for more information. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";