var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-79B16E83-25AB-45BC-8AE1-2DA3E3BE911B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getModContextBBoxMin()\">\n      <meta name=\"indexterm\" content=\"getModContextBBoxMax()\">\n      <meta name=\"indexterm\" content=\"setModContextBBox()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Modifier Transform Context Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-79B16E83-25AB-45BC-8AE1-2DA3E3BE911B\"></a><div class=\"head\">\n            <h1>Node Modifier Transform Context Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D62\"></a><pre><em class=\"codeEmphasisStrong\">getModContextTM</em> &lt;node&gt; &lt;modifier&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3415\"></a>Returns a Matrix3 value giving the modifier\'s context transform for the local coordinates\n            used in modifier sub-object gizmos. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3414\"></a>Accessing the transform properties of a modifier sub-object such as, a gizmo or a\n            center in MAXScript yields values that are relative to that modifier\'s context transform,\n            equivalent to the values shown in track view for those properties. If the modifier\n            is not operating on a sub-object selection such as, a face or vertex selection, or\n            if the modifier was interactively applied to an object selection, this context TM\n            is the local coordinate space of the object. However, if the modifier is operating\n            on either an object selection set or a sub-object selection, the context transform\n            gives the position and orientation of that selection, so you can use the \n            		<span class=\"code\"> <em class=\"strong\">getModContextTM()</em> </span> function to get the world-space transform properties of any of its sub-objects. \n            	 \n         </p>\n         <p><a name=\"P_D9317FAA17324012B202992D442DED4A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D61\"></a><pre><em class=\"codeEmphasisStrong\">setModContextTM</em> &lt;node&gt; &lt;modifier&gt; &lt;matrix3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3411\"></a>Sets the modifier context transformation matrix of the specified modifier on the given\n            node. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3410\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_2828E10BFCA44F92AF910ABEA4B1A38B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D60\"></a><pre><em class=\"codeEmphasisStrong\">getModContextBBoxMin</em> &lt;node&gt; &lt;modifier&gt; \n<em class=\"codeEmphasisStrong\">getModContextBBoxMax</em> &lt;node&gt; &lt;modifier&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-340A\"></a>These functions complement the \n            		<span class=\"code\"> <em class=\"strong\">getModContextTM()</em> </span> function and can be used to derive the world-space coordinates of the bounding box\n            of the modifier context. This can be used, for example, to determine the bounds of\n            a modifier operating on a sub-selection or the bounds of an FFD lattice. This is particularly\n            useful for scripting FFD control point placement because these control points live\n            in a 0-to-1 lattice space. The mod context bounding box gives the world space bounds\n            of this lattice space allowing you to compute scaled lattice space coordinates from\n            world coordinates. The functions return Point3 values for the minimum and maximum\n            extents of the bounding box. \n         </p>\n         <p><a name=\"P_EC3374686FBD499EBD9D8AF5C8438186\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D5F\"></a><pre><em class=\"codeEmphasisStrong\">setModContextBBox</em> &lt;node&gt; &lt;modifier&gt; &lt;point3 min&gt; &lt;point3 max&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3407\"></a>Sets the modifier context bounding box of the modifier on the given node to the specified\n            minimum and maximum values. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3406\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3404\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-1E2277FE-7854-4404-89A9-9D72C07CDBDB.htm\">Modifier Sub-Object Transform Properties</a></span> for examples of using the above methods. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";