var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7B851ED2-B59C-45E7-97BF-16B0A5C02971\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Function Variables</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7B851ED2-B59C-45E7-97BF-16B0A5C02971\"></a><div class=\"head\">\n            <h1>Function Variables </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8734D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8734E\"></a>  When you define a function, the following events occur: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87351\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87353\"></a>The function definition is evaluated, creating a function value. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87355\"></a>The function <span class=\"code\"> <em class=\"strong\">&lt;name&gt;</em> </span> is used to declare a new variable with that name. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87357\"></a>The function value is placed into that variable. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87359\"></a>The function value is returned as the result of the function definition expression.\n                     \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8735A\"></a>Because the function itself is a value stored in a variable, you not only can call\n               the function through the function name variable. By simply referring the function\'s\n               variable you can also assign the function value to another variable, store it in an\n               array, or pass it as an argument to another function. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8735B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8735C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-609E\"></a><pre>\nsurface_functions=#()\nfn build_math_mesh x = print \"build math mesh\"\n\n-- some 3D surface functions\nfn saddle x y = sin x * sin y\nfn sombrero x y = cos (x^2 + y^2) / (1 + (x^2 + y^2))\nprint (saddle 1 1) -- try one out\nsurface_functions[1] = saddle -- store the functions in an array\nsurface_functions[2] = sombrero\n-- call one of them from within the array:\nz = (surface_functions[1]) 10 10\n-- pass one in to a higher-order function:\nbuild_math_mesh sombrero\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8736A\"></a>The scope of a function variable is the current MAXScript scope context. The variables\n               used inside a function have a local scope, unless the variable was already defined\n               at a higher scope or is declared as global in the function. An exception to this is\n               the function parameter variables, which always have a local scope. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8736B\"></a>When writing scripts, it is <em class=\"strong\">good programming practice</em> to <em class=\"strong\">explicitly declare your local and global variables</em>. Implicit declaration is provided as a short-hand, typically used when working in\n               the Listener interactively or developing short scripts. When developing extended scripts,\n               explicitly declaring variables can reduce errors and improve readability of the code.\n               It is also recommend that you declare as local all variables unless you really want\n               them to be global variables. The reasons for this are described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8736C\"></a>If a function variable is assigned to another variable, a reference to the function\n               value is stored in that variable. Thus while a function variable may no longer be\n               in scope, the function itself still is if the variable it is assigned to has a scope\n               that extends outside the current MAXScript scope context. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8736D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8736E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-609D\"></a><pre>\nfn funcA which =\n(\nif which == 1 then\nfn saddle x y = sin x * sin y\nelse\nfn sombrero x y = cos (x^2 + y^2) / (1 + (x^2 + y^2))\n)\nmyfunc=funcA 2\nz=myfunc 10 10\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8737A\"></a><p class=\"table-body\">In the above example, the scope of variables <span class=\"code\"> <em class=\"strong\">saddle</em> </span> and <span class=\"code\"> <em class=\"strong\">sombrero</em> </span> is local to <span class=\"code\"> <em class=\"strong\">funcA</em> </span>, and the variables are out of scope outside the function. The return value of <span class=\"code\"> <em class=\"strong\">funcA</em> </span> is either the function value <span class=\"code\"> <em class=\"strong\">saddle()</em> </span> or <span class=\"code\"> <em class=\"strong\">sombrero()</em> </span>, and is assigned to variable <span class=\"code\"> <em class=\"strong\">myfunc</em> </span>. As also can be seen in this example, you can define a function within any expression.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8737D\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8737E\"></a> <span class=\"char_link\"><a href=\"GUID-26009A1A-50AF-4ED7-AECA-8CB60D11A1A5.htm\">Function Calls</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";