var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7C91D285-5683-4606-9F7C-B8D3A7CA508B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NodeEventCallback()\">\n      <meta name=\"indexterm\" content=\"Node Event System\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Event System</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7C91D285-5683-4606-9F7C-B8D3A7CA508B\"></a><div class=\"head\">\n            <h1>Node Event System </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-198D\"></a>The \n            		<em class=\"strong\">Node Event System</em> available in \n            		<em class=\"strong\">3ds Max 2009 and higher</em> lets you define a scripted function that is triggered in response to any of various\n            node-related scene events. The events map one-to-one with the event methods of class\n            \n            		<em class=\"strong\">INodeEventCallback</em> in the \n            		<em class=\"strong\">3ds Max SDK</em>. For detailed information on each, read the methods comments for class \n            		<em class=\"strong\">INodeEventCallback</em> in \n            		<em class=\"strong\">maxsdk\\include\\ISceneEventManager.h</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-198B\"></a>The Node Event System is similar to the \n            		<span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span>. It operates as a layer over the General Event Callback system, but also receives\n            some node messages which the older system cannot handle, like geometry, topology and\n            mapping changes. This system will also catch events which happen as a result of undo/redo,\n            while the older system sometimes would not. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-198A\"></a>Thus, if you wish to catch nodes-related events and changes to nodes, the Node Event\n            System is your best option. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7554\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The Node Event System is \n               		<em class=\"strong\">inappropriate</em> for catching any events except those specifically related to \n               		<em class=\"strong\">scene nodes</em>. It is mainly intended to be used with a UI (such as a scripted plug-in). The system\n               is timer based, so it requires the Windows message loop to be running, which means\n               its use in a script without a UI can be problematic. \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_649D0C32444E49F8BFFC288368BDACA7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1986\"></a> <em class=\"strong\">Contructor:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6933\"></a><pre>&lt;callbackItem&gt;<em class=\"codeEmphasisStrong\">NodeEventCallback</em> [<em class=\"codeEmphasisStrong\">mouseUp</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">delay</em>:&lt;integer&gt;] \\\n[<em class=\"codeEmphasisStrong\">enabled</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">polling</em>:&lt;bool&gt;] \\\n[<em class=\"codeEmphasisStrong\">callbackBegin</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">all</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">added</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">deleted</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">linkChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">layerChanged</em>:&lt;fn&gt;]\\\n[<em class=\"codeEmphasisStrong\">groupChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">hierarchyOtherEvent</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">modelStructured</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">geometryChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">topologyChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">mappingChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">extentionChannelChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">modelOtherEvent</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">materialStructured</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">materialOtherEvent</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">controllerStructured</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">controllerOtherEvent</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">nameChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">wireColorChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">renderPropertiesChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">displayPropertiesChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">userPropertiesChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">propertiesOtherEvent</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">subobjectSelectionChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">selectionChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">hideChanged</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">freezeChanged</em>:&lt;fn&gt;] \\\n[<em class=\"codeEmphasisStrong\">displayOtherEvent</em>:&lt;fn&gt;] [<em class=\"codeEmphasisStrong\">callbackEnd</em>:&lt;fn&gt;] 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1975\"></a>The example script below prints a message to the MAXScript Listener when any message\n            is received by registering a function to the optional keyword argument \n            		<span class=\"code\"> <em class=\"strong\">all:</em> </span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1974\"></a>The script also displays a message box when the \n            		<span class=\"code\"> <em class=\"strong\">linkChanged:</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">layerChanged:</em> </span> event occurs, that is, whenever one node is linked or unlinked from another node,\n            or moved to a different layer. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1972\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1971\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6932\"></a><pre>\n--Define a callback function to handle linking and layer changes:\nfn CallbackFn1 ev nd = (\nmessageBox (\"Event Detected: Event \"+(ev as string)+ \\\n\", Nodes \" + (nd as string))\n)\n--Define a callback function to handle ALL messages:\nfn CallbackFn2 ev nd = (\nformat \"Event Detected: Event%, Nodes %\\n\" ev nd )\n--Register callbacks for link changes, layer changes using the\n--first function and for all changes using the second function.\n--Act only when mouse is up and there have been no other events\n--within one second (1000 milliseconds):\ncallbackItem = NodeEventCallback mouseUp:true delay:1000 linkChanged:CallbackFn1 layerChanged:CallbackFn1 all:CallbackFn2\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-195E\"></a> <em class=\"strong\">Destructor:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-195D\"></a>When the \n            		<span class=\"code\"> <em class=\"strong\">NodeEventCallback()</em> </span> constructor is called, an instance of the class is created and returned as the result\n            of the call. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-195C\"></a>To release this instance and thus remove the callback, the value of the variable holding\n            the handler to the instance has to be set to undefined and the garbage collector must\n            be called to reclaim the memory and effectively destroy the callback. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-195B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-195A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6931\"></a><pre>\n--Continuing the previous example where the variable\n--callbackItem was used to store the callback instance,\ncallbackItem = undefined\ngc light:true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1952\"></a> \n            <h2><a name=\"GUID-2A7B2F71-35E8-41B3-9688-113406EE3C15\"></a> <em class=\"strong\">Handling optional keyword parameters:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6930\"></a><pre><em class=\"codeEmphasisStrong\">mouseup:</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1950\"></a>If the optional keyword argument \n               		  <span class=\"code\"><em class=\"strong\">mouseUp:</em></span> is set to \n               		  <span class=\"code\"><em class=\"strong\">true</em></span>, the callback will only be triggered when the mouse button is released. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692F\"></a><pre><em class=\"codeEmphasisStrong\">delay:</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-194D\"></a>When the optional keyword argument \n               		  <span class=\"code\"><em class=\"strong\">delay:</em></span> is supplied (as time in milliseconds), the callback is only triggered if the given\n               time passes with no events, that is, only after the system is idle for the specified\n               time. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">polling:</em> </pre></div> \n            <p> When the optional keyword argument \n               		  <span class=\"code\"><em class=\"strong\">polling:</em></span> is set to true, the pending events for the \n               		  <span class=\"code\">NodeEventCallbackValue</span> can be fired by calling \n               		  <span class=\"code\">triggerNodeEventCallback()</span>. Available in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. The \n               		  <em class=\"strong\">polling</em> argument cannot be used if either \n               		  <em class=\"strong\">mouseUp</em> or \n               		  <em class=\"strong\">delay</em> are specified. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-194C\"></a> \n            <h2><a name=\"GUID-31677C29-ADE1-476E-AD13-EAE8621A076A\"></a> <em class=\"strong\">Callback Function optional keyword parameters:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-194B\"></a>One or more of the other optional keyword arguments can be supplied with pre-defined\n               MAXScript Functions to be executed if a callback of the specified type is found in\n               the message received by the Node Event System. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1949\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1948\"></a><p class=\"table-body\"> <em class=\"strong\">IMPORTANT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1947\"></a><p class=\"table-body\">The callback functions \n                           						<em class=\"strong\">always</em> take \n                           						<em class=\"strong\">two parameters</em>: the first is the event name that triggered the function call, the second is a list\n                           of node \n                           						<span class=\"char_link\"><a href=\"GUID-25211F97-E81A-4D49-AFB6-50B30894FBEB.htm\">AnimHandles</a></span>. \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1946\"></a><p class=\"table-body\">The \n                           						<span class=\"code\"> <em class=\"strong\">GetAnimByHandle()</em> </span> method must be used to get the node itself. \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1945\"></a><p class=\"table-body\">If the specified function does not expect two arguments, an error will be thrown.\n                           For example, if the function ObjFn is passed but it does not provide any arguments,\n                           the error will look like \n                           					 \n                        </p> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692E\"></a><pre>\n&gt;&gt; MAXScript NodeEventCallback Exception: -- Argument count error: ObjFn wanted 0, got 2 &lt;&lt;\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1943\"></a><p class=\"table-body\">From the text of the error one could incorrectly assume that the function was correct\n                           and the callback was wrong, but this is not the case. \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1942\"></a><p class=\"table-body\">The callback always passes the two arguments, but if the function is unable to accept\n                           them, the error message simply reflects that fact as it has no knowledge what called\n                           the function and why it passed two parameters to it. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1940\"></a> \n               <h3><a name=\"GUID-AC7CAA29-ABE9-4D90-B1CE-52C2549CA530\"></a> <em class=\"strong\">Callback Batch Handling:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692D\"></a><pre><em class=\"codeEmphasisStrong\">callbackBegin</em>:   \n<em class=\"codeEmphasisStrong\">callbackEnd</em>: </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-193D\"></a>When a callback is triggered, messages for all queued events will be sent in \n                  			 <em class=\"strong\">one batch</em>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-193C\"></a>The \n                  			 <span class=\"code\"> <em class=\"strong\">callbackBegin:</em> </span> message indicates the start of a batch, while \n                  			 <span class=\"code\"> <em class=\"strong\">callbackEnd:</em> </span> indicates the end of a batch. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-193B\"></a>Registering functions using these two optional keyword arguments lets you get notification\n                  of the beginning and the end of a single message batch. \n                  		  \n               </p> \n               <p><a name=\"P_A8CF5BEA68634B8D92E0365BCAA5E945\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692C\"></a><pre><em class=\"codeEmphasisStrong\">all:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1938\"></a>The supplied function will be called whenever ANY of the node-related messages listed\n                  below has been received. Note that this function is called in addition to any event-specific\n                  functions that have been registered. The \n                  			 <span class=\"code\"><em class=\"strong\">all</em></span> function is called first. \n                  		  \n               </p> \n               <p><a name=\"P_E7E99E4CA87C4863BDCCBE55E5927099\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1937\"></a> \n               <h3><a name=\"GUID-FA2937CC-FC37-44C7-B476-91D7388EF017\"></a> <em class=\"strong\">Node Creation and Removal Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692B\"></a><pre><em class=\"codeEmphasisStrong\">added:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1935\"></a>The supplied function will be called whenever a node has been added to the scene.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_070B92C2512043CE94A597625A9D1E49\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-692A\"></a><pre><em class=\"codeEmphasisStrong\">deleted:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1932\"></a>The supplied function will be called whenever a node has been deleted from the scene.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_DE8206678BD64B0E8DF4AF00E183AEC7\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1931\"></a> \n               <h3><a name=\"GUID-6EEA74AF-B11C-4737-A762-5BAF7C29BE5E\"></a> <em class=\"strong\">Node Hierarchy, Layer and Group Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6929\"></a><pre><em class=\"codeEmphasisStrong\">linkChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-192F\"></a>The supplied function will be called whenever the node is linked to or unlinked from\n                  another node. \n                  		  \n               </p> \n               <p><a name=\"P_F79DAF57FC9B4E7686B5F90433F62357\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6928\"></a><pre><em class=\"codeEmphasisStrong\">layerChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-192C\"></a>The supplied function will be called whenever the node has moved to another layer.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_7F3F2A70FF7342A8909B400B0F0B90A5\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6927\"></a><pre><em class=\"codeEmphasisStrong\">groupChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1929\"></a>The supplied function will be called whenever the node has been added or removed from\n                  a group. \n                  		  \n               </p> \n               <p><a name=\"P_51826675C1AC4A678C42868C4955911A\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6926\"></a><pre><em class=\"codeEmphasisStrong\">hierarchyOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1926\"></a>The supplied function will be called whenever the node\'s hierarchy has been changed\n                  in some other way. \n                  		  \n               </p> \n               <p><a name=\"P_EFDDBF3E9F3243358C75743612EDA254\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1925\"></a> \n               <h3><a name=\"GUID-93B124BF-1A3A-458B-8ACE-74636C17E95B\"></a> <em class=\"strong\">Node Model, Geometry, Topology and Mapping Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6925\"></a><pre><em class=\"codeEmphasisStrong\">modelStructured:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1923\"></a>The supplied function will be called whenever the model\'s structure has been modified.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_8BAB06ED2F764EBA8729C14068B37759\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6924\"></a><pre><em class=\"codeEmphasisStrong\">geometryChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1920\"></a>The supplied function will be called whenever the geometry of the node has changed,\n                  for example a vertex has been moved. \n                  		  \n               </p> \n               <p><a name=\"P_2B8E4AEFE2D54C2F9CDD35CCFD350B08\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6923\"></a><pre><em class=\"codeEmphasisStrong\">topologyChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-191D\"></a>The supplied function will be called whenever the topology of the node\'s geometry\n                  has changed, for example an edge has been added or removed. \n                  		  \n               </p> \n               <p><a name=\"P_7F50E88BBF2C4920AFDE70C880C8AC25\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6922\"></a><pre><em class=\"codeEmphasisStrong\">mappingChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-191A\"></a>The supplied function will be called whenever the mapping of the node\'s geometry has\n                  changed, for example UV coordinates have been assigned or modified. \n                  		  \n               </p> \n               <p><a name=\"P_518920BA08024E0585FC6DE3ED4D8AE3\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6921\"></a><pre><em class=\"codeEmphasisStrong\">extentionChannelChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1917\"></a>The supplied function will be called whenever the a non-mapping channel of the node\n                  has been changed, for example Vertex Alpha, Soft-Selection and so on. \n                  		  \n               </p> \n               <p><a name=\"P_FC3EEFFEFFC149F49F68DB290FE81818\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6920\"></a><pre><em class=\"codeEmphasisStrong\">modelOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1914\"></a>The supplied function will be called whenever the node\'s model has been changed in\n                  some other way. \n                  		  \n               </p> \n               <p><a name=\"P_49EEBE56B4874210AFCF697EB851EAE8\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1913\"></a> \n               <h3><a name=\"GUID-6310E0FA-3873-407C-B1AB-70B193498E4A\"></a> <em class=\"strong\">Node Material Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691F\"></a><pre><em class=\"codeEmphasisStrong\">materialStructured:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1911\"></a>The supplied function will be called whenever a material has been added or removed\n                  from the node. \n                  		  \n               </p> \n               <p><a name=\"P_13BFE404D45B4708828629B9825ADDDE\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691E\"></a><pre><em class=\"codeEmphasisStrong\">materialOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-190E\"></a>The supplied function will be called whenever the node\'s material has been changed.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_A99CB264690F43C6B2D52873222B597E\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-190D\"></a> \n               <h3><a name=\"GUID-34F95A3F-2C1F-4C81-BF4D-EF841EF45EF7\"></a> <em class=\"strong\">Node Controller Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691D\"></a><pre><em class=\"codeEmphasisStrong\">controllerStructured:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-190B\"></a>The supplied function will be called whenever a controller has been assigned or removed\n                  to a SubAnim track of the node. \n                  		  \n               </p> \n               <p><a name=\"P_87B30F4D4EC748FB9129AD23FA0A8AF0\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691C\"></a><pre><em class=\"codeEmphasisStrong\">controllerOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1908\"></a>The supplied function will be called whenever a node\'s controller has been changed\n                  in another way. \n                  		  \n               </p> \n               <p><a name=\"P_1E4BC9562F534AD49DD235139C32C086\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1907\"></a> \n               <h3><a name=\"GUID-B3A11701-E1D0-4450-B11D-187B2A3A8B86\"></a> <em class=\"strong\">Node Name and Properties Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691B\"></a><pre><em class=\"codeEmphasisStrong\">nameChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1905\"></a>The supplied function will be called whenever the name of the node has been changed.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_B83EC9CE1CF348559951B7D13FB459E5\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-691A\"></a><pre><em class=\"codeEmphasisStrong\">wireColorChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1902\"></a>The supplied function will be called whenever the wireframe color of the node has\n                  been changed. \n                  		  \n               </p> \n               <p><a name=\"P_5DE3C46E59D646C3AC9F9F0C8B89C523\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6919\"></a><pre><em class=\"codeEmphasisStrong\">renderPropertiesChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18FF\"></a>The supplied function will be called whenever the Render Properties of the node has\n                  been changed, including Renderable, Visible To Camera, Visible To Reflections and\n                  so on. \n                  		  \n               </p> \n               <p><a name=\"P_721ED07F13D045B3BB0CE878F7DFEF51\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6918\"></a><pre><em class=\"codeEmphasisStrong\">displayPropertiesChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18FC\"></a>The supplied function will be called whenever a display property of the node has been\n                  changed, for example \"Display As Box\", \"Show Vertex Ticks\", \"Backface Culling\" and\n                  so on. \n                  		  \n               </p> \n               <p><a name=\"P_B5384BD0BC354AE589FD70D0E1A1030A\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6917\"></a><pre><em class=\"codeEmphasisStrong\">userPropertiesChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18F9\"></a>The supplied function will be called whenever the User Properties buffer of the node\n                  has been changed. \n                  		  \n               </p> \n               <p><a name=\"P_43C8798792DC46269A202D81ED9884F2\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6916\"></a><pre><em class=\"codeEmphasisStrong\">propertiesOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18F6\"></a>The supplied function will be called whenever any other properties of a node have\n                  been changed. \n                  		  \n               </p> \n               <p><a name=\"P_CD41249DE4054DB999398ADFA2D6E434\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18F5\"></a> \n               <h3><a name=\"GUID-F44FBC3C-9C88-4DFB-8911-68D0327BAB29\"></a> <em class=\"strong\">Node Selection Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6915\"></a><pre><em class=\"codeEmphasisStrong\">subobjectSelectionChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18F3\"></a>The supplied function will be called whenever the sub-object selection of a node has\n                  changed. \n                  		  \n               </p> \n               <p><a name=\"P_1736754916BC4B6BB093C840163BE46D\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6914\"></a><pre><em class=\"codeEmphasisStrong\">selectionChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18F0\"></a>The supplied function will be called whenever the selected state of the node has changed,\n                  for example a node has been selected or deselected. \n                  		  \n               </p> \n               <p><a name=\"P_24571536C9AF442EBE9033E3049E4ACB\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18EF\"></a> \n               <h3><a name=\"GUID-D1ADE1A5-2118-43D1-91DB-E999E4458173\"></a> <em class=\"strong\">Node Display Callbacks:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6913\"></a><pre><em class=\"codeEmphasisStrong\">hideChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18ED\"></a>The supplied function will be called whenever the Hidden flag of a node has changed.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_712A79DD6F474148AACE9AC53133EDBB\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6912\"></a><pre><em class=\"codeEmphasisStrong\">freezeChanged:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18EA\"></a>The supplied function will be called whenever the Frozen flag of a node has changed.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_E2D3F39789F94B53AE050A60806B7804\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6911\"></a><pre><em class=\"codeEmphasisStrong\">displayOtherEvent:</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18E7\"></a>The supplied function will be called whenever other display flags of a node have changed.\n                  \n                  		  \n               </p> \n               <p><a name=\"P_E1E55D4E718F4D5CB686B3754EE8F045\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_A7BE7D1D905B4AF8BD81C7E396F66E95\"></a> \n            <h2><a name=\"GUID-1CB4D5C3-F99F-4946-9238-EFCFDC795970\"></a>Related Functions\n            </h2> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">triggerNodeEventCallback</em> &lt;NodeEventCallbackValue&gt;</pre></div> \n            <p> \n               		   Triggers the pending events for the specified NodeEventCallbackValue. Available\n               in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. This function works for \n               		  <span class=\"code\">NodeEventCallbackValues</span> with \n               		  <span class=\"code\"><em class=\"strong\">polling</em></span> specified as true. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>&lt;array&gt; <em class=\"codeEmphasisStrong\">getNodeEventCallbacks</em> </pre></div> \n            <p> Gets an array of all registered NodeEventCallback values in the current scene. Available\n               in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">showNodeEventCallbacks</em> [<em class=\"codeEmphasisStrong\">asArray</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [</pre></div> \n            <p> Returns information about all registered NodeEventCallback values in the current\n               scene, including the \n               		  <em class=\"strong\">enabled</em>, \n               		  <em class=\"strong\">polling</em>, \n               		  <em class=\"strong\">mouseUp</em>, and \n               		  <em class=\"strong\">delay</em> settings, the eventIds registered and the functions associated with those events,\n               and the script file name that created the NodeEventCallback. Available in <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. \n               		\n            </p> \n            <p>If the optional \n               		  <em class=\"strong\">asArray</em> keyword parameter is specified as true, this information is returned as an array\n               of strings, one for each NodeEventCallback. Otherwise it is a single string. \n               		\n            </p> \n            <p>If the optional \n               		  <em class=\"strong\">to</em> keyword parameter is specified, the output is written to the specified stream. \n               		\n            </p> \n            <p> </p> <a name=\"TABLE_7F274DD88CC741F58041586F7C5EE059\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">For Example \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>poll_event_count = 0\n\nfn runExample = (\n	-- reset the scene\n	resetMaxFile #noprompt --reset the scene\n	gc() -- run gc again to clean out previous runs\n\n	--Define a callback function to handle ALL messages:\n	fn MyCallback ev nd = (format \"Event Detected: Event%, Nodes %\\n\" ev nd )\n\n	fn MyPollCallback ev nd = 	(\n		format \"Event Detected: Event%, Nodes %\\n\" ev nd\n		poll_event_count += 1 )\n\n	-- Create callback item\n	callbackItem = NodeEventCallback added:MyCallback \n	pollCallBackItem = NodeEventCallback added:MyPollCallback	\n\n	-- add something, which will trigger the first callback, but not the second:\n	t = teapot()\n\n	-- this will still be 0, because polling is on:\n	format \"poll events: % \\n\" poll_event_count\n		\n	-- trigger polling callback\n	triggerNodeEventCallback pollCallBackItem\n\n	-- node event system is timer based, and requires\n	-- message pump system.  This will give the system\n	-- time to \"catch up\", since we do not have a UI\n	windows.processpostedmessages();sleep .1\n	windows.processpostedmessages()\n\n	-- did it trigger?\n	format \"poll events: % \\n\" poll_event_count\n		\n	showNodeEvents = showNodeEventCallbacks asArray:true\n	format \"showNodeEventCallbacks : % \\n\" showNodeEvents\n\n	getNodeEvents = getNodeEventCallbacks()\n	format \"Number of event callbacks: %\\n\" getNodeEvents.count\n	for i = 1 to getNodeEvents.count do format \"Callback % : % \\n\" i getNodeEvents[i]\n		\n	-- delete the callback items, and garbage collect:\n	callbackItem = pollCallbackItem = undefined\n	gc()\n\n)\n\nrunExample()\n\n--&gt; Output:\nrunExample()\npoll events: 0 \nEvent Detected: Event#added, Nodes #(6772)\nEvent Detected: Event#added, Nodes #(6772)\npoll events: 1 \nshowNodeEventCallbacks : #(#(NodeEventCallback&lt;0x000001A535A18210&gt;, #added, \"MyPollCallback\", \\\n \"D:\\My Documents\\3ds Max\\scripts\\NodeEventCallbacksEx.ms\"), #(NodeEventCallback&lt;0x000001A535A229F4&gt;,\\\n #added, \"MyCallback\", \"D:\\My Documents\\3ds Max\\scripts\\NodeEventCallbacksEx.ms\")) \nNumber of event callbacks: 2\nCallback 1 : NodeEventCallback&lt;0x000001A535A18210&gt; \nCallback 2 : NodeEventCallback&lt;0x000001A535A229F4&gt; \n482872L\nOK</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div><a name=\"TABLE_A15A01D6AD844090ACFF72483B591E1A\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.6900369003690034%\">\n                  <col width=\"41.25461254612546%\">\n                  <col width=\"55.055350553505534%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\" valign=\"middle\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\" valign=\"middle\"> <a name=\"P_F9F79863295744AC92140F5BAB992D95\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                        				  \n                     </p> <a name=\"P_92463B3BC8554507B8CB0B646CEEC790\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Callback Notifications - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18E3\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18E2\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18E0\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";