var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7D83837E-8ACC-4B4F-A9E1-DBA71C59C950\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"precedence\">\n      <meta name=\"indexterm\" content=\"association rules\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Precedence and Association Rules</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7D83837E-8ACC-4B4F-A9E1-DBA71C59C950\"></a><div class=\"head\">\n            <h1>Precedence and Association Rules </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E7B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E7C\"></a>  As in mathematics, a sequence of operands and operators is evaluated according to\n               a set of precedence and association rules. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E7F\"></a>The following table shows sample expressions and their order of evaluation: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E80\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"33.333333333333336%\">\n                     <col width=\"33.333333333333336%\">\n                     <col width=\"33.333333333333336%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E81\"></a><p class=\"table-body\"> <em class=\"strong\">Expression</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E82\"></a><p class=\"table-body\"> <em class=\"strong\">Order of evaluation</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E83\"></a><p class=\"table-body\"> <em class=\"strong\">Note</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">a + b * c</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">a + (b * c)</span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E86\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">a + b - c</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">(a + b) - c</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">&nbsp;</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">a ^ b ^ c</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">a ^ (b ^ c)</span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E8C\"></a><p class=\"table-body\">exponentiation, raise to the power </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E8E\"></a>The evaluation order in the previous table follows standard precedence rules, where\n               <span class=\"code\"> <em class=\"strong\">*</em> </span> and <span class=\"code\"> <em class=\"strong\">/</em> </span> operations are evaluated before <span class=\"code\"> <em class=\"strong\">+</em> </span> and <span class=\"code\"> <em class=\"strong\">-</em> </span> operations, and where <span class=\"code\"> <em class=\"strong\">+</em> </span> and <span class=\"code\"> <em class=\"strong\">-</em> </span> operations associate to the left (that is, operands on the left are evaluated before\n               operands on the right) and exponentiation operations associate to the right (that\n               is, operands on the right are evaluated before operands on the left). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E8F\"></a>These precedence rules define the ordering of evaluation in all expressions in MAXScript,\n               unless parenthesizing is used to force a different order. Expressions in parenthesis\n               are evaluated before the surrounding operands are applied. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E90\"></a>The following list shows the <em class=\"strong\">precedence order</em> for <em class=\"strong\">math expressions</em> starting with the highest precedence: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E91\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6128\"></a><pre>&lt;operand&gt;</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6127\"></a><pre>&lt;function_call&gt;</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6126\"></a><pre>as</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6125\"></a><pre><em class=\"codeEmphasisStrong\">^</em> -- right associative</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6124\"></a><pre><em class=\"codeEmphasisStrong\">*</em> and <em class=\"codeEmphasisStrong\">/</em> -- left associative</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6123\"></a><pre><em class=\"codeEmphasisStrong\">+</em> and <em class=\"codeEmphasisStrong\">-</em> -- left associative</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E9A\"></a> <span class=\"char_link\"><a href=\"GUID-DF143835-008F-4753-9674-BB7B02DCDE51.htm\">Function Precedence</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";