var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7DED5D97-5679-4FA8-8048-F482999394BD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"numPoints()\">\n      <meta name=\"indexterm\" content=\"getPointPos()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Deformable Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7DED5D97-5679-4FA8-8048-F482999394BD\"></a><div class=\"head\">\n            <h1>Node Deformable Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3DDCBAB2212B7835B3AF-7CC7\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D5E\"></a><pre><em class=\"codeEmphasisStrong\">isDeformable</em> &lt;node&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33FE\"></a>Returns true if the node\'s object is deformable. Available in \n               		  <em class=\"strong\">3ds Max 2008 and higher</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33FA\"></a> <em class=\"strong\">What are deformable objects?</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F9\"></a>A deformable object is an object with points that can be modified. Internally, these\n               points can be stored in any form the object wants. They are accessed through a virtual\n               array interface with methods to get and set the \'i-th\' point. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F8\"></a>This abstraction layer allows \n               		  <em class=\"strong\">3ds Max</em> to apply the same modifiers to the various Geometry classes like Editable Meshes,\n               Editable Poly, Splines, Patches, and Nurbs without specific knowledge of the internal\n               structures of these classes. The modifier simply operates on points provided by the\n               object using the virtual array interface methods, but these points can be vertices,\n               Bezier spline knots and tangents, Patch knots and tangents, and so on. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F7\"></a>See the \n               		  <span class=\"char_link\"><a href=\"GUID-3FB57157-0112-4617-9532-014B9CECC98E.htm\">simpleMod Scripted Plugin</a></span> for a scripted modifier that can operate on points in this manner by implementing\n               the \n               		  <span class=\"code\"> <em class=\"strong\">\'on map &lt;index&gt; &lt;point&gt; do\'</em> </span> handler. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AED\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F3\"></a>While isDeformable might return true for some nodes, this does not necessarily mean\n                     that they can be deformed. For example, all legacy particle systems like Snow, Superspray,\n                     and Blizzard return true, but are not affected by deformations, while all geometry\n                     primitives return false, but can be deformed. \n                     		  \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F2\"></a>The method simply wraps the SDK method and returns the value provided by the object\n                     when asked wether it is deformable or not. \n                     		  \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33F0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33EF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D5D\"></a><pre>\nfor g in geometryClass.classes do\n(\n try\n (\n o = execute (g as string +\"()\")\n if isDeformable o then\n format \"% is Deformable.\\n\" g\n else\n format \"% is NOT Deformable.\\n\" g\n )catch(format \"Failed To Create %\\n\" g)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_C2E192D239774FB8B5DE70AA308F3E8E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D5C\"></a><pre><em class=\"codeEmphasisStrong\">numPoints</em> &lt;node&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33DE\"></a>Returns the number of deformable points for the node\'s object. Available in \n               		  <em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n               		  <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            </p> \n            <p><a name=\"P_358484B5752443B68E36C3FD320ED4AF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D5B\"></a><pre><em class=\"codeEmphasisStrong\">getPointPos</em> &lt;node&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33DB\"></a>Returns the position of the indexed point for the node\'s object. Position is returned\n               in current coordinate system. Available in \n               		  <em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n               		  <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";