var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-7F26EC19-6C56-4580-B6C3-C51ACC8E4356\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"PathConfig Struct\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>PathConfig Struct</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7F26EC19-6C56-4580-B6C3-C51ACC8E4356\"></a><div class=\"head\">\n            <h1>PathConfig Struct </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-212D\"></a> The \n            		<em class=\"strong\">PathConfig</em> struct provides methods to access and manage Project paths, System paths, manipulate\n            paths and convert between UNC, absolute and relative paths and so on. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-212B\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher. \n               		</em> \n         </p>\n         <p><a name=\"GUID-7ED260E6-E010-475D-A618-975CFA36856C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-212A\"></a> \n            <h2><a name=\"GUID-D3CCAB3F-3A7D-46F6-82D2-F0CFF8FA7779\"></a> <em class=\"strong\">Project Folder</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A26\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.doProjectSetupSteps()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2128\"></a>Performs all steps necessary to set up a new Project, including browsing for project\n               folder and creating all sub-folders. Returns true on success, false if cancelled.\n               \n               		\n            </p> \n            <p><a name=\"GUID-2DEBC27E-9B6C-4206-A8B2-CCEB42C209E4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A25\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.doProjectSetupStepsUsingDirectory</em> &lt;ProjectPath&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2125\"></a>Performs all steps necessary to set up a new Project using the supplied Project Path\n               as the Root. Returns true on success, false if cancelled. \n               		\n            </p> \n            <p><a name=\"GUID-90372C82-D851-42DD-910C-7FCED2E7B85B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A24\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.getCurrentProjectFolder()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2122\"></a>Returns the current Project Folder. \n               		\n            </p> \n            <p><a name=\"GUID-E58863EF-18C6-4402-8F37-B1AAD3DCAA9C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A23\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.getCurrentProjectFolderPath()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-211F\"></a>Returns the current Project Folder definition file (*.MXP). \n               		\n            </p> \n            <p><a name=\"GUID-262D12B3-DDD5-4B02-85A8-EC1774209C03\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A22\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.getProjectFolderPath</em> &lt;ProjectPath&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-211C\"></a>Returns the Project Definition filename (&lt;ProjectPath&gt;\\&lt;ProjectName&gt;.mxp) for the\n               specified Project Folder. \n               		\n            </p> \n            <p><a name=\"GUID-06F8C76D-8549-499B-BCA3-97E2C173D8B3\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A21\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.getProjectSubDirectory</em> &lt;subdir_index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2119\"></a>Returns the indexed Project sub-directory. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2118\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2117\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A20\"></a><pre>\n--Print all Project Sub-Directories:\nfor i = 1 to pathConfig.getProjectSubDirectoryCount() do\nformat \"%: %\\n\" i (pathConfig.getProjectSubDirectoryi)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-5DC8B7DF-0897-4500-8E2B-3B88372D437A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1F\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.getProjectSubDirectoryCount()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-210E\"></a>Returns the number of Project sub-directories. See above example. \n               		\n            </p> \n            <p><a name=\"GUID-CA7A8B30-8482-44FF-8174-AC7D3662D97D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1E\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.addProjectDirectoryCreateFilter</em> &lt;#directory_type&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-210B\"></a>Adds Project Directory Filter where \n               		  <span class=\"code\">&lt;directory_type&gt;</span> is one of the following: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-210A\"></a><pre> <em class=\"codeEmphasisStrong\">#font | #Scene | #export | #import | #help | #expression | #preview | #image | #Sound | #plugcfg | #maxstart | #vpost | #drivers | #autoback | #matlib | #scripts | #startupScripts | #defaults | #renderPresets | #ui | #maxroot | #renderoutput | #animations | #archives | #Photometric | #renderassets | #userScripts | #userMacros | #userStartupScripts | #temp | #userIcons | #maxData | #downloads | #proxies</em> </pre></div> \n            <p><a name=\"GUID-1BBF4827-276D-48A7-9960-2ABA7213B7A7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">pathConfig.removeProjectDirectoryCreateFilter</em> &lt;#directory_type&gt;</pre></div> \n            <p> Removes the specified Project Directory Filter where \n               		  <span class=\"code\">&lt;directory_type&gt;</span> is one of those listed for \n               		  <span class=\"code\">addProjectDirectoryCreateFilter()</span>.\n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1D\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.removeAllProjectDirectoryCreateFilters()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2107\"></a>Removes all filters added using \n               		  <span class=\"code\"> <em class=\"strong\">pathConfig.addProjectDirectoryCreateFilter()</em> </span> \n            </p> \n            <p><a name=\"GUID-CD32F22E-88EF-4105-B5DA-69BE4C8D3D9B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">pathConfig.getProjectDirectoryCreateFilters()</em> </pre></div> \n            <p> Returns an array of the currently set Project Directory Filters. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1C\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.setCurrentProjectFolder</em> &lt;ProjectPath&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2104\"></a>Sets the current project folder to the given path. The Project Folder is displayed\n               in the title bar of \n               		  <em class=\"strong\">3ds Max</em> and will be updated instantly. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2103\"></a> \n            <h2><a name=\"GUID-F6D86210-C808-472E-A870-C2FFB589075D\"></a> <em class=\"strong\">Path Manipulation, Conversion and Resolving</em> \n            </h2> \n            <p><a name=\"GUID-7116119A-169A-4E96-B128-5372E95A0EC8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1B\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.appendPath</em> &lt;path1&gt; &lt;path2&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2101\"></a>Appends the second argument filename to the first argument path, adding backslash\n               if necessary. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2100\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20FF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A1A\"></a><pre>\npathConfig.appendPath \"c:\\\\temp\" \"test.txt\"\n\"c:\\temp\\test.txt\"\npathConfig.appendPath \"c:\\\\temp\\\\\" \"test\"\n\"c:\\temp\\test\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-925FC7DB-7266-4CCB-A84F-C11EA0D953BB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A19\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.convertPathToAbsolute</em> &lt;relative_path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20F5\"></a>Converts the relative path argument to absolute project path using the Project Directory.\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20F4\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20F3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A18\"></a><pre>\npathConfig.convertPathToAbsolute \"meshes\"\n\"C:\\Documents and Settings\\username\\My Documents\\3dsmax\\meshes\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-8238BB92-64EA-4C8D-8037-64CF4E6CC41D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A17\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.convertPathToLowerCase</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20EB\"></a>Converts the path argument to lower case and unifies the backslashes. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20EA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20E9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A16\"></a><pre>\npathConfig.convertPathToLowerCase \"C:\\\\Temp\\Test/pATH\"\n\"c:\\temp\\test\\path\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-36CF2AED-CA0A-457A-87CA-919030D6CACE\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A15\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.convertPathToRelativeTo</em> &lt;path1&gt; &lt;path2&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20E1\"></a>Converts the first path argument to a relative path with respect to the second path\n               argument. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20E0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20DF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A14\"></a><pre>\npathConfig.convertPathToRelativeTo \"C:\\\\Temp\\\\Test\" \"c:\\\\Program Files\\\\\"\n\"..\\Temp\\Test\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-58D7E796-7694-4879-9A82-F593F6215161\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A13\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.convertPathToUnc</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20D7\"></a>Returns the UNC path from a mapped drive path. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20D6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20D5\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A12\"></a><pre>\n--If drive letter T: is mapped to a server called MyServer, then\npathConfig.convertPathToUnc \"t:\\\\project\"\n\"\\\\MyServer\\projects\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-24A91399-237B-4B00-AB31-F7064D0AD5EF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A11\"></a><pre><em class=\"codeEmphasisStrong\">mapPaths.getFullFilePath</em> &lt;filename&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20CC\"></a>Resolves the filename using map paths, returns fully qualified filename if the file\n               is found. \n               		\n            </p> \n            <p><a name=\"GUID-45E117A5-3905-49C0-B116-8814BA6CC305\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A10\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.normalizePath</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20CA\"></a>Returns a normalized path name. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20C9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20C8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0F\"></a><pre>\npathConfig.normalizePath \"scenes/test.txt\"\n\".\\scenes\\test.txt\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-94D44C83-807E-4BA2-92D0-C150EBA766FB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0E\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.pathsResolveEquivalent</em> &lt;path1&gt; &lt;path2&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20C0\"></a>Returns true if the two paths resolve to the same location (in other words the two\n               paths are equivalent), false if they are not equivalent. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20BF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20BE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0D\"></a><pre>\npathConfig.pathsResolveEquivalent \"scenes\\\\test.txt\" \"./scenes/test.txt\"\ntrue\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-1F6020CF-828C-4890-A115-3E17EE097855\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0C\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.resolvePathSymbols</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20B6\"></a>Resolves the path symbols. \n               		\n            </p> \n            <p><a name=\"GUID-DF07073F-129F-4DB9-BF1D-7090B8EEA648\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0B\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.resolveUNC</em> SystemGlobal:resolveUNC false </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20B3\"></a>This is the property toggle found in \n               		  <em class=\"strong\">Preferences&gt;Files</em> which controls whether max automatically converts absolute paths to their UNC equivalents.\n               (i.e. M:\\file.txt to server1\\\\file.txt if M: is mapped to server1\\\\) \n               		\n            </p> \n            <p><a name=\"GUID-F8518AA3-1B09-46E5-9BE3-3F8E593BE8F8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A0A\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.removePathLeaf</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20B0\"></a>Removes a leaf from the given path. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20AF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20AE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A09\"></a><pre>\npathConfig.removePathLeaf \"c:\\\\temp\\\\test\"\n\"c:\\temp\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-8B8AFC0D-577C-4D06-880C-6FC8607D91BD\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A08\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.removePathTopParent</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20A6\"></a>Removes the top parent from the given path. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20A5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-20A4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A07\"></a><pre>\npathConfig.removePathTopParent \"c:\\\\temp\\\\test\"\n\"temp\\test\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-607F31B9-4957-40E0-9460-0329E011C334\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A06\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.stripPathToLeaf</em> &lt;path_or_filename&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-209C\"></a>Returns the last sub-directory name from the given path. If the path is a full file\n               name, returns the file name. Equivalent to filename from path. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-209B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-209A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A05\"></a><pre>\npathConfig.stripPathToLeaf \"C:\\\\temp\\\\test\"\n\"test\"\npathConfig.stripPathToLeaf \"C:\\\\temp\\\\test\\\\\"\n\"\"\npathConfig.stripPathToLeaf \"C:\\\\temp\\\\test\\\\somefile.tga\"\n\"somefile.tga\"\n--COMPARE:\nfilenamefrompath \"C:\\\\temp\\\\test\"\n\"test\"\nfilenamefrompath \"C:\\\\temp\\\\test\\\\\"\n\"\"\nfilenamefrompath \"C:\\\\temp\\\\test\\\\somefile.tga\"\n\"somefile.tga\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-81135009-AD42-4B84-8793-1735940BE3BE\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A04\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.stripPathToTopParent</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2087\"></a>Returns the root of the given path. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2086\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2085\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A03\"></a><pre>\npathConfig.stripPathToTopParent \"C:\\\\temp\\\\test\\\\test.tga\"\n\"C:\\\"\npathConfig.stripPathToTopParent \"\\\\\\\\SomeServer\\\\Projects\\\\Test\"\n\"\\\\SomeServer\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-207E\"></a> \n            <h2><a name=\"GUID-25BB99ED-3CCA-4DEF-94EE-D9C8A0ACDA9B\"></a> <em class=\"strong\">Is... Query Methods</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A02\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isAbsolutePath</em> &lt;path_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-207C\"></a>Returns true if the argument is an absolute path, false if it is a relative path.\n               The path does not have to exist for this method to operate on it. \n               		\n            </p> \n            <p><a name=\"GUID-8BB2E8A2-6B01-4459-9617-C96E40372A32\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A01\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isLegalPath</em> &lt;path_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2079\"></a>Returns true if the argument is a legal path definition, false if it is an illegal\n               path. The path does not have to exist for this method to operate on it, it is only\n               being parsed for correctness. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2078\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2077\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A00\"></a><pre>\npathConfig.isLegalPath \"c:\\\\\" --legal path, existing\ntrue\npathConfig.isLegalPath \"z:\\\\path\" --legal path, not existing\ntrue\npathConfig.isLegalPath \"zz:\\\\path\" --illegal double drive letter!\nfalse\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-C03603A2-78B7-43AA-A698-045C872EB5BA\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FF\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isPathRootedAtBackslash</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-206B\"></a>Returns true if the argument starts with a backslash, false if it does not. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-206A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2069\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FE\"></a><pre>\n--starts with backslash:\npathConfig.isPathRootedAtBackslash \"\\\\machine\\\\c$\"\ntrue\n--does not start with backslash:\npathConfig.isPathRootedAtBackslash \"c:\\\\temp\"\nfalse\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-5A6AE10F-1FCD-4B43-8D56-A6054DEA4C8A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FD\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isPathRootedAtDriveLetter</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-205D\"></a>Returns false if the argument starts with a backslash, true if it starts with a drive\n               letter. The inverse of \n               		  <span class=\"code\"> <em class=\"strong\">pathConfig.isPathRootedAtBackslash()</em> </span> \n            </p> \n            <p><a name=\"GUID-CF90AB66-2412-47E4-B681-A5C6BF50BA3F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FC\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isProjectFolder</em>&lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-205A\"></a>Returns true if the argument path is a valid Project Folder root, false otherwise.\n               \n               		\n            </p> \n            <p><a name=\"GUID-723FC3F8-FF71-491A-A56F-362D89B0CCE6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FB\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isRootPath</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2057\"></a>Returns true if the argument path is a Root path, false otherwise \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2056\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2055\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69FA\"></a><pre>\npathConfig.isRootPath \"C:\\\\\"\ntrue\npathConfig.isRootPath \"C:\\\\temp\"\nfalse\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-5E9190D6-F8CF-42F3-A8D1-C3BB881615CB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F9\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isUncPath</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-204C\"></a>Returns true if the argument path is a UNC path, false otherwise \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-204B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-204A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F8\"></a><pre>\npathConfig.isUncPath \"T:\\\\Projects\" --mapped drive, not UNC\nfalse\npathConfig.isUncPath \"\\\\\\\\MyServer\\\\Projects\" --UNC path\ntrue\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-9E0A8A8D-6DD7-4F55-A6B0-03CA0116D261\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F7\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isUncSharePath</em> &lt;path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2041\"></a>Returns true if the argument path is a UNC share path, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-CD68D3D1-0C3D-4DD9-A123-769B6B4A4E2D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F6\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isUsingProfileDirectories()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-203E\"></a>Returns true if the system is using Profile directories, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-6D15A57C-B261-496F-91C1-FF81CB45CD83\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F5\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.isUsingRoamingProfiles()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-203B\"></a>Returns true if the system is using Roaming Profiles, false otherwise. When using\n               roaming profiles on somebody else\'s machine, your profile is being accessed over the\n               network from your own machine. This mode is not officially supported. \n               		\n            </p> \n            <p><a name=\"GUID-214BA213-4F98-4A7F-ACD7-14AE2B4DDBB1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">pathConfig.doesFileExist</em> &lt;filename_string&gt; ignoreCache:&lt;bool&gt; </pre></div> \n            <p> Returns true if the path is absolute and points to a file or directory that currently\n               exists. This function checks if a file or directory exists in the location pointed\n               to by the absolute \n               		  <span class=\"code\">filename_string</span>, potentially considering the MissingPathCache. See the \n               		  <span class=\"char_link\"><a href=\"GUID-9EFFD0CD-7FFE-4F46-9022-E02186B34C5C.htm\">MissingPathCache</a></span> for more information. \n               		\n            </p> \n            <p> Note that the disk is accessed to check for its existence, so checking paths (especially\n               on network drives) may incur a performance cost. \n               		\n            </p> \n            <p> If \n               		  <span class=\"code\">ignoreCache</span> is specified as true, testing does not consider whether the file\'s path may be in\n               the File Path Not Present Cache maintained by the MissingPathCache. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2039\"></a> \n            <h2><a name=\"GUID-B6133DD8-A7B7-4079-81BA-E3F8BF5E5627\"></a> <em class=\"strong\">Other Path-Related Methods and Structs</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F4\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.GetDir</em> &lt;#directory_type&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2037\"></a>Points at the \n               		  <span class=\"code\"> <em class=\"strong\">GetDir()</em> </span> method \n               		  <span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm\">documented here</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2036\"></a>Returns the system directory where directory_type is one of the following: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2035\"></a><pre><em class=\"codeEmphasisStrong\">#font | #Scene | #export | #import | #help | #expression | #preview | #image | #Sound | #plugcfg | #maxstart | #vpost | #drivers | #autoback | #matlib | #scripts | #startupScripts | #defaults | #renderPresets | #ui | #maxroot | #renderoutput | #animations | #archives | #Photometric | #renderassets | #userScripts | #userMacros | #userStartupScripts | #temp | #userIcons | #maxData | #downloads | #proxies | #pageFile</em> </pre></div> \n            <p><a name=\"GUID-8DAA3E75-D3A9-4D67-917B-5B42922C9F50\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F3\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.mapPaths</em> #Struct:mapPaths </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2032\"></a>Points at the \n               		  <span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5463\">mapPaths struct</a></span> definition. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2031\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2030\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F2\"></a><pre>\n--the two method calls are equivalent:\nmapPaths.getFullFilePath \"fir.tga\"\npathConfig.mapPaths.getFullFilePath \"fir.tga\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-42CF6236-B9A6-46E5-B77F-F6826D2C75AC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F1\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.pluginPaths</em> #Struct:pluginPaths </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2027\"></a>Points at the \n               		  <span class=\"char_link\"><a href=\"GUID-0A32BE7C-2389-4C5B-8CD1-E3A1E04C3827.htm\">pluginPaths struct</a></span>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2026\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2025\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69F0\"></a><pre>\ncount = pathConfig.pluginPaths.count()\nfor j = 1 to count do\nformat \" % : %\\n\" j (pathConfig.pluginPaths.get j)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-965977E1-69F9-436B-8970-B3F1B39BB310\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69EF\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.sessionPaths</em> #Struct:sessionPaths </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-201C\"></a>Points at the \n               		  <span class=\"char_link\"><a href=\"GUID-162DC544-DC8D-41E9-8DAD-D0F7266BF173.htm\">sessionPaths struct</a></span>. \n               		\n            </p> \n            <p><a name=\"GUID-84CAC946-26E8-434B-B4DB-FE46BFEF83EC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69EE\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.SetDir</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2019\"></a>Points at the \n               		  <span class=\"code\"> <em class=\"strong\">SetDir()</em> </span> method \n               		  <span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm\">documented here</a></span>. \n               		\n            </p> \n            <p><a name=\"GUID-9C09CAE4-82D9-4D8F-BD94-BE4C75581D40\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69ED\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.xrefPaths</em> #Struct:xrefPaths </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2016\"></a>Points at the<span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-544D\">XRefPath struct</a></span> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2015\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2014\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69EC\"></a><pre>\n--the two method calls are equivalent:\nxrefPaths.getFullFilePath \"delme.max\"\npathConfig.xrefPaths.getFullFilePath \"delme.max\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-200D\"></a> \n            <h2><a name=\"GUID-83956DE3-1E6C-415C-A367-5C77C2270B7E\"></a> <em class=\"strong\">Configurate User Paths Dialog - Path Settings Loading, Saving and Merging</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69EB\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.SaveTo</em> &lt;filename&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-200B\"></a>Saves the path configuration to the given filename.Returns true on success, false\n               otherwise.Corresponds to the \n               		  <em class=\"strong\">Save To...</em> button in the \n               		  <em class=\"strong\">Customize&gt;Configure User Paths</em> dialog. \n               		\n            </p> \n            <p><a name=\"GUID-43B80A6E-313C-4EAA-98C1-429ACA3D1019\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69EA\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.load</em> &lt;filename&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2008\"></a>Loads the path configuration from the specified path configuration file. Returns true\n               on success, false otherwise.Corresponds to the \n               		  <em class=\"strong\">Load</em> button in the \n               		  <em class=\"strong\">Customize&gt;Configure User Paths</em> dialog. \n               		\n            </p> \n            <p><a name=\"GUID-1F231B63-8327-4731-A4F6-4771DDB63284\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E9\"></a><pre><em class=\"codeEmphasisStrong\">pathConfig.merge</em> &lt;filename&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2005\"></a>Merges the settings from the given path configuration file. Returns true on success,\n               false otherwise. Loads the path configuration from the specified path configuration\n               file. Returns true on success, false otherwise. Corresponds to the \n               		  <em class=\"strong\">Merge</em> button in the \n               		  <em class=\"strong\">Customize&gt;Configure User Paths</em> dialog. \n               		\n            </p> \n            <p><a name=\"GUID-6721297E-555A-4561-913B-DE165C5C356B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2003\"></a> <span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm\">3ds Max System Directories</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";