var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-809E0228-B713-43E4-A805-6C8736A4FD6A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Direct 3D Cache Allocation Query Functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Direct 3D Cache Allocation Query Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-809E0228-B713-43E4-A805-6C8736A4FD6A\"></a><div class=\"head\">\n            <h1>Direct 3D Cache Allocation Query Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1482\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-147E\"></a>The following functions available in <em class=\"strong\">3ds Max 2010 and higher</em> let you query the memory usage, face count and timing of the Direct3D Mesh Cache. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-684C\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getD3DMeshAllocated</em>() 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-147B\"></a>Returns the Direct3D Mesh Cache memory allocation in Megabytes. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-684B\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getD3DMeshAllocatedFaces</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1478\"></a>Returns the Direct3D Mesh Cache face count. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-684A\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getD3DTimer</em> &lt;integer&gt;timer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1475\"></a>For internal use only. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1473\"></a>In addition, the Direct3D Mesh Cache creation is multi-threaded since <em class=\"strong\">3ds Max 2010</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1472\"></a>The following function can be used to switch back to the old single-threaded cache\n               creation mode for compatibility reasons: \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6849\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">SetUseOldD3DCache</em> &lt;boolean&gt;useOld </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1470\"></a>When the argument is true, enables single-threaded cache creation. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-146F\"></a>When the argument is false, enables multi-threaded cache creation (default). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-146E\"></a>Returns true on success, false on failure. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-146B\"></a> <span class=\"char_link\"><a href=\"GUID-6201E848-41CF-4A78-90B5-1A545D33944D.htm\">Interface: ViewportSSB</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-146A\"></a> <span class=\"char_link\"><a href=\"GUID-E15A1883-B97D-4CB8-98FD-6C6C8E502F19.htm\">Viewport Shading Settings</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";