var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"CreateDialog\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>CreateDialog</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7\"></a><div class=\"head\">\n            <h1>CreateDialog </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5AA2\"></a> The CreateDialog function lets you turn an existing rollout definition into a floating\n            Dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-1E49A61E-88BC-46BB-BFBD-B9D6246EE0FD\"></a>Other than a RolloutFloater, which is a container of one or more rollouts, a Dialog\n            is a special display form of the rollout itself. \n            	 \n         </p>\n         <p><a name=\"GUID-A06F6A47-3FD4-4B3D-9CEB-5C55CA516367\"></a>It provides advanced features like a modal display option, background bitmap display,\n            and mouse event handlers. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5AA0\"></a> <em class=\"strong\">The syntax for creating dialogs is: \n               		</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72DC\"></a><pre><em class=\"codeEmphasisStrong\">CreateDialog</em> &lt;Rollout&gt; [&lt;width&gt; &lt;height&gt; &lt;position_x&gt; &lt;position_y&gt;]\\ \n[<em class=\"codeEmphasisStrong\">pos</em>:&lt;Point2&gt;] [<em class=\"codeEmphasisStrong\">width</em>:&lt;integer&gt;] [<em class=\"codeEmphasisStrong\">height</em>:&lt;integer&gt;] \\ \n[<em class=\"codeEmphasisStrong\">bgcolor</em>:&lt;color&gt;] [<em class=\"codeEmphasisStrong\">fgcolor</em>:&lt;color&gt;] \\ \n[<em class=\"codeEmphasisStrong\">bitmap</em>:&lt;bitmap&gt;] {<em class=\"codeEmphasisStrong\">bmpstyle</em>:&lt;bmpstyle&gt; \\ \n[<em class=\"codeEmphasisStrong\">menu</em>:&lt;RCMenu&gt;] [<em class=\"codeEmphasisStrong\">style</em>:&lt;array&gt;] [<em class=\"codeEmphasisStrong\">modal</em>:&lt;boolean&gt;] \\ \n[<em class=\"codeEmphasisStrong\">escapeEnable</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">lockHeight</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">lockWidth</em>:&lt;boolean&gt;] \\\n[<em class=\"codeEmphasisStrong\">autoLayoutOnResize</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">parent</em>:&lt;HWND&gt;]	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A9A\"></a>When the optional \n            		<span class=\"code\"> <em class=\"strong\">modal:</em> </span> keyword is set to True, the dialog ignores all user interactions except those within\n            the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-54DE6743-454C-4576-A10D-7C5FF30099AD\"></a>Call \n            		<span class=\"code\"> <em class=\"strong\">DestroyDialog()</em> </span> to close it, presumably in a scripted OK button. \n            	 \n         </p>\n         <p><a name=\"GUID-66ECB423-42D4-49B9-B624-51628E7C49C7\"></a>The user can also close a modal scripted dialog by hitting the Escape key as long\n            as \n            		<span class=\"code\"> <em class=\"strong\">escapeEnable</em> </span> keyword is set to False or not supplied. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A99\"></a>When the optional \n            		<span class=\"code\"> <em class=\"strong\">escapeEnable</em> </span> keyword is set to True, MAXScript escape checker will be disabled for the dialog,\n            preventing the \"** Interrupted **\" message from appearing. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A98\"></a>If the optional \n            		<span class=\"code\"> <em class=\"strong\">lockHeight</em> </span> keyword is True , the height of the dialog cannot be interactively changed. \n            	 \n         </p>\n         <p><a name=\"GUID-E908D26F-06AE-4DD3-AEBC-D2F6C0D7B92D\"></a>If the optional \n            		<span class=\"code\"> <em class=\"strong\">lockWidth</em> </span> keyword is True , the width of the dialog cannot be interactively changed. \n            	 \n         </p>\n         <p><a name=\"GUID-F1C5B4F2-BF9A-4DE5-9133-B0015FA0053F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_88CBA1240E2648168781F0158A034DC2\"></a> <em class=\"strong\">Parameters:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72DB\"></a><pre>&lt;Rollout&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A95\"></a>The rollout definition to create the dialog form. \n            	 \n         </p>\n         <p><a name=\"GUID-C8579828-A79E-4143-99DD-E32F319374E0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72DA\"></a><pre><em class=\"codeEmphasisStrong\">pos</em>:&lt;Point2&gt; -- default:dialog will center within MAX. 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A93\"></a>Placement of the upper left corner of the dialog relative to the upper left corner\n            of the screen. \n            	 \n         </p>\n         <p><a name=\"GUID-E7C8DE8B-58F7-47C0-AFC0-E7B44435C8BB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D9\"></a><pre><em class=\"codeEmphasisStrong\">width</em>:&lt;integer&gt; -- default:200   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A91\"></a>Width of the dialog box. \n            	 \n         </p>\n         <p><a name=\"GUID-489E994B-DEE4-4C90-ADDC-4EB8BED98C8A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D8\"></a><pre><em class=\"codeEmphasisStrong\">height</em>:&lt;integer&gt; -- default:dynamic on control extents </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A8F\"></a>Height of the dialog box. \n            	 \n         </p>\n         <p><a name=\"GUID-10B3CFD5-379D-474A-9DFA-552D66CC5883\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D7\"></a><pre><em class=\"codeEmphasisStrong\">bgcolor</em>:&lt;color&gt; -- default:(&lt;system button color&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A8D\"></a>Background color of the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-998CDD7D-DCFB-41CC-84AC-F208F5C4FDE8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D6\"></a><pre><em class=\"codeEmphasisStrong\">fgcolor</em>:&lt;color&gt; -- default:(color 0 0 0) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A8B\"></a>Forground color of the dialog (static text color) \n            	 \n         </p>\n         <p><a name=\"GUID-F291D088-5BCF-40F3-9F6C-83D7F754E317\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D5\"></a><pre><em class=\"codeEmphasisStrong\">bitmap</em>:&lt;bitmap&gt; -- default:undefined </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A89\"></a>Background bitmap for the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-44081147-D28F-44C4-B119-B512D7B2B266\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D4\"></a><pre><em class=\"codeEmphasisStrong\">bmpstyle</em>:&lt;key&gt; -- default:#bmp_center </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A87\"></a>The way that the background bitmap is displayed. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A86\"></a>It can be one of the following: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D3\"></a><pre><em class=\"codeEmphasisStrong\">#bmp_center</em> <em class=\"codeEmphasisStrong\">#bmp_tile</em> <em class=\"codeEmphasisStrong\">#bmp_stretch</em> </pre></div>\n         <p><a name=\"GUID-D7A60B7D-6348-4E64-A97C-7C8D9A3E46BE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D2\"></a><pre><em class=\"codeEmphasisStrong\">menu</em>:&lt;RCMenu&gt; -- default:undefined </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A81\"></a>Menu that appears in the title bar area of the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-795F39D0-17B1-44B9-9DBA-A03369A44FD5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D1\"></a><pre><em class=\"codeEmphasisStrong\">style</em>:&lt;array&gt; -- default:#(#style_titlebar, #style_border, #style_sysmenu) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7F\"></a>Array of style flags that can be one or more of the following: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7E\"></a> <span class=\"code\"> <em class=\"strong\">#style_border:</em> </span> Creates a window with a double border, but no title. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7D\"></a> <span class=\"code\"> <em class=\"strong\">#style_titlebar:</em> </span> Creates a dialog with a title bar. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7C\"></a> <span class=\"code\"> <em class=\"strong\">#style_toolwindow:</em> </span> Creates a tool window, which has a title bar and is intended to be used as a floating\n            toolbar. A tool window has a title bar that is shorter than a normal title bar, and\n            the window title is drawn using a smaller font. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7B\"></a> <span class=\"code\"> <em class=\"strong\">#style_resizing:</em> </span> Creates a window with a thick frame that can be used to size the window. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A7A\"></a> <span class=\"code\"> <em class=\"strong\">#style_minimizebox:</em> </span> Creates a window that has a minimize button. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A79\"></a> <span class=\"code\"> <em class=\"strong\">#style_maximizebox:</em> </span> Creates a window that has a maximize button. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A78\"></a> <span class=\"code\"> <em class=\"strong\">#style_sysmenu:</em> </span> Creates a window that has a window menu in its title bar. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A77\"></a> <span class=\"code\"> <em class=\"strong\">#style_sunkenedge:</em> </span> Specifies that a window has a 3D look in the form of a border with a sunken edge.\n            \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75CE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If the style keyword parameter is not specified, the default styles of \n               		<span class=\"code\"> <em class=\"strong\">#style_titlebar</em> </span>, \n               		<span class=\"code\"> <em class=\"strong\">#style_border</em> </span>, and \n               		<span class=\"code\"> <em class=\"strong\">#style_sysmenu</em> </span> are used. \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_E4A316BC56A945E797057854CD1DFB25\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">autoLayoutOnResize</em>:&lt;boolean&gt;]</pre></div>\n         <p> If set to true, when the dialog is resized either in the UI or by a script, the layout\n            of the controls in the rollout is updated if \n            		<em class=\"strong\">autoLayoutOnResize:true</em> was also specified for the rollout. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. \n            	 \n         </p>\n         <p>The default is \n            		<em class=\"strong\">false</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">parent</em>:&lt;HWND&gt; -- default:&lt;MAX_HWND&gt;</pre></div>\n         <p><a name=\"GUID-C8CEC872-E60E-47E7-9083-2438E8663701\"></a>Parents the dialog to the specified window. \n            	 \n         </p>\n         <p><a name=\"GUID-2C6667F9-AA7F-4CE4-98CD-FC91860CA98A\"></a>When not supplied, the parent is set to the \n            		<em class=\"strong\">3ds Max</em> Window Handle, causing the dialog to minimize/maximize with the \n            		<em class=\"strong\">3ds Max</em> UI. \n            	 \n         </p>\n         <p><a name=\"GUID-05D74F7F-EE04-48A8-A6DB-41151A05A4EB\"></a>When set to a valid HWND, the dialog becomes a Child dialog of the specified Parent\n            and minimizes/restores with it. It always stays in front of the Parent even when the\n            Parent has focus. \n            	 \n         </p>\n         <p><a name=\"GUID-FDF1478F-B232-4436-8D6E-0C466AE3DA27\"></a>As the rollout class provides a \n            		<span class=\"code\"> <em class=\"strong\">.hwnd</em> </span> property, it is easy to parent one dialog to another: \n            	 \n         </p>\n         <p><a name=\"GUID-638656D9-26D4-415D-A4EC-8367575CD62A\"></a> <a name=\"TABLE_C74DC4F59E204FE09C20715AF46A24BF\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-79214716-86FC-4E26-BC42-84EDB99E5DE9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nrollout parent_dialog \"Parent\" --define a rollout and create a dialog \n(\n	label lbl_test \"Parent\"\n	on parent_dialog close do print \"PARENT Closed!\"\n)\n\ncreateDialog parent_dialog pos:[100,100] style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)\n\nrollout child_dialog \"Test2\" --define another rollout\n(\n	label lbl_test \"Child\"\n	on child_dialog close do print \"CHILD Closed!\"\n)\n--Create a dialog from the second rollout and pass the .HWND of the first dialog as the parent: argument:\ncreateDialog child_dialog pos:[200,130] parent:parent_dialog.hwnd style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)\nsetFocus parent_dialog --set focus on the Parent dialog - the Child will still be drawn in front of it!\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-661E7E5F-22C1-441A-B6CA-FB334381F893\"></a><p class=\"table-body\">At this point, minimizing and restoring the Parent dialog causes the Child dialog\n                           to follow. When the Parent dialog is minimized, the Child is not shown at all. \n                           				  \n                        </p> <a name=\"GUID-A54FE908-4539-4A90-9B32-2AEA184B4B81\"></a><p class=\"table-body\">Closing the Parent dialog automatically closes the Child, but it will \n                           					 <em class=\"strong\">NOT</em> invoke the \n                           					 <span class=\"code\">on close do</span> handler of the Child dialog. \n                           				  \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <div><a name=\"GUID-D2081342-0721-4A74-9511-AFCB50750BCD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>There is no \n               		<span class=\"code\"> <em class=\"strong\">.parent</em> </span> property, only a parameter. It is not possible to dynamically re-parent an already\n               created dialog. \n               	 \n            </div>\n         </div>\n         <p><a name=\"GUID-F81FAC24-7C4E-4B41-B961-786F5E2C786D\"></a> <a name=\"TABLE_DABAC42B90274DC5867C1828E72D0481\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-73DD5E73-4140-4537-AEF1-20863201874F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\n(\nsme.Open() --Open the SME\ntheParent = windows.getChildHWND 0 \"Slate Material Editor\" --get the HWND of the SME\nrollout sme_toolbox_rollout \"SME Toolbox\"\n(\n	button btn_nextMap \"UP One Level\" width:150\n	on btn_nextMap pressed do\n	(\n		theObj = sme.GetMtlInParamEditor() --get the node from the parameter panel\n		if theObj != undefined do --if there is a valid node, get its dependents\n		(\n			local theDeps = for m in refs.dependents theObj where isKindOf m TextureMap or isKindOf m Material collect m\n			if theDeps.count &gt; 0 do sme.SetMtlInParamEditor theDeps[1]	--if there were any, select the first one	\n		)\n	)\n)\ncreateDialog sme_toolbox_rollout parent:theParent[1] --create a dialog as child of the SME\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-06408C23-E5AB-4A33-8D35-38A30B07022D\"></a><p class=\"table-body\">The new dialog stays in front of the SME and minimizes/restores with it, but it does\n                           not close if the SME is closed. \n                           				  \n                        </p> <a name=\"GUID-5E55DFDD-44B2-4702-A703-5D8BEC35FE98\"></a><p class=\"table-body\"></p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <p><a name=\"GUID-25291D63-CF75-456C-B214-3294B67688B4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_A07E07D218C9411F9E51F4ABA77B90C8\"></a> <em class=\"strong\">Events:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72D0\"></a><pre><em class=\"codeEmphasisStrong\">on </em>&lt;Rollout&gt; <em class=\"codeEmphasisStrong\">open do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A70\"></a>Called when the dialog is opening. \n            	 \n         </p>\n         <p><a name=\"GUID-F77ECC92-E4AB-4666-9345-CE909432306D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CF\"></a><pre><em class=\"codeEmphasisStrong\">on </em>&lt;Rollout&gt; <em class=\"codeEmphasisStrong\">close do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A6D\"></a>Called when the dialog is closing. \n            	 \n         </p>\n         <p><a name=\"GUID-8C95E89F-29C2-4ADA-AF3E-0E8AED63190B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CE\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">moved</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A6A\"></a>Called when the dialog is being moved. \n            	 \n         </p>\n         <p><a name=\"GUID-F0107F3E-244A-41F7-BCFD-FF9A8460673A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CD\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">resized</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A67\"></a>Called when the dialog is being resized. \n            	 \n         </p>\n         <p><a name=\"GUID-8B22F24B-BA1C-4E63-A384-B8094C04FEE0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CC\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">mousemove</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A64\"></a>Called when the mouse is being moved within the dialogs client area. \n            	 \n         </p>\n         <p><a name=\"GUID-178B1D42-A75B-4F7F-9C40-2005F2157515\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CB\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">lbuttondown</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A61\"></a>Called when the left mouse button is pressed down within the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-D79A0727-F6A3-466D-9778-90927733B2A8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72CA\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">lbuttonup</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A5E\"></a>Called when the left mouse button is released. \n            	 \n         </p>\n         <p><a name=\"GUID-4FAADEE6-C010-4448-90D5-C72D4F388CC4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C9\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">lbuttondblclk</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A5B\"></a>Called when the left mouse button is double clicked within the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-D136A673-05FC-41EE-9E2C-620F3E1E0B12\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C8\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">mbuttondown</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A58\"></a>Called when the middle mouse button is pressed down within the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-777E21F4-F513-48C7-90FA-908BF4DB56A6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C7\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">mbuttonup</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A55\"></a>Called when the middle mouse button is released. \n            	 \n         </p>\n         <p><a name=\"GUID-4022EF4A-653C-4F66-9105-9F6555C9370D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C6\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">mbuttondblclk</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A52\"></a>Called when the middle mouse button is double clicked within the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-DE4D16A2-64CD-4D90-B60A-605C048CE6F0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C5\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">rbuttondown</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A4F\"></a>Called when the right mouse button is pressed down within the dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-F9741007-6C57-4F60-A330-9263FF14EC7F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C4\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">rbuttonup</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A4C\"></a>Called when the right mouse button is released. \n            	 \n         </p>\n         <p><a name=\"GUID-A89577DA-8F9C-4DA2-9177-76ECB6119130\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72C3\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;Rollout&gt; <em class=\"codeEmphasisStrong\">rbuttondblclk</em> &lt;Point2&gt; <em class=\"codeEmphasisStrong\">do</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A49\"></a>Called when the right mouse button is double clicked within the dialog. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75CD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-94909791-1FF4-40A7-AA5B-10E11A4A6106\"></a>The &lt;Point2&gt; value passed to the event handlers is the position of the mouse within\n                  the dialog client window. A value of [0,0] corresponds to the top left corner of the\n                  client window. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"P_E723EA36A5D044FABD35ACCC36EA25E4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_378FE9E2FA75454899EAA68192DDECB7\"></a> <em class=\"strong\">Associated Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72BC\"></a><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">GetDialogPos</em> &lt;Rollout&gt; [<em class=\"codeEmphasisStrong\">removeUIScaling</em>: &lt;bool&gt;]\n&lt;Point2&gt;<em class=\"codeEmphasisStrong\">GetDialogSize</em> &lt;Rollout&gt;  [<em class=\"codeEmphasisStrong\">removeUIScaling</em>: &lt;bool&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A23\"></a>Returns the position or size of the Dialog built from the rollout relative to the\n            upper left corner of the screen in Point2 format. \n            	 \n         </p>\n         <p><span class=\"code\">removeUIScaling</span>: Removes UI scaling applied by high-DPI displays if true. The default is true. \n            	 \n         </p>\n         <p><a name=\"GUID-BB319B97-B6FE-4E7B-8BD8-86C43C1932AD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72BB\"></a><pre><em class=\"codeEmphasisStrong\">SetDialogPos</em> &lt;Rollout&gt; &lt;Point2&gt; [<em class=\"codeEmphasisStrong\">applyUIScaling</em>: &lt;bool&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A20\"></a>Sets the position of the Dialog built from the rollout. The position is relative to\n            the upper left corner of the screen. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A1F\"></a> <span class=\"code\"> &lt;Rollout&gt;: \n               		</span> The rollout used to build the Dialog to set the position of. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A1E\"></a> <span class=\"code\"> &lt;Point2&gt;: \n               		</span> Position applied to the Dialog. \n            	 \n         </p>\n         <p> <span class=\"code\">applyUIScaling</span>: Applies UI scaling to the position on high-DPI displays if true. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. The default is true. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">SetDialogSize</em> &lt;Rollout&gt; &lt;Point2&gt; [<em class=\"codeEmphasisStrong\">applyUIScaling</em>: &lt;bool&gt;]</pre></div>\n         <p> Sets the size of the Dialog built from the rollout. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. \n            	 \n         </p>\n         <p> <span class=\"code\"> &lt;Rollout&gt;: \n               		</span> The rollout used to build the Dialog to set the size of. \n            	 \n         </p>\n         <p> <span class=\"code\"> &lt;Point2&gt;: \n               		</span> Size to applied to the Dialog. \n            	 \n         </p>\n         <p> <span class=\"code\">applyUIScaling</span>: Applies UI scaling to the size on high-DPI displays if true. The default is true.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-EBC4CFEF-E06F-4B32-AEF7-85CE35244CBC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72BF\"></a><pre><em class=\"codeEmphasisStrong\">SetDialogBitmap</em> &lt;rollout&gt; &lt;bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A36\"></a>Sets the bitmap background for the dialog associated with the rollout. If the rollout\n            is not in a dialog, no action is taken. A value of \'undefined\' for the bitmap clears\n            the current bitmap. \n            	 \n         </p>\n         <p><a name=\"GUID-012772A5-A82D-4E59-9361-579D6AC5E086\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72BE\"></a><pre>&lt;bitmap&gt;<em class=\"codeEmphasisStrong\">GetDialogBitmap</em> &lt;rollout&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A33\"></a>Gets the bitmap background for the dialog associated with the rollout. If the rollout\n            is not in a dialog, \'undefined\' is returned \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A31\"></a> <span class=\"char_link\"><a href=\"GUID-61E8ABE7-5506-422C-B497-9867A4695980.htm\">DestroyDialog</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5A2F\"></a> <span class=\"char_link\"><a href=\"GUID-E66C9960-E058-4EF8-92EA-EB65365B79CF.htm\">MAXScript Dialogs and Rollout Floaters as Extended viewports</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";