var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-822DE27D-004E-4B19-ADA6-B0E980626462\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"keywords\">\n      <meta name=\"indexterm\" content=\"positional arguments\">\n      <meta name=\"indexterm\" content=\"function calls\">\n      <meta name=\"indexterm\" content=\"arguments - positional and keyword\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Positional and Keyword Arguments</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-822DE27D-004E-4B19-ADA6-B0E980626462\"></a><div class=\"head\">\n            <h1>Positional and Keyword Arguments </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F35\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F36\"></a>    A function can take two kinds of arguments: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F3B\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F3D\"></a> <em class=\"strong\">Positional Arguments.</em> If you call a function that takes positional arguments, you must specify those arguments\n                     first and in the correct order. Positional arguments correspond to the function arguments\n                     in most programming languages - they are required and have a fixed number and order.\n                     \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F3F\"></a> <em class=\"strong\">Keyword Arguments.</em> You write keyword arguments as a \n                     				<span class=\"code\"><em class=\"strong\">keyword:</em>&lt;value&gt;</span> pair, and they can appear in any order after the positional arguments. Functions\n                     can use some or all of their keyword arguments as optional arguments. If you call\n                     a function and don\'t supply optional keyword arguments, they will have either the\n                     default value supplied by the called function, or the special value \n                     				<span class=\"code\"><em class=\"strong\">unsupplied</em></span> when first referenced in the called function. \n                     			 \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F40\"></a>Optional keyword arguments are useful in command languages where commands can have\n               many options. They are particularly useful within \n               		  <em class=\"strong\">3ds Max</em> where most functions have numerous optional keyword arguments. For example, all scene\n               object creation functions take optional keyword arguments for their creation parameters.\n               As there are sometimes more than 100 arguments to these functions, using positional\n               arguments would simply be unworkable. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F41\"></a>As an example of positional arguments, the syntax for the print function is: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6110\"></a><pre><em class=\"codeEmphasisStrong\">print</em> &lt;value&gt; [<em class=\"codeEmphasisStrong\">to</em>:&lt;file&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F43\"></a> <span class=\"code\">&lt;value&gt;</span> is a positional argument, and is required. \n               		  <span class=\"code\"><em class=\"strong\">to:</em> &lt;file&gt;</span> is an optional keyword argument, where \n               		  <span class=\"code\"><em class=\"strong\">to</em></span> is the argument keyword and \n               		  <span class=\"code\">&lt;file&gt;</span> is the argument value. If the \n               		  <span class=\"code\"><em class=\"strong\">to</em></span> argument value is \n               		  <span class=\"code\"><em class=\"strong\">unsupplied</em></span>, MAXScript outputs \n               		  <span class=\"code\">&lt;value&gt;</span> to Listener. Otherwise, MAXScript outputs \n               		  <span class=\"code\">&lt;value&gt;</span> to the file specified by \n               		  <span class=\"code\">&lt;file&gt;</span>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F44\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F45\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F46\"></a><p class=\"table-body\">As another example, you can create a sphere object in the \n                           						<em class=\"strong\">3ds Max</em> scene with no arguments: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-610F\"></a><pre>sphere()</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F4A\"></a><p class=\"table-body\">Or, you could specify just one argument: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-610E\"></a><pre>sphere radius:23</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F4E\"></a><p class=\"table-body\">Or, you can specify more optional arguments: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-610D\"></a><pre>sphere segs:20 smooth:on radius:15 hemisphere:0.5 mapcoords:on</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F53\"></a>For those keyword arguments not specified when creating \n               		  <em class=\"strong\">3ds Max</em> objects, default values are used. The default value used for each keyword argument\n               is shown in the descriptions of the object classes. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";