var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Bitmap Gamma and MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80\"></a><div class=\"head\">\n            <h1>Bitmap Gamma and MAXScript </h1>\n         </div>\n         <p><a name=\"GUID-0D373D29-B302-479C-AB3C-DB4866F52504\"></a> The handling of Bitmap Gamma in MAXScript has been overhauled in <em class=\"strong\">3ds Max 2014</em> to solve several long-standing issues. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_FCF4F7BBE5D9499C9FB1102B77ADE735\"></a> \n            <h2><a name=\"GUID-814232F5-4CCF-49CB-AF79-1E6A3FFFEE5F\"></a>The Past Problems\n            </h2> \n            <p><a name=\"GUID-736464FF-417F-4861-A42E-06E411BC1B38\"></a>In versions prior to <em class=\"strong\">3ds Max 2014</em>, MAXScript had limited access to the Gamma settings of the <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm\">Bitmap Values</a></span> loaded from files, created by a script, or saved to disk bitmap files in various\n               formats. \n            </p> \n            <p><a name=\"GUID-71517B9F-ACC4-456C-AFA5-6CF1FCC78591\"></a>Here is a list of some of the problems: \n            </p> <a name=\"UL_E244FB6DD9D9458980A6EE3BC182A5A4\"></a><ul>\n               <li>When loading a Bitmap Value from a bitmap file, MAXScript had no access to the BitmapInfo\n                  describing meta-data including the Gamma. \n               </li>\n               <li>Similarly, when saving a bitmap value to a bitmap file, MAXScript could only provide\n                  the file name, but not the relevant meta-data including the actual Gamma loaded from\n                  disk. \n               </li>\n               <li>Copying a bitmap value to a new value using MAXScript would set the copied data to\n                  linear internally. \n               </li>\n               <li>Since MAXScript does not support the saving of a bitmap value loaded from a bitmap\n                  file, a copy of the bitmap value has to be created before saving, but because of the\n                  previous issue with copying bitmap values, the gamma was changed implicitly. \n               </li>\n               <li>The <span class=\"code\"> <em class=\"strong\">.gamma</em> </span> property of the MAXScript bitmap value attempted to represent both the loading and\n                  saving gamma, which was incorrect or misleading in many cases. \n               </li>\n               <li>Access to pixel data via the <span class=\"code\"> <em class=\"strong\">getPixels()</em> </span> function was always working with the raw data and had no way to respect the Gamma\n                  settings. \n               </li>\n               <li>Similarly, the <span class=\"code\"> <em class=\"strong\">compareBitmaps()</em> </span> function would produce false when comparing a JPG (which loads with a gamma of 2.2)\n                  to its own copy with would have a gamma of 1.0. \n               </li>\n            </ul> \n            <p><a name=\"P_C2E8B5E0AF224354A832FC8495ADAC70\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_362A11C5BC924A1BBC74810ECBF9D1C6\"></a> \n            <h2><a name=\"GUID-A7E48326-6D63-4D95-A9B0-463CD82C6BFD\"></a>Gamma-Related MAXScript Features in 3ds Max 2014 and higher\n            </h2> \n            <p><a name=\"GUID-25E56096-79A0-47D1-97AD-DA19CA173085\"></a>To solve the above issues, MAXScript was extended in <em class=\"strong\">3ds Max 2014</em> to let scripts properly handle the Gamma of Bitmap Values. \n            </p> \n            <p><a name=\"GUID-414203F3-9CDD-4C2E-B745-C58F5AB6D8A0\"></a>In all cases, the additions have been implemented as extensions, in other words old\n               scripts will remain syntactically correct. \n            </p> \n            <div class=\"section\"><a name=\"SECTION_13D56999A06E4972856ECDD05BE895B0\"></a> \n               <h3><a name=\"GUID-93BDAB67-E2EB-43C0-9916-4123A166CB62\"></a>Gamma Modes - Auto, Override and Default\n               </h3> \n               <p><a name=\"GUID-FECB2F8F-E100-4965-B357-675DCA216C17\"></a>In <em class=\"strong\">3ds Max 2014 and higher</em>, the Gamma of a Bitmap Value can be controlled in three ways - as <span class=\"code\"> <em class=\"strong\">#auto</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> or an override. \n               </p> <a name=\"UL_468E10E860DE4FD8B00FBEE13C1A1DC4\"></a><ul>\n                  <li><span class=\"code\"> <em class=\"strong\">#auto</em> </span> is the new, intelligent mode. It uses the file information when present, or intelligently\n                     chooses gamma based on whether the file is Floating point or not. This is the default\n                     behavior. \n                  </li>\n                  <li>If gamma is an override, an actual floating point value is used. </li>\n                  <li><span class=\"code\"> <em class=\"strong\">#default</em> </span> is actually the <em class=\"strong\">old legacy mode</em> which only exists for completeness and for loading old files. \n                  </li>\n               </ul> \n               <p><a name=\"GUID-092875EA-CE4B-4C42-AD1C-901037B25CA1\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <p><a name=\"GUID-C1B4F1F4-0717-4A01-BC0D-E1C098AD91D5\"></a> <em class=\"strong\">The following extensions have been implemented:</em> \n               </p> \n               <p><a name=\"GUID-1D44C165-6195-4ECF-A098-DE9F07B8951C\"></a>The <span class=\"code\"> <em class=\"strong\">openBitmap()</em> </span> function now accepts an optional <span class=\"code\"> <em class=\"strong\">gamma:</em> </span> keyword argument, so you can say \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E65\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E64\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>a = openBitmap \"test.jpg\" gamma:#auto -- auto mode \nb = openBitmap \"test.exr\" gamma:1.0 -- an override</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-9199E46C-AAB9-4CE3-9E93-6B5740A5C933\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <p><a name=\"GUID-01AD9F81-BC95-43B2-BEAD-AC54F323D986\"></a>Similarly, the bitmap <span class=\"code\"> <em class=\"strong\">save()</em> </span> method has been extended with an optional <span class=\"code\"> <em class=\"strong\">gamma:</em> </span> keyword, so you can say: \n               </p> \n               <div class=\"codeBlock\"><pre>save a gamma:#auto -- auto mode \nsave b gamma:1.0 -- an override</pre></div> \n               <p><a name=\"GUID-91563FE4-CCB5-48D5-AB4B-D1F76C2B356B\"></a>In addition, the <span class=\"code\"> <em class=\"strong\">save()</em> </span> function now provides a <span class=\"code\"> <em class=\"strong\">metadata:</em> </span> optional keyword which can be used to pass the dialog settings acquired from the\n                  various bitmap filename picking functions - <span class=\"code\"> <em class=\"strong\">SelectSaveBitmap()</em> </span>, <span class=\"code\"> <em class=\"strong\">getBitmapSaveFilename()</em> </span> and <em class=\"strong\"> <span class=\"code\">getBitmapOpenFilename()</span> </em>. See further on this page for details. \n               </p> \n               <p><a name=\"GUID-080B519F-94C8-4699-A2AA-6026AA6C1D38\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <p><a name=\"GUID-97A91248-26CD-4218-9672-167BE1787DBA\"></a>If you render to a file using the <span class=\"code\"> <em class=\"strong\">render()</em> </span> function, you can also set the Gamma using the optional <span class=\"code\"> <em class=\"strong\">gamma:</em> </span> keyword: \n               </p> <a name=\"TABLE_6DFBDCD8E9284FB89E2D7C102F671E62\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-3CDED3C9-189F-40D1-9AC7-E9DA7AF693DA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>render filename:\"something.exr\" gamma:#auto -- auto mode \nrender filename:\"somotherthing.jpg\" gamma:1.0 -- an override</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-5E43F455-7979-4EBD-9052-184E4D2E0485\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_FB3F17D723114E878572A41DAFCADB24\"></a> \n               <h3><a name=\"GUID-AEE499D9-A6AA-42C8-A60F-398D962335EF\"></a>New and Modified Bitmap Value Gamma Properties\n               </h3> \n               <p><a name=\"GUID-23044F7E-DF88-45B7-979A-8D42C72F7858\"></a>The existing <span class=\"code\"> <em class=\"strong\">.gamma</em> </span> property has been modified to represent the ACTUAL gamma of the bitmap. In the past,\n                  it confused output and input gamma into one parameter, which was problematic. \n               </p> \n               <p><a name=\"GUID-40350EE0-55B2-4AA0-913E-CECC039AC8CB\"></a>For this reason, two new properties have been added to explicitly address the input\n                  gamma, and how that gamma was obtained: \n               </p> \n               <p><a name=\"GUID-0F114D01-CBCB-4CD1-AC8A-87D26EAA85BF\"></a><span class=\"code\"> <em class=\"strong\">.inputGamma</em> </span> will inform you of the gamma of the file that was loaded. It will return either #auto,\n                  #default or the override value. This can be used to display e.g. where the gamma info\n                  comes from. It can also be used to make sure to save a bitmap the same as it was loaded,\n                  for example. \n               </p> \n               <p><a name=\"GUID-28E792C2-5884-4141-8B69-8600B9ACD7C5\"></a><em class=\"strong\"> <span class=\"code\">.inputGammaValue</span> </em> just returns the actual value that was used, e.g. for #auto it would return 1.0 or\n                  2.2 depending on file type, for #default it would return 2.2, and for an override\n                  it returns the override value. \n               </p> \n               <p><a name=\"GUID-02104DC7-BB87-4616-A392-686EFBD475F5\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_1F7389607D9A457096E6978482D87983\"></a> \n               <h3><a name=\"GUID-CEBBB855-D3DE-40E5-B85A-B0199DEBB9B1\"></a>Bitmap File Open and Save Dialogs Meta-Data Access\n               </h3> \n               <p><a name=\"GUID-15036F1D-9CF8-407D-9197-BD483079070D\"></a> Features have been added to the MAXScript bitmap file dialogs to return as an optional\n                  by-reference output parameters the Gamma values, as well as the dialog\'s setup data.\n                  \n               </p> \n               <p><a name=\"GUID-62D80E8E-AAF0-45F6-BD00-768DE42696F3\"></a>When these optional parameters are used, the gamma options are visible and work. When\n                  they are not used, the Gamma options will be grayed out in the file dialog. \n               </p> \n               <p><a name=\"GUID-5E033F6C-A8D3-478C-B394-2C8AE3262EB6\"></a> <em class=\"strong\">The functions that have been extended are:</em> \n               </p> \n               <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">getBitmapOpenFilename()\ngetBitmapSaveFilename() \nSelectSaveBitmap()</em></pre></div> \n               <p><a name=\"GUID-7B7FCF70-0C01-4A9B-BAC3-D30D1A95E472\"></a>In each one of these functions, an optional keyword argument <span class=\"code\"> <em class=\"strong\">gamma:</em> </span> can refer to a by-reference variable that will return <span class=\"code\"> <em class=\"strong\">#auto</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> or a numeric value: \n               </p> <a name=\"TABLE_14465BDA79A34915AE29861FEA2A26CC\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-9B394C45-4687-4497-92EB-E2A11FEF1A2C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>x = SelectSaveBitmap caption:\"Select a file\" gamma:&amp;gma</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-6E81FCC0-A9A6-4A37-9081-278570F09235\"></a><p class=\"table-body\">If the function returns successfully, the variable \'gma\' will contain the gamma value\n                              from the dialog. \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-029D3BC3-DB01-4409-AF89-4BDD9BB0394C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <p><a name=\"GUID-A129ECAF-A8E3-4166-B406-3D7E0CA0FF49\"></a>Similarly, bitmap Save dialogs can return the meta-data stored by the \"Setup\" button,\n                  by requesting it via the <span class=\"code\"> <em class=\"strong\">metadata:</em> </span> by-reference optional argument: \n               </p> <a name=\"TABLE_C467244A84D34364B2521024DBDFB4E7\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-F12F5CC2-317F-4B29-816A-0FBAFEE8DC38\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>x = SelectSaveBitmap caption:\"Select a file\" gamma:&amp;gma metadata:&amp;data</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-6C95C8D3-510F-4675-9EC7-1AFA5DCD998B\"></a><p class=\"table-body\">Upon success, the \'gma\' variable will contain the gamma, and the \'data\' variable will\n                              contain an array of data stored by the bitmap plugin. This data can then be used in\n                              bitmap save operations, for example: \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>bitmap.filename = SelectSaveBitmap caption:\"Select a file\" gamma:&amp;gma metadata:&amp;data\nif (bitmap.filename) do save bitmap gamma:gma metadata:data\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-9B8149C4-C1B8-413B-A150-C2639F6093A4\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_78C76AEF7C39422F8FECD1F3C3F64D7D\"></a> \n               <h3><a name=\"GUID-D799BA01-0322-4435-B0DA-68916D2CB79E\"></a>Pixels Access - Linear vs. Raw\n               </h3> \n               <p><a name=\"GUID-702144C2-F1DA-4E5B-8796-CAF1E286E27B\"></a> The function <span class=\"code\"> <em class=\"strong\">getPixels()</em> </span> have been extended with the optional <span class=\"code\"> <em class=\"strong\">linear:</em> </span> boolean parameter: \n               </p> <a name=\"TABLE_C214E09900384AC98A3DD3116BC34187\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-32D54240-A351-43ED-BA9C-1F861EAA9763\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>a = openBitmap \"hello.jpg\" gamma:#auto --this will set gamma to 2.2\np = getPixels a [0,0] 50 linear:true  --get the linear pixel values (gamma 1.0)\np[1].r *= 2.0 --make first pixel twice as red...</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"P_E2C3320B1796490BA6393EC2B9885C12\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <p><a name=\"GUID-E06AE5D9-C695-4552-AC49-010EA67DB581\"></a>The following example script goes through all Bitmap Textures and if they are set\n                  to <span class=\"code\"> <em class=\"strong\">#default</em> </span> (legacy mode), changes the Gamma to an override of 2.2. \n               </p> \n               <p><a name=\"GUID-3C7F5950-5EF0-4D93-915F-22BBE1F59AAB\"></a>Note that you <em class=\"strong\">cannot change</em> the Gamma of a bitmap value (this gets burned in when loading it), but you can simply\n                  re-load it with the new Gamma from the original source file. \n               </p> <a name=\"TABLE_C884305A08B640589E7414BB342142C0\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-99725C98-51A2-4A5E-AB2C-D9F30008499B\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>for tmap in (getClassInstances BitmapTexture) where (tmap.bitmap.inputGamma == #default) do \n  tmap.bitmap = openBitmap tmap.bitmap.filename gamma:2.2</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-5A96008A-4BAC-4693-908D-663B01F782F0\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";