var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-83E779EA-03B6-4785-B610-9A6EE574E10A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I keep a Plane aligned to 3 Point Helpers?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-83E779EA-03B6-4785-B610-9A6EE574E10A\"></a><div class=\"head\">\n            <h1>How do I keep a Plane aligned to 3 Point Helpers? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1215\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1217\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1218\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8E6\"> Working With Animation</a></span> &gt; How do I keep a Plane aligned to 3 Point Helpers? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC121A\"></a> \n            <h2><a name=\"GUID-B95F441A-8546-41F6-8EBC-804CBCB376AB\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC121B\"></a>I have 3 Point Helpers which determines a plane in 3d space and I animated all of\n               them randomly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC121C\"></a>How can I keep a Plane object always oriented exactly to the plane determined by the\n               Points? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC121D\"></a> \n            <h2><a name=\"GUID-8769B011-798F-4DD0-ADBD-185084276DA7\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC121E\"></a>This is a good place to use a <span class=\"char_link\"><a href=\"GUID-CFAF04F2-BBA9-432C-B0CA-4CE682A323E0.htm\">Transform Script controller</a></span> because we can control both the rotation (orientation) and position of the plane\n               with it. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1220\"></a><p class=\"list-intro\"><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7B05\"></a>The following script\n            </p>\n            <ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1222\"></a>Creates a Plane primitive \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1224\"></a>Creates 3 Point Helpers \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1226\"></a>Assigns a Transform Script and calculates a Matrix3 value which keeps the plane in\n                     the plane defined by the three points and centers it in the middle point between the\n                     helpers. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1227\"></a>If you would move or animate the points, the Plane should follow. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1229\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC122A\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6631\"></a><pre>\n--Create a plane and 3 point helper\nthePlane = Plane()\np1 = point pos:[40,-10,30]\np2 = point pos:[20,30,40]\np3 = point pos:[-10,-20,30]\n--Create a Transform Script and assign it to the Plane\nctrl = transform_script()\nthePlane.transform.controller = ctrl\n--Create three Node variables and assign the Helpers to them\nctrl.addNode\"p1\" p1\nctrl.addNode\"p2\" p2\nctrl.addNode\"p3\" p3\n--We create a variable to hold the expression\n--We calculate the vector from Point01 to Point02\ntxt =\"v1 = normalize (p2.pos-p1.pos)\\n\"\n--and the vector from Point01 to Point03\ntxt +=\"v2 = normalize (p3.pos-p1.pos)\\n\"\n--The cross productof the two vectors is the normal to the plane\ntxt +=\"nv1 = normalize (cross v1 v2)\\n\"\n--Thecross product ofthenormal and vector 1gives us a third axis\ntxt +=\"nv2=normalize(cross nv1 v1)\\n\"\n--We create a matrix3 value using he first vector,\n--and the two cross products which are all orthogonal to each-other.\n--The translation part .row4 is the middle point\n--of the 3 points\' positions:\ntxt +=\"matrix3 v1 nv2 nv1 ((p1.pos+p2.pos+p3.pos)/3)\"\n--Assign the expression to the script controller\nctrl.setExpression txt\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1251\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1252\"></a> <span class=\"char_link\"><a href=\"GUID-CFAF04F2-BBA9-432C-B0CA-4CE682A323E0.htm\">transform_script: Matrix3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1254\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";