var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-853014AC-9DC8-4F5C-B14B-3643E5925AD8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Vertex Renderer</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-853014AC-9DC8-4F5C-B14B-3643E5925AD8\"></a><div class=\"head\">\n            <h1>How To ... Develop a Vertex Renderer </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2180\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2181\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Develop a Vertex Renderer \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2183\"></a>The tutorial will demonstrate the basics of rendering - transforming objects from\n            3D space into 2D images.To make it simple and fast (realtime!), the script will draw\n            only vertices. The image will be redrawn every time the viewport is updated - changing\n            the view, panning, zooming and orbiting will be reflected by the vertex renderer instantly!\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2184\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2185\"></a> <span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm\">Accessing Active Viewport Info, Type, and Transforms</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2187\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2188\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2189\"></a><p class=\"table-body\">Create a macroScript. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC218A\"></a><p class=\"table-body\">Define a flag variable to remember whether the renderer is enabled or disabled \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC218B\"></a><p class=\"table-body\">Define local variables to hold the render size and the front and back buffer images\n                        \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC218C\"></a><p class=\"table-body\">Define a function to be called when the viewport redraws. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC218D\"></a><p class=\"table-body\">In the function, \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC218E\"></a><ul>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2190\"></a>Copy the back buffer into the front buffer \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2192\"></a>Go through all geometry objects and get their mesh \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2194\"></a>Get every vertex of the mesh, transform into image coordinates using the current view\n                              transformation matrix \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2196\"></a>Draw a pixel for the vertex in the front buffer \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2198\"></a>When done, display the image \n                              						\n                           </p> \n                        </li>\n                     </ul> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2199\"></a><p class=\"table-body\">Return the flag from the on isChecked handler. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC219A\"></a><p class=\"table-body\">When executed, \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC219B\"></a><ul>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC219D\"></a>Invert the flag \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC219F\"></a>Redefine the render size variables and the bitmaps \n                              						\n                           </p> \n                        </li>\n                        <li> \n                           <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21A1\"></a>Register the viewport redraw callback function if the flag is true, unregister if\n                              false. \n                              						\n                           </p> \n                        </li>\n                     </ul> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21A3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21A4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CA\"></a><pre>\nmacroScript VertexRender category:\"HowTo\"\n(\nlocal VertexRendererEnabled = false\nlocal screen_width, screen_height, back_vfb, front_vfb\nfn VertexRendererFunction =\n(\nst = timestamp()\ncopy back_vfb front_vfb\nfor o in geometry where classof o != TargetObject do \n(\ntheMesh = snapshotAsMesh o\ndot_color = #(o.wirecolor)\ntheVertCount = theMesh.numverts\nfor v = 1 to theVertCount do\n(&nbsp;\nthePos = (getVert theMesh v)* viewport.getTM()\nscreen_origin = mapScreenToView [0,0] (thePos.z) [screen_width,screen_height]\nend_screen = mapScreenToView [screen_width,screen_height] (thePos.z) [screen_width,screen_height]\nworld_size = screen_origin-end_screen\nx_aspect = screen_width/(abs world_size.x)\ny_aspect = screen_height/(abs world_size.y)\nscreen_coords = point2 (x_aspect*(thePos.x-screen_origin.x)) (-(y_aspect*(thePos.y-screen_origin.y)))\nsetPixels front_vfb screen_coords dot_color\n)--end v loop\n)--end o loop\ndisplay front_vfb&nbsp;\net = timestamp()\npushPrompt (\"VertRender \"+(1000.0/(et-st)) as string +\" fps\")\n)--end fn\n&nbsp;\non isChecked return VertexRendererEnabled\n&nbsp;\non execute do\n(\nVertexRendererEnabled =not VertexRendererEnabled\n&nbsp;\nif VertexRendererEnabled then\n(\nscreen_width=RenderWidth\nscreen_height=RenderHeight\nback_vfb = bitmap screen_width screen_height\nfront_vfb = bitmap screen_width screen_height\nregisterRedrawViewsCallback VertexRendererFunction\nRedrawViews()&nbsp;\n)&nbsp;\nelse\n(\nunRegisterRedrawViewsCallback VertexRendererFunction&nbsp;\nclose front_vfb&nbsp;\n)\n)--end on execute\n)--end script\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-76DC\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-B22E1D14-6E5C-4D81-ADD9-E528B2F2E784-low.gif\"></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21DD\"></a> \n            <h2><a name=\"GUID-874E38EE-0C27-46D7-8C83-25063A9F436B\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C9\"></a><pre><em class=\"codeEmphasisStrong\">macroScript VertexRender category:\"HowTo\"\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21E0\"></a>We start by defining a MacroScript with the name VertexRender which will appear in\n               the category \"HowTo\". This will be an advanced macroScripts which will have \n               		  <span class=\"code\"> <em class=\"strong\">on execute do</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">on is Checked do</em> </span> event handlers. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C8\"></a><pre><em class=\"codeEmphasisStrong\">localVertexRendererEnabled= false</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21E2\"></a>We define a local variable to hold a flag determining whether the renderer is active\n               or not. In the beginning, the variable will be set to false. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C7\"></a><pre><em class=\"codeEmphasisStrong\">local screen_width,screen_height, back_vfb,front_vfb</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21E4\"></a>We define a couple more local variables to hold the width and height of the image\n               and the two bitmaps - the back buffer and the front buffer (see below for more info).\n               \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C6\"></a><pre><em class=\"codeEmphasisStrong\">fn VertexRendererFunction =\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21E7\"></a>This is the function that will be executed when the renderer is enabled and the viewport\n               is being updated. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C5\"></a><pre><em class=\"codeEmphasisStrong\">st = timestamp()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21E9\"></a>To be able to output info on the rendering speed, we will use the timestamp function\n               to get the current system time. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C4\"></a><pre><em class=\"codeEmphasisStrong\">copy back_vfb front_vfb</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21EB\"></a>Then we will copy the back buffer into the front buffer, basically clearing the previous\n               image. The back buffer could be changed to hold a background image, and the function\n               would draw on top of it... For now, the back buffer image is set to black. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C3\"></a><pre><em class=\"codeEmphasisStrong\">for o in geometry where classof o != TargetObject do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21EE\"></a>We loop through all scene geometry objects that are not target objects of lights,\n               cameras etc. Note that we are not checking for hidden objects - you could add this\n               to the code as an exercise! Right now, all objects will be drawn, even the hidden\n               ones! \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C2\"></a><pre><em class=\"codeEmphasisStrong\">theMesh = snapshotAsMesh o</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21F0\"></a>Then we snapshot the objects as mesh into memory. This includes all modifiers AND\n               space warps applied to the object. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C1\"></a><pre><em class=\"codeEmphasisStrong\">dot_color = #(o.wirecolor)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21F2\"></a>We define an array to be used for painting the vertices and use the wireframe color\n               to draw. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64C0\"></a><pre><em class=\"codeEmphasisStrong\">theVertCount = theMesh.numverts</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21F4\"></a>To speed things up, we read the number of vertices in the mesh once. We will use this\n               value below to limit the vertex loop: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BF\"></a><pre><em class=\"codeEmphasisStrong\">for v = 1 to theVertCount do\n(</em>&nbsp;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21F7\"></a>The v variable will count from 1 to the number of vertices. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BE\"></a><pre><em class=\"codeEmphasisStrong\">thePos = (getVert theMesh v)* viewport.getTM()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21F9\"></a>The position of the v-th vertex has to be multiplied by the transformation matrix\n               of the viewport. (If the viewport is a Camera, the viewport.getTM() returns the inverse\n               of the camera\'s transformation matrix. If the viewport is a Perspective or Ortho view,\n               the matrix is already inverted). By multiplying the vertex position by this matrix,\n               we transform the 3D space coordinates into camera space! \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BD\"></a><pre><em class=\"codeEmphasisStrong\">screen_origin = mapScreenToView [0,0] (thePos.z) [screen_width,screen_height]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21FB\"></a>Now we need to know the size of the projection plane with pixel size equal to the\n               rendering image when placed at the depth of the current vertex. To calculate this,\n               we will need the two extremes (upper left and lower right) points of the plane as\n               3D points in camera space. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21FC\"></a>Since thePos is already in camera coordinates, the.Z coordinate is the Z-depth of\n               the point!The return value of \n               		  <span class=\"code\"> <em class=\"strong\">mapScreenToView</em> </span> is a 3D point in camera space corresponding to the upper left corner of the projection\n               plane. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BC\"></a><pre><em class=\"codeEmphasisStrong\">end_screen = mapScreenToView [screen_width,screen_height] (thePos.z) [screen_width,screen_height]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21FE\"></a>We do the same for the lower right corner of the projection plane. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC21FF\"></a>Here is what we just did and why: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2200\"></a>As you know, the camera has a cone (frustrum) with the top at the position of the\n               camera. If the projection plane would \"travel\" along the Z axis of the camera, the\n               farther it gets from the \"eye\", the larger it becomes in world units, but the number\n               of pixels in the final image remains the same. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2201\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F18B8243-7BF3-4894-8D32-45DE2884F9CA-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2202\"></a>On the screenshot, you can see a camera and two projection planes (shown as red X).\n               You can also see that the size of the projection plane is increasing as it gets farther\n               from the camera. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2203\"></a>The farther projection plane is exactly at the depth of the teapot\'s position in camera\n               space. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2204\"></a>The red sphere in the upper left corner of the projection plane corresponds to the\n               \n               		  <span class=\"code\"> <em class=\"strong\">screen_origin</em> </span> coordinate calculated above. To create the image, the \n               		  <span class=\"code\"> <em class=\"strong\">screen_origin</em> </span> value was calculated, then the MAXScript line of code \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BB\"></a><pre>sphere pos:(screen_origin*$Camera01.transform)</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2207\"></a>was called to create a sphere in world coordinates representing that point. (<span class=\"code\"> <em class=\"strong\">screen_origin</em> </span> was originally in camera space, multiplying it by the camera\'s transformation matrix\n               transforms it back into world coordinates!) \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2208\"></a>Same with the blue sphere - it represents the \n               		  <span class=\"code\"> <em class=\"strong\">end_screen</em> </span> coordinate. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2209\"></a>Here is what the camera sees when rendering the view - notice the red and blue spheres\n               appearing exactly where expected: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC220A\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-2553A757-0412-469C-973C-FB5806851F12-low.gif\"></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64BA\"></a><pre><em class=\"codeEmphasisStrong\">world_size = screen_origin-end_screen</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC220C\"></a>Now we know the two extremes of the projection plane and can calculate the width and\n               height of the projection plane in world units. We also know the size of the plane\n               in pixels, so we can determine the relationship between pixels and world units! \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B9\"></a><pre><em class=\"codeEmphasisStrong\">x_aspect = screen_width/(abs world_size.x)\ny_aspect = screen_height/(abs world_size.y)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC220F\"></a>Using the size of the plane, we can calculate the aspect values - basically the number\n               of pixels corresponding to one world unit along X and Y. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B8\"></a><pre><em class=\"codeEmphasisStrong\">screen_coords= point2 (x_aspect*(thePos.x-screen_origin.x)) (-(y_aspect*(thePos.y-screen_origin.y)))</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2211\"></a>Using the aspect values, we can convert the X and Y values of the vertex position\n               into actual pixel positions. Note that the Y coordinate is inverted, and the X position\n               has to be offset by the screen_origin because the camera axis (the center of the image)\n               is located at coordinates [0,0], while the actual origin of the image in MAXScript\n               is in the upper left corner... \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B7\"></a><pre><em class=\"codeEmphasisStrong\">setPixels front_vfbscreen_coordsdot_color</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2213\"></a>Now we can draw a pixel in the front buffer at the location of the current vertex\n               using the color array defined above using the wireframe color. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B6\"></a><pre><em class=\"codeEmphasisStrong\">)--end v loop\n)--end o loop\ndisplay front_vfb&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2217\"></a>When all vertices of all objects have been processed, we can update the display. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B5\"></a><pre><em class=\"codeEmphasisStrong\">et = timestamp()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2219\"></a>Then we can stop the time again to see how long it took to draw once. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B4\"></a><pre><em class=\"codeEmphasisStrong\">pushPrompt (\"VertRender \" +(1000.0/(et-st)) as string + \" fps\")</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC221B\"></a>The result will be output to the status bar. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B3\"></a><pre><em class=\"codeEmphasisStrong\">)--end fn\non isChecked returnVertexRendererEnabled</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC221F\"></a>When the macroScript is placed on a toolbar, menu or QuadMenu, its checked status\n               will be determined by the boolean value stored in the local variable we defined in\n               the beginning... \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B2\"></a><pre><em class=\"codeEmphasisStrong\">on execute do</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2222\"></a>When the user presses the button / selects the menu item... \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B1\"></a><pre><em class=\"codeEmphasisStrong\">VertexRendererEnabled = not VertexRendererEnabled</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2224\"></a>...we flip the state of the variable - if it was true it becomes false and vice-versa.\n               \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64B0\"></a><pre><em class=\"codeEmphasisStrong\">if VertexRendererEnabled then\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2227\"></a>If the script was just enabled, then \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AF\"></a><pre><em class=\"codeEmphasisStrong\">screen_width=RenderWidth\nscreen_height=RenderHeight</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC222A\"></a>we read the current size values of the Render Scene dialog. You could replace these\n               values with your fixed values, for example 320 and 240 to have a fixed size regardless\n               of the renderer settings... \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AE\"></a><pre><em class=\"codeEmphasisStrong\">back_vfb = bitmap screen_width screen_height\nfront_vfb = bitmap screen_width screen_height</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC222D\"></a>Then we use these size values to define two bitmaps. The first is the back buffer\n               used to clear the image before drawing. Once again, you could use an openBitmap call\n               here to load a background image from disk to draw on top of it! \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AD\"></a><pre><em class=\"codeEmphasisStrong\">registerRedrawViewsCallback VertexRendererFunction</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC222F\"></a>Here we register the function we defined above as a viewport redraw callback. Each\n               time the \n               		  <em class=\"strong\">3ds Max \n                  		  </em>viewport is redrawn, the function will be called and update the rendered image! \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AC\"></a><pre><em class=\"codeEmphasisStrong\">VertexRendererFunction()&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2231\"></a>To initialize the display, we call the function once. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AB\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\nelse\n(\nunRegisterRedrawViewsCallback VertexRendererFunction&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2236\"></a>If the renderer was already open, it has to close now. We unregister the callback\n               function to avoid further updates, \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64AA\"></a><pre><em class=\"codeEmphasisStrong\">close front_vfb&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2238\"></a>and close the image to undisplay it. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64A9\"></a><pre><em class=\"codeEmphasisStrong\">)\n)--end on execute\n)--end script</em></pre></div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC223D\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";