var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-85DF0C09-7418-4440-B2AB-FA199CFD143A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface TVerts\">\n      <meta name=\"indexterm\" content=\"xView, TVerts Interface\">\n      <meta name=\"indexterm\" content=\"TVerts Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: TVerts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-85DF0C09-7418-4440-B2AB-FA199CFD143A\"></a><div class=\"head\">\n            <h1>Interface: TVerts </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E6E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E6D\"></a><p class=\"table-body\">  <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; T-Verts xView Checker \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E6B\"></a>The<em class=\"strong\"> TVerts Core Interface </em>exposes methods for controlling the T-Vertices xViewChecker which visualizes vertices\n            at T-shaped edgesin Poly objects. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E6A\"></a>Any vertex with three outgoing edges is considered a T-Vertex regardless of the angle\n            between the edges. T-Vertices are typically found where the flow of an edge loop is\n            interrupted by a full polygon. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E69\"></a>Available in <em class=\"strong\">3ds Max 2010</em> and higher.   \n         </p>\n         <p><a name=\"GUID-AE302945-0B53-4F38-A301-611DBC78D1A6\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E67\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E66\"></a>Does not expose any properties. \n         </p>\n         <p><a name=\"GUID-2063B510-8D74-4695-B899-91EC20867AEF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E65\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5430\"></a><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">TVerts.Check</em> &lt;time&gt;time &lt;node&gt;nodeToCheck &lt;&amp;index array&gt;results 	 \n\nCheck enums: { <em class=\"codeEmphasisStrong\">#Failed|#Vertices|#Edges|#Faces</em>} 	 \nresults is In and Out parameter   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E64\"></a>Performs a T-Vertices geometry check at the given time on the specified node and returns\n            its results in the array passed by-reference as third argument. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E63\"></a>The method itself<em class=\"strong\"> always</em> returns the <span class=\"code\"> <em class=\"strong\">#vertices</em> </span> enum because the values written to the results array always represent the indices\n            of vertices. \n         </p>\n         <p><a name=\"GUID-472BAFD9-ED3F-424B-BAFB-170A15C784E3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-542E\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">TVerts.hasPropertyDlg</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E61\"></a>Returns true if the xView checker implements a property dialog, false if it does not.\n            \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E60\"></a>In the particular case of the T-Vertices checker, it<em class=\"strong\"> always returns false</em>. \n         </p>\n         <p><a name=\"GUID-32E4C43C-312B-44EA-A5F9-5BF5BC73FB36\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-542D\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">TVerts.showPropertyDlg</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E5E\"></a>Shows the property dialog \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E5D\"></a>In the particular case of the T-Vertices checker this method<em class=\"strong\"> does nothing</em>. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7611\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D39DB3C5-F97C-4DDC-9F9F-C34EE7E50653-low.gif\"></div>\n         <p><a name=\"GUID-527F7119-C4C5-4847-8D8D-2B55DAC82E9A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E59\"></a> <span class=\"char_link\"><a href=\"GUID-3E1B1FA8-710C-4FF8-A067-68F6DFF15799.htm\">xView Geometry Checker Access</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";