var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-87081207-7388-4F7E-AA7B-60D00ABECF03\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ListView ActiveX Control Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ListView ActiveX Control Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-87081207-7388-4F7E-AA7B-60D00ABECF03\"></a><div class=\"head\">\n            <h1>ListView ActiveX Control Example </h1>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-759E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-484E\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                  Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-484D\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                  on the system to be accessible to MAXScript. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-484C\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-484B\"></a>See the topic <span class=\"char_link\"><a href=\"GUID-25E15114-B1F5-4C62-8E84-C630C15E92BB.htm\">Converting ActiveX ListView Control to DotNet ListView Control</a></span> for an example of switching existing ActiveX code to DotNet. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4849\"></a>The following example will not work on your system unless it has a ListView ActiveX\n                  control installed. \n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4845\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4844\"></a><p class=\"table-body\"> <em class=\"strong\">SAMPLE SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7099\"></a><pre>\nrollout controlR92 \"Microsoft ListView Control, version 6.0\"\n(\nactiveXControl ax \"{BDD1F04B-858B-11D1-B16A-00C0F0283628}\" height:200 width:300 align:#left\n--on ax Click do format \"handler: Click\\n\"\n--on ax DblClick do format \"handler: DblClick\\n\"\non controlR92 open do\n(\nshowProperties ax\nax.MousePointer = #ccArrow\nax.GridLines = true\nax.AllowColumnReorder = true\nax.BorderStyle = #ccFixedSingle\nax.view = #lvwReport\nchs = ax.columnHeaders\n--showProperties chs\n--showMethods chs\nhTargets = chs.Add()\nhWeights = chs.Add()\nhTargets.text = \"Node\"\nhWeights.text = \"Weights\"\nlis = ax.listItems\nfor i=0 to 10 do\n(\nlocal li\nli = lis.Add()\nli.text = \"Item \" + i as string\n)\nfor li in ax.listItems do li.bold = true\nli = ax.HitTest 100 1500\nif li != undefined do\n(\nshowProperties li\nli.text = \"Just Hit Tested\"\nshowEvents controlR92.ax\nshowMethods controlR92.ax\n)\n)\n)\nnr92 = newRolloutFloater \"Microsoft ListView Control, version 6.0\" 350 300 10 10\naddRollout ControlR92 nr92\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4813\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5B097B80-912F-4080-AFD1-4CFA9BE84EA6-low.gif\"></div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4811\"></a> <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              One</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4810\"></a> <span class=\"char_link\"><a href=\"GUID-C9BD442F-7B4E-42F6-92CC-31B2DEE9E4FB.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              Two</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-480F\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";