var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"objects\">\n      <meta name=\"indexterm\" content=\"class: property inspection\">\n      <meta name=\"indexterm\" content=\"class: and object inspector functions\">\n      <meta name=\"indexterm\" content=\"help()\">\n      <meta name=\"indexterm\" content=\"apropos()\">\n      <meta name=\"indexterm\" content=\"showClass()\">\n      <meta name=\"indexterm\" content=\"getObjectName\">\n      <meta name=\"indexterm\" content=\"showProperties()\">\n      <meta name=\"indexterm\" content=\"show()\">\n      <meta name=\"indexterm\" content=\"getPropNames()\">\n      <meta name=\"indexterm\" content=\"setProperty()\">\n      <meta name=\"indexterm\" content=\"getProperty()\">\n      <meta name=\"indexterm\" content=\"setPropertyController()\">\n      <meta name=\"indexterm\" content=\"getPropertyController()\">\n      <meta name=\"indexterm\" content=\"hasProperty()\">\n      <meta name=\"indexterm\" content=\"isProperty()\">\n      <meta name=\"indexterm\" content=\"isPropertyAnimatable()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Class and Object Inspector Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52\"></a><div class=\"head\">\n            <h1>Class and Object Inspector Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7434\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7433\"></a>   MAXScript provides a number of built-in functions for displaying information about\n               the classes that are accessible in your particular \n               		  <em class=\"strong\">3ds Max</em> installation. These functions are useful as an online reference for the core \n               		  <em class=\"strong\">3ds Max</em> classes and provide the only way of determining what properties in \n               		  <span class=\"char_link\"><a href=\"GUID-7D8FE93F-BB97-4509-8CE7-EB8483E48EC4.htm\">third-party plug-in classes</a></span> are accessible. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7FDD\"></a> \n            <h2><a name=\"GUID-DEB9439B-BFCA-4319-BF35-A91D11206CE0\"></a>  apropos\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-742D\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">apropos()</em> </span> function is used to search for and print out information about global variables by\n               name pattern and class of contents. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-742C\"></a>This function has the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6F\"></a><pre><em class=\"codeEmphasisStrong\">apropos</em> &lt;pattern_string&gt; [ <em class=\"codeEmphasisStrong\">implicitWild</em>:true ] [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-742A\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">&lt;pattern_string&gt;</em> </span> argument is a string containing a wild-card pattern for matching against global variables.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7429\"></a>The pattern form is: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6E\"></a><pre>&lt;variable_name_pattern_string[:class_name_pattern_string]&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7427\"></a>that is, a global variable name pattern optionally followed by a \':\' and a class name\n               pattern. \n               		\n            </p> \n            <p><a name=\"P_FB6E1F3B11774AA6999BCDF7D7630968\"></a>If the optional class name pattern is given, it restricts the printout to globals\n               containing values of the specified classes. \n               		\n            </p> \n            <p><a name=\"P_2E0395A81ACE47828AD545BDCD105384\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">apropos()</em> </span> function assumes a wild-card \'*\' at the start and end of each pattern, implying a\n               \'contains\' pattern match, unless \n               		  <span class=\"code\"> <em class=\"strong\">implicitWild:false</em> </span> is specified, in which case no \'*\' are assumed. The pattern strings can contain name\n               characters and \'*\'s and \'?\'s. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7426\"></a>The output consists of the global variable name, a tag in () indicating if the variable\n               is a system or const (unchangeable) variable and the class of the value currently\n               in it, followed by a printed representation of that value. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7425\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7424\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6D\"></a><pre>\napropos \"light\" -- any variables with \'light\' in the variable name\napropos \":float\" -- any variables containing float values\napropos \"\" to:f -- dump all variables to the stream f\napropos \"controller:super\" -- the list of controller superclasses\napropos \"foo:control\" -- any variables whose name contains \'foo\'\n-- and that contain controller classes\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-741B\"></a><p class=\"table-body\">Here\'s a fragment of the first example\'s output: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6C\"></a><pre>\nlights (const ObjectSet): $lights\nlightLevel (system Float): 1.0\nSunlight (const MAXClass): Sunlight\nDirectionallight (const MAXClass): Directionallight\nlightLevelController (system Control): Controller:Bezier_Float\nlight (const MAXSuperClass): light\nNewLight (const Primitive): NewLight()\nlightTintColor (system Color): (color 255 255 255)\nVolume_Light (const MAXClass): Volume_Light\nlightTintColorController (system Control): Controller:Bezier_Color\ngw.getMaxLights (Primitive): getMaxLights()\ngw.setLight (Primitive): setLight()\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-740B\"></a>To make scripting easier to teach and use everyday, a ScriptTool function for \n               		  <em class=\"strong\">Help</em> has been added. It is an alias for \n               		  <em class=\"strong\">apropos</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-740A\"></a>Typing \n               		  <em class=\"strong\">Help \"Box\"</em> will show all the commands using the name BOX. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7FCB\"></a> \n            <h2><a name=\"GUID-0B434944-47B1-4CA8-BF19-DD1D2A358235\"></a> showClass\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7408\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> function prints information about a specified \n               		  <em class=\"strong\">3ds Max</em> class or classes. It has the following form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6B\"></a><pre><em class=\"codeEmphasisStrong\">showClass</em> &lt;pattern_string&gt; [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7406\"></a>where \n               		  <span class=\"code\"> &lt;pattern_string&gt; \n                  		  </span> is a string containing a wild-card pattern to match against \n               		  <em class=\"strong\">3ds Max</em> class names, superclass names and property names, and the optional \n               		  <span class=\"code\"> <em class=\"strong\">to:</em>&lt;stream&gt; \n                  		  </span> keyword argument specifies a \n               		  <span class=\"char_link\"><a href=\"GUID-A2290E77-5392-431D-8B75-F6A1262E9639.htm\">Stream Value</a></span> to output the display to. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7405\"></a>The pattern string has this form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D6A\"></a><pre>\"&lt;class_name&gt;[:&lt;superclass_name&gt;][.&lt;property_name&gt;]\"</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7403\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7402\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D69\"></a><pre>\nshowClass \"path*\" -- all 3ds Max classes starting \'path\'\nshowClass \"noise.*\" -- all the accessible properties on the\n-- Noise texture map\nshowClass \"*:mod*\" -- all the modifier classes\nshowClass \"*.*rad*\" -- all the classes with a property name\n-- containing \'rad\'\nshowClass \"*.*\" to:f -- everything, out to a file\nshowClass \"*:*controller*\" -- all the classes that have\n-- \"controller\" in their superclass\n-- name\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73F5\"></a>In the output from the last example, the controllers include \n               		  <em class=\"strong\">3ds Max</em>\'s core controllers and any 3rd-party plug-in controllers. In some cases, embedded\n               controllers for some complex plug-ins might be visible in the \n               		  <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> listing (such as for Character Studio Bipeds). You must \n               		  <em class=\"strong\">not</em> attempt to create and use these controllers individually, this might result in system\n               exceptions. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73F4\"></a>If you leave out the superclass pattern (the \n               		  <span class=\"code\"> <em class=\"strong\">\':\'</em> </span> part), it matches \n               		  <em class=\"strong\">all</em> superclasses. If you leave out the property pattern (the \n               		  <span class=\"code\"> <em class=\"strong\">\'.\'</em> </span> part), you only get class names printed. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1909\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This function \n                  		  <em class=\"strong\">only</em> displays matching MAXWrapper classes (nodes, modifiers, materials, and others), not\n                  the foundation classes in MAXScript (float, integer, array, point3, and others). \n                  		\n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73EF\"></a>The following shows examples of the \n               		  <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> output: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73EE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73ED\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D68\"></a><pre>\nshowclass \"box*\" -- show all classes whose name starts with \"box\"\nshowclass \"box.*\" -- show all properties for class box\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73E8\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D67\"></a><pre>\nBox : GeometryClass {10,0} -- start of output from line 1\nBoxGizmo : helper {3bc31904,67d74ec9}\nOK -- result returned from line 1\nBox : GeometryClass {10,0} -- start of output from line 2\n.height : float\n.length : float\n.lengthsegs : integer\n.width : float\n.widthsegs : integer\n.mapCoords : boolean\n.heightsegs : integer\nOK -- result returned from line 2\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_692C29D225F54A42A52715B7C3ACF670\"></a> \n            <h2><a name=\"GUID-A1102AA9-5DD8-45DE-9B5B-0287C568D6D7\"></a> getObjectName\n            </h2> \n            <p>The getObjectName function returns the class name of an object, as it would appear\n               in the history browser or modifier stack. If the passed object is not an object or\n               modifier, this function returns undefined. The function has the following syntax:\n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">getObjectName</em> &lt;object&gt;</pre></div> \n            <p>For example:\n               		\n            </p> <a name=\"TABLE_6A8246B48709400691FBB535BCD3BBC1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nmyBox = Box name:\"myBox\"\nmyBend = Bend()\nmyCompass = Compass()\ngetObjectName myBox\n--&gt; \"Box\"\ngetObjectName myBend\n--&gt; \"Bend\"\ngetObjectName myCompass\n--&gt; \"Compass\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7FB8\"></a> \n            <h2><a name=\"GUID-96E455C1-6B67-4574-9CB8-2C28D9F60375\"></a>   <em class=\"strong\">showProperties</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D7\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span> function is used to display the properties for a specific object that is an instance\n               of one of the MAXWrapper classes. It can be used in place of \n               		  <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> in situations where you have an actual object in hand. Unlike \n               		  <span class=\"code\"> <em class=\"strong\">showClass()</em> </span>, it can display the \n               		  <span class=\"char_link\"><a href=\"GUID-B9058582-6DA8-41AF-B44E-930C787807F1.htm\">dynamic properties</a></span> that might appear in individual objects as you work on them in the scene such as,\n               the sub-controllers in a list controller or the animated control points in an FFD\n               modifier. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D6\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span> function has the following form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D66\"></a><pre><em class=\"codeEmphasisStrong\">showProperties</em> &lt;maxwrapper_object&gt; [ &lt;property_pattern&gt; ] [ <em class=\"codeEmphasisStrong\">to</em> :&lt;stream&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D4\"></a>where \n               		  <span class=\"code\"> &lt;maxwrapper_object&gt; \n                  		  </span> is the \n               		  <em class=\"strong\">3ds Max</em> entity to be inspected, the optional \n               		  <span class=\"code\"> &lt;property_pattern&gt; \n                  		  </span> is a wild-card pattern that names the properties to be inspected, and the optional\n               \n               		  <span class=\"code\"> <em class=\"strong\">to:</em>&lt;stream&gt; \n                  		  </span> keyword argument specifies a \n               		  <span class=\"char_link\"><a href=\"GUID-A2290E77-5392-431D-8B75-F6A1262E9639.htm\">Stream Value</a></span> to output the display to. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D3\"></a>If the property name pattern is not supplied, \n               		  <em class=\"strong\">all</em> properties are listed. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73D0\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D65\"></a><pre>\nshowProperties $foo.bend -- show properties of the Bend modifier on object foo \nffdmod = $baz.\'FFD_box__4x4x4\' -- point to the FFD modifier on object baz\nshowProperties ffdmod \"disp*\" to:log -- show properties starting with \"disp\" in the FFD modifier\nshowProperties $foo.pos.controller -- sub controllers in a position list controller\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1908\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73C5\"></a>When the \n                     			 <em class=\"strong\">3ds Max</em> entity specified is a node (for example, $box01), this function \n                     			 <em class=\"strong\">only</em> displays the properties of the base object. It does not show the properties of the\n                     transform controllers, modifiers, or materials applied to the object. To display the\n                     properties for one of these objects, it must be specified as the \n                     			 <em class=\"strong\">3ds Max</em> entity as shown in the above examples. \n                     		  \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73C4\"></a> <em class=\"strong\">showProperties</em> includes properties defined by FPS interfaces in \n                     			 <em class=\"strong\">3ds Max 8 and higher</em>. See \n                     			 <span class=\"char_link\"><a href=\"\">Inspecting Interface Properties</a></span> for an example. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73C2\"></a>The following shows examples of the \n               		  <em class=\"strong\">showProperties</em> output: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73C0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73BF\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D64\"></a><pre>\nb = box() -- create a box\nffd_mod = ffdBox() -- create a ffdBox modifier\naddmodifier b ffd_mod -- apply ffdBox modifier to the box\nshowproperties b -- show all properties for the box\nshowproperties ffd_mod -- show all properties for the ffdBox modifier \n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-73B7\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D63\"></a><pre>\n$Box:Box07 @ [0.0000,0.0000,0.0000] -- result from line 1\nFFD_box__4x4x4:FFD(box) 4x4x4 -- result from line 2\nOK -- result from line 3\n.height : float -- start of output from line 4\n.length : float\n.lengthsegs : integer\n.width : float\n.widthsegs : integer\n.mapCoords : boolean\n.heightsegs : integer\nOK -- result from line 4\n.dispLattice (Lattice) : boolean -- start of output from line 5\n.dispSource (Source Volume) : boolean\n.deformType (&lt;unknown&gt;) : integer\n.falloff : float\n.tension : float\n.continuity : float\n.inPoints (Inside Points) : boolean\n.outPoints (Outside Points) : boolean\n.offset : float\n.lattice_transform : transform\nOK -- result from line 5\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-739D\"></a>To make scripting easier to teach and use everyday, a ScriptTool function for \"Show\"\n               has been added. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-739C\"></a> <em class=\"strong\">Show</em> is the short way of typing \n               		  <em class=\"strong\">ShowProperties</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-739B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-739A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D62\"></a><pre>\nShow $ --will show you the properties of the selected object\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F9F\"></a> \n            <h2><a name=\"GUID-6A7A5726-9441-45E7-B188-74E6D91CC71F\"></a> getPropNames\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7394\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> function is similar to \n               		  <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span>, except it returns the property names for a specific object as an array. Unlike \n               		  <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span>, you can specify whether to return only the names of \n               		  <span class=\"char_link\"><a href=\"GUID-B9058582-6DA8-41AF-B44E-930C787807F1.htm\">dynamic properties</a></span> of the object. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7393\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames</em> </span> function has the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D61\"></a><pre><em class=\"codeEmphasisStrong\">getPropNames</em> &lt;maxwrapper_obj&gt; [ <em class=\"codeEmphasisStrong\">#dynamicOnly</em>]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7390\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> function returns an array of the property names accessible on the object. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-738F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-738E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-738D\"></a><p class=\"table-body\">if a FFD(Box) modifier with animated control points is applied to a sphere, \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D60\"></a><pre>\ngetPropNames $sphere01.\'FFD(box) 4x4x4\'\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7389\"></a><p class=\"table-body\">could yield: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5F\"></a><pre>\n#(#dispLattice, #dispSource, #deformType, #falloff, #tension, #continuity, #inPoints, #outPoints, #offset, #Lattice_Transform, #Control_Point_49, #Control_Point_50, #Control_Point_51, #Control_Point_52, #Control_Point_53)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1907\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7382\"></a>When the \n                     			 <em class=\"strong\">3ds Max</em> entity specified is a node (for example, $box01), this function \n                     			 <em class=\"strong\">only</em> returns the properties of the base object. It does not return the properties of the\n                     transform controllers, modifiers, or materials applied to the object. To return the\n                     properties for one of these objects, it must be specified as the \n                     			 <em class=\"strong\">3ds Max</em> entity as shown in the above examples. \n                     		  \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7381\"></a> <em class=\"strong\">getPropNames</em> includes properties defined by FPS interfaces in \n                     			 <em class=\"strong\">3ds Max 8 and higher</em>. See \n                     			 <span class=\"char_link\"><a href=\"\">Inspecting Interface Properties</a></span> for an example. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-737F\"></a>If you call \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> on MAXWrapper classes such as, Box, Line, or Bend, it will return the properties\n               common to all instances of that class. If you call \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> on a \n               		  <em class=\"strong\">3ds Max</em> entity, it will return the properties currently defined for that entity. If you add\n               the optional keyword \n               		  <span class=\"code\"> <em class=\"strong\">#dynamicOnly</em> </span> to the \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> call for an entity, it returns the dynamic properties unique to that instance. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-737D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-737C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-737B\"></a><p class=\"table-body\">if a FFD(Box) modifier with animated control points is applied to a sphere, \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5E\"></a><pre>\ngetPropNames $sphere01.\'FFD(box) 4x4x4\' #dynamicOnly\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7377\"></a><p class=\"table-body\">could yield: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5D\"></a><pre>\n#(#Lattice_Transform, #Control_Point_49, #Control_Point_50, #Control_Point_51, #Control_Point_52, #Control_Point_53)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1906\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The property names for the lattice transform and control points which was returned\n                  by the previous example is not returned when \n                  		  <span class=\"code\"> <em class=\"strong\">#dynamicOnly</em> </span> is specified. These properties are unique to the specific FFD modifier. \n                  		\n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-736E\"></a>As a special case, you can also call \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> on the superclass \'Node\' to get the list of properties common to all scene nodes\n               such as, \n               		  <span class=\"code\"> <em class=\"strong\">.position</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">.name</em> </span>, or \n               		  <span class=\"code\"> <em class=\"strong\">.wireColor</em> </span>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-736C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-736B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5C\"></a><pre>\ngetPropNames node\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F84\"></a> \n            <h2><a name=\"GUID-4A9FC5ED-2B62-4F91-B9A9-449B441387B0\"></a> <em class=\"strong\">getPropNames and Interfaces</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7366\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames</em> </span> method has been extended to work with the various interface values. The method will\n               return the names of properties exposed by the interface. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7365\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7364\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5B\"></a><pre>\ngetpropnames s.inode\n#(#boneEnable, #posTaskWeight, #rotTaskWeight, #boneAutoAlign, #boneFreezeLength, #boneScaleType, #stretchTM, #boneAxis, #boneAxisFlip, #primaryVisibility, #secondaryVisibility, #applyAtmospherics, #vertexColorType, #showVertexColors, #shadeVertexColors, #handle, #posInParent, #rotInParent, #scaleInParent, #scaleOrientInParent)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F7F\"></a> \n            <h2><a name=\"GUID-42A16C08-CAFF-49E0-A08D-8B0CF71BD546\"></a>  getProperty and setProperty\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-735C\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getProperty()</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">setProperty()</em> </span> functions allow you to access and set properties using computed property names. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-735B\"></a>The forms for each of these functions are: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D5A\"></a><pre><em class=\"codeEmphasisStrong\">getProperty</em> &lt;obj&gt; &lt;property_name&gt; [removeUIScaling:&lt;bool&gt;]\n<em class=\"codeEmphasisStrong\">setProperty</em> &lt;obj&gt; &lt;property_name&gt; &lt;value&gt; [applyUIScalling:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7358\"></a>The property name can be either a name, for example, \n               		  <span class=\"code\"> <em class=\"strong\">#length</em> </span>, or a string, for example, \n               		  <span class=\"code\"> <em class=\"strong\">\"length\"</em> </span>. You can construct property names with string operations. \n               		\n            </p> \n            <p>The \n               		  <span class=\"code\">removeUIScaling</span>/<span class=\"code\">applyUIScaling</span> parameters default to true. If false, the value will be affected by the scale factor\n               on High DPI displays, for those properties related to screen values (for example,\n               #pos for UI controls). Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7357\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7356\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D59\"></a><pre>\ngetProperty foo #x -- equiv. to foo.x\nsetProperty $foo \"radius\" 23 -- equiv. to $foo.radius = 23\ngetProperty $foo.ffd_2x2x2 (\"control_point_\" + n as string)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-734F\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">getPropNames()</em> </span> function can be used in conjunction with the \n               		  <span class=\"code\"> <em class=\"strong\">getProperty()</em> </span> function to implement object \'dumping’ tools that can iterate over all the properties\n               of an arbitrary object and output them as required. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-734E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-734D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D58\"></a><pre>\nfor p in getPropNames $foo do\nformat \"% = %\\n\" p (getProperty $foo p)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7347\"></a>Similar functions for accessing and setting the values of property-assigned controllers\n               are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D57\"></a><pre><em class=\"codeEmphasisStrong\">getPropertyController</em> &lt;value&gt; &lt;string_or_name&gt;\n<em class=\"codeEmphasisStrong\">setPropertyController</em> &lt;value&gt; &lt;string_or_name&gt; &lt;controller&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7343\"></a>Get and set the controller assigned to the named property of the value. If no controller\n               has been assigned to the property, a value of undefined is returned. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F6C\"></a> \n            <h2><a name=\"GUID-3B5686E3-F1B8-4FB8-8FA8-1280FFEFF441\"></a> hasProperty\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7340\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">hasProperty()</em> </span> function allows you to test whether an object has a specified property name. Unlike\n               \n               		  <span class=\"code\"> <em class=\"strong\">isProperty(),</em> </span> the property name string supports wildcard patterns. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D56\"></a><pre><em class=\"codeEmphasisStrong\">hasProperty</em> &lt;obj&gt; &lt;prop_name_or_pattern_string&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-733D\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the object has the given property or has properties matching the string pattern.\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-733B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-733A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D55\"></a><pre>\nhasProperty $Box01 \"height\" --test for height in a Box\n--&gt; true\nhasProperty $Box01 \"radius\" --test for radius in a Box\n--&gt; false\nhasProperty $Sphere01 \"radius\" --test for radius in a Sphere\n--&gt; true\nhasProperty $Sphere01 \"rad*\" --test for any property name\n--&gt; true --starting with \"rad\" in a Sphere\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F64\"></a> \n            <h2><a name=\"GUID-B4D5DD8B-A475-473F-A8D2-F26605D6FC20\"></a> isProperty\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-732F\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">isProperty()</em> </span> function allows you to test whether an object has a specified property. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D54\"></a><pre><em class=\"codeEmphasisStrong\">isProperty</em> &lt;MAXWrapper_object&gt; &lt;property_name_or_string&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-732D\"></a> <span class=\"code\"> <em class=\"strong\">isProperty()</em> </span> returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified property is a property of the MAXWrapper object, \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. The property name can be either a name, for example, \n               		  <span class=\"code\"> <em class=\"strong\">#length</em> </span>, or a string, for example, \n               		  <span class=\"code\"> <em class=\"strong\">\"length\"</em> </span>. You can construct property names with string operations. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-732C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-732B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D53\"></a><pre>\nb=box()\ns=sphere()\nisProperty $Box001 #height --test for height in a Box\n--&gt; true\nisProperty $Box001 #radius --test for radius in a Box\n--&gt; false\nisProperty $Sphere001 #radius --test for radius in a Sphere\n--&gt; true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F5C\"></a> \n            <h2><a name=\"GUID-93BFF395-3F47-44E2-839A-246275E2FF54\"></a> <em class=\"strong\">The difference between hasProperty and isProperty</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7322\"></a> <em class=\"strong\">hasProperty</em> and \n               		  <em class=\"strong\">isProperty</em> do entirely different things. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7321\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7320\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D52\"></a><pre>\nhasProperty $Box01 \"name\"&nbsp;\n--&gt; false\nisProperty $Box01 \"name\"&nbsp;\n--&gt; true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7318\"></a> <em class=\"strong\">hasProperty</em> uses the same code as \n               		  <span class=\"code\"> <em class=\"strong\">showPropeties()</em> </span>, but instead of returning a list of the properties found, it returns true on the\n               first property name that matches the specified pattern. \n               		  <em class=\"strong\">showProperties</em> is looking at just the box base object and its MAXClass definition. It does not look\n               at any higher level properties (and in versions prior to \n               		  <em class=\"strong\">3ds Max 8</em> it does&nbsp;not look at any of the FPS interface exposed properties). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7317\"></a> <em class=\"strong\">isProperty</em> on the other hand actually tries to access the specified object with the specified\n               name and to detect whether&nbsp;the access succeeded or failed. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7F55\"></a> \n            <h2><a name=\"GUID-F2F7B42D-0E5D-4D25-BFDD-D3329BB9F776\"></a> isPropertyAnimatable\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D51\"></a><pre><em class=\"codeEmphasisStrong\">isPropertyAnimatable</em> &lt;obj&gt; &lt;string_or_name&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7313\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the property is found and is animatable. Returns \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> if the property is not found or is not animatable. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7312\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7311\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D50\"></a><pre>\ns = Sphere() --create a sphere\n--&gt; $Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\nisPropertyAnimatable s #radius --check if radius is animatable\n--&gt; true\nisPropertyAnimatable s #mapCoords --check if UV coords are\n--&gt; false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7307\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7306\"></a><p class=\"table-body\"> <em class=\"strong\">ANOTHER EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D4F\"></a><pre>\ns = Sphere() --create a sphere\n--Print a list of all properties of the sphere and whether\n--they are animatable or not:\nfor i in getPropNames s do\nformat \"% Property: % - Animatable: %\\n\"s.name i (isPropertyAnimatable s i)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72FE\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D4E\"></a><pre>\n$Sphere:Sphere003 @ [0.000000,0.000000,0.000000]\nSphere003 Property: #smooth - Animatable: true\nSphere003 Property: #radius - Animatable: true\nSphere003 Property: #segs - Animatable: true\nSphere003 Property: #mapcoords - Animatable: false\nSphere003 Property: #slice - Animatable: false\nSphere003 Property: #hemisphere - Animatable: true\nSphere003 Property: #sliceFrom - Animatable: true\nSphere003 Property: #sliceTo - Animatable: true\nSphere003 Property: #chop - Animatable: false\nSphere003 Property: #recenter - Animatable: false\nSphere003 Property: #realWorldMapSize - Animatable: false\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72EE\"></a> \n            <h2><a name=\"GUID-7D68B965-3941-4CAA-9C47-D559B55D4B9F\"></a> <em class=\"strong\">SubAnims and ParamBlocks</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72ED\"></a> <em class=\"strong\">3ds Max</em> stores all of properties for objects in structures called \n               		  <em class=\"mild\">subAnims</em>. In some cases, a subAnim will contain nested subAnims. An example of this can be\n               seen with the Standard material. If you apply a Standard material to a \n               		  <em class=\"strong\">3ds Max</em> object, and then expand the object\'s tracks in Track View to display the material,\n               you will see three Track View nodes - Parameters, Maps, and Shader. Each of these\n               nodes is a subAnim defined in the Standard material’s class. Expanding the tracks\n               for these three nodes, you will see various properties listed. These properties are\n               defined in each of the nested subAnims in a structure called a \n               		  <em class=\"mild\">ParamBlock</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72EC\"></a>MAXScript automatically finds animatable properties in all ParamBlocks associated\n               with an object. To access these properties, you use the same nesting as shown in Track\n               View when referencing those properties in MAXScript. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72EA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72E9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72E8\"></a><p class=\"table-body\">you would access the Ambient Color property in a Standard material in MAXScript as:\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D4D\"></a><pre>\n$box01.material.shader.diffuse_color\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72E3\"></a>For more information about accessing animatable properties in MAXScript, see also\n               \n               		  <span class=\"char_link\"><a href=\"GUID-3F9BC35F-918C-46C6-8617-7DCDDD62FCE3.htm\">Indexed Access to Animatable Properties in 3ds Max Objects</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72E2\"></a>The properties accessible on various kinds of values are documented for each class.\n               Many of the foundation classes in MAXScript (such as, point3, color, and so on) support\n               a special kind of \n               		  <em class=\"strong\">nested-property assignment</em> which allows sub-properties on object properties such as, the \n               		  <span class=\"code\"> <em class=\"strong\">.x</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">.y</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">.z</em> </span> coordinates in a node\'s \n               		  <span class=\"code\"> <em class=\"strong\">.position</em> </span> property to be individually and directly set. See \n               		  <span class=\"char_link\"><a href=\"GUID-10A0C4F9-D22E-4203-A775-5087AA190156.htm\">Nested Object Properties</a></span> for details. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72E0\"></a> <span class=\"char_link\"><a href=\"GUID-782447FD-103B-4686-8F65-97A2A02EB3FB.htm\">showInterfaces Inspector Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72DF\"></a> <span class=\"char_link\"><a href=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94.htm\">GetInterfaces Interface Inspector</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72DE\"></a> <span class=\"char_link\"><a href=\"GUID-C3849AEC-32FC-41B4-9934-1AFAA22CAB79.htm\">showInterface Inspector Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72DD\"></a> <span class=\"char_link\"><a href=\"GUID-41314BEF-A7C5-4525-AF73-B826194A4965.htm\">getClassInstances</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72DB\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72DA\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";