var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-87A31BAC-84A1-4BE7-A948-E8BEB77B0ED7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: AutoTangentMan</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-87A31BAC-84A1-4BE7-A948-E8BEB77B0ED7\"></a><div class=\"head\">\n            <h1> Interface: AutoTangentMan </h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_40B94786B53346CB815A4AF289D48C7E\"></a> \n            <p><a name=\"GUID-55C53AEC-A58A-4D99-A50E-F7B15FD53EAB\"></a>This Core Interface provides access to the AutoTangent algorithm settings of <em class=\"strong\">3ds Max</em>. \n            </p> \n            <p><a name=\"GUID-02D38974-DE1D-4FBA-B27C-8B701987D177\"></a>Available in <em class=\"strong\">3ds Max 2012 and higher</em>. \n            </p> \n            <p><a name=\"GUID-72DF7A0A-4DA4-43EB-A487-1AD3327417FE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_EAC817094AAA4FE88A75E78AC67FD226\"></a><pre> Interface: <em class=\"codeEmphasisStrong\">AutoTangentMan</em></pre></div> \n            <p><a name=\"GUID-91DA3627-D1C9-45B4-99DE-41B759E33F45\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"GUID-6F25C930-86A2-4EDA-9EE2-7350B6DD6AD3\"></a> <em class=\"strong\"> Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_B82CB153725C44ECA2760F02254D7A06\"></a><pre><em class=\"codeEmphasisStrong\">AutoTangentMan</em>.<em class=\"codeEmphasisStrong\">NewControllersAutoTangentAlgorithm</em> : enum : Read|Write\n\nNewControllersAutoTangentAlgorithm enums: {<em class=\"codeEmphasisStrong\">#unsupported</em> | <em class=\"codeEmphasisStrong\">#legacy</em> | <em class=\"codeEmphasisStrong\">#unified</em>}</pre></div> \n            <p><a name=\"GUID-A597CF63-D8FD-4FE7-AD19-683041016D67\"></a> Get/set the default Auto Tangent algorithm for new controllers. \n            </p> \n            <p><a name=\"GUID-986CC85E-4802-47B8-92A6-90B98C58DC1B\"></a> Possible return values are: \n            </p> \n            <p><a name=\"GUID-2239D2CE-BF74-4A6B-A1B3-BAED7148B429\"></a> <em class=\"strong\"> #unsupported</em> - Auto Tangents are not supported. \n            </p> \n            <p><a name=\"GUID-26E49558-9DBE-4D80-967E-BEB87CA28303\"></a> <em class=\"strong\"> #legacy</em> - Use the legacy algorithm of <em class=\"strong\">3ds Max 2011 and earlier</em>. \n            </p> \n            <p><a name=\"GUID-3D358FD0-6332-47A4-A2ED-4F69615118BD\"></a> <em class=\"strong\"> #unified</em> - Use the unified Auto Tangent algorithm implemented in <em class=\"strong\">Autodesk 3ds Max 2012</em>, <em class=\"strong\">Autodesk Maya 2012</em> and <em class=\"strong\">Autodesk Softimage 2012</em>. \n            </p> \n            <p><a name=\"GUID-764CFCC5-C128-4EB2-92D3-663FC826DE1F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"GUID-D8882E56-E4E8-4E03-9BE8-494B34FA1372\"></a> <em class=\"strong\"> Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_F8A3B2F61E614CEC85F93441D22F6A5F\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">AutoTangentMan</em>.<em class=\"codeEmphasisStrong\">SupportsAutoTangent</em> &lt;maxObject&gt;anim</pre></div> \n            <p><a name=\"GUID-6E566FB0-1F5E-406E-8C42-4A4422F55CCF\"></a> Returns true if the supplied Anim supports Auto Tangents, false if it does not. \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_8BC81F7FBE464E809B2DB9CBC8B7475E\"></a><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">AutoTangentMan</em>.<em class=\"codeEmphasisStrong\">GetAutoTangentAlgorithm</em> &lt;maxObject&gt;anim\n\nGetAutoTangentAlgorithm enums: {<em class=\"codeEmphasisStrong\">#unsupported</em> | <em class=\"codeEmphasisStrong\">#legacy</em> | <em class=\"codeEmphasisStrong\">#unified</em>}</pre></div> \n            <p><a name=\"GUID-B2BCDF94-E8AD-45C5-A3D3-3F9357CE27D3\"></a> Returns the Auto Tangent Algorithm of the supplied Anim argument. \n            </p> \n            <p><a name=\"GUID-2F8DB54E-81C9-4B08-8838-629BCCCFA43D\"></a> Possible return values are: \n            </p> \n            <p><a name=\"GUID-A8C132F4-A9C0-46B9-82BF-413D8D26EA61\"></a> <em class=\"strong\"> #unsupported</em> - the controller does not support Auto Tangents. \n            </p> \n            <p><a name=\"GUID-861ECA06-61AA-4223-B3C0-093EB6AD0A90\"></a> <em class=\"strong\"> #legacy</em> - the controller uses the legacy algorithm of <em class=\"strong\">3ds Max 2011 and earlier</em>. \n            </p> \n            <p><a name=\"GUID-6F5644E3-A8E7-46E5-B154-1B92290A8B5A\"></a> <em class=\"strong\"> #unified</em> - the controller uses the unified Auto Tangent algorithm implemented in <em class=\"strong\">Autodesk 3ds Max 2012</em>, <em class=\"strong\">Autodesk Maya 2012</em> and <em class=\"strong\">Autodesk Softimage 2012</em>. \n            </p> \n            <p><a name=\"GUID-D322D2F0-1F85-4FE8-BF72-2C17072F1076\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_493413E1F88D4B1687A774F52721113B\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">AutoTangentMan</em>.<em class=\"codeEmphasisStrong\">SetAutoTangentAlgorithm</em> &lt;enum&gt;algorithm &lt;&amp;maxObject array&gt;anims\n\nalgorithm enums: {<em class=\"codeEmphasisStrong\">#unsupported</em> | <em class=\"codeEmphasisStrong\">#legacy</em> | <em class=\"codeEmphasisStrong\">#unified</em>}\nanims is In and Out parameter </pre></div> \n            <p><a name=\"GUID-E3FDE0C2-7EE8-4565-B830-6A22F9663774\"></a> Sets the Auto Tangent Algorithm of the Anims passed in the second argument\'s array\n               to the mode specified by the first argument. \n            </p> \n            <p><a name=\"GUID-59A87B9B-4C63-4CE3-8988-4EFE1F2932FF\"></a> See above for description of the possible algorithm enums. \n            </p> \n            <p><a name=\"GUID-2C49D51D-15B8-4DB6-A95B-30C340175BA7\"></a> <em class=\"strong\"> Actions:</em> \n            </p> \n            <p><a name=\"GUID-B0E24EFB-AE3C-46AF-BBAD-38599A71F803\"></a>--none-- \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";