var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-887D3A2C-64CB-4AAA-A6E9-FFC73455CDAD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Get the Local Rotation of a Face?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-887D3A2C-64CB-4AAA-A6E9-FFC73455CDAD\"></a><div class=\"head\">\n            <h1>How do I Get the Local Rotation of a Face? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1025\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1027\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1028\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8DC\"> Working With Editable Meshes</a></span> &gt; How do I Get the Local Rotation of a Face? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102A\"></a>Here is how to obtain the rotation value displayed in the Rotate Transform Type-In\n            box when in the local coordinate system from a face in an Editable Mesh. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102B\"></a> <span class=\"char_link\"><a href=\"GUID-58D1F8B6-0012-4727-AA29-B2C79EA46E16.htm\">GetFaceNormal</a></span> returns the face normal in local coordinates as a Point3 value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102C\"></a>Multiplied by the transformation matrix of the object, we get the face normal in world\n            space. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102D\"></a>Using <span class=\"char_link\"><a href=\"GUID-D77C780A-4E8A-4528-949F-CC09AAE048DA.htm\">matrixFromNormal</a></span>, we create a new matrix3 value using the face normal as the local Z axis. This matrix3\n            value is rotated relatively to the identity matrix exactly by the values we are searching\n            for. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102E\"></a>By converting the matrix3 value to<span class=\"char_link\"><a href=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F.htm\">eulerAngles</a></span>, we retrieve exactly the same 3 values displayed in the Transform Type-In when a\n            face is selected while in Local coordinate system. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC102F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1030\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6646\"></a><pre>\nfn getLocalFaceRotation mesh index =\n(\n  (matrixFromNormal (getFaceNormal mesh index)*mesh.transform ) as eulerAngles\n)\n\nobj = sphere() --create a GeoSphere\nconvertToMesh obj --collapse to EditableMesh\nsetFaceSelection obj #{38..40, 49, 50, 59, 60, 70, 80} -- select some faces\nfor f in getFaceSelection obj  do\n  format \"Face: % - Rotation: % \\n\" f (getLocalFaceRotation obj f)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC103C\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";