var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8C8AA5D7-5C8D-44C5-BAED-BA8EC10C59FC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Trackbar Keys Filter Callback Function Examples\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Trackbar Keys Filter Callback Function Examples</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8C8AA5D7-5C8D-44C5-BAED-BA8EC10C59FC\"></a><div class=\"head\">\n            <h1>Trackbar Keys Filter Callback Function Examples </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1545\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1544\"></a> The following examples show the possible ways to implement trackbar key filter functions:\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1542\"></a> \n            <h2><a name=\"GUID-A5A3127D-142A-4EF3-A9DE-D23DCFC70BF3\"></a> <em class=\"strong\">Visibility Keys Filter Function Examples</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1541\"></a>To register a filter that will display only Visibility keys: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1540\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-153F\"></a><p class=\"table-body\"> <em class=\"strong\">YOU CAN SAY</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6863\"></a><pre>\nfn filterVisibilityKeys theAnim theParent theIndex theGParent theNode =\n(\nif theParent != undefined then\ntheParent[theIndex].name == \"Visibility\"\nelse\nfalse\n)\nfn testCallbackAdditionFunction arg1 arg2 = (true)\ntheInterface = maxOps.trackbar\ntheIndex = theInterface.registerFilter filterVisibilityKeys callbackAdditionFunction \"Visibility\" 8 active:true stopTraversal:false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1532\"></a>The filter function will return true only when the Parent is not undefined and the\n               subAnim indexed track of the parent is called \"Visibility\". \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1531\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1530\"></a><p class=\"table-body\"> <em class=\"strong\">A faster and better way to define a visibility track key filter function is</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6862\"></a><pre>\nfn filterVisibilityKeys theAnim theParent theIndex theGParent theNode = ( theIndex == 2 and theParent == theNode )\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-152C\"></a>This function will return true only when the parent is the node itself and the index\n               is 2, which corresponds to the Visibility track. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-152B\"></a> \n            <h2><a name=\"GUID-01E039B5-115F-4E38-A827-E8437AB7EB20\"></a> <em class=\"strong\">Name and Class Filter Function Examples</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-152A\"></a>You can define filter functions that will filter keys by the class or even the name\n               of the node being traversed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1529\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1528\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6861\"></a><pre>\n--this function will show keys only of Sphere class nodes:\nfn filterSphereKeys theAnim theParent theIndex theGParent theNode = ( classof theNode == Sphere )\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6860\"></a><pre>\n--this function will show keys only of objects whose name starts with \"Sphere\":\nfn filterSphereByNameKeys theAnim theParent theIndex theGParent theNode = ( substring theNode.name 1 6 == \"Sphere\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-4BDB\"></a> \n            <h2><a name=\"GUID-304F7980-1C68-4930-9AE9-889E6CE315E7\"></a> <em class=\"strong\">Key Count Filter Function Examples</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-151E\"></a>In some cases, for example, when animating using Reactor or baking animation to keys\n               per frame using MAXScript, the trackBar can become very slow as it tries to display\n               hundreds and even thousands of keys. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-151D\"></a>The following function will show keys of only those controllers that have less than\n               10 keys: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-685F\"></a><pre>\nfn filterNonMassiveKeys theAnim theParent theIndex theGParent theNode = (superClassof theAnim == FloatController and theAnim.keys.count &lt; 10 )\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-151A\"></a>Create some object in the scene like a Box, set the Animation mode to Set Key and\n               start animating the position by pressing the Key button. The trackBar will display\n               the keys of the Box until you create the 10<sup> <span class=\"charspan-emphasis\">th</span> </sup> key, after that all keys will be filtered out and will disappear. You can define\n               a global variable to control the number of keys to be displayed at a time. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1519\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1518\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-685E\"></a><pre>\nglobal maxNumberOfKeysInTrackbar = 50\nfn filterNonMassiveKeys theAnim theParent theIndex theGParent theNode = ( superClassof theAnim == FloatController and theAnim.keys.count &lt; maxNumberOfKeysInTrackbar )\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1512\"></a>Simply changing the value stored in the global variable maxNumberOfKeysInTrackbar\n               will control how many keys a controller must have to appear in the trackBar. You can\n               even define a small dialog with a spinner and dock it in the UI to have interactive\n               control over the keys display: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1510\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-150F\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-685D\"></a><pre>\n(\ntry (cui.UnRegisterDialogBar MassiveKeysFilterCount) catch()\ntry (destroyDialog MassiveKeysFilterCount) catch()\nglobal maxNumberOfKeysInTrackbar = 20\n--Define a rollout with a spinner\nrollout MassiveKeysFilterCount \"Keys Limit\"\n(\nspinner massive_count \"Max.Keys:\" range:[10,1000,20] type:#integer fieldwidth:40\non massive_count changed val do\n	(\n	maxNumberOfKeysInTrackbar = val\n	select selection\n	)\n)\n--Create a dialog, register as DialogBar and dock at bottom\ncreateDialog MassiveKeysFilterCount 120 25\ncui.RegisterDialogBar MassiveKeysFilterCount style:#(#cui_dock_all)\ncui.DockDialogBar MassiveKeysFilterCount #cui_dock_bottom \n--Define, register and enable the key filter functions:\nfn callbackAdditionFunction arg1 arg2 = (true)\nfn filterNonMassiveKeys theAnim theParent theIndex theGParent theNode =\n(\nsuperClassof theAnim == FloatController and theAnim.keys.count &lt; maxNumberOfKeysInTrackbar\n)\ntheIndex = (maxOps.trackBar).registerFilter filterNonMassiveKeys callbackAdditionFunction \"Massive Keys Filter\" 13 active:true stopTraversal:false\n)--end script\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14EC\"></a> <span class=\"char_link\"><a href=\"GUID-45E2F1A9-AFBB-413F-AEAD-7C9816BA94E5.htm\">Exploring the Trackbar Filter Callback Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14EB\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">Trackbar Interface</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";