var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8DF57F3D-8F38-4575-969E-736511A5372D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Color Picker Dialog\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Color Picker Dialog</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8DF57F3D-8F38-4575-969E-736511A5372D\"></a><div class=\"head\">\n            <h1>Color Picker Dialog </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E9E\"></a> The following method can be used to create a color picker dialog without using a colorPicker\n            rollout control. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E9C\"></a>This method is available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. It was previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E86\"></a><pre><em class=\"codeEmphasisStrong\">colorPickerDlg</em> &lt;init_color&gt; &lt;title_string&gt; <em class=\"codeEmphasisStrong\">alpha</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">pos</em>:&lt;&amp;Point2&gt; <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E99\"></a>Displays a modal color picker. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E98\"></a> <span class=\"code\"> <em class=\"strong\">init_color</em> </span> is the initial color \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E97\"></a> <span class=\"code\"> <em class=\"strong\">title_string</em> </span> is displayed in the title bar of the color picker. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E96\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">alpha:</em> </span> is true, the color picker supports alpha. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E95\"></a> <span class=\"code\"> <em class=\"strong\">pos:</em> </span> specifies the position of the dialog. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E94\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">pos:</em> </span> is specified as a by-reference variable, the position of the dialog when closed is\n            written back to the specified variable. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E93\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">pos:</em> </span> is not specified, the dialog is displayed at its last position. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E92\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">pos:</em> </span> is [-1,-1], the dialog is displayed centered on the 3ds Max window. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E91\"></a>If the color picker is closed other than via pressing OK, a value of \'undefined\' is\n            returned. \n            	 \n         </p>\n         <p><span class=\"code\"><em class=\"strong\">applyUIScaling</em></span> indicates whether to apply UI scaling on high-DPI displays.\n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E8F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E8E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E85\"></a><pre>\ncolorPickerDlg (color 100 200 300) \"Pick A Better Color:\" alpha:true pos:[100,100]\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E8A\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E88\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-24867CBA-D975-4F0E-944C-7BFCC354951A-low.gif\"></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E84\"></a> <span class=\"char_link\"><a href=\"GUID-A10F3B7A-B147-48E5-8ADC-CCDC60F5DB1B.htm\">ColorpickerRollout Control</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";