var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8E902545-FEDA-45BF-B052-07732329FA65\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"HD IK controller chains can be assigned to existing hierarchies\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>HD IK controller chains can be assigned to existing hierarchies</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8E902545-FEDA-45BF-B052-07732329FA65\"></a><div class=\"head\">\n            <h1>HD IK controller chains can be assigned to existing hierarchies </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BFA\"></a> The IKChainControl uses a boolean controller for turning the IK solver on/off. On/off\n            implies an opposite referencing structure. When it is on, joints reference the ik\n            goal, whereas when it is off, the goal references the end joint, ie. the goal has\n            to snap to the end effector. This means that the direction of message propagation\n            is decided on the state of this boolean controller. To avoid evaluating an animatable\n            attribute during message propagation, we require that this controller cannot be replaced\n            by a possibly arbitrarily wired controller. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BF8\"></a>HD IK controller chains can be assigned to existing hierarchies. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BF7\"></a> <em class=\"strong\">Prototype:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B24\"></a><pre><em class=\"codeEmphasisStrong\">HDIKSys.ikChain</em> &lt;startJoint&gt; &lt;endJoint&gt; &lt;assignEE&gt;</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B23\"></a><pre>&lt;<em class=\"codeEmphasisStrong\">startJoint</em>&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BF4\"></a>The first node in the new chain, called the ancestor. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B22\"></a><pre>&lt;<em class=\"codeEmphasisStrong\">endJoint</em>&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BF2\"></a>The last node in the chain, called the decendent. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B21\"></a><pre>&lt;<em class=\"codeEmphasisStrong\">assignEE</em>&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BF0\"></a>A boolean parameter: when TRUE, a position end effector is created at the endJoint.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BEE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BEC\"></a><p class=\"table-body\">If 4 boxes existed in the scene and Box02 was a child of Box01, Box03 was a child\n                        of Box02, and Box04 was a child of Box03: \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BEB\"></a><p class=\"table-body\"></p> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B20\"></a><pre>\nHDIKSys.<div class=\"codeBlock\"><a name=\"CODEBLOCK_C9E4B8A14F0E46269BB29614BCCEE46B\"></a><pre> <em class=\"codeEmphasisStrong\">ikChain</em></pre></div> $Box01 $Box04 TRUE \n                           				</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BE9\"></a><p class=\"table-body\"></p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BE8\"></a><p class=\"table-body\">would assign HD IK controllers and create anend effector at Box04. </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BE6\"></a> \n            <h2><a name=\"GUID-E3B8CAAC-B6C0-4E5B-85E2-8422A09CAD38\"></a> <em class=\"strong\">Pos/Rotation/Scale Property Access</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BE5\"></a>Pos/Rotation/Scale properties of the nodes are accessible immediately. Instead of\n               writing $node.transform.controller.ik_goal.controller.pos, you can say, in MAXScript,\n               $node.pos.controller, etc. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F87\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-4D2F5CFC-6574-4583-B68D-CE0027E1B548\"></a>Both IKControl and IKChainControl can not be instanced. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BDE\"></a> <span class=\"char_link\"><a href=\"GUID-67D4697E-D0F6-4B9C-93A0-8A1D5C57AA9B.htm\">IKChainControl : Matrix3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BDD\"></a> <span class=\"char_link\"><a href=\"GUID-8396FB0C-E332-41F1-92E2-540FEAF0AB4C.htm\">Interface: HDIKSys</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BDC\"></a> <span class=\"char_link\"><a href=\"GUID-A22DCC5C-A298-4FBD-8BC4-2F086FD2CEEE.htm\">Interface: IKSys</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BDB\"></a> <span class=\"char_link\"><a href=\"GUID-25DA5CC7-E8AB-4E6E-92DF-200E121D2CCB.htm\">IKLimb Solver</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";