var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8E91039D-04CF-41EF-B60B-73BE4011C4B6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface test\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: test</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8E91039D-04CF-41EF-B60B-73BE4011C4B6\"></a><div class=\"head\">\n            <h1>Interface: test </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E833D9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833DC\"></a> <em class=\"strong\">The test Interface is exposed by all Test Classes.</em>  \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833DD\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <p><a name=\"GUID-B6B4ECA2-90EF-46F2-9DBD-DE861B5A4FED\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4166\"></a><pre>&lt;void&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">proceedStep1</em> &lt;IObject&gt;container &lt;object&gt;particleSystem &lt;node&gt;particleSystemNode &lt;node&gt;actionNode &lt;Interface&gt;integrator 	 </pre></div> \n            <p><a name=\"GUID-ED4F8DB6-6FCA-4F99-A190-E12A7B96E2A5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833E0\"></a><span class=\"code\">&lt;IObject&gt;container </span>- the current particle container. Can be accessed via the <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> inside a hander using <span class=\"code\"> <em class=\"strong\">pCont.GetParticleContainer()</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833E2\"></a><span class=\"code\">&lt;object&gt;particleSystem </span> - the particle system that generates the particle stream. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FE6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-5B801402-310E-4D8A-8B51-71A1910F41C8\"></a>The same operator may get calls from different particle systems. If the result varies\n                     according to the particle system that generates particles, then this parameter defines\n                     which one to be used. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833E8\"></a><span class=\"code\">&lt;node&gt;particleSystemNode </span>- Node of the particle system that generates the particles. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833EA\"></a><span class=\"code\">&lt;node&gt;actionNode</span> - Node of the Test action. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833EC\"></a><span class=\"code\">&lt;Interface&gt;integrator </span>- an operator to proceed particles according to \"inertia\" rules. The operator updates\n               time, speed, position, spin, orientation channels on the basis of time, acceleration,\n               speed, angular acceleration and spin channels. Each particle system has a default\n               inertia operator. When an action wants to update the current time for particles, it\n               uses the \"inertia\" operator. An Action in the ActionList stack may \"switch\" the suggested\n               \"inertia\" operator by its own if the Action supports the \"inertial\" operator interface.\n               The particle system recognizes such an Action as a holder of \"inertia\" interface,\n               and uses it for \"inertia\" purposes later on. If the parameter is NULL then the particle\n               system doesn\'t allow the test to advance particles in the time channel. \n            </p> \n            <p><a name=\"GUID-68918888-005B-4628-862E-1A77AD047CE6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4160\"></a><pre>&lt;bool&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">proceedStep2</em> &lt;time&gt;timeStartTick &lt;float&gt;timeStartFraction &lt;&amp;time&gt;timeEndTick &lt;&amp;float&gt;timeEndFraction &lt;&amp;bitArray&gt;testResult &lt;&amp;float array&gt;testTime \n\ntimeEndTick is In and Out parameter \ntimeEndFraction is In and Out parameter \ntestResult is In and Out parameter \ntestTime is In and Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833F3\"></a>Returns <em class=\"strong\">true</em> if the test has been proceeded successfully. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833F4\"></a>The <span class=\"code\"> <em class=\"strong\">proceedStep1</em> </span> and <span class=\"code\"> <em class=\"strong\">proceedStep2</em> </span> verify the test condition and may change particle channels. Particles that satisfy\n               the condition may be advanced to the time of the condition satisfaction according\n               to the inertia operator <span class=\"code\"> <em class=\"strong\">integrator</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833F6\"></a><span class=\"code\">&lt;time&gt;timeStartTick </span> - The time for a particle to start the simulation. Each particle may have its own\n               current valid time greater than timeStart. In this case the test should consider the\n               current particle time and timeEnd parameter. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833F9\"></a><span class=\"code\">&lt;float&gt;timeStartFraction</span> <span class=\"code\">&lt;&amp;float&gt;timeEndFraction</span> - Float portion of the real TimeValue \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833FB\"></a> <span class=\"code\">&lt;&amp;bitArray&gt;testResult </span> - A bit array indicating which particles satisfy the test condition \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833FD\"></a><span class=\"code\">&lt;&amp;float array&gt;testTime </span>- For particles that satisfy the condition, the list of time moments when a particle\n               satisfies the condition. The tab has the same number of entries as particles in the\n               container. The entry is set only for particles that satisfy the condition . \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E833FE\"></a>See <span class=\"char_link\"><a href=\"GUID-BFB330E6-9A3B-4C24-B28C-C7750F1FBECB.htm\">Speed Operator in Script Operator Example</a></span> for sample usage. \n            </p> \n            <p><a name=\"GUID-6EBBE406-B8D7-49E2-B732-C37F64ECF209\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-415A\"></a><pre>&lt;node&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">getNextActionList</em> &lt;node&gt;testNode &lt;*bool&gt;linkActive \n\nlinkActive is In and Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83401\"></a>Returns the next Action List of the specified testNode. This is basically the ActionList\n               (Event) wired to the Test. If a particle satisfies the test then it is directed to\n               this Action List. Since a Test may have several instances with different next events,\n               it is necessary to pass the TestNode as parameter. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FE5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <em class=\"strong\">For future use only</em>. The parameter &lt;*bool&gt;linkActive is passed by NULL as default in the current release\n                  of <em class=\"strong\">Particle Flow</em>. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83406\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83407\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4158\"></a><pre>\nev1_a11.GetNextActionList ev1_a11 false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8340C\"></a>For a complete example, see <span class=\"char_link\"><a href=\"GUID-9AAA093F-FBA4-4B6A-8F8A-76C21F9F355E.htm\">VolumeDocking Sample Script</a></span>. \n            </p> \n            <p><a name=\"GUID-64CE83A7-EA4F-474F-A997-3482C70F6C65\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4157\"></a><pre>&lt;bool&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">setNextActionList</em> &lt;node&gt;actionList &lt;node&gt;testNode </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8340F\"></a>Wires the specified testNode to the supplied actionList node. Returns <em class=\"strong\">true</em> on success. The next actionList node can be rejected if it is not a real actionList.\n               \n            </p> \n            <p><a name=\"GUID-01C98CC2-D93F-4DF9-A907-8FCB92ABC242\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4156\"></a><pre>&lt;bool&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">clearNextActionList</em> &lt;node&gt;testNode </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83412\"></a>Disconnects the specified testNode from its Action List. \n            </p> \n            <p><a name=\"GUID-70D1459B-0A06-41EA-A77C-6FF8555DB9FA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4155\"></a><pre>&lt;bool&gt;&lt;PFlowTest&gt;.<em class=\"codeEmphasisStrong\">setLinkActive</em> &lt;bool&gt;linkActive &lt;node&gt;testNode </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83415\"></a>Will set the Active status of the Link to the supplied boolean value for the specified\n               testNode. Returns <em class=\"strong\">true</em> on success. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7FE4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <em class=\"strong\">For future use only</em>. Currently it can be used only to test if the Test Action has a link. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8341A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8341B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4154\"></a><pre>\nev1_a11.setLinkActive true ev1_a11\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83420\"></a>For a complete example, see <span class=\"char_link\"><a href=\"GUID-9AAA093F-FBA4-4B6A-8F8A-76C21F9F355E.htm\">VolumeDocking Sample Script</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83421\"></a> <em class=\"strong\">This Interface is available in:</em> \n            </p> <a name=\"TABLE_DFAB336A0A164860B01B811D54EBA418\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                     <col>\n                     <col>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83422\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-9D2E3BF3-A1AF-4200-AF42-0C38FF3FD799.htm\">Age_Test : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83423\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-3504EE64-9BC0-49AC-B1A2-AB4B1360E80B.htm\">Collision : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83424\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-2B26090C-6DFC-4062-9AF9-27B62D0FBF90.htm\">Collision_Spawn : Helper</a></span> \n                        </p> <a name=\"GUID-A4093C3F-51F4-492D-BA61-182406DB0651\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-FC4CBEDE-DDB6-45BA-A79E-0E19063F1545.htm\">Copy_Out : Helper</a></span> \n                        </p> <a name=\"GUID-4523E45F-CC65-416E-A838-17730EDA2283\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-01E76760-88AE-440E-B662-34F449F209C0.htm\">Data_Test : Helper</a></span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83425\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83427\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-01640C9A-5FA5-452F-8C72-A3558A9999A6.htm\">Go_To_Rotation : Helper</a></span> \n                        </p> <a name=\"GUID-19118C7B-73E3-4DDE-ACF3-9FA8B8FA9B02\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-6D5AAD12-EAD9-4D30-8501-6D1622490C9F.htm\">mP_Collision : Helper</a></span> \n                        </p> <a name=\"GUID-C2F8EEDA-9083-4FC7-9298-CBDD6D46281F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-765249F1-63EB-487B-A979-939A9E515F68.htm\">mP_Glue : Helper</a></span> \n                        </p> <a name=\"GUID-82822A1B-D32F-40C2-A824-A8C9C6C1DB97\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-809C2220-CDA3-4B88-AF15-A50C3603949F.htm\">mP_InterCollision : Helper</a></span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-95EEAA13-E24F-4B40-BD87-966ECF1DBDDF\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-C8A59616-D435-43A2-8859-065E3B41F45B.htm\">mP_World : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83428\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-3DF32EB7-A689-405B-B94E-BABADFD5D2ED.htm\">Scale_Test : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83429\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E83426\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-DFC5128F-F184-4F87-8461-53449AE5526A.htm\">Send_Out : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8342A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-AA10A930-7D9B-4DE2-A89C-3AEC08475DA2.htm\">Spawn : Helper</a></span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8342B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-6D1935F6-F7AE-445A-9F99-726310E28E31.htm\">speed : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8342C\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-93EB0BE9-EA7B-4832-AEB3-8EA6BEEEE4C8.htm\">Split_Amount : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8342D\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-3DF16F3B-E557-425C-BA36-E308646DFF08.htm\">Split_Selected : Helper</a></span> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8342E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BA78BFEC-AAAB-47AB-9E39-C90D970281F8.htm\">Split_Source : Helper</a></span> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83430\"></a> <span class=\"char_link\"><a href=\"GUID-B4D7BCE0-D4BC-48C8-8B0E-1513ED9BF43E.htm\">Particle Flow Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83431\"></a> <span class=\"char_link\"><a href=\"GUID-BFB330E6-9A3B-4C24-B28C-C7750F1FBECB.htm\">Speed Operator in Script Operator Example</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83432\"></a> <span class=\"char_link\"><a href=\"GUID-9AAA093F-FBA4-4B6A-8F8A-76C21F9F355E.htm\">VolumeDocking Sample Script</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";