var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8F085A1E-01CA-427E-A094-9334066946E8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Matrix3 Scripted Controller\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Matrix3 Scripted Controller</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8F085A1E-01CA-427E-A094-9334066946E8\"></a><div class=\"head\">\n            <h1>Matrix3 Scripted Controller </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CC4\"></a> The Transform Script controller contains all of the information contained in a Position/Rotation/Scale\n            (PRS) controller in one scripted matrix value. Instead of having three separate tracks\n            for position, rotation, and scale, all three values can be simultaneously accessed\n            from one script controller dialog. Because a script defines the transform values,\n            they are easier to animate. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CC2\"></a>The value of the controller script must be a <span class=\"char_link\"><a href=\"GUID-D77C780A-4E8A-4528-949F-CC09AAE048DA.htm\">matrix3 values</a></span> . A matrix3 value is a 4x3 3D transformation matrix. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CC1\"></a>The software interprets the text you type into the Script text box as the body of\n            a MAXScript block expression. You can type as many expressions as you want on as many\n            lines as you want, and they are evaluated in turn. The value of the last expression\n            is taken as the controller value. This must yield a matrix3 value for Transform Script\n            controllers. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CC0\"></a>Since the text is inside a block expression, you can declare local variables, which\n            are visible only within the script and are temporary for one evaluation. You can also\n            declare or access global variables that are shared with all other scripts in MAXScript\n            and hold their values from one evaluation to the next. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CBF\"></a>The software with respect to a specific animation time always evaluates a controller.\n            This might be the current time slider or incrementing frame time if an animation is\n            playing, or a rendering is under way. In the case of Script controllers, the time\n            being evaluated is used to establish an automatic \"at time\" context around the controller\n            script, so any properties you access (outside of other explicit \"at time\" expressions)\n            yield the correct values for the current controller evaluation time. This means you\n            don\'t have to do anything special in your scripts to work at the correct time. You\n            can access the evaluation time, with the standard MAXScript variable, current Time.\n            You can also reference scene property values at other times by using \"at time\" expressions\n            in your scripts, as in regular MAXScript programming. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CBE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CBD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B3D\"></a><pre>\nt=transform_script ()\nt.script =\"(matrix3 1)\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CB6\"></a> <span class=\"char_link\"><a href=\"GUID-CFAF04F2-BBA9-432C-B0CA-4CE682A323E0.htm\">transform_script - superclass: Matrix3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CB5\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CB3\"></a> <span class=\"char_link\"><a href=\"GUID-83E779EA-03B6-4785-B610-9A6EE574E10A.htm\">How do I keep a Plane aligned to 3 Point Helpers?</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";