var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8FB870E5-823A-42FE-9A8C-70D25FF3B92C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I find the angle between 3 vertices?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8FB870E5-823A-42FE-9A8C-70D25FF3B92C\"></a><div class=\"head\">\n            <h1>How do I find the angle between 3 vertices? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB34\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB36\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB37\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8B9\">Working With Vectors</a></span> &gt; How do I find the angle between 3 vertices? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB39\"></a> \n            <h2><a name=\"GUID-1045644E-06D8-4D34-A6F3-AD9F1DF9D34B\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3A\"></a>I have 3 vertices defining a face. How do I find the angle at the corner of the face?\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3B\"></a> \n            <h2><a name=\"GUID-8AFC6969-3603-4D8A-9557-8B78B6F6C5ED\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3C\"></a>A face always has 3 vertices. Each pair of vertices define one of the 3 edges of the\n               face, and at the same time can be seen as a vector. As shown in <span class=\"char_link\"><a href=\"GUID-A80603FB-F487-42F4-868D-E97FC4876563.htm\">How do I make a vector from a vertex position?</a></span> FAQ topic, every vertex is already a vector, and the edge vector connecting two vertices\n               can be calculated easily by subtracting the two vertex positions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3D\"></a>Let\'s call the 3 vertices A, B and C. If you want to calculate the angle at vertex\n               A, you will need the two vectors which start from vertex A and point at B and C respectively.\n               These two vectors would be expressed as \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3E\"></a> <span class=\"code\"> <em class=\"strong\">V1 = B-A</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB3F\"></a> <span class=\"code\"> <em class=\"strong\">V2 = C-A</em> </span> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB40\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0AA384FD-B447-4181-A9F0-39F9F64150C1-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB41\"></a>The image shows point A with coordinates [0,0,0], point B with coordinates [2,0,1]\n               and point C with coordinates [-1,0,2]. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB42\"></a>Now you have two vectors, but the vector dot product requires normalized vectors to\n               return usable results.A normalized vector has the same direction as the original vector,\n               but the length of 1.0. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB43\"></a>You can calculate the normalized vector by using the normalize method on the vectors\n               V1 and V2: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB44\"></a> <span class=\"code\"> <em class=\"strong\">N1 = normalize V1</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB45\"></a> <span class=\"code\"> <em class=\"strong\">N2 = normalize V2</em> </span> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB46\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-DC159444-96D8-467C-8331-42BB5D1FCE52-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB47\"></a>In the case of V1 = [2,0,1], N1 = normalize V1 returns [0.894427,0,0.447214] because\n               length V1 =2.23607, and the normalized vector is calculated by dividing the X, Y and\n               Z coordinates by the length, in this case [2/2.23607, 0/2.23607, 1/2.23607]. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB48\"></a>N2 = normalize V2 returns [-0.447214,0,0.894427] because the length of the vector\n               [-1,0,2] is also 2.23607, and the normalized vector is calculated as [-1/2.23607,\n               0/2.23607, 2/2.23607]. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB49\"></a>Finally, as explained in the <span class=\"char_link\"><a href=\"GUID-5FE610EF-120D-46F4-A2F3-7353ED255534.htm\">How do I find the angle between two vectors?</a></span>, we need to calculate the acos of the dot product of these normalized vectors. acos\n               is the reverse operations of cos, returning the angle whose cos is equal to the operand\n               (in other words, if X = cos Alpha, then Alpha = acos X). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4A\"></a> <span class=\"code\"> <em class=\"strong\">Angle = acos (dot N1 N2)</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4B\"></a>The Angle will range between 0 (when the two vectors are parallel) and 180 degrees\n               (when the two vectors are pointing in opposite directions). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4C\"></a>In the above case of coordinates [0,0,0], [2,0,1] and [-1,0,2], the angle at point\n               A is 90 degrees. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4D\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-00C39A4E-AF72-40CD-9E26-902C07AEF338-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4E\"></a>To calculate the angle at B, you would apply the same rules, but will use the vectors\n               A-B and C-B, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB4F\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-CAB2C0F9-11A0-428C-888E-2BA1474F2E96-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB50\"></a>then normalize the vectors, calculate the dot product and get the acos of the result.\n               The angle at point B in this example is 45 degrees. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB51\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D0F56422-4AD6-477E-88C6-93FF22BFE12E-low.gif\"></div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB54\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";