var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-8FCABE2E-664A-4A82-9FAC-2C5694DC8B4C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Vector Arithmetic</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8FCABE2E-664A-4A82-9FAC-2C5694DC8B4C\"></a><div class=\"head\">\n            <h1>Vector Arithmetic </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171763\"></a>This topic is a quick review for readers who need a reminder about vector arithmetic.\n            If you’re familiar with vectors and vector calculations, you can skip this topic.\n            If this topic is difficult to follow, you might consult a more basic reference on\n            mathematics. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171764\"></a>A vector expresses a length and a direction in a particular space. The vector is expressed\n            as a point; for example, [5, 5, 7]. The length is the distance from the origin to\n            that point, and the direction is similarly from the origin to (and through) the point.\n            \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171765\"></a>In <em class=\"strong\">3ds Max</em>, vectors have three values and describe positions in three-dimensional space. They\n            can also represent percent scaling in X, Y, and Z; and—more abstractly—describe locations\n            in RGB color space. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171766\"></a> <em class=\"strong\">Unit Vectors and Basic Vectors</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171767\"></a>A unit vector has a length of one. Unit vectors are often used to express direction\n            only. The three basic vectors are unit vectors that describe the three axes (X, Y,\n            and Z) of 3D space. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171768\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-29CE477A-7F8A-4BAD-8EAB-75EDA60CC5F8-low.gif\"><p class=\"figure-title\">Basic vectors and the XYZ axes</p>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171769\"></a> <em class=\"strong\">Adding and Subtracting Vectors</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917176A\"></a>Adding two vectors creates a new vector that combines the length and direction of\n            the original two. Vector addition is commutative: V+W = W+V. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917176B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-12C70F4A-B45F-4251-8935-4A671A484361-low.gif\"><p class=\"figure-title\">Adding two vectors</p>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917176C\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-2DB06E23-FC8B-4DBB-BDBC-2EB3D2DDE0C6-low.gif\"></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917176D\"></a>Subtracting two vectors gives the vector between the two points. \n         </p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E2E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-955E7E5A-F384-4E9B-B0CE-4D6CBD537057-low.gif\"><p class=\"figure-title\">Subtracting two vectors</p>\n         </div><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E2D\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-8F26451F-5497-4E9F-9743-53F7688D7DB4-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E2C\"></a> <em class=\"strong\">Scalar Multipliation and Division</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E2B\"></a>Multiplying a vector by a scalar changes the vector’s length, as does dividing the\n            vector by a scalar. \n         </p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E2A\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D519729D-A4A3-47F9-B71E-4ED8D5681D0F-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E29\"></a> <em class=\"strong\">Vector Length and Direction</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E28\"></a>The length of a vector is obtained from the Pythagorean theorem. \n         </p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E27\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-846F406B-F0D2-4998-B1F7-BC274DAA3C99-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E26\"></a>In MAXScript, the <span class=\"code\">length()</span> function returns this value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E25\"></a>The direction of the vector is the vector divided by its length; this gives you a\n            unit vector with the same direction. \n         </p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E24\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F428FADA-1175-4CC0-B027-F971D4A67873-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E23\"></a>The distance between two points is the length of the vector between them. \n         </p><a name=\"WS73099CC142F48755-412E633C12B0D13CDAD-7E22\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E988A3B4-4C4C-4838-ABCD-3AE67288F863-low.gif\"><p class=\"figure-title\">Subtracting vectors to obtain a distance</p>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";