var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-90C2E88D-7373-44D7-A0FB-1ADDB55CECDC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Adaptive Degradation Access\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Adaptive Degradation Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-90C2E88D-7373-44D7-A0FB-1ADDB55CECDC\"></a><div class=\"head\">\n            <h1>Adaptive Degradation Access </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2BA9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2BA8\"></a> The following method pairs can be used to control the Adaptive Degradation system\n               which was redesigned in <em class=\"strong\">3ds Max 2008</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2BA4\"></a> <img src=\"../images/GUID-0D193017-2B58-4FD4-BA41-5E62DDF8790A-low.gif\"> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-59D1\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B8A\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegGoalFPS</em>() 		<em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegGoalFPS</em> &lt;float&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2BA1\"></a>Get/Set the \"Maintain Frames Per Second\" target frame rate. This is the frame rate\n               the adaptive degradation system will try to keep. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B89\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDrawBackfaces</em>() 	 <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDrawBackfaces</em> &lt;boolean&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B9D\"></a>Gets/Sets the state of the <em class=\"strong\">\"Draw Backfaces During Degrade\"</em> option. When set to true, backfaces will be drawn when degrading even for objects\n               whose backface cull option is turned on, thus improving performance. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B88\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegNeverDegradeSelected</em>()   <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegNeverDegradeSelected</em> &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B99\"></a>Gets/Sets the state of the <em class=\"strong\">\"Never Degrade Selected\"</em> option. When set to true, selected objects will never get degraded allowing the user\n               to focus on them. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B87\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDegradeLight</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDegradeLight</em> &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B95\"></a>Get/Set the state of the <em class=\"strong\">\"Degrade to Default Lighting\"</em> option. When true, the system will degrade the lights to just the default headlight.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B86\"></a><pre><em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegNeverRedrawAfterDegrade</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegNeverRedrawAfterDegrade</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B91\"></a>Get/Set the state of the <em class=\"strong\">\"Never Redraw After Degrade\"</em> option. When true, the system will remain in degraded state even after a mouse up.\n               On large scenes this can help reduce pauses caused by full redraws between navigation\n               operations. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-59C6\"></a> \n               <h3><a name=\"GUID-51CB14AC-1517-442C-9FAE-9192A870C176\"></a> <em class=\"strong\">Adapt Object Display by Priority</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B85\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModeCurrent</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModeCurrent</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B8D\"></a>Get/Set whether to use the current display mode when degrading. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B84\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModeFastShaded</em> <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModeFastShaded</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B89\"></a>Get/Set whether to use the fast shaded display mode when degrading. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B83\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModeWire</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModeWire</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B85\"></a>Get/Set whether to use the wireframe display mode when degrading. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B82\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModeBox</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModeBox</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B81\"></a>Get/Set whether to use the box display mode when degrading. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B81\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModePoint</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModePoint</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B7D\"></a>Get/Set whether to replace objects with point drawing primitives when degrading. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B80\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegDisplayModeHide</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegDisplayModeHide</em> &lt;boolean&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B79\"></a>Get/Set whether to hide objects when degrading. \n               </p> \n            </div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-59B9\"></a> \n               <h3><a name=\"GUID-5C5648E1-222A-456E-896C-225787DD1DD7\"></a> <em class=\"strong\">Prioritize Scene Objects</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B7F\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegCameraDistancePriority</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegCameraDistancePriority</em> &lt;float&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B75\"></a>Get/Set the <em class=\"strong\">\"Distance from Camera\"</em> value. This weights whether the distance from camera or screen size is used to determine\n                  which objects will be degraded. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B7E\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegScreenSizePriority</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegScreenSizePriority</em> &lt;float&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B71\"></a>Get/Set the <em class=\"strong\">\"Screen Size\"</em> value. This weights whether the distance from camera or screen size is used to determine\n                  the degradation priorities. \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B7D\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">viewport.GetAdaptiveDegMinSize</em>() <em class=\"codeEmphasisStrong\">viewport.SetAdaptiveDegMinSize</em> &lt;integer&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B6D\"></a>Get/Set the value of the <em class=\"strong\">\"Force objects displayed smaller than N pixels to the lowest priority\"</em> option. \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B6A\"></a> <span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm\">Accessing Active Viewport Info, Type, and Transforms</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";