var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-927A47B2-9749-4E6A-989A-55EFA06FDFD9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"picking\">\n      <meta name=\"indexterm\" content=\"fencePickNode()\">\n      <meta name=\"indexterm\" content=\"circlePickNode()\">\n      <meta name=\"indexterm\" content=\"boxPickNode()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Picking Scene Nodes By Region</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-927A47B2-9749-4E6A-989A-55EFA06FDFD9\"></a><div class=\"head\">\n            <h1>Picking Scene Nodes By Region </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35B5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35B4\"></a>    The following methods allow you to pick one or more objects based on their position\n               in the viewports. All coordinates used in these methods are in Windows format with\n               the origin in the upper left. The \n               		  <span class=\"code\"> <em class=\"strong\">gw.getWinSizeX()</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">gw.getWinSizeY()</em> </span> methods can be used to determine the size of the viewport in pixels. The objects\n               to pick are filtered based on the Selection Filter specified in the \n               		  <em class=\"strong\">3ds Max</em> main toolbar. \n               		\n            </p> \n            <p><a name=\"GUID-08F2DC79-106A-4024-93F8-04362A7D935D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D26\"></a><pre><em class=\"codeEmphasisStrong\">boxPickNode</em> &lt;box2&gt; [ <em class=\"codeEmphasisStrong\">crossing</em>:&lt;boolean&gt; ] [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35AE\"></a>Returns an array of the nodes within the specified rectangular region. The \n               		  <span class=\"code\"> <em class=\"strong\">&lt;box2&gt;</em> </span> value specifies the corner in pixel values within the active viewport. If the \n               		  <span class=\"code\"> <em class=\"strong\">crossing:</em> </span> parameter value is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>, an object only partially in the region will be picked. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the object must be completely within the region to be picked. The default \n               		  <span class=\"code\"> <em class=\"strong\">crossing:</em> </span> value is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n               		\n            </p> \n            <p>The \n               		  <span class=\"code\"><em class=\"strong\">applyUIScaling</em></span> parameter indicates whether to apply UI scaling on high-DPI displays.\n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35AD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35AC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D25\"></a><pre>\nboxPickNode (box2 [0,0] [1000,1000])\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-806E400C-C7F8-45D1-B6A3-A14A29331FF1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D24\"></a><pre><em class=\"codeEmphasisStrong\">circlePickNode</em> &lt;box2&gt; [ <em class=\"codeEmphasisStrong\">crossing</em>:&lt;boolean&gt;] [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35A6\"></a>Returns an array of the nodes within the specified circular region. The \n               		  <span class=\"code\"> <em class=\"strong\">&lt;box2&gt;</em> </span> value specifies the center of the circle and a point on the circle in pixel values\n               within the active viewport. If the \n               		  <span class=\"code\"> <em class=\"strong\">crossing:</em> </span> parameter value is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>, an object only partially in the region will be picked. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the object must be completely within the region to be picked. The default \n               		  <span class=\"code\"> <em class=\"strong\">crossing:</em> </span> value is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>. The \n               		  <span class=\"code\"> <em class=\"strong\">[left, bottom]</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">[right, top]</em> </span> components of the box2 parameter value correspond to the center and radius points,\n               respectively. The box2 parameter value needs to be set up in a specific manner as\n               shown in the following script: \n               		\n            </p> \n            <p>The \n               		  <span class=\"code\"><em class=\"strong\">applyUIScaling</em></span> parameter indicates whether to apply UI scaling on high-DPI displays.\n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35A5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35A4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D23\"></a><pre>\nvpCenter = (point2 (gw.getWinSizeX()) (gw.getWinSizeY()))/2\nvpQuarter = point2 (vpCenter.x/2) vpCenter.y\ncircleRegion = box2 0 0 0 0 -- initialize circleRegion to a box2 value\ncircleRegion.left = vpCenter.x -- the center of the circle\ncircleRegion.bottom = vpCenter.y\ncircleRegion.right = vpCenter.x/2 -- a point on the circle\ncircleRegion.top = vpCenter.y\nfor obj in (circlePickNode circleRegion crossing:false) do\nprint obj.name\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3598\"></a>This will print the names of all nodes completely within a circular region, where\n               the center of the circle is the center of the viewport and the point on the circle\n               is located one quarter of the distance from the edge to the center of the viewport.\n               \n               		\n            </p> \n            <p><a name=\"GUID-C172553B-3C49-40B5-BD69-552920E6C8D3\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D22\"></a><pre><em class=\"codeEmphasisStrong\">fencePickNode</em> &lt;point2_array&gt; [ <em class=\"codeEmphasisStrong\">crossing</em>:&lt;boolean&gt;] [ <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;true&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3595\"></a>Returns an array of the nodes within the specified fenced region. The fenced area\n               is defined by the array of point2 values. The default \n               		  <span class=\"code\"> <em class=\"strong\">crossing:</em> </span> value is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n               		\n            </p> \n            <p>The \n               		  <span class=\"code\"><em class=\"strong\">applyUIScaling</em></span> parameter indicates whether to apply UI scaling on high-DPI displays.\n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3593\"></a> <span class=\"char_link\"><a href=\"GUID-9D407E2A-3691-426F-9B06-4A744C3DEE58.htm\">Picking Scene Nodes by Name</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3592\"></a> <span class=\"char_link\"><a href=\"GUID-CB0EBFC3-9360-445B-BCD4-5F5B2031579F.htm\">Picking Scene Nodes By Hit</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";