var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"if/then/else expression\">\n      <meta name=\"indexterm\" content=\"if/do expression\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>If Expression</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809\"></a><div class=\"head\">\n            <h1>If Expression </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B3\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B4\"></a>    The \n               		  <span class=\"code\"> <em class=\"strong\">if</em> </span> expression is used to conditionally execute an expression based on the result of\n               a boolean test expression. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871B9\"></a>The syntax for an \n               		  <span class=\"code\">&lt;if_expr&gt;</span> is one of: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C7\"></a><pre><em class=\"codeEmphasisStrong\">if</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">then</em> &lt;expr&gt; [<em class=\"codeEmphasisStrong\">else</em> &lt;expr&gt; ]\n\n<em class=\"codeEmphasisStrong\">if</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871BD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871BE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C6\"></a><pre>if a &gt; b do (print d; print e)\na = (if d = = 0 then 0 else a / d)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871C4\"></a>The first \n               		  <span class=\"code\">&lt;expr&gt;</span> is a test expression that must evaluate to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, such as a comparison or logical expression. If the result is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>, the \n               		  <span class=\"code\"> <em class=\"strong\">then</em> </span> or \n               		  <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> is evaluated and its value is returned as the result of the \n               		  <span class=\"code\">&lt;if_expr&gt;</span>. If the result is \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the optional \n               		  <span class=\"code\"><em class=\"strong\">else</em> &lt;expr&gt;</span> is evaluated and its value is returned as the result of the \n               		  <span class=\"code\">&lt;if_expr&gt;</span>. If there is no \n               		  <span class=\"code\"> <em class=\"strong\">else</em> </span> or the \n               		  <span class=\"code\"> <em class=\"strong\">do</em> </span> form is used, the \n               		  <span class=\"code\">&lt;if_expr&gt;</span> returns the value \n               		  <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871C5\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">do</em> </span> form is provided particularly for use during interactive sessions in the MAXScript\n               Listener. When you enter expressions for immediate evaluation into the Listener, MAXScript\n               determines if your expression is complete and then evaluates it. If you use the optional\n               \n               		  <span class=\"code\"> <em class=\"strong\">else</em> </span> form in the Listener and you want to omit the \n               		  <span class=\"code\"><em class=\"strong\">else</em> &lt;expr&gt;</span>, MAXScript continues to \"wait and see\" if you enter an \n               		  <span class=\"code\"><em class=\"strong\">else</em> &lt;expr&gt;</span>. The line break after the \n               		  <span class=\"code\"><em class=\"strong\">then</em> &lt;expr&gt;</span> is legal and does not cause MAXScript to evaluate the current line right away. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871C6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871C7\"></a><p class=\"table-body\"> <em class=\"strong\">AS AN EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871C8\"></a><p class=\"table-body\">As an example, if the following script is entered in Listener, the first line will\n                           not evaluate until you enter the second line: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C5\"></a><pre>if match x y then print x\nprint \"hello\"</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871CE\"></a>When you use the optional \n               		  <span class=\"code\"> <em class=\"strong\">else</em> </span> form inside a block or another expression, MAXScript can determine from the code\n               that follows it if you omitted the optional \n               		  <span class=\"code\"> <em class=\"strong\">else</em> </span>. Use the \n               		  <span class=\"code\"> <em class=\"strong\">do</em> </span> form for \n               		  <span class=\"code\"> <em class=\"strong\">if</em> </span> statements without an \n               		  <span class=\"code\"> <em class=\"strong\">else</em> </span> as top-level commands in the Listener: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871CF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871D0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C4\"></a><pre>if match x y do print x</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>You can nest \n               		  <span class=\"code\"><em class=\"strong\">if...then...else</em></span> clauses, however in this situation consider using a \n               		  <span class=\"char_link\"><a href=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439.htm\">Case expression</a></span> for better code clarity:\n               		\n            </p> <a name=\"TABLE_4A56140558264253B1E560F24EA458BB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>if a &gt; b then print a\nelse if b &gt; c then print b\nelse if c &gt; d then print c\nelse print d</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871D5\"></a>As described in \n               		  <span class=\"char_link\"><a href=\"GUID-B93647B2-8BC7-4D83-BA90-0105DAB3591C.htm\">Expressions</a></span>, anywhere you can write an \n               		  <span class=\"code\">&lt;expr&gt;</span> expression, you can write \n               		  <em class=\"strong\">any</em> construct in MAXScript. In statement-based languages, there is usually one syntax\n               for \n               		  <span class=\"code\"> <em class=\"strong\">if</em> </span> statements and a separate one for conditional expressions. In MAXScript, a single\n               syntax is used for both cases. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871D6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871D7\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871D8\"></a><p class=\"table-body\">the following two lines of code are both valid, and their meaning should be obvious:\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C3\"></a><pre>if a &gt; b then print c else print d\nx = if a &gt; b then c else d</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871DD\"></a><p class=\"table-body\">You can also write the following line, containing a nested \n                           						<span class=\"code\"> <em class=\"strong\">if</em> </span> expression and a nested assignment, which is itself an expression: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C2\"></a><pre>x = if (if a &gt; b then c else d) &lt; e then f else (g = 23)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";