var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"PrintAllElements Variable and Context\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>PrintAllElements Variable and Context</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085\"></a><div class=\"head\">\n            <h1>PrintAllElements Variable and Context </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87742\"></a>In versions prior to \n            		<em class=\"strong\">3ds Max 7</em>, printing or coercing \n            		<span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-728FCDFB-96ED-42D5-B7CF-ADE4406DB101.htm\">VertexSelection</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-95DA3E18-179B-45F8-AA7F-724154D6A2B1.htm\">FaceSelection</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-102A446F-9146-4D1B-A44A-818F749E61E8.htm\">EdgeSelection</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-CBC09FDC-52DD-4D05-9C7E-E2923DBCC4BA.htm\">BigMatrix</a></span>, and BigMatrixRowArray values to string converts only the first 20 elements. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87743\"></a>In \n            		<em class=\"strong\">3ds Max 7 and higher</em>, a MAXScript variable and a new context are available. They control whether the above\n            mentioned value types are fully printed/coerced to string, or just their first 20\n            elements. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87744\"></a>The \n            		<em class=\"strong\">variable</em> is: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6038\"></a><pre><em class=\"codeEmphasisStrong\">options.printAllElements</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87746\"></a>When set to true, all elements of Array, MeshSelection, BigMatrix, and BigMatrixRowArray\n            values are printed or coerced to string. If false, only the first 20 elements of these\n            value types are printed. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87748\"></a>The \n            		<em class=\"strong\">context</em> is: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6037\"></a><pre><em class=\"codeEmphasisStrong\">with printAllElements</em> &lt;bool&gt; &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8774A\"></a>If \n            		<span class=\"code\">&lt;bool&gt;</span> is true, \n            		<span class=\"code\">&lt;expr&gt;</span> is run with printAllElements true. This is exception safe. If an exception occurs\n            in \n            		<span class=\"code\">&lt;expr&gt;</span>, printAllElements is returned to its initial value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8774C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8774D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6036\"></a><pre>\na = for i = 1 to 30 collect i\n--&gt; #(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, ...)\n&nbsp;\nwith printAllElements off (print a #nomap;ok)\n--&gt; #(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, ...)\n--&gt; OK\n&nbsp;\nwith printAllElements on (print a #nomap;ok)\n--&gt; #(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30)\n--&gt; OK\n&nbsp;\nwith printAllElements off a as string\n--&gt; \"#(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, ...)\"\n&nbsp;\nwith printAllElements on a as string\n--&gt; \"#(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30)\"\n&nbsp;\n(\n-- note that the following is not exception safe!\nlocal oldPrintAllElements = options.printAllElements\noptions.PrintAllElements = true\nprint a #nomap\noptions.printAllElements = oldPrintAllElements\nok\n)\n--&gt; #(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30)\n--&gt; OK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";