var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-92E4150E-0AD4-430C-A852-783A45276D23\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"setSaveRequired()\">\n      <meta name=\"indexterm\" content=\"resetting 3ds Max\">\n      <meta name=\"indexterm\" content=\"resetMaxFile()\">\n      <meta name=\"indexterm\" content=\"quitMAX()\">\n      <meta name=\"indexterm\" content=\"getSaveRequired()\">\n      <meta name=\"indexterm\" content=\"exiting 3ds Max\">\n      <meta name=\"indexterm\" content=\"clearUndoBuffer()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Exiting and Resetting 3ds Max</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-92E4150E-0AD4-430C-A852-783A45276D23\"></a><div class=\"head\">\n            <h1>Exiting and Resetting 3ds Max </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13F9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13F8\"></a>       The \n               		  <span class=\"code\"> <em class=\"strong\">quitMAX()</em> </span> function lets you exit \n               		  <em class=\"strong\">3ds Max</em> under script control. This function is typically used in batch processing or render\n               scripts. The function has the form: \n               		\n            </p> \n            <p><a name=\"GUID-35693E0F-F961-42E6-8F2F-239562739163\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6837\"></a><pre><em class=\"codeEmphasisStrong\">quitMAX</em> [ #noPrompt ] quiet:&lt;bool&gt; exitCode:&lt;int&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13EF\"></a>If the \n               		  <span class=\"code\"> <em class=\"strong\">#noPrompt</em> </span> optional argument is not specified and there are unsaved changes in the scene, \n               		  <em class=\"strong\">3ds Max</em> will prompt with its standard save changes dialog. The \n               		  <span class=\"code\"><em class=\"strong\">quiet:&lt;bool&gt;</em></span> argument does the same thing, and overrides the \n               		  <span class=\"code\"><em class=\"strong\">#noPrompt</em></span> option if both are specified. \n               		\n            </p> \n            <p>If the optional \n               		  <span class=\"code\"><em class=\"strong\">exitCode</em></span> argument is specified, when 3ds Max exits a message of \"3ds Max Ended with Unknown\n               Reason (Exit Code \n               		  <em class=\"mild\">X</em>)\" is printed to the console, where \n               		  <em class=\"mild\">X</em> is the specified integer. This can be useful for batch processing scripts using \n               		  <span class=\"filePath\">3dsmaxbatch.exe</span> that want to get user-specified status codes from the application. \n               		\n            </p> \n            <p> </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13ED\"></a>Additionally, you can control the scene save and undo states in \n               		  <em class=\"strong\">3ds Max</em> with the following functions: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6836\"></a><pre><em class=\"codeEmphasisStrong\">setSaveRequired</em> &lt;boolean&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13EB\"></a>lets you set the \n               		  <em class=\"strong\">3ds Max</em> system \"dirty\" flag. If this flag is set or there are entries in the Undo buffer,\n               the user is asked if they want to save the scene file on a File &gt; New or File &gt; Reset.\n               \n               		\n            </p> \n            <p><a name=\"GUID-CDEACDBB-2915-455C-9ECA-31EF0E42AE2A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6835\"></a><pre><em class=\"codeEmphasisStrong\">getSaveRequired</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13E8\"></a>returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the \n               		  <em class=\"strong\">3ds Max</em> system \"dirty\" flag is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> or if the Undo buffer is not empty. If the Undo buffer if not empty, this function\n               will still return \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>, even if you just called \n               		  <span class=\"code\"> <em class=\"strong\">setSaveRequired false</em> </span>. \n               		\n            </p> \n            <p><a name=\"GUID-48160F8E-86AE-40C5-BB1A-416653C47F4C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6834\"></a><pre><em class=\"codeEmphasisStrong\">clearUndoBuffer</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13E5\"></a>empties the Undo buffer, both providing a way to reset the undo state and another\n               way to control the save-changes requester. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13E3\"></a>Normally, if there are entries in the Undo buffer when the scene is closed, \n               		  <em class=\"strong\">3ds Max</em> will prompt with a save-changes requester. In some cases, where you are controlling\n               undo in MAXScript, you may want to force the need for a save-changes prompt. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13E2\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">resetMAXFile()</em> </span> function lets you reset \n               		  <em class=\"strong\">3ds Max</em> under script control. This function is typically used in batch processing or render\n               scripts. The function has the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6833\"></a><pre><em class=\"codeEmphasisStrong\">resetMaxFile</em>() [<em class=\"codeEmphasisStrong\">#noPrompt</em>] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13E0\"></a>If the \n               		  <span class=\"code\"> <em class=\"strong\">#noPrompt</em> </span> optional argument is not specified, \n               		  <em class=\"strong\">3ds Max</em> will prompt with its standard dialog \"Do you really want to reset\". \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-754E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>In order to check for unsaved changes before resetting the scene, you should use \n                  		  <span class=\"code\"> <em class=\"strong\">checkForSave()</em> </span>. See \n                  		  <span class=\"char_link\"><a href=\"GUID-624D3D05-B15D-4A97-9F15-DA35CDB0DDD2.htm\">3ds Max File Loading and Saving</a></span> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13DB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13DA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6832\"></a><pre>\n--CheckForSave checks whether the scene has been modified \n--and issues the standard \"Do you want to save your changes\" dialog. \n--If the user presses Yes or No, the function returns true and \n--resetMaxFile will be called. \n--If the user presses Cancel, the function returns false and \n--resetMaxFile will not be called. \nif checkForSave() do resetMaxFile()\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13CE\"></a> <span class=\"char_link\"><a href=\"GUID-624D3D05-B15D-4A97-9F15-DA35CDB0DDD2.htm\">3ds Max File Loading and Saving</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";