var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-931FB071-811A-4B36-A0A2-5DCFFB38D0B8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"AlembicFloat\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"Matrix3Controller: MAXWrapper\">\n      <meta name=\"indexterm\" content=\"AlembicXform - Matrix3Controller\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AlembicFloat : FloatController</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-931FB071-811A-4B36-A0A2-5DCFFB38D0B8\"></a><div class=\"head\">\n            <h1>AlembicFloat : FloatController</h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">AlembicFloat - superclass: floatController; super-superclass:MAXWrapper - 6:0 - classID: #(3408044305L, 448532752L)</em></pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7848\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7847\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-D26D932B-0E6C-4A1E-934C-AF2883DD850F.htm\">Matrix3Controller</a></span> &gt; AlembicFloat \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 and higher</em>: The AlembicFloat controller is used to load the visibility animation track of a\n            single object entity from an imported Alembic .ABC cache file into a 3ds Max scene.\n            \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Constructor:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>AlembicFloat ...</pre></div>\n         <p> </p>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">source</em>    String    default: \"\"   --  filename</pre></div>\n         <p>Gets/sets the Alembic .ABC source file name for the object this controller is associated\n            with. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">object</em>     UndefinedClass    default: undefined   --  string;</pre></div>\n         <p>Gets/sets the object path definition string within the Alembic .ABC source file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackType</em>     Integer    default: 0   --  integer; Playback_Type</pre></div>\n         <p><a name=\"GUID-B422D9FD-23A7-4AAD-85B6-EA129C206A21\"></a> Gets/sets the playback type drop-down list selection index. \n            	 \n         </p>\n         <p><a name=\"GUID-8E666B15-CDD9-469C-8CAC-C861A82F323A\"></a> Possible values are: \n            	 \n         </p>\n         <p><a name=\"GUID-5CD572E9-34D4-479C-9E19-A2641ED6178E\"></a> 0 - \n            		<em class=\"strong\">Original Range</em> (default) - use the start and end values stored in the ABC file. \n            	 \n         </p>\n         <p><a name=\"GUID-807C0DBF-E059-423C-BA5C-A5CD3B346E24\"></a>1 - \n            		<em class=\"strong\">Custom Start</em> - use the \n            		<span class=\"code\">.playbackStart</span> property to define the scene time on which to start the playback. This can be used\n            to offset the beginning of the playback while keeping the same playback speed. \n            	 \n         </p>\n         <p><a name=\"GUID-D2745C86-03C0-4107-9F82-3508CC03E81D\"></a>2 - \n            		<em class=\"strong\">Custom Range</em> - use the \n            		<span class=\"code\">.playbackStart</span> and \n            		<span class=\"code\">.playbackEnd</span> properties to define a custom range within which to play back the original animation.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-512E6746-AC67-4B48-8BD3-272F0C580022\"></a>3 - \n            		<em class=\"strong\">Playback Graph</em> - keyframe the \n            		<span class=\"code\">.playbackFrame</span> property to define the file\'s frame to be loaded on each scene frame. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackStart</em>     Float    default: 0.0   --  float</pre></div>\n         <p><a name=\"GUID-E3AF6443-8E71-4398-8DB1-E1DACB0A39C7\"></a> Gets/sets the start frame of the playback range. \n            	 \n         </p>\n         <p><a name=\"GUID-025BC5B2-55DB-4E08-97A9-634E92BB8BBA\"></a>Applicable when .<em class=\"strong\"> <span class=\"code\">playbackType</span> </em> is set to 1 or 2. \n            	 \n         </p>\n         <p><a name=\"GUID-381FDEDE-0061-4F86-99D8-B79A5C3CEB42\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackEnd</em>     Float    default: 0.0   --  float</pre></div>\n         <p><a name=\"GUID-7AFF180B-BB29-4E14-8669-D28D6B993929\"></a> Gets/sets the end frame of the playback range. \n            	 \n         </p>\n         <p><a name=\"GUID-4BDEC50C-16E4-4A9F-B98A-029D0B4237DB\"></a>Applicable when .<em class=\"strong\"> <span class=\"code\">playbackType</span> </em> is set to 2. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackFrame</em>     Float    default: 0.0   --  animatable; float</pre></div>\n         <p><a name=\"GUID-04B594F0-828F-46DB-9434-2C23EC776D46\"></a> Gets/sets the current playback frame. \n            	 \n         </p>\n         <p><a name=\"GUID-10771CB5-E5DD-400F-9755-75E983B9868A\"></a>Keyframe this property to produce custom playback within the defined range, or set\n            to a static value to load a single frame. \n            	 \n         </p>\n         <p><a name=\"GUID-BB634910-7972-4ED4-8381-E2AAD416FBC0\"></a> Applicable when .<em class=\"strong\"> <span class=\"code\">playbackType</span> </em> is set to 3. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackStartGen</em>     Integer    default: 0   --  integer\n&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackEndGen</em>     Integer    default: 0   --  integer\n&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackTypeGen</em>     Integer    default: 0   --  integer\n&lt;AlembicFloat&gt;.<em class=\"codeEmphasisStrong\">playbackFrameGen</em>     Integer    default: 0   --  integer\n</pre></div>\n         <p>Used by the versioning system for Alembic properties. For internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2224\"></a> <span class=\"char_link\"><a href=\"GUID-5994F8B6-E408-4970-B9F6-3DD3B85A8CF4.htm\">Alembic_Export : ExporterPlugin</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-E36925F7-7CD9-4020-9759-524D7A8843A0\"></a> <span class=\"char_link\"><a href=\"GUID-504B022E-C059-49EF-A54D-A1EDC88D1B4A.htm\">Alembic_Import : ImporterPlugin</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2223\"></a> <span class=\"char_link\"><a href=\"GUID-EA706D2E-19A6-45E0-8A0D-B8200A47FECB.htm\">AlembicCamera : Camera</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-6D1640BA-2C0C-4685-9213-29631096E036\"></a> <span class=\"char_link\"><a href=\"GUID-4C06CF63-DCC2-422C-9BC4-41D4FC85EBB2.htm\">AlembicContainer : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-C586B4A8-4C68-482B-BFA6-7CE23824FFE6\"></a> <span class=\"char_link\"><a href=\"GUID-DA9E3B99-C894-4D32-B161-DDC4AB3D1203.htm\">AlembicObject : GeometryClass</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";