var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"utility\">\n      <meta name=\"indexterm\" content=\"Clauses\">\n      <meta name=\"indexterm\" content=\"rollout\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Utility Clauses</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F\"></a><div class=\"head\">\n            <h1>Utility Clauses </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A79\"></a>The \n            		<span class=\"code\"> &lt;utility_body&gt; \n               		</span> of a scripted utility definition is composed of a sequence of utility clauses as\n            follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D5\"></a><pre>&lt;utility_body&gt; ::= { &lt;utility_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A77\"></a>where \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D4\"></a><pre>&lt;utility_clause&gt; ::= &lt;rollout_clause&gt; | &lt;nested_rollout&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A75\"></a>A \n            		<span class=\"code\"> &lt;utility_clause&gt; \n               		</span> can contain one or more instances of \n            		<span class=\"code\"> &lt;rollout_clause&gt; \n               		</span> or \n            		<span class=\"code\"> &lt;nested_rollout&gt; \n               		</span>. A nested rollout is basically another self-contained rollout definition which can\n            be used to construct scripted utilities with multiple rollouts or populate rollout\n            floater windows that may be associated with the utility. A \n            		<span class=\"code\"> &lt;nested_rollout&gt; \n               		</span> is defined as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D3\"></a><pre><em class=\"codeEmphasisStrong\">rollout </em>&lt;var_name&gt; &lt;description_string&gt; [ <em class=\"codeEmphasisStrong\">rolledUp</em>:&lt;boolean&gt; ] [<em class=\"codeEmphasisStrong\"> silentErrors</em>:&lt;boolean&gt; ] \\\n  [ <em class=\"codeEmphasisStrong\">autoLayoutOnResize</em>:&lt;boolean&gt; ]\n<em class=\"codeEmphasisStrong\">( </em>\n&lt;rollout_body&gt;\n<em class=\"codeEmphasisStrong\">)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A73\"></a>where \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D2\"></a><pre>&lt;rollout_body&gt; ::= { &lt;utility_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A71\"></a>In other words, a rollout definition is identical to a utility definition except its\n            description string is not displayed in the Utilities list in the MAXScript rollout.\n            In fact, a utility can just be considered a special case of a rollout, and both are\n            instances of the Rollout class. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A70\"></a>As an example, consider the following script. In this script, line 1 defines the start\n            of the utility, and the utility body is lines 2 through 42. The following line ranges\n            are utility clauses: 3 (a rollout clause), 5 to 9 (a nested rollout), 11 to 30 (a\n            nested rollout), 32 to 35 (a rollout clause), and 37 to 40 (a rollout clause). \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A6F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A6E\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D1\"></a><pre>\nutility MyUtil \"My Utility\"\n(\nlocal pot\nrollout bout \"About My Utility\"\n(\nbutton aboutMU \"About\" width:45 height:20\non aboutMU pressed do\nmessagebox \"My First Utility\\nby ME\\nVersion .1\"\\\ntitle:\"About My Utility\"\n) -- end rollout bout\nrollout creator \"The Teapot\"\n(\ngroup \"Object Creator\"\n(\nbutton tea \"Teapot\"\nspinner rad \"Radius\" range:[10,50,20] type:#integer\nspinner seg \"Segments\" range:[4,32,12] type:#integer scale:1\n)\non tea pressed do\n(\npot=teapot radius:rad.value\npot.name=\"TestPot\"\npot.segs=seg.value\n) -- end on tea pressed\non rad changed value do\npot.radius=value\non seg changed value do\npot.segs=seg.value\n) -- end rollout creator\non MyUtil open do\n(\naddRollout bout\naddRollout creator\n) -- end on MyUtil open\non MyUtil close do\n(\nremoveRollout bout\nremoveRollout creator\n) -- end on MyUtil close\n) -- end utility MyUtil\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A42\"></a>The Utilities panel rollouts created by the previous script look like the following:\n            \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A41\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-73430F90-C840-40F0-BC43-D36086B25BDA-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A40\"></a> <em class=\"strong\">Multiple rollouts defined in a utility</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A3F\"></a>You can also define rollouts outside utility definitions when you want to add them\n            to a rollout floater window that may not be associated with a scripted utility. This\n            is described more fully in \n            		<span class=\"char_link\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm\">Rollout Floater Windows</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A3E\"></a>A value is created for a utility or rollout when the script defining the utility or\n            rollout is executed. In general, the lifetime of a utility value is the entire \n            		<em class=\"strong\">3ds Max</em> session, unless a new utility with the same name is executed. The lifetime of a rollout\n            defined in a utility is the lifetime of the utility value. The lifetime of a rollout\n            defined outside a utility is the lifetime of the context the rollout was defined in.\n            For more information, see \n            		<span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A3C\"></a> <span class=\"char_link\"><a href=\"GUID-B478B60B-B27D-4916-A07E-264818666080.htm\">Scripted Utilities</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A3B\"></a> <span class=\"char_link\"><a href=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2.htm\">Scripted Utility Panels</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A3A\"></a> <span class=\"char_link\"><a href=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF.htm\">Managing Multiple Rollouts in a Scripted Utility</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";