var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9355B32D-DDC4-4C26-BEFD-66BE3D291B63\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Basic Utility</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9355B32D-DDC4-4C26-BEFD-66BE3D291B63\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Basic Utility </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2565\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2566\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Basic Utility \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2568\"></a>The original code of the complete advanced version was developed in less than an hour\n            and showcases the flexibility of MAXScript for prototyping applications of any kind.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2569\"></a>Here is the very basic initial version: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC256B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC256C\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC256D\"></a><p class=\"table-body\">We will develop a simple MacroScript that creates a dialog from a rollout. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC256E\"></a><p class=\"table-body\">The rollout will contain only a bitmap UI control </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC256F\"></a><p class=\"table-body\">The user will paint by pressing the left mouse button and dragging the mouse inside\n                        the bitmap. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2570\"></a><p class=\"table-body\">The brush will be a single black dot - if the mouse moves fast, the strokes will appear\n                        dotted. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2573\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2574\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-643C\"></a><pre>\nmacroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry (destroyDialog MicroPaint_CanvasRollout) catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n&nbsp;bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n&nbsp;fn paintBrush pos =\n&nbsp;(\n&nbsp;&nbsp;setPixels theCanvasBitmap pos #(black)\n&nbsp;&nbsp;theCanvas.bitmap = theCanvasBitmap\n&nbsp;)\n&nbsp;on MicroPaint_CanvasRollout lbuttondown pos do\n&nbsp;(\n&nbsp;&nbsp;isDrawing = true\n&nbsp;&nbsp;paintBrush pos\n&nbsp;)\n&nbsp;on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\n&nbsp;on MicroPaint_CanvasRollout mousemove pos do if isDrawing do paintBrush pos\n)\ncreateDialog MicroPaint_CanvasRollout bitmapX bitmapY\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2592\"></a> \n            <h2><a name=\"GUID-A02AA631-6BC1-4531-BBF5-41135CE56775\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-643B\"></a><pre><em class=\"codeEmphasisStrong\">macroScript MicroPaint category:\"HowTo\"</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2595\"></a>We define a macroScript called MicroPaint which will appear in the \"HowTo\" category.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-643A\"></a><pre><em class=\"codeEmphasisStrong\">global MicroPaint_CanvasRollout</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2597\"></a>In order to be able to close any existing dialog from previous sessions, we define\n               the variable of the rollout to be used as dialog as a global variable. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2598\"></a> <span class=\"char_link\"><a href=\"GUID-A6E95530-F419-4837-B10A-E881A62AD5F9.htm\">Local and Global Variables</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6439\"></a><pre><em class=\"codeEmphasisStrong\">try(destroyDialog CanvasRollout)catch()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC259A\"></a>Then we try to destroy any existing dialog from a previous session. If there is none,\n               the try()catch() error trap will prevent any error messages. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC259B\"></a> <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm\">Try Expression</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6438\"></a><pre><em class=\"codeEmphasisStrong\">local isDrawing = false</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC259D\"></a>This local variable will be used as a flag for enabling drawing. When the variable\n               is false, the mouse move event handler will not draw. When the left mouse button has\n               been pressed, this variable will be set to true and allow drawing until the left mouse\n               button is released. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC259E\"></a> <span class=\"char_link\"><a href=\"GUID-BCAFBD54-CE0D-40D0-8424-99E1FE1518CC.htm\">BooleanClass Values</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6437\"></a><pre><em class=\"codeEmphasisStrong\">local bitmapX = bitmapY = 512</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A0\"></a>These local variables will contain the size of the bitmap to be painted. Simply changing\n               this value would resize the tool to paint on a different canvas size! \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6436\"></a><pre><em class=\"codeEmphasisStrong\">local theCanvasBitmap = bitmap bitmapX bitmapY color:white</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A2\"></a>This variable will contain the canvas to draw on. We initialize it to a white bitmap\n               with a size of 400 by 400 pixels. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A3\"></a> <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm\">Bitmap Values</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6435\"></a><pre><em class=\"codeEmphasisStrong\">rollout MicroPaint_CanvasRollout \"MicroPaint\"</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A6\"></a>This is the rollout which will define the dialog with the bitmap canvas. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6434\"></a><pre><em class=\"codeEmphasisStrong\">bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A8\"></a>This is the bitmap User Interface control. It is aligned to the upper left corner\n               of the rollout and displays the 400 by 400 canvas bitmap. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25A9\"></a> <span class=\"char_link\"><a href=\"GUID-F9F2AE47-958E-4B5E-86F3-17C92A69C66C.htm\">Bitmap</a></span> \n            </p> \n            <div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-2BBA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25AD\"></a>that there are two different constructors with the name <em class=\"strong\">bitmap</em>- the User Interface control used here and the bitmap value constructor used two lines\n                     higher! MAXScript knows which one you have in mind based on the context - if you are\n                     inside a rollout definition scope and type in \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6433\"></a><pre>\nbitmap my_bmp width:100 height:100\n</pre></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25B1\"></a>MAXScript will create a User Interface control. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25B2\"></a>If you are inside the same rollout and type in \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6432\"></a><pre>\nlocal my_bmp = bitmap 100 100\n</pre></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25B6\"></a>a new local bitmap value will be created and NOT a User Interface control! \n                  </p> \n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6431\"></a><pre><em class=\"codeEmphasisStrong\">fn paintBrush pos =</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25BA\"></a>This function will be called to draw a point on the bitmap. The argument pos will\n               contain the 2D coordinates to place the new point at. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25BB\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6430\"></a><pre><em class=\"codeEmphasisStrong\">setPixels theCanvasBitmap pos #(black)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25BD\"></a>setPixels is used to change the color of one or more pixels in a row. The pos defines\n               the location in the bitmap (where 0,0 is the upper left corner) the paining should\n               start at.The colors to be changes are provided in an array. In our case, the array\n               contains a single element, the color black. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25BE\"></a> <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm#WS73099CC142F487553098682E12AC2FC2BC7-5ECF\">setpixels</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642F\"></a><pre><em class=\"codeEmphasisStrong\">theCanvas.bitmap = theCanvasBitmap</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25C0\"></a>After the black point is drawn into the bitmap, we assign it to the user interface\n               control to update the drawing. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642E\"></a><pre><em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">onMicroPaint_CanvasRollout lbuttondown pos do</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25C4\"></a>This dialog event handler is called whenever the left mouse button is pressed while\n               the mouse is located over the rollout. The argument pos will contain the 2D position\n               in rollout coordinates. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25C5\"></a> <span class=\"char_link\"><a href=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7.htm\">CreateDialog</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642D\"></a><pre><em class=\"codeEmphasisStrong\">isDrawing = true</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25C7\"></a>We raise the flag to notify the mousemove handler (see below) that the drawing can\n               be started. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642C\"></a><pre><em class=\"codeEmphasisStrong\">paintBrush pos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25C9\"></a>We also call the paintbrush function by passing the currently clicked point to it.\n               This way, simply clicking without moving the mouse will cause a black point to be\n               placed on the bitmap. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642B\"></a><pre> <em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25CC\"></a>This dialog event handler is called whenever the left mouse button is released. We\n               just lower the flag again so the drawing can be stopped. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-642A\"></a><pre><em class=\"codeEmphasisStrong\">on MicroPaint_CanvasRollout mousemove pos do if isDrawing do paintBrush pos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25CE\"></a>This dialog event handler is called whenever the mouse movies over the rollout, regardless\n               of the button state. The argument pos contains the 2D position in pixels inside the\n               rollout, coinciding with the position in pixels inside the bitmap (remember? Both\n               have the same origin [0,0]. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25CF\"></a>We check to see whether the left mouse button has been pressed but not released yet\n               by looking into the isDrawing variable. If it contains true, we call the drawing paintbrush\n               function with the current position of the mouse inside the dialog. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6429\"></a><pre><em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">createDialogMicroPaint_CanvasRollout bitmapX bitmapY</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D2\"></a>Finally, we create a dialog using the rollout we just defined. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6428\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D4\"></a> \n            <h2><a name=\"GUID-CD9582EE-B3F1-4467-850D-77D151C29728\"></a> <em class=\"strong\">Result</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D5\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-BAEE8878-1007-4160-9615-56778B2DE216-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D6\"></a> <em class=\"strong\">Next Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D7\"></a> <span class=\"char_link\"><a href=\"GUID-89495341-DEA2-41D9-BFBB-543006E64CA2.htm\">How To ... Develop a Bitmap Painting Tool - Strokes Support</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25D9\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";