var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9383EF8E-819E-4C4A-B60B-D69C1FEAC54F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"geometry - Node\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Geometry Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9383EF8E-819E-4C4A-B60B-D69C1FEAC54F\"></a><div class=\"head\">\n            <h1>Scripted Geometry Plug-ins </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5274\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5273\"></a>  A scripted Geometry plug-in is declared by specifying the <span class=\"code\"> <em class=\"strong\">&lt;superclass&gt;</em> </span> as <span class=\"code\"> <em class=\"strong\">geometry</em> </span>. \n            </p> \n            <p><a name=\"GUID-01A90F58-E144-47BD-A10E-A076C12F8AED\"></a>Scripted Geometry plug-ins require a <span class=\"code\"> <em class=\"strong\">create</em> </span> tool unless they are invisible, temporary, or extend another plug-in. \n            </p> \n            <p><a name=\"GUID-226B1469-B2C0-4EE8-BE19-8A836341D7B2\"></a>If the plug-in extends another plug-in, and a <span class=\"code\"> <em class=\"strong\">create</em> </span> tool is specified, it will override the delegate\'s create tool. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5270\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-526F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A7\"></a><pre>\nplugin geometry foo_plugin_def\nname:\"FooBar\"\ncategory:\"Scripted Primitives\"\n(\nlocal boxes = #()\nlocal clickAt\ntool create\n(\non mousePoint click do\n(\nclickAt = worldPoint\nboxes =for i in 1 to 10 collect box pos:([i*20,0,0] + clickAt)\n#stop\n)\n)\nrollout frab \"Parameters\"\n(\nspinner frab_value \"Frabulate\" range:[-1000,1000,20]\non frab_value changed val do\nfor i in 1 to boxes.count do\nboxes[i].pos = [i*val,0,0] + clickAt\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5254\"></a>This adds a new geometry category with one button to the Create panel. Pressing the\n               FooBar button starts a mouse command mode that creates a row of 10 boxes where you\n               click and adds a rollout to the command panel with one spinner that lets you adjust\n               the separation of the boxes. This is very similar to a System object like the RingArray,\n               except it lives in the Geometry tab. This is the simplest type of scripted of plug-in;\n               it has no specific scene object and no storable parameters. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5252\"></a>In the tool handlers, you can set the delegate properties as needed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5251\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5250\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A6\"></a><pre>\nplugin geometry Cuboid\nname:\"Cuboid\"\nclassID:#(0x133067, 0x54374)\ncategory:\"Scripted Primitives\"\nextends:Box\n(\nfn fmax val1 val2 = if val1 &gt; val2 then val1 else val2\ntool create\n(\non mousePoint click do\ncase click of\n(\n1: nodeTM.translation = gridPoint\n2: #stop\n)\non mouseMove click do\nif click == 2 then\ndelegate.width = delegate.length =\ndelegate.height = 2 * fmax (abs gridDist.x) (abs gridDist.y)\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5236\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5235\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5234\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5233\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5232\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";