var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-94056D8F-C907-4875-9CDC-B7ABC23E678E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I rotate a vector around the Z axis?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-94056D8F-C907-4875-9CDC-B7ABC23E678E\"></a><div class=\"head\">\n            <h1>How do I rotate a vector around the Z axis? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB56\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB58\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB59\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8B9\">Working With Vectors</a></span> &gt; How do I rotate a vector around the Z axis? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB5B\"></a> \n            <h2><a name=\"GUID-00DF15AC-CE5F-4E47-B99F-08592C3955FF\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB5C\"></a>I am trying to rotate a unit vector around 360 degrees in steps of 2 degrees. It only\n               needs to rotate around the Z axis, X and Y stay the same. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB5D\"></a> \n            <h2><a name=\"GUID-DE4FAD0A-89D6-49C1-B043-EAF8811CD24C\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB5E\"></a>The <span class=\"char_link\"><a href=\"GUID-D77C780A-4E8A-4528-949F-CC09AAE048DA.htm\">Matrix3 Values</a></span> topic provides convenient ways to transform vectors (Point3 values) including rotation\n               about the world Z axis! You can simply construct a rotate Z Matrix value and transform\n               the original vector using it: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB5F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB60\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7DD0\"></a> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6681\"></a><pre>\nresetMaxFile #noPrompt --reset the file\ntheV = normalize [5,0,10] --the vector to rotate, normalized to unit vector\ntheStep = 10 --the step by which you want to rotate\n--rotate from 0 to 360-theStep with step TheStep:\nfor a = 0 to 360-theStep by theStep do\n(\n  rm = rotateZMatrix a --create a rotation matrix from the value\n  theRotV = theV * rm --transform the original vector using the matrix\n  format \"%: %\\n\" a theRotV --print the result to Listener\n  c = cylinder() --create a cylinder\n  c.dir = theRotV --orient along the vector to see what it looks like\n)\n</pre></div> \n                        </div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB71\"></a>The results looks like a muffin! \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB72\"></a> <img src=\"../images/GUID-13DEE325-48BC-44CD-BD48-F0B8D7EC3B7F-low.gif\"> <img src=\"../images/GUID-501D9391-522C-4472-87B5-403E1F5BBC8D-low.gif\"> <img src=\"../images/GUID-F175FEF8-97D7-4BE8-A77B-F2E437B6D121-low.gif\"> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCB75\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";