var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-94B704E2-E93F-495B-BB65-A2E99D9E2F12\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"\'This\' Local Variable in Scripted Controllers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>\'This\' Local Variable in Scripted Controllers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-94B704E2-E93F-495B-BB65-A2E99D9E2F12\"></a><div class=\"head\">\n            <h1>\'This\' Local Variable in Scripted Controllers </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CB1\"></a> The <span class=\"code\"> <em class=\"strong\">this</em> </span> local variable in scripted controllers will contain a MAXWrapper value wrapping the\n            scripted controller. \n         </p>\n         <p><a name=\"GUID-9E5EFF20-D7F8-4A36-B32D-ED10576243C8\"></a>The <span class=\"code\"> <em class=\"strong\">this</em> </span> is a local variable that exists while evaluating the scripted controller\'s script,\n            and is not a property of the scripted controller. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CAF\"></a>In order to access the actual object the controller is assigned to, you can use the\n            <span class=\"code\"> <em class=\"strong\">refs.dependents</em> </span> method using the <span class=\"code\"> <em class=\"strong\">this</em> </span> variable, then filter the valid nodes. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CAE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CAD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B3C\"></a><pre>\nrefsArray = (refs.dependents this)\nfor i in refsArray where isvalidnode i do print i.name\n0.0\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CA7\"></a>The example returns the name of the object the scripted controller is assigned to.\n            \n         </p>\n         <p><a name=\"GUID-CD0948A5-0577-4DC1-9566-7ABDB4936A6E\"></a>Obviously it is <em class=\"strong\">not possible</em> to tell the actual node when the controller is instanced across multiple objects\n            which is a <em class=\"strong\">known limitation</em>. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CA5\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CA4\"></a> <span class=\"char_link\"><a href=\"GUID-CF4BD614-5A08-4DB6-9039-49EE32AA5178.htm\">dependsOn For Scripted Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";