var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-95CCAA15-0FA7-4273-AD8E-96B019CE7D28\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"nested contexts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Nested Contexts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-95CCAA15-0FA7-4273-AD8E-96B019CE7D28\"></a><div class=\"head\">\n            <h1>Nested Contexts </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87161\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87162\"></a>  All context expressions remember the prior setting of the context when they are set,\n               and restore the original setting when the expression completes. Therefore, you can\n               nest context clauses in any way you want including contexts of the same type to override\n               an outer setting. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87165\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87166\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CE\"></a><pre>\nwith animate on, at time t\n(\nmove ... -- all these place keys\nrotate ...\nanimate off -- turn off animate for a bit\n(\nmove ... -- working maneuvers, these don\'t effect animation\nrotate ...\n) -- animate on is restored here\nscale ... -- place keys again\n...\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87176\"></a>Further, all the contexts are <em class=\"strong\">dynamically scoped</em>. Any code inside a context expression, any functions that code calls, and functions\n               they call down to any level are executed in the current prevailing context. So, a\n               function can move an object and place keyframes at a certain time when called from\n               one client and do no keyframing when called from another client depending on how the\n               callers have set up the contexts. The called function can explicitly set its own contexts\n               if it wants to, overriding those that might have been set up by the caller. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";