var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"mapped operations\">\n      <meta name=\"indexterm\" content=\"collections\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Collections</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D\"></a><div class=\"head\">\n            <h1>Collections </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A89\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; Collections \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A86\"></a>Many of the values you work with in MAXScript are sequenced \n            		<em class=\"strong\">collections</em>, notably \n            		<span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">arrays</a></span>, wild-card \n            		<span class=\"char_link\"><a href=\"GUID-47B0A7AE-5401-4E92-BB47-F12C5B4E93D7.htm\">pathname</a></span> selections, and the built-in \n            		<span class=\"char_link\"><a href=\"GUID-77CB1890-C949-43AC-B1E9-B37F97B6712D.htm\">object sets</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A85\"></a>In the manner of most operating system shell command languages, MAXScript will \n            		<em class=\"strong\">automatically</em> apply appropriate operations to each of the members in these target collections.\n            This is called a \n            		<em class=\"strong\">mapped operation</em>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A83\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A82\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\">&nbsp;</td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">hide $lights/key*</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A80\"></a><p class=\"table-body\">Hide all the \'key\' lights in the scene \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">$box*.position = [0,0,0]</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A7E\"></a><p class=\"table-body\">Re-center all boxes \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">delete dead_objects</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A7C\"></a><p class=\"table-body\">Delete all the objects in the array \'dead_objects\' \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">obj.pos.keys.intangent=#fast</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A7A\"></a><p class=\"table-body\">Set in tangent to fast for all obj\'s position keys \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">lights.value *= 0.8</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A78\"></a><p class=\"table-body\">Turn down all the lights 20% \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A76\"></a>MAXScript determines whether to perform a \n            		<em class=\"strong\">mapped operation</em> by looking at \n            		<em class=\"strong\">the first argument</em> to a function or the target in a property assignment to see if it is a sequenced\n            collection. In the case of a function call, it also looks to see if the function is\n            of the appropriate kind, evaluates all the other argument expressions \n            		<em class=\"strong\">only once</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A75\"></a>MAXScript then calls the function on each of the members of the first argument collection\n            passing along the other evaluated arguments. In the case of a property assignment,\n            it evaluates the right-hand-expression \n            		<em class=\"strong\">only once</em> and assigns the value to the named property of each of the elements in the target\n            value collection. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A74\"></a>This means that every element in the collection \n            		<em class=\"strong\">must be</em> a valid target for the function or have the named property in question. If MAXScript\n            comes across an inappropriate target it will report an error and stop the automatic\n            operation. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A73\"></a>Except for certain common properties, MAXScript currently only allows automatic collection\n            mapping of property assignment \n            		<em class=\"strong\">one level deep</em>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A72\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A71\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A70\"></a><p class=\"table-body\">the following will perform collection mapping across the objects \n                        					 <span class=\"char_link\"><a href=\"GUID-77CB1890-C949-43AC-B1E9-B37F97B6712D.htm\">ObjectSet</a></span>: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E5C\"></a><pre>\nobjects.pos = [0,0,0] --move all objects to world center\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A6B\"></a>If the last level specified is one of the following component names, the automatic\n            collection mapping is performed on the preceding property: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E5B\"></a><pre><em class=\"codeEmphasisStrong\">.angle</em> <em class=\"codeEmphasisStrong\">.b</em> <em class=\"codeEmphasisStrong\">.blue</em> <em class=\"codeEmphasisStrong\">.axis</em> <em class=\"codeEmphasisStrong\">.controller</em> <em class=\"codeEmphasisStrong\">.g</em> <em class=\"codeEmphasisStrong\">.green</em> <em class=\"codeEmphasisStrong\">.isAnimated</em> <em class=\"codeEmphasisStrong\">.keys</em> <em class=\"codeEmphasisStrong\">.r</em> <em class=\"codeEmphasisStrong\">.red</em> <em class=\"codeEmphasisStrong\">.track</em> <em class=\"codeEmphasisStrong\">.x</em> <em class=\"codeEmphasisStrong\">.x_rotation</em> <em class=\"codeEmphasisStrong\">.y</em> <em class=\"codeEmphasisStrong\">.y_rotation</em> <em class=\"codeEmphasisStrong\">.z</em> <em class=\"codeEmphasisStrong\">.z_rotation</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A57\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A56\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A55\"></a><p class=\"table-body\">the following will perform collection mapping across the \n                        					 <em class=\"strong\">objects</em> ObjectSet: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E5A\"></a><pre>\nobjects.pos.z = 0.0 --move all objects to world XY plane\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A50\"></a>This behavior of calling a function on all the elements of a collection is known as\n            \n            		<em class=\"strong\">mapping</em> in computer science. In the description of each collection type, you will find those\n            kinds of sequenced collections that can be mapped over identified as \n            		<em class=\"strong\">mappable</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A4F\"></a>In the descriptions of the various functions and operators throughout this document,\n            those that act on each element in a collection are labeled \n            		<em class=\"strong\">mapped.</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A4E\"></a>In general, the functions that are mapped are those that have some side-effect on\n            the value they take, such as moves, and deletes and hides. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A4D\"></a>Others, like the test function \n            		<span class=\"code\"> <em class=\"strong\">isHidden()</em> </span>, are \n            		<span class=\"code\"> <em class=\"strong\">not</em> </span> mapped because it would be pointless since the result would not be able to represent\n            the state of multiple objects. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A4C\"></a>All mapped functions defined by MAXScript, such as \n            		<span class=\"code\"> <em class=\"strong\">copy()</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">delete()</em> </span>, or \n            		<span class=\"code\"> <em class=\"strong\">move()</em> </span>, take an optional last argument, \n            		<span class=\"code\"> <em class=\"strong\">#noMap</em> </span>. This causes the functions not to be mapped when called on collection arguments such\n            as arrays. When used with \n            		<span class=\"code\"> <em class=\"strong\">copy()</em> </span> on arrays in particular, this will return a top-level copy of the array itself and\n            not perform an individual \n            		<span class=\"code\"> <em class=\"strong\">copy()</em> </span> on each element of the array. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A4B\"></a>You can make your own \n            		<span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">mapped scripted functions</a></span> by preceding the function definition with the reserved word \n            		<span class=\"code\"> <em class=\"strong\">mapped</em> </span>, \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A49\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A48\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A47\"></a><p class=\"table-body\">the following will perform collection mapping across the objects ObjectSet: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E59\"></a><pre>\nmapped function rand_color x = (x.wireColor = random black white)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A42\"></a>This causes such functions to be automatically called repeatedly on the elements of\n            a collection if a collection is given as the first argument to the function. The \n            		<span class=\"code\"> <em class=\"strong\">#noMap</em> </span> argument is not applicable to user-written functions! \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A41\"></a>As described in \n            		<span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span>, a \n            		<span class=\"code\"> <em class=\"strong\">for</em> </span> loop can be set up to iterate through a collection set assigning successive elements\n            in the collection to the loop value each time through the loop. \n            		<span class=\"code\"> <em class=\"strong\">For</em> </span> loops can also be set up to return an array collection set as its result. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A40\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A3F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E58\"></a><pre>\n-- sequence an array:\nfor item in table1 do x = x + item.height\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E57\"></a><pre>\n-- you can sequence pathnames:\nbigones = for obj in $box* where obj.height &gt; 100 collect obj\n-- collect the big boxes into an array\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A33\"></a>When iterating through a collection set using a \n            		<span class=\"code\"> <em class=\"strong\">for</em> </span> loop, or when passing a collection to a mapped function, care must be taken not to\n            reorder or remove elements in the collection set within the \n            		<span class=\"code\"> <em class=\"strong\">for</em> </span> loop or function. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A32\"></a>Take for an example a script that is supposed to convert all of the selected splines\n            into NURBS curves. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A31\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A30\"></a><p class=\"table-body\"> <em class=\"strong\">TWO SCRIPTS THAT DO NOT EXECUTE PROPERLY ARE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E56\"></a><pre>\nfor obj in selection do ( convertToNURBSCurve obj)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E55\"></a><pre>\nconvertToNURBSCurve selection\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A29\"></a><p class=\"table-body\">The reason neither of these lines execute properly is that the \n                        					 <span class=\"code\"> <em class=\"strong\">convertToNURBSCurve()</em> </span> function clears the current selection. So only the first spline is passed to \n                        					 <span class=\"code\"> <em class=\"strong\">convertToNURBSCurve()</em> </span> and converted. Since \n                        					 <span class=\"code\"> <em class=\"strong\">convertToNURBSCurve()</em> </span> is a built-in function, there is no way to modify this behavior. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A28\"></a><p class=\"table-body\">To get around this problem, you need to first \"snapshot\" the selection collection\n                        set as an array using the \n                        					 <span class=\"code\"> <em class=\"strong\">as</em> </span> operator, or use the \n                        					 <span class=\"code\"> <em class=\"strong\">getCurrentSelection()</em> </span> function, which returns the current selection set as an array. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7A27\"></a><p class=\"table-body\"> <em class=\"strong\">TWO SCRIPTS THAT EXECUTE PROPERLY ARE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E54\"></a><pre>\nfor obj in (selection as array) do ( convertToNURBSCurve obj)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E53\"></a><pre>\nconvertToNURBSCurve (getCurrentSelection())\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";