var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-99E9991F-E246-41C8-A76F-AF5F341A1A52\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface IInteractionMode\">\n      <meta name=\"indexterm\" content=\"IInteractionMode Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: IInteractionMode</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-99E9991F-E246-41C8-A76F-AF5F341A1A52\"></a><div class=\"head\">\n            <h1>Interface: IInteractionMode </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1058\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1057\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; IInteractionMode  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0F6E106E-11DD-4E43-8F2D-483A73D100EC\"></a>This Core Interface exposes the <em class=\"strong\">Interaction Mode</em> tab of the <em class=\"strong\">Preference Settings dialog</em> to MAXScript. \n         </p>\n         <p><a name=\"GUID-FA1C040F-2FB0-4558-9D55-BD61A15476F4\"></a>See also the related <span class=\"char_link\"><a href=\"GUID-724B14D0-06DC-424A-A6FE-8C494579ECA3.htm\">Interface: MouseConfigManager</a></span>. \n         </p>\n         <p><a name=\"GUID-4493374E-98AA-409C-B651-7356B950DC5A\"></a>Available in <em class=\"strong\">3ds Max 2013 and higher</em>. \n         </p>\n         <p><a name=\"GUID-E3D3C26D-2826-4B85-97C6-02F7E06F453F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-72E6CD70-8817-403E-8813-1B21B53C55E3\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">IInteractionMode.CurrentMode</em> : enum : Read|Write \n\nCurrentMode enums: {<em class=\"codeEmphasisStrong\">#3dsMaxMode</em>|<em class=\"codeEmphasisStrong\">#MayaMode</em>|<em class=\"codeEmphasisStrong\">#CustomizedMode</em>}</pre></div>\n         <p><a name=\"GUID-C4D5C6E0-836E-43F5-9E36-8E2B25D67322\"></a>Get/set the current Interaction Mode for both mouse and keyboard. \n         </p>\n         <p><a name=\"GUID-A50BA4BC-BD3D-4A48-BFEA-AEE5F923A96E\"></a>Corresponds to the Interaction Mode tab of the Preference Settings dialog. \n         </p>\n         <p><a name=\"GUID-B6EB95DC-B278-4CDC-BE30-EBF538D4FF80\"></a> <img src=\"../images/GUID-87C37FFA-C94A-4960-96E6-BAAF9EEC483B-low.png\"> \n         </p><a name=\"TABLE_7EBE52918A524F88BEAD32DFC7CFD884\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-74B30B31-F860-49EC-8100-546B66AA81B7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n(\ntheProps = #(\"ArcRotateLocked\", \"MayaSelectionMode\", \"AutoFocusViewportOnKeyPress\", \"ZoomWheelIncrement\",\n	\"MiddleMouseStrokeMode\", \"ZoomAboutMousePointOrthographic\", \"ZoomAboutMousePointPerspective\", \n	\"RightClickMenuOverSelectedOnly\", \"ZoomInDirection\")\ntheMethods = #(\"GetZoomShortcut\",\"GetPanShortcut\",\"GetRotateShortcut\")\n\nfn printInteractionSettings =\n(\n	for p in theProps do format \"%: %\\n\" p (execute (\"MouseConfigManager.\"+p))\n	for m in theMethods do (\n		(execute (\"MouseConfigManager.\"+m+\" &amp;theKey &amp;theButton\" ))\n		format \"%: %+%\\n\" m (theKey as string) (theButton as string)\n	)--end m loop\n)--end fn\n\nfor i in #(\"3dsMaxMode\", \"MayaMode\", \"CustomizedMode\") do\n(\n	format \"INTERACTION MODE: %\\n\" i\n	IInteractionMode.CurrentMode = (i as name)\n	printInteractionSettings()\n	format \"\\n\"\n)\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-CC83A358-2E41-4C13-91EE-6F7762A82423\"></a><p class=\"table-body\"> <em class=\"strong\">SAMPLE OUTPUT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>INTERACTION MODE: 3dsMaxMode\nArcRotateLocked: false\nMayaSelectionMode: false\nAutoFocusViewportOnKeyPress: false\nZoomWheelIncrement: 1.0\nMiddleMouseStrokeMode: false\nZoomAboutMousePointOrthographic: false\nZoomAboutMousePointPerspective: false\nRightClickMenuOverSelectedOnly: false\nZoomInDirection: #North\nGetZoomShortcut: CtrlAlt+MiddleButton\nGetPanShortcut: null+MiddleButton\nGetRotateShortcut: alt+MiddleButton\n\nINTERACTION MODE: MayaMode\nArcRotateLocked: true\nMayaSelectionMode: true\nAutoFocusViewportOnKeyPress: true\nZoomWheelIncrement: 1.0\nMiddleMouseStrokeMode: false\nZoomAboutMousePointOrthographic: false\nZoomAboutMousePointPerspective: false\nRightClickMenuOverSelectedOnly: false\nZoomInDirection: #SouthEast\nGetZoomShortcut: alt+RightButton\nGetPanShortcut: alt+MiddleButton\nGetRotateShortcut: alt+LeftButton\n\nINTERACTION MODE: CustomizedMode\nArcRotateLocked: true\nMayaSelectionMode: true\nAutoFocusViewportOnKeyPress: true\nZoomWheelIncrement: 1.0\nMiddleMouseStrokeMode: false\nZoomAboutMousePointOrthographic: false\nZoomAboutMousePointPerspective: false\nRightClickMenuOverSelectedOnly: false\nZoomInDirection: #SouthEast\nGetZoomShortcut: alt+RightButton\nGetPanShortcut: alt+MiddleButton\nGetRotateShortcut: alt+LeftButton\n\nOK</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-B0D3BF06-A5F6-4F13-89F3-B7F97B3107C5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE9\"></a> <span class=\"char_link\"><a href=\"GUID-724B14D0-06DC-424A-A6FE-8C494579ECA3.htm\">Interface MouseConfigManager</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";