var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9AA3FE8F-1B39-42FE-BC4F-C915EDE1B343\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MeshProjIntersect ReferenceTarget\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MeshProjIntersect : ReferenceTarget</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9AA3FE8F-1B39-42FE-BC4F-C915EDE1B343\"></a><div class=\"head\">\n            <h1>MeshProjIntersect : ReferenceTarget </h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCC\"></a><pre><em class=\"codeEmphasisStrong\">MeshProjIntersect - superclass: ReferenceTarget; super-superclass:MAXWrapper - 0:0 - classID: #(1266304708, 865233301)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BFD\"></a>&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BFC\"></a>This class exposes an interface that is used by the ProjectionMappingtools to find\n            the projection of one mesh point onto another mesh. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BFB\"></a> <em class=\"strong\">MeshProjIntersect interfaces:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCB\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">rayMeshProjIntersectOps</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BF9\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCA\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">SetNode</em> &lt;node&gt;node </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BF7\"></a>Sets the node to perform the intersections on.Multiple nodes can be added to the same\n            instance of the intersector interface. Use the GetHitNode() method to determine which\n            of the nodes added to the intersector was hit. \n         </p>\n         <p><a name=\"GUID-4388962E-BE2E-41B8-B0F3-0A59AFA1834C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC9\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">Build</em> () </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BF4\"></a>Builds the internal data structures for fast intersections.This method has to be called\n            after adding the nodes. \n         </p>\n         <p><a name=\"GUID-4D5601C3-8975-4F90-BCD8-E38CA603A463\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC8\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">Free</em> () </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BF1\"></a>Removes the internal data structures, frees memory. \n         </p>\n         <p><a name=\"GUID-CF3144C6-880C-45E8-91AD-A4809BB015AA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC7\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">ProjectionFace</em> &lt;integer&gt;triIndex &lt;point3 by value&gt;triBary </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BEE\"></a>Performs a face projection. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BED\"></a>The triIndex argument is the 0-based face index. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BEC\"></a>The triBary argument specifies the barycentric coordinates of the point in the face.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BEB\"></a>Returns true on success, false if no valid projection could be performed. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BEA\"></a>When performing Projection Mapping, a <em class=\"strong\">low-resolution working</em> model and a <em class=\"strong\">high-resolution reference</em> model are used. A cage is defined around the working model which has to completely\n            surround the reference model. Every point on the high-resolution reference model corresponds\n            to a point on the low-resolution working model. There can be multiple reference modes\n            for one working model. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE9\"></a>To use this method, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE8\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE6\"></a>Create an instance of the <span class=\"code\"> <em class=\"strong\">MeshProjIntersect</em> </span> class. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE4\"></a>Call <span class=\"code\"> <em class=\"strong\">SetNode()</em> </span> passing the low-resolution working modeland call <span class=\"code\"> <em class=\"strong\">Build()</em> </span> to generate the acceleration data. It must have a Projection modifier applied. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE2\"></a>The Projection modifier must have one or more reference models defined.&nbsp; \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BE0\"></a>Call the <span class=\"code\"> <em class=\"strong\">ProjectionFace()</em> </span> method with the face index and barycentric coordinates of any point on the surface\n                  of the working model. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BDF\"></a>As result, the <span class=\"code\"> <em class=\"strong\">ProjectionFace()</em> </span> method sets the internal values to hits on the reference models. The method <span class=\"code\"> <em class=\"strong\">getHitNode()</em> </span> will return the reference model that was hit,<span class=\"code\"> <em class=\"strong\">getHitFace()</em> </span> will return the face index, <span class=\"code\"> <em class=\"strong\">getHitPos()</em> </span> will return the position of the hit and so on.See further on this page for details.\n            \n         </p>\n         <p><a name=\"GUID-7DC7E6A2-085A-41F1-B914-D93D15F0CB9F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC6\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">ClosestFace</em> &lt;point3 by value&gt;point <em class=\"codeEmphasisStrong\">dir</em>:&lt;point3 by value&gt;<em class=\"codeEmphasisStrong\">caged</em>:&lt;boolean&gt; <em class=\"codeEmphasisStrong\">doubleSided</em>:&lt;boolean&gt; \n<em class=\"codeEmphasisStrong\">dir</em> default value: [0,0,0] \n<em class=\"codeEmphasisStrong\">caged</em> default value: false \n<em class=\"codeEmphasisStrong\">doubleSided</em> default value: false </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD9\"></a>Returns the closest face to the given point is space. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD8\"></a>If the optional <span class=\"code\"> <em class=\"strong\">dir:</em> </span> keyword parameter is supplied and is not [0,0,0], the closest face in the given direction\n            is detected. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD7\"></a>If the optional <span class=\"code\"> <em class=\"strong\">doubleSided:</em> </span> keyword parameter is supplied and is true, both facing and backfacing faces will\n            be considered. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD6\"></a>Returns true if a closest face has been found, false otherwise. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD3\"></a><p class=\"table-body\">Currently, you have to call the <span class=\"code\"> <em class=\"strong\">IntersectRay()</em> </span> method <em class=\"strong\">AT LEAST ONCE</em> before calling the <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> method - some internal structures required for closest face calculations are only\n                        initialized when performing intersections! \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BD2\"></a><p class=\"table-body\">The results from the <span class=\"code\"> <em class=\"strong\">IntersectRay()</em> </span> call should not be trusted though. See warning further on this page. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-506418BC-71ED-4DF6-A208-4DC7169E45D3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC4\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitDist</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BCD\"></a>Returns the distance to the hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BCC\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> keyword argument is not supplied or is supplied as -1, the closest hit is returned.\n            If it is supplied and is a positive integer, the distance to the corresponding indexed\n            hit is returned.See warning below. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BCA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BC8\"></a><p class=\"table-body\">After calling the <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> method, you MUST NOT specify the <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> optional parameter when calling any of the following methods! There is only one possible\n                        closest face and attempting to pass a value other than -1 can cause <em class=\"strong\">instabilities</em> or <em class=\"strong\">incorrect results</em>. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-C24179B2-AB05-4B25-A90B-21DC9AC80DC8\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC2\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitNode</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BC3\"></a>Returns the node that has been hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BC2\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> keyword argument is not supplied or is supplied as -1, the node of the closest hit\n            is returned. If it is supplied and is a positive integer, the node of the corresponding\n            indexed hit is returned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BC1\"></a>See previous warning regardinggetting data after a <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> call. \n         </p>\n         <p><a name=\"GUID-7C7D1909-EC24-4F76-8537-1421B53EFC5C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FC0\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitFace</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BBD\"></a>Returns the <em class=\"strong\">ZERO-BASED</em> indexof the face that has been hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BBC\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> keyword argument is not supplied or is supplied as -1, the closest face hit is returned.\n            If it is supplied and is a positive integer, the face of the corresponding indexed\n            hit is returned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BBB\"></a>See previous warning regarding getting data after a <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> call. \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F3F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BB8\"></a>The face indexing can change between a geometry primitive and the Editable Mesh version\n                  of the same geometry. For example, a plane with just two faces would return a hit\n                  as face 0 when using the primitive geometry but 1 for the same hit when using a collapsed\n                  version of the same object. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BB7\"></a>This is normal but quite rarelyvisible throughMAXScript since no other methods provide\n                  access to the actual underlying geometry of primitives - the other intersection and\n                  mesh methods operate on objects already converted to mesh. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"GUID-A6459766-FDEB-4840-A6DA-72C2BE65F33C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FBE\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitBary</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BB2\"></a>Returns the barycentric coordinates of the hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BB1\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex</em> </span>: keyword argument is not supplied or is supplied as -1, the barycentric coordinates\n            of the closest hit are returned. If it is supplied and is a positive integer, the\n            barycentric coordinates of the corresponding indexed hit are returned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BB0\"></a>See previous warning regarding getting data after a <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> call. \n         </p>\n         <p><a name=\"GUID-435D98EC-382F-4B0E-86CA-E0888CA27283\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FBC\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitBackfacing</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BAC\"></a>Returns the backfacing hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BAB\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> keyword argument is not supplied or is supplied as -1, the closest backfacing hit\n            is returned. If it is supplied and is a positive integer, the corresponding indexed\n            backfacing hit is returned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BAA\"></a>See previous warning regarding getting data after a <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> call. \n         </p>\n         <p><a name=\"GUID-FB4C89AC-5FE5-481C-8377-789F8CBAB4FE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FBA\"></a><pre>&lt;fpvalue by value&gt;<em class=\"codeEmphasisStrong\">GetHitPos</em> <em class=\"codeEmphasisStrong\">hitIndex</em>:&lt;integer&gt; \n<em class=\"codeEmphasisStrong\">hitIndex</em> default value: -1 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BA6\"></a>Returns the world position of the hit. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BA5\"></a>If the optional <span class=\"code\"> <em class=\"strong\">hitIndex:</em> </span> keyword argument is not supplied or is supplied as -1, the position of the closest\n            hit is returned. If it is supplied and is a positive integer, the position of the\n            corresponding indexed hit is returned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BA4\"></a>See previous warning regarding getting data after a <span class=\"code\"> <em class=\"strong\">ClosestFace()</em> </span> call. \n         </p>\n         <p><a name=\"GUID-230BC7EA-023D-43AB-A935-5BF0B283BC45\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FB8\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">IntersectRay</em> &lt;point3 by value&gt;point &lt;point3 by value&gt;dir <em class=\"codeEmphasisStrong\">doubleSided</em>:&lt;boolean&gt; \n<em class=\"codeEmphasisStrong\">doubleSided</em> default value: false </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3BA0\"></a>Performs a ray intersection with the nodes set using <span class=\"code\"> <em class=\"strong\">SetNode()</em> </span> from the world space position defined by the point parameter in the direction of\n            the vector specified by the dir parameter. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B9F\"></a>If the optional <span class=\"code\"> <em class=\"strong\">doubleSided:</em> </span> keyword parameter is supplied and is true, intersections will be performed with both\n            the front and the backside of the faces. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B9E\"></a>Returns true if the ray has hit any faces, false if there was no intersection. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B9D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B9B\"></a><p class=\"table-body\">This method is currently considered <em class=\"strong\">broken</em> and should not be used to perform actuall intersections. Under some circumstances\n                        it can return incorrect results. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B98\"></a> <span class=\"char_link\"><a href=\"GUID-3CF6FA6C-4CEA-4CC4-BACF-B2E40EF28C53.htm\">RayMeshGridIntersect : ReferenceTarget</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B97\"></a> <span class=\"char_link\"><a href=\"GUID-C6CD8B3A-C5EF-4A83-8DB2-B5EDFEFDEEDD.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D4B\">IntersectRay</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3B96\"></a> <span class=\"char_link\"><a href=\"GUID-C6CD8B3A-C5EF-4A83-8DB2-B5EDFEFDEEDD.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D4B\">IntersectRayExt</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";