var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9AAA093F-FBA4-4B6A-8F8A-76C21F9F355E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"VolumeDocking Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>VolumeDocking Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9AAA093F-FBA4-4B6A-8F8A-76C21F9F355E\"></a><div class=\"head\">\n            <h1>VolumeDocking Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D19\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D1A\"></a>The following sample is based on Laszlo Sebo\'s <em class=\"mild\">VolumeDocking01.max</em> scene and illustrates the following MAXScript operations with <em class=\"strong\">Particle Flow</em> : \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D1B\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D1D\"></a>Common Action creation, \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D1F\"></a>Appending Actions to an Event, \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D21\"></a>Inserting Actions to an Event, \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D23\"></a>Cloning Actions and Events \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D25\"></a>Wiring \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D27\"></a>Repositioning events in Particle View \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D28\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D29\"></a>The script is self-contained and recreates all objects and <em class=\"strong\">Particle Flow</em> Events and Actions on the fly: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2A\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5B2EA27F-F442-4C32-B255-AD0128ADD076-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2B\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2C\"></a>The script creates two geometry primitives and two <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Sources</a></span> with corresponding Actions and Events. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2D\"></a>The geometry objects are used as volumes to be filled with particles. The initial\n            positions of the particles are dumped to the particleVector channel. Using a <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target</a></span> action, the particles find their way from the one volume to the other and switch\n            places after swirling around. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84D2F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E05\"></a><pre>\n-----------------\n-- SCENE SETUP --\n-----------------\n \n-- Set scene animation range to 150 frames\nanimationRange = interval 0f 150f\n-- Create Cylinder primitive\ncyl=cylinder radius:44 height:44 heightsegs:5 sides:18 pos:[-60, -55, 0]\n-- Create a Torus primitive\ntor=torus radius1:55 radius2:20 smooth:2 pos:[135, 120, 0]\n-- Create a Vortex Space Warp\nvor=vortex timeOff:33 axialStrength:22 rotationStrength:33 iconSise:40 rotation:(quat -1 0 0 0) pos:[20,35,-5]\n \n-- PF_Flow setup\npf=PF_Source Show_Logo:off Show_Emitter:off Quantity_Viewport:100 isSelected:true\n \n-------------------------------------\n-- Action List - Appending Example --\n-------------------------------------\n \n-- Disable automatic Event Encapsulation &amp; begin editing:\nParticleFlow.BeginEdit()\na1 = RenderParticles()--define Action 1\npf.AppendAction a1--append the Action to PF_Source\nParticleFlow.EndEdit()--End editing, enable Auto-Encapsulation\n \nx=y=1--Initialize two variables\n--Get the location of the PF_Source in Particle View:\npf.GetPViewLocation &amp;x &amp;y\n \n------------------------\n-- Define First Event --\n------------------------\nParticleFlow.BeginEdit()--start editing\n-- Create a Birth Action for Event 1\nev1_a1 = Birth Emit_Start:0 Emit_Stop:0 Amount:300\n \n-- Create a Position Object Action for Event 1\nev1_a2 = Position_Object Location:4 Emitter_Objects:#(tor) name:\"PositionObjectFirst\"\n-- Comment the Position Object\npf.SetComments ev1_a2 \"The operator defines the destination point inside the target volume\"\n \n-- Create a Script Operator\nev1_a3 = Script_Operator()\n-- Set the script operator’s script code as string.\n-- The code enables Position and Vector channels,\n-- the writes the particle position in the Vector channel\n-- for all new particles.\nev1_a3.proceed_script = \"on ChannelsUsed pCont do\n(\n pCont.usePosition = true\n pCont.useVector = true\n)\non Init pCont do\n(\\n\n)\non Proceed pCont do\n(\n count = pCont.NumParticles()\n for i in 1 to count do\n (\n pCont.particleIndex = i\n if (pCont.particleNew) then\n ( pCont.particleVector = pCont.particlePosition)\n )\n)\non Release pCont do\n(\\n\n)\"\n \n-- Comment the action:\npf.SetComments ev1_a3 \"The script is used to dump particle position to script vector channel\"\n \n-- Clone the Position_Object action from Event 1\n-- The result of the cloning will be stored in the\n-- by-reference variable dc.\nmaxOps.cloneNodes ev1_a2 newNodes:&amp;dc\n-- Get the clone (first element of array)\nev1_a4 = dc[1]\n-- Set the name of the action\nev1_a4.name =\"PositionObjectSecond\"\n-- Set the Cylinder as the Emitter\nev1_a4.Emitter_Objects = #(cyl)\n \n-- Comment the action:\npf.SetComments ev1_a4 \"The operator defines the initial position of a particle inside a start volume. The destination position is overwritten but the real value is kept in Script Vector channel\"\n \n-- Create some more actions needed to control the particle system\nev1_a5 = Speed Direction:3\nev1_a6 = Rotation()\nev1_a7 = ShapeStandard Shape:1\nev1_a8 = DisplayParticles Type:6 Color:(color 255 0 0)\n \n-- Create a new empty event, then append all already created\n-- actions to it:\nev1 = Event()\nev1.AppendAction ev1_a1\nev1.AppendAction ev1_a2\nev1.AppendAction ev1_a3\nev1.AppendAction ev1_a4\nev1.AppendAction ev1_a5\nev1.AppendAction ev1_a6\nev1.AppendAction ev1_a7\nev1.AppendAction ev1_a8\n-- Disable editing, enable Auto-Event-Encapsulation\nParticleFlow.EndEdit()\n \n-- Append the event as the Initial Action List to the PF_Source.\n-- This will connect the Event to the PF_Source.\npf.appendInitialActionList ev1\n-- Position the Event inside the Particle View\nev1.SetPViewLocation x (y+100)\n \n-------------------------------------\n-- Action List - Inserting Example --\n-------------------------------------\n \n--Begin Editing again\nParticleFlow.BeginEdit()\n \nev1_a9 = Spin SpinRate:200 Variation:55--Create a Spin action\nev1_a10 = Force Influence:111--Create a Force\n--Set the Vortex as Space Warp in the Force\nev1_a10.Force_Space_Warps = #(vor)\n \n--Create and setup a Find_Target action:\nev1_a11 = Find_Target()\nev1_a11.name =\"FindTarget\"\nev1_a11.Cruise_Speed_Variation = 1000\nev1_a11.Acceleration_Limit=3000\nev1_a11.Aim_Point_Type = 2\nev1_a11.Icon_Size = 0\n \n-- Comment the action:\npf.SetComments ev1_a11 \"The destination point is defined by script vector. The script vector value was defined by the Script Operator 01 from the Position Object 01\"\n \n-- Insert the new actions into the existing Event\nev1.InsertAction ev1_a9 8\nev1.InsertAction ev1_a10 9\nev1.InsertAction ev1_a11 10\nParticleFlow.EndEdit()\n \n-- Create a Second Event and its actions:\nParticleFlow.BeginEdit()\nev2_a1 = Speed Speed:0\nev2 = Event()\nev2_a2 = DisplayParticles Type:6 Color:(color 0 255 0)\nev2.AppendAction ev2_a1\nev2.AppendAction ev2_a2\nParticleFlow.EndEdit()\n \n--Connect the second Event to the Find_Target\nev1_a11.setNextActionList ev2 ev1_a11\n--Reposition the even\nev2.SetPViewLocation x (y+400)\n \n \n-- Make copy of PF_Source and exchange Emitter objects\n-- for Position_Object operators:\n \n-- Clone the PF_Source and the two Emitters,\n-- store the clones in a by-reference variable\nmaxOps.CloneNodes #(pf, ev1, ev2) newNodes:&amp;dc\n \n-- Get the PF_Source and Emitter clones\npfc = dc[1]\nev1c = dc[2]\nev2c = dc[3]\n \n-- Get the current position of the Particle View...\nx=y=1\npfc.GetPViewLocation &amp;x &amp;y\n-- Reposition the two Events\nev1c.SetPViewLocation x (y+100)\nev2c.SetPViewLocation x (y+400)\n \n-- Copy the emitter objects from the original Position_Objects\nif $PositionObjectFirst01 != undefined then (\n $PositionObjectFirst01.Emitter_Objects = ev1_a4.Emitter_Objects\n)\nif $PositionObjectSecond01 != undefined then (\n $PositionObjectSecond01.Emitter_Objects = ev1_a2.Emitter_Objects\n)\n \n-- Bind the Find_Target Test output to the clone of the Second Event\nif $FindTarget01 != undefined then (\n $FindTarget01.setNextActionList ev2c $FindTarget01\n) \n \n-- Switch to Modify Tab\nmax modify mode\n-- Open Particle View to see what happened...\nParticleFlow.OpenParticleView()\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84DF5\"></a> <span class=\"char_link\"><a href=\"GUID-627D5362-6E27-42FF-A89B-198410821E5E.htm\">particleFlow Global Interface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84DF6\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84DF7\"></a> <span class=\"char_link\"><a href=\"GUID-EFFE90C4-D746-494B-97E6-D49E89B50731.htm\">Particle Flow Classes</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";