var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"utility\">\n      <meta name=\"indexterm\" content=\"scripted utility panels\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Utility Panels</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2\"></a><div class=\"head\">\n            <h1>Scripted Utility Panels </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AAD\"></a>A scripted utility panel is created using the <span class=\"code\"> <em class=\"strong\">utility</em> </span> definition construct in MAXScript. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AAC\"></a>The top-level syntax is as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D7\"></a><pre><em class=\"codeEmphasisStrong\">utility</em> &lt;var_name&gt; &lt;description_string&gt; [<em class=\"codeEmphasisStrong\">rolledUp</em>:&lt;boolean&gt; ] [<em class=\"codeEmphasisStrong\">silentErrors</em>:&lt;boolean&gt; ]\n<em class=\"codeEmphasisStrong\">(</em> \n&lt;utility_body&gt; \n<em class=\"codeEmphasisStrong\">)</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA9\"></a>The <span class=\"code\"> &lt;var_name&gt; </span> is the name of an automatically created global variable to hold the value that represents\n            the scripted utility panel. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA8\"></a>The <span class=\"code\"> &lt;description_string&gt; </span> is a string which is used as the description for the utility in the Utilities list\n            in the MAXScript rollout. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA7\"></a>The optional <span class=\"code\"> <em class=\"strong\">rolledUp:</em> </span> parameter specifies whether the utility rollout is initially rolled up. If set to\n            <span class=\"code\"> <em class=\"strong\">true</em> </span>, the utility rollout is initially rolled up. The default value is <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA6\"></a>The optional <span class=\"code\"> <em class=\"strong\">silentErrors:</em> </span> parameter controls whether MAXScript runtime error messages are displayed while executing\n            the scripted utility. If this parameter is set to <span class=\"code\"> <em class=\"strong\">false</em> </span>, error messages are displayed to Listener and possibly to a pop-up error dialog,\n            and continued execution of the utility is terminated. If this parameter is set to\n            <span class=\"code\"> <em class=\"strong\">true</em> </span>, error messages will not be displayed, and continued execution of the utility is\n            permitted. Setting this parameter to <span class=\"code\"> <em class=\"strong\">true</em> </span> is useful for distributed scripted plug-ins that may confuse the user with MAXScript\n            error messages. The default value is <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA5\"></a>The <span class=\"code\"> &lt;utility_body&gt; </span> is inside the required parentheses and is a sequence of clauses that defines the\n            user-interface items that will appear in the utility, along with functions and event\n            handlers that process user interactions, as defined in detail in <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA3\"></a>Here is a short example that implements a utility for spreading the positions of the\n            objects in the current selection. It installs a <span class=\"code\"> <em class=\"strong\">Spread objects</em> </span> entry in the Utilities list. When opened, the <span class=\"code\"> <em class=\"strong\">Spread objects</em> </span> rollout has three check boxes and one spread amount spinner. The spread spinner event\n            handler is called whenever the user adjusts the spinner, and the event handler expression\n            computes a new position for the objects in the selection, testing the state of each\n            check box to control the spread. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AA1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D6\"></a><pre>\nutility spread \"Spread objects\" -- define the utility name and description string\n(\nlocal last_amt = 0 -- define and initialize local variable\ncheckbox x \"Spread in x\" -- create 3 checkboxes\ncheckbox y \"Spread in y\"\ncheckbox z \"Spread in z\"\nspinner spread \"Spread amount:\" range:[-1000,1000,0] -- create a spinner\non spread changed amt do -- when spinner value changes...\n(\ndelta = amt - last_amt -- calculate difference in current and previous\nfor obj in selection do -- values for each selected object\n(\n-- calculate new position based on current position and selection center\np = obj.pos + normalize (obj.pos - selection.center) * delta\nif x.checked then obj.pos.x = p.x -- if checkbox x checked, apply X position\nif y.checked then obj.pos.y = p.y -- if checkbox y checked, apply Y position\nif z.checked then obj.pos.z = p.z -- if checkbox z checked, apply Z position\n)\nlast_amt = amt -- store spinner value as previous value\n) -- end of \"on spread changed\"\n) -- end of utility definition\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A88\"></a>The Utilities panel rollout created by the previous script looks like the following\n            figure. The Close button is automatically created by MAXScript in the utility rollout,\n            and closes the rollout. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A87\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-C80D0D89-21D3-4503-BFF8-F11AB1544E5C-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A86\"></a> <em class=\"strong\">Spread objects rollout</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A85\"></a>Evaluating a utility definition does several things. It creates a new value which\n            is an instance of the Rollout class and contains the utility definition. It assigns\n            this value to the named global variable and installs the utility description in the\n            Utilities list in the MAXScript rollout. At this point, the user can select the utility\n            from the Utilities list and the utility’s rollout(s) will open. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75ED\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-510B86A2-41FB-4E8D-B4D2-5F47072AC278\"></a>If a scripted utility already exists with the same description, the old rollout(s)\n                  is replaced with the new one(s), even if it is currently open in the Utilities panel.\n                  This allows you to incrementally develop a utility. Each time you modify and evaluate\n                  its definition, the old version is replaced with the new one. \n               </p> \n            </div>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A80\"></a> <span class=\"char_link\"><a href=\"GUID-B478B60B-B27D-4916-A07E-264818666080.htm\">Scripted Utilities</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A7F\"></a> <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A7E\"></a> <span class=\"char_link\"><a href=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF.htm\">Managing Multiple Rollouts in a Scripted Utility</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";