var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"showClass()\">\n      <meta name=\"indexterm\" content=\"modifying the box\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifying the Box</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D\"></a><div class=\"head\">\n            <h1>Modifying the Box </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-2EDB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F12\"></a>  In the <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">previous lesson</a></span>, you created a box by assigning it to a named variable. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F15\"></a>Because you used a variable for the box, you can now access all of the box’s properties\n               easily. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F16\"></a>The variable name <span class=\"code\">mybox</span> is the <em class=\"mild\">handle</em> to your box. To access the properties of the handle, append a \".\" (period), and then\n               the property name. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F17\"></a>For example, <span class=\"code\">mybox.height</span> can be read as \"the height of mybox.\" \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-2EDA\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F19\"></a>All <em class=\"strong\">3ds Max</em> objects have creation parameters such as width, length, and height for boxes, or\n               radius for spheres and circles. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1A\"></a>These objects also have transformation properties, such as scale, rotation, or position,\n               and general properties like name, wirecolor, etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1B\"></a>To change any of these properties, you can set the property to a new value. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1C\"></a> \n            <h2><a name=\"GUID-FFDA4DCF-F892-4273-BF63-F09932AF2ACC\"></a> <em class=\"strong\">Changing Object Properties</em> \n            </h2> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1D\"></a> \n               <h3><a name=\"GUID-A5FCEBBD-1A51-4597-8F11-3B5A54E6CBB7\"></a> <em class=\"strong\">Object Name</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1E\"></a>If you don’t like the default object name Box001, you can change the name property\n                  of the box: \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F1F\"></a>Enter <span class=\"code\">mybox.name = \"BlueBox\"</span> in the Listener window and the software renames the box. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F20\"></a>You can see the new name in the Name edit box when you go to the Modify panel: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F21\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D2686E09-A228-414A-8AEA-685AF0B862B0-low.gif\"></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F22\"></a> \n               <h3><a name=\"GUID-902FCCD3-EEFC-473E-9E66-A578F771E476\"></a> <em class=\"strong\">Color</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F23\"></a>By default, 3ds Max assigns the color of objects randomly at creation time. Therefore,\n                  the color of your box is not necessarily blue. In this case, BlueBox wouldn’t be an\n                  appropriate name for your box. However, you can change the color of your box to match\n                  the name: \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F24\"></a>Enter <span class=\"code\">mybox.wirecolor = blue</span> and watch the box in your viewports turn blue. You may have to select the box again\n                  to reflect the new color in the color swatch next to the object name in the Modify\n                  panel. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F25\"></a>The color <span class=\"code\">blue</span> is a predefined color constant in MAXScript and its RGB value is defined as (0,0,255).\n                  The other predefined color variables are red, green, white, black, orange, yellow,\n                  and brown. Instead of using a predefined color, you can assign a color with different\n                  RGB values, such as: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5088\"></a><pre>\nmybox.wirecolor = (color 255 0 255)\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F27\"></a>Notice the special syntax for entering specific color values. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F28\"></a>The example shown would change the box to magenta. If you entered this command, click\n                  <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo to change the box back to blue. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F29\"></a>For more information on colors, see the <span class=\"char_link\"><a href=\"GUID-D8DBE1AA-F3D7-4708-93FA-7C28845A1C03.htm\">Color Values</a></span> topic in the MAXScript reference. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2A\"></a> \n               <h3><a name=\"GUID-381E87F0-7CFE-4110-AEBF-AB0E0CEA1ACE\"></a> <em class=\"strong\">Position</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2B\"></a>You can change the position of the box by changing the box’s position property. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2C\"></a>You refer to the position property for this example box with <span class=\"code\">mybox.pos</span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2D\"></a>The position is expressed as the X, Y, Z coordinates. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2E\"></a>For example <span class=\"code\">[0,-75,0]</span> will position the box 75 units along the negative Y axis. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F2F\"></a>Enter <span class=\"code\">mybox.pos = [0,-75,0]</span> and watch the box jump in the perspective view. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F30\"></a>Click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo to move the box back to the origin. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F31\"></a>&nbsp;<img src=\"../images/GUID-9E79A889-A802-4451-9428-5919BBBA2905-low.gif\"> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F33\"></a> \n               <h3><a name=\"GUID-055E3DE0-CF27-4442-BBA3-C32D30F796BA\"></a> <em class=\"strong\">Size</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F34\"></a>To make the box bigger, you can use the scale property of the box: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F35\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F36\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5087\"></a><pre>\nmybox.scale = [1.5,1.5,1.5]\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F3B\"></a>to see the box resized to 1.5 times its original size. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F3D\"></a>&nbsp;<img src=\"../images/GUID-3893148A-C193-442C-8C17-FFD3CCF0D505-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F3E\"></a>Click<img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\"> Undo to undo the scale and return the box to its original size. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F40\"></a>The scale property requires a scaling factor for each of the X, Y, and Z axes, or,\n                  in this case, the width, length and height of the box. You don’t have to use the same\n                  value for each axis unless you want to resize the box uniformly. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F41\"></a>If you want to change the scale to affect only the height and the width, but not the\n                  length, use the following \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F42\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F43\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5086\"></a><pre>\nmybox.scale = [1,3,2]\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-64F8\"></a>When you scale your original [20,20,20] box by any factor, the box’s parameters are\n                  still 20 for width, 20 for length, and 20 for height. You can see this when you open\n                  the Modify panel. The box parameters are not changed by the scale transformation:\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F48\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-ACFBEF8A-BE0F-4E2F-A57E-E9A48DEA7D88-low.gif\"></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F4A\"></a>&nbsp;<img src=\"../images/GUID-D965438C-6631-4D9F-B105-42C048A0DD12-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F4B\"></a>Although altering the height and width properties of the box achieves the same result,\n                  <em class=\"mild\">visually</em>, the above scale modification is <em class=\"mild\">not</em> equivalent to using the following two commands: \n               </p> \n               <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7EA5\"></a> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5085\"></a><pre>\nmybox.height = 40 -- 2 times the original 20 units \nmybox.width = 60 -- 3 times the original 20 units\n</pre></div> \n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F4D\"></a>The reason for this is that changing the height property of the box changes the creation\n                  parameter of the box’s height. Using the scale property to transform the height of\n                  the box does not. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F4E\"></a>Again, the effect of using either method is visually the same. However, when you want\n                  to maintain the original creation parameters of an object (so that you can alter them\n                  even after a number of different transformations), you must use the scale property\n                  to manipulate the size of the box, not the individual creation properties. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F4F\"></a>Also note that in real world production, scaling objects is generally a bad idea as\n                  it can interfere with the animation of hierarchically linked objects and other features\n                  of <em class=\"strong\">3ds Max</em>. Using an XForm modifier\'s and scaling its Gizmo is the preferred approach as it\n                  localizes the scale to the Modifier Stack and does not affect the animation transformations.\n                  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F50\"></a>Click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo to change the box back to its original scale of [1,1,1]. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F51\"></a> \n               <h3><a name=\"GUID-D9124CB8-D118-4D70-8909-B05FC7893E25\"></a> <em class=\"strong\">Finding Additional Parameters</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F52\"></a>The Parameters rollout shows all the creation parameters for a box. You can change\n                  them using the spinners in the rollout. If you want to change the value of the length,\n                  width, and height segments, or the setting of the mapping coordinates in MAXScript,\n                  you need to know the syntax for these parameters. In order to find the syntax for\n                  <em class=\"mild\">all</em> of the parameter settings, there are two different inspector functions. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F53\"></a>The first of these is <span class=\"code\">showclass()</span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F54\"></a>The <span class=\"code\">showClass()</span> function prints information about a specified <em class=\"strong\">3ds Max</em> class or classes. The information entered in the parentheses is a string containing\n                  a wild-card pattern to match against <em class=\"strong\">3ds Max</em> class names, superclass names, and property names. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F55\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F56\"></a><p class=\"table-body\"> <em class=\"strong\">ENTER:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5084\"></a><pre>\nshowclass \"box.*\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F5B\"></a>MAXScript shows all the box parameters that are equivalent to the ones you see in\n                  the Parameters rollout, including which object class the box object belongs to, and\n                  the data type that each parameter requires: \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F5C\"></a>&nbsp;<img src=\"../images/GUID-D1A4DC42-3812-434A-BAF7-F8D664068EF3-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F5D\"></a>Notice that you can use the \"*\" character as a wildcard to see all box parameters.\n                  If you had entered <span class=\"code\">showClass \"box*.*,\"</span> MAXScript would have listed all of the parameters of the<span class=\"code\">Box</span><em class=\"mild\"> and</em> the <span class=\"code\">BoxGizmo</span> classes. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F5E\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F5F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5083\"></a><pre>\nshowClass \"box*\" -- all 3ds max classes starting \"box\"\nshowClass \"box.*\" -- all the accessible properties of the box class\nshowClass \"*:mod*\" -- all the modifier classes\nshowClass \"*.*rad*\" -- all the classes with a property name containing \"rad\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F67\"></a>The second inspector function is <span class=\"code\">showProperties()</span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F68\"></a>The <span class=\"code\">showProperties()</span> function is used to display the properties for a specific object that is an instance\n                  of one of the <em class=\"strong\">3ds Max</em> classes. It can be used in place of <span class=\"code\">showClass()</span> in situations where you have an actual object in hand. Unlike <span class=\"code\">showClass()</span>, it can display the dynamic properties that may appear in individual objects as you\n                  work on them in the scene. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F69\"></a>To learn more about these functions, see <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F6A\"></a> <em class=\"strong\">Next Topic</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F6B\"></a> <span class=\"char_link\"><a href=\"GUID-308EA213-59FA-4F1B-AF40-FC7E658F5DD2.htm\">Applying Standard Transformations</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";