var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9CCCED2F-48B9-4E53-A2F3-C7C5504EEC39\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Camera_Culling Helper\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AirFlow_Spline : Helper</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9CCCED2F-48B9-4E53-A2F3-C7C5504EEC39\"></a><div class=\"head\">\n            <h1>AirFlow_Spline : Helper</h1>\n         </div>\n         <div class=\"codeBlock\"><pre>AirFlow_Spline - superclass: helper; super-superclass:node - 8:0 - classID: #(1509449991L, 515064320L)</pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E8351D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8351E\"></a><p class=\"table-body\">  <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-4ECA4F12-1972-42E7-BDDD-9AE188AC4BEF.htm\">Helper</a></span> &gt; AirFlow_Spline \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> The AirFlow_Spline helper converts CFD Data to particle flow splines for airflow\n            simulations. Available in \n            		<em class=\"strong\"> in 3ds Max 2018 and higher.</em> \n         </p>\n         <div><a name=\"GUID-18CB993A-4F59-4D99-80B8-FEEC42BEC47D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> this class is not creatable in the 3ds Max ParticleFlow UI. It can only be created\n               via MAXScript. \n               	 \n            </div>\n         </div>\n         <div><a name=\"GUID-35A016D5-6E7F-4093-80DF-AAC57F9FACDA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> The AirFlow* pflow classes in MAXScript are a prototype for CFD visualization. The\n               recommended method is to use MCG. See \"Visualizing CFD Data\" in the 3ds Max User’s\n               Guide. \n               	 \n            </div>\n         </div>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Data_Source_File</em>     UndefinedClass    default: undefined   --  filename; </pre></div>\n         <p> Gets or sets the data source FBX file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Emit_Start</em>     Integer    default: 0   --  integer; Emit_Time \n&lt;AirFlow_Spline&gt;.Emit_Stop     Integer    default: 4800   --  integer</pre></div>\n         <p>Gets or sets the emit start and stop time. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Max_Speed</em>     Float    default: 10000.0   --  animatable; worldUnits \n&lt;AirFlow_Spline&gt;.Min_Speed     Float    default: 0.0   --  animatable; worldUnits</pre></div>\n         <p>Gets or sets the air flow minimum and maximum speed. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Rate</em>     Float    default: 60.0   --  animatable; float</pre></div>\n         <p>Gets or sets the emit rate. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Speed_Factor</em>     Float    default: 0.01   --  animatable; float</pre></div>\n         <p>Gets or sets the speed factor. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Spline&gt;.<em class=\"codeEmphasisStrong\">Splines</em>     ArrayParameter    default: #()   --  node array; SubAnim</pre></div>\n         <p>An array of splines imported from the data file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E83543\"></a> \n            <h2><a name=\"GUID-14B36B1A-9868-4A47-B9D6-5806E6F6AAF8\"></a> <em class=\"strong\">AirFlow_Spline interfaces:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83544\"></a> <em class=\"strong\">The following common Particle Flow Interfaces are exposed by the AirFlow_Spline Class:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83545\"></a> <span class=\"char_link\"><a href=\"GUID-E79B7C9A-90E9-4EBA-8528-D819882EADF2.htm\">Interface: action</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83546\"></a> <span class=\"char_link\"><a href=\"GUID-997AF141-E2BD-419E-A10A-71B2288F571C.htm\">Interface: operator</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83547\"></a> <span class=\"char_link\"><a href=\"GUID-E431999C-D823-4650-8C5C-D02137348CF9.htm\">Interface: PViewItem</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";