var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"defining\">\n      <meta name=\"indexterm\" content=\"local variables\">\n      <meta name=\"indexterm\" content=\"global variables\">\n      <meta name=\"indexterm\" content=\"custom functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Defining Custom Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2\"></a><div class=\"head\">\n            <h1>Defining Custom Functions </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC515B\"></a>    MAXScript’s built-in functions are very powerful. They provide access to objects,\n            allowing you to read and set their properties. However, scripting in <em class=\"strong\">3ds Max</em> normally entails going beyond simple object creation. Fortunately, MAXScript allows\n            you to make your own functions, giving you the ability to streamline and customize\n            your work. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5160\"></a>In MAXScript, you can use functions to perform almost any of the software’s operations.\n            Start with a simple function definition that subtracts two variables: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5161\"></a>&nbsp;<img src=\"../images/GUID-A149D177-B559-4C7B-A2F0-FA288180DEF2-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5162\"></a>MAXScript returns <span class=\"code\">subtract()</span> to let you know that it has defined the function, subtract. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5163\"></a>The definition contains the keyword <span class=\"code\">function</span> (you can also use the word <span class=\"code\">fn</span> in place of <span class=\"code\">function</span>), followed by the name of the function (<span class=\"code\">subtract</span>), followed by the list of variables (<span class=\"code\">x</span> and <span class=\"code\">y</span>). The equal sign signifies the start of the body of the function. The body is the\n            series of statements that the function executes. Even if there is only one statement,\n            the body of the function must be in parentheses. \n         </p>\n         <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7D3F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5166\"></a>Any variables created in the body of a function are local variables unless otherwise\n                  specified. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5168\"></a>Once a function has been defined, it can be used anywhere throughout the script. Therefore,\n            it is useful to place function definitions at the beginning of your scripts. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5169\"></a>In order to use a function, you simply enter the function name and the values for\n            its variables: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC516A\"></a>&nbsp;<img src=\"../images/GUID-39E0D9F5-1013-41E8-B395-31236C69BC6F-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC516B\"></a>This example uses what are known as <em class=\"mild\">positional arguments</em>. When you call the function, you must supply both arguments, and you must supply\n            them in the proper order for the function to execute properly. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC516C\"></a>The second type of arguments you can use are <em class=\"mild\">keyword</em> arguments. This is what is used for all of the object constructors in MAXScript.\n            The function definition is the same, with the exception of declaring the keyword arguments,\n            or default values for the variables in a function. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC516D\"></a>The following example determines whether a number is positive, negative, or equal\n            to zero. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC516F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5170\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-505E\"></a><pre>\nfunction sign val:0 =\n(\nif val == 0\nthen messagebox (\"Equal to 0\")\nelse if val &gt; 0\nthen messagebox (\"Greater than 0\")\nelse messagebox (\"Less than 0\")\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC517C\"></a>The <span class=\"code\">messagebox</span> command causes a message box to pop up on the screen, displaying the argument in\n            the parentheses that follow the command. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC517D\"></a>In this example, a parameter called <span class=\"code\">val</span> has been declared in the function definition. The value after the colon is the parameter’s\n            default value. When the function definition contains parameters like this, they are\n            optional in the function call. If you enter <span class=\"code\">sign()</span>, without specifying any parameters in the function call, MAXScript uses the default\n            value: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC517E\"></a>&nbsp;<img src=\"../images/GUID-957CAB61-2B26-433D-84C1-61562FCA80FB-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC517F\"></a>The \"Equal to 0\" message box appears, since the default value for <span class=\"code\">val</span> (0) will be used. However, if you do define <span class=\"code\">val</span>: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-505C\"></a><pre>\nsign val:-5\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5181\"></a>&nbsp;<img src=\"../images/GUID-CC7F11DE-8A08-433A-B477-62332E4B411F-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5182\"></a>the \"Less than 0\" message appears. You can include as many keyword arguments in a\n            function as you need, and they can be entered in any order when calling the function.\n            This is useful when you consider functions such as object-creation functions, where\n            the new object might have 20 or 30 parameters associated with it. If you wanted to\n            use positional argument functions to create the same objects, you would have to provide\n            all of these parameters, in the right order, each time you wanted to call the function.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5183\"></a>It is also possible to use both positional and keyword arguments in the same function\n            call. In this case, you must use positional arguments first, followed by the keyword\n            arguments, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5184\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5185\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-505B\"></a><pre>\nfunction mycube side position:[0, 0, 0] =\n(\nbox length:side width:side height:side pos:position\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC518D\"></a>This function requires you to enter the size of the cube, but the position is optional.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC518E\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC518F\"></a> <span class=\"char_link\"><a href=\"GUID-A35C74C5-1721-4B19-9FC4-E1CD6563505B.htm\">Structure Definitions</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";