var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9D407E2A-3691-426F-9B06-4A744C3DEE58\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"picking\">\n      <meta name=\"indexterm\" content=\"selectByName()\">\n      <meta name=\"indexterm\" content=\"Select by Name\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Picking Scene Nodes by Name</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9D407E2A-3691-426F-9B06-4A744C3DEE58\"></a><div class=\"head\">\n            <h1>Picking Scene Nodes by Name </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35DC\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35DB\"></a>   You can use the <span class=\"code\"> <em class=\"strong\">selectByName()</em> </span> function to open the standard <em class=\"strong\">3ds Max</em> Select By Name dialog allowing users to pick objects which are then returned as an\n               array of MAXScript node values. \n            </p> \n            <p><a name=\"GUID-C43A7CD9-CB61-4A55-B3D6-3AFF7A96C6F1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35D7\"></a> <em class=\"strong\">The form is: </em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2E\"></a><pre><em class=\"codeEmphasisStrong\">selectByName</em> [		<em class=\"codeEmphasisStrong\">title</em>:&lt;string&gt;] [		<em class=\"codeEmphasisStrong\">buttonText</em>:&lt;string&gt;] [ 		<em class=\"codeEmphasisStrong\">filter</em>:&lt;fn&gt;] [		<em class=\"codeEmphasisStrong\">showHidden</em>:&lt;boolean&gt;][		<em class=\"codeEmphasisStrong\">single</em>:&lt;boolean&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35D5\"></a>The optional keyword arguments are interpreted as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2D\"></a><pre><em class=\"codeEmphasisStrong\">title:\"</em>string	 <em class=\"codeEmphasisStrong\">\"</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35D3\"></a>Specifies the dialog window title. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2C\"></a><pre><em class=\"codeEmphasisStrong\">buttonText:\"</em>string  <em class=\"codeEmphasisStrong\">\"</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35D1\"></a>Lets you specify the label text in the \'accept\' button in the dialog. The default\n               value is \"Select\". \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2B\"></a><pre><em class=\"codeEmphasisStrong\">showHidden:&lt;</em>boolean<em class=\"codeEmphasisStrong\">&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35CF\"></a>Controls whether hidden and frozen objects are eligible for display. The default value\n               is <span class=\"code\"> <em class=\"strong\">false</em> </span>. This option was broken in versions prior to <em class=\"strong\">3ds Max 8</em>. Now it works as expected. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2A\"></a><pre><em class=\"codeEmphasisStrong\">single:&lt;</em>boolean<em class=\"codeEmphasisStrong\">&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35CD\"></a>Controls whether single or multiple objects may be selected in the selector. The default\n               is <span class=\"code\"> <em class=\"strong\">false</em> </span>, meaning multiple objects may be selected, and they are returned in an array. If\n               <span class=\"code\"> <em class=\"strong\">single:true</em> </span> is specified, a single object may be selected and is returned directly, not in an\n               array. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D29\"></a><pre><em class=\"codeEmphasisStrong\">filter:&lt;</em>fn<em class=\"codeEmphasisStrong\">&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35CB\"></a>Lets you specify a filter function that determines which objects should be displayed\n               in the list. This is similar to the filter functions elsewhere in MAXScript. The function\n               you supply should take one argument, which the current object being tested for inclusion\n               and the function should return <span class=\"code\"> <em class=\"strong\">true</em> </span> for include, <span class=\"code\"> <em class=\"strong\">false</em> </span> for exclude. If you don\'t specify a filter, all objects are displayed. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35CA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35C9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35C8\"></a><p class=\"table-body\">the following function limits the choices to shape objects: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D28\"></a><pre>\nfn shape_filt obj = isKindOf obj Shape\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35C4\"></a><p class=\"table-body\">Then you can call the Select By Name function to select multiple shapes including\n                           hidden ones: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D27\"></a><pre>\ntheShapes =selectByName title:\"Select Shapes\" buttonText:\"GET \'EM!\" filter:shape_filt showHidden:true single:false\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35C0\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35BE\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-51EA45D0-8330-419B-9E06-336D4253A7A2-low.gif\"></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35BB\"></a>If the user cancels out of the dialog, the function returns the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35B8\"></a> <span class=\"char_link\"><a href=\"GUID-CB0EBFC3-9360-445B-BCD4-5F5B2031579F.htm\">Picking Scene Nodes By Hit</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35B7\"></a> <span class=\"char_link\"><a href=\"GUID-927A47B2-9749-4E6A-989A-55EFA06FDFD9.htm\">Picking Scene Nodes By Region</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35B6\"></a> <span class=\"char_link\"><a href=\"GUID-42CD0531-6BD1-4489-B5A0-C001F4EE577B.htm\">Picking Points in the Viewports</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";