var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"unDisplay()\">\n      <meta name=\"indexterm\" content=\"silentMode()\">\n      <meta name=\"indexterm\" content=\"setSilentMode()\">\n      <meta name=\"indexterm\" content=\"setPixels()\">\n      <meta name=\"indexterm\" content=\"setIndexedPixels()\">\n      <meta name=\"indexterm\" content=\"selectSaveBitMap()\">\n      <meta name=\"indexterm\" content=\"selectBitMap()\">\n      <meta name=\"indexterm\" content=\"save()\">\n      <meta name=\"indexterm\" content=\"openBitMap()\">\n      <meta name=\"indexterm\" content=\"gotoFrame()\">\n      <meta name=\"indexterm\" content=\"getPixels()\">\n      <meta name=\"indexterm\" content=\"getIndexedPixels()\">\n      <meta name=\"indexterm\" content=\"getChannelAsMask()\">\n      <meta name=\"indexterm\" content=\"getChannel()\">\n      <meta name=\"indexterm\" content=\"freeSceneBitmaps()\">\n      <meta name=\"indexterm\" content=\"display()\">\n      <meta name=\"indexterm\" content=\"close()\">\n      <meta name=\"indexterm\" content=\"bitmap: values\">\n      <meta name=\"indexterm\" content=\"Bitmap Value Methods\">\n      <meta name=\"indexterm\" content=\"free()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"compareBitmaps()\">\n      <meta name=\"indexterm\" content=\"pasteBitmap()\">\n      <meta name=\"indexterm\" content=\"getBitmapInfo()\">\n      <meta name=\"indexterm\" content=\"getBitmapSaveFileName()\">\n      <meta name=\"indexterm\" content=\"getBitmapOpenFileName()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Bitmap Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304\"></a><div class=\"head\">\n            <h1>Bitmap Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E79\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E78\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span>&gt; Bitmap Value \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E76\"></a>The \n            		<em class=\"strong\">Bitmap</em> class provides storage of \n            		<em class=\"strong\">3ds Max</em> bitmaps and low-level access to them. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E75\"></a>Bitmaps can be temporary objects that are resident only in memory, or they can be\n            associated with a file on the disk. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E74\"></a>Those bitmaps associated with files have a non-null \n            		<span class=\"code\"> <em class=\"strong\">.fileName</em> </span> property and are either load-only or save-only, but not both (this is with respect\n            to file I/O; all bitmaps in memory can have their pixels modified by the \n            		<span class=\"code\"> <em class=\"strong\">setPixel()</em> </span> functions). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E73\"></a>You can make load-only bitmaps with the \n            		<span class=\"code\"> <em class=\"strong\">openBitmap()</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">selectBitmap()</em> </span> functions. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E72\"></a>You can make temporary or save-only bitmaps with the \n            		<span class=\"code\"> <em class=\"strong\">bitmap()</em> </span> constructor, or with the<span class=\"code\"> <em class=\"strong\">render()</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">copy()</em> </span>, or \n            		<span class=\"code\"> <em class=\"strong\">getChannelAsMask()</em> </span> functions. To make them savable, they must have a valid file name, supplied either\n            on the constructor with a \n            		<span class=\"code\"> <em class=\"strong\">fileName:</em> </span> parameter or by setting the \n            		<span class=\"code\"> <em class=\"strong\">.fileName</em> </span> property. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E71\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5588\"></a><pre><em class=\"codeEmphasisStrong\">bitmap</em> &lt;width &lt;height&gt; [<em class=\"codeEmphasisStrong\">filename</em>:&lt;filename_string&gt;] \\ \n[<em class=\"codeEmphasisStrong\">numframes</em>:&lt;integer&gt;] \\\n[<em class=\"codeEmphasisStrong\">color</em>:&lt;color&gt;] \\ \n[<em class=\"codeEmphasisStrong\">gamma</em>:&lt;float&gt;] \\ \n[<em class=\"codeEmphasisStrong\">pixelAspect</em>:&lt;float&gt;] \\ \n[<em class=\"codeEmphasisStrong\">channels</em>:&lt;channel_name array&gt;]\\ \n[<em class=\"codeEmphasisStrong\">hdr</em>:&lt;bool&gt;] \\\n[<em class=\"codeEmphasisStrong\">iconName</em>:&lt;filename&gt;]\\\n[<em class=\"codeEmphasisStrong\">iconSize</em>:&lt;point2&gt;]\n	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E69\"></a>Creates an empty bitmap. The bitmap value returned is a savable bitmap. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E68\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">filename:</em> </span> parameter allows you to set the name of the file in which the bitmap will be saved\n            using the \n            		<span class=\"code\"> <em class=\"strong\">save</em> </span> method. Specifying an existing bitmap file name does not load the contents of the\n            bitmap file into the bitmap value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E67\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">numframes:</em> </span> parameter allows you to create a multi-frame bitmap. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E66\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">color:</em> </span> parameter allows you to set the initial color of all pixels in the bitmap. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E65\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E64\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5587\"></a><pre>\nb = bitmap 320 240 color:white\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E5F\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">gamma:</em> </span> parameter allows you to set the gamma for the newly created bitmap. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E5E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E5D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5586\"></a><pre>\nb = bitmap 320 240 gamma:1.9\nrender camera:c to:b\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E58\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">pixelAspect:</em> </span> parameter allows you to set the pixel aspect for the newly created bitmap. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E55\"></a>Once created, it is \n                  		  <em class=\"strong\">not</em> possible to change the gamma or pixel aspect of a bitmap, though you can copy one\n                  bitmap into a newly created one that has a different gamma or pixel aspect to achieve\n                  this effect. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E53\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">channels:</em> </span> parameter lets you specify the channels to be created. It is also available as a\n            property. For a list of valid names, see the \n            		<span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm#WS73099CC142F487553098682E12AC2FC2BC7-5ECD\">getChannel</a></span> method documentation. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E52\"></a>When the optional \n            		<em class=\"strong\">hdr:</em> parameter introduced in \n            		<em class=\"strong\">3ds Max 8</em> is set to true, the constructor creates a 32 bit per channel bitmap value instead\n            of an 8 bit per channel bitmap value. \n            	 \n         </p>\n         <p> The \n            		<span class=\"code\"> <em class=\"strong\">iconName:</em> </span> parameter allows you to specify an icon file to load. The \n            		<span class=\"code\"> <em class=\"strong\">iconSize:</em> </span> parameter specifies the icon\'s size at 100% DPI scaling.\n            	 \n         </p>\n         <p><a name=\"P_03300B6BD5DA40809B91999B09046DA0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5585\"></a><pre><em class=\"codeEmphasisStrong\">openBitMap</em> &lt;filename_string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E50\"></a>Returns a bitmap value containing the contents of the specified bitmap file. The bitmap\n            value returned is a load-only bitmap. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E4F\"></a>If the specified bitmap file does not exist, a runtime error is generated in \n            		<em class=\"strong\">3ds Max 9 and earlier</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E4E\"></a>If the specified bitmap does not exist, a value of \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_A6E2E611893D4C90A7A0AA27E229A352\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5584\"></a><pre><em class=\"codeEmphasisStrong\">selectBitMap</em> [<em class=\"codeEmphasisStrong\">caption</em>:&lt;open_dialog_title_string&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E4B\"></a>This method displays an Image Input selection browser for the user to select a bitmap\n            file. Returns a bitmap value containing the contents of the selected bitmap file,\n            or the value<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the user presses \n            		<em class=\"strong\">Cancel</em> in the browser. The bitmap value returned is a load-only bitmap. \n            	 \n         </p>\n         <p><a name=\"P_50BBB55808444B9186FAD682E5717FE4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5583\"></a><pre>&lt;bitmap&gt;<em class=\"codeEmphasisStrong\">copy</em> &lt;bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E48\"></a>Copies an existing bitmap, creating an unique instance of the bitmap. \n            	 \n         </p>\n         <p><a name=\"P_9B5B3C4B1E6B4A4CA0D0C166BDA30207\"></a>If the source bitmap is load-only, the bitmap value returned is a temporary bitmap\n            value with a null filename and just one frame. \n            	 \n         </p>\n         <p><a name=\"P_F35E828A68B04FDB91F47FBB8D8B9A02\"></a>If the source is a multi-frame file, it snaps the current frame into the new copy,\n            which becomes frame 0. \n            	 \n         </p>\n         <p><a name=\"P_1B5BEDD10F1A47AEA4A29D82E7B9B282\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E47\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5582\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">filename</em> : String </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E45\"></a>Lets you get or set the file name associated with the bitmap. \n            	 \n         </p>\n         <p><a name=\"P_C8BE0258E84741999A5E1768C610CBA1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5581\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">palette</em> : Array </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E42\"></a>Yields an array of 256 colors (a bug in the current \n            		<em class=\"strong\">3ds Max</em> SDK prevents working with paletted files of other than 256 entries). Take care accessing\n            this array with color indexes retrieved by the \n            		<span class=\"code\"> <em class=\"strong\">getIndexedPixels()</em> </span> function described below because these indexes are 0-based and MAXScript array indexes\n            are 1-based. Yields \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the bitmap is not paletted. Currently, you cannot create a paletted bitmap in\n            MAXScript. However, you can read and write to a pre-existing paletted bitmap. \n            	 \n         </p>\n         <p><a name=\"P_5B3B1EA3DE324EA0AB3035E6181F36CC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5580\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">frame</em> : Integer </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E3F\"></a>Get and set the current frame number in a multi-frame file. Setting this property\n            is permitted only on load-only bitmaps. The frame number is 0-based for inherently\n            multi-frame files such as, .avi and .mov. \n            	 \n         </p>\n         <p><a name=\"P_E2C3320B1796490BA6393EC2B9885C12\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557F\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">numframes</em> : Integer </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E3C\"></a>The number of frames in a multi-frame file, yields 1 for a single image file. \n            	 \n         </p>\n         <p><a name=\"P_991B3C5317FE418A9302FF4705B3C60F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557E\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">height</em> : Integer, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E3A\"></a>Returns bitmap\'s height in pixels. \n            	 \n         </p>\n         <p><a name=\"P_9CDA785452D449ACB70CD998DC8E5B0A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557D\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">width</em> : Integer, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E37\"></a>Returns bitmap\'s width in pixels. \n            	 \n         </p>\n         <p><a name=\"P_C381C8268CFC41048A7E53E41C560ECD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557C\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">gamma</em> : Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E34\"></a>Get and set the gamma value of the bitmap. \n            	 \n         </p>\n         <p><a name=\"P_2833038D52A34DB4BF9E69E095C8AFFF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">inputGamma</em> : {<em class=\"codeEmphasisStrong\">#auto</em> | <em class=\"codeEmphasisStrong\">#default</em> | Float}</pre></div>\n         <p><a name=\"GUID-C8A33127-A846-43E2-8EFB-52C1682A3A62\"></a>Returns the input gamma mode of the bitmap. \n            	 \n         </p>\n         <p><a name=\"GUID-A48218DF-4216-4033-B0C3-284972FFC82E\"></a>This value reflects the Gamma mode that was set when a bitmap value was loaded from\n            an image file. \n            	 \n         </p>\n         <p><a name=\"GUID-E7B89570-5FB1-401A-B36D-1F3BDD76FC07\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80.htm\">Bitmap Gamma and MAXScript</a></span> for details. \n            	 \n         </p>\n         <p><a name=\"GUID-80646A9D-6538-460A-9174-7C558B02B18F\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014</em> and higher. \n            	 \n         </p>\n         <p><a name=\"GUID-EC801580-4CA5-4598-8391-73ADCB9E3718\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">inputGammaValue</em> : Float</pre></div>\n         <p><a name=\"GUID-0D088516-6AFE-4330-87C4-70DA44CD01AA\"></a> Returns the actual input gamma value of the bitmap. \n            	 \n         </p>\n         <p><a name=\"GUID-D862BE85-C6C0-469F-9F76-1B08B24B0444\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80.htm\">Bitmap Gamma and MAXScript</a></span> for details. \n            	 \n         </p>\n         <p><a name=\"GUID-23802EE9-9B62-421E-868D-E836F1659865\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014</em> and higher. \n            	 \n         </p>\n         <p><a name=\"GUID-29076B01-1642-41B3-A27E-53EBF86B15CA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557B\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">aspect</em> : Float, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E31\"></a>Returns the bitmap\'s pixel aspect. Note that this is the aspect of the pixel, not\n            the aspect of the bitmap image. \n            	 \n         </p>\n         <p><a name=\"P_0BBC51D3232142C08E268B2A42A31B6A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-557A\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">channels</em> : Array </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E2E\"></a>This property lets you get and set the bitmap channels available in the bitmap. For\n            a list of valid names, see the \n            		<span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm#WS73099CC142F487553098682E12AC2FC2BC7-5ECD\">getChannel</a></span> method documentation. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E2D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E2C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5579\"></a><pre>\nb = bitmap 100 100 channels:#(#weight)\n--&gt; BitMap:\nb.channels\n--&gt; #(#weight)\nb.channels = #(#zDepth)\n--&gt; #(#zDepth)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_0C18FD4AC6B64D23BFD64FD876C9E304\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED7\"></a><pre>&lt;bitmap&gt;.<em class=\"codeEmphasisStrong\">hasAlpha</em> : Boolean, read-only </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E21\"></a>This property contains true if the bitmap has an alpha channel and false if it does\n            not. \n            	 \n         </p>\n         <p><a name=\"P_E6E5F00481DD42CBB11A87C1721D3B38\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-67DB\"></a>  <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED6\"></a><pre><em class=\"codeEmphasisStrong\">display</em> &lt;bitmap&gt; <em class=\"codeEmphasisStrong\">caption:</em>&lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E1E\"></a>Opens a virtual frame buffer (VFB) displaying the image. \n            	 \n         </p>\n         <p><a name=\"GUID-766CFABA-1E84-4719-962B-64BD9E17F112\"></a>Changes to the bitmap are not automatically displayed to the VFB. \n            	 \n         </p>\n         <p><a name=\"GUID-A4104501-1512-4909-993A-9F2537C3D3A9\"></a>To update the VFB, you need to call this function again. \n            	 \n         </p>\n         <p><a name=\"GUID-B2AA399D-5991-4D22-A7D6-868F74C68445\"></a>Setting the \n            		<span class=\"code\"> <em class=\"strong\">frame</em> </span> property of the bitmap value updates the VFB. \n            	 \n         </p>\n         <p><a name=\"GUID-7133357C-5776-42B1-82AE-BB777259F186\"></a>Each bitmap has its own VFB (if you display two different bitmaps, two VFBs will be\n            displayed). \n            	 \n         </p>\n         <p><a name=\"GUID-FBCA9C81-624C-489D-8DF5-2830F1C04349\"></a>Since \n            		<em class=\"strong\">3ds Max 2015</em>, if the optional keyword argument \n            		<span class=\"code\"> <em class=\"strong\">caption:</em> </span> is specified as string, it will be displayed as the caption in the title bar of the\n            VFB. \n            	 \n         </p>\n         <p><a name=\"P_92486335E4FC442083AFE5DACD59B3BA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED5\"></a><pre><em class=\"codeEmphasisStrong\">unDisplay</em> &lt;bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E1B\"></a>Close the VFB associated with the bitmap if open. \n            	 \n         </p>\n         <p><a name=\"P_D6E9476F12C64D9FB80200CEBA3BF3ED\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED4\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">save</em> &lt;bitmap&gt; [<em class=\"codeEmphasisStrong\">frame</em>:&lt;integer&gt;] [<em class=\"codeEmphasisStrong\">gamma</em>:{<em class=\"codeEmphasisStrong\">#auto</em>|<em class=\"codeEmphasisStrong\">#default</em>|&lt;float&gt;}] [<em class=\"codeEmphasisStrong\">quiet</em>:&lt;bool&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E18\"></a>Saves the current state of the bitmap. Make sure that the file name is set first.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-890D9C63-B08C-4794-8625-15BAA6E36A56\"></a>When saving multi-frame image files, the effect of the \n            		<span class=\"code\"> <em class=\"strong\">frame:</em> </span> keyword parameter is different depending on the type of output file. \n            	 \n         </p>\n         <p><a name=\"GUID-138804AB-AC73-4ECC-8A56-180F7920A001\"></a>Inherently multi-frame files such as, .avi and .mov ignore the \n            		<span class=\"code\"> <em class=\"strong\">frame:</em> </span> parameter and always write to the next output file frame in sequence on each \n            		<span class=\"code\"> <em class=\"strong\">save()</em> </span>. You cannot randomly write frames or rewrite frames that are already saved. \n            	 \n         </p>\n         <p><a name=\"GUID-FF1A871E-259F-4333-BDEB-B13BC4CCD8A3\"></a>Saving image sequences (such as, .bmp, .jpg, and .tga) requires supplying the \n            		<span class=\"code\"> <em class=\"strong\">frame:</em> </span> parameter and causes the frame number to be appended to the output file name for\n            each frame saved. This effectively generates a sequence of image files suitable for\n            building an IFL. \n            	 \n         </p>\n         <p><a name=\"GUID-F8C4F734-982D-4FB4-A43B-7C98CD800531\"></a>The output file remains open until you call \n            		<span class=\"code\"> <em class=\"strong\">close</em> </span> on the bitmap. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E17\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">save()</em> </span> function can only be called on a savable bitmap. You will get a runtime error if\n            you attempt to save a bitmap opened with \n            		<span class=\"code\"> <em class=\"strong\">openBitmap()</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">selectBitmap()</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-D61C062E-8C62-4A7F-8449-D8E2A3ABF556\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">gamma:</em> </span> keyword parameter can be used in \n            		<em class=\"strong\">3ds Max 2014 and higher</em> to set the Gamma mode or Gamma Override value: \n            	 \n         </p><a name=\"UL_468E10E860DE4FD8B00FBEE13C1A1DC4\"></a><ul>\n            <li><span class=\"code\"> <em class=\"strong\">#auto</em> </span> is the new, intelligent mode. It uses the file information when present, or intelligently\n               chooses gamma based on whether the file is Floating point or not. This is the default\n               behavior. \n               		\n            </li>\n            <li><span class=\"code\"> <em class=\"strong\">#default</em> </span> is actually the \n               		  <em class=\"strong\">old legacy mode</em> which only exists for backwards compatibility. \n               		\n            </li>\n            <li>If set to a floating point value, the Gamma will be overridden by that value. \n               		\n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E16\"></a>For details on the \n            		<span class=\"code\"> <em class=\"strong\">quiet:</em> </span> option that was added to this method in \n            		<em class=\"strong\">3ds Max 8</em>, please see \n            		<span class=\"char_link\"><a href=\"GUID-A1FFEDE0-9B92-4CD5-8127-76AA393D5143.htm\">Quiet Mode</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E15\"></a>The method will return True on success or False if the saving failed (for example,\n            if attempting to overwrite an existing read-only file) in \n            		<em class=\"strong\">3ds Max 8 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_FF19173A62C84D45B4F94CEE3EBACF2F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED3\"></a><pre><em class=\"codeEmphasisStrong\">close</em> &lt;bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E13\"></a>Closes the bitmap file associated with the bitmap if it is open for output. A bitmap\n            file is opened for output when you call \n            		<span class=\"code\"> <em class=\"strong\">save</em> </span> on the bitmap value the first time. If a Virtual Frame Buffer (Rendered Frame Window)\n            associated with the bitmap is open, it will be closed. This function also frees all\n            memory allocated by the bitmap, including the internal pixel frame buffer. If you\n            are generating many bitmaps, say in a rendering loop, you can use the \n            		<span class=\"code\"> <em class=\"strong\">close()</em> </span> function to free these large amounts of memory, which is otherwise not released until\n            the next garbage collection. \n            	 \n         </p>\n         <p><a name=\"P_762E62E02ED046018B4978F0E94BA3D1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEB\"></a><pre><em class=\"codeEmphasisStrong\">free</em> &lt;bitmap&gt;</pre></div>\n         <p><a name=\"P_E6BEEA05E1FB4E0DAF89D080FDD8A3BD\"></a>Frees the memory used by the bitmap value without waiting for garbage collection.\n            \n            	 \n         </p>\n         <p><a name=\"P_39FEC8F5717B454E99C1C31F9A85D04E\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_BA4040974D7046A48FEB1E21953280F0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_0B5D322B08284CB69AEC2C0092FE2462\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED2\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;source_bitmap&gt; &lt;dest_bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E10\"></a>Copies the source bitmap to the destination bitmap. If the size of the two bitmaps\n            is different, the image will be scaled to fit the destination bitmap. \n         </p>\n         <p><a name=\"P_6914A47CFD524609AA6DB67C38016D52\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED1\"></a><pre><em class=\"codeEmphasisStrong\">gotoFrame</em> &lt;bitmap&gt; &lt;frame&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E0E\"></a>Position multi-frame file (avi, flc, and so on) to frame \n            		<span class=\"code\"> <em class=\"strong\">frame</em> </span>. This method is permitted only on load-only bitmaps. The frame number is 0-based\n            for inherently multi-frame files such as, .avi and .mov. Updates VFB if open. \n            	 \n         </p>\n         <p><a name=\"P_0EC793A88EED40368BD1BB429EA8700F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ED0\"></a><pre><em class=\"codeEmphasisStrong\">getPixels</em> &lt;bitmap&gt; &lt;coord_point2&gt; &lt;num_pixels&gt; <em class=\"codeEmphasisStrong\">linear:</em>&lt;bool&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E0B\"></a>Retrieve a sequence of pixels from a row in the bitmap as an array of color values.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-06CFEEDB-91BE-428D-AD3A-1300B1767E12\"></a>The coord_point2 argument specifies the starting pixel coordinate with [0,0] at the\n            top-left-hand pixel. \n            	 \n         </p>\n         <p><a name=\"GUID-97DECA29-6598-4BD5-8C2D-AC73CBF22678\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">.x</em> </span> component of the Point2 coordinate is the column, and the \n            		<span class=\"code\"> <em class=\"strong\">.y</em> </span> component is the row. \n            	 \n         </p>\n         <p><a name=\"GUID-6A075F96-A4B5-4653-8C05-1649A696121C\"></a>The sequence must come from one row only. You cannot retrieve a sequence of pixels\n            that spans multiple rows. \n            	 \n         </p>\n         <p><a name=\"GUID-B56F7E21-E9A4-40E4-9038-A428A67E1177\"></a>Using any out of-bounds coordinates or retrieving over row boundaries will fail and\n            yield an empty array. \n            	 \n         </p>\n         <p><a name=\"GUID-827831BF-4E9F-4A6E-B682-1070F6FAF004\"></a> The optional \n            		<span class=\"code\"> <em class=\"strong\">linear:</em> </span> keyword parameter introduced in \n            		<em class=\"strong\">3ds Max 2014</em> can be set to True to access linear values with Gamma of 1.0, or False to access\n            raw data (default, old behavior prior to \n            		<em class=\"strong\">3ds Max 2014</em>). \n            	 \n         </p>\n         <p><a name=\"P_F6E8346B97B44E2788B54B3EDC614AF7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ECF\"></a><pre><em class=\"codeEmphasisStrong\">setPixels</em> &lt;bitmap&gt; &lt;coord_point2&gt; &lt;color_value_array&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E08\"></a>Sets the sequence of pixels in a row in the bitmap starting at the Point2 coordinate\n            to the values in the given array. The \n            		<span class=\"code\"> <em class=\"strong\">.x</em> </span> component of the Point2 coordinate is the column and the \n            		<span class=\"code\"> <em class=\"strong\">.y</em> </span> component is the row. The number of pixels to set is taken from the size of the array.\n            As with \n            		<span class=\"code\"> <em class=\"strong\">getPixels()</em> </span>, you cannot set pixel sequences across a row boundary. \n            	 \n         </p>\n         <p><a name=\"P_E91C278C81004439B53C54D16017A779\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ECE\"></a><pre><em class=\"codeEmphasisStrong\">getIndexedPixels</em> &lt;bitmap&gt; &lt;coord_point2&gt; &lt;num_pixels&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E06\"></a>Retrieve a row of pixels as an array of palette index numbers. The coord_point2 argument\n            specifies the starting pixel coordinate with 0,0 at the top-left-hand pixel. The index\n            numbers are origin 0. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E03\"></a>This is in keeping with indexed color conventions, but \n                  		  <em class=\"strong\">not</em> MAXScript\'s. Take care accessing any retrieved palette array using these numbers\n                  because the retrieved palette is returned as a MAXScript array and these arrays use\n                  1-based indexes. You cannot get pixels sequences that cross row boundaries. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"P_C1BFBF165FB848D3AB502CAF297D43A0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5578\"></a><pre><em class=\"codeEmphasisStrong\">setIndexedPixels</em> &lt;bitmap&gt; &lt;coord_point2&gt; &lt;number_array&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7E00\"></a>Sets the row of pixels starting at the Point2 coordinate to the color indexes in the\n            given array. The number of pixels to set is taken from the size of the array. The\n            color indexes are zero-based. You cannot set pixels sequences that cross row boundaries.\n            \n            	 \n         </p>\n         <p><a name=\"P_629BBEF3EF3747278ADD9BA26B3902E2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ECD\"></a><pre><em class=\"codeEmphasisStrong\">getChannel</em> &lt;bitmap&gt; &lt;coord_point2&gt; &lt;chan_name&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DFD\"></a>Retrieves the g-buffer channel data for the named channel for the pixel specified\n            by 2D coordinate. The \n            		<span class=\"code\"> <em class=\"strong\">chan_name</em> </span> argument specifies the channel identifier, chosen from the following: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5577\"></a><pre><em class=\"codeEmphasisStrong\">#zDepth \n#matID\n#objectID \n#UVCoords \n#normal \n#unClamped \n#coverage \n#node \n#mask \n#shaderColor \n#shaderTransparency \n#velocity \n#weight</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DEF\"></a>If the bitmap contains the requested channel, the returned value is always an array\n            of values, one for each layer present in the channel at that pixel, ordered from front\n            to back. If the bitmap does not contain the requested channel, the function returns\n            the value \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. Typically, you get bitmaps containing channels by opening .rla files or using the\n            MAXScript \n            		<span class=\"code\"> <em class=\"strong\">render()</em> </span> function with the \n            		<span class=\"code\"> <em class=\"strong\">channels:</em> </span> parameter supplied. You will get multiple values in the array if the front objects\n            have any transparency. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DEE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DED\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ECB\"></a><pre>\ngetChannel bm [x,y] #zDepth\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DE9\"></a><p class=\"table-body\">might return: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5ECA\"></a><pre>\n#(-354.413, -354.467, -355.271, -1e+030)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DE5\"></a><p class=\"table-body\">indicating there is a front surface with non-zero transparency at depth -354.413,\n                        another at -354.467, and a final one at -355.271. The -1e+30 value represents the\n                        background image plane. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DE4\"></a><p class=\"table-body\">You can retrieve the \n                        					 <span class=\"code\"> <em class=\"strong\">#node</em> </span> channel (if it was generated) to get the actual scene objects at those depths, \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC9\"></a><pre>\ngetChannel bm [x,y] #node\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DE0\"></a><p class=\"table-body\">might return: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC8\"></a><pre>\n#($Sphere:Sphere02 @ [-4.7,24.3,0.0], $Sphere:Sphere02 @ [-4.7,24.3,0.0],$Sphere:Sphere01 @ [-8.3,56.2,5.7])\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DDB\"></a>The type of values returned in the array depend on the channel, as follows: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5576\"></a><pre><em class=\"codeEmphasisStrong\">#zDepth</em>: &lt;float&gt; \n<em class=\"codeEmphasisStrong\">#matID</em>: &lt;integer&gt; \n<em class=\"codeEmphasisStrong\">#objectID</em>: &lt;integer&gt; \n<em class=\"codeEmphasisStrong\">#UVCoords</em>: &lt;point2&gt; \n<em class=\"codeEmphasisStrong\">#normal</em>: &lt;point3&gt; \n<em class=\"codeEmphasisStrong\">#unClamped</em>: &lt;color&gt; \n<em class=\"codeEmphasisStrong\">#coverage</em>: &lt;float&gt; \n<em class=\"codeEmphasisStrong\">#node</em>: &lt;node&gt; \n<em class=\"codeEmphasisStrong\">#shaderColor</em>: &lt;color&gt; \n<em class=\"codeEmphasisStrong\">#shaderTransparency</em>: &lt;color&gt; \n<em class=\"codeEmphasisStrong\">#velocity</em>: &lt;point2&gt; \n<em class=\"codeEmphasisStrong\">#weight</em>: &lt;color&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DCE\"></a>See the \n            		<em class=\"strong\">3ds Max</em> Software Development Kit Help file for information on the data stored in the g-buffer\n            channels. \n            	 \n         </p>\n         <p><a name=\"P_3AF09CB05EF74CC28649583669E8E428\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC6\"></a><pre><em class=\"codeEmphasisStrong\">getChannelAsMask</em>&lt;bitmap&gt; &lt;chan_name&gt; [<em class=\"codeEmphasisStrong\">to</em>:&lt;bitmap&gt;] \\ \n[<em class=\"codeEmphasisStrong\">fileName</em>:\"filename_string\"] [<em class=\"codeEmphasisStrong\">pixelAspect</em>:&lt;float&gt;] \\ \n[<em class=\"codeEmphasisStrong\">gamma</em>:&lt;float&gt;] [<em class=\"codeEmphasisStrong\">layer</em>:&lt;integer&gt;] [<em class=\"codeEmphasisStrong\">invert</em>:&lt;boolean&gt;] \\ \n[<em class=\"codeEmphasisStrong\">node</em>:&lt;node&gt; |<em class=\"codeEmphasisStrong\">objectID</em>:&lt;integer&gt; |<em class=\"codeEmphasisStrong\">matID</em>:&lt;integer&gt;] \\ \n[<em class=\"codeEmphasisStrong\">velocity</em>:<em class=\"codeEmphasisStrong\">#angle</em> | <em class=\"codeEmphasisStrong\">#magnitude</em>] | [<em class=\"codeEmphasisStrong\">angle</em>:&lt;float&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DC9\"></a>Builds and returns a separate 8-bit gray-level bitmap suitable for use as a mask in\n            materials, maps, effects, and so on. This bitmap corresponds roughly to the display\n            you see in the visual frame buffer if you select a g-buffer channel to view. In addition,\n            you can cause this mask to be masked itself to a selected node, object ID, or material\n            ID. The parameters are as follows: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC5\"></a><pre>&lt;bitmap&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DC7\"></a>The source bitmap containing the source g-buffer channel data. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC4\"></a><pre>&lt;chan_name&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DC5\"></a>The channel from which to generate a mask. The \n            		<span class=\"code\"> <em class=\"strong\">chan_name</em> </span> values are as described for the \n            		<span class=\"code\"> <em class=\"strong\">getChannel()</em> </span> method. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DC2\"></a>The mask is a single 8 bit value while the channel might be a complex value of some\n                  kind. In each case, a mapping to 8 bits is performed. \n                  		\n               </p> \n               <p><a name=\"P_5622C424ED9144AFB487FC1C3098B97E\"></a>Unless noted differently below, this mapping is the same mapping used by \n                  		  <em class=\"strong\">3ds Max</em> to generate monochrome images in the Virtual Frame Buffer. \n                  		\n               </p> \n            </div>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC3\"></a><pre><em class=\"codeEmphasisStrong\">to</em>:&lt;bitmap&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DBF\"></a>Specifies an existing bitmap to write the mask into. Its width and height must match\n            the source bitmap. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC2\"></a><pre><em class=\"codeEmphasisStrong\">fileName</em>:\"filename_string\" </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DBD\"></a>Specifies the file name associated with the generated bitmap. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC1\"></a><pre><em class=\"codeEmphasisStrong\">gamma</em>:&lt;float&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DBB\"></a>Specifies the generated bitmap\'s gamma value. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EC0\"></a><pre><em class=\"codeEmphasisStrong\">pixelAspect</em>:&lt;float&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DB9\"></a>Specifies the generated bitmap\'s pixel aspect. Note that this is the aspect of the\n            pixel, not the aspect of the bitmap image. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBF\"></a><pre><em class=\"codeEmphasisStrong\">layer</em>: &lt;integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DB7\"></a>Specifies the channel layer of the source bitmap to extract data from. Defaults to\n            1. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBE\"></a><pre><em class=\"codeEmphasisStrong\">invert</em>:&lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DB5\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, inverts the generated bitmap. Defaults to .<span class=\"code\"> <em class=\"strong\">false</em> </span> . \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBD\"></a><pre><em class=\"codeEmphasisStrong\">node</em>:&lt;node&gt; <em class=\"codeEmphasisStrong\">objectID</em>:&lt;integer&gt; <em class=\"codeEmphasisStrong\">matID</em>:&lt;integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DB1\"></a>Specifies a sub-mask. If one of these parameters is supplied, the generated mask is\n            clipped to contain data only in pixels where the given node, objectID, or materialID\n            is visible. To use this sub-masking, you must ensure the \n            		<span class=\"code\"> <em class=\"strong\">#node</em> </span>,<span class=\"code\"> <em class=\"strong\"> #objectID</em> </span>, or \n            		<span class=\"code\"> <em class=\"strong\">#matID</em> </span> channel is present in the source bitmap. Further, if the \n            		<span class=\"code\"> <em class=\"strong\">#coverage</em> </span> channel is present in the source bitmap, the sub-mask is anti-aliased by the coverage\n            data. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBC\"></a><pre><em class=\"codeEmphasisStrong\">velocity</em>:<em class=\"codeEmphasisStrong\">#angle </em>| <em class=\"codeEmphasisStrong\">#magnitude</em> <em class=\"codeEmphasisStrong\">angle</em>:&lt;float&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DAE\"></a>These parameters can only be specified if the selected channel is \n            		<span class=\"code\"> <em class=\"strong\">#velocity</em> </span>. The default \n            		<span class=\"code\"> <em class=\"strong\">velocity</em> </span> parameter value is \n            		<span class=\"code\"> <em class=\"strong\">#magnitude</em> </span>. These parameters control the generated bitmap as follows: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBB\"></a><pre><em class=\"codeEmphasisStrong\">velocity</em>:<em class=\"codeEmphasisStrong\">#angle</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DAC\"></a>Generated bitmap pixel values are proportional to angle of pixel movement direction\n            with an angle of direction of 0 degrees (horizontal to the right) mapping to a luminance\n            value of 0, 180 degrees mapping to a luminance value of 127, and 360 degrees mapping\n            to a luminance value of 255. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EBA\"></a><pre><em class=\"codeEmphasisStrong\">velocity</em>:<em class=\"codeEmphasisStrong\">#magnitude </em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DAA\"></a>Generated bitmap pixel values are proportional to velocity magnitude. High velocities\n            are darker than low velocities. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB9\"></a><pre><em class=\"codeEmphasisStrong\">angle</em>:&lt;float&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA8\"></a>Generated bitmap pixel values are proportional to movement direction deviation from\n            the given angle with a luminance value of 255 at the exact angle and falling off to\n            a luminance value of 0 at 10 degrees from the specified angle. The specified angle\n            is relative to 0 being horizontal to the right. \n            	 \n         </p>\n         <p><a name=\"P_569EC423ABE849CD9817422A25F716FC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB8\"></a><pre><em class=\"codeEmphasisStrong\">CompareBitmaps</em> {&lt;filename&gt;File1 | &lt;bitmap&gt;bitmap1} {&lt;filename&gt;File2 | &lt;bitmap&gt;bitmap2}\\ \n&lt;int&gt;tolerance(# different pixels) &lt;int&gt;variation(0-255)\\\n<em class=\"codeEmphasisStrong\">useAlpha</em>:&lt;boolean&gt;<em class=\"codeEmphasisStrong\">errorMsg</em>:&lt;&amp;string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA5\"></a>In \n            		<em class=\"strong\">3ds Max 9</em> and higher, returns true if the bitmaps compare as the same, false if not. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA4\"></a>More than\'tolerance\' number of pixels must be different before the comparison fails.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA3\"></a>Two pixels are considered the same if the difference in each component value is less\n            than or equal to \'variation\'. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA2\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">useAlpha</em> </span> is true, the alpha component value is also tested. If false (the default), the alpha\n            component is not tested. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA1\"></a>If specified, the \n            		<span class=\"code\"> <em class=\"strong\">errorMsg</em> </span> keyword variable (passed by reference) will contain an error message. \n            	 \n         </p>\n         <p><a name=\"P_14025945FB9D4C34B99EDF96FBEE8CDC\"></a>The potential messages are: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7DA0\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D9E\"></a>\"Passed.\" \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D9C\"></a>\"Different Pixels: #\" (where # is the number of pixels that are different) \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D9A\"></a>\"One or both Bitmaps not found\" \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D98\"></a>\"Bitmaps have different sizes\" \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"P_FCCB9D3A03CD47B788253ADD8EC7518E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB7\"></a><pre><em class=\"codeEmphasisStrong\">pasteBitmap</em> &lt;src_bitmap&gt; &lt;dest_bitmap&gt; (&lt;src_box2&gt; | &lt;src_point2&gt;) &lt;dest_point2&gt; \\\n[<em class=\"codeEmphasisStrong\">maskColor</em>:&lt;color&gt;<em class=\"codeEmphasisStrong\">type</em>:{<em class=\"codeEmphasisStrong\">#paste</em>|<em class=\"codeEmphasisStrong\">#composite</em>|<em class=\"codeEmphasisStrong\">#blend</em>|<em class=\"codeEmphasisStrong\">#function</em>}] \\\n[<em class=\"codeEmphasisStrong\">function</em>:&lt;composite_fn&gt;] [<em class=\"codeEmphasisStrong\">alphaMultiplier</em>:&lt;float&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D95\"></a>Copies a block of pixels from the source bitmap to the destination bitmap. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D94\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D93\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D91\"></a>The position of the source block is specified by src_box2 or src_point2, and the destination\n                  by dest_point2. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D8F\"></a>The width and height of the block is specifed by src_box2 or, if src_point2 is specified,\n                  by the remaining size of the source bitmap. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D8D\"></a>The width and height will be clamped to prevent either source or target overruns.\n                  \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D8B\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">maskColor:</em> </span> is supplied, pixels with this color in src_bitmap are not copied to dest_bitmap.\n                  \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D89\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">type:</em> </span> is \n                  			 <span class=\"code\"> <em class=\"strong\">#paste</em> </span> (the default), the source is pasted on the destination ignoring all alpha. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D87\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">type:</em> </span> is \n                  			 <span class=\"code\"> <em class=\"strong\">#composite</em> </span>, the source alpha of the source is used:<span class=\"code\"> <em class=\"strong\">clamp (R = S + D * (1-S.alpha))</em> </span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D85\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">type:</em> </span> is \n                  			 <span class=\"code\"> <em class=\"strong\">#blend</em> </span>, the source alpha of the source is used: \n                  			 <span class=\"code\"> <em class=\"strong\">R = S * S.alpha + D * (1-S.alpha)</em> </span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D83\"></a>For both \n                  			 <span class=\"code\"> <em class=\"strong\">type:#composite</em> </span> and \n                  			 <span class=\"code\"> <em class=\"strong\">type:#blend</em> </span>, \n                  			 <span class=\"code\"> <em class=\"strong\">R.alpha = S.alpha + D.alpha * (1-S.alpha)</em> </span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D81\"></a>The \n                  			 <span class=\"code\"> <em class=\"strong\">type:#composite</em> </span> is typically used for pre-multiplied alpha images. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D7F\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">type:</em> </span> is \n                  			 <span class=\"code\"> <em class=\"strong\">#composite</em> </span> or \n                  			 <span class=\"code\"> <em class=\"strong\">#blend</em> </span>, the source alpha is multiplied by the \n                  			 <span class=\"code\"> <em class=\"strong\">alphaMultiplier:</em> </span> value, which defaults to a value of 1.0 if not supplied. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D7D\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">type:</em> </span> is \n                  			 <span class=\"code\"> <em class=\"strong\">#function</em> </span>, an optional \n                  			 <span class=\"code\"> <em class=\"strong\">function:</em> </span> parameter can specify a user-defined function taking 4 arguments - the source pixel\n                  color, the source pixel location, the second source pixel color, and second source\n                  pixel location. The second source is the destination bitmap. The return result of\n                  the function is stored in the destination bitmap\'s pixel. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D7B\"></a>Only RGBA information is copied - no channel data is copied. \n                  		  \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D79\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D78\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB6\"></a><pre>bm1=bitmap 100 100 color:red \nbm2=bitmap 100 100 color:green \nbm3=bitmap 100 100 color:blue \npasteBitmap bm2 bm1 (box2 0 0 25 50) [50,50] \ndisplay bm1 \npasteBitmap bm1 bm3 [25,25] [25,50] maskColor:green\ndisplay bm3 \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D6E\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D6C\"></a><p class=\"table-body\"> <img src=\"../images/GUID-00558997-9D51-426E-A83E-D26D379EA62F-low.bmp\"> <img src=\"../images/GUID-EBD168FA-3C37-48A5-A1E8-133B9E7E44A0-low.bmp\"> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D6B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D6A\"></a><p class=\"table-body\"> <em class=\"strong\">CUSTOM COMPOSITING EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB5\"></a><pre>\nresetMaxFile #noPrompt--start a new scene\n--Create a teapot and two slightly offset target cameras\ntheTeapot = teapot wirecolor:white segs:10\ntheTarget1 = targetObject pos:[-1,0,10]\ntheCamera1 = TargetCamera pos:[-10,-130,30] target:theTarget1\ntheTarget2 = targetObject pos:[1,0,10]\ntheCamera2 = TargetCamera pos:[10,-130,30] target:theTarget2\n&nbsp;\n--Create two bitmaps to render and process\nb1 = bitmap 320 240\nb2 = bitmap 320 240\n--Render the two cameras into the two bitmaps\nrender camera:theCamera1 to:b1 vfb:off\nrender camera:theCamera2 to:b2 vfb:off\n&nbsp;\n--This is the custom compositing function:\nfn compfn c1 p1 c2 p2 =\n(\nres = c2--the result will contain the G and B of b2\nres.r = c1.r--but the R from b1\nres--then we return the resulting color value\n)\n&nbsp;\n--Perform the compositing using the above function:\npastebitmap b1 b2 [0,0] [0,0] type:#function function:compfn\ndisplay b2\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D4C\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-C4589BE0-DC94-4377-B2ED-2AF47E423C0F-low.gif\"></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D4A\"></a><p class=\"table-body\">This method is typically 3 to 5 times faster than using getPixels/SetPixels in a MAXScript\n                        loop depending on the complexity of the custom function. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D49\"></a><p class=\"table-body\">For an example of modifying a single bitmap using this method, see the third example\n                        in the \n                        					 <span class=\"char_link\"><a href=\"GUID-5ECE930B-32E0-42A7-9344-B9E0A2F73171.htm\">Never get a single pixel when you can get a whole line</a></span> topic of the MAXScript Frequently Asked Questions. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_5A7EEC56DA03414A86411A866B32B47D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB4\"></a><pre><em class=\"codeEmphasisStrong\">getBitmapInfo</em> {&lt;filename&gt; | &lt;bitmap&gt;} </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D44\"></a>Returns information on the specified bitmap file as a 13 element array. Available\n            in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D43\"></a> <em class=\"strong\">Array elements are:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D42\"></a>1. Expanded bitmap file name as String \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D41\"></a>2. Device name as String \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D40\"></a>3. Bitmap width as Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3F\"></a>4. Bitmap height as Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3E\"></a>5. Number of bits for each RGB component value as Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3D\"></a>6. Number of bits for alpha component as Integer. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3C\"></a>7. The aspect ratio of the bitmap as Float \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3B\"></a>8. The gamma of the bitmap as Float \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D3A\"></a>9. Whether the bitmap has alpha as a Boolean \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D39\"></a>10. First frame as Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D38\"></a>11. Last frame as Integer \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D37\"></a>12. The bitmap type (from BitmapInfo::Type()) as Integer. See topic \"Bitmap Types\"\n            in the SDK help file for more info on the bitmap types. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D36\"></a>13. The bitmap flags (from BitmapInfo::Flags()) as Integer. See topic \"Bitmap Flags\"\n            in the SDK help file for more info on the meaning of each bit. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D35\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D34\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB3\"></a><pre>\nprint (getBitmapInfo (getDir #maxroot +\"\\\\maps\\\\OAKLEAF.TGA\"))\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D30\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB2\"></a><pre>\n\"C:\\Program Files\\Autodesk\\3ds Max 2015\\maps\\OAKLEAF.TGA\"\n\"Targa Image File\"\n152\n256\n8\n8\n1.0\n2.2\nfalse\n0\n0\n3\n0\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-1E935425-1583-496E-997F-E4AF70D0AE1B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">forceReloadBitmapFile</em> &lt;bitmap&gt;</pre></div>\n         <p><a name=\"GUID-46D4B297-E9D4-4E7F-9310-CBCB1BD2C79F\"></a>Forces the reloading of the Bitmap File associated with the specified bitmap. \n            	 \n         </p>\n         <p><a name=\"GUID-3FE63C67-6C95-49DD-8BCF-2D229A0A0D04\"></a> Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-3599E18D-C5A0-4166-BE58-17E791F47274\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">registerFileChangedFunction</em> &lt;bitmap&gt; &lt;callback_functions&gt;</pre></div>\n         <p><a name=\"GUID-3F376AB9-ECF1-488F-8A5A-C29656F6CD19\"></a>Registers a File Change Callback Function for the bitmap specified by the first argument.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-F94E6973-D32B-4D9A-BDBC-6FEDB7E180A6\"></a>The second argument must be a MAXScript function expecting one argument. \n            	 \n         </p>\n         <p><a name=\"GUID-B1B2B0CB-2AB3-4931-8E73-137F99CB203F\"></a>Returns True on success, False on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-A66C9D46-8B41-4C58-96FE-D84E6DBF106B\"></a> Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p><a name=\"TABLE_8EDFE224ED214473A46DF26AA6EDE36A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-1FF94FBE-4CEF-4DB2-90CD-4DB1E85DCFBC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>b = bitmap 100 100 --Create a new bitmap value\nb.filename = @\"c:\\temp\\testme.bmp\" --Give it a file name\nsave b --Save it to file\n\n--Now open the file for reading\nb1 = openbitmap @\"c:\\temp\\testme.bmp\"\n\n--Define and register a callback function to monitor bitmap file changes\nfn onFileChanged arg = format \"Bitmap Value File Modified: %\\n\" arg\nregisterFileChangedFunction b1 onFileChanged\n\nsetPixels b [50,50] #(red) --Write a pixel into the original bitmap value...\nsave b --...and save it to disk\n--The change to the file on disk will trigger the callback function!\n--&gt; Bitmap Value File Modified: BitMap:c:\\temp\\testme.bmp\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-C8EBAA2F-0343-42FF-B91F-0B0C6E237D66\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6740\"></a> <em class=\"strong\">Related Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB1\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">setSilentMode</em> &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D1D\"></a>Sets Silent mode on or off. If Silent mode is off, any errors occurring during bitmap\n            input or output will result in an error message dialog being displayed by the \n            		<em class=\"strong\">3ds Max</em> bitmap I/O routines. If Silent mode is on, error message dialogs are not displayed.\n            Returns a boolean signifying the prior Silent mode state. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D1C\"></a>The Silent mode state is an internal \n            		<em class=\"strong\">3ds Max</em> state, and other \n            		<em class=\"strong\">3ds Max</em> plug-ins can turn this state on or off. If you use this method, it is recommended\n            that you turn the state on or off saving the return value, perform the bitmap input\n            or output, and then restore the state to its original value. \n            	 \n         </p>\n         <p><a name=\"P_B91C35D282284C87A6033E8801DDA506\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EB0\"></a><pre><em class=\"codeEmphasisStrong\">silentMode</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D19\"></a>Returns a boolean signifying the Silent mode state. \n            	 \n         </p>\n         <p><a name=\"P_C2E8B5E0AF224354A832FC8495ADAC70\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EAF\"></a><pre><em class=\"codeEmphasisStrong\">selectSaveBitMap</em> [<em class=\"codeEmphasisStrong\">caption</em>:&lt;open_dialog_title_string&gt; ] [<em class=\"codeEmphasisStrong\">gamma:</em>&amp;gama_value] [<em class=\"codeEmphasisStrong\">metadata:</em>&amp;dataArray]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D17\"></a>Displays a \n            		<em class=\"strong\">3ds Max</em> bitmap save dialog and returns the fully-specified file path name as a string. \n            	 \n         </p>\n         <p><a name=\"GUID-3257A558-00A0-425F-9EDD-E6F8A08C69A7\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the user cancels out of the bitmap save dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-7DF601FC-A383-458E-BE19-F1057135CA4D\"></a> If the optional \n            		<span class=\"code\"> <em class=\"strong\">gamma:</em> </span> keyword is provided in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>, the by-reference variable passed as parameter will be set to the gamma mode value:\n            \n            		<span class=\"code\"> <em class=\"strong\">#auto</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">#default</em> </span>, or a Float gamma override value. \n            	 \n         </p>\n         <p><a name=\"GUID-1035FFDA-895F-417E-ADA8-602D841C23EB\"></a> If the optional \n            		<span class=\"code\"> <em class=\"strong\">metadata:</em> </span> keyword is provided in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>, the by-reference variable passed as parameter will be set to the BitmapInfo expressed\n            as an array of values that can be passed to the \n            		<span class=\"code\"> <em class=\"strong\">save()</em> </span> function\'s \n            		<span class=\"code\"> <em class=\"strong\">metadata:</em> </span> optional keyword. See \n            		<span class=\"char_link\"><a href=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80.htm\">Bitmap Gamma and MAXScript</a></span> for details. \n            	 \n         </p><a name=\"TABLE_095BB560BD5847CDB0296FCBB143DD38\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-D55030DC-5701-4C2E-B539-448DFA2E039C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>bitmap.filename = SelectSaveBitmap caption:\"Select a file\" gamma:&amp;gma metadata:&amp;data\nif (bitmap.filename) do save bitmap gamma:gma metadata:data</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_345AEAC8083F48039AAFF9E074EE35A4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EAE\"></a><pre><em class=\"codeEmphasisStrong\">freeSceneBitmaps</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D14\"></a>Frees up all the memory used by the image file bitmap caches. This is useful if memory\n            is fragmented with a lot of different bitmaps and you want to have just the ones currently\n            active reloaded. \n            	 \n         </p>\n         <p><a name=\"P_78422C888BEA42AE9D64A3ED5F152C8E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EAD\"></a><pre><em class=\"codeEmphasisStrong\">getBitmapOpenFileName</em> [<em class=\"codeEmphasisStrong\">caption</em>:&lt;title&gt;] [<em class=\"codeEmphasisStrong\">filename</em>:&lt;seed_filename_string&gt;]  [<em class=\"codeEmphasisStrong\">metadata:</em>&amp;dataArray]\n\n<em class=\"codeEmphasisStrong\">getBitmapSaveFileName</em> [<em class=\"codeEmphasisStrong\">caption</em>:&lt;title&gt;] [<em class=\"codeEmphasisStrong\">filename</em>:&lt;seed_filename_string&gt;] [<em class=\"codeEmphasisStrong\">metadata:</em>&amp;dataArray]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D0E\"></a>Displays the bitmap file selection dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-12A1152F-9392-44DD-8E2D-AA5B9CBBD8C7\"></a>Both functions return a fully-specified file path name or undefined if the user cancels\n            out. \n            	 \n         </p>\n         <p><a name=\"GUID-E5C51283-AE6C-41C9-A18E-1071478F5C13\"></a>If an existing file name is selected using the \n            		<span class=\"code\"> <em class=\"strong\">getBitmapSaveFileName()</em> </span> function, a File Exists/Confirm Overwrite dialog will be displayed. \n         </p>\n         <p><a name=\"GUID-1430E859-EDC7-4485-89BC-F39DD8D09D30\"></a> If the optional \n            		<span class=\"code\"> <em class=\"strong\">metadata:</em> </span> keyword is provided in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>, the by-reference variable passed as parameter will be set to the BitmapInfo expressed\n            as an array of values that can be passed to the \n            		<span class=\"code\"> <em class=\"strong\">save()</em> </span> function\'s \n            		<span class=\"code\"> <em class=\"strong\">metadata:</em> </span> optional keyword. See \n            		<span class=\"char_link\"><a href=\"GUID-82742687-1173-40C5-BDDE-7B5AE010DD80.htm\">Bitmap Gamma and MAXScript</a></span> for details. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D0B\"></a>The \n                  		  <span class=\"code\"> <em class=\"strong\">getBitmapOpenFileName()</em> </span> function does not require that an existing file name be selected. A file name is\n                  returned if the user types a file name that does not exist. If necessary, you should\n                  check the file name that is returned to ensure the file exists. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D09\"></a>When you open a bitmap file, an entire frame is loaded into memory. When you are finished\n            processing a bitmap, it is a good idea to either call \n            		<span class=\"code\"> <em class=\"strong\">close()</em> </span> on the bitmap or assign the value \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> to the variable storing the bitmap value, and then manually run garbage collection\n            (<span class=\"code\"> <em class=\"strong\">gc light:true</em> </span>) so that memory can be released. Another technique for conserving memory when using\n            the \n            		<span class=\"code\"> <em class=\"strong\">render()</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">getChannelAsMask()</em> </span> functions repeatedly is to use the \n            		<span class=\"code\"> <em class=\"strong\">to:&lt;bitmap&gt;</em> </span>keyword argument which allows those functions to overwrite an existing bitmap’s pixel\n            image with the new rendering or mask. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D08\"></a>There is currently no access to the properties associated with some of the bitmap\n            output plug-ins. This means that you cannot set the codec used for .avi files. The\n            properties used are the properties that were last used when saving that file type\n            in \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D06\"></a>The following script shows how to properly create and save a multi-frame image file\n            in AVI format. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D05\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7D04\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5575\"></a><pre>\ntheTeapot=teapot()--something to render\nanimate on at time 10 \\--set animate and time context\nrotate theTeapot 180 z_axis--rotate the teapot\ncam=targetcamera pos:[200,0,100] \\--camera pointed at teapot\ntarget:theTeapot\nrenderFrames=#{1,3,5..12}-- specify frames to render\nb=bitmap 160 120 filename:@\"c:\\temp\\testme.bmp\"--create a new bitmap\nfor i= 1 to renderFrames.count do--loop though renderFrames\n(\nif renderFrames[i] then--if supposed to render frame...\n(\nat time i--set time context\nrender 160 120 camera:cam to:b-- render to bitmap frame\nsave b frame:i-- save each frame as you advance\n)-- if you save AFTER the loop,\n-- just the last frame is saved.\n)\nclose b-- close the output file - this will also get rid of\n--the reference to the bitmap value and free its memory.\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CEE\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5574\"></a><pre>\n$Teapot:Teapot004 @ [0.000000,0.000000,0.000000]-- result of line 1\nOK-- result of lines 2 and 3\n$Target_Camera:Camera005 @ [200.000000,0.000000,100.000000]-- result of lines 4 and 5\n#{1, 3, 5..12}-- result of line 6\nBitMap:c:\\temp\\testme.bmp-- result of line 7\nOK-- result of for loop, lines 8 to 15\nOK-- result of line 16\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CE2\"></a>While the \n                  		  <span class=\"code\"> <em class=\"strong\">frame:i</em> </span> keyword argument to the \n                  		  <span class=\"code\"> <em class=\"strong\">save()</em> </span> method is optional for AVI files (they would advance automatically after each frame),\n                  Quicktime MOV files \n                  		  <em class=\"strong\">require</em> it to save correctly. Otherwise, each rendered frame will overwrite the first frame\n                  in the file and the MOV would end up only one frame long. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CE0\"></a>The following script reads a bitmap file and outputs a script to Listener that implements\n            a function to recreate the same bitmap. This function can then be copied into your\n            script. This is useful for building button images in MAXScript so that you do not\n            need to distribute bitmap files along with your script. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CDF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CDE\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EAC\"></a><pre>\n(\nb=selectbitmap()-- open image file browser\nbname=\"bitmap_\"+(getfilenamefile b.filename)-- build name from filename\nw=b.width-- get properties of bitmap\nh=b.height\nformat \"----------\\nfn load_% = (\\n\" bname -- start defining function\nformat \"local %=bitmap % %\\n\" bname w h -- create bitmap in function\n-- write out a function that unpacks an integer into a pixel color\nformat \"fn unpack val = for p in val collect (r=p/256^2; g=p/256-r*256; b=mod p 256; color r g b)\\n\"\nfor r = 0 to h-1 do-- for each row in the bitmap\n-- have function write the column of pixels to the bitmap\n( format \"setpixels % [0,%] (unpack #(\"bname r\npixels=getpixels b [0,r] w-- read in the column of pixels\nfor c = 1 to w do-- loop through each pixel\n( p = pixels[c]-- get the pixel\n-- pack the pixel into an integer and write it out\nformat \"%\" (((p.r as integer)*256+(p.g as integer))*256+(p.b as integer))\nif c != w then-- if not at end of data\nformat \", \"-- write a comma\nelse\nformat \"))\\n\"-- else close out the line\n)\n)\nformat \"return %\\n\" bname-- function returns the bitmap\nformat \")\\n----------\\n\"-- finish off function definition\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CC1\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EAB\"></a><pre>\n----------\nfn load_bitmap_convert = (\nlocal bitmap_convert=bitmap 4 4\nfn unpack val = for p in val collect (r=p/256^2; g=p/256-r*256; b=mod p 256; color r g b)\nsetpixels bitmap_convert [0,0] (unpack #(12632256, 12632256, 12632256, 12632256))\nsetpixels bitmap_convert [0,1] (unpack #(255, 255, 255, 255))\nsetpixels bitmap_convert [0,2] (unpack #(255, 255, 255, 255))\nsetpixels bitmap_convert [0,3] (unpack #(255, 12632256, 12632256, 12632256))\nreturn bitmap_convert\n)\n----------\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CB2\"></a>Also see the example in<span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> for another usage of class Bitmap. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7CAF\"></a> <span class=\"char_link\"><a href=\"GUID-5D007B11-0770-47BC-B4ED-5D3DF8C78BE9.htm\"> Accessing the Last Rendered Image</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";