var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A02EECAD-E33B-40C0-BC32-FF5C1C6E8289\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Get Faces With Normals Facing Away?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A02EECAD-E33B-40C0-BC32-FF5C1C6E8289\"></a><div class=\"head\">\n            <h1>How do I Get Faces With Normals Facing Away? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10DA\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10DC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10DD\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8DC\"> Working With Editable Meshes</a></span> &gt; How Do I Get Faces With Normals Facing Away? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10DF\"></a> \n            <h2><a name=\"GUID-367E4457-62A4-46B2-BC3A-111224CEBAB3\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10E0\"></a>Can anyone tell me how to get faces that have normals pointing outside of the current\n               viewport? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10E1\"></a> \n            <h2><a name=\"GUID-2CEAFBBF-571C-4CC3-9602-DF48337437B5\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10E2\"></a>You can get the face normal in viewspace, then you just have to check the sign of\n               the Z component. If it is negative, it is facing away from the camera! \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10E3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10E4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-663A\"></a><pre>\n(\ntheObj = Teapot segs:10 --create ateapot\nconvertToMesh theObj --convert to EMesh\ntheMeshCount = theObj.numfaces --get the number of faces in the object\nselArray = #() --init. an array to collect faces\nfor f = 1 to theMeshCount do --loop through all faces\n(\n  in coordsys (inverse (viewport.GetTM())) theFN = getFaceNormal theObj f\n  if theFN.z &lt; 0 then append selArray f -- if Z is negative, add to array\n)\nsetFaceSelection theObj selArray --set the face selection in the EMesh\nmax modify mode --go to modify mode\nselect theObj --select the mesh\nsubObjectLevel = 3 --go to Face SO level\nmodPanel.addModToSelection (deleteMesh()) --add a delete mesh, preserving the SO selection\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10F8\"></a> <em class=\"strong\">Result</em>:All triangles facing away from the camera will be deleted! \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10F9\"></a> <img src=\"../images/GUID-326CD86E-222B-4C56-9AE3-0821E4F32D39-low.gif\"> <img src=\"../images/GUID-C5FC6976-CE4C-4DED-93FB-B51EC4F9E7CC-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10FA\"></a>The image on the left shows the teapot with deleted backfaces as seen from a camera\n               viewport. The image on the right shows the teapot and the camera as seen from the\n               side. Note that for the screenshot, the backface culling was disabled (you can see\n               the backfaces on the right image), but the left image looks just like it would with\n               backface culling enabled! This is because the script deletes the same faces the viewport\n               backface culling would skip! \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10FC\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";