var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A2C25DDF-2FC1-456B-90C2-B91D98296C3F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"2D and 3D point literals\">\n      <meta name=\"indexterm\" content=\"Point3: literals\">\n      <meta name=\"indexterm\" content=\"Point2: literals\">\n      <meta name=\"indexterm\" content=\"literals\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>2D and 3D Point Literals</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A2C25DDF-2FC1-456B-90C2-B91D98296C3F\"></a><div class=\"head\">\n            <h1>2D and 3D Point Literals </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D76\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D77\"></a>    Coordinates are used extensively in MAXScript programming. They support a large range\n               of operations as described in <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> and <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span>. You can write point literals using the following forms: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D7C\"></a> <em class=\"strong\">2D</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6145\"></a><pre><em class=\"codeEmphasisStrong\">[</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D7E\"></a> <em class=\"strong\">3D</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6144\"></a><pre><em class=\"codeEmphasisStrong\">[</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt;<em class=\"codeEmphasisStrong\">,</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D80\"></a>where <span class=\"code\"> &lt;expr&gt; </span> evaluates to an Integer or Float value. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D81\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D82\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6143\"></a><pre>\n[320, 240] -- 2D point\n[10, 20, 30] -- 3D point\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D88\"></a>Expressions in a literal are evaluated when the literal is built. The following script\n               and results show the value stored in a Point3 when expressions are used in the literal:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D89\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D8A\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6142\"></a><pre>\na=10\nb=45\n[10, 20, 30]\n[sin a, 2 * b, a^2 + b^2] -- can contain expressions\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D91\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6141\"></a><pre>\n10.0 -- result of line 1\n45 -- result of line 2\n[10,20,30] -- result of line 3\n[0.173648,90,2125] -- result of line 4\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D9A\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D9B\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";