var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A2F1412A-0EF7-405B-A4A2-6F169A838C4C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Persistents Structure\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Persistents Structure</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A2F1412A-0EF7-405B-A4A2-6F169A838C4C\"></a><div class=\"head\">\n            <h1>Persistents Structure </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B46\"></a> The \n            		<em class=\"strong\">Persistents struct</em> provides methods to collect, create, and test persistent global variables. \n            	 \n         </p>\n         <p><a name=\"P_F045366280554A4F8FB33FA847056139\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_4AB4D1729C014EE9B18682C1C3A76D92\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6196\"></a><pre><em class=\"codeEmphasisStrong\">persistents</em>.<em class=\"codeEmphasisStrong\">show</em> [ to:&lt;stream&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A76\"></a>Displays a list of persistent globals and their value. \n            	 \n         </p>\n         <p> The optional \n            		<span class=\"code\">&lt;stream&gt;</span> argument can be a \n            		<span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">filestream</a></span>, \n            		<span class=\"char_link\"><a href=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6.htm\">stringstream</a></span>, or \n            		<span class=\"char_link\"><a href=\"GUID-88912612-DDDC-4016-AD24-1180BB2DAD96.htm\">windowstream</a></span>, which the method sends its output to. Available in <em class=\"strong\">3ds Max 2019 and higher</em>.\n            	 \n         </p>\n         <p><a name=\"P_91CC7AEEA78348CC8E72A4BCDFDF2364\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6195\"></a><pre><em class=\"codeEmphasisStrong\">persistents</em>.<em class=\"codeEmphasisStrong\">remove </em>&lt;var_name&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A79\"></a>Removes the named persistent global from the persistent global pool. The variable\n            remains as a global variable and retains its value. \n            	 \n         </p>\n         <p><a name=\"P_537C0518AE2E421DA3642F70D36841D7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6194\"></a><pre><em class=\"codeEmphasisStrong\">persistents</em>.<em class=\"codeEmphasisStrong\">removeAll</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A7C\"></a>Removes all persistent globals from the persistent global pool. The variables remain\n            as global variables and retain their value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A7D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A7E\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6193\"></a><pre>\na= \"Hello world\"\npersistent global a\npersistent global b=box()\npersistents.show()\npersistents.remove #a\npersistents.removeall()\na\nb\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A89\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6192\"></a><pre>\n\"Hello world\"\nOK\n$Box:Box002 @ [0.000000,0.000000,0.000000]\na: \"Hello world\"\nb: $Box:Box002 @ [0.000000,0.000000,0.000000]\nOK\nOK\nOK\n\"Hello world\"\n$Box:Box002 @ [0.000000,0.000000,0.000000]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6183\"></a><pre><em class=\"codeEmphasisStrong\">persistents.gather</em>() 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B4B\"></a>This method returns an array of all persistent global variable names as &lt;name&gt; values.\n            \n            	 \n         </p>\n         <p><a name=\"P_349E3837DC2242F18425E29E1F1F92D2\"></a> Available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_64A3C3E6F5B24511A3746E14421B8F38\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6182\"></a><pre><em class=\"codeEmphasisStrong\">persistents.make</em> &lt;global var name&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B4E\"></a>This method makes the specified global variable name persistent. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B4F\"></a>The name specified must be a global variable\'s name, otherwise a runtime error is\n            thrown. See \n            		<span class=\"char_link\"><a href=\"GUID-E7584E94-8696-421E-920C-2A83FCD9ABBF.htm\">globalVars structure</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_E349D9A80B9941FD82BB4BAA6576185E\"></a> Available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_5207F792FE744A3CA40B7BF9755C2B22\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6181\"></a><pre><em class=\"codeEmphasisStrong\">persistents.isPersistent</em> &lt;global var name&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B52\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, if the specified global variable name is persistent, \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> if it is not persistent. \n            	 \n         </p>\n         <p><a name=\"P_87F609D1601C4F299CAE1DCC29E77889\"></a> Available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B53\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B54\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6180\"></a><pre>\nglobal aVar&nbsp; --define a global variable\n--&gt; OK&nbsp; --done!\npersistents.isPersistent #aVar --is it persistent?\n--&gt; false&nbsp; --it is not!\npersistents.make #aVar --make the existing global persistent\n--&gt; OK&nbsp; --done!\npersistents.isPersistent #aVar --see if it is persistent now\n--&gt; true&nbsp; --now it is!\npersistent global aNewPV --declare a variable as persistent global\n--&gt; undefined&nbsp; --done, variable has a value of undefined\npersistents.isPersistent #aNewPV --then see if it is persistent\n--&gt; true&nbsp; --it is!\npersistents.isPersistent #anUndeclaredVar --check an undeclared var.\n--&gt; false&nbsp; --it is not persistent\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B68\"></a> <span class=\"char_link\"><a href=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186.htm\">Persistent Global Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B69\"></a> <span class=\"char_link\"><a href=\"GUID-E7584E94-8696-421E-920C-2A83FCD9ABBF.htm\">globalVars Structure</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B6B\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B6C\"></a> <span class=\"char_link\"><a href=\"GUID-3E792B8C-AF02-4178-9651-EDDB1341B68D.htm\">Specifying Global Variables As Global Using ::</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";