var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A35C74C5-1721-4B19-9FC4-E1CD6563505B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"structure definitions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Structure Definitions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A35C74C5-1721-4B19-9FC4-E1CD6563505B\"></a><div class=\"head\">\n            <h1>Structure Definitions </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5191\"></a> In addition to custom functions, you can also create custom compound values in MAXScript\n            using \"structure definitions\". Structure definitions are a flexible data type, built\n            of simpler data types. They let you define the layout of a new structured type of\n            value that you can then create and work with in your code. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5193\"></a>The syntax for a structure definition is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-505A\"></a><pre><em class=\"codeEmphasisStrong\">struct </em>&lt;struct_name&gt; ( &lt;member&gt; , &lt;member&gt; )</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5195\"></a>where each <span class=\"code\">&lt;member&gt;</span> can be one of: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5059\"></a><pre>\n&lt;name&gt; [ = &lt;expr&gt; ]  --name and optional initial value\n&lt;function_definition&gt;\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5198\"></a>Create a new structure, called person: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5058\"></a><pre>Struct person (name, height, age, sex)</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC519A\"></a>&nbsp;<img src=\"../images/GUID-6699AC72-91A6-44E1-B2D6-063851912A98-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC519B\"></a>Now create an instance of this structure using the ‘person’ constructor: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5057\"></a><pre>Bill = person name:\"Bill\" height:72 age:34 sex:#male</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC519D\"></a>This stores an instance of the person structure in the variable Bill. Member <span class=\"code\">name</span> is initialized to the string value \"Bill\", <span class=\"code\">height</span> to the integer value 72, <span class=\"code\">age</span> to the integer value 34, and <span class=\"code\">sex</span> to the name value <span class=\"code\">#male</span>. Create another instance: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5056\"></a><pre>Joe = person name:\"Joseph\" sex:#male</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC519F\"></a>In this example, another ‘person’ is created. However, this person does not have initialized\n            values for the <span class=\"code\">height</span> and <span class=\"code\">age</span> members. Since you did not provide these members with an optional default value in\n            our structure definition, they will default to a value of <span class=\"code\">undefined</span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC51A0\"></a>&nbsp;<img src=\"../images/GUID-FAB7C955-F221-475C-946A-3185A8C08C38-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC51A1\"></a>Structure definitions are a good alternative to arrays when you have a fixed, small\n            number of components. The code for these types of values is easier to work with since\n            you can reference property names rather than index numbers in arrays. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC51A2\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC51A3\"></a> <span class=\"char_link\"><a href=\"GUID-C778E515-8B85-4828-96E9-8CB41315E4C4.htm\">3ds Max Commands in MAXScript</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";