var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"with - loop exit\">\n      <meta name=\"indexterm\" content=\"while loop exit\">\n      <meta name=\"indexterm\" content=\"loop exit\">\n      <meta name=\"indexterm\" content=\"for loop\">\n      <meta name=\"indexterm\" content=\"exit - loops\">\n      <meta name=\"indexterm\" content=\"do loop exit\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Loop Exit</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4\"></a><div class=\"head\">\n            <h1>Loop Exit </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E872B0\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872B1\"></a>       MAXScript provides an <span class=\"code\"> <em class=\"strong\">exit</em> </span> construct for breaking out of <span class=\"code\"> <em class=\"strong\">for</em> </span>, <span class=\"code\"> <em class=\"strong\">do</em> </span>, and <span class=\"code\"> <em class=\"strong\">while</em> </span> loops prematurely, even though the loop test expression is still <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n            </p> \n            <p><a name=\"P_1774CC89F3C64C07A63A817DCA87AD76\"></a>This is often useful to simplify the loop test expression, and still use error or\n               other complex termination tests in the body <span class=\"code\">&lt;expr&gt;</span> of the loop. \n            </p> \n            <p><a name=\"P_1AF353F5C32640C28ABBC9860530512D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872B9\"></a>Its <em class=\"strong\">syntax </em>is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AB\"></a><pre><em class=\"codeEmphasisStrong\">exit</em> [ <em class=\"codeEmphasisStrong\">with</em> &lt;expr&gt; ] </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872BC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872BD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AA\"></a><pre>\nwhile x &lt; y do\n(\nlocal delta = x - y\nif delta &lt;= 0 then exit -- time to bail\n$foo.pos.x = compute_x (foo / delta)\nx += 0.1\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872C7\"></a>The optional <span class=\"code\"> <em class=\"strong\">with</em> &lt;expr&gt;</span> lets you specify what the overall value of the loop expression should be if the loop\n               exits prematurely. \n            </p> \n            <p><a name=\"P_A9171F059BB24A05AB0B3DA536C16E5D\"></a>If you don\'t specify an exit value, the loop returns the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span> upon exit. \n            </p> \n            <p><a name=\"P_813F4AF8BBF546528BE58EA3B03455DA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872C8\"></a>Exiting a <span class=\"code\"> <em class=\"strong\">for ... do</em> </span> loop using a <span class=\"code\"> <em class=\"strong\">with</em> &lt;expr&gt;</span> returns the expression value as the result of the loop. \n            </p> \n            <p><a name=\"P_51022CFDE4CE4AFF995E6DCA27536024\"></a><em class=\"strong\">Note</em> that in releases prior <em class=\"strong\">3ds Max 6</em>, <span class=\"code\"> <em class=\"strong\">OK</em> </span> was returned. \n            </p> \n            <p><a name=\"P_E5C5A188FED54643AEB34D3B15E3976D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872C9\"></a>Exiting a <span class=\"code\"> <em class=\"strong\">for ... collect</em> </span> loop using a <span class=\"code\"> <em class=\"strong\">with &lt;expr&gt;</em> </span> results in the array of body values collected up to the point of exit. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872CB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872CC\"></a><p class=\"table-body\"> <em class=\"strong\">PERFORMANCE WARNING!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872CD\"></a><p class=\"table-body\">Breaking out of a loop using an <span class=\"code\"> <em class=\"strong\">exit</em> </span> construct is implemented internally using try/catch, which is <em class=\"strong\">extremely slow!</em> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872CE\"></a><p class=\"table-body\">It is recommended to use the optional <span class=\"code\"> <em class=\"strong\">while</em> </span> test added to <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">for loops</a></span> in <em class=\"strong\">3ds Max 6</em> for performance reasons. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872D0\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872D1\"></a> <span class=\"char_link\"><a href=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8.htm\">Skipping Loop Iterations</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";