var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"string methods\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"execute()\">\n      <meta name=\"indexterm\" content=\"getTextExtent()\">\n      <meta name=\"indexterm\" content=\"findString()\">\n      <meta name=\"indexterm\" content=\"filterString()\">\n      <meta name=\"indexterm\" content=\"replace()\">\n      <meta name=\"indexterm\" content=\"substring()\">\n      <meta name=\"indexterm\" content=\"append (string)\">\n      <meta name=\"indexterm\" content=\"stricmp()\">\n      <meta name=\"indexterm\" content=\"toUpper()\">\n      <meta name=\"indexterm\" content=\"toLower()\">\n      <meta name=\"indexterm\" content=\"substituteString()\">\n      <meta name=\"indexterm\" content=\"replace_LF_with_CRLF()\">\n      <meta name=\"indexterm\" content=\"replace_CRLF_with_LF()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>String Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4\"></a><div class=\"head\">\n            <h1>String Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B2\"></a>The \n            		<em class=\"strong\">String</em> class defines the characteristics of character strings. The character strings can\n            be of any length. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B3\"></a> <em class=\"strong\">Literal</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF8\"></a><pre>\"&lt;characters&gt;\"</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B5\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-7F17449E-C377-445C-AC15-CD3BA88A975B.htm\">String Literals</a></span> for a description of String literals. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B6\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF7\"></a><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">as string</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B8\"></a>Converts any value into its string representation. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879B9\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF6\"></a><pre>&lt;string&gt;.<em class=\"codeEmphasisStrong\">count</em>: Integer, read-only</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879BB\"></a>The number of characters in the string. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879BC\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF5\"></a><pre>&lt;string&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;string&gt;</pre></div>\n         <p><a name=\"GUID-F5031FC2-D3A3-43C6-81D2-EEB008B090F0\"></a>Returns a new string that is the concatenation of two strings. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF4\"></a><pre>\n&lt;string&gt; == &lt;string&gt;\n&lt;string&gt; != &lt;string&gt;\n&lt;string&gt; &gt; &lt;string&gt;\n&lt;string&gt; &lt; &lt;string&gt;\n&lt;string&gt; &gt;= &lt;string&gt;\n&lt;string&gt; &lt;= &lt;string&gt;\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879C6\"></a>Standard lexical string comparisons (case sensitive). \n            	 \n         </p>\n         <p><a name=\"GUID-6C8CA979-4C98-449B-83B3-869DE8271161\"></a>To perform a case insensitive equality comparison, please use the \n            		<span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FD6\"> \n                  			 stricmp() \n                  		   method</a></span> that performs a lower-case comparison. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF3\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;index_number&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879C9\"></a>Returns the indexed character as a single-character string, index starts at 1. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF2\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;index_number&gt;<em class=\"codeEmphasisStrong\">]</em>= &lt;single_character_string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879CC\"></a>Sets the indexed character to the given character. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF1\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">as</em>&lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879CF\"></a>Converts the string to an instance of the given class. You can convert a string into\n            a Name value using the \n            		<span class=\"code\"> <em class=\"strong\">as</em> </span> operator. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879D0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879D1\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF0\"></a><pre>\n\"Foo\" as name-- <span class=\"codeComment\">returns #foo</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879D6\"></a>You can also convert strings to numbers using the \n            		<span class=\"code\"> <em class=\"strong\">as</em> </span> operator. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879D7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879D8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEF\"></a><pre>\n\"123.4\" as float-- <span class=\"codeComment\">returns 123.4</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879DD\"></a>You can use any of the Number classes as a target class: Number, Float, or Integer.\n            If you use Number, the appropriate class will be used depending on the syntax of the\n            number in the string. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879DE\"></a>You can convert a string to a StringStream value using the \n            		<span class=\"code\"> <em class=\"strong\">as</em> </span> operator. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879DF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879E0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEE\"></a><pre>\n\"$box01\" as stringstream-- <span class=\"codeComment\">returns the string as a stringstream</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879E4\"></a>Converting a string to a StringStream value allows you to read through a string using\n            the MAXScript\'s text file I/O operations. See \n            		<span class=\"char_link\"><a href=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6.htm\">StringStream Values</a></span> for a description of StringStreams. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879E5\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FED\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">copy</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879E8\"></a>Creates a new copy of the string value and returns it. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879E9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879EA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEC\"></a><pre>\nnewstr = copy oldstr\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879EE\"></a>The new value contains a copy of the text contents of the copied string and is independent\n            of the copied string. \n            	 \n         </p>\n         <p><a name=\"GUID-638901DD-FC2D-4D54-9F23-55E79B5EE69B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEB\"></a><pre><em class=\"codeEmphasisStrong\">free</em> &lt;string&gt;</pre></div>\n         <p><a name=\"GUID-80A1F5FD-372A-4C91-B526-EF443CB0F079\"></a><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> Frees the memory used by the string value without waiting for garbage collection.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-54037C97-6B9A-429C-8299-50C1CFE320E2\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher</em>. \n            	 \n         </p><a name=\"TABLE_6B1E40F0A0E9481CAB1EDB999E7B7AF0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-7558C1C3-8EFE-4577-B954-89FFEB2814A9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_BD5C574D5CA54DF099BF9C61F1F01701\"></a><pre>s = \"ABCD\"\n--&gt; \"ABCD\"\ns\n--&gt; \"ABCD\"\nfree s\n--&gt; OK\ns\n--&gt; \"\"</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-D14B4280-6F7F-459D-89E6-09670B285515\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_118A4857AD2442FB9FA54574B7CCE94F\"></a><pre><em class=\"codeEmphasisStrong\">execute</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879F1\"></a>Compiles and evaluates the contents of the string as a MAXScript expression and returns\n            the result of the evaluation. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879F2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879F3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEA\"></a><pre>\nexecute\"2 + 2\"-- <span class=\"codeComment\">yields the value 4</span>\nstr =\"$foo.ffd_2x2x2.control_point_\"+\nn as string +\" = [1,1,1]\"\nexecute str\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879FA\"></a>The result of an \n            		<span class=\"code\"> <em class=\"strong\">execute()</em> </span> call is the result of the last expression in the string argument. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879FB\"></a>You can use \n            		<span class=\"code\"> <em class=\"strong\">execute()</em> </span> to access object using a computed name. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879FC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E879FD\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE9\"></a><pre>\nobj = execute (\"$foo/\"+ child_name)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A01\"></a>It retrieves the child of \n            		<span class=\"code\"> <em class=\"strong\">$foo</em> </span> named in the variable \n            		<span class=\"code\"> <em class=\"strong\">child_name</em> </span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A02\"></a>Here is a more complex example: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A03\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A04\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE8\"></a><pre>\nside =\"left\"\nfinger = 2\nlimb =\"arm\"\nobj = execute (\"$torso/\"+ limb +\"/\"+\nside +\"/finger/\"+\nfinger as string)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A0E\"></a>The scope of variables used in the evaluated string is \n            		<em class=\"strong\">global</em> and not the scope in effect when the \n            		<span class=\"code\"> <em class=\"strong\">execute()</em> </span> method is executed. So, if you call \n            		<span class=\"code\"> <em class=\"strong\">execute()</em> </span> within a function, scripted utility, or anywhere where the scope is not global, you\n            will need to explicitly specify the scope of any variables used in the string that\n            is executed. In the following example, the scope of variable \n            		<span class=\"code\"> <em class=\"strong\">posObj</em> </span> is local to utility \n            		<span class=\"code\"> <em class=\"strong\">myUtil</em> </span>, so the string needs to specify the variable’s name as being in \n            		<span class=\"code\"> <em class=\"strong\">myUtil</em> </span>’s scope: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A0F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A10\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE7\"></a><pre>\nUtility myUtil\"My Utility\"\n(\nlocal posObj\nfn test obj =\n(\nlocal i, j, thisCont\nthisCont=execute (\"myUtil.posObj.\'\"+j+\"\'pos.controller\")\n)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A1D\"></a>In general, you \n            		<em class=\"strong\">cannot</em> access locals from outside of an object, except for top-level locals in rollouts,\n            utilities, tools, and plug-ins (because they are semi-permanent and are stored with\n            these objects). Function parameters and locals are dynamic and stack-based and not\n            accessible as properties of the function definition. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A1E\"></a>For more information on variable scope, see \n            		<span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> and \n            		<span class=\"char_link\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code</a></span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE6\"></a><pre>&lt;Point2&gt; <em class=\"codeEmphasisStrong\">GetTextExtent</em>&lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A21\"></a>Returns a Point2 value containing the size of the string in pixels if it was displayed\n            in a command panel. \n         </p>\n         <p><a name=\"GUID-7A75BE76-0C64-4CE2-9EB1-56EB9EEFDBFB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE5\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">findString</em>&lt;string&gt; &lt;search_string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A24\"></a>Returns the index of \n            		<span class=\"code\"> <em class=\"strong\">search_string</em> </span> in \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if not found. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A25\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A26\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE4\"></a><pre>\nfindString \"Thanks for all the fish!\" \"all\" -- <span class=\"codeComment\">returns 12</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE3\"></a><pre>&lt;array of strings&gt;<em class=\"codeEmphasisStrong\">filterString</em> &lt;string&gt; &lt;token_string&gt; [<em class=\"codeEmphasisStrong\">splitEmptyTokens:</em>&lt;boolean&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A2D\"></a>Parses \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> based on \n            		<span class=\"code\"> <em class=\"strong\">token_string</em> </span> and returns an array of strings. The \n            		<span class=\"code\"> <em class=\"strong\">filterString</em> </span> splits the input \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> into substrings based on the characters given in \n            		<span class=\"code\"> <em class=\"strong\">token_string</em> </span>, and returns each substring as a member of the array. The \n            		<span class=\"code\"> <em class=\"strong\">token_string</em> </span> is simply a list of \'splitter characters\' (when the string is scanned, any occurrence\n            of any of the tokens is regarded as the start of a substring). This function is useful\n            for file import/export scripts or for any type of manual parsing. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A2E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A2F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE2\"></a><pre>\nfilterString \"MAX Script, is-dead-funky\" \", -\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A33\"></a><p class=\"table-body\"> <em class=\"strong\">WOULD RETURN</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE1\"></a><pre>\n#(\"MAX\",\"Script\",\"is\",\"dead\",\"funky\")\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A38\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">splitEmptyTokens</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> or not specified, sequential tokens are handled as a single token and tokens at the\n            beginning or end of the string are ignored. If \n            		<span class=\"code\"> <em class=\"strong\">splitEmptyTokens</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, each token found will result in string element in the output, with the string element\n            in the cases ignored above being empty strings. Available in \n            		<em class=\"strong\">3ds Max 8 and higher</em>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A39\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A3A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FE0\"></a><pre>\ns = \"One\\t\\tThree\\tFour\"\ntokens = filterString s \"\\t\"\n--&gt; #(\"One\", \"Three\", \"Four\")\ntokens = filterString s \"\\t\" splitEmptyTokens:true\n--&gt; #(\"One\", \"\", \"Three\", \"Four\")\ns =\"\\t\\t\\tOne\\t\\t\\tThree\\tFour\\t\\t\\t\"\ntokens = filterString s \"\\t\"\n--&gt; #(\"One\", \"Three\", \"Four\")\ntokens = filterString s \"\\t\" splitEmptyTokens:true\n--&gt; #(\"\", \"\", \"\", \"One\", \"\", \"\", \"Three\", \"Four\", \"\", \"\", \"\")\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDF\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">replace</em> &lt;string&gt; &lt;from_integer&gt; &lt;length_integer&gt; &lt;new_string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A4A\"></a>Returns a new string where the substring in \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> starting at index \n            		<span class=\"code\"> <em class=\"strong\">from_integer</em> </span> and of length \n            		<span class=\"code\"> <em class=\"strong\">length_integer</em> </span> is replaced with the \n            		<span class=\"code\"> <em class=\"strong\">new_string.new_string</em> </span> of any length. The sum of \n            		<span class=\"code\"> <em class=\"strong\">from_integer</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">length_integer</em> </span> must be less than the length of \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A4B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A4C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDE\"></a><pre>\ns=\"1234567890\"\ns1=replace s 5 3 \"inserted string\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A51\"></a><p class=\"table-body\"> <em class=\"strong\">RETURNS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDD\"></a><pre>\n\"1234inserted string890\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDC\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">substring</em> &lt;string&gt; &lt;from_integer&gt; &lt;length_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A58\"></a>Returns a new string consisting of the substring in \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> starting at index \n            		<span class=\"code\"> <em class=\"strong\">from_integer</em> </span> and of length \n            		<span class=\"code\"> <em class=\"strong\">length_integer</em> </span>. If the sum of \n            		<span class=\"code\"> <em class=\"strong\">from_integer</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">length_integer</em> </span> is greater than the length of \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span>, a shorter string is returned containing as many characters as are available in the\n            source. If a negative value is specified for \n            		<span class=\"code\"> <em class=\"strong\">length_integer</em> </span>, the remainder of the string starting from \n            		<span class=\"code\"> <em class=\"strong\">from_integer</em> </span> is returned. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A59\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A5A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDB\"></a><pre>\ns =\"Balerofon\"\nss = substring s 5 3-- <span class=\"codeComment\">returns \"rof\"</span>\nss = substring s 5 -1-- <span class=\"codeComment\">returns \"rofon\"</span>\nss = substring s 5 100-- <span class=\"codeComment\">returns \"rofon\"</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FDA\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">matchPattern</em> &lt;string&gt; <em class=\"codeEmphasisStrong\">pattern</em>:&lt;pattern_string&gt; [<em class=\"codeEmphasisStrong\">ignoreCase</em>:&lt;boolean&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A64\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if \n            		<span class=\"code\"> <em class=\"strong\">string</em> </span> is matched by the wild card \n            		<span class=\"code\"> <em class=\"strong\">pattern_string</em> </span>,<span class=\"code\"> <em class=\"strong\"> false</em> </span> otherwise. The comparison is case-insensitive unless \n            		<span class=\"code\"> <em class=\"strong\">ignoreCase:false</em> </span> is specified. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61AE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <span class=\"code\"> <em class=\"strong\">matchPattern()</em> </span> executes much faster than \n               		<span class=\"code\"> <em class=\"strong\">findString()</em> </span> and must be used in its place when possible. \n               	 \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A69\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A6A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD9\"></a><pre>\ns=\"text1\"\nmatchPattern s pattern:\"text?\"-- <span class=\"codeComment\">returns true</span>\nmatchPattern s pattern:\"T*\"-- <span class=\"codeComment\">returns true</span>\nmatchPattern s pattern:\"T*\"ignoreCase:false-- <span class=\"codeComment\">returns false</span>\nmatchPattern s pattern:\"s*\"-- <span class=\"codeComment\">returns false</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD8\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">append</em> &lt;string1&gt; &lt;string2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A75\"></a>Appends \n            		<span class=\"code\"> <em class=\"strong\">string2</em> </span> to \n            		<span class=\"code\"> <em class=\"strong\">string1</em> </span>. Operates on \n            		<span class=\"code\"> <em class=\"strong\">string1</em> </span> in place and returns \n            		<span class=\"code\"> <em class=\"strong\">string1</em> </span> as its result. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61AF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A78\"></a>As this method operates on \n                  		  <span class=\"code\"> <em class=\"strong\">string1</em> </span> in place, after running the following code snippet, both \n                  		  <span class=\"code\"> <em class=\"strong\">s1</em> </span> and \n                  		  <span class=\"code\"> <em class=\"strong\">s2</em> </span> will continue to point to the same string value: \n                  		\n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD7\"></a><pre>\ns1 = \"aa\"\ns2 = s1\nappend s1 \"bb\"\ns1-- <span class=\"codeComment\">returns \"aabb\"</span>\ns2-- <span class=\"codeComment\">returns \"aabb\"and not \"aa\"</span> </pre></div> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A80\"></a>Append is typically used when incrementally building a large string from many small\n            strings. \n            		<em class=\"strong\">As the string is operated on in place, memory usage might be significantly reduced</em> because intermediate string values will not remain in memory until the next garbage\n            collection. \n            	 \n         </p>\n         <p><a name=\"GUID-46D8650A-7888-4927-BB2C-6B44730F7F78\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD6\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">stricmp</em> &lt;string1&gt; &lt;string2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A83\"></a>In \n            		<em class=\"strong\">3ds Max6 and higher</em>, this method performs a lower case comparison of string1 and string2. \n            	 \n         </p>\n         <p><a name=\"GUID-9E4363EB-C141-4CAE-924A-3D50F9648C61\"></a>Returns an integer value &lt; 0 if string1 is less than string 2, = 0 if string1 is identical\n            to string 2, and &gt; 1 if string1 is greater than string 2. \n         </p>\n         <p><a name=\"GUID-D12910B4-38DC-408F-B88A-878C7FBDEFEA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD5\"></a><pre><em class=\"codeEmphasisStrong\">toUpper</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A87\"></a>Returns a new string value with the string converted to upper case. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A88\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A89\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD4\"></a><pre>\ntoUpper \"so long and thanks for all the scripts\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A8D\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD3\"></a><pre>\n\"SO LONG AND THANKS FOR ALL THE SCRIPTS\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD2\"></a><pre><em class=\"codeEmphasisStrong\">toLower</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A93\"></a>Returns a new string value with the string converted to lower case. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87A94\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A95\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD1\"></a><pre>\ntoLower \"Life, The Universe And Everything\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87A99\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FD0\"></a><pre>\n\"life, the universe and everything\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCF\"></a><pre><em class=\"codeEmphasisStrong\">substituteString</em> &lt;source_string&gt; &lt;from_string&gt; &lt;to_string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AA0\"></a>Returns a new string with all occurrences of \n            		<span class=\"code\">&lt;from_string&gt;</span> in \n            		<span class=\"code\">&lt;source_string&gt;</span> replaced with \n            		<span class=\"code\">&lt;to_string&gt;</span>. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AA1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87AA2\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCE\"></a><pre>\ns1 = \"Truth, Justice And The American Way\"\ns2 = \"The American Way\"\ns3 = \"All That Stuff\"\ns4 = substituteString s1 s2 s3\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87AA9\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCD\"></a><pre>\n\"Truth, Justice And All That Stuff\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCC\"></a><pre><em class=\"codeEmphasisStrong\">replace_LF_with_CRLF </em>&lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AB1\"></a>Returns a new string where line feeds in input string are replaced with carriage return/line\n            feed, unless the character preceding the line feed is a carriage return. Available\n            in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-A571EF56-2D29-4BCE-BC02-7DFF68B2573A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FCB\"></a><pre><em class=\"codeEmphasisStrong\">replace_CRLF_with_LF</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AB4\"></a>Returns a new string where carriage return/line feeds in input string are replaced\n            with line feeds. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B0\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AB8\"></a>The following script shows the use of various literals, constructors, properties,\n               operators, and methods of the String class. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87ABA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87ABB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5594\"></a><pre>\n-- <span class=\"codeComment\">strings test bed</span>\nfn uppercase instring =-- <span class=\"codeComment\">beginning of function definition</span>\n( local upper, lower, outstring-- <span class=\"codeComment\">declare variables as local</span>\nupper=\"ABCDEFGHIJKLMNOPQRSTUVWXYZ\"-- <span class=\"codeComment\">set variables to literals</span>\nlower=\"abcdefghijklmnopqrstuvwxyz\"\n&nbsp;\n-- <span class=\"codeComment\">create an unique copy of the string referenced by instring,</span>\n-- <span class=\"codeComment\">and store reference to unique copy in outstring</span>\noutstring=copy instring\n&nbsp;\n--<span class=\"codeComment\"> increment from 1 to number of character in string</span>\nfor i=1 to outstring.count do\n&nbsp;\n-- <span class=\"codeComment\">see if the single character at index i in outstring</span>\n-- <span class=\"codeComment\">is present instring lower</span>\n-- <span class=\"codeComment\">If so, j equals position in string lower.</span>\n-- <span class=\"codeComment\">If not, j equals undefined</span>\n( j=findString lower outstring[i]\n&nbsp;\n-- <span class=\"codeComment\">if character was found in lower,</span>\n-- <span class=\"codeComment\">replace with corresponding character in upper:</span>\nif (j != undefined) do outstring[i]=upper[j]\n)\noutstring-- <span class=\"codeComment\">value will be returned as function result</span>\n)-- <span class=\"codeComment\">end of fn uppercase</span>\n&nbsp;\ns1=\"AbCdEfGh\"-- <span class=\"codeComment\">set variable to literal</span>\ns2=uppercase s1-- <span class=\"codeComment\">call function uppercase, passing s1 as parameter</span>\nif s1 == <span class=\"codeComment\">s2 do print \"strings s2 and s3 are the same\"-- compare strings</span>\nif s1 != <span class=\"codeComment\">s2 do print \"strings s1 and s2 are different\"</span>\n&nbsp;\ntheObject=\"sphere\"--<span class=\"codeComment\"> set variable to literal</span>\ntheRadius= (random 10. 100.) as string-- <span class=\"codeComment\">convert number to string</span>\n-- <span class=\"codeComment\">concatenate strings and execute string</span>\nmyObject=execute (theObject +\" radius:\"+ theRadius)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87AE1\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5593\"></a><pre>\nuppercase()-- <span class=\"codeComment\">result to function definition</span>\n\"AbCdEfGh\"-- <span class=\"codeComment\">result of line 24</span>\n\"ABCDEFGH\"-- <span class=\"codeComment\">result of line 25</span>\nundefined-- <span class=\"codeComment\">result of line 26 - stringsnot equal,</span>\n-- <span class=\"codeComment\">and no else expression in if expression</span>\n\"strings s1 and s2 are different\"-- <span class=\"codeComment\">output from line 27</span>\n\"strings s1 and s2 are different\"-- <span class=\"codeComment\">result of line 27</span>\n\"sphere\"-- <span class=\"codeComment\">result of line 29</span>\n\"75.4091\"-- <span class=\"codeComment\">result of line 30</span>\n$Sphere:Sphere001 @ [0.000000,0.000000,0.000000]-- <span class=\"codeComment\">result of line 32. Execute function</span>\n-- <span class=\"codeComment\">created a sphere object</span> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87AB6\"></a> <span class=\"char_link\"><a href=\"GUID-09174DC2-033E-4EA5-ACBB-AA840A15D070.htm\">String Parser Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";