var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A6E95530-F419-4837-B10A-E881A62AD5F9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Local and Global Variables\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Local and Global Variables</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A6E95530-F419-4837-B10A-E881A62AD5F9\"></a><div class=\"head\">\n            <h1>Local and Global Variables </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC511D\"></a> In MAXScript, there are two classes of variables that you can create: \"local\" and\n            \"global\" variables. When a variable is global, it means that the variable can be used\n            anywhere in the program. The only place you cannot use a global variable is before\n            you have defined it. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC511F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5120\"></a><p class=\"table-body\"> <em class=\"strong\">For example, the following lines will produce an error:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5065\"></a><pre>sphere radius:rad\nglobal rad = 10</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5126\"></a>The variable \"<span class=\"code\">rad</span>\" does not exist until it has been defined. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5127\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5128\"></a><p class=\"table-body\"> <em class=\"strong\">The following is an acceptable form of the previous lines:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5064\"></a><pre>global rad = 10\nsphere radius:rad</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC512E\"></a>Now that \"<span class=\"code\">rad</span>\" has been defined, MAXScript was able to use it in the definition of a sphere. In\n            fact, since \"<span class=\"code\">rad</span>\" is a global variable, it can be used throughout the rest of the script. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5130\"></a>There are several global variables that <em class=\"mild\">can</em> be used without defining them first. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5131\"></a>They are the system global variables, which have already been created and assigned\n            to a default value. Most of these variables can be reassigned to different values.\n            For more information on the system global variables, see the <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm\">3ds Max System Globals</a></span> topic in the MAXScript reference. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5133\"></a>Unlike global variables, local variables can be used only within the block in which\n            they are defined. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5134\"></a>A block is a grouping of MAXScript code, such as the statements within loops and conditional\n            statements. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5135\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5136\"></a><p class=\"table-body\"> <em class=\"strong\">HERE IS AN EXAMPLE OF A FOR LOOP</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5063\"></a><pre>for i = 1 to 3 do\n(\n  local rad = 10\n  s = sphere()\n  s.pos.x = i * 10\n  s.radius = rad\n)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5141\"></a>Local variables can only exist within a block. For this reason, they must be created\n            in a block. If you try to define a local variable from the top level of MAXScript,\n            you will receive an error message. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5142\"></a>In the previous example, you defined a local variable named \"<span class=\"code\">rad</span>\". This variable is active only within the parentheses inside the for loop; if you\n            attempt to use the variable \"<span class=\"code\">rad</span>\" elsewhere, you will get an error. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5143\"></a>Although <span class=\"code\">rad</span> is initialized to a specific value, this is not necessary. When you define variables\n            using a \"local\" or \"global\" identifier, you can do so without assigning an initial\n            value. The name of the variable will be recognized. However, the software will not\n            know the type of the variable (name, number, color, etc.). MAXScript automatically\n            assigns the variable a special value of \"undefined\". The first time you assign something\n            to the variable, it will become defined by the data type that you have assigned it\n            to. In practice, it is always best to define variables with an initial value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5144\"></a>It is important to note that <span class=\"code\">rad</span> is not the only local variable in the previous example. The variable \"<span class=\"code\">s</span>\" is also a local variable, and cannot be accessed outside of the parentheses. It\n            is not necessary to declare every variable with a \"global\" or \"local\" statement. You\n            learned previously that you can implicitly create a variable by simply assigning a\n            value to it. If you do not make the \"global\" or \"local\" distinction upon your variable,\n            MAXScript will create the appropriate association, depending on where the variable\n            is defined in the script. For example if you create a variable inside a block, MAXScript\n            automatically treats it as a local variable. On the other hand, any variable created\n            at the top level of MAXScript (outside of all blocks) is always a global variable.\n            As mentioned previously, MAXScript does not allow for the creation of local variables\n            outside of a block. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5145\"></a>These concepts are presented in the following \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5146\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5147\"></a><p class=\"table-body\"> <em class=\"strong\">HERE IS AN EXAMPLE OF A FOR LOOP</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5061\"></a><pre>for i = 1 to 5 do\n(\n  global rad = 10\n  cyl_height = 25\n  c = cylinder()\n  c.radius = rad\n  c.height = cyl_height\n  c.pos.x = i * 25\n)\ns = sphere radius:rad</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5156\"></a>In this example, four variables are created: <span class=\"code\">rad, cyl_height, c</span>, and <span class=\"code\">s</span>. Because they were implicitly created within a block, <span class=\"code\">c</span> and <span class=\"code\">cyl_height</span> are both local variables. The other two variables are both global; <span class=\"code\">s</span>, because it was created outside of a block, and <span class=\"code\">rad</span>, because it was declared as a global variable. For this reason, you can use<span class=\"code\">rad</span> again to define the sphere, <span class=\"code\">s</span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5158\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5159\"></a> <span class=\"char_link\"><a href=\"GUID-9CEB4477-35B7-45F1-907A-9F31DF9325D2.htm\">Defining Custom Functions</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";