var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A726F335-2CB0-4B65-B9A3-F546888C0A42\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"CUI Struct\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>CUI Struct - UI Customization</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A726F335-2CB0-4B65-B9A3-F546888C0A42\"></a><div class=\"head\">\n            <h1>CUI Struct - UI Customization </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D41\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D40\"></a> The CUI Struct provides methods and <em class=\"strong\">3ds Max</em> system globals related to the loading and saving of custom user interface files and\n               the management of custom user interface components and modes. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D3D\"></a>The following methods provide access to Custom User Interface (CUI) files: \n            </p> \n            <p><a name=\"GUID-89397312-DE65-4CED-88F9-A96258AC5B15\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E50\"></a><pre><em class=\"codeEmphasisStrong\">cui.getDir</em>() 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D3B\"></a>Returns the directory of the currently active CUI file as a string. \n            </p> \n            <p><a name=\"GUID-86399688-20C3-4461-9E60-2738F52CF675\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4F\"></a><pre><em class=\"codeEmphasisStrong\">cui.getConfigFile</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D38\"></a>Returns the currently active CUI file name as a string. \n            </p> \n            <p><a name=\"GUID-BE057CFD-69AE-4CFB-A231-A2C5017CBDFD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4E\"></a><pre><em class=\"codeEmphasisStrong\">cui.setConfigFile</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D35\"></a>Sets the currently active CUI file to the specified file name. \n            </p> \n            <p><a name=\"GUID-E0DE06F1-9A6F-4B14-BE15-73401DA6E052\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4D\"></a><pre><em class=\"codeEmphasisStrong\">cui.saveConfig</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D32\"></a>Saves the current CUI configuration data to the active .cui file \n            </p> \n            <p><a name=\"GUID-13BA01CE-51B9-4549-A3BC-2B31A68F55F8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4C\"></a><pre><em class=\"codeEmphasisStrong\">cui.saveConfigAs</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D2F\"></a>Saves current CUI configuration data to the specified file. The specified file is\n               made the current CUI file. \n            </p> \n            <p><a name=\"GUID-99A7062F-8DA6-4F81-9881-359DAAE2ACAA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4B\"></a><pre><em class=\"codeEmphasisStrong\">cui.loadConfig</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D2C\"></a>Loads the CUI configuration data from supplied file. The specified file is made the\n               current CUI file. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7585\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The Customize/Load Custom UI Scheme menu item is implemented as a macroScript. This\n                  macroScript is called <em class=\"strong\">macro_uischeme.mcr</em> in the <em class=\"strong\">\\ui\\macroscripts</em> directory, <span class=\"code\"> <em class=\"strong\">cui.loadConfig</em> </span> is only part of what needs to be done to switch over to a new UI scheme. The aforementioned\n                  macroScript will guide you through the other actions that also need to be performed.\n                  \n               </div>\n            </div> \n            <p><a name=\"GUID-4A7C62B9-02FB-4667-BE48-35C13FC14356\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E4A\"></a><pre><em class=\"codeEmphasisStrong\">cui.RegisterDialogBar</em> &lt;RolloutFloater_or_Rollout&gt; [<em class=\"codeEmphasisStrong\">minSize</em>:&lt;Point2&gt;] [<em class=\"codeEmphasisStrong\">maxSize</em>:&lt;Point2&gt;] [<em class=\"codeEmphasisStrong\">style</em>:&lt;Array&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D25\"></a>This method registers a MAXScript window as a dockable CUI window in MAX. \n            </p> \n            <p><a name=\"GUID-BA60E24F-4A22-4FDD-83E3-4CFA60E9DDB6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E49\"></a><pre><em class=\"codeEmphasisStrong\">cui.UnRegisterDialogBar</em> &lt;RolloutFloater_or_Rollout&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D22\"></a>This method un-registers a dockable MAXScript window. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D21\"></a>See <span class=\"char_link\"><a href=\"GUID-8A9EEAEF-DDD7-40E2-875A-D344BF1DB991.htm\">cui.RegisterDialogBar and cui.UnRegisterDialogBar</a></span> for details. \n            </p> \n            <p><a name=\"GUID-99D07A9A-7889-4F46-B887-8F069D200DB2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E48\"></a><pre><em class=\"codeEmphasisStrong\">cui.DockDialogBar</em> &lt;RolloutFloater_or_Rollout&gt; &lt;dockflag&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D1E\"></a>This method docks a registered dialog bar to the specified docking area. \n            </p> \n            <p><a name=\"GUID-318C42EF-6935-4308-91F6-64FD4F07B96B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E47\"></a><pre><em class=\"codeEmphasisStrong\">cui.FloatDialogBar</em> &lt;RolloutFloater_or_Rollout&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D1B\"></a>This method will float a registered dialog bar. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D1A\"></a>See <span class=\"char_link\"><a href=\"GUID-A0895201-5DDE-4268-8A7A-69384A24EB62.htm\">cui.DockDialogBar and cui.FloatDialogBar</a></span> for details. \n            </p> \n            <p><a name=\"GUID-968F7BBE-8956-475F-9338-111AA5B7840D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E46\"></a><pre><em class=\"codeEmphasisStrong\">cui.getDockState</em> &lt;RolloutFloater_or_Rollout&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D17\"></a>This method returns the current dock state of the registered dialog bar. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D16\"></a>See <span class=\"char_link\"><a href=\"GUID-6C646AA0-B7D5-409D-8D69-77877C25459A.htm\">cui.getDockState</a></span> for details. \n            </p> \n            <p><a name=\"GUID-099F3204-618E-4114-BCE6-9B379D82D048\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E45\"></a><pre><em class=\"codeEmphasisStrong\">cui.commandPanelOpen : Booleans</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D13\"></a>This <em class=\"strong\">3ds Max</em> system global variable lets you get and set whether the command panel is displayed\n               or not. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D12\"></a>See <span class=\"char_link\"><a href=\"GUID-D2A6D67D-60D6-4068-80E2-7C16496213CF.htm\">Command Panels</a></span> for details. \n            </p> \n            <p><a name=\"GUID-B71B6E45-6326-466F-980A-49BA19059FF4\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">cui.showToolbar</em> &lt;string&gt;</pre></div> \n            <p><a name=\"GUID-AC124FFA-B0CE-471F-B526-44755CA43754\"></a> Displays the Toolbar specified by name. \n            </p> \n            <p><a name=\"GUID-EA7F9CB0-A8DF-4590-801B-DFF923461386\"></a>Returns True on success, False if the toolbar name does not exist. \n            </p> \n            <p><a name=\"GUID-CE2799E7-D93C-4AAF-B3F5-B15391E5EA68\"></a>Available in <em class=\"strong\">3ds Max 2014 and higher</em>. \n            </p> <a name=\"TABLE_8D8E7FAEAD8C463D8DBC868F291B4091\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"P_1C8154BEECC44BF581C3A1BF01F98D2A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"P_8A1A7F72F0E94E1985AB4236F6EFFEA6\"></a><pre>cui.showToolbar \"Brush Presets\"</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-861AD2B2-BE0A-4833-9B64-FD7152C68E45\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E44\"></a><pre><em class=\"codeEmphasisStrong\">cui.expertModeOn()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D0F\"></a>Turns expert mode on. \n            </p> \n            <p><a name=\"GUID-3B213E3D-2F43-424A-A20C-BB46496ADE85\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E43\"></a><pre><em class=\"codeEmphasisStrong\">cui.expertModeOff()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D0C\"></a>Turns expert mode off. \n            </p> \n            <p><a name=\"GUID-8E0BE2E4-8C30-45F1-A530-906B23BBF39D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E42\"></a><pre><em class=\"codeEmphasisStrong\">cui.getExpertMode()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D09\"></a>Returns True of expert mode is on, False if it is off. \n            </p> \n            <p><a name=\"GUID-04AB8F77-7F43-4575-8B96-4465A568D1A8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E41\"></a><pre><em class=\"codeEmphasisStrong\">cui.setAppTitle</em> &lt;string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D07\"></a>This method sets the title bar of the main <em class=\"strong\">3ds Max</em> window to the specified string. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7584\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-520E99EA-0E1A-4BE2-B1AC-28E6C5E7F2CB\"></a>The title string will be automatically reset to default on file operations like Reset,\n                     New, Open etc. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3D00\"></a> <span class=\"char_link\"><a href=\"GUID-F122718E-CC36-4CAB-8947-527F608FC184.htm\">Menu and CUI Loading</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3CFF\"></a> <span class=\"char_link\"><a href=\"GUID-7BCF183F-F45E-4AD3-8179-2BEE2154F1FD.htm\">Custom User Interface Files</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3CFE\"></a> <span class=\"char_link\"><a href=\"GUID-8A9EEAEF-DDD7-40E2-875A-D344BF1DB991.htm\"> cui.RegisterDialogBar and cui.UnRegisterDialogBar</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3CFD\"></a> <span class=\"char_link\"><a href=\"GUID-A0895201-5DDE-4268-8A7A-69384A24EB62.htm\"> cui.DockDialogBar and cui.FloatDialogBar</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3CFC\"></a> <span class=\"char_link\"><a href=\"GUID-6C646AA0-B7D5-409D-8D69-77877C25459A.htm\">cui.getDockState</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3CFB\"></a> <span class=\"char_link\"><a href=\"GUID-D2A6D67D-60D6-4068-80E2-7C16496213CF.htm\">Command Panels</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";