var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A731E672-9B9A-4D5B-A8A7-EA584AD12FE5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Disable Undo system when possible</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A731E672-9B9A-4D5B-A8A7-EA584AD12FE5\"></a><div class=\"head\">\n            <h1>Disable Undo system when possible </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1288\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC128A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC128B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Disable Undo system when possible \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC128E\"></a>The undo system can consume large amounts of memory and slow down processing. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC128F\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1291\"></a>MAXScript commands run from Listener. Script Editor or Macro Script are run within\n                  an undo on context. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1293\"></a>MAXScript commands run from scripted UI controls are <em class=\"strong\">not</em> run within an undo on context. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1295\"></a>Do not delete nodes with undo off, unless you also created the nodes with undo off\n                  and did not do anything to the node with undo on. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1297\"></a>When working with meshes, you typically want to use meshop methods as they support\n                  undo/redo. But typically you do not want to store undo records for all operations\n                  in a loop, just the first and last. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1299\"></a>When working with EPoly, you want to store undo records for all operations in a loop.\n                  \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC129B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC129C\"></a><p class=\"table-body\"> <em class=\"strong\">TEST CASE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6630\"></a><pre>\nem = mesh()\nmeshop_setvert = meshop.setvert\nfn test7 holdAll =\n(\n&nbsp;local nVerts = getnumverts em\n&nbsp;for i = 1 to nVerts do\n&nbsp;&nbsp;with undo (holdAll or (i == 1 or i == nVerts))\n&nbsp;&nbsp;&nbsp;meshop_setvert em i ([1,1,1]*i)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12A9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12AA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR 100,000 ITERATIONS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662F\"></a><pre>\ntest7 true&nbsp;-- 85313 msec., 229 MB\ntest7 false-- 7609 msec., 11 MB\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12B1\"></a>Every operation that creates an undo record will cost time and memory as it will create\n            internal copies of the changing objects to allow an undo later. When making multiple\n            changes in a loop like for example attaching multiple objects together, the Undo system\n            would attempt to create a single undo copy of each resulting object and might even\n            run out of memory. Disabling Undo explicitly using the <span class=\"code\">Undo off ()</span> context can help to speed up scripts significantly in such cases. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12B2\"></a> <span class=\"char_link\"><a href=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11.htm\">undo</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12B3\"></a>The following extreme example shows the difference. In both cases, 1000 boxes will\n            be created using MAXScript and then attached to a single mesh using the attach function.\n            In the first case, each attach call will generate by default an undo record. In the\n            second case, the undo will be explicitly disabled. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12B4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12B5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1 - UNOPTIMIZED SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662E\"></a><pre>\ndelete $Box*--delete any existing boxes\nbox_array = #()--initialize an array\nfor i = 1 to 1000 do--repeat 1000 times\n  box_array[i] = box pos:[i*30,0,0]--create 1000 boxes\nst = timestamp()--get the start time in milliseconds\nmaster_box = convertToMesh box_array[1]--collapse the first box to mesh\nfor i = 2 to 1000 do--go through all other boxes\n  attach master_box box_array[i]--attach each box to the mesh\net = timestamp()--stop the time\nprint (et-st)--print the resulting time\ngc()--call Garbage Collection &amp;endash; you will needed it!\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12C4\"></a><p class=\"table-body\">On a 800MHz PC, the execution of the attaching part of the script took more than a\n                        minute mainly because the system run out of memory and the OS had to swap to disk.\n                        Memory usage for <em class=\"strong\">3ds Max</em> went up with about 300 MB! \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12C7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12C8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2 - OPTIMIZED SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-662D\"></a><pre>\ndelete $Box*\nbox_array = #()\nfor i = 1 to 1000 do\nbox_array[i] = box pos:[i*30,0,0]\nst = timestamp()\nundo off--the only difference - the undo\n(--has been turned off\n  master_box = convertToMesh box_array[1]\nfor i = 2 to 1000 do\n  attach master_box box_array[i]\n)--end undo off\net = timestamp()\nprint (et-st)\n--call Garbage Collection - you will needed it!\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12D9\"></a><p class=\"table-body\">On the same 800MHz machine, the execution of the attaching part of the script took\n                        only 3685 milliseconds, almost 20 times faster! There were no memory consumption changes\n                        visible in the Windows Task Manager. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12DC\"></a> <em class=\"strong\">Previous Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12DD\"></a> <span class=\"char_link\"><a href=\"GUID-75BB21C9-2283-49BD-853C-78006717FBE2.htm\">Disable Viewport Redraws when making changes to scene objects</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12DE\"></a> <em class=\"strong\">Next Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC12DF\"></a> <span class=\"char_link\"><a href=\"GUID-CD2CE8D0-D478-4BF2-A52D-1BF0424A31A6.htm\">Modify Panel can be slow -change to Create Panel when possible</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";