var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A7CB37DD-5852-4C55-8C38-3335C56F9D01\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Access To CATRigs\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Access To CATRigs</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A7CB37DD-5852-4C55-8C38-3335C56F9D01\"></a><div class=\"head\">\n            <h1>MAXScript Access To CATRigs </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C99\"></a>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E2\"></a> The following page provides an overview of the various major components of the <em class=\"strong\">3ds Max CAT</em> animation system, their Function Publishing Interfaces, and possible MAXScript access\n            approaches. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E3\"></a> \n            <h2><a name=\"GUID-1C61A15D-E3EA-4B43-AF14-E49DC09A9879\"></a> <em class=\"strong\">CATParent</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E4\"></a>The <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent Helper Object</a></span> stores the common shared information about a character rig including the name of\n               the rig and the [<span class=\"char_link\"><a href=\"GUID-96413459-CF04-4959-932A-08630C59014D.htm\">CATUnits Ratio</a></span>] value. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E5\"></a>It also holds the layers system details including the name of each layer and its global\n               weight. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E6\"></a>It provides some useful arrays listing all controllers and all nodes used in the rig\n               for fast iterations through all components using MAXScript. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E7\"></a>The <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent</a></span> exposes the following two Function Publishing Interfaces: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E8\"></a> <span class=\"char_link\"><a href=\"GUID-D0888B54-7E5F-434F-BB8A-4BA1577A5B97.htm\">Interface: CATParentFPInterface</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67E9\"></a> <span class=\"char_link\"><a href=\"GUID-D3F998FD-2F74-4393-B705-B3B12F6EE9CD.htm\">Interface: LayerRootFPInterface</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67EB\"></a>To create a new character using a pre-saved Rig file, you can simply create a new\n               <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent Helper</a></span> and call the <span class=\"code\">LoadRig()</span> function of the <span class=\"char_link\"><a href=\"GUID-D0888B54-7E5F-434F-BB8A-4BA1577A5B97.htm\">CATParentFPInterface</a></span>: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67EC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67ED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504B\"></a><pre>\ntheParent = CATParent()--create a new CATrig parent:\n$Object:Character001 @ [0.000000,0.000000,0.000000]\ntheParent.LoadRig (GetDir #plugcfg +\"\\\\CAT\\\\CATRigs\\\\Marine\\\\Marine.rg3\")\ntrue\ntheParent--note that loading a rig deletes the original parent!\n &lt;Deleted scene node&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_92B150CF174444C4B1AF69FD27051C46\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1476235442241105%\">\n                     <col width=\"54.170601196096946%\">\n                     <col width=\"42.681775259678936%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_AE400232BF854DD4A6D1A7E5EC35A758\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_4A09B88C32BB4E9CA0D9A6FFBB0BDE13\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9A\"></a></p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67F8\"></a> \n            <h2><a name=\"GUID-49AC6B9C-0B30-404F-886F-7AC490165254\"></a> <em class=\"strong\">CATControl</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67F9\"></a> <em class=\"strong\">3ds Max CAT</em> can be described as a hierarchy of controllers and nodes. Each bone is represented\n               by a controller (CATControl) managing the bone\'s behavior, animation and functionality,\n               and a CATBone scene object used mainly for display, Skin Deformations, and rendering.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67FA\"></a>Every bone controller in the CATRig structure exposes the <span class=\"char_link\"><a href=\"GUID-367D9339-35CF-4950-9132-65A8C9AC42B9.htm\">CATControlInterface</a></span>. This means that every bone can return the <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent</a></span> and a name and can be used to save or load clip files or paste a layer. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67FC\"></a>You can use the <span class=\"code\"> <em class=\"strong\">.CATPatent</em> </span> property exposed by the <span class=\"char_link\"><a href=\"GUID-367D9339-35CF-4950-9132-65A8C9AC42B9.htm\">CATControlInterface</a></span> to access the <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent</a></span> from any CATBone. For example, if you have a pointer to a finger or an arm bone,\n               you can easily find out the CATParent and perform all the loading, saving, and layer\n               operations using it. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67FD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67FE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504A\"></a><pre>\ntheParent = CATParent()--create a new CATrig parent:\n--&gt; $Object:Character001 @ [0.000000,0.000000,0.000000]\nrig_path = GetDir #maxroot + \"\\\\plugcfg_ln\\\\CAT\\\\CATRigs\\\\Marine\\\\Marine.rg3\"\ntheParent.loadRig rig_path\n--&gt; true\ntheParent--note that loading a rig deletes the original parent.\n--&gt;&lt;Deleted scene node&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6806\"></a>Each bone controller also exposes the <span class=\"char_link\"><a href=\"GUID-6AD3551C-6AE4-4120-8CD1-CB3C78C09D50.htm\">CATNodeControlFPInterface</a></span> interface that provides properties and methods related to arbitrary bones management,\n               transformation matrix access in various coordinate systems, ans so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6807\"></a>The <span class=\"char_link\"><a href=\"GUID-2D024908-FB79-45B0-BC5C-DA247F7B0467.htm\">ExtraRigNodesInterface</a></span> lets you add and remove extra rig nodes and access the array of extra rig nodes.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6809\"></a>You can always access the corresponding scene node of a bone controller by using its\n               <span class=\"code\">.node</span> property: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC680A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC680B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC680C\"></a><p class=\"table-body\">If you select a bone that has extra bones added to it such as, a head bone that has\n                           facial bones, you can use the following: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5049\"></a><pre>\ntheHeadCtrl =$MarineHead[3]--get the Head\'s controller:\ntheArbBone = theHeadCtrl.GetArbBone 1--get its first arbitrary bone:\ntheArbBone.node--get the scene node of that bone:\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6812\"></a><p class=\"table-body\">You will now have the node of the first extra bone that is attached to the head bone.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-5776AA8512A55EE963C-7D00\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6817\"></a>Internally, an \"Extra\" bone is called an \"Arb\" (shot for \"Arbitrary\") bone. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6818\"></a>An <span class=\"char_link\"><a href=\"GUID-7BFF20C3-A548-4BAC-A801-304FDB1CBF67.htm\">ArbBone</a></span> has no predefined use, unlike digit, limb, spine, or tail bones that provide respective\n                     built-in behavior to simulate fingers, arms, legs, spines, and tails. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9B\"></a></p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC681B\"></a> \n            <h2><a name=\"GUID-CBE51631-0D10-40B4-A44F-96E85C905B13\"></a> <em class=\"strong\">Hubs</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC681C\"></a>The Hub is a special bone where multiple specialized bone groups such as, limbs, spines,\n               and tails can be connected to the rig. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC681D\"></a>The Hub bone exposes a unique <span class=\"char_link\"><a href=\"GUID-E87AD4FE-C495-4EF1-ADEA-56C48A75F144.htm\">HubFPInterface</a></span> for features available only to Hubs. This includes the adding of spines, arms, legs,\n               and tails. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9C\"></a></p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6820\"></a> \n            <h2><a name=\"GUID-0FC2826C-DD80-4F7E-8A66-E1896329C249\"></a> <em class=\"strong\">Limbs</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6821\"></a>Limbs are bones dedicated to the creation of arms and legs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6822\"></a>All Limb Bone controllers expose the following Interfaces: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6823\"></a> <span class=\"char_link\"><a href=\"GUID-B69FF2D2-12CC-4817-8DAC-B2FA7B721149.htm\">Interface: LimbFPInterface</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6824\"></a> <span class=\"char_link\"><a href=\"GUID-367D9339-35CF-4950-9132-65A8C9AC42B9.htm\">Interface: CATControlInterface</a></span> \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9D\"></a></p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6827\"></a> \n            <h2><a name=\"GUID-E15FB862-EC14-40B3-AA9F-3EDC3BEF2CE9\"></a> <em class=\"strong\">Tails</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6828\"></a>Tail bone controllers are dedicated to the creation of tails. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6829\"></a>The <span class=\"char_link\"><a href=\"GUID-12DA76AC-7DE2-48DE-8DE6-D2D7F11F6923.htm\">TailTrans controller</a></span> exposes the following Interfaces: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC682A\"></a> <span class=\"char_link\"><a href=\"GUID-367D9339-35CF-4950-9132-65A8C9AC42B9.htm\">Interface: CATControlInterface</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC682B\"></a> <span class=\"char_link\"><a href=\"GUID-6AD3551C-6AE4-4120-8CD1-CB3C78C09D50.htm\">Interface: CATNodeControlFPInterface</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC682C\"></a> <span class=\"char_link\"><a href=\"GUID-2D024908-FB79-45B0-BC5C-DA247F7B0467.htm\">Interface: ExtraRigNodesInterface</a></span> \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9E\"></a></p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC682F\"></a> \n            <h2><a name=\"GUID-A2FBDCB6-981D-4E8A-B327-AC3B47C1947D\"></a> <em class=\"strong\">CATObjects</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6830\"></a>All CATBones use a CATObject to display their geometry in the viewport. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6831\"></a>The CATObject exposes the <span class=\"char_link\"><a href=\"GUID-38E05EC7-7AA4-407D-8DBA-3BAE7A459FB8.htm\">CATObjectFPInterface</a></span> that provides control over the custom mesh display. \n            </p> \n         </div><a name=\"TABLE_E4FABCC303B948AFA176EC6A285E329A\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.1476235442241105%\">\n                  <col width=\"54.170601196096946%\">\n                  <col width=\"42.681775259678936%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\"> <a name=\"P_6AE6D0D14E68443EB5DC6D11058DD369\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_5006C107DA1C4634A6FDD367BA6C88BC\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6834\"></a> <span class=\"char_link\"><a href=\"GUID-7664D95A-A27D-4356-8442-F53064920BF8.htm\">3ds Max CAT and MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";