var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-A81EA1A3-BE58-4A69-BB30-474F805D5E81\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Active X Inspector Functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Active X Inspector Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A81EA1A3-BE58-4A69-BB30-474F805D5E81\"></a><div class=\"head\">\n            <h1>Active X Inspector Functions </h1>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75B5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C35\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                  Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C34\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                  on the system to be accessible to MAXScript. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C33\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C30\"></a>The following Inspector Functions can be used to acquire lists of available ActiveX\n            Controls and their methods, events, and properties: \n         </p>\n         <p><a name=\"GUID-967E029C-51BB-4912-9EB8-9BA6545C99B0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712F\"></a><pre><em class=\"codeEmphasisStrong\">showAllActiveXControls</em> [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ] 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C2E\"></a>Prints a list of ActiveX controls with their progID and classID, registered on your\n            system. \n         </p>\n         <p><a name=\"GUID-95F6F15F-E81E-4461-8653-54CDC52AD4DE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712E\"></a><pre><em class=\"codeEmphasisStrong\">showMethods</em>&lt;axControl&gt; [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ] [ <em class=\"codeEmphasisStrong\">showHidden</em>:&lt;false&gt;]   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C2B\"></a>Prints a list of methods and their arguments that can be invoked on the control \n         </p>\n         <p><a name=\"GUID-B91B69DA-8AA9-43BC-8682-F78631A651A1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712D\"></a><pre><em class=\"codeEmphasisStrong\">showEvents</em> &lt;axControl&gt; [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C28\"></a>Prints a list of events and their arguments that are sent by the control \n         </p>\n         <p><a name=\"GUID-98032FEE-14F9-4E74-A99C-2FF5067AB541\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712C\"></a><pre><em class=\"codeEmphasisStrong\">showProperties</em> &lt;axControl&gt; [ <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; ] [<em class=\"codeEmphasisStrong\">showHidden</em>:&lt;false&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C25\"></a>Prints a list of the properties and their types, supported by the control. Some properties\n            are marked read-only \n         </p>\n         <p><a name=\"GUID-DB3474A2-A5D3-4C10-B9B3-98CB81661382\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712B\"></a><pre><em class=\"codeEmphasisStrong\">getPropNames</em> &lt;axControl&gt; [<em class=\"codeEmphasisStrong\">showHidden</em>:&lt;false&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C22\"></a>Returns an array of the properties supported by the control \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C21\"></a>where \n         </p>\n         <p><a name=\"GUID-93227D3F-592F-46B1-A9CC-929D38D7F7D7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-712A\"></a><pre><em class=\"codeEmphasisStrong\">to:&lt;</em>stream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C1F\"></a>is the output stringstream. \n         </p>\n         <p><a name=\"GUID-3D5D227C-3B47-4D5C-A7C8-572203C6F092\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7129\"></a><pre><em class=\"codeEmphasisStrong\">showHidden:&lt;</em>boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C1D\"></a>controls whether hidden properties/methods should be included in the enumeration.\n            The default value is false. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C1C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C1B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7128\"></a><pre>\nrollout test \"Test\"\n(\n  activeXControl lv \"MSComctlLib.ListViewCtrl\"\n  on test open do\n  (\n    format \"PROPERTIES:\\n\"\n    showProperties lv\n    format \"METHODS:\\n\"\n    showMethods lv\n    format \"EVENTS:\\n\"\n    showEvents lv\n  )\n)\ncreateDialog test\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C0A\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7127\"></a><pre>\nRollout:test\nPROPERTIES:\n.Arrange : ListArrangeConstants( #lvwNone | #lvwAutoLeft | #lvwAutoTop )\n.ColumnHeaders : IColumnHeaders\n.DropHighlight : IListItem\n.DropHighlight : undefined, read-only\n.HideColumnHeaders : boolean\n.HideSelection : boolean\n.Icons : IVBDataObject\n.Icons : undefined, read-only\n.ListItems : IListItems\n.LabelEdit : ListLabelEditConstants( #lvwAutomatic | #lvwManual )\n.LabelWrap : boolean\n.MouseIcon : IPictureDisp\n.MousePointer : MousePointerConstants( #ccDefault | #ccArrow | #ccCross | #ccIBeam | #ccIcon | #ccSize | #ccSizeNESW | #ccSizeNS | #ccSizeNWSE | #ccSizeEW | #ccUpArrow | #ccHourglass | #ccNoDrop | #ccArrowHourglass | #ccArrowQuestion | #ccSizeAll | #ccCustom )\n.MultiSelect : boolean\n.SelectedItem : IListItem\n.SelectedItem : undefined, read-only\n.SmallIcons : IVBDataObject\n.SmallIcons : undefined, read-only\n.Sorted : boolean\n.SortKey : integer\n.SortOrder : ListSortOrderConstants( #lvwAscending | #lvwDescending )\n.View : ListViewConstants( #lvwIcon | #lvwSmallIcon | #lvwList | #lvwReport )\n.OLEDragMode : OLEDragConstants( #ccOLEDragManual | #ccOLEDragAutomatic )\n.OLEDropMode : OLEDropConstants( #ccOLEDropNone | #ccOLEDropManual )\n.Appearance : AppearanceConstants( #ccFlat | #cc3D )\n.BackColor : OLE_COLOR\n.BorderStyle : BorderStyleConstants( #ccNone | #ccFixedSingle )\n.Enabled : boolean\n.Font : IFontDisp\n.ForeColor : OLE_COLOR\n.hWnd : OLE_HANDLE\n.AllowColumnReorder : boolean\n.Checkboxes : boolean\n.FlatScrollBar : boolean\n.FullRowSelect : boolean\n.GridLines : boolean\n.HotTracking : boolean\n.HoverSelection : boolean\n.Picture : IPictureDisp\n.PictureAlignment : ListPictureAlignmentConstants( #lvwTopLeft | #lvwTopRight | #lvwBottomLeft | #lvwBottomRight | #lvwCenter | #lvwTile )\n.ColumnHeaderIcons : IVBDataObject\n.ColumnHeaderIcons : undefined, read-only\n.TextBackground : ListTextBackgroundConstants( #lvwTransparent | #lvwOpaque )\nMETHODS:\n.FindItem sz:string Where:undefined Index:undefined fPartial:undefined\n.GetFirstVisible()\n.HitTest x:float y:float\n.StartLabelEdit()\n.OLEDrag()\n.Refresh()\nEVENTS:\non &lt;control_name&gt; BeforeLabelEdit Cancel:integer do ( ... )\non &lt;control_name&gt; AfterLabelEdit Cancel:integer NewString:string do ( ... )\non &lt;control_name&gt; ColumnClick ColumnHeader:ColumnHeader do ( ... )\non &lt;control_name&gt; ItemClick Item:ListItem do ( ... )\non &lt;control_name&gt; KeyDown KeyCode:integer Shift:integer do ( ... )\non &lt;control_name&gt; KeyUp KeyCode:integer Shift:integer do ( ... )\non &lt;control_name&gt; KeyPress KeyAscii:integer do ( ... )\non &lt;control_name&gt; MouseDown Button:integer Shift:integer x:OLE_XPOS_PIXELS y:OLE_YPOS_PIXELS do ( ... )\non &lt;control_name&gt; MouseMove Button:integer Shift:integer x:OLE_XPOS_PIXELS y:OLE_YPOS_PIXELS do ( ... )\non &lt;control_name&gt; MouseUp Button:integer Shift:integer x:OLE_XPOS_PIXELS y:OLE_YPOS_PIXELS do ( ... )\non &lt;control_name&gt; Click do ( ... )\non &lt;control_name&gt; DblClick do ( ... )\non &lt;control_name&gt; OLEStartDrag &amp;Data:DataObject &amp;AllowedEffects:integer do ( ... )\non &lt;control_name&gt; OLEGiveFeedback &amp;Effect:integer &amp;DefaultCursors:boolean do ( ... )\non &lt;control_name&gt; OLESetData &amp;Data:DataObject &amp;DataFormat:integer do ( ... )\non &lt;control_name&gt; OLECompleteDrag &amp;Effect:integer do ( ... )\non &lt;control_name&gt; OLEDragOver &amp;Data:DataObject &amp;Effect:integer &amp;Button:integer &amp;Shift:integer &amp;x:float &amp;y:float &amp;State:integer do ( ... )\non &lt;control_name&gt; OLEDragDrop &amp;Data:DataObject &amp;Effect:integer &amp;Button:integer &amp;Shift:integer &amp;x:float &amp;y:float do ( ... )\non &lt;control_name&gt; ItemCheck Item:ListItem do ( ... )\ntrue\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4BBD\"></a> \n            <h2><a name=\"GUID-5C81A6B8-D341-46E7-A4F7-166EA7ECE78B\"></a> <em class=\"strong\">Type Conversion</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4BBC\"></a>All supported COM datatypes are converted to an appropriate MAXScript wrapper when\n               passed to and from a COM object. Here are the supported types and their mapping: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7126\"></a><pre>undefined - VT_EMPTY\nboolean - VT_BOOL\ninteger - VT_UI1\ninteger - VT_UI2\ninteger - VT_UI4\ninteger - VT_UI8\ninteger - VT_I1\ninteger - VT_I2\ninteger - VT_I4\ninteger - VT_I8\nfloat - VT_R4\nfloat - VT_R8\nstring - VT_BSTR\nfloat - VT_CY\ndate - VT_DATE\nerror - VT_ERROR\ncolor - VT_COLOR\nMSDispatch - VT_DISPATCH\nfont - VT_FONT\nundefined - VT_UNKNOWN\nComArray - VT_SAFEARRAY\nComArray - VT_CARRAY\nComArray - VT_ARRAY</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4BA4\"></a>Valid string handling for property sets and method call arguments, you can safely\n               do \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4BA3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4BA2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7125\"></a><pre>\nax.Navigate\"http://www.autodesk.com\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B9E\"></a><p class=\"table-body\">where: ax is the Microsoft Web Browser Control </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75B4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Restricted functions like QueryInterface, AddRef, Release are displayed by <span class=\"code\">showMethods()</span> function. \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B96\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";