var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-AB7D2A56-0AEE-48FE-8D59-7862B88421FA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Metaball Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Metaball Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AB7D2A56-0AEE-48FE-8D59-7862B88421FA\"></a><div class=\"head\">\n            <h1>Metaball Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8496E\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8496F\"></a>The following example shows a sample Metaball script using the Parray particle system.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84970\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84971\"></a>Should be used in a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84972\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-50BD3B68-7541-4956-8FBF-47FF52A51137-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84973\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84974\"></a>In the Proceed handler, a new Mesh object is created with a vertex at each particle.\n            Then, a PArray classical particle system is created and used to generate a metaball\n            mesh out of all vertices of the supplied mesh. Now, using a Mesher compound object,\n            a snapshot of the metaball is made and used as the shape of the first particle. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84975\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-9144CDEC-AC18-4535-AA32-81FCE4644FC3-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84976\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84977\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0E\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.usePosition = true\npCont.useTime = true\npCont.useSpeed = true\npCont.useShape = true\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \non Proceed pCont do\n(\n--Get the start and end times\nt1 = pCont.getTimeStart() as float\nt2 = pCont.getTimeEnd() as float\n \n--As long as there are particles \nif (pCont.NumParticles() &gt; 0) then\n(\n--Disable screen redraws to keep speed up\nwith redraw off\n(\n-- create an empty mesh\nnMesh = editable_mesh()\n-- Set the number of vertices and faces to the\n-- number of particles.\nnMesh.numVerts = pCont.NumParticles()\nnMesh.numFaces = pCont.NumParticles()\n--We will make a single vertex for each particle\nfor i in 1 to pCont.NumParticles() do\n(\n-- Time for the particle to travel at this integration step\ntimeStep = t2 - (pCont.getParticleTime(i) as float)\n-- Speed is added to foresee the particle position at the end\n-- of the integration step\nnMesh.verts[i] = pCont.getParticlePosition(i) + timeStep * pCont.getParticleSpeed(i)\n-- The face references the same vertex 3 times!\nnMesh.faces[i] = [i,i,i]\n)\n \n-- create PArray with particles on vertices of the mesh\na = PArray()\na.speed = 0\na.formation = 2-- at all vertices\na.quantityMethod = 1--use Total\na.Total_Number = 1--just initializing\na.viewPercent = 100\na.Emitter_Start = 0f\na.Emitter_Stop = 0f\na.subsampleCreationTime =off\na.Display_Until = 2000f\na.life = 2000f\na.Growth_Time = 0f\na.Fade_Time = 0f\na.particleType = 1--metaballs\na.metaballAutoCoarsness =off\na.metaballRenderCoarsness = 0.9\na.metaballViewCoarsness = 0.9\na.Metaparticle_Tension = 1.0\na.size = 5\na.Total_Number = pCont.NumParticles()--use particles count\na.emitter = nMesh\n \n-- acquire the metaball mesh from the PArray\nmshr = mesher() --create a Mesher Compound object\nmshr.pick = a --get the PArray\nmetaballMesh = snapshot mshr --make a snapshot of the Mesher\ndelete a --delete the PArray\ndelete #(mshr, nMesh) --delete the Mesher and our mesh\n \n-- speed is added to foresee the particle position at the end\n-- of the integration step\ntimeStep = t2 - (pCont.getParticleTime(1) as float)\nspaceOffset = pCont.getParticlePosition(1) + timeStep * pCont.getParticleSpeed(1)\n-- adjust vertex location to center around the first particle\nfor i in 1 to metaballMesh.verts.count do\n( move metaballMesh.verts[i] (-spaceOffset) )\n--Create an empty mesh to assign to all particles\nemptyMesh = editable_mesh()\n--Assign the empty mesh to all particles.\n--This makes them invisible\npCont.setShapeForAllParticles(emptyMesh.mesh)\n--First particle carries all the mesh data\npCont.setParticleShape 1 metaballMesh.mesh\n--Delete the empty mesh and the snapshot\ndelete #(emptyMesh, metaballMesh)\n) \n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n \n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849E6\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849E7\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";