var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-AC26099B-60BF-4C99-997B-DF65F8D47DC1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface : CustomControlsOptions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AC26099B-60BF-4C99-997B-DF65F8D47DC1\"></a><div class=\"head\">\n            <h1>Interface : CustomControlsOptions </h1>\n         </div>\n         <p> This Core Interface can be used for debugging custom controls like Qt icons and text\n            clipping. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2804\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CustomControlsOptions.PrintIconPaths</em> : bool : Read|Write</pre></div>\n         <p> Get/set the state of the Print Icon Paths feature. \n            	 \n         </p>\n         <p> When set to True, rolling the mouse pointer over a custom control containing an icon\n            will print information about its path to the MAXScript Listener. \n            	 \n         </p>\n         <p> When set to False (default), no icon path information will be printed. \n            	 \n         </p><a name=\"TABLE_4E15F662853243C3B79878EABF749275\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-F16B3F88-A91F-44BA-B2C3-5E30ABB1904B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nCustomControlsOptions.PrintIconPaths = true --enable the printing of icon paths\ntrue\n\n--Roll over the Render icon in the Main Toolbar.\nPath of this control\'s QIcon: [C:\\Program Files\\Autodesk\\3ds Max 2017\\UI_LN\\IconsDark.rcc] MainToolbar\\RenderProduction\nIconSize: 24x24 (native) IconState: off\nAvailable Files: RenderProduction_24.png, RenderProduction_30.png, RenderProduction_36.png, RenderProduction_48.png\n\n--Then roll over the “Box” button in the Create tab of the Modifier Panel which does not have an icon.\nIcon does not exist (no icon on this CustButton)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CustomControlsOptions.PrintTextClippingIssues</em> : bool : Read|Write</pre></div>\n         <p> Get/set the state of the Print Text Clipping Issues feature. \n            	 \n         </p>\n         <p> When set to True, Custom Controls whose text exceeds the control\'s size along X or\n            Y will be reported to the MAXScript Listener. \n            	 \n         </p>\n         <p> When set to False (default), no issues will be reported. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CustomControlsOptions.TextClippingIssuesSensitivityX</em> : integer : Read|Write</pre></div>\n         <p> Get/set the X Sensitivity value for the Print Text Clipping Issues feature. \n            	 \n         </p>\n         <p> This value defined the threshold above which clipping issues along X will be reported.\n            \n            	 \n         </p>\n         <p> Default is 1. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CustomControlsOptions.TextClippingIssuesSensitivityY</em> : integer : Read|Write</pre></div>\n         <p> Get/set the Y Sensitivity value for the Print Text Clipping Issues feature. \n            	 \n         </p>\n         <p> This value defined the threshold above which clipping issues along Y will be reported.\n            \n            	 \n         </p>\n         <p> Default is 1. \n            	 \n         </p><a name=\"TABLE_559491FADA6D477B8D88BFE5DA551BCF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nCustomControlsOptions.PrintTextClippingIssues = true --enable the clipping issues printing\ntrue\n--Then open Material Editor and expand the Maps rollout of any Standard Material:\nUI CLIPPING ERROR: hwnd: 0x60DAE - Static text clipped: \'Map Type\' (22 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x50E8E - Checkbox text clipped: \'Ambient Color . . . . . . . . . . . . . . . . .\' (98 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CEE - Checkbox text clipped: \'Diffuse Color . . . . . . . . . . . . . . . . .\' (93 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x50E4E - Checkbox text clipped: \'Specular Color  . . . . . . . . . . . . . . . .\' (96 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60C80 - Checkbox text clipped: \'Specular Level  . . . . . . . . . . . . . . . .\' (96 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D5A - Checkbox text clipped: \'Glossiness  . . . . . . . . . . . . . . . . . .\' (90 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D40 - Checkbox text clipped: \'Self-Illumination . . . . . . . . . . . . . . .\' (93 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D38 - Checkbox text clipped: \'Opacity . . . . . . . . . . . . . . . . . . . .\' (89 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CE8 - Checkbox text clipped: \'Filter Color  . . . . . . . . . . . . . . . . .\' (86 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D60 - Checkbox text clipped: \'Bump  . . . . . . . . . . . . . . . . . . . . .\' (88 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D1E - Checkbox text clipped: \'Reflection  . . . . . . . . . . . . . . . . . .\' (89 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D82 - Checkbox text clipped: \'Refraction  . . . . . . . . . . . . . . . . . .\' (91 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CD6 - Checkbox text clipped: \'Displacement  . . . . . . . . . . . . . . . . .\' (97 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D16 - Checkbox text clipped: \'. . . . . . . . . . . . . . . . . . . . . . . .\' (77 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CDA - Checkbox text clipped: \'. . . . . . . . . . . . . . . . . . . . . . . .\' (77 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CD2 - Checkbox text clipped: \'. . . . . . . . . . . . . . . . . . . . . . . .\' (77 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CBA - Checkbox text clipped: \'. . . . . . . . . . . . . . . . . . . . . . . .\' (77 px missing in x )\n\nCustomControlsOptions.TextClippingIssuesSensitivityX  = 90 --set the threshold to 90 px\n90\n--Collapse and expand the Maps rollout of a Standard Material again –\n--only controls whose text is clipped above 90 pixels will be reported:\nUI CLIPPING ERROR: hwnd: 0x50E8E - Checkbox text clipped: \'Ambient Color . . . . . . . . . . . . . . . . .\' (98 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CEE - Checkbox text clipped: \'Diffuse Color . . . . . . . . . . . . . . . . .\' (93 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x50E4E - Checkbox text clipped: \'Specular Color  . . . . . . . . . . . . . . . .\' (96 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60C80 - Checkbox text clipped: \'Specular Level  . . . . . . . . . . . . . . . .\' (96 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D40 - Checkbox text clipped: \'Self-Illumination . . . . . . . . . . . . . . .\' (93 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60D82 - Checkbox text clipped: \'Refraction  . . . . . . . . . . . . . . . . . .\' (91 px missing in x )\nUI CLIPPING ERROR: hwnd: 0x60CD6 - Checkbox text clipped: \'Displacement  . . . . . . . . . . . . . . . . .\' (97 px missing in x )\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CustomControlsOptions.UIUserScaleFactor</em> : float : Read|Write</pre></div>\n         <p> Get/set the user-defined scale factor of the User Interface. \n            	 \n         </p>\n         <p> Default is 0.0 (no custom scaling, equivalent to 1.0). \n            	 \n         </p>\n         <p> A value of 1.0 performs no scaling. \n            	 \n         </p>\n         <p> A value of 2.0 will make all custom controls 2 times larger, and so on. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">CustomControlsOptions.SetPrintIconPathsPersist</em> &lt;bool&gt;print_paths &lt;bool&gt;persist</pre></div>\n         <p> Sets the state and persistence of the Print Icon Paths feature. \n            	 \n         </p>\n         <p> The first argument sets the state - True to print the icon paths, False to disable\n            printing. \n            	 \n         </p>\n         <p> The second argument sets the persistence - True to persist between \n            		<em class=\"strong\">3ds Max</em> sessions, False to set for the current session only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">CustomControlsOptions.SetPrintTextClippingIssuesPersist</em> &lt;bool&gt;print_issues &lt;bool&gt;persist</pre></div>\n         <p> Sets the state and persistence of the Print Text Clipping Issues feature. \n            	 \n         </p>\n         <p> The first argument sets the state - True to print the issues, False to disable printing.\n            \n            	 \n         </p>\n         <p> The second argument sets the persistence - True to persist between \n            		<em class=\"strong\">3ds Max</em> sessions, False to set for the current session only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">CustomControlsOptions.SetTextClippingIssuesSensitivityXPersist</em> &lt;integer&gt;sensitivity &lt;bool&gt;persist</pre></div>\n         <p> Sets the value and persistence of the Print Text Clipping Issues X Sensitivity threshold.\n            \n            	 \n         </p>\n         <p> The first argument defines the sensitivity value. \n            	 \n         </p>\n         <p> The second argument sets the persistence - True for the value to persist between\n            \n            		<em class=\"strong\">3ds Max</em> sessions, False to set for the current session only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">CustomControlsOptions.SetTextClippingIssuesSensitivityYPersist</em> &lt;integer&gt;sensitivity &lt;bool&gt;persist</pre></div>\n         <p> Sets the value and persistence of the Print Text Clipping Issues Y Sensitivity threshold.\n            \n            	 \n         </p>\n         <p> The first argument defines the sensitivity value. \n            	 \n         </p>\n         <p> The second argument sets the persistence - True for the value to persist between\n            \n            		<em class=\"strong\">3ds Max</em> sessions, False to set for the current session only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><em class=\"strong\">Actions:</em> \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Related Functions:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Point2 Array&gt;<em class=\"codeEmphasisStrong\">getIconSizes</em> &lt;string&gt;iconPath</pre></div>\n         <p> Returns an array of Point2 values representing the available icon sizes. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Point2&gt;<em class=\"codeEmphasisStrong\">getQtTextExtent</em> &lt;string&gt;UItext</pre></div>\n         <p> Returns a Point2 value representing the Qt text size in pixels of the specified string.\n            \n            	 \n         </p>\n         <p> The custom UI scale factor will \n            		<em class=\"strong\">not</em> be taken into account. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetUIScaleFactor</em> &lt;int&gt;monitorID</pre></div>\n         <p> Gets the scale factor for High DPI monitors, for the specified monitor. If not specified,\n            the default monitor (-1) is queried. \n            	 \n         </p>\n         <p>See also the \n            		<span class=\"char_link\"><a href=\"GUID-AC26099B-60BF-4C99-997B-DF65F8D47DC1.htm\">CustomControlsOptions.UIUserScaleFactor</a></span> interface property for getting and setting the UI scale. \n            	 \n         </p><a name=\"TABLE_5B4BF8C4F0C44DB1A8F759018FFADD5D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nb = getIconAsBitmap @\"MainToolbar\\RenderSetup\" --get the Render Setup icon as bitmap\ndisplay b --display the bitmap\n\ngetIconSizes @\"MainToolbar\\RenderSetup\" --get the Render Setup icon as bitmap\n#([24,24], [30,30], [36,36], [48,48])\n\ngetQtTextExtent \"MAXScript\"\n[48,13]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";