var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Scripted Custom Attributes\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Custom Attributes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2\"></a><div class=\"head\">\n            <h1>Scripted Custom Attributes </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B22\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B21\"></a>  <span class=\"code\"> <em class=\"strong\">Custom Attributes</em> </span> let you create and assign additional parameters to any object, modifier, or material\n               in your scene. This is useful for game and other project-specific data. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1F\"></a>MAXScript provides a way to define and add these custom attributes to objects in a\n               scene, and also a way to define UI rollups for accessing these attributes. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1E\"></a> <em class=\"strong\">Custom Attributes Topics:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1D\"></a> <span class=\"char_link\"><a href=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7.htm\">Adding Custom Attributes</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1C\"></a> <span class=\"char_link\"><a href=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4.htm\">Global and Private Custom Attributes Definitions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1B\"></a> <span class=\"char_link\"><a href=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559.htm\">Custom Attribute Management Functions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B1A\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B19\"></a> <span class=\"char_link\"><a href=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0.htm\">Access to Custom Attributes Virtual Array</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B18\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B16\"></a> \n               <h3><a name=\"GUID-445E3601-B0F5-4951-A2BB-62E513D64A79\"></a> <em class=\"strong\">Attribute Definitions</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B15\"></a>Attributes can be added to an object using an \"<span class=\"code\"> <em class=\"strong\">attribute definition</em> </span>\". This is a syntactic construct in MAXScript that is similar to a <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">scripted plug-in definition</a></span>, but rather than adding a new plug-in class, a definition is built to add custom\n                  attributes and rollout UI to any number of objects at any time through a special function.\n                  \n               </p> \n               <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F5D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You <span class=\"code\"> <em class=\"strong\">cannot</em> </span> use Custom Attributes per face-data. The face-data channels store objects of a user\n                     defined type and MAXScript cannot create objects of types other than those known by\n                     MAXScript. \n                  </div>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B10\"></a> <em class=\"strong\">The syntax has the following form:</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2314\"></a><pre><em class=\"codeEmphasisStrong\">attributes</em> &lt;name&gt; [<em class=\"codeEmphasisStrong\">version</em>:n] [<em class=\"codeEmphasisStrong\">silentErrors</em>:t/f] [<em class=\"codeEmphasisStrong\">initialRollupState</em>:0xnnnnn] [<em class=\"codeEmphasisStrong\">remap</em>:#(&lt;old_param_names_array&gt;, &lt;new_param_names_array&gt;)]\n(\n&lt;locals&gt;\n&lt;globals&gt;\n&lt;parameters&gt;\n&lt;rollouts&gt;\n&lt;handlers&gt;\n)\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B07\"></a> <em class=\"strong\">Remarks</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B06\"></a>The name is a descriptive name for the definition and can be either a &lt;name&gt; or a\n                  &lt;string&gt;. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B05\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B04\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2313\"></a><pre>\ngameDataCA = attributes \"Game Data\"\n(\n...\n)\nor\nattributes gameData\n(\n...\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AF8\"></a>The attribute header keyword parameters and main clauses are basically identical to\n                  the same keyword parameters and clauses in <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span>. The \'custom attributes\' are effectively the parameters defined in any parameter\n                  clauses in the body of the attributes definition. The UI for them is defined by the\n                  rollout clauses, which will be automatically displayed in the Command Panel and Material\n                  Editor when an object containing custom attributes is selected. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AF7\"></a>The <span class=\"code\"> <em class=\"strong\">initialRollupState</em> </span> argument is an integer whose 32 bits are used to initialize the rollouts\' rollup\n                  state in both the create and modify panel. However, the semantics are different for\n                  these two cases. Whenever the rollouts are created in the create tab, their state\n                  will be specified by this value. In the modify tab, the first time an object of this\n                  type is modified, the state will be that of this value, but after that it will remain\n                  what it was last set to. The bits of this value indicate the corresponding rollout\n                  is rolled up (closed). The zero bit corresponds to the first rollout, the first bit\n                  is the second rollout, and so on. The default value of 0x7fffffff is used, so the\n                  command panel can detect that this value is not being overridden, and leave the rollouts\n                  as is. For example, a value of 0x07 results in the first three rollouts being rolled\n                  up, and the remaining rollouts open (2^2+2^1+2^0 = 4+2+1 = 7). \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AF5\"></a>The following example defines three new attributes for weapon objects in a game level\n                  editor set up. The attributes, hitPoints, cost, and sound are defined as parameters\n                  and the UI for them in a rollout: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AF4\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AF3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2312\"></a><pre>\nweaponDataCA= <em class=\"codeEmphasisStrong\">attributes</em> weaponData\n(\nparameters main rollout:params\n(\nhitPoints type:#float ui:hits default:10\ncost type:#float ui:cost default:100\nsound type:#string\n)\n&nbsp;\nrollout params \"Weapon Parameters\"\n(\nspinner hits \"Hit Points\" type: #float\nspinner cost \"Cost\" type: #float\ndropdownlist sound_dd \"Sound\" items:# (\"boom\",\"sparkle\",\"zap\",\"fizzle\")\n&nbsp;\non sound_dd selected i do sound = sound_dd.items [i]\n)\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F5C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ADC\"></a>The auto-UI connection between the parameters and rollout items using the UI and keyword\n                        is the same as the support in <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span>. You can treat attribute scripting as basically identical to scripting plug-ins in\n                        terms of parameter, rollout setup, and handler programming. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ADB\"></a>Since <em class=\"strong\">3ds Max 5.1</em>, scripted custom attributes can be applied to any MAXWrapper object such as, base\n                        objects, modifiers, materials, nodes, controllers, <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm#WS73099CC142F487553098682E12AC2FC2BC7-6220\">rootnodes</a></span>, render effects, and others. \n                     </p> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ADA\"></a>Custom attributes is currently supported only in the Material Editor and the Command\n                        Panel, so you can only see any rollouts associated with the custom attributes on base\n                        objects, modifiers, and materials. \n                     </p> \n                  </div>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-585E\"></a> \n               <h3><a name=\"GUID-6B3D25FE-E76C-45AA-8803-DD7C928853D1\"></a> <em class=\"strong\">Remapping Parameters when Redefining Custom Attributes</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AD8\"></a>The optional <span class=\"code\"> <em class=\"strong\">remap:</em> </span> keyword allows parameter names in the definitions to be changed when updating existing\n                  definitions. It is also available in <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm#WS73099CC142F487553098682E12AC2FC2BC7-7225\">Scripted Plug-ins</a></span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AD7\"></a>The keyword takes as an argument a two element array, where each element contains\n                  an array of string literal or name values. The size of the two arrays must be the\n                  same. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AD6\"></a>The names in the first array are the existing parameter names and the names in the\n                  second array are the new parameter names. As parameter names are read in while migrating\n                  existing plugin instances, the parameter names are searched for in the first array.\n                  If the name is found, the data associated with that parameter is moved to the parameter\n                  name in the corresponding location in the second array. If a parameter name is not\n                  found in the first array, the parameter name is not remapped. If the parameter name\n                  in the second array does not match a parameter name in the new definition, the parameter\n                  data is not moved to the new definition. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AD5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AD4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2311\"></a><pre>\nCAT_DEF = attributes Custom_Attributes\nRedefine:CAT_CurrentDef\nremap: # (# (\"Param1\"),# (\"Param9\"))\n(\nParameters main rollout:params\n(\n\'Param9\' Type:# float UI:\'Param9\' Default:0.0\n\'Param2\' Type:# float UI:\'Param2\' Default:0.0\n)\nRollout Params \"Custom Attributes\"\n(\nspinner \'Param9\' \"Param9\" Width:160 Height:16 Align: # Center Type: # float Range:[0,100,0]\nspinner \'Param2\' \"Param2\" Width:160 Height:16 Align: # Center Type: # float Range:[0,100,0]\n)\n)\nCustAttributes.add CAT_TargetObject CAT_DEF #Unique BaseObject : false\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AC1\"></a>This will move the data associated with Param1 to Param9 in existing instances. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AC0\"></a> <em class=\"strong\">Next Topic:</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ABF\"></a> <span class=\"char_link\"><a href=\"GUID-A583C75E-C8B8-470E-B083-CCE87CAEB65E.htm\">MSCustAttribDef Class</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ABD\"></a> <span class=\"char_link\"><a href=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4.htm\">Global and Private Custom Attributes Definitions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ABC\"></a> <span class=\"char_link\"><a href=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559.htm\">Custom Attribute Management Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ABB\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4ABA\"></a> <span class=\"char_link\"><a href=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0.htm\">Access to Custom Attributes Virtual Array</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AB9\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AB8\"></a>&nbsp; \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AB7\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AB6\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\"> Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";