var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getInterfaces Interface Inspector\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>GetInterfaces Interface Inspector</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94\"></a><div class=\"head\">\n            <h1>GetInterfaces Interface Inspector </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-703F\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D03\"></a><pre><em class=\"codeEmphasisStrong\">getInterfaces</em> {&lt;MAXWrapper&gt; | &lt;MAXClass&gt;}</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-703A\"></a> The <span class=\"code\"> <em class=\"strong\">getInterfaces()</em> </span> function returns an array containing the interfaces exposed by the argument.&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7039\"></a>If the argument is a node, the node level interfaces for that node are returned. If\n               you want the interfaces for the node\'s base object, you need to specify <span class=\"code\"> <em class=\"strong\">&lt;node&gt;.baseobject</em> </span> as the argument. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7037\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7036\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D02\"></a><pre>\ns=sphere()\n--&gt; $Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\nconverttopoly s\n--&gt; $Editable_Poly:Sphere01 @ [0.000000,0.000000,0.000000]\ngetInterfaces s\n--&gt; #(&lt;MixinInterface:IAssembly&gt;, &lt;MixinInterface:INodeGIProperties&gt;, &lt;MixinInterface:INode&gt;, &lt;MixinInterface:INodeLayerProperties&gt;, &lt;MixinInterface:INodeBakeProperties&gt;, &lt;MixinInterface:SkinPose&gt;, &lt;MixinInterface:INodeBakeProjProperties&gt;, &lt;MixinInterface:INodeMentalRayProperties&gt;, &lt;MixinInterface:INodeDisplayProperties&gt;, &lt;MixinInterface:INodeShadingProperties&gt;)\ngetInterfaces s.baseobject\n--&gt; #(&lt;MixinInterface:EditablePoly&gt;)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-702A\"></a>If the argument is a MAXClass, only static interfaces for that class are returned.\n               Typically, only utility plugin classes define static interfaces. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7029\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7028\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D01\"></a><pre>\ngetInterfaces Plug_in_Manager\n#(&lt;Interface:PluginMgrAction&gt;)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7021\"></a> <span class=\"char_link\"><a href=\"GUID-78D32F5B-1805-4134-A923-60E541C984AD.htm\">getInterface Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7020\"></a> <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-701F\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-701E\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";