var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B015A2D1-AC4D-4773-99F1-78115ACC944D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"working with\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Working with MAXKey Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B015A2D1-AC4D-4773-99F1-78115ACC944D\"></a><div class=\"head\">\n            <h1>Working with MAXKey Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B46\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B45\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-5ED6F7E0-33CC-4F4E-972E-094EB33BEA85.htm\">MAXKey Values</a></span> &gt; Working with MAXKey Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B43\"></a>Changing the <span class=\"code\"> <em class=\"strong\">.time</em> </span> property of a key may cause it to go out of time order relative to the other keys\n            in the controller. You <em class=\"strong\">must</em> call the <span class=\"code\"> <em class=\"strong\">sortKeys()</em> </span> function on the controller or associated <em class=\"strong\">MAXKeyArray</em> once all key time manipulations of this kind is complete so that animation will perform\n            correctly. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B42\"></a>The class of a key\'s value property is determined by the controller it is in, for\n            example, a <span class=\"code\"> <em class=\"strong\">linear_float</em> </span> key has a float <span class=\"code\"> <em class=\"strong\">.value</em> </span>, a <span class=\"code\"> <em class=\"strong\">tcb_rotation</em> </span> key has a quaternion <span class=\"code\"> <em class=\"strong\">.value</em> </span>, etc. The properties are all settable and support the math-assignment operators and\n            nested-property access. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B41\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B40\"></a><p class=\"table-body\"> <em class=\"strong\">HERE ARE SOME EXAMPLES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E70\"></a><pre>\n$foo.pos.keys[2].time += 20f -- change time of single key\n$foo.pos.keys.time += 20f -- change time of all keys\n$box1.uvw_map.center.keys[2].value.x += 20\nfor k in $baz.bend.angle.keys do k.value *= 1.1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B38\"></a>In some cases, the actual value stored in a key is not the value shown in the command\n            panels, shown in Track View, the value returned by the <span class=\"code\"> <em class=\"strong\">.value</em> </span> property of the key, or the value returned when accessing the property to which the\n            key’s controller is assigned. Instead, a scaling factor is applied to the key’s value\n            before the value is made \"visible\". For example, percentages are normally displayed\n            with a range of 0-100, rotation angles are in degrees, colors are [0-255,0-255,0-255].\n            The unscaled key values for percentages are normally in a range of 0-1, rotation angles\n            in radians, and colors are [0-1,0-1,0-1]. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B37\"></a>In the description of properties for each class, the scaling factor, if any, is identified\n            for each property. Take the following properties for the PArray class \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B36\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B35\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6F\"></a><pre>\n&lt;PArray&gt;.X_Spin_Vector Float default: 1.0 -- animatable\n&lt;PArray&gt;.Spin_Time_Variation Float default: 0.0 -- animatable, percentage\n&lt;PArray&gt;.Spin_Phase Float default: 0.0 -- animatable, angle\n&lt;PArray&gt;.viewPercent Float default: 10.0 -- percentage\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B2D\"></a>The <span class=\"code\"> <em class=\"strong\">.X_Spin_Vector</em> </span> property does not apply any scaling to its controller keys. The <span class=\"code\"> <em class=\"strong\">.Spin_Time_Variation</em> </span> property applies percentage scaling to its controller keys (displayed as percentage,\n            stored as fraction). The <span class=\"code\"> <em class=\"strong\">.Spin_Phase</em> </span> property applies angle scaling to its controller keys (displayed as degrees, stored\n            as radians). The <span class=\"code\"> <em class=\"strong\">.viewPercent</em> </span> property is stored internally with a percentage scaling factor, but since this property\n            is not animatable, this scaling it invisible to MAXScript. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B2C\"></a>Normally this scaling is not of concern when programming in MAXScript, but there are\n            two cases where it must be taken into account. The first is when using script controllers,\n            and is described in <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B2B\"></a>The second case is when one controller is applied as the controller for two or more\n            properties. The scaling is an attribute of the animatable <em class=\"strong\">property</em>, not the controller, so in (the admittedly rare) situations in which a controller\n            is shared by several animatables that have <em class=\"strong\">different</em> scaling, unexpected results will occur if you do not take into account the scaling\n            factor. An example of this is shown in the following script, where the same controller\n            is shared between three differently scaled properties. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B2A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B29\"></a><p class=\"table-body\"> <em class=\"strong\">FOREXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6E\"></a><pre>\nobj=PArray()\ncont=bezier_float()\nobj.X_Spin_Vector.controller=cont\nobj.Spin_Time_Variation.controller=cont\nobj.Spin_Phase.controller=cont\nobj.X_Spin_Vector=1\nobj.X_Spin_Vector -- no scaling\nobj.Spin_Time_Variation -- percentage\nobj.Spin_Phase -- angle\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B1D\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E6D\"></a><pre>\n$PArray:PArray03 @ [0,0,0] -- result line 1\nController:Bezier_Float -- result line 2\nController:Bezier_Float -- result line 3\nController:Bezier_Float -- result line 4\nController:Bezier_Float -- result line 5\n1 -- result line 6\n1.0 -- result line 7, unscaled\n100.0 -- result line 8, percentage scaled, 1 = 100%\n57.2958 -- result line 9, angle scaled, \n1 radian = 57.2958 degrees&nbsp;\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7B11\"></a>If you do assign the same controller to properties with different scaling factors,\n            you should take care to access the <span class=\"code\"> <em class=\"strong\">.value</em> </span> property through the correct animatable property - this provides a scaling context\n            for the access operation. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";