var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"getPointControllers()\">\n      <meta name=\"indexterm\" content=\"getPointController()\">\n      <meta name=\"indexterm\" content=\"displayControlDialog()\">\n      <meta name=\"indexterm\" content=\"clearControllerNewFlag()\">\n      <meta name=\"indexterm\" content=\"isController()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Controller Common Properties, Operators, and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569\"></a><div class=\"head\">\n            <h1>Controller Common Properties, Operators, and Methods </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D85\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D86\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Animation Controllers</a></span> &gt; Controller \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D88\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D89\"></a>All controllers have the following properties: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1E\"></a><pre>&lt;controller&gt;.<em class=\"codeEmphasisStrong\">keys</em> MAXKeyArray -- read-only, the controller’s key array \n&lt;controller&gt;.<em class=\"codeEmphasisStrong\">value</em> varies -- get or set the current controller value 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D8C\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">keys</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">value</em> </span> properties provide access to the value and keys in a free-standing controller. It\n            is useful when working with the global tracks controllers that are accessible in MAXScript.\n            The controllers that are not keyframeable return an empty KeyArray for their \n            		<span class=\"code\"> <em class=\"strong\">keys</em> </span> property. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D8D\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">value</em> </span> property is sensitive to the current time and animate contexts, so you can use it\n            to evaluate a controller at various times or to plant keyframes in the controllers\n            that support keys. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D8E\"></a>You can only assign a value to a controller’s \n            		<span class=\"code\"> <em class=\"strong\">value</em> </span> property if the controller is a key-based controller. The only exception to this\n            is that you can assign a Matrix3 value to a PRS controller’s \n            		<span class=\"code\"> <em class=\"strong\">value</em> </span> property. MAXScript automatically sets the individual position, rotation, and scale\n            values to the values represented in the Matrix3 value. \n            	 \n         </p>\n         <p><a name=\"GUID-E8AF23FC-B83D-4735-ABE8-C30417657289\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D90\"></a>If an Ease Curve is assigned to a controller, the following controller-related sub-property\n            is available: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1D\"></a><pre>&lt;controller&gt;.<em class=\"codeEmphasisStrong\">Ease_Curve</em> Float -- the controller’s ease curve value   </pre></div>\n         <p><a name=\"P_132D7D61BE494465A60C4C30465915F5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D93\"></a>If a MultiplierCurve is assigned to a controller, the following controller-related\n            sub-property is available: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1C\"></a><pre>&lt;controller&gt;.<em class=\"codeEmphasisStrong\">Multiplier_Curve</em> Float -- the controller’s multiplier curve value </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D96\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-2184B9B7-716F-4CFB-A7A6-E121DB24B08A.htm\">Ease and Multiplier Curve Functions</a></span> for methods and notes related to Ease and Multiplier curves. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D97\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D98\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1B\"></a><pre>\nglobaltracks.float.mycontroller.value\nglobaltracks.float.mycontroller.keys[2]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D9E\"></a> <em class=\"strong\">Associated Properties</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D9F\"></a>All animatable properties in \n            		<em class=\"strong\">3ds Max</em> objects let you reference several controller-related sub-properties. These are: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1A\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">controller</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DA1\"></a>The property’s controller. \n            	 \n         </p>\n         <p><a name=\"GUID-370AD837-E608-4B0A-943B-450BDB7127A2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F19\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">track</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DA4\"></a>A synonym for .controller. \n            	 \n         </p>\n         <p><a name=\"GUID-F1E104D5-DF9B-4A54-9275-BB966F32DB72\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F18\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">isAnimated</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DA7\"></a>A boolean indicating whether the property is animated. \n            	 \n         </p>\n         <p><a name=\"GUID-5CF3198A-C06D-4044-B6BC-369FEDC62D97\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F17\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">keys</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DAA\"></a>Read-only, gets the property’s controller’s key array \n            	 \n         </p>\n         <p><a name=\"GUID-D9651806-E0C9-4C62-80E0-98E4CBA7986B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F16\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">supportsKeys</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DAC\"></a>Read-only, boolean, true if controller is key-framable \n            	 \n         </p>\n         <p><a name=\"GUID-DFEC2476-2754-46D3-AB14-D92430312A2A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F15\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">keyable</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DAF\"></a>Boolean, true if controller is keyable, false if set to unkeyable \n            	 \n         </p>\n         <p><a name=\"GUID-1EC8B0E2-771A-444D-8564-C40F0E12756A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F14\"></a><pre>&lt;property&gt;.<em class=\"codeEmphasisStrong\">isHSV</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DB2\"></a>Read-only, boolean, true if controller\'s value represent HSV colors \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DB4\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">track</em> </span> property is a simple synonym for \n            		<span class=\"code\"> <em class=\"strong\">controller</em> </span>. If an animatable property does not have an assigned controller, the \n            		<span class=\"code\"> <em class=\"strong\">isAnimated</em> </span> property returns \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> and the \n            		<span class=\"code\"> <em class=\"strong\">controller</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">track</em> </span>, and \n            		<span class=\"code\"> <em class=\"strong\">keys</em> </span> properties return \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DB5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DB6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F13\"></a><pre>\n$foo.pos.controller\nbend_mod1.angle.isAnimated\n$bar.taper.gizmo.scale.keys[2]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DBD\"></a>You can create controllers like other \n            		<em class=\"strong\">3ds Max</em> objects by calling the class\' constructor function: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DBE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DBF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F12\"></a><pre>\nc = bezier_position()\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DC4\"></a>and assign them to animatable properties by assigning to the controller property in\n            those animatables. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DC5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DC6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F11\"></a><pre>\n$foo.pos.controller = c\n$baz.bend.gizmo.rotation.controller = tcb_rotation()\n$box01.length = linear_float()\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-7FAF\"></a>   <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F10\"></a><pre><em class=\"codeEmphasisStrong\">getPointControllers</em> {&lt;editable_mesh_node&gt; | &lt;editable_spline_node&gt;} </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DD0\"></a>Returns an array of controllers assigned to the vertices in the mesh or spline. If\n            no controller is assigned to a vertex, the array element value will be undefined.\n            For editable splines, each knot consists of three vertices: the in vector, knot, and\n            out vector. The array of controllers returned is a \"snapshot\" of the current controllers.\n            If controllers are assigned or changed for a vertex, this change is not reflected\n            in the array. If a vertex is added/deleted, the array is not resized to reflect the\n            change in number of vertices. \n            	 \n         </p>\n         <p><a name=\"GUID-6DCBE3C5-579D-4D0A-90EE-D12E20A60AC9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0F\"></a><pre><em class=\"codeEmphasisStrong\">getPointController</em> &lt;editable_mesh_node&gt; &lt;vertex_index_integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DD3\"></a>Returns the controller currently assigned to the vertex, undefined if no controller\n            is assigned. \n            	 \n         </p>\n         <p><a name=\"GUID-4430B9DA-8D87-4314-9D71-AA2712A2CC0B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0E\"></a><pre><em class=\"codeEmphasisStrong\">getPointController</em> &lt;editable_spline_node&gt; &lt;spline_index_integer&gt; &lt;vertex_index_integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DD6\"></a>Returns the controller for specified vertex in the specified spline, undefined if\n            no controller is assigned. Each spline knot consists of three vertices: the in vector,\n            knot, and out vector. \n            	 \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7FBB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-CDA7F065-D8F3-4709-83F4-0CEEC35C53D9\"></a>Applying a controller to a property causes the controller to take on the properties\n                  value at frame 0. If keys are present for the controller before the assignment to\n                  the property, all keys will be adjusted by the difference between the controller’s\n                  value at frame 0 and the property’s value. This is shown in the following example.\n                  \n                  		\n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DDC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DDD\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0D\"></a><pre>\na=bezier_float ()\naddnewkey a 0\naddnewkey a 10\na.keys[1].value=10\na.keys[2].value=100\nb=box()\nb.height\nb.height.controller=a\nb.height\nat time 10 b.height\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DEA\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0C\"></a><pre>\nController:Bezier_Float-- result line 1\n#Bezier Float key(1 @ 0f)-- result line 2\n#Bezier Float key(2 @ 10f)-- result line 3\n10-- result line 4, key value at time 0\n100-- result line 5, key value at time 10\n$Box:Box006 @ [0.000000,0.000000,0.000000]-- result line 6\n25.0-- result line 7, default property value\nController:Bezier_Float-- result line 8\n10.0-- result line 9, key value changed from 10 to 25 (delta= +15)\n100.0-- result line 10, key value changed by delta = +15\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DF7\"></a><p class=\"table-body\">An issue can occur when a single controller is assigned to multiple object properties.\n                        The value actually stored in a controller might not necessarily be the same value\n                        seen in Track View or in the command panels, nor the same value returned by accessing\n                        the property value in MAXScript. Part of a MAXWrapper property definition is scaling\n                        value that is applied when reading or setting the true value stored in a controller.\n                        For example, the \n                        					 <span class=\"code\"> <em class=\"strong\">slice_to</em> </span> and \n                        					 <span class=\"code\"> <em class=\"strong\">slice_from</em> </span> properties associated with many of the geometry primitives is displayed in degrees.\n                        The actual value stored in the controller associated with these properties are in\n                        radians. This scaling factor is an internal property of the MAXWrapper property, and\n                        not an internal property of the controller. Both \n                        					 <em class=\"strong\">3ds Max</em> and MAXScript automatically apply the specified scaling factor when accessing properties,\n                        so this scaling is normally invisible to the user. If the same controller is assigned\n                        to two properties that have different scaling factors, the question arises as to which\n                        scaling factor to apply to the output of the controller. If you are accessing the\n                        controller’s value through a MAXWrapper property, the scaling factor associated with\n                        that property is applied to the controller’s value. MAXScript also internally stores\n                        the last scaling factor applied to the controller’s value. If you are directly accessing\n                        the \n                        					 <span class=\"code\"> <em class=\"strong\">value</em> </span> property of the controller, or the \n                        					 <span class=\"code\"> <em class=\"strong\">value</em> </span> property of a key in the controller, the stored scaling factor is used. This can\n                        result in a controller’s \n                        					 <span class=\"code\"> <em class=\"strong\">value</em> </span> property returning different values at different times in a script, based on how\n                        the controller was last accessed. Because of this, it is highly recommended that you\n                        do not instance a controller onto multiple MAXWrapper properties that have different\n                        scaling factors. The scaling factor, if any, is listed for each MAXWrapper property\n                        in the documentation of the MAXWrapper classes. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-EF8E0384-117A-4FEE-9904-6001C6A4DF53\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0B\"></a><pre><em class=\"codeEmphasisStrong\">displayControlDialog</em> &lt;controller&gt; &lt;string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DFB\"></a>Displays the modal controller dialog, if any. The string will be in the dialog title\n            bar. If the controller is a keyframe controller, the key info dialog is displayed\n            for the selected keys. If no keys are selected, no dialog is displayed. \n         </p>\n         <p><a name=\"GUID-709CBF2E-CAA4-4394-9BDD-410AE40FAA87\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F0A\"></a><pre><em class=\"codeEmphasisStrong\">clearControllerNewFlag</em> &lt;controller&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DFE\"></a>Clears the \'new\' flag on the MAXScript wrapper for the controller. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7DFF\"></a>When this flag is set, when you assign the controller to a property, the initial value\n            of the controller is set to the property value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E00\"></a>When you create an instance of a controller, this flag is set. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E01\"></a>It is normally cleared only after the controller is assigned to a property. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E02\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, it was available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span> . \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">isController</em> &lt;value&gt; </pre></div>\n         <p>Returns true if the value wraps a controller. </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E04\"></a>Controllers that can be keyframed support several time and key-related functions as\n            described in the following topics: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E05\"></a> <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E06\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E07\"></a> <span class=\"char_link\"><a href=\"GUID-FC8E346B-AF24-426F-9A64-73C8AA865F40.htm\">Controller Out-Of-Range Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E08\"></a> <span class=\"char_link\"><a href=\"GUID-2184B9B7-716F-4CFB-A7A6-E121DB24B08A.htm\">Controller Ease and Multiplier Curve Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E09\"></a> <span class=\"char_link\"><a href=\"GUID-E6615B92-8BC4-4A13-BC31-86E006657A5C.htm\">Controller Key Reducer</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E0A\"></a> <span class=\"char_link\"><a href=\"GUID-B9AB78DC-D837-47F6-9B70-F4DEE00B716F.htm\">ControllermapKeys() method</a></span> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E0C\"></a> <span class=\"char_link\"><a href=\"GUID-DB1E088D-DA4E-44BF-AE9A-B207653E96B8.htm\">Key Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E0D\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E0E\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";