var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B3D86BDD-E947-43F3-B57B-168A1420E3FA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"trackView\">\n      <meta name=\"indexterm\" content=\"Track View Pick Dialog\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"TrackViewPick - value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Track View Pick Dialog</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B3D86BDD-E947-43F3-B57B-168A1420E3FA\"></a><div class=\"head\">\n            <h1>Track View Pick Dialog </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2E07\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2E06\"></a>  The Track View Pick dialog displays the hierarchy for the <em class=\"strong\">3ds Max</em> scene in a manner similar to what is seen in Track View. The user can select one\n               or more items from this dialog. The following method displays the Track View Pick\n               dialog: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BEA\"></a><pre><em class=\"codeEmphasisStrong\">trackView.pickTrackDlg</em> [<em class=\"codeEmphasisStrong\">#multiple</em>][&lt;filter function&gt;] [<em class=\"codeEmphasisStrong\">options</em>:&lt;integer&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2E02\"></a>This method brings up the Track View Pick dialog and returns a <span class=\"char_link\"><a href=\"GUID-B3D86BDD-E947-43F3-B57B-168A1420E3FA.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5B2B\">TrackViewPick value</a></span> when the user selects a track and clicks \"Ok\", or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the user clicks \"Cancel\". \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2E01\"></a>If the optional argument <span class=\"code\"> <em class=\"strong\">#multiple</em> </span> is passed, multiple tracks can be picked in the dialog and an array of TrackViewPick\n               values is returned instead of a single value. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2E00\"></a>If the optional <span class=\"code\"> <em class=\"strong\">filter_function</em> </span> is supplied, each track is passed to the function as a TrackViewPick value. If the\n               function returns true, the track is selectable in the Track View Pick dialog. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DFF\"></a>If the optional keyword argument <span class=\"code\"> <em class=\"strong\">options</em> </span>: is specified, the bits of the integer value define what is shown in the Track View\n               Pick dialog. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DFE\"></a>The bits are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE9\"></a><pre>\n1: turn on display of animated tracks only\n2: turn off display of node Visibility track\n3: turn on display of only selected nodes\n4: turn off display of World Space Modifiers\n5: turn off display of Object Space Modifiers\n6: turn off display of node Transform track\n7: turn off display of node base object\n8: turn off display of controller types\n9: turn off display of note tracks\n10: turn off display of the sound track\n11: turn off display of maps in materials\n12: turn off display of material parameters\n13: turn on display of hidden nodes\n14: turn off display of hierarchy\n15: turn off display of non-keyable tracks\n16: turn off display of nodes\n17: turn off display of geometry nodes\n18: turn off display of shape nodes\n19: turn off display of light nodes\n20: turn off display of camera nodes\n21: turn off display of helper nodes\n22: turn off display of warp nodes\n23: turn off display of position controllers\n24: turn off display of rotation controllers\n25: turn off display of scale controllers\n26: turn off display of bone nodes\n27: set focus to first selected node found\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DE1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DE0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE8\"></a><pre>\ntheInt = 0 \ntheInt = bit.set theInt 1 true --animated tracks only\ntheInt = bit.set theInt 3 true --display selected nodes only\ntheInt = bit.set theInt 10 true --hide sound track\ntheTrack = trackView.pickTrackDlg options:theInt --open dialog\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DDC\"></a><p class=\"table-body\">You can also use the following function to turn a bitarray into an integer with bits\n                           set according to the flags described above. The resulting integer can be passed to\n                           the named <span class=\"code\"> <em class=\"strong\">options</em> </span>: parameter: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE7\"></a><pre>\nfn bitArrayToInt theBitArray = (\nlocal theInt = 0\nfor i in theBitArray do theInt = bit.set theInt i true\ntheInt\n)\ntheInt =bitArrayToInt #{1,3,10}\ntheTrack = trackView.pickTrackDlg options:theInt\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5B2B\"></a> \n            <h2><a name=\"GUID-CCA20640-3F06-4B7E-9FE8-CF76320A1623\"></a>  TrackViewPick : Value\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DCE\"></a>Instances of the TrackViewPick class store the result of a selection from the Track\n               View Pick dialog. A TrackViewPick value has the following properties: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE6\"></a><pre>&lt;trackViewPick&gt;.<em class=\"codeEmphasisStrong\">name</em> : string</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DCC\"></a>The name of the picked item as shown in the Track View Pick dialog. \n            </p> \n            <p><a name=\"GUID-4E9A0498-DDCD-435E-8076-B51E43DF62A2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE5\"></a><pre>&lt;trackViewPick&gt;.<em class=\"codeEmphasisStrong\">anim</em> : subAnim</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DC9\"></a>The subAnim for the item the user picked. \n            </p> \n            <p><a name=\"GUID-756B60D1-681A-436C-B25B-D1F8C588166F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE4\"></a><pre>&lt;trackViewPick&gt;.<em class=\"codeEmphasisStrong\">client</em> : MAXWrapper</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DC6\"></a>The owner of the subAnim for the item the user picked. If the owner is a subclass\n               of MAXWrapper, the MAXWrapper value for the owner is returned. Otherwise, a value\n               of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n            </p> \n            <p><a name=\"GUID-F3015757-74F0-4BEE-BA95-A4CCCFF71473\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE3\"></a><pre>&lt;trackViewPick&gt;.<em class=\"codeEmphasisStrong\">subNum</em>: integer</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DC3\"></a>The subAnim index for <span class=\"code\"> <em class=\"strong\">anim</em> </span> in <span class=\"code\"> <em class=\"strong\">client</em> </span>. \n            </p> \n            <p><a name=\"GUID-E294E714-3F9B-45B3-B432-C55C1B36E4E7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DC2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2DC1\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6BE2\"></a><pre>\n-- Create a sphere, apply a bend modifier and execute:\ns=sphere()\nb=bend()\naddmodifier $Sphere001 b\ntvp=trackview.pickTrackDlg()\n-- pick objects-&gt;Sphere01-&gt;Modified object-&gt;Bend-&gt;Angle\ntvp.anim -- returns SubAnim:Angle\ntvp.client -- returns Bend:Bend\ntvp.subNum -- returns 3\ntvp.name -- returns \"Angle\"\ntvp.client[tvp.subNum] -- returns SubAnim:Angle\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";