var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B478B60B-B27D-4916-A07E-264818666080\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"utility\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"scripted utilities\">\n      <meta name=\"indexterm\" content=\"rollout - value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Utilities and Rollouts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B478B60B-B27D-4916-A07E-264818666080\"></a><div class=\"head\">\n            <h1>Scripted Utilities and Rollouts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ACA\"></a>MAXScript provides a set of classes and functions and some special syntax to allow\n            you to construct custom rollouts that can be incorporated into the existing <em class=\"strong\">3ds Max</em> user interface. You typically use custom rollouts to provide a point-and-click interface\n            to a tool that you have written or want to write in MAXScript, so users of your tool\n            don\'t have to work with it at the script level. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC9\"></a>There are several places in the <em class=\"strong\">3ds Max</em> user interface where you can install scripted rollouts: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC8\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC6\"></a>In the <span class=\"char_link\"><a href=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2.htm\">Utilities panel</a></span>.Use the <span class=\"code\"> <em class=\"strong\">utility</em> </span> definition construct in MAXScript to define and install scripted utilities. Once\n                  installed, they appear in the Utilities list at the bottom of the MAXScript rollout.\n                  If the user selects a utility in this list, its rollout(s) appear below the MAXScript\n                  rollout and functions just like a plug-in utility. This was the original way of creating\n                  scripted utilities when MAXScript was first introduced in <em class=\"strong\">3ds Max 2</em>. The main benefit of using a scripted utility is that it can be created very fast\n                  and does not require much management code to add rollouts and perform operations onto\n                  the scene so it is a good way to start into scripting. The main drawback is that the\n                  Utilities rollout is narrow and rather hidden and cannot be open at the same time\n                  as the Create and Modify tabs of the Command Panel. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC4\"></a>In special modeless <span class=\"char_link\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm\">rollout floater windows</a></span> that you can create with the <span class=\"code\"> <em class=\"strong\">newRolloutFloater()</em> </span> function. These windows appear on the desktop and function in a way similar to the\n                  Material Editor and the Selection floater in <em class=\"strong\">3ds Max</em>. You can click to alternate between them and the main <em class=\"strong\">3ds Max</em> user interface. You create individual rollout(s) for these windows using the <em class=\"strong\">rollout</em> definition construct in MAXScript and install them in a rollout floater window using\n                  the <span class=\"code\"> <em class=\"strong\">addRollout()</em> </span> function. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC2\"></a>In floating <span class=\"char_link\"><a href=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7.htm\">scripted Dialogs</a></span>. Dialogs are not a holder for rollouts but a special display form of an existing\n                  rollout. They can be created out of a rollout using the <span class=\"code\"> <em class=\"strong\">createDialog()</em> </span> function. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AC0\"></a>In <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">scripted plugins</a></span>. Scripted plugins can contain one or more rollouts which will be displayed inside\n                  the Command Panel\'s Create and Modify tabs and can be linked to Parameter Blocks for\n                  automatic animation track management. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ABE\"></a>In <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Custom Attributes</a></span> added to scene objects or modifiers. Custom Attributes are a special form of a Parameter\n                  Block that can be attached to other objects. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ABD\"></a>Choosing which place is best for your scripted rollouts depends on a number of factors.\n            It is best to keep them in the Utilities panel if possible, as that maximizes the\n            use of the screen and is consistent with the <em class=\"strong\">3ds Max</em> user interface conventions. However sometimes it is useful to have them in a modeless\n            window if the user of your tool needs to move between the various command panels while\n            using the tool. In some cases, you might want to provide a \"float me\" button on a\n            scripted Utility rollout, similar to the Color Clipboard utility, so the user can\n            choose to display the rollouts in a rollout floater window or in the Utilities panel.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ABC\"></a>The following topics provide information about scripting utility panels and rollout\n            floater windows: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ABB\"></a> <span class=\"char_link\"><a href=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2.htm\">Scripted Utility Panels</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6ABA\"></a> <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB9\"></a> <span class=\"char_link\"><a href=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF.htm\">Managing Multiple Rollouts in a Scripted Utility</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB8\"></a> <span class=\"char_link\"><a href=\"GUID-1361B847-7878-4C52-98DE-5BC5CA830B40.htm\">Rollout Clauses</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB7\"></a> <span class=\"char_link\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout Properties, Methods, and Event Handlers</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB6\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB5\"></a> <span class=\"char_link\"><a href=\"GUID-608825CD-D025-4054-91E2-2562A6AB31CF.htm\">Visibility of Locals, Functions, Structures, and User-Interface Items in Rollout Code</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB4\"></a> <span class=\"char_link\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6AB3\"></a> <span class=\"char_link\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm\">Rollout Floater Windows</a></span> \n         </p><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2.htm\">Scripted Utility Panels </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF.htm\">Managing Multiple Rollouts in a Scripted Utility </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-1361B847-7878-4C52-98DE-5BC5CA830B40.htm\">Rollout Clauses </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-BA683828-589C-4BBB-897C-FD2B7DA0E147.htm\"> Non-Local Variables As Captions Of Rollouts and UI Controls  </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout Properties, Methods, and Event Handlers </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049.htm\">Rollout Floater Windows </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-608825CD-D025-4054-91E2-2562A6AB31CF.htm\">Visibility of Locals, Functions, Structures and User-Interface Items in Rollout Code\n                        </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-CDE5B06D-4BB4-4DEA-96C1-6BAB98709F09.htm\">SubRollout Class </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5DFECB42-C452-457B-BAD4-B07767AE8C9E.htm\">Rollout .Controls Property </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-2C5F5486-A171-43C1-9304-8A3D016BB0BD.htm\">Rollout Systems \'category\' Mechanism </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E66C9960-E058-4EF8-92EA-EB65365B79CF.htm\">MAXScript Dialogs and Rollout Floaters as Extended Viewports </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-53483E27-8DFA-47E6-8835-E6FE1C031B12.htm\">Macro Recorder Emission From Rollout UI Actions </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";