var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B930B1E8-8CB6-4A21-8D92-D81989683197\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: BooleanExplorerManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B930B1E8-8CB6-4A21-8D92-D81989683197\"></a><div class=\"head\">\n            <h1>Interface: BooleanExplorerManager </h1>\n         </div>\n         <p> This Core Interface exposes methods for controlling the Boolean Explorer dialog.\n            Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2804\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <p>None. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanExplorerManager.OpenBooleanExplorer</em>()</pre></div>\n         <p> Opens the Boolean Explorer. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanExplorerManager.CloseBooleanExplorer</em>()</pre></div>\n         <p> Closes the Boolean Explorer. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanExplorerManager.IsBooleanExplorerOpen</em>()</pre></div>\n         <p> Returns True if the Boolean Explorer is currently open, False if it is closed. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanExplorerManager.LoadBooleanExplorerConfiguration</em> &lt;&amp;TSTR&gt;configurationFile\nconfigurationFile is In parameter</pre></div>\n         <p> Loads a Boolean Explorer configuration from the specified file. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanExplorerManager.SaveBooleanExplorerConfiguration</em> &lt;&amp;TSTR&gt;outputConfigurationFile\noutputConfigurationFile is In parameter</pre></div>\n         <p> Saves the current Boolean Explorer configuration to the specified file. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Actions:</em> \n         </p>\n         <p>None. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"TABLE_4E15F662853243C3B79878EABF749275\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-F16B3F88-A91F-44BA-B2C3-5E30ABB1904B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nBooleanExplorerManager.IsBooleanExplorerOpen() --check if already open \n--&gt; false –- it is not open yet\nBooleanExplorerManager.OpenBooleanExplorer() -- open the Boolean Explorer\n--&gt; true -- success!\nBooleanExplorerManager.IsBooleanExplorerOpen() -- check again\n--&gt; true -- now it is open\nBooleanExplorerManager.CloseBooleanExplorer()  -- close it\n--&gt; true -- success!\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";