var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-B93647B2-8BC7-4D83-BA90-0105DAB3591C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B93647B2-8BC7-4D83-BA90-0105DAB3591C\"></a><div class=\"head\">\n            <h1>Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DB6\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DB7\"></a> MAXScript is an <em class=\"mild\">expression-based</em> language. Every construct in the language is an expression and yields a result. This\n               includes constructs that other languages consider as statements. The simplified syntax\n               of the language allows you to build very expressive code. Anywhere you can write an\n               <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> expression, and you can write any construct in MAXScript. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DB9\"></a>A good example of this is the <span class=\"code\"> <em class=\"strong\">if</em> </span> construct. In statement-based languages, there is usually one syntax for <span class=\"code\"> <em class=\"strong\">if</em> </span> statements and another for conditional expressions. In MAXScript, a single syntax\n               is used for both cases. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DBA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DBB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DBC\"></a><p class=\"table-body\">The following two lines of code are both valid and their meaning is obvious: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-613B\"></a><pre>\nif a &gt; b then print c else print d\nx = if a &gt; b then c else d\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DC1\"></a><p class=\"table-body\">You can also write the following line with a nested <span class=\"code\"> <em class=\"strong\">if</em> </span> expression and a nested assignment, which itself is an expression: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-613A\"></a><pre>\nx = if (if a &gt; b then c else d) &lt; e then f else (g = 23)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DC6\"></a>Another example is the block-expression, denoted by <span class=\"code\">&lt;block_expr&gt;</span>. It contains a series of <span class=\"code\">&lt;expr&gt;</span> expressions enclosed in parentheses. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DC7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DC8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6139\"></a><pre>a = 2\nb = 1\n(\nprint a\nprint b\nif a &gt; b then print \"the big a\"\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DD1\"></a>Each expression in the block is separated by a line break. You can also write several\n               expressions in one line using a \";\" (semicolon) to separate them. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DD2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DD3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6138\"></a><pre>\n(print a; print b; if a &gt; b then print \"the big a\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DD8\"></a>Block-expressions are themselves <span class=\"code\">&lt;expr&gt;</span> expressions. They evaluate their component expressions in sequence and their value\n               is the value of the last expression in the block. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DD9\"></a>To create classic block-structured statements: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DDA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DDB\"></a><p class=\"table-body\"> <em class=\"strong\">YOU MIGHT WRITE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6137\"></a><pre>c = 3\nd = 4\nif a &gt; b then\n(\nprint c\nx = sqrt (c)\n)\nelse\n(\nprint d\nx = sin (e)\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DE8\"></a><p class=\"table-body\"> <em class=\"strong\">OR</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86DE9\"></a><p class=\"table-body\">Use a nested block-expression to compute a comparison operand. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6136\"></a><pre>\nif a &gt; (y = sin b; sqrt(y * z)) then print c\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DEE\"></a>At its simplest, a MAXScript program is made up of <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> expressions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86DEF\"></a>An <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> is defined as any of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6135\"></a><pre>\n&lt;simple_expr&gt;\n&lt;variable_decls&gt;\n&lt;assignment&gt;\n&lt;context_expr&gt;\n&lt;if_expr&gt;\n&lt;while_loop&gt;\n&lt;do_loop&gt;\n&lt;for_loop&gt;\n&lt;loop_exit&gt;\n&lt;case_expr&gt;\n&lt;try_expr&gt;\n&lt;function_def&gt;\n&lt;function_return&gt;\n&lt;struct_def&gt;\n&lt;max_command&gt;\n&lt;utility_def&gt;\n&lt;rollout_def&gt;\n&lt;tool_def&gt;\n&lt;rcmenu_def&gt;\n&lt;plugin_def&gt;\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E04\"></a>These expressions constitute the main constructs in MAXScript. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E06\"></a> <span class=\"char_link\"><a href=\"GUID-A097AC72-2ADD-4618-896C-20B203A81E0B.htm\">Simple Expressions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E07\"></a> <span class=\"char_link\"><a href=\"GUID-E672728A-EE15-4197-9EDD-487781167B01.htm\">Context Expressions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E08\"></a> <span class=\"char_link\"><a href=\"GUID-798DBAF9-7171-457A-95EE-FC8F2062CCBD.htm\">Controlling Program Flow</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E09\"></a> <span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">Creating Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0A\"></a> <span class=\"char_link\"><a href=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6.htm\">Structure Definition</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0B\"></a> <span class=\"char_link\"><a href=\"GUID-ECB4AC81-658B-4256-A31D-9C3FE78D9EB5.htm\">Literal Constants</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0C\"></a> <span class=\"char_link\"><a href=\"GUID-A3520718-09E9-4AFE-9CE0-B7BE62E97823.htm\">Variables - Assignment and Scope</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0D\"></a> <span class=\"char_link\"><a href=\"GUID-A96857E7-73FE-4F42-BE71-E8185356F4C9.htm\">3ds Max Commands</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0E\"></a> <span class=\"char_link\"><a href=\"GUID-B478B60B-B27D-4916-A07E-264818666080.htm\">Scripted Utilities</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E0F\"></a> <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E10\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E11\"></a> <span class=\"char_link\"><a href=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8.htm\">Scripted Right-Click Menus</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E12\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";