var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-BB31B990-EDFE-4E4E-8B28-02A882F33300\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"cascading contexts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Cascading Contexts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BB31B990-EDFE-4E4E-8B28-02A882F33300\"></a><div class=\"head\">\n            <h1>Cascading Contexts </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87149\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8714A\"></a>  You can cascade a set of context prefixes, optionally separated by commas, onto one\n               subject expression, effectively applying all the contexts (in order) to the subject\n               expression.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8714D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8714E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D0\"></a><pre>\nanimate on, at time (t+1), with undo off,coordsys local\n(\n...\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87156\"></a>All the context forms are true expressions, yielding the value of their subject expression,\n               so:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87157\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CF\"></a><pre>\npos0 = at time 35 $box01.position\npos1 = at time 75 $box01.position\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8715C\"></a><p class=\"table-body\">assigns the <span class=\"code\"> <em class=\"strong\">box01</em> </span> position at time\'s <span class=\"code\"> <em class=\"strong\">35</em> </span> and <span class=\"code\"> <em class=\"strong\">75</em> </span> to variables <span class=\"code\"> <em class=\"strong\">pos0</em> </span> and <span class=\"code\"> <em class=\"strong\">pos1</em> </span>.\n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8715E\"></a>This is particularly useful with the <span class=\"code\"> <em class=\"strong\">at time</em> </span> context, as you can very easily do across-time computations.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8715F\"></a>The operand to an <span class=\"code\"> <em class=\"strong\">at time</em> </span> context can be any valid time value (numbers are taken as frames for convenience),\n               including sub-frame times down to the tick level.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87160\"></a>The animation system in <em class=\"strong\">3ds Max</em> will interpolate animated parameters at these fine levels so you can easily do sub-frame\n               simulation computations.\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";