var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-BCB0E3E1-31C2-4A6B-B221-2FA798D772CE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"dontRepeatMessages\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dontRepeatMessages Context</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BCB0E3E1-31C2-4A6B-B221-2FA798D772CE\"></a><div class=\"head\">\n            <h1>dontRepeatMessages Context</h1>\n         </div>\n         <p> The \n            		<span class=\"code\">dontrepeatmessages</span> context does an exception safe extending of the optimization of the removal of duplicate\n            reference change messages across multiple notifications. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">with dontRepeatMessages</em> &lt;bool&gt; &lt;expression&gt;</pre></div>\n         <p>When the \'removal of duplicate reference change messages\' optimization is enabled\n            (see \n            		<span class=\"code\"><span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm#WS73099CC142F487553098682E12AC2FC2BC7-6234\">preferences.dontRepeatRefMsg</a></span></span>), during a single reference change notification duplicate messages sent to the same\n            objects are removed. Within a \n            		<span class=\"code\">dontrepeatmessages</span> context, that optimization applies across all reference change notifications within\n            that context. So, for example: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>with dontrepeatmessages on with animate on for t = 1 to 100 do at time t $.radius = t/2</pre></div>\n         <p>The notifications that are sent to the dependents of the selected node $ when the\n            first value is set are not sent for the remainder of the value set operations. This\n            can result in significant performance benefits in some cases. For example running:\n            \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>s = sphere isSelected:true\n(t1=timestamp();with dontrepeatmessages off with animate on for t = 1 to 10000 do at time t s.radius = t/2;timestamp()-t1)</pre></div>\n         <p>shows that setting all of the values with the context off took 226 milliseconds, while\n            running: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>s = sphere isSelected:true\n(t1=timestamp();with dontrepeatmessages on with animate on for t = 1 to 10000 do at time t s.radius = t/2;timestamp()-t1)</pre></div>\n         <p>shows that setting all of the values with the context on took 175 milliseconds. \n            	 \n         </p>\n         <p>See the related setting \n            		<span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm#WS73099CC142F487553098682E12AC2FC2BC7-6234\">preferences.dontRepeatRefMsg</a></span>. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";