var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-BE78BD90-3030-45F9-8F7C-C8386891B56C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I update the items in a dropdownList or listBox?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BE78BD90-3030-45F9-8F7C-C8386891B56C\"></a><div class=\"head\">\n            <h1>How do I update the items in a dropdownList or listBox? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE7C\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE7E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE7F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8CE\">Scripted UI</a></span> &gt; How do I update the items in a dropdownList or listBox? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE81\"></a>The .items property is an <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">array</a></span> of strings. You can manipulate the array just like a regular array, use methods like\n            <span class=\"code\">append</span>,<span class=\"code\"> findItem</span>,<span class=\"code\"> deleteItem</span> etc. to change its content, and assign the result to the .items property as often\n            as you want. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE82\"></a>The following sample script creates a <span class=\"char_link\"><a href=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7.htm\">dialog</a></span> with a <span class=\"char_link\"><a href=\"GUID-7C37748B-C682-4834-B5A6-74185C8C661A.htm\">listBox</a></span> UI element containing two initial items.There areal so three <span class=\"char_link\"><a href=\"GUID-E03EED5F-E21F-4C2F-AFA9-BA16A6602ACA.htm\">buttons</a></span> to manipulate the content of the listBox. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE83\"></a>Pressing the first button will append a new item to the end of the list. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE84\"></a>Pressing the second button will insert the new item before the currently selected\n            item. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE85\"></a>Pressing the third button will delete the currently selected item from the list. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE86\"></a>See the comments in the code for more details! \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE88\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCE89\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6654\"></a><pre>\nrollout test \"Test\"\n(\nlistBox testList items:#(\"Item 1\",\"Item 2\")\nbutton addToList \"Add Item To End Of List\" width:180\nbutton insertToList \"Insert Before Current Item\" width:180\nbutton removeFromList \"Remove Current Item\" width:180\n--Append a new Item to the array. Since append returns the resuling array,\n--it is OK to assign the result directly to the .items property\non addToList pressed do\n&nbsp; testList.items = append testList.items (\"Item \"+ (testList.items.count+1) as string)\n--Instert new item before current item\non insertToList pressed do\n(\n  --Check whether current item selection exists (greater than 0)\n &nbsp;if testList.selection &gt; 0 do\n&nbsp; (\n    --Because insertItem returns OK instead of the resulting array,\n    --you cannot assign the result of the expression directly to the property.\n    --Instead, you have to get a copy of the items array in a local variable...\n  &nbsp;&nbsp;temp_array = testList.items\n    --...perform the insertion with the temp. array in the local variable...\n  &nbsp;&nbsp;insertItem (\"Item \"+ (testList.items.count+1) as string) temp_array testList.selection\n    --...and assign back the temp. array to the .items property\n  &nbsp;&nbsp;testList.items = temp_array\n &nbsp;)\n)\n--Remove currently selected item from the list:\non removeFromList pressed do\n(\n  --Check whether there are any items left and there is a valid selection.\n  --Then delete the current item. DeleteItem returns the resulting array,\n  --so you can assign the result directly to the .items property\n &nbsp;if testList.items.count &gt; 0 and testList.selection &gt; 0 do\n&nbsp;  &nbsp;testList.items = deleteItem testList.items testList.selection\n)\n)\ncreateDialog test 200 220\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEB3\"></a> <span class=\"char_link\"><a href=\"\">Creating MAXScript Tools - Topics Index</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEB4\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";