var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-BEFD6E9D-65BF-4C0B-B217-8604DC48200B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"string operations\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"random numbers\">\n      <meta name=\"indexterm\" content=\"operations with strings\">\n      <meta name=\"indexterm\" content=\"mathematical operations in MAXScript\">\n      <meta name=\"indexterm\" content=\"math\">\n      <meta name=\"indexterm\" content=\"incrementing\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Mathematical Operations in MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BEFD6E9D-65BF-4C0B-B217-8604DC48200B\"></a><div class=\"head\">\n            <h1>Mathematical Operations in MAXScript </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA8\"></a>        Besides strings which we looked at in the <span class=\"char_link\"><a href=\"GUID-78A3F5B1-9C42-4725-B7BB-E67708D39644.htm\">previous lesson</a></span>, you can enter other types of data into MAXScript. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB1\"></a>MAXScript not only recognizes numeric characters as numbers, it can also perform mathematical\n            operations with them. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB2\"></a>As with strings, if you just enter a number by itself, MAXScript echoes it back to\n            you; it evaluates the number and displays its value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB3\"></a>Mathematical operations are more interesting. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB4\"></a> \n            <h2><a name=\"GUID-B86387F4-4B6E-421C-A5DD-D4CA6205E19A\"></a> <em class=\"strong\">Basic Mathematical Operations</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB5\"></a>MAXScript has many built-in functions that let you use MAXScript as a calculator.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB6\"></a>Enter <span class=\"code\">36.5 * 2</span>, for example, to see what a certain dimension needs to be if you want to double it.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB7\"></a>&nbsp;<img src=\"../images/GUID-6D35D90C-F807-4049-85BA-6DE498F47E57-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB8\"></a>MAXScript returns the result of the calculation. This is useful for quick calculations\n               where loading an external calculator program doesn’t seem worth the trouble. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EB9\"></a>MAXScript also recognizes several mathematical constants. Enter <span class=\"code\">pi</span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBA\"></a>&nbsp;<img src=\"../images/GUID-433C403F-D81F-48F3-B3E3-B624A024459F-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBB\"></a>MAXScript knows the value of <span class=\"code\">pi</span> and returns it. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBC\"></a>You can use this value in more complex operations. For example, if you want to know\n               the volume of a sphere with a 2.5-inch radius, multiply the cube of the radius by\n               <span class=\"code\">pi</span>, then multiply by 4.0 and divide by 3.0. Enter <span class=\"code\">4.0/3.0 * pi * 2.5^3</span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBD\"></a>&nbsp; <img src=\"../images/GUID-15B339BF-01E4-4D66-BCED-A48AA065ED12-low.png\"> \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBE\"></a> \n               <h3><a name=\"GUID-B96EAEAC-76C8-435F-9B84-5A20447099FC\"></a> <em class=\"strong\">Operations with Strings</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EBF\"></a>You can also perform some simple mathematical operations with strings. For example,\n                  if you have defined <span class=\"code\">a=\"MAXScript\"</span> and <span class=\"code\">b=\" is fun!\"</span>, entering <span class=\"code\">a+b</span> returns <span class=\"code\">\"MAXScript is fun!\"</span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC0\"></a>&nbsp;<img src=\"../images/GUID-52CE0B66-6EDC-4AC7-B22B-83F4DAE52F2B-low.gif\"> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC1\"></a>For more string operations, see the <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm\">String Values</a></span> topic in the MAXScript reference. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC2\"></a> \n               <h3><a name=\"GUID-2E5900E0-EB43-44A6-BBBD-1F4633139316\"></a> <em class=\"strong\">Additional Mathematical Operations</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC3\"></a>MAXScript is able to perform many mathematical operations, including most trigonometric\n                  functions (sin, cosh, atan) and transcendental functions (exp, log, sqrt). This topic\n                  introduces two of the most useful operations: random numbers and incrementing. For\n                  a complete list of the operations supported by MAXScript, see the <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm\">Number Values</a></span> topic in the MAXScript reference. \n               </p> \n               <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC4\"></a> \n                  <h4><a name=\"GUID-F48D6E79-F17A-4B28-B4A7-A9F527111805\"></a> <em class=\"strong\">Creating Random Numbers</em> \n                  </h4> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC5\"></a>One very useful mathematical operation in MAXScript is the random number function.\n                     It returns a pseudo-random number selected inclusively between two user-specified\n                     arguments. \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC6\"></a><div class=\"table-ruled\">\n                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                        <colgroup>\n                           <col width=\"100%\">\n                        </colgroup>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EC7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                              </p> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-even-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5092\"></a><pre>random 1 100</pre></div> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4ECB\"></a><p class=\"table-body\">returns a random integer between 1 and 100. </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4ECC\"></a><p class=\"table-body\">The return value type (Float or Integer) is the same as the type of the first argument\n                                 in the function, therefore if you enter \n                              </p> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-even-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5091\"></a><pre>random 1.0 100</pre></div> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4ED0\"></a><p class=\"table-body\">MAXScript returns a random float between 1.0 and 100.0 </p> \n                           </td>\n                        </tr>\n                     </table>\n                  </div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4ED2\"></a>&nbsp;<img src=\"../images/GUID-FE754FB5-474D-4A72-A45D-F9AC6010A29D-low.gif\"> \n                  </p> \n                  <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7F0F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4ED6\"></a>For reasons beyond the scope of this tutorial, the <span class=\"code\">random</span> command will generate the same \"random\" numbers each time a script is run. This happens\n                           if you restart the software and run the script, but not if you run the script over\n                           and over. If you want the values created by the <span class=\"code\">random</span> function to change each time you start the software, you can use the <span class=\"code\">seed</span> command: \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5090\"></a><pre>seed &lt;number&gt;</pre></div> where <span class=\"code\">&lt;number&gt;</span> is any float or integer. Each time you change the <span class=\"code\"> seed</span> value, MAXScript generates a new set of \"random\" numbers. \n                        </p> \n                     </div>\n                  </div> \n               </div> \n               <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EDB\"></a> \n                  <h4><a name=\"GUID-A104DE65-2BCB-41E1-9C16-9D6EC1575C6B\"></a> <em class=\"strong\">Incrementing</em> \n                  </h4> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EDC\"></a>Another useful mathematical operation that MAXScript provides is <em class=\"strong\">incrementing</em>. This is a shorthand form of assignment that can be used to modify a value in place,\n                     as shown in the following long form examples: \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508F\"></a><pre>x = x + 1</pre></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EDE\"></a>There are assignment operators corresponding to the four math operations (+,-,*, and\n                     /) that apply the operation to the assignment’s destination with the result. Their\n                     syntax is: \n                  </p> \n                  <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-2EE2\"></a> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508E\"></a><pre>\n&lt;destination&gt; += &lt;expr&gt; -- add &lt;expr&gt; to destination\n&lt;destination&gt; -= &lt;expr&gt; -- subtract &lt;expr&gt; from destination\n&lt;destination&gt; *= &lt;expr&gt; -- multiply destination by &lt;expr&gt;\n&lt;destination&gt; /= &lt;expr&gt; -- divide destination by &lt;expr&gt;\n</pre></div> \n                  </div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EE4\"></a>Using this shorthand form of assignment, the previous example can be written as: \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-508D\"></a><pre><em class=\"codeEmphasisStrong\">x += 1</em></pre></div> \n               </div> \n            </div> \n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EE6\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EE7\"></a> <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">Drawing a Box with MAXScript</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";