var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-BFB330E6-9A3B-4C24-B28C-C7750F1FBECB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Speed Operator in Script Operator Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Speed Operator in Script Operator Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BFB330E6-9A3B-4C24-B28C-C7750F1FBECB\"></a><div class=\"head\">\n            <h1>Speed Operator in Script Operator Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848BE\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848BF\"></a>The following example shows a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span> that creates a <span class=\"char_link\"><a href=\"GUID-6D1935F6-F7AE-445A-9F99-726310E28E31.htm\">Speed operator</a></span> and uses it to simulate its own functionality. It is possible to create several standard\n            operators in this manner, set their properties in the Init block, and use them all\n            together in succession in the Proceed block. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848C0\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848C1\"></a>Must be used inside a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848C2\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848C3\"></a>This is basically a script wrapped around a Speed Operator. The Script Operator has\n            the same functionality as the encapsulated Speed Operator inside of it. Using this\n            as the starting point, the script can be enhanced to add scripted functionality to\n            the existing operator. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E848C4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E848C5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E10\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\non ChannelsUsed pCont do\n(\n-- No channels specified because the script doesn\'t make direct\n-- access to particle data\n)\n \n--The Init handler is called on initialization.\n--It is used to get the Speed action or create a new one\n--if there is not an existing one\non Init pCont do\n(\n--Get an existing Speed Action by its unique name.\nbb = $Speed74b93a88\n \n--If the unique action does not exist, create one and give it\n--the unique name. If you are reusing the code in multiple\n--Script Operators, change the name to have a unique ID!\nif (bb == undefined) then\n(\nParticleFlow.BeginEdit()\nbb = Speed()\nbb.name =\"Speed74b93a88\"\nbb.speed = 100\nParticleFlow.EndEdit()\n)\ninitActions = pCont.getInitActions()\n--Call the Init method in the Speed Action and pass\n--the Particle container, Particle System object and node\n--and the init action objects and nodes from the Scripted Operator.\nbb.Init (pCont.getParticleContainer()) (pCont.getParticleSystem()) (pCont.getParticleSystemNode()) (pCont.getInitActions()) (pCont.getInitActionNodes())\n)\n \n--In the Proceed handler, we can call the .Proceed method\n--of the Operator Interface and pass the container,\n--particle system object and node, and\n--the Init Action objects and nodes\n--This means that the external Speed action will proceed whenever\n--the Script_Operator does.\non Proceed pCont do\n(\nt_start = pCont.GetTimeStart() as time\nt_end = pCont.GetTimeEnd() as time\nbb = $Speed74b93a88\nif (bb != undefined) then\n(\nbb.Proceed (pCont.getParticleContainer()) t_start &amp;t_end (pCont.getParticleSystem()) (pCont.getParticleSystemNode()) bb (pCont.GetIntegrator())\n)\npCont.SetTimeEnd t_end\n)\n \n--In the Release hander of the Script_Operator,\n--call the.Release method and pass the container of the\n--Script_Operator. \non Release pCont do\n(\nbb = $Speed74b93a88\nif (bb != undefined) then\nbb.Release(pCont.getParticleContainer())\n)\n \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84908\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84909\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";