var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C0BFFE27-BB59-4265-8F70-BFE8A636F7CB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"simpleObject Plug-in\">\n      <meta name=\"indexterm\" content=\"geometry - Node\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted SimpleObject Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C0BFFE27-BB59-4265-8F70-BFE8A636F7CB\"></a><div class=\"head\">\n            <h1>Scripted SimpleObject Plug-ins </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5231\"></a>   A SimpleObject is a kind of geometry primitive that is defined by a tri-mesh such\n            as, a box, sphere, cone, and so on. In other words, a simpleObject plugin is similar\n            to all the Standard and Extended primitives in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"GUID-224A7BBE-0308-4922-BEAC-2428FEEB37CB\"></a>In scripting a SimpleObject plug-in, you need to supply a handler for building this\n            mesh and <em class=\"strong\">3ds Max</em> automatically handles the scene display, hit-testing, ray intersection, rendering,\n            modifier applicability, and others. \n         </p>\n         <p><a name=\"GUID-17FF96EF-7A86-4A21-9836-ADE63B2871AD\"></a>A scripted SimpleObject plug-in is declared by specifying the <span class=\"code\"> &lt;superclass&gt; </span> as <span class=\"code\"> <em class=\"strong\">simpleObject</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-522D\"></a>Scripted SimpleObject plug-ins <em class=\"strong\">require </em> a <span class=\"code\"> <em class=\"strong\">create</em> </span> tool. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-522C\"></a>A SimpleObject plug-in must not perform any scene related actions such as, creating\n            scene nodes or building modifier stacks. It must only adjust its parameters in the\n            mouse tool handlers and construct a mesh in the <span class=\"code\"> <em class=\"strong\">buildMesh</em> </span> handler. Attempting to create scene nodes or applying modifiers in a SimpleObject\n            plug-in will cause all kinds off strange interactions with the in-progress scene node\n            creation. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-522B\"></a>A SimpleObject plug-in has a predefined local variable <span class=\"code\"> <em class=\"strong\">mesh</em> </span>. This variable contains the underlying mesh of the object being created. The <span class=\"code\"> <em class=\"strong\">mesh</em> </span> local variable is accessible in any of the plug-in\'s handlers, but is typically only\n            built in the <span class=\"code\"> <em class=\"strong\">buildMesh</em> </span> handler. You can either modify the existing TriMesh value in place using the TriMesh\n            methods, or construct a new TriMesh value and assign it to the <span class=\"code\"> <em class=\"strong\">mesh</em> </span> plug-in local variable. The TriMesh methods and properties are described in <span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Editable Mesh</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-522A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5229\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A5\"></a><pre>\nplugin simpleObject tower_plugin_def\nname:\"Tower\"\nclassID:#(145345,543211)\ncategory:\"Scripted Primitives\"\n(\n  parameters main rollout:params\n  (\n    height type:#worldUnits ui:height default:0\n    width type:#worldUnits ui:width default:0\n    depth type:#worldUnits ui:depth default:0\n  )\n  rollout params \"Two Faces Parameters\"\n  (\n    spinner height \"Height\" type:#worldunits range:[-1000,1000,0]\n    spinner width \"Width\" type:#worldunits range:[-1000,1000,0]\n    spinner depth \"Depth\" type:#worldunits range:[-1000,1000,0]\n  )\n  on buildMesh do\n  (\n    setMesh mesh \\\n    verts:#([0,0,0],[width,0,0],[width,depth,0],[0,depth,0]) \\\n    faces:#([3,2,1], [1,4,3])\n    extrudeFace mesh #(1,2) (height * 0.5) 40 dir:#common\n    extrudeFace mesh #(1,2) (height * 0.5) 50 dir:#common\n  )\n  tool create\n  (\n    on mousePoint click do\n      case click of\n      (\n        1: nodeTM.translation = gridPoint\n        3: #stop\n       )\n    on mouseMove click do\n      case click of\n      (\n        2: (width = gridDist.x; depth = gridDist.y)\n        3: height = gridDist.z\n      )\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51FC\"></a>In this script a new primitive called Tower is defined. It constructs a very simple\n            tower form; the first drag sets the base and the second drag sets the height. It contains\n            three animatable rollout parameters: <span class=\"code\"> <em class=\"strong\">height</em> </span>, <span class=\"code\"> <em class=\"strong\">width</em> </span>, and <span class=\"code\"> <em class=\"strong\">depth</em> </span>, which set the object\'s basic bounds. The key components here are the <span class=\"code\"> <em class=\"strong\">create</em> </span> tool and the <span class=\"code\"> <em class=\"strong\">on buildMesh</em> </span> handler, and they work together in a simple way. The <span class=\"code\"> <em class=\"strong\">create</em> </span> tool sets the values of the parameters and the <span class=\"code\"> <em class=\"strong\">on buildMesh</em> </span> handler constructs a mesh based on the parameter values. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51FB\"></a>The <span class=\"code\"> <em class=\"strong\">create</em> </span> tool can also access and set the position of the node that is being created to contain\n            the new object through the Matrix3 value in the pre-defined mouse tool local variable\n            <span class=\"code\"> <em class=\"strong\">nodeTM</em> </span>. In this case, the position portion of the node\'s TM is set to the initial mouse\n            down world position. The <span class=\"code\"> <em class=\"strong\">on mouseMove</em> </span> handler sets the width and depth during click 2 and the height during click 3. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51FA\"></a>The <span class=\"code\"> <em class=\"strong\">on buildMesh</em> </span> handler constructs the desired mesh in the TriMesh value in the pre-defined plug-in\n            local variable <span class=\"code\"> <em class=\"strong\">mesh</em> </span>. Typically, it does this by building the mesh from scratch each time the handler\n            is called. In the above example, the mesh is initially set to a simple two-face rectangular\n            plane (using <span class=\"code\"> <em class=\"strong\">setMesh()</em> </span>), and then the two faces are extruded up and scaled-down twice to get the simple\n            tower. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51F9\"></a>The <span class=\"code\"> <em class=\"strong\">mesh</em> </span> plug-in local variable is accessible in any of the plug-in\'s handlers, but is typically\n            built only in the <span class=\"code\"> <em class=\"strong\">on buildMesh</em> </span> handler. You can either modify the existing TriMesh value in place using the TriMesh\n            methods, or construct a new TriMesh value and assign it to the <span class=\"code\"> <em class=\"strong\">mesh</em> </span> plug-in local variable. The TriMesh created must be valid or a <em class=\"strong\">3ds Max</em> crash might occur. All face, vertex, material ID, and texture vertex arrays allocated\n            must be filled in the handler. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51F8\"></a>There are three additional event handlers that might be implemented for a scripted\n            SimpleObject: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A4\"></a><pre><em class=\"codeEmphasisStrong\">on OKtoDisplay do</em> &lt;boolean_expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51F6\"></a>If the <span class=\"code\"> <em class=\"strong\">OKtoDisplay</em> </span> event handler is implemented, <span class=\"code\"> <em class=\"strong\">&lt;boolean_expr&gt;</em> </span> must return <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span> depending on whether it is OK to display the current mesh. This is useful in situations\n            where a mesh might be in some degenerate state for certain parameter settings and\n            must not be displayed in the viewports. The default implementation is <span class=\"code\"> <em class=\"strong\">true</em> </span>. Note that empty meshes are OK to display. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A3\"></a><pre><em class=\"codeEmphasisStrong\">on hasUVW do</em> &lt;boolean_expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51F3\"></a>If the <span class=\"code\"> <em class=\"strong\">hasUVW</em> </span> event handler is implemented, <span class=\"code\"> <em class=\"strong\">&lt;boolean_expr&gt;</em> </span> must return <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span> depending on whether UVW coordinates are present on the mesh. In many primitive objects,\n            a Generate Mapping Coords checkbox is provided for the user to control UVW coordinate\n            generation and the <span class=\"code\"> <em class=\"strong\">hasUVW</em> </span> handler expression returns the state of this checkbox. The default implementation\n            returns <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span> depending on whether the mesh has texture vertices or not. At present, only a single\n            map channel is supported. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A2\"></a><pre><em class=\"codeEmphasisStrong\">on setGenUVW</em> &lt;onOff&gt; <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51F0\"></a>The <span class=\"code\"> <em class=\"strong\">setGenUVW</em> </span> event handler is called when <em class=\"strong\">3ds Max</em> wants the plug-in to automatically generate mapping coordinates. This happens when\n            you first render an object that has a material applied, but not mapping coordinates.\n            It is called with a switch argument <span class=\"code\"> <em class=\"strong\">&lt;onOff&gt;</em> </span>, which is <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span> to turn on or turn off the mapping coordinates. If your plug-in is managing mapping\n            coordinates, it must implement this handler and generate mapping coordinates when\n            called with a <span class=\"code\"> <em class=\"strong\">true</em> </span> argument. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51EE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-51ED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A1\"></a><pre>\nplugin simpleObject TexturePlane\nname:\"TexturePlane\"\nclassID:#(0x19a75166, 0x83e3a1c7)\ncategory:\"MAXScript Examples\"\n(\nparameters main rollout:params\n(\n  Size type:#worldUnits ui:size default:0\n  genMapCoords type:#boolean ui:gen_Map_Coords default:false animatable:false\n  u_tile type:#float default:1.0 ui:u_step\n  v_tile type:#float default:1.0 ui:v_step\n)\nrollout params \"TexturePlane\"\n(\n  group \"Geometry\"\n  (\n    spinner size \"Size:\" type:#worldunits range:[0,1000,1]\n  )\n  group \"Mapping\"\n  (\n    spinner u_step \"U Tiling\" scale:0.01\n    spinner v_step \"V Tiling\" scale:0.01\n    checkbox gen_Map_Coords \"Generate Mapping Coords.\"\n  )\n) --end roll\n\n--When Max wants to know whether the object has UV coords,\n--return the value stored in genMapCoords to inform it of\n--the current UV sate of the plug-in.\n\n<em class=\"codeEmphasisStrong\">on hasUVW do genMapCoords</em> \n\n--When 3ds Max tells the plug-in to turn on UV coordinates \n--(for example when applying a texture \n--with \"Show Map In Viewport\" checked), \n--this handler will automagically check the checkbutton \n--connected to our parameter called genMapCoords. \n--Also, when the user changes the checkbox, \n--the variable will tell the builMesh to generate coordinates. \n--Note that the handler will override the manual settings, \n--for example if a texture has \"Show Map In Viewport\" enabled, \n--you cannot actually uncheck the \"Generate Mapping Coords.\" \n--checkbox with the mouse! \n					 \n<em class=\"codeEmphasisStrong\">on setGenUVW bool do genMapCoords = bool</em> \n\non buildMesh do ( \n  --Generate a simple Quad \n  local vertex_array = #() \n  append vertex_array [-size/2,-size/2,0] \n  append vertex_array [size/2,-size/2,0] \n  append vertex_array [size/2,size/2,0] \n  append vertex_array [-size/2,size/2,0] \n  face_array = #( [1,2,3], [1,3,4] ) \n  setMesh mesh verts:vertex_array faces:face_array \n  --If the checkbox was enabled and we want \n  --coordinates to be generated... \n					 \n  <em class=\"codeEmphasisStrong\">if genMapCoords then</em> <em class=\"codeEmphasisStrong\">(</em> --define the texture vertices \n    <em class=\"codeEmphasisStrong\">local uvw_array = #()</em> <em class=\"codeEmphasisStrong\">append uvw_array [0.0,0.0,0.0]</em> <em class=\"codeEmphasisStrong\">append uvw_array [u_tile ,0.0,0.0]</em> <em class=\"codeEmphasisStrong\">append uvw_array [u_tile ,v_tile ,0.0]</em> <em class=\"codeEmphasisStrong\">append uvw_array [0.0,v_tile ,0.0]</em> \n    --set the number of vertices \n    <em class=\"codeEmphasisStrong\">setNumTVerts mesh uvw_array.count</em> \n    --set all vertices \n    <em class=\"codeEmphasisStrong\">for v = 1 to uvw_array.count do</em> <em class=\"codeEmphasisStrong\">setTVert mesh v uvw_array[v]</em> \n    --build texture faces \n    <em class=\"codeEmphasisStrong\">buildTVFaces mesh false</em> \n    --set all texture faces (in this case using the mesh faces \n    --since we happen to have a one-to-one correspondence \n    --between vertices and texture vertices.) \n    --This is not always the case though... \n    <em class=\"codeEmphasisStrong\">for f = 1 to face_array.count do</em> <em class=\"codeEmphasisStrong\">setTVFace mesh f face_array[f]</em> <em class=\"codeEmphasisStrong\">)</em> \n)--end on buildMesh \ntool create \n( \n  on mousePoint click do \n  case click of \n  ( \n    1: ( nodeTM.translation = gridPoint ) \n    2: ( #stop) \n  ) \n  on mouseMove click do \n  case click of \n  ( \n    2: (Size= abs gridDist.x) \n  ) \n  ) \n)--end plugin \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5185\"></a>Here is another example that creates a mesh by first building other temporary objects\n            and using mesh booleans to build the final mesh: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5183\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5182\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A0\"></a><pre>\nplugin simpleObject squareTube\nname:\"SquareTube\"\nclassID:#(63445,55332)\ncategory:\"Scripted Primitives\"\n(\nlocal box1, box2\nparameters main rollout:params\n(\n  length type:#worldUnits ui:length default:1E-3\n  width type:#worldUnits ui:width default:1E-3\n  height type:#worldUnits ui:height default:1E-3\n)\nrollout params \"SquareTube\"\n(\n  spinner height \"Height\" type:#worldUnits range:[1E-3,1E9,1E-3]\n  spinner width \"Width\" type:#worldUnits range:[1E-3,1E9,1E-3]\n  spinner length \"Length\" type:#worldUnits range:[-1E9,1E9,1E-3]\n)\non buildMesh do\n(\n  if box1 == undefined do\n    (box1 = createInstance box; box2 = createInstance box)\n  box1.height = height; box2.height = height\n  box1.width = width; box2.width = width * 2\n  box1.length = length; box2.length = length * 2\n  mesh = box2.mesh - box1.mesh\n)\ntool create\n(\n  on mousePoint click do\n    case click of\n    (\n      1: nodeTM.translation = gridPoint\n      3: #stop\n    )\n  on mouseMove click do\n    case click of\n    (\n      2: (width = abs gridDist.x; length = abs gridDist.y)\n      3: height = gridDist.z\n    )\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5153\"></a>In this example, the parameters and rollouts are handled in a similar manner to the\n            first example, but the <span class=\"code\"> <em class=\"strong\">buildMesh</em> </span> handler generates the mesh in an indirect way. The final object is in the form of\n            a rectangular pipe, a box with a box hole through the middle. Two plug-in locals (<span class=\"code\"> <em class=\"strong\">box1</em> </span> and <span class=\"code\"> <em class=\"strong\">box2</em> </span>) are made to contain Box base objects whose size parameters are set according to\n            the plug-in\'s parameters (<span class=\"code\"> <em class=\"strong\">box2</em> </span> is the outer box and <span class=\"code\"> <em class=\"strong\">box1</em> </span> is the hole). The final mesh is made by boolean subtraction of <span class=\"code\"> <em class=\"strong\">box1</em> </span> from <span class=\"code\"> <em class=\"strong\">box2</em> </span>. In this case, a separate new mesh is created and assigned to the <span class=\"code\"> <em class=\"strong\">mesh</em> </span> plug-in local variable, in contrast to the first example that modified the object\'s\n            original mesh directly. Either method is okay. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5152\"></a>The <span class=\"code\"> <em class=\"strong\">createInstance()</em> </span> method is used to directly create the box base objects. This method creates the geometry\n            associated with the specified object, but does not create a node. This method is used\n            since SimpleObject plug-in must not perform any scene related actions such as, creating\n            scene nodes or building modifier stacks. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5150\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-514F\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-514E\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-514D\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-514C\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";