var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C0F38270-F5DD-4356-AFFF-B037D97F0017\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"The SDK and MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>The SDK and MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C0F38270-F5DD-4356-AFFF-B037D97F0017\"></a><div class=\"head\">\n            <h1>The SDK and MAXScript </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC394A\"></a>  <em class=\"strong\">3ds Max</em> gives you two ways to write plug-in applications: the SDK, which uses C++, and MAXScript,\n            the program\'s native scripting language. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC394C\"></a>Which language you choose depends partly on how you want to work, and partly on what\n            you want your plug-in to accomplish. Both languages have their strengths and limitations,\n            but you can develop complex applications with either of them. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC394E\"></a> \n            <h2><a name=\"GUID-105C32AF-2414-4993-91E3-9250B79C7C0A\"></a>MAXScript\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC394F\"></a>In general, MAXScript plug-ins run more slowly than comparable plug-ins written in\n               C++, so if performance is an issue, using the SDK is probably preferable. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3950\"></a>On the other hand, MAXScript provides some methods that are higher level than those\n               to be found in the C++ SDK, and supports a few<em class=\"strong\"> 3ds Max </em>features and capabilities that are not exposed to the SDK. If your feature needs functionality\n               supported by MAXScript but not the SDK, then MAXScript is your only choice. In particular,\n               exposing <em class=\"strong\">3ds Max </em>features via OLE/ActiveX/DotNet controls is easier to code in MAXScript than it is\n               with the SDK. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3951\"></a>MAXScript can be useful for prototyping plug-ins, developing comparatively small features,\n               and writing test suites. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3952\"></a> \n            <h2><a name=\"GUID-B0490AC3-B1D7-4DC2-B92C-71364B718017\"></a>The SDK\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3953\"></a>The SDK is preferable when performance is important; in general, this is when computation\n               rather than interactivity is the main purpose of the plug-in. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3954\"></a>Performance is most often an issue when the plug-in handles large sets of entities\n               such as objects, sub-objects, files, notification messages, and so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3955\"></a>On the flip side, developing and especially debugging a C++ plug-in can be orders\n               of magnitude slower as it requires often recompiling, restarting of <em class=\"strong\">3ds Max</em> and tweaking of GUI resources. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3957\"></a> \n            <h2><a name=\"GUID-B23FF423-6FC3-422A-B865-D807DCB733A0\"></a>The Middle Way\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3958\"></a>In some cases, combining the positive sides of the two approaches while negating their\n               shortcoming can be a good idea. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3959\"></a>Implementing a hybrid system where the time-critical functionality is written using\n               the SDK and exposed to MAXScript as Function Publishing Interfaces while the User\n               Interface is taken care of by MAXScript can shorten the development time and even\n               allow certain flexibility in updating features or letting the end user reconfigure\n               the UI while using the same underlying C++ code. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"\">Developing Scripted Plug-ins - Topics Index </a></span></li>\n                  <li><span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";