var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Callbacks\">\n      <meta name=\"indexterm\" content=\"general event callback mechanism\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>General Event Callback Mechanism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36\"></a><div class=\"head\">\n            <h1>General Event Callback Mechanism </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18DA\"></a>MAXScript allows you to register callback scripts for all of the notification events\n            supported by \n            		<em class=\"strong\">3ds Max</em>, such as pre/post scene file open, new, reset, scene file save, pre/post render,\n            selection change, etc. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18D9\"></a>You can specify any number of callback scripts per notification event. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18D8\"></a>Callback scripts can be bundled into sets with user-defined IDs and can be deleted\n            by type, by ID or by both. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18D7\"></a>Callback scripts can be specified as persistent so that they are saved and loaded\n            with the currently open file. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B9\"></a> \n            <h2><a name=\"GUID-A24EED25-F171-466D-B474-EAE2F028AACC\"></a>Adding Callbacks\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B7\"></a>The callbacks are added using the following syntax: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6910\"></a><pre><em class=\"codeEmphasisStrong\">callbacks</em>.<em class=\"codeEmphasisStrong\">addScript</em> &lt;callback_type_name&gt; (&lt;script_string&gt; | &lt;script_stringstream&gt; | <em class=\"codeEmphasisStrong\">fileName</em>:&lt;filename_string&gt;) [<em class=\"codeEmphasisStrong\">id</em>:&lt;name&gt;] [<em class=\"codeEmphasisStrong\">persistent</em>:&lt;boolean&gt;] 		</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B5\"></a>This method is used to register a new callback script. Requires as the first argument\n               a name that specifies which type of notify event this script is associated with. The\n               list of valid \n               		  <span class=\"code\"> <em class=\"strong\">callback_type_name</em> </span> values is listed below. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B4\"></a>The script is supplied either as a direct String or StringStream value containing\n               the text of the script to run, or as a \n               		  <span class=\"code\"> <em class=\"strong\">fileName:</em> </span> keyword argument, in which case the named file is loaded and run whenever the event\n               notification callback occurs. You can specify either a direct string or a \n               		  <span class=\"code\"> <em class=\"strong\">fileName:</em> </span>, but not both. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B3\"></a>The optional \n               		  <span class=\"code\"> <em class=\"strong\">id:</em> </span> parameter lets you tag one or a group of callbacks with a unique name so that you\n               can remove them all as a group without interfering with other callbacks, perhaps registered\n               by other scripted tools. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B2\"></a>The optional \n               		  <span class=\"code\"> <em class=\"strong\">persistent:</em> </span> parameter lets you control whether the script is saved permanently in the currently\n               open scene file or is a global callback script that remains in place no matter what\n               file opening and closing is performed. A \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> value for the parameter specifies that the script should be stored in the current\n               file and loaded and registered for callback whenever that file is opened again. Persistent\n               callback scripts are always removed when a new file is loaded or a reset is performed\n               so that persistent scripts in one file don\'t accidentally get copied to a later file.\n               The default for this parameter is \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, indicating the script is a global script and is not persistent. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18B0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690F\"></a><pre>\ncallbacks.addScript #preRender \"setUpRenderGeom()\" id:#jbwRender\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18AC\"></a><p class=\"table-body\">This registers a new callback script that will be called just before a render is performed.\n                           The script invokes a function (that has presumably already been set up). A unique\n                           ID has been assigned to the script for later selective removal. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18AA\"></a> \n            <h2><a name=\"GUID-385DFF8D-AC3E-44B8-ACEF-E48E80EB9221\"></a>Removing Callbacks\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690E\"></a><pre><em class=\"codeEmphasisStrong\">callbacks</em>.<em class=\"codeEmphasisStrong\">removeScripts</em> [&lt;callback_type_name&gt;] [<em class=\"codeEmphasisStrong\">id</em>:&lt;name&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A8\"></a>This method is used to unregister and remove one or more callback scripts. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A7\"></a>Specifying just a callback event type name removes all the callback scripts for that\n               event type. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A6\"></a>Specifying just an \n               		  <span class=\"code\"> <em class=\"strong\">id:</em> </span> removes all callback scripts in all events with that ID. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A5\"></a>Specifying both limits the ID-based removal to the specified event type. \n               		\n            </p> \n            <p><a name=\"P_5E5AE9C1486142189923BFBD2B1FEB36\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A4\"></a> \n            <h2><a name=\"GUID-10454B23-DF7B-4883-8EDA-28BC054E4139\"></a>Inspecting Callbacks\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690D\"></a><pre><em class=\"codeEmphasisStrong\">callbacks</em>.<em class=\"codeEmphasisStrong\">show</em> [&lt;callback_type_name&gt;] [<em class=\"codeEmphasisStrong\">id:</em>&lt;name&gt;] [<em class=\"codeEmphasisStrong\">to:</em>&lt;stream&gt;] \\\n  [<em class=\"codeEmphasisStrong\">asArray</em>: &lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A1\"></a>This method lists out the current callback scripts in the Listener window, or to an\n               optional stream. Callbacks are listed with their ID, persistent setting, and the script\n               or filename in which they are defined. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-18A0\"></a>If the optional callback type name argument is specified in \n               		  <em class=\"strong\">3ds Max 2009 and higher</em>, only callbacks of that type will be shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-189F\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">id:</em> </span> is specified, only callbacks with that ID will be shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-189E\"></a>If type name and ID are both specified, only callbacks of the type with the given\n               ID will be shown. \n               		\n            </p> \n            <p>Available in \n               		  <em class=\"strong\">3ds Max 2018.4 and higher</em>: If the optional keyword argument \n               		  <span class=\"code\"><em class=\"strong\">to:</em></span> is specified, output from the method is sent to the specified stream. \n               		\n            </p> \n            <p> If the optional keyword argument \n               		  <span class=\"code\"><em class=\"strong\">asArray:</em></span> is specified, the output is returned as an array, with an element for each callback.\n               Available in \n               		  <em class=\"strong\">3ds Max 2019.3 Update and higher</em>. Each element is an array that contains information about the callback. \n               		\n            </p> <a name=\"TABLE_2EA485D3884B450E9F51E7A12F85ED23\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"><em class=\"strong\">Example</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>-- show callbacks of type #filePreOpen\ncallbacks.show #filePreOpen\n--&gt; output:\nfilePreOpen:\n  id:#PhysXPlugin, persistent:false, script:\"px_filePreOpen()\"\n  id:#ALC_SecurityTool, persistent:false, script:\"::ALC_SecurityTool.scenePreOpen()\"\n  id:#CRP_SecurityTool, persistent:false, script:\"::CRP_SecurityTool.m_in_file_open = true;::CRP_SecurityTool.register_post_load_check()\"\n  id:#ADSL_SecurityTool, persistent:false, script:\"::ADSL_SecurityTool.m_in_file_open = true;::ADSL_SecurityTool.register_post_load_check()\"\n\n-- the same thing, but as an array:\ncallbacks.show #filePreOpen asArray:true\n--&gt; output:\n#(#(#filePreOpen, #PhysXPlugin, false, false, \"px_filePreOpen()\"), #(#filePreOpen, #ALC_SecurityTool, false, false, \"::ALC_SecurityTool.scenePreOpen()\"), #(#filePreOpen, #CRP_SecurityTool, false, false, \"::CRP_SecurityTool.m_in_file_open = true;::CRP_SecurityTool.register_post_load_check()\"), #(#filePreOpen, #ADSL_SecurityTool, false, false, \"::ADSL_SecurityTool.m_in_file_open = true;::ADSL_SecurityTool.register_post_load_check()\"))</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_977AFC8C6A944369924543714C371D18\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690C\"></a><pre><em class=\"codeEmphasisStrong\">callbacks</em>.<em class=\"codeEmphasisStrong\">broadcastCallback</em> &lt;callback_type_name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-189B\"></a>This method provides a way for you to simulate one of the events and have all the\n               callback scripts for it executed. \n               		\n            </p> \n            <p><a name=\"GUID-72DE60C6-B19B-4FE4-9DE7-BCC62CFF988D\"></a>Within \n               		  <em class=\"strong\">3ds Max</em>, the \n               		  <span class=\"code\"> <em class=\"strong\">#preRenderFrame</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">#postRenderFrame</em> </span> callbacks can only be called by the renderer. These callbacks can not be called by\n               using this method. \n               		\n            </p> \n            <p><a name=\"P_0BA710DE551B4A5595AC390F1A90F26D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-189A\"></a> \n            <h2><a name=\"GUID-CDAD184B-B000-47A3-8276-F8E6F1438B01\"></a> <em class=\"strong\">Additional Notification Information on the Callback:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690B\"></a><pre><em class=\"codeEmphasisStrong\">callbacks.notificationParam</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1897\"></a>This method can be called in a callback script to provide additional information on\n               the callback. The value returned by this method varies based on the callback type.\n               If no additional information was present for the callback, a value of \'undefined\'\n               is returned. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1896\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1895\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-690A\"></a><pre>\n--Remove any existing callbacks with this ID.\ncallbacks.removeScripts id:#MXSHelp\n--Add a new callback script which will call\n--callbacks.notificationParam() before selected nodes are deleted\n--and thus will print the deleted objects to the Listener:\ncallbacks.addScript #selectedNodesPreDelete\" print (callbacks.notificationParam())\" id:#MXSHelp\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-188B\"></a> \n            <h2><a name=\"GUID-D5AAA4F4-D7C2-4BEE-8596-E53472A2BEDA\"></a> <em class=\"strong\">Callback Event Names and notificationParam Return Values</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-188A\"></a>These are all supported the Callback Event Names and the \n               		  <span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> values typically returned. Depending on how the broadcast is generated, a value of\n               \'undefined\' may be returned by this method instead of the value shown. \n               		\n            </p> <a name=\"TABLE_8693AE09E3C8427DABE040AE3976EFD7\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-E67F6251-E084-4394-AD5E-547085406CAC.htm\">ActionItem Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-2AE51843-EB2C-482F-A1FE-B5C0751C4023.htm\">Named Selection Set Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-678E1808-607A-45D6-9F17-14331F2BD3BF.htm\">Animation Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-F0CD0BD9-FC77-4881-8021-102B5837F7B2.htm\">Node Related Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-60F9451E-7F2D-48FB-AFC8-EBC7E8CC323A.htm\">Direct3D Device Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-2ABCA59B-A1A3-497E-B800-05427B6CD937.htm\">Plug-in Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-1FFA4B15-B79E-4E5D-BBB4-36F5D682CC30.htm\">FileLink Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-42FCADDD-0007-4576-8596-86D219675C59.htm\">Radiosity Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-2D8606DF-EF5D-4F5B-A00C-B10D29A14947.htm\">File Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-E5BE0058-2216-4E0B-88AF-680CA58AAC73.htm\">Rendering Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-B4DF545D-009C-40E2-9EF1-0FC231106BC5.htm\">Image Viewer Display Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-93CBF022-D7A1-4742-A7DE-AEB554CD238C.htm\">Render Dialog and Renderer Plugin Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-55051341-B0BA-41AA-AFAE-E7C46EE2A124.htm\">Layer System Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-6C08C910-3C6E-4926-BD11-2DC0EEDDC757.htm\">Schematic Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-316B2E8E-39B6-4310-BA48-743F99D41F0A.htm\">Manipulate Mode Notification</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-C9E47563-0AD8-40DD-93E1-D79735737241.htm\">System Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-A39363BA-4844-496A-976B-648DFA543043.htm\">Modifier Panel Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-3C42A302-2746-4E88-A7D4-8B40F362B168.htm\">Undo System Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-C70CD1C6-5739-4C12-96BA-E439FDAF9299.htm\">Modifier Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-8187DB00-BDA4-49F3-BC8E-8AB0A31C092A.htm\">Xrefs Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-AB66611D-2FE2-4F6F-990B-BC194C869AEE.htm\">Material Library Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-EF9E6C50-CD43-4A71-9162-3D0B6B4463C3.htm\">Other Notifications</a></span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"char_link\"><a href=\"GUID-F602E1AE-4C75-4FC5-91E3-8076715F70F0.htm\">Material Notifications</a></span> \n                     </td>\n                     <td class=\"table-body\">&nbsp; </td>\n                  </tr>\n               </table>\n            </div> \n            <p> </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-161D\"></a> <span class=\"char_link\"><a href=\"GUID-F7FA2755-0408-4610-ABDB-B403D85AA597.htm\">How To ... Change Objects At Render Time</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-161C\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-161B\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-161A\"></a> <span class=\"char_link\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">Time Change Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1619\"></a> <span class=\"char_link\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">Viewport Redraw Callback Mechanism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E67F6251-E084-4394-AD5E-547085406CAC.htm\">ActionItem Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-678E1808-607A-45D6-9F17-14331F2BD3BF.htm\">Animation Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-60F9451E-7F2D-48FB-AFC8-EBC7E8CC323A.htm\">Direct3D Device Notification</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-1FFA4B15-B79E-4E5D-BBB4-36F5D682CC30.htm\">FileLink Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-2D8606DF-EF5D-4F5B-A00C-B10D29A14947.htm\">File Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-B4DF545D-009C-40E2-9EF1-0FC231106BC5.htm\">Image Viewer Display Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-55051341-B0BA-41AA-AFAE-E7C46EE2A124.htm\">Layer System Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-316B2E8E-39B6-4310-BA48-743F99D41F0A.htm\">Manipulate Mode Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-A39363BA-4844-496A-976B-648DFA543043.htm\">Modifier Panel Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-C70CD1C6-5739-4C12-96BA-E439FDAF9299.htm\">Modifier Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-AB66611D-2FE2-4F6F-990B-BC194C869AEE.htm\">Material Library Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-F602E1AE-4C75-4FC5-91E3-8076715F70F0.htm\">Material Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-2AE51843-EB2C-482F-A1FE-B5C0751C4023.htm\">Named Selection Set Notification</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-F0CD0BD9-FC77-4881-8021-102B5837F7B2.htm\">Node Related Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-2ABCA59B-A1A3-497E-B800-05427B6CD937.htm\">Plug-in Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-42FCADDD-0007-4576-8596-86D219675C59.htm\">Radiosity Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E5BE0058-2216-4E0B-88AF-680CA58AAC73.htm\">Rendering Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-93CBF022-D7A1-4742-A7DE-AEB554CD238C.htm\">Render Dialog and Renderer Plugin Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-6C08C910-3C6E-4926-BD11-2DC0EEDDC757.htm\">Schematic View Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-C9E47563-0AD8-40DD-93E1-D79735737241.htm\">System Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-3C42A302-2746-4E88-A7D4-8B40F362B168.htm\">Undo System Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-8187DB00-BDA4-49F3-BC8E-8AB0A31C092A.htm\">Xrefs Notifications</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-EF9E6C50-CD43-4A71-9162-3D0B6B4463C3.htm\">Other Notifications</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";