var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C20D1836-542E-4458-B8A5-4D8C806FA120\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"ModifierArray Values\">\n      <meta name=\"indexterm\" content=\"collections\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ModifierArray Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C20D1836-542E-4458-B8A5-4D8C806FA120\"></a><div class=\"head\">\n            <h1>ModifierArray Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74FD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74FC\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> &gt; ModifierArray Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74FA\"></a>A<em class=\"strong\"> ModifierArray</em> represents the modifiers present on a scene node as an array. \n         </p>\n         <p><a name=\"P_6EE6BAE52A6B4D7F86DDE5E182B39DAB\"></a>As such, you can access a modifier by index, iterate over the modifiers, and apply\n            mapped functions to the modifiers. \n         </p>\n         <p><a name=\"P_0C04CB7849EA499C964BB136D405AE1A\"></a>See also <span class=\"char_link\"><a href=\"GUID-55EC8090-6593-416B-923F-2291D3983BC6.htm\">Modifiers</a></span>. \n         </p>\n         <p><a name=\"P_918C3643D62D43F684006F77F92C1B32\"></a>ModifierArray values are <em class=\"strong\">mappable</em>. \n         </p>\n         <p><a name=\"P_22C6E8101E4D4B579C2F966B7726EBB9\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74F9\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D90\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">modifiers</em> </pre></div>\n         <p><a name=\"P_11A5562772F74C3CB3A74690438E3BB2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74F7\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D8F\"></a><pre>&lt;modifierarray&gt;.<em class=\"codeEmphasisStrong\">count </em>: Integer, read-only   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74F5\"></a>Returns the number of modifiers in the modifier array. \n         </p>\n         <p><a name=\"P_4759CDD180D94B31AA75FB7A24CC0A73\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74F4\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D8E\"></a><pre>&lt;modifierarray&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74F2\"></a>Retrieves indexed modifier. Index is 1-based with 1 being the modifier on the top\n            of the modifier stack. \n         </p>\n         <p><a name=\"P_39FFD815404942E8B27969D2F5803246\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D8D\"></a><pre>&lt;modifierarray&gt;<em class=\"codeEmphasisStrong\">[</em>( &lt;name&gt; | &lt;string&gt; )<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74EF\"></a>Retrieves named modifier using modifier name as string or name. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74ED\"></a> <span class=\"char_link\"><a href=\"GUID-29CF3A8E-D9CC-4233-AEBF-FF0989FBB859.htm\">Modifier and SpacewarpModifier Types</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-74EC\"></a> <span class=\"char_link\"><a href=\"GUID-55EC8090-6593-416B-923F-2291D3983BC6.htm\">Modifier : MAXWrapper and SpacewarpModifier : MAXWrapper</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";