var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C30999F3-2BB4-4A16-AB70-634F96DC72A9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Select a Face of an Editable Mesh by its Index?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C30999F3-2BB4-4A16-AB70-634F96DC72A9\"></a><div class=\"head\">\n            <h1>How do I Select a Face of an Editable Mesh by its Index? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10AD\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10AF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B0\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8DC\"> Working With Editable Meshes</a></span> &gt; How Do I Select a Face of an Editable Mesh by its Index? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B3\"></a> \n            <h2><a name=\"GUID-ED5705E7-AC10-4E87-A248-7F59B124C854\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B4\"></a>Is there a way to select a face in an editable mesh when you only know its index?\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B5\"></a> \n            <h2><a name=\"GUID-F9B674F5-AE63-49FE-93D3-F47803C3A8F0\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B6\"></a>When doing it just once, you can quickly type in the Listener something like: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-663E\"></a><pre>\nsetFaceSelection $ {10}\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B8\"></a>This selects the face with index 10 assuming that a single object is selected and\n               it is an Editable_Mesh. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10B9\"></a>If you are doing this very often, the following macroScript provides a UI with a spinner\n               to select the face index and some error handling: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10BA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10BB\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-663D\"></a><pre>\nmacroScript FaceByIndex category:\"MXS Help\"\n(\nglobal SelectFaceRoll\ntry (destroyDialog SelectFaceRoll) catch()\n&nbsp;\nrollout SelectFaceRoll \"Select Face\"\n(\n  spinner face_index \"Face Index\" type:#integer range:[1,100000000,1]\n  on face_index changed val do\n  (\n    if isValidNode selection[1] and classof selection[1].baseobject == Editable_Mesh do\n    (\n      if val &lt;= selection[1].numfaces then\n        setFaceSelection selection[1] #{val}\n      else&nbsp;&nbsp;&nbsp;\n        setFaceSelection selection[1] #{}\n    )\n  )\n)\nmax modify mode\ntry (subObjectLevel = 3) catch()\ncreateDialog SelectFaceRoll 150 30\n)--end macro\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10D7\"></a> <span class=\"char_link\"><a href=\"GUID-58D1F8B6-0012-4727-AA29-B2C79EA46E16.htm\">Mesh Face Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10D8\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";