var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C6CD8B3A-C5EF-4A83-8DB2-B5EDFEFDEEDD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"intersectRay()\">\n      <meta name=\"indexterm\" content=\"intersectRayEx()\">\n      <meta name=\"indexterm\" content=\"intersectRayScene()\">\n      <meta name=\"indexterm\" content=\"printStack()\">\n      <meta name=\"indexterm\" content=\"intersects()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Utility Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C6CD8B3A-C5EF-4A83-8DB2-B5EDFEFDEEDD\"></a><div class=\"head\">\n            <h1>Node Utility Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4F\"></a><pre><em class=\"codeEmphasisStrong\">isDeleted</em> &lt;MAXWrapper_object&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3396\"></a>This function yields the result \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the object has been deleted and \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> if it still exists in the scene. Using the function only makes sense in situations\n            where references to \n            		<em class=\"strong\">3ds Max</em> objects are held in variables or arrays, or passed as parameters and you want to\n            determine whether the object has been deleted from the scene. Performing an operation\n            on a deleted \n            		<em class=\"strong\">3ds Max</em> object referenced in a variable or array otherwise generates an exception. Any kind\n            of \n            		<em class=\"strong\">3ds Max</em> object can be tested in this way such as, scene objects, modifiers, controllers,\n            materials, and others. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3395\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3394\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4E\"></a><pre>\nsel = selection as array-- snapshot selection\n--...\n-- &lt;one or more objects in the selection are deleted,\n-- by the user or other scripts&gt;\n--...\nfor obj in sel\nwhere not isDeleted obj do\nmove obj [10,0,0]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3388\"></a>When a node has been deleted, \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3387\"></a>&lt;node&gt; == undefined returns \n            		<em class=\"strong\">false</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3386\"></a>&lt;node&gt; != undefined returns \n            		<em class=\"strong\">true</em> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3385\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3384\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4D\"></a><pre>\nif mynode != undefined and not isdeleted myNode do...\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_62EDB86A7EE74F53BF0C5A155A764316\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4C\"></a><pre><em class=\"codeEmphasisStrong\">distance</em> &lt;node&gt; &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-337E\"></a>Computes the distance between the pivot points of the two specified nodes. \n            	 \n         </p>\n         <p><a name=\"P_8E46144B213B4C8BB2179FB4294334A9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4B\"></a><pre><em class=\"codeEmphasisStrong\">intersectRay</em> &lt;node&gt; &lt;ray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-337B\"></a>Computes the closest intersection of the ray and the surface of the given node. Returns\n            another Ray which defines the position of intersection in 3D space and the surface\n            normal direction vector at that point. The intersection test respects the face normals\n            of the node. If a face\'s normal points away from the ray\'s source, an intersection\n            test is not performed on that face .<span class=\"code\"> <em class=\"strong\">intersectRay()</em> </span> works if the world state of the node (the state of the node at the top of the node\'s\n            stack) has a surface such as, an editable mesh, a Standard, Extended, or Compound\n            Primitive, a Patch, or a NURBS surface object. Splines and NURBS curves do not have\n            a surface. Returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the ray does not intersect the node, the faces it does intersect point away from\n            the ray\'s position, or the node does not have a surface. \n         </p>\n         <p><a name=\"P_9CE6BF521F984D328387ECFAF76699C6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D4A\"></a><pre><em class=\"codeEmphasisStrong\">intersectRayEx</em> &lt;node&gt; &lt;ray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3378\"></a>Takes a ray and computes the closest intersection to the surface of the given node.\n            It returns an array with the following three elements. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3377\"></a><ol type=\"1\" start=\"1\">\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3375\"></a>A Ray defining the position of intersection in 3-space and the surface normal direction\n                  vector at the point. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3373\"></a>The index of the face the ray intersects with. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3371\"></a>The barycentric coordinates of the face that was hit. \n                  		  \n               </p> \n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3370\"></a>This method only works if the world state of the node is a mesh, either because it\n            started as an editable mesh or it has modifiers applied that convert the node to a\n            mesh. Unlike \n            		<span class=\"code\"> <em class=\"strong\">intersectRay()</em> </span>, this method will not work if the node is a Standard or Extended Primitive; the node\'s\n            stack must evaluate to a mesh. The intersection test respects the face normals of\n            the node. If a face\'s normal points away from the ray\'s source, an intersection test\n            is not performed on that face. Returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the ray does not intersect the node, the faces it intersects point away from the\n            ray\'s position, or the node is not a mesh. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-336F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-336E\"></a><p class=\"table-body\"> <em class=\"strong\">WHAT ARE BARYCENTRIC COORDINATES?</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-336D\"></a><p class=\"table-body\">Barycentric coordinates are the coordinates relative to the triangular face. The barycentric\n                        coordinates of a point \n                        					 <span class=\"code\"> <em class=\"strong\">p</em> </span> relative to a triangle describe that point as a weighted sum of the vertices of the\n                        triangle. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-336C\"></a><p class=\"table-body\">If the barycentric coordinates are \n                        					 <span class=\"code\"> <em class=\"strong\">b0</em> </span>,<span class=\"code\"> <em class=\"strong\">b1</em> </span>, and \n                        					 <span class=\"code\"> <em class=\"strong\">b2</em> </span>, then \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-336B\"></a><p class=\"table-body\"></p> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D49\"></a><pre>\np = b0*p0 + b1*p1 + b2*p2\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3369\"></a><p class=\"table-body\"></p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3368\"></a><p class=\"table-body\">where, \n                        					 <span class=\"code\"> <em class=\"strong\">p0</em> </span>,<span class=\"code\"> <em class=\"strong\">p1</em> </span>, and \n                        					 <span class=\"code\"> <em class=\"strong\">p2</em> </span> are the positions of the vertices of the triangle. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3367\"></a><p class=\"table-body\">The Point3 returned by this method has the barycentric coordinate stored in its three\n                        component values. The coordinate is relative to the triangular face that was intersected.\n                        \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3366\"></a><p class=\"table-body\">Barycentric coordinates can also be used to interpolate any quantity whose value is\n                        known at the vertices of the triangle. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3364\"></a>Following is an example of finding the UV coordinates at the intersection point: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3363\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3362\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D48\"></a><pre>\ns = geosphere material:(standardMaterial diffuseMap:(checker()))\nshowTextureMap s.material s.material.diffuseMap on\n--\n-- Add a normal modifier to make the sphere into a mesh\naddModifier s (normalModifier())\nr = ray [-100,5,0] (s.center-[-100,5,0])\n--\n-- Get the Intersection details\narr = (intersectRayEx s r)\n--\n-- Create a dummy at the point of intersection\ndummy pos:(arr[1]).pos\n--\n-- Get the texture face\ntf = getTVFace s arr[2]\n--\n-- Get the UVW verts of the face\ntv1 = getTVert s tf.x\ntv2 = getTVert s tf.y\ntv3 = getTVert s tf.z\n--\n-- Calculate the texture vertices at point of intersection from\n-- the barycentric coordinates\ntv = tv1*arr[3].x + tv2*arr[3].y + tv3*arr[3].z\n--\n-- Delete the modifier\ndeleteModifier s 1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_160422FE0A6D44BFA2CB1B0F06DF26B8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D47\"></a><pre><em class=\"codeEmphasisStrong\">intersectRayScene</em> &lt;ray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3341\"></a>Performs intersectRay on all nodes in the scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3340\"></a>Returns an array of results, one entry per node hit, where each entry is a 2 element\n            array containing the node and the intersectRay result for that node. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-333F\"></a>The intersection is performed for all geometry objects including hidden ones. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-333E\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-333D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-333C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D46\"></a><pre>\n(\nlocal r = ray [0,0,0] [1,0,0]--define a ray along X\nfor i = 0 to 4 do--loop 5 times\n(\n box pos:[i * 30, 0,0]--create a box\n)\nlocal hits = intersectRayScene r--intersect withscene\nprint hits --Misses box 1 because ray originates inside the box\n)\n\n-- output\n \n--&gt; #($Box:Box02 @ [30.000000,0.000000,0.000000], (ray [17.5,0,0] [-1,0,0]))\n--&gt; #($Box:Box03 @ [60.000000,0.000000,0.000000], (ray [47.5,0,0] [-1,0,0]))\n--&gt; #($Box:Box04 @ [90.000000,0.000000,0.000000], (ray [77.5,0,0] [-1,0,0]))\n--&gt; #($Box:Box05 @ [120.000000,0.000000,0.000000], (ray [107.5,0,0] [-1,0,0]))\n--&gt; OK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_0EB8AEF054424B65A89EB5618D0F9F71\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D45\"></a><pre><em class=\"codeEmphasisStrong\">intersects</em> &lt;node&gt; &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3326\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the bounding boxes of the two specified nodes overlap, or \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> if they do not overlap. \n         </p>\n         <p><a name=\"P_B0622562EEF24FD284F2049285CB0EBF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D44\"></a><pre><em class=\"codeEmphasisStrong\">printStack</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3323\"></a>Prints a representation of the current modifier stack for the given node. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">getLastMergedNodes</em>()</pre></div>\n         <p>Returns an array of nodes loaded by the last merge operation, for example by \n            		<span class=\"code\">mergeMAXFile()</span>. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";