var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"skipping loop iterations\">\n      <meta name=\"indexterm\" content=\"for loop\">\n      <meta name=\"indexterm\" content=\"continue\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Skipping Loop Iterations</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8\"></a><div class=\"head\">\n            <h1>Skipping Loop Iterations </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87290\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87291\"></a>   MAXScript provides a <span class=\"code\"> <em class=\"strong\">continue</em> </span> construct that allows you to jump to the end of a <span class=\"code\"> <em class=\"strong\">for</em> </span>, <span class=\"code\"> <em class=\"strong\">do</em> </span>, or <span class=\"code\"> <em class=\"strong\">while</em> </span> loop body <span class=\"code\">&lt;expr&gt;</span> and resume with the next loop iteration. \n            </p> \n            <p><a name=\"P_5446855A9FB34BDE911AB623027C3B97\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87295\"></a>Its <em class=\"strong\">syntax </em>is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AF\"></a><pre><em class=\"codeEmphasisStrong\">Continue</em></pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87298\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87299\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AE\"></a><pre>\nfor i=1 to 8 do (if i == 5 do continue; print i) -- prints 1..4, 6..8\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AD\"></a><pre>\nwhile not eof f do -- read until reach end of file\n(\nlocal line=readline f -- read in a line\nif line[1] = = \"-\" do continue -- if comment, skip to next line\nline1=parser1 line -- call function parser1\nprocessobjs line1 -- call function processobjs\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872A6\"></a>If a <span class=\"code\"> <em class=\"strong\">continue</em> </span> is executed in a <span class=\"code\"> <em class=\"strong\">for ... collect</em> </span> loop, the expression result for that loop iteration is not collected in the array\n               of body values. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872A7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872A8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60AC\"></a><pre>\nfor i=1 to 8 collect (if i = = 5 do continue; i) -- returns #(1, 2, 3, 4, 6, 7, 8)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872AE\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872AF\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">Loop Exit</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";