var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-C6FFDDE9-60F9-4105-B550-0099A37BB8CF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ColorMap : textureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C6FFDDE9-60F9-4105-B550-0099A37BB8CF\"></a><div class=\"head\">\n            <h1>ColorMap : textureMap </h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ColorMap - superclass: textureMap; super-superclass:material - 6:0 - classID: #(329196230L, 334932244L)</em></pre></div>\n         <p> Offers a simple way to pass a solid color into any map slot, allowing for example\n            the instancing of a color value among independent Materials and Maps. Available in\n            \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2804\"></a> <em class=\"strong\">Constructor:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ColorMap...</em></pre></div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.solidcolor</em>     Color    default: (color 127.5 127.5 127.5)   --  animatable; fRGBA color; Solid_Color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div>\n         <p> Get/set the color value of the Solid Color swatch. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.mapEnabled</em>    BooleanClass    default: true   --  boolean; Map_Enable</pre></div>\n         <p> Get/set the state of the map enabled checkbox. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.map</em>    UndefinedClass    default: undefined   --  texturemap</pre></div>\n         <p> Get/set the texture map to be used in place of the solid color value. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.gamma</em>     Float    default: 2.2   --  animatable; float</pre></div>\n         <p> Get/set the Gamma value. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.gain</em>     Float    default: 1.0   --  animatable; float</pre></div>\n         <p> Get/set the Gain value. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;ColorMap&gt;<em class=\"codeEmphasisStrong\">.ReverseGamma</em>     BooleanClass    default: true   --  animatable; boolean; Reverse_Gamma</pre></div>\n         <p> Get/set the state of the Reverse Gamma checkbox. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"TABLE_395B1C1EBB374058A436E5782DF4AD73\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">Example</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>(\nresetMaxFile #noprompt --reset the scene\n--define an array of material classes and their base color map properties:\ntheMatClasses = #(#(Standardmaterial, #diffuseMap), #(Architectural, #diffuseMap), #(Autodesk_Material, #Generic_Image), #(RaytraceMaterial, #diffuseMap), #(PhysicalMaterial, #base_color_map), #(InkNPaint, #paint_map) )\ncm = colorMap() --create a color map instance\nfor i = 1 to theMatClasses.count do --loop through the list of material classes\n(\n    m = theMatClasses[i][1]() --create a material instance\n    setProperty m theMatClasses[i][2] cm --set its base color to the color map\n    geosphere radius:25 pos:[i*60,0,0] material:m --create a geosphere offset along X\n    if theMatClasses[i][1] == InkNPaint do m.paint_map_on = true --if the material is InkNPaint, also enable the Paint Map\n    showTextureMap m true --enable the display of the material\'s maps in the viewport (does not work for InkNPaint)\n)\nmax zoomext sel all --zoom all\n\ncm.solidcolor = red --set the color of the colorMap to red and render\nbmp1 = render()\ncm.solidcolor = green --set the color of the colorMap to green and render\nbmp2 = render()\n\n--As you can see, we can control the solid color of multiple independent material types\n--using an instances colorMap!\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";