var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Vector_Map TextureMap\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Vector_Map : textureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7\"></a><div class=\"head\">\n            <h1>Vector_Map : textureMap </h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Vector_Map - superclass: textureMap; super-superclass:material - 31:0 - classID: #(-1817630903, 1804420874)</em></pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7325\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7326\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap</a></span> &gt; Vector_Map \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-C91AB83C-DFF8-4719-B145-601AC981ADA6\"></a> The \n            		<em class=\"strong\">Vector_Map TextureMap</em> available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em> can load and generate a rasterized bitmap representation of several vector graphics\n            formats, including the open SVG and SVGZ, Autodesk\'s AutoCAD .PAT, and Adobe\'s AI\n            and PDF formats. \n            	 \n         </p>\n         <p><a name=\"GUID-71B4BF27-25C2-4E62-84DB-27704E037C00\"></a>The Scalable Vector Graphics (SVG) XML format, an open format developed by the World\n            Wide Web Consortium, allows the description of geometry shapes, images and text that\n            are resolution-independent and can produce a bitmap of arbitrary size without storing\n            actual texels on disk. The benefit of this approach is high quality graphics and text\n            at any resolution and very small source description file sizes. \n            	 \n         </p>\n         <p><a name=\"GUID-22D8D0DA-5C32-47A4-AEB6-3A03A71ACF31\"></a>SVG files can be created by hand or by dedicated tools, downloaded from the Web, or\n            generated automatically using MAXScript. In addition, the \n            		<em class=\"strong\">3ds Max</em> implementation of the Vector_Map TextureMap provides the ability to embed MAXScript\n            function calls inside the SVG XML source file. \n            	 \n         </p>\n         <p><a name=\"GUID-BF2A2FA4-80B8-4461-A932-81BD8087658B\"></a>To learn more about the basics of creating SVG files and the integration of the Vector_Map\n            with MAXScript, please see the topic \n            		<span class=\"char_link\"><a href=\"GUID-3EF5C2D1-992C-4F29-8543-72D61F2870D1.htm\">VectorMap TextureMap and MAXScript</a></span>. \n            	 \n         </p>\n         <p><a name=\"GUID-A59E7C9B-BC34-4BD6-A051-BD3E433C4D4E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-A0A7A9EA-493D-46A0-885C-6E8532B2B47D\"></a> <em class=\"strong\">Constructors:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Vector_Map... \nVectorMap...</em></pre></div>\n         <p><a name=\"GUID-562FDE86-4F8E-4809-A503-D1D5B1AD1805\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-3CD44CD1-7107-4F83-9F16-2DEDAF0BD40A\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"section\"><a name=\"SECTION_FB2C914DCEC045C08655D5F9ABAB1B33\"></a> \n            <h2><a name=\"GUID-B457E7F8-1BE7-4FB2-B680-A9108A6D2369\"></a>Coordinates rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">coords</em>     StandardUVGen    default: MtlBase:Placement   --  maxObject; Coordinates; SubAnim</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7375\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-BD6C5537-7314-4A1B-940C-32E471045621.htm\">UVGenClass</a></span> for the StandardUVGen properties. \n               		\n            </p> \n            <p><a name=\"GUID-657499B1-A45D-4CFE-8720-BCC9C3C8D2A7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_30F9D592412A4C52938D50AB387B8481\"></a> \n            <h2><a name=\"GUID-258266E4-214C-4311-A485-73700BF0D978\"></a>Parameters rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">vectorfile</em>     String    default: \"\"   --  filename</pre></div> \n            <p><a name=\"GUID-97328A97-661F-43F0-BB62-90214CCAFEA6\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Vector File\"</em> button. \n               		\n            </p> \n            <p><a name=\"GUID-258D09DA-6656-4388-928F-514B550BDEBA\"></a>This is the file name of the vector file used as the source of the Scalable Vector\n               Graphics map generation. \n               		\n            </p> \n            <p><a name=\"GUID-5B7BA21A-AAB9-4A29-8340-EA77263D8DF1\"></a>Supported file formats include: \n               		\n            </p> \n            <p><a name=\"GUID-9D0AD324-DA6B-4735-9FD1-40D46A3D76AB\"></a><em class=\"strong\">.SVG</em> - Scalable Vector Graphics XML format. When saved from a 3rd party editor like tje\n               open source Inkscape, the file must be saved as Plain SVG. \n               		\n            </p> \n            <p><a name=\"GUID-0D75F14C-F505-4667-8C39-65D7D07D3C3D\"></a><em class=\"strong\">.SVGZ \n                  		  </em>- Compressed Scalable Vector Graphics format \n               		\n            </p> \n            <p><a name=\"GUID-1AD05A09-C573-4C20-A676-FCFB838A7971\"></a><em class=\"strong\">.AI</em> - Adobe Illustrator format - AI9 to SC5. Files must be saved with \"Create PDF Compatible\n               File\" option checked. \n               		\n            </p> \n            <p><a name=\"GUID-CC15744B-7731-4AE0-B30D-4EF4E1FC96CE\"></a><em class=\"strong\">.PAT</em> - Autodesk AutoCAD Pattern file format \n               		\n            </p> \n            <p><a name=\"GUID-B771BAC7-1CAF-49B1-836A-570F0C3DD7D9\"></a><em class=\"strong\">.PDF</em> - Adobe Portable Document Format \n               		\n            </p> \n            <p><a name=\"GUID-195F2AD9-0CAD-478F-9BE4-B836645FEF71\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"section\"><a name=\"SECTION_0D6220F41EB643E1A9E3AE5A70B2AEDA\"></a> \n               <h3><a name=\"GUID-C660301F-9E51-4E17-91A4-C501FEF1F72E\"></a>Filtering group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">filter</em>     BooleanClass    default: true   --  boolean</pre></div> \n               <p><a name=\"GUID-5C70DBB2-E4EE-4BFE-8646-1168FF65F02E\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Filter Result\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-2F1F64B6-291F-42B4-B909-8B2FFF4B8C5B\"></a>When set to True (default), the rasterized bitmap produced from the vector graphics\n                  definition will be filtered. \n                  		  \n               </p> \n               <p><a name=\"GUID-3AE99718-4703-4224-BF68-02F3C82BE2CB\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">mipmap</em>     BooleanClass    default: true   --  boolean</pre></div> \n               <p><a name=\"GUID-0D5168A3-6A59-428E-8DE7-6EF554A15DF4\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Mip Mapping\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-A09DA805-E8F4-448B-AB33-6F9548DF616C\"></a>When set to True (default), multiple resolutions of the texture map will be rasterized\n                  to allow for better texture filtering at render time. \n                  		  \n               </p> \n               <p><a name=\"GUID-D7B5C136-C733-41AB-910D-BD12901CC0E2\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_3B63162682984DC3AEBCCBB5C3306396\"></a> \n               <h3><a name=\"GUID-C94FFE53-14E0-4FA9-8408-FE0ACC5B5D4A\"></a>Cropping / Placement group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">applycrop</em>     BooleanClass    default: false   --  boolean</pre></div> \n               <p><a name=\"GUID-4DCDB429-21D2-4C96-ABC1-2CDE28B08D5E\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Apply\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-0B5E792B-11B5-4DBB-BD8E-92502FD5C2D4\"></a>When set to True, the resulting rasterized bitmap will be cropped or placed according\n                  to the parameters below. \n                  		  \n               </p> \n               <p><a name=\"GUID-CCE4C06B-555E-4F60-8488-7E0ADE4728EA\"></a>When set to False (default), no cropping or placement will be performed. \n                  		  \n               </p> \n               <p><a name=\"GUID-FF280E9A-1D55-4BFB-8FEF-1EE17C916465\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">croporplace</em>     Integer    default: 0   --  integer</pre></div> \n               <p><a name=\"GUID-A049B852-B1AB-433B-830B-E4B3511CF854\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Crop/Place\"</em> radius buttons. \n                  		  \n               </p> \n               <p><a name=\"GUID-D56884C5-F237-434A-A4A3-8B547AA9300A\"></a>Possible values are \n                  		  \n               </p> \n               <p><a name=\"GUID-89953D3C-5F3C-4E1D-816D-5FE2C11A0AB5\"></a>0 - \n                  			 <em class=\"strong\">Crop \n                     			 </em>(default) \n                  		  \n               </p> \n               <p><a name=\"GUID-C346B957-8E54-4B0A-A661-78ED101B600D\"></a>1 - \n                  			 <em class=\"strong\">Place</em> \n               </p> \n               <p><a name=\"GUID-7EE81B95-257B-4742-B444-8F55FFAC1C8E\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">crop_u</em>     Float    default: 0.0   --  animatable; float; Clip_U_Offset</pre></div> \n               <p><a name=\"GUID-4FCCB39C-2855-4952-9AAE-2691487D9DE2\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"U\"</em> spinner. \n                  		  \n               </p> \n               <p><a name=\"GUID-EF1D0A16-CA5C-47F6-95D2-F4FB842CEDE0\"></a>It defines the horizontal component of the upper left corner of the region to be affected,\n                  expressed in normalized units between 0.0 and 1.0. \n                  		  \n               </p> \n               <p><a name=\"GUID-134CC94E-B4FF-46AA-AFB8-6B4D7D69F367\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">crop_v</em>     Float    default: 0.0   --  animatable; float; Clip_V_Offset</pre></div> \n               <p><a name=\"GUID-CCFCE3F1-62F6-449C-989E-45CBDCB1A301\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"V\"</em> spinner. \n                  		  \n               </p> \n               <p><a name=\"GUID-8ED8DCF1-D65B-4D32-A703-EE8B7BDBC99E\"></a>It defines the vertical component of the upper left corner of the region to be affected,\n                  expressed in normalized units between 0.0 and 1.0. \n                  		  \n               </p> \n               <p><a name=\"GUID-ED33A780-23FC-4B8F-AAED-6AF6A0C514B3\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">crop_w</em>     Float    default: 1.0   --  animatable; float; Clip_U_Width</pre></div> \n               <p><a name=\"GUID-6CAF678E-1A36-4050-9304-BF44364867FC\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"W\"</em> spinner. \n                  		  \n               </p> \n               <p><a name=\"GUID-85B488AB-8039-46A6-B044-C2D04CFD358B\"></a>It defines the Width of the region to be affected, expressed in normalized units between\n                  0.0 and 1.0. \n                  		  \n               </p> \n               <p><a name=\"GUID-82B2D218-FD9F-48E1-B16D-E6D6B430CE28\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">crop_h</em>     Float    default: 1.0   --  animatable; float; Clip_V_Width</pre></div> \n               <p><a name=\"GUID-4495F056-A65E-420D-A2A4-F73D1FF0ACFE\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"H\"</em> spinner. \n                  		  \n               </p> \n               <p><a name=\"GUID-18D8C2D1-D07C-4898-9DCD-539E489D8AA4\"></a>It defines the Height of the region to be affected, expressed in normalized units\n                  between 0.0 and 1.0. \n                  		  \n               </p> \n               <p><a name=\"GUID-B0A6FC41-A86A-4DCC-8D91-B584284EAC18\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">Jitter</em>     BooleanClass    default: false   --  boolean</pre></div> \n               <p><a name=\"GUID-05653492-2476-4C97-AEDF-92CC5492D13C\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Jitter Placement\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-7411B5E6-5766-4132-9B0C-E5658937BC1C\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">jitteramt</em>     Float    default: 1.0   --  animatable; float; Jitter_Placement</pre></div> \n               <p><a name=\"GUID-34413118-0791-41E3-B197-D1C940EA0F2E\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"Jitter Placement\"</em> spinner. \n                  		  \n               </p> \n               <p><a name=\"GUID-24D0FD86-4720-4D0C-BD5E-A8024C2F148F\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_665FECBFF0C843D9AFA03A17C4EF795A\"></a> \n               <h3><a name=\"GUID-2244C2FE-381A-4D09-9BF8-E83EE0034838\"></a>Mono Channel Output group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">monoOutput</em>     Integer    default: 1   --  integer</pre></div> \n               <p><a name=\"GUID-F8674D69-5ACD-4F68-B47E-2FC625A09298\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Mono Channel Output\"</em> radio buttons. \n                  		  \n               </p> \n               <p><a name=\"GUID-467AC2F0-ECA9-408C-8078-384A3C1DACB1\"></a>Possible values are: \n                  		  \n               </p> \n               <p><a name=\"GUID-9F6A68C6-1859-46DA-B3A5-FA17F91B1D06\"></a>0 - \n                  			 <em class=\"strong\">RGB Intensity</em> \n               </p> \n               <p><a name=\"GUID-E6252AB9-C0E2-46BA-B260-5EEB246F788F\"></a>1 - \n                  			 <em class=\"strong\">Alpha \n                     			 </em>(default) \n                  		  \n               </p> \n               <p><a name=\"GUID-B14EE6E8-8B58-423E-85DF-B06BA7848E29\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_8B01AC7A8E7F4F81973D5A3E1A27EA67\"></a> \n               <h3><a name=\"GUID-919D2FAC-82B8-4163-BDDA-BFFFFECD6CE6\"></a>RGB Channel Output group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">rgbOutput</em>     Integer    default: 0   --  integer</pre></div> \n               <p><a name=\"GUID-62A8780B-5E3E-42F4-9A75-3D7FE6598120\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"RGB Channel Output\"</em> radio buttons. \n                  		  \n               </p> \n               <p><a name=\"GUID-C17CE2D4-C16A-4FDD-A1DF-B64C59EB24C2\"></a>Possible values are: \n                  		  \n               </p> \n               <p><a name=\"GUID-E7A60C3D-D64D-4961-9FC6-BF8EDA7717B8\"></a>0 - \n                  			 <em class=\"strong\">RGB \n                     			 </em>(default) \n                  		  \n               </p> \n               <p><a name=\"GUID-4904B9A1-C937-4CF5-B304-4BCAB56CD621\"></a>1 - \n                  			 <em class=\"strong\">Alpha as Gray</em> \n               </p> \n               <p><a name=\"GUID-031C513E-1CC9-4A3B-B318-263758328C3E\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_5715D43EA8724DD6BFBFB49E60969796\"></a> \n               <h3><a name=\"GUID-DCD1CD16-3BF3-4748-B2D0-BE781D259CA9\"></a>Alpha Source group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">alphasource</em>     Integer    default: 2   --  integer; Alpha_Source</pre></div> \n               <p><a name=\"GUID-7051E768-5688-489E-B189-02FB288745C5\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Alpha Source\"</em> radio buttons. \n                  		  \n               </p> \n               <p><a name=\"GUID-3BD32C8A-D58F-4EFF-B0A2-B9FC4742E327\"></a>Possible values are: \n                  		  \n               </p> \n               <p><a name=\"GUID-3CC8A625-30DC-4DEE-95AE-1D5FDE94F566\"></a>0 - \n                  			 <em class=\"strong\">Image Alpha</em> \n               </p> \n               <p><a name=\"GUID-09448CD4-87CB-4203-87C4-98AF76BA9CE9\"></a>1 - \n                  			 <em class=\"strong\">RGB Intensity</em> \n               </p> \n               <p><a name=\"GUID-25BDA37E-01EE-45A7-A738-AFA762C729DA\"></a>2 - \n                  			 <em class=\"strong\">None (Opaque)</em> (default) \n                  		  \n               </p> \n               <p><a name=\"GUID-195682AF-07B7-4971-94CD-BB7692CB581D\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_9471CE9681D24FBC910668D42A6CB092\"></a> \n               <h3><a name=\"GUID-6C1B2FF0-FF06-4DCA-9C60-13EABDDCCE9F\"></a>Virtual Resolution group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">restype</em>     Integer    default: 0 --  integer;</pre></div> \n               <p>Get/set the state of the \n                  			 <em class=\"strong\">\"Virtual Resolution\"</em> radio buttons. Available in \n                  			 <em class=\"strong\">3ds Max 2018 and higher.</em> \n               </p> \n               <p>Possible values are: \n                  		  \n               </p> \n               <p>0 - \n                  			 <em class=\"strong\">Finite</em> (default) \n                  		  \n               </p> \n               <p>1 - \n                  			 <em class=\"strong\">Infinite</em> \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">finiteresolution</em>     Integer    default: 10000   --  integer;</pre></div> \n               <p>Get/set the value of the \n                  			 <em class=\"strong\">Finite</em> spinner. Available in \n                  			 <em class=\"strong\">3ds Max 2018 and higher.</em> \n               </p> \n               <p>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_B59B2CD24A0D49389EB646BFE9631C4A\"></a> \n            <h2><a name=\"GUID-50F9B71E-F2F5-4025-BB11-3630CC6F727C\"></a>Pattern Parameters rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">patternname</em>     Integer    default: 0   --  integer</pre></div> \n            <p><a name=\"GUID-8BA2D0FB-53BE-4BF1-BE00-81A5A0E6EC37\"></a>Get/set the selection of the \n               		  <em class=\"strong\">\"Pattern\"</em> drop-down list available if the \n               		  <span class=\"code\"> <em class=\"strong\">.vectorfile</em> </span> property points at a .PAT file. \n               		\n            </p> \n            <p><a name=\"GUID-C75EABBB-9CE7-4F23-A60F-DEAC253398F2\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">patternrepeat</em>     Float    default: 1.0   --  animatable; float; Pattern_Repeat</pre></div> \n            <p><a name=\"GUID-2843A034-75E2-4629-82F4-6DAA82471051\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Repeat\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-2A4A1F27-F46F-4F05-9D0D-C438A395D022\"></a>It controls the repeating of the pattern. \n               		\n            </p> \n            <p><a name=\"GUID-F83661A8-336F-4314-B7E1-00AF0FD95EDD\"></a>Use Repeat instead of tiling since most patterns do not tile nicely. \n               		\n            </p> \n            <p><a name=\"GUID-E9DF51A1-B741-4090-92DD-52689231AF06\"></a>Note that this parameter is animatable. \n               		\n            </p> \n            <p><a name=\"GUID-44E91D66-C772-4B01-B936-3160CC66D3D5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">linewidth</em>     Float    default: 1.0   --  animatable; float; Line_Width</pre></div> \n            <p><a name=\"GUID-1969319E-7FA4-4173-8CF4-FA9154C76A56\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Line Width\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-87C152AB-D264-4160-9A5B-C5D78742BD97\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">linecolor</em>     Color    default: (color 0 0 0)   --  animatable; RGB color; Line_Color; Controller Scaling: ([1,1,1] : (color 255 255 255)))</pre></div> \n            <p><a name=\"GUID-97ACD914-405F-4558-ADB7-DE950B7CEE6E\"></a>Get/set the color of the \n               		  <em class=\"strong\">\"Line Color\"</em> value. \n               		\n            </p> \n            <p><a name=\"GUID-C7102EE2-FC5E-46CB-ADB2-C553804FBB29\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">backcolor</em>     Color    default: (color 255 255 255)   --  animatable; RGB color; Background_Color; Controller Scaling: ([1,1,1] : (color 255 255 255)))</pre></div> \n            <p><a name=\"GUID-5E0580CB-67F2-4D9E-A522-C4EE0AC31DFC\"></a>Get/set the color of the \n               		  <em class=\"strong\">\"Background\"</em> value. \n               		\n            </p> \n            <p><a name=\"GUID-160F595A-681F-4F2B-9FC6-E7FB38B246BA\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">linecap</em>     Integer    default: 0   --  integer; Line_Cap</pre></div> \n            <p><a name=\"GUID-5510A74B-55E9-419C-9C18-FA8000C2C9CA\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Line Cap\"</em> radio buttons. \n               		\n            </p> \n            <p><a name=\"GUID-82D1FE16-3999-4D5F-A1D5-7C529D63818E\"></a>Possible values are: \n               		\n            </p> \n            <p><a name=\"GUID-CC023725-6BE7-4F29-AC12-4F12BC2C3508\"></a>0 - \n               		  <em class=\"strong\">Round</em> (default) \n               		\n            </p> \n            <p><a name=\"GUID-A99225A2-1169-457D-8F0B-8A32CE9E2BAC\"></a>1 - \n               		  <em class=\"strong\">Square</em> \n            </p> \n            <p><a name=\"GUID-9489516B-ACEF-4416-9EAC-D159C69877FC\"></a>2 - \n               		  <em class=\"strong\">None</em> \n            </p> \n            <p><a name=\"GUID-0F7E536D-8F6D-4C0D-A6A7-C63EF8F9577F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_50FDC964A86048C1A38ADBA03456FB9F\"></a> \n            <h2><a name=\"GUID-C4E7FA5A-016F-4FAF-B4AD-BD9FF4031D93\"></a>Adobe Illustrator / PDF Parameters rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">pdf_page</em>     Float    default: 1.0   --  animatable; float; PDF_Page_Number</pre></div> \n            <p><a name=\"GUID-60DDB264-A972-4032-9814-BBFC892773EA\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Page\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-50CB6FFE-5907-4772-83C0-14A97E14C92D\"></a>It is animatable, allowing to scrolling through a PDF document when the \n               		  <span class=\"code\"> <em class=\"strong\">.continuous</em> </span> property is set to True. \n               		\n            </p> \n            <p><a name=\"GUID-BE97F6B3-B87C-448C-B31B-026C867C5AD1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">continous</em>     BooleanClass    default: false   --  boolean</pre></div> \n            <p><a name=\"GUID-F4E56C16-BB62-4026-A7AC-02A5F4883139\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Continuous\"</em> checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-4DA65ABB-EEB4-469E-9269-595AB8511FD7\"></a>When True, the page transitions will be smooth. \n               		\n            </p> \n            <p><a name=\"GUID-6AF60864-A80C-4307-A855-761DCE1E4D7C\"></a>When False (default), the \n               		  <span class=\"code\"> <em class=\"strong\">.pdf_page</em> </span> value will be interpreted as an integer and only whole pages will be displayed. \n               		\n            </p> \n            <p><a name=\"GUID-499EB260-B522-4C13-9F56-C80EABBF7381\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"section\"><a name=\"SECTION_06242B7201044F7C8852423DCF3C6D20\"></a> \n               <h3><a name=\"GUID-A5B8A138-842A-4ADF-A7B0-688EF493E5FF\"></a>Background group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">transparent</em>     BooleanClass    default: true   --  boolean</pre></div> \n               <p><a name=\"GUID-9C8E71E1-D0A5-4A13-AA69-91123374C364\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Transparent\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-A541A5FD-DC9E-4D15-8A29-08037D5A51C6\"></a>When set to True (default), the page\'s background will be considered transparent.\n                  \n                  		  \n               </p> \n               <p><a name=\"GUID-49B0D099-CCA6-4BEB-B844-F63D74ED2849\"></a>When set to False, the \n                  			 <em class=\"strong\">.pagecolor</em> property will be used as the background color. \n                  		  \n               </p> \n               <p><a name=\"GUID-6F1DEC81-51C7-4F89-AF45-5BAAB12B833B\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">pagecolor</em>     Color    default: (color 255 255 255)   --  animatable; RGB color; Page_Color; Controller Scaling: ([1,1,1] : (color 255 255 255))</pre></div> \n               <p><a name=\"GUID-C7C25380-862B-41AE-BC17-7BD545033181\"></a>Get/set the value of the \n                  			 <em class=\"strong\">\"Page Color\"</em> picker. \n                  		  \n               </p> \n               <p><a name=\"GUID-3E4BFD78-6F46-4D85-894D-02CA2D68E692\"></a>Used when the \n                  			 <span class=\"code\"> <em class=\"strong\">.transparent</em> </span> property is set to False. \n                  		  \n               </p> \n               <p><a name=\"GUID-F5A3E666-2FF7-4E06-AE10-A324F5A92A33\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_3BB9E6084B254B3691CCB9787407E22C\"></a> \n               <h3><a name=\"GUID-44C417DD-50D9-4A69-A200-7FA3381D6ACE\"></a>Page Transition group of controls\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">transition_mode</em>     Integer    default: 0   --  integer; </pre></div> \n               <p><a name=\"GUID-7E096ED0-E3E3-423D-93A7-DF63FF935310\"></a>Get/set the selection of the \n                  			 <em class=\"strong\">\"Mode\"</em> drop-down list. \n                  		  \n               </p> \n               <p><a name=\"GUID-6E54B833-8B3E-4AD3-8A62-05896BC5B536\"></a>Possible values are: \n                  		  \n               </p> \n               <p><a name=\"GUID-1848E592-BEAA-4682-8E04-1993AA900BA5\"></a>0 - \n                  			 <em class=\"strong\">Blend</em> \n               </p> \n               <p><a name=\"GUID-9AFAA262-4F6D-4469-915D-98BD5629E311\"></a>1 - \n                  			 <em class=\"strong\">Scroll</em> \n               </p> \n               <p><a name=\"GUID-951C8ACE-5917-419F-9E75-521159D5D96B\"></a>2 - \n                  			 <em class=\"strong\">Move In \n                     			 </em> \n               </p> \n               <p><a name=\"GUID-816C9406-3363-4DC1-B15C-B4692AD148A0\"></a>3 - \n                  			 <em class=\"strong\">Move Out</em> \n               </p> \n               <p><a name=\"GUID-12CA8EBA-87C4-49AD-ABD9-672549B0BC30\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">transitiondir</em>     Integer    default: 0   --  animatable; integer; Transition_Direction</pre></div> \n               <p><a name=\"GUID-F3A82E4B-A025-48C3-9B8C-3B0C54475434\"></a>Get/set the transition direction controls selection used when \n                  			 <em class=\"strong\"> <span class=\"code\">.transition_mode</span> </em> is greater than 0 (Scrolling Or Moving In or Out). \n                  		  \n               </p> \n               <p><a name=\"GUID-A65A67E4-0127-4CB2-A17C-83923E7799FE\"></a>Possible values are: \n                  		  \n               </p> \n               <p><a name=\"GUID-BAD2AC95-5781-45A5-BD98-CD84DC2902B1\"></a>0 - \n                  			 <em class=\"strong\">Up</em> \n               </p> \n               <p><a name=\"GUID-B3B2AC82-71F3-45B3-AED0-9A16A3EBD846\"></a>1 - \n                  			 <em class=\"strong\">Right-Up</em> \n               </p> \n               <p><a name=\"GUID-2CCF97DA-DB01-4879-A61A-BCC7097E197D\"></a>2 - \n                  			 <em class=\"strong\">Right</em> \n               </p> \n               <p><a name=\"GUID-48B50524-5D6C-44D2-A7AF-4E3845B5B3CE\"></a>3 - \n                  			 <em class=\"strong\">Right-Down \n                     			 </em> \n               </p> \n               <p><a name=\"GUID-BE7C2975-C612-4D16-98D3-CBEFCA29ADDA\"></a>4 - \n                  			 <em class=\"strong\">Down</em> \n               </p> \n               <p><a name=\"GUID-8A4ABF18-172B-4090-82A1-699906636062\"></a>5 - \n                  			 <em class=\"strong\">Left-Down</em> \n               </p> \n               <p><a name=\"GUID-DC9932EF-6D77-4513-B586-73C6FDA7669E\"></a>6 - \n                  			 <em class=\"strong\">Left</em> \n               </p> \n               <p><a name=\"GUID-EF8EA8BA-9C47-4ADF-9BE0-94AB161996A5\"></a>7 - \n                  			 <em class=\"strong\">Left-Up</em> \n               </p> \n               <p><a name=\"GUID-4470FE42-C176-4874-8220-F94611FE87B8\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">preview</em>     BooleanClass    default: false   --  boolean</pre></div> \n               <p><a name=\"GUID-52C7DACA-3ABA-4B2E-B78D-9ADE5946D202\"></a>Get/set the state of the \n                  			 <em class=\"strong\">\"Preview\"</em> checkbox. \n                  		  \n               </p> \n               <p><a name=\"GUID-F986D228-BECA-42C3-A3AE-B30A76E2571F\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_B9F32976B4EC464AA63AC92C681FCB1B\"></a> \n            <h2><a name=\"GUID-C2BDF534-8266-4D9D-91A5-0072F7056164\"></a>Advanced Parameters rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">hwbitmapsize</em>     Integer    default: 256   --  integer</pre></div> \n            <p><a name=\"GUID-A5B59901-1BCC-4920-9AEC-D2A4E428A37D\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"HW Bitmap Size\"</em> slider. \n               		\n            </p> \n            <p><a name=\"GUID-F015E9B4-A771-44C8-80E2-2BA1C9007842\"></a>Possible values are in the range from 256 to 4096. \n               		\n            </p> \n            <p><a name=\"GUID-7B38AEFF-006B-4FC7-AA86-57F319036381\"></a>This property controls the bitmap resolution used for hardware rendering (iRay, Quicksilver).\n               It does NOT apply to viewport bitmap display. \n               		\n            </p> \n            <p><a name=\"GUID-038E8F93-D8E6-4B05-ACA8-CAEDE72217F7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">memlimit</em>     Integer    default: 0   --  integer</pre></div> \n            <p><a name=\"GUID-5A873FFB-C8FE-4E0D-BC42-094DA8264C21\"></a>This property is unused and does nothing. \n               		\n            </p> \n            <p><a name=\"GUID-49ACED82-3A8B-43EA-B716-2BC816C2C701\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_C637134D1997475E84DFE38B9B618F89\"></a> \n            <h2><a name=\"GUID-5BC4DDD8-4223-4387-B5BF-E0D62F36202C\"></a>Output rollout\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Vector_Map&gt;.<em class=\"codeEmphasisStrong\">output</em>     StandardTextureOutput    default: MtlBase:Output   --  maxObject; SubAnim</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7378\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-F37AE1A1-0747-4DC9-83CC-B8F036375DC3.htm\">TexOutputClass</a></span> for the StandardTextureOutput properties. \n               		\n            </p> \n            <p><a name=\"GUID-AA0C5583-2B9B-4C78-869F-F768D92E66A9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_9CEB526E088E4AD1990C351983120FAD\"></a> \n            <h2><a name=\"GUID-E895DF6D-3FC2-4A7F-947C-0B7092115289\"></a>Vector_Map interfaces:\n            </h2> \n            <div class=\"codeBlock\"><pre>Interface: <em class=\"codeEmphasisStrong\">VectorMap</em></pre></div> \n            <p><a name=\"GUID-03102306-BC3B-4D9E-B525-0B40E6575ED7\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">Reload()</em></pre></div> \n            <p><a name=\"GUID-09C0683D-F341-46FE-9C3E-99CEECAFB94B\"></a>Equivalent to pressing the \n               		  <em class=\"strong\">\"Reload\"</em> button in the Parameters rollout of the VectorMap. \n               		\n            </p> \n            <p><a name=\"GUID-8583A3D5-F3D3-44DB-AA73-FC0F47349333\"></a>Causes the reloading of the source file definition and refreshing of the texture.\n               \n               		\n            </p> \n            <p><a name=\"GUID-4B396D67-0BE1-4F11-8F31-E179B71056F5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">ViewImage()</em></pre></div> \n            <p><a name=\"GUID-59B565EA-E549-4422-A1E7-1DDDB3ED8644\"></a>Equivalent to pressing the \n               		  <em class=\"strong\">\"View Image\"</em> button in the Cropping/Placement group of controls inside the Parameters rollout\n               of the VectorMap. \n               		\n            </p> \n            <p><a name=\"GUID-CFD1ABAB-DEC2-4D5A-B72A-EB3FAD0D6176\"></a>Causes the display of the rasterized bitmap representation of the vector map in a\n               \"Specify Cropping/Placement\" window. \n               		\n            </p> \n            <p><a name=\"GUID-0CB32A59-F8B3-4FF8-8318-9525C1CE0722\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">Refresh()</em></pre></div> \n            <p><a name=\"GUID-4790150D-6A94-461E-B1F9-8A8B2137A93C\"></a>Refreshes the map without reloading the source. \n               		\n            </p> \n            <p><a name=\"GUID-7E73FA09-E228-4E84-A1D7-04450E717434\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">SetSvgString</em> &lt;string&gt;fnSetSvgString</pre></div> \n            <p><a name=\"GUID-A46A9D77-A6FC-41F2-8120-EB71C67EB279\"></a>Gets the Vector Map\'s definition via a MAXScript String value instead of an external\n               text file. \n               		\n            </p> \n            <p><a name=\"GUID-6EDF3DA7-715C-4624-9507-369E3B29CB6D\"></a>Use MAXScript to build an SVG XML description into a String variable, then pass this\n               String as argument to this function. \n               		\n            </p> \n            <p><a name=\"GUID-82F0CA58-2505-4188-A676-75E482B46162\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>Interface: <em class=\"codeEmphasisStrong\">IMtlRender_Compability_MtlBase</em></pre></div> \n            <p><a name=\"GUID-48038239-84F5-484C-A169-9095C2EE63B7\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <p><a name=\"GUID-5673D29E-B06F-4D03-B8CE-220B0A4BA313\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <p><a name=\"GUID-17DB480B-2216-4665-94AA-A28A8333D542\"></a> <em class=\"strong\">Actions:</em> \n            </p> \n         </div>\n         <p><a name=\"GUID-DCC5BFFE-79F1-4253-BC45-C3C34BC42DEE\"></a></p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C73B4\"></a> <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C73B8\"></a> <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C73B9\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C73BA\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";