var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CA7ABB4B-6CB6-47B7-903D-84D2F45D993D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"manual garbage collection\">\n      <meta name=\"indexterm\" content=\"garbage collection\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Manual Garbage Collection</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CA7ABB4B-6CB6-47B7-903D-84D2F45D993D\"></a><div class=\"head\">\n            <h1>Manual Garbage Collection </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B92\"></a>  The function <span class=\"code\"> <em class=\"strong\">gc()</em> </span> invokes the garbage collector. \n         </p>\n         <p><a name=\"P_B3A630103899472DB8ADFE7688CAEA6E\"></a>Normally, the collector runs automatically when available memory runs low, so you\n            don\'t normally need to call it explicitly. \n         </p>\n         <p><a name=\"P_EE5584E322EF46639CF461117647F881\"></a>However, in some situations, it is useful to be able to force a collect to ensure\n            a pause due to garbage collection will be delayed as long as possible. \n         </p>\n         <p><a name=\"P_2B36903918894BEC8580E89BC96F8C59\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B95\"></a>You can also invoke the collector to cause any unreferenced open files to be closed.\n            \n         </p>\n         <p><a name=\"P_B5A2BBECBC62420493B98ED8254433EC\"></a>In some situations, a file can be left open if a runtime error occurs while it is\n            still open. \n         </p>\n         <p><a name=\"P_5AE9B50F32CF4DC1AEEBD2FCAE64932B\"></a>If the file object was being held in a local variable at this point, it may not be\n            possible to get at it from the Listener to force a close. \n         </p>\n         <p><a name=\"P_FD7411DAD1F641BAA300560FCADF40AC\"></a>Any subsequent attempts to open it may result in an \"already open\" error from the\n            operating system. \n         </p>\n         <p><a name=\"P_CBA0700BD1FF45ABB6FD7D3D2834ABD3\"></a>Running the collector will cause the file object to be reclaimed and this forces any\n            open file associated with it to be closed. \n         </p>\n         <p><a name=\"P_24C783C9782F45FEB1E914DA8909C3EF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-617D\"></a><pre><em class=\"codeEmphasisStrong\">gc</em> [<em class=\"codeEmphasisStrong\">light</em>:false] [<em class=\"codeEmphasisStrong\">delayed</em>:false] 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B98\"></a>This function returns the number of bytes free in the MAXScript heap after collection.\n            \n         </p>\n         <p><a name=\"P_67138E1B3C5C4D76B838E3CC1A4ED724\"></a>Note that the collector may take many seconds to run if the heap is full of many small\n            reclaimable objects. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B97\"></a>&nbsp; \n         </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-7534\"></a> \n            <h2><a name=\"GUID-BDDCD1ED-6485-4826-83F0-A8CAA0B30228\"></a> <em class=\"strong\">Garbage Collection light: option</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B99\"></a>When the optional <span class=\"code\"> <em class=\"strong\">light:</em> </span> keyword argument is passed as <span class=\"code\"> <em class=\"strong\">true</em> </span>, the undo buffer will not be flushed. \n            </p> \n            <p><a name=\"P_3FBF542E3F5749A4A1D288DC956A094F\"></a>If you are performing a lot of scene operations then it is recommended to call <span class=\"code\"> <em class=\"strong\">gc()</em> </span> without any argument or pass <span class=\"code\"> <em class=\"strong\">light:false</em> </span>, in which case the undo buffer will be flushed prior to the garbage collection. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9A\"></a>When <span class=\"code\"> <em class=\"strong\">light:true</em> </span> is specified, any value that derives from MAXWrapper will not be collected. \n            </p> \n            <p><a name=\"P_EF0DC4751DD0418886802A86FEFB831C\"></a>This covers all value types that could potentially be in the undo buffer. \n            </p> \n            <p><a name=\"P_548BB8CB35454C458B76599AA0ECCA69\"></a>The result is that, for this case, less memory is released and <span class=\"code\"> <em class=\"strong\">gc</em> </span> runs a bit slower, but you can\'t corrupt the undo stack. \n            </p> \n            <p><a name=\"P_F3CD98C568FD41139554FB6F7E0BEE63\"></a>If <span class=\"code\"> <em class=\"strong\">light:true</em> </span> is not specified, behavior and speed is same as before. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9B\"></a>What does get collected with <span class=\"code\"> <em class=\"strong\">light:true</em> </span> includes rollouts, floaters, UI items, bitmaps, strings, arrays, and bitArrays. \n            </p> \n            <p><a name=\"P_0E59E8F0F53C49ED8CECE671F54F18E9\"></a>Those are all items that do not exist in the scene. \n            </p> \n            <p><a name=\"P_BF41FB2446384E30BF330BFD0B9E8FA0\"></a>&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9C\"></a> \n            <h2><a name=\"GUID-68B56D56-97E4-4548-BE45-9DDDAA80A85C\"></a> <em class=\"strong\">Automatic Garbage Collection behavior and delayed: option</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9D\"></a>When MAXScript runs out of heap memory, it runs garbage collection to free unused\n               memory. \n            </p> \n            <p><a name=\"P_2323635F246D44A1A849A88C2A7967E5\"></a>Since a value collected may be the last reference to a MAX object, we need to flush\n               the undo system since it may contain a pointer to that object or one of its dependents.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9E\"></a>In <em class=\"strong\">3ds Max 5</em>, the \'light\' keyword argument has been introduced for manual garbage collection where,\n               if true, MAXWrapper-derived values are not garbage collected, thus no MAX objects\n               are deleted, and no flush of the undo system is required. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B9F\"></a>The change to MAXScript in <em class=\"strong\">3ds Max 6</em> extended this to <em class=\"strong\">automatic garbage collection</em>. \n            </p> \n            <p><a name=\"P_D4D3CF83DF624316BCC420145E9FEE6C\"></a>When an automatic garbage collection is performed, and the undo system is not empty,\n               an initial garbage collection is performed where MAXWrappers are not garbage collected,\n               and a flag is set so that on the next undo system flush, a full garbage collection\n               is performed. \n            </p> \n            <p><a name=\"P_F0DAFB107CE64B2CAF5BB6D7D9018CCB\"></a>If this initial garbage collection does not free up sufficient memory to satisfy the\n               memory request, or if the undo system is empty, a full garbage collection is performed\n               where MAXWrappers are deleted and the undo system is flushed. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BA0\"></a>With the recent improvements in MAXWrapper interning, undo system flushes due to MAXScript\n               garbage collection should be a fairly rare event. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BA1\"></a>To maintain current behavior, a manual garbage collection using \'gc()\' still flushes\n               the undo system. <span class=\"code\"> <em class=\"strong\">gc light:true</em> </span> will still not flush the undo system. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BA2\"></a>The <span class=\"code\"><em class=\"strong\">delayed:</em>&lt;boolean&gt;</span> option will cause a full garbage collection at the next undo system flush. \n            </p> \n            <p><a name=\"P_B0DC3EB3D5EC4767AF64ED3DC07029B1\"></a>So you could say the following to match the behavior of an automatic garbage collection:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86BA3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-617C\"></a><pre>gc light:true delayed:true</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BA9\"></a> <span class=\"char_link\"><a href=\"GUID-DF09BF99-2106-408D-9965-60436B853D76.htm\">Memory Allocation and Garbage Collection</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";