var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CD5DD388-588A-4D03-8946-38534058791D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"C++-style bracketing comments\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>C++-style bracketing comments</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CD5DD388-588A-4D03-8946-38534058791D\"></a><div class=\"head\">\n            <h1>C++-style bracketing comments </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86408\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86409\"></a> C++-style bracketing can be used to comment out extended segments of code or add lengthy\n               comments. These comments begin with the two characters <em class=\"strong\">/*</em> and end at the next <em class=\"strong\">*/</em> (or end of file).\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8640B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8640C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-626D\"></a><pre>\n/* this is a long comment\nblah blah\nprint \"debug 1\" -- code commented out\nmore comments\n*/\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86415\"></a>You can also use this within a line to comment out a script fragment:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86416\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86417\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-626C\"></a><pre>\nfor i in 1 to 10 do(/* messageBox \"in loop\"; */frabulate i )\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A314\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8641E\"></a>The <em class=\"strong\">/*</em> and <em class=\"strong\">*/</em> have to be adjacent characters.\n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8641F\"></a>If you leave out the closing */ or make it * /, the rest of the file will be commented\n                     out.\n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86422\"></a> <span class=\"char_link\"><a href=\"GUID-BB89D44C-96BB-4E3C-99F7-C66350AA45C0.htm\">MAXScript Editor Commands</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86423\"></a> <span class=\"char_link\"><a href=\"GUID-E7FBAD67-2B3F-42B4-9C91-81E1F40087AB.htm\">Source Code Layout</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86424\"></a> <span class=\"char_link\"><a href=\"GUID-779C94C1-87B6-46D4-80E5-9737689FD182.htm\">Source Code Layout and Continuation Lines</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";