var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CDDF38BF-5AE2-4643-A5CA-12FE92469A01\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: SceneConverter</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CDDF38BF-5AE2-4643-A5CA-12FE92469A01\"></a><div class=\"head\">\n            <h1>Interface: SceneConverter</h1>\n         </div>\n         <p> This Core Interface exposes properties and methods for setting up the scene converter\n            system and its rules. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">visible</em> : bool : Read|Write</pre></div>\n         <p>Get/set the visible state of the Scene Converter dialog. \n            	 \n         </p>\n         <p>Setting the property to True will open the dialog, setting it to False will close\n            it. \n            	 \n         </p>\n         <p>Getting the property will indicate whether the dialog is open (True) or closed (False).\n            \n            	 \n         </p>\n         <p>See also the \n            		<span class=\"char_link\"><a href=\"GUID-B8090816-82DE-40F6-ACC4-E0B62383A49A.htm\">Scene_Converter: GlobalUtilityPlugin</a></span> class and its Actions MixinInterface which exposes a \n            		<span class=\"code\">.show()</span> method that can be used to open the dialog. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">OpenWhenNeededOnFileOpen</em> : bool : Read|Write</pre></div>\n         <p>Get/set the state of the \"<span class=\"MenuCascade\">Open Scene Converter on file open when missing plugins</span>\" checkbox. \n            	 \n         </p>\n         <p>When set to False (default), the Scene Converter will not be opened automatically\n            when loading a scene with missing plugins. \n            	 \n         </p>\n         <p>When set to True, the Scene Converter will be opened automatically if missing plugins\n            are detected. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">BackupOriginalFiles</em> : bool : Read|Write</pre></div>\n         <p>Get/set whether to back up the original files before performing a conversion. \n            	 \n         </p>\n         <p>When set to True, a backup copy with the suffix \"_backup\" will be created. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">ConvertOnlySelectedObjects</em> : bool : Read|Write</pre></div>\n         <p>Get/set the state of the \"<span class=\"MenuCascade\">Apply only to selected objects</span>\" checkbox. \n            	 \n         </p>\n         <p>When set to False (default), the conversion will be applied to the whole scene. \n            	 \n         </p>\n         <p>When set to True, the conversion will only be applied to the selected objects. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">ApplyOnlySelectedRules</em> : bool : Read|Write</pre></div>\n         <p>Get/set whether to apply all rules (False) or only the selected rules (True). The\n            selected rules are the rules selected in the Scene Converter dialog, which requires\n            the user to use the UI.\n            	 \n         </p>\n         <p>Default is False. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">FilterConversionTypesFromScene</em> : bool : Read|Write</pre></div>\n         <p>Get/set the state of the \"<span class=\"MenuCascade\">Only display types in the current scene</span>\" checkbox. \n            	 \n         </p>\n         <p>When set to False (default), all object types that can be converted will be listed\n            in the Source list of the dialog. \n            	 \n         </p>\n         <p>When set to True, only the object types found in the current scene that can be converted\n            will be listed in the Source list of the dialog. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">ScriptFolder</em> : string : Read|Write</pre></div>\n         <p>Get/set the Scene Converter Script Folder. \n            	 \n         </p>\n         <p>Default is \"<span class=\"filePath\">C:\\Users\\%USERNAME%\\AppData\\Local\\Autodesk\\3dsMax\\[Max Version]\\[Language]\\Scene Converter\\</span>\". \n            	 \n         </p>\n         <p>This folder has two sub-folders: \n            	 \n         </p>\n         <p>\"<span class=\"filePath\">\\ConversionScripts</span>\" containing the MAXScript files describing the conversion rules for individual object\n            types,and \n            	 \n         </p>\n         <p>\"<span class=\"filePath\">\\ConversionPresets</span>\" containing the MAXScript files describing the conversion presets for one renderer\n            to another. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>SceneConverter.<em class=\"codeEmphasisStrong\">BatchMode</em> : enum : Read|Write</pre></div>\n         <p> BatchMode enums: {#XRefs|#File|#Folder} \n            	 \n         </p>\n         <p>Get/set the state of the \"Batch Conversions\" radio buttons under the \"Options\" tab\n            of the dialog. \n            	 \n         </p>\n         <p>Possible values are: \n            	 \n         </p><a name=\"UL_BA20702426514887AE7FFD5A808B012B\"></a><ul>\n            <li>0 - #XRefs (default) – \"Convert Reference Files\" mode, will convert all external references\n               of the scene. \n               		\n            </li>\n            <li>1 - #File – \"Convert File\" mode, will convert the specified file. \n               		\n            </li>\n            <li>2 - #Folder – \"Convert Folder\" mode, will convert the scene files in the specified\n               folder. \n               		\n            </li>\n         </ul>\n         <p>The integers 0, 1 and 2 can be used in place of the enums, but getting the property\n            will always return the enum names. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>sceneconverter.<em class=\"codeEmphasisStrong\">AutoRemoveMissingLegacyAssets</em> : bool : Read|Write</pre></div>\n         <p> Available in \n            		<em class=\"strong\">3ds Max 2018.4 and higher</em>: Gets or sets the state of the \"Automatically remove missing legacy assets on file\n            open\" checkbox in the Scene Converter dialog. \n            		<em class=\"strong\">Note</em>: Setting this to true will remove all missing legacy assets each time a file is opened\n            or merged without the Scene Converter dialog appearing. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;SceneConverter.<em class=\"codeEmphasisStrong\">ConvertScene</em>()</pre></div>\n         <p>Equivalent to pressing the \"<span class=\"MenuCascade\">Convert Scene</span>\" button in the dialog. \n            	 \n         </p>\n         <p>Performs the conversion of the current scene according to the set rules. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;SceneConverter.<em class=\"codeEmphasisStrong\">CancelConversion</em>()</pre></div>\n         <p>Equivalent to pressing the \"<span class=\"MenuCascade\">Cancel</span>\" button in the dialog. \n            	 \n         </p>\n         <p>Cancels an ongoing scene conversion process. \n            	 \n         </p>\n         <p>Applies to all possible conversion processes, including current scene, other MAX file,\n            XRefs, or Batch conversion. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;SceneConverter.<em class=\"codeEmphasisStrong\">SaveSceneMaterialLibrary</em> &lt;filename&gt;LibraryFullPathFilename</pre></div>\n         <p>Saves a .MAT Material Library with the scene materials. \n            	 \n         </p>\n         <p>The argument is the full filename and path of the Material Library. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;SceneConverter.<em class=\"codeEmphasisStrong\">OverwriteFromMaterialLibrary</em> &lt;filename&gt;LibraryFullPathFilename</pre></div>\n         <p>Replaces the scene materials and maps with material and maps with the same names from\n            the specified .MAT Material Library. \n            	 \n         </p>\n         <p>The argument is the full filename and path of the Material Library. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">ConvertAllReferencedFiles</em>()</pre></div>\n         <p>Performs conversion of all XRef files without converting the current scene. \n            	 \n         </p>\n         <p>Returns True on success, False on failure. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">ConvertMaxFile</em> &lt;filename&gt;MaxFullpathFilename</pre></div>\n         <p>Performs conversion of the specified .MAX file. \n            	 \n         </p>\n         <p>Returns True on success, False on failure. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">ConvertFolder</em> &lt;string&gt;Folder</pre></div>\n         <p>Performs conversion of the .MAX files in the specified folder and its sub-folders.\n            \n            	 \n         </p>\n         <p>Returns True on success, False on failure. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">LoadConversionPreset</em> &lt;filename&gt;presetFilename</pre></div>\n         <p>Loads the specified conversion preset. \n            	 \n         </p>\n         <p>The argument is the fully qualified file name and path of the preset script file.\n            \n            	 \n         </p>\n         <p>Existing presets can be found by looking in the ConversionPresets subfolder of the\n            SceneConverter.ScriptFolder folder and getting all .MS files using \n            		<span class=\"code\">getFiles()</span>. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-776D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-776C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5565\"></a><pre>\nthePresets = getFiles (SceneConverter.ScriptFolder + @\"ConversionPresets\\*.ms\") --get all preset files\nif thePresets.count &gt; 0 then\n  SceneConverter.LoadConversionPreset thePresets[1] --load the first preset found, if any\nelse\n  format “--No Presets Found!\\n”\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;string by value array&gt;<em class=\"codeEmphasisStrong\">GetMissingLegacyAssetsName</em>()\n      GetMissingLegacyAssetsName - no automatic redraw after invoked</pre></div>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018.4 and higher</em>: Returns a tab of strings, which is the list of missing legacy assets. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">RemoveMissingLegacyAssetsFromScene</em> &lt;&amp;string array&gt;TabString_MissingLegacyAssetsNames\n       RemoveMissingLegacyAssetsFromScene - no automatic redraw after invoked\n       TabString_MissingLegacyAssetsNames is In and Out parameter</pre></div>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018.4 and higher</em>: Takes a tab of strings, which are the missing legacy assets to remove from the scene.\n            \n            		<em class=\"strong\">Note</em>: passing an empty string array will remove all the missing legacy assets in the scene.\n            \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">The following methods expose functionality that is meant for internal use only:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;SceneConverter.<em class=\"codeEmphasisStrong\">ClearInvalidClassIDs</em>()</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;SceneConverter.<em class=\"codeEmphasisStrong\">GetNumInvalidClassIDs</em> &lt;enum&gt;classIDType</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;int by value array&gt;SceneConverter.<em class=\"codeEmphasisStrong\">GetInvalidClassIDs</em> &lt;enum&gt;classIDType &lt;integer&gt;index</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">AddInvalidClassID</em> &lt;enum&gt;classIDType &lt;INT64 array&gt;classIDAs2IntegersInATab\n    classIDType enums: {#eLight|#eMaterial|#eMap|#eGeometry|#eCamera|#eExposureControl|#eRenderEffect|#eRenderElement|#eOther} \n	 </pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">RemoveInvalidClassID</em> &lt;enum&gt;classIDType &lt;integer&gt;index\n    classIDType enums: {#eLight|#eMaterial|#eMap|#eGeometry|#eCamera|#eExposureControl|#eRenderEffect|#eRenderElement|#eOther}</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;SceneConverter.<em class=\"codeEmphasisStrong\">AddLoadedStandinRef</em> &lt;maxObject&gt;standin &lt;string&gt;name &lt;integer&gt;isMentalRay</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">AddConversionRule</em> &lt;INT64 array&gt;sourceClassID &lt;INT64 array&gt;destinationClassID scriptID:&lt;string&gt; sourceAutodeskMaterialBaseType:&lt;string&gt; destinationAutodeskMaterialBaseType:&lt;string&gt;\n   scriptID default value: \"\" \n	  sourceAutodeskMaterialBaseType default value: \"\" \n	  destinationAutodeskMaterialBaseType default value: \"\"</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">RemoveFromScene</em> &lt;INT64 array&gt;sourceClassID sourceAutodeskMaterialBaseType:&lt;string&gt;\n   sourceAutodeskMaterialBaseType default value: \"\"</pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;SceneConverter.<em class=\"codeEmphasisStrong\">DoNotConvert</em> &lt;INT64 array&gt;sourceClassID sourceAutodeskMaterialBaseType:&lt;string&gt;\n   sourceAutodeskMaterialBaseType default value: \"\" \n	 </pre></div>\n         <p>For Internal use only. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Actions:</em> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";