var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CE0FD5F8-61D6-4B61-AB86-D2176CEE990B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rollout User-Interface Control Types\">\n      <meta name=\"indexterm\" content=\"pickbutton\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Pickbutton UI Control</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CE0FD5F8-61D6-4B61-AB86-D2176CEE990B\"></a><div class=\"head\">\n            <h1>Pickbutton UI Control </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DBC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DBB\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">User Interface Controls</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Common Properties</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Layout</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Types </a></span>&gt; Pickbutton \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DB9\"></a>A <em class=\"strong\">pickbutton control</em> is used to place a scene object-picker button on the rollout. It operates like a\n            normal pick button in the <em class=\"strong\">3ds Max</em> user interface, turning light-green when pressed and causing an object-pick mode\n            to be entered. The user can then choose a scene object by clicking on it. The pick\n            mode exits and the button returns to its unpressed state. The user can right-click\n            to cancel the pick mode. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DB8\"></a> <em class=\"strong\">The syntax is:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7335\"></a><pre><em class=\"codeEmphasisStrong\">pickbutton</em> &lt;name&gt; [&lt;caption&gt;] [<em class=\"codeEmphasisStrong\">message</em>:&lt;string&gt;] [<em class=\"codeEmphasisStrong\">filter</em>:&lt;function&gt;] [<em class=\"codeEmphasisStrong\">toolTip</em>:&lt;string&gt;] [<em class=\"codeEmphasisStrong\">autoDisplay</em>:&lt;boolean&gt;] 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DB6\"></a>The default alignment of <span class=\"code\"> <em class=\"strong\">pickbutton</em> </span> items is <span class=\"code\"> <em class=\"strong\">#center</em> </span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DB4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5DB3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7334\"></a><pre>\nrollout pick_box_test \"Pick Box Test\"\n(\n--filter all objects of class Box:\nfn box_filt obj = classof obj == Box\n--Pickbutton to select a Box from the scene\npickbutton chooseit \"Select Box\" width:140 filter:box_filt\n--If the user picked an object, then\non chooseit picked obj do\n(\n--see if the user did not cancel the picking...\nif obj != undefined do\n(\n--if he did not, make the box\'s wireframe red:\nobj.wirecolor = red\n--and display the name of the object on the button:\nchooseit.text = obj.name\n)\n)--end on\n)--end rollout\ncreateDialog pick_box_test\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D9B\"></a> <img src=\"../images/GUID-A7C0D341-8764-4FE9-9224-025634232452-low.gif\"> <img src=\"../images/GUID-C98FF22A-EFB5-419C-A1B2-0BDA712E5431-low.gif\"> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D9A\"></a>Note that the filter function will not let you select any other objects except Boxes.\n            \n         </p>\n         <p><a name=\"GUID-DFD930D0-DF6F-4D37-9223-1814391A901B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D98\"></a> <em class=\"strong\">Parameters:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7333\"></a><pre><em class=\"codeEmphasisStrong\">message</em>:   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D96\"></a>The optional text to be displayed in the <em class=\"strong\">3ds Max</em> status line while in the pick mode. Default is no message. \n         </p>\n         <p><a name=\"GUID-2D2B81D8-E1FA-4598-8A18-31F1896A22AA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7332\"></a><pre><em class=\"codeEmphasisStrong\">filter</em>: </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D93\"></a>The optional filter function that will be called to test the eligibility of the scene\n            object under the cursor for picking. It must be a function of one argument, which\n            will be the object under test, and return <span class=\"code\"> <em class=\"strong\">true</em> </span> if the object is eligible or <span class=\"code\"> <em class=\"strong\">false</em> </span> if not. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D92\"></a>Default is no filtering. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D91\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D90\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-63A0\"></a><p class=\"table-body\">The following filter function allows only objects whose names begin with \"foo\" to\n                        be pickable: \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7331\"></a><pre>\nfn foo_filter obj = matchPattern obj.name pattern:\"foo*\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-AAB6A2C7-AD5D-4D1E-A7BA-AD0BBD2E9CB1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7330\"></a><pre><em class=\"codeEmphasisStrong\">toolTip</em>: </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D89\"></a>Provides text for a tooltip for the button. No tooltip if unsupplied. \n         </p>\n         <p><a name=\"GUID-1E26240C-8755-4D75-87BA-46A804D44F03\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732F\"></a><pre><em class=\"codeEmphasisStrong\">autoDisplay:</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D86\"></a>When set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, the name of the picked object will be automatically displayed as the text on the\n            button. If <span class=\"code\"> <em class=\"strong\">false</em> </span> or not specified, the button caption will not be changed. \n         </p>\n         <p><a name=\"GUID-4BDDD1F3-E80E-4872-BE2A-93CC3BC27A2C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D84\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732E\"></a><pre>&lt;pickbutton&gt;.<em class=\"codeEmphasisStrong\">object</em> Node </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D82\"></a>The last object picked using the <span class=\"code\"> <em class=\"strong\">pickbutton</em> </span>, <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if no object has been picked. The property can be both get and <em class=\"strong\">set</em>, accepting a node or undefined. \n         </p>\n         <p><a name=\"GUID-D8A38855-D72B-4BB7-AEC9-44DEC46053C3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732D\"></a><pre>&lt;pickbutton&gt;.<em class=\"codeEmphasisStrong\">tooltip</em> String </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D7F\"></a>Get/set the tooltip string of the checkbutton. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D7E\"></a>Available in <em class=\"strong\">3ds Max 9 and higher</em>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D7D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D7C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732C\"></a><pre>\n--If you pick a scene object, the tooltip of the pickbutton will show\n--the name of the object you picked.\nrollout test \"Test\"\n(\npickbutton pck_test \"&gt;&gt;Pick An Object\" tooltip:\"Pick A Scene Object...\"\non pck_test picked obj do\nif isValidNode obj do pck_test.tooltip = \"You picked \" + obj.name\n)\ncreateDialog test\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0AE66D14-F211-4C8E-8BCC-16DC571B7CDA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D6F\"></a> <em class=\"strong\">Events:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732B\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;pickbutton&gt; <em class=\"codeEmphasisStrong\">picked</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D6D\"></a>Called when the user selects an object in the scene while in the <span class=\"code\"> <em class=\"strong\">pickbutton</em> </span> pick mode. The <span class=\"code\"> <em class=\"strong\">&lt;arg&gt;</em> </span> argument will contain the selected object. The handler is not called if the user\n            cancels out of the pick mode. \n         </p>\n         <p><a name=\"GUID-247C840E-F50F-468D-861F-39AA61760EDA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-732A\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;pickbutton&gt; <em class=\"codeEmphasisStrong\">rightclick do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D6A\"></a>Called when the right mouse button is released over the button. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D67\"></a> <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Items Common Properties</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D66\"></a> <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Items Common Layout Parameters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D65\"></a> <span class=\"char_link\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Rollout User-Interface Control Types</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D63\"></a> <em class=\"strong\">Similar Controls</em> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D62\"></a> <span class=\"char_link\"><a href=\"GUID-DA0EEF5F-FF31-498D-A334-B4448F8E9A09.htm\">Materialbutton</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D61\"></a> <span class=\"char_link\"><a href=\"GUID-54F9E004-A178-48B1-A537-EB42546C1093.htm\">Mapbutton</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D60\"></a> <span class=\"char_link\"><a href=\"GUID-E03EED5F-E21F-4C2F-AFA9-BA16A6602ACA.htm\">Button</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5D5F\"></a> <span class=\"char_link\"><a href=\"GUID-084BC777-9353-455E-A869-9F5C514E0CE6.htm\">Checkbutton</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";