var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Use ActiveX Controls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n         One\n      </title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C\"></a><div class=\"head\">\n            <h1>How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n               One \n            </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FBD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FBE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-62A4F4C6-2012-415B-8641-2D85AE4E02EE.htm\">Use ActiveX Controls</a></span>&gt; Develop a Selected Objects Inspector - Part One \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FC0\"></a>This tutorial will demonstrate how to set up an ActiveX Control in a MAXScript rollout\n            to display details about selected scene objects. \n         </p>\n         <div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-2BB0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FC5\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                  Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FC6\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                  on the system to be accessible to MAXScript. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FC7\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FC8\"></a>Please see the topic <span class=\"char_link\"><a href=\"GUID-25E15114-B1F5-4C62-8E84-C630C15E92BB.htm\"> Converting ActiveX ListView Control to DotNet ListView Control</a></span> \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FCB\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FCC\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FCD\"></a> <span class=\"char_link\"><a href=\"GUID-0C6E7C77-A065-4602-9930-4FE275AE3B9A.htm\">ListView ActiveX Control</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FCE\"></a> <span class=\"char_link\"><a href=\"GUID-D62ADC40-0FEB-42FC-AD97-0C6BC5BD383E.htm\">Listview ActiveX functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FCF\"></a> <span class=\"char_link\"><a href=\"GUID-87081207-7388-4F7E-AA7B-60D00ABECF03.htm\">ListView ActiveX Control Example</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD2\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD3\"></a><p class=\"table-body\">Create a simple macroScript. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD4\"></a><p class=\"table-body\">Define a rollout which will be used to create a floating dialog. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD5\"></a><p class=\"table-body\">The only UI control in the rollout will be a Listview ActiveX Control. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD6\"></a><p class=\"table-body\">Create a function to define the layout and appearance of the Listview. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD7\"></a><p class=\"table-body\">Create another function to fill in the data of selected objects into the list </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FD8\"></a><p class=\"table-body\">The two functions will be called by the on open event handler whenever the dialog\n                        is created (and thus the rollout is opened). \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FDA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FDB\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6380\"></a><pre>\nmacroScript SceneListView category:\"HowTo\"\n(\nrollout listview_rollout \"ListView Selected\"\n(\nfn initListView lv =\n(\nlv.gridLines = true &nbsp;\nlv.View = #lvwReport &nbsp;\nlv.fullRowSelect = true&nbsp;\n&nbsp;\nlayout_def = #(\"Object Name\",\"Object Class\",\"Verts\",\"Faces\",\"Material\")\n&nbsp;\nfor i in layout_def do\n(\ncolumn = lv.ColumnHeaders.add()\ncolumn.text = I\n)&nbsp;\n)&nbsp;\n&nbsp;\nfn fillInSpreadSheet lv =\n(\nfor o in selection do\n(\nli = lv.ListItems.add()\nli.text = o.name\nsub_li = li.ListSubItems.add()\nsub_li.text = (classof o) as string\nsub_li = li.ListSubItems.add()\nsub_li.text =try((o.mesh.numverts) as string)catch(\"--\")\nsub_li = li.ListSubItems.add()\nsub_li.text =try((o.mesh.numfaces) as string)catch(\"--\")\nsub_li = li.ListSubItems.add()\nsub_li.text = (o.material)as string\n)\n)&nbsp;\n&nbsp;\nactiveXControl lv_objects \"MSComctlLib.ListViewCtrl\" width:490 height:190 align:#center\non listview_rollout open do\n(\ninitListView lv_objects\nfillInSpreadSheet lv_objects\n)&nbsp;\n)\ncreateDialog listview_rollout500 200\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC300D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC300E\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3010\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A15CE4AA-D1DE-4220-8E01-7308DCA73F7B-low.gif\"></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3012\"></a> \n            <h2><a name=\"GUID-ACFC8C75-1E75-4FC5-998A-BEACE86BCE79\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637F\"></a><pre><em class=\"codeEmphasisStrong\">macroScript SceneListView category:\"HowTo\"</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3015\"></a>We start by defining a simple MacroScript with the name SceneListview which will appear\n               in the category \"HowTo\". Simple (old-style) macroScripts do not have on execute do\n               or on isEnabled event handlers. The code inside the MacroScript definition is executed\n               immediately when the ActionItem (button, menu item or keyboard shortcut) representing\n               the MacroScript is activated. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637E\"></a><pre><em class=\"codeEmphasisStrong\">rollout listview_rollout \"ListView Selected\"</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3018\"></a>This is the rollout to be created when the MacroScript is executed. It will display\n               the title \"ListView Selected\". The variable listview_rollout will be local to the\n               macroScript and will be used later on to create a dialog out of the rollout definition.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637D\"></a><pre><em class=\"codeEmphasisStrong\">fn initListView lv =</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC301B\"></a>This is the function which will perform the initialization of the ListView ActiveX\n               control we will create. The control itself will be passed as argument to the function.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637C\"></a><pre><em class=\"codeEmphasisStrong\">lv.gridLines = true</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC301D\"></a>We want the ListViewControl to display grid lines. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637B\"></a><pre><em class=\"codeEmphasisStrong\">lv.View = #lvwReport</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC301F\"></a>We also want to see the column headers, so we define the view type as lvwReport. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-637A\"></a><pre><em class=\"codeEmphasisStrong\">lv.fullRowSelect = true&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3021\"></a>By setting this property to true, we ensure that selecting a row will select across\n               all columns. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6379\"></a><pre><em class=\"codeEmphasisStrong\">layout_def = #(\"Object Name\",\"Object Class\",\"Verts\",\"Faces\",\"Material\")</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3023\"></a>This user variable is assigned an array containing the names of the columns to be\n               created. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6378\"></a><pre><em class=\"codeEmphasisStrong\">for i in layout_def do</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3026\"></a>The i loop will go through all elements of the array defined above. Inside the loop,\n               a new column will be created for each entry in the array. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6377\"></a><pre><em class=\"codeEmphasisStrong\">column = lv.ColumnHeaders.add()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3028\"></a>By calling the function add() in the ColumnHeaders property of the listview, we add\n               a new column to the list. A reference to the column is returned and written in the\n               user variable \"column\", so we can now access properties of the column. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6376\"></a><pre><em class=\"codeEmphasisStrong\">column.text =i&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC302A\"></a>For example, we can set the text in the column header to the string stored in the\n               array we are looping through. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6375\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC302C\"></a>This is the end of the i loop.. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6374\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC302E\"></a>This is the end of the function. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6373\"></a><pre><em class=\"codeEmphasisStrong\">fn fillInSpreadSheet lv =\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3032\"></a>This is the function which will fill in the data of the selected scene objects into\n               the Listview ActiveX control. The control itself will be passed as argument to the\n               function. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6372\"></a><pre><em class=\"codeEmphasisStrong\">for o in selection do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3035\"></a>This loop will iterate through all objects currently selected in the scene. The variable\n               o will contain one object at a time, the loop will repeat as ofter as there are objects\n               in the selection set. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6371\"></a><pre><em class=\"codeEmphasisStrong\">li = lv.ListItems.add()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3037\"></a>We add a new row to the Listview. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6370\"></a><pre><em class=\"codeEmphasisStrong\">li.text = o.name</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3039\"></a>Then we set the text displayed in the first column of the list to the name of the\n               object. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636F\"></a><pre><em class=\"codeEmphasisStrong\">sub_li = li.ListSubItems.add()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC303B\"></a>Now we add a new sub-item (which is basically the following column) by calling the\n               <span class=\"code\">.add()</span> method in the ListSubItems property of the current listItem (which represents the\n               first column). The result is written into the user variable sub_li \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636E\"></a><pre><em class=\"codeEmphasisStrong\">sub_li.text = (classof o) as string</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC303D\"></a>We can now set the .text property of the new column to the class of the current object.\n               Since the result of <span class=\"code\">classof()</span> is not a string, we have to explicitly convert it to string before assigning it to\n               the <span class=\"code\">.text</span> property. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636D\"></a><pre><em class=\"codeEmphasisStrong\">sub_li = li.ListSubItems.add()\nsub_li.text = try((o.mesh.numverts) as string)catch(\"--\")</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3040\"></a>We create a third column the same way as above and assign the number of vertices in\n               the mesh of the current object to the .text property of the new column. Since the\n               number of vertices is returned as an integer, we have to convert it to a string before\n               assigning it to the<span class=\"code\"> .text</span> property. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3041\"></a>Some of the selected objects might not have a <span class=\"code\">.mesh</span> property (for example lights, helpers, cameras, targetObjects etc.) In these cases,\n               trying to access <span class=\"code\">o.mesh.numverts</span> would cause an error. For these cases, we put the <span class=\"code\">try()catch()</span> error trap. If the attempt to read the vertex count fails, we assign the string \"--\"\n               to the<span class=\"code\"> .text</span> property of the sub-list item instead. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636C\"></a><pre><em class=\"codeEmphasisStrong\">sub_li = li.ListSubItems.add()\nsub_li.text = try((o.mesh.numfaces) as string)catch(\"--\")</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3044\"></a>We create another column the same way as above and assign the number of f aces in\n               the mesh of the current object to the <span class=\"code\">.text</span> property of the new column. Since the number of faces is returned as an integer,\n               we have to convert it to a string before assigning it to the <span class=\"code\">.text</span> property. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3045\"></a>Some of the selected objects might not have a .mesh property (for example lights,\n               helpers, cameras, targetObjects etc.) In these cases, trying to access <span class=\"code\">o.mesh.numfaces </span>would cause an error. For these cases, we put the <span class=\"code\">try()catch()</span> error trap. If the attempt to read the face count fails, we assign the string \"--\"\n               to the <span class=\"code\">.text</span> property of the sub-list item instead. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636B\"></a><pre><em class=\"codeEmphasisStrong\">sub_li = li.ListSubItems.add()\nsub_li.text = (o.material) as string</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3048\"></a>Finally, we create another column the same way as above and assign the material of\n               the current object to the <span class=\"code\">.text</span> property of the new column. Objects without a material will display \"undefined\" in\n               the column. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-636A\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\n)\n&nbsp;\nactiveXControl lv_objects \"MSComctlLib.ListViewCtrl\" width:490 height:190 align:#center</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC304D\"></a>This is it - the ActiveX control we have been processing in the above functions! It\n               is the only user interface element in the rollout. It is centered to the rollout and\n               slightly smaller than the dialog dimensions. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6369\"></a><pre><em class=\"codeEmphasisStrong\">on listview_rollout open do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3050\"></a>When the rollout is opened for display as a dialog, this event handler will be called.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6368\"></a><pre><em class=\"codeEmphasisStrong\">initListView lv_objects\nfillInSpreadSheet lv_objects</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3053\"></a>We can use the event to both initialize and fill in the listview with the currently\n               selected objects\' data. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6367\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3055\"></a>This is the end of the on open event handler. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6366\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3057\"></a>This is the end of the rollout definition. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6365\"></a><pre><em class=\"codeEmphasisStrong\">try(destroyDialog listview_rollout)catch()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3059\"></a>Before creating the dialog, we try to close it. Since the variable <span class=\"code\"> <em class=\"strong\">listview_rollout</em> </span> is local to the MacroScript, calling the MacroScript multiple times will always access\n               the same variable and will be able to close a previously opened dialog before creating\n               a new one. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6364\"></a><pre><em class=\"codeEmphasisStrong\">createDialog listview_rollout 500 200</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC305B\"></a>At the end, we create the dialog using the rollout we defined above. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6363\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC305D\"></a> \n            <h2><a name=\"GUID-A136BC46-97E9-4771-8330-5FF28BF7A34D\"></a> <em class=\"strong\">Using the Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC305E\"></a>After evaluating the script, you will find a new ActionItem in the \"HowTo\" category\n               of the Customize User Interface dialog. Assign it to a toolbar, menu, QuadMenu or\n               keyboard shortcut to be able to access it quickly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC305F\"></a>Select some scene objects and press the button/select the menu item or press the keyboard\n               shortcut - a new dialog with a listView ActiveX control displaying the name, class,\n               vertex and face count and assigned material should appear. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3060\"></a>Select some other object and call the script again - the old dialog will be closed,\n               a new one will be opened and will display the data of the new selection. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3062\"></a> \n            <h2><a name=\"GUID-5673E0F7-EE0D-44A3-8D52-55C4DC82AAFD\"></a> <em class=\"strong\">What\'s Next?</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3063\"></a>This is a very basic version of the script. To see how it can be further improved\n               and customized, see <span class=\"char_link\"><a href=\"GUID-C9BD442F-7B4E-42F6-92CC-31B2DEE9E4FB.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                     Two</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3066\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3067\"></a> <span class=\"char_link\"><a href=\"GUID-0C6E7C77-A065-4602-9930-4FE275AE3B9A.htm\">ListView ActiveX Control</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";