var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-CF42632D-E10A-4C98-92F0-1FE949A80298\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SkinPose Interface\">\n      <meta name=\"indexterm\" content=\"Interface SkinPose\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: SkinPose</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CF42632D-E10A-4C98-92F0-1FE949A80298\"></a><div class=\"head\">\n            <h1>Interface: SkinPose </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA0\"></a> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A9F\"></a>  This is a <em class=\"strong\">Node Interface</em> providing access to the general node posing capabilities. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A9C\"></a>It does <em class=\"strong\">not</em> require a Skin modifier in order to be accessed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A9B\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5317\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinPos</em> : point3 by value : Read|Write 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A9A\"></a>Get/Set the value of the position part of the transformation pose. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5316\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinRot</em> : point3 by value : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A98\"></a>Get/Set the value of the rotation part of the transformation pose - Euler angle in\n               position XYZ \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5315\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinScale</em> : point3 by value : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A96\"></a>Get/Set the value of the scale part of the transformation pose - Point3 as scale factors\n               x, y, and z \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5314\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinScaleOrient</em> : quat by value : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A94\"></a>Get/Set the orientation of the scale factor axes \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5313\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinPosEnabled</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A92\"></a>Check whether the pose position is enabled / Enable the pose position. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5312\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinRotEnabled</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A90\"></a>Check whether the pose rotation is enabled / Enable the pose rotation. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5311\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinScaleEnabled</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A8E\"></a>Check whether the pose scale is enabled / Enable the pose scale. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5310\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">skinPoseMode</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A8C\"></a>Check whether the node transformation is in pose mode / Enable the pose mode. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A8B\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530F\"></a><pre>&lt;void&gt;&lt;node&gt;.<em class=\"codeEmphasisStrong\">setSkinPose</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A8A\"></a>Sets the state of all three non-animatied skin pose transforms to the animated normal\n               pose \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530E\"></a><pre>&lt;void&gt;&lt;node&gt;.<em class=\"codeEmphasisStrong\">assumeSkinPose</em>() </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A87\"></a> <span class=\"char_link\"><a href=\"GUID-38A8EFE3-685B-41F8-9E36-5B6B5CEACC18.htm\">Node Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A86\"></a> <span class=\"char_link\"><a href=\"GUID-0820AA26-920F-434D-A6BC-E8B6B57F54AC.htm\">Skin : Modifier</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";