var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D06B671D-5FE9-4673-8664-493F64B36FEB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"math expressions\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Math Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D06B671D-5FE9-4673-8664-493F64B36FEB\"></a><div class=\"head\">\n            <h1>Math Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E4B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E4C\"></a>  The math expressions in MAXScript correspond to the common operator expressions in\n               mathematics, such as add, subtract, multiply, divide, and so on. The <span class=\"code\"> &lt;math_expr&gt; </span> constructs in MAXScript are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-612E\"></a><pre>&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;math_operand&gt; -- standard arithmetic addition \n&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;math_operand&gt; -- standard arithmetic subtraction\n&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;math_operand&gt; -- standard arithmetic multiplication\n&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">/</em> &lt;math_operand&gt; -- standard arithmetic division\n&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">^</em> &lt;math_operand&gt; -- exponential, raise to the power\n&lt;math_operand&gt; <em class=\"codeEmphasisStrong\">as</em> &lt;class&gt; -- conversion between types</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E50\"></a>where <span class=\"code\"> <em class=\"strong\">&lt;math_operand&gt;</em> </span> can be one of: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-612D\"></a><pre>&lt;operand&gt;\n&lt;function_call&gt;\n&lt;math_expr&gt;</pre></div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1936\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A math operand can be another nested math expression. This is another instance of\n                  a recursive syntax definition which lets you create arbitrary sequences of operands\n                  and operators. Note also that the math unary minus is not defined here, it is one\n                  of the <span class=\"code\"> &lt;operand&gt; </span> types described in <span class=\"char_link\"><a href=\"GUID-7861EA5A-81DC-4BFE-9585-1FFC08ACEDB2.htm\">Operands</a></span>. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E58\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86E59\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-612C\"></a><pre>42\n2 + 2\n2 * a - sin x / b -- using a function call\n(a + b) * -c\n2 ^ n\n(n + 1) as string -- converts result to a string value</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E63\"></a>The conversion operator, <em class=\"strong\">as</em>, works between selected sets of source and destination value types. Only certain\n               kinds of values can be converted into certain other kinds of values. These allowed\n               conversions are defined for each type of value, and are documented with the value\n               type descriptions. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E65\"></a> <span class=\"char_link\"><a href=\"GUID-4C706E8C-89D4-4E39-8F28-F1BAB50D2C47.htm\">Math Assignment</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E66\"></a> <span class=\"char_link\"><a href=\"GUID-7D83837E-8ACC-4B4F-A9E1-DBA71C59C950.htm\">Precedence and Association Rules</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86E67\"></a> <span class=\"char_link\"><a href=\"GUID-296A15F5-AE95-4D2A-9775-D8B730AF2A23.htm\">Polymorphism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-4C706E8C-89D4-4E39-8F28-F1BAB50D2C47.htm\">Math Assignment </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-7D83837E-8ACC-4B4F-A9E1-DBA71C59C950.htm\">Precedence and Association Rules </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-296A15F5-AE95-4D2A-9775-D8B730AF2A23.htm\">polymorphism </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";