var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D2A6D67D-60D6-4068-80E2-7C16496213CF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"command panels\">\n      <meta name=\"indexterm\" content=\"variables - 3ds Max system globals\">\n      <meta name=\"indexterm\" content=\"suspendEditing()\">\n      <meta name=\"indexterm\" content=\"setCommandPanelTaskMode()\">\n      <meta name=\"indexterm\" content=\"resumeEditing()\">\n      <meta name=\"indexterm\" content=\"getCommandPanelTaskMode()\">\n      <meta name=\"indexterm\" content=\"CUI Struct\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Command Panels</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D2A6D67D-60D6-4068-80E2-7C16496213CF\"></a><div class=\"head\">\n            <h1>Command Panels </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E51\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E50\"></a>      The following methods are used to get or set the active command panel: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E73\"></a><pre><em class=\"codeEmphasisStrong\">setCommandPanelTaskMode</em> [<em class=\"codeEmphasisStrong\">mode</em>:]&lt;panel_name&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E48\"></a>Sets the specified command panel as active. The valid <span class=\"code\"> <em class=\"strong\">panel_name</em> </span> values are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E72\"></a><pre><em class=\"codeEmphasisStrong\">#create </em>-- Create Panel\n<em class=\"codeEmphasisStrong\">#modify </em>-- Modify Panel\n<em class=\"codeEmphasisStrong\">#hierarchy </em>-- Hierarchy Panel\n<em class=\"codeEmphasisStrong\">#motion </em>-- Motion Panel\n<em class=\"codeEmphasisStrong\">#display </em>-- Display Panel\n<em class=\"codeEmphasisStrong\">#utility </em>-- Utility Panel</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E41\"></a>The syntax of <span class=\"code\"> <em class=\"strong\">SetCommandPanelTaskMode</em> </span> was modified in <em class=\"strong\">3ds Max 7</em> so that the panel name to switch to can either be specified as the mode keyword argument,\n               or simply as the argument to the method. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E40\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E3F\"></a><p class=\"table-body\"> <em class=\"strong\">The following expressions are equivalent:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E71\"></a><pre>\nsetCommandPanelTaskMode #modify\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E70\"></a><pre>\nsetCommandPanelTaskMode mode:#modify\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6F\"></a><pre><em class=\"codeEmphasisStrong\">getCommandPanelTaskMode</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E36\"></a>Returns the current command panel as a name value. The name values correspond to the\n               <span class=\"code\"> <em class=\"strong\">panel_name</em> </span> values for <span class=\"code\"> <em class=\"strong\">SetCommandPanelTaskMode()</em> </span>. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6E\"></a><pre><em class=\"codeEmphasisStrong\">suspendEditing which</em>:&lt;panel_name&gt; \n<em class=\"codeEmphasisStrong\">alwaysSuspend</em>:&lt;bool&gt;\n<em class=\"codeEmphasisStrong\">resumeEditing which</em>:&lt;panel_name&gt; \n<em class=\"codeEmphasisStrong\">alwaysSuspend</em>:&lt;bool&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E32\"></a>Suspend/resume rollout display in the command panels. The <span class=\"code\"> <em class=\"strong\">panel_name</em> </span> values are as described for the <span class=\"code\"> <em class=\"strong\">setCommandPanelTaskMode</em> </span> command. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E31\"></a>If <span class=\"code\"> <em class=\"strong\">which</em> </span>: is not specified, all panels are suspended or resumed. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E30\"></a>If <span class=\"code\"> <em class=\"strong\">alwaysSuspend</em> </span>: is true (default is true), the panel is suspended even if the panel is not selected\n               when the command is run. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E2F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E2E\"></a><p class=\"table-body\"> <em class=\"strong\">NOTES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E2D\"></a><p class=\"table-body\">Only Modify, Hierarchy, and Motion panels support suspend/resume. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E2C\"></a><p class=\"table-body\">If the steps between the SuspendEditing and the ResumeEditing can throw an exception,\n                           the steps <em class=\"strong\">should</em> be performed in a try/catch so that the editing state can be properly restored. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E2A\"></a>The following <em class=\"strong\">3ds Max</em> system global variables are associated with the command panel: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6D\"></a><pre><em class=\"codeEmphasisStrong\">cui.commandPanelOpen</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E27\"></a>Lets you get and set whether the command panel is displayed. A Boolean value - <span class=\"code\"> <em class=\"strong\">true</em> </span> if the command panel is displayed, <span class=\"code\"> <em class=\"strong\">false</em> </span> if not displayed. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E26\"></a>Specific methods and <em class=\"strong\">3ds Max</em> global variables are associated with the Create and Modify panels. These methods\n               and global variables are described in the following topics: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E25\"></a> <span class=\"char_link\"><a href=\"GUID-D8CBACCF-73B3-41DF-9A2D-031CED757371.htm\">Create Panel</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E24\"></a> <span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";