var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D37202D3-0E64-4A15-B737-9FA0D22A3C5B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"undefined value\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Undefined Value</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D37202D3-0E64-4A15-B737-9FA0D22A3C5B\"></a><div class=\"head\">\n            <h1>Undefined Value </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EF2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EF1\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"\">Special Data Values</a></span> &gt; Undefined Value \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EEF\"></a>The <em class=\"strong\">Undefined</em> class implements the value used in uninitialized variables and array members. \n         </p>\n         <p><a name=\"P_2FCF32F4856F4AD8B1276734C46A4A85\"></a>There is one distinguished instance of the <em class=\"strong\">Undefined</em> class in the reserved system variable <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n         </p>\n         <p><a name=\"P_CAFF7F45042C45BC9B551DB4DA2EC129\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EEE\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EDD\"></a><pre><em class=\"codeEmphasisStrong\">undefined</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EEB\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EEA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EDC\"></a><pre>\nMyLight = Targetspot pos:[10,20,100] target:(box())\n-- check to see if MyLight has a target\nif MyLight.target != undefined then\n-- distance from light to target\ndist=distance MyLight.pos MyLight.target.pos\nelse\n-- distance from light to [0,0,0]\ndist=length MyLight.pos\n-- set CH_Hand1 to undefined so can test later to see if deleted\n--deleteChangeHandler CH_Hand1; CH_Hand1=undefined\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EDC\"></a> <span class=\"char_link\"><a href=\"GUID-EF3AB642-73A1-4ED3-917B-0DC74FC20D72.htm\">MAXScript FAQ: What is the difference between \'undefined\' and \'unsupplied\' values?</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EDB\"></a> <span class=\"char_link\"><a href=\"GUID-5A0FC656-A2EC-4F0C-8E75-9FF9ADD4261C.htm\">Unsupplied Value</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7EDA\"></a> <span class=\"char_link\"><a href=\"\">Special Data Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";