var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"syntax definitions in this document\">\n      <meta name=\"indexterm\" content=\"syntax\">\n      <meta name=\"indexterm\" content=\"definitions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Syntax Definitions in This Document</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5\"></a><div class=\"head\">\n            <h1>Syntax Definitions in This Document </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C91\"></a>   The ways you can write MAXScript tokens and clauses are given using a set of shorthand\n            rules as shown in the following example: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638F\"></a><pre>[<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}[<em class=\"codeEmphasisStrong\">.</em>{&lt;digit&gt;}][(<em class=\"codeEmphasisStrong\">e</em>|<em class=\"codeEmphasisStrong\">E</em>)[<em class=\"codeEmphasisStrong\">+</em>|<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}+]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C97\"></a>These rules, or <em class=\"mild\">syntax definitions</em>, follow the standard EBNF notation (Extended Backus-Naur Form). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C98\"></a>The previous example shows the syntax for a decimal number in MAXScript. The rules\n            typically contain a number of characters with special meanings. For example, brackets\n            enclose optional items, such as the minus sign in front of the number. Braces enclose\n            items you can use repeatedly, and bars separate multiple items from which you can\n            choose one. Sometimes, rules are given names so they can be referred to in the documentation\n            or as parts of other rules. The special characters in the rules have the following\n            meaning: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C99\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C9A\"></a><p class=\"table-body\"> <em class=\"strong\">Characters</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C9B\"></a><p class=\"table-body\"> <em class=\"strong\">Meaning</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">[...]</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C9D\"></a><p class=\"table-body\">items inside the brackets are optional </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">(...|...|...)</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C9F\"></a><p class=\"table-body\">choose one of the items separated by the bars </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">{...}</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CA1\"></a><p class=\"table-body\">you can specify the braced item ZERO or more times </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">{...}+</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CA3\"></a><p class=\"table-body\">you can specify the braced item ONE or more times </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">::=</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CA5\"></a><p class=\"table-body\">define a name for a syntax rule </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">&lt;rule&gt;</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CA7\"></a><p class=\"table-body\">you can insert what is defined by the named rule </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">bold_characters</em> </span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CA9\"></a><p class=\"table-body\">characters or token as written </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CAB\"></a>The previous number syntax example is interpreted as follows: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CAC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CAD\"></a><p class=\"table-body\"> <em class=\"strong\">Syntax</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CAE\"></a><p class=\"table-body\"> <em class=\"strong\">Definition</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">[<em class=\"strong\">-</em>]{&lt;digit&gt;}</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB0\"></a><p class=\"table-body\">an optional minus sign (the sign), followed by 0 or more digits (the integer part),\n                        followed by \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">[<em class=\"strong\">.</em>{&lt;digit&gt;}]</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB2\"></a><p class=\"table-body\">an optional sequence (the fraction part) comprised of: a period character, followed\n                        by 0 or more digits, followed by \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">[(<em class=\"strong\">e</em>|<em class=\"strong\">E</em>)[<em class=\"strong\">+</em>|<em class=\"strong\">-</em>]{&lt;digit&gt;}+]</span> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB4\"></a><p class=\"table-body\">an optional sequence (the exponent part) comprised of: either an ’r;e’ or ’r;E’, followed\n                        by an optional plus or minus sign, followed by one or more digits. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB5\"></a>Examples of valid numbers are: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CB7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES OF VALID NUMBERS ARE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638E\"></a><pre>\n123\n1.456\n-0.89e-7\n1.536E23\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CBF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CC0\"></a><p class=\"table-body\"> <em class=\"strong\">THE FOLLOWING NUMBERS ARE NOT VALID:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638D\"></a><pre>\n12x34\n-0.45x10^3\n0e\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CC7\"></a>The syntax definitions in <span class=\"char_link\"><a href=\"GUID-46ECBAD7-35E9-43BD-8A8C-849772924805.htm\">MAXScript Grammar</a></span> are in the form of named rule definitions. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CC8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CC9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638C\"></a><pre>number ::= [<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}[<em class=\"codeEmphasisStrong\">.</em>{&lt;digit&gt;}](<em class=\"codeEmphasisStrong\">e</em>|<em class=\"codeEmphasisStrong\">E</em>)[<em class=\"codeEmphasisStrong\">+</em>|<em class=\"codeEmphasisStrong\">-</em>]{&lt;digit&gt;}+]</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CCD\"></a><p class=\"table-body\">allowing the rule to be referred to by name in other rules in the grammar. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CCE\"></a><p class=\"table-body\"> <em class=\"strong\">AN EXAMPLE OF SUCH RULE IS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-638B\"></a><pre><em class=\"codeEmphasisStrong\">mod</em> &lt;number1&gt; &lt;number2&gt;</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CD2\"></a><p class=\"table-body\">modulo arithmetic, the remainder when<span class=\"code\"> &lt;number1&gt; </span>is divided by <span class=\"code\"> &lt;number2&gt; </span> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CD4\"></a>Some definitions throughout this document also use the convention of showing alternative\n            definitions for a rule on consecutive lines instead of separating them with the \'<span class=\"code\"> <em class=\"strong\">|</em> </span>\' symbol. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-10373DCE-57EA-49B2-A66D-1C7320A6EA0F.htm\">Index vs Integer Function Arguments </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";