var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D4094A36-8F1F-4564-8F2C-1C3B2630F3BF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Custom_LPE: RenderElement\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Custom_LPE : RenderElement</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D4094A36-8F1F-4564-8F2C-1C3B2630F3BF\"></a><div class=\"head\">\n            <h1>Custom_LPE : RenderElement</h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Custom_LPE - superclass: RenderElement; super-superclass:MAXWrapper - 6:0 - classID: #(733032594, 560299706)</em></pre></div>\n         <p><a name=\"GUID-B561B9A6-021D-44F2-835A-045D1082BF27\"></a> The Custom_LPE RenderElement is used to output a custom pass from the iRay renderer.\n            Other than the rest of the iRay Render Elements, the <span class=\"code\"> <em class=\"strong\">.lpeName</em> </span> property specifying the Light Path Expression string is not pre-defined and has to\n            be set to a valid regular expression to create a valid Render Element. Available in\n            <em class=\"strong\">3ds Max 2015 and higher</em>. \n         </p>\n         <p><a name=\"GUID-DCF6B263-0D0C-4637-A5DB-B1AF5C6C2345\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-FAC62B76-FFC4-440D-9830-F2CA16BA01B3\"></a> <em class=\"strong\">Constructors:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Custom_LPE... \nirayCustom...</em></pre></div>\n         <p><a name=\"GUID-B1E49CED-3E2E-43C5-832B-F9C98DD9240F\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">atmosphereOn</em>     BooleanClass    default: true   --  boolean</pre></div>\n         <p><a name=\"GUID-FCAE8F20-B514-456F-9FB0-A929C09257C6\"></a>Get/set whether to include atmospheric effects in the Render Element. \n         </p>\n         <p><a name=\"GUID-0B031745-06C0-4636-BFE8-F806178C8358\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">bitmap</em>     UndefinedClass    default: undefined   --  bitmap</pre></div>\n         <p><a name=\"GUID-6BA34118-E156-45C6-9670-0CF670134F16\"></a>Contains the Render Element\'s internal bitmap. \n         </p>\n         <p><a name=\"GUID-25597E39-AED4-4FDD-A913-EE1C63D5C1AF\"></a>Read-only. \n         </p>\n         <p><a name=\"GUID-F18A3A52-894D-42B9-AA41-2ED4FCD8298F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">elementName</em>     String    default: \"Custom LPE\"   --  string</pre></div>\n         <p><a name=\"GUID-A8B9B39C-009C-44EB-8BB3-64BABADC6434\"></a>Get/set the name of the Render Element. \n         </p>\n         <p><a name=\"GUID-52B79758-57C2-448B-A623-706712AF44C4\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">enabled</em>     BooleanClass    default: true   --  boolean</pre></div>\n         <p><a name=\"GUID-C782BB68-9996-42A6-BB48-7F3508F1F901\"></a>Get/set the enabled state of the Render Element. \n         </p>\n         <p><a name=\"GUID-A22C580F-D75C-4ACE-8D6E-3E49EC9B65FB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">filterOn</em>     BooleanClass    default: true   --  boolean; FilteringOn</pre></div>\n         <p><a name=\"GUID-02304477-F3AD-46F6-A7B3-554CD75006AB\"></a>Get/set the state of the Render Element\'s filter option. \n         </p>\n         <p><a name=\"GUID-2E805476-9EF2-4824-8AA7-8EA2D677BF7F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Custom_LPE&gt;.<em class=\"codeEmphasisStrong\">lpeName</em>     String    default: \"\"   --  string; LPE</pre></div>\n         <p><a name=\"GUID-7F7F113E-6BE2-478F-AEAD-EF40FB1BF389\"></a>Get/set the Light Path Expression string of the Render Element. \n         </p>\n         <p><a name=\"GUID-DF6AB57F-ACCF-420B-BA16-721CC3AB25AF\"></a>The Light Path Expression is a Regular Expression which controls which light transport\n            paths to include in the Render Element\'s output. \n         </p>\n         <p><a name=\"GUID-1FB55BD7-1CBE-40D9-856D-8BCA5206BF50\"></a>By default, the Custom LPE Render Element does not output any data unless this property\n            is set to a valid Regular Expression! \n         </p>\n         <p><a name=\"GUID-D97540E2-D5CB-4353-AF8C-A598807A61FF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";