var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D44D0019-FDEC-4826-ACAA-8C1C44E6CF7D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"modifying existing NURBS objects\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifying Existing NURBS Objects</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D44D0019-FDEC-4826-ACAA-8C1C44E6CF7D\"></a><div class=\"head\">\n            <h1>Modifying Existing NURBS Objects </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48CD\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48CC\"></a> The classes can also be used to modify the properties of existing NURBS objects in\n               the scene. To gain access to an internal <em class=\"strong\">3ds Max</em> NURBS object, you must have the data copied into a NURBSSet. This is done using the\n               node method <span class=\"code\"> <em class=\"strong\">getNURBSSet()</em> </span>. You can then use the methods of the NURBSSet to access the objects. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48CA\"></a>For example, the following sample code attempts to grab the first NURBS sub-object\n               from the first node in the current selection set. It then checks if it is a blend\n               surface and if so, adjusts one of the tension parameters. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48C9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48C8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22CE\"></a><pre>\n-- get the first node in selection\nnode = selection[1];\n-- make sure creation has been completed on the node\nstopCreating node\n-- get the nurbs set for it\ngetSet = getNURBSSet node #relational\n-- extract the first obj, check class &amp; set tension\nobj = getObject getSet 1\nif classOf obj == NURBSBlendSurface then obj.tension1 = 2.0\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48BB\"></a>The type of modifications that you can perform in this way are limited to changing\n               those parameters and properties that do not alter the <em class=\"strong\">structure</em> of the NURBS scene object. You can modify point and CV positions, CV weights, and\n               dependent object parameters such as, offsets and extrude amounts. You cannot add or\n               delete objects, change the number of CVs or knots or parent curves, and so on. To\n               do this kind of structural modification, use the <span class=\"code\"> <em class=\"strong\">appendObject()</em> </span>, <span class=\"code\"> <em class=\"strong\">setObject()</em> </span>, and <span class=\"code\"> <em class=\"strong\">removeObject()</em> </span> functions defined in <span class=\"char_link\"><a href=\"GUID-B5D639EF-BC99-448C-B737-A8347EBD6250.htm\">NURBSSet : Value</a></span> and the <span class=\"code\"> <em class=\"strong\">addNURBSSet()</em> </span>, <span class=\"code\"> <em class=\"strong\">breakSurface()</em> </span>, and similar functions defined in <span class=\"char_link\"><a href=\"GUID-8E66EBA2-CD22-41DB-8F26-6A961B0F7018.htm\">NURBS Node Properties and Methods</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48BA\"></a>The <span class=\"code\"> <em class=\"strong\">stopCreating()</em> </span> method is used to ensure that the specified node is fully created. This method is\n               primarily used to ensure that a NURBS scene object is fully created, which it will\n               not be until the creation is stopped. The NURBSSet returned for a NURBS scene object\n               will not be complete if the object is still in creation mode. This method will also\n               deactivate any activated object create buttons in the Create panel. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B9\"></a>There are other global functions that might be used to modify NURBS scene objects.\n               These functions are documented in <span class=\"char_link\"><a href=\"GUID-8E66EBA2-CD22-41DB-8F26-6A961B0F7018.htm\">NURBS Node Properties and Methods</a></span>. For instance, developers can use the function <span class=\"code\"> <em class=\"strong\">breakSurface()</em> </span> to take an existing NURBS surface and break it into two separate surfaces. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B8\"></a> <em class=\"strong\">Non-relational NURBSSets</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B7\"></a>You can also use the <span class=\"code\"> <em class=\"strong\">getNURBSSet()</em> </span> function in a non-relational mode, but not supplying the <span class=\"code\"> <em class=\"strong\">#relational</em> </span> argument to retrieve a \"flattened\" version of the NURBSSet in which all dependent\n               surfaces such as, blends, offsets, and lofts are represented as independent curves\n               and surfaces, and there is no \'live\' connection back to the scene object from which\n               the NURBSSet was derived. You might use this to get a simplified version of the NURBS\n               scene object for an export script. For example, if the destination system does not\n               support relational objects. You can also use a non-relational NURBSSet derived in\n               this way as the basis for creating other scene objects such as, modifying or adding\n               to the set and then re-instantiating it with the <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span> function. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";