var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D4660B55-E229-4155-9B4B-EE13178D4E8D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"sticky contexts\">\n      <meta name=\"indexterm\" content=\"set context\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Sticky Contexts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D4660B55-E229-4155-9B4B-EE13178D4E8D\"></a><div class=\"head\">\n            <h1>Sticky Contexts </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87177\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87178\"></a>   You can force the settings of contexts such as, <span class=\"code\"> <em class=\"strong\">coordsys</em> </span>, <span class=\"code\"> <em class=\"strong\">animate</em> </span>, <span class=\"code\"> <em class=\"strong\">time</em> </span>, and so on to be \"sticky.\" \n            </p> \n            <p><a name=\"P_A9C47C9E6DF246B593E922ACE5A475D4\"></a>The settings will stay active for any code execution that follows until the point\n               you change them or override them with a context prefix for an expression. \n            </p> \n            <p><a name=\"P_3A0BF2AC5DC442B7B9453DE2CAB24C41\"></a>This is particularly useful when working in the Listener, allowing you to set a context\n               and then perform several interactive operations in that context without prefixing\n               each with the desired context construct. \n            </p> \n            <p><a name=\"P_BA1D8869349945A3B3700A5B7AB86F9A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8717C\"></a>Establishing a sticky context is accomplished with the <span class=\"code\"> <em class=\"strong\">set</em> </span> construct: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CD\"></a><pre><em class=\"codeEmphasisStrong\">set</em> &lt;context&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8717E\"></a>Where, <span class=\"code\">&lt;context&gt;</span> is one of the MAXScript context prefixes: <span class=\"code\"> <em class=\"strong\">animate</em> </span>, <span class=\"code\"> <em class=\"strong\">time</em> </span>, <span class=\"code\"> <em class=\"strong\">in</em> </span>, <span class=\"code\"> <em class=\"strong\">coordsys</em> </span>, <span class=\"code\"> <em class=\"strong\">about</em> </span>, <span class=\"code\"> <em class=\"strong\">level</em> </span>, or <span class=\"code\"> <em class=\"strong\">undo</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87180\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87181\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CC\"></a><pre>\nb=box()\ns=sphere()\nc=cylinder()\naddModifier c (bend angle:30)\nset animate on\nset time 30f\nmove b [80,0,0]\nscale s [1,1,3]\nc.bend.angle += 23\n--...\nset animate off\nset time off\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8718D\"></a>This turns animate on and sets the current time to frame 30 after which any number\n               of interactive operations can be performed that will generate animation at frame 30.\n               \n            </p> \n            <p><a name=\"P_BD2D94F862654C40959FE725B96067D7\"></a>The modes are then returned to default. \n            </p> \n            <p><a name=\"P_63939A62E15049AEBAB3D27D128C7D4E\"></a>As shown in this example, certain MAXScript contexts permit syntactic variants to\n               make the set construct read clearly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8718E\"></a> <em class=\"strong\">In particular, these are:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CB\"></a><pre><em class=\"codeEmphasisStrong\">set time</em> &lt;value&gt; | <em class=\"codeEmphasisStrong\">off</em> -- variant of at time &lt;time&gt;   </pre></div> \n            <p><a name=\"P_24A88F61561D459096A00A71A855C726\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60CA\"></a><pre><em class=\"codeEmphasisStrong\">set level</em> &lt;node&gt; -- variant of at level &lt;node&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87191\"></a>The time context can be set to <span class=\"code\"> <em class=\"strong\">off</em> </span>, signifying the current value of the <em class=\"strong\">3ds Max</em> time slider is to be used. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87192\"></a>All the <span class=\"code\"> <em class=\"strong\">set</em> </span> constructs are expressions that yield the context setting that <em class=\"strong\">was in force</em> at the time the new context was set. \n            </p> \n            <p><a name=\"P_32C0E8BE7F6B4647872D5C26DFA53C9E\"></a>This allows you to simulate the standard nested forms of these constructs by storing\n               the old context in a variable and using that to restore the context later. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87193\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87194\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C9\"></a><pre>\noc = set coordsys parent -- remember old coordsys\nrotate $foo (quat 30 z_axis)\n...\nset coordsys oc -- restore it\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8719C\"></a>You can also force several of the contexts back to their default states by specifying\n               <span class=\"code\"> <em class=\"strong\">#default</em> </span> as their parameter. \n            </p> \n            <p><a name=\"P_D748934D8F4C45EBB3699E27A631BE89\"></a>The <span class=\"code\"> set </span> constructs for which you can specify <span class=\"code\"> <em class=\"strong\">#default</em> </span> are: <span class=\"code\"> <em class=\"strong\">animate</em> </span>, <span class=\"code\"> <em class=\"strong\">in</em> </span>, <span class=\"code\"> <em class=\"strong\">coordsys</em> </span>, and <span class=\"code\"> <em class=\"strong\">level</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8719D\"></a>When using the <span class=\"code\"> <em class=\"strong\">set undo on</em> </span> construct to enable the undoing of scripted changes in the Listener, undo granularity\n               is a top-level expression. \n            </p> \n            <p><a name=\"P_A6152DB4850F4A3D8180A178835BC437\"></a>Each time you evaluate an expression or sequence of selected expressions with the\n               <span class=\"code\"> <em class=\"strong\">ENTER</em> </span> or <span class=\"code\"> <em class=\"strong\">Number-Pad ENTER</em> </span> key, a single entry is added to the Undo stack. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";