var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D62ADC40-0FEB-42FC-AD97-0C6BC5BD383E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"setIndent() - listview\">\n      <meta name=\"indexterm\" content=\"Listview ActiveX functions\">\n      <meta name=\"indexterm\" content=\"hittest() - listview\">\n      <meta name=\"indexterm\" content=\"getIndent() - listview\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Listview ActiveX functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D62ADC40-0FEB-42FC-AD97-0C6BC5BD383E\"></a><div class=\"head\">\n            <h1>Listview ActiveX functions </h1>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-759F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4869\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                  Windows operating system in favor of the \n                  		  <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n               </p>  \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4867\"></a>As a replacement of ActiveX controls, MAXScript supports \n                  		  <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in \n                  		  <em class=\"strong\">3ds Max 9 and higher</em>. \n                  		\n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4868\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                  on the system to be accessible to MAXScript. \n                  		\n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4866\"></a>See the topic \n                  		  <span class=\"char_link\"><a href=\"GUID-25E15114-B1F5-4C62-8E84-C630C15E92BB.htm\">Converting ActiveX ListView Control to DotNet ListView Control</a></span> for an example of switching existing ActiveX code to DotNet. \n                  		\n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4863\"></a>The following additional functions packaged in a structure called \n            		<em class=\"strong\">ListView</em> work in conjunction with the \n            		<span class=\"char_link\"><a href=\"GUID-0C6E7C77-A065-4602-9930-4FE275AE3B9A.htm\">ListView ActiveX Control</a></span>. All functions need to be passed the windows handle, which can be acquired with the\n            \n            		<span class=\"code\"> <em class=\"strong\">.hWnd</em> </span> property of the ActiveX control. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-709C\"></a><pre><em class=\"codeEmphasisStrong\">Listview.hittest</em> &lt;hWnd&gt; &lt;point2_pos&gt; applyUIScaling:&lt;true&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4861\"></a>Returns an array of listitem index and the subItem index, subItem index is 0 only\n            when the listItem is hittested. The Point2 value is expected in Pixels, NOT twips.\n            The \n            		<span class=\"code\">applyUIScaling</span> parameter indicates whether to apply UI scaling on high-DPI displays.\n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-709B\"></a><pre><em class=\"codeEmphasisStrong\">Listview.getIndent</em> &lt;hWnd&gt; &lt;index&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-485E\"></a>Returns the indent of the indexed listitem. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-709A\"></a><pre><em class=\"codeEmphasisStrong\">Listview.setIndent</em> &lt;hWnd&gt; &lt;index&gt; &lt;int_indent&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-485B\"></a>Sets the indent of the indexed listitem. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4858\"></a> <span class=\"char_link\"><a href=\"GUID-0C6E7C77-A065-4602-9930-4FE275AE3B9A.htm\">ListView ActiveX Control</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4857\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4856\"></a> <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              One</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4855\"></a> <span class=\"char_link\"><a href=\"GUID-C9BD442F-7B4E-42F6-92CC-31B2DEE9E4FB.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              Two</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";