var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D7747871-6C5D-46FD-97A5-5A6A67585E1A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"convertToSplineShape()\">\n      <meta name=\"indexterm\" content=\"canConvertTo()\">\n      <meta name=\"indexterm\" content=\"convertTo()\">\n      <meta name=\"indexterm\" content=\"convertToNURBSSurface()\">\n      <meta name=\"indexterm\" content=\"convertToNURBSCurve()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Conversion Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D7747871-6C5D-46FD-97A5-5A6A67585E1A\"></a><div class=\"head\">\n            <h1>Node Conversion Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D56\"></a><pre><em class=\"codeEmphasisStrong\">convertToMesh</em> &lt;node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33B8\"></a>This function converts appropriate scene object types into Editable Meshes. It is\n            similar to \n            		<span class=\"code\"> <em class=\"strong\">collapseStack()</em> </span> in that it will remove all modifiers present, but unlike \n            		<span class=\"code\"> <em class=\"strong\">collapseStack()</em> </span> it will \n            		<em class=\"strong\">always</em> replace the base object with an editable mesh version, even if there are no modifiers\n            present. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33B7\"></a> <span class=\"code\"> <em class=\"strong\">convertToMesh()</em> </span> can be applied to any object that an Edit Mesh modifier can work on such as, geometry\n            and shapes, but not helpers, space warps, lights, and so on. If the object cannot\n            be converted, the function returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_754230BE6B43428BA20DDA01C23A33BC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D55\"></a><pre><em class=\"codeEmphasisStrong\">convertToSplineShape</em> &lt;node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33B4\"></a>Converts the given scene node to a SplineShape object. If the object cannot be converted\n            (typically, if it is not a shape), the function returns \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. Any modifiers present will be collapsed. The \n            		<span class=\"code\"> <em class=\"strong\">collapseStack()</em> </span> function can also be used as well as the collapse button in the modifier stack dialog\n            in \n            		<em class=\"strong\">3ds Max</em>; both generate a SplineShape, but will only do so if there is at least one modifier\n            present. \n         </p>\n         <p><a name=\"P_FEDCCE54CF834B299B9647CDA40444B8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D54\"></a><pre><em class=\"codeEmphasisStrong\">canConvertTo</em> &lt;node&gt; &lt;class&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33B1\"></a>Allows you to test whether a given node is convertible into a given class. Returns\n            \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33B0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33AF\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D53\"></a><pre>\nif canConvertTo $foo NURBSSurface then...\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33AB\"></a>The kind of classes you can convert objects to are the generic editable forms including\n            Mesh, SplineShape, NURBSCurve, NURBSSurface, and others. \n            	 \n         </p>\n         <p><a name=\"P_8D9EF4E5FB88480BA9EE2EC0FD3EA21A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D52\"></a><pre><em class=\"codeEmphasisStrong\">convertTo</em> &lt;node&gt; &lt;class&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33A8\"></a>This function is a general form of the existing specific conversion functions such\n            as, \n            		<span class=\"code\"> <em class=\"strong\">convertToMesh()</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">convertToSplineShape()</em> </span>, and so on. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33A7\"></a> <span class=\"code\"> <em class=\"strong\">convertToSplineShape()</em> </span> can be written as: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33A6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33A5\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D51\"></a><pre>\nconvertTo $circle001 SplineShape\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-33A1\"></a>If the conversion is not supported, the function returns the value \n            		<em class=\"strong\">undefined</em>. \n            	 \n         </p>\n         <p><a name=\"P_1D39A9098EFD46EEA720A253B01AD1D4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D50\"></a><pre><em class=\"codeEmphasisStrong\">convertToNURBSSurface</em> &lt;node&gt; -- mapped \n<em class=\"codeEmphasisStrong\">convertToNURBSCurve</em> &lt;node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-339C\"></a>These functions work on those primitive geometry and shape classes that support conversion\n            to NURBS (such as boxes, spheres, circles, lines, and others). If an object does not\n            support conversion, the function returns \n            		<em class=\"strong\">undefined</em>. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";