var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-D8CBACCF-73B3-41DF-9A2D-031CED757371\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"command panels\">\n      <meta name=\"indexterm\" content=\"okToCreate()\">\n      <meta name=\"indexterm\" content=\"isCreatingObject()\">\n      <meta name=\"indexterm\" content=\"Create Panel\">\n      <meta name=\"indexterm\" content=\"startObjectCreation()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Create Panel</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D8CBACCF-73B3-41DF-9A2D-031CED757371\"></a><div class=\"head\">\n            <h1>Create Panel </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E23\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E22\"></a>    The <span class=\"code\"> <em class=\"strong\">startObjectCreation()</em> </span> method is used to simulate the user finding a Create Panel button for a given object\n               class and pressing that button, putting <em class=\"strong\">3ds Max</em> into create mode for that object class. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E1D\"></a> <em class=\"strong\">The form is:</em>  \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6C\"></a><pre><em class=\"codeEmphasisStrong\">startObjectCreation</em> &lt;maxobjclass&gt; [		<em class=\"codeEmphasisStrong\">returnNewNodes</em>:&lt;flag&gt;] [		<em class=\"codeEmphasisStrong\">newNodeCallback</em>:&lt;fn&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E1B\"></a>This method simply opens up the Create Panel at the right tab and category and depresses\n               the appropriate object button. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E1A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E19\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6B\"></a><pre>\nstartObjectCreation box\nstartObjectCreation targetSpot\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E13\"></a>This method is primarily intended for use in macroScripts, but can be used in generalized\n               scripts. Script execution will continue immediately after entering the create mode,\n               and you must ensure that the script does not interfere with the object creation. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E12\"></a>The values that can be supplied to the optional <span class=\"code\"> <em class=\"strong\">returnNewNodes:</em> </span> keyword argument are <span class=\"code\"> <em class=\"strong\">true</em> </span>, <span class=\"code\"> <em class=\"strong\">false</em> </span> (the default) or <span class=\"code\"> <em class=\"strong\">#first</em> </span>. If <span class=\"code\"> <em class=\"strong\">true</em> </span> is supplied, all of the nodes created, up until the current create mode is exited,\n               will be returned in an array. If <em class=\"strong\">#first</em> is supplied, only the first node created is returned, immediately after it is created.\n               The function doesn’t wait for the create mode to be exited by the user. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E11\"></a>The optional <span class=\"code\"> <em class=\"strong\">newNodeCallback:</em> </span> keyword argument can supply a scripted function of one argument to the create mode\n               that is started, such that the function will be called each time a node is created\n               with the new node as its argument. This is similar to supplying <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> filter functions, although the return value of the <span class=\"code\"> <em class=\"strong\">newNodeCallback:</em> </span> function is ignored. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7588\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The callback function is invoked immediately upon new node creation, *before* any\n                  base object is installed in it, so <em class=\"strong\">only node-related properties</em> can be accessed and changed during this callback. \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E0C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E0B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E6A\"></a><pre>\nfn setColor n = n.wireColor= red\nstartObjectCreation box newNodeCallback:setColor\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E06\"></a><p class=\"table-body\">would cause all new boxes created in the started create mode to have red wire color.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E04\"></a>The <span class=\"code\"> <em class=\"strong\">returnNewNodes:</em> </span> and <span class=\"code\"> <em class=\"strong\">newNodeCallback:</em> </span> can both be supplied on the same call; the callback will be called on each node,\n               and they will be returned in an array as the result of the <span class=\"code\"> <em class=\"strong\">startObjectCreation()</em> </span> function. \n            </p> \n            <p><a name=\"GUID-ECDA3AB7-E10A-4139-8A80-0774AB620673\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E69\"></a><pre><em class=\"codeEmphasisStrong\">okToCreate &lt;maxclass&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E03\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified maxclass can be created in the UI, <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. If the argument is undefined, also returns <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E02\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3E01\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E68\"></a><pre>\nokToCreate terrain\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DFD\"></a><p class=\"table-body\">will return <span class=\"code\"> <em class=\"strong\">false</em> </span> unless at least one shape is selected, or if any non-shape is selected. This corresponds\n                           to whether the button for the object is enabled. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-49040352-3316-4A60-A075-66469B36F861\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E67\"></a><pre><em class=\"codeEmphasisStrong\">isCreatingObject</em> [ &lt;maxclass&gt; ] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DFA\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified maxclass is currently being created in the UI, <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DF9\"></a>If called without an argument returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if ANY object is being created in the UI, <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DF8\"></a>In <em class=\"strong\">3ds Max 2010 and higher</em>, also returns <span class=\"code\"> <em class=\"strong\">false</em> </span> if the argument is undefined for consistency with <span class=\"code\"> <em class=\"strong\">okToCreate()</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DF7\"></a>Available in <em class=\"strong\">3ds Max 9</em> and higher. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DF6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DF5\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E66\"></a><pre>\n--go to Create panel, click the Box button and evaluate:\nisCreatingObject Box\ntrue\n--in the Create panel, click on the Cone button and evaluate:\nisCreatingObject Box\nfalse\nisCreatingObject Cone\ntrue\nisCreatingObject()\ntrue\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DE6\"></a> <span class=\"char_link\"><a href=\"GUID-D2A6D67D-60D6-4068-80E2-7C16496213CF.htm\">Command Panels</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DE5\"></a> <span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DE3\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3DE2\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";