var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Adding Custom Attributes\">\n      <meta name=\"indexterm\" content=\"presets\">\n      <meta name=\"indexterm\" content=\"CustomAttributesPresets\">\n      <meta name=\"indexterm\" content=\"Custom_Attributes_Presets\">\n      <meta name=\"indexterm\" content=\"Attribute Holder Modifier\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Adding Custom Attributes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7\"></a><div class=\"head\">\n            <h1>Adding Custom Attributes </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4AA0\"></a> \n            <p><a name=\"GUID-42875FD0-F371-432A-8893-FD752FC1F9F0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-230D\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes.add</em> &lt;object_or_collection&gt; &lt;attributes_definition&gt; [		<em class=\"codeEmphasisStrong\">#unique</em>] [		<em class=\"codeEmphasisStrong\">BaseObject</em>:&lt;bool&gt;] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A9C\"></a>Adds a set of attributes to an object or a collection. You can only add one custom\n               attribute set of a particular attributes definition to an object, but you can have\n               as many different attribute sets from different definitions as needed.&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-5F471C59-D5A2-4B6F-BB68-9C49EF1EC27B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-230C\"></a><pre><em class=\"codeEmphasisStrong\">#unique</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A9A\"></a>When adding custom attributes to an object using the \n               		  <span class=\"code\"> <em class=\"strong\">custAttributes.add()</em> </span> function, you can now supply an optional \n               		  <span class=\"code\"> <em class=\"strong\">#unique</em> </span> keyword as the third argument. If you do this, each object being added to will have\n               custom attributes added that have their own private copy of the definition and do\n               \n               		  <span class=\"code\"> <em class=\"strong\">*not*</em> </span> share the original definition. Any later redefinitions of the original attributes\n               definition will not update these custom attributes. To update the individual object\'s\n               attributes, you would get the unique definition from the object using \n               		  <span class=\"code\"> <em class=\"strong\">custAttributes.getDef</em> </span>, and redefine it in one of the two ways described. \n               		\n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F5B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If you extract the uniquely-added definition, and use it directly in another non-unique\n                  \n                  		  <span class=\"code\"> <em class=\"strong\">custAttributes.add()</em> </span> on some other object, a definition sharing will be set up. Using \n                  		  <span class=\"code\"> <em class=\"strong\">#unique</em> </span> when adding a global definition will make the added custom attributes non-global,\n                  they will have their own private definition which starts out being identical to the\n                  original global definition. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-A83E1E12-B461-4214-B519-BD3430568544\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-230B\"></a><pre><em class=\"codeEmphasisStrong\">BaseObject</em>:&lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A95\"></a>If the optional keyword argument \n               		  <span class=\"code\"> <em class=\"strong\">baseObject</em> </span> is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (the default), in case the object specified is a node, the base object will be operated\n               on. If \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node itself will be operated on. \n               		\n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F5A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>In versions priorto \n                  		  <em class=\"strong\">3ds Max 5.1</em>, the base object was always used. \n                  		\n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A90\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A8F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-230A\"></a><pre>\ncustAttributes.add $weapon01 weaponData\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A8B\"></a><p class=\"table-body\">Opening $weapon01 in the Modify panel will now display the \"Weapon Parameters\" rollout\n                           and allow them to be edited as can normal object parameters. You can use attribute\n                           definitions to add their defined sets of attributes to any object at any time. Any\n                           appropriate type of parameter can be animated, also, exactly as with scripted plug-ins.\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A89\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">custAttributes.add()</em> </span> function can be applied to an object collection to add sets of attributes to a group\n               of objects in one go. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A88\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A87\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2309\"></a><pre>\ncustAttributes.add $weapon* the_weaponData\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A83\"></a><p class=\"table-body\">Adds a separate set of these custom attributes to all objects whose names begin \"weapon\"\n                           in the scene. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F59\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-049788C3-C5BE-4D6C-850C-73E30A868EE9\"></a>Further, an object can have any number of separate sets of custom attributes added\n                     from different attribute definitions. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A7D\"></a>As with \n               		  <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted plug-ins</a></span>, an attributes definition can have any number of sets of parameter and rollout clauses,\n               to allow you to organize added attributes into multiple rollouts as needed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A7C\"></a>Scripted custom attributes added to an object or modifier can be accessedviaMAXScript.\n               They turn up directlyas properties on the objectsthey are added to. If the names of\n               any of the custom attributes are the same as existing properties on the host object,\n               the custom attributes \n               		  <em class=\"strong\">are effectively hidden</em> when accessed directly. As an alternative, you can access each added block of custom\n               attributesby their attributes definition nameand then access individual attributes\n               as properties within that block. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A7B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A7A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A79\"></a><p class=\"table-body\">if the following attributes were added to $box01 \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2308\"></a><pre>\nthe_weaponData = attributes weaponData\n(\nparameters main rollout:params\n(\nhitPoints type: #float ui:hits default:10\ncost type: #float ui:cost default:100\nsound type: #string\n)\nrollout params \"Weapon Parameters\"\n( \n	 spinner hits \"Hit Points\" type: #float\n  spinner cost \"Cost\" type: #float\n  dropdownlist sound_dd \"Sound\" items:# (\"boom\",\"sparkle\",\"zap\",\"fizzle\")\n )\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A6B\"></a><p class=\"table-body\">the custom attributes could be accessed as \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2307\"></a><pre>$box01.<em class=\"codeEmphasisStrong\">hitPoints</em> \n$box01.<em class=\"codeEmphasisStrong\">cost</em> \n$box01.<em class=\"codeEmphasisStrong\">sound</em> </pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A66\"></a><p class=\"table-body\">or indirectly through the attributes block: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2306\"></a><pre>$box01.<em class=\"codeEmphasisStrong\">weaponData.hitPoints</em> \n$box01.<em class=\"codeEmphasisStrong\">weaponData.cost</em> \n$box01.<em class=\"codeEmphasisStrong\">weaponData.sound</em> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> </p> \n            <p><em class=\"strong\">Adding Custom Attributes Presets</em> \n            </p> \n            <p>Custom Attributes Presets can be added to an object using the pre-defined attributes\n               definition \n               		  <span class=\"code\">CustomAttributesPresets</span>, which is defined in the \n               		  <span class=\"filePath\">[3dsmax]\\scripts\\Startup\\CustomAttributes.ms</span> file. This corresponds to the \"Add Presets Options\" checkbox in the \n               		  <em class=\"strong\">Parameter Editor</em> in the 3ds Max UI. \n               		\n            </p> <a name=\"TABLE_F00FE770AB7C410A82BBCCAB9DEB411B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\ncustAttributes.add $weapon* CustomAttributesPresets\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\">Adds Custom Attributes Presets to all objects whose name begins with \"weapon\" in the\n                           scene. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>custAttributes.add $weapon.modifiers[#Attribute_Holder] CustomAttributesPresets</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\">Adds Custom Attributes Presets to the Attribute Holder Modifier on the $weapon object.\n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A60\"></a> <em class=\"strong\">Next Topic:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A5F\"></a> <span class=\"char_link\"><a href=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4.htm\">Global and Private Custom Attributes Definitions</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A5D\"></a> <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Scripted Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A5C\"></a> <span class=\"char_link\"><a href=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559.htm\">Custom Attribute Management Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A5B\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A5A\"></a> <span class=\"char_link\"><a href=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0.htm\">Access to Custom Attributes Virtual Array</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A59\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";