var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"StringStream values\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"free()\">\n      <meta name=\"indexterm\" content=\"print()\">\n      <meta name=\"indexterm\" content=\"format()\">\n      <meta name=\"indexterm\" content=\"readValue()\">\n      <meta name=\"indexterm\" content=\"readLine()\">\n      <meta name=\"indexterm\" content=\"readExpr()\">\n      <meta name=\"indexterm\" content=\"readChars()\">\n      <meta name=\"indexterm\" content=\"readChar()\">\n      <meta name=\"indexterm\" content=\"skipToString()\">\n      <meta name=\"indexterm\" content=\"skipToNextLine()\">\n      <meta name=\"indexterm\" content=\"readDelimitedString()\">\n      <meta name=\"indexterm\" content=\"execute()\">\n      <meta name=\"indexterm\" content=\"filePos()\">\n      <meta name=\"indexterm\" content=\"seek()\">\n      <meta name=\"indexterm\" content=\"eof()\">\n      <meta name=\"indexterm\" content=\"flush()\">\n      <meta name=\"indexterm\" content=\"close()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>StringStream Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6\"></a><div class=\"head\">\n            <h1>StringStream Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7C01\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7C00\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-A2290E77-5392-431D-8B75-F6A1262E9639.htm\">Stream Values</a></span> &gt; StringStream Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BFE\"></a>The \n            		<em class=\"strong\">StringStream</em> class allows you to construct and parse strings using all the text file I/O functions.\n            For example, you can set up a StringStream and build it up by performing prints and\n            formats to it, just as you would to a text file. Conversely, you can convert a String\n            into a StringStream and then work through it using functions like \n            		<span class=\"code\"> <em class=\"strong\">readLine()</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">readValue()</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">skipToString()</em> </span>, etc. Since Strings are easily converted to and from StringStreams, this is often\n            a convenient way to work on large, complex strings. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BFD\"></a>The StringStream class can be used in conjunction with the \n            		<em class=\"strong\">AppData accessing functions</em> for storing and retrieving large and complex amounts of script-generated data permanently\n            \n            		<em class=\"strong\">within</em> a \n            		<em class=\"strong\">3ds Max</em> scene file. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BFC\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E94\"></a><pre><em class=\"codeEmphasisStrong\">stringStream</em> &lt;initial_string&gt; 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BFA\"></a>Create a new StringStream using the initial string. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E93\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\"> as stringStream</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BF8\"></a>Convert existing String to StringStream. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BF7\"></a>See also \n            		<span class=\"char_link\"><a href=\"GUID-7F17449E-C377-445C-AC15-CD3BA88A975B.htm\">String Literals</a></span> and \n            		<span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm\">String Values</a></span>. \n            	 \n         </p>\n         <p><a name=\"GUID-3E5E922C-15B3-4F99-B4BA-BFCCEF6AC7D2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BF6\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E92\"></a><pre>&lt;stringstream&gt; <em class=\"codeEmphasisStrong\">as string</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BF4\"></a>Convert StringStream to a String \n            	 \n         </p>\n         <p><a name=\"GUID-557D9415-42CE-4733-94A6-E667F3065730\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-668D\"></a>  <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E91\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BF1\"></a>Create a separate copy of the StringStream \n            	 \n         </p>\n         <p><a name=\"GUID-B9737BA9-91F4-4ED9-B118-37DBD00E7D1D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FEB\"></a><pre><em class=\"codeEmphasisStrong\">free</em> &lt;stringStream&gt;</pre></div>\n         <p><a name=\"GUID-295A781F-D6A1-45DC-9652-13DFBA37C939\"></a>Frees the memory used by the stringStream value without waiting for garbage collection.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-5A316DFD-5D3C-4467-9731-475EF12701AC\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher</em>. \n            	 \n         </p><a name=\"TABLE_D9348AFEA09043EEBFE35226E3D5AD33\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-BB349400-140D-4FF6-BB6F-565DE648A719\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_FD21F70CB2414BC4B29386B06B2BD4FD\"></a><pre>\nss = stringstream \"ABCDE\"\n--&gt; StringStream:\"ABCDE\"\nss\n--&gt; StringStream:\"ABCDE\"\nfree ss\n--&gt; OK\nss\n--&gt; StringStream:\"\"\n\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-FFCC5451-6385-40D8-8134-A5A3099B4BF4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6689\"></a>   <em class=\"strong\">Associated Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E90\"></a><pre><em class=\"codeEmphasisStrong\">print</em> &lt;value&gt; <em class=\"codeEmphasisStrong\">to</em>:&lt;stringstream&gt; </pre></div>\n         <p><a name=\"GUID-F7BDFB2D-F4FA-4A44-BF56-55E11B6423E5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8F\"></a><pre><em class=\"codeEmphasisStrong\">format</em> \"&lt;fmt_string&gt;\" {values}<em class=\"codeEmphasisStrong\"> to</em>:&lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BEB\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">print()</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">format()</em> </span> functions provide a way to build up a StringStream a piece at a time. As with text\n            file output, each call to print or format appends to existing text, the StringStream\n            dynamically grows as needed. Note that you can reposition output streaming using the\n            \n            		<span class=\"code\"> <em class=\"strong\">seek()</em> </span> function documented below. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BEA\"></a>The following functions are identical to the text file input functions available for\n            text FileStream values. (See the \n            		<span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">FileStream Values</a></span> class documentation). When called on StringStream instances, they read progressively\n            through the string extracting successive values and lines and characters, etc. \n         </p>\n         <p><a name=\"GUID-1D795593-B7F2-4225-BCF8-B2F4006854EB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_1F7DFFABC92745DC817664B275B76C69\"></a><pre>&lt;stringstream&gt;<em class=\"codeEmphasisStrong\">append</em> &lt;stringstream&gt; &lt;string&gt;</pre></div>\n         <p><a name=\"GUID-A80B76F1-051C-45F8-8B23-1FA436AF957B\"></a> Appends the string passed as second argument to the stringstream provided as first\n            argument. \n            	 \n         </p>\n         <p><a name=\"GUID-0D50D289-5E31-4CF4-B80C-A48700478D60\"></a>It operates on the stringstream in place, and also returns the resulting stringstream.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-D1A20397-8922-4CF2-A1DF-074E6890B00B\"></a>Available in \n            		<em class=\"strong\">3ds Max 2012 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-09175155-D650-4A5D-A4DC-8F4DBFFCFC2C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8E\"></a><pre><em class=\"codeEmphasisStrong\">readValue</em> &lt;stringstream&gt; [ <em class=\"codeEmphasisStrong\">ignoreStringEscapes</em>:&lt;boolean&gt; ] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BE8\"></a>Read and evaluate the next MAXScript \n            		<span class=\"code\"> <em class=\"strong\">&lt;operand&gt;</em> </span> from the stringStream. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BE7\"></a>If the optional \n            		<span class=\"code\"> <em class=\"strong\">ignoreStringEscapes:</em> </span> keyword argument is not supplied or supplied as false and the value read is a string,\n            \'\\\' characters in the string are handled as escape characters. If true, \'\\\' characters\n            in the string are not handled as escape characters. This option is available in \n            		<em class=\"strong\">3ds Max 8 and higher</em>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BE6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BE5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8D\"></a><pre>\nss = stringstream \"\\\"a\\\\tb\\\"\"\nseek ss 0\nreadvalue ss\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BDF\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8C\"></a><pre>\n\"a b\" -- \\t handled as a tab\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BDB\"></a><p class=\"table-body\"> <em class=\"strong\">BUT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8B\"></a><pre>\nseek ss 0\nreadvalue ss ignoreStringEscapes:true\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BD6\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E8A\"></a><pre>\n\"a\\t\\b\" -- \\t handled as characters\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-7747231A-F13E-436A-8386-8F3B35EAEE2B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E89\"></a><pre><em class=\"codeEmphasisStrong\">readExpr</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BCC\"></a>Read and evaluate the next MAXScript \n            		<span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> from the stringStream. As with \n            		<span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FEB\">execute(),</a></span> the scope of the evaluation is the global scope, not the current scope. \n         </p>\n         <p><a name=\"GUID-BA272F4B-6AAC-4D8E-873A-42DD6DEAF492\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E88\"></a><pre><em class=\"codeEmphasisStrong\">readLine</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BC9\"></a>Read next line, return as string \n            	 \n         </p>\n         <p><a name=\"GUID-92D304AA-C8D2-4A86-82B2-2D1953509937\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E87\"></a><pre><em class=\"codeEmphasisStrong\">readChar</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BC6\"></a>Read next char, return as string \n            	 \n         </p>\n         <p><a name=\"GUID-7C4F0CAC-C768-4BB3-A952-D9DF1C9280EA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E86\"></a><pre><em class=\"codeEmphasisStrong\">readChars</em> &lt;stringstream&gt; &lt;number&gt; errorAtEOF:&lt;bool&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BC3\"></a>Reads the specified number of characters and returns them in a string. \n            	 \n         </p>\n         <p>When the \n            		<span class=\"code\">errorAtEOF</span> parameter is \n            		<em class=\"strong\">false</em>, this method does not throw an exception when it attempts to read past the end of\n            the stringstream. As well, setting this parameter to \n            		<em class=\"strong\">false</em> and \n            		<span class=\"code\">&lt;char_count&gt;</span> to -1 causes this method to read to the end of the stringstream. The default is \n            		<em class=\"strong\">true</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-493EC089-7102-4543-9D57-96CFFBF6DDD0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E85\"></a><pre><em class=\"codeEmphasisStrong\">readDelimitedString</em> &lt;stringstream&gt; &lt;string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BBE\"></a>Takes a delimiter character (as a string) and reads in characters until the delimiter\n            is found (or end-of-file is reached) and returns the characters in a string. \n         </p>\n         <div><a name=\"GUID-87AE4A88-1AA8-483A-9A85-BDE2A09D55AF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If the delimiter string is more than one character, every single character in the\n               string is treated as a delimiter, rather than the string itself. For example, \n               		<span class=\"code\">readDelimitedString (stringStream \"This is an abc string\") \"abc\"</span> will return “This is \" rather than \"This is an\". \n               	 \n            </div>\n         </div>\n         <p><a name=\"GUID-F11014FA-C54F-401E-B735-D434DBDFCFB6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E84\"></a><pre><em class=\"codeEmphasisStrong\">skipToString</em> &lt;stringstream&gt; &lt;string&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BBB\"></a>Takes a character string and scans forward in the file until it finds an occurrence\n            of the string and positions the file just after that string. If the string is not\n            found, the function returns the value \n            		<span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-37425E87-8DFB-463C-92F7-B8FB254DF127\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E83\"></a><pre><em class=\"codeEmphasisStrong\">skipToNextLine </em>&lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BB8\"></a>Positions the input file at the beginning of the next line \n            	 \n         </p>\n         <p><a name=\"GUID-0E8C3C6C-2002-49BC-B0AC-D5E588601483\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E82\"></a><pre><em class=\"codeEmphasisStrong\">execute</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BB0\"></a>Read and evaluate all the expressions left in the stringStream. Note that the scope\n            of the evaluation is the \n            		<em class=\"strong\">global</em> scope, not the current scope! \n         </p>\n         <p><a name=\"GUID-AD3857DF-8377-455A-8F8F-169606B35277\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E81\"></a><pre><em class=\"codeEmphasisStrong\">filePos</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BAD\"></a>Retrieve the current offset into the file \n         </p>\n         <p><a name=\"GUID-97122AD6-5777-45EC-8251-14A139FA47AA\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E80\"></a><pre><em class=\"codeEmphasisStrong\">seek </em>&lt;stringstream&gt; &lt;pos&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BAA\"></a>Position the file at the given offset so that subsequent I/O will start there. \n         </p>\n         <p><a name=\"GUID-47390B6F-2675-4348-94AA-826E777FCB94\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E7F\"></a><pre><em class=\"codeEmphasisStrong\">eof</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BA7\"></a>Returns \n            		<em class=\"strong\">true</em> if there is no more data in the stringStream, \n            		<em class=\"strong\">false</em> otherwise. \n         </p>\n         <p><a name=\"GUID-DCD81107-9284-40DC-9671-690D3A6040C6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E7E\"></a><pre><em class=\"codeEmphasisStrong\">close</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"GUID-9967ACA6-D06B-435C-8F64-EC0722C60977\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5E7D\"></a><pre><em class=\"codeEmphasisStrong\">flush</em> &lt;stringstream&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7BA2\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">close()</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">flush()</em> </span> functions are provided for consistency with file I/O but are not necessary for StringStreams\n            and do nothing if called. \n         </p>\n         <p><a name=\"GUID-6E47DDBD-23E0-4A3F-A2DD-EEE8557EC610\"></a></p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";