var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"normalize()\">\n      <meta name=\"indexterm\" content=\"length()\">\n      <meta name=\"indexterm\" content=\"distance()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Point2 Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF\"></a><div class=\"head\">\n            <h1>Point2 Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CFB\"></a>The \n            		<em class=\"strong\">point2</em> class defines the characteristics of points in 2D space. \n            	 \n         </p>\n         <p><a name=\"P_8089D8C67F0A4912A8D6FFD100E07937\"></a>This class is a 2D version of Point3 and is used in utility rollout positioning parameters\n            and for accessing Bitmap values, etc. \n            	 \n         </p>\n         <p><a name=\"P_1B97711449BB46A58E42DAA5F063C9D8\"></a>See also \n            		<span class=\"char_link\"><a href=\"GUID-A2C25DDF-2FC1-456B-90C2-B91D98296C3F.htm\">2D and 3D Point Literals</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_BE9800A07F1C44EB896F7E87561969EC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CFC\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8D\"></a><pre><em class=\"codeEmphasisStrong\">[</em>&lt;expr&gt;, &lt;expr&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E87CFF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87D00\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8C\"></a><pre>\n[x, y]\n[10, 20]\n[sin x, cos x]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D07\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8B\"></a><pre><em class=\"codeEmphasisStrong\">point2</em> &lt;x&gt; &lt;y&gt;-- x and y are numbers \n&lt;point3&gt; <em class=\"codeEmphasisStrong\">as point2</em>-- created from the x and y components of the point3   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D0A\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F8A\"></a><pre>&lt;point2&gt;<em class=\"codeEmphasisStrong\">.x</em>: Float \n&lt;point2&gt;<em class=\"codeEmphasisStrong\">.y</em>: Float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D0D\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F89\"></a><pre>&lt;point2&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;point2&gt; \n&lt;point2&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;point2&gt; &nbsp; \n&lt;point2&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;point2_or_number&gt; \n&lt;point2&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;point2_or_number&gt; \n&lt;point2&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;point2_or_number&gt; \n&lt;point2&gt; <em class=\"codeEmphasisStrong\">/</em> &lt;point2_or_number&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D15\"></a>Standard vector arithmetic. If the second operand is a number it does scalar arithmetic\n            on vector. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F88\"></a><pre><em class=\"codeEmphasisStrong\">-</em>&lt;point2&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D18\"></a>unary minus \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F87\"></a><pre>&lt;point2&gt;[&lt;integer&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D1B\"></a>Returns a component of the Point2 as a float. Valid range on the index is 1 to 2.\n            \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F86\"></a><pre>&lt;point2&gt;[&lt;integer&gt;]<em class=\"codeEmphasisStrong\">=</em>&lt;float&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D1E\"></a>Sets a component of the Point2 to the float. Valid range on the index is 1 to 2. \n            	 \n         </p>\n         <p><a name=\"P_D271D3590C604051BA16891B3E0ECCB8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6AE5\"></a>      <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F85\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;point2&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D25\"></a>Creates a new copy of the point2 value. \n            	 \n         </p><a name=\"TABLE_EBEC8B9E4DC5440DBD71E6EA5CF75138\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"P_5796CADA76B649CDAEAA409A19EE94E1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_BA6446773DD94195B027A56195B46C4B\"></a><pre>\nnewPoint = copy oldPoint\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D27\"></a>The new value contains a copy of the input point2 value, and is independent of the\n            input point2 value. \n            	 \n         </p>\n         <p><a name=\"P_2BBF7F8FA5634AD8A4E26FF7ED686C6B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F83\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;point2&gt; &lt;point2&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D2A\"></a>Generates a pseudo-random point between the given points. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D2C\"></a> <em class=\"strong\">length</em>&lt;point2&gt; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D2D\"></a>Returns the length of the vector. \n            	 \n         </p>\n         <p><a name=\"P_DD16A35B10EA48C3B8033B03CAFEB16F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F82\"></a><pre><em class=\"codeEmphasisStrong\">distance</em> &lt;point2&gt; &lt;point2&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D30\"></a>Returns the distance between the points - length of (point 2 - point 1). \n            	 \n         </p>\n         <p><a name=\"P_99D63C868F21465E8C8656A0068F86EF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F81\"></a><pre><em class=\"codeEmphasisStrong\">normalize</em> &lt;point2&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D33\"></a>Returns the \n            		<span class=\"code\"> <em class=\"strong\">point2</em> </span> value normalized such that the vector length equals 1. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D35\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D36\"></a> <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D37\"></a> <span class=\"char_link\"><a href=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525.htm\">Box2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D38\"></a> <span class=\"char_link\"><a href=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D.htm\">Ray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";