var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DE30E7CB-EDC3-4EF7-8457-A9F63F6EF60C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface INodeShadingProperties\">\n      <meta name=\"indexterm\" content=\"INodeShadingProperties Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: INodeShadingProperties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DE30E7CB-EDC3-4EF7-8457-A9F63F6EF60C\"></a><div class=\"head\">\n            <h1>Interface: INodeShadingProperties </h1>\n         </div><a name=\"TABLE_A5DC1F058B8C408DABE59092626789E2\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.147623544224111%\">\n                  <col width=\"96.8523764557759%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"P_A56874E20C4D41C7A29D58B67E7BC277\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_B36541CA6A4A405E8B14DB39E1E96AD5\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Viewport Shading - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-ACC\"></a>  The<em class=\"strong\"> INodeShadingProperties Node Interface</em> exposes the node-related viewport shading properties to MAXScript. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-ACB\"></a>Only nodes whose base object is of Light superclass will effectively use these properties,\n            but the property can be set in any node. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-ACA\"></a>Available in<em class=\"strong\"> 3ds Max 2008</em> and higher. \n         </p>\n         <p><a name=\"GUID-1E8AAD91-BB07-41D1-B7C4-294A17401F73\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-531E\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">INodeShadingProperties</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC8\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-531D\"></a><pre><em class=\"codeEmphasisStrong\">INodeShadingProperties</em>.<em class=\"codeEmphasisStrong\">ViewportIllumination </em>: bool : Read|Write   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC7\"></a>When set to<span class=\"code\"> <em class=\"strong\"> true </em> </span>(default), enables Viewport Illumination for the node, assuming the base object is\n            a Light and the Viewport Shading mode is set to Best (SM3.0) - see<span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span> on how to enable the advanced shading modes. The Best mode depends on the graphics\n            hardware supporting the SM3.0 shader model. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC6\"></a>On hardware that supports only SM2.0, the Good mode performs old-style vertex lighting\n            only and does not support per-pixel lighting. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-531C\"></a><pre>\nIViewportShadingMgr.ShadingLimits= #Best --enable shadows\n$Spot01.on = true --make sure the light is on\n$Spot01.ViewportIllumination = true --display illumination\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A3674\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F15D72BA-EFE7-4859-9EE5-05FCE69E0CBA-low.gif\"></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AC0\"></a>When set to<span class=\"code\"> <em class=\"strong\"> false</em> </span>, Viewport Illumination is turned off for the node. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-ABF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-ABE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">$Spot01.ViewportIllumination = false --</em> display illumination </span> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A3675\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-FE2D5F88-403F-4E2D-8FBB-D875096175BE-low.gif\"></div>\n         <p><a name=\"GUID-F69876F6-47A9-4264-A09E-369E89B57595\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-531B\"></a><pre><em class=\"codeEmphasisStrong\">INodeShadingProperties</em>.<em class=\"codeEmphasisStrong\">ViewportShadowCasting</em> : bool : Read|Write </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB9\"></a>When set to<span class=\"code\"> <em class=\"strong\"> true</em> </span>, enables Viewport Shadow Casting for the node, provided the base object is a Light\n            and Shadow Casting is turned on in the light\'s base object using <span class=\"code\">&lt;light&gt; <em class=\"strong\">.baseobject.castShadows = true</em></span>. (Remember, <span class=\"code\"> <em class=\"strong\">.castShadows </em> </span>is also a node property and requires explicit access in the baseobject to affect the\n            shadow casting of the light). \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB8\"></a>To see the shadows in the viewport, the Viewport Shading has to be set to Good (SM2.0)\n            or Best (SM3.0) - see <span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span> on how to enable the advanced shading modes. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-531A\"></a><pre>\nIViewportShadingMgr.ShadingLimits = #Best --enable shadows\n$Spot01.baseobject.castshadows = true --enable shadows in Spot01\n$Spot01.ViewportShadowCasting = true --display shadows ofSpot01\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A3676\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A95F4B80-0BE9-4CE2-871C-919A376E0556-low.gif\"></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB3\"></a>When set to <span class=\"code\"> <em class=\"strong\">false</em> </span>,Viewport Shadow Casting is turned off for the node. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB2\"></a>Since <em class=\"strong\">3ds Max 2010</em>, this property defaults to true, thus automatically enabling viewport shadow casting\n            for any light that has its base object shadows turned on. In<em class=\"strong\"> 3ds Max 2008</em> and<em class=\"strong\"> 2009</em>, the property was set to false by default. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AB0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5319\"></a><pre>\n$Spot01.ViewportShadowCasting = false\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A3677\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F15D72BA-EFE7-4859-9EE5-05FCE69E0CBA-low.gif\"></div>\n         <p><a name=\"GUID-23F042EB-3628-4B94-9C34-7ABBE5F2846F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5318\"></a><pre><em class=\"codeEmphasisStrong\">INodeShadingProperties</em>.<em class=\"codeEmphasisStrong\">LockedViewportIllumination </em>: bool : Read|Write </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AAB\"></a>When set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, locks the Viewport Illumination for the node \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AAA\"></a>When set to <span class=\"code\"> <em class=\"strong\">false</em> </span> (default), Viewport Illumination is unlocked for this node. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA9\"></a>When the <span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span><span class=\"code\"> <em class=\"strong\">.AutoDisplaySelLights </em> </span>property is set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, lights that are not selected will not illuminate the scene. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA8\"></a>By setting the<span class=\"code\"> <em class=\"strong\"> .LockedViewportIllumination</em> </span> property to <span class=\"code\"> <em class=\"strong\">true</em> </span>, a light node can be locked to keep on illuminating the scene even after it has been\n            deselected. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA7\"></a>See <span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span> for methods to quickly lock and unlock multiple lights. The<em class=\"strong\"> 3ds Max QuadMenus </em>provide menu items to call these methods on the selected lights: \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA5\"></a> <span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA4\"></a> <span class=\"char_link\"><a href=\"GUID-E15A1883-B97D-4CB8-98FD-6C6C8E502F19.htm\">Viewport Shading Settings</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-AA3\"></a> <span class=\"char_link\"><a href=\"GUID-6201E848-41CF-4A78-90B5-1A545D33944D.htm\">Interface: ViewportSSB</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";