var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DEF09985-1709-4801-9B0B-16B577C48D43\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Constructors</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DEF09985-1709-4801-9B0B-16B577C48D43\"></a><div class=\"head\">\n            <h1>Node Constructors</h1>\n         </div>\n         <p> The following constructors are applicable to any value that is derived from a Node.\n            \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB4\"></a><pre>&lt;non_wild_card_pathname&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3603\"></a>identifies a unique node in the scene. \n            	 \n         </p>\n         <p><a name=\"P_B2D96C2E7A244580BE4A64C2C23A1D07\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB3\"></a><pre>&lt;objectset&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> \n&lt;wild_card_pathname&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3600\"></a>n\'th scene object in collection. \n            	 \n         </p>\n         <p><a name=\"P_B4805C7708684BEBBD0D4138182422B3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB2\"></a><pre>&lt;node_constructor&gt; [<em class=\"codeEmphasisStrong\">name</em>: &lt;string&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">prefix</em>: &lt;string&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">material</em>: &lt;material&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">target</em>: &lt;node&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">pos</em>: &lt;point3&gt; ] \\-- default [0,0,0] \n[ <em class=\"codeEmphasisStrong\">position</em>: &lt;point3&gt; ] \\-- synonym for pos \n[ <em class=\"codeEmphasisStrong\">rotation</em>: &lt;quat&gt; ] \\-- default 0 rotation \n[ <em class=\"codeEmphasisStrong\">scale</em>: &lt;point3&gt; ] \\-- default 100% scale \n[ <em class=\"codeEmphasisStrong\">pivot</em>: &lt;point3&gt; ] \\-- default normal node pivot location \n[ <em class=\"codeEmphasisStrong\">transform</em>: &lt;matrix3&gt; ] \\-- default identity \n[ <em class=\"codeEmphasisStrong\">isSelected</em>: &lt;boolean&gt; ] \\-- default false \n[ <em class=\"codeEmphasisStrong\">dir</em>: &lt;point3&gt; ]-- set local z direction   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35F3\"></a>The position and rotation values are relative to the current active grid if \'coordsys\n            grid\' is the current working coordinate system. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35F2\"></a>A \n            		<span class=\"code\"> <em class=\"strong\">&lt;node_constructor&gt;</em> </span> is one of the scene node classes listed in \n            		<span class=\"char_link\"><a href=\"GUID-A1A1A4CC-615C-4EDA-9CBA-0E89774AF0E6.htm\">Node Subclasses</a></span> such as, box, sphere, quadPatch, splineShape, and so on. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35F1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35F0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB1\"></a><pre>\nb = box name:\"foo\" position:[10,10,10] height:20\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35EB\"></a>All of the node constructors can take the above optional keyword arguments along with\n            any of the general node properties or any of the properties for the particular node\n            class as keyword arguments. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35EA\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">name</em> </span> keyword can be used to specify the name for the created node. \n            		<em class=\"strong\">3ds Max</em> allows the same name to be used for more than one node. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35E9\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">prefix</em> </span> keyword can be used in place of the \n            		<span class=\"code\"> <em class=\"strong\">name</em> </span> keyword argument to specify the start of the node name from which \n            		<em class=\"strong\">3ds Max</em> will generate a unique name by adding a series of digits, as it does when creating\n            objects interactively. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35E8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35E7\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB0\"></a><pre>\nfor i in 1 to 100 do sphere prefix:\"baz\"\n--creates 100 spheres, giving each a unique name\n--beginning with \"baz\", such as $baz001, $baz002, $baz003, etc.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35E1\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">material</em> </span> keyword can be used to apply the specified material to the created node. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35E0\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">target</em> </span> keyword can be used to automatically apply a LookAt controller to the node\'s transform\n            track, and set the specified node as the LookAt target. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-35DF\"></a>The transformation arguments, \n            		<span class=\"code\"> <em class=\"strong\">pos</em> </span> , \n            		<span class=\"code\"> <em class=\"strong\">scale</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">rotation</em> </span>, and \n            		<span class=\"code\"> <em class=\"strong\">pivot</em> </span> are applied to the new object in the order they are specified in the constructor\n            call, so you can control transform order. The \n            		<span class=\"code\"> <em class=\"strong\">pos</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">scale</em> </span>, and \n            		<span class=\"code\"> <em class=\"strong\">rotation</em> </span> arguments are mutually exclusive with the \n            		<span class=\"code\"> <em class=\"strong\">transform</em> </span> argument that can be used as an alternative way to set the node\'s complete transform\n            matrix in one go. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AF4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AF3\"></a>Exercise care if you specify the \n                  		  <span class=\"code\"> <em class=\"strong\">target</em> </span> keyword. When you specify a target object, \n                  		  <em class=\"strong\">3ds Max</em> stores with the target object the last object it was assigned as a target of. If\n                  you delete the target object, the behavior of \n                  		  <em class=\"strong\">3ds Max</em> is to also delete the object looking at it. If the target object is a \n                  		  <span class=\"char_link\"><a href=\"GUID-9FFE83EB-72F2-40C4-BD14-356DFCA88638.htm\">targetobject</a></span> class object, deleting an object looking at it will also delete the target object,\n                  even if another object is also looking at it. \n                  		\n               </p> \n               <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AF2\"></a>The performance of iterating and indexing the \'<em class=\"strong\">selection</em>\' and \'<em class=\"strong\">$</em>\' object sets has been substantially improved in \n                  		  <em class=\"strong\">3ds Max 4</em>. In versions prior to \n                  		  <em class=\"strong\">3ds Max 4</em>, the whole scene was traversed looking for selected nodes when indexing, iterating,\n                  or snapshotting into an array causing big delays in large scenes. Now, the \n                  		  <em class=\"strong\">\'selection\'</em> object set uses direct access to the SDK explicit current selection set. \n                  		\n               </p> \n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";