var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-DF068975-00B6-4CF9-B240-50B032C1B960\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Active Shade Bitmap Access\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Active Shade Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DF068975-00B6-4CF9-B240-50B032C1B960\"></a><div class=\"head\">\n            <h1>Active Shade Access</h1>\n         </div>\n         <p><a name=\"GUID-F26E2998-CB80-498E-85DA-7E62A20D0821\"></a> The following functions provide access to the rendered image of the Active Shade\n            feature, and a way to close Active Shade. Available in <em class=\"strong\">3ds Max 2015 and higher</em>. \n         </p>\n         <p><a name=\"GUID-3A837A43-D9F6-48BD-B8FC-C0444971A24B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bitmap&gt;<em class=\"codeEmphasisStrong\">GetActiveShadeBitmap </em> [<em class=\"codeEmphasisStrong\">wait:</em>&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">timeout:</em>&lt;float&gt;] [<em class=\"codeEmphasisStrong\">result:</em>&amp;result]</pre></div>\n         <p><a name=\"GUID-7BE88874-07DF-4D1F-B6F7-6AD5696E31D0\"></a>If ActiveShade is active, returns a copy of the Bitmap value containing the current\n            ActiveShade render result. \n         </p>\n         <p><a name=\"GUID-F38D00D9-88A3-4996-B2F9-BEFA487A7AD5\"></a>If no ActiveShade view is active, returns undefined. \n         </p>\n         <p><a name=\"GUID-091ABB39-184D-47D7-8BF9-DEEA505CC5D2\"></a>If the optional keyword <span class=\"code\"> <em class=\"strong\">wait:</em> </span> is passes as True, the function will wait for the rendering to end before returning\n            the bitmap. If not specified or set to False, the current bitmap will be returned\n            immediately. \n         </p>\n         <p><a name=\"GUID-DF6B0647-2777-44FE-A577-F81CC338D6E9\"></a>If the optional keyword <span class=\"code\"> <em class=\"strong\">timeout:</em> </span> is specified and <span class=\"code\"> <em class=\"strong\">wait:</em> </span> is set to True, the function will wait up to the specified number of seconds. If\n            the rendering has not finished until then, it will return without waiting for it to\n            finish. \n         </p>\n         <p><a name=\"GUID-0352B8BC-2AF4-42F7-AD7E-DEBD37755A42\"></a>If the optional keyword <span class=\"code\"> <em class=\"strong\">result:</em> </span> is specified, the by-reference out variable &amp;result will be set to one of the following:\n            \n         </p>\n         <p><a name=\"GUID-7BE13B03-B489-410D-B3DF-05C23C69A7AA\"></a><em class=\"strong\">#done</em> - the render completed, or if <span class=\"code\"> <em class=\"strong\">wait:</em> </span> was set to False or not specified, the current bitmap was returned without waiting.\n            \n         </p>\n         <p><a name=\"GUID-21DB588F-289C-4DDF-BC3E-458430FBB96E\"></a><em class=\"strong\">#waitTimeout</em> - the timeout threshold (if specified via timeout: keyword) was reached before completing\n            the rendering. \n         </p>\n         <p><a name=\"GUID-B3D07842-0BE5-4CEF-A870-93A5FBECF35B\"></a><em class=\"strong\">#error</em> - the rendering did not even start due to an error. \n         </p>\n         <p><a name=\"GUID-8827EC82-0DDE-4943-9D18-9AC36D09D440\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">CloseActiveShade()</em></pre></div>\n         <p><a name=\"GUID-2520746D-DBD7-4469-B5D0-947384AEEB17\"></a>Closes the ActiveShade window if it is open. \n         </p>\n         <p><a name=\"GUID-18BB8212-7633-4D35-9EBA-01DDC5471267\"></a>Does nothing if no ActiveShade window is open. \n         </p>\n         <p><a name=\"GUID-4DADFC49-C92E-49F9-AC0F-753E7F04733C\"></a>Returns OK in both cases. \n         </p>\n         <p><a name=\"GUID-13922A4C-2FF4-45F3-B865-910E5CCF420F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";