var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E03DD372-9EBE-4F1D-9446-F8AD153492FE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"World Space Modifiers - Force-Related Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>World Space Modifiers - Force-Related Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E03DD372-9EBE-4F1D-9446-F8AD153492FE\"></a><div class=\"head\">\n            <h1>World Space Modifiers - Force-Related Methods </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6719\"></a> The following methods can be used to calculate forces defined by World Space Modifiers\n            (Space Warps). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C671B\"></a>These methods are available in <em class=\"strong\">3ds Max 2008</em> and higher. They were previously available in the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4659\"></a><pre><em class=\"codeEmphasisStrong\">WSMApplyFC</em> &lt;WSM_node_array&gt; &lt;pos_point3_array&gt; &lt;vel_point3_array&gt; &lt;force_point3_array&gt; <em class=\"codeEmphasisStrong\">interval</em>:&lt;interval&gt; <em class=\"codeEmphasisStrong\">stepsize</em>:&lt;time&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C671E\"></a>Applies force-field (Particles &amp; Dynamics + Displace) and deflector (Particles Only)\n            type Space Warps to the position, velocity, and force array values. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C671F\"></a> \n            <h2><a name=\"GUID-DD6CF2EB-1DDF-4E4A-A966-CBAEBA07FB91\"></a> <em class=\"strong\">Units:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6720\"></a>The position values are in <em class=\"strong\">3ds Max</em> units, the velocity values are in <em class=\"strong\">3ds Max</em> units/tick, the force values are in <em class=\"strong\">3ds Max</em> units/tick^2 (mass assumed to be == 1). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6721\"></a>The position, velocity, and force arrays must be the same size. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6722\"></a> \n            <h2><a name=\"GUID-8E7EE9FB-D936-43E2-A607-3169BC7FAA81\"></a> <em class=\"strong\">Evaluation Interval and Order:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6723\"></a>The effects of the space warps are evaluated over the specified interval, with a default\n               interval of (interval currenttime (currenttime+1f)), using the specified stepsize,\n               with a default of 1 frame. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6724\"></a>The effect of the force-field space warps are first evaluated in the order specified,\n               followed by the deflector space warps in the order specified. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6725\"></a>The values in the position, velocity, and force arrays are replaced with the results\n               of the evaluation of the effects of the space warps \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6726\"></a>The supplied force values are applied prior to the space warps being applied. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6727\"></a> \n            <h2><a name=\"GUID-158846B9-DC76-44FF-AC4A-F571D4710128\"></a> <em class=\"strong\">Initial Values:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6728\"></a>Normally you want to set the force array to contain values of [0,0,0] prior to calling\n               this method. Only if you are calculating an additional force in your script would\n               you set the force array to other values. The position and velocity arrays would normally\n               contain the results of the last call to this method. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6729\"></a> \n            <h2><a name=\"GUID-65474199-5547-447A-BEC5-E29511CD0215\"></a> <em class=\"strong\">Supported Space Warps:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C672A\"></a>Any force-field space warp, including 3rd party plug-ins, should work correctly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C672B\"></a>Only the deflector space warps that ship with 3ds Max are supported. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C672C\"></a>The Path Follow space warp is not supported as it requires a particle system. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C672D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C672E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4658\"></a><pre>\n(\nresetMaxFile #noPrompt\ngravity pos:[41.7827,242.9,0] isSelected:on iconSize:33.4742 transform:(matrix3 [1,0,0] [0,-1,0] [0,0,-1] [41.7827,242.9,0])\nDeflector bounce:1 width:101.617 length:74.9636 transform:(matrix3 [1,0,0] [0,0.751713,0.659491] [0,-0.659491,0.751713] [16.7722,4.28949,-146.329])\nposArray=#([10,0,0],[10,10,0])\nvelArray=#([0,0,0],[0,0,0])\nforceArray=#([0,0,0],[0,0,0])\nfor i = 0 to 40 do(\npoint pos:posArray[1] wirecolor:red\npoint pos:posArray[2] wirecolor:blue\nat time i WSMApplyFC #($gravity001,$deflector001) posArray velArray forceArray\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6741\"></a><p class=\"table-body\"></p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6742\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-806D2A79-D555-42D1-9895-D7574229DFA1-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6743\"></a><p class=\"table-body\"></p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4657\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">WSMSupportsForce</em> &lt;node&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6747\"></a>Returns true if the specified node can be used as a force-field type space warp for\n               <span class=\"code\"><em class=\"strong\">WSMApplyFC()</em>.</span> \n            </p> \n            <p><a name=\"GUID-1AFADF37-91B9-4A88-A42C-CD896A198DF5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4656\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">WSMSupportsCollision</em> &lt;node&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C674A\"></a>Returns true if the specified node can be used as a deflector type space warp for\n               <span class=\"code\"> <em class=\"strong\">WSMApplyFC().</em> </span> \n            </p> \n            <p><a name=\"GUID-B914BA6B-DB07-4E93-8A10-80EFAD2644AD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";