var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E15A1883-B97D-4CB8-98FD-6C6C8E502F19\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Viewport Shading Settings\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Viewport Shading Settings</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E15A1883-B97D-4CB8-98FD-6C6C8E502F19\"></a><div class=\"head\">\n            <h1>Viewport Shading Settings </h1>\n         </div><a name=\"TABLE_A5DC1F058B8C408DABE59092626789E2\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.147623544224111%\">\n                  <col width=\"96.8523764557759%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"P_A56874E20C4D41C7A29D58B67E7BC277\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_B36541CA6A4A405E8B14DB39E1E96AD5\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Viewport Shading - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-272D\"></a>The following method exposed by the <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm#WS1A9193826455F5FF-56C0CD8012A8003217A-1254\">MaxOps struct</a></span> in <em class=\"strong\">3ds Max 2010 and higher</em> returns a ViewportShadingSettings object which in turn provides interfaces to control\n            some advanced viewport settings including Soft Shadows, Ambient Occlusion and Exposure\n            Control preview. \n         </p>\n         <div><a name=\"GUID-B0CEED6A-98B5-4A5F-9230-BB241D92835B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"P_D3F4C7FADBB1427EA4AAFF5C68864721\"></a>In <em class=\"strong\">3ds Max 2012</em>, these settings apply to the Direct3D driver. When running the <span class=\"char_link\"><a href=\"GUID-34892DB6-E840-4F52-9175-30332799B7B1.htm\">Nitrous Graphics Manager</a></span>, most of these properties and methods will have no effect, for example the property\n                  <span class=\"code\"> <em class=\"strong\">.ActivateViewportShading</em> </span> documented below will return true when the viewport is set to \"Realistic\" mode, but\n                  setting the property to false <em class=\"strong\">will have no effect </em>on the viewport mode or on the value of the property. \n               </p> \n            </div>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6ACA\"></a><pre>&lt;IObject&gt;<em class=\"codeEmphasisStrong\">maxops.getViewportShadingSettings</em>() 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-272A\"></a>Returns an &lt;IObject:ViewportShadingSettings&gt; object exposing several interfaces related\n            to advanced viewport shading controls. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2728\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2727\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC9\"></a><pre>\nvss = maxops.getViewportShadingSettings()\n--&gt; &lt;IObject:ViewportShadingSettings&gt;\nshowInterfaces vss\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-D4433C22-276B-4690-858D-78D45B5A900E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC8\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">ViewportBasicSettings</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2719\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC7\"></a><pre>IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">ActivateViewportShading</em>: bool : Read|Write </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2717\"></a>Get/set the state of the <em class=\"strong\">Enable Hardware Shading</em> checkbox in the Lighting and Shadows tab of the Viewport Configuration dialog. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2716\"></a>Set to true to enable hardware shading, set to false to disable it. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2715\"></a>This is equivalent to <span class=\"code\"> <em class=\"strong\">IViewportShadingMgr.ShadingLimit=#None</em> </span> \n         </p>\n         <p><a name=\"GUID-CB3DFF46-A564-406B-8A55-373BB37FB5DE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC6\"></a><pre>IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">ShadingQuality</em>: enum : Read|Write \nShadingQuality enums: {<em class=\"codeEmphasisStrong\">#Good</em>|<em class=\"codeEmphasisStrong\">#Best</em>} </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2711\"></a>Get/set thestate of the <em class=\"strong\">Quality/Hardware Support</em> radio buttons in the Global Settings group of controls in the Lighting and Shadows\n            tab of the Viewport Configuration dialog. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2710\"></a>These are equivalent to \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC4\"></a><pre><em class=\"codeEmphasisStrong\">IViewportShadingMgr.ShadingLimit=#Good</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-270E\"></a>and \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC3\"></a><pre><em class=\"codeEmphasisStrong\">IViewportShadingMgr.ShadingLimit=#Best</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-270B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-270A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC2\"></a><pre>\nvss = maxops.getViewportShadingSettings()\n--&gt;&lt;IObject:ViewportShadingSettings&gt;\nvss.ActivateViewportShading\n--&gt;false\nvss.ActivateViewportShading = true\n--&gt;true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_0C173539A4AC4C2DB5FF1098A979B104\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC1\"></a><pre>IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">ShadowsActive</em>: bool : Read|Write </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26FE\"></a>Get/set the state of the <em class=\"strong\">Enable Shadows</em> checkbox in the Shadow Options group of controls in the Lighting and Shadows tab\n            of the Viewport Configuration dialog. \n         </p>\n         <p><a name=\"GUID-D9E8C457-533D-40C7-A271-DCD8AB5F0600\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AC0\"></a><pre>IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">TonemappingActive</em>: bool : Read|Write </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26FB\"></a>Get/set the state of the <em class=\"strong\">Enable Exposure Control in Viewport</em> checkbox in the Lighting and Shadows tab of the Viewport Configuration dialog. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26FA\"></a>When set to true, the Exposure Control will be applied to the viewport. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26F9\"></a>When set to false, it will be applied only to the final rendering. \n         </p>\n         <p><a name=\"GUID-EB6D1E3A-B01E-4AA3-8104-75BFFB5B1E74\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6ABF\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">ViewportGISettings</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26F6\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-56C5\"></a> \n            <h2><a name=\"GUID-D66268F8-3710-413B-986D-62618726BE4E\"></a> <em class=\"strong\">Ambient Occlusion</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6ABE\"></a><pre> &lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">AmbientOcclusionMode</em> : enum : Read|Write \n\nAmbientOcclusionMode enums: {<em class=\"codeEmphasisStrong\">#GIOff</em>|<em class=\"codeEmphasisStrong\">#AOOnly</em>|<em class=\"codeEmphasisStrong\">#AOComposite</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26F2\"></a>Get/set the Viewport Ambient Occlusion mode. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26F1\"></a>The Lighting and Shadows tab of the Viewport Configuration dialog exposes only a checkbox\n               which corresponds to #GIOff when the checkbox is unchecked and #AOComposite when the\n               checkbox is checked. Zero-based integers can be used in place of the enums. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26F0\"></a>Possible numeric or enum values are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26EF\"></a>0 (<em class=\"strong\">#GIOff</em>) - No Global Illumination. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26EE\"></a>1 (<em class=\"strong\">#AOOnly</em>) - Only Ambient Occlusion, black and white with no other shading. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26ED\"></a>2 (<em class=\"strong\">#AOComposite</em>) - Ambient Occlusion composited over the shaded scene. \n            </p> \n            <p><a name=\"GUID-FB6083D7-7697-46CD-B354-7E7340550D5F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6ABC\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">AmbientOcclusionQuality</em>: enum : Read|Write \n\nAmbientOcclusionQuality enums: {<em class=\"codeEmphasisStrong\">#Low</em>|<em class=\"codeEmphasisStrong\">#Medium</em>|<em class=\"codeEmphasisStrong\">#High</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E9\"></a>Get/set the Viewport Ambient Occlusion quality. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E8\"></a>Possible numeric or enum values are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E7\"></a>0 (<em class=\"strong\">#Low</em>) - 16 sample points \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E6\"></a>1 (<em class=\"strong\">#Medium</em>) - 32 sample points \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E5\"></a>2 (<em class=\"strong\">#High</em>) - 64 sample points \n            </p> \n            <p><a name=\"GUID-A6B86D13-210D-497E-94E7-F4A16768C66A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6ABA\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">AmbientOcclusionRadius</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26E2\"></a>Get/set the Ambient Occlusion sample radius value. \n            </p> \n            <p><a name=\"GUID-580765A9-0BFB-4921-821B-6A66FF950789\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB9\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">AmbientOcclusionStrength</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26DF\"></a>Get/set the Ambient Occlusion strength value. It controls the intensity of the effect.\n               Effective range is from 0.0 to 1.0. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-56B0\"></a> \n            <h2><a name=\"GUID-409E524A-EE8A-4438-94D9-E5BDE92468D1\"></a> <em class=\"strong\">Indirect Lighting (Unsupported)</em> \n            </h2> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7562\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The Indirect Lighting preview feature is <em class=\"strong\">not exposed to the UI</em> and is <em class=\"strong\">not supported</em> in <em class=\"strong\">3ds Max 2010</em>. \n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB8\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">IndirectLightingMode</em>: enum : Read|Write \n\nIndirectLightingMode enums: {<em class=\"codeEmphasisStrong\">#ILOff</em>|<em class=\"codeEmphasisStrong\">#ILOnly</em>|<em class=\"codeEmphasisStrong\">#ILAOComposite</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26D6\"></a>Get/set the Indirect Illumination mode. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26D5\"></a>Possible numeric or enum values are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26D4\"></a>0 (<em class=\"strong\">#ILOff</em>) - No Indirect Lighting (default) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26D3\"></a>1 (<em class=\"strong\">#ILOnly</em>) - Only the Indirect Lighting effect will be used. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26D2\"></a>2 (<em class=\"strong\">#ILAOComposite</em>) - Indirect Lighting and Ambient Occlusion Composite mode. \n            </p> \n            <p><a name=\"GUID-A5F0A660-9C79-440C-A9A7-25AD22A3E601\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB6\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">IndirectLightingQuality</em>: enum : Read|Write \n\nIndirectLightingQuality enums: {<em class=\"codeEmphasisStrong\">#Low</em>|<em class=\"codeEmphasisStrong\">#Medium</em>|<em class=\"codeEmphasisStrong\">#High</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26CE\"></a>Get/set the Indirect Lighting quality. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26CD\"></a>Possible numeric or enum values are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26CC\"></a>0 (<em class=\"strong\">#Low</em>) - 16 sample points \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26CB\"></a>1 (<em class=\"strong\">#Medium</em>) - 32 sample points (default) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26CA\"></a>2 (<em class=\"strong\">#High</em>) - 64 sample points \n            </p> \n            <p><a name=\"GUID-24F63776-5BE6-4109-85B4-0711804F036F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB4\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">IndirectLightingRadius</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26C7\"></a>Get/set the Indirect Lighting radius value. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26C4\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26C3\"></a><p class=\"table-body\"> <em class=\"strong\">CORNELL BOX EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB3\"></a><pre>\nresetMaxFile #noPrompt\nviewport.setTM (matrix3 [1,0,0] [0,0,-1] [0,1,0] [6,-150,-800])\nbx = box width:300 height:300 length:300 backfacecull:true\naddModifier bx (normalModifier flip:true)\nmtl = multiMaterial numsubs:6\nmtlred = standard diffusecolor:red\nmtlblue = standard diffusecolor:blue\nmtlwht = standard diffusecolor:white\nmtl.materialList = #(mtlwht,mtlwht,mtlred,mtlblue,mtlwht,mtlwht)\nbx.material = mtl\nom = omniLight pos:[0,0,250] rgb:white shadowMultiplier:0.5\nom.baseobject.castshadows = true\nsph = sphere radius:50 pos:[0,0,50] segs:32\nsph.material = standard diffusecolor:green selfillumamount:15.0\nvss = maxops.getViewportShadingSettings()\nvss.ActivateViewportShading = true\nvss.ShadowsActive = true\nvss.IndirectLightingRadius = 200\nvss.IndirectLightingQuality = #medium\nvss.IndirectLightingMode = #ILAOComposite\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26A7\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26A5\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-1D2B5035-F399-4861-AF69-50B96E0BDAFE-low.gif\"></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB2\"></a><pre>\nvss.IndirectLightingMode = #ILOnly\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-26A0\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT (Indirect Lighting Only)</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-269E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E96C15F2-DBAC-4296-B38B-69021CFE26AC-low.gif\"></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5695\"></a> \n            <h2><a name=\"GUID-E348359F-E246-4D5C-95A2-2CB6D1C66854\"></a> <em class=\"strong\">Depth Of Field (Unsupported)</em> \n            </h2> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7561\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The Depth Of Field preview feature is <em class=\"strong\">not exposed to the UI</em> and is <em class=\"strong\">not supported</em> in <em class=\"strong\">3ds Max 2010</em>. \n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB1\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">DepthOfFieldActive</em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2694\"></a>Get/set the Depth Of Field enabled state. \n            </p> \n            <p><a name=\"GUID-511F4227-502A-457D-803E-3F2988CEC7FE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AB0\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">DepthOfFieldNearPlane</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2691\"></a>Get/set the Depth Of Field Near Plane value. \n            </p> \n            <p><a name=\"GUID-B9569890-51C2-4153-A093-B15B791B72FE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAF\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">DepthOfFieldFarPlane</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-268E\"></a>Get/set the Depth Of Field Far Plane value. \n            </p> \n            <p><a name=\"GUID-85263DC7-BFF6-44F3-A0E3-C213C52C580B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAE\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">DepthOfFieldFocusPlane</em>: float : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-268B\"></a>Get/set the Depth Of Field Focus Plane value. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2689\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2688\"></a><p class=\"table-body\"> <em class=\"strong\">DOF BOX EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAD\"></a><pre>\nresetMaxFile #noPrompt\nviewport.setTM (matrix3 [1,0,0] [0,0,-1] [0,1,0] [6,-150,-800])\nbx = box width:500 height:300 length:2000 backfacecull:true\naddModifier bx (normalModifier flip:true)\nmp1 = checker color1:[0,200,255] color2:[255,255,200]\nmp1.coords.U_Tiling = 10\nmp1.coords.V_Tiling = 10\nbx.material = standard diffusecolor:white diffusemap:mp1\nshowTextureMap bx.material mp1 true\nom = omniLight pos:[0,0,250] rgb:white shadowMultiplier:0.5\nom.baseobject.castshadows = true\nsph = sphere radius:50 pos:[0,0,50] segs:32\nsph.material = standard diffusecolor:green selfillumamount:15.0\ntp1 = teapot radius:50 pos:[80,-250,0]\ntp1.material = standard diffusecolor:red\ntp2 = teapot radius:50 pos:[-100,500,0]\ntp2.material = standard diffusecolor:blue\nvss = maxops.getViewportShadingSettings()\nvss.ActivateViewportShading = true\nvss.ShadowsActive = true\nvss.ShadowMode = #Soft\nvss.AmbientOcclusionMode = #AOComposite\nvss.DepthOfFieldActive = true\nvss.DepthOfFieldNearPlane = 300\nvss.DepthOfFieldFarPlane = 1500\nvss.DepthOfFieldFocusPlane = 800\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2663\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2661\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E0242591-1952-4EF9-A8BF-E1A3515C4E40-low.gif\"></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-88690FE7-C2EB-4F0F-B8BA-E948DE6AB674\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAC\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">ViewportShadowSettings</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-265D\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAB\"></a><pre>&lt;IObject:ViewportShadingSettings&gt;.<em class=\"codeEmphasisStrong\">ShadowMode</em>: enum : Read|Write \nShadowMode enums: {<em class=\"codeEmphasisStrong\">#Hard</em>|<em class=\"codeEmphasisStrong\">#Soft</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-265A\"></a>Get/set thestate of the Hard/Soft Shadow radio buttons in the Shadow Options group\n               of controls in the Lighting and Shadows tab of the Viewport Configuration dialog.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2659\"></a>When set to <span class=\"code\"> <em class=\"strong\">#Hard</em> </span>, the shadows will be drawn in the original mode introduced in <em class=\"strong\">3ds Max 2008</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2658\"></a>When set to <span class=\"code\"> <em class=\"strong\">#Soft</em> </span>, the soft shadows mode introduced in <em class=\"strong\">3ds Max 2010</em> will be used instead. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2656\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2655\"></a><p class=\"table-body\"> <em class=\"strong\">VIEWPORT SHADING EXPLORER SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6AAA\"></a><pre>\nmacroScript ViewportShadingExplorer category:\"MAXScript Help\"\n(\nglobal Viewport_Shading_Explorer_Dialog\ntry(destroyDialog Viewport_Shading_Explorer_Dialog)catch()\nrollout Viewport_Shading_Explorer_Dialog \"Viewport Shading Explorer\"\n(\nlocal vss = maxops.getViewportShadingSettings()\ngroup \"Hardware Shading\"\n(\ncheckbox chk_ActivateViewportShading \"Activate Viewport Shading \"checked:vss.ActivateViewportShading\ndropdownlist ddl_ShadingQuality items:#(\"Good Quality\", \"Best Quality\") selection: (findItem #(#Good, #Best) vss.ShadingQuality)\ncheckbox chk_TonemappingActive \"Exposure Control In Viewport\" checked:vss.TonemappingActive\n)\ngroup \"Shadows\"\n(\ncheckbox chk_ShadowsActive \"Shadows Active\" checked:vss.ShadowsActive\ndropdownlist ddl_ShadowMode items:#(\"Hard Shadows\",\"Soft Shadows\") selection:(if vss.ShadowMode == #Hard then 1 else 2)\n)\ngroup \"Soft and Area Shadows\"\n(\nspinner spn_CubeBias \"Cube Bias\" range:[0,1000,ViewportSSB.CubeBias] fieldwidth:50\nspinner spn_ShadowMapSize \"Shadow Map Size (2^N)\" range:[1,10,sqrt ViewportSSB.ShadowMapSize] type:#integer fieldwidth:50\ncheckbox chk_AreaShadow \"Area Shadow\" checked:ViewportSSB.AreaShadow\ncheckbox chk_TransAreaShadow \"Transparent Area Shadow\" checked:ViewportSSB.TransAreaShadow\n)\ngroup \"Ambient Occlusion\"\n(\ndropdownlist ddl_AmbientOcclusionMode items:#(\"Ambient Occlusion Off\",\"Ambient Occlusion Only\", \"Ambient Occlusion Composite\") selection:(findItem #(#AOOff,#AOOnly,#AOComposite) vss.AmbientOcclusionMode )\ndropdownlist ddl_AmbientOcclusionQuality items:#(\"Low Quality\",\"Medium Quality\", \"High Quality\") selection:(findItem #(#Low,#Medium,#High) vss.AmbientOcclusionQuality )\nspinner spn_AmbientOcclusionRadius \"Sample Radius:\" range:[0,1000,vss.AmbientOcclusionRadius] fieldwidth:50\nspinner spn_AmbientOcclusionStrength \"Strength:\" range:[0,1000,vss.AmbientOcclusionStrength] fieldwidth:50\n)\ngroup \"Indirect Lighting\"\n(\ndropdownlist ddl_IndirectLightingMode items:#(\"Indirect Lighting Off\",\"Indirect Lighting Only\", \"Indirect Lighting AO Composite\") selection:(findItem #(#ILOff,#ILOnly,#ILAOComposite) vss.IndirectLightingMode )\ndropdownlist ddl_IndirectLightingQuality items:#(\"Low Quality\",\"Medium Quality\", \"High Quality\") selection:(findItem #(#Low,#Medium,#High) vss.IndirectLightingQuality )\nspinner spn_IndirectLightingRadius \"Sample Radius:\" range:[0,1000,vss.IndirectLightingRadius] fieldwidth:50\n)\ngroup \"Depth Of Field\"\n(\ncheckbox chk_DepthOfFieldActive \"Depth Of Field Active\" checked:vss.DepthOfFieldActive\nspinner spn_DepthOfFieldNearPlane \"Near Plane\" range:[0,10000000,vss.DepthOfFieldNearPlane] fieldwidth:50\nspinner spn_DepthOfFieldFarPlane \"Far Plane\" range:[0,10000000,vss.DepthOfFieldFarPlane] fieldwidth:50\nspinner spn_DepthOfFieldFocusPlane \"Focus Plane\" range:[0,10000000,vss.DepthOfFieldFocusPlane] fieldwidth:50\n)\non chk_ActivateViewportShading changed state do\nvss.ActivateViewportShading = state\non ddl_ShadingQuality selected itm do\nvss.ShadingQuality = (#(#Good, #Best))[itm]\non chk_TonemappingActive changed state do\nvss.TonemappingActive = state\non chk_ShadowsActive changed state do\nvss.ShadowsActive = state\non ddl_ShadowMode selected itm do\nvss.ShadowMode = (#(#Hard, #Soft))[itm]\non spn_CubeBias changed val do\nViewportSSB.CubeBias = val\non spn_ShadowMapSize changed val do\nViewportSSB.ShadowMapSize = 2^val\non chk_AreaShadow changed state do\nViewportSSB.AreaShadow = state\non chk_TransAreaShadow changed state do\nViewportSSB.TransAreaShadow = state\non ddl_AmbientOcclusionMode selected itm do\nvss.AmbientOcclusionMode = (#(#AOOff,#AOOnly,#AOComposite))[itm]\non ddl_AmbientOcclusionQuality selected itm do\nvss.AmbientOcclusionQuality = (#(#Low,#Medium,#High))[itm]\non spn_AmbientOcclusionRadius changed val do\nvss.AmbientOcclusionRadius = val\non spn_AmbientOcclusionStrength changed val do\nvss.AmbientOcclusionStrength = val\non ddl_IndirectLightingMode selected itm do\nvss.IndirectLightingMode = (#(#ILOff,#ILOnly,#ILAOComposite))[itm]\non ddl_IndirectLightingQuality selected itm do\nvss.IndirectLightingQuality = (#(#Low,#Medium,#High))[itm]\non spn_IndirectLightingRadius changed val do\nvss.IndirectLightingRadius = val\non chk_DepthOfFieldActive changed state do\nvss.DepthOfFieldActive = state\non spn_DepthOfFieldNearPlane changed val do\nvss.DepthOfFieldNearPlane = val\non spn_DepthOfFieldFarPlane changed val do\nvss.DepthOfFieldFarPlane = val\non spn_DepthOfFieldFocusPlane changed val do\nvss.DepthOfFieldFocusPlane = val\n)\ncreateDialog Viewport_Shading_Explorer_Dialog 200 605\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_25391960FED849F1AA44B1C193531AD9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-271F\"></a> <span class=\"char_link\"><a href=\"GUID-C0F9BB42-F3A6-48E3-BD0E-E660CB987F71.htm\">Interface: IViewportShadingMgr</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-271E\"></a> <span class=\"char_link\"><a href=\"GUID-6201E848-41CF-4A78-90B5-1A545D33944D.htm\">Interface: ViewportSSB</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-271D\"></a> <span class=\"char_link\"><a href=\"GUID-DE30E7CB-EDC3-4EF7-8457-A9F63F6EF60C.htm\">Interface: INodeShadingProperties</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-25EC\"></a> <span class=\"char_link\"><a href=\"GUID-34892DB6-E840-4F52-9175-30332799B7B1.htm\">Interface: NitrousGraphicsManager</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";