var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface AssetManager\">\n      <meta name=\"indexterm\" content=\"AssetManager Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: AssetManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15\"></a><div class=\"head\">\n            <h1>Interface: AssetManager </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D3C\"></a>The \n            		<em class=\"strong\">AssetManagerCore Interface</em> introduced in \n            		<em class=\"strong\">3ds Max 2010</em> manages the saving of Asset data into the \n            		<em class=\"strong\">3ds Max</em> scene file. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D3A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D39\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces </a></span> &gt; AssetManager \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D37\"></a>In releases prior to \n            		<em class=\"strong\">3ds Max 2010</em>, a plug-in that referenced an external file (an asset) holds the asset’s filename\n            as a string or as a Path object, and stores the filename to the \n            		<em class=\"strong\">3ds Max</em> scene file as a string or an IParameterBlock2 TYPE_FILENAME parameter. To allow \n            		<em class=\"strong\">3ds Max</em> to identify the assets used by a plug-in, the plug-in implements an IAssetAccessor-derived\n            class. The information provided from this class was primarily used by the Asset Tracker.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D36\"></a>Since \n            		<em class=\"strong\">3ds Max 2010</em>, assets are handled as instances of class \n            		<em class=\"strong\">AssetUser</em> . An instance of this class contains information on the asset filename, its type,\n            and the \n            		<em class=\"strong\">3ds Max</em> scene file that depends on it (this is used for resolving external references). Access\n            to, and lifetime management of assets is handled by the \n            		<em class=\"strong\">Asset Manager</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D35\"></a>Loading and saving the Asset to the \n            		<em class=\"strong\">3ds Max</em> scene file is now done through the \n            		<span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">AssetUser</a></span> and the \n            		<em class=\"strong\">AssetManager</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D34\"></a>When saving a \n            		<em class=\"strong\">3ds Max</em> scene, the asset data is saved by the Asset Manager to a \n            		<em class=\"strong\">separate stream</em> in the \n            		<em class=\"strong\">3ds Max</em> file. This gives the capability to external programs to access the asset data to\n            identify the assets used by the scene and potentially modify the asset data without\n            loading the scene file into \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D33\"></a>The following methods expose the information handled by the AssetManager to MAXScript:\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D32\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D31\"></a> \n            <h2><a name=\"GUID-7B4792FB-8088-41E7-9F23-03AF9CB139AE\"></a> <em class=\"strong\">Get Asset</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C6E\"></a><pre>&lt;IObject&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetAsset</em> &lt;filename&gt;fileName &lt;enum&gt;assetType <em class=\"codeEmphasisStrong\">autoAcquire</em>:&lt;bool&gt; 		\n\nassetType enums: {<em class=\"codeEmphasisStrong\">#Other | #Bitmap | #XRef | #Photometric | #Animation | #VideoPost | #BatchRender | #ExternalLink | #RenderOutput | #PreRenderScript | #PostRenderScript | #Sound | #Container | #MaxCreationGraph</em>} 		\nautoAcquire default value: true 	   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D2C\"></a>Returns the \n               		  <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">AssetUser Object</a></span> of the asset with the specified file name and asset type. \n               		\n            </p> \n            <p><a name=\"GUID-819D01B2-5EA4-4B45-84E8-D7F4AD3B629A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C6B\"></a><pre>&lt;IObject&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetAssetByIndex</em> &lt;index&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D29\"></a>Returns the \n               		  <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">AssetUser Object</a></span> of the asset with the given index. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D28\"></a>Use \n               		  <span class=\"code\"> <em class=\"strong\">AssetManager.GetNumAssets()</em> </span> to get the number of Assets. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D27\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm#WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7B5D\">example at the end of this topic</a></span> for details. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;IObject&gt;<em class=\"codeEmphasisStrong\">GetAssetById</em> &lt;&amp;TSTR&gt;assetid\n\nassetid is In parameter</pre></div> \n            <p> Returns the \n               		  <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">AssetUser Object</a></span> of the asset with the given asset ID. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>. \n               		\n            </p> <a name=\"TABLE_CEA541A402DF4CA3A6C390AB8EB2330A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nbox material:(standard diffusemap:(bitmaptexture filename:\"fur.tga\"))\n--&gt; $Box:Box002 @ [0.000000,0.000000,0.000000]\nassetid = (assetmanager.GetAssetByIndex 1).GetAssetId(); \n--&gt; \"{DBD187ED-0BA9-4D07-9B85-BA44F5170FD9}\"\nassetmanager.GetFileName assetid\n--&gt; \"fur.tga\"	\na=assetmanager.GetAssetById assetid\n--&gt; &lt;IObject:AssetUser&gt;\na.GetFileName()\n--&gt; \"fur.tga\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D25\"></a> \n            <h2><a name=\"GUID-6AD9A7BD-58EA-4C18-A1EE-666AD2291108\"></a> <em class=\"strong\">Get Asset ID and File Name</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C6A\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetAssetId</em> &lt;filename&gt;fileName &lt;enum&gt;assetType \n\nassetType enums: {<em class=\"codeEmphasisStrong\">#Other | #Bitmap | #XRef | #Photometric | #Animation | #VideoPost | #BatchRender | #ExternalLink | #RenderOutput | #PreRenderScript | #PostRenderScript | #Sound | #Container | #MaxCreationGraph</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D21\"></a>Returns the asset ID of the specified file name of the given asset type. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D1F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D1E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C67\"></a><pre>\nAssetManager.GetAssetID \"Simple_Stone_Mtl_Marble_bump.jpg\" #Bitmap\n\"{7477A3A4-0304-47AC-8427-6B490673231A}\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-F80BCBAC-6F23-4F33-A83D-FA6CD0699A5D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C66\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetFileName</em> &lt;&amp;TSTR&gt;assetid \n\nassetid is In parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D15\"></a>Returns the file name of the asset with the given AssetID. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D13\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D12\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C63\"></a><pre>\nAUIO = AssetManager.GetAssetByIndex 1--get the AsserUser with index 1\n--&gt;&lt;IObject:AssetUser&gt;\n&nbsp;\nAUIO.GetFileName()--get the file name\n--&gt;\"Untitled Scene\"\n&nbsp;\n--This is equivalent:\nAssetManager.GetFileName (AUIO.getAssetID())--get the name by AssetID\n--&gt;\"Untitled Scene\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D05\"></a> \n            <h2><a name=\"GUID-CF3FC396-A259-481A-87D7-5C5732F85EB4\"></a> <em class=\"strong\">Add and Release Reference</em> \n            </h2> \n            <p><a name=\"GUID-BD224E5C-55E0-4EE8-826B-CFCD4B38CEB6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C62\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetNumReference</em> &lt;&amp;TSTR&gt;assetid \n\nassetid is In parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D02\"></a>Returns the number of the References to the Asset with the given AssetID. \n               		\n            </p> \n            <p><a name=\"GUID-E4636F37-5DDC-4548-95CE-EA0BFAED908D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C5F\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">AssetManager.AddReference</em> &lt;&amp;TSTR&gt;assetid \n\nassetid is In parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CFE\"></a>Adds a Reference to the Asset with the given AssetID. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CFD\"></a>Returns true on success, false on failure. \n               		\n            </p> \n            <p><a name=\"GUID-C7A54262-5B88-466A-84B9-FDF9D514B5BF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C5C\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">AssetManager.ReleaseReference</em> &lt;&amp;TSTR&gt;assetid \n\nassetid is In parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CF9\"></a>Releases the Reference of the Asset with the given AssetID. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CF8\"></a>Returns true on success, false on failure. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CF6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CF5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C59\"></a><pre>\nAUIO = AssetManager.GetAssetByIndex 1--get the AsserUser with index 1\n--&gt;&lt;IObject:AssetUser&gt;\n&nbsp;\nAID =AUIO.getAssetID()--get the file name\n--&gt;\"{7477A3A4-0304-47AC-8427-6B490673231A}\"\n&nbsp;\nAssetManager.GetNumReference AID--get the reference numberby AssetID\n--&gt;4\n&nbsp;\nAssetManager.AddReference AID--add a referenceby AssetID\n--&gt;true\n&nbsp;\nAssetManager.GetNumReference AID--get thereference numberby AssetID\n--&gt;5\n&nbsp;\nAssetManager.ReleaseReference AID--release a referenceby AssetID\n--&gt;true\n&nbsp;\nAssetManager.GetNumReference AID--get thereference numberby AssetID\n--&gt;4\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CDD\"></a> \n            <h2><a name=\"GUID-9955117A-2CD6-4AE5-B7A4-05D25F1EB932\"></a> <em class=\"strong\">Get Number of Assets and AssetUsers</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5625\"></a><pre>&lt;INT64&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetNumAssetUsersCreated</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CDB\"></a>Returns the total number of AssetUser instances created during the current \n               		  <em class=\"strong\">3ds Max</em> session. \n               		\n            </p> \n            <p><a name=\"GUID-C26DAA19-2CE4-4DCD-9C53-212C1833E816\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5624\"></a><pre>&lt;INT64&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetNumAssetUsers</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CD8\"></a>Returns the number of AssetUser instances. \n               		\n            </p> \n            <p><a name=\"GUID-258C6C38-B812-4712-9CFB-10E7F707C4E9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5623\"></a><pre>&lt;INT64&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetNumAssetsCreated</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CD5\"></a>Returns the total number of Assets created during the current \n               		  <em class=\"strong\">3ds Max</em> session. \n               		\n            </p> \n            <p><a name=\"GUID-BEA6F364-75D1-4F76-AEE1-27C10CDF1F07\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5622\"></a><pre>&lt;INT64&gt;<em class=\"codeEmphasisStrong\">AssetManager.GetNumAssets</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CD2\"></a>Returns the number of Assets. \n               		\n            </p> \n            <p><a name=\"GUID-CFD91E51-658E-4650-A179-0428180AB06E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CD0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CCF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5621\"></a><pre>\nAssetManager.GetNumAssetUsersCreated()\n--&gt;19862L\n&nbsp;\nAssetManager.GetNumAssetUsers()\n--&gt;114L\n&nbsp;\nAssetManager.GetNumAssetsCreated()\n--&gt;1080L\n&nbsp;\nAssetManager.GetNumAssets()\n--&gt;18L\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-663AD41C-C4E1-4D92-9E31-DCBD9625ADE4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">AssetManager.RemoveMissingAssets</em>()</pre></div> \n            <p><a name=\"GUID-3BF76BC6-71D7-40E0-AE42-FFB79D0A790A\"></a> Removes any missing assets. \n               		\n            </p> \n            <p><a name=\"GUID-CA089257-6D71-4DD6-AB39-2BB385FBD462\"></a> Returns True if missing assets were removed successfully. \n               		\n            </p> \n            <p><a name=\"GUID-22EBF7E0-F04E-4AC6-AF8B-4B449FF198C5\"></a> Returns False if no missing assets were removed. \n               		\n            </p> \n            <p><a name=\"GUID-3F0E5633-D2A6-4133-90DA-D50A2FD36CC8\"></a> Available in \n               		  <em class=\"strong\">3ds Max 2016 and higher</em>. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-2EF5785512B7835A83D-7B5D\"></a> \n               <h3><a name=\"GUID-A9919BB8-93D1-4775-955F-6D1CEFBB974F\"></a> <em class=\"strong\">Examples:</em> \n               </h3> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CBF\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CBE\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CBD\"></a><p class=\"table-body\">The following script outputs to the MAXScript Listener the ID, type, and file name\n                              of all Assets in the current scene: \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5620\"></a><pre>\n--Loop through all Asset indices:\nfor i = 1 to AssetManager.GetNumAssets() do\n(\nlocal AUIO = AssetManager.GetAssetByIndex i--get the AssetUser IObject\nlocal AID = AUIO.GetAssetId()--get the Asset\'s ID\nlocal AType = AUIO.getType()--get the Asset\'s Type\nlocal AFile = AUIO.getfilename()--get the Asset\'s File Name\nformat\"ID:% Type:% File:%\\n\"AID AType AFile--format the info\n)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6CB1\"></a><p class=\"table-body\"> <em class=\"strong\">POSSIBLE OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-561F\"></a><pre>\nID:{B6D86A17-85FF-42E2-99D4-BB2F1857C4FB} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\PlaneToBake_diffuse.tga\nID:{7477A3A4-0304-47AC-8427-6B490673231A} Type:#bitmap File:Simple_Stone_Mtl_Marble_bump.jpg\nID:{8188ACCD-A014-4B24-A3DD-697269D8BFDB} Type:#bitmap File:Simple_Concrete_Mtl_BroomStraight_pattern.jpg\nID:{B0B6A6FD-2B76-4EA0-8B34-D1F3F3596F91} Type:#bitmap File:x47645df4\nID:{CF096A5C-41C8-43FD-852F-8823B9A707C7} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsmax\\renderoutput\\AssetMan_.tga\nID:{D5A9608F-EE4E-4BDC-AAB6-93D3D34E5F65} Type:#bitmap File:Simple_Concrete_Mtl_BroomCurved_pattern.jpg\nID:{30241317-2623-4628-9BF1-ED06449E3D06} Type:#bitmap File:Simple_Metal_Mtl_DiamondPlate_pattern.jpg\nID:{742F4FE3-91FC-48E7-9F3B-37CE76D37046} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Sphere01_diffuse.tga\nID:{8BEFCD25-F133-4D5E-8678-E710F8BFBFF8} Type:#bitmap File:Simple_Metal_Mtl_CheckerPlate_pattern.jpg\nID:{21B0F246-C6D0-44D3-9ECE-87D7BF8AFF14} Type:#bitmap File:Simple_Metal_Mtl_Break_pattern.jpg\nID:{B5BB9B91-DBB4-486B-835A-A107F9F4783F} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\PlaneToBake_lighting.tga\nID:{65CAE8F4-F0DF-4CC3-A05C-733CC0285CF4} Type:#bitmap File:C:\\Program Files\\Autodesk\\3ds Max 2010\\CachedThumbnails\\1000000000000003.bmp\nID:{5FF857B0-D2E0-4DCC-B4F7-97248CBC6FC5} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Sphere01LightingMap.tga\nID:{31FE4D48-12B5-422E-A5D2-3A2979D773CD} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Sphere01_lighting.tga\nID:{6AC17983-685D-42A8-8269-DBEA5FECB0DB} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Plane01_lighting.tga\nID:{9BEAD40C-2562-42CF-A95D-E13E0EBD526D} Type:#bitmap File:C:\\Program Files\\Autodesk\\3ds Max 2010\\CachedThumbnails\\1000000000000004.bmp\nID:{2253E2F5-82FE-46B1-B012-BC5FA100D86A} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Sphere01DiffuseMap.tga\nID:{42B8F3F4-0D38-49D9-A9D9-598288A4E674} Type:#renderoutput File:C:\\Documents and Settings\\username\\My Documents\\3dsmax\\renderoutput\\AssetMan_.tga\nID:{AC8AF90A-44DB-42C9-AC9E-7C35A7EBFF1A} Type:#bitmap File:C:\\Documents and Settings\\username\\My Documents\\3dsMax\\sceneassets\\images\\Plane01_diffuse.tga\nID:{A9742E5A-4AB4-471D-A440-DE47F5262EF9} Type:#bitmap File:Simple_Stone_Mtl_Granite_bump.jpg\nID:{8EC0A624-D996-48D7-9AA8-775ACA1652B9} Type:#xref File:C:\\Documents and Settings\\username\\My Documents\\3dsmax\\scenes\\RENOIR\\AssetManagerTest.max\nID:{B51DCC8A-57C6-4308-B5B8-00FE0A105A29} Type:#bitmap File:Simple_Stone_Mtl_StoneWall_bump.jpg\nID:{16544B6C-5D81-4E96-9B4D-550BFD4111E3} Type:#bitmap File:Simple_Metal_Mtl_Brush_pattern.jpg\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6C95\"></a> <em class=\"strong\">See also</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6C94\"></a> <span class=\"char_link\"><a href=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866.htm\">Accessing AssetManager, AssetUser and Asset Metadata in MAX Files</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6C92\"></a> <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">IObject:AssetUser</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6C91\"></a> <span class=\"char_link\"><a href=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6.htm\">MAX File Asset Metadata Stream Access</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6C90\"></a> <span class=\"char_link\"><a href=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358.htm\">Interface: FileResolutionManager</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";