var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E59FCB9A-04C0-4228-9779-4FD74F2D35AD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"The Super Class ID and the Class ID\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>The Super Class ID and the Class ID</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E59FCB9A-04C0-4228-9779-4FD74F2D35AD\"></a><div class=\"head\">\n            <h1>The Super Class ID and the Class ID </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5563\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5562\"></a> Plug-ins of all types create MAX system objects. These are not the 3D objects that\n               appear in a scene, but objects in the C++ sense. There are two IDs associated with\n               each plug-in system object. These are the Super Class ID and the Class ID. The Super\n               Class ID specifies what super-class of MAX the plug-in class is a sub-class of. The\n               Class ID differentiates between the various plug-ins for a super-class. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5560\"></a>MAXScript provides a method to generate a fresh random class ID each time you run\n               it: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7233\"></a><pre><em class=\"codeEmphasisStrong\">genClassID</em> [<em class=\"codeEmphasisStrong\">returnValue:</em>&lt;boolean&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-555D\"></a>This method generates a random class ID similar to #(0x9b7ea231, 0xb6db86ef), and\n               prints it to Listener if <span class=\"code\"> <em class=\"strong\">returnValue</em> </span> is not supplied or set to <span class=\"code\"> <em class=\"strong\">false</em> </span>. You can cut and paste this class ID into your script to use the generated ID. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-555C\"></a>If <span class=\"code\"> <em class=\"strong\">returnValue</em> </span> is <span class=\"code\"> <em class=\"strong\">true</em> </span>, the classid is not printed to the Listener, rather a 2 element array containing\n               the 2 parts of the class ID is returned. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-555B\"></a>MAX, and each plug-in falls into one of these predefined categories define the Super\n               Class IDs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-555A\"></a>For instance, all Texture Map plug-ins share the same Super Class ID of TEXMAP_CLASS_ID.\n               Each individual texture map plug-in has its own unique Class ID however. Thus, the\n               Super Class ID defines which kind of object it is, the Class ID uniquely identifies\n               a specific plug-in class. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5558\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5557\"></a> <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Scripted Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5556\"></a> <span class=\"char_link\"><a href=\"GUID-258F6015-6B45-4A87-A7F5-BB091A2AE065.htm\">Menu Manager</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";