var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E6FD6664-B41B-4FF4-9086-D0EAAC6BD6A8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"language\">\n      <meta name=\"indexterm\" content=\"keywords\">\n      <meta name=\"indexterm\" content=\"reserved: keywords\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Language Reserved Keywords</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E6FD6664-B41B-4FF4-9086-D0EAAC6BD6A8\"></a><div class=\"head\">\n            <h1>Language Reserved Keywords </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E863A3\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863A4\"></a>   Keywords begin or separate portions of MAXScript commands. \n            </p> \n            <p><a name=\"P_714A04BFC7E244EDA113B02E0C25D6A5\"></a>For example, one form of the <span class=\"code\"> <em class=\"strong\">if</em> </span> expression is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-626E\"></a><pre><em class=\"codeEmphasisStrong\">if</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">then</em> &lt;expr&gt; [<em class=\"codeEmphasisStrong\">else</em>&lt;expr&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863A9\"></a>In order for MAXScript to easily identify the various portions of the <span class=\"code\"> <em class=\"strong\">if</em> </span> expression, the words <span class=\"code\"> <em class=\"strong\">if</em> </span>,<span class=\"code\"> <em class=\"strong\">then</em> </span> and <span class=\"code\"> <em class=\"strong\">else</em> </span> are reserved keywords and can not be used as variable names or identifiers. So, for\n               example, you cannot declare a variable or function called <span class=\"code\"> <em class=\"strong\">if</em> </span>. \n            </p> \n            <p><a name=\"P_3F45E9E5624B4BF49F239D1B7F8C6A04\"></a>The following table lists all MAXScript reserved keywords. Click a reserved keyword\n               to go to a description of its usage. In some cases, a keyword may have more additional\n               meanings, depending on its context. This information is also summarized in <span class=\"char_link\"><a href=\"GUID-46ECBAD7-35E9-43BD-8A8C-849772924805.htm\">MAXScript Grammar</a></span>. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AA\"></a> \n               <h3><a name=\"GUID-C0F45518-E1B9-4B01-A583-B725DFDEE187\"></a> <em class=\"strong\">Reserved Keywords</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AB\"></a> <span class=\"char_link\"><a href=\"GUID-E4732A5D-91C4-4EDD-8944-F00E7DC57D10.htm\">about</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AC\"></a> <span class=\"char_link\"><a href=\"GUID-7C65C77D-3C74-482B-ACC2-3D5D879DD99C.htm\">and</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AD\"></a> <span class=\"char_link\"><a href=\"GUID-CC2D2450-AECD-4732-BF93-4AA91ED0BC56.htm\">animate</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AE\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">as</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863AF\"></a> <span class=\"char_link\"><a href=\"GUID-4E9CCD61-F575-42E1-8654-315DDF6C6A26.htm\">at</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B0\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">by</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B1\"></a> <span class=\"char_link\"><a href=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439.htm\">case</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B2\"></a> <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm\">catch</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B3\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">collect</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B4\"></a> <span class=\"char_link\"><a href=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8.htm\">continue</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B5\"></a> <span class=\"char_link\"><a href=\"GUID-6C7219CF-B9B7-4B18-A846-5522A9D970F3.htm\">coordsys</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B6\"></a> <span class=\"char_link\"><a href=\"GUID-EAD55DDE-6C7C-44CB-8BC8-34905BC05BE5.htm\">do</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B7\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">else</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B8\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">exit</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863B9\"></a> <span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">fn</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BA\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">for</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BB\"></a> <span class=\"code\"> <em class=\"strong\">from</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BC\"></a> <span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">function</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BD\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">global</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BE\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">if</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863BF\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">in</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C0\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">local</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C1\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">macroscript</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C2\"></a> <span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">mapped</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C3\"></a> <span class=\"char_link\"><a href=\"GUID-A96857E7-73FE-4F42-BE71-E8185356F4C9.htm\">max</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C4\"></a> <span class=\"char_link\"><a href=\"GUID-7C65C77D-3C74-482B-ACC2-3D5D879DD99C.htm\">not</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C5\"></a> <span class=\"char_link\"><a href=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439.htm\">of</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C6\"></a> <span class=\"char_link\"><a href=\"GUID-233CEDB5-0A54-4843-93DA-73C1E714C070.htm\">off</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C7\"></a> <span class=\"char_link\"><a href=\"GUID-1361B847-7878-4C52-98DE-5BC5CA830B40.htm\">on</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C8\"></a> <span class=\"char_link\"><a href=\"GUID-7C65C77D-3C74-482B-ACC2-3D5D879DD99C.htm\">or</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863C9\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">parameters</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CA\"></a> <span class=\"char_link\"><a href=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186.htm\">persistent</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CB\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">plugin</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CC\"></a> <span class=\"char_link\"><a href=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8.htm\">rcmenu</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CD\"></a> <span class=\"char_link\"><a href=\"GUID-07D714FC-B207-4BBF-9590-16C93C631F50.htm\">return</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CE\"></a> <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">rollout</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863CF\"></a> <span class=\"char_link\"><a href=\"GUID-D4660B55-E229-4155-9B4B-EE13178D4E8D.htm\">set</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D0\"></a> <span class=\"char_link\"><a href=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6.htm\">struct</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D1\"></a> <span class=\"char_link\"><a href=\"GUID-9294EF2F-B785-462A-B30E-19CDE2CE2809.htm\">then</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D2\"></a> <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm\">throw</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D3\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">to</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D4\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">tool</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D5\"></a> <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm\">try</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D6\"></a> <span class=\"char_link\"><a href=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11.htm\">undo</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D7\"></a> <span class=\"char_link\"><a href=\"GUID-B478B60B-B27D-4916-A07E-264818666080.htm\">utility</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D8\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">when</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863D9\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">where</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863DA\"></a> <span class=\"char_link\"><a href=\"GUID-EAD55DDE-6C7C-44CB-8BC8-34905BC05BE5.htm\">while</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863DB\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">with</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E863DC\"></a>&nbsp; \n               </p> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A313\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"code\"> <em class=\"strong\">from</em> </span> keyword is reserved, but not currently used. \n                  </div>\n               </div> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";