var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E7584E94-8696-421E-920C-2A83FCD9ABBF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"globalVars Structure\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>globalVars Structure</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E7584E94-8696-421E-920C-2A83FCD9ABBF\"></a><div class=\"head\">\n            <h1>globalVars Structure </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ADC\"></a> The \n            		<em class=\"strong\">globalVars struct</em> provides methods to collect, create, test and remove global variables. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ADE\"></a>These methods are available in \n            		<em class=\"strong\">3ds Max 2008</em> and higher. \n            	 \n         </p>\n         <p><a name=\"P_F8F2C0C6BDD94D9AB53208EF07301A27\"></a>They were previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_C48E69B96AC44BCF843E98E5AE98C470\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"P_211CF7B74DC745149ABDF74818CCC0B3\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-618D\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.get</em> &lt;global var name&gt; 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE1\"></a>Returns the value of the specified global variable. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE2\"></a>The argument must be a MAXScript name value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE3\"></a>The global variable name must exist, otherwise a runtime error will be generated.\n            \n            	 \n         </p>\n         <p><a name=\"P_597DC32674654AA1B3F30BF6B2171136\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-618C\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.set</em> &lt;global var name&gt; &lt;value&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE6\"></a>Sets the value of the specified global variable. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE7\"></a>The argument must be a MAXScript name value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AE8\"></a>The global variable name must exist, otherwise a runtime error will be generated.\n            \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AEA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86AEB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-618B\"></a><pre>\nglobalVars.get #dontknow --try to get an undeclared variable\n-- Runtime error: Specified global variable does not exist: #dontknow\nglobal dontknow = \"Now I Know\" --declare the variable\n--&gt; \"Now I Know\"\nglobalVars.get #dontknow --now we can get and set the value\n--&gt; \"Now I Know\"\nglobalVars.set #dontknow \"I Still Know What You Did Last Siggraph\"\n--&gt; \"I Still Know What You Did Last Siggraph\"\nglobalVars.set #reallydontknow \"MAXScript\"\n-- Runtime error: Specified global variable does not exist: #reallydontknow\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_2708A421E67B4586A40CA011C88C6554\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-618A\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.gather</em> [filter:&lt;function&gt;] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AFB\"></a>Returns an array of all global variable names declared in the current session. \n            	 \n         </p>\n         <p> Available \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>: The optional filter parameter is a two argument function that returns either true\n            or false. The first argument is the global variable\'s name, and the second argument\n            is the global variable\'s value. If the filter function returns true, the variable\n            is gathered. \n            	 \n         </p><a name=\"TABLE_62F8EA2B693744ACA6C1C7CD2C2F49F0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nro_controls = globalvars.gather filter:(fn filterfn n v = (iskindof v rolloutcontrol))\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_4B9FEFB294C24F6BA1C5070896ED731C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6189\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.isglobal</em> &lt;var name&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AFE\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified variable name is global, false if it is not global or not declared.\n            \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AFF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B00\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE (CONTINUED FROM PREVIOUS EXAMPLE)</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6188\"></a><pre>\nglobalVars.isglobal #dontknow --declared in previous example\n--&gt; true\nglobalVars.isglobal #reallydontknow --still notdeclared\n--&gt; false\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_7CCED928124A4AAB9C23D3E79D11B986\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6187\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.getTypeTag</em> &lt;var name&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B09\"></a>Returns the type of the global variable as an integer or name value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0A\"></a>The specified global variable name must exist. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0B\"></a> <em class=\"strong\">This method is mainly for internal testing.</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0C\"></a>The primary type tag values are: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0D\"></a>10 - general global \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0E\"></a>11 - constant global \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B0F\"></a>12 - system global \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B10\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B11\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE (CONTINUED FROM PREVIOUS EXAMPLE)</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6186\"></a><pre>\nglobalVars.getTypeTag #dontknow --declared in previous example\n--&gt; 10P\nglobalVars. getTypeTag #reallydontknow --variable does not exist\n-- Runtime error: Specified global variable does not exist: #reallydontknow\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B19\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.getValueTag </em>&lt;var name&gt; 		</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1A\"></a>Returns the type of the value in the global variable as an integer or name value.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1B\"></a>The specified global variable name must exist. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1C\"></a> <em class=\"strong\">This method is mainly for internal testing.</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1D\"></a>Each value type has its own tag value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B1F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6185\"></a><pre>\nglobal aString = \"I Know Kung-Fu!\"\n--&gt; \"I Know Kung-Fu!\"\nglobal aFloat = 123.456\n--&gt; 123.456\nglobal anInt = 42\n--&gt; 42\nglobal aMatrix = matrix3 1\n--&gt; (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])\nglobalVars.getValueTag #aString\n--&gt; #String\nglobalVars.getValueTag #aFloat\n--&gt; #float\nglobalVars.getValueTag #anInt\n--&gt; #integer\nglobalVars.getValueTag #aMatrix\n--&gt; #Matrix3\nglobalVars.getValueTag #reallydontknow\n-- Runtime error: Specified global variable does not exist: #reallydontknow\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_D3C9B6FE30F548DA935DB011B13FC4CC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6184\"></a><pre><em class=\"codeEmphasisStrong\">globalVars.remove</em> &lt;var name&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B36\"></a>Removes the specified variable name from the list of global variables. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B37\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                  </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B3A\"></a><p class=\"table-body\"> <em class=\"strong\">Use With Caution!</em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B3E\"></a> <span class=\"char_link\"><a href=\"GUID-A2F1412A-0EF7-405B-A4A2-6F169A838C4C.htm\">Persistents Structure</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B40\"></a> <span class=\"char_link\"><a href=\"GUID-A3520718-09E9-4AFE-9CE0-B7BE62E97823.htm\"> Variables - Assignment and Scope</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B41\"></a> <span class=\"char_link\"><a href=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04.htm\"> Variable Assignment</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B43\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B44\"></a> <span class=\"char_link\"><a href=\"GUID-3E792B8C-AF02-4178-9651-EDDB1341B68D.htm\">Specifying Global Variables As Global Using ::</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";