var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E75D8D72-53D4-4306-BD8C-25D7363A7050\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"vertex animation\">\n      <meta name=\"indexterm\" content=\"scripting vertex and control point animation\">\n      <meta name=\"indexterm\" content=\"animation\">\n      <meta name=\"indexterm\" content=\"animateVertex()\">\n      <meta name=\"indexterm\" content=\"animateAll()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripting Vertex and Control Point Animation</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E75D8D72-53D4-4306-BD8C-25D7363A7050\"></a><div class=\"head\">\n            <h1>Scripting Vertex and Control Point Animation </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CD2\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CD1\"></a>     You can add animation to vertices in editable meshes, spline shapes and FFD modifiers\n               using the <span class=\"code\"> <em class=\"strong\">animateVertex()</em> </span> method. Its syntax is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FFA\"></a><pre><em class=\"codeEmphasisStrong\">animateVertex</em> &lt;node_or_ffd_modifier&gt; &lt;vertex_spec&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CCA\"></a>Animates one or more vertex, knot, or control point, where <span class=\"code\"> <em class=\"strong\">&lt;vertex_spec&gt;</em> </span> is one of \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FF9\"></a><pre>&lt;index&gt;\n&lt;index_array&gt;\n<em class=\"codeEmphasisStrong\">#all</em> <em class=\"codeEmphasisStrong\">#selected</em> -- not applicable for FFD modifiers   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CC5\"></a>For FFD modifiers, the <span class=\"code\"> <em class=\"strong\">animateAll()</em> </span> method will animate all the control points, and is equivalent to <span class=\"code\"> <em class=\"strong\">animateVertex &lt;ffd_modifier&gt; #all</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CC4\"></a>Its syntax is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FF8\"></a><pre><em class=\"codeEmphasisStrong\">animateAll</em> &lt;ffd_modifier&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CC2\"></a>Animates all control points. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CC1\"></a>The <span class=\"code\"> <em class=\"strong\">animateVertex()</em> </span> and <span class=\"code\"> <em class=\"strong\">animateAll()</em> </span> methods effectively assign controllers to editable meshes, spline shapes and FFD\n               modifiers which make them appear as animatables in the Track View, allowing further\n               scripting of these vertex animation controllers. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CC0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CBF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FF7\"></a><pre>\nanimateVertex $line01 2\nanimateVertex $box01 # (2,3,4,5)\nanimateAll $box01.ffd_3x3x3\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB8\"></a>These <span class=\"code\"> <em class=\"strong\">animateVertex()</em> </span> method only work on editable meshes, spline shapes and FFD modifiers and will report\n               an error if applied to other types of objects. You can use the functions <span class=\"code\"> <em class=\"strong\">convertToMesh()</em> </span> and <span class=\"code\"> <em class=\"strong\">convertToSplineShape()</em> </span> to convert existing geometry into the needed forms. Note that Line objects are SplineShapes\n               already and don\'t need conversion. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB7\"></a>The vertices to be animated are specified by index number, with the keyword <span class=\"code\"> <em class=\"strong\">#all</em> </span> to animate all vertices or control points, or <span class=\"code\"> <em class=\"strong\">#selected</em> </span> to animate the currently selected vertices. The <span class=\"code\"> <em class=\"strong\">#selected</em> </span> keyword is not applicable to FFD modifiers. In the case of SplineShapes, the vertex\n               index numbers are interpreted in a special way to accommodate tangent handles and\n               multiple curves, as follows: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB6\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB4\"></a>Each SplineShape vertex has <em class=\"strong\">three</em> indexes, one for each in-tangent handle, vertex, and out-tangent handle, in that\n                     order. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB2\"></a>The indexes run consecutively through each curve in a multi-curve shape, with the\n                     index number for the first in-tangent handle of a curve starting after the index of\n                     the last out-tangent handle in the prior curve. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB1\"></a>See Also <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> for details on accessing the vertices, tangents, or control points. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CB0\"></a>For information about scripting FFD control placement within FFD lattice space, See\n               Also the <span class=\"code\"> <em class=\"strong\">getModContextBBoxMin()</em> </span> and <span class=\"code\"> <em class=\"strong\">getModContextBBoxMin()</em> </span> functions, as described in <span class=\"char_link\"><a href=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD.htm\">Modifier Common Properties, Operators, and Methods</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3CAF\"></a>For editable meshes and spline shapes, the controller values assigned to the vertices,\n               knots, and tangent handles is in object space. See <span class=\"char_link\"><a href=\"GUID-3B001F21-8FE9-4663-A972-E648682A0ACD.htm\">Using Node Transform Properties</a></span>for information on converting between world space to object space. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";