var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E7FBAD67-2B3F-42B4-9C91-81E1F40087AB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"source code layout\">\n      <meta name=\"indexterm\" content=\"line breaks\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Source Code Layout</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E7FBAD67-2B3F-42B4-9C91-81E1F40087AB\"></a><div class=\"head\">\n            <h1>Source Code Layout </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E22\"></a>  The layout rules for MAXScript code are unlike those of most programming languages.\n            MAXScript gives you the advantage of freeform languages, such as C and C++, without\n            the need for extensive punctuation. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E25\"></a>MAXScript lets you break statements and expressions across lines wherever you want.\n            The line break can be in the middle of an expression. MAXScript reads your code until\n            the end of each line and determines whether it has a complete expression. If it does\n            not, it continues to read subsequent lines until it finds the rest of the expression.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E26\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E27\"></a><p class=\"table-body\"> <em class=\"strong\">Take as an example the following line:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-509A\"></a><pre>\na + b * c / d - e + f * g / h\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E2B\"></a>This line can be broken after any of the operators. MAXScript continues to read the\n            next line, because an operator needs another argument. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E2C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E2D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5099\"></a><pre>\na + b * c / d - e +\nf * g / h\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E32\"></a>You cannot break the example line as shown next and get the same result, because the\n            expression on the first line is a complete expression. MAXScript considers the two\n            lines as separate expressions, and the second line is now syntactically wrong, because\n            it starts with an operator: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E33\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E34\"></a><p class=\"table-body\"> <em class=\"strong\">WRONG SYNTAX:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5098\"></a><pre>\na + b * c / d - e\n+ f * g / h\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E39\"></a>If you do want to break a line at the end of a sub-expression, you can use the backslash\n            line continuation character: ’\\’. The previous example of an invalid break can be\n            made valid using the line continuation character after the ’r;e’: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E3A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E3B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5097\"></a><pre>\na + b * c / d - e \\\n+ f * g / h\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E40\"></a>Whenever MAXScript encounters a ’\\’ as the last character on a line (except for spaces,\n            tabs, or comments), it continues to read the next line as though the break were not\n            present. Line continuations can be useful for breaking up long or complex lines of\n            code, making them easier to read. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E41\"></a>MAXScript also lets you combine multiple statements and expressions in a single line.\n            The statements or expressions are separated with a ’;’ \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E42\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E43\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E45\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-41EBE44D-D7C3-4687-9D80-EC0749802472-low.gif\"></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E47\"></a>Sometimes it is useful to enter comments within your script to provide guidance or\n            context. You can enter comments in MAXScript by preceding your comment with a double-hyphen\n            --. As soon as MAXScript reaches the double-hyphen, it stops evaluating the rest of\n            that line. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E48\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E49\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E4B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-2D96B3CB-4356-410E-896A-2B8A8F57CF69-low.gif\"></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E4D\"></a> <em class=\"strong\">Next Topic</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E4E\"></a> <span class=\"char_link\"><a href=\"GUID-34C253DE-0F9F-4FB5-BBB1-4233F2C32477.htm\">Entering Information into MAXScript</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";