var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-E9C5AFAA-52A0-4274-A92C-8075C3BD0F25\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Brush Size and Color</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E9C5AFAA-52A0-4274-A92C-8075C3BD0F25\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Brush Size and Color </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2665\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2666\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Brush Size and Color \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2668\"></a>In this step of the Bitmap Painting tool development, we will add brush color and\n            size controls. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC266A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC266B\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC266C\"></a><p class=\"table-body\">We will extend the existing MacroScript by adding new UI controls to the rollout to\n                        define the Ink color and the Brush Size. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC266D\"></a><p class=\"table-body\">The paintbrush function will be changed to use the color defined by the UI color picker.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC266E\"></a><p class=\"table-body\">The drawStroke function will be enhanced to draw a large rectangle based on the defined\n                        size. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2670\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2671\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6416\"></a><pre>\nmacroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog MicroPaint_CanvasRollout)catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n &nbsp;bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n &nbsp;colorpicker inkColor height:16 modal:false color:black across:2\n &nbsp;spinner BrushSize\"Size\"range:[1,50,10] type:#integer fieldwidth:40\n&nbsp;\n &nbsp;fn paintBrush pos = (setPixels theCanvasBitmap pos #(inkColor.color))\n &nbsp;fn drawStroke lastPos pos =\n &nbsp;(\n  &nbsp;&nbsp;currentPos = lastPos\n  &nbsp;&nbsp;deltaX = pos.x - lastPos.x\n  &nbsp;&nbsp;deltaY = pos.y - lastPos.y\n  &nbsp;&nbsp;maxSteps = amax #(abs(deltaX),abs(deltaY))\n  &nbsp;&nbsp;deltaStepX = deltaX / maxSteps\n  &nbsp;&nbsp;deltaStepY = deltaY / maxSteps\n  &nbsp;&nbsp;for i = 0 to maxSteps do\n  &nbsp;&nbsp;(\n   &nbsp;&nbsp;&nbsp;for b = -BrushSize.value/2 to BrushSize.value/2 do\n    &nbsp;&nbsp;&nbsp;&nbsp;for c = -BrushSize.value/2 to BrushSize.value/2 do\n&nbsp;&nbsp;&nbsp;&nbsp;     &nbsp;paintBrush (currentPos + [c,b])\n   &nbsp;&nbsp;&nbsp;currentPos += [deltaStepX, deltaStepY]\n  &nbsp;&nbsp;)&nbsp;\n  &nbsp;&nbsp;theCanvas.bitmap = theCanvasBitmap\n &nbsp;)\n &nbsp;on MicroPaint_CanvasRollout lbuttondown pos do\n &nbsp;(\n  &nbsp;&nbsp;lastPos = pos\n  &nbsp;&nbsp;isDrawing = true\n  &nbsp;&nbsp;drawStroke lastPos pos\n &nbsp;)\n&nbsp; on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\n &nbsp;on MicroPaint_CanvasRollout mousemove pos do\n&nbsp; (\n  &nbsp;&nbsp;if isDrawing do drawStroke lastPos pos\n  &nbsp;&nbsp;lastPos = pos\n &nbsp;)\n)\ncreateDialog MicroPaint_CanvasRollout bitmapX (bitmapY+30)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26A4\"></a> \n            <h2><a name=\"GUID-5BE4320D-1320-444C-8C75-389190DD34E4\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6415\"></a><pre><em class=\"codeEmphasisMild\"><em class=\"codeEmphasisStrong\">--Code in italic has no changes since the previous version.</em></em> <em class=\"codeEmphasisMild\">macroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog CanvasRollout)catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\nbitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap</em> <em class=\"codeEmphasisStrong\">colorpicker inkColor height:16 modal:false color:black across:2</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26B4\"></a>This is the color picker which will be used to define the color of the paintbrush.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26B5\"></a> <span class=\"char_link\"><a href=\"GUID-A10F3B7A-B147-48E5-8ADC-CCDC60F5DB1B.htm\">Colorpicker</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6414\"></a><pre><em class=\"codeEmphasisStrong\">spinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26B7\"></a>This spinner will define the size of the paintbrush. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26B8\"></a> <span class=\"char_link\"><a href=\"GUID-411DB273-7B74-4FD7-89E9-B74B9CED102B.htm\">Spinner</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6413\"></a><pre><em class=\"codeEmphasisMild\">fn paintBrush pos = (setPixels theCanvasBitmap pos)\nfn drawAPoint lastPos pos =\n(\ncurrentPos = lastPos\ndeltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y\nmaxSteps = amax #(abs(deltaX),abs(deltaY))\ndeltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps\nfor i = 0 to maxSteps do\n(</em> <em class=\"codeEmphasisStrong\">for b = -BrushSize.value/2 to BrushSize.value/2 do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26C8\"></a>This new loop will define the vertical size of the brush. It counts from minus half\n               the size to plus half the size, full size altogether. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6412\"></a><pre><em class=\"codeEmphasisStrong\">for c = -BrushSize.value/2 to BrushSize.value/2 do</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26CA\"></a>This second loop defines the width of the paintbrush. It also loops from minus half\n               the size to plus half the size, full size altogether. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6411\"></a><pre><em class=\"codeEmphasisStrong\">paintBrush (currentPos + [c,b])</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26CC\"></a>After each iteration of the c loop, we call our paint Brush function, passing the\n               current position in the stroke plus the offset based on half the size of the brush\n               and the b loop. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6410\"></a><pre><em class=\"codeEmphasisMild\">)\ncurrentPos += [deltaStepX, deltaStepY]\n)&nbsp;\ntheCanvas.bitmap = theCanvasBitmap\n)\non MicroPaint_CanvasRollout lbuttondown pos do\n(\nlastPos = pos\nisDrawing = true\ndrawAPoint lastPos pos\n)\non MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\non MicroPaint_CanvasRollout mousemove pos do\n(\nif isDrawing do drawAPoint lastPos pos\nlastPos = pos\n)</em> <em class=\"codeEmphasisStrong\">createDialog MicroPaint_CanvasRollout bitmapX (bitmapY+30)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26DF\"></a>To accommodate the new User Interface controls for the color and brush size, we have\n               to increase the vertical size of the dialog by 30 pixels. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640F\"></a><pre><em class=\"codeEmphasisMild\">)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E2\"></a> \n            <h2><a name=\"GUID-8691B7CA-57EF-4602-BF79-EEC072AA4888\"></a> <em class=\"strong\">Result</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-9824C739-088F-4B3A-B6C7-BBE2C7530F4F-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E4\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E5\"></a> <span class=\"char_link\"><a href=\"GUID-89495341-DEA2-41D9-BFBB-543006E64CA2.htm\">How To ... Develop a Bitmap Painting Tool - Strokes Support</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E6\"></a> <em class=\"strong\">Next Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E7\"></a> <span class=\"char_link\"><a href=\"GUID-78460DD3-5FA4-4F68-990A-54D8D6092802.htm\">How To ... Develop a Bitmap Painting Tool - Airbrush and Shapes</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26E9\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";