var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rollout user-interface controls\">\n      <meta name=\"indexterm\" content=\"layout parameters - rollout user-interface controls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout User-Interface Controls Common Layout Parameters</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7\"></a><div class=\"head\">\n            <h1>Rollout User-Interface Controls Common Layout Parameters </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6619\"></a>The layout of user-interface items defined in a utility or rollout is, by default,\n            handled by MAXScript. \n         </p>\n         <p><a name=\"GUID-8B3A3EE3-9BEF-4887-B2B3-EB29084E842C\"></a>It places each successive interface item down the rollout, one below the other, horizontally\n            and vertically aligning them to match the layout conventions in the built-in <em class=\"strong\">3ds Max</em> command panels. \n         </p>\n         <p><a name=\"GUID-C9A667C3-E2E9-4049-AFF8-AFD0A3160644\"></a>For the most part, this works well, particularly for rollouts displayed in the Utilities\n            panel, because there is usually just enough room for one item across. \n         </p>\n         <p><a name=\"GUID-9FC6FEA8-9370-40E4-999E-AB8F5B89597F\"></a>In some cases, you may want to adjust or override the automatic layout and for this\n            there are a number of definition-line layout parameters you can use. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6618\"></a>The user-interface element <span class=\"code\">&lt;parameters&gt;</span> that can be supplied in the item definition varies with the item type and is defined\n            in each type\'s topic, for example spinner ranges, check box initial states, list box\n            contents, and so on. \n         </p>\n         <p><a name=\"GUID-AFF43E7D-6324-45C8-AAC9-44DA0AE759DA\"></a>There is, however, a set of common layout parameters that you can specify on any user-interface\n            item. \n         </p>\n         <p><a name=\"GUID-8CDBC975-2D65-4B0D-BD87-E56C6D5E627D\"></a>Except for the <span class=\"code\"> <em class=\"strong\">pos:</em> </span> parameter, these parameters are not properties of the user-interface item and cannot\n            be accessed or changed by a script once the control has been created. \n         </p>\n         <p><a name=\"GUID-A5B97EF2-2EFA-4A78-8F48-9577525D997D\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-E4485928-C8D4-4334-ACC0-C1DF5958B69C\"></a>The <em class=\"strong\">common layout parameters </em>for all user-interface items are: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745C\"></a><pre><em class=\"codeEmphasisStrong\">align</em>:#left</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745B\"></a><pre><em class=\"codeEmphasisStrong\">align</em>:#center</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745A\"></a><pre><em class=\"codeEmphasisStrong\">align</em>:#right</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6614\"></a>Aligns the user-interface item to the left, center, or right in the rollout. Default\n            varies by type. \n         </p>\n         <p><a name=\"GUID-AFA14EEC-44DF-4610-94F1-5E2B8EDE5A61\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7459\"></a><pre><em class=\"codeEmphasisStrong\">offset</em>: &lt;point2&gt; default: [0,0]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6611\"></a>Specifies an [x,y] offset in pixels relative to automatic placement. This is applied\n            after all other layout parameters are applied, and can be used to adjust them. \n         </p>\n         <p><a name=\"GUID-CF42E189-88D5-4EC4-AFC1-CFD596EB6E9B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7458\"></a><pre><em class=\"codeEmphasisStrong\">width</em>: &lt;number&gt; default: varies</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-660E\"></a>Forces the user-interface item to a specified width in pixels. Useful with buttons,\n            for example, which otherwise self-size to their text label. Specifying an explicit\n            width always overrides any widths computed from the <span class=\"code\"> <em class=\"strong\">text</em> </span> or <span class=\"code\"> <em class=\"strong\">caption</em> </span> properties. For example, if a spinner is given a fixed width that is too small for\n            both label and spinner, it always aligns things to show the spinner and so might push\n            the text out of view. \n         </p>\n         <p><a name=\"GUID-46288CD6-257E-4E43-9A9A-8EB820808B31\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7457\"></a><pre><em class=\"codeEmphasisStrong\">height</em>: &lt;number&gt; default: varies by type</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-660B\"></a>Forces the user-interface item to a specified height, typically in pixels. This lets\n            you override the default setting height for user-interface items. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-660A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6609\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7456\"></a><pre>\nbutton foo \"Stop\" width:75 height:25\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F487554A38425612A6182AEB9-6A4F\"></a><p class=\"table-body\">makes a nice big stop button. </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6603\"></a>For <span class=\"code\"> <em class=\"strong\">comboBox</em> </span>, <span class=\"code\"> <em class=\"strong\">dropdownList</em> </span> and <span class=\"code\"> <em class=\"strong\">listBox</em> </span> user-interface items, the height is in text rows. \n         </p>\n         <p><a name=\"GUID-DBC0417D-D77D-41BF-8DB9-B2ECCF4E6B31\"></a>To have a <span class=\"code\"> <em class=\"strong\">comboBox</em> </span> exactly display <span class=\"code\"> <em class=\"strong\">N</em> </span> items, set <span class=\"code\"> <em class=\"strong\">height</em> </span> to <span class=\"code\"> <em class=\"strong\">N+2</em> </span>. \n         </p>\n         <p><a name=\"GUID-90E617F0-D450-4ACE-9DB3-253F1BFCD1B0\"></a>To have a <span class=\"code\"> <em class=\"strong\">dropdownList</em> </span> exactly display <span class=\"code\"> <em class=\"strong\">N</em> </span> items in the list, set <span class=\"code\"> <em class=\"strong\">height</em> </span> to <span class=\"code\"> <em class=\"strong\">N+2</em> </span>. \n         </p>\n         <p><a name=\"GUID-86B9F812-CF00-4F4A-BED5-73F87C920D42\"></a>To have a <span class=\"code\"> <em class=\"strong\">listBox</em> </span> exactly display <span class=\"code\"> <em class=\"strong\">N</em> </span> items, set <span class=\"code\"> <em class=\"strong\">height</em> </span> to <span class=\"code\"> <em class=\"strong\">N</em> </span>. \n         </p>\n         <p><a name=\"GUID-B65BEC24-2C1C-4E87-BC2D-702F513ED161\"></a>Height has no affect on <span class=\"code\"> <em class=\"strong\">spinner</em> </span> and <span class=\"code\"> <em class=\"strong\">slider</em> </span> user-interface items. \n         </p>\n         <p><a name=\"GUID-B5355F25-0546-47D2-8EA1-4D65189BA6F0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7455\"></a><pre><em class=\"codeEmphasisStrong\">across</em>: &lt;number&gt; default: 1</pre></div>\n         <p><a name=\"GUID-B0D63642-7982-4D9D-A310-2B4AC880052C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6600\"></a>Causes this and following <span class=\"code\"> <em class=\"strong\">&lt;number&gt;-1</em> </span> items to be laid out horizontally rather than vertically. The <span class=\"code\"> <em class=\"strong\">&lt;number&gt;</em> </span> given defines how many items to arrange horizontally. Layout then reverts to normal\n            vertical placement. This parameter effectively divides the utility into the given\n            number of equal-width columns and places items within them using the normal alignment\n            for each item. The other layout parameters can be used with the<em class=\"strong\"> across:</em> parameter to control layout within the item\'s column. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7454\"></a><pre><em class=\"codeEmphasisStrong\">pos</em>: &lt;point2&gt; default: varies</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-65FD\"></a>This forces the user-interface item to a fixed [x,y] pixel position in the rollout,\n            with [0,0] at the top-left corner. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-65FB\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-65FA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7453\"></a><pre>\nbutton foo \"foo\" align:#right -- default alignment is center\n-- align right and bump this button down a bit:\nbutton baz \"baz\" align:#right offset:[0,6]\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7452\"></a><pre>\n-- put b1, b2, b3 across:\ncheckbutton b1 \"yes\" across:3\ncheckbutton b2 \"no\"\ncheckbutton b3 \"maybe\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7451\"></a><pre>\n-- default alignment is right\nspinner s1 \"Length:\" align:#left\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-65E7\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-65E6\"></a> <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Controls Common Properties</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";