var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EAD55DDE-6C7C-44CB-8BC8-34905BC05BE5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"while/do expression\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"do/while expression\">\n      <meta name=\"indexterm\" content=\"do and while loops\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>While and Do Loops</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EAD55DDE-6C7C-44CB-8BC8-34905BC05BE5\"></a><div class=\"head\">\n            <h1>While and Do Loops </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87206\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87207\"></a>      <span class=\"code\"> <em class=\"strong\">while</em> </span> and <span class=\"code\"> <em class=\"strong\">do</em> </span> loops are used to repeatedly execute an expression until a test expression evaluates\n               as <span class=\"code\"> <em class=\"strong\">false</em> </span>. The <span class=\"code\"> <em class=\"strong\">while </em> </span>loop and <span class=\"code\"> <em class=\"strong\">do</em> </span> loop are simple variants of one another. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8720D\"></a>The syntax is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BD\"></a><pre><em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt;\n\n<em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87210\"></a>Both loops repeat the <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> as long as the <span class=\"code\"><em class=\"strong\">while</em> &lt;expr&gt;</span> evaluates to the value <span class=\"code\"> <em class=\"strong\">true</em> </span>. The <span class=\"code\"> <em class=\"strong\">do</em> </span> form evaluates the <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> at least once, evaluating the test expression at the end of each loop. The <span class=\"code\"> <em class=\"strong\">while</em> </span> form evaluates the test expression at the start of each loop and may not loop at\n               all. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87211\"></a>Both forms return as their value the result of the <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> from the last successful loop iteration. The <span class=\"code\"> <em class=\"strong\">while</em> </span> form will return the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the test expression immediately returns <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87213\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87214\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BC\"></a><pre>while x &gt; 0 do\n( print x\nx -= 1\n)</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BB\"></a><pre>while not eof f do print (read_value f)</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BA\"></a><pre>\ndo\n(\nexchanged=false\nfor i=1 to imax do\n(\nj=i+gap\nif (compare array[j] array[i]) do\n(swap array[j] array[i]; exchanged=true)\n)\n)\nwhile exchanged\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8722D\"></a> <span class=\"char_link\"><a href=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8.htm\">Skipping Loop Iterations</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8722E\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">Loop Exit</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";