var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EB69A035-7FF4-4A0A-8A82-409C4145B9DF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface InstanceMgr\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: InstanceMgr</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EB69A035-7FF4-4A0A-8A82-409C4145B9DF\"></a><div class=\"head\">\n            <h1>Interface: InstanceMgr </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-157B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-157A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; InstanceMgr \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1578\"></a>The<em class=\"strong\"> Instance Manager Core Interface</em> provides access to properties and methods related to Instanced Nodes. It provides\n            means for collecting instances, managing material propagation to instances, making\n            instanced modifiers, controllers and nodes unique etc. \n            	 \n         </p>\n         <p><a name=\"GUID-97FBEC5F-2CC9-4C82-A36F-FF7E604A1558\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1577\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D7\"></a><pre><em class=\"codeEmphasisStrong\">InstanceMgr</em>.<em class=\"codeEmphasisStrong\">autoMtlPropagation </em>: boolean : Read|Write 	 </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1576\"></a>When set to \n            		<span class=\"code\"> <em class=\"strong\">True</em> </span>, Materials assigned to an object will propagate automatically to all its instances.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-C23E2DC9-64BE-45FA-AD09-FADB848B0C37\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1575\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D6\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">InstanceMgr.GetInstances</em> &lt;node&gt;source &lt;&amp;node array&gt;instances   \n\ninstances is Out parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1574\"></a>Returns the number of instances of the specified source node and the list of all instances\n            in the by-reference Out parameter. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1573\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1572\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D4\"></a><pre>\ntp = Teapot() --create a teapot\n--&gt; $Teapot:Teapot01 @ [0.000000,0.000000,0.000000]\ntp1 = instance tp --instance the teapot\n--&gt; $Teapot:Teapot02 @ [0.000000,0.000000,0.000000]\ntp2 = instance tp --instance it again\n--&gt; $Teapot:Teapot03 @ [0.000000,0.000000,0.000000]\ntp3 = copy tp --copy the teapot\n--&gt; $Teapot:Teapot04 @ [0.000000,0.000000,0.000000]\nInstanceMgr.GetInstances tp &amp;instances -- get the instances of the original\n--&gt; 3\ninstances --show the returned array- all instances are there, the copy isn\'t\n--&gt; #($Teapot:Teapot03 @ [0.000000,0.000000,0.000000], $Teapot:Teapot02 @ [0.000000,0.000000,0.000000], $Teapot:Teapot01 @ [0.000000,0.000000,0.000000])\nInstanceMgr.GetInstances tp3 &amp;instances --get the instances of the copy\n--&gt; 1\ninstances -- show the returned array - the copy is the only object in it\n--&gt; #($Teapot:Teapot04 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"GUID-03FB6762-EA90-41D5-AFB5-B9231D605D98\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This function also considers objects to be instances when they share the same styles\n               or categories as defined in AutoCAD Architecture, or the same families and types as\n               defined in Autodesk Revit, when a scene is imported or linked from a DWG file. In\n               this case, the function works like the \n               		<em class=\"strong\">Select Similar</em> command. In this case, to select only 3ds Max instances, use: \n               		\n               <div class=\"codeBlock\"><pre>-- Note that this code works only if the selection set ($) is not empty\nInstanceMgr.GetInstances $ &amp;rptInstances \ntrueInstances = for n in rptInstances where (areNodesInstances $ n) collect n</pre></div> \n            </div>\n         </div>\n         <p><a name=\"GUID-99AC9A7E-8A07-4AC8-BBCE-53D3C7581CF0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D3\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\"> InstanceMgr.SetMtlOnInstances </em>&lt;node&gt;source &lt;material&gt;newMtl </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-156F\"></a>Propagates the supplied new material to all instances of the specified source node.\n            Normally, instances can have independent materials. Using this method, all instances\n            can be updated to use the same material. Returns the number of instances. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-156E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-156D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D2\"></a><pre>\ntp = Teapot() --create a teapot\n--&gt; $Teapot:Teapot01 @ [0.000000,0.000000,0.000000]\ntp.material = standard diffuse:(color 255 0 0) --assign a red material\n--&gt; Standardmaterial:Standard\ntp1 = instance tp --create an instance\n--&gt; $Teapot:Teapot02 @ [0.000000,0.000000,0.000000]\ntp1.pos = [100,0,0] --move the instance\n--&gt; [100,0,0]\ntp1.material = standard diffuse:(color 0 255 0) --assign a green material\n--&gt; Standardmaterial:Standard\ntp2 = instance tp --create another instance\n--&gt; $Teapot:Teapot03 @ [0.000000,0.000000,0.000000]\ntp2.pos = [200,0,0] --move the instance\n--&gt; [200,0,0]\ntp2.material = standard diffuse:(color 0 0 255) --assign a blue material\n--&gt; Standardmaterial:Standard\nnewMaterial = standard diffuse:(color 250 255 255) --create a white material\n--&gt; Standardmaterial:Standard\n\nInstanceMgr.SetMtlOnInstances tp newMaterial --assign to all instances 3 --3 object affected! \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-EB899A20-BFD1-43DF-9701-F69BC8C66BCC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D1\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">InstanceMgr.MakeObjectsUnique</em> &lt;&amp;node array&gt;nodes &lt;enum&gt;multiNodeOption \n\nnodes is In parameter \nmultiNodeOption enums: {<em class=\"codeEmphasisStrong\">#prompt</em> | <em class=\"codeEmphasisStrong\">#individual</em> | <em class=\"codeEmphasisStrong\">#group</em>} </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-156A\"></a>Makes the objects passed by-reference unique. Returns<span class=\"code\"> <em class=\"strong\"> True</em> </span> on success. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1569\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1568\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59CF\"></a><pre>\ntp = Teapot() --create a teapot\n--&gt; $Teapot:Teapot01 @ [0.000000,0.000000,0.000000]\ntp1 = instance tp --instance the trapot\n--&gt; $Teapot:Teapot02 @ [0.000000,0.000000,0.000000]\ntp2 = instance tp --instance it once again\n--&gt; $Teapot:Teapot03 @ [0.000000,0.000000,0.000000]\nInstanceMgr.GetInstances tp &amp;instances --get all instances\n--&gt; 3\n--make the instances unique. Show a prompt to confirm the operation\nInstanceMgr.MakeObjectsUnique &amp;instances #prompt\n--&gt; true\n--Check that every object is an instance of itself only.\nInstanceMgr.GetInstances tp &amp;instances\n--&gt; 1\nInstanceMgr.GetInstances tp1 &amp;instances\n--&gt; 1\nInstanceMgr.GetInstances tp2 &amp;instances\n--&gt; 1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-1F69A6E8-64C4-436B-8735-4AA8FBBD7728\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59CE\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">CanMakeObjectsUnique</em> &lt;&amp;node array&gt;nodes \n\nnodes is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1565\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">True</em> </span> when the specified nodes can be made unique,<span class=\"code\"> <em class=\"strong\"> False \n                  		  </em> </span>otherwise. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1564\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1563\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59CC\"></a><pre>\ntp = Teapot() --create a teapot\n--&gt; $Teapot:Teapot01 @ [0.000000,0.000000,0.000000]\ntp1 = instance tp --instance the teapot\n--&gt; $Teapot:Teapot02 @ [0.000000,0.000000,0.000000]\ntp2 = copy tp --copy the teapot\n--&gt; $Teapot:Teapot03 @ [0.000000,0.000000,0.000000]\n--Check if the two instances can be made unique - they can\nInstanceMgr.CanMakeObjectsUnique #(tp,tp1)\n--&gt; True\n--Check the original and the copy - not instances, cannot be made unique\nInstanceMgr.CanMakeObjectsUnique #(tp,tp2)\n--&gt; False\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-3FC0A4DE-8D44-4C5E-AF1F-E18AB4B7D948\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59CB\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">InstanceMgr.MakeModifiersUnique</em> &lt;&amp;node array&gt;nodes &lt;&amp;maxObject array&gt;modifiers &lt;enum&gt;multiNodeOption \n\nnodes is In parameter \nmodifiers is In parameter \nmultiNodeOption enums: {<em class=\"codeEmphasisStrong\">#prompt</em> | <em class=\"codeEmphasisStrong\">#individual</em> | <em class=\"codeEmphasisStrong\">#group</em>} </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1560\"></a>Makes the specified modifiers of the supplied nodes unique. Returns<span class=\"code\"> <em class=\"strong\"> True</em> </span> on success. \n            	 \n         </p>\n         <p><a name=\"GUID-96F01C25-230B-4559-9761-47C2D979AA52\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59C9\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">InstanceMgr.CanMakeModifiersUnique</em> &lt;&amp;node array&gt;nodes &lt;&amp;maxObject array&gt;modifiers \n\nnodes is In parameter \nmodifiers is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-155E\"></a>Returns<span class=\"code\"> <em class=\"strong\"> True \n                  		  </em> </span>when the specified modifiers of the supplied nodes can be made unique,<span class=\"code\"> <em class=\"strong\"> False \n                  		  </em> </span>otherwise. \n            	 \n         </p>\n         <p><a name=\"GUID-62603D7B-E5AD-4499-9051-8F6EA5210867\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59C7\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">MakeControllersUnique</em> &lt;&amp;node array&gt;nodes &lt;&amp;maxObject array&gt;controllers &lt;enum&gt;multiNodeOption \n\nnodes is In parameter \ncontrollers is In parameter \nmultiNodeOption enums: {<em class=\"codeEmphasisStrong\">#prompt</em> | <em class=\"codeEmphasisStrong\">#individual</em> | <em class=\"codeEmphasisStrong\">#group</em>} </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-155C\"></a>Makes the specified controllers of the supplied nodes unique. Returns \n            		<span class=\"code\"> <em class=\"strong\">True \n                  		  </em> </span>on success. \n            	 \n         </p>\n         <p><a name=\"GUID-96FEC7CE-EA59-41F7-A18E-FA1A2066E25C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59C5\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">InstanceMgr.CanMakeControllersUnique </em>&lt;&amp;node array&gt;nodes &lt;&amp;maxObject array&gt;controllers \n\nnodes is In parameter \ncontrollers is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-155A\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">True</em> </span> when the specified controllers of the supplied nodes can be made unique, \n            		<span class=\"code\"> <em class=\"strong\">False</em> </span> otherwise. \n            	 \n         </p>\n         <p><a name=\"GUID-5E2BA2C6-6F2F-4B51-A7BD-12BE963CC951\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1558\"></a> <span class=\"char_link\"><a href=\"GUID-41314BEF-A7C5-4525-AF73-B826194A4965.htm\">getClassInstances</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";