var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EBF62EB2-9B3C-4A63-B002-137CEFB327D6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"particleFloat Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>particleFloat Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EBF62EB2-9B3C-4A63-B002-137CEFB327D6\"></a><div class=\"head\">\n            <h1>particleFloat Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84652\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84653\"></a>The following script sets each particle\'s float value as one tenth of its particle\n            ID or birth index number. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84654\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84655\"></a>Can be used to control the <em class=\"strong\">.Force</em> value of <em class=\"strong\">Force</em> and <em class=\"strong\">Speed_Keep_Apart</em> Operators. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84656\"></a> <span class=\"char_link\"><a href=\"GUID-D0C1C6E8-438C-423C-844B-3C1F4E529AA0.htm\">Force : Helper</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84657\"></a> <span class=\"char_link\"><a href=\"GUID-6493B179-EF5F-41E9-834F-2066857C4011.htm\">Speed_Keep_Apart : Helper</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84658\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84659\"></a>The first particles get a low float value and thus a low Influence value. Each successive\n            particle gets a larger float value than the one before. As a result, the later a particle\n            is born, the more it is subject to the space warp(s) in the operator. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8465B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8465C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E16\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useFloat = true--enable the Float channel\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n(\n--Get the number of particles\ncount = pCont.NumParticles()\n \n--Loop from 1 to the number of particles:\nfor i in 1 to count do\n(\n \n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one\npCont.particleIndex = i\n \n--Set the particleFloat channel value of the current particle\n--to the particleID of the current particle divided by 10.0.\n--The younger the particle, the higher the particleFloat value.\npCont.particleFloat = pCont.particleID/10.0\n)--end i loop\n)--end Proceed\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8468F\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84690\"></a> <span class=\"char_link\"><a href=\"GUID-D0C1C6E8-438C-423C-844B-3C1F4E529AA0.htm\">Force : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84691\"></a> <span class=\"char_link\"><a href=\"GUID-6493B179-EF5F-41E9-834F-2066857C4011.htm\">Speed_Keep_Apart : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84692\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84693\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";