var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-ECB4AC81-658B-4256-A31D-9C3FE78D9EB5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"literals\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Literal Constants</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-ECB4AC81-658B-4256-A31D-9C3FE78D9EB5\"></a><div class=\"head\">\n            <h1>Literal Constants </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C36\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C37\"></a> MAXScript has many built-in data types: numbers, strings, names, arrays, vectors,\n               and matrices, as well as special data types which store the <em class=\"strong\">3ds Max</em> objects such as geometry objects, splines, materials, modifiers, etc.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C39\"></a>Some data types have special literal constant forms, where the literal constant is\n               a value that is keyed directly into your program where it is needed. The syntax of\n               the literal constant specifies both its value and data type. In MAXScript, the assignment\n               of a literal constant might look like this:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86C3A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-616C\"></a><pre>\nb=50\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C3F\"></a>In this line, <span class=\"code\"> <em class=\"strong\">b</em> </span> is the variable name, and <span class=\"code\"> <em class=\"strong\">50</em> </span> is the literal constant of type integer assigned to <span class=\"code\"> <em class=\"strong\">b</em> </span>. <span class=\"code\"> <em class=\"strong\">50</em> </span> is a literal constant because you cannot assign a value to <span class=\"code\"> <em class=\"strong\">50</em> </span>, and its value cannot be changed.\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C41\"></a> <span class=\"char_link\"><a href=\"GUID-9D3F7F9E-3919-4078-BB24-AAB97C31F1C3.htm\">Number Literals</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C42\"></a> <span class=\"char_link\"><a href=\"GUID-7F17449E-C377-445C-AC15-CD3BA88A975B.htm\">String Literals</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C43\"></a> <span class=\"char_link\"><a href=\"GUID-4389A5F4-9D6E-4DDE-B3A1-F19E89ED3FB5.htm\">Time Literals</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C44\"></a> <span class=\"char_link\"><a href=\"GUID-8395020C-E3B6-4282-AF1C-5B58BDB97A24.htm\">Pathname Literals</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C45\"></a> <span class=\"char_link\"><a href=\"GUID-A2C25DDF-2FC1-456B-90C2-B91D98296C3F.htm\">2D and 3D Point Literals</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86C46\"></a> <span class=\"char_link\"><a href=\"GUID-F44E766A-34AA-4F90-9776-E8A1C4D7CF33.htm\">Array Literals</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";