var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-ED92EB20-5E7E-4FC3-81CA-9454D38F97B1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: CustomSceneStreamManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-ED92EB20-5E7E-4FC3-81CA-9454D38F97B1\"></a><div class=\"head\">\n            <h1>Interface: CustomSceneStreamManager</h1>\n         </div>\n         <p> The \n            		<span class=\"code\">CustomSceneStreamManager</span> interface is used to query, add, modify and remove \n            		<span class=\"char_link\"><a href=\"GUID-81C6EC68-B766-4C6C-A6A4-D0272A0DE953.htm\">CustomFileStreams</a></span> in the current 3ds Max scene file. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. \n            	 \n         </p>\n         <p> </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6492\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6493\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; CustomSceneStreamManager \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_DB1F074A534E467891115828343CA32F\"></a> \n            <h2><a name=\"GUID-9B65C00F-7F04-414B-9C80-354603A8B1DE\"></a>Flag Values\n            </h2> \n            <p>Custom file streams have three flags that determine how they are handled by the \n               		  <span class=\"code\">CustomFileStreamManager</span>: \n               		\n            </p> \n            <dl><a name=\"GUID-DD1B4F10-23CC-4E5A-B4D9-901589DA9474\"></a><dt><span class=\"term\">Persistence Flag \n                     			 </span></dt>\n               <dd>\n                  <div class=\"definition\">When this flag is set, the \n                     				<span class=\"code\">CustomSceneStreamManager</span> writes this stream to the scene file when the scene file is saved, and reads the\n                     stream into its cache when the scene file is loaded. This flag\'s value is persisted\n                     across a save/load operation. This allows a CustomFileStream to be automatically persisted\n                     across multiple load/save operations. See \n                     				<span class=\"code\">is/setStreamPersistent()</span>. \n                     			 \n                  </div>\n               </dd><a name=\"GUID-E82FEAC4-44E8-420D-8EA7-15B4ED6BF936\"></a><dt><span class=\"term\">Save Flag \n                     			 </span></dt>\n               <dd>\n                  <div class=\"definition\">This flag indicates whether the CustomFileStream is saved when the scene file is saved.\n                     Setting this flag allows you to add a non-persistent stream and have it saved on scene\n                     file save. This flag does not persist, and is cleared when the stream is read from\n                     the scene file. \n                     			 \n                  </div>\n               </dd><a name=\"GUID-32E7E37B-190D-4B94-928C-C610AA05C3EA\"></a><dt><span class=\"term\">No Load Flag \n                     			 </span></dt>\n               <dd>\n                  <div class=\"definition\">This flag indicates whether the CustomFileStream is loaded by the \n                     				<span class=\"code\">CustomSceneStreamManager</span> when the scene file is loaded. This flag allows you to create streams that are not\n                     loaded on file load, for example for data to be consumed by an external tool or workflow.\n                     See \n                     				<span class=\"code\">getNoLoadOnSceneLoad()</span> and \n                     				<span class=\"code\">setNoLoadOnSceneLoad()</span>. \n                     			 \n                  </div>\n               </dd>\n            </dl> \n            <div><a name=\"GUID-272500A1-CFD8-4D94-A93E-E777C600C6D3\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>These flags are stored in a \"private\" 32 bit integer (private in the sense that all\n                  bits are reserved for future use by 3ds Max). The \n                  		  <span class=\"code\">CustomSceneStreamManager</span> interface exposes methods to get this integer value, or to get and set the individual\n                  flags in the value. There is also a \"public\" 32 bit integer value that you can use\n                  for defining additional custom flags. \n                  		\n               </div>\n            </div> \n            <div><a name=\"GUID-726D1993-80C4-49B0-915F-F7D6D06FDDF0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If the Save Flag is set, the Persistence Flag is not set, and the No Load Flag is\n                  not set, then the stream is persisted across a single save/load operation, since the\n                  Save Flag is cleared on load. \n                  		\n               </div>\n            </div> \n            <p> </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_D60DDC1B2C434E05BE716A7F1803B4E2\"></a> \n            <h2><a name=\"GUID-DA255609-A21E-4113-AD51-532A23045392\"></a>Notifications\n            </h2> \n            <p> Because the \n               		  <span class=\"code\">CustomSceneStreamManager</span> code may be loaded and invoked at different times, depending on system configuration,\n               the order in which it and other 3ds Max components will receive file operation notifications\n               can be unpredictable. For this reason, you should use the interface\'s methods for\n               registering callbacks if you need to operate on the \n               		  <span class=\"code\">CustomSceneStreamManager</span> itself, or on the scene file (such as copying and storing it). \n               		\n            </p> \n         </div>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>.<em class=\"codeEmphasisStrong\">numEntries</em> : integer : Read</pre></div>\n         <p>The number of entries in the \n            		<span class=\"code\">CustomSceneStreamManager</span>\'s cache. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>.<em class=\"codeEmphasisStrong\">locked</em> : bool : Read|Write</pre></div>\n         <p>Whether the \n            		<span class=\"code\">CustomSceneStreamManager</span> is locked. When locked, the \n            		<span class=\"code\">CustomSceneStreamManager</span> does not react to any notifications from 3ds Max. This means that the manager does\n            not automatically load or save data streams. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">getStreamName</em> &lt;index&gt;index</pre></div>\n         <p>Returns the name of the stream for the specified cache entry index. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">getStreamByName</em> &lt;string&gt;name</pre></div>\n         <p>Returns the index of the named stream. Throws an exception if the named stream does\n            not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">doesStreamExist</em> &lt;value&gt;which</pre></div>\n         <p>Returns true if the specified stream exists. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getStreamFlag</em> &lt;value&gt;which\n	privateFlag:&lt;bool&gt;\n	privateFlag default value: false\n\n&lt;void&gt;<em class=\"codeEmphasisStrong\">setStreamFlag</em> &lt;value&gt;which\n	&lt;integer&gt;value privateFlag:&lt;bool&gt;\n	privateFlag default value: false</pre></div>\n         <p>Gets or sets the specified stream\'s public or private flags value. The \"private\" integer\n            contains the persistence, save, and cache flags in the first 3 bits. The remaining\n            bits are reserved for future use. The \"public\" integer can contain any flags or other\n            data you wish. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">isStreamDataAnArray</em> &lt;value&gt;which</pre></div>\n         <p>Returns true if the specified stream\'s content is an array of strings. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">getStreamData</em> &lt;value&gt;which</pre></div>\n         <p>Returns the specified stream\'s content as a string. If the content is an array of\n            strings, the first string is returned. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;string by value array&gt;<em class=\"codeEmphasisStrong\">getStreamDataAsArray</em>\n	&lt;value&gt;which</pre></div>\n         <p>Returns the specified stream\'s content as an array of strings. If the content is a\n            single string, it is returned in a 1 element array. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setStreamData</em> &lt;value&gt;which\n	&lt;string&gt;string</pre></div>\n         <p>Sets the specified stream\'s content as a string. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setStreamDataAsArray</em> &lt;value&gt;which\n	&lt;&amp;string array&gt;string_array\n	string_array is In parameter</pre></div>\n         <p>Sets the specified stream\'s content as an array of strings. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            		<em class=\"strong\">Note</em>: if you store an empty array, \n            		<span class=\"code\">isStreamDataAnArray()</span> returns false. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">isStreamPersistent</em> &lt;value&gt;which\n\n&lt;void&gt;<em class=\"codeEmphasisStrong\">setStreamPersistent</em> &lt;value&gt;which\n	&lt;bool&gt;persistent</pre></div>\n         <p>Gets or sets the specified stream is flagged as persistent when written to the scene\n            file. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">getSaveNonPersistentStream</em> &lt;value&gt;which\n\n&lt;void&gt;<em class=\"codeEmphasisStrong\">setSaveNonPersistentStream</em> &lt;value&gt;which &lt;bool&gt;val</pre></div>\n         <p>Gets or sets whether the specified stream is flagged as to be written to the scene\n            file even if not flagged as persistent file. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">getNoLoadOnSceneLoad</em> &lt;value&gt;which\n\n&lt;void&gt;<em class=\"codeEmphasisStrong\">setNoLoadOnSceneLoad</em> &lt;value&gt;which &lt;bool&gt;val</pre></div>\n         <p>Gets or sets whether the specified stream is flagged as not to be loaded on scene\n            file load when written to the scene file. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. Throws an exception if the\n            specified stream does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">deleteStream</em> &lt;value&gt;which</pre></div>\n         <p>Deletes the specified stream. The \n            		<span class=\"code\">which</span> parameter can be either a stream name or a stream index. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;index&gt; <em class=\"codeEmphasisStrong\">createStream</em> &lt;string&gt;name\npersistent:&lt;bool&gt; saveNonPersistentStream:&lt;bool&gt;\nnoLoadOnSceneLoad:&lt;bool&gt;\npersistent default value: true\nsaveNonPersistentStream default value: true\nnoLoadOnSceneLoad default value: false</pre></div>\n         <p>Creates a cache entry with the specified name and flag values. The content of the\n            entry will be an empty string. Throws an exception if a cache entry with the same\n            name already exists. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">registerCallback</em> &lt;value&gt;callback_fn\n&lt;value&gt;callback_id &lt;enum&gt;event\nevent enums: {#postLoad|#preSave|#postSave}</pre></div>\n         <p>Registers a callback function that is called when the corresponding \n            		<span class=\"code\">CustomSceneStreamManager</span> event occurs. The \n            		<span class=\"code\">callback_id</span> must be a name value. The callback function must take 2 arguments: the first argument\n            is the file name and the second argument is the event type as a name value (<span class=\"code\">#postLoad</span>, \n            		<span class=\"code\">#preSave</span>, or \n            		<span class=\"code\">#postSave</span>). If an exception occurs while executing a callback function, that function is automatically\n            unregistered. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">unregisterCallbacks</em> callback_fn:&lt;value&gt;\ncallback_id:&lt;value&gt; event:&lt;enum&gt;\ncallback_fn default value: undefined\ncallback_id default value: undefined\nevent enums: {#postLoad|#preSave|#postSave}\nevent default value: -1</pre></div>\n         <p>Unregisters any callback functions that match all the values specified via the keyword\n            arguments. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;value&gt;<em class=\"codeEmphasisStrong\">getCallbacks</em> callback_fn:&lt;value&gt;\ncallback_id:&lt;value&gt; event:&lt;enum&gt;\ncallback_fn default value: undefined\ncallback_id default value: undefined\nevent enums: {#postLoad|#preSave|#postSave}\nevent default value: -1</pre></div>\n         <p>Returns an array of all callback functions that match all the values specified via\n            the keyword arguments. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";