var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EE2C3ADF-9BAB-4424-AAAB-A5ABF027DE73\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables - 3ds Max system globals\">\n      <meta name=\"indexterm\" content=\"setWaitCursor()\">\n      <meta name=\"indexterm\" content=\"setSysCur()\">\n      <meta name=\"indexterm\" content=\"setArrowCursor()\">\n      <meta name=\"indexterm\" content=\"screenpos - mouse\">\n      <meta name=\"indexterm\" content=\"pos - mouse\">\n      <meta name=\"indexterm\" content=\"mouse cursors\">\n      <meta name=\"indexterm\" content=\"mode - mouse\">\n      <meta name=\"indexterm\" content=\"buttonStates - mouse\">\n      <meta name=\"indexterm\" content=\"mouse access\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Mouse Cursors</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EE2C3ADF-9BAB-4424-AAAB-A5ABF027DE73\"></a><div class=\"head\">\n            <h1>Mouse Cursors </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ACB\"></a>         The following methods control the \n            		<em class=\"strong\">mouse cursor</em>: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B60\"></a><pre><em class=\"codeEmphasisStrong\">setWaitCursor</em>() 		\n<em class=\"codeEmphasisStrong\">setArrowCursor</em>() 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ABF\"></a>These functions can be used to display the system wait cursor during some prolonged\n            computation and then replace it with the normal cursor. You might want to do this\n            instead of putting up a \n            		<em class=\"strong\">3ds Max</em> progress bar, which may be too heavy-weight in some situations. Note that in some\n            cases, \n            		<em class=\"strong\">3ds Max</em> may itself restore the arrow cursor underneath this one (for example, with \n            		<span class=\"code\"> <em class=\"strong\">loadMAXFile()</em> </span>), and you may need to redisplay it after such calls. \n            	 \n         </p>\n         <p><a name=\"GUID-4BB3110A-5C72-465F-ABD0-DE31BD66394B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5F\"></a><pre><em class=\"codeEmphasisStrong\">setSysCur</em> &lt;name&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ABC\"></a>Sets the current system cursor to one of the standard \n            		<em class=\"strong\">3ds Max</em> cursors. Valid \n            		<span class=\"code\"> <em class=\"strong\">&lt;name&gt;</em> </span> values are: \n            	 \n         </p>\n         <p><a name=\"GUID-59B2F04D-8FAD-4142-AE5E-DAF2AA179E42\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5E\"></a><pre><em class=\"codeEmphasisStrong\">#move</em> <em class=\"codeEmphasisStrong\">#rotate</em> <em class=\"codeEmphasisStrong\">#uscale</em> <em class=\"codeEmphasisStrong\">#nuscale</em> <em class=\"codeEmphasisStrong\">#squash</em> <em class=\"codeEmphasisStrong\">#select</em> <em class=\"codeEmphasisStrong\">#arrow</em> </pre></div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-756C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <span class=\"code\"> <em class=\"strong\">setSysCur #squash</em> </span> shows the non-uniform scale cursor. \n               	 \n            </div>\n         </div>\n         <p><a name=\"GUID-9A0F794D-23EC-4FC6-91D2-6D8ECC248D70\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AB0\"></a> \n            <h2><a name=\"GUID-B8DCFAC8-C048-407C-A9CC-22C542D28C4C\"></a> <em class=\"strong\">The following 3ds Max system global variables are associated with the mouse:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5D\"></a><pre><em class=\"codeEmphasisStrong\">mouse.mode</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-29A01C2129CC3210CE-76DC\"></a> A read only variable to get the mouse mode as an &lt;integer&gt; value. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AAB\"></a>Return values are: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AAA\"></a>0 - Idle; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AA9\"></a>1 - Point; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AA8\"></a>2 - Move \n               		\n            </p> \n            <p><a name=\"GUID-BE01527C-F074-406B-A9BE-01EC937828C1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5C\"></a><pre><em class=\"codeEmphasisStrong\">mouse.buttonStates</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AA5\"></a>A read only variable to get the state of the mouse buttons as a 3 element &lt;bitArray&gt;.\n               The order of the bits is: #{Left, Middle, Right} \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-756B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-4DFED4A1-669A-4B5D-AC05-F21C0612DFB2\"></a>Right mouse button state is not always correct. If you right-click to bring up a right-click\n                     menu and then click in the viewport to dismiss the menu, the right mouse button is\n                     still reported as down. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-DF33485A-DA05-49E6-BB27-FCCAA77E3B88\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5B\"></a><pre><em class=\"codeEmphasisStrong\">mouse.pos</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2A9E\"></a>A read only variable to get the scaled mouse position in the currently active viewport\n               as a &lt;point2&gt; value. The coordinates are in pixel values. If the currently active\n               viewport is a 2D view (Track View, Schematic View, Listener, etc.), the coordinates\n               are in the first non-2D viewport. \n               		\n            </p> \n            <p><a name=\"GUID-DE9C6B93-5244-4554-A8C3-6AE00B266DFB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">mouse.posUnscaled</em></pre></div> \n            <p> A read-only variable to get the unscaled mouse position in the currently active viewport\n               as a &lt;point2&gt; value. The coordinates are in pixel values, before UI scaling has been\n               applied. If the currently active viewport is a 2D view (Track View, Schematic View,\n               Listener, etc.), the coordinates are in the first non-2D viewport. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>.\n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B5A\"></a><pre><em class=\"codeEmphasisStrong\">mouse.screenpos</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2A9B\"></a>A read only variable to get the scaled mouse position on the screen as a \n               		  <span class=\"code\"> <em class=\"strong\">&lt;point2&gt;</em> </span> value. The coordinates are in pixel values relative to the top-left corner of the\n               screen, after UI scaling has been applied. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">mouse.screenposUnscaled</em></pre></div> \n            <p> &nbsp;A read-only variable to get the unscaled mouse position on the screen as a &lt;point2&gt;\n               value. The coordinates are in pixel values relative to the top-left corner of the\n               screen, before UI scaling has been applied. Available in \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B59\"></a><pre><em class=\"codeEmphasisStrong\">mouse.inAbort</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2A98\"></a>Contains true if any mouse proc is currently in the process of aborting; otherwise\n               contains false. Read-only. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2A97\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2008</em> and higher. Previously available in \n               		  <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";