var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-EE72D175-55FF-454E-BD35-0665BF3851D1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Access to the new node bone properties and methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Access to the node bone properties and methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EE72D175-55FF-454E-BD35-0665BF3851D1\"></a><div class=\"head\">\n            <h1>Access to the node bone properties and methods </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1E9\"></a> There are several properties and methods accessible on scene nodes that correspond\n            to the Bone parameters and functions in the node properties dialog. \n         </p>\n         <p><a name=\"P_061C58E513BF40C3B4576ADCB21BD678\"></a> These properties and methods are exposed by the INode Node Interface - <span class=\"char_link\"><a href=\"GUID-0BFEF796-5952-48B0-8929-88475F927649.htm\">Interface : INode</a></span> \n         </p>\n         <p><a name=\"P_95545409435E4A36885D659CD3A46931\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1EC\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31CA\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">boneEnable</em> : Boolean, read-only	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1EE\"></a>See <span class=\"code\"> &lt;node&gt;.<em class=\"strong\">setBoneEnable</em> </span> for the set method. \n         </p>\n         <p><a name=\"P_6E686E1AE215458493F55AA24E0CA6BE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C9\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">boneAutoAlign</em>  : Boolean </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1F2\"></a>When turned off, the bone\'s pivot point will not align to its child object. \n         </p>\n         <p><a name=\"P_DEF268D5F4ED4284BD277EA2972419FA\"></a>The translation of a child bone will not be converted into rotation of the parent.\n            \n         </p>\n         <p><a name=\"P_0DFEF0AC2E3B448DB2B271841780A926\"></a>Instead the child will be allowed to move away from the parent\'s X-axis. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2ABA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Changing the state of this check box will <em class=\"strong\">not</em> have an immediate visual effect on the skeleton. It only affects future behavior\n               when bones are moved. This option is only available if Bone is off. \n            </div>\n         </div>\n         <p><a name=\"P_501F6F528C344BBFBD7DD3857838432B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C8\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">boneFreezeLength</em> : Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1F9\"></a>When turned on, the bone maintains its length. \n         </p>\n         <p><a name=\"P_FA9A324E276F484BA58AA29734CC8400\"></a>When turned off, the bone\'s length is based on the translation of its child bone.\n            \n         </p>\n         <p><a name=\"P_EF68F859F4AD478AA53A450FCDEDB13E\"></a>This option is available only if Auto-Align is on. \n         </p>\n         <p><a name=\"P_23E832F551A54457915F81A49F55F2BA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C7\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">boneScaleType</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1FC\"></a>one of #scale, #squash, or #none \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1FD\"></a> <span class=\"code\"> <em class=\"strong\">#None</em> </span> - No stretch takes place. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1FE\"></a> <span class=\"code\"> <em class=\"strong\">#Scale</em> </span> - Lets the bone scale. The stretch happens along one axis. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1FF\"></a> <span class=\"code\"> <em class=\"strong\">#Squash</em> </span> - Lets the bone squash. The bone gets fatter as it gets shorter, and thinner as it\n            gets longer. \n         </p>\n         <p><a name=\"P_10C386B43ADC49BBA3FBBBF5BB604415\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C6\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">stretchTM</em> : matrix3, read-only</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C203\"></a>Normally, matrix concatenation occurs in the following manner: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C204\"></a>objectTM = objectOffsetTM * stretchTM * nodeTM \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C205\"></a>So code that uses the objectTM will transparently inherit the effects of the stretchTM.\n            \n         </p>\n         <p><a name=\"P_1DB180D9E8E14DE6A66662946638D980\"></a>However if you want the stretchTM included but not the object offset, this property\n            will return the stretchTM alone. \n         </p>\n         <p><a name=\"P_9834EC76AEE04521AC4BD60CEA093643\"></a>If the node is not a bone or has no stretching, this property will return the identity\n            matrix. \n         </p>\n         <p><a name=\"P_44C62332CC504847B76E1D2A4D079A4F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C206\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C5\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">setBoneEnable</em> &lt;onOff_boolean&gt; &lt;initial-time_time&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C208\"></a>Sets the Bone enable on or off. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C4\"></a><pre>&lt;onOff boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C20A\"></a>When turned on, the bone or object behaves as a bone. Turning this option off causes\n            the node to stop behaving like a bone. There is no auto alignment or stretching. Note\n            that turning this option on will not cause the object to immediately align or stretch.\n            However future translations of children may cause rotation and stretching. Default=on\n            for bone objects, off for other objects. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C3\"></a><pre>&lt;initial-time time&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C20C\"></a>Specifies the time at which to calculate and store initial child position. \n         </p>\n         <p><a name=\"P_5BCBFD35273F487286AD4159282B29D2\"></a>This is usually used with the current time slider position. \n         </p>\n         <p><a name=\"P_4682B78FEB104A66815A0747032BD0C6\"></a>The time associated with the time slider can be queried and set using the <span class=\"code\"> <em class=\"strong\">sliderTime</em> </span> global variable.<span class=\"char_link\"><a href=\"GUID-49AC1816-93C7-452E-BD30-62066AB038B7.htm\">Time Control</a></span> \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AB9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A very good macroscript example to review, which uses <span class=\"code\"> <em class=\"strong\">.setBoneEnable</em> </span>, can be found in your<em class=\"strong\"> 3ds Max</em> directory at: \\ui\\macroscripts\\Macro_Bones.mcr. \n            </div>\n         </div>\n         <p><a name=\"P_7A77DEEACDDB453FBC5BD5ED66D9F54E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C2\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">realignBoneToChild</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C212\"></a>Rotates the node such that its X axis points at the average position of all children\n            with the bone property turned on. \n         </p>\n         <p><a name=\"P_1A01496360C94D228B97357762300A7B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-31C1\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">resetBoneStretch</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C215\"></a>Resets the initial child position used to compute the stretch factor to the current\n            child position. \n         </p>\n         <p><a name=\"P_FF36B6B1ABE54512885C97DAE1AB167D\"></a>This will cause the stretch factor to become equal to one. \n         </p>\n         <p><a name=\"P_08901546C1164E78BC50B9F4938EDC2C\"></a>If it was previously not equal to one then the object would snap to its original unstretched\n            state. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C217\"></a> <span class=\"char_link\"><a href=\"GUID-0BFEF796-5952-48B0-8929-88475F927649.htm\">Interface : INode</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5651\"></a> <span class=\"char_link\"><a href=\"GUID-AB920CA1-5DC2-44F5-9B3C-2B6D5047AC8A.htm\">Node Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C219\"></a> <span class=\"char_link\"><a href=\"GUID-FA82CDDF-1B77-4507-8583-B7927D5E49D3.htm\">Bone Creation</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C21A\"></a> <span class=\"char_link\"><a href=\"GUID-A726B2AF-2251-40B4-A01C-4A9137CE3D1A.htm\">Bone : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C21B\"></a> <span class=\"char_link\"><a href=\"GUID-0820AA26-920F-434D-A6BC-E8B6B57F54AC.htm\">Skin : Modifier</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C21C\"></a> <span class=\"char_link\"><a href=\"GUID-CCE12D55-2983-4E43-94FB-A17EE92A0D15.htm\">Bones : System</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C21D\"></a> <span class=\"char_link\"><a href=\"GUID-6BD7F514-04E9-45E9-A10D-D63E837074C6.htm\">Interface: BoneSys</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";