var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F122718E-CC36-4CAB-8947-527F608FC184\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Menu and CUI Loading\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Menu and CUI Loading</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F122718E-CC36-4CAB-8947-527F608FC184\"></a><div class=\"head\">\n            <h1>Menu and CUI Loading </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3752\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3751\"></a> You can load a menu file in MAXScript as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D72\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.loadMenuFile</em> \"MaxModelingMenu.mnu\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-374E\"></a>The full path should not be specified. It will look in the appropriate directories\n               for menu files. The default is the \"ui\" directory. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-374D\"></a>You can set the main menu in max as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D71\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setMainMenuBar</em> \"Menu Bar1\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-374B\"></a>To restore MAX\'s default main menu: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D70\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setMainMenuBar</em> \"Main Menu Bar\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3749\"></a>The function returns true of it succeeds and false if it can\'t find the named menu.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3748\"></a>You can set the quad right-click menu that MAX uses in the viewports using the following\n               MAXScript: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D6F\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.setViewportRightClickMenu</em> #nonePressed \"Modeling 2\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3746\"></a>Sets the default (no keys pressed) quad menu to \"Modeling 2\". The menu name must be\n               a quad menu that is listed in the \"Quads\" customization dialog, and the name must\n               match exactly, including capitalization. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3745\"></a>For the first parameter, you can use one of the following 8 values: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D6E\"></a><pre><em class=\"codeEmphasisStrong\">#nonePressed</em> <em class=\"codeEmphasisStrong\">#shiftPressed</em> <em class=\"codeEmphasisStrong\">#altPressed</em> <em class=\"codeEmphasisStrong\">#controlPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndControlPressed</em> <em class=\"codeEmphasisStrong\">#controlAndAltPressed</em> <em class=\"codeEmphasisStrong\">#shiftAndAltAndControlPressed</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-373C\"></a>Here are two macroScripts that set and reset two of the right-click menus: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-373B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-373A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D6D\"></a><pre>\nmacroScript SetQuads\ncategory:\"Custom UI\"\ntooltip:\"Set Quad\"\n(\non execute do\n(\nmenuMan.setViewportRightClickMenu #nonePressed \"Modeling 2\"\nmenuMan.setViewportRightClickMenu #controlPressed \"Sample 4x1\"\n)\n)\n------------------------------\nmacroScript ResetQuads\ncategory:\"Custom UI\"\ntooltip:\"Reset Quads\"\n(\non execute do\n(\nmenuMan.setViewportRightClickMenu #nonePressed \"Default Viewport Quad\"\nmenuMan.setViewportRightClickMenu #controlPressed \"Modeling 1 [Cntrl+RMB]\"\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3721\"></a>You can display a quad menu like this: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D6C\"></a><pre><em class=\"codeEmphasisStrong\">menuMan.trackQuadMenu</em> \"Default Viewport Quad\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-371F\"></a>The menu name must be a quad menu that is listed in the \"Quads\" customization dialog,\n               and the name must match exactly, including capitalization. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-371E\"></a>You can load a CUI file from MAXScript as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D6B\"></a><pre><em class=\"codeEmphasisStrong\">maxOps.loadCUIFile</em> \"ModelingCUI.cui\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-371C\"></a>It will search the appropriate UI directory for the .cui file. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3719\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">Interface: maxOps</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3718\"></a> <span class=\"char_link\"><a href=\"GUID-258F6015-6B45-4A87-A7F5-BB091A2AE065.htm\">Menu Manager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3717\"></a> <span class=\"char_link\"><a href=\"GUID-1374EDCA-CC8B-4B43-81A5-6ED98DBE01D3.htm\">Interface: menuMan</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3716\"></a> <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm\">3ds MaxSystem Globals</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";