var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F1B3ECFD-2649-48C8-B130-15A17527433C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Split a Mesh by UV Elements?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F1B3ECFD-2649-48C8-B130-15A17527433C\"></a><div class=\"head\">\n            <h1>How do I Split a Mesh by UV Elements? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC103D\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC103F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1040\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8DC\"> Working With Editable Meshes</a></span> &gt; How do I Split a Mesh by UV Elements? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1042\"></a>Using the <span class=\"char_link\"><a href=\"GUID-17D700DC-1FDC-4713-8041-D9E3C3EB4789.htm\">Unwrap_UVW</a></span> modifier\'s Flatten option, you can split the UV Coordinates into elements based on\n            a threshold angle for easier texturing. The following scripted function allows you\n            to detach the mesh faces based on the corresponding Map faces. (Remember, there is\n            a one-to-one correspondence between their indices, so the task is relatively trivial\n            - see <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinates</a></span>). \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1044\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1045\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6645\"></a><pre>\nfn splitMeshByUVElements mesh channel =\n(\n	with undo off\n	(\n		local obj = copy mesh--copy the original object\n		convertToMesh obj--convert to editable mesh\n		while obj.numfaces &gt; 0 do--repeat until all elements have been detached\n		(\n			  face_array = #(1)--init. an array including only face 1\n			  cnt = 0--init. a counter  --repeat until the counter is higher than the faces stored in the array\n			  while cnt &lt; face_array.count do\n			  (\n					cnt += 1 --increase the counter --get all map vertices used by the current map face in the collection array:\n					theVerts = meshop.getMapVertsUsingMapFace obj channel #(face_array[cnt])\n					--get all map faces used by these map vertices - --this gives us all neighbours of the current map face\n					theFaces = meshop.getMapFacesUsingMapVert obj channel theVerts\n					--make sure only unique faces are written to the array\n					for f in theFaces where findItem face_array f == 0 do\n						append face_array f\n			  )--end while cnt --once all connected faces in an element are collected, --create a new empty EMesh:\n			  with undo on\n			  new_emesh = Editable_mesh()\n			  --detach the collected faces and assign to the EMesh\'s TriMesh\n			  new_emesh.mesh = meshop.detachFaces obj face_array delete:true asMesh:true\n			  --Copy the transformation of the original object\n			  new_emesh.transform = mesh.transform\n			  --Assign a unique name based on the original one\n			  new_emesh.name = uniquename (mesh.name +\"_UVsplit\")\n		)--end while numfaces\n	delete obj--delete the clone which has no faces at this point\n	)\n)\n \n--Example usage:\ntheTeapot = Teapot mapcoords:true\nsplitMeshByUVElements theTeapot 1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC106E\"></a> <span class=\"char_link\"><a href=\"GUID-CBBA20AD-F7D5-46BC-9F5E-5EDA109F9CF4.htm\">Understanding Texture Coordinates</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC106F\"></a> <span class=\"char_link\"><a href=\"GUID-17D700DC-1FDC-4713-8041-D9E3C3EB4789.htm\">Unwrap_UVW : Modifier</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1070\"></a> <span class=\"char_link\"><a href=\"GUID-A97DF4E3-04A7-4A91-AE7C-3C75A8BAA399.htm\">Meshop General Mapping Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1071\"></a> <span class=\"char_link\"><a href=\"GUID-EF78FA1A-A382-4BED-BA10-7C856A7551A5.htm\">Meshop Face Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1072\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";