var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F31D331A-D62B-4E31-8579-24911D35CD3D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"AdvancedWood\">\n      <meta name=\"indexterm\" content=\"AdvancedWood TextureMap\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AdvancedWood : textureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F31D331A-D62B-4E31-8579-24911D35CD3D\"></a><div class=\"head\">\n            <h1>AdvancedWood : textureMap</h1>\n         </div>\n         <div class=\"codeBlock\"><pre>AdvancedWood - superclass: textureMap; super-superclass:material - 47:0 - classID: #(2290417414L, 2683680373L)</pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7325\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7326\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap</a></span> &gt; AdvancedWood \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> The AdvancedWood texturemap is a procedural texture map that creates highly realistic\n            wood textures, with pre-sets for several common wood types. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. \n            	 \n         </p>\n         <p>Connecting an AdvancedWood map to a Material will automatically create Map Output\n            Selector nodes to connect both Diffuse Color and Bump ports on the Material, which\n            are hidden by default in the Slate Material Editor. You can get the AdvancedWood object\n            by looking at the sourceMap property. For example: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>tpot = teapot()\nmat = StandardMaterial()\nadvWood = AdvancedWood()\n\n-- doing this creates Map Output Selectors\n-- that connect the AdvancedWood Diffuse to Material Diffuse\n-- and AdvancedWood Roughness to Material Bump\n\nmat.diffuseMap = advWood\ntpot.material = mat\n\n-- but to get the wood we need to look at the sourceMap of the \n-- Output Selector:\nmyAdvWood = mat.diffuseMap.sourceMap</pre></div>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7328\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-439D\"></a><pre><em class=\"codeEmphasisStrong\">AdvancedWood</em>... 	  </pre></div>\n         <div class=\"section\"><a name=\"SECTION_8E7192FFEE6F47E18D53DACA20312445\"></a> \n            <h2><a name=\"GUID-A5F6BDBC-91BA-4AF9-AEA0-9775FF6D3525\"></a>Properties\n            </h2> \n            <p>The properties are listed here organized in the order they appear on the AdvancedWood\n               UI, with the exception of the Perlin Noise profile parameters, which are not viisble\n               on the UI. \n               		\n            </p> \n            <div class=\"section\"><a name=\"SECTION_E65B17D7BBCA4D2C9F497AB9363738AA\"></a> \n               <h3><a name=\"GUID-79B5C1C5-F10F-4299-AAE0-164061154A28\"></a>Presets\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">preset</em>     Integer    default: 0   --  integer</pre></div> \n               <p>Gets or sets the preset profile, from 0 = \"3D Ash Glossy\" to 39 = \"3D Walnut - Unfinished\".\n                  \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_1E65E8240690461BBB4E0B7D9E800163\"></a> \n               <h3><a name=\"GUID-D3E05252-B9AC-4431-A11E-335C016A6594\"></a>General Properties\n               </h3> \n               <p>These are parameters that appear in the \n                  			 <em class=\"strong\">General</em> area of the AdvancedWood UI. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">scale</em>     Float    default: 1.0   --  animatable; float</pre></div> \n               <p>Scales the texture map. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">axis</em>     Integer    default: 2   --  animatable; integer</pre></div> \n               <p>The axis of the wood grain where 0=X, 1=Y, and 2=Z. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">unit_dependent</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to use scene units for scaling. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">roughness</em>     Float    default: 0.16   --  animatable; float</pre></div> \n               <p>Specifies the amount of roughness, on a scale of 0.0 = 1.0. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">early_wood_color</em>     Color    default: (color 182.444 131.937 75.9015)   --  animatable; RGB color; Controller Scaling: ([1,1,1] : (color 255 255 255)); WeirdScaled ([1,1,1])</pre></div> \n               <p>The \"early\" (light) wood color in the grain. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">early_wood_color_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n               <p>The map applied to early wood color. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_early_wood_color_perlin</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply perlin noise to the early wood color. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_groove_roughness</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to create groove roughness. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">groove_roughness</em>     Float    default: 0.22   --  animatable; float</pre></div> \n               <p>The groove roughness amount, when .<span class=\"code\">use_groove_roughness</span> is true. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">late_wood_color_power</em>     Float    default: 1.0   --  animatable; float; Late_Color_Power</pre></div> \n               <p>The amount to \"darken\" (if &gt; 1.0) or \"lighten\" (&lt;1.0) the early wood color to create\n                  the late wood color, if a late wood color or map is not specified. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_manual_late_wood_color</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to calculate late wood color based on the early wood color (false),\n                  or use a the specified \n                  			 <span class=\"code\">manual_late_wood_color</span> (true). \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">manual_late_wood_color</em>     Color    default: (color 147.784 105.863 55.0198)   --  animatable; RGB color; Controller Scaling: ([1,1,1] : (color 255 255 255)); WeirdScaled ([1,1,1])</pre></div> \n               <p>The color to use for late wood, if \n                  			 <span class=\"code\">use_manual_late_wood_color</span> is true. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">manual_late_wood_color_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n               <p>A map to use for late wood color, if defined and \n                  			 <span class=\"code\">use_manual_late_wood_color</span> is true. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_late_wood_color_perlin</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply Perlin noise to the late wood color. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_late_wood_bump</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply bump map to the late wood color. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">late_wood_bump_depth</em>     Float    default: 0.1   --  animatable; float</pre></div> \n               <p>The bump depth, if \n                  			 <span class=\"code\">use_late_wood_bump</span> is true. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_diffuse_perlin</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply Perlin noise to the fiber. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">diffuse_perlin_scale_z</em>     Float    default: 0.05   --  animatable; float</pre></div> \n               <p>Sets the scale of the Perlin noise applied to the diffuse color, if \n                  			 <span class=\"code\">use_diffuse_perlin</span> is true. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">diffuse_lobe_weight</em>     Float    default: 0.8   --  animatable; float</pre></div> \n               <p>The global diffuse lobe weight, which is a multiplier to the diffuse color output.\n                  \n                  		  \n               </p> \n               <p> </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_3813EB69D1EB4634A3619AFFFBB72A81\"></a> \n               <h3><a name=\"GUID-68CB1245-2228-4317-96EC-94EF47B52CA7\"></a>Weights and Ratios\n               </h3> \n               <p>These parameters affect relationships between other parameters, as well as sharpness\n                  and noise settings. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_fiber_cosine</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to use the fiber cosline. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_fiber_perlin</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply Perlin noise to the wood fiber. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">fiber_perlin_scale_z</em>     Float    default: 0.1   --  animatable; float</pre></div> \n               <p>Specifies the amount of Perlin noise to apply to the wood fiber. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_growth_perlin</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to apply Perlin noise to the wood growth rings. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">late_wood_ratio</em>     Float    default: 0.098   --  animatable; float</pre></div> \n               <p>Specifies the ratio of early wood to late wood, where 1.0 is all early wood, 0.0 is\n                  all late wood, and 0.5 is half of each. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">early_wood_sharpness</em>     Float    default: 0.395   --  animatable; float</pre></div> \n               <p>Defines the sharpness or amount of transition between the early wood and late wood\n                  rings. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">late_wood_sharpness</em>     Float    default: 0.668   --  animatable; float</pre></div> \n               <p>Specifies the sharpness of the transition between the late wood and the next growth\n                  ring. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ring_thickness</em>     Float    default: 1.0   --  animatable; float</pre></div> \n               <p>Specifies the width or thickness of the wood growth rings, with 1.0 being the maximum\n                  ring size. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_43D1FF3978244626BA07A9D125F5A59E\"></a> \n               <h3><a name=\"GUID-E3AB626F-A22D-41A1-B0D5-27DE6FAA2F30\"></a>Pores\n               </h3> \n               <p>These settings affect the apperance of \"pores\" in the wood, which are veins that appear\n                  as holes in the wood end grain, and stripes or streaks in the side grain. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_pores</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to generate pores. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">pore_type</em>     Integer    default: 0   --  integer</pre></div> \n               <p>Specifies where to generate pores, where 0 = Both, 1 = Early Only, and 2 = Late Only.\n                  \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">pore_radius</em>     Float    default: 0.04   --  animatable; float</pre></div> \n               <p>The radius of the pores. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">pore_cell_dim</em>     Float    default: 0.15   --  animatable; float</pre></div> \n               <p> The dimension of the cell noise that makes pores. A smaller number increases the\n                  density of pores.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">pore_color_power</em>     Float    default: 1.4   --  animatable; float</pre></div> \n               <p>The amount of darkening to apply to the early wood color to produce the pore color.\n                  \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">pore_depth</em>     Float    default: 0.025   --  animatable; float</pre></div> \n               <p>The depth amount of the pores. \n                  		  \n               </p> \n               <p> </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_E0AB9A3A532145059E44468611FB1A0F\"></a> \n               <h3><a name=\"GUID-10CEE9B7-CD46-497C-B3CB-D90537C5BEA1\"></a>Rays\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">use_rays</em>     BooleanClass    default: true   --  animatable; boolean</pre></div> \n               <p>Specifies whether to use rays.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ray_color_power</em>     Float    default: 1.25   --  animatable; float</pre></div> \n               <p>A color multiplier to apply to the early wood color to generate the ray color. Higher\n                  numbers produce darker rays.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ray_seg_length_z</em>     Float    default: 5.0   --  animatable; float</pre></div> \n               <p>Ray segment length, higher numbers produce fewer rays.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ray_num_slices</em>     Integer    default: 30   --  integer</pre></div> \n               <p>The number of ray slices. Higher numbers increase the ray density.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ray_ellipse_z2x</em>     Float    default: 10.0   --  animatable; float</pre></div> \n               <p>The ray ellipse shape ratio.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">ray_ellipse_scale_x</em>     Float    default: 0.5   --  animatable; float</pre></div> \n               <p>The ray radius.\n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_EBC6E77C5A444AB88F71D7B20EE9BD07\"></a> \n               <h3><a name=\"GUID-BFD9A2CE-B985-4488-A135-795FA8BFD0B4\"></a>Coordinates\n               </h3> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">coords</em>     StandardXYZGen    default: MtlBase:Placement   --  alias: Coordinates; SubAnim</pre></div> \n               <p>See StandardXYZGen for the coordinates properties. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_E3E00E3F23644CB39F8D11F5858D3886\"></a> \n               <h3><a name=\"GUID-DB6C4A29-E7DA-4FAD-8076-A7444A4E2FD4\"></a>Profile Parameters\n               </h3> \n               <p>These parameters are exposed to MAXScript but do not appear in the Advanced Wood texture\n                  map UI. These are strings that set the profile used to generate Perlin noise for those\n                  parameters to which Perlin noise can be applied. Generally the default is sufficient\n                  to produce good results. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">diffuse_perlin_prof</em>     String    default: \"0.1 0.1 0.4 0.15 5 0.2 0.01 0.4\"   --  string; Diffuse_Perlin_Profile</pre></div> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">early_wood_color_perlin_prof</em>     String    default: \"8 0.2 3 0.3 0.35 0.15\"   --  string; Early_Wood_Color_Perlin_Profile</pre></div> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">fiber_cosine_prof</em>     String    default: \"15 0.2 2 0.5\"   --  string; Fiber_Cosine_Profile</pre></div> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">fiber_perlin_prof</em>     String    default: \"23.5 1.25 8 0.75 2 0.15\"   --  string; Fiber_Perlin_Profile</pre></div> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">growth_perlin_prof</em>     String    default: \"0.5 0.5\"   --  string; Growth_Perlin_Profile</pre></div> \n               <div class=\"codeBlock\"><pre>&lt;AdvancedWood&gt;.<em class=\"codeEmphasisStrong\">late_wood_color_perlin_prof</em>     String    default: \"4 0.25 1.5 0.15\"   --  string; Late_Wood_Color_Perlin_Profile</pre></div> \n            </div> \n         </div>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";