var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F33A03CA-24A3-4CBF-AF4A-FA3408ACD95D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"particleInteger Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>particleInteger Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F33A03CA-24A3-4CBF-AF4A-FA3408ACD95D\"></a><div class=\"head\">\n            <h1>particleInteger Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84697\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84698\"></a>The following sample script assigns Integer values to the <em class=\"strong\">particleInteger</em> channel according to particle speed. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84699\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8469A\"></a>Can be used to choose targets in the <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target</a></span> Test when <span class=\"code\"> <em class=\"strong\">.Assignment_Type</em> </span> is set to <em class=\"strong\">4 : By Script Integer</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8469B\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8469C\"></a>When used with a <em class=\"strong\">Find_Target</em> operator, the <em class=\"strong\">particleInteger</em> channel can be used to specify the target objects by index. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8469D\"></a>If the speed is below 1 unit per frame, then the particle is assigned to the first\n            target (index=0). If the speed is higher than 10 units per frame then the particle\n            is assigned to the third target (index=2). All other particles are assigned to the\n            second target (index = 1). \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8469F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E846A0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E15\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\n--Enable the Time channel:\npCont.useTime = true\n--Enable the Speed channel:\npCont.useSpeed = true\n--Enable the Integer channel:\npCont.useInteger = true\n)\n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n( \n--get the number of particles\ncount = pCont.NumParticles()\n \n--define two local variables slowSpeed and fastSpeed\n--as 1 resp. 10 units per frame (in NTSC time 160 ticks are 1 frame)\nslowSpeed = 1/160.0\nfastSpeed = 10/160.0\n \n--Loop from 1 to the number of particles:\nfor i in 1 to count do\n(\n \n--Set the particle index in the container to the current i value\npCont.particleIndex = i\n \n--If the length of the particleSpeed vector is shorter than\n--the defined slowSpeed value,\n--then set the particleInteger value to 0:\nif length(pCont.particleSpeed) &lt; slowSpeed then\npCont.particleInteger = 0\n \n--If the particle is faster than the slowSpeed value, test its\n--speed against the fastSpeed value. If faster, assign 2, if slower,\n--(between slowSpeed and fastSpeed), assign 1 to the\n--particleInteger channel:\nelse\n(\nif (length(pCont.particleSpeed) &gt; fastSpeed) then\npCont.particleInteger = 2\nelse\npCont.particleInteger = 1\n)\n)--end i loop\n)--end Proceed\n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846E7\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846E8\"></a> <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846E9\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846EA\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";