var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F3DD633D-728E-46EB-8D07-31307AEE1BF4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"Interval Values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interval Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F3DD633D-728E-46EB-8D07-31307AEE1BF4\"></a><div class=\"head\">\n            <h1>Interval Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F22\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F21\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"\">Time Data Values</a></span> &gt; Interval Values \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F1F\"></a>An <em class=\"strong\">Interval </em>class represents an interval of time. \n         </p>\n         <p><a name=\"P_6B4C8B8938224F2CAE9AEB5669640FBF\"></a>It has two time value components: start and end. \n         </p>\n         <p><a name=\"P_24C5CF71EE4E4201B8F9B2539BA59916\"></a>The start and end values can be numbers or <span class=\"char_link\"><a href=\"GUID-51429B01-2FC6-4746-9E88-5EB5D93056CC.htm\">Time values</a></span> (numbers are interpreted as frame counts). \n         </p>\n         <p><a name=\"P_DB72CF13ACAC423E99A564009A14F0E3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F1E\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE1\"></a><pre><em class=\"codeEmphasisStrong\">interval</em> &lt;start_time&gt; &lt;end_time&gt;</pre></div>\n         <p><a name=\"P_8E37C270D7D9409B8E48BD19E89BE861\"></a>Construct a new interval value from start and end values. \n         </p>\n         <p><a name=\"P_E45B6206DAB647BA98AC6BBB5531E17B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F1B\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EE0\"></a><pre>&lt;interval&gt;.<em class=\"codeEmphasisStrong\">start</em> : Time</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F19\"></a>Gets/sets the start value of the interval. \n         </p>\n         <p><a name=\"P_5A0A47B1C37B4FED98CE55730DBC4F3A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EDF\"></a><pre>&lt;interval&gt;.<em class=\"codeEmphasisStrong\">end </em>: Time</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F16\"></a>Gets/sets the end value of the interval. \n         </p>\n         <p><a name=\"P_64F009458E5C44A490C79C62395AE328\"></a>&nbsp;&nbsp;&nbsp; \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F14\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F13\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5EDE\"></a><pre>\nt = animationRange.start + 5\norig_anim_range=animationRange -- store original animation range\nanimationRange=interval 0 100000 -- set real long animation range\n-- assign script controller, controllers range is the current\n-- animation range\nControlObj.scale.controller=scale_script()\n-- assign a script to the controller\nControlObj.scale.controller.script = controlscript\n-- reset animationRange back to original value\nanimationRange=orig_anim_range\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F05\"></a>Some of the examples above refer to system global variables. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7F04\"></a>See <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm\">3ds MaxSystem Globals</a></span> for more details. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";