var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F4472597-9ECE-4884-A5C0-2161F1E4F60A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Duplicated Members And Functions in Structure Definitions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F4472597-9ECE-4884-A5C0-2161F1E4F60A\"></a><div class=\"head\">\n            <h1>Duplicated Members And Functions in Structure Definitions </h1>\n         </div>\n         <p><a name=\"GUID-8DDE831D-3BE4-4116-B280-4DBC3D4260D1\"></a> In versions prior to <em class=\"strong\">3ds Max 2014</em>, both duplicated Members and Function definitions were allowed. \n         </p><a name=\"TABLE_E2CBE1859A58453095318FEAF7423FB7\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE PRIOR TO 3DS MAX 2014:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\ntest = 1,\ntest = 2\n)\na = test()\na.test</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>2</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-251E2CDC-34FC-433D-97D8-37E202D89FF4\"></a> Starting with <em class=\"strong\">3ds Max 2014</em>, duplicated Member definitions are disallowed and a Compile-time error is generated:\n            \n         </p><a name=\"TABLE_A409D8A8FB004DE38CFA1A7019A62702\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE IN 3DS MAX 2014:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\ntest = 1,\ntest = 2\n)\na = test()\na.test</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- Error occurred in anonymous codeblock; filename: ; position: 32; line: 4\n-- Compile error: Duplicate struct member name:  test\n--  In line: test=\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-3B98E1CD-9501-4EB3-BECD-210D36F8CEC2\"></a>The same applies to duplicated names in Members and Functions. \n         </p>\n         <p><a name=\"GUID-CF08F79F-2BE5-44E2-ADC4-5F185B161787\"></a>Prior to <em class=\"strong\">3ds Max 2014</em>, an error is caused by the member <span class=\"code\">test</span> being <span class=\"code\">undefined</span> and the function call <span class=\"code\">test()</span> attempting to access the member <span class=\"code\">test</span> due to the duplicated name: \n         </p><a name=\"TABLE_3AA120C994784903984B64CD5673494C\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE PRIOR TO 3DS MAX 2014:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\ntest,\nfn test2 = test(),\nfn test = print \"hello!\"\n)\na = test()\na.test2()</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>#Struct:Test(\n  Test:&lt;fn&gt;; Public,\n  test2:&lt;fn&gt;; Public)\n(Test)\n-- Error occurred in test2(); filename: C:\\Program Files\\Autodesk\\3ds Max 2013\\scripts\\; position: 40; line: 4\n--  Frame:\n-- Type error: Call needs function or class, got: undefined</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-B8C6F93E-E29C-4EEB-BAA1-9687921E94CC\"></a>Starting with <em class=\"strong\">3ds Max 2014</em>, a Compile-time error is caused by the name duplication of Member <span class=\"code\">test</span> and the Function <span class=\"code\">test</span>: \n         </p><a name=\"TABLE_D47976E7CBDD4077A649CFA8E6E28A18\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE IN 3DS MAX 2014:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\ntest,\nfn test2 = test(),\nfn test = print \"hello!\"\n)\na = test()\na.test2()</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- Error occurred in anonymous codeblock; filename: ; position: 52; line: 5\n-- Compile error: Duplicate struct member name:  test\n--  In line: fn test =</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-BE2B306B-A51A-486C-A666-35A37C424654\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-64F48DEE-DF26-443B-B2FF-AA73CA0BC0F4\"></a>Duplicated Function definitions are allowed both prior and after <em class=\"strong\">3ds Max 2014</em> - the last defined function will be used. \n         </p>\n         <p><a name=\"GUID-1B105D29-8351-4F6D-A661-A1100638ABAE\"></a>This provides a way to perform forward declarations of Functions. \n         </p><a name=\"TABLE_7D583D9C179244F7B0A89DDD64A6C9C1\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">TEST WITHOUT FORWARD DECLARATION:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\nfn test2 = test(),\nfn test = print \"hello!\"\n)\na = test()\na.test2()\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>#Struct:test(\n  test2:&lt;fn&gt;; Public,\n  test:&lt;fn&gt;; Public)\n(test)\n(test)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-A0A9DCE6-802E-4D4E-9DB8-885DD3CF74A7\"></a>&nbsp;&nbsp;&nbsp; \n         </p><a name=\"TABLE_B39FF40A18894DAD854E73A5B4F58EE5\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">TEST WITH FORWARD DECLARATION:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>struct test \n(\nfn test = (), -- Pre-declare test to allow test2 to \"see\" it\nfn test2 = test(), -- Point at the pre-declared function\nfn test = print \"hello!\" -- Replace existing test definition, test2 now sees the new definition\n)\na = test()\na.test2()\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>#Struct:test(\n  test2:&lt;fn&gt;; Public,\n  test:&lt;fn&gt;; Public)\n(test)\n\"hello!\"\n\"hello!\"</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0BA77208-7238-4EF2-AA48-1D8847C0610A\"></a>In this case, the Function <span class=\"code\">test2</span> first points at the first occurrence of <span class=\"code\">test</span>, then as <span class=\"code\">test</span> is redefined, <span class=\"code\">test2</span> starts pointing at the latest definition of <span class=\"code\">test</span>. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";