var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F4752B8E-BF87-44FA-97F2-EC73B1B90F29\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Debugger\">\n      <meta name=\"indexterm\" content=\"Manual Break Points using the Break Function\">\n      <meta name=\"indexterm\" content=\"break()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Manual Break Points using the Break() Function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F4752B8E-BF87-44FA-97F2-EC73B1B90F29\"></a><div class=\"head\">\n            <h1>Manual Break Points using the Break() Function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC534B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC534C\"></a>   You can add manual break points to your code by using the <span class=\"code\"> <em class=\"strong\">break()</em> </span> function to invoke the Debugger. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5351\"></a> <em class=\"strong\">Syntax:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6378\"></a><pre> <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">break()</em></pre></div> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5353\"></a>This function breaks the execution of the code and invokes the Debugger allowing you\n               to see the state of your variables at that point. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5355\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5356\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6377\"></a><pre>\nfor i = 1 to 10000 do\n(\ntheRandom = random 1 100\nif theRandom == 50 do break()\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC535F\"></a>In this simple example, the Debugger will be called if the random value generated\n               within the loop generates the integer 50. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5361\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5362\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5363\"></a><p class=\"table-body\">Some parts of the code are \"locked\" and cannot be stopped from executing. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5364\"></a><p class=\"table-body\">One of the \"locks\" that prevents breaking into the debugger is one associated with\n                           arrays. When you are iterating across an array using the FOR statement, the lock is\n                           set. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5365\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6376\"></a><pre>\nfor i in #(1,2) do break()\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5369\"></a><p class=\"table-body\">The result will be *** Break attempt timed out *** printed to the Debugger Output\n                           without a successful break. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC536D\"></a> <span class=\"char_link\"><a href=\"GUID-1B1833F0-8712-4EA5-AFFA-3E42DBF7960C.htm\">The MAXScript Debugger</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC536E\"></a> <span class=\"char_link\"><a href=\"GUID-B016FEF4-BE4C-40EB-887C-0752F97239F2.htm\">Interface: MXSDebugger</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";