var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F6D660D1-D0EE-41DB-804D-7404E513E2B6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>For Loop Collect Vs For Loop Do Performance</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F6D660D1-D0EE-41DB-804D-7404E513E2B6\"></a><div class=\"head\">\n            <h1>For Loop Collect Vs For Loop Do Performance </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15A9\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15AB\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15AC\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; For Loop Collect Vs For Loop Do \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15AE\"></a> \n            <h2><a name=\"GUID-30358C07-169C-4E9F-BCD5-FC791137C944\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15AF\"></a>I was quickly making a script to select all objects and I realized that it was very\n               slow, even with undo off, disableSceneRedraw and suspendEditing. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6606\"></a><pre>for o in objects do selectmore o</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15B3\"></a>I thought a bit and discovered that I could select an array of objects like in this\n               code: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6605\"></a><pre>a=#()\nfor o in objects do append a o\nselectmore a</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15B8\"></a>The difference in speed is really huge (like 3000%+ faster). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15B9\"></a>But there is absolutely no reference to the possibility of selecting an array of objects\n               in the MAXScript help, even in the \"how to make it faster\" section. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BA\"></a>Is there anything I should know about that way of selecting objects? \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BB\"></a>Why isn\'t that documented a tall as it looks very effective? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BC\"></a> \n            <h2><a name=\"GUID-8796C7F3-5062-4488-929B-3240757C629E\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BD\"></a>The truth is people tend to code differently. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BE\"></a>All the info needed was in the Reference, but it did not really tell you \"Don\'t do\n               this\" because nobody can anticipate every possible expression someone might write.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15BF\"></a>Doing things one at a time instead of once for the whole collection sounds like it\n               would be slow, and it is. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C0\"></a>The first example loops through an ObjectSet and sets the isSelected property of the\n               node to true for each one, which is very very slow. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C1\"></a>The second example does indeed call selectMore() in a mapped fashion, but the array\n               building is a bit inefficient, as it uses append() which has to grow the array on\n               each call by duplicating the previous array in memory. With few objects it would be\n               negligible though, with a lot more objects it might start causing slowdowns... \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C4\"></a><p class=\"table-body\"> <em class=\"strong\">POSSIBLE EXPRESSIONS</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C5\"></a><p class=\"table-body\">If you really have to do a FOR loop, use the COLLECT form instead of DO. It builds\n                           the array and gives back the result without using append() explicitly or any intermediate\n                           variables to store the array. You could assign to a vatiable if you want to keep the\n                           selection snapshot around. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15C6\"></a><p class=\"table-body\">It would be something like: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6604\"></a><pre>\nselect (for o in objects collect o)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15CA\"></a><p class=\"table-body\">This would allow you to apply where conditions, for example to select all visible\n                           objects, \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6603\"></a><pre>\nselect (for o in objects where not o.isHiddenInVpt collect o)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15CE\"></a><p class=\"table-body\">or, if this really is what you are trying to do, selecting ALL scene object, simply\n                           \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6602\"></a><pre>\nselect objects\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15D3\"></a>There is no reason to do selectmore() if you are selecting all scene objects anyway,\n               and you can operate on the live collection of scene objects without converting it\n               to array. Note that select() will make sure the previous selection is removed, while\n               selectMore() will obviously add to the existing one. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15D5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15D6\"></a><p class=\"table-body\"> <em class=\"strong\">SOME BENCHMARK RESULTS</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15D7\"></a><p class=\"table-body\">The time is measured on the same reference computer around the select() method and\n                           does NOT include the time it takes the viewport(s) to actually redraw, just the time\n                           to set the selected flags of the nodes. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15D8\"></a><p class=\"table-body\"> <em class=\"strong\">EXPRESSION 1 - SELECT ALL</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6601\"></a><pre>\nselect objects\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15DC\"></a><p class=\"table-body\">With 100objects (boxinstances), the above expressiontook31 ms. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15DD\"></a><p class=\"table-body\">With 1,000objects, it took 78ms. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15DE\"></a><p class=\"table-body\">With 10,000objects, it took 328ms. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15DF\"></a><p class=\"table-body\">With 100,000objects, it took 15,468ms. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15E0\"></a><p class=\"table-body\"> <em class=\"strong\">EXPRESSION 2 - DO, APPEND AND SELECT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6600\"></a><pre>\na=#()\nfor o in objects do append a o\nselect a\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15E6\"></a><p class=\"table-body\">With 100, 1000 and 10,000 objects, the above expression performed similarly to the\n                           first one, proving that the memory overhead of the array management is not measurable\n                           with relatively low numbers of iterations. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15E7\"></a><p class=\"table-body\">The code is longer and less elegant though. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15E8\"></a><p class=\"table-body\">With 100,000 objects, the expression took 17,547ms., or about two seconds more than\n                           the first expression. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15E9\"></a><p class=\"table-body\"> <em class=\"strong\">EXPRESSION 3 - TEST, COLLECT AND SELECT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FF\"></a><pre>\nselect (for o in objects where not o.isHiddenInVpt collect o)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15ED\"></a><p class=\"table-body\">The above expression took around 430ms with 1000 objects. </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15EE\"></a><p class=\"table-body\">Performing a condition test on 1000 objects does not make a significant difference,\n                           but increases the flexibility of the expression to select specific objects by their\n                           properties. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15F0\"></a><p class=\"table-body\"> <em class=\"strong\">EXPRESSION 4 - DO AND SELECT MORE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65FE\"></a><pre>\nfor o in objects do selectMore o\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15F4\"></a><p class=\"table-body\">The above expression took only <em class=\"strong\">171 ms</em> if all 1000 objects were <em class=\"strong\">already selected</em> because it had nothing to do, but <em class=\"strong\">674172 ms</em> (over <em class=\"strong\">11 minutes!!!</em>) if none of the 1000 objects were selected! \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15F5\"></a><p class=\"table-body\"> <em class=\"strong\">STAY AWAY FROM IT!</em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15F7\"></a> <em class=\"strong\">Previous Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15F8\"></a> <span class=\"char_link\"><a href=\"GUID-279879A8-9844-4C29-9EA8-43E5FF922692.htm\">For Loop By Index Vs For Loop Through Collection Performance</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15FA\"></a> <em class=\"strong\">Next Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC15FB\"></a> <span class=\"char_link\"><a href=\"GUID-2420F55C-E839-4F6A-9E89-6866D118A4A9.htm\">Optimizing Particle Flow Script Operator For Loops For Speed</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";