var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F7FA2755-0408-4610-ABDB-B403D85AA597\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Change Objects At Render Time</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F7FA2755-0408-4610-ABDB-B403D85AA597\"></a><div class=\"head\">\n            <h1>How To ... Change Objects At Render Time </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2121\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2122\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Change Objects At Render Time \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2124\"></a>Using callback scripts, you can let MAXScript perform specific operations whenever\n            certain system events occur. In the following example, we will increase the segment\n            count of all spheres in the scene prior rendering, and decrease again after finishing.\n            This will implement a kind of custom render resolution control for spheres. You can\n            use similar approach to implement other pre-render preparations. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2125\"></a> <em class=\"strong\">Related Topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2126\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining MacroScripts</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2127\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2129\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212A\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212B\"></a><p class=\"table-body\">Package the code as macroScript to be able to use as a button, menu item or shortcut.\n                        \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212C\"></a><p class=\"table-body\">Remove any existing callbacks with our unique id. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212D\"></a><p class=\"table-body\">Create a string containing the callback script for increasing the segment count of\n                        spheres. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212E\"></a><p class=\"table-body\">In the script, loop through all geometry objects, check for sphere class of the base\n                        object and increase the segment count value 8 times. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC212F\"></a><p class=\"table-body\">Register a callback to be called before Rendering starts, give it a unique id. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2130\"></a><p class=\"table-body\">Create a second string containing the callback script for decreasing the segment count\n                        of spheres. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2131\"></a><p class=\"table-body\">In the script, loop through all geometry objects, check for sphere class of the base\n                        object and decrease the segment count value 8 times. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2132\"></a><p class=\"table-body\">Register a callback to be called after Rendering finishes, give it the same unique\n                        id. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2133\"></a><p class=\"table-body\">Create a second macroScript that removes our callbacks by id. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2135\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-15E55659-1BE5-4343-8A9C-DFC84676195A-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2136\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-FECED988-73E8-490F-A7A5-90D37C2AF8BE-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2138\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2139\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D5\"></a><pre>\nmacroscript SphereSegsOn category: \"HowTo\"\n(\ncallbacks.removescripts id:#sphere_segs\ntxt =\"for o in geometry do(\\n\"\ntxt +=\"if classof o.baseObject == Sphere then \\n\"\ntxt +=\"o.baseObject.segments *= 8.0\\n\"\ntxt +=\")\\n\"\n&nbsp;\ncallbacks.addscript #preRender txt id:#sphere_segs\ntxt =\"for o in geometry do(\\n\"\ntxt +=\"if classof o.baseObject == Sphere then \\n\"\ntxt +=\"o.baseObject.segments /= 8.0\\n\"\ntxt +=\")\\n\"\n&nbsp;\ncallbacks.addscript #postRender txt id:#sphere_segs\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D4\"></a><pre>\nmacroscript SphereSegsOff category: \"HowTo\"\n(\ncallbacks.removescripts id:#sphere_segs\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2152\"></a> \n            <h2><a name=\"GUID-64A48721-1011-484E-9D56-EE323CA5B714\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D3\"></a><pre><em class=\"codeEmphasisStrong\">macroscript SphereSegsOn category:\"HowTo\"\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2155\"></a>The macroScript will be called \n               		  <span class=\"code\"> <em class=\"strong\">SphereSegsOn</em> </span>. To use the script, you can go to Customize... and drag the script from the category\n               \"HowTo\" to a toolbar, a menu, a quad menu or assign to a keyboard shortcut. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2156\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D2\"></a><pre><em class=\"codeEmphasisStrong\">callbacks.removescripts id:#sphere_segs</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2158\"></a>Before creating new callbacks, we try to remove any existing ones from a previous\n               session. It is allowed to call \n               		  <span class=\"code\"> <em class=\"strong\">callbacks.removescripts</em> </span> even if no callbacks with the specified id exist in the moment. If there are none,\n               the call does nothing. If there are any, they will be removed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2159\"></a>We are going to use the same id \n               		  <span class=\"code\"> <em class=\"strong\">#sphere_segs</em> </span>throughout the code. This way, we can affect only our callbacks without touching any\n               others callbacks. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC215A\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm#WS73099CC142F487553098682E12AC2FC2BC7-690E\">Callbacks.removeScripts</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D1\"></a><pre><em class=\"codeEmphasisStrong\">txt = \"for o in geometry do(\\n\"\ntxt +=\"if classof o.baseObject == Sphere then \\n\"\ntxt +=\"o.baseObject.segments *= 8.0\\n\"\ntxt +=\")\\n\"</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC215F\"></a>In order to define a callback, we will need a string containing the code to be executed.\n               We define a new user variable called txt and assign our code to it. The backslash\n               n sequence denotes a new line. The script will loop through all geometry objects in\n               the scene and ask each one for its base object (the object at the bottom of the modifier\n               stack). If the class of the base object is Sphere, then we multiply the existing number\n               of segments by 8. This means that the spheres will be changed even if there are modifiers\n               like MeshSmooth, Bend etc. on the stack. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2160\"></a> <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm\">String Values</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2161\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2162\"></a> <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2163\"></a> <span class=\"char_link\"><a href=\"GUID-00AB0CFA-3190-4A28-A185-4774B684F6D8.htm\">General Node Properties</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2164\"></a> <span class=\"char_link\"><a href=\"GUID-BD5ADFE5-379A-40D5-8FA2-3EB9649F088B.htm\">Sphere : GeometryClass</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64D0\"></a><pre><em class=\"codeEmphasisStrong\">callbacks.addscript #preRender txt id:#sphere_segs</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2166\"></a>Now we can assign the code as a callback script. . The keyword \n               		  <span class=\"code\"> <em class=\"strong\">#preRender</em> </span> tells the callback that the script will be executed before rendering begins. The\n               callback will have our unique id \n               		  <span class=\"code\"> <em class=\"strong\">#sphere_segs</em> </span> so we can remove it by id anytime. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2167\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CF\"></a><pre><em class=\"codeEmphasisStrong\">txt = \"for o in geometry do(\\n\"\ntxt +=\"if classof o.baseObject == Sphere then \\n\"\ntxt +=\"o.baseObject.segments /= 8.0\\n\"\ntxt +=\")\\n\"</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC216C\"></a>This is basically the same code as before, but instead of multiplying, we divide the\n               segments by 8. This should return all spheres to their original state. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CE\"></a><pre><em class=\"codeEmphasisStrong\">callbacks.addscript #postRender txt id:#sphere_segs</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC216E\"></a>We assign the new code as a callback script again. The keyword \n               		  <span class=\"code\"> <em class=\"strong\">#postRender</em> </span> tells the callback that the script will be executed after the rendering finishes.\n               The callback will have the same unique id. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CD\"></a><pre><em class=\"codeEmphasisStrong\">)\nmacroscript SphereSegsOff category:\"HowTo\"\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2172\"></a>We define a second macroScript for turning off the effect of the callbacks. It will\n               appear in the same category and will have the name \n               		  <span class=\"code\"> <em class=\"strong\">SphereSegsOff</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2173\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CC\"></a><pre><em class=\"codeEmphasisStrong\">callbacks.removescripts id:#sphere_segs</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2175\"></a>We remove any existing callbacks with our id. Rendering a scene with spheres should\n               work as usual after calling this line. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2176\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm#WS73099CC142F487553098682E12AC2FC2BC7-690E\">Callbacks.removeScripts</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-64CB\"></a><pre><em class=\"codeEmphasisStrong\">)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2178\"></a> \n            <h2><a name=\"GUID-ED0B47BD-F0F5-49DC-9B9F-FEA31DF8CAA8\"></a> <em class=\"strong\">Using the Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2179\"></a>Evaluate the code. To use the two scripts, you can use Customize... to drag the scripts\n               from the category \"HowTo\" to a toolbar, a menu, a quad menu or to assign to a keyboard\n               shortcut. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC217A\"></a>To use the script, create a scene with a couple of spheres and set their segments\n               count quite low (as low as 4). Render the scene – all spheres should look exactly\n               as they do in the viewports. (See first image). Then execute the SphereSegsOn script\n               – nothing will change in the viewport, but if you render the scene again, all spheres\n               will appear completely smooth. (see second image). Execute the SphereSegsOff script\n               and the rendering should return to normal. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC217B\"></a> <em class=\"strong\">Back to</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC217C\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";