var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-F82B9FF1-2B52-4DA6-B9D3-627742690462\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Better?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To Make It Better?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F82B9FF1-2B52-4DA6-B9D3-627742690462\"></a><div class=\"head\">\n            <h1>How To Make It Better? </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17C4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17C5\"></a><p class=\"table-body\">  <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; How To Make It Better? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17C8\"></a> \n            <h2><a name=\"GUID-CE9BD3D6-C06B-4DE2-AD21-763D6D07CD98\"></a> <em class=\"strong\">Avoid using persistent global variables</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17C9\"></a>A good idea gone bad. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17CA\"></a>Initially added to support scripted controllers and xrefs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17CB\"></a> <em class=\"strong\">Problems:</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17CC\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17CE\"></a>No control over whether they are loaded \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D0\"></a>Overwriting previous values \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D1\"></a> <em class=\"strong\">Solutions:</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D2\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D4\"></a>Use the new scripted controllers in <em class=\"strong\">3ds Max 8</em> \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D6\"></a>Use scripted CAs for persistent data storage (see below) \n                  </p> \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D8\"></a> \n            <h2><a name=\"GUID-FCFD17CB-BCBC-4877-9D87-C3B8E6673AD2\"></a> <em class=\"strong\">Using scripted CAs for persistent data storage</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17D9\"></a>Scripted Custom Attributes can be used instead of persistent global variables to store\n               data with the scene file, avoiding the problems mentioned above. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17DA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17DB\"></a><p class=\"table-body\"> <em class=\"strong\">A scripted CA can be placed on the scene root:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65EF\"></a><pre>\nsceneDataCADef =attributes sceneDataCADef version:1 attribID:#(0x61e9ff5f, 0x63784819)\n(\nparameters main rollout:params\n( note type:#string ui:et_note default:\"\")\nrollout params \"Scene Data Parameters\"\n( edittext et_note \"Note: \")\n)\n&nbsp;\nthescene = (refs.dependents rootnode)[1]\nrootNodeDataCA = undefined\nif (custattributes.add rootnode sceneDataCADef) do\n&nbsp;rootNodeDataCA = rootnode.custAttributes[rootnode.custAttributes.count]\nsceneDataCA = undefined\nif (custattributes.add thescene sceneDataCADef) do\n&nbsp;sceneDataCA = thescene.custAttributes[thescene.custAttributes.count]\nrootNodeDataCA.note\nsceneDataCA.note\nrootNodeDataCA.note = \"rootnode\"\nsceneDataCA.note = \"thescene\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17F2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17F3\"></a><p class=\"table-body\"> <em class=\"strong\">If the file is saved and reloaded, you can access the CAs:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65EE\"></a><pre>\nrootNodeDataCA = undefined\nif(rootnode.custAttributes.count != 0) do\n&nbsp;rootNodeDataCA = rootnode.custAttributes[rootnode.custAttributes.count]\nsceneDataCA = undefined\nif(thescene.custAttributes.count != 0) do\n&nbsp;sceneDataCA = thescene.custAttributes[thescene.custAttributes.count]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17FD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17FE\"></a><p class=\"table-body\"> <em class=\"strong\">If the file is brought in as an XRef scene, you can still access the CAs:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65ED\"></a><pre>\nxr = xrefs.getXRefFile 1\nxr_root = xr.tree\nxr_rootNodeDataCA = undefined\nif (xr_root.custAttributes.count != 0) do\n&nbsp;xr_rootNodeDataCA = xr_root.custAttributes[xr_root.custAttributes.count]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1808\"></a> \n            <h2><a name=\"GUID-8F1F59A9-C2C9-4B89-91DC-9B347161F04E\"></a> <em class=\"strong\">Building UI on Script/Expression Controller</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1809\"></a>By placing a scripted Custom Attributes definition on a script or expression controller,\n               you can provide a custom UI for the controller. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC180A\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC180C\"></a>Define the CA to contain animatable parameters and rollout for UI. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC180E\"></a>Create a script controller. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1810\"></a>Apply the CA to the script controller. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1812\"></a>Apply the script controller. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1814\"></a>Create variables in the script controller. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1816\"></a>Assign Target values to the variables, specifying the CA parameters as the targets.\n                     \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1818\"></a>Display the CA’s UI using createDialog or newRolloutFloater &amp; addrollout \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC181A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC181B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65EC\"></a><pre>\nfloatDataCADef = attributes floatDataCADef version:1\n(\nparameters main rollout:params\n( prop1 type:#float ui:s_prop1 )\nrollout params \"Parameters\"\n( spinner s_prop1 \"Prop1: \")\nfn getRollout = params\n)\n&nbsp;\nsc = float_Script()\ncustattributes.add sc floatDataCADef\nfloatCA = sc.custattributes[1]\nsc.addTarget \"prop1\" floatCA[#prop1]\n&nbsp;\ndisplayControlDialog sc \"\"\n&nbsp;\nmscas =for ca in sc.custattributes where isMSCustAttrib ca collect ca\nrollouts =for ca in mscas where isproperty ca #getrollout collect ca.getrollout()\nif rollouts.count == 1 then\n&nbsp;createdialog rollouts[1]\nelse if rollouts.count &gt; 1 do\n(\n&nbsp;width = rollouts[1].width\n&nbsp;for ro in rollouts do\n&nbsp;&nbsp;width = amax width ro.width\n&nbsp;rof = newrolloutfloater \"\" (width+13) 0 0 0\n&nbsp;for ro in rollouts do addrollout ro rof\n&nbsp;height = 6\n&nbsp;for ro in rollouts do\n&nbsp;&nbsp;height += ro.height + 24\n&nbsp;rof.size = [rof.size.x,height]\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1841\"></a> <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster?</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1842\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";