var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FAE5BB27-C3B2-46B4-B0BA-FF7CA80969A8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I call the dropdownList Selected handler as a function?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FAE5BB27-C3B2-46B4-B0BA-FF7CA80969A8\"></a><div class=\"head\">\n            <h1>How do I call the dropdownList Selected handler as a function? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEB6\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEB8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEB9\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8CE\">Scripted UI</a></span> &gt; How do I call the dropdownList Selected handler as a function? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEBB\"></a> \n            <h2><a name=\"GUID-F88178BB-E500-4ABD-B2BD-1052A9ACFCC5\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEBC\"></a>Event handlers of User Interface Controls can be called as functions. For example,\n               myButton.pressed(), mySpinner.changed 10.0 and so on, but this is not possible with\n               the onselected() event handler of a <span class=\"char_link\"><a href=\"GUID-172DE6D6-796F-419B-936E-4FD64AD24CB9.htm\">dropdownlist control</a></span> because it already has a property called .selected that \"hides\" the function. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEBD\"></a>Is there any way to call this method? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEBE\"></a> \n            <h2><a name=\"GUID-9DB1E9D4-25D9-4CB9-950D-503D79C4E7C0\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEBF\"></a>Not directly - it is a known limitation, but unlikely to get fixed because of backwards\n               compatibility problems. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEC0\"></a>What you can do is define a function that does what the handler does, then call this\n               custom function from both the handler and from whatever other code that wants to invoke\n               the handler. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEC2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEC3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6653\"></a><pre>\nrollout testddl_rollout \"Dropdownlist Handler\"\n(\n  dropdownlist ddl_someList items:#(\"1\",\"2\",\"3\")--this is the dropdownlist\n  button btn_select1 \"Select 1\"--these buttons will set the list\n  button btn_select2 \"Select 2\"--by calling the custom function that\n  button btn_select3 \"Select 3\"--replaces the on selected() handler\n \n  --this is the custom function that performs the operations normally done\n  --inside the on selected() event handler:\n  fn ddl_someList_Selected itm =--we pass the argument passed to the handler\n  (\n    format \"You selected %\\n\" itm--and do something inside\n  )\n  --now we can call this custom function from the event hander itself\n  on ddl_someList selected itm do ddl_someList_Selected itm\n  --and from any other event handlers that want to affect the dropdownlist\n  on btn_select1 pressed do ddl_someList_Selected (ddl_someList.selection = 1)\n  on btn_select2 pressed do ddl_someList_Selected (ddl_someList.selection = 2)\n  on btn_select3 pressed do ddl_someList_Selected (ddl_someList.selection = 3)\n)\ncreateDialog testddl_rollout\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEDD\"></a> <span class=\"char_link\"><a href=\"GUID-172DE6D6-796F-419B-936E-4FD64AD24CB9.htm\">Dropdownlist</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEDE\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";