var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FB6EA335-79C3-437E-8DD8-68B56981F771\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ungroup()\">\n      <meta name=\"indexterm\" content=\"explodeGroup()\">\n      <meta name=\"indexterm\" content=\"detachNodesFromGroup()\">\n      <meta name=\"indexterm\" content=\"attachNodesToGroup()\">\n      <meta name=\"indexterm\" content=\"isOpenGroupHead()\">\n      <meta name=\"indexterm\" content=\"isGroupHead()\">\n      <meta name=\"indexterm\" content=\"isOpenGroupMember()\">\n      <meta name=\"indexterm\" content=\"isGroupMember()\">\n      <meta name=\"indexterm\" content=\"setGroupOpen()\">\n      <meta name=\"indexterm\" content=\"setGroupMember()\">\n      <meta name=\"indexterm\" content=\"setGroupHead()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Group-Related Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FB6EA335-79C3-437E-8DD8-68B56981F771\"></a><div class=\"head\">\n            <h1>Node Group-Related Methods</h1>\n         </div>\n         <p>  </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D88\"></a><pre><em class=\"codeEmphasisStrong\">group</em> &lt;node_collection&gt; [<em class=\"codeEmphasisStrong\">name</em>:&lt;string&gt; ] [<em class=\"codeEmphasisStrong\">prefix</em>:&lt;string&gt; ] [<em class=\"codeEmphasisStrong\">select</em>:&lt;boolean&gt; ] </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34D3\"></a>Makes a group of the given nodes and returns the group node. You can optionally specify\n            the group name or group name prefix. Not specifying a name or specifying a group name\n            prefix ensures that the group name assigned is unique. Specifying \n            		<span class=\"code\"> <em class=\"strong\">select:true</em> </span> selects the group after it is made. \n            	 \n         </p>\n         <div><a name=\"GUID-605566DE-7991-448A-B7D1-01D42B4BD321\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This function returns the group on success, and OK on failure. You can test the result\n               using isvalidnode(): \n               		\n               <div class=\"codeBlock\"><pre>result = group $box*\nif (isvalidnode result) do ...</pre></div> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34D2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34D1\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D87\"></a><pre>\ngroup $box* name:\"boxes\"--makes a group of all box*\'s named \"boxes\".\ngroup selection--groups current selection.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_9D9A9EB21B4A43CF9200891BAF848399\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D86\"></a><pre><em class=\"codeEmphasisStrong\">ungroup</em> &lt;group_head_node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34CA\"></a>Ungroups one level of a group node. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34C9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34C8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D85\"></a><pre>\nungroup $group001--ungroups group $group001\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_1C8C8F37BBBD492DA21F1ACFD8F4B503\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D84\"></a><pre><em class=\"codeEmphasisStrong\">explodeGroup</em> &lt;group_head_node&gt; -- mapped </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34C2\"></a>Ungroups all levels in a group node. \n         </p>\n         <p><a name=\"P_9F04917D6A724C2CB78A75B9BFCAFBA4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D83\"></a><pre><em class=\"codeEmphasisStrong\">attachNodesToGroup</em> &lt;node_collection&gt; &lt;targetNode&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34BD\"></a>Attaches a node collection to an existing group. Nodes that are already members of\n            a group cannot be attached to another group. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34BC\"></a>&lt;node_collection&gt; is an array of nodes to be attached to the group of targetNode.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34BB\"></a>&lt;targetNode&gt; must be a group member or a group head node and cannot be a member of\n            &lt;nodeCollection&gt;. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34BA\"></a>Available in \n            		<em class=\"strong\">3ds Max 2010</em> and higher. \n            	 \n         </p>\n         <p><a name=\"P_EA66D5B9423C45CF9D4E8AE013ABFC85\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D82\"></a><pre><em class=\"codeEmphasisStrong\">detachNodesFromGroup</em> &lt;node_collection&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34B7\"></a>Detaches the specified nodes from the groups they belong to. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34B6\"></a>&lt;node_collection&gt; is an array of nodes that must be detached from their group heads.\n            All members of &lt;nodeCollection&gt; must be open group members. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34B5\"></a>Available in \n            		<em class=\"strong\">3ds Max 2010</em> and higher. \n            	 \n         </p>\n         <p><a name=\"P_5A1C5F42552E40F6B5E72AAF157330DC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D81\"></a><pre><em class=\"codeEmphasisStrong\">isGroupHead</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34B1\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if node is group head,<span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n         </p>\n         <p><a name=\"P_5FF4599F631E48A581269A224C4845C4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D80\"></a><pre><em class=\"codeEmphasisStrong\">isOpenGroupHead</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34AE\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if \n            		<span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> is the head of a group, and that group is open. \n            	 \n         </p>\n         <p><a name=\"P_2DD4C96B26D547A3AD6B8D57F0A6DC44\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7F\"></a><pre><em class=\"codeEmphasisStrong\">isGroupMember</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34AA\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if node is in a group,<span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n         </p>\n         <p><a name=\"P_B19041EA6D3548FAB11F7281C4FA24A7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7E\"></a><pre><em class=\"codeEmphasisStrong\">isOpenGroupMember</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34A7\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if \n            		<span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> is a member of a group, and that group is open. \n            	 \n         </p>\n         <p><a name=\"P_BF23A9EAB2374833A533BBFB45EADA20\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7D\"></a><pre><em class=\"codeEmphasisStrong\">setGroupOpen</em> &lt;group_head_node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34A4\"></a>Sets whether the group is set as open or closed. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, the group is set as open. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> the group is closed. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34A2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34A1\"></a><p class=\"table-body\"> <em class=\"strong\">WARNING!</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-34A0\"></a><p class=\"table-body\"> <em class=\"strong\">Use the following methods with care.</em> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-349F\"></a><p class=\"table-body\"> <em class=\"strong\">You can place nodes in states that are impossible to accomplish using the 3ds Max\n                           user interface.</em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_D01552DBE3F3407E83FF4230A2D69E42\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7C\"></a><pre><em class=\"codeEmphasisStrong\">setGroupMember</em> &lt;node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-349C\"></a>Sets whether the node is a group member or not. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, node is set as a group member. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> and the node is a group member, the node is set as not being a group member and is\n            unlinked from the group head. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AEF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"P_A1F6B3DE05E24FD8A3B20AC7566B05AB\"></a>If you set a node to be a group member using this method, you need to set the node\n                  to be a child of a group head. Otherwise, the node name is not shown in the Select\n                  By Name dialog. \n                  		\n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3497\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3496\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7B\"></a><pre>\nsetGroupHead $dummy001 true\nappend $group003.children $dummy001\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_60C63CBB4A174F858B96529E41DE5107\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D7A\"></a><pre><em class=\"codeEmphasisStrong\">setGroupHead</em> &lt;node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-348F\"></a>Sets whether the node is flagged as a group head or not. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span>, node is flagged as a group head. If \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> is \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span>, the node is set as not being a group head. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AEE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"P_B1C375260F5D4117B0177A15518DAF48\"></a>If you flag a node as a group head using this method, the node\'s mesh will not be\n                  displayed in the viewports and its properties will not be shown in the Modify panel.\n                  If you flag a group head node as not being a group head using this method, you will\n                  not be able to Open or Explode the group using the Group menu command. \n                  		\n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-348A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3489\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3D79\"></a><pre>\n-- create a set of spheres, group them, and test group head and member of group\nmySpheres=for i = 1 to 5 collect sphere pos:(random [-100,-100,0] [100,100,0])\ngroup MySpheres name:\"MyGroup\"\nisGroupHead $MyGroup-- returns true\nisGroupMember $sphere001-- returns true\n-- check to see if group is open. Open group and test member of group\nisOpenGroupHead $MyGroup-- returns false\nsetGroupOpen $MyGroup true\nisOpenGroupMember $sphere001-- returns false\n-- create a new set of spheres, append the group to the set, and then group them all\nNewSpheres=for i= 1 to 3 collect sphere pos:(random [-100,-100,0] [100,100,0])\nappend NewSpheres $MyGroup\ngroup NewSpheres name:\"BiggerGroup\"\n-- open the group head, test member of group, and then close the groups.\nsetGroupOpen $BiggerGroup true\nisOpenGroupMember $MyGroup\nsetGroupOpen $MyGroup false\nsetGroupOpen $BiggerGroup false\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";