var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FDDA3651-2336-4DAA-A265-7576D7E16D58\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Using DotNet Forms To Create MAXScript User Interfaces\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using DotNet Forms To Create MAXScript User Interfaces</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FDDA3651-2336-4DAA-A265-7576D7E16D58\"></a><div class=\"head\">\n            <h1>Using DotNet Forms To Create MAXScript User Interfaces </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-D14\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-D10\"></a>DotNet controls cannot only be placed inside <em class=\"strong\">3ds Max</em> Dialogs and Rollouts, but they can also be used to generate user interfaces implemented\n               completely using DotNet Forms. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-D0F\"></a>In the following example, a DotNet Button is created and assigned to a DotNet Form\n               including a custom function declared as an event handler. Finally, the Form is displayed\n               as a dialog by calling its .show() method. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-D0D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-D0C\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-677B\"></a><pre>\n(\nfn whenButtonIsPressed a b =\n(\nformat \"Pressed from a DotNet Button\\n\"\nformat \"Argument a (Form): &lt;%&gt; \\n\" (classof a)\nformat \"Properties:\\n\"\nshowproperties a\nformat \"Methods:\\n\"\nshowmethods a\nformat \"Events:\\n\"\nshowevents a\nformat \"\\nArgument b (Button): &lt;%&gt; \\n\" (classof b)\nformat \"Properties:\\n\"\nshowproperties b\nformat \"Methods:\\n\"\nshowmethods a\nformat \"Events:\\n\"\nshowevents a\n)\n<span class=\"codeComment\">--Create a DotNet Button</span>\nmButton = dotNetObject \"System.Windows.Forms.Button\"\nmButton.text = \"BIG DotNet Button\"\nmButton.size = dotNetObject \"System.Drawing.Size\" 160 160\nmButton.location = dotNetObject \"System.Drawing.Point\" 60 60\n<span class=\"codeComment\">--Create a DotNet Form</span>\nhForm = dotNetObject \"System.Windows.Forms.Form\"\nhForm.controls.add mButton <span class=\"codeComment\">--add the Button to the Form</span>\nhForm.topmost = true\n<span class=\"codeComment\">--Add an Event Handler for the click event:</span>\ndotNet.addEventHandler mButton \"click\" whenButtonIsPressed\nhForm.show() <span class=\"codeComment\">--show the Form with the Button</span>\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-CE6\"></a> <img src=\"../images/GUID-6E0A20E3-7334-4513-8D6C-3CB5B25B2734-low.gif\"> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-CE4\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-CE3\"></a><p class=\"table-body\"> <em class=\"strong\">Output Of The Event Handler When Button Is Pressed:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-677A\"></a><pre>\nPressed from a DotNet Button\nArgument a (Form): &lt;dotNetObject&gt;\nProperties:\n.AccessibilityObject : &lt;System.Windows.Forms.AccessibleObject&gt;, read-only\n.AccessibleDefaultActionDescription : &lt;System.String&gt;\n.AccessibleDescription : &lt;System.String&gt;\n.AccessibleName : &lt;System.String&gt;\n.AccessibleRole : &lt;System.Windows.Forms.AccessibleRole&gt;\n.AllowDrop : &lt;System.Boolean&gt;\n.Anchor : &lt;System.Windows.Forms.AnchorStyles&gt;\n.AutoEllipsis : &lt;System.Boolean&gt;\n.AutoScrollOffset : &lt;System.Drawing.Point&gt;\n.AutoSize : &lt;System.Boolean&gt;\n.AutoSizeMode : &lt;System.Windows.Forms.AutoSizeMode&gt;\n.BackColor : &lt;System.Drawing.Color&gt;\n.BackgroundImage : &lt;System.Drawing.Image&gt;\n.BackgroundImageLayout : &lt;System.Windows.Forms.ImageLayout&gt;\n.BindingContext : &lt;System.Windows.Forms.BindingContext&gt;\n.Bottom : &lt;System.Int32&gt;, read-only\n.Bounds : &lt;System.Drawing.Rectangle&gt;\n.CanFocus : &lt;System.Boolean&gt;, read-only\n.CanSelect : &lt;System.Boolean&gt;, read-only\n.Capture : &lt;System.Boolean&gt;\n.CausesValidation : &lt;System.Boolean&gt;\n.CheckForIllegalCrossThreadCalls : &lt;System.Boolean&gt;, static\n.ClientRectangle : &lt;System.Drawing.Rectangle&gt;, read-only\n.ClientSize : &lt;System.Drawing.Size&gt;\n.CompanyName : &lt;System.String&gt;, read-only\n.Container : &lt;System.ComponentModel.IContainer&gt;, read-only\n.ContainsFocus : &lt;System.Boolean&gt;, read-only\n.ContextMenu : &lt;System.Windows.Forms.ContextMenu&gt;\n.ContextMenuStrip : &lt;System.Windows.Forms.ContextMenuStrip&gt;\n.Controls : &lt;System.Windows.Forms.Control+ControlCollection&gt;, read-only\n.Created : &lt;System.Boolean&gt;, read-only\n.Cursor : &lt;System.Windows.Forms.Cursor&gt;\n.DataBindings : &lt;System.Windows.Forms.ControlBindingsCollection&gt;, read-only\n.DefaultBackColor : &lt;System.Drawing.Color&gt;, read-only, static\n.DefaultFont : &lt;System.Drawing.Font&gt;, read-only, static\n.DefaultForeColor : &lt;System.Drawing.Color&gt;, read-only, static\n.DialogResult : &lt;System.Windows.Forms.DialogResult&gt;\n.DisplayRectangle : &lt;System.Drawing.Rectangle&gt;, read-only\n.Disposing : &lt;System.Boolean&gt;, read-only\n.Dock : &lt;System.Windows.Forms.DockStyle&gt;\n.Enabled : &lt;System.Boolean&gt;\n.FlatAppearance : &lt;System.Windows.Forms.FlatButtonAppearance&gt;, read-only\n.FlatStyle : &lt;System.Windows.Forms.FlatStyle&gt;\n.Focused : &lt;System.Boolean&gt;, read-only\n.Font : &lt;System.Drawing.Font&gt;\n.ForeColor : &lt;System.Drawing.Color&gt;\n.Handle : &lt;System.IntPtr&gt;, read-only\n.HasChildren : &lt;System.Boolean&gt;, read-only\n.Height : &lt;System.Int32&gt;\n.Image : &lt;System.Drawing.Image&gt;\n.ImageAlign : &lt;System.Drawing.ContentAlignment&gt;\n.ImageIndex : &lt;System.Int32&gt;\n.ImageKey : &lt;System.String&gt;\n.ImageList : &lt;System.Windows.Forms.ImageList&gt;\n.ImeMode : &lt;System.Windows.Forms.ImeMode&gt;\n.InvokeRequired : &lt;System.Boolean&gt;, read-only\n.IsAccessible : &lt;System.Boolean&gt;\n.IsDisposed : &lt;System.Boolean&gt;, read-only\n.IsHandleCreated : &lt;System.Boolean&gt;, read-only\n.IsMirrored : &lt;System.Boolean&gt;, read-only\n.LayoutEngine : &lt;System.Windows.Forms.Layout.LayoutEngine&gt;, read-only\n.Left : &lt;System.Int32&gt;\n.Location : &lt;System.Drawing.Point&gt;\n.Margin : &lt;System.Windows.Forms.Padding&gt;\n.MaximumSize : &lt;System.Drawing.Size&gt;\n.MinimumSize : &lt;System.Drawing.Size&gt;\n.ModifierKeys : &lt;System.Windows.Forms.Keys&gt;, read-only, static\n.MouseButtons : &lt;System.Windows.Forms.MouseButtons&gt;, read-only, static\n.MousePosition : &lt;System.Drawing.Point&gt;, read-only, static\n.Name : &lt;System.String&gt;\n.Padding : &lt;System.Windows.Forms.Padding&gt;\n.Parent : &lt;System.Windows.Forms.Control&gt;\n.PreferredSize : &lt;System.Drawing.Size&gt;, read-only\n.ProductName : &lt;System.String&gt;, read-only\n.ProductVersion : &lt;System.String&gt;, read-only\n.RecreatingHandle : &lt;System.Boolean&gt;, read-only\n.Region : &lt;System.Drawing.Region&gt;\n.Right : &lt;System.Int32&gt;, read-only\n.RightToLeft : &lt;System.Windows.Forms.RightToLeft&gt;\n.Site : &lt;System.ComponentModel.ISite&gt;\n.Size : &lt;System.Drawing.Size&gt;\n.TabIndex : &lt;System.Int32&gt;\n.TabStop : &lt;System.Boolean&gt;\n.Tag : &lt;System.Object&gt;\n.Text : &lt;System.String&gt;\n.TextAlign : &lt;System.Drawing.ContentAlignment&gt;\n.TextImageRelation : &lt;System.Windows.Forms.TextImageRelation&gt;\n.Top : &lt;System.Int32&gt;\n.TopLevelControl : &lt;System.Windows.Forms.Control&gt;, read-only\n.UseCompatibleTextRendering : &lt;System.Boolean&gt;\n.UseMnemonic : &lt;System.Boolean&gt;\n.UseVisualStyleBackColor : &lt;System.Boolean&gt;\n.UseWaitCursor : &lt;System.Boolean&gt;\n.Visible : &lt;System.Boolean&gt;\n.Width : &lt;System.Int32&gt;\n.WindowTarget : &lt;System.Windows.Forms.IWindowTarget&gt;\nMethods:\n.&lt;System.IAsyncResult&gt;BeginInvoke &lt;System.Delegate&gt;method\n.&lt;System.IAsyncResult&gt;BeginInvoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n.BringToFront()\n.&lt;System.Boolean&gt;Contains &lt;System.Windows.Forms.Control&gt;ctl\n.CreateControl()\n.&lt;System.Drawing.Graphics&gt;CreateGraphics()\n.&lt;System.Runtime.Remoting.ObjRef&gt;CreateObjRef &lt;System.Type&gt;requestedType\n.Dispose()\n.&lt;System.Windows.Forms.DragDropEffects&gt;DoDragDrop &lt;System.Object&gt;data &lt;System.Windows.Forms.DragDropEffects&gt;allowedEffects\n.DrawToBitmap &lt;System.Drawing.Bitmap&gt;bitmap &lt;System.Drawing.Rectangle&gt;targetBounds\n.&lt;System.Object&gt;EndInvoke &lt;System.IAsyncResult&gt;asyncResult\n.&lt;System.Boolean&gt;Equals &lt;System.Object&gt;obj\n.[static]&lt;System.Boolean&gt;Equals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n.&lt;System.Windows.Forms.Form&gt;FindForm()\n.&lt;System.Boolean&gt;Focus()\n.[static]&lt;System.Windows.Forms.Control&gt;FromChildHandle &lt;System.IntPtr&gt;handle\n.[static]&lt;System.Windows.Forms.Control&gt;FromHandle &lt;System.IntPtr&gt;handle\n.&lt;System.Windows.Forms.Control&gt;GetChildAtPoint &lt;System.Drawing.Point&gt;pt\n.&lt;System.Windows.Forms.Control&gt;GetChildAtPoint &lt;System.Drawing.Point&gt;pt &lt;System.Windows.Forms.GetChildAtPointSkip&gt;skipValue\n.&lt;System.Windows.Forms.IContainerControl&gt;GetContainerControl()\n.&lt;System.Int32&gt;GetHashCode()\n.&lt;System.Object&gt;GetLifetimeService()\n.&lt;System.Windows.Forms.Control&gt;GetNextControl &lt;System.Windows.Forms.Control&gt;ctl &lt;System.Boolean&gt;forward\n.&lt;System.Drawing.Size&gt;GetPreferredSize &lt;System.Drawing.Size&gt;proposedSize\n.&lt;System.Type&gt;GetType()\n.Hide()\n.&lt;System.Object&gt;InitializeLifetimeService()\n.Invalidate()\n.Invalidate &lt;System.Drawing.Rectangle&gt;rc\n.Invalidate &lt;System.Drawing.Region&gt;region\n.Invalidate &lt;System.Boolean&gt;invalidateChildren\n.Invalidate &lt;System.Drawing.Region&gt;region &lt;System.Boolean&gt;invalidateChildren\n.Invalidate &lt;System.Drawing.Rectangle&gt;rc &lt;System.Boolean&gt;invalidateChildren\n.&lt;System.Object&gt;Invoke &lt;System.Delegate&gt;method\n.&lt;System.Object&gt;Invoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n.[static]&lt;System.Boolean&gt;IsKeyLocked &lt;System.Windows.Forms.Keys&gt;keyVal\n.[static]&lt;System.Boolean&gt;IsMnemonic &lt;System.Char&gt;charCode &lt;System.String&gt;text\n.NotifyDefault &lt;System.Boolean&gt;value\n.PerformClick()\n.PerformLayout()\n.PerformLayout &lt;System.Windows.Forms.Control&gt;affectedControl &lt;System.String&gt;affectedProperty\n.&lt;System.Drawing.Point&gt;PointToClient &lt;System.Drawing.Point&gt;p\n.&lt;System.Drawing.Point&gt;PointToScreen &lt;System.Drawing.Point&gt;p\n.&lt;System.Windows.Forms.PreProcessControlState&gt;PreProcessControlMessage &lt;System.Windows.Forms.Message&amp;&gt;msg\n.&lt;System.Boolean&gt;PreProcessMessage &lt;System.Windows.Forms.Message&amp;&gt;msg\n.&lt;System.Drawing.Rectangle&gt;RectangleToClient &lt;System.Drawing.Rectangle&gt;r\n.&lt;System.Drawing.Rectangle&gt;RectangleToScreen &lt;System.Drawing.Rectangle&gt;r\n.[static]&lt;System.Boolean&gt;ReferenceEquals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n.Refresh()\n.ResetBackColor()\n.ResetBindings()\n.ResetCursor()\n.ResetFont()\n.ResetForeColor()\n.ResetImeMode()\n.ResetRightToLeft()\n.ResetText()\n.ResumeLayout()\n.ResumeLayout &lt;System.Boolean&gt;performLayout\n.Scale &lt;System.Single&gt;ratio\n.Scale &lt;System.Drawing.SizeF&gt;factor\n.Scale &lt;System.Single&gt;dx &lt;System.Single&gt;dy\n.Select()\n.&lt;System.Boolean&gt;SelectNextControl &lt;System.Windows.Forms.Control&gt;ctl &lt;System.Boolean&gt;forward &lt;System.Boolean&gt;tabStopOnly &lt;System.Boolean&gt;nested &lt;System.Boolean&gt;wrap\n.SendToBack()\n.SetBounds &lt;System.Int32&gt;x &lt;System.Int32&gt;y &lt;System.Int32&gt;width &lt;System.Int32&gt;height\n.SetBounds &lt;System.Int32&gt;x &lt;System.Int32&gt;y &lt;System.Int32&gt;width &lt;System.Int32&gt;height &lt;System.Windows.Forms.BoundsSpecified&gt;specified\n.Show()\n.SuspendLayout()\n.&lt;System.String&gt;ToString()\n.Update()\nEvents:\non &lt;control_name&gt; AutoSizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackColorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackgroundImageChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackgroundImageLayoutChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BindingContextChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; CausesValidationChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ChangeUICues &lt;System.Windows.Forms.UICuesEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Click &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ClientSizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ContextMenuChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ContextMenuStripChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ControlAdded &lt;System.Windows.Forms.ControlEventArgs&gt;e do ( ... )\non &lt;control_name&gt; ControlRemoved &lt;System.Windows.Forms.ControlEventArgs&gt;e do ( ... )\non &lt;control_name&gt; CursorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Disposed &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DockChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DoubleClick &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragDrop &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragEnter &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragLeave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragOver &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; EnabledChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Enter &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; FontChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ForeColorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; GiveFeedback &lt;System.Windows.Forms.GiveFeedbackEventArgs&gt;e do ( ... )\non &lt;control_name&gt; GotFocus &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HandleCreated &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HandleDestroyed &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HelpRequested &lt;System.Windows.Forms.HelpEventArgs&gt;hlpevent do ( ... )\non &lt;control_name&gt; ImeModeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Invalidated &lt;System.Windows.Forms.InvalidateEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyDown &lt;System.Windows.Forms.KeyEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyPress &lt;System.Windows.Forms.KeyPressEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyUp &lt;System.Windows.Forms.KeyEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Layout &lt;System.Windows.Forms.LayoutEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Leave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; LocationChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; LostFocus &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MarginChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseCaptureChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseClick &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseDoubleClick &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseDown &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseEnter &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseHover &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseLeave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseMove &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseUp &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseWheel &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Move &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; PaddingChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Paint &lt;System.Windows.Forms.PaintEventArgs&gt;e do ( ... )\non &lt;control_name&gt; ParentChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; PreviewKeyDown &lt;System.Windows.Forms.PreviewKeyDownEventArgs&gt;e do ( ... )\non &lt;control_name&gt; QueryAccessibilityHelp &lt;System.Windows.Forms.QueryAccessibilityHelpEventArgs&gt;e do ( ... )\non &lt;control_name&gt; QueryContinueDrag &lt;System.Windows.Forms.QueryContinueDragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; RegionChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Resize &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; RightToLeftChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; SizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; StyleChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; SystemColorsChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TabIndexChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TabStopChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TextChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Validated &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Validating &lt;System.ComponentModel.CancelEventArgs&gt;e do ( ... )\non &lt;control_name&gt; VisibleChanged &lt;System.EventArgs&gt;e do ( ... )\nArgument b (Button): &lt;dotNetObject&gt;\nProperties:\n.Button : &lt;System.Windows.Forms.MouseButtons&gt;, read-only\n.Clicks : &lt;System.Int32&gt;, read-only\n.Delta : &lt;System.Int32&gt;, read-only\n.Location : &lt;System.Drawing.Point&gt;, read-only\n.X : &lt;System.Int32&gt;, read-only\n.Y : &lt;System.Int32&gt;, read-only\n.Empty : &lt;System.EventArgs&gt;, read-only, static\nMethods:\n.&lt;System.IAsyncResult&gt;BeginInvoke &lt;System.Delegate&gt;method\n.&lt;System.IAsyncResult&gt;BeginInvoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n.BringToFront()\n.&lt;System.Boolean&gt;Contains &lt;System.Windows.Forms.Control&gt;ctl\n.CreateControl()\n.&lt;System.Drawing.Graphics&gt;CreateGraphics()\n.&lt;System.Runtime.Remoting.ObjRef&gt;CreateObjRef &lt;System.Type&gt;requestedType\n.Dispose()\n.&lt;System.Windows.Forms.DragDropEffects&gt;DoDragDrop &lt;System.Object&gt;data &lt;System.Windows.Forms.DragDropEffects&gt;allowedEffects\n.DrawToBitmap &lt;System.Drawing.Bitmap&gt;bitmap &lt;System.Drawing.Rectangle&gt;targetBounds\n.&lt;System.Object&gt;EndInvoke &lt;System.IAsyncResult&gt;asyncResult\n.&lt;System.Boolean&gt;Equals &lt;System.Object&gt;obj\n.[static]&lt;System.Boolean&gt;Equals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n.&lt;System.Windows.Forms.Form&gt;FindForm()\n.&lt;System.Boolean&gt;Focus()\n.[static]&lt;System.Windows.Forms.Control&gt;FromChildHandle &lt;System.IntPtr&gt;handle\n.[static]&lt;System.Windows.Forms.Control&gt;FromHandle &lt;System.IntPtr&gt;handle\n.&lt;System.Windows.Forms.Control&gt;GetChildAtPoint &lt;System.Drawing.Point&gt;pt\n.&lt;System.Windows.Forms.Control&gt;GetChildAtPoint &lt;System.Drawing.Point&gt;pt &lt;System.Windows.Forms.GetChildAtPointSkip&gt;skipValue\n.&lt;System.Windows.Forms.IContainerControl&gt;GetContainerControl()\n.&lt;System.Int32&gt;GetHashCode()\n.&lt;System.Object&gt;GetLifetimeService()\n.&lt;System.Windows.Forms.Control&gt;GetNextControl &lt;System.Windows.Forms.Control&gt;ctl &lt;System.Boolean&gt;forward\n.&lt;System.Drawing.Size&gt;GetPreferredSize &lt;System.Drawing.Size&gt;proposedSize\n.&lt;System.Type&gt;GetType()\n.Hide()\n.&lt;System.Object&gt;InitializeLifetimeService()\n.Invalidate()\n.Invalidate &lt;System.Drawing.Rectangle&gt;rc\n.Invalidate &lt;System.Drawing.Region&gt;region\n.Invalidate &lt;System.Boolean&gt;invalidateChildren\n.Invalidate &lt;System.Drawing.Region&gt;region &lt;System.Boolean&gt;invalidateChildren\n.Invalidate &lt;System.Drawing.Rectangle&gt;rc &lt;System.Boolean&gt;invalidateChildren\n.&lt;System.Object&gt;Invoke &lt;System.Delegate&gt;method\n.&lt;System.Object&gt;Invoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n.[static]&lt;System.Boolean&gt;IsKeyLocked &lt;System.Windows.Forms.Keys&gt;keyVal\n.[static]&lt;System.Boolean&gt;IsMnemonic &lt;System.Char&gt;charCode &lt;System.String&gt;text\n.NotifyDefault &lt;System.Boolean&gt;value\n.PerformClick()\n.PerformLayout()\n.PerformLayout &lt;System.Windows.Forms.Control&gt;affectedControl &lt;System.String&gt;affectedProperty\n.&lt;System.Drawing.Point&gt;PointToClient &lt;System.Drawing.Point&gt;p\n.&lt;System.Drawing.Point&gt;PointToScreen &lt;System.Drawing.Point&gt;p\n.&lt;System.Windows.Forms.PreProcessControlState&gt;PreProcessControlMessage &lt;System.Windows.Forms.Message&amp;&gt;msg\n.&lt;System.Boolean&gt;PreProcessMessage &lt;System.Windows.Forms.Message&amp;&gt;msg\n.&lt;System.Drawing.Rectangle&gt;RectangleToClient &lt;System.Drawing.Rectangle&gt;r\n.&lt;System.Drawing.Rectangle&gt;RectangleToScreen &lt;System.Drawing.Rectangle&gt;r\n.[static]&lt;System.Boolean&gt;ReferenceEquals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n.Refresh()\n.ResetBackColor()\n.ResetBindings()\n.ResetCursor()\n.ResetFont()\n.ResetForeColor()\n.ResetImeMode()\n.ResetRightToLeft()\n.ResetText()\n.ResumeLayout()\n.ResumeLayout &lt;System.Boolean&gt;performLayout\n.Scale &lt;System.Single&gt;ratio\n.Scale &lt;System.Drawing.SizeF&gt;factor\n.Scale &lt;System.Single&gt;dx &lt;System.Single&gt;dy\n.Select()\n.&lt;System.Boolean&gt;SelectNextControl &lt;System.Windows.Forms.Control&gt;ctl &lt;System.Boolean&gt;forward &lt;System.Boolean&gt;tabStopOnly &lt;System.Boolean&gt;nested &lt;System.Boolean&gt;wrap\n.SendToBack()\n.SetBounds &lt;System.Int32&gt;x &lt;System.Int32&gt;y &lt;System.Int32&gt;width &lt;System.Int32&gt;height\n.SetBounds &lt;System.Int32&gt;x &lt;System.Int32&gt;y &lt;System.Int32&gt;width &lt;System.Int32&gt;height &lt;System.Windows.Forms.BoundsSpecified&gt;specified\n.Show()\n.SuspendLayout()\n.&lt;System.String&gt;ToString()\n.Update()\nEvents:\non &lt;control_name&gt; AutoSizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackColorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackgroundImageChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BackgroundImageLayoutChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; BindingContextChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; CausesValidationChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ChangeUICues &lt;System.Windows.Forms.UICuesEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Click &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ClientSizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ContextMenuChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ContextMenuStripChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ControlAdded &lt;System.Windows.Forms.ControlEventArgs&gt;e do ( ... )\non &lt;control_name&gt; ControlRemoved &lt;System.Windows.Forms.ControlEventArgs&gt;e do ( ... )\non &lt;control_name&gt; CursorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Disposed &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DockChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DoubleClick &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragDrop &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragEnter &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragLeave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; DragOver &lt;System.Windows.Forms.DragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; EnabledChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Enter &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; FontChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; ForeColorChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; GiveFeedback &lt;System.Windows.Forms.GiveFeedbackEventArgs&gt;e do ( ... )\non &lt;control_name&gt; GotFocus &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HandleCreated &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HandleDestroyed &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; HelpRequested &lt;System.Windows.Forms.HelpEventArgs&gt;hlpevent do ( ... )\non &lt;control_name&gt; ImeModeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Invalidated &lt;System.Windows.Forms.InvalidateEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyDown &lt;System.Windows.Forms.KeyEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyPress &lt;System.Windows.Forms.KeyPressEventArgs&gt;e do ( ... )\non &lt;control_name&gt; KeyUp &lt;System.Windows.Forms.KeyEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Layout &lt;System.Windows.Forms.LayoutEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Leave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; LocationChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; LostFocus &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MarginChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseCaptureChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseClick &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseDoubleClick &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseDown &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseEnter &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseHover &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseLeave &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseMove &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseUp &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; MouseWheel &lt;System.Windows.Forms.MouseEventArgs&gt;e do ( ... )\non &lt;control_name&gt; Move &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; PaddingChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Paint &lt;System.Windows.Forms.PaintEventArgs&gt;e do ( ... )\non &lt;control_name&gt; ParentChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; PreviewKeyDown &lt;System.Windows.Forms.PreviewKeyDownEventArgs&gt;e do ( ... )\non &lt;control_name&gt; QueryAccessibilityHelp &lt;System.Windows.Forms.QueryAccessibilityHelpEventArgs&gt;e do ( ... )\non &lt;control_name&gt; QueryContinueDrag &lt;System.Windows.Forms.QueryContinueDragEventArgs&gt;e do ( ... )\non &lt;control_name&gt; RegionChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Resize &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; RightToLeftChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; SizeChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; StyleChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; SystemColorsChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TabIndexChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TabStopChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; TextChanged &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Validated &lt;System.EventArgs&gt;e do ( ... )\non &lt;control_name&gt; Validating &lt;System.ComponentModel.CancelEventArgs&gt;e do ( ... )\non &lt;control_name&gt; VisibleChanged &lt;System.EventArgs&gt;e do ( ... )\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B55\"></a>Using this output, you can easily see what Properties, Methods, and Events are available\n               for each control and implement additional functionality to extend the script, change\n               the appearance and behaviour of the DotNet controls, and so on. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B53\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";