var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FE5381EF-88F1-462C-8ACC-5B7A488E85FC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I uncheck a MacroScript button correctly?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FE5381EF-88F1-462C-8ACC-5B7A488E85FC\"></a><div class=\"head\">\n            <h1>How do I uncheck a MacroScript button correctly? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE0\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE3\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8CE\">Scripted UI</a></span> &gt; How do I uncheck a MacroScript button correctly? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE5\"></a> \n            <h2><a name=\"GUID-9BC73652-2C89-4AFD-8E10-02498B56DB95\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE6\"></a>Let\'s say you have a macroscript button that opens a dialog.&nbsp; Now you\'d like to take\n               advantage of the isChecked handler to show the button being checked when the dialog\n               is open and when pressed again (unchecked) will close the dialog.&nbsp;So far so good.\n               Now the user closes the interface using the [x] button.. or any other means except\n               pressing that same macroscript button.&nbsp; How does one go about un-checking that macroscript\n               button? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE7\"></a> \n            <h2><a name=\"GUID-483C643E-1120-4EF7-BBF7-DB3EDFE6E029\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE8\"></a>Here is one possible way to implement this behavior using a \"private global\" variable\n               (local to the macro Script\'s scope) which holds the current open/closed state. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEE9\"></a>This variable can be set from inside the On Close() handler of the rollout so when\n               you hit[X], it forces the3ds MaxGUI to update and uncheck the button. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEEA\"></a>This can be done using a global variable (if you want other scripts to be able to\n               force your script / dialog to close).Also, more error checking could be added, but\n               the general idea is this: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEEC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCEED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6652\"></a><pre>\nmacroScript test category:\"Tests\"\n(\n&nbsp; local isOpen = false --initialize to false (closed)\n &nbsp;rollout myRollout \"MyRollout\"\n&nbsp; (\n&nbsp;&nbsp;  label lbl_hello \"hello world\"\n  &nbsp;&nbsp;on myRollout close do --when closing, set to false and redraw GUI\n&nbsp;&nbsp;  (\n   &nbsp;&nbsp;&nbsp;isOpen = false\n&nbsp;&nbsp;&nbsp;   updateToolbarButtons()\n  &nbsp;&nbsp;)\n &nbsp;)\n&nbsp; on execute do\n &nbsp;(\n&nbsp;  &nbsp;if isOpen then --if open, close it\n  &nbsp;&nbsp;(\n&nbsp;&nbsp;   &nbsp;destroyDialog myRollout\n   &nbsp;&nbsp;&nbsp;isOpen = false--and lower the flag\n  &nbsp;&nbsp;)\n  &nbsp;&nbsp;else --if closed, open it\n  &nbsp;&nbsp;(\n&nbsp;&nbsp;   &nbsp;createDialog myRollout\n   &nbsp;&nbsp;&nbsp;isOpen = true --and raise the flag\n  &nbsp;&nbsp;)\n &nbsp;)\n&nbsp; on isChecked return isOpen --return the flag\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF0D\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";