var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FE555353-8A2D-4B64-8B81-8394F7921C72\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ProSound SoundClass\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ProSound : SoundClass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FE555353-8A2D-4B64-8B81-8394F7921C72\"></a><div class=\"head\">\n            <h1>ProSound : SoundClass </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5259\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2494\"></a><pre><em class=\"codeEmphasisStrong\">ProSound - superclass: SoundClass; super-superclass:MAXWrapper - classID: #(1198500318, 1536265802)</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5256\"></a> The <em class=\"strong\">ProSound SoundClass</em> introduced in <em class=\"strong\">3ds Max 2010</em> provides an advanced Sound Object with support for 100 sound channels and extensive\n               MAXScript access. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5255\"></a>See also the <span class=\"char_link\"><a href=\"GUID-7DDD5571-7928-4573-83F8-80639C2A3A23.htm\">ProSound Extension</a></span> topic for an introduction. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5254\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5253\"></a> \n               <h3><a name=\"GUID-82F4D80B-09EA-4A29-BB4B-BAE70D371B38\"></a> <em class=\"strong\">Sound System Initialization</em> \n               </h3> \n               <p><a name=\"GUID-39E28ABC-AB66-4A8D-AADE-1B8026E71194\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2493\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.init</em> &lt;boolean&gt;KeepExistingFile 	 </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5251\"></a>Initializes ProSound for MaxScript access. If ProSound is not loaded, it will load\n                  itself and become the Sound Object for <em class=\"strong\">3ds Max</em>. If there is already an audio file loaded in the Default SoundClass object of <em class=\"strong\">3ds Max</em>, setting the <span class=\"code\"> <em class=\"strong\">KeepExistingFile</em> </span> flag to true will add that file as one of the audio tracks in ProSound, thus preserving\n                  the existing track. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5250\"></a>Returns true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-8ED02AD4-83CF-419B-BE2C-E23EEC841D00\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2492\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound. isActive()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-524D\"></a>Returns true if ProSound is the Sound Object for <em class=\"strong\">3ds Max</em>, false otherwise. If the return value is false, call <span class=\"code\"> <em class=\"strong\">prosound.init()</em> </span> to access all other ProSound MAXScript functions. \n               </p> \n               <p><a name=\"GUID-B16DD71F-4810-4C57-A212-360922284AEF\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2491\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">prosound.Version()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-524A\"></a>Returns the version of ProSound times 100. For example if the version is 1.4, this\n                  function will return 140. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5248\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5247\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2490\"></a><pre>\nprosound.isActive () --check whether ProSound is active\n--&gt; ProSound is not active. Call ProSound.Init (true)\nProSound.Init (true)\n--&gt; Attempting to Load ProSound\n--&gt; ProSound Init Success\n--&gt; true\nprosound.isActive () --try again\n--&gt; ProSound is active.\n--&gt; true\nprosound.version () --get version\n--&gt; 140\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-12CC55B8-73B5-4844-9C19-3CD665275F87\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248F\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.unload</em> () </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5237\"></a>Unloads ProSound and enables the 3dsMaxDefault SoundClass Object. Returns true if\n                  successful, false otherwise. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5235\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5234\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248E\"></a><pre>\nprosound.unload () -- unload ProSound and enable Default Sound.\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-522F\"></a> \n               <h3><a name=\"GUID-E83A17AD-E683-4389-93EC-6FDFB6E70159\"></a> <em class=\"strong\">ProSound Dialog Control</em> \n               </h3> \n               <p><a name=\"GUID-72E86507-742E-40D2-8E2F-ED4D3A1CC8BC\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248D\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">prosound.open</em> () </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-522D\"></a>Opens/Maximizes the ProSound dialog. \n               </p> \n               <p><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F62\"></a>If the ProSound is not active, it will activate it as well. \n               </p> \n               <p><a name=\"GUID-55047DC5-F698-4ED3-B395-AE898ADDD292\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248C\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">prosound.close()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-522A\"></a>Closes the ProSound dialog if it is open. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5228\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5227\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248B\"></a><pre>\nprosound.open () -- open the ProSound dialog.\nprosound.close () -- close the dialog.\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5221\"></a> <img src=\"../images/GUID-1634D218-DC7A-4376-BDDA-C5FEA6B5FFB0-low.gif\"> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-5DBC\"></a> \n               <h3><a name=\"GUID-070326FA-916E-45D2-B6EE-05FACF7B9F5C\"></a> <em class=\"strong\">Adding and Querying Sound Files</em> \n               </h3> \n               <p><a name=\"GUID-C836ED4D-18EA-4618-B047-26CD802D0E09\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-248A\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">prosound.MaxTracks()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-521F\"></a>Returns the maximum number of audio tracks supported in ProSound. Currently, this\n                  number is 100. \n               </p> \n               <p><a name=\"GUID-55896084-A19E-48E4-B28B-FDECF84B7FDC\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2489\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">prosound.NumTracks()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-521D\"></a>Returns the number of audio tracks in use within ProSound. This includes tracks that\n                  are inactive, but have a file assigned. \n               </p> \n               <p><a name=\"GUID-E7BD0C93-BEF5-4C6F-B5F7-CFCEEC146705\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2488\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.append</em> &lt;filename&gt;AudioFile </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-521B\"></a>Loads the specified file and appends it to the list of audio tracks. The argument\n                  must be the full name of a valid audio file. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-521A\"></a>Equivalent to using the \"Add\" button in the ProSound UI. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5219\"></a>Returns true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-B8D29A04-4FDF-48D7-A311-03D390C8FC4F\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2487\"></a><pre>boolean&gt;<em class=\"codeEmphasisStrong\">prosound.delete</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5217\"></a>Deletes the specified audio track. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5216\"></a>Equivalent to using the \"Delete\" button in the ProSound UI. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5215\"></a>Returns true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-24952EDB-90A4-4D92-9F3C-288FCDC68EA9\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2486\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.replace</em> &lt;index&gt;Track &lt;filename&gt;AudioFile </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5213\"></a>Replaces the audio file at the specified index. The first argument is the Index of\n                  the file to replace, the second argument is the full file name of a valid audio file\n                  to replace with. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5212\"></a>Equivalent to using the \"Replace\" button in the ProSound UI. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5211\"></a>Returns true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-9724D7DD-6B18-432D-8BE0-80C3FB142EB7\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2485\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.ReloadAll()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-520F\"></a>Reloads all audio files in ProSound. Returns true if the reload is successful, false\n                  otherwise. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-520D\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-520C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2484\"></a><pre>\nprosound.append\"C:\\\\WINDOWS\\\\Media\\\\chimes.wav\"--adds a file\n--&gt; true\nprosound.append\"C:\\\\WINDOWS\\\\Media\\\\tada.wav\"--adds another\n--&gt; true\nprosound.numtracks() --check the number of tracks\n--&gt; 2\nprosound.delete 1 --deletestrack 1\n--&gt; true\nprosound.replace 1 \"C:\\\\WINDOWS\\\\Media\\\\notify.wav\"\n--&gt; true\nprosound.numtracks() --get the number of track safter deleting 1\n--&gt; 1\nprosound.maxtracks() --see how many tracks are supported\n--&gt; 100\nprosound.reloadall() --reload all tracks\n--&gt; true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51F7\"></a> \n               <h3><a name=\"GUID-FDA505E1-C362-426C-87B0-FF61FC05745E\"></a> <em class=\"strong\">Working With Tracks</em> \n               </h3> \n               <p><a name=\"GUID-22F1EF21-D130-46F5-AF86-6769FC30152E\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2483\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.active</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51F6\"></a>Returns true if the specified indexed track is active, false otherwise. \n               </p> \n               <p><a name=\"GUID-DAEF6C8C-79A8-479C-A16E-F54C2D082814\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2482\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetActive</em> &lt;index&gt;Track &lt;boolean&gt;ActiveState </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51F4\"></a>Sets the active status of the specified track. Returns true if successful, false otherwise.\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51F2\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51F1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2481\"></a><pre>\nprosound.active 1 --see if track 1 is active\n--&gt;true\nprosound.setactive 1 false --turn it off\n--&gt;true\nprosound.active 1 --see if it is on or off now\n--&gt;false\nprosound.setactive 1 true --turn it back on\n--&gt;true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-D7B6BF21-3BF8-4C35-9C98-767DD355A58F\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2480\"></a><pre>filename&gt;<em class=\"codeEmphasisStrong\">Name</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51E4\"></a>Returns the name of the file for the specified track. \n               </p> \n               <p><a name=\"GUID-CC015940-6C0D-4752-B9F0-EA7B9CAB59A9\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247F\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">prosound.SampleRate</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51E2\"></a>Returns the sample rate of the audio track. \n               </p> \n               <p><a name=\"GUID-2132FCAF-8D4A-43A0-AF32-95F90BD11ACA\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247E\"></a><pre>integer&gt;<em class=\"codeEmphasisStrong\">prosound.channels</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51E0\"></a>Returns the number of audio channels for the specified audio track. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51DE\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51DD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247D\"></a><pre>\nprosound.name 1 --get the name of track 1\n--&gt;\"C:\\WINDOWS\\Media\\notify.wav\"\nprosound.SampleRate 1 --get the sample rate of track 1\n--&gt;22050\nprosound.channels 1 --get the channels of track 1\n--&gt;2\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-9DEC16B0-C612-4E94-8388-62BEC48D761E\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247C\"></a><pre>time&gt;<em class=\"codeEmphasisStrong\">prosound.start</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51D2\"></a>Returns the start frame number for the specified indexed track. \n               </p> \n               <p><a name=\"GUID-016188C0-3878-4F45-B7AB-FC606DA4B1FA\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247B\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetStart</em> &lt;index&gt;Track &lt;time&gt;StartFrame </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51D0\"></a>Sets the start frame of the specified indexed track. Returns true if successful, false\n                  otherwise. \n               </p> \n               <p><a name=\"GUID-CFCECA3A-3EB9-46D3-AF67-5636B4DA9D8C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-247A\"></a><pre>time&gt;<em class=\"codeEmphasisStrong\">prosound.end</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51CE\"></a>Returns the end frame number for the specified track. \n               </p> \n               <p><a name=\"GUID-C4C34D66-20B0-4D0E-85F1-53D7B9E106E2\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2479\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetEnd</em> &lt;index&gt;Track &lt;time&gt;EndFrame </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51CC\"></a>Sets the end frame of the specified track. Returns true if successful, false otherwise.\n                  \n               </p> \n               <p><a name=\"GUID-CE5E5DAF-C81C-4A42-90A0-4C3886A8ADB1\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2478\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.Shift</em> &lt;index&gt;Track &lt;time&gt;Frames </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51CA\"></a>Shifts the start and end frames of the specified track by the specified amount. Returns\n                  true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-9E783F3B-5931-4305-87F8-6BB736ED5C5C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2477\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.ShiftAll</em> &lt;integer&gt;Frames </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51C8\"></a>Shifts the start and end frames of all audio tracks by the specified amount. Returns\n                  true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-210CC315-3EBC-4FBE-BD6C-77CBE535F6AE\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2476\"></a><pre>time&gt;<em class=\"codeEmphasisStrong\">prosound.filelength</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51C6\"></a>Returns the length of the specified audio file (in frames). Note that this is the\n                  file length, not the track length. So, if the file is 120 frames long, but the track\n                  has a start and end frame of 0 and 150, 120 and not 150 is returned. Use <span class=\"code\"> <em class=\"strong\">prosound.end()</em> </span> and <span class=\"code\"> <em class=\"strong\">prosound.start()</em> </span> to get the track length. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51C5\"></a>Equivalent to the \"Duration\" value in the ProSound UI. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51C3\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51C2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2475\"></a><pre>\nprosound.start 1 --get the start frame of track 1\n--&gt;0f\nprosound.end 1 --get the end frame of track 1\n--&gt;18.9625f\nprosound.filelength 1 --get the file length of track 1\n--&gt;40.5875f\nprosound.setstart 1 10 --sets the start frame of track 1to 10\n--&gt;true\nprosound.setend 1 123 --sets the end frame of track 1 to 123\n--&gt;true\nprosound.start 1 --check the new start frame of track 1\n--&gt;10f\nprosound.end 1 --check the new end frame of track 1\n--&gt;123f\nprosound.shift 1 50 --shift both start and end by 50 frames\n--&gt;true\nprosound.start 1 --check the shifted start frame of track 1\n--&gt;60f\nprosound.end 1 --check the shifted end frame of track 1\n--&gt;173f\nprosound.shiftAll -50 --shift all tracks back 50 frames\n--&gt;true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-7B26C943-EA00-4662-A81D-081C9E2728E1\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2474\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">prosound.NumLoops</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51A8\"></a>If this track uses loops, returns the number of loops for the track. Otherwise, calculates\n                  the number of complete loops based on track duration and file length. \n               </p> \n               <p><a name=\"GUID-19093D1C-5BE0-47AC-84A8-853ADBC13501\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2473\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetNumLoops</em> &lt;index&gt;Track &lt;integer&gt;NumberOfLoops </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51A6\"></a>Sets the number of loops for the specified track. It also sets the \"Use Loops\" option\n                  for this track to true. Returns true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-192D3D5E-F644-448A-A2BB-08160E96E0E4\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2472\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.UseLoops</em> &lt;index&gt;Track </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51A4\"></a>Returns true if \"UseLoops\" option is enabled for the specified track, false otherwise.\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51A2\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-51A1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2471\"></a><pre>\nprosound.numloops 1 --get the loops of track 1 \n--&gt;2\nprosound.setnumloops 1 3 --set the loops of track 1 to 3\n--&gt;true\nprosound.end 1 --check the new end frame of track 1\n--&gt;181.762f\nprosound.useloops 1 --see if track 1 will use loops\n--&gt;true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5195\"></a> \n               <h3><a name=\"GUID-DE75215B-D2AB-4945-B625-B631B1F8D24C\"></a> <em class=\"strong\">Playback Controls</em> \n               </h3> \n               <p><a name=\"GUID-BCFE816A-6378-4AA8-87A3-C51275A01F50\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2470\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.backwardScrub()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5194\"></a>Returns the state of the \"Permit Backwards Scrubbing\" playback option - true if Backwards\n                  Scrubbing is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-068690CD-F341-4DDA-9F5B-16908E1E75EB\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246F\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.setBackwardScrub</em> &lt;boolean&gt;BackwardsScrubState </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5192\"></a>Sets the \"Permit Backwards Scrubbing\" playback option. Returns true if successful,\n                  false otherwise. \n               </p> \n               <p><a name=\"GUID-438E5AB9-7FEF-473C-A596-E185ECC74ED7\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246E\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.PlayOnce()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5190\"></a>Returns true if the \"Play Once\" option is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-3FDE9183-3867-45B6-82BD-64A86AEE460F\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246D\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetPlayOnce</em> &lt;boolean&gt;State </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-518E\"></a>Sets the \"Play Once\" playback option to true or false. Returns true if successful,\n                  false otherwise. \n               </p> \n               <p><a name=\"GUID-5D0F3183-7FEF-4F0D-BCA7-C78A2156E09D\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246C\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.UsePlaybackRange()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-518C\"></a>Returns true if the \"Use Playback Range\"option is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-3C98D8D1-C3B2-4F6C-8919-B9253E9E119C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246B\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetUsePlaybackRange</em> &lt;boolean&gt;State </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-518A\"></a>Sets the \"Use Playback Range\" playback option to the given Boolean state. Returns\n                  true if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-5CAF2FC8-0490-4477-BD47-9E3068E8561C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-246A\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetPlaybackEnd</em> &lt;integer&gt;EndFrame </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5188\"></a>Sets the end frame of the \"Use Playback Range\" playback option. Returns true if successful,\n                  false otherwise. \n               </p> \n               <p><a name=\"GUID-1C18738E-7ECB-4D57-8CD6-2015426CB264\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2469\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetPlaybackStart</em> &lt;integer&gt;StartFrame </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5186\"></a>Sets the starting frame for the \"Use Playback Range\" playback option. Returns true\n                  if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-135AE399-BA90-4B90-9018-69F6098CDD11\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2468\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.PingPong()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5184\"></a>Returns true if the \"Ping Pong\" playback option is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-CB77E673-6D3C-453B-A124-04E0AE5FCB49\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2467\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetPingPong</em> &lt;boolean&gt;State </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5182\"></a>Sets the state of the \"Ping Pong\" playback option. Returns true if successful, false\n                  otherwise. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5180\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-517F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2466\"></a><pre>\nprosound.backwardScrub ()-- check if backwards scrubbing is on\n--&gt; false\nprosound.setBackwardScrub true-- enable backwards scrubbing\n--&gt; true\nprosound.backwardScrub () --check again\n--&gt; true\nprosound.playonce () --check the state of the Play Once option\n--&gt; false\nprosound.setplayonce true --set to loop the playback\n--&gt; true\nprosound.useplaybackrange () --see if playback range is used\n--&gt; false\nprosound.setuseplaybackrange true --enable playback range\n--&gt; true\nprosound.setplaybackend 100 --set the playback range end to 100\n--&gt; true\nprosound.setplaybackstart 0 --set the playback range start to 0\n--&gt; true\nprosound.pingpong () --see if ping-pong playback is enabled\n--&gt; false\nprosound.setpingpong true --enable ping-pong playback\n--&gt; true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-17C82243-D7C9-4551-B9BB-32CDBF18233D\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2465\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.isPlaybackActive</em> () </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5165\"></a>Returns true if the ProSound playback is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-DA383BCC-C7A9-4E9B-B4BF-2E18552DEB82\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2464\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetPlaybackActive</em> &lt;boolean&gt;State </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5163\"></a>Enables or disables the audio playback based on the Boolean argument. Returns true\n                  if successful, false otherwise. \n               </p> \n               <p><a name=\"GUID-41E184A7-6093-465C-A8DA-1F589BE9E204\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2463\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">prosound.Step()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5161\"></a>Steps forward by one frame and plays the corresponding audio. \n               </p> \n               <p><a name=\"GUID-8E0868FD-904A-4DDC-9967-CEC10B807061\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2462\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">prosound.Stepback()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-515F\"></a>Steps backwards by one frame and plays the corresponding audio. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-515D\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-515C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2461\"></a><pre>\nprosound.isplaybackactive() --check if playback is active\n--&gt; false\nprosound.setplaybackactive true --activate playback\n--&gt; true\nprosound.isplaybackactive() --check again if playback is active\n--&gt; true\nprosound.step()\nprosound.Stepback()\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-5D57\"></a> \n               <h3><a name=\"GUID-8CB39866-09BF-4CDF-A47B-26D430B236FF\"></a> <em class=\"strong\">Render Controls</em> \n               </h3> \n               <p><a name=\"GUID-5C2284FB-3DBE-44F0-9929-16B13D38E2CE\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2460\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.export</em> &lt;filename&gt;AudioFile &lt;integer&gt;StartFrame &lt;integer&gt;EndFrame </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-514F\"></a>Attempts to export the combined audio to the specified filename. The file will be\n                  saved in PCM using the Render settings. Returns true if successful, false otherwise.\n                  \n               </p> \n               <p><a name=\"GUID-EBB01ACB-CDA4-4812-85C4-E9725E91EB16\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245F\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.isRenderActive()</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-514C\"></a>Returns true if the ProSound audio rendering is enabled, false otherwise. \n               </p> \n               <p><a name=\"GUID-D18D88E3-6415-4B49-84C4-0E4CCC548945\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245E\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetRenderActive</em> &lt;boolean&gt;State </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5149\"></a>Enables audio rendering based on the Boolean argument. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5148\"></a>Returns true if successful, false otherwise. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5146\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5145\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245D\"></a><pre>\nprosound.export \"c:\\\\sounds\\\\export_test.wav\" 0 100\n--&gt; true\nprosound.isrenderactive() --check if rendering is active\n--&gt; false\nprosound.setrenderactive true\n--&gt; true\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-5D4C\"></a> \n               <h3><a name=\"GUID-7A42034D-7FC4-4BB8-AF27-B1A98CF1FC66\"></a> <em class=\"strong\">Metronome Controls</em> \n               </h3> \n               <p><a name=\"GUID-7EAD11AB-5F89-4848-8B53-9B5A951FD63A\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245C\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.isMetroActive</em> () </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-513A\"></a>Returns true if the Metronome is enabled, false if it is disabled. \n               </p> \n               <p><a name=\"GUID-BB323A94-228C-48AE-8FFE-FFD625B9338D\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245B\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">prosound.SetMetroActive</em> &lt;boolean&gt;ActiveState </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5137\"></a>Turns the metronome on or off depending on the Boolean argument. Returns true if successful,\n                  false otherwise. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5135\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5134\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-245A\"></a><pre>\nprosound.ismetroactive() --check if metronome is active\n--&gt; false\nprosound.setmetroactive true --enable metronome\n--&gt; true\nprosound.ismetroactive() --see if the change worked\n--&gt; true\nprosound.setmetroactive false --disable metronome\n--&gt; true\nprosound.ismetroactive() --should be false (disabled) now\n--&gt; false\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5125\"></a> <span class=\"char_link\"><a href=\"GUID-7DDD5571-7928-4573-83F8-80639C2A3A23.htm\">ProSound Extension</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5124\"></a> <span class=\"char_link\"><a href=\"GUID-E57309CD-303C-4943-82DF-6A79AF3612C9.htm\">Default_Sound : SoundClass</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";