var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-11-25\">\n      <meta name=\"topicid\" content=\"GUID-FEA0A322-ECD4-465C-8C11-DDC4E36DC7BE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Increasing Performance when Searching for Interfaces and Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Increasing Performance when Searching for Interfaces and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FEA0A322-ECD4-465C-8C11-DDC4E36DC7BE\"></a><div class=\"head\">\n            <h1>Increasing Performance when Searching for Interfaces and Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-709D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-709C\"></a> Searching for an interface and a method in an interface can be slow. Especially when\n               calling the same method multiple times in a loop, for example in order to affect multiple\n               vertices, faces, normals, objects etc., performance can decrease significantly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-709A\"></a>To speed up access to methods in interfaces, you can let MAXScript search for the\n               interface and method once and then access the method directly in the loop. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7099\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7098\"></a><p class=\"table-body\"> <em class=\"strong\">INSTEAD OF SAYING</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D09\"></a><pre>\nfor i = 1 to 100 do\nmyObject.edit_normals.setNormal i myNormals[i]\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7093\"></a><p class=\"table-body\"> <em class=\"strong\">YOU SHOULD SAY</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D08\"></a><pre>\nEN_setNormal = myObject.edit_normals.setNormal -- the method\nfor i = 1 to 100 do\nEN_setNormal i myNormals[i]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-708C\"></a>This way, the required interface and method will be searched for just once, and then\n               accessed directly multiple times in the loop without searching. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-708A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7089\"></a><p class=\"table-body\"> <em class=\"strong\">ANOTHER WAY (NOT AS FAST AS THE ABOVE) WOULD BE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D07\"></a><pre>\nEN_mod_i = myObject.edit_normals.EditNormalsMod -- the interface\nfor i = 1 to 100 do\nEN_mod_i.setNormal i myNormals[i]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7082\"></a>In this case, the interface will be searched for just once, but the method will be\n               searched for multiple times. If you intend to access many methods from the same interface,\n               this way would be still faster than searching for both interface and method inside\n               the loop. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7080\"></a> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-707F\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-707E\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";